README file for Xplasma Module

Prepared by C.Ludescher-Furth -- ludescher@pppl.gov 06/26/00

****************
REVISION HISTORY
****************
      date          Description

  June 26, 2000  -- Created
  Feb. 08, 2001  -- Support of EFIT output
  June 21, 2001  -- Added geqxpl2 sample program
  Mar. 14, 2006  -- Added xplasma_fsp_test example
  Sep. 08, 2006  -- New xplasma2
----------------------------------------------------------------


Index:
   1. CONTENTS
   2. UNPACKING INSTRUCTIONS
   3. DESTINATIONS
   4. BUILDING INSTRUCTIONS
   5. TESTING INSTRUCTIONS
   6. DOCUMENTATION
   7. FINAL INSTALLATION


************
1. CONTENTS:
************
This directory should contain the following files:

README_Xplasma: This file.  Brief descriptions of the other files, and
                instructions for compiling, testing and installing the
                libxplasma2, old_xplasma, xplasma_debug libraries,
                and the test drivers xplasma2_test,
                test_xplasma, xplasma_fsp_test and geqxpl{2}
                and the utility plot_xplasma. 

Makefile:       NOTE, "GNU make" must be used
                (usually in /usr/gnu/bin or /usr/local/bin).
		Main Makefile to envoke Makefile(s) in subdirectories.  

-- in subdirectory share:
   Make.flags:        Include file for Makefile, to setup Flags, etc.
   Make.local.sample: Include file for Makefile, to setup non-conventional,
                      site specific locations.

-- in subdirectory xplasma:
   Copy of README
   Makefile
   Sources to build the library libxplasma.a
	*.f, *.F, *.F90
   Sources for programs:
   	test_xplasma.f90, plot_xplasma.f, geqxpl[2}.for
	xplasma_fsp_test.f90 xplasma2_test.f90

   Sample input/output files for test:
  	 *.ind, *.treq_data script_output.ps, g*.nstx 
         104276D02_4s710_xplasma.cdf

-- in subdirectory comput:
   Makefile 
   Sources to build libcomput.a, an internally used library 
	with transformation/interpolation routines.
   
-- in subdirectory fluxav:
   Makefile 
   Sources to build libfluxav.a, an internally used library 
	for flux zone / flux surface averages and integrals.

-- in subdirectory fpreproc:
   Python scripts for fortran pre-processing.

-- in subdirectory include/fpreproc:
   *.h files for source pre-processing.

-- in subdirectory mclib:
   Makefile 
   Sources to build libmclib.a, an internally used library 
	for string manipulation.
   
-- in subdirectory r8bloat:
   Makefile 
   Sources to build libr8bloat.a, an internally used library 
	with miscelanious math routines.
   
-- in subdirectory smlib:
   Makefile 
   Sources to build libsmlib.a, an internally used library 
	with math routines.
      
-- in subdirectory tridiag:
   Makefile 
   Sources to build libtridiag.a, an internally used library
	for solving tridiagonal systems.

-- in subdirectory portlib:
   Makefile
   Sources to build internally used library libportlib.a.

-- for the test and the visualization programs:
   subdirectories sglib, trgraf, ureadsub, vaxonly, lsode,
	lsode_linpack, mdstransp, nscrunch
   	containing sources and Makefiles to build these libraries.

**************************
2. UNPACKING INSTRUCTIONS:
**************************
Note: Download the module(s) into an empty directory.

for tarfiles:
  > gunzip xplasma.tar.gz
  > tar xvf xplasma.tar

or, for zip archives:
  > unzip xplasma.zip


****************
3. DESTINATIONS:
****************
Or where do the files go?
(this refers to building and testing; see FINAL INSTALLATION for end result) 


When you extract the tar file you get sub directories:
./xplasma2          --  sources and Makefile
./old_xplasma       --  sources and Makefile
./xplasma_debug     --  sources and Makefile
./comput            --  transformation/interpolation routines
./fluxav            --  flux zone / flux surface averages and integrals
./fpreproc          --  scripts for pre-processing of fortran
./geqdsk_mds        --  
./include/fpreproc  --  *.h files for cpp
./lsode             --  REAL*8 version of netlib odepack
./lsode_linpack     --  linpack routines used by lsode
./mclib             --  string manipulation
./mds_dummy         --  Dummy routines for mdsplus
./mdstransp         --  fortran/c interface for mdsplus
./nscrunch          --  moment representation of nested flux surfaces
./portlib           --  internally used library
./r8bloat           --  miscelanious math routines
./share             --  include file Make.flags, Make.local.sample
./smlib             --  math algorithms
./tridiag           --  for solving tridiagonal systems
./vaxonly	    --  Low level code for machine dependence

for test_xplasma and visualization program:
./sglib             -- graphics 
./trgraf	    -- display routines
./ureadsub          -- interactive command interface 


The makefile will create more sub directories,

lib:     for the libraries
mod:     for the f90 modules
obj/*:   for compiled objects and pre-processed sources
test:    for the test programs and the sample output files.

By default these directories are created in  
./<MACHINE>, which is determined by Make.flags.
e.g.: if you are running Linux, and the tar file resides in $HOME/foo,
      the directories would be in
      $HOME/foo/LINUX/...

You can overwrite the destination by defining OBJ, as an environment
variable (e.g. export OBJ=/dir1/dir2),
or with make (e.g. "make all OBJ=.").
If OBJ is defined, the destinations will be
$OBJ/lib and $OBJ/test.
If OBJ is defined as "." then, in the example above, the destination
would be $HOME/foo/lib.

The rationale behind <MACHINE> is to facilitate building for various platforms.

Note: If you define OBJ as option to gmake, you have to consistently do so;
      e.g: gmake clean OBJ=., gmake install OBJ=.

 
*************************
4. BUILDING INSTRUCTIONS:
*************************

Required Libraries:
===================
           libpspline.a   -> NTCC module PSPLINE, now on GitHub
           lapack
	   blas
           netCDF


Optional Libraries:
===================
           MDSplus   for geqxpl option 

	   readline, history, termcap  for Command Line Editing
           Note: if these libraries are "partionally" installed,
                 not all three are available, 
                 you must define NO_EDITLIBS
		 e.g.: gmake NO_EDITLIBS=Y

Check with your systems administrator where these libraries and modules are.


lapack, blas and netCDF
-----------------------
lapack, blas and netCDF are assumed to be in /usr/local/lib,
if not, you can specify the location with LIBROOT,

e.g.: "gmake LIBROOT=/usr/contrib".

If netCDF is in a separate location, specify NETCDF_DIR

e.g.: "gmake NETCDF_DIR=/usr/local/my-netcdf LIBROOT=/my-libroot".

Alternatively you can modify Make.local.sample
and rename it to Make.local.

pspline
-------
If your site already has pspline installed,
specify the location (library and modules) with PREFIX, 

e.g. "gmake PREFIX=/usr/ntcc"

At PPPL ntcc libraries are in /usr/ntcc.

Note: If you don't have all required NTCC libraries, you may download
      them together into the same root directory. The Makefile will build
      them all in one step. 


Building libraries and proprams
-------------------------------- 
> gmake            -- to compile library and link all test programs

> gmake checklibs  -- tells you what the makefile will do
                      (without any action);
                      it says which libraries it will make and
                      which ones it already found and where.
 
> gmake clean      -- to remove objects
> gmake realclean  -- to remove objects and library

> gmake show_makeflags -- to see what flags, definitions Make will use

Compiling on Linux:
-------------------

By default the Makefile will select Fujitsu f95.

To select a different compiler define
FORTRAN_VARIANT to "Portland"  "PathScale" " GCC" "NagWare"  "Fujitsu" or "Absoft"

e.g.:
setenv FORTRAN_VARIANT Portland (csh)
FORTRAN_VARIANT=Portland; export  FORTRAN_VARIANT (sh)

Alternatively, FORTRAN_VARIANT can be passed directly to the gmake
command, as in:
gmake  FORTRAN_VARIANT=Portland

Note: some test programs are linked with g++; to find the Fortran libraries,
      you need to define FLIBROOT

To use vastf90:
> gmake VAST90=y

To use NAG90: 
> gmake NAG90=y


Compiling on Alpha Linux:
-------------------------
The Makefile assumes the Compaq compiler and specifies the 
 " -assume no2underscores " option.

Therefore the calling user software must also be compiled with this
option, or you should edit share/Make.flags to remove the option.


Compiling on SUN:
-----------------
The Makefile specifies the " -fast " option which includes -dalign.
Therefore the calling user software must also be compiled with this
option, or you should edit share/Make.flags to remove the option.



************************
5. TESTING INSTRUCTIONS:
************************

directory $OBJ/test  -or-  <MACHINE>/test  will contain:

xplasma2_test    :  Quick test of xplasma

test_xplasma     :  Test driver for xplasma 
script.ind       :  controlling input script for test_xplasma
jet.ind		 :  input script for script.ind
nstx.ind         :  input script for script.ind
plotall.ind
script_output.ps :  output from "test_xplasma @script"

geqxpl           :  Test for EFIT output
nstx_geqdsk.ind  :  controlling input script for geqxpl
g104403.nstx     :  a G-EQDSK file
geqxpl_output.ps :  output from "geqxpl @nstx_geqxpl"

geqxpl2          :  Example to create an xplasma from a geqdsk file
g103875.nstx     :  a G-EQDSK file

xplasma_fsp_test :  Examples for F77 interface calls
104276D02_4s710_xplasma.cdf : input for xplasma_fsp_test

plot_xplasma     :  visialization utility


To run tests:
-------------
define environment variable TERMINAL_TYPE = XTERM
 (e.g. export TERMINAL_TYPE=XTERM)

cd <MACHINE>/test
./xplasma2_test

No input required. 

./test_xplasma @script

This will produce a canned sequence of plots.  This is the same set of
plots as are stored in script_output.ps

./geqxpl @nstx_geqdsk

This will also produce a canned sequence of plots.  This is the same set of
plots as are stored in geqxpl_output.ps

./geqxpl2

This will start an interactive session.


./xplasma_fsp_test

This will read the includes netCDF file and print the example results.
(no graphics).

For details see README or http://w3.pppl.gov/~pshare/help/xplasma.htm


************************
6. DOCUMENTATION:
************************

XPLASMA Home Page:
http://w3.pppl.gov/NTCC/Xplasma

XPLASMA HELP
http://w3.pppl.gov/~pshare/help/xplasma.htm

NTCC Home Page:
http://w3.pppl.gov/NTCC


**********************
7. FINAL INSTALLATION:
**********************

Choose or create the root directory in which you wish to install the software.
A common location would be /usr/ntcc, but installation can occur in any
directory where you have appropriate permissions.

You define your choice of root directory via PREFIX.
The default for PREFIX is /usr/ntcc.

The assumptions are:

libraries in:       $PREFIX/lib        = $LIBDIR
f90 modules in:     $PREFIX/mod        = $MODDIR
utility in:         $PREFIX/bin        = $BINDIR
man pages in:       $PREFIX/man/man3   = $MANDIR/man3

To install the software, return to the top directory (the directory,
where you downloaded the tar files) and type

> gmake install  
    to install into /usr/ntcc/...

> gmake install PREFIX=/dir1/dir2/
    to install into /dir1/dir2/...

If you want things elsewhere, you can overwrite the default with
> gmake install LIBDIR=/xxx MODDIR=yyy BINDIR=zzz

NOTE:
-----
The library is installed as libxplasma.a
Users should link with

-L<PREFIX>/lib -lxplasma -lfluxav -lezcdf \
	 -lmclib -lsmlib -ltrgraf -lureadsub -lvaxonly  \
	 -ltridiag -lr8bloat -lcomput -lpspline -lportlib

Make sure users know what <PREFIX> is.

After you have installed the software, you can delete the entire tree
with
> cd ..
> rm -r foo
   assuming the previous example.

----------------------------------------------------------------------------

IF YOU HAVE ANY PROBLEMS, PLEASE CONTACT EITHER:


        Doug McCune, Princeton University
                dmccune@pppl.gov
        or

        Christiane Ludescher-Furth, Princeton University
                cludescher@pppl.gov
        or      
                ntcc_webmaster@pppl.gov

#include "fpreproc/f77_dcomplx.h"
C******************** START FILE LOKJAC.FOR ; GROUP TKBLOAT ******************
 
C-- END FILE #BLOAT# ************************************
CFORMFEEDC-- START FILE #LOKJAC# ************************************
       LOGICAL FUNCTION r8lokjac(R0,DR0DXI,RJ,DRJDXI,YJ,DYJDXI,NMOM)
C
C
C       BOB MCCANN, 19-APR-85
C
C
C       --------
C       COMMENTS
C       --------
C
C
C	THIS CHECKS TO SEE IF THE JACOBIAN D(R<Y)/D(XI,XI) CHANGES SIGN
C    AROUND THE GIVEN FLUX SURFACE.  LOKJAC=.T. IF THE SIGN IS UNCHANGED,
C    AND LOKJAC=.F. IF THE SIGN CHANGES
C    (THE TRANSFORMATION WENT SINGULAR).
C
C
C       -------------------
C       GLOBAL DECLARATIONS
C       -------------------
C
C
C***
C
C
C       ---------------
C       INPUT VARIABLES
C       ---------------
C
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER nth,i,j
!============
! idecl:  explicitize implicit REAL declarations:
      REAL*8 zpi,zth,zjmin,thjmin,zjmax,thjmax
!============
      INTEGER	NMOM		!# OF MOMENTS OF R, Y
C
C    THE FOLLOWING REFER TO A GIVEN FLUX SURFACE:
C
      REAL*8	R0		!ZEROTH MOMENT
      REAL*8	DR0DXI		!D(R0)/DXI
      REAL*8	RJ(NMOM)	!J=1,NMOM MOMENTS OF R
      REAL*8	DRJDXI(NMOM)	!D(RJ)/DXI
C
      REAL*8	YJ(NMOM)	!K=1, NMOM MOMENTS OF Y
      REAL*8	DYJDXI(NMOM)	!D(YJ)/DXI
C
C
C       ----------------
C       OUTPUT VARIABLES
C       ----------------
C
C
C	LOGICAL LOKJAC	!=.T. IF THE TRANSFORMATION IS OK
C			!=.F. IF THE COORDINATES ARE SINGULAR
C
C
C       ------------------
C       LOCAL DECLARATIONS
C       ------------------
C
C
      PARAMETER	(NTH = 127)	!# ANGLES TO USE IN FINDING EXTREMA
C
      REAL*8	ZC(NTH)		!COS(J*TH) ASSUMING NMOM.LE.NTH
      REAL*8	ZS(NTH)
C
      REAL*8	ZR77		!R(TH)
      REAL*8	ZY77		!Y(TH)
      REAL*8	ZDRDTH		!DR/DTH
      REAL*8	ZDYDTH		!DY/DTH
      REAL*8	ZDRDXI		!DR/DXI
      REAL*8	ZDYDXI		!DY/DXI
      REAL*8	ZJ		!JACOBIAN
C
C
C       ---------------
C       DATA STATEMENTS
C       ---------------
C
C
C***
C
C
C       -------------------
C       STATEMENT FUNCTIONS
C       -------------------
C
C
C***
C
C
C=========================================
C
C
C       ----------------------
C       0.1     INITIALIZATION
C       ----------------------
C
C
      ZPI = 4.0D0*ATAN(1.0D0)
C
C    LOOP OVER SOME ANGLES FROM 0 TO PI:
C
      DO 69000 I = 1, NTH
C
        ZTH = ZPI*AREAL(I-1)/AREAL(NTH-1)
C
        DO 100 J = 1, NMOM
          ZC(J) = COS(J*ZTH)
          ZS(J) = SIN(J*ZTH)
100     CONTINUE
C
C
C	----------------------------------------------
C	1.0	COMPUTE VARIOUS DERIVATIVES OF R AND Y
C	----------------------------------------------
C
C
10000 CONTINUE
C
C    HANDLE ZEROTH MOMENT AND INITIALIZE THE MOMENTS LOOP
C
      ZR77 = R0
      ZDRDXI = DR0DXI
      ZDRDTH = 0.0D0
C
      ZY77 = 0.0D0
      ZDYDTH = 0.0D0
      ZDYDXI = 0.0D0
C
C    ADD UP THE CONTRIBUTION FROM EACH MOMENT
C
      DO 10100 J = 1, NMOM
C
        ZR77 = ZR77 + RJ(J)*ZC(J)
C
        ZDRDXI = ZDRDXI + DRJDXI(J)*ZC(J)
        ZDRDTH = ZDRDTH - RJ(J)*AREAL(J)*ZS(J)
C
        ZY77 = ZY77 + YJ(J)*ZS(J)
C
        ZDYDXI = ZDYDXI + DYJDXI(J)*ZS(J)
        ZDYDTH = ZDYDTH + YJ(J)*AREAL(J)*ZC(J)
C
10100 CONTINUE
C
C
C       -------------------------------------------------
C       2.0     COMPUTE THE JACOBIAN OF THIS FLUX SURFACE
C       -------------------------------------------------
C
C
20000   CONTINUE
C
      ZJ = ZDRDXI*ZDYDTH - ZDRDTH*ZDYDXI	!JACOBIAN
C
C
C	--------------------------------------------------
C	3.0	FIND THE MAXIMA AND MINIMA OF THE JACOBIAN
C	--------------------------------------------------
C
C
30000 CONTINUE
C
      IF(I.EQ.1)	THEN	!INITIALIZE MAX AND MIN
C
        ZJMIN = ZJ
        THJMIN = ZTH
        ZJMAX = ZJ
        THJMAX = ZTH
C
      ELSE			!FIND THE TRUE MIN AND MAX
C
        IF(ZJ.LT.ZJMIN)	THEN
          ZJMIN = ZJ
          THJMIN = ZTH
        ELSEIF(ZJ.GT.ZJMAX)	THEN
          ZJMAX = ZJ
          THJMAX = ZTH
        ENDIF
C
      ENDIF
C
69000 CONTINUE		!END OF ANGLE LOOP
C
C
C       ------------------------
C       7.0     CLEANUP & RETURN
C       ------------------------
C
C
70000   CONTINUE
C
C
      IF(ZJMIN*ZJMAX.GT.0.0D0)	THEN	!THEY HAVE THE SAME SIGN
          r8lokjac = .TRUE.
      ELSE
          r8lokjac = .FALSE.
      ENDIF
C
C
79000   CONTINUE        !ERROR RETURNS HERE
C
        RETURN
C
C
C       ----------------------
C       8.0     ERROR HANDLING
C       ----------------------
C
C
C***
C
C
        END
C******************** END FILE LOKJAC.FOR ; GROUP TKBLOAT ******************
! 11Jan2003 fgtok -s r8_precision.sub r8bloat_names.sub "r8con.csh conversion"
! 11Jan2003 fgtok

subroutine eq_gbids(id_g,id_R,id_BR,id_BZ,id_Bmod)

  !  get the field related Xplasma profile IDs
  !   g(rho)  BR(theta,rho)  BZ(theta,rho)  Bmod(theta,rho)

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  integer, intent(out) :: id_g,id_R,id_BR,id_BZ,id_Bmod

  !-----------------
  integer :: iertmp
  !-----------------

  call xplasma_common_ids(s,iertmp, &
       id_g=id_g, id_R=id_R, id_BR=id_BR, id_BZ=id_BZ, id_Bmod=id_Bmod)

  if(iertmp.ne.0) then
     write(lunerr,*) ' ?eq_gbids -- failed to get B field IDs'
     call xplasma_error(s,iertmp,lunerr)

     id_g = 0
     id_R = 0
     id_BR = 0
     id_BZ = 0
     id_Bmod = 0
  endif

end subroutine eq_gbids

module xplasma_debug_link

  ! provide method to load and call xplasma debug routines
  ! if a program just "use"s this module, it should link xplasma_debug
  ! even if the xplasma_debug_access call is not made.

  use xplasma_definitions
  use eqi_intg_module

  private

  public :: xplasma_debug_access

  contains
    subroutine xplasma_debug_access(s)

      type (xplasma), pointer :: s

      sp_debug => s
      call xplasma_debug

    end subroutine xplasma_debug_access

end module xplasma_debug_link

      SUBROUTINE MCRDR_OPENCK(LUN,NAME,LUNT,IER)
C
C  OPEN A FILE - READONLY - ERROR CHECK
C
      CHARACTER*(*) NAME
C
      CLOSE(UNIT=LUN,ERR=5)
 5    CONTINUE
C
      CALL UFOPEN(LUN,NAME,1,IER,0)
      IF(IER.EQ.0) GO TO 20
C
 10   CONTINUE
      WRITE(LUNT,1001) LUN,NAME,IER
 1001 FORMAT(' %MCRDR_OPENCK:  ',
     >'ASCII SEQUENTIAL READONLY FILE OPEN FAILURE'/
     >'  NAME="',A,'"  LUN=',I4,' IOSTAT=',I4)
C
 20   CONTINUE
      RETURN
      END

subroutine eqi_fbmod(ivec,zrho,zchii,ict,ivecd,zans,ier)

  use xplasma_definitions
  use eqi_rzbox_module

  !  evaluate 2d spline (and derivatives) of mod(B) vs. rho,chi

  IMPLICIT NONE

  !  input:

  integer ivec
  REAL*8 zrho(ivec)                 ! argument -- where to evaluate
  REAL*8 zchii(ivec)                ! argument -- where to evaluate
  integer ict                       ! 1: return B; 2: return B & dB/dtheta

  !  chi is periodic and will be adjusted, but, the user should avoid
  !  passing chi arguments that are out of the normal range by more than
  !  a few periods.

  !  output:

  integer ivecd
  REAL*8 zans(ivecd,ict)            ! result of evaluation(s)
  integer ier                       ! exit code, 0= normal

  !----------------------------------
  integer :: ilist(ict)
  integer :: ideriv(ict)
  integer :: id_Bmod
  !----------------------------------

  call xplasma_common_ids(sp,ier,id_Bmod=id_Bmod)
  if(ier.ne.0) return

  if(id_Bmod.eq.0) then
     call xplasma_errmsg_append(sp, &
          ' ?eqi_fBod: no Bmod(rho,theta) spline found.')
     ier=106
     return
  endif

  ilist=id_Bmod
  ideriv(1)=0
  if(ict.eq.2) ideriv(2)=1

  call xplasma_eval_prof(sp,ilist, &
       xplasma_theta_coord,zchii, xplasma_rho_coord,zrho, &
       zans(1:ivec,1:ict),ier, ideriv1s=ideriv)

end subroutine eqi_fbmod

subroutine eq_flxint_arr2(zdata,iwant,result,inumchi,inumrho,ierr)

  ! integration of user defined data -- legacy f77 interface

  use xplasma_obj_instance
  use eq_module
  IMPLICIT NONE
  
  !  given zdata(1:nchi,1:nrho) represent f(chi,rho), use eq_flxint_arr2s
  !  to (a) setup a spline representation, and (b) do the chosen set of
  !  numeric integrations using this representation.

  !  "not a knot" boundary condition will be applied to the spline.
  !  for more control of the boundary condition see eq_flxint_arr2s.

  !  *** iwant *** specifies the type of integration desired:
  !    here "f" denotes the interpolating function generated from the
  !    passed array data.

  !    iwant=1:  surface integral:
  !       int[phi=0 to 2pi] dphi * {
  !            int[chi=0 to 2pi] dchi * f }

  !    iwant=5:  volume weighted surface integral:
  !        int[phi=0 to 2pi] dphi * {
  !            int[chi=0 to 2pi] dchi * f * det(Jacobian) }

  !      **caution** if rho(1) corresponds to the mag. axis, a
  !        det(Jacobian)=0 and a value of 0.0 is always returned!

  !    iwant=6:  volume weighted surface average:

  !        int[phi=0 to 2pi] dphi * {
  !            int[chi=0 to 2pi] dchi * f * det(Jacobian)}
  !        -----------------------------------------------
  !        int[phi=0 to 2pi] dphi * {
  !            int[chi=0 to 2pi] dchi * det(Jacobian)}

  !      **caution** if rho(1) corresponds to the mag. axis,
  !        the value "f" evaluated at the axis is returned there.

  !  zonal integrals:  result(1:nrho-1) are computed; result(j)
  !                    corresponds to the integral from rho(j) to rho(j+1)

  !    iwant=2:  integrate f*drho*dtheta*dphi:

  !       int[rho=rho(j) to rho(j+1)] drho * {
  !          int[phi=0 to 2pi] dphi * {
  !               int[chi=0 to 2pi] dchi * f } }

  !    iwant=3:  integrate f*dV (use det(Jacobian))

  !       int[rho=rho(j) to rho(j+1)] drho * {
  !          int[phi=0 to 2pi] dphi * {
  !               int[chi=0 to 2pi] dchi * f * det(Jacobian) } }

  !    iwant=4:  compute <f> = (integrated f*dV)/dVol
  !              where dVol is the volume btw rho(j) and rho(j+1)

  !  **caution** in axisymmetric case there is no variation with phi,
  !  but a factor of 2pi still arises from the phi integration...

  !  **input**

  real*8 zdata(*)

  integer iwant                ! type of integrations wanted

  integer inumchi              ! 1st (chi) dim of result
  integer inumrho              ! 2nd (rho) dim of result

  !  if inumchi=1, do integrations over the entire flux zone / flux surface
  !  if inumchi>1, do integrations over chi segments.

  !  **output**

  real*8 result(inumchi,inumrho) ! results of integrations
  integer ierr                   ! completion code, 0=OK
  !                                  ! see description, above...

  !  this routine has a simplified argument list; eq_flxint_arr2s
  !  and eq_flxint_arr2d are more complex, with more control options.

  !  **note** the number of values returned by result is set by a prior
  !  call to eq_flxint_init -- #integration zones if iwant.gt.1;
  !  #integration zones + 1 if iwant.eq.1
  !-------------------------------------
  real*8 :: zdum(1)
  !-------------------------------------

  zdum(1)=0.0d0

  call eq_flxint_arr2s(zdata, &
       0,zdum,0,zdum, &
       iwant,result,inumchi,inumrho,ierr)

  if(ierr.ne.0) then
     write(lunerr,*) ' eq_flxint_arr2: eq_flxint_arr2s returned ierr=',ierr
  endif

end subroutine eq_flxint_arr2

subroutine eqi_xpsi_fun(ivec,iok,x,ansr,ivecd,zinput,ninput,zoutput,noutput)

  ! subroutine passed to "zridderx" root finder -- 
  !   looking for rho to satisfy Psi(rho) - Psi_target = 0

  use xplasma_definitions
  use eqi_rzbox_module
  implicit NONE

  integer ivec
  logical iok(ivec)  ! if iok(i) TRUE then SKIP element i of vector
  real*8 x(ivec)     ! input vector {x(i)}
  real*8 ansr(ivec)  ! output vector {f(x(i))}
  integer ivecd      ! auxilliary information vector size (.ge.ivec)
  integer ninput,noutput
  real*8 zinput(ivecd,ninput),zoutput(ivecd,noutput)

  !-----------------
  integer, parameter :: ilun_dbg=6
  integer :: id_psi,i,iertmp,itry
  real*8 :: xtry(ivec),pstry(ivec),pstarg(ivec)
  !-----------------

  xtry = 0
  pstry = 0
  pstarg = 0
  call xplasma_common_ids(sp,iertmp, id_psi=id_psi) ! assume this is OK

  itry = 0
  do i=1,ivec
     if(.not.iok(i)) then
        itry=itry+1
        xtry(itry)=x(i)
        pstarg(itry)=zinput(i,1)
     endif
  enddo

  call xplasma_eval_prof(sp,id_psi,xtry,pstry,iertmp, force_bounds=.TRUE.)
  if(iertmp.ne.0) then
     write(ilun_dbg,*) ' ? xplasma2/eqi_xpsi_fun.f90: unexpected error:'
     call xplasma_error(sp,iertmp,6)
  endif

  itry = 0
  do i=1,ivec
     if(.not.iok(i)) then
        itry=itry+1
        ansr(i)=pstry(itry)-pstarg(itry)
     endif
  enddo

end subroutine eqi_xpsi_fun

module eq_arc_scrunch_mod

  ! "private" module for nscrunch library

  use iso_c_binding, only: fp => c_double
  implicit NONE

  integer :: ntha
  real(fp), dimension(:,:), allocatable :: tha_pkg   ! working TH grid

  real(fp), dimension(:,:), allocatable :: Rspl  ! R(TH)
  real(fp), dimension(:,:), allocatable :: Zspl  ! Z(TH)
  real(fp), dimension(:,:), allocatable :: Lspl  ! L(TH) precise arc-length
  real(fp), dimension(:), allocatable :: wk,thmap

  real(fp) :: thzero,Lzero,Ltotal

  real(fp), parameter :: CSMALL = 1.0e-14_fp

contains

  subroutine eq_arc_scrunch1(Raxis,Zaxis, R,Z, rmc,rms,zmc,zms, imom,ier)
    use physconst_mod, only: zero, twopi
    implicit none

    !--------------------------------------
    !  equal arc scrunch a single surface; define theta=0 as being on
    !  the outer half midplane, drawn horizontally outward from the 
    !  magnetic axis; store R[0:2pi],Z[0:2pi] w.r.t. an equal arc length
    !  defined poloidal angle parameter; also compute FFT moments 
    !  representation

    real(fp), intent(in) :: Raxis,Zaxis        ! axis location

    real(fp), dimension(:), intent(inout) :: R,Z  ! a surface contour
    !  each point must be distinct; 1st and last points must match.
    !  these are assumed to be smoothly spaced, e.g. equispaced in
    !  angle defined by an arc-tangent from the magnetic axis

    integer, intent(in) :: imom  ! #moments not counting 0th moment

    !  the R & Z cos and sin moments:

    real(fp), intent(out) :: rmc(0:imom),rms(0:imom),zmc(0:imom),zms(0:imom)

    integer, intent(out) :: ier

    !--------------------------------------
    !  external routines for root finder...

    external eq_arc_fmidplane
    external eq_arc_findarc

    !--------------------------------------
    !  local variables...

    integer :: i,ii,im,idum,izero,ifound,iertmp,inm1
    real(fp) :: zdR,zdZ,zdL,zdth,eps,eta,ztest,zdlmin,zdlmax

    integer, dimension(3) :: ict_eval = (/ 1, 0, 0 /)
    integer, dimension(3) :: ict_der1 = (/ 0, 1, 0 /)

    real(fp) :: w0(10),th0(10),wvec(10),thvec(10)  ! for integration of L(TH)
    real(fp) :: drdth(10),dzdth(10),dldth,thzero,zlsum,zdum

    logical, dimension(:), allocatable :: imask
    real(fp), dimension(:), allocatable :: ltarg,thfnd,th1,th2,zdumma

    !  fft arrays -- dimension should match largest value of ichk!

    integer :: nfft
    real(fp), dimension(:), allocatable :: thfft,rfft,zfft,zs1d,zc1d

    !--------------------------------------
    !  debugging...
    !
#ifdef __DEBUG

    logical, save :: idebug = .FALSE.
    integer, save :: ictr = 0

    integer, parameter :: neval = 1001
    real(fp) :: theval(neval),dldth1(neval),dldth2(neval),zdra(neval),zdza(neval)
#endif
    real(fp), dimension(:,:), allocatable :: thpkg2,rspl2,zspl2

    !--------------------------------------

#ifdef __DEBUG
    ictr = ictr + 1

    if(ictr.eq.51) then
      idebug=.TRUE.
      write(6,*) ' ictr = ',ictr
    else
      idebug=.FALSE.
    endif
#endif
    ier = 0

    if(size(R).le.3) then
      ier=201   ! a non-singular closed contour must be at least 4 pts
      return
    endif

    if(size(R).ne.size(Z)) then
      ier=202   ! R and Z array sizes must match
      return
    endif

    ntha = size(R)

    if((R(1).ne.R(ntha)).or.(Z(1).ne.Z(ntha))) then
      ier=203   ! contour must close
      return
    endif

    if(allocated(tha_pkg)) deallocate(tha_pkg,Rspl,Zspl,Lspl,wk,thmap)

    allocate(tha_pkg(ntha,4),Rspl(4,ntha),Zspl(4,ntha),Lspl(4,ntha))
    allocate(wk(ntha),thmap(ntha))

    do i=1,ntha
      thmap(i)=(i-1)*twopi/(ntha-1)
    enddo

    !  create TH grid package for 1d spline evaluation (pspline lib call)
    call genxpkg(ntha,thmap,tha_pkg,1,0,0,ZERO,3,ier)
    if(ier.ne.0) then
      ier=205
      return
    endif

    !  create R spline & Z spline -- periodic splines

    Rspl(1,1:ntha)=R
    call cspline(thmap,ntha,Rspl,-1,ZERO,-1,ZERO,wk,ntha,idum,ier)
    if(ier.ne.0) then
      ier=206
      return
    endif

    Zspl(1,1:ntha)=Z
    call cspline(thmap,ntha,Zspl,-1,ZERO,-1,ZERO,wk,ntha,idum,ier)
    if(ier.ne.0) then
      ier=207
      return
    endif

    !  compute data for arc-length spline
    !  also find zone on large major radius side crossing Z=Zaxis

    call integ_wts(th0,w0)

    Lspl(1,1)=ZERO

    izero=0
    ifound=0
    if((R(ntha).gt.Raxis).and.(Z(ntha).eq.Zaxis)) then
      izero=ntha-1
      ifound=ntha
    endif

    do i=1,ntha-1
      wvec = (thmap(i+1)-thmap(i))*w0
      thvec = thmap(i) + (thmap(i+1)-thmap(i))*th0

      ! dR/dth evals

      call spvec(ict_der1,10,thvec,10,drdth,ntha,tha_pkg,Rspl,idum,ier)
      if(ier.ne.0) then
        ier=211
        return
      endif

      ! dZ/dth evals

      call spvec(ict_der1,10,thvec,10,dzdth,ntha,tha_pkg,Zspl,idum,ier)
      if(ier.ne.0) then
        ier=212
        return
      endif

      Lspl(1,i+1)=Lspl(1,i)
      do ii=1,10
        dldth = sqrt(drdth(ii)*drdth(ii) + dzdth(ii)*dzdth(ii))
        Lspl(1,i+1) = Lspl(1,i+1) + dldth*wvec(ii)
      enddo

      if((R(i).gt.Raxis).and.(Z(i).eq.Zaxis).and.(ifound/=ntha.or.i/=1)) then
        if(izero.gt.0) ier=213
        izero=i
        ifound=i
      else if(min(R(i),R(i+1)).gt.Raxis) then
        ztest = (Z(i)-Zaxis)*(Z(i+1)-Zaxis)
        if(ztest.lt.ZERO) then
          if(izero.gt.0) ier=213
          izero=i
        endif
      endif
      if(ier.ne.0) return

    enddo

    if(izero.eq.0) then
      ier=299  ! search failure, unexpected
      return
    endif

    !  setup L(TH)

    call cspline(thmap,ntha,Lspl,-1,ZERO,-1,ZERO,wk,ntha,idum,ier)
    if(ier.ne.0) then
      ier=215
      return
    endif

    Ltotal=Lspl(1,ntha)

#ifdef __DEBUG
    if(idebug) then
      do i=1,neval
        theval(i)=(i-1)*twopi/(neval-1)
      enddo
      call spvec(ict_der1,neval,theval,neval,dldth1, &
           ntha,tha_pkg,Lspl,idum,ier)
      call spvec(ict_der1,neval,theval,neval,zdra, &
           ntha,tha_pkg,Rspl,idum,ier)
      call spvec(ict_der1,neval,theval,neval,zdza, &
           ntha,tha_pkg,Zspl,idum,ier)

      do i=1,neval
        dldth1(i)=dldth1(i)/(Ltotal/twopi)
        dldth2(i)=sqrt(zdra(i)**2+zdza(i)**2)/(Ltotal/twopi)
        zdra(i)=zdra(i)/(Ltotal/twopi)
        zdza(i)=zdza(i)/(Ltotal/twopi)
      enddo

      call r8_grafx2(theval,dldth1,dldth2,neval,'rad',' ', &
           'eq_arc_scrunch1 debug plot', &
           '[(dl/dth)/(Ltot/2pi)] from L spline', &
           '[(dl/dth)/(Ltot/2pi)] from R & Z splines')

      call r8_grafx3(theval,dldth2,zdra,zdza,neval,'rad',' ', &
           'eq_arc_scrunch1 debug plot', &
           '[(dl/dth)/(Ltot/2pi)] from R & Z splines', &
           'R & Z contributions separately.')
    endif
#endif

    !  find TH satisfying {R > Raxis, Z(TH)=Zaxis}

    eps=CSMALL*twopi
    eta=CSMALL*Ltotal

    allocate(imask(ntha-2))
    imask=.FALSE.

    ! reuse thmap; the th working grid data is in tha_pkg(:,1)

    if(ifound.gt.0) then
      thzero=thmap(ifound)
    else

      call zridderx(1, imask, tha_pkg(izero,1), tha_pkg(izero+1,1), &
           eps, eta, eq_arc_fmidplane, thzero, ier, &
           1,Zaxis,1,Zdum,0)

    endif
    if(ier.ne.0) then
      ier=217
      return
    endif

    call spvec(ict_eval,1,thzero,1,Lzero,ntha,tha_pkg,Lspl,idum,iertmp)
    ier=max(ier,iertmp)
    call spvec(ict_eval,1,thzero,1,R(1),ntha,tha_pkg,Rspl,idum,iertmp)
    ier=max(ier,iertmp)
    call spvec(ict_eval,1,thzero,1,Z(1),ntha,tha_pkg,Zspl,idum,iertmp)
    ier=max(ier,iertmp)

    if(ier.gt.0) then
      ier=218
      return
    endif

    !  zero point = 2pi point established...

    R(ntha)=R(1)
    Z(ntha)=Z(1)

    imask(1)=.FALSE.

    !  get the rest...

    allocate(Ltarg(ntha-2),thfnd(ntha-2),th1(ntha-2),th2(ntha-2))
    allocate(zdumma(ntha-2))

    zLsum=Lzero
    do i=1,ntha-2
      zLsum = zLsum + Ltotal/(ntha-1)  ! equal arc increments
      if(zLsum.gt.Ltotal) then
        zLsum=zLsum-Ltotal
        izero=1
      endif
      Ltarg(i)=zLsum
      do
        if(Ltarg(i).gt.Lspl(1,izero+1)) then
          izero=izero+1
        else
          exit
        endif
      enddo
      th1(i)=tha_pkg(izero,1)
      th2(i)=tha_pkg(izero+1,1)
    enddo

    call zridderx(ntha-2, imask, th1, th2, eps, eta, eq_arc_findarc, &
         thfnd, ier, ntha-2, Ltarg, 1, zdumma, 1)

    if(ier.ne.0) then
      ier=219
      return
    endif

    call spvec(ict_eval,ntha-2,thfnd,ntha-2,R(2:ntha-1), &
         ntha,tha_pkg,Rspl,idum,iertmp)
    ier=max(ier,iertmp)

    call spvec(ict_eval,ntha-2,thfnd,ntha-2,Z(2:ntha-1), &
         ntha,tha_pkg,Zspl,idum,iertmp)
    ier=max(ier,iertmp)

    do i=1,ntha
      thmap(i)=(i-1)*twopi/(ntha-1)
    enddo

    allocate(thpkg2(ntha,4),rspl2(4,ntha),zspl2(4,ntha))
    call genxpkg(ntha,thmap,thpkg2,1,0,0,ZERO,3,ier)

    rspl2(1,1:ntha) = r(1:ntha)
    zspl2(1,1:ntha) = z(1:ntha)

    call cspline(thmap,ntha,Rspl2,-1,ZERO,-1,ZERO,wk,ntha,idum,ier)
    call cspline(thmap,ntha,Zspl2,-1,ZERO,-1,ZERO,wk,ntha,idum,ier)

#ifdef __DEBUG

    if(idebug) then

      call spvec(ict_der1,neval,theval,neval,zdra, &
           ntha,thpkg2,Rspl2,idum,ier)
      call spvec(ict_der1,neval,theval,neval,zdza, &
           ntha,thpkg2,Zspl2,idum,ier)

      do i=1,neval
        dldth2(i)=sqrt(zdra(i)**2+zdza(i)**2)/(Ltotal/twopi)
        zdra(i)=abs(zdra(i))/(Ltotal/twopi)
        zdza(i)=abs(zdza(i))/(Ltotal/twopi)
      enddo

      call r8_grafx3(theval,dldth2,zdra,zdza,neval,'rad',' ', &
           'eq_arc_scrunch1 debug plot', &
           '[(dl/dth)/(Ltot/2pi)] from R & Z spline set#2', &
           'R & Z contributions separately.')

    endif

#endif
    !  FFT

    nfft=8
    do
      if(nfft.ge.4*imom) exit
      nfft=nfft*2
    enddo

    allocate(thfft(nfft),rfft(nfft),zfft(nfft),zs1d(nfft),zc1d(nfft))

    do i=1,nfft
      thfft(i)=(i-1)*twopi/nfft
    enddo

    call spvec(ict_eval,nfft,thfft,nfft,rfft, &
         ntha,thpkg2,rspl2,idum,ier)
    call spvec(ict_eval,nfft,thfft,nfft,zfft, &
         ntha,thpkg2,zspl2,idum,ier)

    call r8fftsc(Rfft,nfft,zs1d,zc1d,ier)

    rmc(0)=zc1d(1)/(2*nfft)
    do im=1,imom
      rmc(im)=zc1d(im+1)/nfft
      rms(im)=zs1d(im+1)/nfft
    enddo

    call r8fftsc(Zfft,nfft,zs1d,zc1d,ier)

    zmc(0)=zc1d(1)/(2*nfft)
    do im=1,imom
      zmc(im)=zc1d(im+1)/nfft
      zms(im)=zs1d(im+1)/nfft
    enddo

#ifdef __DEBUG
    if(idebug) then
      do i=1,neval-1
        call r8sincos(theval(i),imom,zs1d,zc1d)
        zdra(i)=rmc(0)
        zdza(i)=zmc(0)
        do im=1,imom
          zdra(i)=zdra(i)+rmc(im)*zc1d(im)+rms(im)*zs1d(im)
          zdza(i)=zdza(i)+zmc(im)*zc1d(im)+zms(im)*zs1d(im)
        enddo
      enddo
      zdra(neval)=zdra(1)
      zdza(neval)=zdza(1)

      call r8_grafc2(r,z,ntha, zdra,zdza,neval, 'm','m', &
           '[R,Z] contour & FFT expansion version', &
           'eq_arc_scrunch_mod debug plot', ' ')
    endif
#endif

    deallocate(thfft,rfft,zfft,zs1d,zc1d)
    deallocate(imask,Ltarg,thfnd,th1,th2,zdumma)
    deallocate(thpkg2,rspl2,zspl2)

  end subroutine eq_arc_scrunch1

end module eq_arc_scrunch_mod

!------------------------------------------------------
  subroutine geq_units_echeck_r4(expr,zdatr4,ndata,ierr)
    !
    !  R4 version of geq_units_echeck
    !
    character*(*), intent(in) :: expr    ! MDS+ expression
    integer, intent(in) :: ndata         ! #data pts
    real, intent(inout) :: zdatr4(ndata) ! data pts (may be rescaled)
    integer, intent(out) :: ierr         ! completion code (out)

    integer, parameter :: r8 = selected_real_kind(12,100)
    real(r8) :: zdata(ndata)

    !--------------------------

    zdata = zdatr4
    call geq_units_echeck(expr,zdata,ndata,ierr)
    zdatr4 = zdata

  end subroutine geq_units_echeck_r4
!------------------------------------------------------
  subroutine geq_units_echeck(expr,zdata,ndata,ierr)
    !
    !  geq_units_echeck -- check/convert units for data corresponding
    !    to certain known expressions
    !
    use geqdsk_aux
    implicit NONE

    integer, parameter :: r8 = selected_real_kind(12,100)

    character*(*), intent(in) :: expr    ! MDS+ expression
    integer, intent(in) :: ndata         ! #data pts
    real(r8), intent(inout) :: zdata(ndata) ! data pts (may be rescaled)
    integer, intent(out) :: ierr         ! completion code (out)

    !------------

    character*1 bksl,zcln
    integer :: ii,idelim,ilen
    character*20 ztest

    !-------------
    !  check units corresponding to certain known MDS+ expressions
    !  callable without "use geqdsk_aux".

    ierr = 0
    zcln = ':'
    bksl = char(92)  ! back slash

    ilen=index(expr,'[')-1    ! avoid subscript expressions
    if(ilen.le.0) ilen=len_trim(expr)
    do
       if(expr(ilen:ilen).eq.')') then
          ilen=ilen-1
       else
          exit
       endif
    enddo

    idelim=0
    do ii=ilen,1,-1
       if((expr(ii:ii).eq.bksl).or.(expr(ii:ii).eq.zcln)) then
          idelim = ii
          exit
       endif
    enddo

    ztest = expr(idelim+1:ilen)
    call uupper(ztest)

    if((ztest.eq.'GTIME').or.(ztest.eq.'ATIME')) then
       call geq_units_check(expr,zdata,ndata,time_units)
    else if(ztest.eq.'CPASMA') then
       call geq_units_check(expr,zdata,ndata,current_units)
    else if(ztest.eq.'WMHD') then
       call geq_units_check(expr,zdata,ndata,pressure_units)
    else
       ierr=1
       write(lunmsg,*) ' %geq_units_echeck: not recognized for units check:', &
            ' ',trim(expr)
    endif
  end subroutine geq_units_echeck

!------------------------------------------------------
  subroutine geq_units_check(expr,zdata,ndata,data_units)
    !
    ! fetch units label; check this and convert data if necessary
    ! using the conversion table passed
    !
 
    use geqdsk_aux
    implicit NONE
 
    integer, parameter :: r8 = selected_real_kind(12,100)
    character*(*), intent(in) :: expr
    integer, intent(in) :: ndata
    real(r8), intent(inout) :: zdata(ndata)
    type(ctable), intent(in) :: data_units
 
 ! local:
 
    integer iflag,ilen
    character*5 ztest
    character*32 actual_units
    integer idescr_cstring
    integer istat,mds_value,iret
    real(auxr8) factor
 
 ! executable code:
 
    call ctable_init

    ilen=index(expr,'[')-1    ! avoid subscript expressions
    if(ilen.le.0) ilen=len_trim(expr)
 
    iflag=0
    if(ilen.le.7) then
       iflag=1
    else
       ztest=expr(1:5)
       call uupper(ztest)
       if(ztest.ne.'DATA(') iflag=1
    endif
 
    if(iflag.eq.1) then
       write(lunmsg,*) ' %geqdsk_mod(geq_units_check):  expr = ',expr(1:ilen)
       write(lunmsg,*) '  not a data expression -- likely programming error.'
       return
    endif
 
    istat = mds_value('UNITS('//expr(6:ilen),idescr_cstring(actual_units), &
         & iret)
 
    if(mod(istat,2).ne.1) then
       call mdserr(lunmsg,'%geq_units_check: i/o: UNITS('//expr(6:ilen),istat)
       return
    endif
 
    call ctable_check(data_units, actual_units, factor)
    zdata = factor*zdata
 
  end subroutine geq_units_check
!------------------------------------------------------
  subroutine geq_mds_sub1(zbuf,nbuf,zsav,nsav,indx,nodename, &
       & treename,expr,data_units,istat)
!
!  read and copy a floating scalar fcn of time node, saving valid points only
!
    use geqdsk_aux
    implicit NONE
 
    integer, parameter :: r8 = selected_real_kind(12,100)
    integer, intent(in) :: nbuf,nsav
    real(r8), intent(inout) :: zbuf(nbuf)
    real(r8), intent(out) :: zsav(nsav)
    integer, intent(in) :: indx(nbuf)
 
    character*(*), intent(in) :: treename
    character*(*), intent(in) :: nodename
    character*(*), intent(out) :: expr
 
    type(ctable), intent(in) :: data_units   ! known units labels & conversions
 
    integer, intent(out) :: istat
 
! local
 
    integer iln,ilt, iok
    integer idims(2),iret,mds_value,idescr_floatarr
    integer i
    character*1 bksl
 
    real, dimension(:), allocatable:: r4buf
 
! executable code
 
    call ctable_init

    allocate(r4buf(nbuf), stat=iok)
    if(iok/=0) then
       write(lunmsg,*) '***failed to allocate r4buf in geq_mds_sub1'
       istat = 9999
       return
    endif
 
    bksl = char(92)   ! backslash
 
    idims(1)=nbuf
    idims(2)=0
 
    iln=len_trim(nodename)
    ilt=len_trim(treename)
 
    call geq_mk_expr('data(',nodename(1:iln),')',expr)
    istat = mds_value(expr,idescr_floatarr(r4buf,idims,1),iret)
    zbuf=r4buf
    if(mod(istat,2).eq.1) then
       do i=1,nbuf
          if(indx(i).ne.0) zsav(indx(i))=zbuf(i)
       enddo
       call geq_units_check(expr,zsav,nsav,data_units)
    endif
 
    deallocate(r4buf)
    return
  end subroutine geq_mds_sub1
!------------------------------------------------------
  subroutine geq_mds_subi(ibuf,nbuf,isav,nsav,indx,nodename, &
       & treename,expr,istat)
!
!  read and copy an integer scalar fcn of time node, saving valid points only
!
    implicit NONE
 
    integer, parameter :: r8 = selected_real_kind(12,100)
    integer, intent(in) :: nbuf,nsav
    integer, intent(inout) :: ibuf(nbuf)
    integer, intent(out) :: isav(nsav)
    integer, intent(in) :: indx(nbuf)
 
    character*(*), intent(in) :: treename
    character*(*), intent(in) :: nodename
    character*(*), intent(out) :: expr
 
    integer, intent(out) :: istat
 
! local
 
    integer iln,ilt
    integer idims(2),iret,mds_value,idescr_longarr
    integer i
    character*1 bksl
 
! executable code
 
    bksl = char(92)   ! backslash
 
    idims(1)=nbuf
    idims(2)=0
 
    iln=len_trim(nodename)
    ilt=len_trim(treename)
 
    call geq_mk_expr('data(',nodename(1:iln),')',expr)
    istat = mds_value(expr,idescr_longarr(ibuf,idims,1),iret)
    if(mod(istat,2).eq.1) then
       do i=1,nbuf
          if(indx(i).ne.0) isav(indx(i))=ibuf(i)
       enddo
    endif
 
    return
  end subroutine geq_mds_subi
!------------------------------------------------------
  subroutine geq_mds_sub2(nd1,nt_orig,zsav,nsav,ktdim,indx,nodename, &
       & treename,expr,data_units,istat)
!
!  read and copy a floating profile fcn of time node, saving valid points only
!  *** the code assumes f(x,t) is stored with x variation contiguous ***
!
    use geqdsk_aux
    implicit NONE
 
    integer, parameter :: r8 = selected_real_kind(12,100)
    integer, intent(in) :: nd1,nt_orig,nsav
    real(r8), intent(out) :: zsav(nd1,nsav)
    integer, intent(in) :: indx(nt_orig)
    integer, intent(in) :: ktdim            ! specifies which dim. is time
 
    character*(*), intent(in) :: treename
    character*(*), intent(in) :: nodename
    character*(*), intent(out) :: expr
 
    type(ctable), intent(in) :: data_units   ! known units labels & conversions
 
    integer, intent(out) :: istat
 
! local
 
    integer iln,ilt
    integer idims(2),iret,mds_value,idescr_floatarr,idescr_cstring
    integer i
    character*1 bksl
    integer imatch, iok
    character*20 units_string
 
    real, dimension(:,:), allocatable :: zbuf
 
! executable code
 
    call ctable_init

    bksl = char(92)   ! backslash
!
! determine if "time" is 1st or 2nd dimension -- ck 1st dimension...
!
    iln=len_trim(nodename)
    ilt=len_trim(treename)
 
    if(ktdim.eq.2) then
       idims(1)=nd1
       idims(2)=nt_orig
    else
       idims(1)=nt_orig
       idims(2)=nd1
    endif
 
    allocate(zbuf(idims(1), idims(2)), stat=iok)
    if(iok/=0) then
       write(lunmsg,*) '***failed to allocate zbuf in geq_mds_sub2'
       istat = 9999
       return
    endif
 
    call geq_mk_expr('data(',nodename(1:iln),')',expr)
    istat = mds_value(expr,idescr_floatarr(zbuf,idims,2),iret)
    if(mod(istat,2).eq.1) then
       do i=1,nt_orig
          if(indx(i).ne.0) then
             if(ktdim.eq.2) then
                zsav(1:nd1,indx(i))=zbuf(1:nd1,i)
             else
                zsav(1:nd1,indx(i))=zbuf(i,1:nd1)
             endif
          endif
       enddo
       call geq_units_check(expr,zsav,nd1*nsav,data_units)
    endif
 
    deallocate(zbuf)
 
    return
  end subroutine geq_mds_sub2
 
!------------------------------------------------------
  subroutine geq_mds_sub3(nd1,nd2,nt_orig,zsav,nsav,ktdim,indx,nodename, &
       & treename,expr,data_units,istat)
!
!  read and copy a floating profile f(R,Z,t) node, saving valid points only
!  *** the code assumes R is 1st dimension (contiguous storage), Z is 2nd
!      dimension, t is 3rd dimension
!
    use geqdsk_aux
    implicit NONE
 
    integer, parameter :: r8 = selected_real_kind(12,100)
    integer, intent(in) :: nd1,nd2,nt_orig,nsav
    real(r8), intent(out) :: zsav(nd1,nd2,nsav)
    integer, intent(in) :: indx(nt_orig)
    integer, intent(in) :: ktdim             ! specifies which dim. is "time"
 
    character*(*), intent(in) :: treename
    character*(*), intent(in) :: nodename
    character*(*), intent(out) :: expr
 
    type(ctable), intent(in) :: data_units   ! known units labels & conversions
 
    integer, intent(out) :: istat
 
! local
 
    integer iln,ilt
    integer idims(3),iret,mds_value,idescr_floatarr,idescr_cstring
    integer i, iok
    character*1 bksl
    integer imatch
    character*20 units_string
 
    real, dimension(:,:,:), allocatable :: zbuf
 
! executable code
 
    call ctable_init

    bksl = char(92)   ! backslash
!
! determine if "time" is 1st or 2nd dimension -- ck 1st dimension...
!
    iln=len_trim(nodename)
    ilt=len_trim(treename)
 
    if(ktdim.eq.3) then
       idims(1)=nd1
       idims(2)=nd2
       idims(3)=nt_orig
    else if(ktdim.eq.1) then
       idims(1)=nt_orig
       idims(2)=nd1
       idims(3)=nd2
    else
       idims(1)=nd1
       idims(2)=nt_orig
       idims(3)=nd2
    endif
 
    allocate(zbuf(idims(1), idims(2), idims(3)), stat=iok)
    if(iok/=0) then
       write(lunmsg,*) '***failed to allocate zbuf in geq_mds_sub3'
       istat = 9999
       return
    endif
 
    call geq_mk_expr('data(',nodename(1:iln),')',expr)
    istat = mds_value(expr,idescr_floatarr(zbuf,idims,3),iret)
    if(mod(istat,2).eq.1) then
       do i=1,nt_orig
          if(indx(i).ne.0) then
             if(ktdim.eq.3) then
                zsav(1:nd1,1:nd2,indx(i))=zbuf(1:nd1,1:nd2,i)
             else if(ktdim.eq.1) then
                zsav(1:nd1,1:nd2,indx(i))=zbuf(i,1:nd1,1:nd2)
             else
                zsav(1:nd1,1:nd2,indx(i))=zbuf(1:nd1,i,1:nd2)
             endif
          endif
       enddo
       call geq_units_check(expr,zsav,nd1*nd2*nsav,data_units)
    endif
 
    deallocate(zbuf)
 
    return
  end subroutine geq_mds_sub3
!----------------------------------------------------------
  subroutine geq_mk_expr(prefix,nodename,suffix,expr)
!
    use cgeq_paths
!
!  generate a G-EQDISK MDSplus (TDI) expression
!
!    prefix//bksl//'efit_geqdsk:'//nodename//suffix
!
    character*(*), intent(in) :: prefix
    character*(*), intent(in) :: nodename
    character*(*), intent(in) :: suffix
 
    character*(*), intent(out) :: expr
!
    character*1 bksl
    integer ilpre,ilnod,ilsuf
!
    character*30 ztest
!
!---------------------------
!
    bksl=char(92)   ! backslash
!
    ilpre=len_trim(prefix)
    ilnod=len_trim(nodename)
    ilsuf=len_trim(suffix)
!
    ztest=nodename(1:ilnod)
    call uupper(ztest)
!
    if(ztest.eq.'RBCENT') then
       expr = prefix(1:ilpre)//bksl//trim(cgeq_apath)//nodename(1:ilnod)// &
            & suffix(1:ilsuf)
    else
       expr = prefix(1:ilpre)//bksl//trim(cgeq_gpath)//nodename(1:ilnod)// &
            & suffix(1:ilsuf)
    endif
!
    return
    end

subroutine eq_fun(id_fun,magdim,magfit,cyldim,cylfit,iwarn,ierr)

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  !  retrieve information on the specified function

  integer, intent(in) :: id_fun     ! function id code

  !  variation vs. magnetic coordinates...
  !  magdim=0 if no such variation is defined

  integer, intent(out) :: magdim    ! 1=> f(rho), 2=> f(rho,chi), ...
  integer, intent(out) :: magfit    ! 1=> Hermite, 2=> Spline, ...

  !  variation vs. cylindric coordinates
  !  cyldim=0 if no such variation is defined

  integer, intent(out) :: cyldim    ! 2=> f(R,Z), 3=> f(R,Z,phi)
  integer, intent(out) :: cylfit    ! 1=> Hermite, 2=> Spline, ...

  integer, intent(out) :: iwarn     ! 0=OK, 1=[non-standard axes]
  integer, intent(out) :: ierr      ! 0=OK, 1=[bad id_fun code]

  !  iwarn is also set if the name starts with "__" -- reserved to xplasma.
  !  if iwarn is set, then, magdim=cyldim=0 on exit.
  !---------------------------
  integer :: id_funs(2),idi,id,iertmp,irank,igtype,iorder
  character*32 :: fname
  !---------------------------
  
  magdim=0
  magfit=0

  cyldim=0
  cylfit=0

  ierr=0
  iwarn=0

  id_funs(1)=id_fun
  call xplasma_prof_info(s,id_funs(1),ierr, profId1=id_funs(2), name=fname)

  if(ierr.ne.0) then
     iwarn=1
     write(lunerr,*) '?eq_fun:  invalid id code:  ',id_fun
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  if(fname(1:2).eq.'__') then
     write(lunerr,*) ' %eq_fun: reserved name: ',trim(fname)
     iwarn=1
  else
     do idi=1,2
        id=id_funs(idi)
        if(id.eq.0) cycle

        call xplasma_prof_info(s,id,iertmp, &
             rank=irank, gridType=igtype, splineType=iorder)

        if(igtype.eq.1) then
           magdim=irank
           magfit=iorder

        else if(igtype.eq.2) then
           cyldim=irank
           cylfit=iorder
        endif
     enddo
  endif

end subroutine eq_fun

!------------------------------------------------
subroutine eq_fun_rhogrid(id_fun,id_grid)

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: id_fun     ! function id (in)
  integer, intent(out) :: id_grid   ! indep. coord. grid id (out)

  !  return rho grid id for function (if these exist), or zero.

  !-------------------
  integer :: ierr
  !-------------------

  call xplasma_prof_gridInfo(s,id_fun,xplasma_rho_coord,id_grid,ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_fun_rhogrid: error detected:'
     call xplasma_error(s,ierr,lunerr)
  endif
 
end subroutine eq_fun_rhogrid

!------------------------------------------------
subroutine eq_fun_chigrid(id_fun,id_grid)

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: id_fun     ! function id (in)
  integer, intent(out) :: id_grid   ! indep. coord. grid id (out)

  !  return chi (pol. angle) grid id for function (if these exist), or zero.

  !-------------------
  integer :: ierr
  !-------------------

  call xplasma_prof_gridInfo(s,id_fun,xplasma_theta_coord,id_grid,ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_fun_rhogrid: error detected:'
     call xplasma_error(s,ierr,lunerr)
  endif
 
end subroutine eq_fun_chigrid

!------------------------------------------------
subroutine eq_fun_phigrid(id_fun,id_grid)

  use xplasma_obj_instance
  use eq_module 
  implicit NONE

  integer, intent(in) :: id_fun     ! function id (in)
  integer, intent(out) :: id_grid   ! indep. coord. grid id (out)

  !  return phi grid id for function (if these exist), or zero.

  !-------------------
  integer :: ierr
  !-------------------

  call xplasma_prof_gridInfo(s,id_fun,xplasma_phi_coord,id_grid,ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_fun_rhogrid: error detected:'
     call xplasma_error(s,ierr,lunerr)
  endif
 
end subroutine eq_fun_phigrid

!------------------------------------------------
subroutine eq_fun_Rgrid(id_fun,id_grid)

  use xplasma_obj_instance
  use eq_module 
  implicit NONE

  integer, intent(in) :: id_fun     ! function id (in)
  integer, intent(out) :: id_grid   ! indep. coord. grid id (out)

  !  return R grid id for function (if these exist), or zero.

  !-------------------
  integer :: ierr
  !-------------------

  call xplasma_prof_gridInfo(s,id_fun,xplasma_R_coord,id_grid,ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_fun_rhogrid: error detected:'
     call xplasma_error(s,ierr,lunerr)
  endif
 
end subroutine eq_fun_Rgrid

!------------------------------------------------
subroutine eq_fun_Zgrid(id_fun,id_grid)

  use xplasma_obj_instance
  use eq_module 
  implicit NONE

  integer, intent(in) :: id_fun     ! function id (in)
  integer, intent(out) :: id_grid   ! indep. coord. grid id (out)

  !  return Z grid id for function (if these exist), or zero.

  !-------------------
  integer :: ierr
  !-------------------

  call xplasma_prof_gridInfo(s,id_fun,xplasma_Z_coord,id_grid,ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_fun_rhogrid: error detected:'
     call xplasma_error(s,ierr,lunerr)
  endif
 
end subroutine eq_fun_Zgrid

	subroutine f90_link2
C
C  this is a token f90 routine.  In mixed f77/f90 environments, sometimes
C  an actual f90 routine must be linked, in order for the load process to
C  go correctly.
C
C  in portlib this is called out of "err_end".
C
      integer ivals(8)
C
      character*8 zzdate
      character*10 ztime
      character*5 zone
C
      call date_and_time(zzdate,ztime,zone,ivals)
      if(ivals(2).gt.12) write(6,1001) ivals(2)
 1001	format(' f90_link1:  ?? month .gt. 12:  ',i10)
C
      return
      end

!! subroutine eqi_geq_findrz(ns,lmask,x,dif,idum,psi,idum2,rzvec,id2)
!!   (original routine removed DMC Mar 2008)

subroutine eqi_find_curv(nsrch, lmask, psivec, result, id1, zinput, id2i, &
     zoutput, id2o)

  use eqi_geq_mod
  implicit NONE
  integer, parameter :: r8=selected_real_kind(12,100)

  ! subroutine called by root finder "zriddery" to find psi-surface with
  ! desired matching curvature.  Although formally a collection of searches
  ! can be done, in practice this routine only supports 1 search at a time.

  ! this routine calls eqi_find_curvature which calls zridderx -> a root
  ! finder within a root finder; 2d root finding operation.

  integer, intent(in) :: nsrch   ! number of searches, must = 1
  logical, intent(in) :: lmask(nsrch) ! mask searches where soln is known
 
  real*8, intent(in) :: psivec(nsrch)    ! psi location to try next
 
  real*8, intent(out) :: result(nsrch)   ! curvature difference at surfaces
 
  integer, intent(in) :: id1,id2i,id2o   ! auxilliary array dimensions
 
  real*8, intent(in) :: zinput(id1,id2i) ! target curvature value here
  real*8, intent(out) :: zoutput(id1,id2o)  ! output: 0=OK, 1= arg error
 
  !----------------------------------
  real*8 :: psi_in,xmin,curv_out,curv_sought
  !----------------------------------

  result = 0.0_r8
  if(nsrch.ne.1) then
     zoutput=1.0_r8
     return
  else
     zoutput=0.0_r8
  endif

  ! find Psi value on all rays (eqi_geq_mod: (r0,0) -> {radapt(:),zadapt(:)})
  ! compute normalized curvature

  psi_in = psivec(1)
  curv_sought = zinput(1,1)
  xmin = 0.4_r8  ! expect to look out towards the edge...

  !  use curvad
  call eqi_find_curvature(nthad,psi_in,xmin,psep,rzwk,curvec,curv_out)

  result(1) = curv_out-curv_sought

end subroutine eqi_find_curv

subroutine eqi_find_curvature(ns,psi,xmin,psi_range,rzvec,curvature,mincurv)

  ! find curvature properties of surface at a target psi value, as
  ! measured from a set of rays {(r0,z0)->(radapt(:),zadapt(:))}
  !   (see declarations in eqi_geq_mod

  use eqi_geq_mod
  implicit NONE
  integer, parameter :: r8=selected_real_kind(12,100)

  integer, intent(in) :: ns  ! number of rays; should be equal to nthad

  real*8, intent(in) :: psi  ! target psi value 

  real*8, intent(in) :: xmin ! minimum normalized distance from (r0,z0) at
  !  which to start search (in range [0:1]; could be 0; less than 1).
  !  0 corresponds to (r0,z0); 1 corresponds to r/zadapt.

  real*8, intent(in) :: psi_range  ! Psi(max)-Psi(min) in domain sought over

  real*8, intent(out) :: rzvec(ns,2)   ! (R,Z) values of psi surface found
  real*8, intent(out) :: curvature(ns) ! curvature along surface
  real*8, intent(out) :: mincurv       ! extrapolated minimum curvature

  !---------------------------------
  real*8 :: psivec(ns),vecmin(ns),vec1(ns),xvec(ns)
  real*8 :: tol
  logical :: lmask(ns)
  external :: eqi_geq_findrzs
  integer :: imin,imax,ichk,ii,ifail
  real*8 :: rmin,rmax,circen(2),radius,radmax,c1,c2,c3,aa,bb,xx
  real*8 :: delx12,delx23,r1,r2,r3
  !---------------------------------

  if(ns.ne.nthad) then
     call errmsg_exit('?internal call error, eqi_find_curvature.')
  endif

  psivec=psi
  lmask = .FALSE.
  lmask(ns)=.TRUE.  ! first & last pts match; don't recalculate
  vecmin = xmin
  vec1 = 1.0_r8

  tol = 1.0e-12_r8

  call zridderx(ns, lmask, vecmin, vec1, tol, tol*psi_range, &
       eqi_geq_findrzs, xvec, ifail, ns, psivec, 1, rzvec, 2)

  if(ifail.ne.0) then
     call errmsg_exit(' ?eqi_find_curvature: unexpected zridderx error.')
  endif

  rzvec(ns,1:2)=rzvec(1,1:2)
  imin=1
  imax=1
  rmin=rzvec(1,1)
  rmax=rmin
  do ii=2,ns-1
     if(rzvec(ii,1).lt.rmin) then
        rmin=rzvec(ii,1)
        imin=ii
     endif
     if(rzvec(ii,1).gt.rmax) then
        rmax=rzvec(ii,1)
        imax=ii
     endif
  enddo

  ! quadratic fit
  if(imin.eq.1) then
     r1=rzvec(ns-1,1)
     r2=rmin
     r3=rzvec(2,1)
     delx12=thadapt(ns,isw)-thadapt(ns-1,isw)
     delx23=thadapt(2,isw)-thadapt(1,isw)
  else
     r1=rzvec(imin-1,1)
     r2=rmin
     r3=rzvec(imin+1,1)
     delx12=thadapt(imin,isw)-thadapt(imin-1,isw)
     delx23=thadapt(imin+1,isw)-thadapt(imin,isw)
  endif

  call quad_minmax(delx12,delx23,r1,r2,r3,rmin)

  if(imax.eq.1) then
     r1=rzvec(ns-1,1)
     r2=rmax
     r3=rzvec(2,1)
     delx12=thadapt(ns,isw)-thadapt(ns-1,isw)
     delx23=thadapt(2,isw)-thadapt(1,isw)
  else
     r1=rzvec(imax-1,1)
     r2=rmax
     r3=rzvec(imax+1,1)
     delx12=thadapt(imax,isw)-thadapt(imax-1,isw)
     delx23=thadapt(imax+1,isw)-thadapt(imax,isw)
  endif

  call quad_minmax(delx12,delx23,r1,r2,r3,rmax)

  lnorm = (rmax-rmin)/2
  radmax=10*lnorm

  !  end pts first

  imin=1
  call r8_trirad(rzvec(ns,:),rzvec(1,:),rzvec(2,:),circen,radius,ichk)
  if(ichk.eq.0) then
     curvature(1)=min(radmax,radius)
     mincurv=curvature(1)
  else
     mincurv=radmax
     curvature(1)=radmax
  endif
  curvature(ns)=curvature(1)

  ! search the rest

  do ii=2,ns-1
     call r8_trirad(rzvec(ii-1,:),rzvec(ii,:),rzvec(ii+1,:),circen,radius,ichk)
     if(ichk.eq.0) then
        if(radius.lt.mincurv) then
           imin=ii
           mincurv=radius
        endif
        curvature(ii)=min(radmax,radius)
     else
        curvature(ii)=radmax
     endif
  enddo

  ! normalize the curvature (mincurv not normalized; recomputed below)

  curvature = curvature/lnorm

  ! quadratic fit
  if(imin.eq.1) then
     c1=curvature(ns-1)
     c2=curvature(1)
     c3=curvature(2)
     delx12=thadapt(ns,isw)-thadapt(ns-1,isw)
     delx23=thadapt(2,isw)-thadapt(1,isw)
  else
     c1=curvature(imin-1)
     c2=curvature(imin)
     c3=curvature(imin+1)
     delx12=thadapt(imin,isw)-thadapt(imin-1,isw)
     delx23=thadapt(imin+1,isw)-thadapt(imin,isw)
  endif

  call quad_minmax(delx12,delx23,c1,c2,c3,mincurv)
  
end subroutine eqi_find_curvature

subroutine eqi_geq_findrzs(ns,lmask,x,dif,idum,psi,idum2,rzvec,id2)
 
  use eqi_geq_mod
  implicit NONE
  integer, parameter :: r8=selected_real_kind(12,100)
 
  !
  ! rootfinder (zridderx) subroutine -- difference btw target and actual
  !    abs(psi) for various points along a collection of line segments
  !    (r0,z0) to {radapt(1:ns,isw),zadapt(1:ns,isw)}.
  !
  ! see declarations in eqi_geq_mod
  !
 
  !------------------------------ passed
 
  integer, intent(in) :: ns        ! no. of segments
  logical, intent(in) :: lmask(ns) ! mask segments where target psi was reached
 
  real(r8), intent(in) :: x(ns)    ! parameter, 0->(r0,z0), 1->(r/zseek*(:))
 
  real(r8), intent(out) :: dif(ns) ! psi difference at surfaces
 
  integer, intent(in) :: idum,idum2,id2
 
  real(r8), intent(in) :: psi(ns)  ! target psi values
 
  real(r8), intent(out) :: rzvec(ns,id2)  ! (R,Z) values
 
  !------------------------------ local
 
  integer jvec,j,ier
  real(r8) rtmp(ns),ztmp(ns),psitmp(ns)
  real(r8), parameter :: ZERO=0.0_r8
 
  !------------------------------ executable code
 
  jvec=0
  do j=1,ns
     if(.not.lmask(j)) then
        jvec=jvec+1
        rtmp(jvec)=r0+x(j)*(radapt(j,isw)-r0)
        ztmp(jvec)=z0+x(j)*(zadapt(j,isw)-z0)
     endif
  enddo
 
  !
  !  R0,Z0 and r/zseek are inside the mapped region
  !  0 < x(j) < 1  --> rtmp,ztmp are inside mapped region
  !  so spline call should be safe
  !
 
  call ezspline_interp(pspl, jvec, rtmp, ztmp, psitmp, ier)
  if(ier.ne.0) then
     call errmsg_exit(' ??eqi_geq_findrzs:  unexpected spline error.')
  endif
 
  jvec=0
  do j=1,ns
     if(.not.lmask(j)) then
        jvec=jvec+1
        dif(j)=abs(psi(j))-psitmp(jvec)
        rzvec(j,1)=rtmp(jvec)
        rzvec(j,2)=ztmp(jvec)
     endif
  enddo
 
  return
end subroutine eqi_geq_findrzs

module xplasma_profs

  ! module with routines that help to create various types of xplasma profiles

  use xplasma_obj
  use xplasma_ctran
  use xplasma_sol
  use xplasma_rzgeo
  use xplasma_flxint
  use eqi_rzbox_module

  implicit NONE

  private

  public :: xplasma_rzprof,xplasma_rzprof_fun
  public :: xplasma_brz,xplasma_brz_extrap
  public :: xplasma_irhofun
  public :: xplasma_wr_geqdsk,xplasma_rhopsi_gen,xplasma_rhopsi_find

  contains

    subroutine xplasma_brz_extrap(s,ier, ispline,sm_edge)

      ! create extrapolated B(R,Z) and Psi(R,Z) by standard method, when
      ! starting only with a prescribed boundary core (inverse representation)
      ! equilibrium.

      ! do not use this if a free boundary equilibrium is available...

      type(xplasma), pointer :: s
      integer, intent(out) :: ier ! exit status code 0=OK

      integer, intent(in), optional :: ispline   ! spline fit control
      !  DEFAULT =1, C1 Akima Hermite
      !   ...use 0 for piecewise linear; use 2 for C2 bicubic splines

      real*8, intent(in),optional :: sm_edge   ! edge smoothing
      !  smoothin in vicinity +/- sm_edge (meters) from plasma boundary
      !  i.e. option to smooth transition btw field internal to plasma and
      !  the field outside; default = no smoothing.

      !------------------------
      external eqm_brz_adhoc
      !------------------------

      call xplasma_brz(s,eqm_brz_adhoc,ier, ispline,sm_edge)

    end subroutine xplasma_brz_extrap

    subroutine xplasma_brz(s,userbvec,ier, ispline,sm_edge)

      ! create B(R,Z) and Psi(R,Z), extending fields already defined
      ! inside the plasma to the region outside-- using user provided
      ! subroutine...

      type(xplasma), pointer :: s

      external userbvec
      integer, intent(out) :: ier ! exit status code 0=OK

      integer, intent(in), optional :: ispline   ! spline fit control
      !  DEFAULT =1, C1 Akima Hermite
      !   ...use 0 for piecewise linear; use 2 for C2 bicubic splines

      real*8, intent(in),optional :: sm_edge   ! edge smoothing
      !  smoothin in vicinity +/- sm_edge (meters) from plasma boundary
      !  i.e. option to smooth transition btw field internal to plasma and
      !  the field outside; default = no smoothing.

      !-------------------------
      !  set up Bphi(R,Z), BR(R,Z), and BZ(R,Z) -- Akima-Hermite interpolation
      !  for axisymmetric case, setup psi(pol) also.

      !    data values from user supplied function  of form:

      !        subroutine userbvec(iv,zR,zZ,zphi,init,BR,BZ,BPHI,Psi,kpsi,ierr)
      !          iv -- vector dimension
      !          zR(iv),zZ(iv),zphi(iv)   ! coordinates at which to evaluate
      !          init -- action code
      !          BR(iv),BZ(iv),BPHI(iv)   ! field components returned
      !          Psi(iv)                  ! Psi values returned
      !          kpsi                     ! =1 if Psi values were set
      !          ierr                     ! completion code, 0=OK

      !  the subroutine must be capable of providing BR,BZ,BPHI, and Psi on
      !  points (R(i),Z(j)) which are on the extrapolated (R,Z) grids
      !  i.e. __RGRID and __ZGRID.  Only the points which are beyond the 
      !  plasma boundary need be filled; others can be zero.
      !

      !     normal calls to userbvec use init=0
      !         returns BR,BZ,BPHI, and Psi
      !     an initialization call uses init=1, returns BR=BZ=BPHI=czero
      !         also returns kpsi=1 if a poloidal flux function is to be
      !         returned. 

      !     a cleanup call uses init=2, returns BR=BZ=BPHI=czero

      !------------------------------
      !  This routine is not required for setting up B and Psi on an extended
      !  (R,Z) grid; the alternative is to call xplasma_rzprof separately for
      !  Psi and for each component of B-- as this routine itself does at the
      !  end...
      !------------------------------

      integer :: id_Rg,id_Zg
      integer :: nR,nZ,iR,iZ
      real*8, dimension(:), allocatable :: Rg,Zg,Rtmp,Ztmp,Phidum
      real*8, dimension(:,:), allocatable :: BRx,BZx,Bphix,Bmodx,Psix
      real*8 :: zdum1(1),zdum2(1),zdum3(1),zdum4(1)
      real*8 :: zsm_edge
      integer :: idum,jvec,ii,iersum,kpsi

      integer :: id_psi,id_BR,id_BZ,id_Bmod,id_Bphi,id_out,jspline,iertmp
      integer :: id_g,bphi_ccw,id_map,lrhomap
      logical :: axisymm,scrapeoff,outside_only

      real*8, dimension(:), pointer :: eqbuf
      integer, dimension(:), pointer :: idata

      real*8, parameter :: ZERO = 0.0d0
      !------------------------------

      sp => s
               
      call xplasma_global_info(s,ier, axisymm=axisymm,scrapeoff=scrapeoff, &
           bphi_ccw=bphi_ccw)
      if(ier.ne.0) return

      if(.not.axisymm) then
         ier=107
         call xplasma_errmsg_append(s,'  xplasma_brz still requires axisymmetry!')
         return
      endif

      if(.not.scrapeoff) then
         ier=109
         call xplasma_errmsg_append(s,'  xplasma_brz needs scrapeoff region defined.')
         return
      endif

      !  find needed resources...

      call xplasma_common_ids(s,ier, &
           id_psi=id_psi,id_BR=id_BR,id_BZ=id_BZ,id_Bmod=id_Bmod,id_g=id_g)
      if(ier.ne.0) return

      call xplasma_find_item(s,'__RGRID',id_Rg,ier)
      if(ier.ne.0) return

      call xplasma_find_item(s,'__ZGRID',id_Zg,ier)
      if(ier.ne.0) return

      call xplasma_find_item(s,'Bphi',id_Bphi,ier)
      if(ier.ne.0) return

      !  fetch grids

      call xplasma_grid_size(s,id_Rg,nR,ier)
      if(ier.ne.0) return

      call xplasma_grid_size(s,id_Zg,nZ,ier)
      if(ier.ne.0) return

      !  initialize userbvec

      zdum1=ZERO; zdum2=ZERO; zdum3=ZERO
      call userbvec(1,zdum1,zdum2,zdum3,1,zdum1,zdum2,zdum3,zdum4,kpsi,ier)

      if(ier.ne.0) then
         call xplasma_errmsg_append(s, &
              ' ?xplasma_brz: external call to userbvec failed.')

         return
      endif

      if(kpsi.eq.1) then
         zsm_edge=ZERO  ! if (smooth Psi) is constructed, no further smoothing
      else
         ! If Psi(ext) imposed, smoothing is an option.
         zsm_edge=ZERO
         if(present(sm_edge)) then
            zsm_edge=sm_edge
         endif
      endif

      call xplasma_find_item(s,'__FASTMAP',id_map,iertmp,nf_noerr=.TRUE.)
      if(id_map.eq.0) then
         call eqi_fastinv_gen(id_Rg,id_Zg,nR,nZ,id_map,ier)
         if(ier.ne.0) then
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_brz: fast map setup failed.')
            return
         endif
      endif

      call xplasma_blackbox_retrieve(s, id_map, iertmp, &
           ia_ptr=idata, r8a_ptr=eqbuf)
      lrhomap=idata(1)

      jspline=1
      if(present(ispline)) jspline=ispline

      !  OK...

      iersum=0

      allocate(Rg(nR),Zg(nZ))
      allocate(Rtmp(nR*nZ),Ztmp(nR*nZ),Phidum(nR*nZ))
      allocate(BRx(nR,nZ),BZx(nR,nZ),Bphix(nR,nZ),Bmodx(nR,nZ),Psix(nR,nZ))

      call xplasma_grid(s,id_Rg,Rg,iertmp)
      call xplasma_grid(s,id_Zg,Zg,iertmp)

      Phidum=ZERO

      ii=0
      do iZ=1,nZ
         Rtmp(ii+1:ii+nR)=Rg     ! (1:nR)
         Ztmp(ii+1:ii+nR)=Zg(iZ)
         ii=ii+nR
      enddo

      call userbvec(nR*nZ,Rtmp,Ztmp,Phidum,0, &
              BRx,BZx,Bphix,Psix,idum,ier)
      iersum=iersum+ier

      !  generally profiles may have been evaluated at points beyond plasma
      !  boundary only.  If so Bphix(iR,iZ) will have zeroes; it is 
      !  advantageous to fill in Bphi now using g(rho)/R formula...

      jvec=0
      do iZ=1,nZ
         do iR=1,nR
            if(Bphix(iR,iZ).eq.ZERO) then
               jvec=jvec+1
               exit
            endif
         enddo
         if(jvec.gt.0) exit
      enddo

      outside_only = (jvec.gt.0)

      !  cleanup call for userbvec...

      zdum1=ZERO; zdum2=ZERO; zdum3=ZERO
      call userbvec(1,zdum1,zdum2,zdum3,2,zdum1,zdum2,zdum3,zdum4,idum,ier)
      iersum=iersum+ier

      if(iersum.ne.0) then
         call xplasma_errmsg_append(s,' ?xplasma_brz: extrapolated field setup failed.')
      else

         call xplasma_author_set(s,xplasma_xmhd,iertmp)

         if(outside_only) then
            ! code "id_fun_in=-1" indicates g(rho)/R
            call chk_auth('Bphi_RZ')
            if(id_Bphi.gt.0) then
               call xplasma_rzprof(s,'Bphi_RZ',id_out,ier, &
                    ispline=jspline, sm_edge=zsm_edge, id_fun_in=id_Bphi, &
                    data=Bphix,label='B_phi on (R,Z) grid',units='T')
            else
               call xplasma_rzprof(s,'Bphi_RZ',id_out,ier, &
                    ispline=jspline, sm_edge=zsm_edge, id_fun_in=-1, &
                    data=Bphix,label='B_phi on (R,Z) grid',units='T')
            endif
            iersum=iersum+ier

            call chk_auth('BR_RZ')
            call xplasma_rzprof(s,'BR_RZ',id_out,ier, &
                 ispline=jspline, sm_edge=zsm_edge, id_fun_in=id_BR, &
                 data=BRx,label='B_R on (R,Z) grid',units='T')
            iersum=iersum+ier

            call chk_auth('BZ_RZ')
            call xplasma_rzprof(s,'BZ_RZ',id_out,ier, &
                 ispline=jspline, sm_edge=zsm_edge, id_fun_in=id_BZ, &
                 data=BZx,label='B_Z on (R,Z) grid',units='T')
            iersum=iersum+ier

            if(kpsi.eq.1) then
               call chk_auth('Psi_RZ')
               call xplasma_rzprof(s,'Psi_RZ',id_out,ier, &
                    ispline=jspline, sm_edge=zsm_edge, id_fun_in=id_Psi, &
                    data=Psix, &
                    label='Poloidal flux on (R,Z) grid',units='Wb/rad')
               iersum=iersum+ier
            endif

         endif

         if(zsm_edge.gt.ZERO) then
            if(.not.outside_only) then
               call eqi_rzsmedg(Rg,nR,Zg,nZ,Bphix,zsm_edge,iertmp)
               call eqi_rzsmedg(Rg,nR,Zg,nZ,BRx,zsm_edge,iertmp)
               call eqi_rzsmedg(Rg,nR,Zg,nZ,BZx,zsm_edge,iertmp)
            endif
         endif

         Bmodx=sqrt(BRx**2+BZx**2+Bphix**2)

         if(.not.outside_only) then
            call chk_auth('BR_RZ')
            call xplasma_create_prof(s,'BR_RZ',id_Rg,id_Zg,BRx,id_out,ier, &
                 ispline=jspline,assoc_id=id_BR, &
                 label='B_R on (R,Z) grid',units='T')
            iersum=iersum+ier

            call chk_auth('BZ_RZ')
            call xplasma_create_prof(s,'BZ_RZ',id_Rg,id_Zg,BZx,id_out,ier, &
                 ispline=jspline,assoc_id=id_BZ, &
                 label='B_Z on (R,Z) grid',units='T')
            iersum=iersum+ier

            call chk_auth('BPhi_RZ')
            call xplasma_create_prof(s,'Bphi_RZ',id_Rg,id_Zg,Bphix,id_out,ier,&
                 ispline=jspline,assoc_id=id_Bphi, &
                 label='Btoroidal on (R,Z) grid',units='T')
            iersum=iersum+ier
         endif

         call chk_auth('BMod_RZ')
         call xplasma_create_prof(s,'Bmod_RZ',id_Rg,id_Zg,Bmodx,id_out,ier, &
              ispline=jspline,assoc_id=id_Bmod, &
              label='mod(B) on (R,Z) grid',units='T')
         iersum=iersum+ier

         call xplasma_author_clear(s,xplasma_xmhd,iertmp)
      endif

      deallocate(Rg,Zg,Rtmp,Ztmp,Phidum)
      deallocate(BRx,BZx,Bphix,Bmodx,Psix)

      if(iersum.gt.0) ier=9999

      nullify(eqbuf,idata)

    CONTAINS
      subroutine chk_auth(zname)
        character*(*), intent(in) :: zname

        !  acquire ownership of existing profile, if necessary...

        !----------------------
        integer :: idp,iertmp
        character*32 :: zauth
        integer :: ildbg = 6
        !----------------------

        call xplasma_profId(s,zname,idp)
        if(idp.eq.0) return

        call xplasma_prof_info(s,idp,iertmp, author=zauth)
        if(zauth.ne.xplasma_xmhd) then
#ifdef __DEBUG
           write(ildbg,*) &
                ' %xplasma_brz(chk_auth): resetting author/owner of '// &
                trim(zname)
           write(ildbg,*) '  from "'//trim(zauth)//'" to "'// &
                trim(xplasma_xmhd)//'".'
#endif
           call xplasma_reset_author(s,idp,zauth,xplasma_xmhd,iertmp)
        endif
      end subroutine chk_auth

    end subroutine xplasma_brz

    !-------------------------------------------------------
    subroutine xplasma_rzprof(s,fname,id_out,ier, &
         id_Rgrid,id_Zgrid, &
         ispline,sm_edge, &
         id_fun_in,lamda, &
         label,units,data)

      ! create a profile f(R,Z) from existing data with extrapolation,
      ! or with array data provided.

      ! either an existing function (id_fun_in) or input data (data) or
      ! both must be provided.

      ! modes of use:
      !   (id_fun_in omitted, data(:,:) provided) -- just use the data given
      !   (id_fun_in provided, data(:,:) omitted) -- use existing profile
      !       at id_fun_in to give variation inside plasma; use extrapolation
      !       based on distance map: f_outside = f_bdy*exp(-d/lamda) where
      !       d is the distance from the plasma
      !   (both id_fun_in and data(:,:) provided) -- use existing profile
      !       at id_fun_in to give variation inside plasma: use data to 
      !       specify the variation beyond the plasma.

      !   ispline -- 0 = Bilinear, 1 = C1 Hermite, 2 = C2 Spline

      !   sm_edge -- Meters -- gives smoothing in vicinity of boundary
      !       a hat function convolution of half width sm_edge is applied
      !       in the vicinity of the boundary

      type(xplasma), pointer :: s

      character*(*), intent(in) :: fname  ! name of profile to create...

      integer, intent(out) :: id_out   ! ID of function just created
      integer, intent(out) :: ier      ! completion code 0=OK

      !------

      integer, intent(in), optional :: id_Rgrid,id_Zgrid  ! R & Z grids to use
      !  (default: __RGRID & __ZGRID)

      integer, intent(in), optional :: ispline  ! interpolation order
      ! 0 (default): piecewise linear; 1: C1 Hermite; 2: C2 Spline

      real*8, intent(in), optional :: sm_edge   ! edge smoothing control
      ! default: no smoothing

      integer,intent(in), optional :: id_fun_in ! f(rho) from which to 
      ! form f(R,Z) (default: 0, none)
      ! note: if id_fun_in = -1, use the formula bphi_ccw*g(rho)/R(rho,theta)

      real*8, intent(in), optional :: lamda     ! scrape off distance
      ! default: huge, making for flat extrapolation

      character*(*), intent(in), optional :: label,units  ! labeling info

      real*8, intent(inout), dimension(:,:), optional :: data  ! f(R,Z) data
      ! default: NONE
      ! data must be defined in extrapolated region-- internal region
      ! will be filled in...

      !--------------------------------
      integer :: id_Rg,id_Zg,nR,nZ,i,iZ,jvec
      integer :: jspline,isource,idf,id_dmap,maptype,iertmp,bphi_ccw
      real*8 :: zsm_edge,zlamda
      logical :: standard_RZ,outside_only,need_dmap,axisymm,scrapeoff,iRflag

      real*8, dimension(:,:), allocatable :: zdata
      real*8, dimension(:), allocatable :: zR,zZ,zZtmp,zwk1,zwk2,zwk3,zwk4
      real*8, dimension(:), allocatable :: zdist,zrho,zth
      logical, dimension(:), allocatable :: inside

      integer :: lrhomap,lchimap,ii,jj,kk,id_map
      real*8, dimension(:), pointer :: eqbuf
      integer, dimension(:), pointer :: idata

      real*8, parameter :: lamda_min=0.0001d0
      real*8, parameter :: zlarge = 1.0d35
      real*8, parameter :: ZERO = 0.0d0
      real*8, parameter :: ONE = 1.0d0
      !--------------------------------

      id_out=0

      id_Rg=0; id_Zg=0
      if(present(id_Rgrid)) id_Rg=id_Rgrid
      if(present(id_Zgrid)) id_Zg=id_Zgrid

      call xplasma_ck_rzgrid(s,id_Rg,nR,id_Zg,nZ,standard_RZ,ier)
      if(ier.ne.0) return
               
      call xplasma_global_info(s,ier, axisymm=axisymm,scrapeoff=scrapeoff, &
           bphi_ccw=bphi_ccw)
      if(ier.ne.0) return

      jspline=0
      if(present(ispline)) jspline=ispline

      zsm_edge=ZERO
      if(present(sm_edge)) zsm_edge=sm_edge

      idf=0
      iRflag=.FALSE.
      if(present(id_fun_in)) then
         if(id_fun_in.gt.0) then
            call xplasma_ck_fun(s,id_fun_in,ier)
            if(ier.ne.0) return
            idf=id_fun_in
         else if(id_fun_in.eq.-1) then
            iRflag=.TRUE.  ! sign*g/R
            call xplasma_common_ids(s,ier, id_g=idf)
         endif
      else
         if(present(lamda)) then

            ier=9999
            call xplasma_errmsg_append(s,'  cannot construct f(R,Z): '//trim(fname))
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_rzprof: cannot use scrapeoff length for function')
            call xplasma_errmsg_append(s, &
                 '  extrapolation: no base function specified.')
            return
         endif
      endif

      zlamda=zlarge
      isource=0
      if(present(lamda)) then
         if(zlamda.le.ZERO) then
            zlamda=zlarge
         else
            zlamda=max(lamda_min,lamda)
         endif
         isource=isource+1
      endif

      if(present(data)) then
         need_dmap=.FALSE.
         isource=isource+1
         if((size(data,1).ne.nR).or.(size(data,2).ne.nZ)) then
            ier=510
            call xplasma_errmsg_append(s,'  cannot construct f(R,Z): '//trim(fname))
            call xplasma_errmsg_append(s, &
                 '  ?xplasma_rzprof: input data array dimensions do not match')
            call xplasma_errmsg_append(s, &
                 '   grid sizes of implicitly or explicitly chosen R&Z grids.')
         endif
      else
         need_dmap=.TRUE.
      endif

      if(isource.gt.1) then
         ier=9999
         call xplasma_errmsg_append(s,'  cannot construct f(R,Z): '//trim(fname))
         call xplasma_errmsg_append(s, &
              '  ?xplasma_rzprof: input data array and scrape-off extrapolation (lamda)')
         call xplasma_errmsg_append(s, &
              '   cannot both be present.')
         call xplasma_errmsg_append(s, &
              '   choose one or the other to define region beyond plasma boundary')
         return

      endif

      !----------------------------------------------
      outside_only = need_dmap.and.standard_RZ.and.(zsm_edge.eq.ZERO)

      allocate(zdata(nR,nZ),zR(nR),zZ(nZ),zZtmp(nR),zth(nR*nZ))
      allocate(zwk1(nR*nZ),zwk2(nR*nZ),zwk3(nR*nZ),zwk4(nR*nZ),zrho(nR*nZ))
      allocate(zdist(nR*nZ),inside(nR*nZ))

      call xplasma_grid(s,id_Rg,zR,ier); if (ier.ne.0) return
      call xplasma_grid(s,id_Zg,zZ,ier); if (ier.ne.0) return

      if(idf.eq.0) then

         ! just use the data provided to create a profile...

         zdata = data

      else

         if(standard_RZ) then
            maptype=3

            !  make sure rhomap is available

            call xplasma_ctrans(sp,iertmp, &
                 R_in=zR(nR/2), Z_in=zZ(nZ/2), &
                 rho_out=zrho(1), theta_out=zth(1), maptype=3)

            call xplasma_find_item(s,'__FASTMAP',id_map,iertmp)
            if(iertmp.ne.0) then
               call xplasma_errmsg_append(s, &
                ' %xplasma_rzprof: __FASTMAP not found: no scrapeoff region?')
               maptype=2
            else
               call xplasma_blackbox_retrieve(s, id_map, iertmp, &
                    ia_ptr=idata, r8a_ptr=eqbuf)
               lrhomap=idata(1)
               lchimap=idata(2)
               jj=lrhomap-nR-1
               kk=lchimap-nR-1
            endif
         else
            maptype=2
         endif
      
         jvec=0
         ii=-nR
         do iZ=1,nZ
            ii=ii+nR

            if(maptype.eq.2) then
               zZtmp=zZ(iZ)
               call xplasma_ctrans(s,.TRUE.,ier, R_in=zR,Z_in=zZtmp, &
                    rho_out=zrho(ii+1:ii+nR),theta_out=zth(ii+1:ii+nR), &
                    maptype=maptype)
               if(ier.ne.0) exit
            else
               jj=jj+nR
               kk=kk+nR
               zrho(ii+1:ii+nR)=eqbuf(jj+1:jj+nR)
               zth(ii+1:ii+nR)=eqbuf(kk+1:kk+nR)
            endif

            if(need_dmap) then
               ! using lamda extrapolation for pts beyond plasma bdy

               do i=1,nR
                  if(zrho(ii+i).gt.ONE) then
                     jvec=jvec+1
                     zwk1(jvec)=zZ(iZ)
                     zwk2(jvec)=zR(i)
                     inside(ii+i)=.FALSE.
                     zrho(ii+i)=ONE
                  else
                     inside(ii+i)=.TRUE.
                     zdist(ii+i)=ZERO
                  endif
               enddo
            else
               do i=1,nR
                  if(zrho(ii+i).le.ONE) then
                     jvec=jvec+1
                     zwk1(jvec)=zR(i)
                     zwk2(jvec)=zrho(ii+i)
                     zwk3(jvec)=zth(ii+i)
                     inside(ii+i)=.TRUE.
                  else
                     inside(ii+i)=.FALSE.
                  endif
               enddo

            endif
         enddo

         if(need_dmap) then
            call xplasma_bdfind(s,jvec,zwk2(1:jvec),zwk1(1:jvec),ier, &
                 maptype=maptype,outside_only=outside_only, &
                 theta_out=zwk3(1:jvec), dist=zwk4(1:jvec))
         else

            ! use idf & iRflag

            call xplasma_eval_prof(s,idf, &
                 xplasma_rho_coord,zwk2(1:jvec), &
                 xplasma_theta_coord,zwk3(1:jvec), &
                 zwk4(1:jvec),ier)

            if(iRflag) then
               zwk4(1:jvec)=bphi_ccw*zwk4(1:jvec)/zwk1(1:jvec)
            endif

         endif

         if(ier.eq.0) then
            if(need_dmap) then
               jvec=0
               ii=-nR
               do iZ=1,nZ
                  ii=ii+nR
                  do i=1,nR
                     if(.not.inside(ii+i)) then
                        jvec=jvec+1
                        zth(ii+i)=zwk3(jvec)
                        zdist(ii+i)=zwk4(jvec)
                     endif
                  enddo
               enddo

               call xplasma_eval_prof(s,idf, &
                    xplasma_rho_coord,zrho, xplasma_theta_coord,zth, &
                    zwk2,ier)

               if(ier.eq.0) then
                  ii=-nR
                  do iZ=1,nZ
                     ii=ii+nR
                     do i=1,nR
                        zdata(i,iZ)=zwk2(ii+i)
                        if((zlamda.lt.zlarge).and.(zdist(ii+i).gt.ZERO)) then
                           zdata(i,iZ)=zdata(i,iZ)*exp(-zdist(ii+i)/zlamda)
                        endif
                     enddo
                  enddo
               endif

            else
               ! using data for pts beyond plasma bdy

               jvec=0
               ii=-nR
               do iZ=1,nZ
                  ii=ii+nR
                  do i=1,nR
                     if(inside(ii+i)) then
                        jvec=jvec+1
                        zdata(i,iZ)=zwk4(jvec)  ! interior-- use function eval
                        data(i,iZ)=zwk4(jvec)   ! pass back also...
                     else
                        zdata(i,iZ)=data(i,iZ)  ! exterior-- use passed data
                     endif
                  enddo
               enddo

            endif

         endif
      endif

      if(ier.eq.0) then

         if(zsm_edge.gt.ZERO) then
            if(idf.eq.0) then
               sp => s
               call eqi_rzsmedg(zR,nR,zZ,nZ,zdata,zsm_edge,iertmp)
            else
               ! use module-internal blending routine; mesh with core data
               call xpblend(s,zR,nR,zZ,nZ,zdata,zsm_edge,idf,iRflag,bphi_ccw, &
                    maptype, iertmp)
            endif
         endif

         call xplasma_create_2dprof(s,fname,id_Rg,id_Zg,zdata,id_out,ier, &
              ispline=jspline,assoc_id=idf,label=label,units=units)

      endif

      deallocate(inside,zdata,zR,zZ,zZtmp,zwk1,zwk2,zwk3,zwk4,zrho,zth,zdist)

      nullify(eqbuf,idata)

    end subroutine xplasma_rzprof

    !-------------------------------------------------------
    subroutine xplasma_rzprof_fun(s,fname,user_fcn,user_iarg,id_out,ier, &
         id_Rgrid,id_Zgrid,ispline,sm_edge,id_fun_in,no_extrap, &
         label,units)

      ! create a profile f(R,Z) from a user provided callable function
      ! possibly combined with existing data.

      ! the callable function covers the entire region inside the limiters
      ! if id_fun_in is omitted; it covers only the region outside the plasma
      ! and inside the limiters if id_fun_in is included.

      ! modes of use:
      !   (id_fun_in omitted) -- just use the given callable function.
      !   (id_fun_in provided)-- use existing profile
      !       at id_fun_in to give variation inside plasma; use the given
      !       function to define the variation beyond the plasma boundary.

      ! the region beyond the limiters is defined by a simple extrapolation.
      ! unless no_extrap is set, in which case the function is used even
      ! beyond the limiters.

      !   sm_edge -- Meters -- gives smoothing in vicinity of boundary
      !       a hat function convolution of half width sm_edge is applied
      !       in the vicinity of the boundary

      type(xplasma), pointer :: s

      character*(*), intent(in) :: fname  ! name of profile to create...

      real*8, external :: user_fcn        ! user provided function...
      integer, intent(in) :: user_iarg    ! argument for user_fcn:

      !  real*8 function user_fcn(user_iarg,R,Z,Phi,ier)

      integer, intent(out) :: id_out   ! ID of function just created
      integer, intent(out) :: ier      ! completion code 0=OK

      !------

      integer, intent(in), optional :: id_Rgrid,id_Zgrid  ! R & Z grids to use
      !  (default: __RGRID & __ZGRID)

      integer, intent(in), optional :: ispline  ! interpolation order
      ! 0 (default): piecewise linear; 1: C1 Hermite; 2: C2 Spline

      real*8, intent(in), optional :: sm_edge   ! edge smoothing control
      ! default: no smoothing

      integer,intent(in), optional :: id_fun_in ! f(rho) from which to 
      ! form f(R,Z) (default: 0, none)
      ! note: if id_fun_in = -1, use the formula bphi_ccw*g(rho)/R(rho,theta)

      logical, intent(in), optional :: no_extrap ! T to suppress extrapolation
      ! beyond limiter.  In this case user_fcn calls are used for (R,Z) even
      ! for points outside the limiter.

      character*(*), intent(in), optional :: label,units  ! labeling info

      !--------------------------------
      integer :: id_Rg,id_Zg,nR,nZ,i,iZ,jvec
      integer :: jspline,idf,maptype,iertmp,bphi_ccw
      real*8 :: zsm_edge,zphi0
      real*8, dimension(:,:), allocatable :: zdata
      real*8, dimension(:), allocatable :: zR,zZ,zwkZ,zrho,zth
      real*8, dimension(:), allocatable :: zdist_lim,zfeval,zwkR
      logical, dimension(:), allocatable :: inside
      logical, dimension(:,:), allocatable :: inside_lim
      logical :: standard_RZ,extrap,axisymm,scrapeoff,iRflag

      real*8, parameter :: ZERO = 0.0d0
      real*8, parameter :: ONE = 1.0d0
      !--------------------------------
      !  dmc: this routine might be sped up by making calls covering
      !   all RxZ instead of just one row at a time.  Other routines
      !   have been optimized in this way... but not yet this one.

      id_out=0

      id_Rg=0; id_Zg=0
      if(present(id_Rgrid)) id_Rg=id_Rgrid
      if(present(id_Zgrid)) id_Zg=id_Zgrid

      call xplasma_ck_rzgrid(s,id_Rg,nR,id_Zg,nZ,standard_RZ,ier)
      if(ier.ne.0) return
               
      call xplasma_global_info(s,ier, axisymm=axisymm,scrapeoff=scrapeoff, &
           bphi_ccw=bphi_ccw)
      if(ier.ne.0) return

      jspline=0
      if(present(ispline)) jspline=ispline

      zsm_edge=0
      if(present(sm_edge)) zsm_edge=sm_edge

      idf=0
      iRflag=.FALSE.
      if(present(id_fun_in)) then
         if(id_fun_in.gt.0) then
            call xplasma_ck_fun(s,id_fun_in,ier)
            if(ier.ne.0) return
            idf=id_fun_in
         else if(id_fun_in.eq.-1) then
            iRflag=.TRUE.  ! sign*g/R
            call xplasma_common_ids(s,ier, id_g=idf)
         endif
      endif

      extrap=.TRUE.
      if(present(no_extrap)) extrap = .not.no_extrap

      !------------------------------------------
      allocate(zdata(nR,nZ),zR(nR),zZ(nZ),zwkZ(nR))
      allocate(zrho(nR),zth(nR),zdist_lim(nR),zfeval(nR),zwkR(nR))
      allocate(inside(nR),inside_lim(nR,nZ))

      call xplasma_grid(s,id_Rg,zR,ier); if (ier.ne.0) return
      call xplasma_grid(s,id_Zg,zZ,ier); if (ier.ne.0) return

      if(standard_RZ) then
         maptype=3
      else
         maptype=2
      endif

      zphi0 = ZERO

      do iZ=1,nZ
         zwkZ=zZ(iZ)

         if(idf.eq.0) then
            if(extrap) then
               call xplasma_lim_distance(s,zR,zwkZ,zdist_lim,ier, &
                    maptype=maptype)
               if(ier.ne.0) exit
            else
               zdist_lim=ZERO
            endif

            do i=1,nR
               if(zdist_lim(i).gt.ZERO) then
                  zdata(i,iZ)=ZERO
                  inside_lim(i,iZ)=.FALSE.
               else
                  zdata(i,iZ) = user_fcn(user_iarg,zR(i),zwkZ(1),ZERO,ier)
                  if(ier.ne.0) exit
                  inside_lim(i,iZ)=.TRUE.
               endif
            enddo
            if(ier.ne.0) exit

         else

            call xplasma_ctrans(s,.TRUE.,ier, R_in=zR,Z_in=zwkZ, &
                 rho_out=zrho,theta_out=zth, maptype=maptype)
            if(ier.ne.0) exit

            if(extrap) then
               call xplasma_lim_distance(s,zR,zwkZ,zdist_lim,ier, &
                    maptype=maptype)
               if(ier.ne.0) exit
            else
               zdist_lim=ZERO
            endif

            jvec=0
            do i=1,nR
               inside_lim(i,iZ)=.TRUE.
               if(zdist_lim(i).gt.ZERO) then
                  zdata(i,iZ)=ZERO
                  inside(i)=.FALSE.
                  inside_lim(i,iZ)=.FALSE.
               else if(zrho(i).gt.ONE) then
                  zdata(i,iZ) = user_fcn(user_iarg,zR(i),zwkZ(1),ZERO,ier)
                  if(ier.ne.0) exit
                  inside(i)=.FALSE.
               else
                  jvec=jvec+1
                  inside(i)=.TRUE.
                  zwkR(jvec)=zR(i)
                  zrho(jvec)=zrho(i)
                  zth(jvec)=zth(i)
               endif
            enddo
            if(ier.ne.0) exit

            if(jvec.gt.0) then
               call xplasma_eval_prof(s,idf, &
                    xplasma_rho_coord,zrho(1:jvec), &
                    xplasma_theta_coord,zth(1:jvec), &
                    zfeval(1:jvec),ier)
               if(ier.ne.0) exit

               if(iRflag) then
                  zfeval(1:jvec) = bphi_ccw*zfeval(1:jvec)/zwkR(1:jvec)
               endif

               jvec=0
               do i=1,nR
                  if(inside(i)) then
                     jvec=jvec+1
                     zdata(i,iZ)=zfeval(jvec)
                  endif
               enddo
            endif
         endif

      enddo

      if(ier.eq.0) then

         sp => s

         if(extrap) then
            ! compute simple extrapolation for beyond-limiter data points
            call eqi_rzfx(zR,nR,zZ,nZ,inside_lim,zdata)
         endif

         if(zsm_edge.gt.ZERO) then
            ! optional smoothing...
            if(idf.eq.0) then
               call eqi_rzsmedg(zR,nR,zZ,nZ,zdata,zsm_edge,iertmp)
            else
               ! use module-internal blending routine; mesh with core data
               call xpblend(s,zR,nR,zZ,nZ,zdata,zsm_edge,idf,iRflag,bphi_ccw, &
                    maptype, iertmp)
            endif
         endif

         call xplasma_create_2dprof(s,fname,id_Rg,id_Zg,zdata,id_out,ier, &
              ispline=jspline,assoc_id=idf,label=label,units=units)

      endif

      deallocate(zdata,zR,zZ,zwkZ,zrho,zth,zdist_lim,zfeval,zwkR)
      deallocate(inside,inside_lim)

    end subroutine xplasma_rzprof_fun

    !-------------------------------------------------------
    subroutine xplasma_ck_fun(s,idf,ier)

      !  ** private **
      !  verify function id -- must be fcn of (rho,theta)

      type(xplasma), pointer :: s

      integer, intent(in) :: idf
      integer, intent(out) :: ier

      !------------------
      integer :: id_grid1,id_grid2,icoord1,icoord2
      character*32 zname1,zname2
      !------------------

      do
         call xplasma_prof_info(s,idf,ier, gridId1=id_grid1, gridId2=id_grid2)
         if(ier.ne.0) exit

         call xplasma_grid_info(s,id_grid1,ier, coord=icoord1, name=zname1)
         if(ier.ne.0) exit

         if(id_grid2.gt.0) then
            call xplasma_grid_info(s,id_grid2,ier, coord=icoord2, name=zname2)
            if(ier.ne.0) exit

         else
            icoord2=0
         endif

         if((icoord1.eq.xplasma_rho_coord).or. &
              (icoord1.eq.xplasma_theta_coord)) then

            continue

         else

            ier=9999
            call xplasma_errmsg_append(s, &
                 '   passed profile needs to be defined vs. flux coordinates.')
            call xplasma_errmsg_append(s, &
                 '   instead it is a function of: '//trim(zname1))
            exit
         endif

         if((icoord2.eq.0).or.(icoord2.eq.xplasma_rho_coord).or. &
              (icoord2.eq.xplasma_theta_coord)) then

            continue

         else

            ier=9999
            call xplasma_errmsg_append(s, &
                 '   passed profile needs to be defined vs. flux coordinates.')
            call xplasma_errmsg_append(s, &
                 '   instead it is a function of: '//trim(zname2))
            exit
         endif

         exit
      enddo

      if(ier.ne.0) then
         call xplasma_errmsg_append(s,' ...error in xplasma_profs module.')
      endif

    end subroutine xplasma_ck_fun

    !-------------------------------------------------------
    subroutine xplasma_ck_rzgrid(s,id_Rgrid,nR,id_Zgrid,nZ,standard_RZ,ier)

      !  ** private ** 
      !  summary info on R & Z grids

      type(xplasma), pointer :: s

      integer, intent(inout) :: id_Rgrid,id_Zgrid ! grid IDs: use default if 0
      integer, intent(out) :: nR,nZ               ! grid sizes
      logical, intent(out) :: standard_RZ         ! T if standard grid is used
      integer, intent(out) :: ier                 ! error code, 0=OK

      !-------------------------
      integer :: icoord,isize,id_Rgrid0,id_Zgrid0
      character*32 :: zname
      !-------------------------

      standard_RZ=.FALSE.
      nR=0
      nZ=0

      call xplasma_find_item(s,'__Rgrid',id_Rgrid0,ier)
      if(ier.ne.0) return

      call xplasma_find_item(s,'__Zgrid',id_Zgrid0,ier)
      if(ier.ne.0) return

      if(id_Rgrid.eq.0) then
         id_Rgrid=id_Rgrid0
      endif

      if(id_Zgrid.eq.0) then
         id_Zgrid=id_Zgrid0
      endif

      if((id_Rgrid.eq.id_Rgrid0).and.(id_Zgrid.eq.id_Zgrid0)) then
         standard_RZ=.TRUE.
      endif

      call xplasma_grid_info(s,id_Rgrid,ier, coord=icoord, size=nR, name=zname)
      if(ier.eq.0) then
         if(icoord.ne.xplasma_R_coord) then
            ier=701
            call xplasma_errmsg_append(s,' passed id grid name: '//trim(zname))
         endif
      endif
      if(ier.ne.0) return

      call xplasma_grid_info(s,id_Zgrid,ier, coord=icoord, size=nZ, name=zname)
      if(ier.eq.0) then
         if(icoord.ne.xplasma_Z_coord) then
            ier=701
            call xplasma_errmsg_append(s,' passed id grid name: '//trim(zname))
         endif
      endif
      if(ier.ne.0) return

    end subroutine xplasma_ck_rzgrid

    !=====================================

    subroutine xpblend(s,zR,nR,zZ,nZ,zdata,zsm,idf,iRflag,ibccw,maptype,ier)

      !  ** PRIVATE **

      !  smooth zdata(R,Z) beyond edge region by matching point and slope
      !  of interior function (idf), in extrapolated (rho,theta) space and
      !  then mapping back to (R,Z).

      !  if iRflag is set, expect idf=id_g and use bphi_ccw*f(rho)/R(rho,theta)
      !      (i.e. the toroidal field) for the interior function.

      type (xplasma), pointer :: s

      integer :: nR,nZ        ! grid sizes
      real*8 :: zR(nR),zZ(nZ) ! grids
      real*8 :: zdata(nR,nZ)  ! data

      real*8 :: zsm           ! smoothing distance

      integer :: idf          ! interior matching function ID

      logical :: iRflag       ! T to use ibccw*f(rho)/R; idf points to f(rho)
      integer :: ibccw        ! +/- 1 for use if (iRflag) true

      integer :: maptype      ! mapping selector for (R,Z) -> (rho,theta)

      integer, intent(out) :: ier    ! status code; 0=OK

      !-----------------------------------------------------------
      integer :: ii,jvec,jvec2,iR,iZ
      real*8 :: del,del1,del2,dR1,dZ1
      real*8 :: dat0,dat1,dat2,datx,b,denom,dxtrap,xx,ff

      real*8, parameter :: ZERO = 0.0d0
      real*8, parameter :: HALF = 0.5d0
      real*8, parameter :: ONE  = 1.0d0
      real*8, parameter :: TWO  = 2.0d0
      real*8, parameter :: THREE  = 3.0d0

      ! data for 1 row @ fixed Z:
      real*8, dimension(:), allocatable :: zzwk,zrho,zth,zRb,zZb,z1vec

      ! collected data for edge blending:
      integer :: isizx,isizf
      real*8, dimension(:), allocatable :: delx,rhox,thx,zRx,datbx, &
           Rinx,Zinx,rho_inx,th_inx,datinx
      integer, dimension(:), allocatable :: iRsave,iZsave
      !-----------------------------------------------------------

      del2 = min( (zR(nR)-zR(1))/max(40,nR), (zZ(nZ)-zZ(1))/max(40,nZ) )
      del1 = HALF*del2

      ier=0

      allocate(zzwk(nR),zrho(nR),zth(nR),zRb(nR),zZb(nR),z1vec(nR))
      z1vec = ONE      ! vector of length nR of 1s...

      isizf=20
10    continue
      if(isizf.eq.20) then
         isizf=10
      else if(isizf.eq.10) then
         isizf=5
      else 
         isizf=isizf-1
         if(isizf.eq.0) then
            call xplasma_errmsg_append(s,' ?xpblend: too many points in range for smoothed blending.')
            ier=9999
            return
         endif
      endif

      isizx = (nR*nZ)/isizf
      if(allocated(delx)) then
         deallocate(delx,rhox,thx,datbx,iRsave,iZsave)
         deallocate(Rinx,Zinx,rho_inx,th_inx,datinx)
      endif
      allocate(delx(isizx),rhox(isizx),thx(isizx),zRx(isizx))
      allocate(datbx(isizx),iRsave(isizx),iZsave(isizx))
      allocate(Rinx(2*isizx),Zinx(2*isizx),rho_inx(2*isizx),th_inx(2*isizx))
      allocate(datinx(2*isizx))

      jvec = 0
      jvec2 = 0

      do iZ=1,nZ
         zzwk = zZ(iZ) ! expand this Z to vector of length nR...

         call xplasma_ctrans(s,.TRUE.,ier, R_in=zR, Z_in=zzwk, &
              rho_out=zrho, theta_out=zth, maptype=maptype)
         if(ier.ne.0) exit

         call xplasma_ctrans(s,.TRUE.,ier, rho_in=z1vec, theta_in=zth, &
              R_out=zRb, Z_out=zZb)
         if(ier.ne.0) exit

         do iR=1,nR
            if(zrho(iR).gt.ONE) then
               del = sqrt((zR(iR)-zRb(iR))**2 + (zZ(iZ)-zZb(iR))**2)
               dR1 = (zRb(iR)-zR(iR))/del
               dZ1 = (zZb(iR)-zZ(iZ))/del
               if((ZERO.lt.del).AND.(del.lt.zsm)) then
                  ! point in range for smoothing

                  jvec = jvec + 1
                  if(jvec.gt.isizx) go to 10  ! check bound

                  delx(jvec)=del
                  iRsave(jvec)=iR
                  iZsave(jvec)=iZ
                  rhox(jvec)=ONE
                  thx(jvec)=zth(iR)
                  zRx(jvec)=zRb(iR)

                  Rinx(jvec2+1)=zRb(iR) + del1*dR1
                  Rinx(jvec2+2)=zRb(iR) + del2*dR1

                  Zinx(jvec2+1)=zZb(iR) + del1*dZ1
                  Zinx(jvec2+2)=zZb(iR) + del2*dZ1

                  jvec2 = jvec2 + 2
               endif
            endif
         enddo

      enddo
      if(ier.ne.0) then
         call xplasma_errmsg_append(s,' ?error 1 in xpblend internal routine')
         return
      endif

      ! evaluate data at boundary

      call xplasma_eval_prof(s,idf, &
                 xplasma_rho_coord,rhox(1:jvec), &
                 xplasma_theta_coord,thx(1:jvec), &
                 datbx(1:jvec),ier)
      if(ier.ne.0) then
         call xplasma_errmsg_append(s,' ?error 2 in xpblend internal routine')
         return
      endif

      if(iRflag) then
         datbx(1:jvec) = ibccw*datbx(1:jvec)/zRx(1:jvec)
      endif

      ! evaluate interior points to allow matching assessment
      ! 1st convert (R,Z) to (rho,theta); use maptype=2 for reasonable accuracy

      call xplasma_ctrans(s,.TRUE.,ier, &
           R_in=Rinx(1:jvec2),Z_in=Zinx(1:jvec2), &
           rho_out=rho_inx(1:jvec2),theta_out=th_inx(1:jvec2), &
           maptype=2)
      if(ier.ne.0) then
         call xplasma_errmsg_append(s,' ?error 3 in xpblend internal routine')
         return
      endif

      ! evaluate interior data 

      call xplasma_eval_prof(s,idf, &
                 xplasma_rho_coord,rho_inx(1:jvec2), &
                 xplasma_theta_coord,th_inx(1:jvec2), &
                 datinx(1:jvec2),ier)
      if(ier.ne.0) then
         call xplasma_errmsg_append(s,' ?error 2 in xpblend internal routine')
         return
      endif

      if(iRflag) then
         datinx(1:jvec2) = ibccw*datinx(1:jvec2)/Rinx(1:jvec2)
      endif

      ! find linear extrapolation along fixed exterior theta lines
      ! i.e. a profile with continuous value and 1st derivative; 2nd
      ! derivative definitely not continuous.

      denom = del1*del2*(del2-del1)

      jvec2=0
      do ii=1,jvec
         dat0=datbx(ii)
         dat1=datinx(jvec2+1)
         dat2=datinx(jvec2+2)
         jvec2 = jvec2 + 2

         !  3 pts: (0,dat0), (del1,dat1), (del2,dat2) -- parabolic fit
         !          bdy       1st int.     2nd int.
         !  d(x) = A*x**2 + B*x + C    d(0)=C=dat0; d'(0)=B
         !    denom = del1*del2*(del2-del1)
         !        A = -[(dat1-dat0)*del2 + (dat2-dat0)*del1]/denom
         !        B =  [(dat1-dat0)*del2**2 + (dat2-dat0)*del1**2]/denom

         B = ((dat1-dat0)*del2**2 - (dat2-dat0)*del1**2)/denom

         del=delx(ii)
         xx=del/zsm             ! normalized extrapolation distance

         dxtrap = dat0 - B*del  ! linear extrapolation of interior data

         iR = iRsave(ii)
         iZ = iZsave(ii)

         ! blend using Hermite cubic f*data + (1-f)*dxtrap
         ! f(0)=0, f'(0)=0, f(1)=1, f'(1)=0
         !     => f(x) = x**2*(-2*x + 3)

         ff = xx*xx*(THREE-TWO*xx)

         zdata(iR,iZ) = ff*zdata(iR,iZ) + (ONE-ff)*dxtrap
      enddo

    end subroutine xpblend

    !------------------------------------------
    subroutine xplasma_irhofun(s,id_axis,zlbl,inprof,zprof,iflag,id,ierr, &
         smdelx)

      !  make XPLASMA profile -- integrated quantity; smooth by 1/2 zone width
      !  to insure smooth derivative from spline

      type (xplasma), pointer :: s

      integer, intent(in) :: id_axis    ! axis id -- must be rho or akin to rho

      character*(*), intent(in) :: zlbl ! name for profile function to create

      integer, intent(in) :: inprof     ! size of the integrated data profile

      real*8, intent(in) :: zprof(inprof) ! the integrated data provided
              ! if inprof = size(x_axis) zprof(1)=0 is expected
              ! if inprof = size(x_axis)-1 the axial data point
              !    is presumed to be omitted.

      integer, intent(in) :: iflag      ! =1 -- volume normalization;
              ! derivative evaluations -> W/m^3, #/sec/m^3, etc.
              ! =2 -- area normalization;
              ! derivative evaluations -> A/m^2 (current density).

              ! >2 -- ID of normalization profile, should be akin to vol(rho)
              !       or area(rho)

      integer, intent(out) :: id        ! id of stored profile (if successful)
      integer, intent(out) :: ierr      ! completion code, 0=OK.

      real*8, intent(in), optional :: smdelx   ! smoothing width (option)

      !  a single zone width hat function smooth (effectively, half a zone
      !  width) is the minimum used by eqi_irhofun.  For more smoothing
      !  than this, give smdelx = [a number greater than x(2)-x(1)] where
      !  x(1:2) are the 1st two grid points identified via id_axis.

      !  Note, the actual smoothing width is proportional to the grid
      !  resolution and so could vary across the grid; a fixed multiplier
      !  of smdelx/(x(2)-x(1)) would be applied in this case.  In the
      !  evaluation routine (eqi_irhofun) there is an upper limit imposed
      !  which corresponds a multiplier that yields (1/4) the profile width
      !  at the grid spacing at rho=0.

      !  if an error occurs and ierr is set, id=0 will be returned.
      !-----------------------------------------------------------------
      integer :: ierr_save
      real*8 :: zsm
      !-----------------------------------------------------------------

      sp => s

      zsm = 0.0d0
      if(present(smdelx)) zsm = smdelx

      call eqi_irhofun(id_axis,zlbl,inprof,zprof,iflag,zsm,id,ierr)

    end subroutine xplasma_irhofun

    !-------------------------------------------------------
    subroutine xplasma_wr_geqdsk(s,ierr, &
         lun_geqdsk, filename, label, Rmin, Rmax, Zmin, Zmax, &
         cur, id_qprof, id_pprof, id_psi_in, &
         nh, nv, nbdy)

      !  Build and write a G-eqdsk file (disk file) from current xplasma
      !  contents.  This differs from "xplasma_geqdsk_rewrite" as the latter
      !  just echoes data read in from another G-eqdsk file or MDSplus data
      !  structure.  This actual constructs the information from current
      !  xplasma contents -- interpolation is involved.

      !  The xplasma object must contain a complete free boundary or 
      !  extrapolated equilibrium, so that Psi(R,Z) covering a rectangle
      !  enclosing the plasma is defined.

      !-----------------
      !  required:

      type (xplasma), pointer :: s  ! XPLASMA object containing equilibrium

      integer, intent(out) :: ierr  ! status code on exit: 0=OK

      !-----------------
      !  optional:

      integer, intent(in), optional :: lun_geqdsk  
      ! FORTRAN LUN on which to write file.  If omitted, the LUN used for
      ! reading G-eqdsk files, in the geqdsk_mds library, is used.
      !   (call geq_getlun(ilun)) (geqdsk_mod default value: 77 as of 7/2006).

      character*(*), intent(in), optional :: filename
      ! default " "; if non-blank, it is the
      ! name of the file to write.  If blank or omitted, the code simply 
      ! writes to lun_geqdsk; it would be up to the caller to OPEN a file.

      character*(*), intent(in), optional :: label
      ! default " "; default means: use xplasma global label; 
      ! if non-blank, the 1st 48 characters are used as a label string in the
      ! G-eqdsk file being written.

      real*8, intent(in), optional :: Rmin,Rmax, Zmin,Zmax
      ! [R,Z] domain over which Psi(R,Z) is written in the G-eqdsk file.
      ! default: use the [R,Z] grid limits already stored in xplasma.  If
      ! explicit limits are provided, overriding the defaults, these must
      ! not extend beyond the grid limits.

      real*8, intent(in), optional :: cur
      ! total plasma current.  Default: use value implied by equilibrium data.

      integer, intent(in), optional :: id_qprof
      ! ID of profile f(rho) defining q(rho).  Default: use value derived from
      ! equilibrium-- calculated here, it will be named Q_EQDSK

      integer, intent(in), optional :: id_pprof
      ! ID of profile f(rho) defining equilibrium pressure.  Default: use value
      ! previously tagged as equilibrium pressure.  If this is not available,
      ! the code will attempt to compute a pressure using the surface averaged
      ! GS equation JxB=grad(P).  This could lead to a non-physical result if
      ! there are errors in the equilibrium data already provided, or if the
      ! assumption of a scalar P is inappropriate.  If a pressure profile is
      ! calculated, it will be named P_EQDSK-- done using an xplasma_gen_p
      ! call.

      integer, intent(in), optional :: id_psi_in
      ! ID of associated pair of Psi(rho) or Psi(R,Z) profiles
      ! If defaulted, the code looks for standard names w/in xplasma object.

      integer, intent(in), optional :: nh,nv
      ! number of horizontal and vertical grid points, respectively.  If
      ! defaulted, the sizes of the [R,Z] grids are used.  NOTE that nh also
      ! controls the size of the 1d profiles f,ff',P,P',and q written in the
      ! G-eqdsk profiles.  These 1d profiles are written over an implied 
      ! evenly spaced Psi grid going from Psi(min) at the axis to Psi(max)
      ! at the boundary.
      
      integer, intent(in), optional :: nbdy
      ! number of points to use to described plasma boundary and limiter.
      ! default: 200.

      !-------------------------------------
      integer :: ilun,istat,ifile,ilen,id_Rc,id_Zc,idp,idq,ii,idpsi
      integer :: inh,inv,inbdy,inum
      integer :: idwk,iertmp

      character*48 glabel
      real*8 :: zRmin,zRmax,zZmin,zZmax,zcur

      !  for plasma current estimate:
      integer, parameter :: inxi=21
      real*8 :: zxi(inxi),zii(inxi)

      integer :: inbdy_dflt=201
      !-------------------------------------

      if(present(lun_geqdsk)) then
         ilun = lun_geqdsk
      else
         call eqi_geq_getlun(ilun)
      endif

      ierr = 0
      ifile= 0
      if(present(filename)) then
         open(unit=ilun,file=trim(filename),status='unknown',iostat=istat)
         if(istat.ne.0) then
            ierr = 9999
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_profs(xplasma_wr_geqdsk): file open failure: '// &
                 trim(filename))
         else
            ifile=1
         endif
      endif
      if(ierr.ne.0) return

      do

         ! label...

         if(present(label)) then
            glabel=label
         else
            glabel='xplasma_wr_geqdsk:'
            ilen=len(trim(glabel))
            call xplasma_global_info(s,ierr,initLabel=glabel(ilen+1:))
         endif
         if(ierr.ne.0) exit
            
         ! Rmin&max, Zmin&max...

         call xplasma_find_item(s,'__R_coord',id_Rc,ierr); if(ierr.ne.0) exit
         call xplasma_find_item(s,'__Z_coord',id_Zc,ierr); if(ierr.ne.0) exit

         call xplasma_coord_info(s,id_Rc,ierr, ngrids=inum); if(ierr.ne.0) exit
         if(inum.eq.0) then
            ierr=615  ! need R & Z rectangle; Psi(R,Z)
            exit
         endif

         call xplasma_coord_info(s,id_Zc,ierr, ngrids=inum); if(ierr.ne.0) exit
         if(inum.eq.0) then
            ierr=615  ! need R & Z rectangle; Psi(R,Z)
            exit
         endif

         call xplasma_coord_info(s,id_Rc,ierr, xmin=zRmin, xmax=zRmax)
         if(ierr.ne.0) exit

         call xplasma_coord_gridId(s,id_Rc,1,idwk,ierr)
         if(ierr.ne.0) exit

         call xplasma_grid_size(s,idwk,inh,ierr)
         if(ierr.ne.0) exit

         call xplasma_coord_info(s,id_Zc,ierr, xmin=zZmin, xmax=zZmax)
         if(ierr.ne.0) exit

         call xplasma_coord_gridId(s,id_Zc,1,idwk,ierr)
         if(ierr.ne.0) exit

         call xplasma_grid_size(s,idwk,inv,ierr)
         if(ierr.ne.0) exit

         if(present(Rmin)) then
            zRmin=max(zRmin,Rmin)
         endif

         if(present(Rmax)) then
            zRmax=min(zRmax,Rmax)
         endif

         if(present(Zmin)) then
            zZmin=max(zZmin,Zmin)
         endif

         if(present(Zmax)) then
            zZmax=min(zZmax,Zmax)
         endif

         !  total current 

         if(present(cur)) then
            zcur=cur
         else
            !  estimate the current

            call xplasma_author_set(s,'xplasma_profs',iertmp)
            do ii=1,inxi
               zxi(ii)=(ii-1)*1.0d0/(inxi-1)
            enddo

            call xplasma_create_integ(s,'__xpasma_profs_tmp_integ', &
                 zxi,idwk,iertmp, cache_enable=.FALSE.)
                 
            call xplasma_rho_zonint(s,idwk,'Itor',zii,ierr)
            if(ierr.ne.0) exit

            zcur=zii(inxi)

            call xplasma_remove_item(s,idwk,iertmp)

            call xplasma_author_clear(s,'xplasma_profs',iertmp)
         endif

         !  P & q

         if(present(id_qprof)) then
            idq=id_qprof
         else
            call xplasma_gen_q(s,'Q_EQDSK',2,idq,ierr)
            if(ierr.ne.0) exit
         endif

         if(present(id_pprof)) then
            idp=id_pprof
         else
            call xplasma_common_ids(s,ierr,id_p=idp)
            if(ierr.ne.0) exit
            if(idp.eq.0) then
               call xplasma_gen_p(s,'P_EQDSK',2,idp,ierr)
               if(ierr.ne.0) exit
            endif
         endif

         if((idp.eq.0).or.(idq.eq.0)) then
            call xplasma_errmsg_append(s, &
                 ' xplasma_profs: zero ids for Pressure or q profiles')
            ierr=9999
            exit
         endif

         !  Psi (id can be zero)

         idpsi=0
         if(present(id_psi_in)) then
            idpsi = id_psi_in
         endif

         !  output grid sizes (default is from R & Z coordinates' 1st grids).

         if(present(nh)) then
            inh=nh
         endif

         if(present(nv)) then
            inv=nv
         endif

         if(present(nbdy)) then
            inbdy=max(61,nbdy)
         else
            inbdy=inbdy_dflt
         endif

         !===============================
         sp => s
         call eqi_geqdsk(ilun,glabel,zRmin,zRmax,zZmin,zZmax,zcur, &
              idp,idq,idpsi,inh,inv,inbdy,ierr)
         !===============================
         exit
      enddo

      if(ierr.ne.0) call xplasma_errmsg_append(s,' error in xplasma_wr_geqdsk')
      if(ifile.eq.1) then
         if(ierr.ne.0) then
            close(unit=ilun,status='delete')
         else
            close(unit=ilun)
         endif
      endif

    end subroutine xplasma_wr_geqdsk

    !-------------------------------------------------------
    subroutine xplasma_rhopsi_gen(s,npsi,ierr, tol, psivals, rhovals)

      !  generate an evenly spaced Psi vector (poloidal flux, Wb/rad) that
      !  spans the plasma from axis to edge.  Psi=0 corresponds to the
      !  magnetic axis; Psibdy is taken to be a positive number; the sign
      !  is omitted.  (The sign is available separately-- it corresponds 
      !  to the direction of the toroidal plasma current, jphi_ccw,
      !  available as an optional argument in xplasma_global_info).

      !  also, find the corresponding rho = sqrt(Phi_tor/Phi_tor_bdy)
      !  values that map to the Psi values w/in tolerance (tol).

      !---------------
      !  required arguments:

      type (xplasma), pointer :: s
      integer, intent(in) :: npsi   ! number of Psi values wanted (min. 2)
      integer, intent(out) :: ierr  ! completion status, 0=OK

      !---------------
      !  optional arguments:
      real*8, intent(in), optional :: tol  ! mapping tolerance
      !  default: something close to real*8 machine precision

      real*8, dimension(:), intent(out), optional :: Psivals
      !  The evenly spaced Psi vector generated, Wb/rad, (1:npsi)

      real*8, dimension(:), intent(out), optional :: Rhovals
      !  Rho values satisfying 
      !     abs(Psi(Rhovals(i))-Psivals(i)) <= tol*[Psi at bdy]
      !  (1:npsi) -- sqrt(toroidal_flux/toroidal_flux_at_bdy)
      !  0 on axis, 1 at the edge.

      !-------------------------------------
      real*8 :: psimin,psimax
      real*8, dimension(:), allocatable :: zpsis,zrhos
      integer :: ipsi
      !-------------------------------------

      ierr=0
      if(npsi.lt.2) then
         ierr=9999
         call xplasma_errmsg_append(s, &
              ' ?xplasma_rhopsi_gen: argument error: npsi >= 2 required.')
         return
      endif

      if(present(psivals)) then
         psivals=0
         if(size(psivals).lt.npsi) then
            ierr=612
            call xplasma_errmsg_append(s, &
                ' ?xplasma_rhopsi_gen: "psivals" array size >= npsi required.')
         endif
      endif

      if(present(rhovals)) then
         rhovals=0
         if(size(rhovals).lt.npsi) then
            ierr=612
            call xplasma_errmsg_append(s, &
                ' ?xplasma_rhopsi_gen: "rhovals" array size >= npsi required.')
         endif
      endif

      if(ierr.ne.0) return

      !-----------------------
      !  error checks passed

      call xplasma_psi_range(s,psimin,psimax)

      allocate(zpsis(npsi),zrhos(npsi))

      zpsis(1)=psimin
      zpsis(npsi)=psimax
      do ipsi=2,npsi-1
         zpsis(ipsi)=((npsi-ipsi)*psimin + (ipsi-1)*psimax)/(npsi-1)
      enddo

      if(present(rhovals)) then
         call xplasma_rhopsi_find(s,zpsis,zrhos,ierr, tol=tol)
      endif

      if(ierr.eq.0) then
         if(present(psivals)) psivals(1:npsi)=zpsis(1:npsi)
         if(present(rhovals)) rhovals(1:npsi)=zrhos(1:npsi)
      endif

      deallocate(zpsis,zrhos)

    end subroutine xplasma_rhopsi_gen

    !-------------------------------------------------------
    subroutine xplasma_rhopsi_find(s,psivals,rhovals,ierr, tol, iwarn)

      !  find rho values corresponding to a specified set of Psi values
      !    Psi -- Poloidal flux, Wb/rad
      !    rho -- sqrt(Tor_flux/Tor_flux_at_bdy)

      !  all input Psi values should be in the range [Psimin,Psimax] where
      !  Psimin corresponds to the magnetic axis and Psimax-Psimin
      !  corresponds to the (unsigned) poloidal flux, Wb/rad, enclosed 
      !  within the core plasma.  Usually Psimin=0 is set.

      type (xplasma), pointer :: s
      real*8, dimension(:), intent(in) :: Psivals  ! Psi values in any order
      real*8, dimension(:), intent(out) :: rhovals ! rho values output
      !  sizes of Psivals and rhovals must match

      integer, intent(out) :: ierr   ! status code, =0 on normal exit
      !  error occurs if xplasma is unitialized or contains no MHD equilibrium;
      !  Psi-out-of-range is handled (see iwarn, below).

      real*8, intent(in), optional :: tol     ! accuracy tolerance
      !  on output, rho values satisfy
      !     abs(Psi(rhovals(i))-Psivals(i)) <= tol*[Psi at bdy]
      !  (1:npsi) -- sqrt(toroidal_flux/toroidal_flux_at_bdy)
      !  0 on axis, 1 at the edge.

      integer, intent(out), optional :: iwarn  ! #of Psi values out of range

      !  if Psi <= Psimin, rho=0 is returned; if Psi >= Psimax rho=1 is
      !  returned.

      !------------------------------------
      real*8 :: psimin,psimax,rhomin,rhomax,ztol,psitol
      real*8, dimension(:), allocatable :: zpsi,zrho,zdum,zmina,zmaxa
      integer :: ipsi,inpsi,jwarn,insize
      logical, dimension(:), allocatable :: iok

      external eqi_xpsi_fun
      !------------------------------------

      ierr=0
      if(size(psivals).ne.size(rhovals)) then
         ierr=612
         call xplasma_errmsg_append(s, &
              ' ?xplasma_rhopsi_find: "psivals" and "rhovals" array argument sizes inconsistent.')
         return
      else
         insize=size(psivals)
      endif

      rhovals = 0
      if(present(iwarn)) iwarn=insize

      rhomin = 0
      rhomax = 1

      !-----------------
      !  get bdy & search error tolerance

      if(present(tol)) then
         ztol=tol
      else
         call xplasma_global_info(s,ierr, bdytol=ztol)
         if(ierr.ne.0) return
      endif

      !-----------------
      !  get available range of Psi values
      
      call xplasma_psi_range(s,psimin,psimax)

      psitol = ztol*max(abs(psimin),abs(psimax))

      !-----------------
      !  get the list of interior values for which search is required

      inpsi=0
      allocate(zpsi(insize),zrho(insize),zdum(insize),iok(insize))
      iok = .FALSE.

      jwarn=0

      do ipsi=1,insize
         if(psivals(ipsi).lt.(psimin+psitol)) then
            rhovals(ipsi)=rhomin
            if(psivals(ipsi).lt.(psimin-psitol)) jwarn = jwarn + 1

         else if(psivals(ipsi).gt.(psimax-psitol)) then
            rhovals(ipsi)=rhomax
            if(psivals(ipsi).gt.(psimax+psitol)) jwarn = jwarn + 1

         else
            inpsi=inpsi+1
            zpsi(inpsi)=psivals(ipsi)
            zrho(inpsi)=(psivals(ipsi)-psimin)/(psimax-psimin) ! crude guess
         endif
      enddo

      !  root finder...

      if(inpsi.gt.0) then

         sp => s

         allocate(zmina(inpsi),zmaxa(inpsi)); zmina=rhomin; zmaxa=rhomax

         call zridderx(inpsi, iok, zmina, zmaxa, ztol, psitol, &
              eqi_xpsi_fun, zrho, ierr, inpsi, zpsi, 1, zdum, 1)

         deallocate(zmina,zmaxa)

         if(ierr.ne.0) then

            ierr=9999
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_rhopsi_find: root finder failure.')
            jwarn=insize

         else

            inpsi = 0
            do ipsi=1,insize
               if(psivals(ipsi).lt.(psimin+psitol)) then
                  continue

               else if(psivals(ipsi).gt.(psimax-psitol)) then
                  continue

               else
                  inpsi = inpsi + 1
                  rhovals(ipsi) = zrho(inpsi)
               endif
            enddo

         endif

      endif
      if(present(iwarn)) iwarn = jwarn

      deallocate(zpsi,zrho,zdum,iok)

    end subroutine xplasma_rhopsi_find

end module xplasma_profs

subroutine eqi_bdfast(ivec,zR,zZ,iwant,want_th,zdist,zth_out,ierr)

  !  evaluate distance map: (R,Z)->(distance,nearest-theta)
  !    distance from rho=1 surface, i.e. the plasma boundary

  !  SOL = scrape off layer region enclosing a plasma.

  !  The SOL is defined by a RxZ grid rectangle.  If an input point
  !  (zR(i),zZ(i)) is not inside this rectangle, a rough correction is
  !  provided to the distance and nearest-theta

  !  *** if the map is undefined, create it ***

  use xplasma_definitions
  use eqi_rzbox_module
  implicit NONE

  integer ivec                      ! vector dimension
  real*8 zR(ivec),zZ(ivec)          ! input positions for which 

  integer, intent(in) :: iwant      ! =2: want entire fast map defined
  ! =1: only need points with d>0, i.e. outside the plasma.

  logical :: want_th                ! .TRUE. if zth_out(...) output is wanted.

  real*8 zdist(ivec)                ! output distance to nearest pt on bdy
  real*8 zth_out(ivec)              ! output theta of nearest pt on bdy

  integer ierr                      ! completion code, 0=OK

  !-----------------------------------------
  real*8 zRtarg(ivec),zZtarg(ivec)
  real*8 zcorr(ivec)

  integer, dimension(:), pointer :: ii,jj
  real*8, dimension(:), pointer :: zRoff,zZoff

  integer iadr00,iadr01,iadr10,iadr11,i,nR,nZ
  real*8 zrmin,zrmax,zzmin,zzmax
  logical :: sol

  real*8 zthbr00,zthbr01,zthbr10,zthbr11,zthmin,zthtest

  integer :: id_map,id_Rgrid,id_Zgrid,ldmap,lthmap,istat
  integer, dimension(:), pointer :: idata
  real*8, dimension(:), pointer :: eqbuf

  type (xpeval) :: R_intrp, Z_intrp

  real*8, parameter :: czero=0.0d0
  real*8, parameter :: chalf=0.5d0
  real*8, parameter :: cone =1.0d0
  real*8, parameter :: ceps =1.0d-15
  real*8, parameter :: c2pi =6.2831853071795862D+00
  real*8, parameter :: cpi  =3.1415926535897931D+00
  !-----------------------------------------

  ierr=0

  call xplasma_RZminmax_extended(sp, zrmin,zrmax, zzmin,zzmax, ierr, sol=sol)
  if(ierr.ne.0) return

  if(.not.sol) then
     ierr=109
     call xplasma_errmsg_append(sp, &
         ' ?? eqi_bdfast.f90 was called, but no scrapeoff region is defined.')
     return
  endif

  call xplasma_find_item(sp,'__DISTMAP',id_map,ierr, nf_noerr=.TRUE.)
  if(ierr.ne.0) return

  call xplasma_find_item(sp,'__Rgrid',id_Rgrid,ierr)
  if(ierr.ne.0) return

  call xplasma_grid_size(sp,id_Rgrid,nR,ierr)
  if(ierr.ne.0) return

  call xplasma_find_item(sp,'__Zgrid',id_Zgrid,ierr)
  if(ierr.ne.0) return

  call xplasma_grid_size(sp,id_Zgrid,nZ,ierr)
  if(ierr.ne.0) return

  ! create full map, if needed...
  if(id_map.eq.0) call eqi_bdfast_gen(id_Rgrid,id_Zgrid,nR,nZ,id_map,iwant, &
       ierr)
  if(ierr.ne.0) return

  call xplasma_blackbox_retrieve(sp, id_map, ierr, &
       ia_ptr = idata, r8a_ptr = eqbuf)

  ldmap = idata(1)
  lthmap = idata(2)
  istat = idata(3)

  ! complete map, if needed...
  if(istat.lt.iwant) then
     call eqi_bdfast_gen(id_Rgrid,id_Zgrid,nR,nZ,id_map,iwant,ierr)
  endif

  !  SOL (rho,th) -- use bilinear approximation
  !  rough correction for points beyond the (R,Z) grid

  do i=1,ivec
     zRtarg(i)=max(zrmin,min(zrmax,zR(i)))
     zZtarg(i)=max(zzmin,min(zzmax,zZ(i)))
     if((zR(i).ne.zRtarg(i)).or.(zZ(i).ne.zZtarg(i))) then
        zcorr(i)=sqrt((zR(i)-zRtarg(i))**2+(zZ(i)-zZtarg(i))**2)
        zcorr(i)=max(ceps,zcorr(i))
     else
        zcorr(i)=czero
     endif
  enddo

  !  lookup...

  call xplasma_x_lookup(sp, id_Rgrid, zRtarg, R_intrp, ierr)
  if(ierr.ne.0) then
     nullify(eqbuf,idata)
     call xpeval_free(R_intrp)
     return
  endif

  call xplasma_x_lookup(sp, id_Zgrid, zZtarg, Z_intrp, ierr)
  if(ierr.ne.0) then
     nullify(eqbuf,idata)
     call xpeval_free(R_intrp)
     call xpeval_free(Z_intrp)
     return
  endif 

  call xpeval_info(R_intrp, ierr, ix=ii, dxn=zRoff)
  call xpeval_info(Z_intrp, ierr, ix=jj, dxn=zZoff)

  !  evaluation...

  do i=1,ivec

     !  rho

     iadr00=ldmap +(jj(i)-1)*nR + ii(i)-1
     iadr01=iadr00+1
     iadr10=iadr00+nR
     iadr11=iadr01+nR

     zdist(i)= &
          (cone-zZoff(i))* &
          ((cone-zRoff(i))*eqbuf(iadr00)+ &
                           zRoff(i)*eqbuf(iadr01)) + &
          zZoff(i)* &
          ((cone-zRoff(i))*eqbuf(iadr10)+ &
                           zRoff(i)*eqbuf(iadr11))

     zdist(i)=zdist(i)+zcorr(i)

     !  th -- watch for branch cut  ** if wanted **

     if(.not.want_th) cycle

     iadr00=lthmap +(jj(i)-1)*nR + ii(i)-1
     iadr01=iadr00+1
     iadr10=iadr00+nR
     iadr11=iadr01+nR

     zthmin=min(eqbuf(iadr00),eqbuf(iadr01),eqbuf(iadr10),eqbuf(iadr11))
     zthtest=zthmin+cpi

     if(eqbuf(iadr00).gt.zthtest) then
        zthbr00=-c2pi
     else
        zthbr00=czero
     endif

     if(eqbuf(iadr01).gt.zthtest) then
        zthbr01=-c2pi
     else
        zthbr01=czero
     endif

     if(eqbuf(iadr10).gt.zthtest) then
        zthbr10=-c2pi
     else
        zthbr10=czero
     endif

     if(eqbuf(iadr11).gt.zthtest) then
        zthbr11=-c2pi
     else
        zthbr11=czero
     endif

     zth_out(i)= &
          (cone-zZoff(i))* &
          ((cone-zRoff(i))*(eqbuf(iadr00)+zthbr00)+ &
                           zRoff(i)*(eqbuf(iadr01)+zthbr01)) + &
          zZoff(i)* &
          ((cone-zRoff(i))*(eqbuf(iadr10)+zthbr10)+ &
                           zRoff(i)*(eqbuf(iadr11)+zthbr11))

  enddo

  nullify(ii,jj,zRoff,zZoff,idata,eqbuf)
  call xpeval_free(R_intrp)
  call xpeval_free(Z_intrp)

end subroutine eqi_bdfast

subroutine eqi_bdfast_gen(id_Rgrid,id_Zgrid,nR,nZ,id_map,iwant,ierr)

  ! generate or complete fast distance map on RxZ extended grids

  !   id_map=0 on input means map does not exist at all;
  !            (it is created and id_map receives the id as output).
  !   id_map=1 on input means map exists but may not be complete (check).

  !   iwant=2 on input means entire map is needed.
  !   iwant=1 on input means only points beyond the plasma boundary are
  !   needed.

  use xplasma_definitions
  use eqi_rzbox_module
  implicit NONE

  !-----------

  integer, intent(in) :: id_Rgrid,id_Zgrid  ! grid IDs
  integer, intent(in) :: nR,nZ              ! grid sizes

  integer, intent(inout) :: id_map          ! "blackbox" id
  integer, intent(in) :: iwant              ! map section desired: 2 for all

  integer, intent(out) :: ierr              ! status code, 0=OK

  !-----------
  real*8 :: Rgrid(nR),Zgrid(nZ),Ztmp(nR),zrho_bdy,zrho0
  real*8, dimension(:), allocatable :: Rvec,Zvec,phidum,phitmp
  real*8, dimension(:), allocatable :: dmap,thmap,rhotmp,chtmp  ! 1 row only
  real*8, dimension(:), pointer :: r8data
  logical, dimension(:), allocatable :: iuse
  integer, dimension(:), pointer :: idata
  integer :: ii,jj,iR,iZ,iRegion(nR),iertmp,itype
  integer :: id_dmap,id_thmap,ihave,jvec
  logical :: iskipi,iskipo,iexact
  !-----------

  iskipi=.FALSE.
  iskipo=.FALSE.
  iexact=.FALSE.
  zrho_bdy = 1.0d0
  zrho0 = 0.0d0

  call xplasma_grid(sp, id_Rgrid, Rgrid, ierr)
  if(ierr.ne.0) return

  call xplasma_grid(sp, id_Zgrid, Zgrid, ierr)
  if(ierr.ne.0) return

  if(id_map.eq.0) then
     allocate(idata(3))
     idata(1)=1
     idata(2)=nR*nZ+1
     idata(3)=0

     itype=77 ! arbitrary type code
     call xplasma_author_set(sp, xplasma_xmhd,iertmp)

     call xplasma_create_blackBox(sp,'__DISTMAP',itype,id_map,ierr, &
          iarray=idata,r8asize=2*nR*nZ, &
          label='fast distance map data')

     call xplasma_author_clear(sp, xplasma_xmhd,iertmp)

     deallocate(idata)
  endif
  if(ierr.ne.0) return

  call xplasma_blackBox_retrieve(sp, id_map, ierr, &
       ia_ptr=idata, r8a_ptr=r8data)
  if(ierr.ne.0) then
     nullify(r8data,idata)
     return
  endif

  ihave = idata(3)

  !  ihave = 0 means: have no data;
  !  ihave = 1 means: have data for pts outside plasma only;
  !  ihave = 2 means: have all data.

  if(ihave.ge.iwant) return

  !  ihave < iwant:
  !    ihave=0, iwant=2: compute entire map
  !    ihave=0, iwant=1: compute map outside plasma only
  !    ihave=1, iwant=2: compute map inside plasma only

  allocate(dmap(nR*nZ),thmap(nR*nZ),rhotmp(nR),chtmp(nR))
  allocate(Phidum(nR*nZ),Phitmp(nR*nZ),Rvec(nR*nZ),Zvec(nR*nZ),iuse(nR*nZ))

  do 

     Phidum = 0

     if((ihave.eq.0).and.(iwant.eq.2)) then
        !  compute entire map...
        ii=0
        do iZ=1,nZ
           Rvec(ii+1:ii+nR)=Rgrid
           Zvec(ii+1:ii+nR)=Zgrid(iZ)
           ii=ii+nR
        enddo
        call eqi_bdfind(nR*nZ,Rvec,Zvec,Phidum,zrho_bdy,iskipi,iskipo,iexact,&
             r8data(nR*nZ+1:2*nR*nZ),Phitmp,r8data(1:nR*nZ),ierr)
        if(ierr.ne.0) exit

     else
        !  compute necessary subset of map
        jvec=0
        ii=0
        do iZ=1,nZ
           Ztmp=Zgrid(iZ)
           call eqi_fastinv(nR,Rgrid,Ztmp,Phidum,zrho0,rhotmp,chtmp,iregion, &
                ierr)
           if(ierr.ne.0) exit

           do iR=1,nR
              ii=ii+1
              if(rhotmp(iR).gt.1.0d0) then
                 if(ihave.eq.0) then
                    !  compute outside points only
                    jvec=jvec+1
                    Rvec(jvec)=Rgrid(iR)
                    Zvec(jvec)=Zgrid(iZ)
                    iuse(ii)=.TRUE.
                 else
                    iuse(ii)=.FALSE.
                 endif
              else
                 if(ihave.eq.1) then
                    !  compute inside points only
                    jvec=jvec+1
                    Rvec(jvec)=Rgrid(iR)
                    Zvec(jvec)=Zgrid(iZ)
                    iuse(ii)=.TRUE.
                 else
                    iuse(ii)=.FALSE.
                 endif
              endif
           enddo
        enddo

        call eqi_bdfind(jvec,Rvec,Zvec,Phidum,zrho_bdy, &
             iskipi,iskipo,iexact,thmap,Phitmp,dmap,ierr)
        if(ierr.ne.0) exit

        jvec=0
        ii=0
        jj=nR*nZ

        do iZ=1,nZ
           do iR=1,nR
              ii=ii+1
              jj=jj+1

              if(iuse(ii)) then
                 jvec=jvec+1
                 r8data(ii)=dmap(jvec)
                 r8data(jj)=thmap(jvec)
              endif
           enddo
        enddo
     endif

     exit
  enddo

  deallocate(dmap,thmap,rhotmp,chtmp)
  deallocate(Phidum,Phitmp,Rvec,Zvec,iuse)

  if(ierr.eq.0) then
     ihave = iwant
     idata(3) = ihave
  endif

  nullify(r8data,idata)

end subroutine eqi_bdfast_gen

subroutine fluxav_balloc(control,ineed)
 
  use fluxav
  implicit NONE
 
!   expand the indicated break list
!
  character*(*) control        ! specifies which list
!
!-----------------------------------------------------
  integer, parameter :: isize0 = 32
  integer :: icheck,iprev,isize
  integer, intent(in) :: ineed
!-----------------------------------------------------
!
  icheck=0
  if(control.eq.'rho') then
     if(n_rhomax.eq.0) then
        isize=max(isize0,ineed)
        allocate(rhobrk(isize))
        rhobrk(1:isize)=0.0_R8
        n_rhomax=isize
     else
        iprev = n_rhomax
        n_rhomax=max(ineed,iprev*2)
!
        allocate(rhobrk_tmp(n_rhomax))
        rhobrk_tmp(1:iprev)=rhobrk(1:iprev)
        rhobrk_tmp(iprev+1:n_rhomax)=0.0_R8
        deallocate(rhobrk)
        rhobrk => rhobrk_tmp
     endif
     icheck=icheck+1
!
  else if(control.eq.'th') then
     if(n_thmax.eq.0) then
        isize=max(isize0,ineed)
        allocate(thbrk(isize))
        thbrk(1:isize)=0.0_R8
        n_thmax=isize
     else
        iprev = n_thmax
        n_thmax=max(ineed,iprev*2)
!
        allocate(thbrk_tmp(n_thmax))
        thbrk_tmp(1:iprev)=thbrk(1:iprev)
        thbrk_tmp(iprev+1:n_thmax)=0.0_R8
        deallocate(thbrk)
        thbrk => thbrk_tmp
     endif
     icheck=icheck+1
!
  else if(control.eq.'phi') then
     if(n_phimax.eq.0) then
        isize=max(isize0,ineed)
        allocate(phibrk(isize))
        phibrk(1:isize)=0.0_R8
        n_phimax=isize
     else
        iprev = n_phimax
        n_phimax=max(ineed,iprev*2)
!
        allocate(phibrk_tmp(n_phimax))
        phibrk_tmp(1:iprev)=phibrk(1:iprev)
        phibrk_tmp(iprev+1:n_phimax)=0.0_R8
        deallocate(phibrk)
        phibrk => phibrk_tmp
     endif
     icheck=icheck+1
  endif
!
  if(icheck.eq.0) then
     write(lunerr,*) ' ?fluxav_brk_init:  no action taken:'
     write(lunerr,*) '  invalid control string:  "',control,'"'
  endif
!
  return
!
end subroutine fluxav_balloc

subroutine eq_find_intg(inumth,idi,inrhoi,inthi,ierr)

  !  xplasma2 f77 interface-- internal routine
  !  find integrator

  use xplasma_obj_instance
  use eq_module
  IMPLICIT NONE

  integer, intent(in) :: inumth  ! theta dimension of output array
  !  if =1, assume flux surface integrals; if <>1 assume zonal integrals

  integer, intent(out) :: idi    ! integrator data set ID or 0 if error

  integer, intent(out) :: inrhoi ! #rho surfaces in integrator (0 if error)
  integer, intent(out) :: inthi  ! #theta surfaces in integrator (0 if error)

  integer, intent(out) :: ierr   ! completion code 0=OK

  ! #rho zones = inrhoi-1; #theta zones = inthi-1; for flux surface averages
  !                                                inthi=2, #theta zones = 1.

  !----------------------------------
  !----------------------------------

  idi = 0
  inrhoi = 0
  inthi = 0

  if(inumth.eq.1) then
     call xplasma_find_item(s,"__F77_INTEGRATOR_1D",idi,ierr)
     if((ierr.ne.0).or.(idi.eq.0)) then
        write(lunerr,*) ' ?eq_flxint: 1D integrator dataset not found.'
        write(lunerr,*) '  prior call to "eq_flxint_init" required.'
        ierr=1

     else
        inthi=2
        call xplasma_integ_info(s,idi,ierr, n_rho_int=inrhoi)

     endif

  else

     call xplasma_find_item(s,"__F77_INTEGRATOR_2D",idi,ierr)
     if((ierr.ne.0).or.(idi.eq.0)) then
        write(lunerr,*) ' ?eq_flxint_arr2d: 2D integrator dataset not found.'
        write(lunerr,*) '  prior call to "eq_flxint_chinit" required.'
        return
        
     else
        call xplasma_integ_info(s,idi,ierr, n_rho_int=inrhoi, n_th_int=inthi)

     endif
  endif

end subroutine eq_find_intg

subroutine eq_tau_bounce(zrho,inum,zx,ztol,zcut, &
     zbmin,zbmax,zvtaub,ierr)
 
  !  evaluate zero banana width approximation to v*tau_bounce
  !
  !  this is the integral over the limits of the orbit of
  !     dtheta*(dlp/dtheta)*(B/Bp)*(1/sqrt(1-B/Brefl))
  !
  !  where Brefl is a trapped orbit's reflection point (vpll=0,v=vperp)
  !  for passing orbits (Brefl > Bmax) the integrand is over the
  !  entire surface contour; for trapped orbits the integrand is
  !  twice the value from theta_lower to theta_upper where these
  !  limits need to be found by a root finder so that
  !     B(theta_lower)=B(theta_upper)=Brefl
  !
  !  the integrand formula follows from the assumptions that v
  !  and mu=vperp**2/B are constants of motion
 
  !  axisymmetry is assumed...
 
  use xplasma_obj_instance
  use eq_module

  implicit NONE
 
  real*8, intent(in) :: zrho   ! surface on which to calculate
  !  note -- must not be magnetic axis; non-singular surface required.
 
  integer, intent(in) :: inum  ! no. of evaluation points
  real*8, intent(in) :: zx(inum) ! evaluation points:
 
  !   zx(j) = (Brefl(j)-Bmin)/(Bmax-Bmin)
  ! where Bmin and Bmax, the min and mod(B) on the zrho surface, will
  ! be found; zx > 0 is required; zx(j+1) > zx(j) required for all j < inum.
 
  real*8, intent(in) :: ztol  ! relative error tolerance for integral
  ! (recommended value 1.0d-4)

  real*8, intent(in) :: zcut  ! minimum allowed value for (1-B/Brefl)
  ! (recommended value 1.0d-8)
 
  !---
 
  real*8, intent(out) :: zbmin,zbmax  ! Bmin and Bmax on zrho surface (T)
  real*8, intent(out) :: zvtaub(inum) ! integral values returned (m)
  !  (divide by ion velocity (m/sec) to get bounce time, seconds).
 
  integer, intent(out) :: ierr  ! completion code, 0=OK
 
  !-------------------------------------------

  call xplasma_vtaub(s,zrho,zx(1:inum),zvtaub(1:inum),ierr, &
       tol=ztol, bcut=zcut, bmin=zbmin, bmax=zbmax)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_tau_bounce: error detected:'
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_tau_bounce

subroutine eq_hrhochi(ivec,zrho,zchi,nlist,iflist,ictwant,ivecd,zans,ierr)

  !  evaluate 1 or more functions f(rho,chi) derivatives df/drho, df/dchi
  !    f(rho) also allowed, in which case df/dchi=0 is returned.

  use xplasma_obj_instance
  use eq_module
  IMPLICIT NONE

  !  input:

  integer ivec                      ! input vector dimension
  !  input negative number for clockwise chi specification

  REAL*8 zrho(abs(ivec))                 ! argument -- where to evaluate
  REAL*8 zchi(abs(ivec))                 ! argument -- where to evaluate
  integer nlist                     ! number of functions
  integer iflist(nlist)             ! functions to evaluate

  integer ictwant(6)                ! output selector (pspline style)

  !  each element of ictwant(1:6) should be 0 or 1
  !  use 1 to indicate a desired item:

  !   ictwant(1) -- function values            ...1 if wanted, 0 otherwise
  !   ictwant(2) -- functions' df/drho values
  !   ictwant(3) -- functions' df/dchi values
  !   ictwant(4) -- functions' d2f/drho2 values
  !   ictwant(5) -- functions' d2f/dchi2 values
  !   ictwant(6) -- functions' d2f/drhodchi values

  integer ivecd                     ! output vector dimension

  !  output:

  REAL*8 zans(ivecd,*)              ! evaluation results
  integer ierr                      ! completion code (0=OK)

  !  ** let ictnum = # of non-zero elements of ictwant.
  !         (ictnum=sum(ictwant)).  Then...
  !  zans(1:ivec,1)   = value or derivative for function id iflist(1)
  !                     indicated by first non-zero value of ictwant(...)
  !  zans(1:ivec,2)   = value or derivative for function id iflist(1)
  !                     indicated by second non-zero value of ictwant(...)
  !    ...
  !  zans(1:ivec,ictnum)   = value or derivative for function id iflist(1)
  !                     indicated by last non-zero value of ictwant(...)

  !  or generally, for 1 .le. k .le. ictnum,
  !    ...
  !  zans(1:ivec,(j-1)*ictnum+k) = value or derivative for function
  !                                id iflist(j), corresponding to k'th
  !                                non-zero element of ictwant(...)

  !--------------------------------------------
  logical :: ccw_chi,rzeval
  integer :: iveca,i,id_R,id_Z,ii,igrp,inumd,itot,ideriv1f(6),ideriv2f(6)
  integer, dimension(:), allocatable :: ids,idrhos,idchis
  !--------------------------------------------

  iveca=abs(ivec)
  ccw_chi = (ivec.gt.0)

  if(ivecd.lt.iveca) then
     ierr=1
     write(lunerr,*) ' ?eq_frhochi: answer array dimension ivecd too small:'
     write(lunerr,*) '  ivec = ',abs(ivec),'; ivecd = ',ivecd
     return
  endif

  inumd=0
  if(ictwant(1).eq.1) then
     inumd=inumd+1
     ideriv1f(inumd)=0
     ideriv2f(inumd)=0
  endif
  if(ictwant(2).eq.1) then
     inumd=inumd+1
     ideriv1f(inumd)=1
     ideriv2f(inumd)=0
  endif
  if(ictwant(3).eq.1) then
     inumd=inumd+1
     ideriv1f(inumd)=0
     ideriv2f(inumd)=1
  endif
  if(ictwant(4).eq.1) then
     inumd=inumd+1
     ideriv1f(inumd)=2
     ideriv2f(inumd)=0
  endif
  if(ictwant(5).eq.1) then
     inumd=inumd+1
     ideriv1f(inumd)=0
     ideriv2f(inumd)=2
  endif
  if(ictwant(6).eq.1) then
     inumd=inumd+1
     ideriv1f(inumd)=1
     ideriv2f(inumd)=1
  endif

  itot=inumd*nlist
  allocate(ids(itot),idrhos(itot),idchis(itot))

  igrp=-inumd
  do ii=1,nlist
     igrp=igrp+inumd
     ids(igrp+1:igrp+inumd)=iflist(ii)
     idrhos(igrp+1:igrp+inumd)=ideriv1f(1:inumd)
     idchis(igrp+1:igrp+inumd)=ideriv2f(1:inumd)
  enddo

  call xplasma_common_ids(s,ierr, id_R=id_R,id_Z=id_Z)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_hrhochi: interpolation call unsuccessful, ierr=',ierr
     call xplasma_error(s,ierr,lunerr)
     return
  endif
  rzeval=.TRUE.
  do i=1,nlist
     if((iflist(i).ne.id_R).and.(iflist(i).ne.id_Z)) then
        rzeval=.FALSE.
        exit
     endif
  enddo

  if(rzeval) then
     call xplasma_RZeval_2d(s,ids, &
          xplasma_rho_coord,zrho, xplasma_theta_coord,zchi, &
          zans(1:iveca,1:itot),ierr, &
          ccwflag2=ccw_chi, ideriv1s=idrhos, ideriv2s=idchis)
  else
     call xplasma_eval_prof(s,ids, &
          xplasma_rho_coord,zrho, xplasma_theta_coord,zchi, &
          zans(1:iveca,1:itot),ierr, &
          ccwflag2=ccw_chi, ideriv1s=idrhos, ideriv2s=idchis)
  endif

  deallocate(ids,idrhos,idchis)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_frhochi: interpolation call unsuccessful, ierr=',ierr
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_hrhochi

subroutine eqi_tau_bounce(zrho,indx,itrap,inum,zx,ztol,zcut, &
     zbmin,zbmax,zvtaub,ierr)
 
  !  evaluate zero banana width approximation to v*tau_bounce
  !
  !  this is the integral over the limits of the orbit of
  !     dtheta*(dlp/dtheta)*(B/Bp)*(1/sqrt(1-B/Brefl))
  !
  !  where Brefl is a trapped orbit's reflection point (vpll=0,v=vperp)
  !  for passing orbits (Brefl > Bmax) the integrand is over the
  !  entire surface contour; for trapped orbits the integrand is
  !  twice the value from theta_lower to theta_upper where these
  !  limits need to be found by a root finder so that
  !     B(theta_lower)=B(theta_upper)=Brefl
  !
  !  the integrand formula follows from the assumptions that v
  !  and mu=vperp**2/B are constants of motion
 
  !  axisymmetry is assumed...

  !  This is an internal private subroutine; error checking done in
  !  xplasma_ctran.f90:xplasma_vtaub contained subroutine.

  !------------------
 
  use xplasma_definitions
  use eqi_rzbox_module
  use eqi_vtaub_mod

  implicit NONE
 
  real*8, intent(in) :: zrho   ! surface on which to calculate
  !  note -- must not be magnetic axis; non-singular surface required.

  integer, intent(in) :: indx  ! vtaub integrand data element indx
  !  (could be a thread number for parallel implementations)
  !  (see eqi_vtaub_mod)

  integer, intent(in) :: itrap ! no. of eval points of trapped orbits
  integer, intent(in) :: inum  ! no. of eval points
  real*8, intent(in) :: zx(inum) ! evaluation points:
 
  !   zx(j) = (Brefl(j)-Bmin)/(Bmax-Bmin)
  ! where Bmin and Bmax, the min and mod(B) on the zrho surface, will
  ! be found; zx > 0 is required; zx(j+1) > zx(j) required for all j < inum.
 
  real*8, intent(in) :: ztol  ! relative error tolerance for integral
  real*8, intent(in) :: zcut  ! minimum allowed value for (1-B/Brefl)
 
  !---
 
  real*8, intent(out) :: zbmin,zbmax   ! Bmin and Bmax on zrho surface (T)
  real*8, intent(out) :: zvtaub(inum)  ! integral values returned (m)
  !  divide by ion velocity (m/sec) to get bounce time in seconds.
 
  integer, intent(out) :: ierr  ! completion code, 0=OK
 
  !-------------------------------------------
  real*8, external :: f_eq_tau_bounce  ! integrand function
  integer i,ieval,iwarn,ilast,id_R,id_th,inth,ith
  integer :: id_Z,id_Bmod,id_BR,id_BZ
  integer, parameter :: ilimit=1000, ilimit4 = 4*ilimit
  real*8, dimension(:), allocatable :: zbvals,zthbr1,zthbr2,zwork
  integer, dimension(:), allocatable :: iwork
  real*8 zthbmin,zthbmax,zaux(4),zabserr
  character*120 zmsg

  real*8, dimension(:), allocatable :: zwkrho,zmodb,zbpol,zdldth
  real*8, dimension(:,:), allocatable :: zwkfth
  integer :: ilist(5),iderivs(5)

  real*8, parameter :: CPI = 3.1415926535897931D+00
  real*8, parameter :: ZERO = 0.0D0
  !-------------------------------------------
 
  zbmin=0
  zbmax=0
  zvtaub=0
  ierr=0

  !  basic grid info
  call xplasma_common_ids(sp,ierr, &
       id_Bmod=id_Bmod,id_BR=id_BR,id_BZ=id_BZ,id_R=id_R,id_Z=id_Z)
  if(ierr.ne.0) return

  if(min(id_Bmod,id_BR,id_BZ).eq.0) then
     ierr=9999
     call xplasma_errmsg_append(sp,' ?eqi_tau_bounce: field data missing.')
     return
  endif

  ilist(1)=id_Bmod; iderivs(1)=0
  ilist(2)=id_BR;   iderivs(2)=0
  ilist(3)=id_BZ;   iderivs(3)=0
  ilist(4)=id_R;    iderivs(4)=1
  ilist(5)=id_Z;    iderivs(5)=1

  call xplasma_prof_info(sp,id_R,ierr, gridId1=id_th)
  if(ierr.ne.0) return

  call xplasma_grid_info(sp,id_th,ierr, size=inth)
  if(ierr.ne.0) return
 
  !  allocate integration data element

  call elem_alloc(indx,inth,ierr)  ! eqi_vtaub_mod 
  if(ierr.ne.0) then
     call errstr(ierr,zmsg)
     ierr=9999
     call xplasma_errmsg_append(sp,zmsg)
     return
  endif

  !  get data for integration

  allocate(zwkrho(inth),zwkfth(inth,5)); zwkrho = zrho
  allocate(zmodb(inth),zbpol(inth),zdldth(inth))

  call xplasma_eval_prof(sp,ilist, &
       xplasma_theta_coord,vta(indx)%th, &
       xplasma_rho_coord,zwkrho, &
       zwkfth,ierr, &
       ideriv1s=iderivs)

  if(ierr.ne.0) return

  do ith=1,inth
     zmodb(ith)=abs(zwkfth(ith,1))
     zbpol(ith)=sqrt(zwkfth(ith,2)**2+zwkfth(ith,3)**2)
     zdldth(ith)=sqrt(zwkfth(ith,4)**2+zwkfth(ith,5)**2)
  enddo

  call elem_init(indx,zmodb,zbpol,zdldth,ierr)

  deallocate(zwkrho,zwkfth,zmodb,zbpol,zdldth)

  if(ierr.ne.0) then
     call errstr(ierr,zmsg)
     ierr=9999
     call xplasma_errmsg_append(sp,zmsg)
     return
  endif

  !-----------------------------------------------------
  !  OK: field and dl/dth splines ready...

  !  get integration limits for trapped population
 
  allocate(zbvals(inum),zthbr1(inum),zthbr2(inum))
  zthbr1=-CPI
  zthbr2=CPI
 
  if(itrap.eq.0) then
     call eqi_bbox(zrho,zbmin,zthbmin,zbmax,zthbmax,ierr)
  else
     call eqi_bbvec(zrho,itrap,zx(1:itrap), &
          zbmin,zbmax,zbvals(1:itrap),zthbr1(1:itrap),zthbr2(1:itrap),ierr)
  endif
  if(ierr.ne.0) go to 999
 
  do i=itrap+1,inum
     zbvals(i)=zbmin+zx(i)*(zbmax-zbmin)
  enddo
 
  !  calculate integrands...
 
  allocate(iwork(ilimit),zwork(ilimit4))
 
  zaux(2)=zcut
  zaux(3)=zrho
  zaux(4)=indx+0.1d0

  do i=1,inum
     zaux(1)=zbvals(i)
     call tr_r8qags(f_eq_tau_bounce,zaux,zthbr1(i),zthbr2(i),ZERO,ztol, &
          zvtaub(i),zabserr,ieval,iwarn,ilimit,ilimit4,ilast,iwork,zwork)
  enddo
 
  zvtaub(1:itrap)=2*zvtaub(1:itrap)  ! trapped orbit goes back on self
 
  deallocate(iwork,zwork)
 
999 continue
  deallocate(zthbr1,zthbr2,zbvals)
 
end subroutine eqi_tau_bounce
 
!------------------------------------------------------------
real*8 function f_eq_tau_bounce(zchi,aux)
 
  !  integrand routine

  use eqi_vtaub_mod
  implicit NONE

  real*8, intent(in) :: zchi  ! poloidal angle
  real*8 aux(*)               ! auxilliary data
 
  !  aux(1) = Brefl
  !  aux(2) = cutoff for (1-B/Brefl)
  !  aux(3) = rho
  !  aux(4) = data element index
 
  real*8 :: zrho,zcut,zbrefl,zbp,zb,zdldth,zvpv,ztheta,zdth
  real*8, parameter :: ONE = 1.0d0
  integer :: indx,ith,inth
  !--------------------
 
  zrho=aux(3)
  zcut=aux(2)
  zbrefl=aux(1)
  indx=aux(4)

  !  bring argument in range; it is assumed to be nearly in range...

  ztheta=zchi

  if(ztheta.lt.-ZPI) then
     do
        ztheta = ztheta + 2*ZPI
        if(ztheta.ge.-ZPI) exit
     enddo

  else if(ztheta.gt.ZPI) then
     do
        ztheta = ztheta - 2*ZPI
        if(ztheta.le.ZPI) exit
     enddo

  endif

  !  find the zone & evaluate splines

  inth = vta(indx)%nth
  ith = 1 + (ztheta+ZPI)*(inth-1)/(2*ZPI)
  ith = max(1,min((inth-1),ith))
  zdth = ztheta - vta(indx)%th(ith)

  zb  = vta(indx)%fmodb(1,ith) + zdth*(vta(indx)%fmodb(2,ith) + &
       zdth*(vta(indx)%fmodb(3,ith) + zdth*vta(indx)%fmodb(4,ith)))

  zbp = vta(indx)%fbpol(1,ith) + zdth*(vta(indx)%fbpol(2,ith) + &
       zdth*(vta(indx)%fbpol(3,ith) + zdth*vta(indx)%fbpol(4,ith)))

  zdldth = vta(indx)%fdldth(1,ith) + zdth*(vta(indx)%fdldth(2,ith) + &
       zdth*(vta(indx)%fdldth(3,ith) + zdth*vta(indx)%fdldth(4,ith)))

  zvpv = sqrt(max(zcut,(ONE-zb/zbrefl)))  ! vpll/v = sqrt(1-B/Brefl)

  f_eq_tau_bounce = zdldth*zb/(zbp*zvpv)

end function f_eq_tau_bounce

subroutine eqi_xtrz(ierr)

  use xplasma_definitions
  use eqi_rzbox_module

  !  given the interior geometry, extrapolate the exterior...
  !  axisymmetry assumed...

  !  this routine creates an extrapolated rho grid, and an extrapolated
  !  set of nested surfaces, based on legacy TRANSP "bloat" software
  !  (D. McCune 17 Jan 2000)

  implicit NONE

  integer ierr                      ! completion code, 0=OK

  !------------------------------------------------

  logical symflag,axisymm,scrapeoff

  integer inbblo                    ! size of temporary extrap. grid
  real*8 zdrho

  real*8 zrmin,zrmax,zzmin,zzmax,zfacx0,zfacx1,zfacx,zfac,rmax_pt
  real*8 zrmin_pl,zrmax_pl,zzmin_pl,zzmax_pl,raxis,zaxis,zlen,zlentot
  real*8 zdlav,zdlmax,zdr,zdz,zfaclim

  real*8, dimension(:), allocatable :: xiblo,xi_bdy,th_bdy,th_arc,zdlen_bdy
  real*8, dimension(:,:), allocatable :: rz_bdy,th_arc_pkg,thspl,rz_ntk
  real*8, dimension(:,:,:), allocatable :: rmc,ymc,rmcx,ymcx
  real*8, dimension(:), allocatable :: th_arc_ntk,th_xpl_ntk,xi_bdy_ntk
  real*8, dimension(:), allocatable :: th_arc_exp,th_xpl_exp
  real*8, dimension(:), allocatable :: th_xpl_fin,th_arc_fin,xi_bdy_fin
  real*8, dimension(:,:), allocatable :: rz_fin

  integer lcentr,nzones,inzp1
  integer, parameter :: mimom = 32  ! no higher than 32

  integer i,ii,ith,ith_rmax,intk,id,id_Rgrid,id_Zgrid,id_R,id_Z,ids(2)
  integer :: ntheta,nthetax,nrhox
  integer :: iaxis_rhox,iaxis_theta,iaxis_thetax,iadd2pi,iertmp
  integer iexpand,idexp,iexp,imark_endpt,idum

  real*8 :: rho_bdy,rho_vac,zdth_mark

  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: c2pi = 6.2831853071795862D+00

  data symflag/.FALSE./

  !------------------------------------------------

  ierr=0
  zfacx1=1.600d0  ! initial grid expansion factor... will be expanded
  !                 if needed to cover SOL (R,Z) rectangle

  rho_bdy = 1.00d0

  call xplasma_global_info(sp,ierr, axisymm=axisymm, scrapeoff=scrapeoff)
  if(ierr.ne.0) return

  if(.not.axisymm) then
     ierr=107
     call xplasma_errmsg_append(sp,' ...error in eqi_xtrz subroutine.')
     return
  endif

  if(.not.scrapeoff) then
     ierr=109
     call xplasma_errmsg_append(sp,' ...error in eqi_xtrz subroutine.')
     return
  endif

  !  just exit now if the extrapolation has been done already...

  call xplasma_find_item(sp,'__R_extrap',id,ierr, nf_noerr=.TRUE.)
  if(ierr.ne.0) return
  if(id.ne.0) return

  !  OK................................................... proceed...
  !  ad hoc extrapolation step

  !  __R_extrap(rho,theta) and __Z_extrap(rho,theta) will be created.
  !  extrapolation grids (__rhox) & (__thetax) will also be defined

  call xplasma_common_ids(sp,ierr, id_R=id_R, id_Z=id_Z)
  if(ierr.ne.0) return

  call xplasma_prof_info(sp,id_R,ierr, gridId1=iaxis_theta)
  if(ierr.ne.0) return

  call xplasma_grid_size(sp,iaxis_theta,ntheta,ierr)
  if(ierr.ne.0) return

  call xplasma_RZminmax_extended(sp, zrmin, zrmax, zzmin, zzmax, ierr, &
       id_Rgrid=id_Rgrid, id_Zgrid=id_Zgrid)
  if(ierr.ne.0) return

  call xplasma_RZminmax_plasma(sp, zrmin_pl,zrmax_pl, zzmin_pl,zzmax_pl, ierr)
  if(ierr.ne.0) return

  call xplasma_mag_axis(sp, ierr, raxis=raxis, zaxis=zaxis)
  if(ierr.ne.0) return

  !-------------------
  !  OK -- will use arc length theta for bloat expansion
  !  error checking is done... error after this point would be a bug

  allocate(xi_bdy(ntheta),th_bdy(ntheta),th_arc(ntheta),zdlen_bdy(ntheta-1))
  allocate(rz_bdy(ntheta,2),th_arc_pkg(ntheta,4),thspl(2,ntheta))
  allocate(th_arc_exp(2*ntheta))

  ids(1)=id_R; ids(2)=id_Z
  xi_bdy = rho_bdy
  call xplasma_grid(sp,iaxis_theta,th_bdy,iertmp)

  call xplasma_eval_prof(sp,ids, &
       xplasma_theta_coord,th_bdy, xplasma_rho_coord,xi_bdy, &
       rz_bdy,iertmp)

  zlentot=ZERO
  zdlmax=ZERO
  ith_rmax=1
  rmax_pt=rz_bdy(1,1)
  do ith=1,ntheta-1
     if(rz_bdy(ith,1).gt.rmax_pt) then
        ith_rmax=ith
        rmax_pt=rz_bdy(ith,1)
     endif
     zdr=rz_bdy(ith+1,1)-rz_bdy(ith,1)
     zdz=rz_bdy(ith+1,2)-rz_bdy(ith,2)
     zdlen_bdy(ith)=sqrt(zdr*zdr+zdz*zdz)
     zdlmax=max(zdlmax,zdlen_bdy(ith))
     zlentot=zlentot+zdlen_bdy(ith)
  enddo
  zdlav=zlentot/(ntheta-1)

  ! Arc-length theta 0 at ith_rmax

  ith=ith_rmax-1
  iadd2pi=0
  th_arc_pkg(1,1)=0
  th_arc_exp(1)=0
  zlen=0.0d0
  iexpand=0
  iexp=1

  do i=1,ntheta-1
     ith=ith+1
     th_arc(ith)=c2pi*(zlen/zlentot)
     thspl(1,i)=th_bdy(ith)+iadd2pi*c2pi
     if(ith.eq.ntheta) then
        ith=1
        iadd2pi=1
        th_arc(1)=th_arc(ntheta)
     endif
     zlen=zlen+zdlen_bdy(ith)
     th_arc_pkg(i+1,1)=c2pi*(zlen/zlentot)
     if(zdlen_bdy(ith).ge.2.500d0*zdlav) then
        idexp = (zdlen_bdy(ith)/zdlav) - 1
        iexpand = iexpand + idexp
        do ii=1,idexp
           iexp=iexp+1
           th_arc_exp(iexp) = th_arc_pkg(i,1) + &
                ii*(th_arc_pkg(i+1,1)-th_arc_pkg(i,1))/(idexp+1)
        enddo
     endif
     iexp=iexp+1
     th_arc_exp(iexp)=th_arc_pkg(i+1,1)
  enddo
  thspl(1,ntheta)=thspl(1,1)+c2pi
  th_arc(ntheta)=th_arc(1)+c2pi

  call genxpkg(ntheta,th_arc_pkg(1:ntheta,1),th_arc_pkg,1,0,0,ZERO,3,iertmp)
  call mkspline(th_arc_pkg(1:ntheta,1),ntheta,thspl,-1,ZERO,-1,ZERO,idum, &
       iertmp)

  !-------------------
  !  bloat gridsize...

  call r8ntk(intk)
  allocate(th_arc_ntk(intk),th_xpl_ntk(intk),xi_bdy_ntk(intk),rz_ntk(intk,2))

  do ith=1,intk
     th_arc_ntk(ith)=(ith-1)*c2pi/intk  ! 0:2pi-dtheta
     xi_bdy_ntk(ith)=rho_bdy
  enddo

  !  transform back to xplasma splines (w/possible 2pi shift) from arclength
  !  angle parameter...

  call vecspline((/1,0,0/),intk,th_arc_ntk,intk, &
       th_xpl_ntk,ntheta,th_arc_pkg,thspl,idum,iertmp)

  !  corresponding (R,Z) locations:

  call xplasma_eval_prof(sp,ids, &
       xplasma_theta_coord,th_xpl_ntk, xplasma_rho_coord,xi_bdy_ntk, &
       rz_ntk,iertmp)

  !  now form final grid & corresponding arclength thetas

  nthetax=ntheta+iexpand
  allocate(th_xpl_exp(nthetax),th_arc_fin(nthetax),th_xpl_fin(nthetax))

  call vecspline((/1,0,0/),nthetax,th_arc_exp(1:nthetax),nthetax, &
       th_xpl_exp,ntheta,th_arc_pkg,thspl,idum,iertmp)

  zdth_mark=2*c2pi
  do iexp=1,nthetax
     if(abs(th_xpl_exp(iexp)-th_bdy(ntheta)).lt.zdth_mark) then
        zdth_mark=abs(th_xpl_exp(iexp)-th_bdy(ntheta))
        imark_endpt=iexp
     endif
  enddo

  if(imark_endpt.eq.nthetax) then
     th_arc_fin=th_arc_exp(1:nthetax)
     th_xpl_fin=th_xpl_exp
     th_xpl_fin(1)=th_bdy(1)
     th_xpl_fin(nthetax)=th_bdy(ntheta)
  else
     th_xpl_fin(1)=th_bdy(1)
     th_arc_fin(1)=th_arc_exp(imark_endpt)
     ii=1
     ith=imark_endpt
     do i=2,nthetax-1
        ith=ith+1
        if(ith.eq.nthetax) ith=1
        ii=ii+1
        if(th_xpl_exp(ith).gt.th_bdy(ntheta)) then
           th_xpl_fin(ii)=th_xpl_exp(ith)-c2pi
        else
           th_xpl_fin(ii)=th_xpl_exp(ith)
        endif
        th_arc_fin(ii)=th_arc_exp(ith)
     enddo
     th_xpl_fin(nthetax)=th_bdy(ntheta)
     th_arc_fin(nthetax)=th_arc_fin(1)
  endif

  allocate(rz_fin(nthetax,2),xi_bdy_fin(nthetax))

  xi_bdy_fin=rho_bdy
  if(iexpand.gt.0) then
     call xplasma_eval_prof(sp,ids, &
          xplasma_theta_coord,th_xpl_fin, xplasma_rho_coord,xi_bdy_fin, &
          rz_fin,iertmp)
  else
     rz_fin = rz_bdy
  endif

  !-------------------
  call xplasma_author_set(sp,xplasma_xmhd,iertmp)

  zdrho= 0.04d0   ! extrapolation rho step size...
  zfacx0=zfacx1
  zfaclim=4.0d0

10 continue
  zfacx=zfacx0*max((zrmax-zrmin)/(zrmax_pl-zrmin_pl), &
       (zzmax-zzmin)/(zzmax_pl-zzmin_pl))

  zfacx=min(zfacx,zfaclim)  ! sanity limit

  rho_vac=zfacx

  inbblo=5+(rho_vac-rho_bdy)/zdrho

  lcentr=1
  nzones=2
  inzp1=nzones+1

  allocate(xiblo(inbblo))
  allocate(rmc(inzp1,0:mimom,2))
  allocate(ymc(inzp1,0:mimom,2))
  allocate(rmcx(inbblo,0:mimom,2))
  allocate(ymcx(inbblo,0:mimom,2))

  !  form temporary grid for bloat routine

  xiblo(1)=0.00d0
  xiblo(2)=0.70d0
  xiblo(3)=rho_bdy
  do i=4,inbblo
     xiblo(i)=xiblo(i-1)+zdrho
  enddo
  rho_vac=xiblo(inbblo)
  nrhox=inbblo-2

  rmc=ZERO
  ymc=ZERO
  rmcx=ZERO
  ymcx=ZERO

  rmc(lcentr,0,1)=raxis
  ymc(lcentr,0,1)=zaxis

  !  setup startup grid -- last two surfaces inside the plasma
  !  complete interior moments

  call eqi_xtrzf(symflag,intk,xiblo(1:inzp1),rmc,ymc, &
       inzp1,mimom,rz_ntk)

  !  extrapolate from plasma bdy out to user specified "rho" ~ r/a

  call r8bloata0(symflag,1,nzones,xiblo(1),inbblo,inbblo,inzp1, &
       rmc(1,0,1),ymc(1,0,1),mimom,mimom,6, &
       rmcx(1,0,1),ymcx(1,0,1),ierr)

  if(ierr.ne.0) then
     ierr=9999
     call xplasma_errmsg_append(sp,' ?? eqi_xtrz:  BLOAT failure.')
     call xplasma_errmsg_append(sp,'    r8bloata0 call failed in eqi_xtrz.')
     go to 1000
  endif

  call eqi_xtrz_test(zrmin,zrmax,zzmin,zzmax, &
       xiblo(1),inbblo,rmcx(1,0,1),ymcx(1,0,1),mimom,zfac,ierr)
  if(ierr.ne.0) then

  !  try to increase the expansion range once, then give up

     if(zfacx0.gt.zfacx1) then
        ierr=9999
        call xplasma_errmsg_append(sp,' ?? eqi_xtrz:  BLOAT failure.')
        call xplasma_errmsg_append(sp,'    Failed to cover (R,Z) rectangle.')
        go to 1000
     else
        zfacx0=(1.1d0)*zfac*zfacx0
        zfaclim=(1.1d0)*zfac*zfaclim
        deallocate(xiblo,rmc,ymc,rmcx,ymcx)
        go to 10
     endif
  endif

  !  extrapolate (rho,theta) space

  call xplasma_create_grid(sp,'__RHOX',xplasma_rhox_coord,xiblo(3:inbblo), &
       iaxis_rhox,ierr, label='extrapolated rho grid')

  call xplasma_create_grid(sp,'__THETAX',xplasma_thx_coord,th_xpl_fin, &
       iaxis_thetax,ierr, label='theta grid for extrapolated region')

  call eqi_xtrza(xiblo(1),inbblo,rmcx(1,0,1),ymcx(1,0,1),mimom, &
       inzp1,xiblo(3:inbblo),nrhox,th_xpl_fin,nthetax,th_arc_fin,rz_fin, &
       iaxis_rhox,iaxis_thetax,raxis,zaxis)

1000 continue
  deallocate(xiblo)

  deallocate(rmc)
  deallocate(ymc)

  deallocate(rmcx)
  deallocate(ymcx)

  deallocate(xi_bdy,th_bdy,zdlen_bdy,rz_bdy)
  deallocate(th_arc,th_arc_pkg,thspl)
  deallocate(th_arc_ntk,th_xpl_ntk,xi_bdy_ntk,rz_ntk)
  deallocate(th_arc_exp,th_xpl_exp)
  deallocate(th_arc_fin,th_xpl_fin,xi_bdy_fin,rz_fin)

  call xplasma_author_clear(sp,xplasma_xmhd,iertmp)

end subroutine eqi_xtrz

!------------------------------------------------------
subroutine eqi_xtrzf(symflag,intk,zrho,rmc,ymc,insurf,mimom,rz_ntk)

  use xplasma_definitions
  use eqi_rzbox_module

  !  get data and do fft to define a surface moments expansion

  implicit NONE

  integer intk                      ! no. of theta points
  logical symflag                   ! symmetry flag
  integer insurf                    ! #of surfaces in rmc,ymc
  real*8 zrho(insurf)               ! surface coordinate
  integer mimom                     ! #of moments in rmc,ymc
  real*8 rmc(insurf,0:mimom,2)      ! R moments (surf. i written)
  real*8 ymc(insurf,0:mimom,2)      ! Y moments (surf. i written)

  real*8 rz_ntk(intk,2)             ! (R,Z) contour at boundary

  !------------------------------------------------
  integer i,ith

  !  automatic:
  real*8 zrwk(intk),zzwk(intk),raxis,zaxis
  real*8 zrmc(3,0:mimom,2),zymc(3,0:mimom,2)

  !------------------------------------------------
  !  caller must assure that zrho(insurf) is at the boundary
  !  and zrho(insurf-1) is some distance in from the boundary

  raxis=rmc(1,0,1)
  zaxis=ymc(1,0,1)

  zrmc=0.0d0
  zymc=0.0d0

  zrwk=0.3d0*raxis+0.7d0*rz_ntk(1:intk,1)
  zzwk=0.7d0*zaxis+0.7d0*rz_ntk(1:intk,2)

  call r8tkbmmc(symflag,zrmc,zymc,mimom,mimom,zrwk,zzwk)
  do i=0,mimom
     rmc(insurf-1,i,1)=zrmc(3,i,1)
     rmc(insurf-1,i,2)=zrmc(3,i,2)
     ymc(insurf-1,i,1)=zymc(3,i,1)
     ymc(insurf-1,i,2)=zymc(3,i,2)
  enddo

  zrmc=0.0d0
  zymc=0.0d0

  zrwk=rz_ntk(1:intk,1)
  zzwk=rz_ntk(1:intk,2)

  call r8tkbmmc(symflag,zrmc,zymc,mimom,mimom,zrwk,zzwk)
  do i=0,mimom
     rmc(insurf,i,1)=zrmc(3,i,1)
     rmc(insurf,i,2)=zrmc(3,i,2)
     ymc(insurf,i,1)=zymc(3,i,1)
     ymc(insurf,i,2)=zymc(3,i,2)
  enddo

end subroutine eqi_xtrzf

!-----------------------------------------------------------------
subroutine eqi_xtrz_test(zrmin,zrmax,zzmin,zzmax, &
     xiblo,inbblo,rmcx,zmcx,mimom,zfac,ierr)

  !  test if extrapolation covers the R,Z cartesian grid

  use xplasma_definitions
  use eqi_rzbox_module

  implicit NONE
  !  input:
  real*8 zrmin,zrmax,zzmin,zzmax    ! range that must be covered
  integer inbblo                    ! no. of moments surfaces
  real*8 xiblo(inbblo)              ! surfaces where moments are given
  integer mimom                     ! no. of moments in Fourier Expansion
  real*8 rmcx(inbblo,0:mimom,2)     ! R moments
  real*8 zmcx(inbblo,0:mimom,2)     ! Z moments

  !  output:
  real*8 zfac                       ! estimate of further expansion needed
  integer ierr                      ! completion code, 0=OK

  !  if ierr=1, zfac is a multiplicative factor to apply to the range
  !  of the previous extrapolation, to get the right amount of total
  !  extrapolation

  !---------------------------------------
  integer ntest
  parameter (ntest=200)

  real*8 zr0,zz0
  real*8 zrtest(ntest),zztest(ntest),ztheta
  real*8 zsn(mimom),zcs(mimom),zRsum,zZsum
  real*8 zrminc,zrmaxc,zzminc,zzmaxc

  integer itop,ileft,ibot,iright,ith,itp,imi,im
  integer itest,ilim1,ilim2

  real*8 ztest1,ztest2,zxpmin
  real*8, parameter :: c2pi = 6.2831853071795862D+00
  real*8, parameter :: czero= 0.0d0
  real*8, parameter :: chalf= 0.5d0

  !---------------------------------------
  zr0=chalf*(zrmin+zrmax)
  zz0=chalf*(zzmin+zzmax)

  do ith=1,ntest
     ztheta=(ith-1)*c2pi/(ntest-1)
     call r8sincos(ztheta,mimom,zsn,zcs)

     imi=inbblo
     zRsum=rmcx(imi,0,1)
     zZsum=zmcx(imi,0,1)
     do im=1,mimom
        zRsum=zRsum+zcs(im)*rmcx(imi,im,1)+zsn(im)*rmcx(imi,im,2)
        zZsum=zZsum+zcs(im)*zmcx(imi,im,1)+zsn(im)*zmcx(imi,im,2)
     enddo

     zrtest(ith)=zRsum
     zztest(ith)=zZsum
  enddo

  !  find pts near corners

  itop=0
  ileft=0
  ibot=0
  iright=0

  do ith=1,ntest-1
     itp=ith+1
     if(((zrtest(itp)-zr0).gt.czero).and. &
          ((zztest(itp)-zz0).gt.czero)) then
        ztest1 = (zzmax-zz0)*(zrmax-zrtest(ith))- &
             (zrmax-zr0)*(zzmax-zztest(ith))
        ztest2 = (zzmax-zz0)*(zrmax-zrtest(itp))- &
             (zrmax-zr0)*(zzmax-zztest(itp))
        if(ztest1*ztest2.le.czero) then
           itop=itp
        endif
     else if(((zrtest(itp)-zr0).lt.czero).and. &
          ((zztest(itp)-zz0).gt.czero)) then
        ztest1 = (zzmax-zz0)*(zrmin-zrtest(ith))- &
             (zrmin-zr0)*(zzmax-zztest(ith))
        ztest2 = (zzmax-zz0)*(zrmin-zrtest(itp))- &
             (zrmin-zr0)*(zzmax-zztest(itp))
        if(ztest1*ztest2.le.czero) then
           ileft=itp
        endif
     else if(((zrtest(itp)-zr0).lt.czero).and. &
          ((zztest(itp)-zz0).lt.czero)) then
        ztest1 = (zzmin-zz0)*(zrmin-zrtest(ith))- &
             (zrmin-zr0)*(zzmin-zztest(ith))
        ztest2 = (zzmin-zz0)*(zrmin-zrtest(itp))- &
             (zrmin-zr0)*(zzmin-zztest(itp))
        if(ztest1*ztest2.le.czero) then
           ibot=itp
        endif
     else if(((zrtest(itp)-zr0).gt.czero).and. &
          ((zztest(itp)-zz0).lt.czero)) then
        ztest1 = (zzmin-zz0)*(zrmax-zrtest(ith))- &
             (zrmax-zr0)*(zzmin-zztest(ith))
        ztest2 = (zzmin-zz0)*(zrmax-zrtest(itp))- &
             (zrmax-zr0)*(zzmin-zztest(itp))
        if(ztest1*ztest2.le.czero) then
           iright=itp
        endif
     endif
  enddo

  !  sanity checks...

  if((itop.eq.0).or.(ibot.eq.0).or.(iright.eq.0).or.(ileft.eq.0)) then
     call xplasma_errmsg_append(sp,' ?? eqi_xtrz_test:  algorithm error 1!')
     ierr=9999
     zfac=1.5d0
     return
  endif

  itest=0
  if(ileft.gt.itop) itest=itest+1
  if(ibot.gt.ileft) itest=itest+1
  if(iright.gt.ibot) itest=itest+1
  if(itop.gt.iright) itest=itest+1
  if(itest.ne.3) then
     call xplasma_errmsg_append(sp,' ?? eqi_xtrz_test:  algorithm error 2!')
     ierr=9999
     zfac=1.5d0
     return
  endif

  zrmaxc=zrtest(iright)
  zrminc=zrtest(ileft)
  zzmaxc=zztest(itop)
  zzminc=zztest(ibot)

  !  min Z on top

  ilim1=itop
  ilim2=ileft
  if(ilim2.lt.ilim1) ilim2=ilim2+ntest
  do ith=ilim1,ilim2
     itp=ith
     if(itp.gt.ntest) itp=itp-ntest
     zzmaxc=min(zzmaxc,zztest(itp))
  enddo

  !  max R on left

  ilim1=ileft
  ilim2=ibot
  if(ilim2.lt.ilim1) ilim2=ilim2+ntest
  do ith=ilim1,ilim2
     itp=ith
     if(itp.gt.ntest) itp=itp-ntest
     zrminc=max(zrminc,zrtest(itp))
  enddo

  !  max Z at bottom

  ilim1=ibot
  ilim2=iright
  if(ilim2.lt.ilim1) ilim2=ilim2+ntest
  do ith=ilim1,ilim2
     itp=ith
     if(itp.gt.ntest) itp=itp-ntest
     zzminc=max(zzminc,zztest(itp))
  enddo

  !  min R on right

  ilim1=iright
  ilim2=itop
  if(ilim2.lt.ilim1) ilim2=ilim2+ntest
  do ith=ilim1,ilim2
     itp=ith
     if(itp.gt.ntest) itp=itp-ntest
     zrmaxc=min(zrmaxc,zrtest(itp))
  enddo

  ierr=0
  if((zrminc.le.zrmin).and.(zrmaxc.ge.zrmax).and. &
       (zzminc.le.zzmin).and.(zzmaxc.ge.zzmax)) then
     continue
  else
     ierr=1
     zxpmin=1.1d0
     zfac=max(zxpmin, &
          (zrmax-zr0)/(zrmaxc-zr0),(zzmax-zz0)/(zzmaxc-zz0), &
          (zrmin-zr0)/(zrminc-zr0),(zzmin-zz0)/(zzminc-zz0))
  endif

end subroutine eqi_xtrz_test

!-----------------------------------------------------------------
subroutine eqi_xtrza(xiblo,inbblo,rmcx,zmcx,mimom,ibdy, &
     rhox,nrhox,thetax,nthetax,th_fft,rz_xbdy,iaxis_rhox,iaxis_thetax, &
     raxis,zaxis)

  use xplasma_definitions
  use eqi_rzbox_module

  implicit NONE

  !  given the extrapolated surface data in moments form, convert to
  !  spline representation & store as xplasma profiles

  !  input:
  integer inbblo                    ! no. of moments surfaces
  real*8 xiblo(inbblo)              ! surfaces where moments are given
  integer mimom                     ! no. of moments in Fourier Expansion
  real*8 rmcx(inbblo,0:mimom,2)     ! R moments
  real*8 zmcx(inbblo,0:mimom,2)     ! Z moments
  integer ibdy                      ! index of plasma bdy surf. in xiblo

  integer :: nrhox                  ! extrap. rho grid
  real*8 :: rhox(nrhox)
  integer :: nthetax                ! extrap. theta grid
  real*8 :: thetax(nthetax)
  real*8 :: th_fft(nthetax)
  real*8 :: rz_xbdy(nthetax,2)      ! R & Z bdy values @ rho=1

  integer :: iaxis_rhox,iaxis_thetax  ! extrapolation grid Ids

  real*8, intent(in) :: raxis, zaxis

  !--------------------------------------
  integer :: ispline,iertmp,itheta,irho,inum,id,ishift
  real*8, dimension(:,:), allocatable :: Rx,Zx,distx,atanx
  real*8, dimension(:), allocatable :: atanx0
  real*8 :: zth,zthmin,zatan,zdra,zdza
  character*80 atanx0_label
  real*8,parameter :: C2PI = 6.2831853071795862D+00
  !--------------------------------------
  !  it will be important to use the same fit for the extrapolated R & Z
  !  profiles as was used for the core profiles...

  call xplasma_global_info(sp,iertmp, rzOrder=ispline)

  !------------------
  !  1.  set boundary values to match core region

  allocate(rx(nthetax,nrhox),zx(nthetax,nrhox))
  allocate(distx(nthetax,nrhox),atanx(nthetax,nrhox),atanx0(nrhox))

  Rx(1:nthetax,1) = rz_xbdy(1:nthetax,1)
  Zx(1:nthetax,1) = rz_xbdy(1:nthetax,2)

  !  2.  find the R & Z sequence for each theta, do a 1d spline on this,
  !     and insert results in 2d spline data arrays

  inum=inbblo-ibdy

  do itheta=1,nthetax
     if(itheta.eq.nthetax) then
        do irho=2,nrhox
           !  periodic condition:
           Rx(nthetax,irho)=Rx(1,irho)
           Zx(nthetax,irho)=Zx(1,irho)
        enddo
     else
        zth=th_fft(itheta)
        call eqi_xtrz_fill(zth,Rx(itheta,2:nrhox),Zx(itheta,2:nrhox),inum, &
             rmcx,zmcx,inbblo,mimom,ibdy)
     endif
  enddo

  !  3.  setup the profile splines...

  call xplasma_create_2dprof(sp,'__R_extrap', &
       iaxis_thetax,iaxis_rhox,Rx,id,iertmp, &
       ispline=ispline,label='R(rho,theta) extrapolation',units='m')

  call xplasma_create_2dprof(sp,'__Z_extrap', &
       iaxis_thetax,iaxis_rhox,Zx,id,iertmp, &
       ispline=ispline,label='Z(rho,theta) extrapolation',units='m')

  do irho=1,nrhox
     do itheta=1,nthetax-1
        zdra=Rx(itheta,irho)-raxis
        zdza=Zx(itheta,irho)-zaxis
        distx(itheta,irho)=sqrt(zdra*zdra+zdza*zdza)
        atanx(itheta,irho)=atan2(zdza,zdra)
     enddo
     distx(nthetax,irho)=distx(1,irho)
     !  now make atanx(theta,rho) be relative to 1st theta atan.
     zatan=atanx(1,irho)
     atanx0(irho)=zatan
     atanx(1,irho)=0.0d0
     atanx(nthetax,irho)=C2PI
     ishift=0
     do itheta=2,nthetax-1
        if(ishift.eq.0) then
           if(atanx(itheta,irho).lt.zatan) then
              ishift=1
           else
              zatan=atanx(itheta,irho)
           endif
        endif
        atanx(itheta,irho)=atanx(itheta,irho)-atanx0(irho)+ishift*C2PI
     enddo
  enddo

  call xplasma_create_2dprof(sp,'__distx_axis',iaxis_thetax,iaxis_rhox, &
       distx,id,iertmp, &
       label='distance to axis',units='m')

  call xplasma_create_2dprof(sp,'__atanx_axis',iaxis_thetax,iaxis_rhox, &
       atanx,id,iertmp, &
       label='adjusted arctan((Zx-Zaxis)/(Rx-Raxis))',units='rad')

  call xplasma_grid_info(sp,iaxis_thetax,iertmp, xmin=zthmin)
 
  atanx0_label=' '
  write(atanx0_label, &
       '(" arctan((Zx-Zaxis)/(Rx-Raxis)) vs. rho @theta=",1pd11.4)') zthmin

  call xplasma_create_prof(sp,'__atanx0_axis',iaxis_rhox, &
       atanx0,id,iertmp, &
       label=trim(atanx0_label),units='rad')
 
  deallocate(Rx,Zx,distx,atanx,atanx0)

end subroutine eqi_xtrza

!------------------------------------------------------------------
subroutine eqi_xtrz_fill(ztheta,Rdata,Zdata,inum, &
     rmcx,zmcx,inbblo,mimom,ibdy)

  !  setup 1d spline vs. rho (beyond plasma bdy) along a fixed
  !  theta line.

  !  the moments input defines an axial point, a non-singular surface
  !  just inside the boundary, the boundary surface, and then a set of
  !  extrapolated surfaces...

  implicit NONE

  real*8 ztheta                     ! theta angle (w.r.t. Fourier exp.)

  integer inum                      ! number of pts
  real*8 :: Rdata(inum),Zdata(inum) ! data points to be computed

  integer inbblo                    ! #of surfaces in moments array
  integer mimom                     ! #of moments in moments array

  integer ibdy                      ! bdy surface index in rmcx,zmcx
  real*8 rmcx(inbblo,0:mimom,2)     ! R moments
  real*8 zmcx(inbblo,0:mimom,2)     ! Z moments

  !--------------------------------------

  integer irho,isurf,im
  real*8 zsn(mimom),zcs(mimom)      ! sincos ladder (automatic storage)
  real*8 zRsum,zZsum

  !--------------------------------------

  !  the 1st data points of R1spl, Z1spl match the interior R,Z set and
  !  are presumed to already have been set ***

  call r8sincos(ztheta,mimom,zsn,zcs)

  do isurf=ibdy+1,inbblo
     irho=isurf-ibdy

     zRsum=rmcx(isurf,0,1)
     zZsum=zmcx(isurf,0,1)
     do im=1,mimom
        zRsum=zRsum+zcs(im)*rmcx(isurf,im,1)+zsn(im)*rmcx(isurf,im,2)
        zZsum=zZsum+zcs(im)*zmcx(isurf,im,1)+zsn(im)*zmcx(isurf,im,2)
     enddo
     Rdata(irho)=zRsum
     Zdata(irho)=zZsum
  enddo

end subroutine eqi_xtrz_fill

module xplasma_sol

  !  xplasma "scrape off layer" module -- xplasma_sol
  !  At present this contains:
  !     -- routines for defining a limiter (2 methods provided)
  !     -- a routine for checking consistency of MHD equilibrium with the
  !        given limiter definition.

  use xplasma_obj
  use xplasma_ctran
  use eqi_rzbox_module  ! for sp ptr
  implicit NONE

  private

  public :: xplasma_mklim_contour
  public :: xplasma_mklim_special
  public :: xplasma_lim_info
  public :: xplasma_limcheck
  public :: xplasma_limcon,xplasma_bdycon
  public :: xplasma_lim_rzminmax
  public :: xplasma_lim_distance, xplasma_lim_dist1,xplasma_lim_distn
  public :: xplasma_fxcep

  interface xplasma_lim_distance
     module procedure xplasma_lim_dist1
     module procedure xplasma_lim_distn
  end interface

  ! (default) surface to use to test for intersection with
  ! mechanical limiter.  The consistency requirement of the equilibrium 
  ! with a limiter specification is that the equilibrium boundary not 
  ! intersect a limiter.  In practice we test a surface offset somewhat
  ! inside the boundary; this parameter identifies what surface is the
  ! default.  See "xplasma_limcheck"...

  real*8, parameter, public :: xplasma_rho_limcheck = 0.95d0

  contains
    subroutine xplasma_mklim_contour(s,rpts,zpts,iwarn,ier)
 
      ! define an axisymmetric limiter/wall from a closed (R,Z) contour

      type (xplasma), pointer :: s
      real*8,intent(in), dimension(:) :: Rpts,Zpts  ! the contour
      !  Both arrays must be of the same length;

      !  Note: must be a closed curve with Rpts(1)=Rpts(npts) and 
      !  Zpts(1)=Zpts(npts).  The curve must not cross itself (this is tested).

      integer, intent(out) :: iwarn  ! warning flag: if limiter is redefined.
      integer, intent(out) :: ier    ! completion status code: 0=OK

      !----------------------------------------------
      integer :: id,itype,iertmp,isize,id_R
      integer :: idata(7),ilocmmx,npts
      real*8, dimension(:), allocatable :: r8data
      !----------------------------------------------

      ier=0
      iwarn=0

      npts=size(rpts)
      if(npts.ne.size(zpts)) then
         ier=510
         iwarn=510
         call xplasma_errmsg_append(s,&
              'limiter contour Rpts(:) and Zpts(:) array lengths unequal.')
         return
      endif

      !  set warning flag if something named "__LIMITER" already exists.

      call xplasma_find_item(s,'__LIMITER',id,iertmp, nf_noerr=.TRUE.)
      if(id.ne.0) iwarn=1

      itype=100

      idata = 0
      idata(1)=1
      idata(4)=Npts

      isize= 6*Npts
      allocate(r8data(isize+4))
      ilocmmx=isize+1
      idata(7)=ilocmmx

      ! call adapted f77-xplasma routine to check contour
      sp => s
      call eqi_cbdy_pts(r8data,Npts,Rpts,Zpts,ier)
      if(ier.ne.0) then
         deallocate(r8data)
         return
      endif

      r8data(ilocmmx)=minval(Rpts)
      r8data(ilocmmx+1)=maxval(Rpts)
      r8data(ilocmmx+2)=minval(Zpts)
      r8data(ilocmmx+3)=maxval(Zpts)

      !----------------------------------------------
      !  create limiter dataset "black box"...

      call xplasma_author_set(s,xplasma_root,iertmp)

      call xplasma_create_blackbox(s,'__LIMITER',itype,id,ier, &
           iarray=idata, r8array=r8data, &
           label='axisymmetric contour limiter data')

      call xplasma_author_clear(s,xplasma_root,iertmp)

      if(ier.ne.0) then
         call xplasma_errmsg_append(s, &
              ' xplasma_mklim_contour: "__LIMITER" create failure.')
      endif

      deallocate(r8data)

      call xplasma_common_ids(s,iertmp, id_R)
      if(id_R.gt.0) then
         call xplasma_limcheck(s,ier)
      endif

    end subroutine xplasma_mklim_contour

    !==========================================================

    subroutine xplasma_mklim_special(s,iwarn,ier, &
         dist, Rmin,Rmax, Zmin,Zmax, &
         nlines, Rl, Zl, thl, &
         ncircs, Rc, Zc, rad)

      ! define an axisymmetric limiter/wall by various means other than
      ! an (R,Z) contour, as described in the optional arguments

      type (xplasma), pointer :: s

      integer, intent(out) :: iwarn  ! warning flag: if limiter is redefined.
      integer, intent(out) :: ier    ! completion status code: 0=OK

      real*8, intent(in), optional :: dist   ! if >=0, limiter at/outside
      !  plasma boundary.  if >0, limiter is located (dist) meters from the
      !  plasma boundary all the way around.  Default: -1.0, i.e. no such 
      !  limiter.

      real*8, intent(in),  optional :: Rmin,Rmax, Zmin,Zmax
      !  Rectangular "box" limiter.  It is expected that the plasma boundary
      !  will not cross this box boundary.

      !--------------------------------------------
      !  "Legacy" limiter specifications...

      integer, intent(in), optional :: nlines   ! # of "line limiters"
      real*8, intent(in), dimension(:), optional :: Rl,Zl,thl

      integer, intent(in), optional :: ncircs   ! # of "circle limiters"
      real*8, intent(in), dimension(:), optional :: Rc,Zc,rad

      !  set up a TRANSP-style machine boundary specification.  This consists
      !  two lists:  a list of circles (R,Z) & radius, and a list of infinite
      !  lines (R,Z) and inclination angle, thl (degrees).

      !  for each circle, the plasma is excluded from the space inside
      !  the circle (sign=-1.) or is excluded from the space outside
      !  (sign=+1.).  The sign is determined by whether the plasma magnetic
      !  axis point (R0,Z0) is inside or outside the circle.

      !  for each infinite line, a start point and orientation angle are
      !  given.  the angle (thl) is in degrees, with convention:

      !    thl(i)=0.0d0 -- horizontal orientation
      !    thl(i)=45.0d0 -- line goes up & to right (+R,+Z) & 
      !                     down to left (-R,-Z)
      !    thl(i)=90.0d0 -- vertical orientation

      !  **CAUTION TRANSP USERS** in TRANSP limiters theta=45.0d is up and to
      !  the left (-R,+Z). -- this is a different convention ***

      !  each line partitions space into two regions, from one of which the
      !  plasma is excluded.  Using (R0,Z0) to test, a sign value is assigned
      !  which determines which half plane is excluded.

      !  the result:  excluded space = union of all excluded spaces of
      !                 individual circle/line "limiters".

      !               included space = all space - excluded space

      !  the plasma boundary must lie entirely inside the included space.
      !  this routine test for this-- if this test fails the error flag is
      !  set.

      !  plasma boundary should never intersect a circle limiter; this is
      !  tested and reported as an error of the plasma 0.95 surface crosses.

      !-------------------------------
      real*8 :: zR0,zZ0
      real*8 :: zRmin_plasma,zRmax_plasma,zZmin_plasma,zZmax_plasma
      real*8 :: zRmin_use,zRmax_use,zZmin_use,zZmax_use,zdist_use
      real*8, parameter :: zrho_bdy = 1.0d0
      integer :: icircs,ilines,ilin,ilocmmx
      real*8, dimension(:), allocatable :: zZl,zRl,zthl

      real*8, parameter :: zsmall = 0.01d0 ! 1cm
      real*8, parameter :: zbig = 100.00d0 ! 100 meters

      integer :: idata(7),ir8size,itype,id,iertmp,id_R,i,j
      real*8, dimension(:), allocatable :: r8data

      integer, parameter :: isrch=300
      real*8 :: rsrch(isrch),zsrch(isrch),zswrk(isrch),zphwrk(isrch)
      real*8 :: zdist(isrch),zdum1(isrch),zdum2(isrch),zdum3(isrch)
      real*8 :: zR0_srch,zZ0_srch,zRmin_srch,zRmax_srch,zZmin_srch,zZmax_srch
      real*8 :: zdistRmin,zdistRmax,zdistZmin,zdistZmax
      real*8 :: zincr
      !-------------------------------

      ier=0
      iwarn=0

      !  set warning flag if something named "__LIMITER" already exists.

      call xplasma_find_item(s,'__LIMITER',id,iertmp, nf_noerr=.TRUE.)
      if(id.ne.0) iwarn=1

      call xplasma_mag_axis(s,ier, zR0, zZ0)
      if(ier.ne.0) then
         ier=3001
         call xplasma_errmsg_append(s, &
              ' ?xplasma_mklim_special: could not get (R0,Z0).')
         return
      endif

      call xplasma_RZminmax(s, zrho_bdy, ier, &
           Rmin=zRmin_plasma, Rmax=zRmax_plasma, &
           Zmin=zZmin_plasma, Zmax=zZmax_plasma)
      if(ier.ne.0) then
         ier=3001
         call xplasma_errmsg_append(s, &
              ' ?xplasma_mklim_special: could not get R & Z min & max at plasma bdy.')
         return
      endif

      zR0_srch=(zRmin_plasma+zRmax_plasma)/2
      zZ0_srch=(zZmin_plasma+zZmax_plasma)/2

      !  check consistency of optional arguments
      if(present(ncircs)) then
         if(ncircs.lt.0) then
            ier=3002
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_mklim_special: ncircs < 0.')
         else if(ncircs.gt.0) then
            if(.not.(present(Rc).and.present(Zc).and.present(rad))) then
               ier=3002
               call xplasma_errmsg_append(s, &
                    ' ?xplasma_mklim_special: if ncircs is present, then')
               call xplasma_errmsg_append(s, &
                    '   Rc, Zc, and rad arrays must also be present.')
            else
               if(min(size(Rc),size(Zc),size(rad)).lt.ncircs) then
                  ier=3002
                  call xplasma_errmsg_append(s, &
                       ' ?xplasma_mklim_special: if ncircs is present, then')
                  call xplasma_errmsg_append(s, &
                       '   Rc, Zc, and rad array sizes must all be >= ncircs.')
               endif
            endif
         endif
      else
         if(present(Rc).or.present(Zc).or.present(rad)) then
            ier=3002
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_mklim_special: if ncircs is absent, then')
            call xplasma_errmsg_append(s, &
                 '  array arguments Rc, Zc, and rad must also all be absent.')
         endif
      endif

      if(present(nlines)) then
         if(nlines.lt.0) then
            ier=3002
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_mklim_special: nlines < 0.')
         else if(nlines.gt.0) then
            if(.not.(present(Rl).and.present(Zl).and.present(thl))) then
               ier=3002
               call xplasma_errmsg_append(s, &
                    ' ?xplasma_mklim_special: if nlines is present, then')
               call xplasma_errmsg_append(s, &
                    '   Rl, Zl, and thl arrays must also be present.')
            else
               if(min(size(Rl),size(Zl),size(thl)).lt.nlines) then
                  ier=3002
                  call xplasma_errmsg_append(s, &
                       ' ?xplasma_mklim_special: if nlines is present, then')
                  call xplasma_errmsg_append(s, &
                       '   Rl, Zl, and thl array sizes must all be >= nlines.')
               endif
            endif
         endif
      else
         if(present(Rl).or.present(Zl).or.present(thl)) then
            ier=3002
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_mklim_special: if nlines is absent, then')
            call xplasma_errmsg_append(s, &
                 '  array arguments Rl, Zl, and thl must also all be absent.')
         endif
      endif
      if(ier.ne.0) return

      !------------------------------------------------------------
      !  set default values; get optional inputs as provided

      !  dist < 0 means: use circles & lines limiters only...

      zdist_use=-1.0d0
      if(present(dist)) zdist_use = dist
      if(zdist_use.lt.0.0d0) zdist_use=-1.0d0

      !  provided "sanity limiters" to guarantee a bounded space
      !  in case user's lines and circles do not enclose plasma...
      !     these are expressed here in terms of R & Z min & max but
      !     will be turned into line limiters below...

      if(present(Rmin)) then
         zRmin_use=Rmin
      else
         zRmin_use=zsmall ! 1cm from machine axis
      endif

      if(present(Rmax)) then
         zRmax_use=Rmax
      else
         zRmax_use=zRmax_plasma + zbig
      endif

      if(present(Zmin)) then
         zZmin_use=Zmin
      else
         zZmin_use=zZmin_plasma - zbig
      endif

      if(present(Zmax)) then
         zZmax_use=Zmax
      else
         zZmax_use=zZmax_plasma + zbig
      endif

      ! circle limiters...
      icircs = 0
      if(present(ncircs)) icircs=ncircs

      ! line limiters
      ilines = 4
      if(present(nlines)) ilines=nlines+4

      allocate(zZl(ilines),zRl(ilines),zthl(ilines))
      if(ilines.gt.4) then
         zZl(1:nlines)=Zl(1:nlines)
         zRl(1:nlines)=Rl(1:nlines)
         zthl(1:nlines)=thl(1:nlines)
      endif

      ! box limiters -- horizontal and vertical lines...

      ilin = ilines-3
      zZl(ilin)=0.0d0
      zRl(ilin)=zRmin_use
      zthl(ilin)=90.0d0

      ilin = ilines-2
      zZl(ilin)=0.0d0
      zRl(ilin)=zRmax_use
      zthl(ilin)=90.0d0

      ilin = ilines-1
      zZl(ilin)=zZmin_use
      zRl(ilin)=0.0d0
      zthl(ilin)=0.0d0

      ilin = ilines
      zZl(ilin)=zZmax_use
      zRl(ilin)=0.0d0
      zthl(ilin)=0.0d0

      !--------------------------------------------
      !  OK -- set up limiter data

      idata(1)=1                ! address of lines data
      idata(2)=1 + 6*ilines     ! address of circles data
      idata(3)=idata(2)+4*icircs           ! address of distance data
      idata(4)=ilines           ! #lines
      idata(5)=icircs           ! #circs, can be zero
      idata(6)=0                ! set =1 for plasma bdy as limiter

      ir8size = 6*ilines + 4*icircs + 1

      ilocmmx = ir8size+1
      idata(7)=ilocmmx

      itype = 101

      allocate(r8data(ir8size+4)); r8data = 0

      r8data(idata(3)) = -1.0d0  ! no distance information yet

      call eqi_tbdy_lines(r8data(idata(1)),ilines,zRl,zZl,zthl,zR0,zZ0)
      if(icircs.gt.0) then
         call eqi_tbdy_circs(r8data(idata(2)),icircs,Rc,Zc,rad,zR0,zZ0)
      endif

      !----------------------------------------------
      !  find approximate min and max of vacuum region--
      !  scan in vicinity of sample plasma; cast a wide net though...

      zincr = zR0_srch/1000

      zRmax_srch=3*zR0_srch
      zRmin_srch=zRmax_srch/isrch

      zZmin_srch=zZ0_srch-3*zR0_srch
      zZmax_srch=zZ0_srch+3*zR0_srch

      do i=1,isrch
         rsrch(i)=((isrch-i)*zRmin_srch + (i-1)*zRmax_srch)/(isrch-1)
         zsrch(i)=((isrch-i)*zZmin_srch + (i-1)*zZmax_srch)/(isrch-1)
         zphwrk(i)=0
      enddo

      !  reuse these variables...

      zRmin_srch=1.0d30
      zRmax_srch=-zRmin_srch

      zZmin_srch=1.0d30
      zZmax_srch=-zZmin_srch

      do j=1,isrch
         zswrk=zsrch(j)  ! one z value for rsrch(1:isrch)
         call eqi_rzdist(isrch,rsrch,zswrk,zphwrk,zdist, &
              itype,idata,r8data, &
              0,zdum1,zdum2,zdum3,ier)
         do i=1,isrch
            if(zdist(i).lt.0.0d0) then
               ! point is inside all limiters...

               if(rsrch(i).lt.zRmin_srch) then
                  zRmin_srch=rsrch(i)
                  zdistRmin=-zdist(i)
               else if(rsrch(i).eq.zRmin_srch) then
                  zdistRmin=max(zdistRmin,-zdist(i))
               endif

               if(rsrch(i).gt.zRmax_srch) then
                  zRmax_srch=rsrch(i)
                  zdistRmax=-zdist(i)
               else if(rsrch(i).eq.zRmax_srch) then
                  zdistRmax=max(zdistRmax,-zdist(i))
               endif

               if(zswrk(i).lt.zZmin_srch) then
                  zZmin_srch=zswrk(i)
                  zdistZmin=-zdist(i)
               else if(zswrk(i).eq.zZmin_srch) then
                  zdistZmin=max(zdistZmin,-zdist(i))
               endif

               if(zswrk(i).gt.zZmax_srch) then
                  zZmax_srch=zswrk(i)
                  zdistZmax=-zdist(i)
               else if(zswrk(i).eq.zZmax_srch) then
                  zdistZmax=max(zdistZmax,-zdist(i))
               endif

            endif
         enddo
      enddo

      r8data(ilocmmx)=max(zRmin_use,(zRmin_srch-zdistRmin-zincr))
      r8data(ilocmmx+1)=min(zRmax_use,(zRmax_srch+zdistRmax+zincr))
      r8data(ilocmmx+2)=max(zZmin_use,(zZmin_srch-zdistZmin-zincr))
      r8data(ilocmmx+3)=min(zZmax_use,(zZmax_srch+zdistZmax+zincr))

      !----------------------------------------------
      !  insert distance information

      r8data(idata(3)) = zdist_use

      !----------------------------------------------
      !  create limiter dataset "black box"...

      call xplasma_author_set(s,xplasma_root,iertmp)

      call xplasma_create_blackbox(s,'__LIMITER',itype,id,ier, &
           iarray=idata, r8array=r8data, &
           label='axisymmetrix limiter data')

      call xplasma_author_clear(s,xplasma_root,iertmp)

      if(ier.ne.0) then
         call xplasma_errmsg_append(s, &
              ' xplasma_mklim_special: "__LIMITER" create failure.')
      endif

      deallocate(r8data)

      call xplasma_common_ids(s,iertmp, id_R)
      if(id_R.gt.0) then
         call xplasma_limcheck(s,ier)
      endif

    end subroutine xplasma_mklim_special

    !==========================================================
    subroutine xplasma_lim_info(s,ier, &
         itype, npts,rpts,zpts, &
         dist, &
         nlines, Rl, Zl, thl, &
         ncircs, Rc, Zc, rad)

      ! retrieve limiter information

      type(xplasma), pointer :: s
      integer, intent(out) :: ier

      integer, intent(out), optional :: itype
      !  itype=100 means piecewise linear closed contour (axisymmetric limiter)
      !  itype=101 means list of circles & infinite lines

      integer, intent(out), optional :: npts ! #pts in contour (itype=100 only)

      real*8, dimension(:), intent(out), optional :: rpts,zpts
      !  the closed contour; rpts(npts)=rpts(1) and zpts(npts)=zpts(1) (m).

      real*8, intent(out), optional :: dist  ! itype=101 limiters only...
      !  if .ge.0.0d0, the plasma boundary + dist is considered a limiter
      !  if .lt.0.0d0-- no plasma boundary based limiter.

      integer, intent(out), optional :: nlines  ! #lines in itype=101 limiter
      real*8, dimension(:), intent(out), optional :: Rl,Zl,thl
      !  point (m) through which line passes, and line orientation in DEGREES
      !  e.g. 45.0 means up and to the right...

      integer, intent(out), optional :: ncircs ! #circles in itype=101 limiter
      real*8, dimension(:), intent(out), optional :: Rc,Zc,rad
      !  center location and radius of each circle (m)

      !-------------------------------------------------------
      integer :: idlim,ilines,icircs,jtype,iadrl,iadrc,iadist,isize_min
      integer :: iadr,iadz,i
      character*128 zmsg
      integer, dimension(:), pointer :: iwork
      real*8, dimension(:), pointer :: r8work
      real*8 :: zargr,zargz,zarg3
      !-------------------------------------------------------

      if(present(itype)) itype=0

      if(present(npts)) npts=0
      if(present(rpts)) rpts=0
      if(present(zpts)) zpts=0

      if(present(dist)) dist=0

      if(present(nlines)) nlines=0
      if(present(Rl)) Rl=0
      if(present(Zl)) Zl=0
      if(present(thl)) thl=0

      if(present(nlines)) nlines=0
      if(present(Rc)) Rc=0
      if(present(Zc)) Zc=0
      if(present(rad)) rad=0

      call xplasma_find_item(s,'__LIMITER',idlim,ier,nf_noerr=.TRUE.)
      if(ier.ne.0) return

      if(idlim.eq.0) then
         ier=3004          ! no __LIMITER object found.
         return
      endif

      !----------------------------------
      !  get limiter information

      call xplasma_blackBox_retrieve(s,idlim,ier, &
           itype=jtype, ia_ptr=iwork, r8a_ptr=r8work)

      if(present(itype)) itype=jtype

      iadrl =iwork(1)
      ilines=iwork(4)

      iadist=iwork(3)

      iadrc =iwork(2)
      icircs=iwork(5)

      !----------------------------------

      if(jtype.eq.100) then

         if(present(npts)) npts=ilines

         isize_min=ilines
         if(present(rpts)) isize_min=min(isize_min,size(rpts))
         if(present(zpts)) isize_min=min(isize_min,size(zpts))

         if(isize_min.lt.ilines) then
            ier=510
            zmsg=' '
            write(zmsg,*) ' ?xplasm_lim_info:  there are ',ilines,' limiter data points.'
            call xplasma_errmsg_append(s,zmsg)
            zmsg=' '
            write(zmsg,*) '  but the output vector size provided is just ',isize_min,'.'
            call xplasma_errmsg_append(s,zmsg)

         else

            iadr=-5
            iadz=-4
            do i=1,ilines-1
               iadr = iadr + 6
               iadz = iadz + 6
               if(present(rpts)) rpts(i)=r8work(iadr)
               if(present(zpts)) zpts(i)=r8work(iadz)
            enddo
            if(present(rpts)) rpts(ilines)=rpts(1)
            if(present(zpts)) zpts(ilines)=zpts(1)
         endif

      else if(jtype.eq.101) then

         if(present(nlines)) nlines=ilines
         if(present(ncircs)) ncircs=icircs

         if(present(dist)) dist = r8work(iadist)

         isize_min=ilines
         if(present(Rl)) isize_min=min(isize_min,size(Rl))
         if(present(Zl)) isize_min=min(isize_min,size(Zl))
         if(present(thl)) isize_min=min(isize_min,size(thl))

         if(isize_min.lt.ilines) then
            ier=510
            zmsg=' '
            write(zmsg,*) ' ?xplasm_lim_info:  there are ',ilines,' limiter lines.'
            call xplasma_errmsg_append(s,zmsg)
            zmsg=' '
            write(zmsg,*) '  but the output vector size provided is just ',isize_min,'.'
            call xplasma_errmsg_append(s,zmsg)

         else
            iadr=-5
            do i=1,ilines
               iadr=iadr+6
               call linparse(r8work(iadr:iadr+5),zargR,zargZ,zarg3)
               if(present(Rl)) Rl(i)=zargR
               if(present(Zl)) Zl(i)=zargZ
               if(present(thl)) thl(i)=zarg3
            enddo

         endif

         isize_min=icircs
         if(present(Rc)) isize_min=min(isize_min,size(Rc))
         if(present(Zc)) isize_min=min(isize_min,size(Zc))
         if(present(rad)) isize_min=min(isize_min,size(rad))

         if(isize_min.lt.icircs) then
            ier=510
            zmsg=' '
            write(zmsg,*) ' ?xplasm_lim_info:  there are ',icircs,' limiter circles.'
            call xplasma_errmsg_append(s,zmsg)
            zmsg=' '
            write(zmsg,*) '  but the output vector size provided is just ',isize_min,'.'
            call xplasma_errmsg_append(s,zmsg)

         else
            iadr=-3
            do i=1,icircs
               iadr=iadr+4
               call cirparse(r8work(iadr:iadr+3),zargR,zargZ,zarg3)
               if(present(Rc)) Rc(i)=zargR
               if(present(Zc)) Zc(i)=zargZ
               if(present(rad)) rad(i)=zarg3
            enddo

         endif

      endif

      nullify(iwork,r8work)

      contains
        subroutine linparse(zdata,Rpt,Zpt,ang_degrees)
          real*8,intent(in) :: zdata(6)
          real*8,intent(out) :: Rpt,Zpt,ang_degrees ! reference pt & angle

          real*8 zang_rad

          Rpt=zdata(1)
          Zpt=zdata(2)
          zang_rad=atan2(-zdata(3),zdata(4))
          ang_degrees=360.00d0*zang_rad/6.2831853071795862D+00

        end subroutine linparse

        subroutine cirparse(zdata,Rc,Zc,radius)
          real*8,intent(in) :: zdata(4)
          real*8,intent(out) :: Rc,Zc,radius  ! center & radius of circle

          Rc=zdata(1)
          Zc=zdata(2)
          radius=zdata(3)

        end subroutine cirparse

    end subroutine xplasma_lim_info
    !==========================================================

    subroutine xplasma_lim_rzminmax(s,zRmin,zRmax,zZmin,zZmax,ier, &
         itype)

      !  get the Rmin,Rmax,Zmin,Zmax of the vacuum region
      !  enclosed by the mechanical limiter
      !    optional: get a limiter type code also.

      type (xplasma), pointer :: s

      real*8, intent(out) :: zRmin,zRmax,zZmin,zZmax  ! R & Z min & max (m)

      integer, intent(out) :: ier

      integer, intent(out), optional :: itype  ! limiter representation
      ! within xplasma: 100 for piecewise contour; 101 for "circles and
      ! lines" possibly augmented by a fixed distance from the plasma
      ! boundary.

      !------------------------------------------
      integer :: idlim,ilocmmx,jtype
      integer, dimension(:), pointer :: iwork
      real*8, dimension(:), pointer :: r8work
      !------------------------------------------

      zRmin = 0; zRmax = 0; zZmin = 0; zZmax = 0

      call xplasma_find_item(s,'__LIMITER',idlim,ier,nf_noerr=.TRUE.)
      if(ier.ne.0) return

      if(idlim.eq.0) then
         ier=3004          ! no __LIMITER object found.
         return
      endif

      !----------------------------------
      !  get limiter information

      call xplasma_blackBox_retrieve(s,idlim,ier, &
           itype=jtype, ia_ptr=iwork, r8a_ptr=r8work)

      if(present(itype)) itype=jtype

      ilocmmx=iwork(7)

      zRmin=r8work(ilocmmx)
      zRmax=r8work(ilocmmx+1)
      zZmin=r8work(ilocmmx+2)
      zZmax=r8work(ilocmmx+3)

      nullify(iwork,r8work)

    end subroutine xplasma_lim_rzminmax

    !==========================================================

    subroutine xplasma_limcheck(s,ier, rho_check)

      !  check if plasma boundary intersects mechanical limiter as 
      !  specified...

      type (xplasma), pointer :: s
      integer, intent(out) :: ier

      real*8, intent(in), optional :: rho_check

      !----------------------------------
      integer :: idlim  ! id of limiter object (must exist)
      real*8, parameter :: zrhomin = 0.9d0
      real*8, parameter :: zrhomax = 1.0d0
      real*8 :: zrho    ! rho of surface to use for testing
      integer :: id_R,id_Z,id2(2),ith

      integer, parameter :: intest=201
      real*8 :: zrho_test(intest),zth_test(intest),zRZ(intest,2),zdist(intest)
      real*8 :: zphiang(intest),zdum1(intest),zdum2(intest),zdum3(intest)
      real*8 :: zdist_max
      integer :: idist_max

      real*8, parameter :: C2PI = 6.2831853071795862D+00

      integer :: itype
      integer, dimension(:), pointer :: iwork
      real*8, dimension(:), pointer :: r8work
      character*128 zmsg
      !----------------------------------

      ier = 0

      zrho = xplasma_rho_limcheck   ! the default
      if(present(rho_check)) then
         zrho = max(zrhomin,min(zrhomax,rho_check))
      endif

      call xplasma_find_item(s,'__LIMITER',idlim,ier,nf_noerr=.TRUE.)
      if(ier.ne.0) return

      if(idlim.eq.0) then
         ier=3004          ! no __LIMITER object found.
         return
      endif

      call xplasma_common_ids(s,ier, id_R=id_R,id_Z=id_Z)
      if(ier.ne.0) return

      if(min(id_R,id_Z).eq.0) then
         ier=3005          ! no flux surfaces found.
         return
      endif

      !----------------------------------
      !  OK the needed data is available.  Get the specified flux surface...
      !  Direct R & Z profile evaluation is done, although a coordinate
      !  transform routine could just as well have been used...

      id2(1)=id_R
      id2(2)=id_Z

      do ith=1,intest
         zrho_test(ith)=zrho
         zth_test(ith)=(ith-1)*C2PI/(intest-1)
         zphiang(ith)=0
      enddo

      call xplasma_RZeval_2d(s,id2, &
           xplasma_theta_coord,zth_test, xplasma_rho_coord,zrho_test, &
           zRZ,ier)

      if(ier.ne.0) return

      !----------------------------------
      !  get limiter information

      call xplasma_blackBox_retrieve(s,idlim,ier, &
           itype=itype, ia_ptr=iwork, r8a_ptr=r8work)

      if(ier.ne.0) then
         nullify(iwork,r8work)
         return
      endif

      !  treat as pure mechanical limiter, i.e. ignore plasma boundary
      !  based limiter specification for now

      !  this routine checks mechanical limiter components only, in 
      !  calculating the distance...

      call eqi_rzdist(intest,zRZ(1:intest,1),zRZ(1:intest,2),zphiang, &
           zdist,itype,iwork,r8work, &
           0,zdum1,zdum2,zdum3,ier)

      if(ier.ne.0) then
         call xplasma_errmsg_append(s, &
              ' ?xplasma_limcheck: error in eqi_rzdist call!')
         nullify(iwork,r8work)
         return
      endif

      idist_max=0
      zdist_max=-1.0d30

      do ith=1,intest
         if(zdist(ith).gt.zdist_max) then
            zdist_max=zdist(ith)
            idist_max=ith
         endif
      enddo

      if(zdist_max.gt.0.0) then
         ier=3003
         zmsg=' '
         write(zmsg,*) '  at rho=',zrho,' theta=',zth_test(idist_max)
         call xplasma_errmsg_append(s,zmsg)
         zmsg=' '
         write(zmsg,*) '  location R=',zRZ(idist_max,1),' Z=',zRZ(idist_max,2)
         call xplasma_errmsg_append(s,zmsg)
         zmsg=' '
         write(zmsg,*) '  plasma interior point outside limiter by ', &
              zdist_max,' meters.'
         call xplasma_errmsg_append(s,zmsg)
      endif

      nullify(iwork,r8work)

    end subroutine xplasma_limcheck

    subroutine xplasma_bdycon(s,rbdy,zbdy,ier)

      !  return a closed contour around the plasma boundary, similar to
      !  xplasma_limcon...

      type (xplasma), pointer :: s

      real*8, dimension(:), intent(out) :: rbdy,zbdy  ! bdy contour
      !  the sizes of these vectors must be the same.

      integer, intent(out) :: ier

      !-------------
      integer :: id_thetax,id_R,ith,inth,isize,indx
      real*8 :: zindx,zfac
      real*8, dimension(:),allocatable :: thetax,rho_use,th_use
      real*8, parameter :: ONE=1.0d0
      real*8, parameter :: ZERO=0.0d0
      !-------------

      call xplasma_find_item(s,'__THETAX',id_thetax,ier,nf_noerr=.TRUE.)
      if(ier.ne.0) return

      isize=size(rbdy)
      if(isize.ne.size(zbdy)) then
         ier=510
         call xplasma_errmsg_append(s, &
              ' ?xplasma_bdycon: size of "rbdy" and "zbdy" vectors must match.')
         return
      endif

      if(id_thetax.eq.0) then
         call xplasma_find_item(s,'R',id_R,ier)
         if(ier.ne.0) return

         call xplasma_prof_info(s,id_R,ier, gridId1=id_thetax)
         if(ier.ne.0) return
      endif

      call xplasma_grid_size(s,id_thetax,inth,ier)
      if(ier.ne.0) return

      allocate(thetax(inth),rho_use(isize),th_use(isize))

      call xplasma_grid(s,id_thetax,thetax,ier)
      if(ier.ne.0) return

      !  here the thetax grid is used, to take advantage of possible
      !  uneven spacing that might compensate for distortion of theta
      !  with respect to arclength along the plasma boundary

      rho_use=ONE
      th_use(1)=thetax(1)
      th_use(isize)=thetax(inth)
      do ith=2,isize-1
         zindx=ONE+(ith-1)*(inth-ONE)/(isize-1)
         indx=zindx
         indx=max(1,min(inth-1,indx))
         zfac=zindx-indx
         zfac=max(ZERO,min(ONE,zfac))
         th_use(ith)=thetax(indx)+zfac*(thetax(indx+1)-thetax(indx))
      enddo

      call xplasma_ctrans(s,.TRUE.,ier, &
           rho_in=rho_use, theta_in=th_use, r_out=rbdy, z_out=zbdy)

      deallocate(thetax,rho_use,th_use)

    end subroutine xplasma_bdycon

    subroutine xplasma_limcon(s,rlim,zlim,inum_got,ier, &
         tol,maptype)

      !  return a closed contour of length size(rlim)=size(zlim) or less
      !  describing the limiter.

      !  if tol.le.0.0d0 -- the length of the description is size(rlim) exactly
      !  if tol.gt.0.0d0 -- length may be shortened to remove colinear points.
      !      also, if the limiter was originally given in contour form, and,
      !      size(rlim) is sufficient, the original specification will be
      !      returned.

      type (xplasma), pointer :: s

      real*8, dimension(:), intent(out) :: rlim,zlim  ! limiter contour
      !  the sizes of these vectors must be the same.
      !  unless the original specification is being returned, the code
      !  requires a minimum size of 30 points.

      integer, intent(out) :: inum_got     ! contour length returned
      !  if inum_got.lt.size(rlim), rlim(inum_got+1:size(rlim))=0 on exit.
      !  similarly for zlim.

      integer, intent(out) :: ier  ! status code, 0=OK

      real*8, intent(in), optional :: tol  ! tolerance specification
      !  if zero or negative, no shortening of the limiter description is
      !  attempted.  If .gt. 0.0, adjacent segments that are colinear to within
      !  tol*[Rmax] are replaced by a single segment.  DEFAULT: s%bdytol

      integer, intent(in), optional :: maptype  ! mapping option
      !  1=slowest but most exact; 2=intermediate; 3=bilinear interpolation
      !  2 or 3 recommended.  DEFAULT: 2

      !----------------------------------
      integer :: idlim  ! id of limiter object (must exist)

      real*8, parameter :: C2PI = 6.2831853071795862D+00

      logical :: icopy
      integer :: itype,ipts,imaptype,isize,i,ibase
      integer, dimension(:), pointer :: iwork
      real*8, dimension(:), pointer :: r8work
      real*8 :: ztol,zbdy_tol,zrmax
      character*128 zmsg

      real*8, dimension(:), allocatable :: ra,za,da,phia, rb,zb,db,phib
      real*8, dimension(:), allocatable :: rx,zx,phix
      real*8 :: lperp(2),lnorm,dtest
      integer, dimension(:), allocatable :: istat
      !----------------------------------

      ier = 0

      inum_got = 0
      rlim = 0
      zlim = 0

      call xplasma_find_item(s,'__LIMITER',idlim,ier,nf_noerr=.TRUE.)
      if(ier.ne.0) return

      if(idlim.eq.0) then
         ier=3004          ! no __LIMITER object found.
         return
      endif

      if(size(rlim).ne.size(zlim)) then
         ier=510
         call xplasma_errmsg_append(s,' in xplasma_limcon:')
         call xplasma_errmsg_append(s, &
              ' sizes of "Rlim" and "Zlim" vector arguments do not match.')
         return
      endif

      !----------------------------------
      !  handle optional arguments; set defaults...

      call xs_max_maptype(s,imaptype,ier)
      if(ier.ne.0) return

      if(present(maptype)) then
         imaptype=max(1,min(imaptype,maptype))
      else
         imaptype=2
      endif

      call xplasma_global_info(s,ier,bdytol=zbdy_tol)
      ztol=zbdy_tol
      if(present(tol)) ztol=tol
      ztol=min(1.0d-5,ztol)

      !----------------------------------
      !  get limiter information

      call xplasma_blackBox_retrieve(s,idlim,ier, &
           itype=itype, ia_ptr=iwork, r8a_ptr=r8work)

      if(ier.ne.0) then
         nullify(iwork,r8work)
         return
      endif

      !----------------------------------
      !  see if we can just copy the original contour...

      icopy=.False.
      if(itype.eq.100) then
         ipts=iwork(4)
         if(size(rlim).eq.ipts) then
            icopy=.TRUE.
         else if((ztol.gt.0.0d0).and.(size(rlim).ge.ipts)) then
            icopy=.TRUE.
         endif
      endif

      if(icopy) then

         inum_got = ipts
         call xplasma_lim_info(s,ier, rpts=rlim(1:ipts), zpts=zlim(1:ipts))
         return

      endif

      !----------------------------------
      !  OK -- need to probe for limiter location...

      if(size(rlim).lt.30) then
         ier=510
         call xplasma_errmsg_append(s,' in xplasma_limcon:')
         call xplasma_errmsg_append(s, &
              ' sizes of "Rlim" and "Zlim" vector arguments too small, need at least 30 pts.')
         return
      endif

      !----------------------------------

      isize=size(rlim)

      allocate(ra(isize),za(isize),da(isize),phia(isize))
      allocate(rb(isize),zb(isize),db(isize),phib(isize))
      allocate(rx(isize),zx(isize),phix(isize),istat(isize))

      sp => s

      do
         call eqi_bprobe(isize,2,imaptype,ra,za,da,rb,zb,db,ier)
         if(ier.ne.0) exit

         phia=0
         phib=0

         call xplasma_fxcep(s,2, &
              ra,za,phia, rb,zb,phib, rx,zx,phix, istat,ier, &
              maptype=imaptype, tol=zbdy_tol, da_input=da, db_input=db)
         if(ier.ne.0) exit

         if(ztol.le.0.0d0) then

            inum_got=isize
            rlim=rx
            zlim=zx
            ier=0
            exit

         endif

         ! remove colinear points...

         ibase=1
         inum_got=1

         zrmax=maxval(rx)

         rlim(1)=rx(1)
         zlim(1)=zx(1)

         do i=3,isize

            ! colinearity test of point (i-1) w.r.t. (ibase) and (i)

            lperp(1)=-(zx(ibase+1)-zx(ibase))
            lperp(2)=(rx(ibase+1)-rx(ibase))
            lnorm=sqrt(lperp(1)**2+lperp(2)**2)
            lperp=lperp/lnorm

            dtest=lperp(1)*(rx(i)-rx(ibase))+ lperp(2)*(zx(i)-zx(ibase))

            if(abs(dtest).gt.ztol*zrmax) then

               ! not sufficiently colinear; add to sequence & update base

               ibase = i-1
               inum_got = inum_got + 1
               rlim(inum_got)=rx(ibase)
               zlim(inum_got)=zx(ibase)

            endif
         enddo

         !  add in last point; matches 1st point

         inum_got = inum_got + 1
         rlim(inum_got) = rlim(1)
         zlim(inum_got) = zlim(1)
         ier = 0
         exit
      enddo

      deallocate(ra,za,phia,rb,zb,phib,da,db,rx,zx,phix)
      nullify(iwork,r8work)

    end subroutine xplasma_limcon

    subroutine xplasma_lim_dist1(s,r,z,d,ier, maptype, rlim1,zlim1)

      !  scalar version of xplasma_lim_distn -- axisymmetry assumed.

      type (xplasma), pointer :: s
      real*8, intent(in) :: R,Z      ! input location (m)
      real*8, intent(out) :: d       ! output distance from nearest point
      !                                on limiter or wall (m).

      integer, intent(out) :: ier

      integer, intent(in), optional :: maptype  ! see xplasma_lim_distn
      real*8, intent(out), optional :: rlim1,zlim1  ! nearest limiter point

      !-----------------------

      real*8 :: rvec(1),zvec(1),dist(1),rlim(1),zlim(1)

      rvec = R
      zvec = Z

      call xplasma_lim_distn(s,rvec,zvec,dist,ier, &
           maptype=maptype, rlim=rlim, zlim=zlim)

      d = dist(1)
      if(present(rlim1)) rlim1=rlim(1)
      if(present(zlim1)) zlim1=zlim(1)

    end subroutine xplasma_lim_dist1

    subroutine xplasma_lim_distn(s,rvec,zvec,dist,ier, &
         maptype,rlim,zlim)

      !  find distance from each element of a vector of (R,Z) pairs
      !  to the nearest point on a limiter.

      !  optionally return the location of that point on the limiter
      !  in (R,Z).

      !  the routine assumes axisymmetry.  Optional phi arguments may
      !  be added someday.

      type (xplasma), pointer :: s
      real*8, intent(in), dimension(:) :: rvec,zvec  ! (R,Z) input vector

      real*8, intent(out), dimension(:) :: dist      ! distance values returned
      integer, intent(out) :: ier

      integer, intent(in), optional :: maptype       ! distance map option
      ! if it is required to compute the distance from the (R,Z) point to 
      ! the plasma boundary, this specifies the option (for xplasma_bdfind).
      !   Default is the circle-fit option (2).  (1) is slower but more
      ! precise; (3) is less accurate but would be faster if a bilinear
      ! distance map has already been computed.

      real*8, intent(out), dimension(:), optional :: rlim,zlim  ! locations
      !                      of nearest contact points on limiter, for each
      !                      input location.
      !-----------------------------------------------------------
      real*8 :: phitmp1(size(rvec)),phitmp2(size(rvec))
      real*8 :: rhotmp(size(rvec)),thtmp(size(rvec)),dtmp(size(rvec))
      integer :: idlim,id_R,id_Z,itype,isize,isize_min,isize_max,ictrz,ipdist
      real*8 :: plasma_lim,delR,delZ,dnorm
      integer :: imap_type,j,jvec,ids(4),idchis(4)
      integer, dimension(:), pointer :: iwork
      real*8, dimension(:), pointer :: r8work
      real*8, dimension(:,:), allocatable :: zrzbuf
      !-----------------------------------------------------------

      call xplasma_find_item(s,'__LIMITER',idlim,ier,nf_noerr=.TRUE.)
      if(ier.ne.0) return

      if(idlim.eq.0) then
         ier=3004          ! no __LIMITER object found.
         return
      endif

      call xplasma_common_ids(s,ier, id_R=id_R,id_Z=id_Z)
      if(ier.ne.0) return

      if(min(id_R,id_Z).eq.0) then
         ier=3005          ! no flux surfaces found.
         return
      endif

      !----------------------------------
      !  OK data is available...

      isize=size(rvec)
      isize_min=isize
      isize_max=isize

      isize_min=min(isize_min,size(zvec))
      isize_min=min(isize_min,size(dist))

      isize_max=max(isize_max,size(zvec))
      isize_max=max(isize_max,size(dist))

      ictrz=0

      if(present(rlim)) then
         ictrz=ictrz+1
         isize_min=min(isize_min,size(rlim))
         isize_max=max(isize_max,size(rlim))
      endif

      if(present(zlim)) then
         ictrz=ictrz+1
         isize_min=min(isize_min,size(zlim))
         isize_max=max(isize_max,size(zlim))
      endif

      if((isize_min.ne.isize_max).or.(ictrz.eq.1)) then
         ier=510
         if(isize_min.ne.isize_max) call xplasma_errmsg_append(s, &
              ' input/output vector sizes not consistent in xplasma_lim_distance call.')
         if(ictrz.eq.1) call xplasma_errmsg_append(s, &
              ' if one of the optional vectors {rlim,zlim} are present, both must be present.')
         return
      endif

      !----------------------------------
      !  get limiter information

      call xplasma_blackBox_retrieve(s,idlim,ier, &
           itype=itype, ia_ptr=iwork, r8a_ptr=r8work)

      if(ier.ne.0) then
         nullify(iwork,r8work)
         return
      endif

      !  first: treat as pure mechanical limiter, i.e. ignore plasma boundary
      !  based limiter specification for now

      !  this routine checks mechanical limiter components only, in 
      !  calculating the distance...

      phitmp1=0
      if(ictrz.gt.0) then
         call eqi_rzdist(isize,rvec,zvec,phitmp1, &
              dist,itype,iwork,r8work, &
              1,rlim,zlim,phitmp2,ier)
      else
         call eqi_rzdist(isize,rvec,zvec,phitmp1, &
              dist,itype,iwork,r8work, &
              0,phitmp2,phitmp2,phitmp2,ier)
      endif

      !  see if a limiter based on plasma boundary location is specified

      plasma_lim = -1.0d0

      if(itype.eq.101) then
         plasma_lim = r8work(iwork(3))
      endif

      if(plasma_lim.lt.0.0d0) return

      !------------------------
      !  a plasma boundary based limiter IS specified...

      imap_type=2
      if(present(maptype)) imap_type=max(1,min(3,maptype))
      if(imap_type.eq.3) call xs_max_maptype(s,imap_type,ier)

      call xplasma_bdfind(s,isize,rvec,zvec,ier, &
           maptype=maptype, theta_out=thtmp, dist=dtmp)

      dtmp = dtmp - plasma_lim  ! distance to limiter, not bdy...

      ! points j for which dtmp(j) > dist(j) [from mechanical limiters]
      ! are situated such that the plasma based limiter is the one closest
      ! to the plasma, i.e. the one to count.

      if(ictrz.eq.0) then
         do j=1,isize
            if(dtmp(j).gt.dist(j)) then
               dist(j)=dtmp(j)
            endif
         enddo
         jvec=0

      else
         ! rlim & zlim are requested
         ! compress the vector... need to find the (R,Z) location which
         ! is "plasma_lim" out on a normal vector from the plasma boundary...

         jvec=0
         do j=1,isize

            if(dtmp(j).gt.dist(j)) then
               ! defer update of dist(j) to loop below...
               jvec=jvec+1
               rhotmp(jvec)=1.0d0
               thtmp(jvec)=thtmp(j)
            endif
         enddo

      endif

      if(jvec.eq.0) return

      ids(1)=id_R
      ids(2)=id_Z
      ids(3)=id_R
      ids(4)=id_Z
      idchis(1:2)=0
      idchis(3:4)=1

      allocate(zrzbuf(jvec,4))

      call xplasma_eval_prof(s,ids, &
           xplasma_theta_coord,thtmp(1:jvec),xplasma_rho_coord,rhotmp(1:jvec),&
           zrzbuf,ier, &
           ideriv1s=idchis)

      jvec=0
      do j=1,isize
         if(dtmp(j).gt.dist(j)) then
            jvec=jvec+1
            dnorm=sqrt(zrzbuf(jvec,3)**2+zrzbuf(jvec,4)**2)
            delr=plasma_lim*zrzbuf(jvec,4)/dnorm
            delz=-plasma_lim*zrzbuf(jvec,3)/dnorm

            dist(j)=dtmp(j)
            rlim(j)=zrzbuf(jvec,1)+delr
            zlim(j)=zrzbuf(jvec,2)+delz
         endif
      enddo

      nullify(iwork,r8work)

    end subroutine xplasma_lim_distn
      
    subroutine xplasma_fxcep(s,ibdy_type, &
         ra,za,phia, rb,zb,phib, rx,zx,phix, istat, ier, &
         maptype, tol, rhosurf, da_input, db_input, da_output, db_output)

      ! given a set of segments, find their intersection with either
      ! the plasma boundary or the limiters

      type (xplasma), pointer :: s

      integer, intent(in) :: ibdy_type  ! =1: plasma bdy; =2: limiter

      real*8, dimension(:), intent(in) :: ra,za,phia  ! endpoints A
      real*8, dimension(:), intent(in) :: rb,zb,phib  ! endpoints B

      real*8, dimension(:), intent(out) :: rx,zx,phix ! intersections found
      integer, dimension(:), intent(out) :: istat     ! status summary

      !  istat(j)=2 -- both endpoints outside bdy
      !  istat(j)=1 -- 1st endpoint outside, 2nd endpoint inside
      !  istat(j)=-1 -- 1st endpoint inside, 2nd endpoint outside
      !  istat(j)=-2 -- both endpoints inside bdy
      !    (rx(j),zx(j)) contains bdy intercept if abs(istat(j))=1.

      integer, intent(out) :: ier   ! status code (0=OK)

      integer, intent(in), optional :: maptype  ! control for type of map
      !  to use when searching for intercept
      !  1=very accurate & slow, 2=quite accurate & faster,
      !  3=bilinear map, very fast, accurate if sufficient resolution provided
      !      (usually 2 or 3 are sufficient).  DEFAULT=2

      real*8, intent(in), optional :: tol       ! search tolerance (relative)
      !      default = s%bdytol

      real*8, intent(in), optional :: rhosurf   ! for ibdy_type=1, set this
      !      to a value other than 1, to search for a surface other than the
      !      plasma boundary

      real*8, intent(in), dimension(:), optional :: da_input,db_input
      ! distances at end points-- can be provided if already known.

      real*8, intent(out), dimension(:), optional :: da_output,db_output
      ! distances at end points-- optional output.

      !-------------------------------------------
      real*8 :: zbdy_tol,ztol
      integer :: imap_type,isize,isize_min,isize_max,iin
      real*8, dimension(:), allocatable :: zda,zdb
      real*8 :: zbdy_info
      !-------------------------------------------

      call xplasma_global_info(s,ier, bdytol=zbdy_tol)
      if(ier.ne.0) return

      ztol=zbdy_tol
      if(present(tol)) ztol=min(1.0d-4,tol)

      call xs_max_maptype(s,imap_type,ier)
      if(ier.ne.0) return

      if(present(maptype)) then
         imap_type=max(1,min(imap_type,maptype))
      else
         imap_type=2
      endif

      !-------------
      if(ibdy_type.eq.1) then
         if(present(rhosurf)) then
            if(rhosurf.le.0.0d0) then
               ier=9999
               call xplasma_errmsg_append(s, &
                    ' xplasma_sol:xplasma_fxcep, optional argument "rhosurf" if present must be >0.')
               return
            endif
            zbdy_info=rhosurf  ! any surface
         else
            zbdy_info=1.0d0  ! boundary surface
         endif
      else
         zbdy_info = -1.0d0  ! i.e. for ibdy_type=2 (limiter)
      endif
      !-------------
      !  check vector sizes-- all must match

      isize=size(ra)
      isize_min=isize
      isize_max=isize

      call schk(za); call schk(phia)
      call schk(rb); call schk(zb); call schk(phib)
      call schk(rx); call schk(zx); call schk(phix)
      isize_min=min(isize_min,size(istat))
      isize_max=max(isize_max,size(istat))

      if(present(da_output)) call schk(da_output)
      if(present(db_output)) call schk(db_output)

      iin=0
      if(present(da_input)) then
         call schk(da_input)
         iin=iin+1
      endif
      if(present(db_input)) then
         call schk(db_input)
         iin=iin+1
      endif

      if(isize_min.lt.isize_max) then
         ier=510
         call xplasma_errmsg_append(s, &
              '  vector sizes inconsistent in call to xplama_fxcep')
      endif

      if(iin.eq.1) then
         ier=510
         call xplasma_errmsg_append(s, &
              '  in either of {da_input,db_input} are present, *both* must be present.')
      endif

      if(ier.ne.0) return

      !  OK.................

      allocate(zda(isize),zdb(isize))
      if(iin.gt.0) then

         iin=1
         zda = da_input
         zdb = db_input

      endif

      sp => s

      call eqi_fxcep(isize,zbdy_info,imap_type,iin, &
           ra,za,phia,zda, rb,zb,phib,zdb, ztol, &
           rx,zx,phix,istat, ier)

      if(ier.ne.0) then

         if(present(da_output)) da_output = zda
         if(present(db_output)) db_output = zdb

      endif

      contains

        subroutine schk(arr)
          real*8, dimension(:) :: arr

          isize_min=min(isize_min,size(arr))
          isize_max=max(isize_max,size(arr))
        end subroutine schk

    end subroutine xplasma_fxcep

    subroutine xs_max_maptype(s,maptype,ier)
      !  ** PRIVATE **

      !  return the maximum maptype: 2 if there is no SOL; 3 if R&Z grids
      !  for SOL exist, so that bilinear maps can be constructed.

      type(xplasma), pointer :: s

      integer, intent(out) :: maptype
      integer, intent(out) :: ier

      !--------------------
      logical :: sol,axisymm
      !--------------------

      maptype=0

      call xplasma_global_info(s,ier, scrapeoff=sol,axisymm=axisymm)
      if(ier.ne.0) then
         sol=.FALSE.
         axisymm=.TRUE.
         return
      endif

      if(.not.axisymm) then
         ier=2509
         return
      endif

      if(sol) then
         maptype=3
      else
         maptype=2
      endif

    end subroutine xs_max_maptype

end module xplasma_sol

subroutine eq_getdetj(ivec,zrho,zchi,zphi,zscale,detj,ierr)

  !  get determinant of Jacobian (metric) without
  !  returning the tensor itself
  !    Note: if calling code uses a clockwise oriented theta, pass ivec < 0
  !          if calling code uses a counter-clockwise oriented theta, 
  !              pass ivec > 0; abs(ivec) = vector size.

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  !  input:
  integer ivec                      ! vector dimensioning
  real*8 zrho(abs(ivec)),zchi(abs(ivec)),zphi(abs(ivec)) ! (rho,chi,phi)
  real*8 zscale                     ! scale factor to apply to det(J)

  !  output:
  real*8 detj(abs(ivec))                 ! determinant of jtens

  integer ierr                      ! error code, 0=OK
 
  !--------------------------------
 
  logical :: ccwflag,axisymm
  integer :: jvec
  real*8 :: zr(abs(ivec)),zdetj(abs(ivec))
 
  !--------------------------------
 
  jvec=abs(ivec)
  ccwflag = (ivec.gt.0)

  call xplasma_global_info(s,ierr, axisymm=axisymm)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?error detected in eq_getdetj:'
     call xplasma_error(s,ierr,lunerr)
  else if(.not.axisymm) then
     ierr=1
     write(lunerr,*) ' ?eq_getdetj: only available for axisymmetric geometry!'
  endif
  if(ierr.eq.0) then

     call xplasma_rzjac(s,zrho,zchi,ierr, &
          ccwflag=ccwflag, &
          r=zr,rzdetj=zdetj)

     if(ierr.eq.0) then

        detj=zr*zdetj*zscale

     else
        write(lunerr,*) ' ?error detected in eq_getdetj xplasm_rzjac call:'
        call xplasma_error(s,ierr,lunerr)
     endif
  endif

  if(ierr.ne.0) detj = 0.0d0

end subroutine eq_getdetj

 
#include "fpreproc/byte_declare.h"
 
!----------------------------------------------------------
! cface  -- generated (f90 fixed form) C interface to:  EQ_GFNUM
      SUBROUTINE  C_EQ_GFNUM(
     > C_ZNAME_LEN,C_ZNAME,IFNUM)
 
      external EQ_GFNUM
 
! argument declarations
 ! scalar char*(*) type, input only:
      INTEGER C_ZNAME_LEN
      BYTE_DECLARE C_ZNAME(C_ZNAME_LEN)
 
      INTEGER IFNUM
 
! local (automatic array) declarations
      CHARACTER(C_ZNAME_LEN) :: ZNAME_act
 
! executable code:  copy for input
 
      call cstring(ZNAME_act, C_ZNAME,'2F')
! call to original routine:  EQ_GFNUM
 
      CALL EQ_GFNUM(
     > ZNAME_act,IFNUM)
 
! copy back outputs if modified.
 
! exit
      return
      end
 
#include "fpreproc/byte_declare.h"
 
!----------------------------------------------------------
! cface  -- generated (f90 fixed form) C interface to:  EQ_GET_FNAME
      SUBROUTINE  C_EQ_GET_FNAME(
     > IFNUM,C_ZNAME_LEN,C_ZNAME)
 
      external EQ_GET_FNAME
 
! argument declarations
      INTEGER IFNUM
 ! scalar char*(*) type, output only:
      INTEGER C_ZNAME_LEN
      BYTE_DECLARE C_ZNAME(C_ZNAME_LEN)
 
 
! local (automatic array) declarations
      CHARACTER(C_ZNAME_LEN) :: ZNAME_act
 
! executable code:  copy for input
 
      ZNAME_act=' '
! call to original routine:  EQ_GET_FNAME
 
      CALL EQ_GET_FNAME(
     > IFNUM,ZNAME_act)
 
! copy back outputs if modified.
      call cstring(ZNAME_act, C_ZNAME,'2C')
 
! exit
      return
      end

subroutine eq_nindx(iaxis,ivec,zval,kindx,iwarn)

  use xplasma_obj_instance
  use eq_module

  !  **vectorized**
  !  return indices kindx corresponding to passed values zval, on axis
  !  identified by iaxis

  IMPLICIT NONE

  integer iaxis                     ! xplasma axis id code
  integer ivec                      ! vector size
  REAL*8 zval(abs(ivec))                 ! (iaxis) coordinate value (input)
  integer kindx(abs(ivec))               ! zone index (output)
  integer iwarn                     ! set .gt.0 if any pts out of range

  !  the subroutine returns
  !     kindx = 0  ... if zval.lt. (1st axis value)
  !     kindx = size(axis) if rho_bdy .gt. (last axis value)
  !        but only if the axis is not periodic.  periodic values get
  !        shifted into range automatically

  !     if 1.le.kindx.lt.size(iaxis) then
  !        kindx satisfies eqbuf(lrho+kindx-1).le.zval.le.eqbuf(lrho+kindx)

  !----------------------------------------

  INTEGER i,id_axis,inum_outside,inumx,ierr,iertmp,inum
  integer, dimension(:), pointer :: ix
  real*8 :: xmin,xmax

  type(xpeval) :: xinfo

  logical :: ccwflag

  !----------------------------------------

  id_axis = iaxis
  inum = abs(ivec)
  ccwflag = ivec.gt.0

  call xplasma_x_lookup(s,id_axis,zval(1:inum),xinfo,ierr, &
       ccwflag=ccwflag, force_bounds=.TRUE., n_out_of_bounds=inum_outside)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_nindx: x lookup error:'
     call xplasma_error(s,ierr,lunerr)
     iwarn=inum+1
     kindx=0
     call xpeval_free(xinfo)
     return
  endif

  iwarn = inum_outside

  call xpeval_info(xinfo,ierr, ix=ix)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_nindx: unexpected xpeval_info error!'
     call xplasma_error(s,ierr,lunerr)
     iwarn=inum+1
     kindx=0
     nullify(ix)
     call xpeval_free(xinfo)
     return
  endif

  if(iwarn.gt.0) then
     call xplasma_grid_info(s,id_axis,iertmp, &
          size=inumx, xmin=xmin, xmax=xmax)
  endif

  do i=1,inum
     kindx(i)=ix(i)
     if(iwarn.gt.0) then
        if(zval(i).gt.xmax) then
           kindx(i)=inumx
        else if(zval(i).lt.xmin) then
           kindx(i)=0
        endif
     endif
  enddo

  nullify(ix)
  call xpeval_free(xinfo)

end subroutine eq_nindx

c
c  "R" routines from fftpack, gathered together, names prepended with "R4"
c      REAL precision -- dmc Aug 2009; implicit NONE imposed
c
c      IMSL fft replacement effort
c
c      test routine included....
c
c--------------------------------------------
      SUBROUTINE R4RFFTI (N,WSAVE)
      implicit none

      integer    N
      real       WSAVE(*)

      IF (N .EQ. 1) RETURN
      CALL R4RFFTI1 (N,WSAVE(N+1),WSAVE(2*N+1))

      RETURN
      END

c--------------------------------------------
      SUBROUTINE R4RFFTF (N,R,WSAVE)
      implicit none

      integer    N
      real       R(*)       ,WSAVE(*)

      IF (N .EQ. 1) RETURN
      CALL R4RFFTF1 (N,R,WSAVE,WSAVE(N+1),WSAVE(2*N+1))

      RETURN
      END

c--------------------------------------------
      SUBROUTINE R4RFFTB (N,R,WSAVE)
      implicit none

      real       R(*)       ,WSAVE(*)
      integer    N

      IF (N .EQ. 1) RETURN
      CALL R4RFFTB1 (N,R,WSAVE,WSAVE(N+1),WSAVE(2*N+1))

      RETURN
      END

c--------------------------------------------
      SUBROUTINE R4RFFTI1 (N,WA,IFAC)
      implicit none

      integer N
      real       WA(*)
      integer    IFAC(*)

c-----------------
      integer :: nl,nf,i,j,ntry,nq,nr,ib,is,l1,nfm1,ip,ld,l2
      integer :: ido,ipm,k1,ii
      real :: tpi,argh,arg,fi,argld

      integer    NTRYH(4)
      DATA NTRYH /4,2,3,5/
c-----------------

      NL = N
      NF = 0
      J = 0
  101 J = J+1
      IF (J-4) 102,102,103
  102 NTRY = NTRYH(J)
      GO TO 104
  103 NTRY = NTRY+2
  104 NQ = NL/NTRY
      NR = NL-NTRY*NQ
      IF (NR) 101,105,101
  105 NF = NF+1
      IFAC(NF+2) = NTRY
      NL = NQ
      IF (NTRY .NE. 2) GO TO 107
      IF (NF .EQ. 1) GO TO 107
      DO 106 I=2,NF
         IB = NF-I+2
         IFAC(IB+2) = IFAC(IB+1)
  106 CONTINUE
      IFAC(3) = 2
  107 IF (NL .NE. 1) GO TO 104
      IFAC(1) = N
      IFAC(2) = NF
      TPI = 6.28318530717959
      ARGH = TPI/FLOAT(N)
      IS = 0
      NFM1 = NF-1
      L1 = 1
      IF (NFM1 .EQ. 0) RETURN
      DO 110 K1=1,NFM1
         IP = IFAC(K1+2)
         LD = 0
         L2 = L1*IP
         IDO = N/L2
         IPM = IP-1
         DO 109 J=1,IPM
            LD = LD+L1
            I = IS
            ARGLD = FLOAT(LD)*ARGH
            FI = 0.
            DO 108 II=3,IDO,2
               I = I+2
               FI = FI+1.
               ARG = FI*ARGLD
               WA(I-1) = COS(ARG)
               WA(I) = SIN(ARG)
  108       CONTINUE
            IS = IS+IDO
  109    CONTINUE
         L1 = L2
  110 CONTINUE

      RETURN
      END

c--------------------------------------------
      SUBROUTINE R4RFFTF1 (N,C,CH,WA,IFAC)
      implicit none

      integer :: N
      real       CH(*)      ,C(*)       ,WA(*)
      integer :: IFAC(*)

c-----------------
      integer :: nf,na,l2,iw,k1,kh,ip,l1,ido,idl1,ix2,ix3,ix4,i
c-----------------

      NF = IFAC(2)
      NA = 1
      L2 = N
      IW = N
      DO 111 K1=1,NF
         KH = NF-K1
         IP = IFAC(KH+3)
         L1 = L2/IP
         IDO = N/L2
         IDL1 = IDO*L1
         IW = IW-(IP-1)*IDO
         NA = 1-NA
         IF (IP .NE. 4) GO TO 102
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IF (NA .NE. 0) GO TO 101
         CALL R4RADF4 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3))
         GO TO 110
  101    CALL R4RADF4 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3))
         GO TO 110
  102    IF (IP .NE. 2) GO TO 104
         IF (NA .NE. 0) GO TO 103
         CALL R4RADF2 (IDO,L1,C,CH,WA(IW))
         GO TO 110
  103    CALL R4RADF2 (IDO,L1,CH,C,WA(IW))
         GO TO 110
  104    IF (IP .NE. 3) GO TO 106
         IX2 = IW+IDO
         IF (NA .NE. 0) GO TO 105
         CALL R4RADF3 (IDO,L1,C,CH,WA(IW),WA(IX2))
         GO TO 110
  105    CALL R4RADF3 (IDO,L1,CH,C,WA(IW),WA(IX2))
         GO TO 110
  106    IF (IP .NE. 5) GO TO 108
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IX4 = IX3+IDO
         IF (NA .NE. 0) GO TO 107
         CALL R4RADF5 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 110
  107    CALL R4RADF5 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 110
  108    IF (IDO .EQ. 1) NA = 1-NA
         IF (NA .NE. 0) GO TO 109
         CALL R4RADFG (IDO,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))
         NA = 1
         GO TO 110
  109    CALL R4RADFG (IDO,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))
         NA = 0
  110    L2 = L1
  111 CONTINUE
      IF (NA .EQ. 1) RETURN
      DO 112 I=1,N
         C(I) = CH(I)
  112 CONTINUE

      RETURN
      END

c--------------------------------------------
      SUBROUTINE R4RFFTB1 (N,C,CH,WA,IFAC)
      implicit none

      integer :: N
      real       CH(*)      ,C(*)       ,WA(*)
      integer :: IFAC(*)

c-----------------
      integer :: nf,na,l2,iw,k1,kh,ip,l1,ido,idl1,ix2,ix3,ix4,i
c-----------------

      NF = IFAC(2)
      NA = 0
      L1 = 1
      IW = 1
      DO 116 K1=1,NF
         IP = IFAC(K1+2)
         L2 = IP*L1
         IDO = N/L2
         IDL1 = IDO*L1
         IF (IP .NE. 4) GO TO 103
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IF (NA .NE. 0) GO TO 101
         CALL R4RADB4 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3))
         GO TO 102
  101    CALL R4RADB4 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3))
  102    NA = 1-NA
         GO TO 115
  103    IF (IP .NE. 2) GO TO 106
         IF (NA .NE. 0) GO TO 104
         CALL R4RADB2 (IDO,L1,C,CH,WA(IW))
         GO TO 105
  104    CALL R4RADB2 (IDO,L1,CH,C,WA(IW))
  105    NA = 1-NA
         GO TO 115
  106    IF (IP .NE. 3) GO TO 109
         IX2 = IW+IDO
         IF (NA .NE. 0) GO TO 107
         CALL R4RADB3 (IDO,L1,C,CH,WA(IW),WA(IX2))
         GO TO 108
  107    CALL R4RADB3 (IDO,L1,CH,C,WA(IW),WA(IX2))
  108    NA = 1-NA
         GO TO 115
  109    IF (IP .NE. 5) GO TO 112
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IX4 = IX3+IDO
         IF (NA .NE. 0) GO TO 110
         CALL R4RADB5 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 111
  110    CALL R4RADB5 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))
  111    NA = 1-NA
         GO TO 115
  112    IF (NA .NE. 0) GO TO 113
         CALL R4RADBG (IDO,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))
         GO TO 114
  113    CALL R4RADBG (IDO,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))
  114    IF (IDO .EQ. 1) NA = 1-NA
  115    L1 = L2
         IW = IW+(IP-1)*IDO
  116 CONTINUE
      IF (NA .EQ. 0) RETURN
      DO 117 I=1,N
         C(I) = CH(I)
  117 CONTINUE

      RETURN
      END

c--------------------------------------------
      SUBROUTINE R4RADF2 (IDO,L1,CC,CH,WA1)
      implicit none

      INTEGER :: IDO,L1
      REAL       CH(IDO,2,L1)           ,CC(IDO,L1,2)           ,
     1                WA1(*)

c-----------------
      integer :: k,ic,i,idp2
      real :: tr2,ti2
c-----------------

      DO 101 K=1,L1
         CH(1,1,K) = CC(1,K,1)+CC(1,K,2)
         CH(IDO,2,K) = CC(1,K,1)-CC(1,K,2)
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            TR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            TI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            CH(I,1,K) = CC(I,K,1)+TI2
            CH(IC,2,K) = TI2-CC(I,K,1)
            CH(I-1,1,K) = CC(I-1,K,1)+TR2
            CH(IC-1,2,K) = CC(I-1,K,1)-TR2
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 DO 106 K=1,L1
         CH(1,2,K) = -CC(IDO,K,2)
         CH(IDO,1,K) = CC(IDO,K,1)
  106 CONTINUE
  107 RETURN
      END

c--------------------------------------------
      SUBROUTINE R4RADF3 (IDO,L1,CC,CH,WA1,WA2)
      implicit none

      INTEGER :: IDO,L1
      REAL       CH(IDO,3,L1)           ,CC(IDO,L1,3)           ,
     1                WA1(*)     ,WA2(*)

c-----------------
      integer :: i,ic,k,idp2
      real :: cr2,ci2,dr2,di2,dr3,di3,tr2,ti2,tr3,ti3
      real :: TAUR,TAUI
c-----------------
      DATA TAUR,TAUI /-.5,.866025403784439/

      DO 101 K=1,L1
         CR2 = CC(1,K,2)+CC(1,K,3)
         CH(1,1,K) = CC(1,K,1)+CR2
         CH(1,3,K) = TAUI*(CC(1,K,3)-CC(1,K,2))
         CH(IDO,2,K) = CC(1,K,1)+TAUR*CR2
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            DR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            DI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            DR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)
            DI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)
            CR2 = DR2+DR3
            CI2 = DI2+DI3
            CH(I-1,1,K) = CC(I-1,K,1)+CR2
            CH(I,1,K) = CC(I,K,1)+CI2
            TR2 = CC(I-1,K,1)+TAUR*CR2
            TI2 = CC(I,K,1)+TAUR*CI2
            TR3 = TAUI*(DI2-DI3)
            TI3 = TAUI*(DR3-DR2)
            CH(I-1,3,K) = TR2+TR3
            CH(IC-1,2,K) = TR2-TR3
            CH(I,3,K) = TI2+TI3
            CH(IC,2,K) = TI3-TI2
  102    CONTINUE
  103 CONTINUE

      RETURN
      END

c--------------------------------------------
      SUBROUTINE R4RADF4 (IDO,L1,CC,CH,WA1,WA2,WA3)
      implicit none

      INTEGER :: IDO,L1
      REAL       CC(IDO,L1,4)           ,CH(IDO,4,L1)           ,
     1                WA1(*)     ,WA2(*)     ,WA3(*)

c-----------------
      integer :: k,idp2,i,ic
      real :: tr1,ti1,tr2,ti2,cr2,ci2,cr3,ci3,cr4,ci4
      real :: tr3,ti3,tr4,ti4
      real :: hsqt2
c-----------------
      DATA HSQT2 /.7071067811865475/

      DO 101 K=1,L1
         TR1 = CC(1,K,2)+CC(1,K,4)
         TR2 = CC(1,K,1)+CC(1,K,3)
         CH(1,1,K) = TR1+TR2
         CH(IDO,4,K) = TR2-TR1
         CH(IDO,2,K) = CC(1,K,1)-CC(1,K,3)
         CH(1,3,K) = CC(1,K,4)-CC(1,K,2)
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            CR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            CI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            CR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)
            CI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)
            CR4 = WA3(I-2)*CC(I-1,K,4)+WA3(I-1)*CC(I,K,4)
            CI4 = WA3(I-2)*CC(I,K,4)-WA3(I-1)*CC(I-1,K,4)
            TR1 = CR2+CR4
            TR4 = CR4-CR2
            TI1 = CI2+CI4
            TI4 = CI2-CI4
            TI2 = CC(I,K,1)+CI3
            TI3 = CC(I,K,1)-CI3
            TR2 = CC(I-1,K,1)+CR3
            TR3 = CC(I-1,K,1)-CR3
            CH(I-1,1,K) = TR1+TR2
            CH(IC-1,4,K) = TR2-TR1
            CH(I,1,K) = TI1+TI2
            CH(IC,4,K) = TI1-TI2
            CH(I-1,3,K) = TI4+TR3
            CH(IC-1,2,K) = TR3-TI4
            CH(I,3,K) = TR4+TI3
            CH(IC,2,K) = TR4-TI3
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 CONTINUE
      DO 106 K=1,L1
         TI1 = -HSQT2*(CC(IDO,K,2)+CC(IDO,K,4))
         TR1 = HSQT2*(CC(IDO,K,2)-CC(IDO,K,4))
         CH(IDO,1,K) = TR1+CC(IDO,K,1)
         CH(IDO,3,K) = CC(IDO,K,1)-TR1
         CH(1,2,K) = TI1-CC(IDO,K,3)
         CH(1,4,K) = TI1+CC(IDO,K,3)
  106 CONTINUE
  107 RETURN
      END

c--------------------------------------------
      SUBROUTINE R4RADF5 (IDO,L1,CC,CH,WA1,WA2,WA3,WA4)
      implicit none

      INTEGER :: IDO,L1
      REAL       CC(IDO,L1,5)           ,CH(IDO,5,L1)           ,
     1                WA1(*)     ,WA2(*)     ,WA3(*)     ,WA4(*)

c-----------------
      integer :: i,k,idp2,ic
      real :: tr11,ti11,tr12,ti12
      real :: cr2,cr3,cr4,cr5,ci2,ci3,ci4,ci5
      real :: dr2,dr3,dr4,dr5,di2,di3,di4,di5
      real :: tr2,tr3,tr4,tr5,ti2,ti3,ti4,ti5
c-----------------
      DATA TR11,TI11,TR12,TI12 /.309016994374947,.951056516295154,
     1-.809016994374947,.587785252292473/

      DO 101 K=1,L1
         CR2 = CC(1,K,5)+CC(1,K,2)
         CI5 = CC(1,K,5)-CC(1,K,2)
         CR3 = CC(1,K,4)+CC(1,K,3)
         CI4 = CC(1,K,4)-CC(1,K,3)
         CH(1,1,K) = CC(1,K,1)+CR2+CR3
         CH(IDO,2,K) = CC(1,K,1)+TR11*CR2+TR12*CR3
         CH(1,3,K) = TI11*CI5+TI12*CI4
         CH(IDO,4,K) = CC(1,K,1)+TR12*CR2+TR11*CR3
         CH(1,5,K) = TI12*CI5-TI11*CI4
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            DR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            DI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            DR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)
            DI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)
            DR4 = WA3(I-2)*CC(I-1,K,4)+WA3(I-1)*CC(I,K,4)
            DI4 = WA3(I-2)*CC(I,K,4)-WA3(I-1)*CC(I-1,K,4)
            DR5 = WA4(I-2)*CC(I-1,K,5)+WA4(I-1)*CC(I,K,5)
            DI5 = WA4(I-2)*CC(I,K,5)-WA4(I-1)*CC(I-1,K,5)
            CR2 = DR2+DR5
            CI5 = DR5-DR2
            CR5 = DI2-DI5
            CI2 = DI2+DI5
            CR3 = DR3+DR4
            CI4 = DR4-DR3
            CR4 = DI3-DI4
            CI3 = DI3+DI4
            CH(I-1,1,K) = CC(I-1,K,1)+CR2+CR3
            CH(I,1,K) = CC(I,K,1)+CI2+CI3
            TR2 = CC(I-1,K,1)+TR11*CR2+TR12*CR3
            TI2 = CC(I,K,1)+TR11*CI2+TR12*CI3
            TR3 = CC(I-1,K,1)+TR12*CR2+TR11*CR3
            TI3 = CC(I,K,1)+TR12*CI2+TR11*CI3
            TR5 = TI11*CR5+TI12*CR4
            TI5 = TI11*CI5+TI12*CI4
            TR4 = TI12*CR5-TI11*CR4
            TI4 = TI12*CI5-TI11*CI4
            CH(I-1,3,K) = TR2+TR5
            CH(IC-1,2,K) = TR2-TR5
            CH(I,3,K) = TI2+TI5
            CH(IC,2,K) = TI5-TI2
            CH(I-1,5,K) = TR3+TR4
            CH(IC-1,4,K) = TR3-TR4
            CH(I,5,K) = TI3+TI4
            CH(IC,4,K) = TI4-TI3
  102    CONTINUE
  103 CONTINUE

      RETURN
      END

c--------------------------------------------
      SUBROUTINE R4RADFG (IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)
      implicit none

      INTEGER :: IDO,L1,IP,IDL1

      REAL       CH(IDO,L1,IP)          ,CC(IDO,IP,L1)          ,
     1                C1(IDO,L1,IP)          ,C2(IDL1,IP),
     2                CH2(IDL1,IP)           ,WA(*)

c-----------------
      real :: tpi,arg,dcp,dsp,ar1,ai1,ar1h,dc2,ds2,ar2,ai2,ar2h
      integer :: ipph,ipp2,idp2,nbd,ik,i,j,k,is,idij,jc,l,lc,j2,ic
c-----------------
      DATA TPI/6.28318530717959/

      ARG = TPI/FLOAT(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IPPH = (IP+1)/2
      IPP2 = IP+2
      IDP2 = IDO+2
      NBD = (IDO-1)/2
      IF (IDO .EQ. 1) GO TO 119
      DO 101 IK=1,IDL1
         CH2(IK,1) = C2(IK,1)
  101 CONTINUE
      DO 103 J=2,IP
         DO 102 K=1,L1
            CH(1,K,J) = C1(1,K,J)
  102    CONTINUE
  103 CONTINUE
      IF (NBD .GT. L1) GO TO 107
      IS = -IDO
      DO 106 J=2,IP
         IS = IS+IDO
         IDIJ = IS
         DO 105 I=3,IDO,2
            IDIJ = IDIJ+2
            DO 104 K=1,L1
               CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J)+WA(IDIJ)*C1(I,K,J)
               CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J)-WA(IDIJ)*C1(I-1,K,J)
  104       CONTINUE
  105    CONTINUE
  106 CONTINUE
      GO TO 111
  107 IS = -IDO
      DO 110 J=2,IP
         IS = IS+IDO
         DO 109 K=1,L1
            IDIJ = IS
            DO 108 I=3,IDO,2
               IDIJ = IDIJ+2
               CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J)+WA(IDIJ)*C1(I,K,J)
               CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J)-WA(IDIJ)*C1(I-1,K,J)
  108       CONTINUE
  109    CONTINUE
  110 CONTINUE
  111 IF (NBD .LT. L1) GO TO 115
      DO 114 J=2,IPPH
         JC = IPP2-J
         DO 113 K=1,L1
            DO 112 I=3,IDO,2
               C1(I-1,K,J) = CH(I-1,K,J)+CH(I-1,K,JC)
               C1(I-1,K,JC) = CH(I,K,J)-CH(I,K,JC)
               C1(I,K,J) = CH(I,K,J)+CH(I,K,JC)
               C1(I,K,JC) = CH(I-1,K,JC)-CH(I-1,K,J)
  112       CONTINUE
  113    CONTINUE
  114 CONTINUE
      GO TO 121
  115 DO 118 J=2,IPPH
         JC = IPP2-J
         DO 117 I=3,IDO,2
            DO 116 K=1,L1
               C1(I-1,K,J) = CH(I-1,K,J)+CH(I-1,K,JC)
               C1(I-1,K,JC) = CH(I,K,J)-CH(I,K,JC)
               C1(I,K,J) = CH(I,K,J)+CH(I,K,JC)
               C1(I,K,JC) = CH(I-1,K,JC)-CH(I-1,K,J)
  116       CONTINUE
  117    CONTINUE
  118 CONTINUE
      GO TO 121
  119 DO 120 IK=1,IDL1
         C2(IK,1) = CH2(IK,1)
  120 CONTINUE
  121 DO 123 J=2,IPPH
         JC = IPP2-J
         DO 122 K=1,L1
            C1(1,K,J) = CH(1,K,J)+CH(1,K,JC)
            C1(1,K,JC) = CH(1,K,JC)-CH(1,K,J)
  122    CONTINUE
  123 CONTINUE
C
      AR1 = 1.
      AI1 = 0.
      DO 127 L=2,IPPH
         LC = IPP2-L
         AR1H = DCP*AR1-DSP*AI1
         AI1 = DCP*AI1+DSP*AR1
         AR1 = AR1H
         DO 124 IK=1,IDL1
            CH2(IK,L) = C2(IK,1)+AR1*C2(IK,2)
            CH2(IK,LC) = AI1*C2(IK,IP)
  124    CONTINUE
         DC2 = AR1
         DS2 = AI1
         AR2 = AR1
         AI2 = AI1
         DO 126 J=3,IPPH
            JC = IPP2-J
            AR2H = DC2*AR2-DS2*AI2
            AI2 = DC2*AI2+DS2*AR2
            AR2 = AR2H
            DO 125 IK=1,IDL1
               CH2(IK,L) = CH2(IK,L)+AR2*C2(IK,J)
               CH2(IK,LC) = CH2(IK,LC)+AI2*C2(IK,JC)
  125       CONTINUE
  126    CONTINUE
  127 CONTINUE
      DO 129 J=2,IPPH
         DO 128 IK=1,IDL1
            CH2(IK,1) = CH2(IK,1)+C2(IK,J)
  128    CONTINUE
  129 CONTINUE
C
      IF (IDO .LT. L1) GO TO 132
      DO 131 K=1,L1
         DO 130 I=1,IDO
            CC(I,1,K) = CH(I,K,1)
  130    CONTINUE
  131 CONTINUE
      GO TO 135
  132 DO 134 I=1,IDO
         DO 133 K=1,L1
            CC(I,1,K) = CH(I,K,1)
  133    CONTINUE
  134 CONTINUE
  135 DO 137 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 136 K=1,L1
            CC(IDO,J2-2,K) = CH(1,K,J)
            CC(1,J2-1,K) = CH(1,K,JC)
  136    CONTINUE
  137 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IF (NBD .LT. L1) GO TO 141
      DO 140 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 139 K=1,L1
            DO 138 I=3,IDO,2
               IC = IDP2-I
               CC(I-1,J2-1,K) = CH(I-1,K,J)+CH(I-1,K,JC)
               CC(IC-1,J2-2,K) = CH(I-1,K,J)-CH(I-1,K,JC)
               CC(I,J2-1,K) = CH(I,K,J)+CH(I,K,JC)
               CC(IC,J2-2,K) = CH(I,K,JC)-CH(I,K,J)
  138       CONTINUE
  139    CONTINUE
  140 CONTINUE
      RETURN
  141 DO 144 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 143 I=3,IDO,2
            IC = IDP2-I
            DO 142 K=1,L1
               CC(I-1,J2-1,K) = CH(I-1,K,J)+CH(I-1,K,JC)
               CC(IC-1,J2-2,K) = CH(I-1,K,J)-CH(I-1,K,JC)
               CC(I,J2-1,K) = CH(I,K,J)+CH(I,K,JC)
               CC(IC,J2-2,K) = CH(I,K,JC)-CH(I,K,J)
  142       CONTINUE
  143    CONTINUE
  144 CONTINUE

      RETURN
      END

c--------------------------------------------
      SUBROUTINE R4RADB2 (IDO,L1,CC,CH,WA1)
      implicit none

      INTEGER :: IDO,L1
      REAL       CC(IDO,2,L1)           ,CH(IDO,L1,2)           ,
     1                WA1(*)

c-----------------
      integer :: i,k,ic,idp2
      real :: tr2,ti2
c-----------------

      DO 101 K=1,L1
         CH(1,K,1) = CC(1,1,K)+CC(IDO,2,K)
         CH(1,K,2) = CC(1,1,K)-CC(IDO,2,K)
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            CH(I-1,K,1) = CC(I-1,1,K)+CC(IC-1,2,K)
            TR2 = CC(I-1,1,K)-CC(IC-1,2,K)
            CH(I,K,1) = CC(I,1,K)-CC(IC,2,K)
            TI2 = CC(I,1,K)+CC(IC,2,K)
            CH(I-1,K,2) = WA1(I-2)*TR2-WA1(I-1)*TI2
            CH(I,K,2) = WA1(I-2)*TI2+WA1(I-1)*TR2
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 DO 106 K=1,L1
         CH(IDO,K,1) = CC(IDO,1,K)+CC(IDO,1,K)
         CH(IDO,K,2) = -(CC(1,2,K)+CC(1,2,K))
  106 CONTINUE
  107 RETURN
      END

c--------------------------------------------
      SUBROUTINE R4RADB3 (IDO,L1,CC,CH,WA1,WA2)
      implicit none

      INTEGER :: IDO,L1
      REAL       CC(IDO,3,L1)           ,CH(IDO,L1,3)           ,
     1                WA1(*)     ,WA2(*)

c-----------------
      integer :: i,k,ic,idp2
      real :: tr2,ti2,cr2,ci2,cr3,ci3,dr2,di2,dr3,di3
      real :: taur,taui
c-----------------
      DATA TAUR,TAUI /-.5,.866025403784439/

      DO 101 K=1,L1
         TR2 = CC(IDO,2,K)+CC(IDO,2,K)
         CR2 = CC(1,1,K)+TAUR*TR2
         CH(1,K,1) = CC(1,1,K)+TR2
         CI3 = TAUI*(CC(1,3,K)+CC(1,3,K))
         CH(1,K,2) = CR2-CI3
         CH(1,K,3) = CR2+CI3
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            TR2 = CC(I-1,3,K)+CC(IC-1,2,K)
            CR2 = CC(I-1,1,K)+TAUR*TR2
            CH(I-1,K,1) = CC(I-1,1,K)+TR2
            TI2 = CC(I,3,K)-CC(IC,2,K)
            CI2 = CC(I,1,K)+TAUR*TI2
            CH(I,K,1) = CC(I,1,K)+TI2
            CR3 = TAUI*(CC(I-1,3,K)-CC(IC-1,2,K))
            CI3 = TAUI*(CC(I,3,K)+CC(IC,2,K))
            DR2 = CR2-CI3
            DR3 = CR2+CI3
            DI2 = CI2+CR3
            DI3 = CI2-CR3
            CH(I-1,K,2) = WA1(I-2)*DR2-WA1(I-1)*DI2
            CH(I,K,2) = WA1(I-2)*DI2+WA1(I-1)*DR2
            CH(I-1,K,3) = WA2(I-2)*DR3-WA2(I-1)*DI3
            CH(I,K,3) = WA2(I-2)*DI3+WA2(I-1)*DR3
  102    CONTINUE
  103 CONTINUE

      RETURN
      END

c--------------------------------------------
      SUBROUTINE R4RADB4 (IDO,L1,CC,CH,WA1,WA2,WA3)
      implicit none

      INTEGER :: IDO,L1
      REAL       CC(IDO,4,L1)           ,CH(IDO,L1,4)           ,
     1                WA1(1)     ,WA2(1)     ,WA3(1)

c-----------------
      integer :: i,k,ic,idp2
      real :: sqrt2,tr1,tr2,tr3,tr4,ti1,ti2,ti3,ti4
      real :: cr2,cr3,cr4,ci2,ci3,ci4
c-----------------
      DATA SQRT2 /1.414213562373095/

      DO 101 K=1,L1
         TR1 = CC(1,1,K)-CC(IDO,4,K)
         TR2 = CC(1,1,K)+CC(IDO,4,K)
         TR3 = CC(IDO,2,K)+CC(IDO,2,K)
         TR4 = CC(1,3,K)+CC(1,3,K)
         CH(1,K,1) = TR2+TR3
         CH(1,K,2) = TR1-TR4
         CH(1,K,3) = TR2-TR3
         CH(1,K,4) = TR1+TR4
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            TI1 = CC(I,1,K)+CC(IC,4,K)
            TI2 = CC(I,1,K)-CC(IC,4,K)
            TI3 = CC(I,3,K)-CC(IC,2,K)
            TR4 = CC(I,3,K)+CC(IC,2,K)
            TR1 = CC(I-1,1,K)-CC(IC-1,4,K)
            TR2 = CC(I-1,1,K)+CC(IC-1,4,K)
            TI4 = CC(I-1,3,K)-CC(IC-1,2,K)
            TR3 = CC(I-1,3,K)+CC(IC-1,2,K)
            CH(I-1,K,1) = TR2+TR3
            CR3 = TR2-TR3
            CH(I,K,1) = TI2+TI3
            CI3 = TI2-TI3
            CR2 = TR1-TR4
            CR4 = TR1+TR4
            CI2 = TI1+TI4
            CI4 = TI1-TI4
            CH(I-1,K,2) = WA1(I-2)*CR2-WA1(I-1)*CI2
            CH(I,K,2) = WA1(I-2)*CI2+WA1(I-1)*CR2
            CH(I-1,K,3) = WA2(I-2)*CR3-WA2(I-1)*CI3
            CH(I,K,3) = WA2(I-2)*CI3+WA2(I-1)*CR3
            CH(I-1,K,4) = WA3(I-2)*CR4-WA3(I-1)*CI4
            CH(I,K,4) = WA3(I-2)*CI4+WA3(I-1)*CR4
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 CONTINUE
      DO 106 K=1,L1
         TI1 = CC(1,2,K)+CC(1,4,K)
         TI2 = CC(1,4,K)-CC(1,2,K)
         TR1 = CC(IDO,1,K)-CC(IDO,3,K)
         TR2 = CC(IDO,1,K)+CC(IDO,3,K)
         CH(IDO,K,1) = TR2+TR2
         CH(IDO,K,2) = SQRT2*(TR1-TI1)
         CH(IDO,K,3) = TI2+TI2
         CH(IDO,K,4) = -SQRT2*(TR1+TI1)
  106 CONTINUE
  107 RETURN
      END

c--------------------------------------------
      SUBROUTINE R4RADB5 (IDO,L1,CC,CH,WA1,WA2,WA3,WA4)
      implicit none

      INTEGER :: IDO,L1
      REAL       CC(IDO,5,L1)           ,CH(IDO,L1,5)           ,
     1                WA1(*)     ,WA2(*)     ,WA3(*)     ,WA4(*)

c-----------------
      integer :: i,k,ic,idp2
      real :: tr2,tr3,tr4,tr5,ti2,ti3,ti4,ti5
      real :: cr2,cr3,cr4,cr5,ci2,ci3,ci4,ci5
      real :: dr2,dr3,dr4,dr5,di2,di3,di4,di5
      real :: tr11,ti11,tr12,ti12
c-----------------
      DATA TR11,TI11,TR12,TI12 /.309016994374947,.951056516295154,
     1-.809016994374947,.587785252292473/

      DO 101 K=1,L1
         TI5 = CC(1,3,K)+CC(1,3,K)
         TI4 = CC(1,5,K)+CC(1,5,K)
         TR2 = CC(IDO,2,K)+CC(IDO,2,K)
         TR3 = CC(IDO,4,K)+CC(IDO,4,K)
         CH(1,K,1) = CC(1,1,K)+TR2+TR3
         CR2 = CC(1,1,K)+TR11*TR2+TR12*TR3
         CR3 = CC(1,1,K)+TR12*TR2+TR11*TR3
         CI5 = TI11*TI5+TI12*TI4
         CI4 = TI12*TI5-TI11*TI4
         CH(1,K,2) = CR2-CI5
         CH(1,K,3) = CR3-CI4
         CH(1,K,4) = CR3+CI4
         CH(1,K,5) = CR2+CI5
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            TI5 = CC(I,3,K)+CC(IC,2,K)
            TI2 = CC(I,3,K)-CC(IC,2,K)
            TI4 = CC(I,5,K)+CC(IC,4,K)
            TI3 = CC(I,5,K)-CC(IC,4,K)
            TR5 = CC(I-1,3,K)-CC(IC-1,2,K)
            TR2 = CC(I-1,3,K)+CC(IC-1,2,K)
            TR4 = CC(I-1,5,K)-CC(IC-1,4,K)
            TR3 = CC(I-1,5,K)+CC(IC-1,4,K)
            CH(I-1,K,1) = CC(I-1,1,K)+TR2+TR3
            CH(I,K,1) = CC(I,1,K)+TI2+TI3
            CR2 = CC(I-1,1,K)+TR11*TR2+TR12*TR3
            CI2 = CC(I,1,K)+TR11*TI2+TR12*TI3
            CR3 = CC(I-1,1,K)+TR12*TR2+TR11*TR3
            CI3 = CC(I,1,K)+TR12*TI2+TR11*TI3
            CR5 = TI11*TR5+TI12*TR4
            CI5 = TI11*TI5+TI12*TI4
            CR4 = TI12*TR5-TI11*TR4
            CI4 = TI12*TI5-TI11*TI4
            DR3 = CR3-CI4
            DR4 = CR3+CI4
            DI3 = CI3+CR4
            DI4 = CI3-CR4
            DR5 = CR2+CI5
            DR2 = CR2-CI5
            DI5 = CI2-CR5
            DI2 = CI2+CR5
            CH(I-1,K,2) = WA1(I-2)*DR2-WA1(I-1)*DI2
            CH(I,K,2) = WA1(I-2)*DI2+WA1(I-1)*DR2
            CH(I-1,K,3) = WA2(I-2)*DR3-WA2(I-1)*DI3
            CH(I,K,3) = WA2(I-2)*DI3+WA2(I-1)*DR3
            CH(I-1,K,4) = WA3(I-2)*DR4-WA3(I-1)*DI4
            CH(I,K,4) = WA3(I-2)*DI4+WA3(I-1)*DR4
            CH(I-1,K,5) = WA4(I-2)*DR5-WA4(I-1)*DI5
            CH(I,K,5) = WA4(I-2)*DI5+WA4(I-1)*DR5
  102    CONTINUE
  103 CONTINUE
      RETURN
      END

c--------------------------------------------
      SUBROUTINE R4RADBG (IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)
      implicit none

      INTEGER :: IDO,L1,IP,IDL1

      REAL       CH(IDO,L1,IP)          ,CC(IDO,IP,L1)          ,
     1                C1(IDO,L1,IP)          ,C2(IDL1,IP),
     2                CH2(IDL1,IP)           ,WA(1)

c-----------------
      integer :: nbd,i,k,idp2,ipp2,ipph,j,j2,jc,ic,l,lc,ik,is,idij
      real :: ar1,ar2,ai1,ai2,ar1h,ar2h,dc2,ds2
      real :: tpi,arg,dcp,dsp
c-----------------
      DATA TPI/6.28318530717959/

      ARG = TPI/FLOAT(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IDP2 = IDO+2
      NBD = (IDO-1)/2
      IPP2 = IP+2
      IPPH = (IP+1)/2
      IF (IDO .LT. L1) GO TO 103
      DO 102 K=1,L1
         DO 101 I=1,IDO
            CH(I,K,1) = CC(I,1,K)
  101    CONTINUE
  102 CONTINUE
      GO TO 106
  103 DO 105 I=1,IDO
         DO 104 K=1,L1
            CH(I,K,1) = CC(I,1,K)
  104    CONTINUE
  105 CONTINUE
  106 DO 108 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 107 K=1,L1
            CH(1,K,J) = CC(IDO,J2-2,K)+CC(IDO,J2-2,K)
            CH(1,K,JC) = CC(1,J2-1,K)+CC(1,J2-1,K)
  107    CONTINUE
  108 CONTINUE
      IF (IDO .EQ. 1) GO TO 116
      IF (NBD .LT. L1) GO TO 112
      DO 111 J=2,IPPH
         JC = IPP2-J
         DO 110 K=1,L1
            DO 109 I=3,IDO,2
               IC = IDP2-I
               CH(I-1,K,J) = CC(I-1,2*J-1,K)+CC(IC-1,2*J-2,K)
               CH(I-1,K,JC) = CC(I-1,2*J-1,K)-CC(IC-1,2*J-2,K)
               CH(I,K,J) = CC(I,2*J-1,K)-CC(IC,2*J-2,K)
               CH(I,K,JC) = CC(I,2*J-1,K)+CC(IC,2*J-2,K)
  109       CONTINUE
  110    CONTINUE
  111 CONTINUE
      GO TO 116
  112 DO 115 J=2,IPPH
         JC = IPP2-J
         DO 114 I=3,IDO,2
            IC = IDP2-I
            DO 113 K=1,L1
               CH(I-1,K,J) = CC(I-1,2*J-1,K)+CC(IC-1,2*J-2,K)
               CH(I-1,K,JC) = CC(I-1,2*J-1,K)-CC(IC-1,2*J-2,K)
               CH(I,K,J) = CC(I,2*J-1,K)-CC(IC,2*J-2,K)
               CH(I,K,JC) = CC(I,2*J-1,K)+CC(IC,2*J-2,K)
  113       CONTINUE
  114    CONTINUE
  115 CONTINUE
  116 AR1 = 1.
      AI1 = 0.
      DO 120 L=2,IPPH
         LC = IPP2-L
         AR1H = DCP*AR1-DSP*AI1
         AI1 = DCP*AI1+DSP*AR1
         AR1 = AR1H
         DO 117 IK=1,IDL1
            C2(IK,L) = CH2(IK,1)+AR1*CH2(IK,2)
            C2(IK,LC) = AI1*CH2(IK,IP)
  117    CONTINUE
         DC2 = AR1
         DS2 = AI1
         AR2 = AR1
         AI2 = AI1
         DO 119 J=3,IPPH
            JC = IPP2-J
            AR2H = DC2*AR2-DS2*AI2
            AI2 = DC2*AI2+DS2*AR2
            AR2 = AR2H
            DO 118 IK=1,IDL1
               C2(IK,L) = C2(IK,L)+AR2*CH2(IK,J)
               C2(IK,LC) = C2(IK,LC)+AI2*CH2(IK,JC)
  118       CONTINUE
  119    CONTINUE
  120 CONTINUE
      DO 122 J=2,IPPH
         DO 121 IK=1,IDL1
            CH2(IK,1) = CH2(IK,1)+CH2(IK,J)
  121    CONTINUE
  122 CONTINUE
      DO 124 J=2,IPPH
         JC = IPP2-J
         DO 123 K=1,L1
            CH(1,K,J) = C1(1,K,J)-C1(1,K,JC)
            CH(1,K,JC) = C1(1,K,J)+C1(1,K,JC)
  123    CONTINUE
  124 CONTINUE
      IF (IDO .EQ. 1) GO TO 132
      IF (NBD .LT. L1) GO TO 128
      DO 127 J=2,IPPH
         JC = IPP2-J
         DO 126 K=1,L1
            DO 125 I=3,IDO,2
               CH(I-1,K,J) = C1(I-1,K,J)-C1(I,K,JC)
               CH(I-1,K,JC) = C1(I-1,K,J)+C1(I,K,JC)
               CH(I,K,J) = C1(I,K,J)+C1(I-1,K,JC)
               CH(I,K,JC) = C1(I,K,J)-C1(I-1,K,JC)
  125       CONTINUE
  126    CONTINUE
  127 CONTINUE
      GO TO 132
  128 DO 131 J=2,IPPH
         JC = IPP2-J
         DO 130 I=3,IDO,2
            DO 129 K=1,L1
               CH(I-1,K,J) = C1(I-1,K,J)-C1(I,K,JC)
               CH(I-1,K,JC) = C1(I-1,K,J)+C1(I,K,JC)
               CH(I,K,J) = C1(I,K,J)+C1(I-1,K,JC)
               CH(I,K,JC) = C1(I,K,J)-C1(I-1,K,JC)
  129       CONTINUE
  130    CONTINUE
  131 CONTINUE
  132 CONTINUE
      IF (IDO .EQ. 1) RETURN
      DO 133 IK=1,IDL1
         C2(IK,1) = CH2(IK,1)
  133 CONTINUE
      DO 135 J=2,IP
         DO 134 K=1,L1
            C1(1,K,J) = CH(1,K,J)
  134    CONTINUE
  135 CONTINUE
      IF (NBD .GT. L1) GO TO 139
      IS = -IDO
      DO 138 J=2,IP
         IS = IS+IDO
         IDIJ = IS
         DO 137 I=3,IDO,2
            IDIJ = IDIJ+2
            DO 136 K=1,L1
               C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J)-WA(IDIJ)*CH(I,K,J)
               C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J)+WA(IDIJ)*CH(I-1,K,J)
  136       CONTINUE
  137    CONTINUE
  138 CONTINUE
      GO TO 143
  139 IS = -IDO
      DO 142 J=2,IP
         IS = IS+IDO
         DO 141 K=1,L1
            IDIJ = IS
            DO 140 I=3,IDO,2
               IDIJ = IDIJ+2
               C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J)-WA(IDIJ)*CH(I,K,J)
               C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J)+WA(IDIJ)*CH(I-1,K,J)
  140       CONTINUE
  141    CONTINUE
  142 CONTINUE
  143 RETURN
      END


      SUBROUTINE R4_RFFT_TEST
C
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
C                       VERSION 4  APRIL 1985
C
C                         A TEST DRIVER FOR
C          A PACKAGE OF FORTRAN SUBPROGRAMS FOR THE FAST FOURIER
C           TRANSFORM OF PERIODIC AND OTHER SYMMETRIC SEQUENCES
C
C                              BY
C
C                       PAUL N SWARZTRAUBER
C
C       NATIONAL CENTER FOR ATMOSPHERIC RESEARCH  BOULDER,COLORADO 80307
C
C        WHICH IS SPONSORED BY THE NATIONAL SCIENCE FOUNDATION
C
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
C
C             THIS PROGRAM TESTS THE PACKAGE OF FAST FOURIER
C     TRANSFORMS FOR BOTH COMPLEX AND REAL PERIODIC SEQUENCES AND
C     CERTIAN OTHER SYMMETRIC SEQUENCES THAT ARE LISTED BELOW.
C
C     1.   RFFTI     INITIALIZE  RFFTF AND RFFTB
C     2.   RFFTF     FORWARD TRANSFORM OF A REAL PERIODIC SEQUENCE
C     3.   RFFTB     BACKWARD TRANSFORM OF A REAL COEFFICIENT ARRAY
C
C
      implicit NONE
C
c---------------------
C
      INTEGER ::      ND(10)
      REAL ::         X(200)     ,Y(200)     ,W(2000)    ,
     1                XH(200)

      real :: sqrt2,fn,tfn,pi,dt,sum1,sum2,arg,arg1
      real :: rftf,rftb,rftfb,cf,sum
      integer :: nns,nz,n,modn,np1,nm1,i,j,k,ns2

c---------------------
      DATA ND(1),ND(2),ND(3),ND(4),ND(5),ND(6),ND(7)/120,54,49,32,4,3,2/

      SQRT2 = SQRT(2.)
      NNS = 7
      DO 157 NZ=1,NNS
         N = ND(NZ)
         MODN = MOD(N,2)
         FN = FLOAT(N)
         TFN = FN+FN
         NP1 = N+1
         NM1 = N-1
         DO 101 J=1,NP1
            X(J) = SIN(FLOAT(J)*SQRT2)
            Y(J) = X(J)
            XH(J) = X(J)
  101    CONTINUE
C
C     TEST SUBROUTINES r4RFFTI,r4RFFTF AND r4RFFTB
C
         CALL r4RFFTI (N,W)
         PI = 3.14159265358979
         DT = (PI+PI)/FN
         NS2 = (N+1)/2
         IF (NS2 .LT. 2) GO TO 104
         DO 103 K=2,NS2
            SUM1 = 0.
            SUM2 = 0.
            ARG = FLOAT(K-1)*DT
            DO 102 I=1,N
               ARG1 = FLOAT(I-1)*ARG
               SUM1 = SUM1+X(I)*COS(ARG1)
               SUM2 = SUM2+X(I)*SIN(ARG1)
  102       CONTINUE
            Y(2*K-2) = SUM1
            Y(2*K-1) = -SUM2
  103    CONTINUE
  104    SUM1 = 0.
         SUM2 = 0.
         DO 105 I=1,NM1,2
            SUM1 = SUM1+X(I)
            SUM2 = SUM2+X(I+1)
  105    CONTINUE
         IF (MODN .EQ. 1) SUM1 = SUM1+X(N)
         Y(1) = SUM1+SUM2
         IF (MODN .EQ. 0) Y(N) = SUM1-SUM2
         CALL r4RFFTF (N,X,W)
         RFTF = 0.
         DO 106 I=1,N
            RFTF = MAX(RFTF,ABS(X(I)-Y(I)))
            X(I) = XH(I)
  106    CONTINUE
         RFTF = RFTF/FN
         DO 109 I=1,N
            SUM = .5*X(1)
            ARG = FLOAT(I-1)*DT
            IF (NS2 .LT. 2) GO TO 108
            DO 107 K=2,NS2
               ARG1 = FLOAT(K-1)*ARG
               SUM = SUM+X(2*K-2)*COS(ARG1)-X(2*K-1)*SIN(ARG1)
  107       CONTINUE
  108       IF (MODN .EQ. 0) SUM = SUM+.5*FLOAT((-1)**(I-1))*X(N)
            Y(I) = SUM+SUM
  109    CONTINUE
         CALL r4RFFTB (N,X,W)
         RFTB = 0.
         DO 110 I=1,N
            RFTB = MAX(RFTB,ABS(X(I)-Y(I)))
            X(I) = XH(I)
            Y(I) = XH(I)
  110    CONTINUE
         CALL r4RFFTB (N,Y,W)
         CALL r4RFFTF (N,Y,W)
         CF = 1./FN
         RFTFB = 0.
         DO 111 I=1,N
            RFTFB = MAX(RFTFB,ABS(CF*Y(I)-X(I)))
  111    CONTINUE

         WRITE (6,1001) N,RFTF,RFTB,RFTFB
C
 1001    format(' shortened test.f: N=',i5/
     >        '    RFTF = ',1pe11.4/
     >        '    RFTB = ',1pe11.4/
     >        '    RFTFB= ',1pe11.4)
C
 157  continue

      RETURN
      END

subroutine eqm_gen_boozer(id_iboozer,id_nuboozer,ierr)

  ! generate profiles:
  !   IBoozer:  T*m*radians
  !      I(theta,rho) = Ib(rho)*thetab(theta,rho)
  !      where Ib(rho) = [Enclosed current, amps, vs. rho]*mu/2pi
  !      thetab(rho) = Boozer poloidal angle theta, 0:2pi
  !
  !   NuBoozer:  radians
  !      nu(theta,rho) -- periodic, 0 @ 1st & last theta point
  !        = zeta - phi, where zeta is the Boozer toroidal component.
  !
  !   These profiles satisfy
  !      mod(Bpol) = 
  !        (dLp/dtheta)**-1 * ( d(Iboozer)/dtheta + g(rho)*d(nu)/dtheta )
  !
  !      where g(rho) = R*B_phi, T*m.
  !
  !   The profiles are computed on the grids of the equilibrium 
  !   {R,Z}(theta,rho)
  !
  !   Note that I(theta,rho) has a branch cut at the end points of the
  !   equilibrium theta grid.  Since other theta grids could have different
  !   endpoints, user code may need to know this...

  use xplasma_obj_instance
  use eq_module

  implicit NONE

  integer, intent(out) :: id_iboozer   ! I(theta,rho) xplasma ID
  integer, intent(out) :: id_nuboozer  ! nu(theta,rho) xplasma ID
  integer, intent(out) :: ierr         ! status code (0=OK)

  !---------------------------

  call xplasma_gen_boozer(s,id_iboozer,id_nuboozer,ierr)

  if(ierr.ne.0) then
     write(lunerr,*) &
          ' ?eqm_gen_boozer: xplasma_gen_boozer call failed:'
     call xplasma_error(s,ierr,lunerr)
  endif
 
end subroutine eqm_gen_boozer

SUBROUTINE screvolvedes(g11)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: half, one
  use scrunch_inc1
  implicit none
  integer :: i
  real(fp) :: fac
  real(fp) :: b1
  real(fp) :: otav
  real(fp) :: dtau
  real(fp) :: g11
  real(fp) :: ftest
  real(fp) :: bmax

  bmax = 0.15_fp
  ftest=gnorm/g11
  dtau=abs(one-ftest)
  g11=gnorm
  otav=dtau/delt
  dtau=delt*otav+.001_fp
  if(dtau.gt.bmax)dtau=bmax
  b1=one-half*dtau
  fac=one/(one+half*dtau)
  do i=1,n2
    xdot(i)=fac*(xdot(i)*b1-delt*gvec(i))
    xvec(i)=xvec(i)+xdot(i)*delt
  end do
  return
end SUBROUTINE screvolvedes

subroutine fluxav_brk_init(control)
 
  use fluxav
  implicit NONE
 
!
!  initialize break lists to contain 2 elements each:  min & max limiting
!  points of the corresponding coordinate dimension
!
  character*(*) control
!
  integer icheck
!
!---------------------------------------------------
  icheck=0
!
  if((control.eq.'all').or.(control.eq.'rho')) then
     if (n_rhomax.eq.0) call fluxav_balloc('rho',4)
     n_rhobrk=0
     icheck=icheck+1
  endif
!
  if((control.eq.'all').or.(control.eq.'th')) then
     if (n_thmax.eq.0)  call fluxav_balloc('th',4)
     n_thbrk=0
     icheck=icheck+1
  endif
!
  if((control.eq.'all').or.(control.eq.'phi')) then
     if (n_phimax.eq.0) call fluxav_balloc('phi',4)
     n_phibrk=0
     icheck=icheck+1
  endif
!
  if(icheck.eq.0) then
     write(lunerr,*) ' ?fluxav_brk_init:  no action taken:'
     write(lunerr,*) '  invalid control string:  "',control,'"'
  endif
!
  return
!
end subroutine fluxav_brk_init

SUBROUTINE scraborter(iu,message)
  implicit none
  integer, intent(in) :: iu
  character(len=*), intent(in) :: message

  write(iu,*) '  nscrunch(scraborter) abnormal exit message:'
  write(iu,*) trim(message)

  return
END SUBROUTINE scraborter
 
SUBROUTINE scrabwarn(iu,message)
  implicit none
  integer, intent(in) :: iu
  character(len=*), intent(in) :: message

  write(iu,*) '  nscrunch(scrabwarn) warning message:'
  write(iu,*) trim(message)

  return
END SUBROUTINE scrabwarn
 

SUBROUTINE scrgetangldes(rval,zval,xpts,rcenter,zcenter)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, twopi
  use scrunch_inc1
  implicit none
  real(fp) :: del_ang
  real(fp) :: denom
  real(fp) :: dnum
  real(fp) :: yc
  real(fp) :: xc
  integer :: iterate
  integer :: j
  integer :: i
  real(fp), dimension(ntheta,*), intent(in) :: rval, zval
  real(fp), dimension(ntheta,*), intent(out) :: xpts
  real(fp), dimension(*), intent(in) :: rcenter, zcenter
  real(fp), dimension(nphi) :: rcos, rsin, zcos, zsin, phi_ang
  !**********************************************************************
  !       Compute angle offset consistent with constraint Z1n = Z1,-n
  !       Note: This is done iteratively, since elongation is unknown
  !**********************************************************************
  do i = 1,nphi
    do j = 1,nthetax
      xpts(j,i) = twopi*(j-1)/DBLE(nthetax)
    end do
  end do
  do iterate = 1,5
    do i = 1,nphi
      rcos(i) = zero
      rsin(i) = zero
      zcos(i) = zero
      zsin(i) = zero
      do j = 1,nthetax
        xc = rval(j,i) - rcenter(i)
        yc = zval(j,i) - zcenter(i)
        rcos(i) = rcos(i) + cos(xpts(j,i))*xc
        rsin(i) = rsin(i) + sin(xpts(j,i))*xc
        zcos(i) = zcos(i) + cos(xpts(j,i))*yc
        zsin(i) = zsin(i) + sin(xpts(j,i))*yc
      end do
    end do
    !**********************************************************************
    !       Compute new angles starting from offset phi_ang(i)
    !**********************************************************************
    dnum = zero
    denom= zero
    do i = 1,nphi
      dnum = dnum + zsin(i)
      denom= denom+ rcos(i)
    enddo
    elongate = dnum/denom
    del_ang = zero
    do i = 1,nphi
      phi_ang(i) = atan2(elongate*zcos(i)-rsin(i), &
           elongate*zsin(i)+rcos(i))
      del_ang = max(del_ang,abs(phi_ang(i)))
      do j = 1,nthetax
        xpts(j,i) = xpts(j,i) + phi_ang(i)
      end do
    end do
    if(del_ang.lt.0.02_fp) go to 40
  end do
40 if (ioflagc) write(lunmsg,*)' Average elongation = ',elongate
end SUBROUTINE scrgetangldes

module eqi_rzbox_module

  use xplasma_obj,only : xplasma
  implicit NONE

  private
  public :: sp,nsrch0,nsrch1

  type (xplasma), pointer :: sp

  integer, parameter :: nsrch0=60       ! #of poloidal zones for search
  integer, parameter :: nsrch1=nsrch0+1 ! #of zone bdys (1st & last coincide)

end module eqi_rzbox_module

      subroutine eq_bget(ivec,zrho,zchi,zphi,irzmode,
     >   bvec,nregion,ierr)
c
c  vectorized interpolation routine.
c  get B field @ (rho,chi,phi)
c        ivec < 0 indicates reversed chi
c
c    if irzmode=1:  BR,BZ,Bphi
c    if irzmode=0:  Brho,Bchi,Bphi -- Brho in dir. normal to flux surface,
c                                     should be zero.
c
      implicit NONE
c input:
      integer ivec                      ! vector dimensioning
      real*8 zrho(abs(ivec)),zchi(abs(ivec)),zphi(abs(ivec)) ! (rho,chi,phi) target coords
c
      integer irzmode                   ! =1: B vector in cyl coords.
c
c output:
      real*8 bvec(3,abs(ivec))               ! the B field components
      integer nregion(abs(ivec))             ! region code, 1= inside core
c
      integer ierr                      ! completion code, 0=OK
c
c--------------------------
c
      real*8 zR(abs(ivec)),zZ(abs(ivec))
c
c--------------------------
c
      call eqmap_bget(ivec,zrho,zchi,zphi,zR,zZ,irzmode,
     >   bvec,nregion,ierr)
c
      return
      end
c---------------------------------------------------------------------
      subroutine eq_bgrad(ivec,zrho,zchi,zphi,irzmode,
     >   bvec,gbtensr,nregion,ierr)
c
c  vectorized interpolation routine.
c  get B field @ (rho,chi,phi)
c        ivec < 0 indicates reversed chi
c  get gradient of B
c     if irzmode=1:  (df/dR,df/dZ,(1/R)*df/dphi) of (BR,BZ,Bphi)
c     if irzmode=0:  (df/dsperp,df/dschi,(1/R)*df/dphi) of (Brho,Bchi,Bphi)
c          where sperp = dl in direction normal to flux surface,
c                schi  = dl in chi direction, normal to phi & tangent
c                           to flux surface
c
      implicit NONE
c input:
      integer ivec                      ! vector dimensioning
      real*8 zrho(abs(ivec)),zchi(abs(ivec)),zphi(abs(ivec)) ! (rho,chi,phi) target coords
c
      integer irzmode                   ! =1: B & grad. vector in cyl coords.
c
c output:
      real*8 bvec(3,abs(ivec))               ! the B field components
      real*8 gbtensr(3,3,abs(ivec))          ! gbtensr(1:3,j,iv)=grad(Bvec(j,iv))
      integer nregion(abs(ivec))             ! region code, 1=inside core
c
      integer ierr                      ! completion code, 0=OK
c
c--------------------------
c
      real*8 zR(abs(ivec)),zZ(abs(ivec))
c
c--------------------------
c
      call eqmap_bgrad(ivec,zrho,zchi,zphi,zR,zZ,irzmode,
     >   bvec,gbtensr,nregion,ierr)
c
      return
      end
C--------------------------------------------------------------------
      subroutine eqmap_bget(ivec,zrho,zchi,zphi,zR,zZ,irzmode,
     >   bvec,nregion,ierr)
c
c  vectorized interpolation routine.
c  get B field @ (rho,chi,phi)
c        ivec < 0 indicates reversed chi
c
c    if irzmode=1:  BR,BZ,Bphi
c    if irzmode=0:  Brho,Bchi,Bphi -- Brho in dir. normal to flux surface,
c                                     should be zero.
c
c  also return (R,Z) of target points
c
      IMPLICIT NONE
c
c  input:
      integer ivec                      ! vector dimensioning
      real*8 zrho(abs(ivec)),zchi(abs(ivec)),zphi(abs(ivec)) ! (rho,chi,phi) target coords
c
      integer irzmode                   ! =1: B vector in cyl coords.
C
C  output:
      real*8 zR(abs(ivec)),zZ(abs(ivec))          ! (R,Z) of target points
      REAL*8 bvec(3,abs(ivec))               ! B field vector
C
      integer nregion(abs(ivec))             ! region code for (R,Z,phi) 1=inside
      integer ierr                      ! completion code, 0=OK
C
C--------------------------
C
      integer nlist
      integer imap
      REAL*8 zdumv(abs(ivec),1),zdumgv(3,abs(ivec),1)
      REAL*8 ztol
      REAL*8 fgrad(3,abs(ivec))              ! (R,Z,phi) gradient of f
      real*8 gbtensr(3,3,abs(ivec))
      integer iveca,lunerr
      logical :: ccwflag
C
C--------------------------
C
      if((irzmode.lt.0).or.(irzmode.gt.1)) then
         call eq_get_lunerr(lunerr)
         write(lunerr,*) ' ?eqmap_bget:  invalid irzmode=',irzmode
         ierr=1
      endif
c
      if(ierr.eq.1) then
         nregion=0
         bvec=0.0d0
         return
      endif
c
      nlist=0
      imap=3-irzmode
      ztol=0.0d0
      iveca=abs(ivec)
      ccwflag=ivec.gt.0
c
      call eqi_getall(iveca,ccwflag,zR,zZ,zphi,imap,zrho,zchi,ztol,0,
     >   1,bvec,gbtensr,nlist,(/ 0 /),iveca,zdumv,zdumgv,
     >   nregion,ierr)
C
      return
      end
C--------------------------------------------------------------------
      subroutine eqmap_bgrad(ivec,zrho,zchi,zphi,zR,zZ,irzmode,
     >   bvec,gbtensr,nregion,ierr)
c
c  vectorized interpolation routine.
c  get B field @ (rho,chi,phi)
c        ivec < 0 indicates reversed chi
c  get gradient of B
c     if irzmode=1:  (df/dR,df/dZ,(1/R)*df/dphi) of (BR,BZ,Bphi)
c     if irzmode=0:  (df/dsperp,df/dschi,(1/R)*df/dphi) of (Brho,Bchi,Bphi)
c          where sperp = dl in direction normal to flux surface,
c                schi  = dl in chi direction, normal to phi & tangent
c                           to flux surface
c
c  also return (R,Z) of target points
c
      IMPLICIT NONE
c
c  input:
      integer ivec                      ! vector dimensioning
      real*8 zrho(abs(ivec)),zchi(abs(ivec)),zphi(abs(ivec)) ! (rho,chi,phi) target coords
c
      integer irzmode                   ! =1: grad. vector in cyl coords.
C
C  output:
      real*8 zR(abs(ivec)),zZ(abs(ivec))          ! (R,Z) of target points
C
      real*8 bvec(3,abs(ivec))               ! the B field components
      real*8 gbtensr(3,3,abs(ivec))          ! gbtensr(1:3,j,iv)=grad(Bvec(j,iv))
      integer nregion(abs(ivec))             ! region code for (R,Z,phi) 1=inside
      integer ierr                      ! completion code, 0=OK
C
C--------------------------
C
      integer nlist
      integer imap
      REAL*8 zdumv(abs(ivec),1),zdumgv(3,abs(ivec),1)
      REAL*8 ztol
      integer iveca,lunerr
      logical :: ccwflag
C
C--------------------------
C
      if((irzmode.lt.0).or.(irzmode.gt.1)) then
         call eq_get_lunerr(lunerr)
         write(lunerr,*) ' ?eqmap_bget:  invalid irzmode=',irzmode
         ierr=1
      endif
c
      if(ierr.eq.1) then
         nregion=0
         return
      endif
c
      nlist=0
      imap=3-irzmode
      ztol=0.0d0
      iveca=abs(ivec)
      ccwflag=ivec.gt.0
c
      call eqi_getall(iveca,ccwflag,zR,zZ,zphi,imap,zrho,zchi,ztol,1,
     >   1,bvec,gbtensr,nlist,(/ 0 /),iveca,zdumv,zdumgv,
     >   nregion,ierr)
c
      return
      end

subroutine eqi_xpsi(nR,nZ,zR,zZ,zg_bdy,zpsi_bdy,nsnccwb,nsnccwi, &
     bra,bza,bphia,psia,ierr)

  use xplasma_definitions
  use eqi_rzbox_module

  use ezspline
  use ezspline_obj

  !  AD HOC field and Psi(R,Z) extrapolation
  !  smooth, stable, fast, reasonable but not physical!

  !  mod DMC 19 Apr 2006 -- "imethod" argument deleted.
  !  DMC May 2006 -- adapted for Xplasma Vsn 2...

  implicit NONE

  integer, intent(in) :: nR,nZ         ! R & Z grid sizes
  real*8, intent(in) :: zR(nR),zZ(nZ)  ! R & Z grids
  real*8, intent(in) :: zg_bdy         ! R*|Bphi| at plasma bdy
  real*8, intent(in) :: zpsi_bdy       ! Psi at bdy

  integer, intent(in) :: nsnccwb       ! Bphi field sign
  integer, intent(in) :: nsnccwi       ! Jphi sign
  !  +1:  points counter-clockwise (ccw) in tokamak viewed from above


  !  output fields and Psi -- only at points beyond plasma boundary!
  !      BR         BZ         Bphi         Psi
  real*8 bra(nR,nZ),bza(nR,nZ),bphia(nR,nZ),psia(nR,nZ)


  integer ierr                         ! completion code, 0=normal

  !  compute the internal BR and BZ on a cartesian grid; then use an
  !  extrapolation method to get BR and BZ outside.
  !    also compute psi(poloidal)

  !  earlier versions extrapolated psi(R,Z) (hence "xpsi" name) but
  !  the current algorithm works with B directly -- 2d axisymmetric
  !  geometry.  method seems less error prone (dmc Jan 2000)

  !  the (R,Z) (rho,chi) binlinear inverse map is extended to the
  !  extrapolated pseudo-magnetic coordinate space beyond the plasma
  !  boundary

  !  the points beyond the boundary are sorted into extrapolated rho
  !  bins to ease interpolation from (rho,chi)->(R,Z) of BR and BZ

  !  2d axisymmetric code

  !  mod dmc 20 Aug 2003 -- imethod argument added --
  !  mod dmc 19 Apr 2006 -- imethod deleted -- ONLY the "ad hoc" method
  !                is available now.

  !  DELETED:
  !   imethod=1 -- use del.B = 0 extrapolation, with del x B = 0 also
  !                until current has to be introduced to stabilize and 
  !                smooth the result (traditional method).

  !                the result can be rough, because the extrapolation
  !                through the eddy-current laden vessel, and coil region
  !                of the tokamak, is exponentially unstable, so...

  !  USED IN ALL CASES:
  !   imethod=2 -- ad hoc method:  for rho>rhobdy, an ad hoc nested
  !                (rho,chi) coordinate system has been formed, a 
  !                pseudo-flux-coordinate system.  Lpol(rho) gives
  !                the poloidal path length of each rho surface:

  !                for Bpol:
  !                Bpol(rho,chi) = Bpol(rhobdy,chi)*Lpol(rhobdy)/Lpol(rho)
  !                is assumed, with direction tangent to the extrapolated
  !                rho surface.

  !                for Bphi, the vacuum value nsnccwb*g(rhobdy)/R is taken.

  !                for the flux function psi: psi is not just a function
  !                of rho for rho>rhobdy.  Instead, psi(rho) is integrated
  !                along the contour [R,Z](rho) @ R=Rmax for each rho surface,
  !                using dpsi = dR*r*Bpol (Bpol=Bz at Rmax of each flux
  !                surface, since the surface tangent is vertical there),
  !                forming psirmx(rho)
  !                Also, chirmx(rho) = chi at Rmax of each rho surface is
  !                computed, and, at rhobdy, f(chi) = R*Bpol/(Rmax*Bpol(Rmax))
  !                is computed.  Then,
  !                   psi(rho,chi) = 
  !                      psi(rhobdy) + (psirmx(rho)-psi(rhobdy))*f(chi_adj)
  !                where chi_adj is a phase adjusted chi based on chirmx(rho).

  !                this leads to a quick, well behaved extrapolation that
  !                has "reasonable" properties for modeling purposes, but
  !                of course is merely ad hoc and non-physical: del.B, 
  !                del x B do not satisfy expected properties, nor does
  !                Bpol = grad(psi)/R outside the boundary...

  !                The results can be plotted with xplasma test programs
  !                which start with a fixed flux bdy interior equilibrium,
  !                e.g. trxpl (accessing TRANSP results)-- dmc Aug 2003.
  !---------------------------------------------------------------------
  !  splines defined for region beyond plasma boundary (rho > rhobdy):

  type (ezspline1) :: lpolspl,psispl,chispl,rbvspl

  !  vs. extrapolated rho coordinate:

  !  lpolspl(rho) = poloidal path length vs. rho
  !  psispl(rho) = psi @ R = Rmax, vs. rho
  !  chispl(rho) = chi (poloidal angle) @ R = Rmax, vs. rho

  !  vs. poloidal angle
  !  fbvspl(chi-chi[Rmax]) = 
  !          [R*Bp](chi;rho=rhobdy)/[Rmax*Bp(Rmax;rho=rhobdy)]

  !  psi(rho,chi) evaluation procedure:
  !    1: find chix = chi-chispl(rho); apply 2pi phase shift if needed;
  !       evaluate fbvspl(chix)
  !    2. evaluate psispl(rho)-psispl(rhobdy)
  !    3. psi = psispl(rhobdy)+fbvspl(chix)*[psispl(rho)-psispl(rhobdy)]

  !  Bpol(rho,chi) evaluation procedure:
  !    mod(Bpol)=Bpol(rhobdy,chi)*Lpolspl(rhobdy)/Lpolspl(rho)
  !    direction = tangent to extrapolated rho-surface
  !    sign = consistent with poloidal field induced by plasma current 
  !           (based on nsnccwi)

  integer isignb                    ! poloidal field sign factor 

  integer ix
  real*8 zchioff
  real*8 zlpol_bdy,zlpol,zlpolp,zRav,zdR,zBZav,zdpsi
  real*8 zbpol,znorm

  integer, parameter :: inchib = 201 ! no. of chi pts at bdy
  real*8, dimension(:), allocatable :: zrpsix,zbzpsix,zwk,zchx,zrho1
  real*8, dimension(:), allocatable :: zbra,zbza,zbphia,zpsia,zlpola
  real*8 zrbvals(inchib,3),zrhobdy(inchib),zf(inchib)

  !---------------------------------------------------------------------

  real*8 zrho,zchi,zZtarg,zphdum,zdum

  real*8, dimension(:), allocatable :: zRtmp,zZtmp,zrhotmp,zchitmp,zphitmp
  logical, dimension(:), allocatable :: ioutsid

  integer jvec,ii,jv,iermax

  real*8, dimension(:), allocatable :: zchia,zpsfac
  real*8, dimension(:,:), allocatable :: zrztan,zbpola

  !  the exterior psi needs a boundary condition to make the poloidal
  !  B field continuous at the boundary
  !------------------------------------------
  integer :: nrhox,id_rhox,id_r,id_br,id_bz,ilist(3)
  integer :: id_Rx,id_Zx,id_chix,id_map,iR,iZ,inc

  real*8, dimension(:), allocatable :: rhox

  real*8, dimension(:), pointer :: eqbuf
  integer, dimension(:), pointer :: idata

  integer :: lrhomap,lchimap

  real*8, parameter :: ZERO=0.0d0
  real*8, parameter :: CPI =3.1415926535897931D+00
  real*8, parameter :: C2PI=6.2831853071795862D+00
  !------------------------------------------

  ierr=0

  call xplasma_find_item(sp,'__RHOX',id_rhox,ierr)
  if(ierr.ne.0) return

  call xplasma_find_item(sp,'__THETAX',id_chix,ierr)
  if(ierr.ne.0) return

  call xplasma_find_item(sp,'__R_EXTRAP',id_Rx,ierr)
  if(ierr.ne.0) return

  call xplasma_find_item(sp,'__Z_EXTRAP',id_Zx,ierr)
  if(ierr.ne.0) return

  call xplasma_grid_size(sp,id_rhox,nrhox,ierr)
  if(ierr.ne.0) return

  call xplasma_common_ids(sp,ierr, id_R=id_R, id_BR=id_br, id_BZ=id_bz)
  if(ierr.ne.0) return

  allocate(rhox(nrhox))
  call xplasma_grid(sp,id_rhox,rhox,ierr)
  if(ierr.ne.0) then
     deallocate(rhox)
     return
  endif

  do

     !  create Lpol and psi splines

     call ezspline_init(lpolspl,nrhox,(/0, 0/),ierr)
     if(ierr.eq.0) then
        lpolspl%x1 = rhox
     else
        call ezspline_error(ierr)
        exit
     endif

     call ezspline_init(psispl,nrhox,(/0, 0/),ierr)
     if(ierr.eq.0) then
        psispl%x1 = rhox
     else
        call ezspline_error(ierr)
        exit
     endif

     call ezspline_init(chispl,nrhox,(/0, 0/),ierr)
     if(ierr.eq.0) then
        chispl%x1 = rhox
     else
        call ezspline_error(ierr)
        exit
     endif

     call ezspline_init(rbvspl,inchib,(/-1, -1/),ierr) ! periodic
     if(ierr.eq.0) then
        do ix=1,inchib
           rbvspl%x1(ix) = (ix-1)*c2pi/(inchib-1)
        enddo
     else
        call ezspline_error(ierr)
        exit
     endif

     zrhobdy=rhox(1)     ! vector of bdy rho values [inchib]

     allocate(zwk(nrhox),zchx(nrhox),zrho1(nrhox))
     allocate(zrpsix(nrhox),zbzpsix(nrhox))
     
     zrho1=rhox(1)       ! vector of bdy rho values [nrhox]

     !  poloidal path length Lpol(rho) of extrapolated surfaces...

     call lpol_gen(zwk,rhox)
     call ezspline_setup(lpolspl,zwk,ierr)
     if(ierr.ne.0) then
        call ezspline_error(ierr)
        exit
     endif

     !  extrapolated psi spline
     !    zwk(...) contains Lpol(x) at grid pts
     !    zchx(...) will contain chi value corresponding to Rmax at 
     !              each x surface

     zphdum=ZERO
     do ix=1,nrhox
        call eqi_rzbox(rhox(ix),zphdum, &
             .FALSE.,zdum,zdum,.TRUE.,zrpsix(ix),zchx(ix), &
             .FALSE.,zdum,zdum,.FALSE.,zdum,zdum, ierr)
        if(ierr.ne.0) exit
     enddo
     if(ierr.ne.0) exit

     !  Bz(rhobdy,chi@Rmax(rho)) evaluated here:

     call xplasma_eval_prof(sp,id_bz, &
          xplasma_rho_coord,zrho1,xplasma_theta_coord,zchx,zbzpsix,ierr)
     if(ierr.ne.0) exit

     !  chi@Rmax vs. rho spline; assure no branch cut...

     zchioff=0
     do ix=2,nrhox
        zchx(ix)=zchx(ix)+zchioff
        if(zchx(ix)-zchx(ix-1).gt.CPI) then
           zchioff=zchioff-C2PI
           zchx(ix)=zchx(ix)-C2PI
        else if(zchx(ix)-zchx(ix-1).lt.-CPI) then
           zchioff=zchioff+C2PI
           zchx(ix)=zchx(ix)+C2PI
        endif
     enddo

     call ezspline_setup(chispl,zchx,ierr)
     if(ierr.ne.0) then
        call ezspline_error(ierr)
        exit
     endif

     !  save sign factor...
     if(zbzpsix(1).lt.0) then 
        isignb=-1
     else
        isignb=1
     endif

     !  will use L(rhobdy)/L(rho)*mod(Bpol(rho,Rmax)) for psi spline...

     zlpol_bdy=zwk(1)
     zbzpsix=abs(zbzpsix)*zlpol_bdy     ! abs(Bz)*Lpol(rhobdy)
     zlpol=zlpol_bdy

     zwk(1)=zpsi_bdy  ! psi at bdy, input
     do ix=2,nrhox
        zlpolp=zlpol                ! Lpol at previous extrap. surface.
        zlpol=zwk(ix)               ! Lpol at next extrap. surface
        zRav=(zrpsix(ix)+zrpsix(ix-1))/2
        zBZav=(zbzpsix(ix)/zlpol+zbzpsix(ix-1)/zlpolp)/2
        zdR=(zrpsix(ix)-zrpsix(ix-1))
        zdpsi=zdR*zRav*zBZav
        zwk(ix)=zwk(ix-1)+zdpsi
     enddo

     call ezspline_setup(psispl,zwk,ierr)
     if(ierr.ne.0) then
        call ezspline_error(ierr)
        exit
     endif

     !  rbv spline: evaluate R(chi),BR(chi),BZ(chi) at desired points,
     !  at rhobdy

     ilist(1)=id_R; ilist(2)=id_BR; ilist(3)=id_BZ
     call xplasma_eval_prof(sp,ilist, &
          xplasma_rho_coord,zrhobdy, &
          xplasma_theta_coord,zchx(1)+rbvspl%x1(1:inchib), &
          zrbvals,ierr)
     if(ierr.ne.0) exit

     do ix=1,inchib
        zf(ix)=zrbvals(ix,1)*sqrt(zrbvals(ix,2)**2+zrbvals(ix,3)**2)
     enddo
     zf=zf/zf(1)                    ! normalized to dimensionless variation
     call ezspline_setup(rbvspl,zf,ierr)
     if(ierr.ne.0) then
        call ezspline_error(ierr)
        exit
     endif

     !  make sure rhomap is available

     call xplasma_ctrans(sp,ierr, &
          R_in=zR(nR/2), Z_in=zZ(nZ/2), &
          rho_out=zrho, theta_out=zchi, maptype=3)
     if(ierr.ne.0) exit

     call xplasma_find_item(sp,'__FASTMAP',id_map,ierr)
     if(ierr.ne.0) exit

     call xplasma_blackbox_retrieve(sp, id_map, ierr, &
          ia_ptr = idata, r8a_ptr = eqbuf)
     if(ierr.ne.0) exit

     lrhomap=idata(1)
     lchimap=idata(2)

     exit
  enddo

  if(allocated(zwk)) deallocate(zwk,zchx,zrho1,zrpsix,zbzpsix)

  if(ierr.ne.0) then
     call xplasma_errmsg_append(sp, &
          ' ?eqi_xpsi ad hoc B(R,Z) extrapolation setup failure.')
     call spl_free
     deallocate(rhox)
     nullify(eqbuf)
     nullify(idata)
     return
  endif

  allocate(zRtmp(nR*nZ),zZtmp(nR*nZ),zrhotmp(nR*nZ),zchitmp(nR*nZ))
  allocate(zphitmp(nR*nZ),ioutsid(nR*nZ))

  jvec=0
  ii=0
  do iz=1,nZ
     do ir=1,nR
        ii=ii+1
        inc=(iz-1)*nR+(ir-1)
        zrho=eqbuf(lrhomap+inc)
        zchi=eqbuf(lchimap+inc)
        if(zrho.le.rhox(1)) then
           ioutsid(ii)=.FALSE.

        else
           !  (R,Z) point is outside plasma bdy -- get extrapolated (rho,chi)
           !  coordinates only, for now

           ioutsid(ii)=.TRUE.

           jvec=jvec+1
           zRtmp(jvec)=zR(ir)
           zZtmp(jvec)=zZ(iz)
           zrhotmp(jvec)=zrho
           zchitmp(jvec)=zchi
           zphitmp(jvec)=ZERO

        endif
     enddo
  enddo

  !  evaluate exterior vector -- just rho,chi (external) coordinates for now

  allocate(zbra(jvec),zbza(jvec),zbphia(jvec),zpsia(jvec),zrho1(jvec))
  allocate(zlpola(jvec),zrztan(jvec,2),zbpola(jvec,2))
  allocate(zchia(jvec),zpsfac(jvec))

  !  evaluate ad hoc extrapolated Bpol

  iermax=0

  zrho1=rhox(1)

  ilist(1)=id_Rx; ilist(2)=id_Zx
  call xplasma_eval_prof(sp,ilist(1:2), &
       xplasma_rhox_coord,zrhotmp(1:jvec), &
       xplasma_thx_coord,zchitmp(1:jvec), &
       zrztan,ierr, ideriv2=1)
  iermax=max(iermax,ierr)

  ilist(1)=id_BR; ilist(2)=id_BZ
  call xplasma_eval_prof(sp,ilist(1:2), &
       xplasma_rho_coord,zrho1,xplasma_theta_coord,zchitmp(1:jvec), &
       zbpola,ierr)
  iermax=max(iermax,ierr)

  call ezspline_interp(lpolspl,jvec,zrhotmp,zlpola,ierr)
  iermax=max(iermax,ierr)

  do jv=1,jvec
     zbpol=sqrt(zbpola(jv,1)**2+zbpola(jv,2)**2)*(zlpol_bdy/zlpola(jv))
     znorm=sqrt(zrztan(jv,1)**2+zrztan(jv,2)**2)
     zbra(jv)=isignb*zrztan(jv,1)*zbpol/znorm
     zbza(jv)=isignb*zrztan(jv,2)*zbpol/znorm
     zbphia(jv)=nsnccwb*zg_bdy/zRtmp(jv)
  enddo

  !  evaluate ad hoc psi

  call ezspline_interp(psispl,jvec,zrhotmp,zpsia,ierr) ! psi @Rmax
  iermax=max(iermax,ierr)

  call ezspline_interp(chispl,jvec,zrhotmp,zchia,ierr)
  iermax=max(iermax,ierr)

  do jv=1,jvec
     zchia(jv)=zchitmp(jv)-zchia(jv) ! adjusted chi
     do                 ! put in range [0,2pi]
        if(zchia(jv).lt.ZERO) then
           zchia(jv)=zchia(jv)+C2PI
        else if(zchia(jv).gt.C2PI) then
           zchia(jv)=zchia(jv)-C2PI
        else
           exit
        endif
     enddo
  enddo

  call ezspline_interp(rbvspl,jvec,zchia,zpsfac,ierr)
  iermax=max(iermax,ierr)

  do jv=1,jvec
     zpsia(jv)=zpsi_bdy+(zpsia(jv)-zpsi_bdy)*zpsfac(jv)
  enddo

  ii=0
  jvec=0
  do iz=1,nz
     do ir=1,nR
        ii=ii+1
        if(ioutsid(ii)) then
           jvec=jvec+1
           bra(ir,iz)=zbra(jvec)
           bza(ir,iz)=zbza(jvec)
           bphia(ir,iz)=zbphia(jvec)
           psia(ir,iz)=zpsia(jvec)
        endif
     enddo                    ! iR
  enddo                             ! Z loop

  deallocate(zbra,zbza,zbphia,zpsia,zrho1)
  deallocate(zlpola,zrztan,zbpola)
  deallocate(zchia,zpsfac)

  call spl_free

  nullify(eqbuf)
  nullify(idata)

contains
  subroutine spl_free

    call ezspline_free(lpolspl,ierr)
    call ezspline_free(psispl,ierr)
    call ezspline_free(rbvspl,ierr)
    call ezspline_free(chispl,ierr)

  end subroutine spl_free

  subroutine lpol_gen(lpol_est,rho)
    real*8, dimension(:), intent(out) :: lpol_est
    real*8, dimension(:), intent(in) ::  rho

    integer :: i,ith,isize
    integer, parameter :: inth=500

    !------------------------------
    real*8 :: thvec(inth)
    real*8 :: rz(inth,2),zsum,zdr,zdz
    integer :: ict(10)

    type (xpeval) :: th_intrp, rho_intrp
    !------------------------------

    isize = size(rho)

    do i=1,inth
       thvec(i)=(i-1)*c2pi/(inth-1)
    enddo

    call xplasma_x_lookup(sp,id_chix, thvec, th_intrp,ierr)
    if(ierr.ne.0) then
       call xpeval_free(th_intrp)
       return
    endif

    do i = 1,isize
       call xplasma_x_lookup(sp,id_rhox, rho(i), rho_intrp,ierr)
       if(ierr.ne.0) exit

       call xplasma_eval_prof(sp,id_Rx,th_intrp,rho_intrp,rz(1:inth,1),ierr)
       if(ierr.ne.0) exit

       call xplasma_eval_prof(sp,id_Zx,th_intrp,rho_intrp,rz(1:inth,2),ierr)
       if(ierr.ne.0) exit

       zsum=0
       do ith=2,inth
          zdr = rz(ith,1)-rz(ith-1,1)
          zdz = rz(ith,2)-rz(ith-1,2)
          zsum = zsum + sqrt(zdr*zdr + zdz*zdz)
       enddo
               
       lpol_est(i)=zsum

    enddo

    call xpeval_free(rho_intrp)
    call xpeval_free(th_intrp)

  end subroutine lpol_gen

end subroutine eqi_xpsi

subroutine eq_fRZ(ivec,zR,zZ,nlist,iflist,ivecd,zans,ierr)

  !  evaluate 1 or more functions f(R,Z)
  !  see also eq_gRZ (below) to evaluate 1st derivatives

  use xplasma_obj_instance
  use eq_module
  IMPLICIT NONE

  !  input:

  integer ivec                      ! input vector dimension
  REAL*8 zR(ivec)                   ! argument -- where to evaluate
  REAL*8 zZ(ivec)                   ! argument -- where to evaluate
  integer nlist                     ! number of functions
  integer iflist(nlist)             ! functions to evaluate

  integer ivecd                     ! output vector dimension

  !  output:

  REAL*8 zans(ivecd,nlist)          ! evaluation results
  integer ierr                      ! completion code (0=OK)

  integer :: iRcoord,iZcoord
  !--------------------------------------------

  call eqi_fRZ_errck(nlist,iflist,iRcoord,iZcoord,ierr)
  if(ierr.ne.0) return

  call xplasma_eval_prof(s,iflist(1:nlist), &
       iRcoord,zR, iZcoord,zZ, zans(1:ivec,1:nlist), &
       ierr)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?xplasma_eval_prof error in eq_frz.f90:'
     call xplasma_error(s,ierr,lunerr)
     zans = 0
  endif

end subroutine eq_fRZ

!===================================================================
subroutine eq_gRZ(ivec,zR,zZ,nlist,iflist,ivecd,zans,ierr)

  !  evaluate 1 or more functions f(R,Z) derivatives df/dR, df/dZ

  use xplasma_obj_instance
  use eq_module
  IMPLICIT NONE

  !  input:

  integer ivec                      ! input vector dimension
  REAL*8 zR(ivec)                   ! argument -- where to evaluate
  REAL*8 zZ(ivec)                   ! argument -- where to evaluate
  integer nlist                     ! number of functions
  integer iflist(nlist)             ! functions to evaluate
  
  integer ivecd                     ! output vector dimension

  !  output:

  REAL*8 zans(ivecd,2,nlist)        ! evaluation results
  integer ierr                      ! completion code (0=OK)

  !  zans(1:ivec,1,j) = df/dR for function id iflist(j)
  !  zans(1:ivec,2,j) = df/dZ for function id iflist(j)
  !--------------------------------------------

  integer :: iRcoord,iZcoord
  integer :: ii,jj
  integer :: iflist2(2*nlist),iRderiv(2*nlist),iZderiv(2*nlist)
  real*8, dimension(:,:), allocatable :: zansb

  !--------------------------------------------

  call eqi_fRZ_errck(nlist,iflist,iRcoord,iZcoord,ierr)
  if(ierr.ne.0) return

  allocate(zansb(ivec,2*nlist))

  jj=0
  do ii=1,nlist
     jj=jj+1
     iflist2(jj)=iflist(ii)
     iRderiv(jj)=1
     iZderiv(jj)=0
     jj=jj+1
     iflist2(jj)=iflist(ii)
     iRderiv(jj)=0
     iZderiv(jj)=1
  enddo

  call xplasma_eval_prof(s,iflist2, &
       iRcoord,zR, iZcoord,zZ, zansb, &
       ierr, &
       ideriv1s=iRderiv, ideriv2s=iZderiv)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?xplasma_eval_prof error in eq_frz.f90:'
     call xplasma_error(s,ierr,lunerr)
     zans = 0

  else
     ierr = 0

     jj=0
     do ii=1,nlist
        jj=jj+1
        zans(1:ivec,1,ii)=zansb(1:ivec,jj)
        jj=jj+1
        zans(1:ivec,2,ii)=zansb(1:ivec,jj)
     enddo
  endif

end subroutine eq_gRZ

subroutine eqi_fRZ_errck(nlist,iflist,iRcoord,iZcoord,ierr)

  !  check that function list arguments are all ok

  !  the first function on the list is probed to determine the [R,Z]
  !  coordinate pair that is in use for this evaluation; the pair may
  !  be reached indirectly through an "associated" profile ID

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  !  input:
  integer nlist                     ! no. of fcns
  integer iflist(nlist)             ! fcn id list

  !  output:
  integer iRcoord                   ! R coordinate ID
  integer iZcoord                   ! Z coordinate ID
  integer ierr                      ! completion code: 0=OK

  !------------------------------------------------------
  integer ii,id,idg1,idg2,irank,icoord1,icoord2,idgR,idgZ,iertmp
  integer ida,iranka,idg1a,idg2a
  character*32 fname,cname1,cname2
  !------------------------------------------------------

  iRcoord=0
  iZcoord=0

  id = iflist(1)

  ! look for grids & associated profile ID

  call xplasma_prof_info(s,id,ierr,rank=irank,gridId1=idg1,gridId2=idg2, &
       profId1=ida)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqi_frz_errck (eq_frz.f90): unexpected info error 1:'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  ! if primary profile is not rank 2, try associated profile

  if(irank.ne.2) then
     if(ida.ne.0) then
        id=ida
        ida=0
        call xplasma_prof_info(s,id,ierr,rank=irank,gridId1=idg1,gridId2=idg2)
     endif
  endif

  ! if associated profile ID is non-zero, then primary profile ID is of rank 2
  ! but still might want associated profile ID data

  if(ida.ne.0) then
     ! rank=2 f(rho,theta) could have associated f(R,Z) @ida
     call xplasma_prof_info(s,ida,ierr,rank=iranka,gridId1=idg1a,gridId2=idg2a)
     if(iranka.ne.2) ida=0  ! ignore assoc. ID if not rank 2
  endif

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqi_frz_errck (eq_frz.f90): unexpected info error 2:'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  if(irank.ne.2) then
     write(lunerr,*) &
          ' ?eqi_frz_errck (eq_frz.f90): not a function of (R,Z): rank=', &
          irank
     ierr=1

  else
     call xplasma_grid_info(s,idg1,iertmp, coord=icoord1)
     ierr=max(ierr,iertmp)
     if((ierr.eq.0).and.(ida.ne.0)) then
        
        ! decide now whether to use ID or IDA data

        call xplasma_coord_info(s,icoord1,iertmp, name=cname1)
        ierr=max(ierr,iertmp)

        if((cname1.ne.'__R').and.(cname1.ne.'__Z').and. &
             (cname1(1:4).ne.'__R_').and.(cname1(1:4).ne.'__Z_')) then

           ! switch to assoc ID grids

           idg1=idg1a
           idg2=idg2a

           call xplasma_grid_info(s,idg1,iertmp, coord=icoord1)
           ierr=max(ierr,iertmp)

        endif
     endif

     call xplasma_grid_info(s,idg2,iertmp, coord=icoord2)
     ierr=max(ierr,iertmp)

     if(ierr.eq.0) then
        call xplasma_coord_info(s,icoord1,iertmp, name=cname1)
        ierr=max(ierr,iertmp)
        call xplasma_coord_info(s,icoord2,iertmp, name=cname2)
        ierr=max(ierr,iertmp)
     endif

     if(ierr.ne.0) then
        write(lunerr,*) ' ?eqi_frz_errck (eq_frz.f90): unexpected coord error:'
        call xplasma_error(s,ierr,lunerr)
     else
        if((cname1.eq.'__R').or.(cname1(1:4).eq.'__R_')) then
           iRcoord=icoord1
        else if((cname1.eq.'__Z').or.(cname1(1:4).eq.'__Z_')) then
           iZcoord=icoord1
        else
           ierr=1
           write(lunerr,*) ' ?eqi_frz_errck: could not decipher as R or Z coordinate: ',trim(cname1)
        endif

        if((cname2.eq.'__R').or.(cname2(1:4).eq.'__R_')) then
           iRcoord=icoord2
        else if((cname2.eq.'__Z').or.(cname2(1:4).eq.'__Z_')) then
           iZcoord=icoord2
        else
           ierr=1
           write(lunerr,*) ' ?eqi_frz_errck: could not decipher as R or Z coordinate: ',trim(cname2)
        endif

        if(iRcoord.eq.0) then
           ierr=1
           write(lunerr,*) ' ?eqi_frz_errck: failed to find R dimension.'
        endif

        if(iZcoord.eq.0) then
           ierr=1
           write(lunerr,*) ' ?eqi_frz_errck: failed to find Z dimension.'
        endif
     endif
  endif

  if(ierr.ne.0) then
     call xplasma_get_item_info(s,id,iertmp, name=fname)
     write(lunerr,*) &
          ' ?eqi_frz_errck (eq_frz.f90): not a function of (R,Z): ', &
          trim(fname)
     RETURN
  endif

  !  OK -- R & Z coords of 1st function found.  All functions must use
  !        these specific R & Z coords (there can be multiple pairs of
  !        R & Z coords, functions cannot be mixed across them).

  ierr=0
  do ii=1,nlist
     id=iflist(ii)

     call xplasma_prof_gridInfo(s,id,iRcoord,idgR,ierr)
     if(ierr.ne.0) exit

     call xplasma_prof_gridInfo(s,id,iZcoord,idgZ,ierr)
     if(ierr.ne.0) exit

     if(min(idgR,idgZ).eq.0) exit
  enddo

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqi_frz_errck (eq_frz.f90): unexpected error:'
     call xplasma_error(s,ierr,lunerr)

  else if(min(idgR,idgZ).eq.0) then
     call xplasma_get_item_info(s,id,iertmp, name=fname)
     write(lunerr,*) &
          ' ?eqi_frz_errck (eq_frz.f90): not a function of (R,Z): ', &
          trim(fname)
     ierr=1

  else
     ierr=0
  endif

end subroutine eqi_fRZ_errck

!-------------------------------------------------------
!  this source file contains the following routines:
!
!    scrunch_rzmom:  input {R,Z} data, return modified {R,Z} data and
!                    corresponding Fourier moments.
!
!    scrunch_rzmom77:  input {R,Z} data, return modified {R,Z} data and
!                    corresponding Fourier moments; no. of moments 
!                    kept can be different than moments array dimension
!
!    scrunch_rz:     input {R,Z} data, return modified {R,Z} data;
!                    scrunch_rzmom is used; Fourier moments not saved.
!
!    scrunch_moms:   input Fourier moments, return modified Fourier 
!                    moments; scrunch_rzmom is used, {R,Z} data is
!                    generated temporarily but not saved.
!
!-------------------------------------------------------
subroutine scrunch_moms(nth,xrho,ns,rmc1d,rms1d,zmc1d,zms1d,imom,iopt,ier)
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: twopi
  implicit none
  !
  integer, intent(in) :: nth    ! size of theta grid to use for {R,Z} expansion
                                ! inth=max(51,nth) actually used...
  integer, intent(in) :: ns     ! no. of surfaces
  real(fp), dimension(ns), intent(in) :: xrho !  = sqrt(phi/philim) (sqrt. tor. flux)
  integer, intent(in) :: imom   ! no. of moments not counting 0'th moment

  real(fp), dimension(0:imom,ns), intent(inout) :: rmc1d  ! rmc1d  R cos moments
  real(fp), dimension(0:imom,ns), intent(inout) :: rms1d  ! rms1d  R sin moments
  real(fp), dimension(0:imom,ns), intent(inout) :: zmc1d  ! zmc1d  Z cos moments
  real(fp), dimension(0:imom,ns), intent(inout) :: zms1d  ! zms1d  Z sin moments

  integer, intent(in) :: iopt   ! option (0=standard, 1=equal arc theta)
  !   iopt in {1,3,5,7} => equal arc; otherwise use standard scrunch theta.

  integer, intent(out) :: ier   ! completion code: 0 = OK
  !
  !------------------ 
  integer :: inth,is,ith,im,jopt
  real(fp), dimension(:,:), allocatable :: r,z
  real(fp) :: ztheta
  real(fp), dimension(imom) :: snthtk, csthtk   ! sin(im*theta),cos(im*theta)
  !------------------
  !  allocate {R,Z}
  !
  inth=max(51,nth)
  !
  allocate(r(inth,ns),z(inth,ns))
  !
  ! use expansion formula to fill in the values

  jopt=iopt
  if(jopt.gt.1) jopt=jopt-2

  do is=1,ns
    do ith=1,inth
      ztheta=(ith-1)*twopi/(nth-1)
      call scrSINCOS(ztheta,imom,snthtk,csthtk)
      r(ith,is)=rmc1d(0,is)
      z(ith,is)=zmc1d(0,is)
      do im=1,imom
        r(ith,is)=r(ith,is)+rmc1d(im,is)*csthtk(im)+rms1d(im,is)*snthtk(im)
        z(ith,is)=z(ith,is)+zmc1d(im,is)*csthtk(im)+zms1d(im,is)*snthtk(im)
      end do
    end do
  end do

  call scrunch_rzmom(r,z,inth, xrho,ns, rmc1d,rms1d,zmc1d,zms1d, imom,jopt,ier)

  deallocate(r,z)

  return
end subroutine scrunch_moms

!-------------------------------------------------------
subroutine scrunch_rz(r,z,nth,xrho,ns,imom,iopt,ier)
!
!  transform r(1:nth,1:ns),z(1:nth,1:ns) to a representation
!  parametrized by the scruncher-optimized theta parameter
!
!  the 1st dimensions of {r,z} contain the present theta variation;
!  r(1,ns)=r(nth,ns) and z(1,ns)=z(nth,ns) is expected to hold
!
!  r(1:nth,1) and z(1:nth,1) contain the magnetic axis (replicated nth times)
!  which should not vary.
!
!  the plasma boundary is in r(1:nth,ns), z(1:nth,ns).
!
!  in the transformation, use truncated Fourier series, with the 0'th
!  moment + `imom' higher moments.
!
!  updown asymmetric surfaces are allowed.
!
!    --dmc 5 Feb 2001--
!
!
  use iso_c_binding, only: fp => c_double
  implicit none

  integer, intent(in) :: nth    ! no. of theta pts
  integer, intent(in) :: ns     ! no. of surfaces

  real(fp), dimension(nth,ns), intent(inout) :: r
  real(fp), dimension(nth,ns), intent(inout) :: z
  real(fp), dimension(ns), intent(in) :: xrho  !  = sqrt(phi/philim) (sqrt. tor. flux)

  integer, intent(in) :: imom   ! no. of moments not counting 0'th moment

  integer, intent(in) :: iopt   ! option: 0=standard, 1=equal arc: th=0:2pi
                                ! option: 2=standard, 3=equal arc: th=-pi:pi
                                !     use odd value of nth to avoid FFT re-eval
                                !     even nth forces FFT re-eval as final step
                                ! option: 5=equal arc: th=0:2pi; re-eval from
                                !         Fourier coefficients as final step
                                ! option: 7=equal arc: th=-pi:pi; re-eval from
                                !         Fourier coefficients as final step

  integer, intent(out) :: ier   ! completion code: 0 = OK
!                             ier=489 means axis pts don't all match
!                             ier=490 means periodicity test failed
!
!
!---------------------------
! local:
!
! Fourier moments description of surfaces
!
  real(fp), dimension(:,:), allocatable :: rmc1d,rms1d,zmc1d,zms1d
!
!---------------------------
!
  allocate(rmc1d(0:imom,ns),rms1d(0:imom,ns))
  allocate(zmc1d(0:imom,ns),zms1d(0:imom,ns))

  call scrunch_rzmom(r,z,nth,xrho,ns,rmc1d,rms1d,zmc1d,zms1d,imom,iopt,ier)

  deallocate(rmc1d,rms1d,zmc1d,zms1d)

  return
end subroutine scrunch_rz


subroutine scrunch_rzmom77(r,z,nth,xrho,ns,rmc1dd,rms1dd,zmc1dd,zms1dd, &
     imomd,imom,iopt,ier)

  ! this routine is like scrunch_rzmom (below) except that the output
  ! moments array dimension and the actual no. of moments can be different.

  ! this routine has the same arguments as scrunch_rz (above) *plus*
  ! the moments sets:
  !
  !    rmc1dd  R cos moments
  !    rms1dd  R sin moments
  !    zmc1dd  Z cos moments
  !    zms1dd  Z sin moments

  use iso_c_binding, only: fp => c_double
  implicit none

  integer, intent(in) :: nth    ! no. of theta pts
  integer, intent(in) :: ns     ! no. of surfaces

  real(fp), dimension(nth,ns), intent(inout) :: r
  real(fp), dimension(nth,ns), intent(inout) :: z
  real(fp), dimension(ns), intent(in) :: xrho !  = sqrt(phi/philim) (sqrt. tor. flux)

  integer, intent(in) :: imomd  ! no. of moments **array dimension**
  integer, intent(in) :: imom   ! no. of moments **used** not counting 0'th moment

  real(fp), dimension(0:imomd,ns), intent(out) :: rmc1dd
  real(fp), dimension(0:imomd,ns), intent(out) :: rms1dd
  real(fp), dimension(0:imomd,ns), intent(out) :: zmc1dd
  real(fp), dimension(0:imomd,ns), intent(out) :: zms1dd

  integer, intent(in) :: iopt   ! option: 0=standard, 1=equal arc: th=0:2pi
  ! option: 2=standard, 3=equal arc: th=-pi:pi
  !     use odd value of nth to avoid FFT re-eval
  !     even nth forces FFT re-eval as final step
  ! option: 5=equal arc: th=0:2pi; re-eval from
  !         Fourier coefficients as final step
  ! option: 7=equal arc: th=-pi:pi; re-eval from
  !         Fourier coefficients as final step

  integer, intent(out) :: ier   ! completion code: 0 = OK

  !                             ier=489 means axis pts don't all match
  !                             ier=490 means periodicity test failed

  !---------------------------------------------
  real(fp), dimension(:,:), allocatable :: rmc1d,rms1d,zmc1d,zms1d
  integer :: imomi
  !---------------------------------------------

  imomi=min(imom,imomd)

  allocate(rmc1d(0:imomi,ns),rms1d(0:imomi,ns))
  allocate(zmc1d(0:imomi,ns),zms1d(0:imomi,ns))

  rmc1dd=0; rms1dd=0; zmc1dd=0; zms1dd=0

  call scrunch_rzmom(r,z,nth,xrho,ns, rmc1d,rms1d,zmc1d,zms1d, imomi,iopt, ier)
  if(ier.eq.0) then
    rmc1dd(0:imomi,ns)=rmc1d(0:imomi,ns)
    rms1dd(0:imomi,ns)=rms1d(0:imomi,ns)
    zmc1dd(0:imomi,ns)=zmc1d(0:imomi,ns)
    zms1dd(0:imomi,ns)=zms1d(0:imomi,ns)
  endif
  deallocate(rmc1d,rms1d,zmc1d,zms1d)

  return
end subroutine scrunch_rzmom77
 

subroutine scrunch_rzmom(r,z,nth,xrho,ns,rmc1d,rms1d,zmc1d,zms1d,imom,iopt, &
     ier)

  ! this routine has the same arguments as scrunch_rz (above) *plus*
  ! the moments sets:
  !
  !    rmc1d  R cos moments
  !    rms1d  R sin moments
  !    zmc1d  Z cos moments
  !    zms1d  Z sin moments

  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, onepi => pi, twopi
  implicit none

  integer, intent(in) :: nth    ! no. of theta pts
  integer, intent(in) :: ns     ! no. of surfaces

  ! numerical surfaces, modified on output:
  real(fp), dimension(nth,ns), intent(inout) :: r
  real(fp), dimension(nth,ns), intent(inout) :: z

  real(fp), dimension(ns), intent(in) :: xrho !  = sqrt(phi/philim) (sqrt. tor. flux)

  integer, intent(in) :: imom   ! no. of moments not counting 0'th moment

  real(fp), dimension(0:imom,ns), intent(out) :: rmc1d
  real(fp), dimension(0:imom,ns), intent(out) :: rms1d
  real(fp), dimension(0:imom,ns), intent(out) :: zmc1d
  real(fp), dimension(0:imom,ns), intent(out) :: zms1d

  integer, intent(in) :: iopt   ! option: 0=standard, 1=equal arc: th=0:2pi
  ! option: 2=standard, 3=equal arc: th=-pi:pi
  !     use odd value of nth to avoid FFT re-eval
  !     even nth forces FFT re-eval as final step
  ! option: 5=equal arc: th=0:2pi; re-eval from
  !         Fourier coefficients as final step
  ! option: 7=equal arc: th=-pi:pi; re-eval from
  !         Fourier coefficients as final step
  ! (all other values equivalent to iopt=0).

  integer, intent(out) :: ier   ! completion code: 0 = OK

  !                             ier=489 means axis pts don't all match
  !                             ier=490 means periodicity test failed

  !---------------------------------------------
  ! local:
  ! indices, etc.

  integer :: i,j,k,im
  real(fp) :: ztheta
  real(fp), dimension(imom) :: snthtk, csthtk   ! sin(im*theta),cos(im*theta)

  logical :: ifft_eval
  logical :: ipi_shift
  integer :: itest,icen

  real(fp), dimension(:), allocatable :: zwk

  !-------------------------------------------------
  !  executable code...

  ier=0
  do j=2,nth
    if((r(j,1).ne.r(1,1)).or.(z(j,1).ne.z(1,1))) then
      ier=489
    end if
  end do
  if(ier.ne.0) return

  do i=2,ns
    if((r(1,i).ne.r(nth,i)).or.(z(1,i).ne.z(nth,i))) then
      ier=490
    end if
  end do
  if(ier.ne.0) return

  if((iopt.eq.1).or.(iopt.eq.3).or.(iopt.eq.5).or.(iopt.eq.7)) then

    call eq_arc_scrunch(r,z,nth,ns,rmc1d,rms1d,zmc1d,zms1d,imom,ier)
    ! r & z defined over (0:2pi) now

    if(iopt.eq.1) then
      ifft_eval=.FALSE.
      ipi_shift=.FALSE.

    else if(iopt.eq.3) then
      ipi_shift=.TRUE.
      itest = nth/2
      itest = 2*itest
      if(nth.eq.itest) then
        ! even number
        ifft_eval=.TRUE.
      else
        ! odd number; FFT re-eval avoided
        ifft_eval=.FALSE.
      end if
    else if(iopt.eq.5) then
      ifft_eval=.TRUE.
      ipi_shift=.FALSE.
    else if(iopt.eq.7) then
      ifft_eval=.TRUE.
      ipi_shift=.TRUE.
    end if

  else
    call scriscrunchx(xrho,r,z,nth,ns,rmc1d,rms1d,zmc1d,zms1d,2,ns, &
         imom,ier)

    ifft_eval=.TRUE.
    ipi_shift= (iopt.eq.2)

  end if

  if(ier.ne.0) then
    ! ZERO all outputs
    rmc1d = zero
    rms1d = zero
    zmc1d = zero
    zms1d = zero
    r = zero
    z = zero

  else
    rms1d(0,:)=zero    ! make sure these unused array elements are defined
    zms1d(0,:)=zero

    if(ifft_eval) then

      ! regenerate {R,Z} from scrunched moments

      ! start at 2nd surface (axis is not moved).

      do i=2,ns
        do j=1,nth-1
          if(ipi_shift) then
            ztheta= -onepi + (j-1)*twopi/(nth-1)
          else
            ztheta=(j-1)*twopi/(nth-1)
          end if
          call scrSINCOS(ztheta,imom,snthtk,csthtk)
          r(j,i)=rmc1d(0,i)
          z(j,i)=zmc1d(0,i)
          do im=1,imom
            r(j,i)=r(j,i)+rmc1d(im,i)*csthtk(im)+rms1d(im,i)*snthtk(im)
            z(j,i)=z(j,i)+zmc1d(im,i)*csthtk(im)+zms1d(im,i)*snthtk(im)
          end do
        end do
        r(nth,i)=r(1,i)
        z(nth,i)=z(1,i)
      end do

    else if(ipi_shift) then
      !  th=0:2pi -> th=-pi:pi w/o FFT re-eval.  nth must be odd.

      allocate(zwk(nth))
      icen = nth/2 + 1
      do i=2,ns
        zwk(1)=r(icen,i)
        zwk(nth)=zwk(1)
        k=icen
        do j=2,nth-1
          k=k+1
          if(k.gt.nth) k=2
          zwk(j)=r(k,i)
        end do
        r(1:nth,i)=zwk

        zwk(1)=z(icen,i)
        zwk(nth)=zwk(1)
        k=icen
        do j=2,nth-1
          k=k+1
          if(k.gt.nth) k=2
          zwk(j)=z(k,i)
        end do
        z(1:nth,i)=zwk
      end do
      deallocate(zwk)

    end if
  end if

  return
end subroutine scrunch_rzmom

 
#include "fpreproc/byte_declare.h"
 
!----------------------------------------------------------
! cface  -- generated (f90 fixed form) C interface to:  EQ_FLXINT
      SUBROUTINE  C_EQ_FLXINT(
     > C_NAME_LEN,C_NAME,NOPTION,RESULT,INUMCHI,INUMRHO,IERR)
 
      external EQ_FLXINT
 
! argument declarations
 ! scalar char*(*) type, input/output:
      INTEGER C_NAME_LEN
      BYTE_DECLARE C_NAME(C_NAME_LEN)
 
      INTEGER NOPTION
      INTEGER INUMCHI
      INTEGER INUMRHO
      INTEGER IERR
      REAL*8 RESULT(INUMCHI,INUMRHO)
 
! local (automatic array) declarations
      CHARACTER(C_NAME_LEN) :: NAME_act
 
! executable code:  copy for input
 
      call cstring(NAME_act, C_NAME,'2F')
! call to original routine:  EQ_FLXINT
 
      CALL EQ_FLXINT(
     > NAME_act,NOPTION,RESULT,INUMCHI,INUMRHO,IERR)
 
! copy back outputs if modified.
      call cstring(NAME_act, C_NAME,'2C')
 
! exit
      return
      end

subroutine eqm_irhofun(id_axis,zlbl,inprof,zprof,iflag,id,ierr)

  use xplasma_obj_instance
  use eq_module

  !  make XPLASMA profile -- integrated quantity; smooth by 1/2 zone width
  !  to insure smooth derivative from spline

  implicit NONE
  integer, intent(in) :: id_axis    ! axis id -- must be rho or akin to rho
  character*(*), intent(in) :: zlbl ! name for profile function to be created
  integer, intent(in) :: inprof     ! size of the integrated data profile
  real*8, intent(in) :: zprof(inprof) ! the integrated data provided
                         ! if inprof = size(x_axis) zprof(1)=0 is expected
                         ! if inprof = size(x_axis)-1 the axial data point
                         !    is presumed to be omitted.
  integer, intent(in) :: iflag      ! =1 -- volume normalization;
                         ! derivative evaluations -> W/m^3, #/sec/m^3, etc.
                                    ! =2 -- area normalization;
                         ! derivative evaluations -> A/m^2 (current density).

  integer, intent(out) :: id        ! id of stored profile (if successful)
  integer, intent(out) :: ierr      ! completion code, 0=OK.

  !  if an error occurs and ierr is set, id=0 will be returned.

  !-------------------------
  integer :: iertmp
  !-------------------------

  call xoi_author_set(iertmp)

  call xplasma_irhofun(s,id_axis,zlbl,inprof,zprof,iflag,id,ierr)
  if(ierr.ne.0) then
     call xplasma_error(s,ierr,lunerr)
  endif

  call xoi_author_clear(iertmp)

end subroutine eqm_irhofun

subroutine eqm_irhofun_sm(id_axis,zlbl,inprof,zprof,iflag,zsm,id,ierr)

  use xplasma_obj_instance
  use eq_module

  !  make XPLASMA profile -- integrated quantity; smooth by at least 1/2 
  !  zone width or increased amount to insure smooth derivative from spline.

  !  the multiplier on the amount of smoothing is zsm/(x(2)-x(1)), where
  !  (x(2)-x(1)) is the spacing of the id_axis identified rho grid by rho=0.

  implicit NONE
  integer, intent(in) :: id_axis    ! axis id -- must be rho or akin to rho
  character*(*), intent(in) :: zlbl ! name for profile function to be created
  integer, intent(in) :: inprof     ! size of the integrated data profile
  real*8, intent(in) :: zprof(inprof) ! the integrated data provided
                         ! if inprof = size(x_axis) zprof(1)=0 is expected
                         ! if inprof = size(x_axis)-1 the axial data point
                         !    is presumed to be omitted.
  integer, intent(in) :: iflag      ! =1 -- volume normalization;
                         ! derivative evaluations -> W/m^3, #/sec/m^3, etc.
                                    ! =2 -- area normalization;
                         ! derivative evaluations -> A/m^2 (current density).

  real*8, intent(in) :: zsm    ! smoothing width, in units of id_axis (rho)
  !  this gets converted into a multiplier based on the zone spacing at rho=0
  !  the minimal smoothing is basedon the zone spacing; the maximum smoothing
  !  corresponds to a multiplier that yields (1/4) the profile width based
  !  on the zone spacing at rho=0.

  integer, intent(out) :: id        ! id of stored profile (if successful)
  integer, intent(out) :: ierr      ! completion code, 0=OK.

  !  if an error occurs and ierr is set, id=0 will be returned.

  !-------------------------
  integer :: iertmp
  !-------------------------

  call xoi_author_set(iertmp)

  call xplasma_irhofun(s,id_axis,zlbl,inprof,zprof,iflag,id,ierr, smdelx=zsm)
  if(ierr.ne.0) then
     call xplasma_error(s,ierr,lunerr)
  endif

  call xoi_author_clear(iertmp)

end subroutine eqm_irhofun_sm

      SUBROUTINE MCSTR_WORDLIM(LINE,INWORD,DELIMS,IWORD1,IWORD2)
C
C  GIVEN THE ADDRESS OF A CHARACTER IN A "WORD" (SUBSTRING) IN
C  THE MAIN STRING "LINE", FIND THE ADDRESS LIMITS OF THE "WORD"
C  THE STRING DELIMS CONTAINS A LIST OF WORD DELIMITERS
C
C  INPUT -
C   LINE -- A CHARACTER STRING
C   INWORD -- LINE(INWORD:INWORD) IS A CHARACTER OF A "WORD" IN LINE
C   DELIMS -- DELIMITER STRING LIST.  A "WORD" IS A CONSECUTIVE SUB
C             SEQUENCE OF CHARACTERS IN "LINE", NOT IN "DELIMS".
C             LINE(INWORD:INWORD) MUST NOT BE IN DELIMS
C
C  OUTPUT-
C   ERROR:  IF INWORD IS OUT OF BOUNDS OR POINTS TO A DELIMITER,
C    IWORD1=IWORD2=0 ON EXIT
C   NORMAL EXIT:  IWORD1= START OF WORD CONTAINING LINE(INWORD:INWORD)
C                 IWORD2= END OF WORD CONTAINING LINE(INWORD:INWORD)
C
      CHARACTER*(*) LINE
      CHARACTER*(*) DELIMS
C
      L=LEN(LINE)
C
      I=INWORD
C
C  ERROR CHECKS
      IWORD1=0
      IWORD2=0
C  WORD ADDRESS IN BOUNDS?
      IF((I.LE.0).OR.(I.GT.L)) RETURN
C  NOT POINTING AT A DELIMITER?
      IF(INDEX(DELIMS,LINE(I:I)).NE.0) RETURN
C
C  FIND WORD LIMITS; LOOP OVER ALL DELIMITERS
      IDELIMS=LEN(DELIMS)
C
      IWORD1=1
      IWORD2=L
C
      DO 10 ID=1,IDELIMS
        CALL MCSTR_DLIMW(LINE,I,DELIMS(ID:ID),IW1,IW2)
        IWORD1=MAX0(IWORD1,IW1)
        IWORD2=MIN0(IWORD2,IW2)
 10   CONTINUE
C
      RETURN
      END

module cgeq_paths
  save
  !  (not needed in xplasma state file -- eq_save/eq_restore)
  !
  !  MDSplus path settings for EFIT trees
  !  this fragment used by geqdsk_mod and geqdsk_subs in xplasma
  !  ...used for resolution of incompatibilities of EFIT trees maintained
  !  on various experimental devices.
  !
  !  dmc 25 Sep 2003
 
  character*50 :: cgeq_apath = ' '
  character*50 :: cgeq_gpath = ' '
  character*10 :: cgeq_nbdry = ' '
 
end module cgeq_paths

subroutine eqi_dxa_search(iin,iout,nvec,distv,atanv, &
     inth,th,inrho,rho,distf,atanf,atan0, &
     inthb,thb,distb,atanb, &
     rhov,thv,nregion)

  implicit NONE

  !  **utility routine** for fast inverse map based on distance from axis...

  !  GIVEN profiles
  !     distf(ith,irho) = sqrt((R(ith,irho)-Raxis)**2+(Z(ith,irho)-Zaxis)**2)
  !     atanf(ith,irho) = atan2((Z(ith,irho)-Zaxis),(R(ith,irho)-Raxis))
  !  and a vector of points at locations (distv(...),atanv(...)) wrt the 
  !  magnetic axis, return estimates of the corresponding rho and theta
  !  locations.
  
  !  Do not return an answer for points that are closer to the magnetic axis
  !  than the closest points in the mapped region;
  
  !  Do not return an answer for points (j) with nregion(j).gt.0.

  !  If iout>0: set nregion(j)=iout if point (j) is beyond the mapped region;
  !  If iout=0: force point(j) to be considered inside the mapped region.

  !  For points found or considered to be within the mapped region, set
  !  nregion(j)=iin and output the correspond rho & theta values in rhov(j)
  !  and thv(j).

  !  For each target point this is a binary search in both of two dimensions
  !  taking advantage of the fact that d(theta,rho) is monotonic increasing
  !  vs. rho along the ray from the magnetic axis to the target point, and,
  !  the adjusted arctan(theta,rho) is monotonic increasing in theta at fixed
  !  rho.

  !---------------------------
  !  PASSED:

  integer, intent(in) :: iin  ! marker code for items in range
  integer, intent(in) :: iout ! marker code for items beyond range
  ! (force into range if iout=0)

  integer, intent(in) :: nvec ! size of vector of points sought

  real*8, intent(in) :: distv(nvec)  ! distances from mag axis to points sought
  real*8, intent(in) :: atanv(nvec)  ! angle to points sought (wrt mag axis)

  integer, intent(in) :: inth        ! theta (poloidal angle) grid of profiles
  real*8, intent(in) :: th(inth)     ! theta grid values

  integer, intent(in) :: inrho       ! rho (radial flux coordinate) grid
  real*8, intent(in) :: rho(inrho)   ! rho grid values

  real*8, intent(in) :: distf(inth,inrho)  ! distance profile   (from mag axis)
  real*8, intent(in) :: atanf(inth,inrho)  ! arctangent profile (wrt mag axis)
  !  above btw 0 and 2pi, monotonic over 1:inth at each rho, relative to:
  real*8, intent(in) :: atan0(inrho)       ! arctan of th(1) half ray

  !  in some configurations xplasma has higher resolution information at/beyond
  !  a boundary.  So, these inputs are provided s.t. they can be used.
  !  the grid thb(1:inthb) is a superset of th(1:inth).  Any th(j) is matched
  !  by some thb(k).  If inthb=inth, then the grids are identical

  integer, intent(in) :: inthb       ! theta grid @bdy (can be different)
  real*8, intent(in) :: thb(inthb)   ! theta grid values @bdy
  real*8, intent(in) :: distb(inthb) ! distance profile @bdy
  real*8, intent(in) :: atanb(inthb) ! atan info @bdy

  !  arctan((Z(ith,irho)-Zaxis)/(R(ith,irho)-Raxis)) = 
  !                                        atanf(ith,irho) - atan0(irho)

  ! "inout" because some values might not get set on this call...

  real*8, intent(inout) :: rhov(nvec)      ! rho grid values found
  real*8, intent(inout) :: thv(nvec)       ! theta grid values found
  integer, intent(inout) :: nregion(nvec)  ! location code (iin/iout)

  !---------------------------
  !  LOCAL:
  integer :: ivec,nseek
  logical, dimension(:), allocatable :: isdone
  integer, dimension(:), allocatable :: jrho,jrho_min,jrho_max
  real*8, dimension(:), allocatable :: th_minrho,th_maxrho
  real*8, dimension(:,:), allocatable :: dsave,thsave
  real*8, parameter :: C2PI = 6.2831853071795862D+00
  real*8, parameter :: CPI =  3.1415926535897931D+00
  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: ONE = 1.0d0
  real*8 :: d,ata,df,thf,dup,ddown,hd,thup,thdown,dmax,dmin,dfac
  integer :: ith,ithb,krho,krho_new,krho_old,iter
  logical :: step_up
  !---------------------------
  !  work vectors

  allocate(isdone(nvec),jrho(nvec),jrho_min(nvec),jrho_max(nvec))
  allocate(th_minrho(nvec),th_maxrho(nvec))
  allocate(thsave(inrho,nvec),dsave(inrho,nvec))

  nseek=0
  do ivec=1,nvec
     jrho_min(ivec)=0
     jrho_max(ivec)=inrho
     jrho(ivec)=inrho
     if(nregion(ivec).eq.0) then
        isdone(ivec)=.FALSE.
        nseek=nseek+1
     else
        isdone(ivec)=.TRUE.
     endif
  enddo

  iter=0
  do
     if(nseek.eq.0) exit
     iter=iter+1
     if(iter.gt.2*inrho) then
        call errmsg_exit(' fatal error, algorithm failure, eqi_dxa_search.f90')
     endif

     do ivec=1,nvec
        if(isdone(ivec)) cycle

        krho=jrho(ivec)
        d=distv(ivec)

        ata=atanv(ivec)-atan0(krho)
        if(ata.lt.ZERO) ata = ata+C2PI
        if(ata.gt.C2PI) ata = C2PI    ! now guaranteed btw 0 and 2pi

        ith = iget_ith(ata,atanf(1:inth,krho),inth)
        ithb = ith

        if(krho.eq.inrho) then
           if(inthb.gt.inth) then
              ithb = iget_ith(ata,atanb,inthb)
           endif
           df = hfun(ata,0,ithb,distb,atanb,inthb)
           thf = hfun(ata,1,ithb,thb,atanb,inthb)

        else
           df = hfun(ata,0,ith,distf(1:inth,krho),atanf(1:inth,krho),inth)
           thf = hfun(ata,1,ith,th,atanf(1:inth,krho),inth)

        endif

        dsave(krho,ivec)=df
        thsave(krho,ivec)=thf

        if(d.gt.df) then
           if(krho.eq.inrho) then
              ! beyond last surface
              isdone(ivec)=.TRUE.
              nseek=nseek-1
              thv(ivec)=thf
              if(iout.eq.0) then
                 df=d  ! force to boundary
                 rhov(ivec)=rho(inrho)
                 nregion(ivec)=iin
              else
                 rhov(ivec)=rho(inrho)*(d/df)
                 nregion(ivec)=iout
              endif
              cycle
           else
              jrho_min(ivec)=krho
              step_up=.TRUE.
           endif

        else if(d.lt.df) then
           if(krho.eq.1) then
              nregion(ivec)=0
              rhov(ivec)=rho(1)
              thv(ivec)=0
              isdone(ivec)=.TRUE.
              nseek=nseek-1
              cycle
           else
              jrho_max(ivec)=krho-1
              step_up=.FALSE.
           endif

        else
           ! exact match
           isdone(ivec)=.TRUE.
           nseek=nseek-1
           nregion(ivec)=iin
           rhov(ivec)=rho(krho)
           thv(ivec)=thf
           cycle

        endif
           
        if(jrho_min(ivec).eq.jrho_max(ivec)) then
           isdone(ivec)=.TRUE.
           nseek=nseek-1

           krho=jrho_min(ivec)

           dup=dsave(krho+1,ivec)
           ddown=dsave(krho,ivec)

           hd=dup-ddown

           thup=thsave(krho+1,ivec)
           thdown=thsave(krho,ivec)

           !  check for branch cut
           if(thup.gt.thdown+CPI) then
              thup=thup-C2PI
           else if(thup.lt.thdown-CPI) then
              thup=thup+C2PI
           endif

           nregion(ivec)=iin
           rhov(ivec)=(rho(krho)*(dup-d)+rho(krho+1)*(d-ddown))/hd
           thv(ivec)=(thdown*(dup-d)+thup*(d-ddown))/hd
           cycle
        endif

        if(step_up) then
           krho_old=jrho_max(ivec)+1
           dmax=dsave(krho_old,ivec)
           dfac=(d-df)/(dmax-df)
           krho_new = krho+dfac*(krho_old-krho)
           krho_new = max(krho+1,min(krho_old-1,krho_new))

        else
           krho_old=jrho_min(ivec)
           if(krho_old.eq.0) then
              krho_new=max(1,min(krho-1,krho/4))
           else
              dmin=dsave(krho_old,ivec)
              dfac=(d-df)/(dmin-df)
              krho_new=krho+dfac*(krho_old-krho)
              krho_new=max(krho_old+1,min(krho-1,krho_new))
           endif

        endif

        jrho(ivec) = krho_new

     enddo
  enddo

  contains

    integer function iget_ith(ata,atanp,inthp)

      real*8, intent(in) :: ata  ! arctan parameter
      real*8, intent(in), dimension(:) :: atanp  ! arctan grid
      integer, intent(in) :: inthp  ! grid size

      integer :: ith,ithmin,ithmax

      ! binary search in theta
      ithmin=1
      ithmax=inthp

      do 
         if(ata.ge.atanp(ithmax-1)) then
            ith=ithmax-1
            exit
         else if(ata.le.atanp(ithmin+1)) then
            ith=ithmin
            exit
         else
            ithmin=ithmin+1
            ithmax=ithmax-1

            if(ithmax.eq.ithmin+1) then
               ith=ithmin
               exit
            endif

            ith = ithmin + (ithmax-ithmin)* &
                 (ata-atanp(ithmin))/ &
                 (atanp(ithmax)-atanp(ithmin))
            if(ith.ge.ithmax) ith=ithmax-1   ! btw ithmin and (ithmax-1) now.

            if(ata.gt.atanp(ith+1)) then
               ithmin=ith+1

            else if(ata.lt.atanp(ith)) then
               ithmax=ith

            else
               exit
            endif
         endif
      enddo

      iget_ith = ith

    end function iget_ith

    real*8 function hfun(ata,ibranch,ith,funp,atanp,inthp)
      !  Hermite interpolation within a theta zone on a surface
      real*8, intent(in) :: ata  ! arctan of target
      integer, intent(in) :: ibranch  ! 1 if funp has a branch cut
      integer, intent(in) :: ith  ! theta zone (must contain ata)
      real*8, dimension(:), intent(in) :: funp  ! function vs. atan param.
      real*8, dimension(:), intent(in) :: atanp  ! atan param. grid
      integer, intent(in) :: inthp  ! size of funp & atanp

      real*8 :: d0,d1,d0p,d1p,h

      d0=funp(ith)
      d1=funp(ith+1)
      if(ith.gt.1) then
         d0p=(funp(ith+1)-funp(ith-1))/ &
              (atanp(ith+1)-atanp(ith-1))
      else
         d0p=(funp(ith+1)+ibranch*C2PI-funp(inthp-1))/ &
              (atanp(ith+1)+C2PI-atanp(inthp-1))
      endif
      if(ith+1.lt.inthp) then
         d1p=(funp(ith+2)-funp(ith))/ &
              (atanp(ith+2)-atanp(ith))
      else
         d1p=(funp(2)+ibranch*C2PI-funp(ith))/ &
              (atanp(2)+C2PI-atanp(ith))
      endif

      h = (atanp(ith+1)-atanp(ith))

      hfun = hermfa(ata-atanp(ith),h,d0,d0p,d1,d1p)

    end function hfun

    real*8 function hermfa(avar,h,f0,f0p,f1,f1p)

      !  Hermite cubic evaluation...
      real*8, intent(in) :: avar,f0,f0p,f1,f1p,h

      real*8 :: hinv,hi2,f00,f01,f10,f11,avari

      hinv = ONE/h
      hi2 = hinv*hinv

      avari=h-avar

      f00 = hi2*avari*avari*(3-2*avari*hinv)*f0
      f01 = hi2*avar*avar*(3-2*avar*hinv)*f1
      f10 = hinv*avari*avari*(1-avari*hinv)*f0p
      f11 = hinv*avar*avar*(avar*hinv-1)*f1p

      hermfa = f00+f01+f10+f11

    end function hermfa

end subroutine eqi_dxa_search

subroutine eq_rcyl(ivec,xx,yy,zR,zphi)

  !  *vectorized*
  !  cartesian to cylindric conversion; see eq_rcylcs, below
  !    ivec > 0: normal Phi; < 0: Phi orientation reversed

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  integer ivec                 ! vector dimension
  REAL*8 xx(abs(ivec)),yy(abs(ivec))    ! input:  (x,y,[z])
  REAL*8 zR(abs(ivec)),zphi(abs(ivec))  ! output: (R,phi,[z])  ! [z] unaffected

  !------------
  integer :: ier
  logical :: iccw
  !------------

  iccw = ivec.gt.0
  call xplasma_ctrans(s,xp_use_coord_vecsize,ier, &
       x_in=xx, y_in=yy, ccw_phi = iccw, i2pi=2, &
       r_out=zR, phi_out=zphi)

  if(ier.ne.0) then
     write(lunerr,*) ' ?eq_rcyl: error in xplasma_ctrans:'
     call xplasma_error(s,ier,lunerr)
  endif

end subroutine eq_rcyl

!--------------------------------------------------------------------
subroutine eq_rcylcs(ivec,xx,yy,zR,zphi,zcosphi,zsinphi)

  !  *vectorized*
  !  convert from cartesian coordinates (x,y,z) to
  !  cylindric coordinates (R,Z,phi)

  !  also return cos(phi), sin(phi)

  !  sqrt(x**2+y**2)->R
  !  y=0, x>0 half line corresponds to phi=0; phi=atan2(y,x)

  use xplasma_obj_instance
  use eq_module

  implicit NONE

  integer ivec                      ! vector dimension
  REAL*8 xx(abs(ivec)),yy(abs(ivec))    ! input:  (x,y,[z])
  REAL*8 zR(abs(ivec)),zphi(abs(ivec))  ! output: (R,phi,[z])  ! [z] unaffected

  real*8 zcosphi(abs(ivec)),zsinphi(abs(ivec)) ! cos(phi),zin(phi)

  !------------
  integer :: ier
  logical :: iccw
  !-------------------------------

  iccw = ivec.gt.0
  call xplasma_ctrans(s,xp_use_coord_vecsize,ier, &
       x_in=xx, y_in=yy, ccw_phi = iccw, i2pi=2, &
       r_out=zR, phi_out=zphi, cosphi=zcosphi, sinphi=zsinphi)

  if(ier.ne.0) then
     write(lunerr,*) ' ?eq_rcylcs: error in xplasma_ctrans:'
     call xplasma_error(s,ier,lunerr)
  endif

end subroutine eq_rcylcs

      SUBROUTINE MCSTR_DLIMW(LINE,I,CHAR,IW1,IW2)
C
C  SIMILAR TO MCSTR_WORDLIM BUT WITHOUT ERROR CHECK AND
C  ONLY ONE DELIMITER SPECIFIED
C
      CHARACTER*(*) LINE
      CHARACTER*1 CHAR
C
      L=LEN(LINE)
C
      IW1=MAX0(1,(MCSTR_LASTX(LINE(1:I),CHAR)+1))
C
      I2=INDEX(LINE(I:L),CHAR)
      IF(I2.EQ.0) I2=L+2
      IW2=MIN0(L,(I+I2-2))
C
      RETURN
      END

!******************** START FILE R8_PCTRAN.FOR
!
!  R8_PCTRAN   DO PCWISE LINEAR INTERPOLATION TO PROGRAM COORDINATES
!
!  ARGS:
!
!  X  IN    X VALUES TO WHICH TO INTERPOLATE
!  Y  OUT   Y VALUES INTERPOLATED
!  N   IN   DIMENSIONALITY OF X,Y
!
!  XPC  IN  X VALUES FROM WHICH TO INTERPOLATE
!  YPC  IN  Y VALUES FROM WHICH TO INTERPOLATE
!  NPC  IN  # OF X,Y, VALUES
!  MAXPC  IN  DIMENSIONALITY OF XPC,YPC
!
SUBROUTINE R8_PCTRAN(X,Y,N,XPC,YPC,MAXPC,NPC)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: ZERO, HALF, ONE
  implicit none
  ! Arguments
  integer, intent(in) :: n, maxpc, npc
  real(fp), dimension(n), intent(in)    :: x
  real(fp), dimension(n), intent(inout) :: y
  real(fp), dimension(maxpc), intent(in) :: xpc, ypc
  ! Local variables
  real(fp) :: zy
  integer :: i, npm1, j, jp1
  !
  IF(NPC.GT.1) GO TO 10
  IF(NPC.LE.0) ZY=ZERO
  IF(NPC.GT.0) ZY=YPC(1)
  DO I=1,N
    Y(I)=ZY
  END DO
  RETURN
!
10 CONTINUE
!
  DO 15 I=1,N
    IF(X(I).GT.XPC(1)) GO TO 12
    Y(I)=YPC(1)
    GO TO 15
12  CONTINUE
    IF(X(I).LT.XPC(NPC)) GO TO 13
    Y(I)=YPC(NPC)
    GO TO 15
13  CONTINUE
    NPM1=NPC-1
    DO 14 J=1,NPM1
      IF((X(I).GE.XPC(J)).AND.(X(I).LT.XPC(J+1))) GO TO 16
14  CONTINUE
16  CONTINUE
    JP1=J+1
    Y(I)=YPC(J)+(X(I)-XPC(J))*(YPC(JP1)-YPC(J))/(XPC(JP1)-XPC(J))
15 CONTINUE
  RETURN
END SUBROUTINE R8_PCTRAN
 

subroutine eqi_xinv2d(ivec,zrho,zth,zphi,zRtarg,zZtarg,nregion, &
     tol,ztol,zrho_bdy,ierr)
  
  !  Newton inverse map routine (internal) -- axisymmetric case
  !  magnetic coordinates

  use xplasma_definitions
  use eqi_rzbox_module
  IMPLICIT NONE

  integer ivec                      ! vector dimension
  REAL*8 zrho(ivec),zth(ivec)       ! in:  init guess, out:  answer
  REAL*8 zphi(ivec)                 ! in:  phi plane (unmodified)
  REAL*8 zRtarg(ivec),zZtarg(ivec)  ! in:  target point
  integer nregion(ivec)             ! out:  region code
  REAL*8 tol                        ! in:  relative error tolerancey
  REAL*8 ztol                       ! in:  error tolerance in (R,Z) units
  real*8 zrho_bdy                   ! last allowed rho value
  
  integer ierr                      ! out:  completion code, 0=OK

  !-------------------------------------
  !  working vectors...

  !  book-keeping, main loop
  integer, dimension(:), allocatable :: istat,indxo,ireset,ibcros,ibchkd,indxb
  real*8, dimension(:), allocatable :: zrho_use,zth_use,zphi_use
  real*8, dimension(:), allocatable :: zrtarg_use,zztarg_use,zdum,zdist
  real*8, dimension(:), allocatable :: zthb,zrtargb,zztargb,zphib
  real*8, dimension(:), allocatable :: zRdiff,zZdiff,zdeti,zdrho,zdth
  real*8, dimension(:,:), allocatable :: zRZ

  logical :: iskipi,iskipo,iexact
  !------------------

  integer itcount,itck,ibck   ! max iterations; iteration control
  integer ibck2,iertmp
  integer i,j,jvec,nc,iaxis

  REAL*8 zdthmax,zdrhomax

  REAL*8 zrhop,zrhomin

  !------------------
  !  more working vectors...

  integer iflist(6),idths(6),idrhos(6),lRnum,lZnum
  real*8 zstep

  REAL*8 zRaxis,zZaxis              ! 2d axisymm:  axis location

  real*8, parameter :: ceps15 = 1.0d-15
  real*8, parameter :: ZERO =0.0d0
  real*8, parameter :: ONE = 1.0d0
  real*8, parameter :: HALF = 0.5d0
  real*8, parameter :: cpi = 3.1415926535897931D+00

  integer, parameter :: iR=1
  integer, parameter :: iRth=2
  integer, parameter :: iRrho=3

  integer, parameter :: iZ=4
  integer, parameter :: iZth=5
  integer, parameter :: iZrho=6

  integer, parameter :: itmax=40

  integer, parameter :: ilun_dbg=6
  !-------------------------------------

  zdrhomax=0.25d0
  zdthmax=0.60d0

  ierr=0

  call xplasma_common_ids(sp,ierr, id_R=lRnum, id_Z=lZnum)
  if(ierr.ne.0) return

  allocate(zRZ(ivec,6),zRdiff(ivec),zZdiff(ivec),zdeti(ivec))
  allocate(zdrho(ivec),zdth(ivec),zthb(ivec),zrtargb(ivec),zztargb(ivec))
  allocate(zphib(ivec),zdist(ivec),zdum(ivec))
  allocate(zrtarg_use(ivec),zztarg_use(ivec),zphi_use(ivec))
  allocate(zrho_use(ivec),zth_use(ivec))
  allocate(istat(ivec),indxo(ivec),ireset(ivec),ibcros(ivec))
  allocate(ibchkd(ivec),indxb(ivec))

  itcount=0
  iaxis=0

  zrhomin=max(ceps15,tol/10)

  jvec=ivec
  do i=1,ivec
     istat(i)=0
     indxo(i)=i
     ireset(i)=0
     ibcros(i)=0
     ibchkd(i)=0
     nregion(i)=0
     zrho_use(i)=max(zrhomin,zrho(i))
     zth_use(i)=zth(i)
     zphi_use(i)=zphi(i)
     zrtarg_use(i)=zrtarg(i)
     zztarg_use(i)=zztarg(i)
  enddo

  iflist(1:3)=lRnum
  iflist(4:6)=lZnum
  idths=0; idths(2)=1; idths(5)=1
  idrhos=0; idrhos(3)=1; idrhos(6)=1

  zstep = ONE

  !  iterative search loop
  do

     if(itcount.eq.(itmax/2)) zstep = HALF

     !  get value & rho,th derivatives

     call xplasma_RZeval_2d(sp,iflist, &
          xplasma_theta_coord,zth_use, xplasma_rho_coord,zrho_use, &
          zRZ, ierr, ideriv1s=idths,ideriv2s=idrhos)

     if(ierr.ne.0) exit

     !  convergence test

     nc=0
     itck=0
     ibck=0
     ibck2=0
     do i=1,jvec
        zRdiff(i)=zRtarg_use(i)-zRZ(i,iR)
        zZdiff(i)=zZtarg_use(i)-zRZ(i,iZ)

#ifdef __DEBUG
        if(itcount.ge.itmax-10) then
           write(ilun_dbg,1001) &
                indxo(i),zrho_use(i),zth_use(i),zRdiff(i),zZdiff(i)
1001       format(1x,i4,' (rho,th) = (',2(1x,1pd11.4),') (dR,dZ) = (', &
                2(1x,1pd11.4))
        endif
#endif

        if(max(abs(zRdiff(i)),abs(zZdiff(i))).lt.ztol) then
           !  OK
           itck=itck+1
           istat(i)=1
           j=indxo(i)
           zrho(j)=zrho_use(i)
           zth(j)=zth_use(i)
           if(zrho_use(i).gt.ONE) then
              nregion(j)=2
           else
              nregion(j)=1
           endif
        else
           nc=nc+1
           !  another iteration

           zdeti(i)=ONE/(zRZ(i,iRrho)*zRZ(i,iZth)-zRZ(i,iZrho)*zRZ(i,iRth))

           zdrho(i)=zdeti(i)*(zRdiff(i)*zRZ(i,iZth)-zZdiff(i)*zRZ(i,iRth))
           if(zdrho(i).gt. zdrhomax) then
              zdrho(i)=zdrhomax
           else if(zdrho(i).lt.-zdrhomax) then
              zdrho(i)=-zdrhomax
           endif

           zdth(i)=zdeti(i)*(-zRdiff(i)*zRZ(i,iZrho)+zZdiff(i)*zRZ(i,iRrho))
           if(zdth(i).gt.(zdthmax)) then
              zdth(i)=zdthmax
           else if(zdth(i).lt.-zdthmax) then
              zdth(i)=-zdthmax
           endif

           zrhop=zrho_use(i)
           zrho_use(i)=zrho_use(i)+zstep*zdrho(i)
           if((zrho_use(i).eq.ONE).and.(zrhop.gt.ONE).and. &
                (zdrho(i).eq.-zdrhomax)) then
              zrho_use(i)=HALF*(zrho_use(i)+zrhop)
           endif

           !  if interior bdy check was done: use this information.

           if(ibchkd(i).eq.1) then
              zrho_use(i)=min(zrho_use(i),(ONE-ceps15))
           endif
           if(ibchkd(i).eq.2) then
              zrho_use(i)=max(zrho_use(i),(ONE+ceps15))
           endif

           !  check for interior bdy crossing...

           if((zrhop-ONE)*(zrho_use(i)-ONE).le.ZERO) then
              ibcros(i)=ibcros(i)+1
           else
              ibcros(i)=0
           endif

           if(zrho_use(i).gt.zrho_bdy) then
              itck=itck+1
              ibck=ibck+1
              istat(i)=-1
              if(iaxis.eq.0) iaxis=-1

           else if(ibcros(i).eq.4) then

              !  solution is oscillating across the (ONE) boundary-- use bdfind

              itck=itck+1
              ibck2=ibck2+1
              istat(i)=-2
              if(iaxis.eq.0) iaxis=-1

           else
              if(zrho_use(i).lt.ZERO) then

                 !  if cross axis:  for next step, go to other side;
                 !  delta(angle)=0.9*pi
                 !  make it hunt around the axis...

                 zrho_use(i)=-zrho_use(i)
                 if(zth_use(i).gt.ZERO) then
                    zth_use(i)=zth_use(i)-0.9d0*cpi
                 else
  !  .8 instead of .9 here, prevents possible oscillation
                    zth_use(i)=zth_use(i)+0.8d0*cpi
                 endif
              else

  !  normal next step

                 zth_use(i)=zth_use(i)+zstep*zdth(i)
              endif
              if(zrho_use(i).lt.zrhomin) then
                 zrho_use(i)=zrhomin
              endif
           endif

#ifdef __DEBUG
           if(itcount.ge.itmax-10) then
              write(ilun_dbg,*) indxo(i),' status = ',istat(i), &
                   ' new rho,th = ',zrho_use(i),zth_use(i)
              write(ilun_dbg,*) '  Rtarg,Ztarg = ',zRtarg_use(i),zZtarg_use(i)
           endif
#endif
        endif
     enddo

     !  get axis location if needed

     if(iaxis.eq.-1) then
        iaxis=1
        call xplasma_mag_axis(sp,iertmp, zRaxis,zZaxis)

        !  check if any points are close to axis -- if so, declare them
        !  converged...

        do i=1,jvec
           if(istat(i).ne.1) then
              if(max(abs(zRtarg_use(i)-zRaxis), &
                   abs(zZtarg_use(i)-zZaxis)).lt.ztol) then
                 if(istat(i).eq.-1) ibck=ibck-1
                 istat(i)=1
                 nc=nc-1               ! decrement non-converged ctr
                 j=indxo(i)
                 zrho(j)=ZERO
                 zth(j)=ZERO
                 nregion(j)=1
              endif
           endif
        enddo

     endif

     if(ibck.gt.0) then

        !  pts strayed out of bounds... use eqi_bdfind
        !  process resets...

        j=0
        do i=1,jvec
           if(istat(i).eq.-1) then
              if(ireset(i).eq.1) then
                 nregion(i)=4
                 ierr=2511
                 call xplasma_errmsg_append(sp, &
                      ' search crossed boundary more than once.')
                 exit
              endif
              ireset(i)=1
              j=j+1
              zRtargb(j)=zRtarg_use(i)
              zZtargb(j)=zZtarg_use(i)
              zphib(j)=zphi_use(i)
              indxb(j)=i
           endif
        enddo
        if(j.ne.ibck) call errmsg_exit(' ?eqi_xinv2d book-keeping bug!')
        if(ierr.gt.0) exit

        iskipi=.FALSE.
        iskipo=.FALSE.
        iexact=.TRUE.
        call eqi_bdfind(ibck,zRtargb,zZtargb,zphib,zrho_bdy,iskipi,iskipo, &
             iexact,zthb,zdum,zdist,ierr)
        if(ierr.ne.0) exit

        do j=1,ibck
           i=indxb(j)
           zrho_use(i)=zrho_bdy
           zth_use(i)=zthb(j)
           if(zdist(j).gt.ZERO) then
              !  this code left over from original xplasma, but, since
              !  eqi_bdfind screening was already done, it should not be
              !  reached...
              istat(i)=1
              nregion(indxo(i))=3
              zrho(indxo(i))=zrho_use(i)
              zth(indxo(i))=zth_use(i)
              nc=nc-1
           else
              istat(i)=0
              itck=itck-1
           endif
        enddo
     endif

     if(ibck2.gt.0) then

        !  pts oscillating across (ONE) interior boundary

        j=0
        do i=1,jvec
           if(istat(i).eq.-2) then
              if(ibchkd(i).ne.0) then
                 ierr=2511
                 call xplasma_errmsg_append(sp, &
                      '?eqi_xinv2d:  convergence failure (bdy oscillation)')
                 nregion(i)=4
                 exit
              endif
              j=j+1
              zRtargb(j)=zRtarg_use(i)
              zZtargb(j)=zZtarg_use(i)
              zphib(j)=zphi_use(i)
              indxb(j)=i
           endif
        enddo
        if(ierr.ne.0) exit

        if(j.ne.ibck2) call errmsg_exit(' ?eqi_xinv2d book-keeping bug!')

        iskipi=.FALSE.
        iskipo=.FALSE.
        iexact=.TRUE.
        call eqi_bdfind(ibck2,zRtargb,zZtargb,zphib,ONE,iskipi,iskipo,iexact, &
             zthb,zdum,zdist,ierr)
        if(ierr.ne.0) exit

        do j=1,ibck2
           i=indxb(j)
           if(zdist(j).gt.ZERO) then
              zrho_use(i)=ONE+ceps15
              ibchkd(i)=2
           else
              zrho_use(i)=ONE-ceps15
              ibchkd(i)=1
           endif
           zth_use(i)=zthb(j)
           if(abs(zdist(j)).lt.ztol) then
              istat(i)=1                    ! close enough: treat as solution
              if(zdist(j).gt.ZERO) then
                 nregion(indxo(i))=2
              else
                 nregion(indxo(i))=1
              endif
              zrho(indxo(i))=zrho_use(i)
              zth(indxo(i))=zth_use(i)
              nc=nc-1
           else
              istat(i)=0                    ! keep looking...
              itck=itck-1
           endif
        enddo
     endif

     !--------------------------
      if(nc.gt.0) then
         !  another iteration is in store...
         itcount=itcount+1
#ifdef __DEBUG
         if(itcount.eq.itmax-10) then
            write(ilun_dbg,*) '%eqi_xinv2d:  convergence warning!'
         endif
#endif
         if(itcount.gt.itmax) then
            call xplasma_errmsg_append(sp, &
                 '?eqi_xinv2d:  convergence failure (itmax)')
            ierr=2511
            exit
         endif

         if(itck.eq.0) cycle         ! next iteration now

         !  status change -- one of the points converged, or, one of the
         !  points went out of bounds...

         !  first reduce vector to unconverged points oinly

         itck=0
         j=0
         do i=1,jvec
            if(istat(i).ne.1) then
               j=j+1
               if(j.lt.i) then
                  istat(j)=istat(i)
                  indxo(j)=indxo(i)
                  ireset(j)=ireset(i)
                  ibcros(j)=ibcros(i)
                  ibchkd(j)=ibchkd(i)
                  zrho_use(j)=zrho_use(i)
                  zth_use(j)=zth_use(i)
                  zphi_use(j)=zphi_use(i)
                  zrtarg_use(j)=zrtarg_use(i)
                  zztarg_use(j)=zztarg_use(i)
               endif
            endif
         enddo
         jvec=j
         if(jvec.eq.0) call errmsg_exit('eqi_xinv2d: algorithm error!')

  !  ok now do the next iteration

         cycle
      endif

      exit
   enddo

   deallocate(zRZ,zRdiff,zZdiff,zdeti,zdrho,zdth,zthb,zrtargb,zztargb)
   deallocate(zphib,zdist,zdum,zrtarg_use,zztarg_use,zphi_use)
   deallocate(zrho_use,zth_use)
   deallocate(istat,indxo,ireset,ibcros,ibchkd,indxb)

 end subroutine eqi_xinv2d

#include "fpreproc/f77_dcomplx.h"
C******************** START FILE TKBCON.FOR ; GROUP TKBLOAT ******************
C
C-- END FILE #QUADFUNS# ************************************
CFORMFEEDC-- START FILE #TKBCON# ************************************
C----------------------------------------------------------
C  TKBCON
C
C  dmc 27 Dec 1996 -- removing TRCOM so this routine can be used
C  outside TRANSP!  adding passed arguments.
C
C  B.BALET  FEB 1994 : ROUTINE UPDATED TO SUPPORT UP-DOWN ASYMMETRIC CASE
C
C  CONSTRUCT THE NEXT CONSTRUCTED MOMENTS SURFACE
C
      SUBROUTINE r8tkbcon(nlsym,xiblo,isurfx,zrmc,zymc,locmax,nmom,
     >      itflag,ziter)
C
C  nlsym -- .TRUE. if equilibrium is up-down symmetric
C  xiblo(...) -- extrapolated grid
C  isurfx -- index to last known grid pt. + 1
C  zrmc(...),zymc(...) -- local moments sets
C  locmax -- local moments max (array dimension)
C  nmom -- number of active moments
C  itflag -- =0 if this is the first extrapolated surface, gt.0 otherwise
C  ziter -- numerical control
C
C============
C idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      INTEGER locmax,nmom,itflag,isurfx,ith,i1,i2
C============
C idecl:  explicitize implicit REAL declarations:
      REAL*8 ziter,zr0sv,zy0sv,xpi,twopi,zdxi,zr0,zy0,zrad,zdra,zachk,
     > zrmid,zymid,zthanl,zderv,zdervn,zangn,zth,zth0,r8fpolar,zr0l,
     > zrnl,ztharc,zdang1,zdang2,zdang,zrxb,zdrat,zrata,zfac,zl1,zl0,zl,
     > zdl12,zdl22,zfac2,zang
C============
      logical nlsym
      REAL*8 xiblo(isurfx)
      REAL*8 zrmc(3,0:locmax,2)
      REAL*8 zymc(3,0:locmax,2)
C
C  dmc 12 Aug 1994 -- added argument ZITER
C   try for an extrapolation scheme that doesn't bend the theta lines
C   so violently -- ZITER=0.0 gives this new scheme, ZITER=1.0 gives
C   the old scheme, intermediate values give intermediate solutions.
C   ZITER must be in range 0.0 to 1.0 inclusive
C
C   caller (BLOAT) should loop over values of ZITER going from 0.0 to
C   1.0 until a successful (non-singular) extrapolation is achieved.
C
      include 'r8tkbparm.inc'
C
      REAL*8 ZR(NTK),ZY(NTK)
      REAL*8 ZRM1(NTK),ZYM1(NTK),ZRM2(NTK),ZYM2(NTK),ZDIST(NTK)
      REAL*8 ZANGS(2)
C
      SAVE ZR,ZY,ZRM1,ZYM1,ZRM2,ZYM2,ZDIST,ZANGS  !RTM 22 NOV 88
      SAVE ZR0SV,ZY0SV
C
C========================================================================
C
      data xpi/3.141593E0_R8/
      data twopi/6.283185E0_R8/
C
C  NORMALIZED SPATIAL ELEMENT
C
      ZDXI=XIBLO(ISURFX)-XIBLO(ISURFX-1)
C
C  GET DATA ON NEAREST ALREADY CONSTRUCTED SURFACES
C
      CALL r8tkbry2(zrmc,zymc,locmax,nmom,
     >           ZRM1,ZYM1,ZRM2,ZYM2,ZR0,ZY0,ITFLAG)
C
      if(itflag.eq.0) then
         zr0sv=zr0
         zy0sv=zy0
      endif
C
        CALL r8tkbrad(ZRM1,ZYM1,ZR0,ZY0,ZDIST,ZRAD)
C
      ZDRA=ZDXI*ZRAD/XIBLO(ISURFX-1)
C
C  CONSTRUCT R,Y PTS FOR NEW SURFACE
C
      ZACHK=0.04E0_R8*XPI
C
        IF(.not.NLSYM) THEN            !UP-DOWN ASYMMETRIC CASE
C
        ZRMID=ZR0     ! use line integral from TKBRY2
        ZYMID=ZY0
C
        ELSE                            !UP-DOWN SYMMETRIC CASE
C
          ZRMID=0.5E0_R8*(ZRM1(1)+ZRM1(NTK2))
          ZYMID=0.5E0_R8*(ZYM1(1)+ZYM1(NTK2))
C
        ENDIF
C
C  DMC
C  THIS IS AN EMPIRICAL DIFFERENTIAL EXPANSION OF THE FLUX COORD SYSTEM
C
      ZTHANL=TWOPI/NTK
C
      DO 100 ITH=1,NTK
C
C  I1,I2 GIVE NEIGHBOURING PT PTRS
C
        CALL r8tkbndr(ITH,ZRM1,ZYM1,ZRM2,ZYM2,
     >       ZDERV,ZDERVN,ZANGN,ZANGS,I1,I2)
        ZTH=TWOPI*(ITH-1)/AREAL(NTK)
C
        ZTH0=r8fpolar((ZRM1(ITH)-ZRMID),(ZYM1(ITH)-ZYMID))
C
        ZR0L=SQRT((ZRM1(ITH)-ZRMID)**2+(ZYM1(ITH)-ZYMID)**2)
        ZRNL=0.5E0_R8* (
     >        SQRT((ZRM1(I1)-ZRMID)**2+(ZYM1(I1)-ZYMID)**2) +
     >        SQRT((ZRM1(I2)-ZRMID)**2+(ZYM1(I2)-ZYMID)**2) )
C
        ZTHARC=r8fpolar((ZRM1(I1)-ZRMID),(ZYM1(I1)-ZYMID)) -
     >           r8fpolar((ZRM1(I2)-ZRMID),(ZYM1(I2)-ZYMID))
        ZTHARC=ABS(mod((ZTHARC+XPI+TWOPI),TWOPI)-XPI)
C
        ZDANG1=mod((ZTH-ZANGN+XPI+TWOPI),TWOPI)-XPI
        ZDANG2=mod((ZTH-ZTH0 +XPI+TWOPI),TWOPI)-XPI
C
        ZDANG=(ZDANG1+ZDANG2*min(1.0E0_R8,(ZTHANL/ZTHARC)))
C
        ZRXB=1.0E0_R8+ZTHANL/ZTHARC*(ZRNL/ZR0L-1.0E0_R8)
C
C  this number gives the ratio:  avg spacing / local spacing
C   where spacing is dist. btw. flux surfaces.  limit range of factor
C    needed to be fixed for heavily squeezed NSTX cases, dmc Apr 1995
C
        ZDRAT=max(0.4E0_R8,min(2.5E0_R8,(ZDRA/ZDERVN)))
        ZRATA=ZRXB*SQRT(ZRAD/ZDIST(ITH))*ZDRAT**1.5E0_R8
        ZFAC=(1.0E0_R8+ZDXI*(ZRATA-1.0E0_R8))**2
        ZL1=ZDERV*ZFAC
C
        ZDANG=ZDANG*ZFAC *ZITER  ! ziter factor, dmc 12 Aug
C
        zl0=zderv*ZDRAT
        zl= ziter*zl1 + (1.0E0_R8-ziter)*zl0  ! dmc 12 Aug
 
C  MOD DMC - IF PTS GETTING CLOSE TOGETHER, ACCELERATE ANGLE
C  NORMALIZATION (APR 1986)
C
        ZDL12=(ZRM1(I1)-ZRM1(ITH))**2+(ZYM1(I1)-ZYM1(ITH))**2
        ZDL22=(ZRM1(I2)-ZRM1(ITH))**2+(ZYM1(I2)-ZYM1(ITH))**2
C
        ZFAC2=0.5E0_R8*(ZDL12**2+ZDL22**2)/(ZDL12*ZDL22)
C
        ZDANG=ZDANG*ZFAC2
C
        ZANG=min((ZANGS(2)-ZACHK),max((ZANGS(1)+ZACHK),
     >                 (ZANGN+ZDANG)))
C
        ZR(ITH)=ZRM1(ITH)+ZL*COS(ZANG)
          ZY(ITH)=ZYM1(ITH)+ZL*SIN(ZANG)
 100  CONTINUE
C
C  EVALUATE MOMENTS FROM R,Y SEQUENCE
C
cdbg      call r8_grafc3(zr,zy,NTK,zrm1,zym1,NTK,zrm2,zym2,NTK,'cm','cm',
cdbg     >    'TKBCON','NTK PT EXPANSION CONTOURS','DEBUG PLOT')
C
      CALL r8tkbmmc(nlsym,zrmc,zymc,locmax,nmom,ZR,ZY)
C
      RETURN
      END
C******************** END FILE TKBCON.FOR ; GROUP TKBLOAT ******************

module eqi_intg_module

  !  a public module with some XPLASMA pointers
  !  enable communication to integrand routines via integrators, to 
  !  debug plotting routines, etc., where passing a pointer through 
  !  the entire call chain is not practical or desirable...

  use xplasma_obj, only: xplasma
  implicit NONE

  private
  public :: sp,sp_debug

  type (xplasma), pointer :: sp,sp_debug

  integer, parameter, public :: eqi_intg_nfi=10

  integer, parameter, public :: eqi_intg_vol=51         ! Volume
  integer, parameter, public :: eqi_intg_area=52        ! Area
  integer, parameter, public :: eqi_intg_dvdrho=53      ! dV/drho
  integer, parameter, public :: eqi_intg_r2i=54         ! <1/R^2>
  integer, parameter, public :: eqi_intg_itor=55        ! enclosed current
  integer, parameter, public :: eqi_intg_lpol=56
  integer, parameter, public :: eqi_intg_surf=57
  integer, parameter, public :: eqi_intg_dvol=58
  integer, parameter, public :: eqi_intg_darea=59
  integer, parameter, public :: eqi_intg_g2r2i=60
  integer, parameter, public :: eqi_intg_ri=61
  integer, parameter, public :: eqi_intg_r3i=62
  integer, parameter, public :: eqi_intg_r2=63
  integer, parameter, public :: eqi_intg_r1=64
  integer, parameter, public :: eqi_intg_bi=65
  integer, parameter, public :: eqi_intg_b2i=66
  integer, parameter, public :: eqi_intg_b2=67
  integer, parameter, public :: eqi_intg_b1=68
  integer, parameter, public :: eqi_intg_bz2=69
  integer, parameter, public :: eqi_intg_g2b2i=70
  integer, parameter, public :: eqi_intg_g1=71
  integer, parameter, public :: eqi_intg_g2=72
  integer, parameter, public :: eqi_intg_g2r3i=73
  integer, parameter, public :: eqi_intg_g2r2=74
  integer, parameter, public :: eqi_intg_giri=75
  integer, parameter, public :: eqi_intg_fhnclass=76
  integer, parameter, public :: eqi_intg_fhnc_tsc=77

  integer, parameter, public :: eqi_intg_booz_qovg=78

  integer, parameter, public :: eqi_intg_fhmmx=79

  integer, parameter, public :: eqi_intg_br2=80

  integer, parameter, public :: eqi_intg_r=1
  integer, parameter, public :: eqi_intg_drdth=2
  integer, parameter, public :: eqi_intg_drdrho=3

  integer, parameter, public :: eqi_intg_z=4
  integer, parameter, public :: eqi_intg_dzdth=5
  integer, parameter, public :: eqi_intg_dzdrho=6

  integer, parameter, public :: eqi_intg_modb=7
  integer, parameter, public :: eqi_intg_br=8
  integer, parameter, public :: eqi_intg_bz=9

  integer, parameter, public :: eqi_intg_2pirdetj=10

  integer, parameter, public :: eqi_intg_bign=1000000
end module eqi_intg_module

      SUBROUTINE MCRDR_OPEN(LUN,NAME)
C
C  OPEN A FILE - READONLY
C
      CHARACTER*(*) NAME
C
      ILUN=IABS(LUN)
      CLOSE(UNIT=ILUN,ERR=5)
 5    CONTINUE
C
      IF(LUN.GT.0) THEN
        OPEN(UNIT=LUN,FILE=NAME,
     >         status='OLD',ACCESS='SEQUENTIAL')
      ELSE
C
C NONAME OPEN
C
         OPEN(UNIT=ILUN,
     >         status='OLD',ACCESS='SEQUENTIAL')
      ENDIF
C
      RETURN
      END
 
 
 
 
 
 
 
 

subroutine eqm_rzfun2(zname,ifun,userfcn,iarg,iorder,zsm,ierr)

  !  set up function "zname" on (R,Z) grid, Akima-Hermite interpolation

  !    data values from user supplied function  of form:

  !        real*8 userfcn(iarg,zR,zZ,zphi,ierr)

  !    note userfcn is only called with (R,Z,phi) values for points which
  !    are INSIDE the user specified limiters, INCLUDING inside the core
  !    plasma.

  use xplasma_obj_instance
  use eq_module

  implicit NONE

  !  input:
  character*(*) zname               ! user supplied name of function
  external userfcn                  ! user supplied function
  real*8 userfcn
  integer iarg                      ! argument passed through to userfcn

  integer iorder                    ! order of interpolating function

  !  iorder=0  -- piecewise bilinear function
  !  iorder=1  -- piecewise bicubic hermite function
  !  iorder=2  -- piecewise bicubic spline function

  !  iorder=99 -- redefinition of existing f(R,Z) function

  !  iorder=100 -- bilinear data (may be replacement of same sized object)
  !  iorder=101 -- Akima Hermite (may be replacement of same sized object)
  !  iorder=102 or 103 -- spline (may be replacement of same sized object)

  real*8 zsm                        ! smoothing parameter for edge (m)

  !  output:
  integer ifun                      ! xplasma function id (returned)
  integer ierr                      ! completion code, 0=OK

  !---------------------------
  integer :: iorderi,id_Rg,id_Zg,iertmp,nR,nZ
  !---------------------------

  ierr=0

  iorderi=iorder
  if(iorderi.lt.99) iorderi=max(0,min(2,iorderi))
  if(iorderi.ge.100) iorderi=max(0,min(2,(iorderi-100)))

  !  iorderi=99 gets special treatment below...

  call xplasma_find_item(s,'__Rgrid',id_Rg,iertmp)
  ierr=max(ierr,iertmp)
  call xplasma_find_item(s,'__Zgrid',id_Zg,iertmp)
  ierr=max(ierr,iertmp)

  if(ierr.ne.0) then
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  !-----------------
  !  iorderi=99 means request to use prior splining method for this call;
  !  this implies profile must already exist:  check...

  if(iorderi.eq.99) then
     call xplasma_find_item(s,zname,ifun,iertmp)
     if(iertmp.eq.0) then
        call xplasma_prof_info(s,ifun,ierr, splineType=iorderi)
     else
        ierr=iertmp
     endif
     if(ierr.ne.0) then
        call xplasma_error(s,ierr,lunerr)
        call eq_errmsg(' ?eqm_rhofun: iorder=99 call failed: '//trim(zname)// &
             ' does not exist.')
        ierr=1
     endif
  endif
  if(ierr.ne.0) return

  !-----------------
  !  OK...

  call xoi_author_set(iertmp)

  call xplasma_rzprof_fun(s,zname,userfcn,iarg,ifun,ierr, &
       ispline=iorderi,sm_edge=zsm)

  call xoi_author_clear(iertmp)

  if(ierr.ne.0) then
     call xplasma_error(s,ierr,lunerr)
     ierr=1
  endif

end subroutine eqm_rzfun2

subroutine eq_author_set(zname,ierr)

  ! set the author name

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  character*(*), intent(in) :: zname
  integer, intent(out) :: ierr

  call xplasma_author_set(s,zname,ierr)

end subroutine eq_author_set


subroutine eq_author_clear(zname,ierr)

  ! clear the author name

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  character*(*), intent(in) :: zname
  integer, intent(out) :: ierr

  call xplasma_author_clear(s,zname,ierr)

end subroutine eq_author_clear

subroutine eq_rget_sm(inrho,zrho,id,zdelta,zval,ierr)
  !
  !  return a profile interpolated and then smoothed.
  !  caution: not recommended for volume- or area-integrated profiles; see
  !    eq_rget_binsm(...)
  !
  implicit NONE
 
  integer, intent(in) :: inrho           ! target gridsize, must be .gt.1
  real*8, intent(in) :: zrho(inrho)      ! target grid-- strict ascending order
 
  integer, intent(in) :: id              ! function id of f(rho) profile
 
  real*8, intent(in) :: zdelta           ! smoothing parameter
 
  !  zdelta defines the base half-width of a triangular weighting function
  !  used for smoothing.  The smoothed output profile at each rho is
  !  weighted average of the original function over the range
  !    (rho-zdelta,rho+zdelta) with weight 1/zdelta at rho linearly
  !  declining to weight 0 at the end points.  (area of weighting
  !  triangle is unity).
 
  real*8, intent(out) :: zval(inrho)     ! results of smoothed interpolation
 
  !  zval(rho) is a weighted average of the original profile over the
  !            range [rho-zdelta,rho+zdelta] with a triangular weighting
  !            function whose weight goes to 0 at the interval enpoints.
 
  integer ierr  ! completion code 0=OK
 
  !--------------------------------------------
  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: bcav = 0.5d0  ! smoothing bc
  real*8 zsm,zrhomin,zrhomax
  integer ix,lunerr
 
  !--------------------------------------------
  call eq_get_lunerr(lunerr)
  ierr=0
  if(inrho.le.1) then
     write(lunerr,*) ' ?eq_rget_sm: output grid must contain at least 2 pts.'
     ierr=1
  endif
  do ix=2,inrho
     if(zrho(ix).le.zrho(ix-1)) then
        write(lunerr,*) ' ?eq_rget_sm: zrho(...) not in ascending order.'
        ierr=1
        exit
     endif
  enddo
  if(ierr.ne.0) return
 
  if(zdelta.le.ZERO) then
     !  interpolate without smoothing
     call eq_rgetf(inrho,zrho,id,0,zval,ierr)
  else
     !  interpolate with smoothing
     call eq_rholim(zrhomin,zrhomax)
     zsm=min(zdelta,(zrhomax-zrhomin)/4) ! sanity check on smoothing parameter
 
     !  just interpolate and smooth the data (no integrals involved)
     call eq_rgetf(inrho,zrho,id,0,zval,ierr)
     if(ierr.ne.0) return
     call r8_qksmooth(inrho,zrho,zval,zsm,bcav,bcav,ierr)
  endif
 
end subroutine eq_rget_sm

      subroutine eqm_premsg(zmsg)
C
      use eq_module
C
C  set the pre-message for xplasma error handling routines
C  if this is set, each error message is preceded with this message text.
C
      IMPLICIT NONE
C
      character*(*) zmsg
C
c$cface_input:  zmsg
C------------------------------------
C
      eq_premsg_text=zmsg
C
      return
      end

      INTEGER FUNCTION MCSTR_FINDND(STR,DLIST)
C
C  FIND FIRST CHARACTER IN STR WHICH IS *NOT* ANY OF THE CHARACTERS
C  IN DELIMITER LIST DLIST
C
C  RETURN ZERO IF ALL CHARACTERS IN STR ARE ALSO IN DLIST
C
      CHARACTER*(*) STR
      CHARACTER*(*) DLIST
C
      L=LEN(STR)
      ND=LEN(DLIST)
C
      IFIRST=0
C
      DO 20 I=1,L
        DO 10 ID=1,ND
          IF(STR(I:I).EQ.DLIST(ID:ID)) GO TO 20
 10     CONTINUE
C  FOUND
        IFIRST=I
        GO TO 30
C
 20   CONTINUE
C
 30   CONTINUE
      MCSTR_FINDND=IFIRST
      RETURN
      END

subroutine eqi_evenx(x,nx,xtol)

  ! if spacing of x grid varies by less than xtol from the averaged,
  ! rebuild the grid to be precisely evenly spaced to real*8 precision

  implicit NONE

  integer, intent(in) :: nx
  real*8 :: x(nx)  ! can be modified on exit
  real*8, intent(in) :: xtol

  !-----------------------------------
  ! local:

  real*8 :: dx_avg,zdx,ztol,ztest
  integer :: i,iredo

  !-----------------------------------
  !  no error messages, but do sanity checks...

  if(nx.le.1) return
  if(x(nx).le.x(1)) return

  ztol=min(1.d-4,max(1.d-12,xtol))

  dx_avg = (x(nx)-x(1))/(nx-1)

  iredo=1
  do i=1,nx-1
     zdx=x(i+1)-x(i)
     ztest = abs(zdx-dx_avg)/dx_avg
     if(ztest.gt.ztol) then
        iredo=0
        exit
     endif
  enddo

  if(iredo.eq.0) return

  do i=2,nx-1
     x(i)=x(1)+(i-1)*dx_avg
  enddo

end subroutine eqi_evenx

!  this file contains work routines for xplasma_integ_work.f90...
!  mostly f77 style interface, object pointer in eqi_intg_module

subroutine xplasma_integ_wk1(icode,id_R,id_Z,id_Bmod,id_BR,id_BZ, &
     nvec,thvec,rhovec,ansvec,ier)

  use xplasma_definitions
  use eqi_intg_module
  implicit NONE

  integer, intent(in) :: icode                ! code: what to evaluate
  integer, intent(in) :: id_R,id_Z,id_Bmod,id_BR,id_BZ   ! xplasma profile ids

  integer, intent(in) :: nvec                 ! vector size
  real*8, intent(in) :: rhovec(nvec),thvec(nvec) ! input vectors

  real*8, intent(out) :: ansvec(nvec)         ! result...
  integer, intent(out) :: ier                 ! status, 0=OK

  !-------------------------------
  integer :: id,ideriv_rho,ideriv_th
  !-------------------------------

  call xplasma_integ_gid(icode,id_R,id_Z,id_Bmod,id_BR,id_BZ, &
       id,ideriv_th,ideriv_rho,ier)

  if(ier.ne.0) return

  call xplasma_eval_prof(sp,id, &
       xplasma_theta_coord,thvec,xplasma_rho_coord,rhovec, &
       ansvec,ier, ideriv1=ideriv_th,ideriv2=ideriv_rho)

end subroutine xplasma_integ_wk1

subroutine xplasma_integ_wk2(icode,id_R,id_Z,id_Bmod,id_BR,id_BZ, &
     nvec,th_intrp,rho_intrp,ansvec,ier)

  use xplasma_definitions
  use eqi_intg_module
  implicit NONE

  integer, intent(in) :: icode                ! code: what to evaluate
  integer, intent(in) :: id_R,id_Z,id_Bmod,id_BR,id_BZ   ! xplasma profile ids

  integer, intent(in) :: nvec                 ! vector size
  type (xpeval) :: th_intrp,rho_intrp         ! pre-evaluated lookup info

  real*8, intent(out) :: ansvec(nvec)         ! result...
  integer, intent(out) :: ier                 ! status, 0=OK

  !-------------------------------
  integer :: id,ideriv_rho,ideriv_th
  !-------------------------------

  call xplasma_integ_gid(icode,id_R,id_Z,id_Bmod,id_BR,id_BZ, &
       id,ideriv_th,ideriv_rho,ier)

  if(ier.ne.0) return

  call xplasma_eval_prof(sp,id, &
       th_intrp, rho_intrp, &
       ansvec,ier, ideriv1=ideriv_th,ideriv2=ideriv_rho)

end subroutine xplasma_integ_wk2

subroutine xplasma_integ_gid(icode,id_R,id_Z,id_Bmod,id_BR,id_BZ, &
     id,ideriv_th,ideriv_rho,ier)

  !  choose profile id...

  use xplasma_definitions
  use eqi_intg_module
  implicit NONE

  integer, intent(in) :: icode                ! code: what to evaluate
  integer, intent(in) :: id_R,id_Z,id_Bmod,id_BR,id_BZ   ! xplasma profile ids

  integer, intent(out) :: id                  ! id chosen from above set
  integer, intent(out) :: ideriv_th           ! theta derivative control
  integer, intent(out) :: ideriv_rho          ! rho derivative control
  integer, intent(out) :: ier                 ! status, 0=OK

  !------------------------------------------

  id = 0
  ier = 0
  ideriv_th = 0
  ideriv_rho = 0

  if(icode.gt.2*eqi_intg_bign) then

     id = icode - 2*eqi_intg_bign

  else if(icode.gt.eqi_intg_bign) then

     id = icode - eqi_intg_bign

  else if(icode.eq.1) then
     id = id_R

  else if(icode.eq.2) then
     id = id_R
     ideriv_th=1

  else if(icode.eq.3) then
     id = id_R
     ideriv_rho=1

  else if(icode.eq.4) then
     id = id_Z

  else if(icode.eq.5) then
     id = id_Z
     ideriv_th=1

  else if(icode.eq.6) then
     id = id_Z
     ideriv_rho=1

  else if(icode.eq.7) then
     id = id_BMOD

  else if(icode.eq.8) then
     id = id_BR

  else if(icode.eq.9) then
     id = id_BZ

  else

     ier=611
     call xplasma_errmsg_append(sp, &
          ' invalid integrand term id code passed to xplasma_integ_wk1')
  endif

  if(id.eq.0) then
     ier=611
     if(icode.gt.6) then
        call xplasma_errmsg_append(sp, &
             ' integrand term eval failed -- B fields not available.')
     else
        call xplasma_errmsg_append(sp, &
             ' integrand term eval failed -- (R,Z) geometry not available.')
     endif
  endif

end subroutine xplasma_integ_gid

subroutine xplasma_integ_fwk(icode,nth,wk,local_wk,fans,ier)
  
  !  evaluate integrand f -- f*dth to be evaluated

  use xplasma_definitions
  use eqi_intg_module
  implicit NONE

  integer, intent(in) :: icode     ! integration selection code

  integer, intent(in) :: nth       ! number of values to evaluate & array dim.

  real*8, intent(in) :: wk(nth,eqi_intg_nfi)  ! cached data
  real*8, intent(in) :: local_wk(nth)      ! cached data
  !  R, dR/dtheta, ...

  real*8, intent(out) :: fans(nth)   ! integrand vector returned
  integer, intent(out) :: ier      ! set if icode not recognized...

  !--------------------------
  integer :: ith
  real*8 :: zmui
  real*8, parameter :: c2pi = 6.2831853071795862D+00
  real*8, parameter :: cmu0 = 2*c2pi*1.0d-7  ! 4*pi*1.0d-7
  !--------------------------

  ier=0
  if(icode.gt.2*eqi_intg_bign) then
     do ith=1,nth
        fans(ith)=c2pi*local_wk(ith)
     enddo
     
  else if(icode.eq.eqi_intg_vol) then
     do ith=1,nth
        fans(ith)=-c2pi*wk(ith,eqi_intg_r)* &
             wk(ith,eqi_intg_drdth)*wk(ith,eqi_intg_z)
     enddo

  else if(icode.eq.eqi_intg_area) then
     do ith=1,nth
        fans(ith)=-wk(ith,eqi_intg_drdth)*wk(ith,eqi_intg_z)
     enddo

  else if(icode.eq.eqi_intg_dvdrho) then
     do ith=1,nth
        fans(ith)=c2pi*wk(ith,eqi_intg_r)*abs( &
             wk(ith,eqi_intg_drdth)*wk(ith,eqi_intg_dzdrho) - &
             wk(ith,eqi_intg_dzdth)*wk(ith,eqi_intg_drdrho))
     enddo

  else if(icode.eq.eqi_intg_itor) then
     zmui=1.0d0/cmu0
     do ith=1,nth
        fans(ith)=abs(wk(ith,eqi_intg_drdth)*wk(ith,eqi_intg_br) + &
             wk(ith,eqi_intg_dzdth)*wk(ith,eqi_intg_bz))*zmui
        !! fans(ith)=sqrt((wk(ith,eqi_intg_drdth)**2+wk(ith,eqi_intg_dzdth)**2)* &
        !!     (wk(ith,eqi_intg_br)**2+wk(ith,eqi_intg_bz)**2))*zmui
     enddo

  else if(icode.eq.eqi_intg_lpol) then
     do ith=1,nth
        fans(ith)=sqrt(wk(ith,eqi_intg_drdth)**2+wk(ith,eqi_intg_dzdth)**2)
     enddo

  else if(icode.eq.eqi_intg_surf) then
     do ith=1,nth
        fans(ith)=sqrt(wk(ith,eqi_intg_drdth)**2+wk(ith,eqi_intg_dzdth)**2)* &
             c2pi*wk(ith,eqi_intg_r)
     enddo

  else if(icode.eq.eqi_intg_booz_qovg) then
     do ith=1,nth
        fans(ith)=sqrt(wk(ith,eqi_intg_drdth)**2+wk(ith,eqi_intg_dzdth)**2)/ &
             sqrt(wk(ith,eqi_intg_br)**2+wk(ith,eqi_intg_bz)**2)/ &
             (c2pi*wk(ith,eqi_intg_r)**2)
     enddo

  else
     fans=0
     ier=611
     call xplasma_errmsg_append(sp, &
          ' ?invalid integration code passed to xplasma_integ_fwk')
  endif

end subroutine xplasma_integ_fwk


subroutine xplasma_integ_fwkdv(icode,nth_eval,nth_dim,wk,local_wk, &
     bmax,fans,ier)
  
  !  evaluate integrand f*dV/drho -- f*dV/drho*dth to be evaluated

  use xplasma_definitions
  use eqi_intg_module
  implicit NONE

  integer, intent(in) :: icode     ! integration selection code

  integer, intent(in) :: nth_eval  ! number of theta values to evaluate
  integer, intent(in) :: nth_dim   ! number of theta values (array dim.)

  real*8, intent(in) :: wk(nth_dim,eqi_intg_nfi)  ! cached data
  real*8, intent(in) :: local_wk(nth_dim)

  !  R, dR/dtheta, ...

  real*8, intent(inout) :: bmax    ! max(B) on surface, used by some integrands

  real*8, intent(out) :: fans(nth_eval) ! integrand vector returned
  integer, intent(out) :: ier      ! set if icode not recognized...

  !--------------------------
  integer :: ith,idv
  real*8 :: zval,zR,zB,zdl,zd2,zgx,zh,zarg
  real*8, parameter :: c2pi = 6.2831853071795862D+00
  real*8, parameter :: c1 = 1.0d0
  real*8, parameter :: chalf = 0.5d0
  real*8, parameter :: c0 = 0.0d0
  real*8, parameter :: ceps6 = 1.0d-6
  !--------------------------

  idv = eqi_intg_2pirdetj
  ier=0

  if(icode.gt.eqi_intg_bign) then
     do ith=1,nth_eval
        zval=local_wk(ith)
        fans(ith)=wk(ith,idv)*zval
     enddo
  
  else if(icode.eq.eqi_intg_r2i) then
     do ith=1,nth_eval
        zval=wk(ith,eqi_intg_r)
        fans(ith)=wk(ith,idv)/(zval*zval)
     enddo

  else if(icode.eq.eqi_intg_ri) then
     do ith=1,nth_eval
        zval=wk(ith,eqi_intg_r)
        fans(ith)=wk(ith,idv)/zval
     enddo

  else if(icode.eq.eqi_intg_r3i) then
     do ith=1,nth_eval
        zval=wk(ith,eqi_intg_r)
        fans(ith)=wk(ith,idv)/(zval*zval*zval)
     enddo

  else if(icode.eq.eqi_intg_r1) then
     do ith=1,nth_eval
        zval=wk(ith,eqi_intg_r)
        fans(ith)=wk(ith,idv)*zval
     enddo

  else if(icode.eq.eqi_intg_r2) then
     do ith=1,nth_eval
        zval=wk(ith,eqi_intg_r)
        fans(ith)=wk(ith,idv)*zval*zval
     enddo

  else if(icode.eq.eqi_intg_br2) then
     do ith=1,nth_eval
        zval=wk(ith,eqi_intg_r)
        fans(ith)=wk(ith,idv)*wk(ith,eqi_intg_modb)*zval*zval
     enddo

  else if(icode.eq.eqi_intg_b2i) then
     do ith=1,nth_eval
        zval=wk(ith,eqi_intg_modb)
        fans(ith)=wk(ith,idv)/(zval*zval)
     enddo

  else if(icode.eq.eqi_intg_bi) then
     do ith=1,nth_eval
        zval=wk(ith,eqi_intg_modb)
        fans(ith)=wk(ith,idv)/zval
     enddo

  else if(icode.eq.eqi_intg_b1) then
     do ith=1,nth_eval
        zval=wk(ith,eqi_intg_modb)
        fans(ith)=wk(ith,idv)*zval
     enddo

  else if(icode.eq.eqi_intg_b2) then
     do ith=1,nth_eval
        zval=wk(ith,eqi_intg_modb)
        fans(ith)=wk(ith,idv)*zval*zval
     enddo

  else if(icode.eq.eqi_intg_bz2) then
     do ith=1,nth_eval
        zval=wk(ith,eqi_intg_bz)
        fans(ith)=wk(ith,idv)*zval*zval
     enddo

  else if(icode.eq.eqi_intg_g2b2i) then
     do ith=1,nth_eval
        zdl = sqrt(wk(ith,eqi_intg_drdth)**2+wk(ith,eqi_intg_dzdth)**2)
        zd2 = abs(wk(ith,eqi_intg_drdth)*wk(ith,eqi_intg_dzdrho) - &
             wk(ith,eqi_intg_dzdth)*wk(ith,eqi_intg_drdrho))
        zgx = zdl/zd2
        zB = wk(ith,eqi_intg_modb)
        fans(ith)=wk(ith,idv)*(zgx*zgx)/(zB*zB)
     enddo

  else if(icode.eq.eqi_intg_g2r2i) then
     do ith=1,nth_eval
        zdl = sqrt(wk(ith,eqi_intg_drdth)**2+wk(ith,eqi_intg_dzdth)**2)
        zd2 = abs(wk(ith,eqi_intg_drdth)*wk(ith,eqi_intg_dzdrho) - &
             wk(ith,eqi_intg_dzdth)*wk(ith,eqi_intg_drdrho))
        zgx = zdl/zd2
        zR = wk(ith,eqi_intg_r)
        fans(ith)=wk(ith,idv)*(zgx*zgx)/(zR*zR)
     enddo

  else if(icode.eq.eqi_intg_g2r3i) then
     do ith=1,nth_eval
        zdl = sqrt(wk(ith,eqi_intg_drdth)**2+wk(ith,eqi_intg_dzdth)**2)
        zd2 = abs(wk(ith,eqi_intg_drdth)*wk(ith,eqi_intg_dzdrho) - &
             wk(ith,eqi_intg_dzdth)*wk(ith,eqi_intg_drdrho))
        zgx = zdl/zd2
        zR = wk(ith,eqi_intg_r)
        fans(ith)=wk(ith,idv)*(zgx*zgx)/(zR*zR*zR)
     enddo

  else if(icode.eq.eqi_intg_g2r2) then
     do ith=1,nth_eval
        zdl = sqrt(wk(ith,eqi_intg_drdth)**2+wk(ith,eqi_intg_dzdth)**2)
        zd2 = abs(wk(ith,eqi_intg_drdth)*wk(ith,eqi_intg_dzdrho) - &
             wk(ith,eqi_intg_dzdth)*wk(ith,eqi_intg_drdrho))
        zgx = zdl/zd2
        zR = wk(ith,eqi_intg_r)
        fans(ith)=wk(ith,idv)*(zgx*zgx*zR*zR)
     enddo

  else if(icode.eq.eqi_intg_giri) then
     do ith=1,nth_eval
        zdl = sqrt(wk(ith,eqi_intg_drdth)**2+wk(ith,eqi_intg_dzdth)**2)
        zd2 = abs(wk(ith,eqi_intg_drdth)*wk(ith,eqi_intg_dzdrho) - &
             wk(ith,eqi_intg_dzdth)*wk(ith,eqi_intg_drdrho))
        zgx = zdl/zd2
        zR = wk(ith,eqi_intg_r)
        fans(ith)=wk(ith,idv)/(zgx*zR)
     enddo

  else if(icode.eq.eqi_intg_g2) then
     do ith=1,nth_eval
        zdl = sqrt(wk(ith,eqi_intg_drdth)**2+wk(ith,eqi_intg_dzdth)**2)
        zd2 = abs(wk(ith,eqi_intg_drdth)*wk(ith,eqi_intg_dzdrho) - &
             wk(ith,eqi_intg_dzdth)*wk(ith,eqi_intg_drdrho))
        zgx = zdl/zd2
        fans(ith)=wk(ith,idv)*(zgx*zgx)
     enddo

  else if(icode.eq.eqi_intg_g1) then
     do ith=1,nth_eval
        zdl = sqrt(wk(ith,eqi_intg_drdth)**2+wk(ith,eqi_intg_dzdth)**2)
        zd2 = abs(wk(ith,eqi_intg_drdth)*wk(ith,eqi_intg_dzdrho) - &
             wk(ith,eqi_intg_dzdth)*wk(ith,eqi_intg_drdrho))
        zgx = zdl/zd2
        fans(ith)=wk(ith,idv)*(zgx)
     enddo

  else if(icode.eq.eqi_intg_fhnclass) then
     if(bmax.eq.c0) then
        do ith=1,nth_eval
           bmax=max(bmax,wk(ith,eqi_intg_modb))
        enddo
     endif
     do ith=1,nth_eval
        zb=wk(ith,eqi_intg_modb)
        zh=zb/bmax              ! B/Bmax
        zarg=max((c1-zh),ceps6)
        fans(ith)=wk(ith,idv)*(c1-sqrt(zarg)*(c1+chalf*zh))/(zh*zh)
     enddo

  else if(icode.eq.eqi_intg_fhnc_tsc) then
     if(bmax.eq.c0) then
        do ith=1,nth_eval
           bmax=max(bmax,wk(ith,eqi_intg_modb))
        enddo
     endif
     do ith=1,nth_eval
        zb=wk(ith,eqi_intg_modb)
        zh=zb/bmax              ! B/Bmax
        zarg=max((c1-zh),ceps6)
        fans(ith)=wk(ith,idv)*(c1/zb**2)*sqrt(zarg)*(c1-zarg/3)
     enddo

  else if(icode.eq.eqi_intg_fhmmx) then
     if(bmax.eq.c0) then
        do ith=1,nth_eval
           bmax=max(bmax,wk(ith,eqi_intg_modb)) ! Bmax -- max on flux surface
        enddo
     endif
     do ith=1,nth_eval
        zb=wk(ith,eqi_intg_modb)
        zh=zb/bmax              ! B/Bmax
        zarg=max((c1-zh),ceps6)
        fans(ith)=wk(ith,idv)*sqrt(zarg)  ! sqrt(1-B/Bmax)
     enddo

  else
     fans=0
     ier=611
     call xplasma_errmsg_append(sp, &
          ' ?invalid integration code passed to xplasma_integ_fwkdv')
  endif

end subroutine xplasma_integ_fwkdv

subroutine fluxav_brk_addperio(oldlist,n_old,newlist,n_new,mergelist,n_merge)
!
!  merge two lists in ascending order, squeezing out duplicates, with only
!  the subset of newlist that is between oldlist(1) and oldlist(n_old)
!  considered.
!
!  presume a periodic coordinate, i.e. newlist can be rotated, and shifted
!  by integer multiples of 2pi
!
!    **newlist** should cover a range of 2pi
!
!  input lists assumed already in ascending order *without checking*
!
  implicit NONE
!
!   input:
!
  integer n_old
  real*8 oldlist(n_old)         ! old list
!
  integer n_new
  real*8 newlist(n_new)         ! new list
!
!   output:
!
  real*8 mergelist(*)           ! merged list
  integer n_merge               ! length of merged list
!
!--------------------------------------
  real*8 :: snewlist(n_new),rnewlist(n_new)
  integer :: ishift
  real*8, parameter :: c2pi = 6.2831853071795862D+00
  integer :: i,ifound,inf
!--------------------------------------

  if(oldlist(1).lt.newlist(1)) then
     ishift=1 + (newlist(1)-oldlist(1))/c2pi
     snewlist = newlist - ishift*c2pi
  else if(oldlist(1).ge.newlist(n_new)) then
     ishift=1 + (oldlist(1)-newlist(n_new))/c2pi
     snewlist = newlist + ishift*c2pi
  else
     snewlist = newlist
  endif

  ! 1 correction allowed

  if(oldlist(1).lt.snewlist(1)) then
     snewlist = snewlist-c2pi
  else if(oldlist(1).ge.snewlist(n_new)) then
     snewlist = snewlist+c2pi
  endif

  if((oldlist(n_old).le.snewlist(1)).or.(oldlist(1).ge.snewlist(n_new))) then
     n_merge=n_old
     mergelist(1:n_old)=oldlist
     return
  endif

  ! OK range lf lists intersects; find first snewlist element that is
  ! greater than the first oldlist element

  ifound=0
  do i=1,n_new
     if(snewlist(i).gt.oldlist(1)) then
        ifound=i
        exit
     endif
  enddo

  if(ifound.eq.0) then
     n_merge=n_old
     mergelist(1:n_old)=oldlist
     return
  endif

  inf=n_new-ifound+1
  rnewlist(1:inf)=snewlist(ifound:n_new)
  rnewlist(inf+1:n_new-1)=snewlist(2:ifound-1)+c2pi
  rnewlist(n_new)=rnewlist(1)+c2pi

  ! OK now do the merge...

  call fluxav_brk_addsub(oldlist,n_old,rnewlist,n_new,mergelist,n_merge)

end subroutine fluxav_brk_addperio
!-------------------------------------------------------------------
subroutine fluxav_brk_addsub(oldlist,n_old,newlist,n_new,mergelist,n_merge)
!
!  merge two lists in ascending order, squeezing out duplicates, with only
!  the subset of newlist that is between oldlist(1) and oldlist(n_old)
!  considered.
!
!  input lists assumed already in ascending order *without checking*
!
  implicit NONE
!
!   input:
!
  integer n_old
  real*8 oldlist(n_old)         ! old list
!
  integer n_new
  real*8 newlist(n_new)         ! new list
!
!   output:
!
  real*8 mergelist(*)           ! merged list
  integer n_merge               ! length of merged list
!
!--------------------------------------
!
  integer i,i1,i2,inum
!
  i1=0
  i2=0
!
  do i=1,n_new
     if(newlist(i).gt.oldlist(1)) then
        if(i1.eq.0) i1=i
     endif
     if(newlist(i).lt.oldlist(n_old)) then
        i2=i
     endif
  enddo

  if((min(i1,i2).eq.0).or.(i2.lt.i1)) then
     mergelist(1:n_old)=oldlist(1:n_old)
     n_merge = n_old
  else

     inum=i2-i1+1
     call fluxav_brk_add0(oldlist,n_old,newlist(i1:i2),inum, &
          mergelist,n_merge)

  endif
end subroutine fluxav_brk_addsub
!--------------------------------------
!-------------------------------------------------------------------
subroutine fluxav_brk_add0(oldlist,n_old,newlist,n_new,mergelist,n_merge)
!
!  merge two lists in ascending order, squeezing out duplicates
!  input lists assumed already in ascending order *without checking*
!
  implicit NONE
!
!   input:
!
  integer n_old
  real*8 oldlist(n_old)         ! old list
!
  integer n_new
  real*8 newlist(n_new)         ! new list
!
!   output:
!
  real*8 mergelist(*)           ! merged list
  integer n_merge               ! length of merged list
!
!--------------------------------------
!
  integer i_old,i_new
  real*8 znew
!
!--------------------------------------
!
  i_old=0
  i_new=0
!
  n_merge=0
!
!  loop until ascending lists are merged into one ascending list.
!
  do
!
!  loop exit test...
!
     if((i_old.ge.n_old).and.(i_new.ge.n_new)) then
        return
!
     else if(i_old.ge.n_old) then
        i_new=i_new+1
        n_merge=n_merge+1
        mergelist(n_merge)=newlist(i_new)
!
     else if(i_new.ge.n_new) then
        i_old=i_old+1
        n_merge=n_merge+1
        mergelist(n_merge)=oldlist(i_old)
!
     else
!
!   both lists are in play
!
        if(oldlist(i_old+1).lt.newlist(i_new+1)) then
           i_old=i_old+1
           znew=oldlist(i_old)
        else
           i_new=i_new+1
           znew=newlist(i_new)
        endif
!
        if(n_merge.eq.0) then
           n_merge=1
           mergelist(n_merge)=znew
!
!  no duplicates...
!
        else if(znew.gt.mergelist(n_merge)) then
           n_merge=n_merge+1
           mergelist(n_merge)=znew
        endif
!
     endif
  enddo
!
end subroutine fluxav_brk_add0

subroutine fluxav_brktol(list,nlist,ztol)

  ! squeeze out successive entries of list that are within ztol of eachother
  ! list must be in ascending order, **not checked**

  real*8 :: list(*)  ! modified on output
  integer :: nlist   ! modified on output
  real*8,intent(in) :: ztol

  !---------------
  real*8 :: ztoli
  integer :: i,ii
  real*8, parameter :: czero = 0.0d0
  real*8, parameter :: ceps4 = 1.0d-4
  !---------------

  ! sanity check...

  if(ztol.le.czero) return
  ztoli=min(ztol,max(abs(list(1)),abs(list(nlist)))*ceps4)

  !---------------

  ii=1
  do i=2,nlist
     if((list(i)-list(i-1)).gt.ztoli) then
        ii=ii+1
        if(ii.lt.i) list(ii)=list(i)
     endif
  enddo

  if(ii.lt.nlist) list(ii+1:nlist)=0
  nlist=ii

end subroutine fluxav_brktol

subroutine xdistrib_sub(ntarg,lmask,xtarg,atarg, &
     & idum0,ztarg,idum1,zdum,idum2)
  !
  ! evaluation subroutine for zridderx
  !
  !    looking for zeroes of F(x(k)) =
  !                    int(x0 to x(k))[f'*dx']/int(x0 to xn)[f'*dx'] - z(k)
  !
  use xdistrib_mod
  implicit NONE
 
  ! ------------------------ arguments --------------------------------
 
  integer, intent(in) :: ntarg         ! input vector dimension
  logical, intent(in) :: lmask(ntarg)  ! masking vector
  real*8, intent(in) :: xtarg(ntarg)   ! input x values to evaluate
  real*8, intent(out) :: atarg(ntarg)  ! output function eval. results.
  real*8, intent(in) :: ztarg(ntarg)   ! data for function eval.
 
  integer, intent(in) :: idum0,idum1,idum2  ! placeholders
  real*8, intent(in) :: zdum(ntarg)    ! placeholder
  ! ------------------------ local stuff ------------------------------
 
  integer nvec,jvec,i,imode,iwarn
  real*8 xvec(ntarg)
  integer iv(ntarg)
  real*8 dxn(ntarg),zdum2(ntarg),zdum3(ntarg)
 
  real*8 feqi_1int                     ! integration subfunction
 
  ! ------------------------ executable code --------------------------
 
  ! --> find the active points
 
  nvec=0
  do i=1,ntarg
     if(.not.lmask(i)) then
        nvec=nvec+1
        xvec(nvec)=xtarg(i)
     endif
  enddo
 
  ! --> table lookup on these
 
  imode=1
 
  iv=0
  call xlookup(nvec,xvec,nx_spl,xpkg,imode,iv,dxn,zdum2,zdum3,iwarn)
 
  jvec=0
  do i=1,ntarg
     if(.not.lmask(i)) then
        jvec=jvec+1
        atarg(i)=ftabl(iv(jvec)) + &
             & feqi_1int(iorder_spl,xpkg,splcoef,nx_spl,iv(jvec),dxn(jvec))
        atarg(i)=atarg(i)/ftabl(nx_spl) - ztarg(i)
     endif
  enddo
 
  return
 
end subroutine xdistrib_sub
 

      subroutine sgefa(a,lda,n,ipvt,info)
      integer lda,n,ipvt(1),info
      real a(lda,1)
c
c     sgefa factors a real matrix by gaussian elimination.
c
c     sgefa is usually called by sgeco, but it can be called
c     directly with a saving in time if  rcond  is not needed.
c     (time for sgeco) = (1 + 9/n)*(time for sgefa) .
c
c     on entry
c
c        a       real(lda, n)
c                the matrix to be factored.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c     on return
c
c        a       an upper triangular matrix and the multipliers
c                which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        info    integer
c                = 0  normal value.
c                = k  if  u(k,k) .eq. 0.0 .  this is not an error
c                     condition for this subroutine, but it does
c                     indicate that sgesl or sgedi will divide by zero
c                     if called.  use  rcond  in sgeco for a reliable
c                     indication of singularity.
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas saxpy,sscal,isamax
c
c     internal variables
c
      real t
      integer isamax,j,k,kp1,l,nm1
c
c
c     gaussian elimination with partial pivoting
c
      info = 0
      nm1 = n - 1
      if (nm1 .lt. 1) go to 70
      do 60 k = 1, nm1
         kp1 = k + 1
c
c        find l = pivot index
c
         l = isamax(n-k+1,a(k,k),1) + k - 1
         ipvt(k) = l
c
c        zero pivot implies this column already triangularized
c
         if (a(l,k) .eq. 0.0e0) go to 40
c
c           interchange if necessary
c
            if (l .eq. k) go to 10
               t = a(l,k)
               a(l,k) = a(k,k)
               a(k,k) = t
   10       continue
c
c           compute multipliers
c
            t = -1.0e0/a(k,k)
            call sscal(n-k,t,a(k+1,k),1)
c
c           row elimination with column indexing
c
            do 30 j = kp1, n
               t = a(l,j)
               if (l .eq. k) go to 20
                  a(l,j) = a(k,j)
                  a(k,j) = t
   20          continue
               call saxpy(n-k,t,a(k+1,k),1,a(k+1,j),1)
   30       continue
         go to 50
   40    continue
            info = k
   50    continue
   60 continue
   70 continue
      ipvt(n) = n
      if (a(n,n) .eq. 0.0e0) info = n
      return
      end

      subroutine dgbsl(abd,lda,n,ml,mu,ipvt,b,job)
      integer lda,n,ml,mu,ipvt(1),job
      double precision abd(lda,1),b(1)
c
c     dgbsl solves the double precision band system
c     a * x = b  or  trans(a) * x = b
c     using the factors computed by dgbco or dgbfa.
c
c     on entry
c
c        abd     double precision(lda, n)
c                the output from dgbco or dgbfa.
c
c        lda     integer
c                the leading dimension of the array  abd .
c
c        n       integer
c                the order of the original matrix.
c
c        ml      integer
c                number of diagonals below the main diagonal.
c
c        mu      integer
c                number of diagonals above the main diagonal.
c
c        ipvt    integer(n)
c                the pivot vector from dgbco or dgbfa.
c
c        b       double precision(n)
c                the right hand side vector.
c
c        job     integer
c                = 0         to solve  a*x = b ,
c                = nonzero   to solve  trans(a)*x = b , where
c                            trans(a)  is the transpose.
c
c     on return
c
c        b       the solution vector  x .
c
c     error condition
c
c        a division by zero will occur if the input factor contains a
c        zero on the diagonal.  technically this indicates singularity
c        but it is often caused by improper arguments or improper
c        setting of lda .  it will not occur if the subroutines are
c        called correctly and if dgbco has set rcond .gt. 0.0
c        or dgbfa has set info .eq. 0 .
c
c     to compute  inverse(a) * c  where  c  is a matrix
c     with  p  columns
c           call dgbco(abd,lda,n,ml,mu,ipvt,rcond,z)
c           if (rcond is too small) go to ...
c           do 10 j = 1, p
c              call dgbsl(abd,lda,n,ml,mu,ipvt,c(1,j),0)
c        10 continue
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas daxpy,ddot
c     fortran min0
c
c     internal variables
c
      double precision ddot,t
      integer k,kb,l,la,lb,lm,m,nm1
c
      m = mu + ml + 1
      nm1 = n - 1
      if (job .ne. 0) go to 50
c
c        job = 0 , solve  a * x = b
c        first solve l*y = b
c
         if (ml .eq. 0) go to 30
         if (nm1 .lt. 1) go to 30
            do 20 k = 1, nm1
               lm = min0(ml,n-k)
               l = ipvt(k)
               t = b(l)
               if (l .eq. k) go to 10
                  b(l) = b(k)
                  b(k) = t
   10          continue
               call daxpy(lm,t,abd(m+1,k),1,b(k+1),1)
   20       continue
   30    continue
c
c        now solve  u*x = y
c
         do 40 kb = 1, n
            k = n + 1 - kb
            b(k) = b(k)/abd(m,k)
            lm = min0(k,m) - 1
            la = m - lm
            lb = k - lm
            t = -b(k)
            call daxpy(lm,t,abd(la,k),1,b(lb),1)
   40    continue
      go to 100
   50 continue
c
c        job = nonzero, solve  trans(a) * x = b
c        first solve  trans(u)*y = b
c
         do 60 k = 1, n
            lm = min0(k,m) - 1
            la = m - lm
            lb = k - lm
            t = ddot(lm,abd(la,k),1,b(lb),1)
            b(k) = (b(k) - t)/abd(m,k)
   60    continue
c
c        now solve trans(l)*x = y
c
         if (ml .eq. 0) go to 90
         if (nm1 .lt. 1) go to 90
            do 80 kb = 1, nm1
               k = n - kb
               lm = min0(ml,n-k)
               b(k) = b(k) + ddot(lm,abd(m+1,k),1,b(k+1),1)
               l = ipvt(k)
               if (l .eq. k) go to 70
                  t = b(l)
                  b(l) = b(k)
                  b(k) = t
   70          continue
   80       continue
   90    continue
  100 continue
      return
      end

      program geqxpl
c
c  create an xplasma from a geqdsk file
c  ...dmc 10 Jan 2001
c
      use eqm_mds_fromgeqdsk_mod
      implicit NONE
c
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      character*150 zfile,zfili,zfilsave
      integer ns,it1,nt1,ier,ilbl,i,ist,ifin,ihsig
      character*50 label
c
      integer lnout
      logical lxout,lyes,lchar,ireduce,ilmds
c
      real*8 fbdy,fbmin,fbmax,ztest,crat,zdum,zxmin,zdtfl,zmaxerr,xbrki
c
      character*50 mds_server
      character*20 mds_tree,mds_time,mds_shot,ctest
      integer ilsrv,iltr,iltm,ilsh,ilc,itest,irz,ixtra
      integer igot,ierr,is,imom,jmom,it,inumt,it_index,icur_psi
      integer iopt_pp
      real*8 ztime
c
      real*8 :: maxvar = 1.0d-4
c
      integer :: id_rho=0,id_phi=0,id_psi=0,id_q=0,id_g=0
      integer :: id_p=0,idum=0
      integer isnccwb,isnccwi
c
      real*8,dimension(:),allocatable :: zx,zdphi,zdpsi,zqprof,zq
      real*8,dimension(:),allocatable :: zdv,zr2i,zg,ztflux,ztfint
c
      integer :: idebug = 0  ! activate (set to =1) for Q/tflux test
      real*8,parameter :: z2pi = 6.2831853071795862D+00
c
      integer :: lunio = 77  ! LUN for fortran ascii file write
c
c---------------------------------------------------------------------
c
      call uinitg("GEQXPL")
c
      ireduce=.TRUE.
      mds_server='LOCAL'
      mds_tree='EFIT01'
      mds_time='1.0'
      mds_shot='123456'
c
      irz=1
      fbdy=1.00_r8
      crat=0.080_r8
      ns=51
      ihsig=1
      nt1=101
      imom=8
      jmom=8
c
      icur_psi=0
      xbrki=0.9_r8
c
      iopt_pp=0
c
 10   continue
      ilmds=.FALSE.
      if(lxout(0)) then
         write(lnout(0),*) ' '
         write(lnout(0),*) ' geqxpl:  compute inverse equilibrium from'
         write(lnout(0),*)
     >      '          EFIT G-EQDISK or MDSplus tree data'
         write(lnout(0),*) 
     >      ' --> enter "i" or "I" for G-EQDISK access via "index file"'
         write(lnout(0),*) ' --> enter "m" or "M" for MDSplus access.'
         write(lnout(0),*) ' --> enter "q" or "Q" to quit.'
         write(lnout(0),*) ' '
      endif
 
      it_index=0
      zfile=' '
      call unixfile('geqxpl',zfile)
 
      if((zfile(1:2).eq.'q ').or.(zfile(1:2).eq.'Q ')) then
         call uexita(0)
         stop
      endif
 
      if((zfile(1:2).eq.'i ').or.(zfile(1:2).eq.'I ')) then
         call unixfile('geqxpl (G-EQDSK index file)',zfili)
         call geqdsk_index1_ntimes(99,'EFIT_INDEX:'//trim(zfili),inumt)
         if(inumt.eq.0) then
            call uermsg(' ?geqxpl: EFIT_INDEX file access failed:',
     >         trim(zfili),0)
            go to 10
         endif
         if(lxout(0)) then
            write(lnout(0),*) ' G-Eqdsk indices, times, and files:'
            do it=1,inumt
               call geqdsk_index1_gtime(99,'EFIT_INDEX:'//trim(zfili),
     >            it,ztime,ierr)
               call geqdsk_index1_gfile(99,'EFIT_INDEX:'//trim(zfili),
     >            it,zfile,ierr)
               write(lnout(0),1998) it,ztime,trim(zfile)
            enddo
 1998       format(2x,i5,'.  time=',1pe12.5,'  G-file=',a)
         endif
         it=1
         call ureadi('geqxpl: choose index to select G-file:$',it)
         it_index=max(1,min(inumt,it))
         call geqdsk_index1_gfile(99,'EFIT_INDEX:'//trim(zfili),
     >      it_index,zfilsave,ierr)
c
         write(zfile,1999) trim(zfili),it
 1999    format('EFIT_INDEX:',a,'(',i5,')')
c
      else if((zfile(1:2).eq.'m ').or.(zfile(1:2).eq.'M ')) then
 20      continue
         ilsrv=len_trim(mds_server)
         iltr=len_trim(mds_tree)
         iltm=len_trim(mds_time)
         ilsh=len_trim(mds_shot)
         if(lxout(0)) write(lnout(0),2001) mds_server(1:ilsrv),
     >      mds_tree(1:iltr),mds_time(1:iltm),mds_shot(1:ilsh),ireduce
 2001    format(
     >      ' geqxpl MDSplus options:'/
     >      ' "S" -- set MDSplus server name (currently:  "',a,'")'/
     >      ' "T" -- set MDSplus tree name   (currently:  "',a,'")'/
     >      ' "M" -- set time of interest    (currently:  "',a,'")'/
     >      ' "N" -- set shot number         (currently:  "',a,'")'/
     >      ' "1" -- to fetch nearest time   (currently:  "',L1,'")'/
     >      ' "A" -- to accept current setting, read tree...'/
     >      ' "Q" -- to quit menu without reading.')
         call uread('geqxpl:  enter MDSplus option:$')
         if(lchar('Q')) then
            go to 10
         else if(lchar('A')) then
            if(ireduce) then
               write(zfile,3001) mds_server(1:ilsrv),
     >            mds_tree(1:iltr),mds_shot(1:ilsh),mds_time(1:iltm)
            else
               write(zfile,3002) mds_server(1:ilsrv),
     >            mds_tree(1:iltr),mds_shot(1:ilsh),mds_time(1:iltm)
            endif
 3001       format('MDS+/REDUCE:',a,':',a,'(',a,';t=',a,')')
 3002       format('MDS+/NOREDUCE:',a,':',a,'(',a,';t=',a,')')
            write(lnout(0),*) '...MDSplus access string: ',zfile
            go to 50
         else if(lchar('S')) then
            call ureadw('geqxpl:  MDSplus server name or "LOCAL":$',
     >         mds_server)
         else if(lchar('T')) then
            call ureadw('geqxpl:  MDSplus tree name:$',mds_tree)
         else if(lchar('M')) then
            call ureadw('geqxpl:  EFIT data time of interest:$',
     >         mds_time)
            iltm=len_trim(mds_time)
            ctest=' '
            ilc=len(ctest)
            ctest(max(1,ilc-iltm+1):ilc)=mds_time
            read(ctest,'(G20.0)',iostat=ier) ztest
            if(ier.ne.0) then
               call uermsg(' ?geqxpl:  G20.0 decode test failed:  ',
     >            mds_time,0)
               mds_time='1.0'
            endif
         else if(lchar('N')) then
            call ureadw('geqxpl:  shot number of MDSplus EFIT data:$',
     >         mds_shot)
            iltm=len_trim(mds_shot)
            ctest=' '
            ilc=len(ctest)
            ctest(max(1,ilc-iltm+1):ilc)=mds_shot
            read(ctest,'(I20)',iostat=ier) itest
            if(ier.ne.0) then
               call uermsg(' ?geqxpl:  I20 decode test failed:  ',
     >            mds_shot,0)
               mds_shot='123456'
            endif
         else if(lchar('1')) then
            if(lxout(0)) write(lnout(0),*) 
     >           '  enter "N" to read all times & interpolate EFIT data'
            if(lxout(0)) write(lnout(0),*) '  to selected time.'
            call uread('geqxpl: enter "Y" to just read one timeslice:$')
            if(lyes(0)) then
               ireduce=.TRUE.
            else
               ireduce=.FALSE.
            endif
         else
            call uermsg(' ?geqxpl: option code not understood.',' ',0)
         endif
         go to 20
      endif
 
 50   continue
 
      if(lxout(0)) then
         write(lnout(0),*) ' '
         write(lnout(0),*) ' settings now in effect:'
         write(lnout(0),*) ' '
         write(lnout(0),*) ' (R,Z) box computation option:'
         if(irz.eq.1) then
            write(lnout(0),*) '   ->> yes, compute B(R,Z) components'
            write(lnout(0),*) '   ->> and R(rho,theta),Z(rho,theta)'
         else
            write(lnout(0),*)
     >         '   --> no, just compute R(rho,theta),Z(rho,theta)'
         endif
         write(lnout(0),*) ' '
         write(lnout(0),*) ' Poloidal angle (theta) definition option:'
         if(nt1.lt.0) then
            write(lnout(0),*) '   ->> Equal Arc.'
         endif

         write(lnout(0),*) ' '
         write(lnout(0),
     >        '(2x,"Jacobian variation min/max limit: ",1pe13.6)') 
     >        maxvar
         write(lnout(0),*) ' '

         write(lnout(0),*) ' Toroidal current & q profile options:'
         if(icur_psi.eq.1) then
            write(lnout(0),*) "   ->> use Psi(R,Z) to rederive "//
     >           "q(rho) & toroidal current;"
            write(lnout(0),*) "       Psi(R,Z) must be based on a "//
     >           "full free boundary GS solution."
            write(lnout(0),*) "       EFIT file data for q(psi) and"//
     >           " total current are discarded."
         else
            write(lnout(0),*) '   ->> EFIT q(psi) data used "as is".'
            write(lnout(0),*) '       EFIT total enclosed current '//
     >           'value from file is used.'
         endif
         write(lnout(0),*)    "       Current profile from Psi(R,Z)"//
     >        " is modified with parabolic"
         write(lnout(0),*)    "       interpolation to match "//
     >        "boundary value;"
            write(lnout(0),'(A,1pe12.5)')
     >           "        parabolic interpolation starts at rho=",xbrki

         write(lnout(0),*) ' '
         if(iopt_pp.eq.1) then
            write(lnout(0),*)
     >           ' Pressure recomputed from P(a) & dP/dPsi.'
         else
            write(lnout(0),*) ' Pressure is not recomputed.'
         endif

         write(lnout(0),*) ' '
         write(lnout(0),*) ' no. of flux surfaces:  ',ns
         write(lnout(0),*) ' no. of theta pts / surface:  ', abs(nt1)
         write(lnout(0),*) ' no. of Fourier moments (regularization):',
     >      '  ',jmom
         write(lnout(0),*) ' '
         write(lnout(0),*) ' delta_psi(bdy) reduction parameter:', fbdy
         write(lnout(0),*) ' minimum curvature parameter:',crat
         write(lnout(0),*) ' '
         if(ihsig.lt.0) then
            write(lnout(0),*) ' Internal representation: Hermite'
         else
            write(lnout(0),*) ' Internal representation: Spline'
         endif
         write(lnout(0),*) ' '
         write(lnout(0),2002)
 2002    format(' options:'/
     >      '  "Q" - quit, get different data.'/
     >      '  "R" - include psi(R,Z), B(R,Z) in xplasma calculation.'/
     >      '  "X" - just do R,Z vs. mag. coordinates in xplasma.'/
     >      '  "I" - enclosed toroidal current profile option.'/
     >      '  "P" - option to recompute P(rho) from dP/dpsi.'/
     >      '  "N" - select number of flux surfaces.'/
     >      '  "M" - select number of theta pts / flux surface.'/
     >      '  "H" - (new) select Hermite internal representation ',
     >               'for R,Z surfaces.'/
     >      '  "K" - select no. of Fourier moments ',
     >               '(surface theta regularization).'/
     >      '  "F" - set delta_psi(bdy) reduction parameter.'/
     >      '  "C" - set minimum curvature parameter.'/
     >      '  "E" - to select equal arc theta definition'/
     >      '  "V" - reset Jacobian min/max limit'/
     >      '  "B" - plot raw EFIT data, no "xplasma" processing'/
     >      '  "A" - accept parameters, go ahead...')
      endif
      call uread('geqxpl:  data processing control option:$')
 
      if(lchar('Q')) then
         go to 10

      else if(lchar('B')) then
         call geqxpl_rawplot(zfile)
 
      else if(lchar('R')) then
         irz=1
 
      else if(lchar('X')) then
         irz=0
 
      else if(lchar('E')) then
         nt1=-abs(nt1)
         jmom=max(16,imom)

      else if(lchar('T')) then
         nt1=abs(nt1)
         jmom=imom

      else if(lchar('A')) then
         go to 100
 
      else if(lchar('H')) then
         call uread(' enter "Y" for Hermite internal representation:')
         if(lyes(0)) then
            ihsig=-1
         else
            ihsig=1
         endif

      else if(lchar('I')) then
         call uread(
     >        ' enter "Y" to rederive q and I profiles from Psi(R,Z):')
         if(lyes(0)) then
            icur_psi=1
         else
            icur_psi=0
         endif

         if(lxout(0)) then
            write(lnout(0),*) ' for the encloded toroidal current I:'
            write(lnout(0),*) 
     >           ' parabolic interpolation to match edge value can'
            write(lnout(0),*) 
     >           ' start in range 0.75 <= rhobrk <= 0.95'
         endif
         call ureadr8(
     >        ' enter "rhobrk" value at which to break profile'//
     >        ' for interpolation:',xbrki)
         xbrki=max(0.75_r8,min(0.95_r8,xbrki))

      else if(lchar('P')) then
         call uread(' enter "Y" to recompute P(rho) using dP/dPsi:')
         if(lyes(0)) then
            iopt_pp=1
         else
            iopt_pp=0
         endif

      else if(lchar('N')) then
         call ureadi(
     >      'geqxpl:  enter no. of flux surfaces, incl mag. axis:$',ns)
         ns=max(4,min(1000,ns))
 
      else if(lchar('M')) then
         it1=abs(nt1)
         call ureadi('geqxpl:  enter no. of theta points:$',it1)
         it1=max(50,min(2000,it1))

         if(nt1.lt.0) then
            nt1 = -it1
         else
            nt1 = it1
         endif
 
      else if(lchar('K')) then
         if(lxout(0)) write(lnout(0),*)
     >        '#moments>=16 forced for equal arc theta parametrization.'
         call ureadi('geqxpl:  enter no. of moments (btw 5 and 64):$',
     >      imom)
         imom=min(64,max(5,imom))
         if(nt1.gt.0) then
            jmom=imom
         else
            jmom=max(16,imom)
         endif

      else if(lchar('F')) then
 
         if(lxout(0)) then
            write(lnout(0),*) ' '
            write(lnout(0),*) ' ...setting this parameter less than one'
            write(lnout(0),*) ' moves the boundary in from the EFIT'
            write(lnout(0),*) ' nominal bdy, reducing the enclosed '
            write(lnout(0),*) ' poloidal flux by the indicated amount.'
            write(lnout(0),*) ' -->recommended value: 1.00'
         endif
         call ureadr8(
     >      'geqxpl:  delta_psi(bdy) parameter (btw 0.95 and 1.0):$',
     >      fbdy)
 
         fbmin=0.95_r8
         fbmax=1.00_r8
         fbdy=max(fbmin,min(fbmax,fbdy))
 
      else if(lchar('C')) then
 
         if(lxout(0)) then
            write(lnout(0),*) ' '
            write(lnout(0),*) ' ...setting this parameter greater than'
            write(lnout(0),*) ' zero establishes a minimum allowed'
            write(lnout(0),*) ' contour curvature, relative to the'
            write(lnout(0),*) ' midplane half width of the flux'
            write(lnout(0),*) ' surface.  This is a way of avoiding a'
            write(lnout(0),*) ' "kinked" boundary contour at a'
            write(lnout(0),*) ' separatrix.  If the condition is'
            write(lnout(0),*) ' violated the software reduces the'
            write(lnout(0),*) ' enclosed poloidal flux slightly.'
            write(lnout(0),*) ' -->recommended value: 0.05'
         endif
         call ureadr8(
     >      'geqxpl:  minimum curvature parameter (btw 0.0 and 0.15):$',
     >      crat)
 
         crat=max(0.0_r8,min(0.15_r8,crat))
 
      else if(lchar('V')) then
         if(lxout(0)) then
            write(lnout(0),*) 
     >           ' reduce this parameter to allow greater variation'
            write(lnout(0),*) 
     >           ' of det(J) on each flux surface (ajac_maxvar).'
            write(lnout(0),*) 
     >           ' allowed range: 0.0000001 to 0.1; default 0.0001.'
         endif
         call ureadr8('geqxpl: ajac_maxvar: ',maxvar)
         if(maxvar.gt.0.1d0) maxvar = 0.1d0
         if(maxvar.lt.0.0000001d0) maxvar = 0.0000001d0

      else
         call uermsg('?geqxpl: invalid control option.',' ',0)
      endif
      go to 50
 
c  OK...
 
 100  continue
 
      if(it_index.eq.0) then
         zfili=zfile
      else
         zfili=zfilsave
      endif

      ilbl=len(label)
      ifin=len_trim(zfili)
      do i=ifin,1,-1
         ist=i
         if((zfili(i:i).eq.'/').or.(zfili(i:i).eq.':').or.
     >      (zfili(i:i).eq.']')) then
            ist=i+1
            exit
         endif
      enddo
      label='GeqXpl:'//zfili(ist:min(ifin,ist+(ilbl-8)))
 
c-------------------------------------
 
      call xmoments_kmom_set(jmom)
 
      call eqi_jacheck_maxvar_Set(maxvar)

      if(zfile(1:4).eq.'MDS+') ilmds=.TRUE.
      call eqm_mds_fromgeqdsk_iadj(label,zfile,ns*ihsig,nt1,
     >     fbdy,crat,icur_psi, xbrki, irz,ier)
 
      if(iopt_pp.eq.1) call eqm_geqdsk_ppadj(ier)

c-------------------------------------
      if((ier.eq.0).and.(idebug.eq.1)) then
c
c  some tests -- consistency of q and toroidal flux representation
c
         allocate(zx(ns),zdphi(ns),zdpsi(ns),zqprof(ns),zq(ns))
c
         call eq_ganum("__RHO",id_rho)
         call eq_grid(id_rho,zx,ns,igot,ierr)
         if(ierr.ne.0) then
            write(6,*) ' eq_grid ("__RHO") failure.'
         else
            call eq_gfnum("PSI",id_psi)
            call eq_gfnum("PHITOR",id_phi)
         endif
c
c  get dpsi/drho and dphi/drho
c
         if(min(id_psi,id_phi).gt.0) then
            call eq_rgetf(ns,zx,id_psi,1,zdpsi,ierr)
            call eq_rgetf(ns,zx,id_phi,1,zdphi,ierr)
c  q = d(phi)/d(psi)
            zqprof(2:ns)=zdphi(2:ns)/(z2pi*zdpsi(2:ns))
            zqprof(1)=zqprof(2)-(zqprof(3)-zqprof(2))/3
c
            call eqm_rhofun(2,id_rho,'Q_DPSIDPHI',zqprof,
     >         0,zdum,0,zdum,idum,ierr)
c
            call eq_gfnum("Q",id_q)
            if(id_q.gt.0) then
               call eq_rgetf(ns,zx,id_q,0,zq,ierr)
c  compare
               call r8_grafx2(zx,zq,zqprof,ns,'rho','q',
     >            'data: '//zfile(1:ifin),
     >            'EFIT q (solid)',
     >            'numerical d(tor.flux)/d(pol.flux) (dashed)')
               zxmin=1.0d-7*zx(ns)
c
c  do integral B.dA to compare flux functions
c
               call eq_flxint_init(1,ns,zx,zxmin,ierr)
               allocate(zdv(ns-1),zr2i(ns-1),zg(ns),ztflux(ns),
     >            ztfint(ns))
c
               call eq_flxint('dVol',1,zdv,1,ns-1,ierr) ! vol. elements
               call eq_flxint('<1/R^2>',1,zr2i,1,ns-1,ierr) ! <1/R**2>
c
c   dphi = g.dVol.<1/R**2>/2pi
c
               call eq_gfnum("G",id_g)
               call eq_rgetf(ns,zx,id_g,0,zg,ierr)
               call eq_rgetf(ns,zx,id_phi,0,ztflux,ierr) !EFIT/xplasma flux fcn
               ztfint(1)=0.0
               do is=2,ns
                  i=is-1
                  zdtfl=zdv(i)*zr2i(i)*(zg(i)+zg(i))/(2*z2pi)
                  ztfint(is)=ztfint(i)+zdtfl
               enddo
c
               call eqm_rhofun(2,id_rho,'TFLUX_INT',ztfint,
     >            0,zdum,0,zdum,idum,ierr)
c
               call r8_grafx2(zx,ztflux,ztfint,ns,'rho','phitor',
     >            'data: '//zfile(1:ifin),
     >            'EFIT/xplasma Tor.flux (solid)',
     >            'numerically integrated Tor.flux (dashed)')
c
               deallocate(zdv,zr2i,zg,ztflux,ztfint)
            endif
         endif
         deallocate(zx,zdphi,zdpsi,zqprof,zq)
      endif
c
c-------------------------------------
 
      if(ier.ne.0) then
         write(lnout(0),*) ' ?eqm_fromgeqdsk error, ier=',ier
#ifdef __DEBUG
         call eqdbg_plot
#endif
         go to 10
      else
         call eqm_geq_maxGSerr(zmaxerr)
         write(6,*) ' '
         write(6,*) ' G-EQdsk data accepted, maximum rel. GS error: ',
     >      zmaxerr
         write(6,*) ' '
         call eq_bchk_sign(isnccwb,isnccwi)
         if(isnccwb.eq.1) then
            write(6,*) ' Bphi is counter-clockwise viewed from above ',
     >         '(nsnccwb = 1)'
         else
            write(6,*) ' Bphi is clockwise viewed from above ',
     >         '(nsnccwb = -1)'
         endif
         write(6,*) ' '
         if(isnccwi.eq.1) then
            write(6,*) ' Jphi is counter-clockwise viewed from above ',
     >         '(nsnccwi = 1)'
         else
            write(6,*) ' Jphi is clockwise viewed from above ',
     >         '(nsnccwi = -1)'
         endif
         write(6,*) ' '
         call eqdbg_plot
      endif
 
      if(ilmds) then
         call uread(
     >      'write G-EQDSK disk file of MDSplus timeslice? Y/N:$')
         if(lyes(0)) then
            call gfilnam('geqxpl(output)')
            call eqm_wr_geqdsk(zfile,ier)
            write(lnout(0),*)
     >         'eqm_wr_geqdsk completion code (0=normal):',ier
         endif
      endif
 
      if(lxout(0)) write(lnout(0),*) ' enter "E" for TORIC EQUIGS file.'
      if(lxout(0)) write(lnout(0),*) ' enter "X" for xplasma save file.'

      call uread('geqxpl:  write psipqgRZ NetCDF file? (Y/N):$')

      if(lchar('X')) then
         call gfilnam('geqxpl(xplasma_netcdf_file)')
         call eq_save(zfile,ier)
         write(lnout(0),*) ' eq_save exit status (0=OK): ',ier

      else if(lchar('E')) then
         call gfilnam('TORIC EQUIGS filename')
         call eq_gfnum('q',id_q)

         !  call equigs_write with idi_xpsi = 0; leave x_psi generation
         !  to equigs_write.f90

         call equigs_write(0,id_q,lunio,zfile,ier)
         write(lnout(0),*) 
     >        'equigs_write completion code (0=normal):',ier

      else if(lyes(0)) then
         call gfilnam('psipqgRZ filename')
         call eq_gfnum('p',id_p)
         call eq_gfnum('q',id_q)
         ixtra=0
         call eq_psipqgrz(zfile,ixtra,id_p,id_q,ier)
         write(lnout(0),*)
     >      'eq_psipqgrz completion code (0=normal):',ier
      endif
 
      go to 10
 
      contains
 
        subroutine gfilnam(unixhint)
 
        character*(*), intent(in) :: unixhint
 
        zfile=' '

        call unixfile(unixhint,zfile)
        end subroutine gfilnam
 
      end

SUBROUTINE scrrestartdes(irst,ier)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, two
  use scrunch_inc1
  implicit none
  integer, intent(inout) :: irst
  integer, intent(inout) :: ier
  integer :: l
  !**********************************************************************
  ! This routine either stores an accepted value of the local solution
  ! (irst=1) or reset the present solution to a previous value (irst=2)
  !**********************************************************************
  go to (15,25)irst

15 continue
  xstore(1:n2) = xvec(1:n2)
  return

25 continue
  do l = 1,n2
    xdot(l) = zero
    xvec(l) = xstore(l)
  end do

  delt = .95_fp*delt
  irst = 1
  nresets = nresets + 1
  if(nresets.ge.100) then
    write(lunmsg,*)' Time step reduced 100 times without convergence'
    ier=13
  end if

end SUBROUTINE scrrestartdes

SUBROUTINE scradphase(raxis,yaxis,rmcx1,ymcx1,immax,imom,zthadj,ier)
  !
  !  adjust phase of theta parametrization on "1" surface
  !    want theta=0 to give R.gt.raxis, y.eq.yaxis
  !
  !  input:  raxis,yaxis -- mag. axis position
  !          rmcx1,ymcx1 -- moments of surface (unadjusted)
  !          immax -- max no. of moments (array dimension)
  !          imom  -- no. of active moments (use 0:imom).
  !
  ! output:  rmcx1,ymcx1 -- adjusted
  !
  !  the idea here is to align the phases of two surfaces, to reduce as
  !  much as possible, on average, the non-orthogonality of the theta
  !  lines -- i.e. remove any "swastika-like" skewing of the theta
  !  parametrization.
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: twopi
  implicit none
  integer, intent(out) :: ier
  real(fp) :: delth
  real(fp) :: angspan
  real(fp) :: angnorm
  real(fp) :: zthadj
  integer :: imom
  integer :: im
  real(fp) :: ztheta
  integer :: ith, itp
  real(fp) :: zpi
  integer :: inpts
  integer :: immax
  !
  integer iy0   ! interval where y=yaxis falls, with r.gt.raxis
  !
  real(fp) :: raxis,yaxis
  real(fp) :: rmcx1(0:immax,2)
  real(fp) :: ymcx1(0:immax,2)
  !
  parameter (inpts=128)
  real(fp) :: r0(inpts),y0(inpts),r1(inpts),y1(inpts)
  real(fp) :: enorm(2),espan(2)
  !
  real(fp) :: zthetap,zthp,zth,zyp,zy,zero
  !
  real(fp) :: zsn(100),zcs(100)
  !
  integer :: lunmsg
  !
  !---------------------------------------------------------------------
  !
  call scrgetlun(lunmsg)
  !
  !  expand surfaces into (R,Y) sequences
  !
  ier = 1
  zero=0
  ztheta=zero
  iy0=0
  !
  do ith=1,inpts
    ztheta=(ith-1)*twopi/inpts
    CALL scrsincos(ztheta,imom,zsn,zcs)
    r1(ith)=rmcx1(0,1)
    y1(ith)=ymcx1(0,1)
    do im=1,imom
      r1(ith)=r1(ith)+rmcx1(im,1)*zcs(im)+rmcx1(im,2)*zsn(im)
      y1(ith)=y1(ith)+ymcx1(im,1)*zcs(im)+ymcx1(im,2)*zsn(im)
    enddo
  enddo
  !
  !  look for interval on large major radius side containing y=yaxis
  !
  do ith=1,inpts
    zthetap=ztheta
    ztheta=(ith-1)*twopi/inpts
    if(ith.gt.1) then
      itp=ith-1
      if((r1(ith).gt.raxis).and.(r1(itp).gt.raxis)) then
        if((y1(ith)-yaxis)*(y1(itp)-yaxis).le.zero) then
          if(iy0.gt.0) then
            if(y1(itp).ne.yaxis) then
              call scraborter(6, '?scradphase:  mult. y=yaxis intervals?')
              ier = 2
            end if
          else
            iy0=itp
            zthp=zthetap
            zth=ztheta
            zyp=y1(itp)
            zy=y1(ith)
          endif
        endif
      endif
    endif
    !
  enddo
  if(ier.ne.1) return
  !
  if(iy0.eq.0) then
    zy=y1(1)
    zyp=y1(inpts)
    zth=zero
    zthp=ztheta-twopi
  endif
  !
  if((zy-yaxis)*(zyp-yaxis).gt.zero) then
    call scraborter(6, '?scradphase: y=yaxis interval search failure?')
    ier = 3
    return
  endif
  !
  zthadj=zthp+(yaxis-zyp)*(zth-zthp)/(zy-zyp)  ! theta -> y=yaxis
  !
  CALL scrphasead(rmcx1,ymcx1,immax,imom,zthadj)
  !
  return
end SUBROUTINE scradphase

#include "fpreproc/f77_dcomplx.h"
      subroutine r8bloats0(lcentr,nzones,xiblo,inbblo,mtbl,mj,
     >                  rmom0,rmom,ymom,nmom,mimom,nonlin,
     >                  rmb0,rmb2,ymb2)
C
C  bloat subroutine -- updown symmetric -- calling arguments, no COMMON!
C  dmc 27 Dec 1996
C
C  caller bloatx.for has some debug plotting stuff that may want to be
C  moved down into this routine in case the iteration loop fails...
C
C  this routine copies the inside-the-plasma moments set to the bloated
C  moments set, and uses a numerical algorithm to create well behaved
C  surfaces beyond the plasma bdy.  these surfaces provide a coordinate
C  system with reasonable properties (|J|>0 always) and a Fourier moments
C  representation, but the ones beyond the boundary are not real magnetic
C  surfaces!
C
C  when done ... set up spline coefficients for Fourier Spline -- used
C  by MOMRY
C
C input:
C  lcentr -- index to centermost surface (mag. axis point).
C            typically 1; 2 (TRCOM's LCENTR) when called from TRANSP.
C  nzones -- the number of flux zones in the plasma (the no. of surfaces
C            counting the mag. axis is nzones+1).
C
C  xiblo(..)  -- x grid for extrapolated space beyond plasma bdy
C  inbblo -- no. of points in use in extrapolated grid.
C  mtbl   -- max no. of grid pts (array dimension for xiblo, etc...)
C  mj     -- max no. of grid pts *inside plasma* (array dim for rmom0, etc.)
C
C  rmom0(..) -- 0th R moment set (inside plasma)
C  rmom(...) -- higher R moments set (inside plasma)
C  ymom(...) -- higher Y moments set (inside plasma)
C
C   caution:  dimension ordering follows TRANSP COMMON!
C
C  nmom   -- no. of Fourier moments in use
C  mimom  -- max no. of Fourier moments (array dimension)
C  nonlin -- LUN for writing error message
C
C output:
C
C   caution:  dimension ordering follows TRANSP COMMON!
C
C  rmb0(...) -- 0th R moments (extrapolated grid)
C  rmb2(...) -- higher R moments (extrapolated grid)
C  ymb2(...) -- higher Y moments (extrapolated grid)
C
C------------------------------------------------------------------
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER nzones,inbblo,mtbl,mj,nmom,mimom,nonlin,lcentr,jmax
      INTEGER inzp1,inzp2,lcm1,j,jzb,im,jbx0,iter,ibad,itermax,ierr
      INTEGER jb1,jb2,imxtra
!============
! idecl:  explicitize implicit REAL declarations:
      REAL*8 ziter,zdx,zr0,zdr0dx
!============
      REAL*8 xiblo(mtbl)
C
      REAL*8 rmom0(mj)
      REAL*8 rmom(mimom,mj),ymom(mimom,mj)
C
      REAL*8 rmb0(mtbl)
      REAL*8 rmb2(mtbl,mimom)
      REAL*8 ymb2(mtbl,mimom)
C
C	--------------
      PARAMETER	(JMAX = 128)
C
C  UP-DOWN SYMMETRIC CASE :
C
      REAL*8	ZRJ(JMAX)               !R(J)
      REAL*8	ZYJ(JMAX)               !Y(J)
      REAL*8	ZDRDXI(JMAX)            !DR(J)/DXI
      REAL*8	ZDYDXI(JMAX)            !DY(J)/DXI
C
      LOGICAL	R8LOKJAC                  !LOGICAL FUNCTION - IS THE JACOBIAN OK?
C
C------------------------------------------------------------------
C
C   first copy the interior moments
C
C   NO. OF BDY'S INSIDE PLASMA; no. of zones PLUS 1
C
      INZP1=NZONES+1
      INZP2=NZONES+2
C
      LCM1=LCENTR-1
C
      DO 60 J = 1, INZP1
         JZB=J+LCM1
         RMB0(JZB) = RMOM0(JZB)
         DO 50 IM = 1, NMOM
            RMB2(JZB,IM) = RMOM(IM,JZB)
            YMB2(JZB,IM) = YMOM(IM,JZB)
 50      CONTINUE
 60   CONTINUE
C
C	DO THE EXTRAPOLATION INTO THE BLOATED ZONES
C
      JBX0=INZP2+LCM1
C
      iter=0
      ibad=0
      itermax=20
C
 99   continue
      ierr=0
      iter=iter+1
      ziter=AREAL(iter)/AREAL(itermax)
      if(ziter.gt.1.0D0) then
C
         WRITE(NONLIN,10150) XIBLO(JZB)
10150    FORMAT(' BLOAT ERROR: BAD BLOATED SURFACE AT XI=',1PE12.4
     1		,/,' THE JACOBIAN CHANGED SIGNS ON THE SURFACE'/
     1             ' Even on the final iteration (99 loop of BLOATX)')
         call errmsg_exit(' ... error in BLOATS0!')
C
      endif
C
      DO 10100 J = INZP2,INBBLO         !INTO GHOST ZONE
C
         JZB  = J + LCM1
         ZDX = XIBLO(JZB) - XIBLO(JZB-1)
C
C  DMC - CONSTRUCT AN EXTRAPOLATED SURFACE USING A LOCAL INTEGRATION
C   SCHEME.  MAKE THETA LINES SEEK A SIMPLE CIRCULAR SHAPE BUT ONLY
C   DIFFERENTIABLY, BASED ON DATA FROM THE PREVIOUS 2 SURFACES.
C
         CALL r8tksbcon(XIBLO,RMB0,MTBL,RMB2,YMB2,MIMOM,NMOM,
     >      JZB,JBX0,ZITER)
C
C  R8LOKJAC DATA
C
         JB1=JZB
         JB2=JZB-1
C
         ZR0=0.5D0*(RMB0(JB1)+RMB0(JB2))
C
         ZDR0DX=(RMB0(JB1)-RMB0(JB2))/ZDX
C
         DO 10090 IM=1,NMOM
C
            ZRJ(IM)=0.5D0*(RMB2(JB1,IM)+RMB2(JB2,IM))
            ZDRDXI(IM)=(RMB2(JB1,IM)-RMB2(JB2,IM))/ZDX
C
            ZYJ(IM)=0.5D0*(YMB2(JB1,IM)+YMB2(JB2,IM))
            ZDYDXI(IM)=(YMB2(JB1,IM)-YMB2(JB2,IM))/ZDX
C
10090    CONTINUE
C
         IMXTRA=NMOM
         IF(R8LOKJAC(ZR0,ZDR0DX,
     1      ZRJ,ZDRDXI,ZYJ,ZDYDXI,IMXTRA))	THEN
C
            GO TO 10100                 !COMPUTE THE NEXT SURFACE
C
         ELSE                           !THIS SURFACE WAS BAD, WARN & END LOOP
C
            ierr=1
            go to 9999
C
         ENDIF
C
10100 CONTINUE
C
 9999 CONTINUE
C
      if(ierr.eq.1) then
         ibad=iter
         go to 99                       ! try again to extrapolate surfaces
      endif
      if(iter.lt.itermax) then
         if(iter.eq.ibad+1) go to 99    ! try for some margin
      endif
C
      RETURN
      END
! 10Jan2003 fgtok -s r8_precision.sub r8bloat_names.sub "r8con.csh conversion"
! 10Jan2003 fgtok

subroutine eqi_mds_fromGeqdsk(filename, ihermite, inew_device, &
     ns, nt1, i2pi, fbdy, cbdy, irz, Jopt, icur_psi, xbrk_cur, &
     xbrk_mom, rtol_mom, gs_maxerr, ier)
 
  !-----------------------------------------------------------------------
  ! read G-EQDSK file and and perform inverse map,
  !   i.e. derive {R(theta,x),Z(theta,x)} flux surfaces from Psi(R,Z)
  !   by contouring (interpolation) techniques
  !-----------------------------------------------------------------------

  !-----------------------------------------------------------------------
  ! The following data from the G-EQDSK data object "geq" are used:
  !    grid dimensions: RLEFT_M, RDIM_M, ZMID_M, ZDIM_M, NW, NH
  !    limiter contour: LIMITR, RLIM_M, ZLIM_M
  !    total toroidal current: CURRENT_A
  !        (always used for sign of current; see icur_psi option 
  !        description in next section of comments).
  !    poloidal flux at axis and byd:  SIMAG_Wb__Rad, SIBRY_Wb__Rad
  !        (used, but adjusted based on analysis of Psi(R,Z))
  !    poloidal flux function Psi(R,Z):  PSIRZ_Wb__Rad -- flux surfaces.
  !    central toroidal field: BCENTR_T (sign only)
  !    plasma boundary contour:  NBBBS, RBBBS_M, ZBBBS_M
  !        (will be adjusted based on analysis of Psi(R,Z))
  !    plasma axis location:  RMAXIS_M, ZMAXIS_M
  !        (will be adjusted based on analysis of Psi(R,Z))
  !    toroidal field function:  FPOL_TM
  !    pressure profile:  PRES_Nt__M2
  ! 
  !-----------------------------------------------------------------------
  ! CONDITIONALLY USED:  if icur_psi = 0, QPSI is used for the q
  !    profile and |CURRENT_A| is used as a boundary condition for the
  !    enclosed toroidal current profile; if icur_psi = 1, QPSI and
  !    CURRENT_A values are discarded: the q profile and total enclosed
  !    current are computed from contour integrals over Psi(R,Z) instead.
  !
  !    (Advice: for EFIT data from e.g. TRANSP time slices, not based on a 
  !    free boundary GS solution, icur_psi = 0 is better; for EFIT data
  !    that is based on a good free boundary GS solution, icur_psi = 1 
  !    is better).
  !
  !    For either setting of icur_psi, xbrk_cur usually needs to be set
  !    to a point somewhat in from the boundary, to get a smooth dI/drho
  !    and <J.B> in the edge region.  Typical value: xbrk_cur=0.9; 
  !    constraint: 0.75 <= xbrk_cur <= 0.95 as of June 2008 (dmc).
  ! 
  !-----------------------------------------------------------------------
  ! NOT USED:  d/dpsi profiles FFPRIM_T2M2Rad__Wb and PPRIME_NtRad__M2Wb
  !            QPSI and CURRENT_A magnitude are not used, if icur_psi = 1.
  ! NB: PPRIME data is saved in xplasma profile "dPdPsi"
  !-----------------------------------------------------------------------

  !-----------------------------------------------------------------------
  ! ORIGINAL COMMENTS:
  !
  ! dmc 10 Jan 2001
  ! based on Alex's i2mex_fromGeqdsk ...
  ! for general xplasma use:
  ! (1) choose boundary psi(bdy) from combination of data and user
  !     input, e.g. use the .99*psi(sep) surface for the boundary
  ! (2) form and use a normalized sqrt toroidal flux variable "xi":
  !     spline q(psi) and integrate dphi = q*dpsi; xi=1 @ psi=psi(bdy).
  ! (3) delineate the psi contours at the psi's corresponding to the
  !     set of selected "xi" surfaces.
  !
  ! dmc -- bugfix -- 9 Nov 2001 -- following correct Lang Lao convention
  !     on significance of signs of items in the G-EQDSK data
  !     "isnccwx" retained for old xplasma g-eqdsk files that did
  !     not follow the sign convention.
  ! (corresponsing bugfix for xplasma g-eqdsk file write is in
  ! eq_geqdsk.for)
  !     for all "real" g-eqdsk files, isnccwx=1 is to be expected.
  !
  !-----------------------------------------------------------------------
  ! CHANGES:
  !
  ! dmc June 2009
  ! --save "PSI0" = the offset applied to make PsiRZ = 0 at the mag. axis.
  !   so that PsiRZ + Psi0 restores the original EFIT Psi(R,Z).  This is
  !   written as element PSI0 in the PSI0_CONTAINER list in xplasma -- see
  !   xplasma_save_psi0 in xplasma_fromgeq module.  If the input is detected
  !   to be a g-eqdsk dataset from a core-only TRANSP run, Psi0 is is not
  !   available and so is not saved.
  !
  !-----------------------
  ! dmc March 2008
  ! 1.  Form theta adaptive grid (thadapt in eqi_geq_mod) to concentrate
  ! points near minima in curvature radius of contours, i.e. near the
  ! separatrix points beyond the boundary.
  ! 2.  If the boundary, as computed on this grid, starting from an EFIT
  ! specified boundary location, exceeds the curvature criterion (cbdy),
  ! it is accepted as the boundary for {R(theta,x),Z(theta,x)}.
  ! 3.  If the EFIT boundary minimum curvature is less than (cbdy), then,
  ! find a boundary shifted in from the EFIT boundary to the extent 
  ! necessary to match the (cbdy) normalized curvature limit PRECISELY.
  ! 4.  Taking the chosen boundary points on the (1:nt1) theta grid, find
  ! all interior points using a root finder, instead of the LSODE-based
  ! contour following method (for better accuracy/reproducibility).

  ! major related sources:
  !   eqi_contour.f90 -- LSODE-based contour follower, used for analysis of
  !   the boundary
  !   eq_geq_findrz.f90 -- root finder code (match chosen target Psi values
  !   along selected line segments in (R,Z) space).
 
  ! ***NOTE***
  !   there are many "bad" EFIT Psi(R,Z) datasets that will trip any number
  !   of error checks in this routine.  If an error is detected, Psi(R,Z) 
  !   should be examined: does it have well behaved nested Psi level contours
  !   inside the specified EFIT boundary ???  Do not assume that the error is
  !   in the code...
  !--------------------------------------
!  use xplasma2_calls
  use xplasma_definitions
  use eqi_rzbox_module

  use eqi_geq_mds_mod  ! contains psi(R,Z) spline, (R0,Z0), and (Rpp,Zpp)
                   ! also contains G-EQDSK module & instance "geq".
 
  implicit none
  integer, parameter :: r8=selected_real_kind(12,100)
 
  ! ------------------ arguments ---------------------------------
 
  character*(*), intent(in) :: filename  ! Geqdsk filename or MDS+ path
  !                  ...or...EFIT_INDEX:filename(t=<time>) specification
  !                  see comments in source/old_xplasma/eqm_fromgeqdsk.f90

  logical, intent(in) :: ihermite  ! .TRUE. for Hermite {R,Z}(rho,theta)
  !  .FALSE. for bicubic spline {R,Z}(rho,theta)
  !  NOTE: in both cases the spline is computed; this flag causes the
  !  bicubic spline representation to be converted to bicubic Hermite.
  !  EITHER WAY, the representation is C2; the two representations are
  !  generally equivalent to machine precision, but there are technical
  !  reasons for making this control available.

  logical, intent(in) :: inew_device  ! .TRUE. for new device; limiter 
  !  definitions to be read in (otherwise assume they are already known).

  integer, intent(in) :: ns     ! no. of surfaces incl. mag. axis
  integer, intent(in) :: nt1    ! no. of theta points
  integer, intent(in) :: i2pi   ! =1: theta range -pi:pi; =2: range 0:2pi
  real(r8), intent(in) :: fbdy  ! psi(bdy) = fbdy * psi(separatrix) [***]

  real(r8), intent(in) :: cbdy  ! min. allowed relative curvature
  !  actually, min(0.2_R8,max(0.03_R8,cbdy)) is used

  integer, intent(in) :: irz    ! =1 to extend xplasma mapped region to (R,Z)

  integer, intent(in) :: jopt   ! =1 for equal arc poloidal angle coordinate
                                ! =0 for traditional VMEC/descur compressed
                                !    moments
                                ! =-1 to use eqi_contour output directly...

  integer, intent(in) :: icur_psi  ! =0: use EFIT scalar data for total current
                                ! and use the EFIT 1d q(psi) profile "QPSI".
                                ! =1: discard EFIT CURRENT_A and QPSI data;
                                ! recompute q(psi) and total current from
                                ! Psi(R,Z) data instead.

  real(r8), intent(in) :: xbrk_cur ! break point for quadratic interpolation
                                ! of I(rho) from interior to edge value
                                ! (whether taken from CURRENT_A or Psi(R,Z)).
                                ! This is necessary to get a smooth <J.B> in
                                ! the edge region.  Typical value: 0.9;
                                ! enforced range: 0.75 <= xbrk_cur <= 0.95.

  real(r8), intent(in) :: xbrk_mom ! x width of axial regularization region
  real(r8), intent(in) :: rtol_mom ! rel. tolerance for zeroing of moments

  real(r8), intent(out) :: gs_maxerr  ! max rel. GS error found
  !  (normalized measure of self-consistency of equilibrium)

  integer, intent(out) :: ier   ! completion code, 0=OK
 
  ! [***] more precisely...
  !
  !   psi(bdy) = psi(axis) + fbdy*(psi(separatrix) - psi(axis))
  !
  !   as Geqdsk psi(axis) can be non-zero
  !
  ! ------------------- local memory -----------------------------
 
  real(r8), dimension(:), allocatable :: p, q, g, psi, psi_geq, psis, &
       & the, rgrid, zgrid, xi, phi, psivec, qpsia, pprime
  integer :: inw,inh

  real(r8), dimension(:, :), allocatable :: r, z, psirz_geq, gserr_geq
  real(r8), dimension(:, :), allocatable :: rmmc, rmms, zmmc, zmms
  real(r8), dimension(:, :), allocatable :: psirz_sm, gpsi_geq, gpsi_wk
  real(r8), dimension(:, :), allocatable :: x2d,x2dq,wkint

  real(r8), dimension(:), allocatable :: csthtk,snthtk,xint,thint,wint
  logical, dimension(:), allocatable :: lsurf,lqpsi
  real(r8), dimension(:), allocatable :: icurt,xtmp

  real(r8) :: rmin, rmax, zmin, zmax, surf, rm, zm, rp, zp, &
       pmag, pi, twopi, zfac, zfacp, tol, ctol, ztol, zero, bdist, &
       rzdel, zxbrk_mom, zfac0, zfac_ok, zfac_fail, zqgen, zgtmp

  real(r8) :: wts(10),xwts(10)  ! gauss-kronrod-patterson quadrature data
 
  real(r8) :: dvdpsi,gpsi2r2i,mu0,xibrk,x1,x2,x3,xxx,aicur,bicur
  integer :: id4(4),ideriv4(4),nsbrk

  real(r8) :: psimin, psimax
  real(r8) :: ztime1,zrnew,zznew,zone,zrtol
 
  real(r8), dimension(ns,2) :: rzvec
  real(r8), dimension(ns) :: rpa,zpa,zero_vec,one_vec,xvec
 
  real(r8), dimension(1) :: wkvec1,wkvec2,wkvec3
  real(r8), dimension(1,4) :: wkvec4
  real(r8), dimension(1,2) :: wkvec5

  ! bdy cond arrays
 
  real(r8) bcr(nt1),bcz(nt1)
 
  integer ifail,jfail,icount,iertmp,imaxr,inumx
  logical lmask(max(ns,nt1))
 
  integer iok, i, ith, j, iter, itmax, imom, ismoo, iez
  integer idrv1,iknot,iwarn,im,ibc1,iiopt,ikmax,ins_test
  integer isnccwi, isnccwb, isnccwx, id_lim, isize_lim
 
  integer id_rho,id_chi,id_R,id_Z,id_psi,id_gpsi,id_phi,id_g,id_q,id_p,idprev
  integer id_Rgrid,id_Zgrid,id_gserr,id_curt,id_pp
 
  real(r8) fbdy_use,cbdy_use,cbdy_got
 
  real(r8) :: xbrkii,zbdyp,zbdym,zincr,zbd4(4),rbd4(4),zwp,zwm,zerr,zdrv1
  integer :: ibdyp,ibdym,idir,iorig

  character*120 msgbuf

  character*32 zauthor
  logical :: ienable,ifinish

  integer, parameter :: ilun_dbg=6
  logical, parameter :: dbg_print = .FALSE.

  integer :: inz,instep,inzmin,inzprev,ifac,ict,ict_ok,ict_fail
  real*8, dimension(:), allocatable :: psis0
  real*8 :: rbdy00,zbdy00,psibdy0,psibdy,psi_test,psi_ok,psi_avg,psibdy_use
  real*8 :: psi_avg_ok,psi_inc,psibdy_reset
  real*8 :: psi_avg_save,zfac_fail_save,zfac_ok_save
  real*8 :: zth,zth2,zth2p,diffmax,psitmp
  real*8 :: psidum1,psidum2
  integer :: ii,jj,jj1,jj2,istat,nsing

  real*8, dimension(:), allocatable :: zwk

  real*8, parameter :: limtol = 1.0d-4

  !--------------------
  !  PSI0 list...

  character*10 :: ztest
  real*8 :: psi0
  logical :: ipsi0

  ! ------------------- root finder passed routine ---------------
 
  external eqi_geq_findrzs  ! find (R,Z) pts along set of arrays to match psi
  external eqi_find_curv    ! find boundary with desired curvature
  external eqi_geq_mds_psimin   ! find min(psi(R)) along line of fixed Z
 
  external eqm_bpsi         ! given psi(R,Z), g(psi), compute B(R,Z) vector
 
  ! ------------------- executable code --------------------------
 
  if(dbg_print) then
     write(ilun_dbg,*) ' ----------------> eqi_mds_fromgeqdsk:'
     write(ilun_dbg,*) '  filename = "'//trim(filename)//'"'
     write(ilun_dbg,*) '  ihermite = ',ihermite
     write(ilun_dbg,*) '  inew_device = ',inew_device
     write(ilun_dbg,*) '  ns  = ',ns
     write(ilun_dbg,*) '  nt1 = ',nt1
     write(ilun_dbg,*) '  i2pi = ',i2pi
     write(ilun_dbg,*) '  fbdy = ',fbdy
     write(ilun_dbg,*) '  cbdy = ',cbdy
     write(ilun_dbg,*) '  irz = ',irz
     write(ilun_dbg,*) '  icur_psi = ',icur_psi
     write(ilun_dbg,*) '  xbrk_cur = ',xbrk_cur
     write(ilun_dbg,*) '  Jopt = ',jopt,' *** '
     write(ilun_dbg,*) '  xbrk_mom = ',xbrk_mom
     write(ilun_dbg,*) '  rtol_mom = ',xbrk_mom
     write(ilun_dbg,*) ' --------------------------------------- '
  endif

  ier = 0
  msgbuf = ' '

  gs_errmax = -1  ! default value (seen e.g. on an early error exit)
 
  call xplasma_author_query(sp,zauthor,ienable,ier)
  if(ier.ne.0) return

  if(zauthor.eq.xplasma_root) then
     call xplasma_author_set(sp,'eqi_mds_fromgeqdsk',ier)
  else
     call xplasma_author_resume(sp,zauthor,ier)  ! ensure write enable
  endif
  if(ier.ne.0) return

  pi   =3.1415926535897931_R8
  twopi=6.2831853071795862_R8
  mu0  = 2*twopi*1.0e-7_R8
        
  zero=0.0_R8
  zone=1.0_R8
 
  iez  =0

  itmax=10

  xbrkii = max(0.75_R8,min(0.95_R8,xbrk_cur))
  if((icur_psi.lt.0).or.(icur_psi.gt.1)) then
     write(msgbuf,*) ' ?eqi_mds_fromgeqdsk: invalid icur_psi switch: not 0 or 1.'
     call eqi_mds_fromg_err(msgbuf)
     ier=101
     go to 1000
  endif

  ! ---> read Geqdsk data
 
  call geq_init(geq, filename, iok)
  call geq_error(iok)
  if(iok/=0) ier = 117
  if(iok/=0) go to 1000
 
  ! grid limits:

  rmin = geq%RLEFT_M
  rmax = geq%RLEFT_M + geq%RDIM_M
  zmin = geq%ZMID_M - geq%ZDIM_M/2.0_r8
  zmax = geq%ZMID_M + geq%ZDIM_M/2.0_r8

  if((rmax.le.rmin).or.(zmax.le.zmin)) then
     write(msgbuf,*) '  singular EFIT R or Z grid: Rmin,Rmax: ',rmin,rmax
     call eqi_mds_fromg_err(msgbuf)
     write(msgbuf,*) '  singular EFIT R or Z grid: Zmin,Zmax: ',zmin,zmax
     call eqi_mds_fromg_err(msgbuf)
     ier = 105
     go to 1000
  endif

  ! check limiter range:

  do ii=1,geq%Limitr
     if((geq%Rlim_m(ii).lt.(Rmin-limtol)).or. &
          (geq%Rlim_m(ii).gt.(Rmax+limtol))) then
        if(ier.eq.0) then
           write(msgbuf,*) &
                '  Limiter R point outside R grid range Rmin to Rmax: ', &
                Rmin,Rmax
           call eqi_mds_fromg_err(msgbuf)
           write(msgbuf,*) &
                '  Limiter point #',ii,' R value: ',geq%Rlim_m(ii)
           call eqi_mds_fromg_err(msgbuf)
        endif
        ier = ier + 1
     else
        geq%Rlim_m(ii) = max(Rmin, min(Rmax, geq%Rlim_m(ii)) )
     endif

     if((geq%Zlim_m(ii).lt.(Zmin-limtol)).or. &
          (geq%Zlim_m(ii).gt.(Zmax+limtol))) then
        if(ier.eq.0) then
           write(msgbuf,*) &
                '  Limiter Z point outside Z grid range Zmin to Zmax: ', &
                Zmin,Zmax
           call eqi_mds_fromg_err(msgbuf)
           write(msgbuf,*) &
                '  Limiter point #',ii,' Z value: ',geq%Zlim_m(ii)
           call eqi_mds_fromg_err(msgbuf)
        endif
        ier = ier + 1
     else
        geq%Zlim_m(ii) = max(Zmin, min(Zmax, geq%Zlim_m(ii)) )
     endif
  enddo

  if(ier.ne.0) then
     ier=104
     go to 1000
  endif

  ! ---> check signs
 
  if( geq%CURRENT_A .gt. 0.0_R8 ) then
 
     isnccwi = 1               ! toroidal current ccw looking down on tokamak
                               ! (g-eqdsk test)
 
  else
 
     isnccwi = -1              ! toroidal current clockwise
                               ! (g-eqdsk test)
 
  endif
 
  if( (geq%SIBRY_Wb__Rad - geq%SIMAG_Wb__Rad ) .gt. 0.0_R8 ) then
 
     isnccwx = 1               ! toroidal current ccw looking down on tokamak
                               ! (old xplasma g-eqdsk)
 
  else
 
     isnccwx = -1              ! toroidal current clockwise
                               ! (old xplasma g-eqdsk)

     call eqi_mds_fromg_err(' %eqi_mds_fromgeqdsk warning (fixup applied):')
     msgbuf=' '
     write(msgbuf,*) '  Psi(bdy) = ',geq%sibry_WB__Rad, &
         ' < Psi(0) = ',geq%SIMAG_Wb__Rad
     call eqi_mds_fromg_err(msgbuf)
     call eqi_mds_fromg_err('  (violates de facto EFIT G-eqdsk convention)')
 
  endif
 
  ! ---> and normalize psi definition:  0 on axis & increasing outward
 
  psimin=0.0_R8
  psimax=isnccwx*(geq%SIBRY_Wb__Rad-geq%SIMAG_Wb__Rad)
 
  inw = geq%NW   ! number of R pts = # of Psi pts in 1d profiles in EFIT data
  inh = geq%NH   ! number of Z pts

  allocate(psirz_geq(inw,inh),gserr_geq(inw,inh))
  allocate(psirz_sm(inw,inh))
  psirz_geq = isnccwx*(geq%psirz_Wb__Rad - geq%SIMAG_Wb__Rad)
 
  ! ---> form R & Z rectangular mesh & check data

  allocate(rgrid(inw))
  allocate(zgrid(inh))
 
  rgrid=rmin + (rmax - rmin)*(/ (real(i-1,r8)/real(inw-1,r8), i=1,inw) /)
  zgrid=zmin + (zmax - zmin)*(/ (real(i-1,r8)/real(inh-1,r8), i=1,inh) /)
 
  call psirz_mds_minmax(inw,inh,rgrid,zgrid,psirz_geq, &
       geq%NBBBS,geq%RBBBS_M,geq%ZBBBS_M,psidum1,psidum2,nsing)

  if(nsing.gt.1) then
     call eqi_mds_fromg_err( &
          ' ?eqi_mds_fromgeqdsk: Psi(R,Z) screening failed, multiple local minima or maxima')
     ier=116
     go to 1000
  endif

  ztest(1:8) = geq%case_(1)
  ztest(9:10) = geq%case_(2)(1:2)

  ipsi0=.TRUE.   ! TRUE to save PSI0 offset
  if(ztest(1:6).eq.'TRXPL ') then

     ! a zero offset value will be saved if this appears to be a
     ! g-eqdsk data set extrapolated from a core only TRANSP equilibrium...

     if(ztest(7:10).ne.'(fb)') then
        ipsi0=.FALSE.
     endif
  endif

  if(ipsi0) then
     psi0 = geq%SIMAG_Wb__Rad
  else
     psi0 = 0.0_r8
  endif

  if (geq%BCENTR_T .gt. 0.0_R8 ) then
 
     isnccwb = 1               ! toroidal field ccw looking down on tokamak
 
  else
 
     isnccwb = -1              ! toroidal field clockwise
 
  endif

  ! ---> smooth Psi(R,Z) beyond the boundary only; use EFIT bdy for this...

  call psirz_mds_smooth(inw,inh,rgrid,zgrid,psirz_geq,psirz_sm, &
       geq%NBBBS,geq%RBBBS_M,geq%ZBBBS_M)
 
  ! check GS error
 
  gserr_geq = 0
 
  bdist = 0.05_r8   ! screen out pts within bdist*(Rmax-Rmin) of bdy
 
  call geq_mds_GSerror(isnccwx, &
       geq, inw, inh, rgrid, zgrid, bdist, gserr_geq, ier)
  if(ier.ne.0) then
     call eqi_mds_fromg_err( &
          ' ?eqi_mds_fromgeqdsk: geq_mds_GSerror found no equilibrium data.')
     gserr_geq = 1
     ier=121
     go to 1000
  endif
 
  gs_errmax=maxval(abs(gserr_geq))  ! in eqi_geq_mod module
  gs_maxerr=gs_errmax               ! in return argument
 
  allocate(psi(ns), psi_geq(inw), p(ns), g(ns), pprime(ns), q(ns), the(nt1))
  allocate(phi(ns), xi(ns))
  allocate(r(nt1, ns), z(nt1, ns), gpsi_geq(nt1,ns))
  allocate(psis(nt1))
 
  ! ---> form psi(R,Z) spline
 
  iez = 1
  call ezspline_init(pspl, inw, inh, (/0,0/), (/0,0/), iok)
  call ezspline_error(iok)
  if(iok.eq.0) then
     pspl%x1 = rgrid
     pspl%x2 = zgrid
     !pspl%isHermite = 1 ! Akima Hermite
     call ezspline_setup(pspl, psirz_sm, iok)
     call ezspline_error(iok)
  endif

  deallocate(psirz_geq)  ! use psirz_sm now...

  if(iok.ne.0) then
     call eqi_mds_fromg_err( &
          ' ?eqi_mds_fromgeqdsk: Psi(R,Z) bicubic spline setup error.')
     ier = 106
     go to 1000
  endif

  ! ---> this will be the normalized sqrt(tor.flux) mesh
 
  xi = (/ (real(i-1,r8)/real(ns-1,r8), i=1,ns) /)
 
  ! ---> and the poloidal grid...

  if(i2pi.eq.1) then
     the = -pi + twopi * (/ (real(i-1,r8)/real(nt1-1,r8), i=1, nt1) /) ! -pi:pi
  else
     the = twopi * (/ (real(i-1,r8)/real(nt1-1,r8), i=1, nt1) /)  ! range 0:2pi
  endif
 
  ! ---> mag axis & point on G-EQDSK plasma boundary -- from EFIT
 
  rm = geq%RMAXIS_M
  zm = geq%ZMAXIS_M

  ! find point with max R value; also construct bdy sequence which does
  ! not close on the last point and which has no duplicate points

  inumx=geq%NBBBS
  if(allocated(rzwk)) deallocate(rzwk)
  allocate(rzwk(inumx,2))

  imaxr=1
  inumx=1
  rzwk(1,1)=geq%RBBBS_M(1)
  rzwk(1,2)=geq%ZBBBS_M(1)
  do ii=1,geq%NBBBS
     if((geq%RBBBS_M(ii).eq.rzwk(inumx,1)).and. &
          (geq%ZBBBS_M(ii).eq.rzwk(inumx,2))) cycle
     if((geq%RBBBS_M(ii).eq.rzwk(1,1)).and. &
          (geq%ZBBBS_M(ii).eq.rzwk(1,2))) cycle
     inumx=inumx+1
     rzwk(inumx,1)=geq%RBBBS_M(ii)
     rzwk(inumx,2)=geq%ZBBBS_M(ii)
     if(rzwk(inumx,1).gt.rzwk(imaxr,1)) then
        imaxr=inumx
     endif
  enddo

  rp = rzwk(imaxr,1)
  zp = rzwk(imaxr,2)
 
  rzdel = (rp-rm)/10

  ! --> try to adjust mag axis location (find true minimum of psi(R,Z) 
  !     interpolant)

  lmask(1)=.FALSE.
  tol=1.0e-9
  wkvec1=zm-rzdel
  wkvec2=zm+rzdel
  wkvec4(1,1)=rm
  wkvec4(1,2)=rzdel
  wkvec4(1,3)=tol
  wkvec4(1,4)=tol*(psimax-psimin)/rzdel
  
  call zriddery(1, lmask(1:1), wkvec1, wkvec2, tol, &
       wkvec4(1,4), eqi_geq_mds_psimin, wkvec3, ifail, &
       1, wkvec4, 4, wkvec5, 2)
  jfail=abs(wkvec5(1,2))+0.5_R8

  if((ifail.ne.0).or.(jfail.ne.0)) then
     call eqi_mds_fromg_err( &
          ' %eqi_mds_fromgeqdsk: Psi_min search failed, using EFIT result')
     r0 = rm
     z0 = zm
  else
     z0=wkvec3(1)
     r0=wkvec5(1,1)
     if(max(abs(r0-rm),abs(z0-zm)).gt.0.005_R8*r0) then
        call eqi_mds_fromg_err(' %eqi_mds_fromgeqdsk: Psi_min axis adjustment:')
        msgbuf=' '
        write(msgbuf,'(5x,a,1pe12.5," -> ",1pe12.5)') 'R_axis: ',rm,r0
        call eqi_mds_fromg_err(msgbuf)
        msgbuf=' '
        write(msgbuf,'(5x,a,1pe12.5," -> ",1pe12.5)') 'Z_axis: ',zm,z0
        call eqi_mds_fromg_err(msgbuf)
     endif
     rm=r0
     zm=z0
  endif
          
  ! now find a new (EFIT) boundary point (rp,zp) with zp=z0 precisely
  ! initiate search

  if(zp.ne.z0) then
     if(zp.gt.z0) then
        zbdyp=zp                  ! zp > z0
        ibdyp=imaxr
        iorig=1

        zbdym=zbdyp
        ibdym=ibdyp
        idir=-1
        call fnxz(ibdym,zbdym)
        if(zbdym.gt.zp) then
           ibdym=ibdyp
           idir=1
           call fnxz(ibdym,zbdym)
        endif

     else
        zbdym=zp                 ! zp < z0
        ibdym=imaxr
        iorig=-1

        zbdyp=zbdym
        ibdyp=ibdym
        idir=1
        call fnxz(ibdyp,zbdyp)
        if(zbdyp.lt.zbdym) then
           ibdyp=ibdym
           idir=-1
           call fnxz(ibdyp,zbdyp)
        endif
     endif

     if(ier.ne.0) then
        call eqi_mds_fromg_err('%eqi_mds_fromgeqdsk: EFIT boundary singular.')
        ier=118
        go to 1000
     endif

     ict=0
     do while ((zbdyp-z0)*(zbdym-z0).gt.0.0_R8)
        ict = ict + 1
        if(ict.gt.inumx) then
           ier=119
           call eqi_mds_fromg_err('%eqi_mds_fromgeqdsk: Psimin outside EFIT boundary.')
           go to 1000
        endif

        call fnxz(ibdyp,zbdyp)
        call fnxz(ibdym,zbdym)
     enddo

     ! pts straddling z0...
     zbd4(2)=zbdym; rbd4(2)=rzwk(ibdym,1)
     zbd4(3)=zbdyp; rbd4(3)=rzwk(ibdyp,1)

     ! and their immediate neighbors...
     idir=idir*iorig
     call fnxz(ibdym,zbdym)
     zbd4(1)=zbdym; rbd4(1)=rzwk(ibdym,1)
     idir=-idir
     call fnxz(ibdyp,zbdyp)
     zbd4(4)=zbdyp; rbd4(4)=rzwk(ibdyp,1)

     ! Now: zbd4(1:4) is an ascending sequence with z0 btw zbd4(2) and zbd4(3).
     !    & rbd4(1:4) are the corresponding R values.

     zwp = (z0-zbd4(2))/(zbd4(3)-zbd4(2))
     zwm = 1.0_R8 - zwp

     rp = zwp*quadintrp(z0,zbd4(2:4),rbd4(2:4)) + &
          zwm*quadintrp(z0,zbd4(1:3),rbd4(1:3))
     zp = z0
  endif

  ! select a point slightly beyond the plasma boundary...
 
  if(rp.le.r0) then
     call eqi_mds_fromg_err( &
          ' %eqi_mds_fromgeqdsk:  outer boundary point Rp < axis R0 ')
     msgbuf=' '
     write(msgbuf,*) '  Rp = ',rp,' R0 = ',r0
     call eqi_mds_fromg_err(msgbuf)
     ier = 120
     go to 1000
  endif
           
  zfac = min(1.025_R8,(rmax-r0)/(rp-r0))
  if(zfac.lt.1.0_R8) then
     call eqi_mds_fromg_err( &
          ' %eqi_mds_fromgeqdsk:  boundary point beyond mapped region.')
     msgbuf=' '
     write(msgbuf,*) '  rp = ',rp,' rmax = ',rmax
     call eqi_mds_fromg_err(msgbuf)
     ier = 120
     go to 1000
  endif
 
  ! interpolate to get psi on axis
 
  call ezspline_interp(pspl, rm, zm, pmag, iok)
  call ezspline_error(iok)

  if(iok/=0) ier = 120
  if(iok/=0) go to 1000
 
  ! psi on separatrix (cleaned up EFIT bdy)
 
  allocate(psis0(inumx))

  call ezspline_interp(pspl, inumx, rzwk(1:inumx,1), rzwk(1:inumx,2), psis0, &
       iok)
  call ezspline_error(iok)

  if(iok/=0) ier = 120
  if(iok/=0) go to 1000

  psep=sum(psis0)/inumx

  deallocate(psis0)
 
  ! check against file values for psi on axis & separatrix
 
  fbdy_use = (psep-pmag)/(psimax-psimin)
  if((fbdy_use.lt.0.98_R8).or.(fbdy_use.gt.1.02_R8)) then
     call eqi_mds_fromg_err(' %eqi_mds_fromgeqdsk:  psi(R,Z) interpolation')
     call eqi_mds_fromg_err('  yields psi(mag) and psi(sep) different')
     call eqi_mds_fromg_err('  from scalar values in g-eqdsk file:')
     msgbuf=' '
     write(msgbuf,*) '  -->interpolation values:  ',pmag,psep
     call eqi_mds_fromg_err(msgbuf)
     msgbuf=' '
     write(msgbuf,*) '  -->offset file values:    ',psimin,psimax
     call eqi_mds_fromg_err(msgbuf)
     ier = 120
     go to 1000
  endif

  !  reset Psi(R,Z) so that actual minimum is zero

  psirz_sm = psirz_sm-pmag
  pspl%fspl(1,:,:) = pspl%fspl(1,:,:)-pmag
  psep=psep-pmag
  if(ipsi0) psi0 = psi0 + pmag
  pmag=0.0_R8
  psimax=psep
  psimin=pmag
 
  fbdy_use = min(1.0_R8, max(0.95_R8, fbdy))
 
  cbdy_use = max(0.03_R8, min(0.2_R8, cbdy))

  cbdy_chk = min(0.25_R8, 2.0_R8*cbdy_use)  ! criterion for "small curvature"
  ! used to identify regions needing finer th grid resolution near bdy
 
  psibdy=psep*fbdy_use  ! EFIT bdy, adjusted 
  psi_ok=0.9_r8*psep    ! should be a safe value well inside the bdy

  !  find a closed field line outside psibdy or as close to it as possible,
  !  relaxing the curvature requirement
  !     ...accept if found outside the EFIT bdy, or if its curvature ratio
  !     is less than half the constrained user specified value (cdby_adjust).

  if(allocated(thadapt)) deallocate(thadapt,radapt,zadapt,curvad,iadapt)
  inz=50*nt1  ! a safe upper limit on required size
  allocate(thadapt(inz,2),radapt(inz,2),zadapt(inz,2),curvad(inz,2))
  allocate(iadapt(inz))

  inzmin=15   ! min. no. of zones to cover each region of high curvature

  !  initial grid...

  isw=1
  nthad=2*(nt1-1) + 1  ! double the grid
  nthad0 = nthad       ! (store in eqi_geq_mod)

  do ii=1,nthad
     thadapt(ii,isw)=(ii-1)*twopi/(nthad-1)
  enddo
  
  zfac0 = 1.0011_R8
  zincr = 5.0e-4_R8

  zfac_ok = zero    ! have not yet seen a closed contour
  zfac_fail = zero  ! have not yet seen an open contour

  iter = 0
  ict_ok = 0        ! #of closed contours seen
  ict_fail = 0      ! #of non-closed (or otherwise unacceptable) contours seen

  psi_avg_ok = 1.000010_R8*psibdy
  psi_inc = 1.0e-6_R8*psibdy
  psibdy_reset = psibdy
  psi_avg_save = -psibdy

  do
     zfac = zfac0
     do
        iter=iter+1
        if(iter.gt.10*itmax) then
           call eqi_mds_fromg_err( &
                ' ?eqi_mds_fromgeqdsk:  constrained closed boundary search failure.')
           ier=129
           go to 1000
        endif

        zfac = zfac - zincr
        rbdy00 = r0 + zfac*(rp-r0)
        zbdy00 = z0 + zfac*(zp-z0)

        call eqi_contour(rbdy00, zbdy00, 0.1_r8*cbdy_use, &
             psep, cbdy_got, psi_avg, istat, iok)
 
        if(istat.ge.3) then
           call eqi_mds_fromg_err( &
                ' ?eqi_mds_fromgeqdsk: unexpected error in eqi_contour.')
           ier=129
           go to 1000

        else if(istat.eq.0) then
           ict_ok = ict_ok + 1
           zfac_ok=zfac
           exit
        else
           ! contour not closed or too kinked at psi=psi_avg
           zfac_fail = zfac
           ict_fail = ict_fail + 1  ! # of non-closed contours seen

           !  reduce psi_avg_ok to be inside open/kinked contours if necessary
           do while (psi_avg.lt.psi_avg_ok)
              psi_avg_ok = psi_avg_ok-psi_inc
           enddo

           psibdy_reset = min(psibdy_reset, psi_avg_ok-psi_inc)

           if(ict_ok.gt.0) then
              zincr=zincr/2         ! we are in a binary search now
           endif
        endif
        if(zfac.lt.0.75_R8) then
           ier=122
           call eqi_mds_fromg_err( &
                ' ?eqi_mds_fromgeqdsk:  closed boundary contour search failed.')
           go to 1000
        endif
     enddo

     if((cbdy_got.ge.0.5_r8*cbdy_use).and.(psi_avg.le.psi_avg_ok)) then
        if(ict_fail.eq.0) then
           ! no open contour seen; starting point of search was too far in
           zfac0 = zfac0 + zincr
        else
           if(psi_avg_save.gt.psi_avg_ok) then
              ! psi_avg_ok moved; prior surface OK now
              zfac_fail=zfac_fail_save
              zfac_ok=zfac_ok_save
           else
              psi_avg_save=psi_avg
              zfac_fail_save=zfac_fail
              zfac_ok_save=zfac_ok
           endif
           zincr = (zfac_fail-zfac_ok)/2  ! binary search btw known limits
           zfac0 = zfac + 2*zincr         ! 1*zincr gets subtracted off
        endif
        cycle
     else
        exit  ! have a usable reference surface now.
     endif
  enddo

  psibdy=psibdy_reset

  if(psi_avg.lt.psi_ok) then
     ! warning only
     call eqi_mds_fromg_err(' %eqi_mds_fromgeqdsk: found closed contour far from EFIT nominal boundary.')
  endif

  ! refine th grid, so that curvature can be measured on ray-psi intercepts
  ! without having to solve an ODE to follow each level-psi contour.  This
  ! is done because the regions of sharp curvature are highly localized in
  ! the geometrical angle space about (r0,z0).

  do 
     inzprev=nthad
     call nx_thadapt(nt1,inzmin)
     if(nthad.eq.inzprev) then
        isw=3-isw  ! no change from prior grid, so, reuse prior data rather
        ! than recompute
        exit
     endif

     !  tolerate detection of sharpened curvature; effect due to change of
     !  "nthad" is possible, so, pass 0.05_r8*cbdy_use instead of 0.1_r8*...

     call eqi_contour(rbdy00, zbdy00, 0.05_r8*cbdy_use, &
          psep, cbdy_got, psi_avg, istat, iok)

     ! iok must = 0 now
     if(iok.ne.0) then
        call eqi_mds_fromg_err(' ?eqi_mds_fromgeqdsk: algorithm failure (L581)')
        ier=138
        go to 1000
     endif
  enddo

  ! force bdy search points to be exactly on rays emanating from the
  ! origin (r0,z0) at the specified grid of angles atan2((Z-Z0),(R-R0)) 
  ! -- they are nearly so already

  if(allocated(rseek)) deallocate(rseek,zseek)
  allocate(rseek(-1:nthad+2),zseek(-1:nthad+2))
  allocate(zwk(-1:nthad+2))

  zth2=0.0_r8
  do ii=1,nthad
     zth2p=zth2
     zth2=atan2(zadapt(ii,isw)-z0,radapt(ii,isw)-r0)
     if(zth2.lt.zth2p-pi) zth2=zth2+twopi
     zwk(ii)=zth2
  enddo

  iter=0
  diffmax=1.0_r8
  do while(diffmax.gt.(twopi*1.0e-15_r8))
     iter=iter+1
     if(iter.gt.itmax) then
        call eqi_mds_fromg_err( &
             ' ?eqi_mds_fromgeqdsk:  search ray angle refinement failure.')
        ier=131
        go to 1000
     endif

     call load_seek

     diffmax=0.0_r8
     zth2=0.0_r8
     do ii=1,nthad
        zth=thadapt(ii,isw)
        if(zth.eq.zwk(ii)) then
           zth2=zth
           cycle
        else if(zth.lt.zwk(ii)) then
           zwp=(zth-zwk(ii-1))/(zwk(ii)-zwk(ii-1))
           zwm=1.0_r8-zwp
           radapt(ii,isw) = &
                zwp*quadintrp(zth,zwk(ii-1:ii+1),rseek(ii-1:ii+1)) + &
                zwm*quadintrp(zth,zwk(ii-2:ii),rseek(ii-2:ii))
           zadapt(ii,isw) = &
                zwp*quadintrp(zth,zwk(ii-1:ii+1),zseek(ii-1:ii+1)) + &
                zwm*quadintrp(zth,zwk(ii-2:ii),zseek(ii-2:ii))
        else
           zwm=(zwk(ii+1)-zth)/(zwk(ii+1)-zwk(ii))
           zwp=1.0_r8-zwm
           radapt(ii,isw) = &
                zwm*quadintrp(zth,zwk(ii-1:ii+1),rseek(ii-1:ii+1)) + &
                zwp*quadintrp(zth,zwk(ii-2:ii),rseek(ii-2:ii))
           zadapt(ii,isw) = &
                zwm*quadintrp(zth,zwk(ii-1:ii+1),zseek(ii-1:ii+1)) + &
                zwp*quadintrp(zth,zwk(ii:ii+2),zseek(ii:ii+2))
        endif
        ! verify
        zth2p=zth2
        zth2=atan2(zadapt(ii,isw)-z0,radapt(ii,isw)-r0)
        if(zth2.lt.zth2p-pi) zth2=zth2+twopi
        diffmax=max(diffmax,abs(zth2-zth))
        zwk(ii)=zth2
     enddo
  enddo

  deallocate(zwk)
  allocate(psis0(nthad))

  call ezspline_interp(pspl, nthad, radapt(:,isw), zadapt(:,isw), psis0, iok)
  call ezspline_error(iok)

  psibdy0=1.01_r8*minval(psis0)-0.01_r8*maxval(psis0)
               ! this Psi(R,Z) value corresponds safely to a closed surface
               ! within the boundary just found (psis0(:) values are all
               ! very nearly equal).
  deallocate(psis0)

  psi_test = min(psibdy0,psibdy)

  !  OK, eqi_geq_mod now contains contour safely beyond final boundary
  !     "zridderx" searches btw (r0,z0) and this can be safely carried out

  !---------------------
  !  find the boundary to be used...

  if(allocated(rzwk)) deallocate(rzwk)
  if(allocated(curvec)) deallocate(curvec)
  allocate(rzwk(nthad,2),curvec(nthad))

  call eqi_find_curvature(nthad,psi_test,0.8_r8,psep,rzwk,curvec,cbdy_got)

  ctol = 1.0e-12_r8
  ztol = ctol*cbdy_use

  if((psi_test.eq.psibdy).and.(cbdy_got.ge.cbdy_use)) then
     ! OK the EFIT bdy (adjusted by fbdy_use) curvature is OK -- use it

     psibdy_use = psi_test

  else if(abs(cbdy_got-cbdy_use).lt.ztol) then
     ! curvature is close enough

     psibdy_use = psi_test

  else if(cbdy_got.gt.cbdy_use) then

     call eqi_mds_fromg_err( &
          ' ?eqi_mds_fromgeqdsk: curvature-match boundary search algorithm failure!')
     ier = 120
     go to 1000

  else
     ! curvature is too sharp at psi=psi_test; find a psi value further
     ! in that gets the desired curvature

     lmask(1)=.FALSE.
     tol=ctol*psi_test

     call zriddery(1, lmask(1:1), psi_ok, psi_test, tol, ztol, &
          eqi_find_curv, psibdy_use, ifail, &
          1, cbdy_use, 1, zerr, 1)

     if((ifail.ne.0).or.(zerr.ne.0.0_r8)) then
        call eqi_mds_fromg_err( &
             ' ?eqi_mds_fromgeqdsk: boundary-curvature-match root finder failure!')
        ier = 120
        go to 1000
     endif

  endif

  !  pick off subset of points that are alligned with the the(1:nt1) grid
  deallocate(rseek,zseek)
  allocate(rseek(nt1),zseek(nt1))

  ii=1
  if(i2pi.eq.1) then
     ! contour covers [0:2pi]; the(1:nt1) convers [-pi:pi]
     jj=(nt1/2) + 1
  else
     ! both contour & the(1:nt1) cover [0:2pi]
     jj=1
  endif

  rseek(jj)=radapt(ii,isw)  ! safe surface beyond bdy
  zseek(jj)=zadapt(ii,isw)

  r(jj,ns)=rzwk(ii,1)       ! pt from psibdy_use bdy contour just found
  z(jj,ns)=rzwk(ii,2)
  jj=jj+1
  ifac=0

  do ii=2,nthad
     if(abs(the(jj)+ifac*twopi-thadapt(ii,isw)).lt.1.0e-14*twopi) then
        rseek(jj)=radapt(ii,isw)
        zseek(jj)=zadapt(ii,isw)
        r(jj,ns)=rzwk(ii,1)       ! pt from psibdy_use bdy contour just found
        z(jj,ns)=rzwk(ii,2)
        jj=jj+1
        if(jj.gt.nt1) then
           rseek(1)=rseek(nt1)
           zseek(1)=zseek(nt1)
           r(1,ns)=r(nt1,ns)
           z(1,ns)=z(nt1,ns)
           jj=2
           ifac=1
        endif
     endif
  enddo

  nthad = nt1
  isw = 1
  thadapt(1:nt1,isw) = the
  radapt(1:nt1,isw) = rseek
  zadapt(1:nt1,isw) = zseek

  deallocate(rseek,zseek)

  ! OK now ready to find rest of surfaces

  ! mag axis:
  r(1:nt1,1) = r0
  z(1:nt1,1) = z0

  if(allocated(rzwk)) deallocate(rzwk)
  if(allocated(curvec)) deallocate(curvec)
  allocate(rzwk(nthad,2))

  allocate(lsurf(ns)); lsurf=.FALSE.
  lsurf(1)=.TRUE.
  lsurf(ns)=.TRUE.

  allocate(x2d(nt1,ns),psivec(nt1))

  x2d(:,1)=0.0_R8
  x2d(:,ns)=1.0_R8

  !----------------------------------
  ! (equispaced) G-eqdsk Psi grid for q,P,g...

  psi_geq = psimin + (psimax-psimin)* &
       & (/ (real(i-1, r8)/real(inw-1,r8), i=1, inw) /)
  
  !----------------------------------
  ! reproduce q(psi) profile, by finding level contours on the equispaced
  ! Psi grid and performing the necessary integration

  if(icur_psi.eq.0) then
     ! use QPSI data from EFIT

     allocate(qpsia(inw))
     qpsia(1:inw) = geq%QPSI(1:inw)

  else
     ! reconstruct q profile from Psi(R,Z) contours

     allocate(qpsia(inw),lqpsi(inw),x2dq(nt1,inw),xtmp(nt1))

     lqpsi = .FALSE.
     x2dq(:,1) = 0.0_R8; lqpsi(1)=.TRUE.
     x2dq(:,inw) = 1.0_R8; lqpsi(inw)=.TRUE.

     ! bdy Qpsi recomputed here:
     call eqi_qpsi_regen(geq%FPOL_TM(inw), nt1, &
          r(1:nt1,ns), z(1:nt1,ns), zqgen)
     qpsia(inw) = zqgen

     ! axial q will be filled in later by an extrapolation

     inz=inw-1
     instep=inz
     do
        instep=instep/2
        if(instep.eq.0) exit

        do ii=1,inw,instep
           if(lqpsi(ii)) cycle

           ! find nearest known surfaces
        
           do jj=ii-1,1,-1
              if(lqpsi(jj)) then
                 jj1=jj
                 exit
              endif
           enddo

           do jj=ii+1,inw,1
              if(lqpsi(jj)) then
                 jj2=jj
                 exit
              endif
           enddo

           lmask(1:nt1-1)=.FALSE.
           lmask(nt1)=.TRUE.

           psivec = psi_geq(ii)

           tol = 1.0e-12_r8
           call zridderx(nt1,lmask, x2dq(:,jj1), x2dq(:,jj2), tol, tol*psep, &
                eqi_geq_findrzs, x2dq(:,ii), ifail, nt1, psivec, 1, rzwk, 2)

           if(ifail.ne.0) then
              call eqi_mds_fromg_err(' %eqi_mds_fromgeqdsk:  Psi root finder (zridderx) error.')
              msgbuf=' '
              write(msgbuf,*) ' ...ifail=',ifail,' (R,Z) pts not found.'
              call eqi_mds_fromg_err(msgbuf)
              ier=120
              go to 1000

           else
              lqpsi(ii)=.TRUE.  ! succeeded with this surface
           endif

           rzwk(nt1,1)=rzwk(1,1)
           rzwk(nt1,2)=rzwk(1,2)

           call eqi_qpsi_regen(geq%FPOL_TM(ii), nt1, &
                rzwk(1:nt1,1), rzwk(1:nt1,2), zqgen)
           qpsia(ii) = zqgen
        enddo
     enddo

     ! axial extrapolation

     lmask(1:nt1-1)=.FALSE.
     lmask(nt1)=.TRUE.

     psivec = psi_geq(1) + 0.2_R8*(psi_geq(2)-psi_geq(1))

     tol = 1.0e-12_r8
     call zridderx(nt1,lmask, x2dq(:,1), x2dq(:,2), tol, tol*psep, &
          eqi_geq_findrzs, xtmp, ifail, nt1, psivec, 1, rzwk, 2)

     if(ifail.ne.0) then
        write(msgbuf,*) ' %zridderx psi contour error near axis; simplified q extrapolation there.'
        qpsia(1) = 2.0_R8*qpsia(2)-qpsia(3)
     else

        rzwk(nt1,1)=rzwk(1,1)
        rzwk(nt1,2)=rzwk(1,2)

        zgtmp = geq%FPOL_TM(1) + 0.2_R8*(geq%FPOL_TM(2)-geq%FPOL_TM(1))
        call eqi_qpsi_regen(zgtmp, nt1, rzwk(1:nt1,1), rzwk(1:nt1,2), zqgen)

        qpsia(1) = (5.0_R8*zqgen - qpsia(2))/4.0_R8
     endif
  endif

  !----------------------------------
  ! using the recomputed q(Psi),
  ! select the psi-surfaces to use
 
  call eqi_geq_psfind(psi_geq, qpsia, inw, xi, ns, psibdy_use/psimax, &
       psi, phi, q, ier)

  deallocate(qpsia)
  if(allocated(lqpsi)) deallocate(lqpsi,x2dq,xtmp)

  if(ier.ne.0) go to 1000
 
  ! get the 1d profiles interpolated to the selected surfaces
 
  call eqi_geq_intrp(psi_geq, geq%FPOL_TM, inw, psi, ns, g, ier)
  g=abs(g)         ! sign is saved in isnccwb
 
  call eqi_geq_intrp(psi_geq, geq%PRES_Nt__M2, inw, psi, ns, p, ier)
  if(ier.ne.0) go to 1000
 
  call eqi_geq_intrp(psi_geq, geq%PPRIME_NtRad__M2Wb, inw, psi, ns, pprime, &
       ier)
  if(ier.ne.0) go to 1000

  !----------------------------------
  ! axis and boundary surface are known; fill in interior surfaces

  inz=ns-1
  instep=inz
  do
     instep=instep/2
     if(instep.eq.0) exit

     do ii=1,ns,instep
        if(lsurf(ii)) cycle

        ! find nearest known surfaces
        
        do jj=ii-1,1,-1
           if(lsurf(jj)) then
              jj1=jj
              exit
           endif
        enddo

        do jj=ii+1,ns,1
           if(lsurf(jj)) then
              jj2=jj
              exit
           endif
        enddo

        lmask(1:nt1-1)=.FALSE.
        lmask(nt1)=.TRUE.

        psivec = psi(ii)

        tol = 1.0e-12_r8
        call zridderx(nt1,lmask, x2d(:,jj1), x2d(:,jj2), tol, tol*psep, &
             eqi_geq_findrzs, x2d(:,ii), ifail, nt1, psivec, 1, rzwk, 2)

        if(ifail.ne.0) then
           call eqi_mds_fromg_err(' %eqi_mds_fromgeqdsk:  root finder (zridderx) error.')
           msgbuf=' '
           write(msgbuf,*) ' ...ifail=',ifail,' (R,Z) pts not found.'
           call eqi_mds_fromg_err(msgbuf)
           ier=120
           go to 1000

        else
           lsurf(ii)=.TRUE.  ! succeeded with this surface
        endif

        rzwk(nt1,1)=rzwk(1,1)
        rzwk(nt1,2)=rzwk(1,2)

        do jj=1,nt1
           r(jj,ii)=rzwk(jj,1)
           z(jj,ii)=rzwk(jj,2)
        enddo
  
     enddo
  enddo
 
  ! define rho grid for xplasma now...
 
  call ckgrid(xi,'__RHO',id_rho)
  if(id_rho.eq.0) then
     if(.not.inew_device) then
        ier=9999
        call xplasma_errmsg_append(sp, &
             ' ?eqi_mds_fromgeqdsk: inew_device=.FALSE. __RHO mismatch.')
     else
        call xplasma_create_grid(sp,'__RHO',xplasma_rho_coord,xi,id_rho,ier)
     endif
     if(ier.ne.0) go to 1000
  endif

  ! *** nscrunch *** the theta parametrization to allow stable
  !  extrapolation beyond the boundary

  if(jopt.gt.-1) then

     call xplasma_global_info(sp,ier,kmom=imom)
     if(ier.ne.0) go to 1000

     if(jopt.eq.1) then
        if(imom.lt.16) then
           imom=16  ! for equal arc require this number of moments at minimum
           call xplasma_kmom_set(sp,imom,ier)
        endif
        ikmax=1
     else
        if(imom.gt.16) then
           imom=16  ! for scrunched moments, imom > 16 seems harmful...
           call xplasma_kmom_set(sp,imom,ier)
        endif
        ikmax=2
     endif

     allocate(rmmc(0:imom,ns),rmms(0:imom,ns),zmmc(0:imom,ns),zmms(0:imom,ns))

     ismoo = 0
     if(jopt.eq.0) then
        if(i2pi.eq.1) then
           iiopt=2
        else
           iiopt=0
        endif
        call scrunch_rzmom(r,z,nt1,xi,ns, rmmc,rmms,zmmc,zmms, imom,iiopt, ier)

        if(ier.ne.0) then
           msgbuf=' '
           write(msgbuf,*) ' ?eqi_mds_fromgeqdsk:  scrunch_rz error, ier=',ier
           call eqi_mds_fromg_err(msgbuf)
           go to 1000
        endif

        !  axial moments regularization; full or partial 
        !  regeneration of {R,Z} from moments.
        zxbrk_mom = xbrk_mom
        if(jopt.eq.1) then
           if(zxbrk_mom.lt.0.1d0) zxbrk_mom=0.1d0
        endif

        if(zxbrk_mom.gt.0.05d0) then
           !  axial moments regularization; regeneration of {R,Z} from moments.
           ismoo=2
        else
           !  moments trimming only; {R,Z} not modified.
           ismoo=1
        endif

        if(rtol_mom.lt.2.0e-6_R8) then
           zrtol=0.0_R8  ! some trimming done by scrunch_rzmom already...
        else
           zrtol=rtol_mom
        endif

        if(ismoo.ge.2) then

           call scrunch_cleanup(xi,ns, rmmc,rmms,zmmc,zmms, imom, &
                (ismoo.ge.2), zxbrk_mom, zrtol, ier)
           if(ier.ne.0) then
              call xplasma_errmsg_append(sp, &
                   ' ?eqi_mds_fromgeqdsk: scrunch_cleanup error.')
              ier=9999
              go to 1000
           endif

           call xpmom_init(sp,ier, rhoi=xi(1:ns), ikmaxe=ikmax)
           call xpmom_setup(sp,rmmc,rmms,zmmc,zmms,ier)  ! save in xplasma
           if(ier.ne.0) then
              call xplasma_errmsg_append(sp, &
                   ' ?eqi_mds_fromgeqdsk: scrunch_cleanup error.')
              ier=9999
              go to 1000
           endif
        endif

        if(ier.ne.0) go to 1000

        if(ismoo.ge.2) then
           !  reset surfaces (axis was moved slightly)
           r(1:nt1,1)=rmmc(0,1)
           z(1:nt1,1)=zmmc(0,1)
           allocate(csthtk(imom),snthtk(imom))
           do j=2,ns
              do ith=1,nt1
                 if(ith.lt.nt1) then
                    zrnew=rmmc(0,j)
                    zznew=zmmc(0,j)
                    call scrSinCos(the(ith),imom,snthtk,csthtk)
                    do im=1,imom
                       zrnew=zrnew+rmmc(im,j)*csthtk(im)+rmms(im,j)*snthtk(im)
                       zznew=zznew+zmmc(im,j)*csthtk(im)+zmms(im,j)*snthtk(im)
                    enddo

                    r(ith,j) = zrnew
                    z(ith,j) = zznew
                 else
                    r(nt1,j)=r(1,j)
                    z(nt1,j)=z(1,j)
                 endif
              enddo
           enddo
           deallocate(csthtk,snthtk)
        endif

     else if(jopt.eq.1) then

        ! rescrunch using equal arc length
        if(i2pi.eq.1) then
           iiopt=3
        else
           iiopt=1
        endif
        call scrunch_rzmom(r,z,nt1,xi,ns, rmmc,rmms,zmmc,zmms, imom,iiopt, ier)
        if(ier.ne.0) go to 1000

     endif
  endif
 
  ! ----------------------------------------------------------
  ! Ok, the inversion of the psi(R,Z) profile is complete; all
  ! G-EQDSK info can now be fed to XPLASMA
 
  call ckgrid(the,'__CHI',id_chi)
  if(id_chi.eq.0) then
     if(.not.inew_device) then
        ier=9999
        call xplasma_errmsg_append(sp, &
             ' ?eqi_mds_fromgeqdsk: inew_device=.FALSE. __CHI mismatch.')
     else
        call xplasma_create_grid(sp,'__CHI',xplasma_theta_coord,the,id_chi,ier)
     endif
     if(ier.ne.0) go to 1000
  endif

  if(jopt.eq.0) then
     ! default BC (not a knot)
     ibc1=0
     bcr=0
     bcz=0
     ! bdy conditions in rho direction: not a knot on axis, 1st div. diff @edge
     ! ibc1=1
     ! bcr=(r(1:nt1,ns)-r(1:nt1,ns-1))/(xi(ns)-xi(ns-1))
     ! bcz=(z(1:nt1,ns)-z(1:nt1,ns-1))/(xi(ns)-xi(ns-1))
  else
     ! for equal arc: use default BC
     ibc1=0
     bcr=0
     bcz=0
  endif

  ! preserve moments representation during eq rebuild
  if(ismoo.ge.2) call xpmom_protect(sp,iertmp)

  call xplasma_rzmag(sp,id_chi,id_rho, &
       r,z,id_R,id_Z,ier, ibc0=0,ibc1=ibc1,Rbc1=bcr,Zbc1=bcz, &
       lhermite=ihermite)
  if(ier.ne.0) go to 1000
 
  if(ismoo.ge.2) call xpmom_unprotect(sp,iertmp)

  ! compute grad(psi) vs. (theta,rho)

  gpsi_geq(:,1) = ZERO
  ii = nt1-1
  allocate(gpsi_wk(ii,2))
  do i=2,ns
     call ezspline_gradient(pspl,ii,r(1:ii,i),z(1:ii,i),gpsi_wk,ier)
     if(ier.ne.0) go to 1000
     do j=1,ii
        gpsi_geq(j,i)=sqrt(gpsi_wk(j,1)**2+gpsi_wk(j,2)**2)
     enddo
     gpsi_geq(nt1,i)=gpsi_geq(1,i)
  enddo

  call xplasma_create_2dprof(sp,'gpsi_geq',id_chi,id_rho,gpsi_geq,id_gpsi,ier,&
       ispline=2,label='grad(Psi) from EFIT Psi(R,Z)',units='Wb/rad/m')
  deallocate(gpsi_wk)
  if(ier.ne.0) go to 1000

  ! Integration weights

  allocate(xint(10*ii),thint(10*ii),wint(10*ii),wkint(10*ii,4))

  call integ_wts(xwts,wts)
  do i=1,ii
     do j=1,10
        thint((i-1)*10 + j) = the(i) + xwts(j)*(the(i+1)-the(i))
        wint((i-1)*10 + j) = wts(j)*(the(i+1)-the(i))
     enddo
  enddo

  id4(1)=id_R;    ideriv4(1)=0
  id4(2)=id_gpsi; ideriv4(2)=0
  id4(3)=id_R;    ideriv4(3)=1
  id4(4)=id_Z;    ideriv4(4)=1

  allocate(icurt(ns))
  icurt(1)=0.0_R8
  if(icur_psi.eq.1) then
     !  q(psi) & total current from Psi(R,Z)
     call surfint(xi(ns))
     icurt(ns) = gpsi2r2i*dvdpsi/(twopi*mu0)
  else
     !  q(psi) & total current from EFIT file data
     icurt(ns)=abs(geq%current_a)
  endif

  ins_test = 1.0_R8/xbrkii + 0.5_R8

  if(ns.gt.ins_test) then
     nsbrk = ns - 2
     xibrk = xi(nsbrk)
  else
     nsbrk = ns - 1
  endif

  do j=2,nsbrk
     call surfint(xi(j))
     icurt(j)=gpsi2r2i*dvdpsi/(twopi*mu0)
     if(ns.gt.ins_test) then
        if(xi(j).ge.xbrkii) then
           xibrk=xi(j)
           nsbrk=j
           exit
        endif
     endif
  enddo

  if(ns.gt.ins_test) then
     ! parabolic piece fit to reach known total toroidal current
     x1=xibrk-xi(nsbrk-1)
     x2=xibrk-xi(nsbrk-2)
     ! parabolic fit to get slope d(icurt)/dx at xibrk:
     bicur = (x2*x2*(icurt(nsbrk-1)-icurt(nsbrk)) - &
          x1*x1*(icurt(nsbrk-2)-icurt(nsbrk))) / (x1*x2*(x1-x2))
     ! parabolic fit to match point and slope at xibrk and reach the
     ! boundary value icurt(ns):
     x3=xi(ns)-xibrk
     aicur = (icurt(ns)-icurt(nsbrk)-bicur*x3)/(x3*x3)
     do j=nsbrk+1,ns-1
        xxx = xi(j)-xibrk
        icurt(j)=icurt(nsbrk) + xxx*(bicur + xxx*aicur)
     enddo
  endif

  ! Boundary Conditions for f(xi) splines
 
  zero=0.0_R8
  iknot=0             ! not-a-knot BC
  idrv1=1             ! fix df/dxi BC, following arg gives value of derivative
 
  ! Splines...

  call xplasma_create_1dprof(sp,'ICURT',id_rho,icurt,id_curt,ier, &
       ispline=2,ibca=idrv1,zbca=ZERO,ibcb=iknot, &
       label='Enclosed toroidal current', units='A')
  if(ier.ne.0) go to 1000                   ! I_phi, dI/dxi = 0 on axis

  call xplasma_create_1dprof(sp,'PSI',id_rho,psi,id_psi,ier, &
       ispline=2,ibca=idrv1,zbca=ZERO,ibcb=iknot, &
       label='Poloidal Flux',units='Wb/rad')
  if(ier.ne.0) go to 1000                   ! psi, dpsi/dxi = 0 on axis
 
  call xplasma_create_1dprof(sp,'PHITOR',id_rho,phi,id_phi,ier, &
       ispline=2,ibca=idrv1,zbca=ZERO,ibcb=iknot, &
       label='Toroidal Flux',units='Wb')
  if(ier.ne.0) go to 1000                   ! phi, dphi/dxi = 0 on axis
 
  call xplasma_create_1dprof(sp,'G',id_rho,g,id_g,ier, &
       ispline=2,ibca=idrv1,zbca=ZERO,ibcb=iknot, &
       label='R*B_phi (toroidal field function)',units='T*m')
  if(ier.ne.0) go to 1000                   ! g, dg/dxi = 0 on axis, @edge
 
  call xplasma_create_1dprof(sp,'Q',id_rho,q,id_q,ier, &
       ispline=2,ibca=iknot,ibcb=iknot, &
       label='q profile',units=' ')
  if(ier.ne.0) go to 1000                   ! q, not-a-knot BCs
 
  ! Hermite pressure profile

  call xplasma_create_1dprof(sp,'P',id_rho,p,id_p,ier, &
       ispline=1,ibca=idrv1,zbca=ZERO,ibcb=iknot, &
       label='MHD equilibrium pressure',units='Pa')
  if(ier.ne.0) go to 1000                   ! pressure, dP/dxi=0 on axis

  call xplasma_set_pressure_id(sp,id_p,ier)
  if(ier.ne.0) go to 1000

  ! Linear dP/dpsi ... might be used to reconstruct pressure

  call xplasma_create_1dprof(sp,'dPdPsi',id_rho,pprime,id_pp,ier, &
       ispline=0,label='d[MHD eq pressure]/dPsi',units='Pa/(Wb/rad)')
 
  !  set the field and current orientations

  call xplasma_field_ccw_set(sp,ier,bphi_ccw=isnccwb,jphi_ccw=isnccwi)
  if(ier.ne.0) go to 1000
 
  ! ...OK, geom. and psi and g are set, compute B,BR,BZ vs. (xi,the)
  ! the field and current orientations are specified.
 
  call xplasma_eqcheck(sp,.FALSE.,icount,ier)
  if(ier.ne.0) go to 1000

  ! now the limiters and the R,Z grids (if required)
 
  if(irz.eq.1) then
 
     call cklim
     if(id_lim.eq.0) then
        isize_lim=geq%Limitr
        call xplasma_mklim_contour(sp, &
             geq%Rlim_m(1:isize_lim),geq%Zlim_m(1:isize_lim),iwarn,ier)

        if(ier.ne.0) go to 1000
     endif
 
     call ckgrid(Rgrid,'__RGRID',id_Rgrid)
     call ckgrid(Zgrid,'__ZGRID',id_Zgrid)
     if((id_Rgrid.eq.0).or.(id_Zgrid.eq.0)) then
        if(.not.inew_device) then
           ier=9999
           call xplasma_errmsg_append(sp, &
                ' ?eqi_mds_fromgeqdsk: inew_device=.FALSE. __RGRID and/or __ZGRID  mismatch.')
        else
           call xplasma_create_RZgrid(sp,Rgrid,Zgrid,id_Rgrid,id_Zgrid,ier)
        endif
        if(ier.ne.0) go to 1000
     endif
 
     ! now:  psi(R,Z) with positive sign except psi(axis)=0.0
 
     idprev=id_psi
     call xplasma_create_2dprof(sp,'PSI_RZ', &
          id_Rgrid,id_Zgrid,psirz_sm,id_psi,ier, &
          ispline=1,assoc_id=idprev, &
          label='Poloidal Flux',units='Wb/rad')
     if(ier.ne.0) go to 1000
 
  ! and GS error
 
     call xplasma_create_2dprof(sp,'GS_ERROR', &
          id_Rgrid,id_Zgrid,gserr_geq,id_gserr,ier, &
          ispline=1, label='GS error estimate',units=' ')
     if(ier.ne.0) go to 1000
 
  ! converting psi(R,Z) -> BR,BZ takes into account isnccwi
  ! get B(R,Z) components
 
     call xplasma_brz(sp,eqm_bpsi,ier)
     if(ier.ne.0) go to 1000
 
     call eqm_geq_mds_curtime(ztime1)
     call xplasma_time_set(sp,ztime1,ier)
     if(ier.ne.0) go to 1000

  endif

  if(ipsi0) then
     call xplasma_save_Psi0(sp,Psi0,ier)
     if(ier.ne.0) go to 1000
  endif

  ! ----------------------------------------------------------
 
1000 continue
 
  if(allocated(rgrid)) deallocate(rgrid)
  if(allocated(zgrid)) deallocate(zgrid)
  if(allocated(psi)) deallocate(psi, &
       psi_geq, psirz_sm, gserr_geq, p, g, q, the)
  if(allocated(pprime)) deallocate(pprime)
  if(allocated(phi)) deallocate(phi, xi)
  if(allocated(r)) deallocate(r, z, gpsi_geq)
  if(allocated(psis)) deallocate(psis)
  if(allocated(rmmc)) deallocate(rmmc,rmms,zmmc,zmms)
  if(allocated(x2d)) deallocate(x2d)
  if(allocated(lsurf)) deallocate(lsurf)
  if(allocated(wint)) deallocate(wint,thint)
  if(allocated(icurt)) deallocate(icurt)

  if(iez.eq.1) call ezspline_free(pspl, iok)

  if(zauthor.eq.xplasma_root) then
     call xplasma_author_clear(sp,'eqi_mds_fromgeqdsk',iertmp)
  endif
  
  return
 
  contains

    subroutine load_seek

      ! extend contour indexing to ease handling of BCs

      rseek(1:nthad)=radapt(1:nthad,isw)
      zseek(1:nthad)=zadapt(1:nthad,isw)
      rseek(-1:0)=rseek(nthad-2:nthad-1)
      zseek(-1:0)=zseek(nthad-2:nthad-1)
      zwk(-1:0)=zwk(nthad-2:nthad-1)-twopi
      rseek(nthad+1:nthad+2)=rseek(2:3)
      zseek(nthad+1:nthad+2)=zseek(2:3)
      zwk(nthad+1:nthad+2)=zwk(2:3)+twopi

    end subroutine load_seek

    subroutine ckgrid(zdata,zname,id)

      real*8, dimension(:), intent(in) :: zdata
      character*(*), intent(in) :: zname
      integer, intent(out) :: id

      !-----------
      !  check if grid is already defined & identical to new grid

      integer :: i,isizo
      real*8 :: zgrido(size(zdata)),ztol

      real*8, parameter :: loctol = 1.0d-10
      !-----------

      call xplasma_find_item(sp,zname,id,iertmp,nf_noerr=.TRUE.)
      if(id.eq.0) return

      call xplasma_grid_size(sp,id,isizo,iertmp)
      if(iertmp.ne.0) then
         id=0
         return
      endif

      call xplasma_grid(sp,id,zgrido,iertmp)
      if(iertmp.ne.0) then
         id=0
         return
      endif

      ztol=loctol*max(abs(zgrido(1)),abs(zgrido(isizo)))

      do i=1,isizo
         if(abs(zgrido(i)-zdata(i)).gt.ztol) then
            id=0  ! value changed...
            exit
         endif
      enddo

    end subroutine ckgrid

    subroutine cklim

      !-------------
      !  check if limiter has changed...

      integer :: itype,isizo,i,iflag
      real*8, dimension(:), allocatable :: rlimo,zlimo
      !-------------

      iflag = 0

      call xplasma_find_item(sp,'__LIMITER',id_lim,iertmp,nf_noerr=.TRUE.)
      if(id_lim.eq.0) return

      call xplasma_lim_info(sp,iertmp,  &
           itype=itype)
      if(itype.ne.100) then
         id_lim=0
         return
      endif

      ! there is a contour limiter

      call xplasma_lim_info(sp,iertmp, npts=isizo)
      if(isizo.ne.geq%Limitr) then
         iflag = 1   ! size mismatch
      endif

      if(iflag.eq.0) then
         allocate(rlimo(isizo),zlimo(isizo))
         call xplasma_lim_info(sp,iertmp, rpts=rlimo, zpts=zlimo)

         do i=1,isizo
            if((rlimo(i).ne.geq%Rlim_m(i)).or.(zlimo(i).ne.geq%Zlim_m(i))) then
               iflag = 1   ! value mismatch
               exit
            endif
         enddo

         deallocate(rlimo,zlimo)
      endif

      if(iflag.eq.1) then
         msgbuf=' %eqi_mds_fromgeqdsk: limiter contour appears to change; old limiter retained.'
         call eqi_mds_fromg_err(msgbuf)
      endif

    end subroutine cklim
      
    subroutine fnxz(indx,zval)
      ! increment index in direction (idir); find next distinct
      ! boundary Z value; wrap index if reach either end of boundary array

      integer, intent(inout) :: indx
      real*8, intent(inout) :: zval

      indx = indx + idir
      if(indx.lt.1) indx=inumx
      if(indx.gt.inumx) indx=1

      zval = rzwk(indx,2)

    end subroutine fnxz

    REAL*8 function quadintrp(x,xx,ff)
      real*8, intent(in) :: x
      real*8, intent(in) :: xx(3),ff(3)

      ! form quadratic from 3 distinct pts 
      !   {(xx(1),ff(1)),(xx(2),ff(2)),(xx(3),ff(3))}
      ! evaluate at x and return result as function value

      real*8 :: xm,xp,fm,fp,aa,bb,denom,answer,xuse

      !--------------

      xuse=x-xx(2)

      xm = xx(1)-xx(2); xp = xx(3)-xx(2)
      fm = ff(1)-ff(2); fp = ff(3)-ff(2)

      denom=xp*xm*(xp-xm)
      aa=(fp*xm-fm*xp)/denom
      bb=(fm*xp*xp-fp*xm*xm)/denom

      answer = xuse*(aa*xuse + bb)

      quadintrp = answer + ff(2)

    end function quadintrp

    subroutine surfint(x)
      real*8, intent(in) :: x

      ! compute numerical integrations for: 
      !     dV/dpsi, <|grad(psi)|**2/R**2>, <1/R**2>

      !-------------------------
      integer :: ith
      real*8 :: dl,Rval,gpsival
      !-------------------------
      xint=x

      call xplasma_eval_prof(sp,id4,id_chi,thint,id_rho,xint,wkint,ier, &
           ideriv1s=ideriv4)

      dvdpsi=ZERO
      gpsi2r2i=ZERO

      do ith=1,size(thint)
         dl=sqrt(wkint(ith,3)**2+wkint(ith,4)**2)
         Rval=wkint(ith,1)
         gpsival=wkint(ith,2)

         dvdpsi = dvdpsi + dl*twopi*Rval*wint(ith)/gpsival
         gpsi2r2i = gpsi2r2i + dl*twopi*gpsival*wint(ith)/Rval
      enddo

      gpsi2r2i = gpsi2r2i/dvdpsi

    end subroutine surfint

  end subroutine eqi_mds_fromGeqdsk
subroutine psirz_mds_smooth(nR,nZ,R,Z,psi,psism,nbdy,rbdy,zbdy)

  !  smooth Psi(R,Z) but only in the region beyond the plasma boundary
  !  idea is to reduce spline interpolation effects near the boundary
  !  for contouring...

  implicit NONE

  integer, intent(in) :: nR,nZ         ! array dimensions
  real*8, intent(in) :: R(nR),Z(nZ)    ! base grids

  real*8, intent(in) :: psi(nR,nZ)     ! original Psi
  real*8, intent(out) :: psism(nR,nZ)  ! smoothed Psi

  integer, intent(in) :: nbdy          ! #pts in boundary contour
  real*8, intent(in) :: rbdy(nbdy),zbdy(nbdy) ! bdy contour itself

  !--------------------
  !  local

  integer :: ibdy,i,j,inum
  real*8, dimension(:), allocatable :: rb,zb  ! bdy, cleaned up...

  real*8 :: rmin,rmax,zmin,zmax,wkmin,wkmax,rx,zx
  real*8 :: delr,delz,d

  integer :: iz1,iz2,ir1,ir2  ! index ranges which hit boundary
  integer :: im,ip,jm,jp

  !  index info for each bdy segment
  integer, dimension(:,:), allocatable :: ircr,izcr

  real*8, dimension(:,:), allocatable :: dsmoo
  real*8, dimension(:), allocatable :: zwk

  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: ONE  = 1.0d0
  real*8, parameter :: THREE= 3.0d0
  real*8, parameter :: SIX  = 6.0d0

  !------------------------------------------------------------------------
  !  0. assume evenly spaced grid

  delr=R(2)-R(1)
  delz=Z(2)-Z(1)

  !--------------------
  !  1. clean up the boundary: remove duplicate points; make sure it closes
  !     at end.  Find global min & max of bdy

  ibdy = nbdy+1
  allocate(rb(ibdy),zb(ibdy))

  ibdy=1
  rb(1)=rbdy(1)
  zb(1)=zbdy(1)
  rmin=rb(1)
  rmax=rmin
  zmin=zb(1)
  zmax=zb(1)

  do i=2,nbdy
     rmin=min(rmin,rbdy(i))
     rmax=max(rmax,rbdy(i))
     zmin=min(zmin,zbdy(i))
     zmax=max(zmax,zbdy(i))
     if(max(abs(rbdy(i)-rbdy(i-1)),abs(zbdy(i)-zbdy(i-1))).gt.ZERO) then
        ibdy=ibdy+1
        rb(ibdy)=rbdy(i)
        zb(ibdy)=zbdy(i)
     endif
  enddo

  if((rb(ibdy).ne.rb(1)).or.(zb(ibdy).ne.zb(1))) then
     ibdy=ibdy+1
     rb(ibdy)=rb(1)
     zb(ibdy)=zb(1)
  endif

  !--------------------
  !  2. find global index range

  ir1=0
  do i=1,nR
     if(ir1.eq.0) then
        if(R(i).gt.rmin) ir1=i
     endif
     if(R(i).ge.rmax) then
        ir2=i-1
        exit
     endif
  enddo

  iz1=0
  do i=1,nZ
     if(iz1.eq.0) then
        if(Z(i).gt.zmin) iz1=i
     endif
     if(Z(i).ge.zmax) then
        iz2=i-1
        exit
     endif
  enddo

  !--------------------
  !  3. find intersecting segments for each horizontal and vertical line
     
  allocate(ircr(ibdy,nR),izcr(ibdy,nZ))

  ircr(1,:)=0
  izcr(1,:)=0

  do i=ir1,ir2
     do j=1,ibdy-1
        if((R(i)-rb(j))*(R(i)-rb(j+1)).le.ZERO) then
           if(rb(j).ne.rb(j+1)) then
              inum=ircr(1,i)
              inum=inum+1
              ircr(1,i)=inum
              ircr(inum+1,i)=j
           endif
        endif
     enddo
  enddo

  do i=iz1,iz2
     do j=1,ibdy-1
        if((Z(i)-zb(j))*(Z(i)-zb(j+1)).le.ZERO) then
           if(zb(j).ne.zb(j+1)) then
              inum=izcr(1,i)
              inum=inum+1
              izcr(1,i)=inum
              izcr(inum+1,i)=j
           endif
        endif
     enddo
  enddo

  !--------------------
  !  4. set up smoothing control based on distance to bdy

  allocate(dsmoo(nR,nZ)); dsmoo=ONE

  do i=ir1,ir2
     wkmin=Z(nZ)
     wkmax=Z(1)
     do j=1,ircr(1,i)
        inum=ircr(j+1,i)  ! bdy segment #
        zx = zb(inum) + &
             (R(i)-rb(inum))*(zb(inum+1)-zb(inum))/(rb(inum+1)-rb(inum))
        wkmin=min(wkmin,zx)
        wkmax=max(wkmax,zx)
     enddo
     do j=1,nZ
        if(z(j).lt.wkmin) then
           dsmoo(i,j)=min(dsmoo(i,j),(wkmin-z(j))/delz)
        else if(z(j).gt.wkmax) then
           dsmoo(i,j)=min(dsmoo(i,j),(z(j)-wkmax)/delz)
        else
           dsmoo(i,j)=ZERO
        endif
     enddo
  enddo

  do i=iz1,iz2
     wkmin=R(nR)
     wkmax=R(1)
     do j=1,izcr(1,i)
        inum=izcr(j+1,i)  ! bdy segment #
        rx = rb(inum) + &
             (Z(i)-zb(inum))*(rb(inum+1)-rb(inum))/(zb(inum+1)-zb(inum))
        wkmin=min(wkmin,rx)
        wkmax=max(wkmax,rx)
     enddo
     do j=1,nR
        if(r(j).lt.wkmin) then
           dsmoo(j,i)=min(dsmoo(j,i),(wkmin-r(j))/delr)
        else if(r(j).gt.wkmax) then
           dsmoo(j,i)=min(dsmoo(j,i),(r(j)-wkmax)/delr)
        else
           dsmoo(j,i)=ZERO
        endif
     enddo
  enddo

  !--------------------
  !  5.  apply smoothing -- hat function convolution
  !        d=dsmoo(i,j); 0 <= d <= 1
  !      f(i,j) -> (d/6)*f(i-1,j) + ((2+d)/3)*f(i,j) + (d/6)*f(i+1,j)
  !        and repeat in j dimension

  do j=1,nZ
     do i=1,nR
        im=max(1,i-1)
        ip=min(nR,i+1)
        d=dsmoo(i,j)
        if(d.gt.ZERO) then
           psism(i,j)=(d/SIX)*(psi(im,j)+psi(ip,j))+((THREE-d)/THREE)*psi(i,j)
        else
           psism(i,j)=psi(i,j)
        endif
     enddo
  enddo
        
  allocate(zwk(nZ))
  do i=1,nR
     do j=1,nZ
        zwk(j)=psism(i,j)
     enddo
     do j=1,nZ
        jm=max(1,j-1)
        jp=min(nZ,j+1)
        d=dsmoo(i,j)
        if(d.gt.ZERO) then
           psism(i,j)=(d/SIX)*(zwk(jm)+zwk(jp))+((THREE-d)/THREE)*zwk(j)
        else
           psism(i,j)=zwk(j)
        endif
     enddo
  enddo

  deallocate(zwk)
  deallocate(rb,zb)
  deallocate(ircr,izcr)
  deallocate(dsmoo)

!dbg  allocate(zwk(2*max(nR,nZ))); zwk=0.0d0

!dbg  call r8_grf3f2(R,psi,psism,Z,zwk,nR,nZ,nR, &
!dbg       'R','Psi','Psi(smoothed)','Z', &
!dbg       'm','Wb/rad','m', &
!dbg       'eqi_mds_fromgeqdsk:psirz_smooth debug plot','xplasma2',0)

!dbg  call r8_grafx1(rbdy,zbdy,nbdy,'m','m','EFIT est. Psi(a) contour', &
!dbg       'eqi_mds_fromgeqdsk:psirz_smooth debug plot','xplasma2')

!dbg  deallocate(zwk)

end subroutine psirz_mds_smooth

subroutine psirz_mds_minmax(nR,nZ,R,Z,psi, &
     nbdy,rbdy,zbdy,psimin,psimax,nsing)

  !  Find min & max Psi(R,Z) inside the passed boundary contour
  !  This uses the same method as psirz_smooth to find what is inside
  !  and what is outside; but instead of smoothing it just computes the
  !  min and max...

  !  also count the number of "singularities" = local maxima or minima
  !  that are fully enclosed w/in the boundary

  implicit NONE

  integer, intent(in) :: nR,nZ         ! array dimensions
  real*8, intent(in) :: R(nR),Z(nZ)    ! base grids

  real*8, intent(in) :: psi(nR,nZ)     ! original Psi

  integer, intent(in) :: nbdy          ! #pts in boundary contour
  real*8, intent(in) :: rbdy(nbdy),zbdy(nbdy) ! bdy contour itself

  real*8, intent(out) :: psimin,psimax   ! results...
  integer, intent(out) :: nsing        ! singularity count

  !--------------------
  !  local

  integer :: ibdy,i,j,inum
  real*8, dimension(:), allocatable :: rb,zb  ! bdy, cleaned up...

  real*8 :: wkmin,wkmax,rx,zx,rmin,rmax,zmin,zmax

  integer :: iz1,iz2,ir1,ir2  ! index ranges which hit boundary
  integer :: im,ip,jm,jp,ict

  !  index info for each bdy segment
  integer, dimension(:,:), allocatable :: ircr,izcr

  real*8, dimension(:,:), allocatable :: dsmoo

  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: ONE  = 1.0d0
  real*8, parameter :: THREE= 3.0d0
  real*8, parameter :: SIX  = 6.0d0

  !------------------------------------------------------------------------
  !  0. set up evenly spaced R and Z grids

  psimin=0.0d0
  psimax=0.0d0
  nsing=0
  
  !--------------------
  !  1. clean up the boundary: remove duplicate points; make sure it closes
  !     at end.  Find global min & max of bdy

  ibdy = nbdy+1
  allocate(rb(ibdy),zb(ibdy))

  ibdy=1
  rb(1)=rbdy(1)
  zb(1)=zbdy(1)
  rmin=rb(1)
  rmax=rmin
  zmin=zb(1)
  zmax=zb(1)

  do i=2,nbdy
     rmin=min(rmin,rbdy(i))
     rmax=max(rmax,rbdy(i))
     zmin=min(zmin,zbdy(i))
     zmax=max(zmax,zbdy(i))
     if(max(abs(rbdy(i)-rbdy(i-1)),abs(zbdy(i)-zbdy(i-1))).gt.ZERO) then
        ibdy=ibdy+1
        rb(ibdy)=rbdy(i)
        zb(ibdy)=zbdy(i)
     endif
  enddo

  if((rb(ibdy).ne.rb(1)).or.(zb(ibdy).ne.zb(1))) then
     ibdy=ibdy+1
     rb(ibdy)=rb(1)
     zb(ibdy)=zb(1)
  endif

  !--------------------
  !  2. find global index range

  ir1=0
  do i=1,nR
     if(ir1.eq.0) then
        if(R(i).gt.rmin) ir1=i
     endif
     if(R(i).ge.rmax) then
        ir2=i-1
        exit
     endif
  enddo

  iz1=0
  do i=1,nZ
     if(iz1.eq.0) then
        if(Z(i).gt.zmin) iz1=i
     endif
     if(Z(i).ge.zmax) then
        iz2=i-1
        exit
     endif
  enddo

  !--------------------
  !  3. find intersecting segments for each horizontal and vertical line
     
  allocate(ircr(ibdy,nR),izcr(ibdy,nZ))

  ircr(1,:)=0
  izcr(1,:)=0

  do i=ir1,ir2
     do j=1,ibdy-1
        if((R(i)-rb(j))*(R(i)-rb(j+1)).le.ZERO) then
           if(rb(j).ne.rb(j+1)) then
              inum=ircr(1,i)
              inum=inum+1
              ircr(1,i)=inum
              ircr(inum+1,i)=j
           endif
        endif
     enddo
  enddo

  do i=iz1,iz2
     do j=1,ibdy-1
        if((Z(i)-zb(j))*(Z(i)-zb(j+1)).le.ZERO) then
           if(zb(j).ne.zb(j+1)) then
              inum=izcr(1,i)
              inum=inum+1
              izcr(1,i)=inum
              izcr(inum+1,i)=j
           endif
        endif
     enddo
  enddo

  !--------------------
  !  4. set up smoothing control based on distance to bdy

  allocate(dsmoo(nR,nZ)); dsmoo=ZERO

  do i=ir1,ir2
     wkmin=Z(nZ)
     wkmax=Z(1)
     do j=1,ircr(1,i)
        inum=ircr(j+1,i)  ! bdy segment #
        zx = zb(inum) + &
             (R(i)-rb(inum))*(zb(inum+1)-zb(inum))/(rb(inum+1)-rb(inum))
        wkmin=min(wkmin,zx)
        wkmax=max(wkmax,zx)
     enddo
     do j=1,nZ
        if(z(j).lt.wkmin) then
           continue
        else if(z(j).gt.wkmax) then
           continue
        else
           dsmoo(i,j)=ONE
        endif
     enddo
  enddo

  do i=iz1,iz2
     wkmin=R(nR)
     wkmax=R(1)
     do j=1,izcr(1,i)
        inum=izcr(j+1,i)  ! bdy segment #
        rx = rb(inum) + &
             (Z(i)-zb(inum))*(rb(inum+1)-rb(inum))/(zb(inum+1)-zb(inum))
        wkmin=min(wkmin,rx)
        wkmax=max(wkmax,rx)
     enddo
     do j=1,nR
        if(r(j).lt.wkmin) then
           continue
        else if(r(j).gt.wkmax) then
           continue
        else
           dsmoo(j,i)=ONE
        endif
     enddo
  enddo

  !--------------------
  !  5.  apply smoothing -- hat function convolution
  !        d=dsmoo(i,j); 0 <= d <= 1
  !      f(i,j) -> (d/6)*f(i-1,j) + ((2+d)/3)*f(i,j) + (d/6)*f(i+1,j)
  !        and repeat in j dimension

  ict=0

  do j=1,nZ
     do i=1,nR
        im=max(1,i-1)
        ip=min(nR,i+1)
        if(dsmoo(i,j).gt.ZERO) then
           if(ict.eq.0) then
              psimin=psi(i,j)
              psimax=psi(i,j)
           else
              psimin=min(psimin,psi(i,j))
              psimax=max(psimax,psi(i,j))
              call cksing
           endif
           ict = ict + 1
        endif
     enddo
  enddo
        
  deallocate(rb,zb)
  deallocate(ircr,izcr)
  deallocate(dsmoo)

CONTAINS

  subroutine cksing

    integer :: ii,jj,ilt,igt
    real*8 :: dmin

    if((i.eq.1).or.(i.eq.nR)) return
    if((j.eq.1).or.(j.eq.nZ)) return

    dmin=min(dsmoo(i-1,j),dsmoo(i,j),dsmoo(i+1,j))

    ilt=0
    igt=0

    if(psi(i-1,j).lt.psi(i,j)) ilt=ilt+1
    if(psi(i+1,j).lt.psi(i,j)) ilt=ilt+1

    if(psi(i-1,j).gt.psi(i,j)) igt=igt+1
    if(psi(i+1,j).gt.psi(i,j)) igt=igt+1

    do jj=j-1,j+1,2
       do ii=i-1,i+1
          dmin=min(dmin,dsmoo(ii,jj))
          if(psi(ii,jj).lt.psi(i,j)) ilt=ilt+1
          if(psi(ii,jj).gt.psi(i,j)) igt=igt+1
       enddo
    enddo

    if(dmin.le.ZERO) return

    ! OK all neighboring points are inside boundary
    !   so, eligible for singularity check.
    !     singularity means: less than, or greater than, all neighbors

    if(ilt.eq.8) nsing = nsing + 1
    if(igt.eq.8) nsing = nsing + 1

  end subroutine cksing
end subroutine psirz_mds_minmax

subroutine xpmom_debug

  use xplasma_definitions
  use xpl_dbg_module

  implicit NONE
 
  real*8, parameter :: z0 = 0.0d0
  real*8, parameter :: zsmall = 1.0d-6

  !------------------------------------------------
  !  xmoments debug plot...
  !------------------------------------------------

  integer :: kmom,ksurf,ier,iertmp,ikmax
  real*8, dimension(:,:), allocatable :: zx,zrmcx,zrmsx,zzmcx,zzmsx
  real*8, dimension(:), allocatable :: zthg,zthwk,zxwk,zwk,zRwk,zZwk
  real*8, dimension(:,:), allocatable :: zRdiff,zZdiff,zsina,zcosa
  real*8 zf,zxa(2),zra(2),zza(2),zdrx,zdzx,zdrsum,zdzsum
  real*8, dimension(:), allocatable :: xrho ! (ksurf)
  real*8, dimension(:), allocatable :: zz ! (0:kmom)
  integer, dimension(:), allocatable :: iself ! (0:kmom)
  character*11, dimension(:), allocatable :: lbsel ! (0:kmom)
  character*17 kylab(5)
  character*60 mnlab(3)
  integer ins(1),inx,ix,ixk,ict(3),id_R,id_Z,id_th,inthg,inthwk
  integer :: ithi,ithg,ii,ith
  logical lxout,lchar
  integer lnout,iscale,im,imm,im1,im2,imc,idum,luntty
  integer, parameter :: inpth = 5

  !------------------------------------------------
  !  exit now if xmoments not fully initialized...

  luntty=lnout(0)

  !  theta grid for testing

  call xplasma_common_ids(sp,ier, id_R=id_R,id_Z=id_Z)
  if(ier.ne.0) then
     write(luntty,*) ' ?xpmom_debug: unexpected xplasma error:'
     call xplasma_error(sp,ier,luntty)
     return
  endif

  call xplasma_prof_info(sp,id_R,ier, gridId1=id_th)

  call xplasma_grid_size(sp,id_th,inthg,ier)
  inthwk=inpth*(inthg-1)+1

  allocate(zthg(inthg),zthwk(inthwk),zxwk(inthwk),zRwk(inthwk),zZwk(inthwk))
  call xplasma_grid(sp,id_th,zthg,ier)
  if(ier.ne.0) then
     write(luntty,*) ' ?xpmom_debug: unexpected xplasma error:'
     call xplasma_error(sp,ier,luntty)
     return
  endif

  zthwk(1)=zthg(1)
  ithi=1
  do ithg=2,inthg
     do ii=1,inpth
        ithi=ithi+1
        zthwk(ithi)=zthg(ithg-1) + ii*(zthg(ithg)-zthg(ithg-1))/inpth
     enddo
  enddo

  !---------------------------
  !  moments rho grid size
  call xpmom_info(sp,ier, kmom=kmom, ksurf=ksurf, ikmax=ikmax)
  if((ier.ne.0).or.(kmom.eq.0).or.(ksurf.eq.0)) then
     write(luntty,*) ' ?xpmom_debug: no Fourier Spline data.'
     return
  endif

  write(luntty,*) kmom,' moments detected.'

  !---------------------------
  !  info on axis derivative
  zdrsum=z0
  zdzsum=z0
  zxa(1)=z0
  zxa(2)=zsmall
  do im=0,kmom,2
     if(im.eq.0) then
        call xpmom_get1(sp,zxa,0,im,ier, rcmom=zra, zcmom=zza)
     else
        call xpmom_get1(sp,zxa,0,im,ier, rcmom=zra, zsmom=zza)
     endif
     if(ier.ne.0) then
        write(luntty,*) ' ?xpmom_debug: unexpected xplasma error:'
        call xplasma_error(sp,ier,luntty)
        exit
     endif
     zdrx=(zra(2)-zra(1))/(zxa(2)-zxa(1))
     zdzx=(zza(2)-zza(1))/(zxa(2)-zxa(1))
     zdrsum=zdrsum+zdrx
     zdzsum=zdzsum+zdzx
     write(luntty,'(" axis: dR[",i2,"]/drho = ",1pe13.6," dZ[",i2,"]/drho = ",1pe13.6)') &
          im,zdrx,im,zdzx
  enddo
  write(luntty,'(1x,a,1pe13.6,1x,a,1pe13.6)') &
       ' axis dR/drho sum: ',zdrsum,' dZ/drho sum: ',zdzsum

  if(ier.ne.0) return

  !----------------------------------------------
  ! test interpolation of scaled moments & plot...
 
  inx=10*(ksurf-1)+1
  ins(1)=inx
  allocate(zx(inx,0:kmom))  ! replicated kmom+1 times
  allocate(zrmcx(inx,0:kmom),zrmsx(inx,0:kmom))
  allocate(zzmcx(inx,0:kmom),zzmsx(inx,0:kmom))
  allocate(zz(0:kmom),iself(0:kmom),lbsel(0:kmom))
  allocate(xrho(ksurf))

  call xpmom_info(sp,ier, xrho=xrho)

  ! fine scale x axis to test interpolation
  ! separate copy of x axis for each moment (for plotting routine)
 
  zx(inx,0:kmom)=xrho(ksurf)
  do ix=1,inx-1
     ixk=1+(ix-1)/10
     zf=(ix-(ixk-1)*10-1)/10.0d0
     !  this is duplicated across moments because of needs of plotting routine
     zx(ix,0:kmom)=(1.0-zf)*xrho(ixk)+zf*xrho(ixk+1)
  enddo

  !---------------------------------
  !  compute R and Z differences btw bicubic spline and Fourier
  !  representation -- on fine x and th grids

  allocate(zRdiff(inthwk,inx),zZdiff(inthwk,inx))

  do
     zrmcx=0; zrmsx=0; zzmcx=0; zzmsx=0
 
     ! labeling stuff
 
     lbsel=' '
     kylab=' '
     mnlab=' '

     if(lxout(0)) write(luntty,1001)
1001 format(/ &
          ' D -- examine difference btw bicubic spline and Fourier representation'/ &
          ' M -- plot all moments'/ &
          ' X -- plot all moments scaled by 1/x'/ &
          ' N -- plot subset of moments'/ &
          ' Y -- plot subset of moments scaled by 1/x'/ &
          ' Q -- quit'/)
     
     call uread('xmoments_debug: plot option:$')
     if(lchar('Q')) then
        exit
     else if(lchar('D')) then
        iscale=-1
        im1=0
        im2=kmom
     else if(lchar('M')) then
        iscale=0
        im1=0
        im2=min(14,kmom)
     else if(lchar('X')) then
        iscale=1
        im1=0
        im2=min(14,kmom)
     else if(lchar('N')) then
        iscale=0
        im1=0
        call ureadi('first moment to plot:',im1)
        im1=min(kmom,max(0,im1))
        im2=im1
        call ureadi('last moment to plot:',im2)
        im2=min(kmom,max(im1,im2))
     else if(lchar('Y')) then
        iscale=1
        im1=0
        call ureadi('first moment to plot:',im1)
        im1=min(kmom,max(0,im1))
        im2=im1
        call ureadi('last moment to plot:',im2)
        im2=min(kmom,max(im1,im2))
     else
        call uermsg(' ?xmoments_debug: unrecognized option.',' ',0)
        cycle
     endif
 
     if(iscale.eq.-1) then
        ! compute difference-- evaluate bicubic spline first...

        do ix=1,inx
           zxwk=zx(ix,0)
           ier=0
           call xplasma_eval_prof(sp,id_R, &
                xplasma_theta_coord,zthwk, xplasma_rho_coord,zxwk, &
                zRdiff(1:inthwk,ix),iertmp)
           ier=max(ier,iertmp)
           call xplasma_eval_prof(sp,id_Z, &
                xplasma_theta_coord,zthwk, xplasma_rho_coord,zxwk, &
                zZdiff(1:inthwk,ix),ier)
           ier=max(ier,iertmp)
           if(ier.ne.0) then
              write(luntty,*) ' ?xpmom_debug: unexpected xplasma error:'
              call xplasma_error(sp,ier,luntty)
              zRdiff=0
              zZdiff=0
              exit
           endif
        enddo
     endif
     ! evaluate scaled moment splines
 
     ict(1)=1; ict(2)=0; ict(3)=0
     if(im1.eq.0) lbsel(0)='0th moment'
     imc=-1
     do im=im1,im2
        imc=imc+1
        call xpmom_get1(sp,zx(1:inx,0),max(0,iscale),im,idum, rcmom=zrmcx(1:inx,imc))
        call xpmom_get1(sp,zx(1:inx,0),max(0,iscale),im,idum, rsmom=zrmsx(1:inx,imc))
        call xpmom_get1(sp,zx(1:inx,0),max(0,iscale),im,idum, zcmom=zzmcx(1:inx,imc))
        call xpmom_get1(sp,zx(1:inx,0),max(0,iscale),im,idum, zsmom=zzmsx(1:inx,imc))
        if(iscale.ge.0) then
           zz(imc)=im
           if(im.gt.0) then
              iself(imc)=imc+1
              if(iscale.eq.1) then
                 if((im.eq.1).or.(ikmax.eq.1)) then
                    write(lbsel(imc),'("moment",i2.2,"/x")') im
                 else
                    write(lbsel(imc),'("mom#",i2.2,"/x^2")') im
                 endif
              else
                 write(lbsel(imc),'("moment ",i2.2)') im
              endif
           endif
        endif
     enddo

     if(iscale.ge.0) then
        iself(0)=-1
 
        ! make plots of moments themselves...
 
        if(iscale.eq.1) then
           kylab(1)='scaled moments'
        else
           kylab(1)='Fourier moments'
        endif
        mnlab(1)='debug plot -- xmoments_spline_setup'
        mnlab(2)='xplasma (xmoments_debug.f90)'
 
        mnlab(3)='R cos moments'
        call r8_grfmm1(zx,zrmcx,inx,ins,1,zz,imc+1,iself,imc+1, &
             ' ','m',mnlab,kylab,lbsel)
 
        mnlab(3)='R sin moments'
        call r8_grfmm1(zx,zrmsx,inx,ins,1,zz,imc+1,iself,imc+1, &
             ' ','m',mnlab,kylab,lbsel)
 
        mnlab(3)='Z cos moments'
        call r8_grfmm1(zx,zzmcx,inx,ins,1,zz,imc+1,iself,imc+1, &
             ' ','m',mnlab,kylab,lbsel)
 
        mnlab(3)='Z sin moments'
        call r8_grfmm1(zx,zzmsx,inx,ins,1,zz,imc+1,iself,imc+1, &
             ' ','m',mnlab,kylab,lbsel)

     else
        ! compute and plot FS and bc spline differences

        allocate(zsina(kmom,inthwk),zcosa(kmom,inthwk))
        do ith=1,inthwk
           call r8sincos(zthwk(ith),kmom,zsina(1:kmom,ith),zcosa(1:kmom,ith))
        enddo

        do ix=1,inx
           zRwk=zrmcx(ix,0)
           zZwk=zzmcx(ix,0)
           do ith=1,inthwk
              do im=1,kmom
                 zRwk(ith)=zRwk(ith) + zrmcx(ix,im)*zcosa(im,ith) + &
                      zrmsx(ix,im)*zsina(im,ith)
                 zZwk(ith)=zZwk(ith) + zzmcx(ix,im)*zcosa(im,ith) + &
                      zzmsx(ix,im)*zsina(im,ith)
              enddo
           enddo

           zRdiff(1:inthwk,ix)=zRdiff(1:inthwk,ix)-zRwk
           zZdiff(1:inthwk,ix)=zZdiff(1:inthwk,ix)-zZwk
        enddo

        allocate(zwk(max(inthwk,inx))); zwk=0

        call r8_grf3f1(zthwk,zRdiff,zx(1:inx,0),zwk, &
             inthwk,inx,inthwk, &
             'theta','delta(R)','rho', 'rad','m',' ', &
             'xpmom_debug plot','compare R Fourier spline & bicubic spline',0)

        call r8_grf3f1(zthwk,zZdiff,zx(1:inx,0),zwk, &
             inthwk,inx,inthwk, &
             'theta','delta(Z)','rho', 'rad','m',' ', &
             'xpmom_debug plot','compare Z Fourier spline & bicubic spline',0)

        deallocate(zwk,zsina,zcosa)

     endif

  enddo
 
  deallocate(zx,zrmcx,zrmsx,zzmcx,zzmsx,zz,iself,lbsel,xrho)
  deallocate(zRdiff,zZdiff,zthwk,zthg,zRwk,zZwk,zxwk)

end subroutine xpmom_debug

!-------------------------------------------
real(fp) function scrXceptcon(x,zsign)
  !
  !  return an estimate of the distance of a point from a flux surface
  !  represented as a series of (R,Y) points
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, one, two
  use mintrp
  implicit none
  real(fp), intent(in) :: x
  real(fp), intent(inout) :: zsign
  real(fp) :: dist
  real(fp) :: zsing
  real(fp) :: zcosg
  real(fp) :: zmu
  real(fp) :: dvdu
  real(fp) :: v
  real(fp) :: u
  real(fp) :: zb
  real(fp) :: za
  real(fp) :: zc
  real(fp) :: dvdu4
  real(fp) :: dvdu1
  real(fp) :: vloc4
  real(fp) :: uloc4
  real(fp) :: vloc1
  real(fp) :: uloc1
  real(fp) :: vtest
  real(fp) :: utest
  real(fp) :: zsinb
  real(fp) :: zcosb
  integer :: ii
  integer :: i
  real(fp) :: zd2save
  real(fp) :: zd1save
  integer :: ktp
  real(fp) :: zdot
  real(fp) :: zminus
  real(fp) :: rminus
  real(fp) :: zplus
  real(fp) :: rplus
  real(fp) :: zd
  integer :: inth
  real(fp) :: zdmin
  real(fp) :: ztest
  real(fp) :: rtest
  real(fp) :: scrYceptcon
  real(fp) :: y
  integer :: ith
  integer :: idbct
  !
  real(fp) :: rloc(4),zloc(4)
  !
  integer :: lunmsg
  logical :: idebug
  data idbct/0/
  !-----------------------------
  !
  !  evaluate y from x (from saved low order fit)
  !
  idebug=.false.
  call scrgetlun(lunmsg)
  !
  !dbg      if((ksurf.eq.45).and.(abs(r2-292.374).le.0.005).and.
  !dbg     >   (abs(z2+89.547).le.0.005)) then
  !dbg	idebug=.true.
  !dbg	idbct=idbct+1
  !dbg      else
  !dbg	idebug=.false.
  !dbg      endif
  !
  if(idbct.eq.1) then
    do ith=1,ntheta0
      write(lunmsg,*) ith,rin(ith,ksurf),zin(ith,ksurf)
    enddo
  endif
  !
  y=scrYceptcon(x,Rtest,Ztest)
  !
  !  first find nearest point on contour
  !
  zdmin=1.0e30_fp
  inth=ntheta0-1
  !
  !  note that rin(1,ksurf)=rin(ntheta(ksurf),ksurf) is the convention
  !            zin(1,ksurf)=zin(ntheta(ksurf),ksurf)
  !  for this representation of a closed contour
  !
  do ith=1,inth
    zd = (Rtest-rin(ith,ksurf))**2  + (Ztest-zin(ith,ksurf))**2
    if(zd.lt.zdmin) then
      kth=ith
      zdmin=zd
    endif
  enddo
  !
  !  now choose of the neighbouring two the nearest interval
  rplus=rin(kth+1,ksurf)
  zplus=zin(kth+1,ksurf)
  if(kth.eq.1) then
    rminus=rin(inth,ksurf)
    zminus=zin(inth,ksurf)
  else
    rminus=rin(kth-1,ksurf)
    zminus=zin(kth-1,ksurf)
  endif
  !
  !  direction vector going from kth-1 to kth+1
  !   dotted with (Rtest,Ztest)-(R(kth),Z(kth))
  !
  zdot=(Rtest-rin(kth,ksurf))*(rplus-rminus) + &
       (Ztest-zin(kth,ksurf))*(zplus-zminus)
  !
  !  if negative, choose the prior interval
  if(zdot.lt.zero) then
    kth=kth-1
    if(kth.eq.0) kth=inth
  endif
  !
  !  distances to endpoints of the chosen interval
  !
  ktp=kth+1
  zd1save=(Rtest-rin(kth,ksurf))**2+(Ztest-zin(kth,ksurf))**2
  zd2save=(Rtest-rin(ktp,ksurf))**2+(Ztest-zin(ktp,ksurf))**2
  !
  zd1save=sqrt(zd1save)
  zd2save=sqrt(zd2save)
  !
  !  store 4 nearby points -- describing 3 nearest contour segments with
  !  the 1 nearest one in the middle
  !
  do i=1,4
    ii=kth-2+i                     ! kth-1 thru kth+2
    if(ii.le.0) ii=ii+inth
    if(ii.gt.inth) ii=ii-inth
    rloc(i)=rin(ii,ksurf)
    zloc(i)=zin(ii,ksurf)
  enddo
  !
  if(idebug) then
    write(lunmsg,'('' kth='',i5)') kth
    do i=1,4
      write(lunmsg,1001) i,rloc(i),zloc(i)
1001  format(' i=',i5,' rloc(i)=',1pe13.6,' zloc(i)=',1pe13.6)
    enddo
  endif
  !
  !  rotate and translate to a metric equivalent coordinate system (u,v)
  !  with origin (rloc(2),zloc(2)) u direction (rloc(3)-rloc(2),zloc(3)-zloc(2))
  !
  zd=sqrt((rloc(3)-rloc(2))**2+(zloc(3)-zloc(2))**2)
  zcosb=(rloc(3)-rloc(2))/zd
  zsinb=(zloc(3)-zloc(2))/zd
  !
  utest= zcosb*(Rtest-rloc(2)) +zsinb*(Ztest-zloc(2))
  vtest=-zsinb*(Rtest-rloc(2)) +zcosb*(Ztest-zloc(2))
  !
  uloc1= zcosb*(rloc(1)-rloc(2)) +zsinb*(zloc(1)-zloc(2))
  vloc1=-zsinb*(rloc(1)-rloc(2)) +zcosb*(zloc(1)-zloc(2))
  !
  uloc4= zcosb*(rloc(4)-rloc(2)) +zsinb*(zloc(4)-zloc(2))
  vloc4=-zsinb*(rloc(4)-rloc(2)) +zcosb*(zloc(4)-zloc(2))
  !
  !  in (u,v) space the 4 nearby points are:
  !    (uloc1,vloc1), (0,0), (d,0), (uloc4,vloc4)
  !
  !  with uloc1 < 0 < d < uloc4, because the change of orientation per
  !  contour segment is assumed small.
  !
  !  so, form a cubic v(u) satisfying v(0)=0, v(d)=0,
  !      and v'(0) and v'(d) numerically evaluated
  !
  !  this is a form of Hermite interpolation
  !
  dvdu1=-vloc1/(zd-uloc1)
  dvdu4=vloc4/uloc4
  !
  !  v(u) = zA*u**3 + zB*u**2 + zC*u
  !
  zC=dvdu1
  zA=(dvdu4+dvdu1)/(zd*zd)
  zB=-(two*dvdu1+dvdu4)/zd
  !
  !  estimate u from ratio of distances from segment end point to
  !  test point; parameter runs from 0 to d
  !
  u=zd*zd1save/(zd1save+zd2save)
  v=u*(zC+u*(ZB+u*ZA))
  !
  !  and the derivative
  !
  dvdu=zC+two*u*(zB+1.5_fp*u*zA)
  !
  !  unit normal to curve in u,v space
  !
  zmu=sqrt(1.0D0+dvdu**2)
  zcosg=1.0D0/zmu
  zsing=dvdu/zmu
  !
  !  signed distance estimate, test point to point on curve
  !
  dist=-zsing*(utest-u) +zcosg*(vtest-v)
  !
  !  done
  !
  zsign=one
  scrXceptcon=dist
  !
  if(idebug) then
    write(lunmsg,1002) x,dist
1002 format('  scrXceptcon:  x=',1pe13.6,' dist=',1pe13.6)
  endif
  !
  return
end function scrXceptcon

subroutine eq_xgetf(ivec,zx,ifcn,iwant,zval,ierr)

  !  f(x) interpolation routine -- with error checking

  use xplasma_obj_instance
  use eq_module
  IMPLICIT NONE

  !  input:

  integer ivec                    ! vector dimension
  REAL*8 zx(abs(ivec))                 ! argument
  integer ifcn                    ! function id number

  !  input:
  integer iwant                   ! 0:  value, 1: df/dx, 2: d2f/dx2

  !  output:
  REAL*8 zval(abs(ivec))               ! result of interpolation
  integer ierr                    ! =0: OK, =1: zx out of range

  !---------------------------
  !  the caller provides the name of the function desired, but it also
  !  provides a number which is writable.  If the caller saves this number
  !  and repeats the call, it saves having to lookup the function name,
  !  a performance enhancement.

  !---------------------------
  integer :: irank,idg,iertmp,ioutside,inum
  logical :: ccwflag
  character*32 fname
  !---------------------------

  call xplasma_prof_info(s,ifcn,ierr, rank=irank, gridId1=idg)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_xgetf: xplasma_prof_info error detected:'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  if(irank.ne.1) then
     call xplasma_prof_info(s,ifcn,iertmp, name=fname)
     write(lunerr,*) ' ?eq_xgetf: not a rank1 profile: "',trim(fname),'".'
     ierr=1
     return
  endif

  ccwflag = (ivec.gt.0) 
  inum=abs(ivec)

  call xplasma_eval_prof(s,ifcn,zx(1:inum),zval(1:inum),ierr, &
       ideriv1=iwant,ccwflag1=ccwflag,n_out_of_bounds=ioutside)

  if(ioutside.gt.0) then
     ierr=1
     write(lunerr,*) ' %eq_xgetf: error flag set, ',ioutside, &
          ' points out of range.'
  else if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_xgetf: xplasma_eval_prof error detected:'
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_xgetf

subroutine scrsetlun(ilun)
  !
  ! set lun for messages
  !
  use scrunch_inc1

  lunmsg = ilun

  return

end subroutine scrsetlun

subroutine scrgetlun(ilun)
  !
  ! set lun for messages
  !
  use scrunch_inc1

  ilun = lunmsg

  return

end subroutine scrgetlun

      subroutine eqxyz_fget(ivec,xx,yy,zz,ztol,ifcn,fval,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated function f @ (x,y,z)
c
c      since this involves an inverse map to (rho,chi,phi)
c      a relative accuracy tolerance is required.
c
c      inverse map results not returned.
c
      implicit NONE
c input:
      integer ivec                      ! vector dimensioning
      real*8 xx(ivec),yy(ivec),zz(ivec) ! (x,y,z) target coordinates
c
      real*8 ztol                       ! rel. tolerance for inv. map
c
c (x,y,z)->(rho,chi,phi) by Newton's method
c          (rho,cho,phi) maps to (x',y',z'); Newton iteration stops when
c                          max(|x-x'|,|y-y'|,|z-z'|).le.ztol*Raxis
c
      integer ifcn                      ! xplasma fcn id, function wanted.
c
c output:
      real*8 fval(ivec)                 ! the function values returned
      integer nregion(ivec)             ! region code
c
      integer ierr                      ! completion code, 0=OK
c
c--------------------------
c
      real*8 zrho(ivec),zchi(ivec),zphi(ivec)
c
c--------------------------
c
      call eqxyzmap_fget(ivec,xx,yy,zz,zrho,zchi,zphi,ztol,ifcn,
     >   fval,nregion,ierr)
c
      return
      end
c---------------------------------------------------------------------
      subroutine eqxyz_fgrad(ivec,xx,yy,zz,ztol,ifcn,
     >   fval,fgrad,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated function f @ (x,y,z)
c  get cartesian gradient of f (df/dx,df/dy,df/dz) @ (x,y,z)
c
c      since this involves an inverse map to (rho,chi,phi)
c      a relative accuracy tolerance is required.
c
c  inverse map results not returned.
c
      implicit NONE
c input:
      integer ivec                      ! vector dimensioning
      real*8 xx(ivec),yy(ivec),zz(ivec) ! (x,y,z) target coordinates
c
      real*8 ztol                       ! rel. tolerance for inv. map
c
c (x,y,z)->(rho,chi,phi) by Newton's method
c          (rho,cho,phi) maps to (x',y',z'); Newton iteration stops when
c                          max(|x-x'|,|y-y'|,|z-z'|).le.ztol*Raxis
c
      integer ifcn                      ! xplasma fcn id, function wanted.
c
c output:
      real*8 fval(ivec)                 ! the function values returned
      real*8 fgrad(3,ivec)              ! the function gradients returned
      integer nregion(ivec)             ! region code
c
      integer ierr                      ! completion code, 0=OK
c
c--------------------------
c
      real*8 zrho(ivec),zchi(ivec),zphi(ivec)
c
c--------------------------
c
      call eqxyzmap_fgrad(ivec,xx,yy,zz,zrho,zchi,zphi,ztol,ifcn,
     >   fval,fgrad,nregion,ierr)
c
      return
      end
C--------------------------------------------------------------------
      subroutine eqxyzmap_fget(ivec,xx,yy,zz,zrho,zchi,zphi,ztol,
     >   ifcn,fval,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated function f @ (x,y,z)
c
c      since this involves an inverse map to (rho,chi,phi)
c      a relative accuracy tolerance is required.
c
c      inverse map results are returned.
c
c  method:
C  transform to (R,Z,phi), get fcn value in this space
C
      IMPLICIT NONE
c
c  input:
      integer ivec                      ! vector dimensioning
      REAL*8 xx(ivec),yy(ivec),zz(ivec) ! (x,y,z) location
      REAL*8 ztol                       ! rel. tol. for (x,y,z)->flux coords
C
c (x,y,z)->(rho,chi,phi) by Newton's method
c          (rho,cho,phi) maps to (x',y',z'); Newton iteration stops when
c                          max(|x-x'|,|y-y'|,|z-z'|).le.ztol*Raxis
c
      integer ifcn                      ! function number
C
C  output:
      REAL*8 zrho(ivec),zchi(ivec),zphi(ivec) ! (rho,chi,phi) (flux coords)
      REAL*8 fval(ivec)                 ! function value
C
      integer nregion(ivec)             ! region code for (x,y,z) (cf eq_xinv).
      integer ierr                      ! completion code, 0=OK
C
C--------------------------
C
      REAL*8 zR(ivec),zdum
C
C--------------------------
C  transform to cylindric coords
      call eq_rcyl(ivec,xx,yy,zR,zphi)
C
C  get values & vectors
C
      call eqrzmap_fget(ivec,zR,zZ,zphi,zrho,zchi,ztol,ifcn,
     >   fval,nregion,ierr)
C
      return
      end
C--------------------------------------------------------------------
      subroutine eqxyzmap_fgrad(ivec,xx,yy,zz,zrho,zchi,zphi,ztol,
     >   ifcn,fval,fgrad,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated function f @ (x,y,z)
c  get cartesian gradient of f (df/dx,df/dy,df/dz) @ (x,y,z)
c
c      since this involves an inverse map to (rho,chi,phi)
c      a relative accuracy tolerance is required.
c
c  inverse map results not returned.
c
C  transform to (R,Z,phi), get fcn value and gradient in this space,
C  then transform back to (x,y,z)
C
      IMPLICIT NONE
c
c  input:
      integer ivec                      ! vector dimensioning
      REAL*8 xx(ivec),yy(ivec),zz(ivec) ! (x,y,z) location
      REAL*8 ztol                       ! rel. tol. for (x,y,z)->flux coords
C
c (x,y,z)->(rho,chi,phi) by Newton's method
c          (rho,cho,phi) maps to (x',y',z'); Newton iteration stops when
c                          max(|x-x'|,|y-y'|,|z-z'|).le.ztol*Raxis
c
      integer ifcn                      ! function number
C
C  output:
      REAL*8 zrho(ivec),zchi(ivec),zphi(ivec) ! (rho,chi,phi) (flux coords)
      REAL*8 fval(ivec)                 ! function value
      REAL*8 fgrad(3,ivec)              ! cartesian gradient of f
C
      integer nregion(ivec)             ! region code for (x,y,z) (cf eq_xinv).
      integer ierr                      ! completion code, 0=OK
C
C--------------------------
C
      REAL*8 zR(ivec),zdum
C
C--------------------------
C  transform to cylindric coords
      call eq_rcyl(ivec,xx,yy,zR,zphi)
C
C  get values & vectors
C
      call eqrzmap_fgrad(ivec,zR,zZ,zphi,zrho,zchi,ztol,ifcn,
     >   fval,fgrad,nregion,ierr)
C
C  map (R,Z,phi) vectors to (x,y,z) system
C
      if(ierr.eq.0) then
         call eqi_rzxvec(ivec,zR,zZ,zphi,0,zdum,zdum,1,ivec,fval,fgrad)
      endif
C
      return
      end
C--------------------------------------------------------------------

subroutine eq_fxcep(inum,itype,idinit, &
     ra,za,phia,da,rb,zb,phib,db,tol, &
     rx,zx,phix,istat,ierr)

  !  given a set of line segments which straddle a boundary, find the points
  !  lying on the segments which intersect the boundary.

  use xplasma_obj_instance
  use eq_module

  implicit NONE

  !  input:

  integer inum                      ! number of segments
  integer itype                     ! =1:  plasma bdy; =2:  limiter
  integer idinit                    ! =1:  da & db already initialized

  real*8 ra(inum),za(inum),phia(inum) ! end pts A of segments
  real*8 rb(inum),zb(inum),phib(inum) ! end pts B of segments

  !  input if idinit=1, output otherwise:

  real*8 da(inum)                   ! distance of A pts from bdy
  real*8 db(inum)                   ! distance of B pts from bdy

  !  input:

  real*8 tol                        ! relative accuracy tolerance

  !  approx. accuracy of intercept position:  tol*[system size]
  !  system size = 0.5*(Rmax-Rmin)

  !  output:

  real*8 rx(inum),zx(inum),phix(inum) ! the intercepts returned

  !  if (from da,db) a segment does not straddle the boundary,
  !                  for that segment rx,zx contains the nearer endpoint

  integer istat(inum)               ! segment status

  !  istat(j)=2 -- both endpoints outside bdy
  !  istat(j)=1 -- 1st endpoint outside, 2nd endpoint inside
  !  istat(j)=-1 -- 1st endpoint inside, 2nd endpoint outside
  !  istat(j)=-2 -- both endpoints inside bdy
  !    (rx(j),zx(j)) contains bdy intercept if abs(istat(j))=1.

  integer ierr                      ! completion code, 0=OK

  !  ierr only set in case of serious error
  !-----------------------------------------------------------------
  integer :: maptype
  !-----------------------------------------------------------------
  
  call xplasma_max_maptype(s,maptype,ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' xplasma_max_maptype call error in eq_fxcep:'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  if(idinit.eq.1) then

      call xplasma_fxcep(s,itype, &
           ra,za,phia,rb,zb,phib, &
           rx,zx,phix,istat,ierr, &
           maptype=maptype, tol=tol, da_input=da, db_input=db)

  else

      call xplasma_fxcep(s,itype, &
           ra,za,phia,rb,zb,phib, &
           rx,zx,phix,istat,ierr, &
           maptype=maptype, tol=tol, da_output=da, db_output=db)

  endif

end subroutine eq_fxcep

!-----------------------------------------------------------------------
subroutine eq_flxint(name,noption,result,inumchi,inumrho,ierr)

  !  return results of numerical integrations
  !  fortran-77 interface

  !  ported to fortran-90 rewritten XPLASMA dmc March 2006

  !  the integration option "noption" no longer has any effect but is
  !  left in place for backwards compatibility reasons.

  use xplasma_obj_instance
  use eq_module
  use eqi_intg_module

  implicit NONE

  !input:

  character*(*) name           ! name of item wanted
  integer noption              ! integration method option (*ignored*)
  integer inumchi              ! 1st dimension, chi dimension of output array
  integer inumrho              ! 2nd dimension, rho dimension of output array

  !output:

  real*8 result(inumchi,inumrho) ! result of integrations

  integer ierr                 ! completion code (0=OK)

  !-------------------------------------------------
  integer :: idi,inum,inrhoi,inthi,inthzons,inzons,inrho_need
  logical :: ilsurf,dvol_need,dvdrho_need,bmaxa_need
  character*32 zname
  !-------------------------------------------------
  result = 0

  call eq_find_intg(inumchi,idi,inrhoi,inthi,ierr)
  if(ierr.ne.0) return

  inthzons = inthi-1
  inzons = inrhoi-1

  zname=name
  call uupper(zname)

  sp => s

  call xplasma_integ_num(zname,inum,ilsurf, &
       dvol_need,dvdrho_need,bmaxa_need)

  if(inum.eq.0) then
     write(lunerr,*) &
          '  unrecognized integration name:  "'//trim(zname)//'".'
     ierr=1
     return
  endif

  if((.not.ilsurf).or.(inum.eq.eqi_intg_dvol).or.(inum.eq.eqi_intg_darea)) then
     inrho_need = inzons
  else
     inrho_need = inzons + 1
  endif

  if(inumchi.lt.inthzons) then
     write(lunerr,*) ' ?eq_flxint: too few poloidal zones in result array:'
     write(lunerr,*) '  received: ',inumchi,'; need at least: ',inthzons
     ierr = 1
  endif

  if(inumrho.lt.inrho_need) then
     write(lunerr,*) ' ?eq_flxint: too few radial zones in result array:'
     write(lunerr,*) '  received: ',inumrho,'; need at least: ',inrho_need
     ierr = 1
  endif

  !---------------------
  !  done with error checking; do integration

  if(inumchi.eq.1) then
     call xplasma_rho_zonint(s,idi,zname,result(1,1:inrho_need),ierr)

  else
     call xplasma_2d_zonint(s,idi,zname,result(1:inthzons,1:inrho_need),ierr)

  endif

end subroutine eq_flxint

!******************** START FILE DDROP.FOR ; GROUP FILTR6 ******************
!
!  DDROP   SUBROUTINE TO DROP OUT DATA POINTS THAT DIVERGE
!          TOO FAR FROM THEIR IMMEDIATE NEIGHBOURS, I.E.,
!          TO REMOVE 'SPIKES' FROM THE DATA SIGNAL.
!
!    X AND Y ARE ARRAYS CONTAINING THE ABSCISSAE AND ORDINATES
!    OF THE DATA SIGNAL, RESPECTIVELY, AND N IS THE
!    NUMBER OF DATA POINTS.
!      DDV, IN PHYSICAL UNITS (UNITS OF THE DATA ORDINATES)
!    IS THE DATA DROP CRITERION.  EACH ORDINATE (EXCEPT THE
!    ENDPOINT ORDINATES) IS COMPARED WITH THE VALUE LIN-
!    EARLY INTERPOLATED FROM THE POINT'S TWO IMMEDIATE
!    NEIGHBORS.  IF THE DIFFERENCE IS MORE THAN DDV,  THE
!    ORDINATE IS CONSIDERED A 'SPIKE', ELIGIBLE FOR REMOVAL.
!    IF THE SPIKE IS ISOLATED FROM OTHER SPIKES, SO THAT
!    THE ALGORITHM CAN REASONABLY DISTINGUISH BETWEEN SPIKE
!    AND SIGNAL, THE SPIKE IS REMOVED BY SUBSTITUTING THE
!   LINEARLY INTERPOLATED VALUE.
!
!  IF CONSECUTIVE POINTS VIOLATE THE DDV CRITERION, IT MAY BE
!  THAT THE ENTIRE SIGNAL CONSISTS OF SPIKES, AND NO ACTION
!   WILL BE TAKEN UNLESS BY CORRECTING ONE OF THE ORDINATES,
!  THE ENTIRE SEQUENCE OF VIOLATIONS CAN BE REMOVED (NOTE THAT
!  FOR A SINGLE SPIKE WHICH IS LARGE ENOUGH, A VIOLATION MAY
!  BE DETECTED AT THE SPIKE POINT ITSELF AND ITS IMMEDIATE
!  NEIGHBORS, RESULTING IN THREE CONSECUTIVE VIOLATIONS)
!
!--------------------------------------------------------
!  WRITTEN D. MC CUNE @PPPL   JAN 10 1979
!   REVISED:
!
SUBROUTINE r8ddrop(X,Y,N,DDV,NDROP)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: ZERO
  implicit none
  ! Arguments
  integer, intent(in) :: n
  real(fp), dimension(n), intent(in)    :: x
  real(fp), dimension(n), intent(inout) :: y
  real(fp), intent(in) :: ddv
  integer, intent(out) :: ndrop  ! Number of points dropped
  ! Local variables
  integer :: nm1,na1,na2,i,im1,ip1,nv1,j,nv2,nviol,nv,nvc,iv, &
       ncm1,ncp1,nam1,np1
  real(fp) :: ysav,dynew
  real(fp), dimension(5) :: dytes
  !
  !  SET UP
  !
  NDROP=0
  NM1=N-1
  IF(N.LT.3) RETURN
  NA1=1
  NA2=5
  DYTES(1)=ZERO
  DO I=2,5
    DYTES(I)=ZERO
    IF(I.GT.NM1) cycle
    IM1=I-1
    IP1=I+1
    DYTES(I)=Y(I)-YLININ(X(I),X(IM1),Y(IM1),X(IP1),Y(IP1))
  END DO
  !
  !  MAIN LOOP
  !
  !  THE FIVE ELEMENT ARRAY DYTES IS A MOVING 'WINDOW' ON THE
  !  DATA, CONTAINING THE LOCAL 'SPIKE HEIGHT' FOR DATA ORDINATES
  !  NA1 THRU NA2.  WHEN A SPIKE HEIGHT VIOLATION IS DETECTED
  !  AND DETERMINED TO BE ISOLATED FROM OTHER VIOLATIONS THRU THIS
  !  WINDOW, IT IS PROCESSED.  ANY PLACE WHERE FOUR OR MORE
  !  CONSECUTIVE VIOLATIONS OCCUR WILL NOT BE PROCESSED
  !
20 CONTINUE
  !  TEST FOR COMPLETION
  IF(NA1.GE.NM1) GO TO 200
  !  TEST FOR CONTINUATION OF SEQUENCE OF VIOLATIONS TOO LENGTHY
  !  TO CORRECT
  IF(ABS(DYTES(1)).GE.DDV) GO TO 150
  !  LOOK FOR NEW VIOLATION
  DO I=2,4
    IF(ABS(DYTES(I)).GE.DDV) GO TO 40
  END DO
  !  NO VIOLATION FOUND
  GO TO 150
  !  FIND END OF SEQUENCE OF VIOLATIONS (IN WINDOW)
40 CONTINUE
  NV1=NA1+I-1
  DO J=I+1,5
    IF(ABS(DYTES(J)).LT.DDV) GO TO 60
  END DO
  !  END OF SEQUENCE OF VIOLATIONS NOT FOUND
  GO TO 150
  !  END OF SEQUENCE OF VIOLATIONS FOUND; SEQUENCE IS AT MOST
  !  THREE DATA POINTS LONG
60 CONTINUE
  NV2=NA1+J-2
  NVIOL=NV2-NV1+1
  GO TO (70,80,100) NVIOL
  !
  !  ISOLATED (SINGLE POINT) VIOLATION
  !
70 CONTINUE
  Y(NV1)=Y(NV1)-DYTES(I)
  NDROP=NDROP+1
  DYTES(I)=ZERO
  GO TO 150
  !
  !  VIOLATEION INVOLVING TWO CONSECUTIVE DATA POINTS
  !
80 CONTINUE
  NV=NV1
  NVC=NV2
  IV=I
  IF(ABS(DYTES(I+1)).LT.ABS(DYTES(I))) GO TO 90
  NV=NV2
  NVC=NV1
  IV=I+1
  !
90 CONTINUE
  !  APPLY CORRECTION FOR LARGER VIOLATION ONLY IF THIS
  !  ALSO REMOVES THE VIOLATION FOR THE OTHER POINT AS WELL
  !
  YSAV=Y(NV)
  Y(NV)=Y(NV)-DYTES(IV)
  NCM1=NVC-1
  NCP1=NVC+1
  DYNEW=Y(NVC)-YLININ(X(NVC),X(NCM1),Y(NCM1),X(NCP1),Y(NCP1))
  IF(ABS(DYNEW).GE.DDV) Y(NV)=YSAV
  IF(Y(NV).EQ.YSAV) GO TO 150
  NDROP=NDROP+1
  DYTES(I)=ZERO
  DYTES(I+1)=ZERO
  GO TO 150
  !
  !  VIOLATION INVOLVING THREE CONSECUTIVE DATA POINTS
  !  TRY CORRECTING MIDDLE VIOLATING POINT ONLY AND
  !  APPLY ONLY IF THIS REMOVES THE VIOLATION FOR ALL THREE
  !  POINTS
  !
100 CONTINUE
  NV=NV1+1
  IV=I+1
  YSAV=Y(NV)
  Y(NV)=Y(NV)-DYTES(IV)
  NCM1=NV1-1
  NCP1=NV2+1
  DYNEW=Y(NV1)-YLININ(X(NV1),X(NCM1),Y(NCM1),X(NV),Y(NV))
  IF(ABS(DYNEW).GE.DDV) Y(NV)=YSAV
  DYNEW=Y(NV2)-YLININ(X(NV2),X(NV),Y(NV),X(NCP1),Y(NCP1))
  IF(ABS(DYNEW).GE.DDV) Y(NV)=YSAV
  IF(YSAV.EQ.Y(NV)) GO TO 150
  NDROP=NDROP+1
  DO J=I,I+2
    DYTES(J)=ZERO
  END DO
  GO TO 150
  !
  !  END OF MAIN LOOP ... ADVANCE WINDOW
  !
150 CONTINUE
  NA1=NA1+1
  DO I=1,4
    DYTES(I)=DYTES(I+1)
  END DO
  DYTES(5)=ZERO
  NA2=NA1+4
  NAM1=NA2-1
  NP1=NA2+1
  IF(NA2.LE.NM1) &
       DYTES(5)=Y(NA2)-YLININ(X(NA2),X(NAM1),Y(NAM1),X(NP1),Y(NP1))
  GO TO 20
  !
  !  LOOP EXIT ***
  !
200 CONTINUE
  RETURN

contains

  real(fp) function ylinin(xx,x1,y1,x2,y2)
    use iso_c_binding, only: fp => c_double
    implicit none
    real(fp), intent(in) :: xx,x1,y1,x2,y2
    ylinin = y1 + (xx-x1)*(y2-y1)/(x2-x1)
    return
  end function ylinin

END SUBROUTINE r8ddrop

subroutine xplasma_debug

  ! debugging tool for xplasma
  ! list contents, make displays, run tests

  ! ***this is not a module routine*** so the XPLASMA pointer is retrieved
  !   via eqi_intg_module

  use xplasma_definitions
  use eqi_intg_module

  use xplasma_debug_module

  implicit NONE

  type (xplasma), pointer :: s

  !----------------------------------
  ! debugging capability will be added for each new xplasma data type
  ! as appropriate
  !----------------------------------
  integer :: inum_lists,inum_coords,inum_grids,inum_profs,inum_blkbxs,ier
  !----------------------------------
  ! CL fortran interface

  integer :: luntty,lnout
  logical :: lxout,lchar

  !----------------------------------

  luntty = lnout(0)

  !----------------------------------
  s => sp_debug
  if(.not.associated(s)) then
     write(luntty,*) ' ?xplasma_debug:  received NULL xplasma object pointer.'
     return
  endif
  !----------------------------------

  do 

     call xplasma_num_items(s,ier, &
          num_lists=inum_lists, &
          num_coords=inum_coords, &
          num_grids=inum_grids, &
          num_profs=inum_profs, &
          num_blkbxs=inum_blkbxs)

     if(ier.ne.0) then
        call xplasma_error(s,ier,luntty)
        return
     endif

     if(lxout(0)) then
        write(luntty,*) ' xplasma_debug: xplasma contents summary:'
        write(luntty,*) '    ',inum_coords,' coordinates.'
        write(luntty,*) '    ',inum_grids,' grids.'
        write(luntty,*) '    ',inum_profs,' profiles.'
        write(luntty,*) '    ',inum_lists,' lists.'
        write(luntty,*) '    ',inum_blkbxs,' "black boxes".'
        write(luntty,*) ' enter:'
        write(luntty,*) '  "A": for special plots or tests.'
        write(luntty,*) '  "C": to examine coordinates.'
        write(luntty,*) '  "G": to examine grids.'
        write(luntty,*) '  "P": to examine profiles.'
        write(luntty,*) '  "L": to examine lists.'
        write(luntty,*) '  "Z": to examine black boxes.'
        write(luntty,*) ' '
        write(luntty,*) '  "S": to examine global scalar data.'
        write(luntty,*) '  "Q": to quit.'
     endif

     call uread('xplasma_debug_master: action option:')

     if(lchar('Q')) then
        exit

     else if(lchar('A')) then
        call xplasma_debug_special(s)

     else if(lchar('C')) then
        call xplasma_debug_coords(s,inum_coords)

     else if(lchar('G')) then
        call xplasma_debug_grids(s,inum_grids)

     else if(lchar('P')) then
        call xplasma_debug_profs(s,inum_profs)

     else if(lchar('L')) then
        call xplasma_debug_lists(s,inum_lists)

     else if(lchar('Z')) then
        call xplasma_debug_blkbxs(s,inum_blkbxs)

     else if(lchar('S')) then
        call examine_scalars

     else
        call uermsg('?xplasma_debug: unrecognized action option.',' ',0)
     endif

  enddo

  contains

    subroutine examine_scalars

      character*128 label0
      real*8 time
      logical :: axisymm,scrapeoff
      integer :: bccw,jccw
      real*8 bdytol
      integer :: rzOrder,iprof

      call xplasma_global_info(s,ier, &
           initLabel=label0, time=time, &
           axisymm=axisymm, scrapeoff=scrapeoff, &
           bphi_ccw=bccw, jphi_ccw=jccw, &
           bdytol=bdytol, rzOrder=rzOrder, prof_counter = iprof)

      write(luntty,*) ' '
      write(luntty,*) ' xplasma global scalar information: '
      write(luntty,*) ' ---------------------------------- '

      write(luntty,*) ' general label: ',trim(label0)
      write(luntty,*) ' time (s): ',time

      write(luntty,*) ' axisymmetry flag: ',axisymm
      write(luntty,*) ' scrapeoff region flag: ',scrapeoff

      if(bccw.eq.1) then
         write(luntty,*) &
              ' direction of toroidal field:  counter-clockwise seen from above.'
      else if(bccw.eq.-1) then
         write(luntty,*) &
              ' direction of toroidal field:  clockwise seen from above.'
      else
         write(luntty,*) &
              ' direction of toroidal field:  unknown.'
      endif

      if(jccw.eq.1) then
         write(luntty,*) &
              ' direction of toroidal current:  counter-clockwise seen from above.'
      else if(jccw.eq.-1) then
         write(luntty,*) &
              ' direction of toroidal current:  clockwise seen from above.'
      else
         write(luntty,*) &
              ' direction of toroidal current:  unknown.'
      endif

      write(luntty,*) ' out-of-bounds tolerance for interpolations: ',bdytol
      write(luntty,*) ' default spline order for {R,Z}(rho,theta): ',rzOrder

      write(luntty,*) ' profile definitions counter: ',iprof

      write(luntty,*) ' '
      write(luntty,*) ' ---------------------------------- '
      write(luntty,*) ' '

    end subroutine examine_scalars
end subroutine xplasma_debug

subroutine eqi_rzsmedg(R,inumR,Z,inumZ,fdata,zsm,ierr)

  !  given f(R,Z) data,
  !  smooth in a band of width (zsm) along the plasma boundary

  !  the smoothing of f(Rj,Zk) is a bi-triangular weighted convolution
  !  over Rj +/- zsmloc, Zk +/- zsmloc, where zsmloc=zsm if distance from
  !  bdy is .le. 0.5*zsm, and a value linearly declining to zero if distance
  !  from bdy is between 0.5*zsm and 1.5*zsm.

  implicit NONE

  integer inumR,inumZ               ! R,Z grid sizes
  real*8 R(inumR),Z(inumZ)          ! R,Z grids
  real*8 fdata(inumR,inumZ)         ! data to be smoothed
  real*8 zsm                        ! smoothing bandwidth

  integer ierr                      ! completion code returned, 0=OK

  !---------------------------------
  real*8, dimension(:,:), allocatable :: wk1,wk2
  real*8, parameter :: HALF = 0.5d0
  !---------------------------------

  ierr=0

  allocate(wk1(inumR,inumZ))
  allocate(wk2(inumR,inumZ))

  !  the bidirectional smooth with varying convolution width is not quite
  !  linear, so compute it both ways and average the result

  wk1=fdata
  wk2=fdata

  call eqi_rzsmedR(R,inumR,Z,inumZ,wk1,zsm)
  call eqi_rzsmedZ(R,inumR,Z,inumZ,wk1,zsm)

  call eqi_rzsmedZ(R,inumR,Z,inumZ,wk2,zsm)
  call eqi_rzsmedR(R,inumR,Z,inumZ,wk2,zsm)

  fdata=HALF*(wk1+wk2)

  deallocate(wk1,wk2)

end subroutine eqi_rzsmedg

subroutine eqm_fRZ(iorder,id_R,id_Z,zlbl,zdata,id1, &
     ibcR0,zbcR0,ibcR1,zbcR1, &
     ibcZ0,zbcZ0,ibcZ1,zbcZ1, &
     id_fun,ierr)

  !  establish a function of "R & Z"

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  !  input:
  integer iorder                    ! desired interpolation order

  !  iorder=0:  bilinear interpolation on data on (nR)x(nZ) grid
  !  iorder=1:  Akima Hermite interpolation on data on(nR)x(nZ) grid
  !  iorder=2 or 3:  Spline interpolation on data on (nR)x(nZ) grid

  !  iorder=99 -- this is a an update of the data in an existing
  !             f(R,Z) object.  The fit order and axes used
  !             cannot change.

  !  iorder=100 -- bilinear data (may be replacement of same sized object)
  !  iorder=101 -- Akima Hermite (may be replacement of same sized object)
  !  iorder=102 or 103 -- spline (may be replacement of same sized object)

  integer id_R                      ! axis id -- 1st dimension, R
  integer id_Z                      ! axis id -- 2nd dimension, Z

  character*(*) zlbl                ! function name (label)
  integer id1                       ! size of 1st dimension of zdata

  REAL*8 zdata(id1,*)               ! data (at least nR*nZ words)

  !  nR and nZ refer to the axes (id_R,id_Z)
  !  id1 must be .ge. size of axis (id_R)

  !  bdy conditions are enforced only for iorder.ge.1
  integer ibcR0,ibcR1               ! BC's at extrema

  !  BC controls are as in "pspline":  0 -- default, 1 -- fix df/dR
  !                                    2 -- fix d2f/dR2, etc...

  REAL*8 zbcR0(*)                   ! if ibc=1:  df/dR @ R(1), nZ pts
                                    ! if ibc=2:  d2f/dR2 @ R(1), nZ pts
  REAL*8 zbcR1(*)                   ! ditto @R(nR)

  !  zbcR0 and zbcR1 ignored if ibcR0=ibcR1=0

  !  bdy conditions are enforced only for iorder.ge.1

  integer ibcZ0,ibcZ1               ! BC's at extrema

  !  BC controls are as in "pspline":  0 -- default, 1 -- fix df/dZ
  !                                    2 -- fix d2f/dZ2, etc...

  REAL*8 zbcZ0(*)                   ! if ibc=1:  df/dZ @ Z(1), nR pts
                                    ! if ibc=2:  d2f/dZ2 @ Z(1), nR pts
  REAL*8 zbcZ1(*)                   ! ditto @Z(nZ)

  !  zbcZ0 and zbcZ1 ignored if ibcZ0=ibcZ1=0

  !  output:

  integer id_fun                    ! function id code
  integer ierr                      ! completion code, 0=OK

  !-----------------------------
  !  local copy

  integer iorderi,iertmp,icoord1,icoord2,ierdum
  integer :: nR,nZ
  character*32 zname

  !-----------------------------
  ierr=0

  iorderi=iorder
  if(iorderi.lt.99) iorderi=max(0,min(2,iorderi))
  if(iorderi.ge.100) iorderi=max(0,min(2,(iorderi-100)))

  !  iorderi=99 gets more special treatment below...
  !--------------------------
  !  check axes

  call xplasma_grid_info(s,id_R,ierr, coord=icoord1)
  if(ierr.ne.0) then
     call xplasma_error(s,ierr,lunerr)
     write(lunerr,*) &
          ' ?eqm_frz ("',trim(zlbl),'"): id_R=',id_R,' invalid grid.'
     ierr=1
  else if(icoord1.ne.xplasma_R_coord) then
     write(lunerr,*) & 
          ' ?eqm_frz ("',trim(zlbl),'"): id_R=',id_R,' *NOT* major radius.'
     call xplasma_grid_info(s,id_R,ierdum, name=zname)
     write(lunerr,*) &
          '  name of id_R grid: ',trim(zname)
     ierr=2
  endif
  iertmp=ierr

  call xplasma_grid_info(s,id_Z,ierr, coord=icoord1)
  if(ierr.ne.0) then
     call xplasma_error(s,ierr,lunerr)
     write(lunerr,*) &
          ' ?eqm_frz ("',trim(zlbl),'"): id_Z=',id_Z,' invalid grid.'
     ierr=1
  else if(icoord1.ne.xplasma_Z_coord) then
     write(lunerr,*) & 
          ' ?eqm_frz ("',trim(zlbl),'"): id_Z=',id_Z,' *NOT* Z.'
     call xplasma_grid_info(s,id_Z,ierdum, name=zname)
     write(lunerr,*) &
          '  name of id_Z grid: ',trim(zname)
     ierr=2
  endif
  ierr=max(ierr,iertmp)
  if(ierr.gt.0) return

  !  OK: grid sizes are...

  call xplasma_grid_size(s,id_R,nR,ierr)
  if(ierr.ne.0) then
     call xplasma_error(s,ierr,lunerr)
     write(lunerr,*) ' ?error in eqm_frz'
  endif

  call xplasma_grid_size(s,id_Z,nZ,ierr)
  if(ierr.ne.0) then
     call xplasma_error(s,ierr,lunerr)
     write(lunerr,*) ' ?error in eqm_frz'
  endif

  !--------------------------
  !  iorderi=99 means request to use prior splining method for this call;
  !  this implies profile must already exist:  check...

  if(iorderi.eq.99) then
     call xplasma_find_item(s,zlbl,id_fun,iertmp)
     if(iertmp.eq.0) then
        call xplasma_prof_info(s,id_fun,ierr, splineType=iorderi)
     else
        ierr=iertmp
     endif
     if(ierr.ne.0) then
        call xplasma_error(s,ierr,lunerr)
        call eq_errmsg(' ?eqm_frz: iorder=99 call failed: '//trim(zlbl)// &
             ' does not exist.')
        ierr=1
     endif
  endif
  if(ierr.ne.0) return

  !--------------------------
  !  iorderi now contains the desired spline type in all cases, so...

  call xoi_author_set(ierr)

  call xplasma_create_2dprof(s,zlbl,id_R,id_Z,zdata(1:nR,1:nZ), &
       id_fun,ierr, &
       ispline=iorderi, &
       ibcx1a=ibcR0,zbcx1a=zbcR0(1:nR),ibcx1b=ibcR1,zbcx1b=zbcR1(1:nR), &
       ibcx2a=ibcZ0,zbcx2a=zbcZ0(1:nZ),ibcx2b=ibcZ1,zbcx2b=zbcZ1(1:nZ))

  call xoi_author_clear(iertmp)

end subroutine eqm_fRZ

#include "fpreproc/f77_dcomplx.h"
      subroutine r8bloata0(symflag,lcentr,nzones,xiblo,inbblo,mtbl,mj,
     >                  rmc,ymc,nmom,mimom,nonlin,
     >                  rmcx,ymcx,ierr)
C
C  bloat subroutine -- updown *asymmetric* -- calling arguments, no COMMON!
C  dmc 27 Dec 1996
C
C  algorithm rewritten -- DMC Aug 14 2003 -- continuing reliability issues
C  with old algorithm not to be overcome.
C
C  Restriction:  thetaA(theta) = atan2((R(theta)-Rcen),(Z(theta)-Zcen))
C  must be monotonic with some margin: d(thetaA)/d(theta) > 0.01D0 ...
C
C  In other words, any straight line drawn out from the magnetic axis
C  must only cross the boundary surface once, and also cannot be
C  tangent to the boudary surface.
C
C  this routine copies the inside-the-plasma moments set to the bloated
C  moments set, and uses a numerical algorithm to create well behaved
C  surfaces beyond the plasma bdy.  these surfaces provide a coordinate
C  system with reasonable properties (|J|>0 always) and a Fourier moments
C  representation, but the ones beyond the boundary are not real magnetic
C  surfaces!
C
C  The (rho,theta)->(R,Z) mapping is continuous but not differentiable
C  accross the plasma boundary; separate splines should be used for the
C  core plasma and vacuum regions.
C
C input:
C  symflag -- TRUE if input equilibrium is updown symmetric (even though
C             the moments arrays have slots for assymetric moment terms).
C
C  lcentr -- index to centermost surface (mag. axis point).
C            typically 1; 2 (TRCOM's LCENTR) when called from TRANSP.
C  nzones -- the number of flux zones in the plasma (the no. of surfaces
C            counting the mag. axis is nzones+1).
C
C  xiblo(..)  -- x grid for extrapolated space beyond plasma bdy
C  inbblo -- no. of points in use in extrapolated grid.
C  mtbl   -- max no. of grid pts (array dimension for xiblo, etc...)
C  mj     -- max no. of grid pts *inside plasma* (array dim for rmom0, etc.)
C
C  rmc(...) -- inside the plasma R moments
C  ymc(...) -- inside the plasma Y moments
C
C   caution:  dimension ordering follows TRANSP COMMON!
C
C  nmom   -- no. of Fourier moments in use
C  mimom  -- max no. of Fourier moments (array dimension)
C  nonlin -- LUN for writing error message
C
C output:
C
C   caution:  dimension ordering follows TRANSP COMMON!
C
C  rmcx(...) -- R moments (extrapolated grid)
C  ymcx(...) -- Y moments (extrapolated grid)
C
C  ierr -- status code: 0 = OK
C
C------------------------------------------------------------------
C
C============
C idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
C
C  passed items:
      INTEGER nzones,inbblo,mtbl,mj,nmom,mimom,nonlin,lcentr
C
      logical symflag
C
      REAL*8 xiblo(mtbl)
C
      REAL*8 rmc(mj,0:mimom,2),ymc(mj,0:mimom,2)
C
      REAL*8 rmcx(mtbl,0:mimom,2)
      REAL*8 ymcx(mtbl,0:mimom,2)
C
      integer ierr
C
C------------------------------------------------------------------
c
      include 'r8tkbparm.inc'
c
C------------------------------------------------------------------
C  local items:
C
      integer inzp1,inzp2,lcm1
      integer j,jzb,im,ics,jbx0,jbxm1,itk,jnext,jmax
      real*8 zshift
C
C  Axis:
      real*8 Rcen,Zcen
C  ThetaA(theta) -- monotonic increasing & invariant
      real*8 Theta(ntk+1),ThetaA(0:ntk+1),rcoef(ntk),zcoef(ntk)
C
C  axis to surface distance -- current surface & previous surface
C
      real*8 dist(ntk),distp(ntk),d_dist(ntk)
C
C  surface contour
      real*8 Rpts(ntk),Zpts(ntk)
C
C  average distance; average change in distance from prev. surface
      real*8 distav,d_distav
C
C  locally smoothed distance
C
      real*8 distsm(ntk)
C
      real*8, parameter :: c2pi = 6.2831853071795862D+00
      real*8, parameter :: cpi =  3.1415926535897931D+00
C
C  smoothing parameter (for distsm):
C
      real*8, parameter :: delsm = c2pi/25
C
C  current step, relative to bdy xiblo value
C
      real*8 delta_x
C
C  surface expansion controls
C
      real*8 alpha,beta,gamma,const
      real*8 afac(ntk),bfac(ntk),gfac(ntk),pfac(ntk)
C
      real*8, parameter :: ZERO = 0.0_R8
      real*8, parameter :: ONE = 1.0_R8
C
      real*8, parameter :: zdthmin = 0.0100_R8  ! min d(ThetaA)/d(Theta).
C
C  fft
C
      real*8 zs1d(ntk),zc1d(ntk)
C
      character*60 mnlab(3)
C
C------------------------------------------------------------------
C   surface expansion algorithm:
C     (A) theta lines extend straight out from the boundary, colinear
C         from a central point (Rcen,Zcen).
C     (B) each successive flux surface is extended from the prior
C         pair of surfaces such as to
C           0.  grow a set of well behaved nested surfaces out from
C               the plasma boundary. (const)
C           1.  reduce global variations in distance from (Rcen,Zcen)
C               towards an average value. (alpha)
C           2.  reduce global variations in spacing of successive
C               surfaces towards an average value. (beta)
C           3.  smooth out local variations in distance from (Rcen,Zcen).
C               (gamma)
C------------------------------------------------------------------
C   first copy the interior moments
C
C   NO. OF BDY'S INSIDE PLASMA; no. of zones PLUS 1
C
      INZP1=NZONES+1
      INZP2=NZONES+2
C
      LCM1=LCENTR-1
      jmax=inbblo+lcm1
C
      DO 60 J = 1, INZP1
         JZB=J+LCM1
         DO IM = 0, NMOM
            DO ICS = 1, 2
               RMCX(JZB,IM,ICS) = RMC(JZB,IM,ICS)
               YMCX(JZB,IM,ICS) = YMC(JZB,IM,ICS)
            enddo
         enddo
 60   CONTINUE
C
C  form & check theta arrays
C
C  boundary surface
      JBX0=INZP1+LCM1
C
      do itk=1,ntk
         Theta(itk)=(itk-1)*c2pi/ntk
      enddo
C
C  get a central point
C
      call get_RZcen(jbx0)
C
C  distance from point
C
      call get_RZdist(jbx0)
 
      zshift=0
      ierr=0
c
c  these items are computed just once at the plasma boundary surface...
c
      do itk=1,ntk
         ThetaA(itk)=atan2(Zpts(itk)-Zcen,Rpts(itk)-Rcen) + zshift
         Rcoef(itk)=(Rpts(itk)-Rcen)/dist(itk)
         Zcoef(itk)=(Zpts(itk)-Zcen)/dist(itk)
         if(itk.gt.1) then
            if(ThetaA(itk).lt.ThetaA(itk-1)-cpi) then
               ThetaA(itk)=ThetaA(itk) + c2pi
               zshift = zshift + c2pi
               if(zshift.gt.1.1_R8*c2pi) ierr=ierr+1
            endif
            if(ThetaA(itk).lt.ThetaA(itk-1)+zdthmin*c2pi/ntk) then
#ifdef __DEBUG
               write(6,*) itk-1,' dth=',thetaA(itk)-thetaA(itk-1), 
     >              ' min=',zdthmin*c2pi/ntk
#endif
               ierr=ierr+1
            endif
         endif
      enddo
      if(ThetaA(1).lt.ThetaA(ntk)-c2pi+zdthmin*c2pi/ntk) then
#ifdef __DEBUG
         write(6,*) ntk,' dth=',thetaA(1)-thetaA(ntk)-c2pi,
     >        ' min=',zdthmin*c2pi/ntk
#endif
         ierr=ierr+1
      endif
      ThetaA(0)=ThetaA(ntk)-c2pi
      ThetaA(ntk+1)=ThetaA(1)+c2pi
C
      if(ierr.ne.0) then
         ierr=99                        ! theta not monotonic
         return
      endif
C
      Theta(ntk+1)=Theta(1)+c2pi
C
cdbg      mnlab(1)='r8bloats0 debug plot'
cdbg      mnlab(2)=' '
cdbg      mnlab(3)='R(theta),Z(theta)'
cdbg      call r8_grafx2(theta,Rpts,Zpts,ntk,'radians','m or cm',
cdbg     >   mnlab(1),mnlab(2),mnlab(3))
C
cdbg      mnlab(3)='ArcTan[(Z(theta)-Zcen),(R(theta)-Rcen)] vs. theta'
cdbg      call r8_grafx2(theta,thetaA,theta,ntk,'radians','radians',
cdbg     >   mnlab(1),mnlab(2),mnlab(3))
C
C	DO THE EXTRAPOLATION INTO THE BLOATED ZONES
C
C  one inside from boundary surface
      JBXM1=JBX0-1
C  find intercepts of lines from axis to boundary with JBXM1 surface...
C
      call find_distm1(JBXM1)
C
C  for each surface...
C
      jnext=jbx0
C
ctmp      alpha=2.0_R8
ctmp      call ureadr8(' alpha (for <D>/D factor):$',alpha)
ctmp      alpha=max(0.0_r8,min(100.0_r8,alpha))
 
ctmp      beta=3.0_R8
ctmp      call ureadr8(' beta (for <D-Dprev>/(D-Dprev) factor):$',beta)
ctmp      beta=max(0.0_r8,min(100.0_r8,beta))
 
ctmp      gamma=2.0_R8
ctmp      call ureadr8(' gamma (for Dsm/D factor):$',gamma)
ctmp      gamma=max(0.0_r8,min(100.0_r8,gamma))
 
ctmp      const=1.0_R8
ctmp      call ureadr8(' growth constant:$',const)
ctmp      const=max(0.5_r8,min(2.0_r8,const))
C
      do
         jnext=jnext+1
         if(jnext.gt.jmax) exit
C
         delta_x=(xiblo(jnext)-xiblo(jnext-1))/
     >      (xiblo(jbx0)-xiblo(lcentr))
C
         d_dist = dist-distp
C
         call get_avdist
C
         call sm_dist
C
cdbg         mnlab(1)='r8bloats0 debug plot'; mnlab(2)=' '
cdbg         write(mnlab(2),1001) distav,d_distav
cdbg 1001    format('avg(dist)=',1pe11.4,', avg(d_dist)=',1pe11.4)
cdbg         mnlab(3)='dist,distp,distsm,d_dist'
cdbg         call r8_grafx4(theta,dist,distp,distsm,d_dist,ntk,
cdbg     >      'radians','m or cm',
cdbg     >      mnlab(1),mnlab(2),mnlab(3))
C
         do itk=1,ntk
            afac(itk)=distav/dist(itk)
            bfac(itk)=ONE
            gfac(itk)=distsm(itk)/dist(itk)
            pfac(itk)=afac(itk)*bfac(itk)*gfac(itk)
         enddo
C
cdbg         mnlab(2)=' '
cdbg         mnlab(3)='surface growth factors a,b,g, product'
cdbg         call r8_grafx4(theta,afac,bfac,gfac,pfac,ntk,
cdbg     >      ' ','m or cm',
cdbg     >      mnlab(1),mnlab(2),mnlab(3))
C
         do itk=1,ntk
            distp(itk)=dist(itk)
            dist(itk)=dist(itk)*(ONE+delta_x*pfac(itk))
            Rpts(itk)=Rcen+Rcoef(itk)*dist(itk)
            Zpts(itk)=Zcen+Zcoef(itk)*dist(itk)
         enddo
C
C  fft and then recompute distance
C
         call r8fftsc(Rpts, ntk, zs1d, zc1d, ierr)
         rmcx(jnext,0,1)=zc1d(1)/(2*ntk)
         do im=1,nmom
            rmcx(jnext,im,1) = zc1d(im+1)/ntk
            if(symflag) then
               rmcx(jnext,im,2) = ZERO
            else
               rmcx(jnext,im,2) = zs1d(im+1)/ntk
            endif
         enddo
 
         call r8fftsc(Zpts, ntk, zs1d, zc1d, ierr)
         if(symflag) then
            ymcx(jnext,0,1)=ZERO
         else
            ymcx(jnext,0,1)=zc1d(1)/(2*ntk)
         endif
         do im=1,nmom
            if(symflag) then
               ymcx(jnext,im,1) = ZERO
            else
               ymcx(jnext,im,1) = zc1d(im+1)/ntk
            endif
            ymcx(jnext,im,2) = zs1d(im+1)/ntk
         enddo
 
         call get_RZdist(jnext)         ! recompute from FFT expansion
 
      enddo
C
#ifdef __DEBUG
      mnlab=' '
      WRITE(MNLAB(1),8101)
 8101 FORMAT('r8bloata0 BLOAT SURFACE EXPANSION, final.')
      WRITE(MNLAB(2),8102) xiblo(jmax)
 8102 FORMAT('EXTRAPOLATION OF MHD SURFACE DATA, XImax=',1pe11.4)
      WRITE(MNLAB(3),8103)
 8103 FORMAT(1X,'(R,Y) BOUNDARY CONTOURS (MOMENTS EQUILIBRIUM)',14X)
      call r8_grfasym(rmcx,ymcx,mtbl,mimom,lcentr,jmax,nmom,
     >      'm or cm','m or cm',mnlab(1),mnlab(2),mnlab(3))
#endif
C
      RETURN
 
      contains
         !------------------------------------------------------------
         subroutine get_RZcen(jsurf)
 
            integer jsurf  ! surface where to get contour & distance profile
 
            Rcen=0; Zcen=0
            do itk=1,ntk
               call r8tkbmry(mtbl,jsurf,Theta(itk),rmcx,ymcx,mimom,nmom,
     >            Rpts(itk),Zpts(itk))
               Rcen=Rcen+Rpts(itk)
               Zcen=Zcen+Zpts(itk)
            enddo
            Rcen=Rcen/ntk
            Zcen=Zcen/ntk
 
         end subroutine get_RZcen
 
         !------------------------------------------------------------
         subroutine get_RZdist(jsurf)
 
            integer jsurf  ! surface where to get contour & distance profile
 
            do itk=1,ntk
               call r8tkbmry(mtbl,jsurf,Theta(itk),rmcx,ymcx,mimom,nmom,
     >            Rpts(itk),Zpts(itk))
               dist(itk)=sqrt((Rpts(itk)-Rcen)**2+(Zpts(itk)-Zcen)**2)
            enddo
 
         end subroutine get_RZdist
 
         !------------------------------------------------------------
         subroutine get_avdist
 
            real*8 zdth,zdthsum
            integer i
 
            distav=0
            d_distav=0
            zdthsum=0
 
            do i=1,ntk
               zdth=(ThetaA(i+1)-ThetaA(i-1))/2
               zdthsum=zdthsum+zdth
               distav=distav+dist(i)*zdth
               d_distav=d_distav+d_dist(i)*zdth
            enddo
            distav = distav/zdthsum
            d_distav = d_distav/zdthsum
 
         end subroutine get_avdist
 
         !------------------------------------------------------------
         subroutine find_distm1(jsurf)
 
            integer jsurf               ! surface where to get distances
 
c  find the intersection of the surface contour (jsurf) with the sequence
c  of line segments connecting the mag. axis to points on the boundary.
 
            real*8 rspl(4,ntk+1)
            real*8 zspl(4,ntk+1)
            real*8 wk(ntk+1)
 
            integer :: ibc = -1         ! periodic splines R(theta),Z(theta)
            real*8 :: zbc = 0.0_R8
 
            integer nn,ilinx
 
            integer, dimension(3) :: iselect = ( /1, 1, 0/ )
            real*8 rrv(3),zzv(3)        ! (R,dR/dtheta,-); (Z,dZ/dtheta,-)
 
            real*8 th                   ! (R(th),Z(th)) on line segment
            real*8 thp                  ! previous guess
            real*8 thn                  ! new guess, range not yet normalized.
 
            real*8 xR,xZ                ! vec perp {(Rbdy-Rcen),(Zbdy-Zcen)}
 
            real*8 f,dfdth
            !------------------------------------
 
            do itk=1,ntk
               call r8tkbmry(mtbl,jsurf,Theta(itk),rmcx,ymcx,mimom,nmom,
     >            Rspl(1,itk),Zspl(1,itk))
            enddo
 
            nn = ntk+1
            Rspl(1,nn)=Rspl(1,1)
            Zspl(1,nn)=Zspl(1,1)
 
            !  periodic splines R(theta), Z(theta)
            !  these describe the surface 1 zone width in from the
            !  boundary surface...
 
            call cspline(theta,nn,Rspl,ibc,zbc,ibc,zbc,wk,nn,ilinx,
     >         ierr)
            if(ierr.ne.0) call errmsg_exit('?cspline(Rspl) error.')
 
            call cspline(theta,nn,Zspl,ibc,zbc,ibc,zbc,wk,nn,ilinx,
     >         ierr)
            if(ierr.ne.0) call errmsg_exit('?cspline(Zspl) error.')
 
            do itk=1,ntk
               xR=-(Zpts(itk)-Zcen)
               xZ= (Rpts(itk)-Rcen)
 
               th = theta(itk)  ! initial guess (in range [theta(1),theta(nn)])
               thn = th         ! next guess (may be out of range)
               thp = c2pi*100   ! prev guess
               do
 
                  !  Newton search
 
                  call cspeval(th,iselect,rrv,theta,nn,ilinx,Rspl,
     >               ierr)
                  if(ierr.ne.0)
     >               call errmsg_exit('?cspeval(Rspl) error')
 
                  call cspeval(th,iselect,zzv,theta,nn,ilinx,Zspl,
     >               ierr)
                  if(ierr.ne.0)
     >               call errmsg_exit('?cspeval(Zspl) error')
 
                  if(abs(thn-thp).le.c2pi*1.0e-10_R8) exit
 
                  f=(rrv(1)-Rcen)*xR + (zzv(1)-Zcen)*xZ
                  dfdth = rrv(2)*xR + zzv(2)*xZ
 
                  thp=th
                  thn = th -f/dfdth
 
                  ! force new th in range, but save thn for comparision
 
                  if(thn.lt.theta(1)) then
                     th=thn+c2pi
                  else if(thn.gt.theta(nn)) then
                     th=thn-c2pi
                  else
                     th=thn
                  endif
 
               enddo
 
               distp(itk)=sqrt((Rcen-rrv(1))**2+(Zcen-zzv(1))**2)
            enddo
         end subroutine find_distm1
 
         !------------------------------------------------------------
         subroutine sm_dist
 
            real*8, dimension(:), allocatable :: dwk,tha
            integer iextnd,ilim1,ilim2,inum,i
 
            real*8, parameter :: zendc = 0.5_R8
 
            ! **quick** smooth of D(thetaA) data
 
            iextnd=ntk/2
            ilim1=1-iextnd
            ilim2=ntk+iextnd
            inum=ilim2-ilim1+1
 
            allocate(dwk(ilim1:ilim2),tha(ilim1:ilim2))
 
            tha(1:ntk)=thetaa(1:ntk)
            dwk(1:ntk)=dist(1:ntk)
            do i=1,iextnd
 
               tha(1-i)=tha(ntk+1-i)-c2pi
               tha(ntk+i)=tha(i)+c2pi
 
               dwk(1-i)=dwk(ntk+1-i)
               dwk(ntk+i)=dwk(i)
            enddo
 
            call r8_qksmooth(inum,tha,dwk, delsm, zendc,zendc, ierr)
            if(ierr.ne.0) call errmsg_exit('r8_qksmooth call error.')
 
            distsm(1:ntk)=dwk(1:ntk)
 
            deallocate(dwk,tha)
 
         end subroutine sm_dist
 
      END

!
! Return the Pfirsch-Schluter moments
!
! Below RHOMIN, the axis value is returned.
! The ZERROR argument returns the relative error of the moments
! sum = |sum(Fm) - <(n.grad(B))**2>/<B**2>| / max(<(n.grad(B))**2>/<B**2>)
!
! MOD DMC Feb 2008 -- used the new xplasma_psmom routine from xplasma2

subroutine eq_psmom(ivec, rho, rhomin, nmom, phi1, idmom, psmom, gamma, ngrdb2, b2, zerror, ier)

  use xplasma_obj_instance
  implicit NONE

  integer, intent(in) :: ivec       ! number of surfaces * sign(gamma)
  real*8,  intent(in) :: rho(abs(ivec))  ! radial coordinate
  real*8,  intent(in) :: rhomin     ! rho values below this are considered on axis
  integer, intent(in) :: nmom       ! number of moments to compute
  real*8,  intent(in) :: phi1       ! toroidal coordinate, same one used for all surfaces
  integer, intent(in) :: idmom      ! dimension of the psmom array

  real*8,  intent(out) :: psmom(idmom,abs(ivec))  ! PS moments
  real*8,  intent(out) :: gamma(abs(ivec))        ! wayne's gamma = 2*pi/integral_0_2pi[Bmod/B.grad(theta)]_dtheta
  real*8,  intent(out) :: ngrdb2(abs(ivec))       ! <(n.grad(B))**2>
  real*8,  intent(out) :: b2(abs(ivec))           ! <B**2>
  real*8,  intent(out) :: zerror(abs(ivec))       ! |sum(Fm) - <(n.grad(B))**2>/<B**2>| / max(<(n.grad(B))**2>/<B**2>)
  integer, intent(out) :: ier                ! nonzero on error

  !----------------------

  integer :: is    ! sign of argument chi, this was ichi_ccw but now ichi_ccw=+1 to reflect the storage in xplasma

  integer :: iveca ! abs(ivec)
  !----------------------
  iveca=abs(ivec)

  is=1
  if(ivec.lt.0) is=-1

  if(nmom.gt.idmom) then
     call eq_errmsg('eq_psmom: nmom exceeds array dimension (idmom).')
     ier=99
     return
  endif

  call xplasma_psmom(s, &
       rho,rhomin,psmom(1:nmom,1:iveca),gamma,ngrdb2,b2,zerror, &
       ier)

  if(ier.ne.0) then
     call eq_errmsg('eq_psmom: error in xplasma_psmom:')
  else
     gamma(1:iveca)  = is*gamma(1:iveca)
  endif

end subroutine eq_psmom

subroutine eqm_save_psi0(psi0,ierr)

  ! store Psi0 -- EFIT Psi offset, mag. axis to machine axis

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  real*8, intent(in) :: psi0        ! Psi0 value, Wb/rad
  integer, intent(out) :: ierr      ! error status code; 0=OK

  !----------------------
  integer :: iertmp
  !----------------------

  call xoi_author_set(ierr)
  if(ierr.ne.0) return

  call xplasma_save_psi0(s,psi0,ierr)

  call xoi_author_clear(iertmp)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqm_save_psi0: error detected in xplasma: '
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eqm_save_psi0

subroutine eqi_nlimitr(zpath,inlim,ierr)

  !  read EFIT data; return the number of points in the [R,Z] axisymmetric
  !  limiter contour

  use eqi_geq_mod
  implicit NONE

  character*(*), intent(in) :: zpath   ! path to G-eqdsk file or MDS+ tree
  integer, intent(out) :: inlim  ! #pts in limiter contour
  integer, intent(out) :: ierr   ! status code, 0=OK

  !----------------
  
  inlim = 0

  call geq_init(geq,zpath,ierr)
  if(ierr.ne.0) return

  inlim = geq%limitr

end subroutine eqi_nlimitr

subroutine eqi_geq_mds_psimin(ns,lmask,zz,dpsidz,idum,rzin,id1,rout,id2)
 
  use eqi_geq_mds_mod
  implicit NONE
  integer, parameter :: r8=selected_real_kind(12,100)
 
  !
  ! rootfinder (zriddery) subroutine -- 
  !    find minimum Psi location
  !    by finding d(psi)/dZ=0 where the derivative is taken
  !    at a location where d(psi)/dR=0 along some line Z=const=(zz)
  !
  ! z0 and psi spline, are all in eqi_geq_mds_mod
  !
  !------------------------------ passed
 
  integer, intent(in) :: ns        ! no. of surfaces
  logical, intent(in) :: lmask(ns) ! mask surfaces where soln is known
 
  real(r8), intent(in) :: zz(ns)   ! Z value to try now
 
  real(r8), intent(out) :: dpsidz(ns) ! d(psi)/dZ returned
 
  integer, intent(in) :: idum,id1,id2
 
  real(r8), intent(in) :: rzin(ns,id1) ! range of R variation to try; tolerance
 
  real(r8), intent(out) :: rout(ns,id2) ! {R,err} returned
 
  !------------------------------ local
 
  real(r8) rr1,rr2,rr_out,tol,tolf,zerr(1),dpsidy(1)
  integer ifail,jfail
  external eqi_geq_mds_psiminr

  !------------------------------ executable code
 
  if(ns.ne.1) then
     rout(:,2)=1
     rout(:,1)=0
     dpsidz=0
     return
  endif

  z0=zz(1)  ! now will look for d(Psi)/dR=0 along Z=z0...
  rr1=rzin(1,1)-rzin(1,2)  ! min R to look at
  rr2=rzin(1,1)+rzin(1,2)  ! max R to look at
  tol=rzin(1,3)
  tolf=rzin(1,4)

  !  dpsidz will also be evaluated...
  
  call zridderx(ns,lmask,rr1,rr2,tol,tolf,eqi_geq_mds_psiminr,rr_out,ifail, &
       1,zerr,1,dpsidy,1)
  jfail=abs(zerr(1))+0.5_R8

  if((ifail.ne.0).or.(jfail.ne.0)) then
     rout(:,2)=1
     rout(:,1)=0
     dpsidz=0
  else
     rout(:,2)=0
     rout(:,1)=rr_out
     dpsidz=dpsidy(1)
  endif
  
  return
end subroutine eqi_geq_mds_psimin

!******************** START FILE WXCINT.FOR ; GROUP FILTR6 ******************
!
!  WXCINT
!
!  COMPUTE C*INTEGRAL OF WEIGHTING FUNCTION FROM X1 TO X2
!
!  DENOMINATOR IN WEIGHTED AVERAGE FORMULA
!
!  W(T)=1-ABS((XCEN-T)/DELTA)   XCEN-DELTA .LE. T .LE. XCEN+DELTA
!
!  TRIANGULAR SHAPED WEIGHTING FUNCTION CENTERED AT XCEN
!    X1 SHOULD BE .LT. X2 AND X1 AND X2 SHOULD
!    BE WITHIN DELTA OF XCEN
!
REAL(fp) FUNCTION r8WXCINT(X1,X2,C,XCEN,DELTA)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: ZERO, HALF, ONE
  implicit none
  ! Arguments
  real(fp), intent(in) :: x1, x2, c
  real(fp), intent(in) :: xcen
  real(fp), intent(in) :: delta
  ! Local variables
  real(fp) :: xa, xb, zdi
  !
  r8wxcint=C
  XA=max(-DELTA,(X1-XCEN))
  XB=min(DELTA,(X2-XCEN))
  IF((XA.GT.DELTA).OR.(XB.LT.-DELTA)) GO TO 1000
  IF(XB.LT.XA) GO TO 1000
  !
  !  NUMERICS CHECK; DELTA <<< X1
  IF(XCEN.EQ.(XCEN+DELTA)) RETURN
  !
  ZDI=ONE/DELTA
  IF((XA.GT.ZERO).OR.(XB.LT.ZERO)) GO TO 100
  !
  r8wxcint=C*ZDI*((XB-XA)-HALF*(XA*XA+XB*XB)*ZDI)
  RETURN
  !
100 CONTINUE
  IF(XA.GT.ZERO) r8wxcint=C*ZDI*((XB-XA)-HALF*(XA+XB)*(XB-XA)*ZDI)
  IF(XB.LT.ZERO) r8wxcint=C*ZDI*((XB-XA)-HALF*(XA+XB)*(XA-XB)*ZDI)
  RETURN
  !
1000 CONTINUE
  write(6,9000)
9000 FORMAT(' SUBROUTINE WXCINT FROM R8FILFN6 FROM R8FILTR6.FOR:'/ &
          ' ILLEGAL INTEGRATION LIMITS')
  call flush(6)
  stop
END FUNCTION R8WXCINT

subroutine eqi_rzsmedR(R,inumR,Z,inumZ,fdata,zsm)

  !  smooth in R direction, in edge vicinity (see eqi_rzsmedg.for).

  use xplasma_definitions
  use eqi_rzbox_module

  implicit NONE

  integer inumR,inumZ
  real*8 R(inumR),Z(inumZ)
  real*8 fdata(inumR,inumZ)
  real*8 zsm

  !-----------------------------

  real*8 eps(inumR),del(inumR),f(inumR),fsm(inumR),zwkZ(inumR)
  real*8 dist(inumR)

  real*8 zdista,zdum,zdum2

  integer iR,iZ,ict,idum1,idum2,iertmp

  real*8, parameter :: HALF = 0.5d0
  real*8, parameter :: C3OV2= 1.5d0
  real*8, parameter :: zbc = HALF

  !-----------------------------

  eps=1.0d30
  del=0.0d0

  do iZ=1,inumZ
     zwkZ=Z(iZ)
     call xplasma_bdfind(sp,inumR,R,ZwkZ,iertmp, &
          maptype=3,dist=dist)

     ict=0
     do iR=1,inumR
        zdista=abs(dist(iR))
        if(zdista.le.HALF*zsm) then
           ict=ict+1
           del(iR)=zsm
        else if(zdista.lt.C3OV2*zsm) then
           ict=ict+1
           del(iR)=C3OV2*zsm-zdista
        endif
     enddo

     if(ict.gt.0) then

  !  something to smooth

        f=fdata(1:inumR,iz)
        call r8filtr6(R,f,fsm,inumR,eps,inumR,eps,0,del, &
             0,zdum,0,zdum,zbc,zbc,zdum2,idum1,idum2)
        fdata(1:inumR,iZ)=fsm

     endif
  enddo

end subroutine eqi_rzsmedR

subroutine fluxav_nzones_get(nthzones,nzones)

  !  get number of poloidal and radial zones in current f77 xplasma integrator

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(out) :: nthzones,nzones

  !----------------------------------
  integer :: idi,ierr,inum,inumth
  !----------------------------------

  nthzones=0
  nzones=0

  call xplasma_find_item(s,"__F77_INTEGRATOR_2D",idi,ierr,nf_noerr=.TRUE.)

  if(idi.eq.0) then
     call xplasma_find_item(s,"__F77_INTEGRATOR_1D",idi,ierr,nf_noerr=.TRUE.)

     if(idi.eq.0) then
        write(lunerr,*) ' ?fluxav_nzones_get: no F77 integrator found; call eq_flxint first.'

     else
        call xplasma_integ_info(s,idi,ierr,n_rho_int=inum)
        if(ierr.eq.0) then
           nthzones=1
           nzones=inum-1
        endif
     endif

  else

     call xplasma_integ_info(s,idi,ierr, n_rho_int=inum, n_th_int=inumth)
     if(ierr.eq.0) then
        nthzones=inumth-1
        nzones=inum-1
     endif

  endif

  if(ierr.ne.0) then

     write(lunerr,*) ' ?fluxav_nzones_get: unexpected error ierr=',ierr
     call xplasma_error(s,ierr,lunerr)

  endif

end subroutine fluxav_nzones_get

subroutine fluxav_nsurfs_get(nthzones,nsurfs)

  !  get number of poloidal zones and radial surfaces in current f77 
  !  xplasma integrator

  implicit NONE

  integer, intent(out) :: nthzones,nsurfs

  call fluxav_nzones_get(nthzones,nsurfs)
  if(nthzones.gt.0) nsurfs = nsurfs + 1

end subroutine fluxav_nsurfs_get

      subroutine eqi_rzxvec(ivec,zR,zZ,zphi,ibflg,bvec,gbtensr,
     >   nlist,ivecd,fvals,fgrads)
C
C  transform [B] and grad[B] and list of scalar functions f and grad(f)
C  from (R,Z,phi) coordinates to (x,y,z) coordinates
C
C    x = R*cos(phi)
C    y = R*sin(phi)
C    z = Z
C
C  grad in (R,Z,phi) is (d/dR,d/dZ,(1/R)d/dphi)
C  grad in (x,y,z)   is (d/dx,d/dy,d/dz)
C
      implicit NONE
C
      integer ivec                      ! vector dimensioning
      real*8 zR(ivec),zZ(ivec),zphi(ivec) ! input coordinates
C
      integer ibflg                     ! flag =1 to transform B
      real*8 bvec(3,ivec)               ! B vector to transform
      real*8 gbtensr(3,3,ivec)          ! grad[B] tensor to transform
C
      integer nlist                     ! number of scalar functions (0 OK)
      integer ivecd                     ! output vector dimensioning
      real*8 fvals(ivecd,*)             ! function values
      real*8 fgrads(3,ivecd,*)          ! function gradients
C
      real*8, parameter :: CZERO = 0.0d0
C
C----------------------------------------------
C
      real*8 gradphi(3),gradBR(3),gradBphi(3),gradBZ(3)
      real*8 tmp(3),btmp(3),zcosphi,zsinphi
      integer i,j
C
C----------------------------------------------
C  scalar function values are correct and do not need to be transformed...
C
 
      do i=1,ivec
         zcosphi=cos(zphi(i))
         zsinphi=sin(zphi(i))
C
C  transform gradients of functions
C
         do j=1,nlist
            tmp(3)=fgrads(2,i,j)
            tmp(1)=fgrads(1,i,j)*zcosphi -fgrads(3,i,j)*zsinphi
            tmp(2)=fgrads(1,i,j)*zsinphi +fgrads(3,i,j)*zcosphi
            fgrads(1:3,i,j)=tmp
         enddo
C
         if(ibflg.eq.1) then
C
C  transform B field
C
            btmp(3)=bvec(2,i)
            btmp(1)=bvec(1,i)*zcosphi -bvec(3,i)*zsinphi
            btmp(2)=bvec(1,i)*zsinphi +bvec(3,i)*zcosphi
C
C  transform grad[B]
C
C  grad(Bz):
            gradBZ(3)=gbtensr(2,2,i)
            gradBZ(1)=gbtensr(1,2,i)*zcosphi -gbtensr(3,2,i)*zsinphi
            gradBZ(2)=gbtensr(1,2,i)*zsinphi +gbtensr(3,2,i)*zcosphi
C
C  grad(Bx) and grad(By):  first get grad(phi),grad(BR),grad(BZ)
C                          in x-y-z form
C
            if(zR(i).ne.czero) then
               gradphi(1)= -zsinphi/zR(i)
               gradphi(2)=  zcosphi/zR(i)
            else
               gradphi(1)= CZERO
               gradphi(2)= CZERO
            endif
C
            gradphi(3)=  CZERO
C
            gradBR(3)=gbtensr(2,1,i)
            gradBR(1)=gbtensr(1,1,i)*zcosphi -gbtensr(3,1,i)*zsinphi
            gradBR(2)=gbtensr(1,1,i)*zsinphi +gbtensr(3,1,i)*zcosphi
C
            gradBphi(3)=gbtensr(2,3,i)
            gradBphi(1)=gbtensr(1,3,i)*zcosphi -gbtensr(3,3,i)*zsinphi
            gradBphi(2)=gbtensr(1,3,i)*zsinphi +gbtensr(3,3,i)*zcosphi
C
C  grad(Bz):
            gbtensr(1:3,3,i)=gradBZ
C
C  grad(Bx):
            gbtensr(1:3,1,i)=gradBR*zcosphi - bvec(1,i)*zsinphi*gradphi
     >         - gradBphi*zsinphi - bvec(3,i)*zcosphi*gradphi
C
C  grad(By):
            gbtensr(1:3,2,i)=gradBr*zsinphi + bvec(1,i)*zcosphi*gradphi
     >         + gradbphi*zcosphi - bvec(3,i)*zsinphi*gradphi
C
C  and store vector Bx,By,Bz
C
            bvec(1:3,i)=btmp
C
         endif
      enddo
C
      return
      end

!******************** START FILE MFALSI.FOR ; GROUP MFALSI ******************
!
!	THIS PROGRAM USES A MODIFIED MFALSI METHOD TO FIND
!	A ROOT OF THE FUNCTION F(X), GIVEN TWO GUESSES, X1 AND
!	X2. THE REQUIRED ACCURACY IN X IS GIVEN AS DX
!	THE ATTAINED ACCURACY IN OUTPUT AS ERR
!	IF A SPECIFIED NUMBER OF LOOPS IS EXCEEDED, THE PROGRAM
!	OUTPUTS WHAT IT HAS, AND TYPES THE ESTIMATED ERROR
!
!	NOTE THAT X1 AND X2 COME BACK AS THE LAST TWO GUESSES, WHICH
!	MAY BE USEFUL FOR REPEATED CALLS TO MFALSI WITH ONLY SLIGHTLY
!	CHANGED VERSIONS OF F
!
!	ROB GOLDSTON    AUG. 22, 1983
!
!  MODIF D. MC CUNE 21 DEC 1983
!    ADOPTED AS A SUBROUTINE OF THE TRANSP MAGDIF SYSTEM
!  FOR FINDING THE ZEFF WHICH PRODUCES
!  A SURFACE VOLTAGE MATCHING THE MEASURED DATA.
!    DIFFERENCES FROM THE ORIGINAL [GOLD]FALSI.FOR:
!  ONLY ONE INITIAL GUESS IS REQUIRED.  THE EXTERNAL SUBROUTINE F
!  SUPPLIES INFORMATION NEEDED TO GENERATE THE NEXT GUESS, OR DECIDE
!  THAT THE FIRST GUESS WAS SUFFICIENTLY ACCURATE.
!
!  COMMENT DMC 3 JAN 1984--
!    MFALSI IS ALSO USED BY THE EFIELD ROUTINES TO FIND THE ZEFF WHICH
!  RESULTS IN THE CORRECT PLASMA CURRENT, GIVEN A GUESS AT THE VOLTAGE
!  PROFILE
!
!  dmc Jun 1997:  EXPERT calls removed.  TRCOM has been removed.
!
!    ADDITIONAL ARGUMENTS XMIN,XMAX,LUN1,LUN2,DF
!
!    ARGUMENTS ROOT AND ICNT ARE DELETED (THE EXTERNAL SUBROUTINE
!  STORES THE FINAL ROOT IN TRANSP COMMON)
!
!    THE ERRORS "TOO MANY ITERATIONS" AND "ROOT HEADED TO INFINITY"
!  ARE MADE FATAL; THE WARNING ERROR THAT THE ROOT WANTS TO BE OUTSIDE
!  THE RANGE XMIN TO XMAX IS ADDED
!    THE REQUIRED ACCURACY DX IS MADE RELATIVE-- THE X'S (ZEFF'S) ARE
!  ALWAYS .GT. ZERO  (XMIN HAD BETTER BE .GT. 0)
!    THE ABSOLUTE ERROR DF IS ADDED-- SINCE F IS AN "ERROR" FUNCTION,
!  IF ABS(F).LT.DF THEN SKIP THE FALSI LOOP
!
SUBROUTINE scrMFALSI(F,X1,DF,DX,XMIN,XMAX,LPMAX,LUN1,LUN2,ZSTAT)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, one, two
  implicit none
  real(fp) :: dx
  real(fp) :: root
  real(fp) :: err
  integer :: lun2
  integer :: lun1
  integer :: lpmax
  real(fp) :: zsign
  real(fp) :: f2
  real(fp) :: x2
  real(fp) :: zinc
  real(fp) :: zinc2
  real(fp) :: zinc1
  real(fp) :: df
  real(fp) :: fmeas
  real(fp) :: f
  real(fp) :: f1
  real(fp) :: xmaxm
  real(fp) :: xminp
  real(fp) :: xmin
  real(fp) :: xmax
  real(fp) :: xrange
  real(fp) :: x1
  real(fp) :: xsave
  real(fp) :: zstat
  integer :: iminc
  integer :: imaxc
  integer :: icnt
  EXTERNAL F
  !
  !  INPUT THROUGH SUBROUTINE ARGUMENT
  !  =================================
  !
  !	F		NAME OF SUBFUNCTION WHOSE ROOT IS TO BE FOUND
  !			  IT MUST BE DECLARED EXTERNAL IN MAIN PROG
  !	DF		IF ABS(F).LT.DF SKIP THE FALSI LOOP
  !
  !	X1		ONE GUESS AS CLOSE TO ROOT AS POSSIBLE
  ! DELETED	X2		ANOTHER GUESS
  !	DX		REQUIRED RELATIVE ACCURACY IN THE ROOT FOUND
  !	XMIN		MINIMUM ALLOWED ROOT (WARNING IF HIT)
  !	XMAX		MAXIMUM ALLOWED ROOT (WARNING IF HIT)
  !	LPMAX		MAXIMUM NUMBER OF PERMITTED ITERATIONS
  !	LUN1		ERROR OUTPUT CHANNEL
  !	LUN2		2nd ERROR OUTPUT CHANNEL (optional, 0 to disable)
  !
  !  OUTPUT THROUGH SUBROUTINE CALLING ARGUMENT
  !  ==========================================
  !
  !               ZSTAT           FLOATING PT ERROR CODE (FOR TRANSP
  !                               PLOTTING OUTPUT)
  !                   =0.0 IS NORMAL-- ROOT FOUND
  !                   =1.0 MEANS A ROOT LIMIT (MIN OR MAX) WAS HIT
  !                   =2.0 MEANS A SINGULARITY (FLAT SPOT OR LOCAL
  !                        MIN- OR MAXIMUM) WAS ENCOUNTERED, AND THE
  !                        1ST GUESS PASSED TO THIS ROUTINE IS RETURNED
  !                        AS THE "ROOT".
  !
  ! DELETED	ROOT		THE ROOT WHICH HAS BEEN FOUND
  ! DELETED	ERR		ABSOLUTE DIFFERENCE BETWEEN LAST TWO GUESSES
  !
  !
  ICNT=0
  !
  !  EXCEEDED-LIMIT COUNTERS
  !
  IMAXC=0
  IMINC=0
  !
  !  SET DEFAULT STATUS = OK
  !
  ZSTAT=zero
  !
  !  SAVE INITIAL GUESS IN CASE OF PROBLEMS ...
  !
  XSAVE=X1
  !
  !  TO AVOID SOME ARCANE BUGS IT IS NECESSARY TO BIND THE INITIAL
  !  GUESSES AWAY FROM THE ROOT EXTREMA
  !
  XRANGE=XMAX-XMIN
  XMINP=XMIN+.01_fp*XRANGE
  XMAXM=XMAX-.01_fp*XRANGE
  X1=MAX(XMINP,MIN(XMAXM,X1))
  !
  !  PROCESS INITIAL GUESS
  !
  F1=F(X1,FMEAS)
  !
  IF(ABS(F1).LT.DF) THEN
    RETURN
  ENDIF
  !
  !  INITIAL GUESS NOT GOOD ENOUGH, TRY ANOTHER GUESS.
  !   F GIVES (MEASURED VOLTAGE - CALCULATED VOLTAGE)
  !   FMEAS GIVES MEASURED VOLTAGE
  !
  !   IF F IS SAME SIGN AS FMEAS TRY A 5% HIGHER VALUE FOR ZEFF (X)
  !   IF F IS OPPOSITE SIGN TRY A 5% LOWER VALUE FOR ZEFF (X)
  !     BUT TRY THE OTHER WAY IF A LIMIT IS ENCOUNTERED
  !
  ZINC1=.1_fp*XRANGE
  ZINC2=.05_fp*ABS(X1)
  ZINC=MIN(ZINC1,ZINC2)
  IF(ZINC.EQ.zero) ZINC=ZINC1
  IF((F1*FMEAS).GE.zero) THEN
    X2=X1+ZINC
    IF(X2.GT.XMAXM) X2=X1-ZINC
  ELSE
    X2=X1-ZINC
    IF(X2.LT.XMINP) X2=X1+ZINC
  ENDIF
  !
  IF(ABS(X2).LT.1.e-30_fp) X2=one
  !  2ND GUESS...
  F2=F(X2,FMEAS)
  !
  !  RECORD SIGN OF SLOPE
  !
  ZSIGN=SIGN(one,((F2-F1)/(X2-X1)))
  !
  !  ITERATIONS
  !
100 CONTINUE
  !
  ICNT=ICNT+1
  !
  !.......ESCAPE FROM INFINITE LOOP
  IF(ICNT.GT.LPMAX) THEN
    WRITE(LUN1,105) LPMAX
    if(lun2.gt.0) WRITE(LUN2,105) LPMAX
105 FORMAT(' MAXIMUM LOOP NUMBER =',I10,' EXCEEDED IN MFALSI')
    ERR=ABS(X1-X2)
    WRITE(LUN1,107) ERR,DX
    if(lun2.gt.0) WRITE(LUN2,107) ERR,DX
107 FORMAT(' ESTIMATED ERROR =',E8.3,' target error was: ',e8.3)
    zstat=3.0
    return
  ENDIF
  !
  !
  !.......ESCAPE FROM PROBLEM SITUATION
  !
  IF(F1.EQ.F2) THEN
    ZSTAT=two
  ELSE IF(SIGN(one,((F2-F1)/(X2-X1))).NE.ZSIGN) THEN
    ZSTAT=two
  ENDIF
  IF(ZSTAT.EQ.two) THEN
    WRITE(LUN1,110) ZSIGN,X1,F1,X2,F2
    if(lun2.gt.0) WRITE(LUN2,110) ZSIGN,X1,F1,X2,F2
110 FORMAT(' ? MFALSI ABORTED SEEKING ROOT OF FUNCTION F WITH ', &
         'SINGULARITY.  INITIAL 2 GUESSES GAVE SIGN(SLOPE)= ',1PE9.2, &
         'BUT:'/'   F(',1PE11.4,')=',1PE11.4/ &
         '   F(',1PE11.4,')=',1PE11.4)
    F1=F(XSAVE,FMEAS)
    RETURN
  ENDIF
  !
  ROOT=(F1*X2-F2*X1)/(F1-F2)
  !
  !  CHECK LIMITS
  !   A LIMIT MUST BE EXCEEDED TWICE CONSECUTIVELY FOR AN ABNORMAL EXIT
  !    (THIS ALLOWS MFALSI TO BOUNCE OFF THE WALL ONCE AND RECOVER)
  !
  IF(ROOT.GT.XMAX) THEN
    IMAXC=IMAXC+1
    IF(IMAXC.GE.2) GO TO 800
    ROOT=XMAX
  ELSE
    !  OK, CLEAR COUNTER
    IMAXC=0
  ENDIF
  !
  IF(ROOT.LT.XMIN) THEN
    IMINC=IMINC+1
    IF(IMINC.GE.2) GO TO 850
    ROOT=XMIN
  ELSE
    !  OK, CLEAR COUNTER
    IMINC=0
  ENDIF
  !
  IF(ABS(ROOT-X2).LT.ABS(ROOT-X1)) THEN
    X1=ROOT
    F1=F(X1,FMEAS)
  ELSE
    X2=ROOT
    F2=F(X2,FMEAS)
  ENDIF
  !
  !.......CHECK FOR CONVERGEANCE
  IF(ABS(X1-X2).GT.DX) GOTO 100
  !
  !  EXIT
  !
200 CONTINUE
  !
  RETURN
  !
  !  ABNORMAL EXITS (ROOT LIMITS EXCEEDED)--
  !
800 CONTINUE
  !
  !  EXCEEDED MAXIMUM
  !
  WRITE(LUN1,801) ROOT,XMAX
  if(lun2.gt.0) WRITE(LUN2,801) ROOT,XMAX
801 FORMAT(' % MFALSI WARNING-- MAXIMUM ROOT EXCEEDED:'/ &
         '  ROOT=',1PE11.4,'  MAX=',1PE11.4)
  F1=F(XMAX,FMEAS)
  ZSTAT=one
  RETURN
  !
  !  LESS THAN MINIMUM
  !
850 CONTINUE
  !
  WRITE(LUN1,851) ROOT,XMIN
  if(lun2.gt.0) WRITE(LUN2,851) ROOT,XMIN
851 FORMAT(' % MFALSI WARNING-- BELOW MINIMUM ROOT:'/ &
         '  ROOT=',1PE11.4,'  MIN=',1PE11.4)
  F1=F(XMIN,FMEAS)
  ZSTAT=one
  RETURN
!
END SUBROUTINE scrMFALSI

subroutine mcgrid_argcheck(subname,ist_th,ist_ph,iextend,ierr)
 
  ! partial argument checker for mcgrid_get/putobj subroutines

  use xplasma_obj_instance
  use eq_module

  implicit NONE

  character*(*), intent(in) :: subname

  integer, intent(in) :: ist_th,ist_ph,iextend
  integer, intent(out) :: ierr

  !---------------------------------------------------------

  ierr = 0

  if((iextend.ne.0).and.(iextend.ne.1)) then
     write(lunerr,*) ' ?'//trim(subname)//':  iextend = ',iextend
     write(lunerr,*) &
          '  legal values are 0 (inside plasma) and 1 (inside and outside).'
     ierr=1
  endif
 
  if((ist_th.ne.0).and.(ist_th.ne.-1)) then
     write(lunerr,*) ' ?'//trim(subname)//':  theta start parameter ist_th = ',ist_th
     write(lunerr,*) &
          '  legal values are 0 (start at 0) and -1 (start at -pi)'
     ierr=1
  endif
 
  if((ist_ph.ne.0).and.(ist_ph.ne.-1)) then
     write(lunerr,*) ' ?'//trim(subname)//':  theta start parameter ist_ph = ',ist_ph
     write(lunerr,*) &
          '  legal values are 0 (start at 0) and -1 (start at -pi)'
     ierr=1
  endif

end subroutine mcgrid_argcheck

      SUBROUTINE MCRDR_RDSS2(LUN,LINE,SUBSTR1,SUBSTR2,IN1,IN2,IEOF)
C
C  READ TO FIRST LINE CONTAINING EITHER OF TWO
C   SUBSTRINGS; EOF CHECK
C
      CHARACTER*(*) LINE
      CHARACTER*(*) SUBSTR1,SUBSTR2
C
      IEOF=0
 10   CONTINUE
      CALL MCRDR_READ(LUN,LINE,IEOF)
      IF(IEOF.EQ.1) GO TO 20
C
      IN1=INDEX(LINE,SUBSTR1)
      IN2=INDEX(LINE,SUBSTR2)
      IF((IN1.EQ.0).AND.(IN2.EQ.0)) GO TO 10
C
 20   CONTINUE
C
      RETURN
      END

      subroutine eq_ffget(ivec,zrho,zchi,zphi,nlist,ifcns,
     >   ivecd,fvals,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated functions f @ (rho,chi,phi)
c        ivec < 0 indicates reversed chi
c
      implicit NONE
c input:
      integer ivec                      ! vector dimensioning
      real*8 zrho(abs(ivec)),zchi(abs(ivec)),zphi(abs(ivec)) ! (rho,chi,phi) target coords
c
      integer nlist                     ! no. of fcns in list
      integer ifcns(nlist)              ! xplasma fcn ids, functions wanted.
c
      integer ivecd                     ! output vector dimension
c
c output:
      real*8 fvals(ivecd,nlist)         ! the functions values returned
      integer nregion(abs(ivec))             ! region code, 1= inside core
c
      integer ierr                      ! completion code, 0=OK
c
c--------------------------
c
      real*8 zR(abs(ivec)),zZ(abs(ivec))
c
c--------------------------
c
      call eqmap_ffget(ivec,zrho,zchi,zphi,zR,zZ,nlist,ifcns,ivecd,
     >   fvals,nregion,ierr)
c
      return
      end
c---------------------------------------------------------------------
      subroutine eq_ffgrad(ivec,zrho,zchi,zphi,irzmode,nlist,ifcns,
     >   ivecd,fvals,fgrads,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated functions f @ (rho,chi,phi)
c        ivec < 0 indicates reversed chi
c  get gradient of f
c     if irzmode=1:  (df/dR,df/dZ,(1/R)*df/dphi) @ (rho,chi,phi)
c     if irzmode=0:  (df/dsperp,df/dschi,(1/R)*df/dphi) @ (rho,chi,phi)
c          where sperp = dl in direction normal to flux surface,
c                schi  = dl in chi direction, normal to phi & tangent
c                           to flux surface
c
      implicit NONE
c input:
      integer ivec                      ! vector dimensioning
      real*8 zrho(abs(ivec)),zchi(abs(ivec)),zphi(abs(ivec)) ! (rho,chi,phi) target coords
c
      integer irzmode                   ! =1: grad. vector in cyl coords.
c
      integer nlist                     ! no. of fcns wanted
      integer ifcns(nlist)              ! xplasma fcn ids, functions wanted.
c
      integer ivecd                     ! output vector dimension
c
c output:
      real*8 fvals(ivecd,nlist)         ! the functions values returned
      real*8 fgrads(3,ivecd,nlist)      ! the functions gradients returned
      integer nregion(abs(ivec))             ! region code, 1=inside core
c
      integer ierr                      ! completion code, 0=OK
c
c--------------------------
c
      real*8 zR(abs(ivec)),zZ(abs(ivec))
c
c--------------------------
c
      call eqmap_ffgrad(ivec,zrho,zchi,zphi,zR,zZ,irzmode,nlist,ifcns,
     >   ivecd,fvals,fgrads,nregion,ierr)
c
      return
      end
C--------------------------------------------------------------------
      subroutine eqmap_ffget(ivec,zrho,zchi,zphi,zR,zZ,
     >   nlist,ifcns,ivecd,fvals,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated functions f @ (rho,chi,phi)
c        ivec < 0 indicates reversed chi
c
c  also return (R,Z) of target points
c
      IMPLICIT NONE
c
c  input:
      integer ivec                      ! vector dimensioning
      real*8 zrho(abs(ivec)),zchi(abs(ivec)),zphi(abs(ivec)) ! (rho,chi,phi) target coords
c
      integer nlist                     ! no. of fcns in list
      integer ifcns(nlist)              ! xplasma fcn ids, functions wanted.
c
      integer ivecd                     ! output vector dimension
C
C  output:
      real*8 zR(abs(ivec)),zZ(abs(ivec))          ! (R,Z) of target points
      REAL*8 fvals(ivecd,nlist)         ! functions value
C
      integer nregion(abs(ivec))             ! region code for (R,Z,phi) 1=inside
      integer ierr                      ! completion code, 0=OK
C
C--------------------------
C
      integer imap
      REAL*8 zdum,ztol
      REAL*8 fgrads(3,abs(ivec),nlist)       ! (R,Z,phi) gradient of f
      integer iveca
      logical ccwflag
C
C--------------------------
C
      ztol=0.0d0
      imap=2
      iveca=abs(ivec)
      ccwflag = ivec.gt.0
c
      call eqi_getall(iveca,ccwflag,zR,zZ,zphi,imap,zrho,zchi,ztol,0,
     >   0,zdum,zdum,nlist,ifcns,ivecd,fvals,fgrads,
     >   nregion,ierr)
C
      return
      end
C--------------------------------------------------------------------
      subroutine eqmap_ffgrad(ivec,zrho,zchi,zphi,zR,zZ,irzmode,
     >   nlist,ifcns,ivecd,fvals,fgrads,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated functions f @ (rho,chi,phi)
c        ivec < 0 indicates reversed chi
c  get gradient of f
c     if irzmode=1:  (df/dR,df/dZ,(1/R)*df/dphi) @ (rho,chi,phi)
c     if irzmode=0:  (df/dsperp,df/dschi,(1/R)*df/dphi) @ (rho,chi,phi)
c          where sperp = dl in direction normal to flux surface,
c                schi  = dl in chi direction, normal to phi & tangent
c                           to flux surface
c
c  also return (R,Z) of target points
c
      IMPLICIT NONE
c
c  input:
      integer ivec                      ! vector dimensioning
      real*8 zrho(abs(ivec)),zchi(abs(ivec)),zphi(abs(ivec)) ! (rho,chi,phi) target coords
c
      integer irzmode                   ! =1: grad. vector in cyl coords.
c
      integer nlist                     ! no. of fcns in list
      integer ifcns(nlist)              ! xplasma fcn ids, functions wanted.
c
      integer ivecd                     ! output vector dimension
C
C  output:
      real*8 zR(abs(ivec)),zZ(abs(ivec))          ! (R,Z) of target points
      REAL*8 fvals(ivecd,nlist)         ! functions values returned
      REAL*8 fgrads(3,ivecd,nlist)      ! functions gradients returned
C
      integer nregion(abs(ivec))             ! region code for (R,Z,phi) 1=inside
      integer ierr                      ! completion code, 0=OK
C
C--------------------------
C
      integer imap
      REAL*8 zdum,ztol
      integer iveca,lunerr
      logical ccwflag
C
C--------------------------
C
      if((irzmode.lt.0).or.(irzmode.gt.1)) then
         call eq_get_lunerr(lunerr)
         write(lunerr,*) ' ?eqmap_ffget:  invalid irzmode=',irzmode
         ierr=1
      endif
c
      if(ierr.eq.1) then
         nregion=0
         return
      endif
c
      imap=3-irzmode
      ztol=0.0d0
      iveca=abs(ivec)
      ccwflag = ivec.gt.0
c
      call eqi_getall(iveca,ccwflag,zR,zZ,zphi,imap,zrho,zchi,ztol,1,
     >   0,zdum,zdum,nlist,ifcns,ivecd,fvals,fgrads,
     >   nregion,ierr)
C
      return
      end

subroutine eqi_geqdsk(lun_geqdsk,geqdsk_lbl, &
     Rmin,Rmax,Zmin,Zmax,zcur, &
     id_p,id_q,id_psi_in,nh,nv,nb, &
     ierr)
  
  !  write GEQDSK file from xplasma module

  !  **correction** dmc 9 Nov 2001:
  !  follow Lang Lao sign convention for G-EQDSK files:
  !  -- psi always increasing
  !  -- direction of current specified in pcur scalar *only*

  !-----------------------------------
  !  DMC Sep 2010: add code to set magnetic axis to match Psi(R,Z) min
  !
  !  Note: surely no "thread safety" here.  A shared xplasma2 pointer "sp"
  !  from the module "eqi_rzbox_module" is used.  The call to eqi_geq_axis
  !  could involve an excursion into a root finder which needs a module with
  !  data elements that use the SAVE attribute.
  !
  !  At present in the TRANSP/xplasma2 world this routine is called only
  !  from the xplasma_profs module, and this routine makes the only existing
  !  call to eqi_geq_axis.  So... arguments could be changed to pass down
  !  xplasma2 object references and establish thread safety, but... it has
  !  not been attempted as of today.  (DMC noted Jan 2011).
  !-----------------------------------

  use xplasma_definitions
  use eqi_rzbox_module
  implicit NONE

  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)

  !  input:

  integer lun_geqdsk                ! logical unit where to write file

  character*48 geqdsk_lbl           ! 48 character label for GEQDSK file
  real*8 Rmin,Rmax                  ! (Rmin,Rmax) of Psi(R,Z)
  real*8 Zmin,Zmax                  ! (Zmin,Zmax) of Psi(R,Z)
  real*8 zcur                       ! plasma current (amps)

  !  [Rmin,Rmax]x[Zmin,Zmax] must contain the core plasma but not exceed the
  !  available (R,Z) grids.

  integer id_p                      ! xplasma id:  Pressure profile
  integer id_q                      ! xplasma id:  q profile
  integer id_psi_in                 ! xplasma id:  Psi (or 0 to use default)

  integer nh                        ! #of GEQDSK horizontal pts
  integer nv                        ! #of GEQDSK vertical pts

  !  note nh also controls the number of pts in the 1d profiles

  integer nb                        ! #of pts in bdy contour

  !  output:

  integer ierr                      ! completion code (0=OK, file written).

  !  local data arrays...

  real*8 psirz(nh,nv)               ! Psi(R,Z) to be written
  real*8 psi(nh)                    ! local psi grid
  real*8 fpol(nh)                   ! f = R*Bt vs. (psi)
  real*8 ffprime(nh)                ! f*f', ' means d/dpsi, vs. psi
  real*8 pres(nh)                   ! p vs. psi
  real*8 pprime(nh)                 ! p' vs. psi
  real*8 qpsi(nh)                   ! q vs. psi

  real*8 xpsi(nh)                   ! rho grid (for equal steps in psi)
  real*8 rgrid(nh)                  ! R grid for psi(R,Z)
  real*8 zgrid(nv)                  ! Z grid for psi(R,Z)
  real*8 zztmp(nh)                  ! array of Z(k) for vector eval

  real*8 thgrid(nb)
  real*8 xtmp(nb)
  real*8 rbdy(nb),zbdy(nb)          ! contour boundary
  real*8 rlim(nb),zlim(nb)          ! limiter boundary
  integer nblim                     ! #of limiter points retained

  real*8 :: psi0a                   ! Psi0 offset to machine axis (if avail.)

  !----------------------
  logical, parameter :: intrp_flag = .TRUE.
  !----------------------

  !  scalars

  real*8 rdim,zdim,rleft,zmid,rmaxis,zmaxis
  real*8 rmaxis_save,zmaxis_save ! for debug testing
  real*8 zpsimag,zpsibdy
  real*8 rcentr,bcentr
  real*8 pcur

  real*8 zrmin,zrmax,zzmin,zzmax

  !  dummies

  integer idum
  real*8 xdum


  !------------------------------------------------------
  !  work stuff

  integer :: nsnccwi,nsnccwb,id_g,id_psi,id_R,id_Z

  integer i,j,igot
  integer ifcns(4)
  real*8 zbuf(4)

  real*8 zbufa(nh,4)
  real*8 zbufd(nh,4)

  real*8 zbufb(nb,2)

  real*8 :: zpsi0,zpsia
  real*8 :: dpsii

  real*8, parameter :: ZERO = 0.0_R8
  real*8, parameter :: C2PI = 6.2831853071795862_R8
  !------------------------------------------------------

  idum=0
  xdum=ZERO

  !  computational region, as per GEQDSK specification

  rdim=Rmax-Rmin
  zdim=Zmax-Zmin
  rleft=Rmin
  zmid=0.5_R8*(Zmin+Zmax)

  call xplasma_common_ids(sp,ierr,id_g=id_g,id_psi=id_psi,id_R=id_R,id_Z=id_Z)
  if(ierr.ne.0) return

  if(id_g.eq.0) then
     ierr=9999
     call xplasma_errmsg_append(sp,' ?eqi_geqdsk: g(rho) not found.')
  endif

  if(id_psi_in.gt.0) then
     id_psi = id_psi_in
  endif

  if(id_psi.le.0) then
     ierr=9999
     call xplasma_errmsg_append(sp,' ?eqi_geqdsk: psi(rho) not found.')
  endif

  if(min(id_R,id_Z).eq.0) then
     ierr=9999
     call xplasma_errmsg_append(sp,' ?eqi_geqdsk: [R,Z](rho,theta) not found.')
  endif
  if(ierr.ne.0) return

  !  magnetic axis

  call xplasma_mag_axis(sp,ierr, raxis=rmaxis,zaxis=zmaxis)
  if(ierr.ne.0) return

  rmaxis_save = rmaxis ! for debug testing
  zmaxis_save = zmaxis

  !  pol. flux & axis & @ bdy -- zpsibdy > zpsimag as per xplasma & G-eqdsk
  !  convention

  call xplasma_psi_range(sp,zpsimag,zpsibdy)

  !  signed vacuum field-- at geometric center (in R) of LCFS

  call xplasma_global_info(sp, ierr, bphi_ccw=nsnccwb, jphi_ccw=nsnccwi)

  call xplasma_RZminmax_plasma(sp, zrmin,zrmax,zzmin,zzmax, ierr)
  if(ierr.ne.0) return

  rcentr=0.5*(zrmin+zrmax)
  bcentr=nsnccwb/rcentr   ! will multiply in bdy R*Bphi later

  !  signed total plasma current

  pcur=nsnccwi*abs(zcur)

  !  ok form profiles:  equispaced psi grid

  psi(1)=zpsimag
  psi(nh)=zpsibdy
  do i=2,nh-1
     psi(i)=abs(zpsimag)+(i-1)*(abs(zpsibdy)-abs(zpsimag))/(nh-1)
  enddo

  !  corresponding x grid

  call xplasma_rhopsi_find(sp,psi,xpsi,ierr)
  if(ierr.ne.0) return

  !  evaluate profiles & derivatives

  ifcns(1)=id_g
  ifcns(2)=id_p
  ifcns(3)=id_psi
  ifcns(4)=id_q

  !  fcn values

  call xplasma_eval_prof(sp,ifcns(1:4),xpsi,zbufa,ierr)
  if(ierr.ne.0) go to 990

  bcentr = zbufa(nh,1)*bcentr  ! multiply in R*(vacuum field) magnitude

  do i=1,nh
     fpol(i)=zbufa(i,1)*nsnccwb
     pres(i)=zbufa(i,2)
     qpsi(i)=zbufa(i,4)
  enddo

  !  derivatives -- off axis

  call xplasma_eval_prof(sp,ifcns(1:4),xpsi,zbufd,ierr, ideriv1=1)
  if(ierr.ne.0) go to 990

  !  df/dpsi = (df/dx)/(dpsi/dx)
  !   ...ok except @mag. axis where dpsi/dx -> 0

  dpsii=0.5/(psi(2)-psi(1)) !uniform grid in psi: 1/(2*dpsi)

  ffprime(1)=dpsii*fpol(1)*(4.0_R8*fpol(2) - fpol(3) - 3.0_R8*fpol(1))
  pprime(1)=dpsii*(4.0_R8*pres(2) - pres(3) - 3.0_R8*pres(1))

  do i=2,nh-1
    ffprime(i)=dpsii*fpol(i)*(fpol(i+1)-fpol(i-1))
    pprime(i)=dpsii*(pres(i+1)-pres(i-1))
  enddo

  ffprime(nh)=dpsii*fpol(nh)*(3.0_R8*fpol(nh) - 4.0_R8*fpol(nh-1) + fpol(nh-2))
  pprime(nh)=dpsii*(3.0_R8*pres(nh) - 4.0_R8*pres(nh-1) + pres(nh-2))

  !  OK... now get psi(R,Z)

  do i=1,nh
     rgrid(i)=Rmin+(i-1)*(Rmax-Rmin)/(nh-1)
  enddo

  do j=1,nv
     zgrid(j)=Zmin+(j-1)*(Zmax-Zmin)/(nv-1)
     zztmp=zgrid(j)
     call xplasma_eval_prof(sp,id_psi, &
          xplasma_R_coord,rgrid,xplasma_Z_coord,zztmp, &
          psirz(1:nh,j),ierr)
     if(ierr.ne.0) go to 990
     
     !  leave psi sign unchanged -- G-EQDSK convention is same as XPLASMA
     !  convention
  enddo

  call xplasma_get_psi0(sp,psi0a,igot,ierr)
  if(ierr.ne.0) go to 990

  !  adjust Psi(R,Z); restoring original EFIT offset; reset extrema as well

  psirz = psirz + psi0a
  zpsimag = zpsimag + psi0a
  zpsibdy = zpsibdy + psi0a

  !-------------------------------------------------------
  !  and now get the plasma boundary specification...

  ifcns(1)=id_R
  ifcns(2)=id_Z
  do i=1,nb
     xtmp(i)=1.0_R8
     thgrid(i)=(i-1)*C2PI/(nb-1)
  enddo

  !  evaluate all but last point; force exact periodicity

  call xplasma_eval_prof(sp,ifcns(1:2), &
       xplasma_theta_coord,thgrid(1:nb-1), xplasma_rho_coord,xtmp(1:nb-1), &
       zbufb(1:nb-1,1:2),ierr)
  if(ierr.ne.0) go to 990
  zbufb(nb,1)=zbufb(1,1)
  zbufb(nb,2)=zbufb(1,2)

  !  copy into output arrays

  rbdy(1:nb)=zbufb(1:nb,1)
  zbdy(1:nb)=zbufb(1:nb,2)

  !  and now, finally, the limiter...

  call xplasma_limcon(sp,rlim,zlim,igot,ierr, tol=ZERO)
  if(ierr.ne.0) go to 990

  nblim=nb

  !-------------------------------------------------------
  if(intrp_flag) then

     ! write out and read back from ascii file -- to get the
     ! effect of loss of precision due to ascii I/O in EQDSK format

     rmaxis = rmaxis_save
     zmaxis = zmaxis_save

     call eqi_geq_axis(nh,rgrid,nv,zgrid,psirz,nb,rbdy,zbdy, &
          rmaxis,zmaxis,zPsi0,zPsia,ierr)
     if(ierr.ne.0) then
        call xplasma_errmsg_append(sp, &
             ' ?Newton loop error in eqi_geq_axis, eqi_geqdsk (xplasma).')
        go to 990
     endif

     ! ** adjust Psi(R,Z) so that the true magnetic axis value is zpsimag

     psirz = psirz + (zpsimag - zPsi0)

     ! ** adjust boundary value per result of eqi_geq_axis evaluation
     !    (include the general adjustment to all of psirz(:,:) ...)

     zpsibdy = zPsia + (zpsimag - zPsi0)

  endif

  !  write the GEQDSK file...

2000 format(a48,3i4)
2001 format(5e16.9)
2002 format(2i5)

  !  from notes (General Atomic, Lang Lao 02/21/00)

  idum=0
  xdum=ZERO

  write(lun_geqdsk,2000) geqdsk_lbl,idum,nh,nv
  write(lun_geqdsk,2001) rdim,zdim,rcentr,rleft,zmid
  write(lun_geqdsk,2001) rmaxis,zmaxis,zpsimag,zpsibdy,bcentr
  write(lun_geqdsk,2001) pcur,zpsimag,xdum,rmaxis,xdum
  write(lun_geqdsk,2001) zmaxis,xdum,zpsibdy,xdum,xdum
  write(lun_geqdsk,2001) (fpol(i),i=1,nh)
  write(lun_geqdsk,2001) (pres(i),i=1,nh)
  write(lun_geqdsk,2001) (ffprime(i),i=1,nh)
  write(lun_geqdsk,2001) (pprime(i),i=1,nh)
  write(lun_geqdsk,2001) ((psirz(i,j),i=1,nh),j=1,nv)
  write(lun_geqdsk,2001) (qpsi(i),i=1,nh)
  write(lun_geqdsk,2002) nb,nblim
  write(lun_geqdsk,2001) (rbdy(i),zbdy(i),i=1,nb)
  write(lun_geqdsk,2001) (rlim(i),zlim(i),i=1,nblim)

  !  that is all

  ierr=0

  go to 1000

  !-----------------------------------
  !  error exit...

990 continue

  ierr=9999
  call xplasma_errmsg_append(sp,' ?data lookup error in eqi_geqdsk (xplasma).')

1000 continue
  return

end subroutine eqi_geqdsk

logical function lmds_errstat(lunmsg,istat)
 
  ! return .FALSE. if status is OK
  ! return .TRUE. & write a message if there is an error.
 
  implicit NONE
 
  integer, intent(in) :: lunmsg  ! fortran LUN for message output
  integer, intent(in) :: istat   ! status code from preceding MDSplus operation
 
  character*100 zmsg
  integer isto2,idum,ilz,mds_errstr
 
  !------------------------------------
 
  isto2=istat/2
  lmds_errstat = ((isto2*2).eq.istat).and.(istat.ne.0)
  if(lmds_errstat) then
 
     zmsg='(no message)'
     idum = mds_errstr(istat,zmsg)
     ilz = len_trim(zmsg)
 
     write(lunmsg,*) ' '
     write(lunmsg,*) ' MDSplus error status:  ',istat,', message:'
     write(lunmsg,*) zmsg(1:ilz)
     write(lunmsg,*) ' '
 
  else if(istat.eq.0) then
 
     write(lunmsg,*) ' (lmds_errstat warning: status code = ZERO)'
 
  endif
 
end function lmds_errstat

subroutine eq_glimrz(rho,r_min,r_max,z_min,z_max,ierr)

  use xplasma_obj_instance
  use eq_module

  !  find the minimum and maximum R and Z on the given surface

  IMPLICIT NONE
  REAL*8 rho                        ! rho of surface (in)
  REAL*8 R_min                      ! minimum R found (out)
  REAL*8 R_max                      ! maximum R found (out)
  REAL*8 Z_min                      ! minimum Z found (out)
  REAL*8 Z_max                      ! maximum Z found (out)
  integer ierr                      ! completion code, 0=OK (out)

  !---------------------------

  call xplasma_RZminmax(s,rho,ierr, rmin=r_min,rmax=r_max, &
       zmin=z_min,zmax=z_max)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?error in eq_glimrz.  Input argument rho=',rho,'.'
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_glimrz

subroutine eq_glimrz1(rho,phi,r_min,r_max,z_min,z_max,ierr)

  use xplasma_obj_instance
  use eq_module

  !  find the minimum and maximum R and Z on the given surface
  !  at a particular toroidal angle (for axisymmetric cases this is the same
  !  as eq_glimrz).

  IMPLICIT NONE
  REAL*8 rho                        ! rho of surface (in)
  REAL*8 phi                        ! toroidal angle (in)
  REAL*8 R_min                      ! minimum R found (out)
  REAL*8 R_max                      ! maximum R found (out)
  REAL*8 Z_min                      ! minimum Z found (out)
  REAL*8 Z_max                      ! maximum Z found (out)
  integer ierr                      ! completion code, 0=OK (out)

  !---------------------------

  call xplasma_RZminmax(s,rho,ierr, phi=phi, rmin=r_min,rmax=r_max, &
       zmin=z_min,zmax=z_max)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?error in eq_glimrz1.'
     write(lunerr,*) '  Input arguments rho=',rho,' phi=',phi,'.'
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_glimrz1

subroutine eq_gflist(nlist,fnames,inames,ierr)

  !  for a list of function names, generate the corresponding set
  !  of function numbers.  set ierr if any names cannot be translated.

  IMPLICIT NONE

  integer nlist                     ! size of list (in)
  character*(*) fnames(nlist)       ! the function names (in)
  integer inames(nlist)             ! the function numbers (out)
  integer ierr                      ! exit code, 0=OK

  !  ierr is set, if any of the names in fnames are unknown.  If
  !  fnames(j) is unknown, inames(j)=0 is returned.

  !  this routine writes no messages.  The caller should check ierr.

  !------------------------------------------------------------------
  integer i
  !------------------------------------------------------------------

  ierr=0
  do i=1,nlist
     call eq_gfnum(fnames(i),inames(i))
     if(inames(i).eq.0) ierr=1
  enddo

end subroutine eq_gflist

subroutine eq_flxint_arr2d(iorder,irhoax,zdata,id1,id2, &
     ibcrho0,idz0,zbcrho0,ibcrho1,idz1,zbcrho1, &
     iwant,result,inumchi,inumrho,ierr)

  ! integration of user defined data -- legacy f77 interface

  use xplasma_obj_instance
  use eq_module
  IMPLICIT NONE

  !  this routine will numerically integrate a 2d axisymmetric function
  !  based on array data provided by the user.  This is a mulltistep process:

  !     (1) a spline (or Hermite) representation of the array data is created
  !         (eqm_frhochi call)
  !     (2) this representation is integrated
  !         (fluxav_zonint or fluxav_zonavg or fluxav_surfint call)
  !     (3) the spline (or Hermite) representation is deleted.

  !         the argument iorder specifies the representation:
  !               iorder=2 --> spline
  !               iorder=1 --> Akima Hermite
  !               iorder=0 --> piecewise linear

  !  currently only axisymmetric data is supported, so the data is a 2d
  !  array, either:
  !     vs. (rho,chi), set irhoax=1; presume zdata(1:nrho,1:nchi), or,
  !     vs. (chi,rho), set irhoax=2; presume zdata(1:nchi,1:nrho)

  !  (rho is the radial flux coordinate; chi is the poloidal angle coordinate)
  !  these are the grids defined by prior eqm_rho and eqm_chi calls.

  !  note the actual size of first dimension of the data is "id1", which must
  !  be greater than either nrho or nchi, depending on the value of irhoax.

  !  ibcrho0,zbcrho0,ibcrho1,zbcrho1 -- boundary conditions for spline
  !  or Hermite fit (passed to eqm_frhochi)

  !  *** iwant *** specifies the type of integration desired:
  !    here "f" denotes the interpolating function generated from the
  !    passed array data.

  !    iwant=1:  surface integral:
  !       int[phi=0 to 2pi] dphi * {
  !            int[chi=0 to 2pi] dchi * f }

  !    iwant=5:  volume weighted surface integral:
  !        int[phi=0 to 2pi] dphi * {
  !            int[chi=0 to 2pi] dchi * f * det(Jacobian) }

  !      **caution** if rho(1) corresponds to the mag. axis, a
  !        det(Jacobian)=0 and a value of 0.0 is always returned!

  !    iwant=6:  volume weighted surface average:

  !        int[phi=0 to 2pi] dphi * {
  !            int[chi=0 to 2pi] dchi * f * det(Jacobian)}
  !        -----------------------------------------------
  !        int[phi=0 to 2pi] dphi * {
  !            int[chi=0 to 2pi] dchi * det(Jacobian)}

  !      **caution** if rho(1) corresponds to the mag. axis,
  !        the value "f" evaluated at the axis is returned there.

  !  zonal integrals:  result(1:nrho-1) are computed; result(j)
  !                    corresponds to the integral from rho(j) to rho(j+1)

  !    iwant=2:  integrate f*drho*dtheta*dphi:

  !       int[rho=rho(j) to rho(j+1)] drho * {
  !          int[phi=0 to 2pi] dphi * {
  !               int[chi=0 to 2pi] dchi * f } }

  !    iwant=3:  integrate f*dV (use det(Jacobian))

  !       int[rho=rho(j) to rho(j+1)] drho * {
  !          int[phi=0 to 2pi] dphi * {
  !               int[chi=0 to 2pi] dchi * f * det(Jacobian) } }

  !    iwant=4:  compute <f> = (integrated f*dV)/dVol
  !              where dVol is the volume btw rho(j) and rho(j+1)

  !  **caution** in axisymmetric case there is no variation with phi,
  !  but a factor of 2pi still arises from the phi integration...

  !----------------------------------
  !  arguments:
  !  -- input --

  integer iorder                ! order of fit (2=spline,1=Hermite,...)
  integer irhoax                ! which axis is "rho" (1 or 2)
  integer id1                   ! size of 1st dimension of zdata
  integer id2                   ! size of 2nd dimension of zdata
  real*8 zdata(id1,id2)         ! the data itself...

  !  irhoax=1 --> expect id1.ge.nrho, id2.ge.nchi
  !  irhoax=2 --> expect id1.ge.nchi, id2.ge.nrho

  integer idz0,idz1             ! sizes of BC data arrays

  integer ibcrho0,ibcrho1       ! BC type @rho(axis), @rho(bdy) resp.
  real*8 zbcrho0(idz0),zbcrho1(idz1)  ! corresponding BC data

  !  BC type values:  for ibcrho0:
  !     =0 -- use "not a knot", zbcrho0(...) ignored
  !     =1 -- match slope, given at x(1),chi(ichi) by zbcrho0(ichi)
  !     =2 -- match 2nd deriv., given at x(1),chi(ichi) by zbcrho0(ichi)
  !     =3 -- boundary condition is slope=0 (df/dx=0) at x(1), all chi(j)
  !           (zbcrho0(...) ignored).
  !  and similarly for (ibcrho1,zbcrho1(...)).

  integer iwant                 ! type of integration desired
  !                                   ! see description, above...

  integer inumchi              ! 1st (chi) dim of result
  integer inumrho              ! 2nd (rho) dim of result

  !  if inumchi=1, do integrations over the entire flux zone / flux surface
  !  if inumchi>1, do integrations over chi segments.

  !  -- output --

  real*8 result(inumchi,inumrho) ! results of integrations...

  integer ierr                  ! completion code, 0=normal

  !---------------------------------------------------------------------

  integer id_ax1,id_ax2,id_tmp,idi

  integer :: nchi,nrho,iertmp,inrhoi,inthi,inthzons,iadj
  integer :: id_R,id_rho,id_chi

  real*8, dimension(:), allocatable :: dvol_1d,dvdrho_1d
  real*8, dimension(:,:), allocatable :: dvol_2d,dvdrho_2d
  integer :: iwarn_vol,iwarn_dv

  character*10 zname
  logical :: ineed_dvol,ineed_dvdrho

  !---------------------------------------------------------------------
  !  quick checks...

  ierr=0
  result=0

  call xplasma_common_ids(s,ierr, id_R=id_R)
  if(ierr.ne.0) then
     return
  else if(id_R.eq.0) then
     return
  endif

  call xplasma_prof_info(s,id_R,iertmp, gridId1=id_chi, gridId2=id_rho)
  call xplasma_grid_size(s,id_chi,nchi,iertmp)
  call xplasma_grid_size(s,id_rho,nrho,iertmp)

  if((irhoax.lt.1).or.(irhoax.gt.2)) then
     write(lunerr,*) ' ?eq_flxint_arr2d: invalid: irhoax=',irhoax
     ierr=1
  endif
  if(ierr.ne.0) return

  if(irhoax.eq.1) then
     if(id1.lt.nrho) then
        write(lunerr,*) ' ?eq_flxint_arr2d:  id1=',id1,' too small.'
        write(lunerr,*) '  was expecting id1.ge.nrho, nrho = ',nrho
        ierr=1
     endif
     if(id2.lt.nchi) then
        write(lunerr,*) ' ?eq_flxint_arr2d:  id2=',id2,' too small.'
        write(lunerr,*) '  was expecting id2.ge.nchi, nchi = ',nchi
        ierr=1
     endif

  else
     if(id1.lt.nchi) then
        write(lunerr,*) ' ?eq_flxint_arr2d:  id1=',id1,' too small.'
        write(lunerr,*) '  was expecting id1.ge.nchi, nchi = ',nchi
        ierr=1
     endif
     if(id2.lt.nrho) then
        write(lunerr,*) ' ?eq_flxint_arr2d:  id2=',id2,' too small.'
        write(lunerr,*) '  was expecting id2.ge.nrho, nrho = ',nrho
        ierr=1
     endif
  endif

  if((ibcrho0.eq.1).or.(ibcrho0.eq.2)) then
     if(idz0.lt.nchi) then
        write(lunerr,*) ' ?eq_flxint_arr2d: idz0=',idz0,' too small'
        write(lunerr,*) '  was expecting idz0.ge.nchi, nchi = ',nchi
        write(lunerr,*) '  because ibcrho0=',ibcrho0
        ierr=1
     endif
  endif

  if((ibcrho1.eq.1).or.(ibcrho1.eq.2)) then
     if(idz1.lt.nchi) then
        write(lunerr,*) ' ?eq_flxint_arr2d: idz1=',idz1,' too small'
        write(lunerr,*) '  was expecting idz1.ge.nchi, nchi = ',nchi
        write(lunerr,*) '  because ibcrho1=',ibcrho1
        ierr=1
     endif
  endif

  if(ierr.ne.0) return

  !------------------------------------------
  !  (1)  set up interpolating function...

  if(irhoax.eq.1) then
     id_ax1=id_rho
     id_ax2=id_chi
  else
     id_ax1=id_chi
     id_ax2=id_rho
  endif

  call eqm_frhochi(iorder,id_ax1,id_ax2,'__TMPI',zdata,id1, &
       ibcrho0,zbcrho0,ibcrho1,zbcrho1,id_tmp,ierr)
  if(ierr.ne.0) return

  !  (2)  perform the integration

  ineed_dvol=.FALSE.
  ineed_dvdrho=.FALSE.

  if(iwant.eq.1) then

     iadj=0 ! surface oriented
     zname = 'I(__TMPI)S'

  else if(iwant.eq.2) then

     !  integral of f*dtheta*dphi*drho over zones

     iadj=1 ! zone oriented
     zname = 'I(__TMPI)'

  else if(iwant.eq.3) then

     !  integral of f*dtheta*dphi*drho*det(J) over zones

     iadj=1 ! zone oriented
     zname = '<__TMPI>'
     ineed_dvol = .TRUE.

  else if(iwant.eq.4) then

     !  integral of f*dtheta*dphi*drho*det(J) over zones, divided by
     !  integral of   dtheta*dphi*drho*det(J) over the same zones.

     iadj=1 ! zone oriented
     zname = '<__TMPI>'

  else if(iwant.eq.5) then

     !  integral of f*dtheta*dphi*det(J) on surfaces

     iadj=0 ! surface oriented
     zname = '<__TMPI>S'
     ineed_dvdrho = .TRUE.

  else if(iwant.eq.6) then

     !  integral of f*dtheta*dphi*det(J) on surfaces divided by
     !    integral of dtheta*dphi*det(J) on surfaces; on axis just return f.

     iadj=0 ! surface oriented
     zname = '<__TMPI>S'

  endif

  ! get 1d or 2d integrator dataset information:

  call eq_find_intg(inumchi,idi,inrhoi,inthi,ierr)
  if(ierr.ne.0) return

  if(inumchi.eq.1) then
     !  integrate over entire flux surface or zone

     if(inumrho.lt.inrhoi-iadj) then
        write(lunerr,*) ' ?eq_flxint: "inumrho" dimension too small.'
        write(lunerr,*) '  found: ',inumrho,' need at least: ',inrhoi-iadj
        ierr=1
        return
     endif
        
     allocate(dvol_1d(inrhoi-1),dvdrho_1d(inrhoi))

     call xplasma_rho_zonint(s,idi,zname,result(1,1:inrhoi-iadj),ierr, &
          dvol_out=dvol_1d,iwarn_dvol=iwarn_vol, &
          dvdrho_out=dvdrho_1d,iwarn_dvdrho=iwarn_dv)

     if(ierr.ne.0) then
        write(lunerr,*) ' ?eq_flxint_arr2d: xplasma_rho_zonint call failed.'

     else

        if(iwant.eq.3) then 
           result(1,1:inrhoi-iadj)= &
                result(1,1:inrhoi-iadj)*dvol_1d(1:inrhoi-iadj)

        else if(iwant.eq.5) then
           result(1,1:inrhoi)=result(1,1:inrhoi)*dvdrho_1d(1:inrhoi)

        endif
     endif
     deallocate(dvol_1d,dvdrho_1d)

  else
     !  integrate over 2d set of zones or segments of surfaces

     inthzons = inthi-1

     if(inumrho.lt.inrhoi-iadj) then
        write(lunerr,*) ' ?eq_flxint_arr2d: "inumrho" dimension too small.'
        write(lunerr,*) '  found: ',inumrho,' need at least: ',inrhoi-iadj
        ierr=1
     endif

     if(inumchi.lt.inthzons) then
        write(lunerr,*) ' ?eq_flxint_arr2d: "inumchi" dimension too small.'
        write(lunerr,*) '  found: ',inumchi,' need at least: ',inthzons
        ierr=1
     endif
     if(ierr.ne.0) return

     allocate(dvol_2d(inthzons,inrhoi-1),dvdrho_2d(inthzons,inrhoi))

     call xplasma_2d_zonint(s,idi,zname,result(1:inthzons,1:inrhoi-iadj),ierr,&
          dvol_out=dvol_2d,iwarn_dvol=iwarn_vol, &
          dvdrho_out=dvdrho_2d,iwarn_dvdrho=iwarn_dv)

     if(ierr.ne.0) then
        write(lunerr,*) ' ?eq_flxint_arr2d: xplasma_2d_zonint call failed.'

     else

        if(iwant.eq.3) then 
           result(1:inthzons,1:inrhoi-iadj)= &
                result(1:inthzons,1:inrhoi-iadj)*dvol_2d(1:inthzons,1:inrhoi-iadj)

        else if(iwant.eq.5) then
           result(1:inthzons,1:inrhoi)= &
                result(1:inthzons,1:inrhoi)*dvdrho_2d(1:inthzons,1:inrhoi)

        endif
     endif
     deallocate(dvol_2d,dvdrho_2d)

  endif

  !  (3)  cleanup

  call xoi_author_set(iertmp)
  call xplasma_remove_item(s,id_tmp,iertmp)
  call xoi_author_clear(iertmp)

end subroutine eq_flxint_arr2d

SUBROUTINE scrclear
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero
  USE mintrp
  USE scrunch_inc1
  USE scrunch_inc2

  !...begin set dynamic arrays to zero
  implicit none
  rin = zero
  zin = zero
  xvec = zero
  gvec = zero
  xdot = zero
  xstore = zero
  m1 = 0
  n1 = 0
  rmomb = zero
  zmomb = zero
  mm = zero
  dm1 = zero
  faccon = zero
  xmpq = zero
  result = zero
  !...end set dynamic arrays to zero
  RETURN
END SUBROUTINE scrclear

subroutine eq_ngrids(inumrho,inumchi,inumphi,inumR,inumZ)

  !  return the sizes of "common" grids-- this means, the first defined
  !  grid for each coordinate.

  !  zeroes are returned for undefined grids.
  !  for axisymmetric cases inumphi=1 is returned.

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer inumrho                   ! radial flux coordinate grid
  integer inumchi                   ! poloidal angle grid
  integer inumphi                   ! toroidal angle grid

  integer inumR                     ! R grid
  integer inumZ                     ! Z grid

  !----------------------------------
  logical :: axisymm
  integer :: ierr
  !----------------------------------

  inumrho = 0
  inumchi = 0
  inumphi = 0

  inumR = 0
  inumZ = 0

  call xplasma_global_info(s,ierr, axisymm=axisymm); if(ierr.ne.0) return

  if(axisymm) then
     inumphi=1
  else
     call get1('__phi_coord',inumphi)
  endif

  call get1('__rho_coord',inumrho)
  call get1('__theta_coord',inumchi)

  call get1('__R_coord',inumR)
  call get1('__Z_coord',inumZ)

  contains

    subroutine get1(cname,ingr1)

      !  find size of 1st grid discretizing named coordinate...

      character*(*), intent(in) :: cname   ! name of coordinate
      integer, intent(out) :: ingr1        ! size of 1st grid

      integer :: id_coord,id_grid,inum

      ingr1=0

      call xplasma_find_item(s,cname,id_coord,ierr)
      if(ierr.ne.0) then
         write(lunerr,*) ' ?eq_ngrids: unexpected error:'
         call xplasma_error(s,ierr,lunerr)
         return
      endif

      call xplasma_coord_info(s,id_coord,ierr, ngrids=inum)
      if(ierr.ne.0) then
         write(lunerr,*) ' ?eq_ngrids: unexpected error:'
         call xplasma_error(s,ierr,lunerr)
         return
      endif

      if(inum.eq.0) return  ! no grid; ingr1=0 stands.

      call xplasma_coord_gridId(s,id_coord,1,id_grid,ierr)
      if(ierr.ne.0) then
         write(lunerr,*) ' ?eq_ngrids: unexpected error:'
         call xplasma_error(s,ierr,lunerr)
         return
      endif

      call xplasma_grid_size(s,id_grid,ingr1,ierr)
      if(ierr.ne.0) then
         ingr1=0
         write(lunerr,*) ' ?eq_ngrids: unexpected error:'
         call xplasma_error(s,ierr,lunerr)
         return
      endif

    end subroutine get1

end subroutine eq_ngrids

!
! compute various flux surface parameters derived from the position of 
! the flux surface on the R,Z grid
!
! the midplane intercepts are defined as the major radiaus at the height of the
! centroid of the flux surface.
!
! the rho value will be forced to be larger then  1.e-5*(rho_bdy-rho_axis)
!
! notes from gelong:
!c
!c> Date: Wed, 22 Sep 1999 11:59:40 -0400
!c> From: Glenn Bateman <bateman@fusion.physics.lehigh.edu>
!c> 	Consider a toroidal magnetic surface (also called a flux surface).
!c> Use the following variables
!c>
!c> R_out   = major radius to the outboard edge of the flux surface
!c>           that is, the largest value of major radius anywhere on the surface
!c> R_in    = major radius to the inboard edge (ie, smallest value of major
!c> radius)
!c> R_top   = major radius to the top edge of the flux surface
!c>           that is, to the highest point on the flux surface cross section
!c> R_bottom = major radius to the lowest point on the flux surface
!c> height  = distance between the elevations of the highest point
!c>           and the lowest point
!c> R_dent_in  = major radius to the most indented inboard part of the surface
!c>           in cases where the flux surface is bean shaped
!c>           with a dent on the inboard edge
!c>           Note: R_dent_in = R_in whenever the flux surface is not indented
!c> R_dent_out = major radius to the most indented outboard part of the surface
!c>
!c> r_minor = half width = (R_out - R_in ) / 2     (usually called minor radius)
!c> r_major = ( R_out + R_in ) / 2                 (usually called major radius)
!c>
!c> elongation:	kappa = height / ( R_out - R_in )
!c>
!c> tiangularity:	delta = ( r_major - min ( R_top, R_bottom ) ) / r_minor
!c>
!c> indentation:	indent = max ( ( R_dent_in - R_in ) / rminor ,
!c> 			       ( R_dent_out - R_out ) / rminor )
!c>
!c> 	Note: for normal convex surfaces, indent = 0.0
!c> For bean-shaped surfaces with indentation on the inboard edge, indent > 0
!c> For bean-shaped surfaces with indentation on the outboard edge, indent < 0
!c>
!c> 	For surfaces with the point of the triangle facing outward,
!c> delta > 0.0, while if the triangle points inward, delta < 0.0
!c>
!c> 	For vertically elongated surfaces, kappa > 1.0
!c> For horizontally elongated surfaces, kappa < 1.0.
!c>
!c> squareness based on Holcomb Phys. Plasmas 16, 056116 (2009), see fig. 1
!c>
!c> Z_rmax = elevation where R==R_out
!c>
!c> Mikkelsen squareness attempts to match moment representation
!c>
!c>    R = Rmajor + Rminor*cos(theta + asin(triang)sin(theta))
!c>    Z = Rmajor + elong*Rminor*sin(theta + square*sin(2*theta))
!c>
!c> by finding the point Rmk = R(pi/4.), interpolating from the boundary
!c> data to Zmk and then using the moment representation at Z(pi/4.) to
!c> derive the squareness.
!c>
!c>
!c>
!
subroutine eq_surfgeo(ivec, rho, phi, ntheta, &
     elong, triang, indent, zmidp, rin_midp, rout_midp, limits, ier)

  ! mod DMC Apr 2011: method now available natively in xplasma
  !   see xplasma2/xplasma_rzgeo.f90

  use xplasma_obj_instance
  use eq_module

  implicit none

  integer, intent(in) :: ivec             ! number of surfaces
  real*8,  intent(in) :: rho(ivec)        ! radial coordinate of flux surface
  real*8,  intent(in) :: phi(ivec)        ! toroidal coordinate of flux surface
  integer, intent(in) :: ntheta           ! number of poloidal points to use around the flux surface
                                          ! or 0 for the default of 400

  real*8,  intent(out) :: elong(ivec)    ! surface elongation
  real*8,  intent(out) :: triang(ivec)   ! triangularity
  real*8,  intent(out) :: indent(ivec)   ! indentation

  real*8,  intent(out) :: zmidp (ivec)   ! height of flux surface centroid
  real*8,  intent(out) :: rin_midp(ivec)  ! inner midplane intercept at centroid height
  real*8,  intent(out) :: rout_midp(ivec)  ! outer midplane intercept at centroid height

  real*8,  intent(out) :: limits(20,ivec) ! surface limits used for elong,triang,indent
                                          ! 1  -> R_in
                                          ! 2  -> R_out
                                          ! 3  -> R_top
                                          ! 4  -> Z_top
                                          ! 5  -> R_bottom
                                          ! 6  -> Z_bottom
                                          ! 7  -> R_dent_in
                                          ! 8  -> R_dent_out
                                          ! 9  -> R_centroid
                                          ! 10 -> Z_centroid
                                          ! 11 -> lower Holcomb squareness
                                          ! 12 -> upper Holcomb squareness
                                          ! 13 -> Z_rmax
                                          ! 14 -> Rmk_low
                                          ! 15 -> Zmk_low
                                          ! 16 -> lower Mikkelsen squareness
                                          ! 17 -> Rmk_upp
                                          ! 18 -> Zmk_upp
                                          ! 19 -> upper Mikkelsen squareness

  integer, intent(out) :: ier             ! nonzero on error
    
  !--------------------------------------------------------------

  call xplasma_surfgeo(s, rho, &
       elong, triang, indent, &
       zmidp, rin_midp, rout_midp, &
       ier, &
       ntheta=ntheta, &
       phival=phi, &
       auxdata=limits)

  if(ier.ne.0) then
     call eq_errmsg('non-zero status code in old_xplasma:eq_surfgeo.f90')
  endif

end subroutine eq_surfgeo

subroutine scrunch_cleanup(xi,ns, rmmc,rmms,zmmc,zmms, kmom, &
     R0patch, xmom_xbrk,xmom_rtol, ierr)

  !  clean up moments representation:
  !   (a) modify R0(x) and Z0(x) so that 
  !       lim[x->0]d[R0]/dx = lim[x->0]d[Z0]/dx = 0
  !       by fiting a parabola that satisfies point and 1st derivative
  !       match at xmom_xbrk and 0 derivative on axis -- THIS MOVES THE
  !       MAGNETIC AXIS SLIGHTLY.
  !       **apply** similar patch to all EVEN numbered moments
  !       execute (a) iff R0patch=.TRUE.
  !
  !   (b) zero out moments that are below tolerance R0*xmom_rtol;
  !       save data on flux location inside of which the moments
  !       profile is below tolerance and should be smoothly set to
  !       zero.  Execute independent of value of R0patch
  !
  !  errors:
  !    ierr=2 -- xmom_xbrk value out of range
  !    ierr=3 -- xmom_rtol exceeds 1.0d-5
  !    ierr=1 -- error (unspecified)
  !
  !  inputs:
  !    ns -- no. of surfaces including axis and bdy
  !    kmom -- no. of highest moment, moments are (0:kmom)
  !    xi(1:ns) -- flux coord. grid [0,1]
  !    xmom_xbrk -- break point for parabola; also, transition width
  !       for zeroing of moments
  !    xmom_rtol -- tolerance that defines when moments values are too
  !       small and should be set to zero
  !
  !  output:
  !    ierr -- completion code (0 = OK)
  !
  !  in/out:
  !    rmmc,rmms,zmmc,zmms all dimensioned (0:kmom,1:ns) -- MODIFIED
  !    
  !-------------------------------------------
  use iso_c_binding, only: fp => c_double
  implicit none

  integer, intent(in) :: ns,kmom
  real(fp), intent(in) :: xi(ns)
  real(fp), intent(inout) :: rmmc(0:kmom,ns),rmms(0:kmom,ns)
  real(fp), intent(inout) :: zmmc(0:kmom,ns),zmms(0:kmom,ns)
  logical, intent(in) :: R0patch
  real(fp), intent(in) :: xmom_xbrk,xmom_rtol
  integer, intent(out) :: ierr 
  !-------------------------------------------
  real(fp) :: xcut_rc(0:kmom),xcut_rs(0:kmom),xcut_zc(0:kmom),xcut_zs(0:kmom)
  !-------------------------------------------

  call scrunch_cleanup_all(xi,ns, rmmc,rmms,zmmc,zmms, kmom, &
       R0patch, xmom_xbrk,xmom_rtol, xcut_rc, xcut_rs, xcut_zc, xcut_zs, ierr)

end subroutine scrunch_cleanup

subroutine scrunch_cleanup_all(xi,ns, rmmc,rmms,zmmc,zmms, kmom, &
     R0patch, xmom_xbrk,xmom_rtol, &
     xcut_rc, xcut_rs, xcut_zc, xcut_zs, ierr)

  !  clean up moments representation:
  !   (a) modify R0(x) and Z0(x) so that 
  !       lim[x->0]d[R0]/dx = lim[x->0]d[Z0]/dx = 0
  !       by fiting a parabola that satisfies point and 1st derivative
  !       match at xmom_xbrk and 0 derivative on axis -- THIS MOVES THE
  !       MAGNETIC AXIS SLIGHTLY.
  !   (b) zero out moments that are below tolerance R0*xmom_rtol;
  !       save data on flux location inside of which the moments
  !       profile is below tolerance and should be smoothly set to
  !       zero-- this step skipped if xmom_rtol=0
  !
  !  errors:
  !    ierr=2 -- xmom_xbrk value out of range
  !    ierr=3 -- xmom_rtol exceeds 1.0d-5
  !    ierr=1 -- error (unspecified)
  !
  !  inputs:
  !    ns -- no. of surfaces including axis and bdy
  !    kmom -- no. of highest moment, moments are (0:kmom)
  !    xi(1:ns) -- flux coord. grid [0,1]
  !    R0patch -- option to patch R0 (T/F)
  !    xmom_xbrk -- break point for parabola; also, transition width
  !       for zeroing of moments
  !    xmom_rtol -- tolerance that defines when moments values are too
  !       small and should be set to zero
  !
  !  output:
  !    ierr -- completion code (0 = OK)
  !    xcut_rc,xcut_rs,xcut_zc,xcut_zs all dimensioned (0:kmom)
  !       x >= xcut_rc(j) --> j'th moment of rmmc is unchanged;
  !       x <= xcut_rc(j)-xmom_xbrk --> j'th moment is zeroed
  !         (smooth transition in between)
  !
  !  in/out:
  !    rmmc,rmms,zmmc,zmms all dimensioned (0:kmom,1:ns) -- MODIFIED
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, one
  implicit NONE

  integer, intent(in) :: ns,kmom
  real(fp), intent(in) :: xi(ns)
  real(fp), intent(inout) :: rmmc(0:kmom,ns),rmms(0:kmom,ns)
  real(fp), intent(inout) :: zmmc(0:kmom,ns),zmms(0:kmom,ns)
  logical, intent(in) :: R0patch
  real(fp), intent(in) :: xmom_xbrk,xmom_rtol
  real(fp), intent(out) :: xcut_rc(0:kmom),xcut_rs(0:kmom)
  real(fp), intent(out) :: xcut_zc(0:kmom),xcut_zs(0:kmom)
  integer, intent(out) :: ierr
  !----------------------------------------------
  real(fp) :: zxrel,zfac
  real(fp) :: ztola   ! absolute tolerance inferred
  real(fp) :: ztolp1
  integer :: i,im,ibrk
  real(fp) :: zmindiff,ztest
  !----------------------------------------------

  ierr=0

  if((xmom_xbrk.lt.0.1_fp).or.(xmom_xbrk.gt.0.2_fp)) then
    ierr=2
  endif

  if((xmom_rtol.lt.zero).or.(xmom_rtol.gt.1.0e-5_fp)) then
    ierr=3
  endif

  if(ierr.ne.0) return

  !  (1) patch the 0'th moments profiles -- borrow 0'th R sin and Z sin
  !      moments slots (reset to zero later)

  if(R0patch) then

    ztolp1 = 1 + xmom_rtol

    rmms(0,1:ns)=rmmc(0,1:ns)
    zmms(0,1:ns)=zmmc(0,1:ns)
    zmindiff = xi(ns)-xi(1)
    do i=1,ns
      ztest=abs(xi(i)-xmom_xbrk)
      if(ztest.lt.zmindiff) then
        zmindiff=ztest
        ibrk=i
      endif
    enddo

    call patch(xi,0,rmms(0,1:ns),rmmc(0,1:ns),ns,ibrk)
    call patch(xi,0,zmms(0,1:ns),zmmc(0,1:ns),ns,ibrk)

    rmms(0,1:ns)=0
    zmms(0,1:ns)=0

    !  (1a) apply similar patch to all even moments
    do im=2,kmom,2
      rmms(0,1:ns)=rmmc(im,1:ns)
      call patch(xi,im,rmms(0,1:ns),rmmc(im,1:ns),ns,ibrk)
      rmms(0,1:ns)=rmms(im,1:ns)
      call patch(xi,im,rmms(0,1:ns),rmms(im,1:ns),ns,ibrk)
      rmms(0,1:ns)=zmmc(im,1:ns)
      call patch(xi,im,rmms(0,1:ns),zmmc(im,1:ns),ns,ibrk)
      rmms(0,1:ns)=zmms(im,1:ns)
      call patch(xi,im,rmms(0,1:ns),zmms(im,1:ns),ns,ibrk)
      rmms(0,1:ns)=0
    enddo
  endif

  !  (2) zero small moments; 0'th moments not eligible

  ztola = xmom_rtol*rmmc(0,1)  ! R0(0)*tolerance
  if(ztola.le.ZERO) then
    xcut_rc=-one
    xcut_rs=-one
    xcut_zc=-one
    xcut_zs=-one
    return
  endif

  xcut_rc(0)=-one
  xcut_rs(0)=-one
  xcut_zc(0)=-one
  xcut_zs(0)=-one

  do im=1,kmom
    call zpatch(rmmc(im,1:ns),xcut_rc(im))
    call zpatch(rmms(im,1:ns),xcut_rs(im))
    call zpatch(zmmc(im,1:ns),xcut_zc(im))
    call zpatch(zmms(im,1:ns),xcut_zs(im))
  enddo

  !----------------------------------------------------------
contains
  subroutine zpatch(zmom,zcut)
    use iso_c_binding, only: fp => c_double
    use physconst_mod, only: zero, one, two

    !
    !  zero patch a single moments profile
    !
    real(fp), intent(inout) :: zmom(ns)
    real(fp), intent(out) :: zcut

    real(fp) :: dfdx,zdelx,a,c

    ibrk=0
    do i=2,ns
      if(abs(zmom(i)).gt.ztola) then
        ibrk=i-1
        exit
      endif
    enddo

    if(ibrk.eq.0) then
      zcut=two  ! zero everywhere
      zmom=zero

    else if(xi(ibrk).le.xmom_xbrk) then
      zcut=-one
      return  ! no change, non-negligible value too close to axis

    else
      zcut=xi(ibrk)
      dfdx = (zmom(ibrk+1)-zmom(ibrk))/(xi(ibrk+1)-xi(ibrk))
      a = dfdx/(2*xmom_xbrk)
      c = zmom(ibrk)-dfdx*xmom_xbrk/2
      do i=1,ibrk-1
        if(xi(i).le.zcut-xmom_xbrk) then
          zmom(i)=0
        else
          zdelx=(xi(i)-(zcut-xmom_xbrk))
          zxrel=zdelx/xmom_xbrk
          zfac=10 + zxrel*(6*zxrel - 15)
          zfac= zfac*zxrel*zxrel*zxrel  ! f(x)=6x**5 -15x**4 +10x**3
          !  f(0)=f'(0)=f''(0)=f'(1)=f''(1)=0; f(1)=1
          zdelx=zcut-xi(i)
          zmom(i)=zfac*(a*zdelx*zdelx+c)
        endif
      enddo
    endif

  end subroutine zpatch

  !-----------------------------------------------------

  subroutine patch(x,imoment,f_orig,f_new,inum,ibrk)
    use iso_c_binding, only: fp => c_double
    integer, intent(in) :: inum
    integer, intent(in) :: imoment  ! 0,2,4,...
    real(fp), intent(in) :: x(inum)
    real(fp), intent(in) :: f_orig(inum)
    real(fp), intent(out) :: f_new(inum)
    integer, intent(in) :: ibrk

    !  parabolic extrapolation to axis ==> d/dx[0'th moments] --> 0

    !-----------------------------
    real(fp) :: f1,f2,f3,x1,x2,x3,dfdx,a,c
    !-----------------------------

    f_new = f_orig

    !  If 1st two points are identically zero, assume that no further
    !  patching is needed...

    if((f_new(1).eq.ZERO).and.(f_new(2).eq.ZERO)) return

    f1=f_orig(ibrk+1)-f_orig(ibrk)
    x1=x(ibrk+1)-x(ibrk)

    f2=f_orig(ibrk+2)-f_orig(ibrk)
    x2=x(ibrk+2)-x(ibrk)

    !  local derivate from parabol through f(ibrk:ibrk+2)...
    !  f(0)=0, f(x1)=f1, f(x2)=f2

    dfdx = (f1*x2*x2-f2*x1*x1)/(x1*x2*(x2-x1))

    f3=f_orig(ibrk)
    x3=x(ibrk)

    if(imoment.eq.0) then

      !  quadratic to satisfy f(x3)=f3, f'(x3)=dfdx, f'(0)=0
      !  f(x) = a*x*x + b*x + c; f'(x) = 2*a*x + b
      !    f'(0) = 0 --> b = 0
      !    f'(x3)=dfdx --> a = dfdx/(2*x3)
      !    f(x3)=f3 --> c = f3 - a*x3*x3 = f3 - dfdx*x3/2

      a = dfdx/(2*x3)
      c = f3 - dfdx*x3/2

      do i=1,ibrk-1
        x1=x(i)
        f_new(i)=a*x1*x1 + c
      enddo

    else

      !  cubic to satisfy f(x3)=f3, f'(x3)=ddfdx, f'(0)=0, f(0)=0
      !  f(x) = a*x*x*x + c*x*x + b*x + d = 0; f'(x) = 3*a*x*x + 2*c*x + b
      !         f(0)=0 --> d = 0    f'(0) = 0 --> b = 0
      !
      !         a*x3**3 + c*x3**2 = f3
      !       3*a*x3**2 + 2*c*x3 = dfdx

      a = (dfdx - 2*f3/x3)/(x3*x3)
      c = (3*f3/x3 - dfdx)/x3

      do i=1,ibrk-1
        x1=x(i)
        f_new(i)=x1*x1*(a*x1 + c)
      enddo

    endif

    return
  end subroutine patch

end subroutine scrunch_cleanup_all

subroutine xplasma_example(filename)

  implicit NONE

  character*(*), intent(in) :: filename

  !
  !  read, access and print TR_PBI data from XPLASMA file "filename".
  !
  !  this is meant as a simple example for prospective XPLASMA uses.
  !

  !--------------------------------------------------
  !  set up a grid -- any grid will do...
  
  integer, parameter :: nx = 21     ! #bdys; #zones = nx-1
  real*8, parameter :: ONE = 1.0d0  ! bdy value of grid (axis is 0.0)

  real*8 x(nx)       ! grid
  real*8 pint(nx)    ! integrated power from TR_PBI profile
  real*8 vol(nx)     ! integrated volumes
  real*8 pdens(nx-1) ! power density "at zone centers".

  integer :: ix,iwant,id,ierr
  real*8 :: xzc

  !-------------

  do ix=1,nx
     x(ix) = (ix-1)*ONE/(nx-1)  ! for nx=20: 0.0,0.05,0.10, ... ,1.00
  enddo
  
  !-------------
  !  read the XPLASMA state file (NetCDF format)

  call eq_restore(filename,ierr)
  if(ierr.ne.0) then
     write(6,*) ' xplasma_example:  failed to read: ',trim(filename)
     return
  endif

  !-------------
  !  get enclosed volumes vs. x

  iwant = 0  ! this means get enclosed volumes vs. x
  call eq_volume(nx,x,iwant,vol,ierr)
  if(ierr.ne.0) then
     write(6,*) ' xplasma_example:  eq_volume call failed: no equilibrium?'
     return
  endif

  !-------------
  !  get ID of TR_PBI profile

  call eq_gfnum('TR_PBI',id)
  if(id.eq.0) then
     write(6,*) ' xplasma_example:  TR_PBI: profile not found.'
     return
  endif

  !-------------
  !  get the data itself (integrated powers vs. x)
  !  by using eq_rgetf we expect the profile to be a function of x only.
  !  here iwant=0 means get the data itself not a derivative

  call eq_rgetf(nx,x,id,iwant,pint,ierr)
  if(ierr.ne.0) then
     write(6,*) ' xplasma_example:  error fetching TR_PBI:  eq_rgetf call.'
     return
  endif

  !-------------
  !  compute power density profile -- presumed appropriate for TR_PBI.

  write(6,*) '  #  x       power density    volume integrated power'
  write(6,*) ' ----------------------------------------------------'

  do ix=1,nx-1
     pdens(ix)=(pint(ix+1)-pint(ix))/(vol(ix+1)-vol(ix))
     xzc = (x(ix)+x(ix+1))/2
     write(6,'(1x,i3,3(1x,1pe12.5))') ix,xzc,pdens(ix),pint(ix+1)
  enddo

end subroutine xplasma_example

subroutine mcgrid_getobj(id_gridi,zname,ist_th,ist_ph,zconv,zdata,idim,ierr)
 
  !  get (fetch) mcgrid scalar field -- one number per grid zone
 
  !  the data can cover the plasma out to the boundary, or, beyond the
  !  boundary into an extrapolated space.  If the stored data goes beyond
  !  the boundary AND the user data has space for it, the beyond-the-boundary
  !  data will be copied, otherwise zeroes will be written.
 
  !  the output data is on the user's (theta,phi) grids; stored data is on
  !  the standardixed xplasma mcgrid:
  !    ist_th(ph) = -1 -- user grid starts at -pi (theta, phi)
  !    ist_th(ph) =  0 -- user grid starts at 0   (theta, phi)
 
  !  if the mcgrid is updown symmetric, only data covering the range
  !  [0,pi] or [-pi,0] are copied, depending on the setting of ist_th.
 
  !  the mcgrid# id_gridi refers to a grid set up by a prior mcgrid_define
  !  call.
 
  !  if id_gridi is negative:  if the named object does not exist,
  !  set the output array to zero without setting an error flag.
 
  !  if id_gridi is positive:  non-existance of named object is an error.
 
  use xplasma_obj_instance
  use eq_module

  implicit NONE
 
  !  NOTE: for compatibility with f77 xplasma: if zname="ZONE_VOLUME" then
  !  the name [gridname]//'_DVOL' is substituted...

  integer, intent(in) :: id_gridi    ! id from prior mcgrid_define call
  character*(*), intent(in) :: zname ! name of object to fetch
  integer, intent(in) :: ist_th,ist_ph  ! angle grid start flags
  integer, intent(in) :: idim        ! dimension of zdata array
  real*8, intent(in) :: zconv        ! units conversion factor
  !  set zconv.lt.0.0 to specify clockwise orientation of poloidal zones
  !  data scaled by a factor of abs(zconv)

  real*8 :: zdata(idim)              ! data to fetch
 
  integer, intent(out) :: ierr       ! completion code (0=OK)
 
  !----------------------------------
  integer :: idtmp,id_grid,inzons,inzonu,nzons,nzons_ext,itype_bb,iertmp
  integer, dimension(:), pointer :: ia_ptr
  character*32 :: mcname,fname
  !----------------------------------
 
  id_grid=abs(id_gridi)

  call mcgrid_argcheck('mcgrid_getobj',ist_th,ist_ph,0,ierr)
  if(ierr.ne.0) return
 
  call xplasma_mcgrid_info(s,id_grid,ierr, &
       nzons=nzons,nzons_ext=nzons_ext,name=mcname)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?mcgrid_getobj: xplasma_mcgrid_info error.'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  fname=zname
  call uupper(fname)
  if((fname.eq.'ZONE_VOLUME').or.(fname.eq.'ZONE_VOLUMES')) then 
     fname=trim(mcname)//'_DVOL'
  endif

  call xplasma_find_item(s,fname,idtmp,ierr,nf_noerr=.TRUE.)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?mcgrid_getobj: xplasma_find_item error.'
     call xplasma_error(s,ierr,lunerr)
     return
  endif
  if(idtmp.eq.0) then
     zdata=0.0d0
     if(id_gridi.gt.0) then
        write(lunerr,*) ' ?mcgrid_getobj: "',trim(fname),'" not found.'
        ierr=1
     endif
     return
  endif
        
  call xplasma_blackBox_retrieve(s,idtmp,ierr,ia_ptr=ia_ptr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?mcgrid_getobj: xplasma_blackBox_retrieve error.'
     call xplasma_error(s,ierr,lunerr)
     nullify(ia_ptr)
     return
  endif

  inzons=ia_ptr(2)

  !  nzons = #interior grid pts
  !  nzons_ext = #total grid pts
  !  inzons = #in data (could be nzons or nzons_ext).
  !  idim = #in passed array

  if(idim.lt.nzons) then
     write(lunerr,*) ' ?mcgrid_getobj: array size too small: idim=',idim, &
          '; need=',inzons
     ierr=1
     nullify(ia_ptr)
     return
  else if(idim.lt.inzons) then
     inzonu=nzons
     if(idim.gt.inzonu) then
        zdata(inzonu+1:idim)=0.0d0
     endif
  else
     inzonu=inzons
     if(idim.gt.inzonu) then
        zdata(inzonu+1:idim)=0.0d0
     endif
  endif

  call xplasma_mcgrid_getobj(s,idtmp,ierr, &
       lstart0_th=(ist_th.eq.0), ccwflag_th=(zconv.ge.0.0d0), &
       data_1d=zdata(1:inzonu))

  if(ierr.ne.0) then
     write(lunerr,*) ' ?mcgrid_getobj: xplasma_mcgrid_getobj error:'
     call xplasma_error(s,ierr,lunerr)
     zdata(1:inzonu)=0.0d0
  else
     zdata(1:inzonu)=zdata(1:inzonu)*abs(zconv)
  endif

  nullify(ia_ptr)

end subroutine mcgrid_getobj

subroutine mcgrid_getobj_r4(id_gridi,zname,ist_th,ist_ph,zconv,zdata,idim,ierr)
 
  !  get (fetch) mcgrid scalar field -- one number per grid zone
  !    _r4 (single precision) version -- user's array is declared REAL.
 
  !  the data can cover the plasma out to the boundary, or, beyond the
  !  boundary into an extrapolated space.  If the stored data goes beyond
  !  the boundary AND the user data has space for it, the beyond-the-boundary
  !  data will be copied, otherwise zeroes will be written.
 
  !  the output data is on the user's (theta,phi) grids; stored data is on
  !  the standardixed xplasma mcgrid:
  !    ist_th(ph) = -1 -- user grid starts at -pi (theta, phi)
  !    ist_th(ph) =  0 -- user grid starts at 0   (theta, phi)
 
  !  if the mcgrid is updown symmetric, only data covering the range
  !  [0,pi] or [-pi,0] are copied, depending on the setting of ist_th.
 
  !  the mcgrid# id_gridi refers to a grid set up by a prior mcgrid_define
  !  call.
 
  !  if id_gridi is negative:  if the named object does not exist,
  !  set the output array to zero without setting an error flag.
 
  !  if id_gridi is positive:  non-existance of named object is an error.
 
  implicit NONE
 
  integer, intent(in) :: id_gridi     ! id from prior mcgrid_define call
  character*(*), intent(in) :: zname ! name of object to fetch
  integer, intent(in) :: ist_th,ist_ph  ! angle grid start flags
  integer, intent(in) :: idim        ! dimension of zdata array
  real, intent(in) :: zconv          ! units conversion factor
  !  set zconv.lt.0.0 to specify clockwise orientation of poloidal zones
  !  data scaled by a factor of abs(zconv)

  real :: zdata(idim)                ! data to fetch
 
  integer, intent(out) :: ierr       ! completion code (0=OK)
 
  !----------------------------------
 
  real*8 :: zconv8
  real*8, dimension(:), allocatable :: zdata8
  !----------------------------------
 
  zconv8=zconv

  allocate(zdata8(idim)); zdata=0.0d0

  call mcgrid_getobj(id_gridi,zname,ist_th,ist_ph,zconv8,zdata8,idim,ierr)

  zdata = zdata8
  deallocate(zdata8)
 
end subroutine mcgrid_getobj_r4
 
subroutine mcgrid_getarr2(id_gridi,zname,ist_th,ist_ph, &
     zconv,zdata,idim1,idim2,idim3,in1,in2,ierr)
 
  !  get (fetch) mcgrid 2d array field -- array(in1,in2) per grid zone
 
  !  the data can cover the plasma out to the boundary, or, beyond the
  !  boundary into an extrapolated space.  If the stored data goes beyond
  !  the boundary AND the user data has space for it, the beyond-the-boundary
  !  data will be copied, otherwise zeroes will be written.
 
  !  the output data is on the user's (theta,phi) grids; stored data is on
  !  the standardixed xplasma mcgrid:
  !    ist_th(ph) = -1 -- user grid starts at -pi (theta, phi)
  !    ist_th(ph) =  0 -- user grid starts at 0   (theta, phi)
 
  !  if the mcgrid is updown symmetric, only data covering the range
  !  [0,pi] or [-pi,0] are copied, depending on the setting of ist_th.
 
  !  the mcgrid# id_grid refers to a grid set up by a prior mcgrid_define
  !  call.
 
  !  if id_gridi is negative:  if the named object does not exist,
  !  set the output array to zero without setting an error flag.
 
  !  if id_gridi is positive:  non-existance of named object is an error.
 
  use xplasma_obj_instance
  use eq_module

  implicit NONE
 
  integer, intent(in) :: id_gridi     ! id from prior mcgrid_define call
  character*(*), intent(in) :: zname ! name of object to fetch
  integer, intent(in) :: ist_th,ist_ph  ! angle grid start flags
  integer, intent(in) :: idim1,idim2,idim3        ! dimension of zdata array
  real*8, intent(in) :: zconv        ! units conversion factor
  !  set zconv.lt.0.0 to specify clockwise orientation of poloidal zones
  !  data scaled by a factor of abs(zconv)

  real*8 :: zdata(idim1,idim2,idim3) ! data to fetch
  integer, intent(inout) :: in1,in2  ! activ dimensions zdata(1:in1,1:in2,j)
 
  integer, intent(out) :: ierr       ! completion code (0=OK)
 
  !----------------------------------
  integer :: idtmp,id_grid,inzons,nzons_ext,itype_bb,iertmp,ii,jj,kk
  integer :: inzonu,nzons
  integer :: irank
  integer, dimension(:), pointer :: ia_ptr
  !----------------------------------
  
  id_grid=abs(id_gridi)

  call mcgrid_argcheck('mcgrid_getarr2',ist_th,ist_ph,0,ierr)
  if(ierr.ne.0) return
  
  call xplasma_mcgrid_info(s,id_grid,ierr, &
       nzons=nzons,nzons_ext=nzons_ext)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?mcgrid_getarr2: xplasma_mcgrid_info error.'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  call xplasma_find_item(s,zname,idtmp,ierr,nf_noerr=.TRUE.)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?mcgrid_getarr2: xplasma_find_item error.'
     call xplasma_error(s,ierr,lunerr)
     return
  endif
  if(idtmp.eq.0) then
     zdata=0.0d0
     if(id_gridi.gt.0) then
        write(lunerr,*) ' ?mcgrid_getarr2: "',trim(zname),'" not found.'
        ierr=1
     endif
     return
  endif
        
  call xplasma_blackBox_retrieve(s,idtmp,ierr,ia_ptr=ia_ptr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?mcgrid_getarr2: xplasma_blackBox_retrieve error.'
     call xplasma_error(s,ierr,lunerr)
     ierr=1
     nullify(ia_ptr)
     return
  endif

  inzons=ia_ptr(2)

  !  nzons = #interior grid pts
  !  nzons_ext = #total grid pts
  !  inzons = #in data (could be nzons or nzons_ext).
  !  idim3 = #in passed array

  if(idim3.lt.nzons) then
     write(lunerr,*) ' ?mcgrid_getarr2: array idim3 too small: idim3=',idim3, &
          '; need=',inzons
     ierr=1
     nullify(ia_ptr)
     return
  else if(idim3.lt.inzons) then
     inzonu=nzons
  else
     inzonu=inzons
  endif

  irank=ia_ptr(3)
  if(irank.ne.2) then
     write(lunerr,*) ' ?mcgrid_getarr2: expected rank2 MCgrid array; irank=',&
          irank
     ierr=1
     nullify(ia_ptr)
     return
  endif

  if(in1.le.0) in1=ia_ptr(4)
  if(in2.le.0) in2=ia_ptr(5)

  if(idim1.lt.in1) then
     write(lunerr,*) ' ?mcgrid_getarr2: array idim1 too small: idim1=',idim1, &
          '; need=',in1
     ierr=1
  else if(in1.ne.ia_ptr(4)) then
     write(lunerr,*) ' ?mcgrid_getarr2: 1st dimension of data is: ',ia_ptr(4)
     write(lunerr,*) '  subroutine argument (in1) says it should be: ',in1
     ierr=1
  endif

  if(idim2.lt.in2) then
     write(lunerr,*) ' ?mcgrid_getarr2: array idim2 too small: idim2=',idim2, &
          '; need=',in2
     ierr=1
  else if(in2.ne.ia_ptr(5)) then
     write(lunerr,*) ' ?mcgrid_getarr2: 1st dimension of data is: ',ia_ptr(5)
     write(lunerr,*) '  subroutine argument (in2) says it should be: ',in2
     ierr=1
  endif

  if(ierr.ne.0) then
     nullify(ia_ptr)
     return
  endif

  call xplasma_mcgrid_getobj(s,idtmp,ierr, &
       lstart0_th=(ist_th.eq.0), ccwflag_th=(zconv.ge.0.0d0), &
       data_3d=zdata(1:in1,1:in2,1:inzonu))

  if(ierr.ne.0) then
     write(lunerr,*) ' ?mcgrid_getarr2: xplasma_mcgrid_getobj error:'
     call xplasma_error(s,ierr,lunerr)
     zdata=0.0d0
  else
     do kk=1,idim3
        do jj=1,idim2
           do ii=1,idim1
              if((ii.le.in1).and.(jj.le.in2).and.(kk.le.inzons)) then
                 zdata(ii,jj,kk)=zdata(ii,jj,kk)*abs(zconv)
              else
                 zdata(ii,jj,ii)=0.0d0
              endif
           enddo
        enddo
     enddo
  endif

  nullify(ia_ptr)

end subroutine mcgrid_getarr2
 
subroutine mcgrid_getarr2_r4(id_gridi,zname,ist_th,ist_ph, &
     zconv,zdata,idim1,idim2,idim3,in1,in2,ierr)
 
  !  get (fetch) mcgrid 2d array field -- array(in1,in2) per grid zone
  !    _r4 (single precision) version -- user's array is declared REAL.
 
  !  the data can cover the plasma out to the boundary, or, beyond the
  !  boundary into an extrapolated space.  If the stored data goes beyond
  !  the boundary AND the user data has space for it, the beyond-the-boundary
  !  data will be copied, otherwise zeroes will be written.
 
  !  the output data is on the user's (theta,phi) grids; stored data is on
  !  the standardixed xplasma mcgrid:
  !    ist_th(ph) = -1 -- user grid starts at -pi (theta, phi)
  !    ist_th(ph) =  0 -- user grid starts at 0   (theta, phi)
 
  !  if the mcgrid is updown symmetric, only data covering the range
  !  [0,pi] or [-pi,0] are copied, depending on the setting of ist_th.
 
  !  the mcgrid# id_gridi refers to a grid set up by a prior mcgrid_define
  !  call.
 
  !  if id_gridi is negative:  if the named object does not exist,
  !  set the output array to zero without setting an error flag.
 
  !  if id_gridi is positive:  non-existance of named object is an error.
 
  implicit NONE
 
  integer, intent(in) :: id_gridi     ! id from prior mcgrid_define call
  character*(*), intent(in) :: zname ! name of object to fetch
  integer, intent(in) :: ist_th,ist_ph  ! angle grid start flags
  integer, intent(in) :: idim1,idim2,idim3        ! dimension of zdata array
  real, intent(in) :: zconv          ! units conversion factor
  !  set zconv.lt.0.0 to specify clockwise orientation of poloidal zones
  !  data scaled by a factor of abs(zconv)

  real :: zdata(idim1,idim2,idim3)   ! data to fetch
  integer, intent(inout) :: in1,in2  ! activ dimensions zdata(1:in1,1:in2,j)
 
  integer, intent(out) :: ierr       ! completion code (0=OK)
 
  !----------------------------------
 
  real*8 :: zconv8
  real*8, dimension(:,:,:), allocatable :: zdata8
 
  !----------------------------------
 
  zconv8 = zconv

  allocate(zdata8(idim1,idim2,idim3)); zdata8=0.0d0

  call mcgrid_getarr2(id_gridi,zname,ist_th,ist_ph, &
       zconv8,zdata8,idim1,idim2,idim3,in1,in2,ierr)

  zdata = zdata8
  deallocate(zdata8)
 
end subroutine mcgrid_getarr2_r4

      INTEGER FUNCTION MCSTR_LASTNB(STR)
C
      CHARACTER*(*) STR
C
C  FIND LAST NONBLANK IN STRING
C
      L=LEN(STR)
C
      DO 10 I=L,1,-1
        IF(STR(I:I).NE.' ') GO TO 20
 10   CONTINUE
C
      I=1
C
 20   CONTINUE
C
      MCSTR_LASTNB=I
C
      RETURN
      END

subroutine eq_grid(id_axis,zdata,nmax,ngot,ierr)

  !  retrieve the axis grid identified by id_axis

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  !  input:

  integer, intent(in) :: id_axis    ! xplasma id of desired grid
  integer, intent(in) :: nmax       ! size of buffer to hold grid data

  !  output:

  real*8 zdata(nmax)                ! buffer for grid data
  integer, intent(out) :: ngot      ! number of points in grid, retrieved
  integer, intent(out) :: ierr      ! completion code, 0=OK

  !  ierr gets set to #pts in grid, if #pts in grid exceeds nmax
  !---------------------------------------------

  call eq_ngrid(id_axis,ngot)
  if(ngot.eq.0) then
     ierr=77
     write(lunerr,*) ' ?eq_grid:  invalid axis id:  ',id_axis
     zdata=czero

  else if(ngot.gt.nmax) then
     write(lunerr,*) ' ?eq_grid:  data buffer too small, have=',nmax, &
          ' need=',ngot
     ierr=ngot
     ngot=0
     zdata=czero

  else
     call xplasma_grid(s,id_axis,zdata(1:ngot),ierr)
     if(ierr.ne.0) then
        write(lunerr,*) ' ?eq_grid: unexpected error in xplasma_grid:'
        call xplasma_error(s,ierr,lunerr)
        ngot=0
        zdata=czero
     else
        if(ngot.lt.nmax) zdata(ngot+1:nmax)=czero
     endif

  endif

end subroutine eq_grid

subroutine eq_grid_zc(id_axis,zdata,nmax,ngot,ierr)

  !  retrieve the axis grid "zone centers" as identified by id_axis
  !  the grid itself is assumed to define boundaries of zones.  There
  !  are 1 fewer zone centers; zone center j = 0.5*(bdy(j)+bdy(j+1))

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: id_axis    ! xplasma id of desired grid
  integer, intent(in) :: nmax       ! size of buffer to hold grid data

  !  output:

  real*8 zdata(nmax)                ! buffer for grid zc data
  integer, intent(out) :: ngot      ! number of points in grid, retrieved
  integer, intent(out) :: ierr      ! completion code, 0=OK

  !  ierr gets set to #pts in grid, if #pts in grid exceeds nmax
  !---------------------------------------------

  integer :: i
  real*8, dimension(:), allocatable :: zdata2

  !---------------------------------------------

  call eq_ngrid(id_axis,ngot)
  if(ngot.eq.0) then
     ierr=77
     write(lunerr,*) ' ?eq_grid_zc:  invalid axis id:  ',id_axis
     zdata=czero

  else if(ngot-1.gt.nmax) then
     write(lunerr,*) ' ?eq_grid_zc:  data buffer too small, have=',nmax, &
          ' need=',ngot-1
     ierr=ngot-1
     ngot=0
     zdata=czero

  else
     ierr=0
     allocate(zdata2(ngot))

     call xplasma_grid(s,id_axis,zdata2,ierr)
     if(ierr.ne.0) then
        write(lunerr,*) ' ?eq_grid_zc: unexpected error in xplasma_grid:'
        call xplasma_error(s,ierr,lunerr)
        ngot=0
        zdata=czero
     else
        do i=1,ngot-1
           zdata(i)=chalf*(zdata2(i)+zdata2(i+1))
        enddo
        ngot=ngot-1
     endif
     deallocate(zdata2)
  endif

end subroutine eq_grid_zc

subroutine eq_ngrid(id_axis,isize)

  !  return the grid size, or, 0 if id_axis is invalid.

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: id_axis     ! xplasma axis id code
  integer, intent(out) :: isize      ! no. of pts in axis grid

  !-----------------------------------
  integer :: itype,ierr
  !-----------------------------------

  isize=0
  call xplasma_get_item_info(s,id_axis,ierr, itype=itype)
  if(ierr.ne.0) return
  if(itype.ne.xplasma_gridType) return

  call xplasma_grid_size(s,id_axis,isize,ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_ngrid: unexpected error in xplasma_grid_size:'
     call xplasma_error(s,ierr,lunerr)
     isize=0
  endif

end subroutine eq_ngrid

subroutine eqi_rzfx(r,nr,z,nz,inside,fcn)

  !  extrapolate based on a nearest neighbour method weighted average
  !  method the fcn to beyond the limiter regions

  implicit NONE
  integer nr,nz                     ! grid dimensions
  real*8 r(nr),z(nz)                ! grid
  logical :: inside(nr,nz)          ! T means inside limiter; F: outside
  real*8 fcn(nr,nz)                 ! fcn needing extrapolation

  !  where inside(i,j)=.TRUE., the fcn is already defined

  !  ad hoc method:
  !  form list of values that border the extrapolation region; average
  !  over these values with inverse square of distance weighting to derive
  !  the extrapolation

  !-----------------------------------------------------------
  !  arrays amply big enough for "edge value list"...

  real*8 rlist(nr*nz),zlist(nr*nz),fval(nr*nz)
  real*8 zwt,zr2sum,zfr2sum

  integer i,j,k,ip,im,jp,jm,ilist
  !-----------------------------------------------------------

  ilist=0

  do j=1,nZ
     jm=max(1,j-1)
     jp=min(nZ,j+1)

     do i=1,nR
        im=max(1,i-1)
        ip=min(nR,i+1)

        if(inside(i,j)) then
           if((.not.inside(i,jm)).or.(.not.inside(i,jp)).or. &
                (.not.inside(im,j)).or.(.not.inside(ip,j))) then

              !  add edge point to list

              ilist=ilist+1
              rlist(ilist)=r(i)
              zlist(ilist)=z(j)
              fval(ilist)=fcn(i,j)

           endif
        endif

     enddo
  enddo

  !  ok use list for extrapolation

  do j=1,nZ
     do i=1,nR

        if(.not.inside(i,j)) then

  !  extrapolate here

           zfr2sum=0.0d0
           zr2sum=0.0d0
           do k=1,ilist
              zwt=1.0d0/((r(i)-rlist(k))**2+(z(j)-zlist(k))**2)
              zr2sum=zr2sum+zwt
              zfr2sum=zfr2sum+fval(k)*zwt
           enddo

           fcn(i,j)=zfr2sum/zr2sum

        endif
     enddo
  enddo

end subroutine eqi_rzfx

subroutine eqm_frhochi(iorder,id_ax1,id_ax2,zlbl,zdata,id1, &
     ibcrho0,zbcrho0,ibcrho1,zbcrho1,id_fun,ierr)

  !  set up a function f(rho,chi)
  !    rho is the radial coordinate; chi the poloidal angle coordinate
  !    e.g. for a 2d function over an axisymmetric tokamak plasma cross
  !    section.

  !    (lots of people use "theta" instead of "chi" for this angle coordinate)
  !    (but the name is not changed in order to preserve back compatibility
  !    with legacy code)

  !    this routine assumes chi describes the contour of a boundary surface
  !    going in a counterclockwise direction.  For the reverse, set iccw=0
  !    and call eqm_frhochi_ccw(...) -- see below

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  !  input:

  integer iorder                    ! desired interpolation order

  !  [in these comments nrho & nchi refer to the axes of the data passed]

  !  iorder=0:  bilinear interpolation on data on (nrho)x(nchi) grid
  !  iorder=1:  Akima Hermite interpolation on data on(nrho)x(nchi) grid
  !  iorder=2 or 3:  Spline interpolation on data on (nrho)x(nchi) grid

  !  iorder=99 -- this is a an update of the data in an existing
  !             f(rho,chi) object.  The fit order and axes used
  !             cannot change.

  !  iorder=100 -- bilinear data (may be replacement of same sized object)
  !  iorder=101 -- Akima Hermite (may be replacement of same sized object)
  !  iorder=102 or 103 -- spline (may be replacement of same sized object)

  integer id_ax1                    ! axis id -- 1st dimension of zdata
  integer id_ax2                    ! axis id -- 2nd dimension of zdata

  !  id_ax1 or id_ax2 must give a rho coordinate; the other coordinate must
  !  be a chi (poloidal angle) coordinate.

  character*(*) zlbl                ! function name (label)
  integer id1                       ! size of 1st dimension of zdata

  REAL*8 zdata(id1,*)               ! data (at least nrho*nchi words)

  !  id1 must be .ge. size of axis (id_ax1)

  !  bdy conditions are enforced only for iorder.ge.1

  integer ibcrho0,ibcrho1           ! BC's at extrema

  !  BC controls are as in "pspline":  0 -- default, 1 -- fix df/drho

  REAL*8 zbcrho0(*)               ! if ibc=1:  df/drho @ rho(1), nchi pts
                                  ! if ibc=2:  d2f/drho2 @ rho(1), nchi pts
  REAL*8 zbcrho1(*)               ! ditto @rho(nrho)

  !     the BC data zbcrho0,zbcrho1 are used iff ibcrho0,ibcrho1 are 1 or 2
  !        otherwise the BC is derived from the main data array
  !     for Hermite fits, ibc values of 0 or 1 (only) are allowed)
  !  output:

  integer id_fun                    ! function id code
  integer ierr                      ! completion code, 0=OK

  !-----------------------------
  integer :: iccw
  !-----------------------------

  iccw = 1
  call eqm_frhochi_ccw(iccw, &
       iorder,id_ax1,id_ax2,zlbl,zdata,id1, &
       ibcrho0,zbcrho0,ibcrho1,zbcrho1,id_fun,ierr)

end subroutine eqm_frhochi

subroutine eqm_frhochi_ccw(iccw,iorder,id_ax1,id_ax2,zlbl,zdata,id1, &
     ibcrho0,zbcrho0,ibcrho1,zbcrho1,id_fun,ierr)

  !  set up a function f(rho,chi)
  !    rho is the radial coordinate; chi the poloidal angle coordinate
  !    e.g. for a 2d function over an axisymmetric tokamak plasma cross
  !    section.

  !    (lots of people use "theta" instead of "chi" for this angle coordinate)
  !    (but the name is not changed in order to preserve back compatibility
  !    with legacy code)

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  !  input:

  integer :: iccw                   ! orientation of chi: 1 means CCW
  ! (CCW, counter-clockwise); 0 means CW, clockwise.
  ! Xplasma internals ALWAYS use the CCW orientation so an ordinate
  ! reversal is needed if iccw=0

  integer iorder                    ! desired interpolation order

  !  [in these comments nrho & nchi refer to the axes of the data passed]

  !  iorder=0:  bilinear interpolation on data on (nrho)x(nchi) grid
  !  iorder=1:  Akima Hermite interpolation on data on(nrho)x(nchi) grid
  !  iorder=2 or 3:  Spline interpolation on data on (nrho)x(nchi) grid

  !  iorder=99 -- this is a an update of the data in an existing
  !             f(rho,chi) object.

  !  iorder=100 -- bilinear data (may be replacement of same sized object)
  !  iorder=101 -- Akima Hermite (may be replacement of same sized object)
  !  iorder=102 or 103 -- spline (may be replacement of same sized object)

  !  Note: replacement is now *always* allowed; the 100...103 argument
  !  values are maintained for backwards compatibility with the old f77
  !  interface (original xplasma interface).

  !  SPECIAL NAMES:  "R" & "Z" vs. (rho,chi) -- axisymmetric equilibrium
  !  flux surfaces.  For these, the equilibrium order if set to 99 or 0
  !  is taken from a scalar stored in s%rzordr -

  integer id_ax1                    ! axis id -- 1st dimension of zdata
  integer id_ax2                    ! axis id -- 2nd dimension of zdata

  !  id_ax1 or id_ax2 must give a rho coordinate; the other coordinate must
  !  be a chi (poloidal angle) coordinate.

  character*(*) zlbl                ! function name (label)
  integer id1                       ! size of 1st dimension of zdata

  REAL*8 zdata(id1,*)               ! data (at least nrho*nchi words)

  !  id1 must be .ge. size of axis (id_ax1)

  !  bdy conditions are enforced only for iorder.ge.1

  integer ibcrho0,ibcrho1           ! BC's at extrema

  !  BC controls are as in "pspline":  0 -- default, 1 -- fix df/drho

  REAL*8 zbcrho0(*)               ! if ibc=1:  df/drho @ rho(1), nchi pts
                                  ! if ibc=2:  d2f/drho2 @ rho(1), nchi pts
  REAL*8 zbcrho1(*)               ! ditto @rho(nrho)

  !     the BC data zbcrho0,zbcrho1 are used iff ibcrho0,ibcrho1 are 1 or 2
  !        otherwise the BC is derived from the main data array
  !     for Hermite fits, ibc values of 0 or 1 (only) are allowed)
  !  output:

  integer id_fun                    ! function id code
  integer ierr                      ! completion code, 0=OK

  !-----------------------------
  ! local
  integer :: icoord1,icoord2,iorderi,iertmp,inx1,inx2,irho12,irzo
  character*32 zname
  real*8, dimension(:), allocatable :: zbc0,zbc1
  logical :: ccwflag
  !-----------------------------

  ierr=0

  iorderi=iorder
  if(iorderi.lt.99) iorderi=max(0,min(2,iorderi))
  if(iorderi.ge.100) iorderi=max(0,min(2,(iorderi-100)))

  if((zlbl.eq.'r').or.(zlbl.eq.'R').or.(zlbl.eq.'z').or.(zlbl.eq.'Z')) then

     !  R & Z names -- special treatment -- R(rho,theta) & Z(rho,theta)
     !  the equilibrium flux surfaces

     call xplasma_global_info(s,ierr, rzOrder=irzo)
     if(ierr.ne.0) then
        call xplasma_error(s,ierr,lunerr)
        return
     endif
     if(iorderi.eq.99) iorderi=irzo
     iorderi=max(irzo,iorderi)

  endif

  !  iorderi=99 gets more special treatment below...

  !--------------------------
  !  check axes

  call xplasma_grid_info(s,id_ax1,ierr, coord=icoord1)
  if(ierr.ne.0) then
     call xplasma_error(s,ierr,lunerr)
     write(lunerr,*) &
          ' ?eqm_frhochi ("',trim(zlbl),'"): id_ax1=',id_ax1,' invalid.'
     ierr=1
  endif
  iertmp=ierr

  call xplasma_grid_info(s,id_ax2,ierr, coord=icoord2)
  if(ierr.ne.0) then
     call xplasma_error(s,ierr,lunerr)
     write(lunerr,*) &
          ' ?eqm_frhochi ("',trim(zlbl),'"): id_ax2=',id_ax2,' invalid.'
     ierr=1
  endif
  ierr=max(ierr,iertmp)
  if(ierr.gt.0) return

  ! OK -- both are x axes at least.  Now, one needs to match the xplasma
  ! module rho and one the xplasma module theta coordinate, order not
  ! important...

  if((icoord1.ne.xplasma_rho_coord).and.(icoord2.ne.xplasma_rho_coord)) then
     ierr=1
     call eq_errmsg(' ?eqm_frhochi: id_ax1 & id_ax2 error: "rho" not found:')
     call xplasma_get_item_info(s,id_ax1,iertmp, name=zname)
     write(lunerr,*) '  id_ax1 = ',id_ax1,' name = ',trim(zname)
     call xplasma_get_item_info(s,id_ax2,iertmp, name=zname)
     write(lunerr,*) '  id_ax2 = ',id_ax2,' name = ',trim(zname)
     return
  endif

  if((icoord1.ne.xplasma_theta_coord).and. &
       (icoord2.ne.xplasma_theta_coord)) then
     ierr=1
     call eq_errmsg(' ?eqm_frhochi: id_ax1 & id_ax2 error: "theta" not found:')
     call xplasma_get_item_info(s,id_ax1,iertmp, name=zname)
     write(lunerr,*) '  id_ax1 = ',id_ax1,' name = ',trim(zname)
     call xplasma_get_item_info(s,id_ax2,iertmp, name=zname)
     write(lunerr,*) '  id_ax2 = ',id_ax2,' name = ',trim(zname)
     return
  endif

  if(icoord1.eq.xplasma_rho_coord) then
     irho12=1
  else
     irho12=2
  endif

  call xplasma_grid_size(s,id_ax1,inx1,iertmp)
  call xplasma_grid_size(s,id_ax2,inx2,iertmp)

  !-----------------
  !  iorderi=99 means request to use prior splining method for this call;
  !  this implies profile must already exist:  check...

  if(iorderi.eq.99) then
     call xplasma_find_item(s,zlbl,id_fun,iertmp)
     if(iertmp.eq.0) then
        call xplasma_prof_info(s,id_fun,ierr, splineType=iorderi)
     else
        ierr=iertmp
     endif
     if(ierr.ne.0) then
        call xplasma_error(s,ierr,lunerr)
        call eq_errmsg(' ?eqm_rhofun: iorder=99 call failed: '//trim(zlbl)// &
             ' does not exist.')
        ierr=1
     endif
  endif

  if(ierr.ne.0) return

  !-----------------
  !  iorderi now contains the desired spline type in all cases, so...

  call xoi_author_set(ierr)

  ccwflag = iccw.eq.1

  if(irho12.eq.1) then
     allocate(zbc0(inx2)); zbc0=0
     allocate(zbc1(inx2)); zbc1=0
     if(ibcrho0.gt.0) zbc0=zbcrho0(1:inx2)
     if(ibcrho1.gt.0) zbc1=zbcrho1(1:inx2)
     call xplasma_create_2dprof(s,zlbl,id_ax1,id_ax2,zdata(1:inx1,1:inx2),&
          id_fun,ierr, &
          iorderi,ibcx1a=ibcrho0,zbcx1a=zbc0,ibcx1b=ibcrho1,zbcx1b=zbc1, &
          ccwflag2=ccwflag)
  else
     allocate(zbc0(inx1)); zbc0=0
     allocate(zbc1(inx1)); zbc1=0
     if(ibcrho0.gt.0) zbc0=zbcrho0(1:inx1)
     if(ibcrho1.gt.0) zbc1=zbcrho1(1:inx1)
     call xplasma_create_2dprof(s,zlbl,id_ax1,id_ax2,zdata(1:inx1,1:inx2),&
          id_fun,ierr, &
          iorderi,ibcx2a=ibcrho0,zbcx2a=zbc0,ibcx2b=ibcrho1,zbcx2b=zbc1, &
          ccwflag1=ccwflag)
  endif

  call xoi_author_clear(iertmp)

  return
end subroutine eqm_frhochi_ccw

subroutine scriscrunch(rin1d, zin1d, jmax, ns, &
     rmc1d, rms1d, ymc1d, yms1d, &
     ic1, inc, imom, ier)
  !
  !  see scriscrunchx (below) for description of arguments.
  !  estimate x and call scriscrunchx
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero
  implicit none
  real(fp), dimension(*) :: rin1d,zin1d
  real(fp), dimension(*) :: rmc1d, rms1d, ymc1d, yms1d
  integer :: jmax, ns
  integer :: ic1, inc, imom, ier
  !
  !-------------------------------------------
  integer :: i, k
  real(fp), dimension(ns) :: rsize, xsize
  !
  !-------------------------------------------
  rsize=zero
  xsize=zero
  !
  do i=inc,ic1,-1
    k=(i-1)*jmax
    rsize(i)=maxval(rin1d(k+1:k+jmax))-minval(rin1d(k+1:k+jmax))
    xsize(i)=rsize(i)/rsize(inc)
  end do
  !
  call scriscrunchx(xsize, rin1d, zin1d, jmax, ns, &
       rmc1d, rms1d, ymc1d, yms1d, &
       ic1,inc,imom,ier)
  !
  return
end subroutine scriscrunch

!-----------------------------------------------------------------------
SUBROUTINE scriscrunchx(xrho,rin1d, zin1d, jmax, ns, &
     rmc1d, rms1d, ymc1d, yms1d, &
     ic1, inc, imom, ier)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero
  use mintrp
  use scrunch_inc1
  !
  !             input:   xrho(1:inc) ... estimated or actual normalized rho
  !                      (recommended based on toroidal flux sqrt(phi/philim))
  !             input:   rin1d, zin1d -- jmax*ns grid vectors. Indexing is
  !                      such that the i-th poloidal point on the j-th radial
  !                      surface, (rin1d(k), zin1d(k)), is given by
  !                      k=(j-1)*jmax+i. Note that the contours must close,
  !                      i.e. rin1d(k1)=rin1d(k2) where k1=(j-1)*jmax+1 and
  !                      k2 = k1 + jmax - 1.
  !
  !             input:   jmax     -- number of poloidal points
  !
  !             input:   ns       -- number of surfaces
  !
  !             output:  rmc1d, rms1d, ymc1d, yms1d -- COS and SIN
  !                      moments stored in 1-d arrays. Indexing is such
  !                      that, eg, rmc1d( (i-1)*(imom+1)+ m+1 ) represents the
  !                      m-th mode at the i-th surface.
  !
  !              input:  ic1:  first surface for which moments are needed
  !                      this should be the first **non-singular** surface
  !                      not the magnetic axis
  !                      e.g. LCENTR+1 in TRCOM
  !
  !                      note:  the magnetic axis position is estimated
  !                             if ic1=1 & no axis position is given.
  !
  !              input:  inc:  last surface for which moments are needed
  !                      this should be the boundary surface.  Generally
  !                      inc = ns.
  !
  !              input:  imom:  number of moments to use
  !                      moments 0:imom are used.
  !
  !  scrunch the inner and outermost surfaces, fit a smooth theta
  !  contour between them, and from this build a complete moments set.
  !
  !  ** caution **
  !  there should be a one to one correspondence in the indexing of the
  !  RIN and ZIN arrays in with the indexing of the rmcx,ymcx
  !  output arrays; i.e. ic1 should point to the first non-singular
  !  surface in both array pairs!
  !
  implicit none
  real(fp), dimension(*) :: rin1d, zin1d,xrho
  real(fp), dimension(*) :: rmc1d, rms1d, ymc1d, yms1d
  !
  real(fp), dimension(:,:,:), allocatable ::  rmcx, ymcx
  !
  logical :: ioflag
  logical :: iasym
  logical :: izak
  data ioflag/.false./               ! descur chat flag
  data iasym/.true./                ! asymmetry flag
  data izak/.false./
  !
  !-----------------------------------------------------------------
  !
  integer :: ns
  integer :: idum
  integer :: ier
  integer :: iok
  integer :: imom,imomuse(ns),jmomuse(0:imom)
  integer :: ic0
  integer :: inum
  integer :: itm
  integer :: ith
  integer :: ict
  integer :: inth
  integer :: inc
  integer :: ic
  integer :: ic1
  integer :: i
  integer :: im
  integer :: is
  integer :: inpts
  integer :: immax
  integer :: k
  integer :: jmax
  integer :: icc(6),icdmin
  real(fp) :: zdel
  real(fp) :: fsq, xtrim
  real(fp), dimension(:,:), allocatable :: rmcx1 ! (0:imom,2)
  real(fp), dimension(:,:), allocatable :: ymcx1 ! (0:imom,2)
  !................................................................
  !...begin heap allocation
  allocate(rmcx1(0:imom,2))
  allocate(ymcx1(0:imom,2))
  allocate(rmcx(ns,0:imom,2), ymcx(ns,0:imom,2))
  !...end heap allocation
  !...begin set dynamic arrays to zero
  rmcx1 = zero
  ymcx1 = zero
  rmcx  = zero
  ymcx  = zero
  !...end set dynamic arrays to zero

  !-----------------------------------------------------------------
  !
  ier = 0

  CALL scrpreset(2*jmax, ns, imom)
 
  if (facmid.le.zero) facmid=0.551_fp
  if (facedg.le.zero) facedg=0.851_fp
  if (facdx0.le.zero) facdx0=0.100_fp
 
  CALL scrmemory(ier)
  if(ier.ne.0) then
    call scraborter(6," scriscrunchx error in scrmemory")
    return
  end if
 
  CALL scrclear
  DO is=1, ns
    k = (is-1)*jmax
    rin(1:jmax,is) = rin1d(k+1:k+jmax)
    zin(1:jmax,is) = zin1d(k+1:k+jmax)
  END DO
  !
  !  arrange for truncation of no. of moments -- zero out the small ones.
  !
  xtrim = 1.0e-4_fp
  !
  imomuse=imom
  jmomuse=1
  do is=1,inc
    if(is.lt.ic1) then
      imomuse(is)=0
      cycle
    else if(is.eq.ic1) then
      imomuse(is)=2
      cycle
    else
      imomuse(is)=imomuse(is-1)
    endif
    if(xrho(is).le.zero) cycle
    imomuse(is)=max(1,imomuse(is))
    if(imomuse(is).eq.imom) cycle
    do
      if(xrho(is)**(imomuse(is)+1).le.xtrim) exit
      imomuse(is)=imomuse(is)+1
      jmomuse(imomuse(is))=is
      if(imomuse(is).eq.imom) exit
    enddo
  enddo

  if(ns.gt.ncmax) then
    write(lunmsg,*) '  ns=',ns,'; ncmax=',ncmax
    CALL scrabwarn(lunmsg,'?iscrunch:  ns exceeds ncmax parameter')
    ier=99
    go to 199
  endif
  !
  !  get mag. axis from nearest non-singular surfaces
  if(ic1.le.1) then
    raxis = (4*SUM(rin(1:jmax,ic1))-SUM(rin(1:jmax,ic1+1)))/(3*jmax)
    zaxis = (4*SUM(zin(1:jmax,ic1))-SUM(zin(1:jmax,ic1+1)))/(3*jmax)
  else
    raxis = SUM(rin(1:jmax,ic1-1))/jmax
    zaxis = SUM(zin(1:jmax,ic1-1))/jmax
  endif
  if(ic1.gt.1) then
    do k=1,ic1-1
      rmcx(k,0,1)=raxis
      ymcx(k,0,1)=zaxis
    enddo
  endif
  !
  !  dmc 23 July 1997 -- compress duplicate points out of RIN,ZIN arrays
  !
  do ic=ic1,inc
    inth=jmax
    ict=1
    do ith=2,inth
      itm=ith-1
      if((rin(itm,ic).eq.rin(ith,ic)).and. &
           (zin(itm,ic).eq.zin(ith,ic)) ) then
        write(lunmsg,6001) ic,itm,ith,rin(itm,ic),zin(itm,ic)
6001    format(/ &
             ' ?iscrunch -- duplicate contour point, surface #',i3, &
             ' theta indices: ',2(1x,i4)/ &
             ' ...R=',1pe12.5,' Z=',1pe12.5)
        ier=1
        go to 199
      else
        ict=ict+1
        if(ict.lt.ith) then
          rin(ict,ic)=rin(ith,ic)
          zin(ict,ic)=zin(ith,ic)
        endif
      endif
    enddo
    ntheta0=ict
    if( abs(rin(1,ic) - rin(ict,ic)) >  1.D-8) then
      write(lunmsg,*) '?iscrunch:  end point does not match starting point.'
      write(lunmsg,*) ' surface ic=',ic,'  nth=',ict
      write(lunmsg,*) ' rin(1,ic) = ',rin(1,ic)
      write(lunmsg,*) ' rin(ict,ic) = ',rin(ict,ic)
      ier = 2
      go to 199
    endif
    if( abs(zin(1,ic) - zin(ict,ic)) > 1.D-8) then
      write(lunmsg,*) '?iscrunch:  end point does not match starting point.'
      write(lunmsg,*) ' surface ic=',ic,'  nth=',ict
      write(lunmsg,*) ' zin(1,ic) = ',zin(1,ic)
      write(lunmsg,*) ' zin(ict,ic) = ',zin(ict,ic)
      ier = 2
      go to 199
    endif
  enddo
  !
  !  scrunch innermost and outermost surface
  inum=inc-ic1+1
  ic0=ic1-1
  !
  icc=0
  icdmin=99
  if(moption.eq.3) then
    !
    !  select surfaces near axis; select that these are
    !  distinct and bound away from axis; if there are too few
    !  radial points they won't be & we revert to a simpler method.
    !
    do i=1,3
      icc(i)=ic0+i*inum*facdx0      ! near axis
      if(i.eq.1) then
        icdmin=min(icdmin,(icc(1)-ic0))
      else
        icdmin=min(icdmin,(icc(i)-icc(i-1)))
      endif
    enddo
    if(icdmin.eq.0) then
      write(lunmsg,*) '%iscrunch: only ', &
           inum,' surfaces: reverting to moption=2 radial fit.'
      moption=2
    endif
  endif
  if(moption.eq.2) then
    icc(1)=ic1
    icc(2)=ic0+inum*facmid         ! one in the middle
    icc(3)=ic0+inum*facedg         ! & one near the edge, for numeric diff
    icc(4)=inc
  else if(moption.eq.3) then
    !
    !  moption.eq.3 OK -- get rest of surfaces.
    !
    icc(4)=ic0+inum*facmid         ! one in the middle
    icc(5)=ic0+inum*facedg         ! & one near the edge, for numeric diff
    icc(6)=inc
  else
    CALL scrabwarn(lunmsg,'?iscrunch:  illegal moption value.')
    ier=99
    go to 199
  endif
  !
  ic=ic1-1
  do i=1,6
    !
    if(icc(i).eq.0) cycle
    !
    !  for moments copying mechanism
    !
    ic=icc(i)
    !
    inth=ntheta0
    !
    !  do the scrunch
    !
    inum=min(17,(imomuse(ic)+1))
    iok=1
    idum=0   ! set to (fortran LUN>0) for scrdescur to save a debug file

    CALL scrdesreg(rin(1,ic),zin(1,ic),inth,inum,idum,ioflag,fsq, &
         iasym,izak,imom,rmcx1,ymcx1,iok)
    !
    if(iok.ne.1) then
      CALL scrabwarn(lunmsg,'?iscrunch:  error code on exit from descur')
      ier=max(1,iok)
      go to 199
    endif
    !
    !  remove any phase twisting -- set theta=0 -->z=zaxis, large radius side
    !  uncomment this to add a twist, for testing...
    !debug            call phasead(rmcx1,ymcx1,imom,imom,0.1)
    ict=0
105 continue
    ict=ict+1
    CALL scradphase(raxis,zaxis,rmcx1,ymcx1,imom,imom,zdel,iok)
    if(iok.ne.1) then
      call scraborter(6, " error calling scradphase from scriscrunchx ")
      ier=max(1,iok)
      goto 199
    end if
    if((abs(zdel).gt.1.0e-10_fp*raxis).or.(ict.eq.1)) go to 105
    !
    !  copy the moments
    !
    do is=1,2
      do im=0,imom
        rmcx(ic,im,is)=rmcx1(im,is)
        ymcx(ic,im,is)=ymcx1(im,is)
      enddo
    enddo
    !
  end do
  !
  !  set up moments for unscrunched surfaces, by interpolation scheme
  !
  inpts = 64
  if(imom.gt.32) inpts = 128

  CALL scrmomintrp(rmcx,ymcx,xrho,imomuse,ic0,icc,ns,imom,inpts,iok,ier)
  if(ier.ne.0) then
    call scraborter(6, " error calling scrmomintrp from scriscrunchx ")
    return
  end if
  !
  DO is=1, ns
    DO im=0, imom
      k = (is-1)*(imom+1) + im + 1
      rmc1d(k) = rmcx(is, im, 1)
      rms1d(k) = rmcx(is, im, 2)
      ymc1d(k) = ymcx(is, im, 1)
      yms1d(k) = ymcx(is, im, 2)
    END DO
  END DO
  !
  !-------------------------------------------------------------------
  !
  ier = iok              ! ier = 0 means ok
 
199 continue
 
  !...begin restore memory
  IF(allocated(rmcx1)) deallocate(rmcx1)
  IF(allocated(ymcx1)) deallocate(ymcx1)
  IF(allocated(rmcx)) deallocate(rmcx)
  IF(allocated(ymcx)) deallocate(ymcx)
  !...end restore memory
  call scrfree

  return
end SUBROUTINE scriscrunchx

! 30Nov1999 fgtok -s r8_precision.sub r8bloat_names.sub "r8con.csh conversion"
C******************** START FILE TKBRY2.FOR ; GROUP TKBLOAT ******************
C-- END FILE #TKBRAD# ************************************
CFORMFEEDC-- START FILE #TKBRY2# ************************************
C------------------------------------------------------------------
      SUBROUTINE r8tkbry2(zrmc,zymc,locmax,nmom,
     >                    ZRM1,ZYM1,ZRM2,ZYM2,ZR0,ZY0,INIT)
C
C============
C idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      INTEGER nmom,init,locmax,ism1,ism2,ith
C============
C idecl:  explicitize implicit REAL declarations:
      REAL*8 zr0,zy0,zr0m2,zy0m2
C============
      REAL*8 zrmc(3,0:locmax,2)
      REAL*8 zymc(3,0:locmax,2)
C
C  mod DMC 29 Dec 1996:
C  passed args added, to avoid later need to refer to COMMON...
C
C  GET DATA ON THE TWO SURFACES INSIDE SURFACE target surface.
C  UNLESS INIT=0 ASSUME 2ND SURFACE GETS VALUES FROM OLD 1ST SURFACE
C  ARRAYS
C
      include 'r8tkbparm.inc'
      REAL*8 ZRM1(NTK),ZYM1(NTK),ZRM2(NTK),ZYM2(NTK)
C
      ISM1=2
      ISM2=1
C
      IF(INIT.EQ.0) THEN
        CALL r8tkbrys(ISM2,zrmc,zymc,locmax,nmom,
     >                ZRM2,ZYM2,ZR0M2,ZY0M2)
      ELSE
        DO 10 ITH=1,NTK
          ZRM2(ITH)=ZRM1(ITH)
          ZYM2(ITH)=ZYM1(ITH)
 10     CONTINUE
      ENDIF
C
      CALL r8tkbrys(ISM1,zrmc,zymc,locmax,nmom,
     >              ZRM1,ZYM1,ZR0,ZY0)
C
      RETURN
      END
C******************** END FILE TKBRY2.FOR ; GROUP TKBLOAT ******************

subroutine eqi_fastinv(ivec,zR,zZ,zphi,zrhomin,zrho_out,zchi_out,iregion,ierr)

  !  eval scrape-off-region (R,Z,phi)->(rho,chi,phi) map.
  !  rho,chi form a nested nonsingular coordinate system, but, no
  !  particular relation to field or flux surfaces.

  !  iregion output:
  !  The SOL is defined by a RxZ grid rectangle.  If an input point
  !  (zR(i),zZ(i)) is not inside this rectangle, iregion(i)=3 is returned.
  !  Otherwise iregion(i)=1 or iregion(i)=2 according as zrho_out(i) is or
  !  is not greater than one.

  !  *** if the map is undefined, create it ***

  use xplasma_definitions
  use eqi_rzbox_module
  implicit NONE

  integer ivec                      ! vector dimension
  real*8 zR(ivec),zZ(ivec),zphi(ivec) ! input positions from which to seek
  real*8 zrhomin                    ! min. allowed rho output

  real*8 zrho_out(ivec)             ! output rho of sol pt
  real*8 zchi_out(ivec)             ! output chi of sol pt
  integer :: iregion(ivec)          ! output region code as described

  integer ierr                      ! completion code, 0=OK

  !-----------------------------------------
  real*8 zRtarg(ivec),zZtarg(ivec)
  real*8 zrmid,zzmid,zcorr(ivec)

  integer, dimension(:), pointer :: ii,jj
  real*8, dimension(:), pointer :: zRoff,zZoff

  integer iadr00,iadr01,iadr10,iadr11,i,nR,nZ
  real*8 zrmin,zrmax,zzmin,zzmax
  logical :: sol

  real*8 zchibr00,zchibr01,zchibr10,zchibr11,zchimin,zchitest

  integer :: id_map,id_Rgrid,id_Zgrid,lrhomap,lchimap
  integer, dimension(:), pointer :: idata
  real*8, dimension(:), pointer :: eqbuf

  type (xpeval) :: R_intrp, Z_intrp

  real*8, parameter :: czero=0.0d0
  real*8, parameter :: chalf=0.5d0
  real*8, parameter :: cone =1.0d0
  real*8, parameter :: ceps =1.0d-15
  real*8, parameter :: c2pi =6.2831853071795862D+00
  real*8, parameter :: cpi  =3.1415926535897931D+00
  !-----------------------------------------

  ierr=0

  call xplasma_RZminmax_extended(sp, zrmin,zrmax, zzmin,zzmax, ierr, sol=sol)
  if(ierr.ne.0) return

  if(.not.sol) then
     ierr=109
     call xplasma_errmsg_append(sp, &
         ' ?? eqi_fastinv.f90 was called, but no scrapeoff region is defined.')
     return
  endif

  call xplasma_find_item(sp,'__FASTMAP',id_map,ierr, nf_noerr=.TRUE.)
  if(ierr.ne.0) return

  call xplasma_find_item(sp,'__Rgrid',id_Rgrid,ierr)
  if(ierr.ne.0) return

  call xplasma_grid_size(sp,id_Rgrid,nR,ierr)
  if(ierr.ne.0) return

  call xplasma_find_item(sp,'__Zgrid',id_Zgrid,ierr)
  if(ierr.ne.0) return

  call xplasma_grid_size(sp,id_Zgrid,nZ,ierr)
  if(ierr.ne.0) return

  if(id_map.eq.0) call eqi_fastinv_gen(id_Rgrid,id_Zgrid,nR,nZ,id_map,ierr)
  if(ierr.ne.0) return

  call xplasma_blackbox_retrieve(sp, id_map, ierr, &
       ia_ptr = idata, r8a_ptr = eqbuf)

  lrhomap = idata(1)
  lchimap = idata(2)

  !  SOL (rho,chi) -- use bilinear approximation

  zrmid=chalf*(zrmin+zrmax)

  zzmid=chalf*(zzmin+zzmax)

  !  rough correction for points beyond the (R,Z) grid

  do i=1,ivec
     zRtarg(i)=max(zrmin,min(zrmax,zR(i)))
     zZtarg(i)=max(zzmin,min(zzmax,zZ(i)))
     if((zR(i).ne.zRtarg(i)).or.(zZ(i).ne.zZtarg(i))) then
        zcorr(i)=sqrt((zR(i)-zrmid)**2+(zZ(i)-zzmid)**2)/ &
             sqrt((zrtarg(i)-zrmid)**2+(zztarg(i)-zzmid)**2)
        zcorr(i)=max(cone+ceps,zcorr(i))
        iregion(i)=3
     else
        zcorr(i)=cone
        iregion(i)=2
     endif
  enddo

  !  lookup...

  call xplasma_x_lookup(sp, id_Rgrid, zRtarg, R_intrp, ierr)
  if(ierr.ne.0) then
     call xpeval_free(R_intrp)
     return
  endif

  call xplasma_x_lookup(sp, id_Zgrid, zZtarg, Z_intrp, ierr)
  if(ierr.ne.0) then
     call xpeval_free(R_intrp)
     call xpeval_free(Z_intrp)
     return
  endif

  call xpeval_info(R_intrp, ierr, ix=ii, dxn=zRoff)
  call xpeval_info(Z_intrp, ierr, ix=jj, dxn=zZoff)

  !  evaluation...

  do i=1,ivec

     !  rho

     iadr00=lrhomap +(jj(i)-1)*nR + ii(i)-1
     iadr01=iadr00+1
     iadr10=iadr00+nR
     iadr11=iadr01+nR

     zrho_out(i)= &
          (cone-zZoff(i))* &
          ((cone-zRoff(i))*eqbuf(iadr00)+ &
                           zRoff(i)*eqbuf(iadr01)) + &
          zZoff(i)* &
          ((cone-zRoff(i))*eqbuf(iadr10)+ &
                           zRoff(i)*eqbuf(iadr11))

     zrho_out(i)=max(zrhomin,zrho_out(i)*zcorr(i))
     if(zrho_out(i).le.cone) iregion(i)=1

     !  chi -- watch for branch cut

     iadr00=lchimap +(jj(i)-1)*nR + ii(i)-1
     iadr01=iadr00+1
     iadr10=iadr00+nR
     iadr11=iadr01+nR

     zchimin=min(eqbuf(iadr00),eqbuf(iadr01),eqbuf(iadr10),eqbuf(iadr11))
     zchitest=zchimin+cpi

     if(eqbuf(iadr00).gt.zchitest) then
        zchibr00=-c2pi
     else
        zchibr00=czero
     endif

     if(eqbuf(iadr01).gt.zchitest) then
        zchibr01=-c2pi
     else
        zchibr01=czero
     endif

     if(eqbuf(iadr10).gt.zchitest) then
        zchibr10=-c2pi
     else
        zchibr10=czero
     endif

     if(eqbuf(iadr11).gt.zchitest) then
        zchibr11=-c2pi
     else
        zchibr11=czero
     endif

     zchi_out(i)= &
          (cone-zZoff(i))* &
          ((cone-zRoff(i))*(eqbuf(iadr00)+zchibr00)+ &
                           zRoff(i)*(eqbuf(iadr01)+zchibr01)) + &
          zZoff(i)* &
          ((cone-zRoff(i))*(eqbuf(iadr10)+zchibr10)+ &
                           zRoff(i)*(eqbuf(iadr11)+zchibr11))

  enddo

  nullify(ii,jj,zRoff,zZoff,idata,eqbuf)
  call xpeval_free(R_intrp)
  call xpeval_free(Z_intrp)

end subroutine eqi_fastinv

subroutine eqi_fastinv_gen(id_Rgrid,id_Zgrid,nR,nZ,id_map,ierr)

  ! generate fast inverse map on RxZ extended grids

  use xplasma_definitions
  use eqi_rzbox_module
  implicit NONE

  !-----------

  integer, intent(in) :: id_Rgrid,id_Zgrid  ! grid IDs
  integer, intent(in) :: nR,nZ              ! grid sizes

  integer, intent(out) :: id_map            ! "blackbox" id
  integer, intent(out) :: ierr              ! status code, 0=OK

  !-----------
  real*8 :: Rgrid(nR),Zgrid(nZ),Ztmp(nR)
  real*8, dimension(:), allocatable :: Rtarg,Ztarg,phidum
  real*8, dimension(:), pointer :: r8data
  integer, dimension(:), allocatable :: iregion
  real*8 :: reltol,rtol
  integer :: idata(2),ii,jj,iR,iZ,iertmp,itype
  real*8 :: zrho_bdy
  !-----------

  call xplasma_grid(sp, id_Rgrid, Rgrid, ierr)
  if(ierr.ne.0) return

  call xplasma_grid(sp, id_Zgrid, Zgrid, ierr)
  if(ierr.ne.0) return

  call xplasma_global_info(sp, ierr, bdytol=reltol)
  if(ierr.ne.0) return

  if(reltol.lt.1.0d-13) reltol=1.0d-13

  allocate(Rtarg(nR*nZ),Ztarg(nR*nZ))
  allocate(phidum(nR*nZ),iregion(nR*nZ))

  call eqi_extrap_rho_bdy(zrho_bdy)

  call xplasma_author_set(sp, xplasma_xmhd,iertmp)

  do 
     rtol=Rgrid(nR)*reltol

     ii=0
     jj=nR*nZ

     idata(1)=ii+1
     idata(2)=jj+1

     itype=77 ! arbitrary type code
     call xplasma_create_blackBox(sp,'__FASTMAP',itype,id_map,ierr, &
          iarray=idata, r8asize=2*nR*nZ, label='fast inverse map data', &
          r8a_ptr=r8data)
     if(ierr.ne.0) exit

     do iZ=1,nZ
        Ztmp=Zgrid(iZ)
        call xplasma_rhoth_inv(sp,Rgrid,Ztmp, &
             r8data(ii+1:ii+nR),r8data(jj+1:jj+nR),iregion(1:nR),ierr)
        if(ierr.ne.0) exit
        Rtarg(ii+1:ii+nR)=Rgrid
        Ztarg(ii+1:ii+nR)=Ztmp
        Phidum(ii+1:ii+nR)=0
        ii=ii+nR
        jj=jj+nR
     enddo
     if(ierr.ne.0) exit

     ! refine this...
     call eqi_xinv2d(nR*nZ,r8data(1:nR*nZ),r8data(nR*nZ+1:2*nR*nZ),Phidum, &
          Rtarg,Ztarg,iregion,reltol,rtol,zrho_bdy,ierr)
     if(ierr.ne.0) exit

     exit
  enddo

  call xplasma_author_clear(sp, xplasma_xmhd,iertmp)
  nullify(r8data)

end subroutine eqi_fastinv_gen

#include "fpreproc/byte_declare.h"

!
! fortran version of MdsCacheConnect(char*)
!
function MdsCacheConnect(server) result(istat)
  character*(*), intent(in) :: server   ! server for cached connection
  
  integer      :: istat                        ! socket
  byte_declare :: cserver(len_trim(server)+1)  ! C string

  integer, external :: c_MdsCacheConnect

  call cstring(trim(server), cserver, '2C')

  istat = c_MdsCacheConnect(cserver)
end function MdsCacheConnect

subroutine fluxav_lunerr_set(ilun)
 
!  set fortran logical unit no. for error messages
 
  use fluxav
  implicit NONE
  integer ilun
 
  lunerr = ilun
 
  return
 
end subroutine fluxav_lunerr_set
 
 
subroutine fluxav_lunerr_get(ilun)
 
!  get fortran logical unit no. for error messages
 
  use fluxav
  implicit NONE
  integer ilun
 
  ilun = lunerr
 
  return
 
end subroutine fluxav_lunerr_get
 
 
 
subroutine fluxav_thlims_set(thmin,thmax,ierr)
 
!  set upper & lower limits of poloidal angle coordinate
!  these should differ by something very close to twopi.
 
  use fluxav
  implicit NONE
  real*8 thmin,thmax
  integer ierr
 
  ierr = 0
  if(abs((thmax-thmin)-twopi).gt.1.0e-4) then
     write(lunerr,*) ' ?fluxav_thlims_set:  thmax-thmin .ne. twopi:'
     write(lunerr,*) '  thmin = ',thmin,'  thmax = ',thmax
     write(lunerr,*) '   diff = ',thmax-thmin,'  twopi = ',twopi
     write(lunerr,*) '  no action taken.'
     ierr=1
     return
  endif
 
  theta_min = thmin
  theta_max = thmax
 
  return
 
end subroutine fluxav_thlims_set
 
 
subroutine fluxav_phlims_set(phmin,phmax,ierr)
 
!  set upper & lower limits of toroidal angle coordinate
!  these should differ by something very close to twopi.
 
  use fluxav
  implicit NONE
  real*8 phmin,phmax
  integer ierr
 
  ierr = 0
  if(abs((phmax-phmin)-twopi).gt.1.0e-4) then
     write(lunerr,*) ' ?fluxav_phlims_set:  phmax-phmin .ne. twopi:'
     write(lunerr,*) '  phmin = ',phmin,'  phmax = ',phmax
     write(lunerr,*) '   diff = ',phmax-phmin,'  twopi = ',twopi
     write(lunerr,*) '  no action taken.'
     ierr=1
     return
  endif
 
  phi_min = phmin
  phi_max = phmax
 
  return
 
end subroutine fluxav_phlims_set

! 21Jul1999 fgtok -impno -s r8_precision.sub "r8con.csh conversion"
 
      subroutine srcom_r8 (rsav, isav, job)
c-----------------------------------------------------------------------
c this routine saves or restores (depending on job) the contents of
c the common blocks ls0001 and eh0001, which are used internally
c by one or more odepack solvers.
c
c rsav = real array of length 218 or more.
c isav = integer array of length 41 or more.
c job  = flag indicating to save or restore the common blocks..
c        job  = 1 if common is to be saved (written to rsav/isav)
c        job  = 2 if common is to be restored (read from rsav/isav)
c        a call with job = 2 presumes a prior call with job = 1.
c-----------------------------------------------------------------------
      IMPLICIT NONE
      integer isav(*), job
      integer ieh, ils
      integer i, lenils, lenrls
      REAL*8 rsav(*),   rls
      common /ls0001/ rls(218), ils(39)
      common /eh0001/ ieh(2)
      data lenrls/218/, lenils/39/
c
      if (job .eq. 2) go to 100
c
      do 10 i = 1,lenrls
 10     rsav(i) = rls(i)
      do 20 i = 1,lenils
 20     isav(i) = ils(i)
      isav(lenils+1) = ieh(1)
      isav(lenils+2) = ieh(2)
      return
c
 100  continue
      do 110 i = 1,lenrls
 110     rls(i) = rsav(i)
      do 120 i = 1,lenils
 120     ils(i) = isav(i)
      ieh(1) = isav(lenils+1)
      ieh(2) = isav(lenils+2)
      return
c----------------------- end of subroutine srcom -----------------------
      end

subroutine eqx_dist(ivec,xx,yy,zz,zdist,ilpt,rlim,zlim,philim,ierr)

  !  **vectorized**
  !  compute distance from limiter: .gt.0 means outside bdy
  !  .lt.0 means inside, # gives actual distance in (R,Z) units
  !  relative to nearest limiting object.

  !  if switch is set, also return coordinates of nearest contact
  !  point on the limiting object.

  implicit NONE

  ! input:
  integer ivec                      ! vector dimension
  real*8 xx(ivec),yy(ivec),zz(ivec) ! locations

  integer ilpt                      ! =1 to calculate nearest limiter pt

  ! output:
  real*8 zdist(ivec)                ! signed distance from bdy/limiter
  integer ierr                      ! completion code, 0=OK

  ! set if ilpt=1:
  real*8 rlim(ivec),zlim(ivec),philim(ivec) ! nearest limiter contact pt

  !--------------------------
  real*8 zR(ivec),zphi(ivec)
  !--------------------------

  call eq_rcyl(ivec,xx,yy,zR,zphi)
  call eq_rzdist(ivec,zR,zZ,zphi,zdist,ilpt,rlim,zlim,philim,ierr)

end subroutine eqx_dist

!----------------------------------------------------------------------
subroutine eq_rzdist(ivec,zR,zZ,zphi,zdist,ilpt,rlim,zlim,philim,ierr)

  !  **vectorized**
  !  compute distance from limiter: .gt.0 means outside limiter
  !  .lt.0 means inside, # gives actual distance in (R,Z) units
  !  relative to nearest limiting object.

  !  if switch is set, also return coordinates of nearest contact
  !  point on the limiting object.

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  ! input:
  integer ivec                      ! vector dimension
  real*8 zR(ivec),zZ(ivec),zphi(ivec) ! location

  integer ilpt                      ! =1 to calculate nearest limiter pt

  ! output:
  real*8 zdist(ivec)                ! signed distance from bdy/limiter
  integer ierr                      ! completion code, 0=OK

  real*8 rlim(ivec),zlim(ivec),philim(ivec) ! nearest limiter contact pt

  !---------------------------------------------------
  logical :: axisymm
  !---------------------------------------------------

  call xplasma_global_info(s,ierr, axisymm=axisymm)
  if(.not.axisymm) then
     write(lunerr,*) ' ?eq_rzdist: non-axisymmetric geometry not supported!'
     ierr=1
     return
  endif

  call xplasma_lim_distance(s,zR,zZ,zdist,ierr, rlim=rlim,zlim=zlim)

  philim = 0
  if(ierr.ne.0) then
     rlim = 0
     zlim = 0
     write(lunerr,*) ' ?error detected in eq_rzdist:'
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_rzdist

module xplasma_nclass

  !  code to compute NCLASS Pfirsch-Schlutter moments and related profiles
  !  ported from old_xplasma DMC Feb 2008

  use xplasma_obj
  use xplasma_flxint
  use xplasma_rzgeo
  use xplasma_ctran
  implicit NONE

  private

  public :: xplasma_psmom, xplasma_ftrap

  !--------------------------
  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: ZSMALL = 1.0d-10
  !--------------------------

  ! (originally from eq_psmom_mod...)

  ! -- parameters --
  integer, parameter :: r8 = kind(0.0D0)                   ! primary kind

  real(kind=r8), parameter :: znc_pi    = 3.1415926535897932_r8 ! pi

  real(kind=r8), parameter :: zrho_min  = 1.e-7_r8         ! rho not allowed below this for xplasma
  real(kind=r8), parameter :: zmax_theta_error = 1.e-3_r8  ! ztheta array must span 2pi within this tolerance
                                                           ! the boundary
  ! -- flags for flow control --
  integer, parameter :: itest=0              ! nonzero for testing

  ! -- xplasma signs --
  integer :: nsnccwb                         ! +1 if Btoroidal  is ccw, -1 o.w.
  integer :: nsnccwi                         ! +1 if plasma current  is ccw, -1 o.w.
  integer, parameter :: ichi_ccw = 1         ! +1 if chi increases ccw, -1 o.w. [ update Sept2006, assume ccw ]

  ! -- existing xplasma function ids --
  integer :: id_rho, id_chi            ! xplasma internal grid codes __RHO, __CHI
  integer :: id_br,  id_bz, id_bmod    ! xplasma internal b field codes BR, BZ, BMOD
  integer :: id_psi                    ! PSI

  ! -- rho,theta grids --
  integer :: nc_rhob                   ! size of xplasma boundary grid
  integer :: nc_theta                  ! size of poloidal grid
  integer :: nc_points                 ! number of rho points to evaluate 
                                             ! nclass quantities
  logical :: is_rhob                   ! .true. if the points and rhob arrays are 
                                             ! the same
  real(kind=r8) :: zrho_axis           ! rhos below this value are considered axis values

  real(kind=r8), allocatable, dimension(:) :: zrhob        ! boundary rho
  real(kind=r8), allocatable, dimension(:) :: ztheta       ! poloidal angle
  real(kind=r8), allocatable, dimension(:) :: ztheta_xp    ! xplasma poloidal angle (may be weird because of chi_cwdir change)
  real(kind=r8), allocatable, dimension(:) :: zpoints      ! rho points to use for nclass quantities

  ! -- moments --
  integer :: nc_mom                          ! number of moments desired for Fm

  ! -- new xplasma function ids --
  integer :: id_bigtheta                     ! xplasma code for computed BIGTHETA if is_rhob
  integer :: id_gamma                        ! xplasma code for computed GAMMA if is_rhob


  ! -- computed quantities --
  real(kind=r8), allocatable, dimension(:,:) :: zbigtheta  ! the BIG theta on the chi,points grid
  real(kind=r8), allocatable, dimension(:)   :: zgamma     ! gamma  at the points
  real(kind=r8), allocatable, dimension(:)   :: zdvol      ! dV/dxi at the points, at axis d2V/dxi2
  real(kind=r8), allocatable, dimension(:)   :: zdpsi      ! dpsi/dxi at the points, at axis d2psi/dxi2
  real(kind=r8), allocatable, dimension(:)   :: zngb2      ! <(n.grad(B))**2> at the points

  real(kind=r8), allocatable, dimension(:)   :: zb2        ! <B**2> at the points
  real(kind=r8), allocatable, dimension(:)   :: zbgrth     ! <B.grad(theta)> at the points
  real(kind=r8)                              :: zbmod_zero ! Bmod at axis

  real(kind=r8), allocatable, dimension(:,:) :: zmom_a     ! Am moment
  real(kind=r8), allocatable, dimension(:,:) :: zmom_b     ! Bm moment
  real(kind=r8), allocatable, dimension(:,:) :: zmom_c     ! Cm moment
  real(kind=r8), allocatable, dimension(:,:) :: zmom_d     ! Dm moment
  real(kind=r8), allocatable, dimension(:,:) :: zmom_f     ! Fm Pfirsch-Schluter moment (m,irho)

  !
  ! --- working variables ---
  ! iztotal may not be changed, the rest can be used in any subroutine
  !
  integer :: iztotal                              ! maximum number of points needed in 
                                                  ! xplasma call

  real(kind=r8), dimension(:),     allocatable :: zrho, zchi       ! for xplasma call
  real(kind=r8), dimension(:,:),   allocatable :: zans             ! hold B fields
  real(kind=r8), dimension(:,:,:), allocatable :: zgans            ! hold dB/dR,dB/dZ field
  real(kind=r8), allocatable :: zdet(:), ztens(:,:,:)              ! holds metrics

  real(kind=r8), dimension(:,:),   allocatable :: zintegrand1      ! integrand for defining THETA
  real(kind=r8), dimension(:,:),   allocatable :: zintegrand2      ! integrand for dV/dxi
  real(kind=r8), dimension(:,:),   allocatable :: zintegrand3      ! integrand for <(n.grad(B))**2>
  real(kind=r8), dimension(:,:),   allocatable :: zintegrand4      ! integrand for <B**2>
  real(kind=r8), dimension(:,:),   allocatable :: zresult1,zresult2,zresult3   ! surface integration 
  real(kind=r8), dimension(:,:),   allocatable :: zresult4                     ! surface integration

  real(kind=r8) :: br,bz,bmod                              ! B fields
  real(kind=r8) :: db_drho, db_dtheta                      ! dB/drho, dB/dtheta
  real(kind=r8) :: drho_dR, drho_dZ, dtheta_dR,dtheta_dZ   ! jacobian elements
  real(kind=r8) :: jacob                                   ! 2D jacobian
  real(kind=r8) :: db_dR, db_dZ                            ! dB/dR, dB/dZ

contains
  
  !
  ! ----------------- xplasma_ftrap ----------------
  ! Compute the trapping fraction from the integral
  !
  !      ftrap = 1 - (3/4)*<h^2>*integral_0to1[ lambda/<sqrt(1-lambda*h)>  dlambda]
  !          h = B/Bmax
  !
  ! The integral is done over alpha, where lambda=sin(pi/2 * alpha).  The alpha
  ! integrand has the form,
  !        lambda_integrand = lambda/<sqrt(1-lambda*h)>
  !        alpha_integrand  = (pi/2)*sqrt(1-lambda^2)*lambda_integrand
  !
  subroutine xplasma_ftrap(s, rho, ftrap, ier, rhomin, nsimp, integrand, lambda, b2)

    type (xplasma), pointer :: s   ! object for which to compute profiles...

    real*8,  intent(in)  :: rho(:)     ! radial coordinate
    real*8,  intent(out) :: ftrap(:)   ! trapping fraction
    integer, intent(out) :: ier        ! nonzero on error

    real*8,  intent(in),  optional :: rhomin          ! rho values below this are deemed on axis
    integer, intent(in),  optional :: nsimp           ! number of simpson intervals to use
    real*8,  intent(out), optional :: integrand(:,:)  ! lambda integrand at each simpson point ; nsimp must be defined
                                                      ! and this should have shape [2*nsimp+1, size(rho)]
    real*8,  intent(out), optional :: lambda(:)       ! when integrand is given, this is lambda at each simpson point
                                                      ! and this should have shape [2*nsimp+1]
    real*8,  intent(out), optional :: b2(:)           ! <B2> for checking flux surface integration [size(rho)]
 
    integer, parameter :: ipts = 5    ! number of gaussian points is 2*ipts between theta grid points using the xplasma standard

    integer :: iveca            ! number of output points
    integer :: isize2,isize2_1  ! theta grid size and interval size
    integer :: isinteg          ! number of quadrature points on one flux surface
    integer :: isall            ! total number of quadrature points on each flux surface
    integer :: i,j,k,ixp,ith,ii ! temps
    integer :: ksimp            ! number of simpson intervals for alpha integral
    integer :: ilamb            ! loop over lambda quadrature points
    integer :: maxsimp          ! totalnumber of simpson points

    real(r8) :: x5(ipts),w5(ipts)  ! gaussian points and weights
    real(r8) :: zxcen, zdx2        ! center and half-width of theta interval
    real(r8) :: dalpha             ! interval size in alpha
    real(r8) :: wlamb              ! lambda quadrature weight
    real(r8) :: xlamb              ! lambda value
    real(r8) :: nlamb              ! lambda quadrature numerator
    real(r8) :: zz                 ! temp

    real(r8), allocatable :: ztheta(:)   ! theta at interval boundaries
    real(r8), allocatable :: zth(:)      ! theta at all quadrature points
    real(r8), allocatable :: wth(:)      ! weight at all quadrature points
    real(r8), allocatable :: rhovec(:)   ! rho at all quadrature and radial points
    real(r8), allocatable :: thvec(:)    ! theta at all quadrature and radial points
    real(r8), allocatable :: bmax(:)     ! Bmax at radial points
    real(r8), allocatable :: zdet(:)     ! jacobian at all points
    real(r8), allocatable :: rvec(:)     ! R at all points
    real(r8), allocatable :: h(:)        ! B/Bmax at all points
    real(r8), allocatable :: h2(:)       ! dVol/dxi*<h^2> at radial points

    ier   = 0
    iveca = size(rho)

    call xplasma_global_info(s, ier, init_check=.TRUE.)
    if(ier.ne.0) then
       ier=777 ; return
    endif

    if(iveca<=0 .or. size(ftrap)/=iveca) then
       call xplasma_errmsg_append(s, '?xplasma_ftrap:"rho" dimension inconsistency')
       ier=9999 ;return
    endif

    if (present(nsimp)) then
       if (nsimp<1) then
          call xplasma_errmsg_append(s, '?xplasma_ftrap: bad nsimp argument')
          ier=1 ; return
       end if
       ksimp = nsimp
    else
       ksimp = 64   ! hard coded, this gives a max error around 1.e-6 at innermost flux surfaces
    end if

    if (present(integrand)) then
       if (.not. present(nsimp)) then
          call xplasma_errmsg_append(s, '?xplasma_ftrap: nsimp argument must be present with integrand argument')
          ier=1 ; return
       end if

       if (size(integrand,1)/=(2*nsimp+1) .or. size(integrand,2)/=iveca) then
          call xplasma_errmsg_append(s, '?xplasma_ftrap: integrand  dimension inconsistency')
          ier=9999 ; return
       endif

       if (present(lambda)) then
          if (size(lambda)/=(2*nsimp+1)) then
             call xplasma_errmsg_append(s, '?xplasma_ftrap: lambda dimension inconsistency')
             ier=9999 ;return
          end if
          lambda = 0.d0
       end if

       integrand = 0.d0
    end if          
          
    if (present(b2)) then
       if (size(b2)/=iveca) then
          call xplasma_errmsg_append(s, '?xplasma_ftrap: b2 dimension inconsistency')
          ier=9999 ;return
       end if
    endif

    ier    = 0
    isize2 = 0
    ftrap  = 0._r8

    call xplasma_integ_g10info(x5,w5)    ! grab gaussian quadrature data

    if (present(rhomin)) then
       zrho_axis = rhomin
    else
       zrho_axis = zrho_min
    end if

    zrho_axis = min(0.2_r8,max(zrho_min,zrho_axis))

    if (ier==0) call xnc_get_id(s, "__CHI", 0, id_chi,  ier) 
    if (ier==0) call xnc_get_id(s, "BMOD",  1, id_bmod, ier) 
    if (ier==0) call xplasma_grid_size(s,id_chi,isize2, ier)

    if (ier/=0 .or. isize2<=2) then
       call xplasma_errmsg_append(s, '? xplasma_ftrap: Unable to get some of the xplasma IDs')
       ier=1 ; return
    end if

    ! -- exit through 100 from now on --

    isize2_1 = isize2-1
    isinteg  = isize2_1*2*ipts
    isall    = isinteg*iveca

    allocate(ztheta(isize2),zth(isinteg),wth(isinteg))
    allocate(rhovec(isall), thvec(isall), bmax(iveca), zdet(isall), h(isall))
    allocate(h2(iveca), rvec(isall))

    ! -- get theta grid points --
    do i=1,isize2
       ztheta(i) = (-znc_pi) + real(i-1,r8)*2.0_r8*znc_pi/isize2_1
    end do

    ! -- get theta quadrature points, weights --
    ixp = -2*ipts
    do ith = 1, isize2_1   ! loop over theta grid intervals       
       ixp=ixp+2*ipts
       
       zxcen= (ztheta(ith+1)+ztheta(ith))/2._r8
       zdx2 = (ztheta(ith+1)-ztheta(ith))/2._r8
       
       do ii=1,ipts
          zth(ixp+ii)      = zxcen+x5(ii)*zdx2
          zth(ixp+ipts+ii) = zxcen-x5(ii)*zdx2
          wth(ixp+ii)      = w5(ii)*zdx2
          wth(ixp+ipts+ii) = w5(ii)*zdx2
       enddo
    end do
    
    ! -- get rho,theta at all points and Bmax on flux surface --
    ixp=0
    do k=1, iveca
       call xplasma_Bminmax(s, rho(k), ier, bmax=bmax(k))

       if (ier/=0) then
          call xplasma_errmsg_append(s, '? xplasma_ftrap: error finding Bmax on flux surface')
          ier=1 ; goto 100
       else if (bmax(k)<=0._r8) then
          call xplasma_errmsg_append(s, '? xplasma_ftrap: zero B field on flux surface')
          ier=1 ; goto 100
       end if

       do j = 1, isinteg
          ixp = ixp+1
          rhovec(ixp) = rho(k)
          thvec(ixp)  = zth(j)
       end do
    end do

    ! -- Jacobian at all points --
    call xplasma_rzjac(s, rhovec, thvec, ier, rzdetj=zdet, r=rvec)

    if (ier/=0) then
       call xplasma_errmsg_append(s, '? xplasma_ftrap: bad call to xplasma_rzjac')
       ier=1 ; goto 100
    end if

    zdet = rvec*abs(zdet)

    ! -- form h=B/Bmax at all points and get h2 --
    call xplasma_eval_prof(s, id_bmod, &
         xplasma_rho_coord,   rhovec, &
         xplasma_theta_coord, thvec, &
         h, ier)

    if (ier/=0) then
       call xplasma_errmsg_append(s, '? xplasma_ftrap: bad call to xplasma_eval_prof for Bmod')
       ier=1 ; goto 100
    end if

    ixp=0
    do k=1, iveca
       h2(k) = 0._r8
       do ii = 1, isinteg
          ixp = ixp+1
          h(ixp) = min(1._r8, h(ixp)/bmax(k))

          h2(k) = h2(k) + wth(ii) * zdet(ixp) * h(ixp)**2
       end do
    end do

    if (present(b2)) then
       do k=1, iveca
          if (rho(k)<=zrho_axis) then
             b2(k) = bmax(k)**2
          else
             ixp = (k-1)*isinteg
             zz  = sum(wth(1:isinteg)*zdet(ixp+1:ixp+isinteg))  ! flux surface integration

             if (zz<=0._r8) then
                call xplasma_errmsg_append(s, '? xplasma_ftrap: bad dV/dxi for <B2>')
                ier=1 ; goto 100
             end if

             b2(k) = bmax(k)**2 * h2(k)/zz
          end if
       end do
    end if

    ! -- now do integration over alpha, lambda=sin((pi/2)*alpha) --
    dalpha = 1._r8/(2*ksimp)

    maxsimp = 2*ksimp+1

    do ilamb = 2, maxsimp          ! loop over simpson points, lambda=0 has a zero integrand
       if (mod(ilamb,2)==0) then
          wlamb = 4._r8*dalpha/3._r8
       else 
          wlamb = 2._r8*dalpha/3._r8
       end if

       if (ilamb==maxsimp) then
          if (.not. present(integrand)) cycle  ! alpha integrand is zero in this case

          xlamb = 1._r8            ! because znc_pi isn't quite pi
          nlamb = 0._r8
          wlamb = 0._r8            ! integrand in lambda is nonzero so need to do this step
       else
          xlamb = sin(znc_pi*(ilamb-1)*dalpha/2._r8)
          nlamb = sin(znc_pi*(ilamb-1)*dalpha)
       end if


       if (present(integrand) .and. present(lambda)) lambda(ilamb)=xlamb

       do k=1, iveca               ! loop over each flux surface
          if (rho(k)<=zrho_axis) then
             ftrap(k) = 0._r8
             if (present(integrand)) integrand(ilamb,k)= xlamb/max(.01_r8,sqrt(1._r8-xlamb))
          else
             ixp = (k-1)*isinteg
             zz  = sum(wth(1:isinteg)*zdet(ixp+1:ixp+isinteg)*sqrt(1._r8-xlamb*h(ixp+1:ixp+isinteg)))  ! flux surface integration

             if (zz<=0._r8) then
                call xplasma_errmsg_append(s, '? xplasma_ftrap: bad denominator in lambda integrand')
                ier=1 ; goto 100
             end if
             
             ftrap(k) = ftrap(k) + wlamb*(nlamb/zz)                   ! add integrand in alpha
             
             if (present(integrand)) integrand(ilamb,k)=xlamb/zz      ! integrand in lambda
          end if
       end do
    end do

    where (rho>zrho_axis)
       ftrap = max(1._r8 - 0.75_r8*h2*(znc_pi/4._r8)*ftrap, 0._r8)
    else where
       ftrap = 0._r8
    end where

100 continue
    if (allocated(ztheta)) deallocate(ztheta, zth, wth)
    if (allocated(rhovec)) deallocate(rhovec, thvec, bmax, zdet, h)
    if (allocated(h2))     deallocate(h2, rvec)

  end subroutine xplasma_ftrap

  !------------------------------------------
  !  THIS the only PUBLIC entry point...

  subroutine xplasma_psmom(s, &
       rho, rhomin, psmom, gamma, ngrdb2, b2, zerror, ier)

    type (xplasma), pointer :: s   ! object for which to compute profiles...

    real*8,  intent(in), dimension(:) :: rho        ! radial coordinate
    real*8,  intent(in) :: rhomin  ! rho values below this are deemed on axis

    real*8,  intent(out), dimension(:,:) :: psmom   ! PS moments
    !  FIRST dimension: moment index; SECOND dimension: radial coordinate
    real*8,  intent(out), dimension(:) :: gamma     ! wayne's gamma 
         ! = 2*pi/integral_0_2pi[Bmod/B.grad(theta)]_dtheta
    real*8,  intent(out), dimension(:) :: ngrdb2    ! <(n.grad(B))**2>
    real*8,  intent(out), dimension(:) :: b2        ! <B**2>
    real*8,  intent(out), dimension(:) :: zerror    ! convergence estimate
         ! |sum(Fm) - <(n.grad(B))**2>/<B**2>| / max(<(n.grad(B))**2>/<B**2>)

    integer, intent(out) :: ier                ! nonzero on error
    ! ier=777 means the passed xplasma pointer is invalid or the object
    !         has not been initialized.

    ! (rho) vector must be monotonic incureasing; 
    !       size of all 1d outputs must match size(rho)

    !       size(psmom,2) = size(rho) also expected.

    !----------------------
    real*8 :: yr02                             ! max(<(n.grad(B))**2>/<B**2>)
    integer :: i,iveca,nmom
    !----------------------

    ier = 0
    iveca=size(rho)
    nmom =size(psmom,1)
    if((iveca.le.0).or.(nmom.le.0)) then
       ier=9999
       call xplasma_errmsg_append(s, &
            'xplasma_psmom: "rho" or "psmom" has empty dimension.')
       return
    endif

    call xplasma_global_info(s,ier, init_check=.TRUE.)
    if(ier.ne.0) then
       ier=777
       return
    endif

    if(size(psmom,2).ne.iveca) ier=ier+1
    if(size(gamma).ne.iveca) ier=ier+1
    if(size(ngrdb2).ne.iveca) ier=ier+1
    if(size(b2).ne.iveca) ier=ier+1
    if(size(zerror).ne.iveca) ier=ier+1

    if(ier.ne.0) then
       ier=9999
       call xplasma_errmsg_append(s, &
            ' "rho" dimension inconsistency in xplasma_psmom')
       return
    endif

    ier=0
    do
       call xnc_get_grid(s, rhomin, ier)                  ; if (ier/=0) exit
       call xnc_set_points(iveca, rho, nmom, ier)         ; if (ier/=0) exit
       call xnc_allocate
  
       psmom = ZERO
       gamma = ZERO
       ngrdb2 = ZERO
       b2 = ZERO
       zerror = ZERO

       call xnc_get_bigtheta(s,ier)  ; if (ier/=0) exit
       call xnc_get_abcd(s,ier)      ; if (ier/=0) exit

       psmom = zmom_f
  
       gamma = zgamma
       ngrdb2 = zngb2
       b2 = zb2

       yr02 = max(1.D-20, maxval(zngb2(1:iveca)/zb2(1:iveca)))
       do i = 1, iveca
          zerror(i) = abs(sum(psmom(1:nmom,i)) - zngb2(i)/zb2(i))/yr02
       end do

       exit
    enddo

    if(ier.ne.0) then
       ier=9999
    endif

    call xnc_free

  end subroutine xplasma_psmom

  !========================================================================
  ! all the rest of the code is PRIVATE...
  !========================================================================

  ! ------------------------- xnc_free ------------------------------------
  ! free up the allocated memory
  !
  subroutine xnc_free
    if(allocated(zbigtheta)) &
         deallocate(zbigtheta,zgamma,zdvol,zdpsi,zngb2,zb2,zbgrth)

    if(allocated(zmom_a)) &
         deallocate(zmom_a, zmom_b, zmom_c, zmom_d, zmom_f)

    if(allocated(zrho)) &
         deallocate(zrho, zchi, zdet)

    if(allocated(zans)) &
         deallocate(zans, zgans, ztens)

    if(allocated(zintegrand1)) &
         deallocate(zintegrand1,zintegrand2,zintegrand3,zintegrand4)

    if(allocated(zresult1)) &
         deallocate(zresult1,zresult2,zresult3,zresult4)

    if(allocated(zrhob)) &
         deallocate(zrhob,ztheta,ztheta_xp)

    if(allocated(zpoints)) deallocate(zpoints)

  end subroutine xnc_free

  ! ------------------------- xnc_get_grid ------------------------------------
  ! get size nc_rhob, nc_theta and data zrhob,ztheta for xplasma grids and 
  ! get the basic xplasma profile ids
  !
  subroutine xnc_get_grid(s,rhomin, ier)

    type (xplasma), pointer :: s   ! object for which to compute profiles...

    real*8,  intent(in)   :: rhomin    ! rhos below this should be considered axis values
    integer, intent(out)  :: ier       ! nonzero on error

    !--------------------

    integer :: isize1, isize2   ! temporary array size
    integer :: ierr1, ierr2     ! error codes
    integer :: i                ! loop variable

    !--------------------

    ier=0
    zrho_axis = rhomin

    !
    ! --- toroidal signs ---
    ! 

    call xplasma_global_info(s,ier, bphi_ccw=nsnccwb, jphi_ccw=nsnccwi)
    if (nsnccwb==0 .or. nsnccwi==0) then
       call xplasma_errmsg_append(s, &
            '? xnc_get_grid: xplasma not initialized -- nsnccwb=0')
       goto 100
    end if

    !
    ! --- get ids ---
    !
    ierr1=0
    call xnc_get_id(s, "__RHO", 0, id_rho,  ierr2) ; ierr1=ierr1+ierr2
    call xnc_get_id(s, "__CHI", 0, id_chi,  ierr2) ; ierr1=ierr1+ierr2
    call xnc_get_id(s, "BR",    1, id_br,   ierr2) ; ierr1=ierr1+ierr2
    call xnc_get_id(s, "BZ",    1, id_bz,   ierr2) ; ierr1=ierr1+ierr2
    call xnc_get_id(s, "BMOD",  1, id_bmod, ierr2) ; ierr1=ierr1+ierr2
    call xnc_get_id(s, "PSI",   1, id_psi,  ierr2) ; ierr1=ierr1+ierr2

    if (ierr1>0) then
       call xplasma_errmsg_append(s, &
            '? xnc_get_grid: Unable to get some of the xplasma IDs')
       goto 100
    end if

    call xplasma_grid_size(s,id_rho,isize1,ierr1)
    call xplasma_grid_size(s,id_chi,isize2,ierr2)

    if( isize1*isize2 > 0 ) then
       nc_rhob=isize1
       nc_theta=isize2

       allocate(zrhob(nc_rhob),ztheta(nc_theta),ztheta_xp(nc_theta))

       call xplasma_grid(s,id_rho,zrhob,ierr1)
       call xplasma_grid(s,id_chi,ztheta_xp,ierr2)

       if (ierr1/=0 .or. ierr2/=0) then
          call xplasma_errmsg_append(s, &
               '? xnc_get_grid: Error fetching grid data')
          goto 100
       end if

       do i=1,isize2
          ztheta(i) = (-znc_pi) + (i-1)*2.0_r8*znc_pi/max(1,isize2-1)
       end do

    else
       call xplasma_errmsg_append(s,'?xnc_get_grid: Zero size grids')
       goto 100
    end if
    return

100 continue
    ier=1
    return
  end subroutine xnc_get_grid

  !
  ! ------------------------- xnc_set_points ------------------------------------
  ! setup points over which the moments will be computed
  !
  subroutine xnc_set_points(npoints, points, nmom, ier)
    integer,                    intent(in) :: npoints            ! number of rho points
    real(kind=r8),dimension(*), intent(in) :: points             ! rho
    integer,                    intent(in) :: nmom               ! number of moments for Fm to calculate
    integer,                    intent(out):: ier                ! nonzero on error

    !-------------------------
    integer        :: i               ! loop variable
    !-------------------------

    ier = 0

    ! -- store --
    nc_mom = nmom

    allocate(zpoints(npoints))
    nc_points = npoints
    do i = 1, npoints
       zpoints(i) = points(i)
       if (points(i)<zrho_axis) zpoints(i)=0._r8
    end do

  end subroutine xnc_set_points
  !
  ! ------------------------- xnc_allocate ------------------------------------
  !
  subroutine xnc_allocate
    !
    ! allocate arrays -- call after xnc_get_grid, xnc_set_points
    !
    integer :: i           ! loop variable
    integer :: inc_points  ! number of allocated points in zpoints

    ! -- points array the same as rhob? --
    is_rhob = (nc_points == nc_rhob)
    if (is_rhob) then
       do i = 1, nc_points
          if (abs(zrhob(i)-zpoints(i))>ZSMALL) is_rhob=.false.
       end do
    end if

    inc_points = size(zpoints)

    if (itest>0) print *, '%xnc_allocate: Allocating xplasma_nclass arrays.'

    allocate(zbigtheta(nc_theta, inc_points))
    allocate(zgamma(inc_points))
    allocate(zdvol(inc_points))
    allocate(zdpsi(inc_points))
    allocate(zngb2(inc_points))
    allocate(zb2(inc_points))
    allocate(zbgrth(inc_points))

    allocate(zmom_a(nc_mom, inc_points), zmom_b(nc_mom, inc_points),&
         zmom_c(nc_mom, inc_points), zmom_d(nc_mom, inc_points),&
         zmom_f(nc_mom, inc_points))

    ! -- allocate working arrays --
    iztotal = max(8*max(64,nc_mom), max(2,nc_theta)*max(nc_rhob,inc_points))
                       ! account for large fft buffer

    allocate(zrho(iztotal), zchi(iztotal), zdet(iztotal))
    allocate(zans(iztotal,3), zgans(iztotal,2,1), ztens(3,3,iztotal))

    allocate(zintegrand1(nc_theta, nc_rhob),&
         zintegrand2(nc_theta,     nc_rhob),&
         zintegrand3(nc_theta,     nc_rhob),&
         zintegrand4(nc_theta,     nc_rhob) &
         )

    allocate(zresult1(nc_theta-1, inc_points),&
         zresult2(1,              inc_points),&
         zresult3(1,              inc_points),&
         zresult4(1,              inc_points) &
         )

  end subroutine xnc_allocate


  !
  ! ------------------------ xnc_get_id ------------------------
  ! returns the xplasma id for the named stored function,
  !
  subroutine xnc_get_id(s, name, itype, id, ier)

    type (xplasma), pointer :: s   ! object for which to compute profiles...

    character(*), intent(in)    :: name   ! name of xplasma id
    integer,      intent(in)    :: itype  ! 0 for axis, 1 for profile
    integer,      intent(inout) :: id     ! resulting id
    integer,      intent(out)   :: ier    ! error code
 
    !----------------------------------

    ier = 0

    if (itype == 0) then
       call xplasma_gridId(s, name, id)
    else
       call xplasma_profId(s, name, id)
    end if

    if (id <= 0) then
       call xplasma_errmsg_append(s, &
            '? xnc_get_id: Could not find the xplasma ID for item: '// &
            trim(name))
       ier=1
    end if
  end subroutine xnc_get_id

  !
  ! ------------------------- xnc_get_bigtheta ------------------------------------
  ! finds the function THETA(theta)
  ! computes gamma, dV/dxi, dpsi/dxi, <(n.grad(B))**2>, <B**2>
  !
  subroutine xnc_get_bigtheta(s,ier)

    type (xplasma), pointer :: s   ! object for which to compute profiles...

    integer, intent(out) :: ier   ! error flag

    !------------------------------

    integer :: itotal      ! number of points to evaluate Jacobian*B
    integer :: i,j,k       ! loop variables
    integer :: ierr        ! error return 
    integer :: iertmp,idi  ! tmp error code; 1d integrator ID
    integer :: idi_2d      ! 2d integrator ID
    integer :: iauth       ! author set flag
    integer :: idtmpf      ! f(chi,rho) temporary spline

    real(kind=r8) :: zs             ! scale factor
    real(kind=r8) :: zstart         ! theta where theta and THETA agree
    real(kind=r8) :: ndgb           ! n.grad(B)
    real(kind=r8) :: zadet          ! absolute value of jacobian

    real*8        :: d2v,d2va(1)    ! d2V/dxi2
    real*8 :: zrhominu

    !------------------------------

    ier  = 0    ! ok, bad variable naming
    ierr = 0

    iauth = 0

    ! --- compute integrands on original grid ---
    itotal = nc_theta*nc_rhob   ! number of points for evaluation

    k = 1
    do i = 1, nc_rhob
       do j = 1, nc_theta
          zrho(k) = zrhob(i)
          zchi(k) = ztheta_xp(j)
          k = k+1
       end do
    end do

    ! -- BR, BZ, BMOD --
    call xplasma_eval_prof(s, (/id_br, id_bz, id_bmod/), &
         xplasma_rho_coord, zrho(1:itotal), &
         xplasma_theta_coord, zchi(1:itotal), &
         zans(1:itotal,1:3),ierr)
    if (ierr /= 0) goto 100

    ! -- dBMOD/drho, dBMOD/dtheta --
    call xplasma_eval_prof(s, (/id_bmod, id_bmod/), &
         xplasma_rho_coord, zrho(1:itotal), &
         xplasma_theta_coord, zchi(1:itotal), &
         zgans(1:itotal,1:2,1), ierr, &
         ideriv1s=(/1,0/), ideriv2s=(/0,1/))
    if (ierr /= 0) goto 100

    ! -- J matrix, det=-J --
    call xplasma_rzjac(s, zrho(1:itotal), zchi(1:itotal), ierr, &
         r=ztens(3,3,1:itotal), rzdetj=zdet(1:itotal), &
         drdrho=  ztens(1,1,1:itotal) ,dzdrho=  ztens(1,2,1:itotal), &
         drdtheta=ztens(2,1,1:itotal) ,dzdtheta=ztens(2,2,1:itotal)  )

    zdet(1:itotal)=zdet(1:itotal)*ztens(3,3,1:itotal)
    if (ierr /= 0) goto 100
    
    ! -- fill integrands --
    k = 1
    zbmod_zero = 0._r8
    do i = 1, nc_rhob    ! loop over flux surfaces

       ! -- fill integrands for this flux surface --
       do j = 1, nc_theta
          br   = zans(k,1)
          bz   = zans(k,2)
          bmod = zans(k,3)

          db_drho   = zgans(k,1,1)
          db_dtheta = zgans(k,2,1)
          
          zadet= abs(zdet(k))

          if (zrhob(i)<=zrho_axis) then
             zintegrand3(j,i)=0._r8
             zbmod_zero = bmod
          else
             ! -- inverse jacobian matrix --
             jacob = ztens(1,1,k)*ztens(2,2,k)-ztens(1,2,k)*ztens(2,1,k)    ! 2d jacobian -- sqrt(g)/R, axisymmetry warning
          
             drho_dR   =  ztens(2,2,k)/jacob
             drho_dZ   = -ztens(2,1,k)/jacob  ! note ztens(2,1,k) = dR/dchi
             dtheta_dR = -ztens(1,2,k)/jacob  !      ztens(1,2,k) = dZ/drho
             dtheta_dZ =  ztens(1,1,k)/jacob
          
             db_dR = db_drho*drho_dR + db_dtheta*dtheta_dR
             db_dZ = db_drho*drho_dZ + db_dtheta*dtheta_dZ
          
             ndgb = (br*db_dR+bz*db_dZ)/bmod

             zintegrand3(j,i) = zadet*(ndgb**2)  ! Jacobian * (B.grad(B)/B)**2
          end if

          zintegrand2(j,i) = zadet             ! Jacobian
          zintegrand1(j,i) = zadet * bmod      ! Jacobian * BMOD 
          zintegrand4(j,i) = zadet * bmod**2   ! Jacobian * BMOD**2

          k = k+1
       end do
    end do

    ! --- initialize surface integrals for THETA ---

    ! some temporary items are created, then removed...
    iauth=1
    call xplasma_author_set(s,"xplasma_nclass",iertmp)  

    idi=0
    idi_2d=0
    idtmpf=0

    zrhominu = max(1.0e-11_r8,min(1.0e-6_r8,zrho_min))

    call xplasma_create_integ(s, "xplasma_nclass_1dinteg", &
         zpoints(1:nc_points), idi, ierr, &
         rhomin=zrhominu, cache_enable = .TRUE.)
    if (ierr /= 0) then
       call xplasma_errmsg_append(s, &
            '? xnc_get_bigtheta: Error creating 1d integrator.')
       ier=1 ; goto 50
    end if

    call xplasma_augment_integ(s, "xplasma_nclass_2dinteg", idi, &
         ztheta(1:nc_theta), idi_2d, ierr)
    if (ierr /= 0) then
       call xplasma_errmsg_append(s, &
            '? xnc_get_bigtheta: Error creating 2d integrator.')
       ier=1 ; goto 50
    end if

    !
    ! integration over surfaces -- integration is over both phi and theta
    !
    ! -- THETA integration --
    zresult1 = 0.0_r8     ! must be set for xplasma
    call xplasma_create_2dprof(s,"__TMPF_NCLASS", &
         id_chi, id_rho, zintegrand1, idtmpf, ierr, &
         ispline=2,ibcx2a=0,ibcx2b=0)
    if (ierr /= 0) then
       call xplasma_errmsg_append(s, &
            '? xnc_get_bigtheta: Error creating zintegrand1 tmp fcn.')
       ier=1 ; goto 50
    end if

    call xplasma_2d_zonint(s, idi_2d, "I(__TMPF_NCLASS)S", zresult1, ierr)
    if (ierr /= 0) then
       call xplasma_errmsg_append(s, &
            '? xnc_get_bigtheta: Error integrating zresult1.')
       ier=1 ; goto 50
    endif

    ! -- dV/dxi --
    zresult2 = 0.0_r8     ! must be set for xplasma
    call xplasma_create_2dprof(s,"__TMPF_NCLASS", &
         id_chi, id_rho, zintegrand2, idtmpf, ierr, &
         ispline=2,ibcx2a=0,ibcx2b=0)
    if (ierr /= 0) then
       call xplasma_errmsg_append(s, &
            '? xnc_get_bigtheta: Error creating zintegrand2 tmp fcn.')
       ier=1 ; goto 50
    end if

    call xplasma_rho_zonint(s, idi, "I(__TMPF_NCLASS)S", zresult2(1,:), ierr)
    if (ierr /= 0) then
       call xplasma_errmsg_append(s, &
            '? xnc_get_bigtheta: Error integrating zresult2.')
       ier=1 ; goto 50
    endif

    ! -- (n.grad(B))**2 --
    zresult3 = 0.0_r8     ! must be set for xplasma
    call xplasma_create_2dprof(s,"__TMPF_NCLASS", &
         id_chi, id_rho, zintegrand3, idtmpf, ierr, &
         ispline=2,ibcx2a=0,ibcx2b=0)
    if (ierr /= 0) then
       call xplasma_errmsg_append(s, &
            '? xnc_get_bigtheta: Error creating zintegrand3 tmp fcn.')
       ier=1 ; goto 50
    end if

    call xplasma_rho_zonint(s, idi, "I(__TMPF_NCLASS)S", zresult3(1,:), ierr)
    if (ierr /= 0) then
       call xplasma_errmsg_append(s, &
            '? xnc_get_bigtheta: Error integrating zresult3.')
       ier=1 ; goto 50
    endif

    ! -- B**2 --
    zresult4 = 0.0_r8     ! must be set for xplasma
    call xplasma_create_2dprof(s,"__TMPF_NCLASS", &
         id_chi, id_rho, zintegrand4, idtmpf, ierr, &
         ispline=2,ibcx2a=0,ibcx2b=0)
    if (ierr /= 0) then
       call xplasma_errmsg_append(s, &
            '? xnc_get_bigtheta: Error creating zintegrand4 tmp fcn.')
       ier=1 ; goto 50
    end if

    call xplasma_rho_zonint(s, idi, "I(__TMPF_NCLASS)S", zresult4(1,:), ierr)
    if (ierr /= 0) then
       call xplasma_errmsg_append(s, &
            '? xnc_get_bigtheta: Error integrating zresult4.')
       ier=1 ; goto 50
    endif

    ! --- normalize so THETA and theta agree at ztheta(1) ---
    zstart = ztheta(1)
    do k = 1, nc_points
       if (zpoints(k)<zrho_axis) then
          call xplasma_volume(s,(/ 0.0_r8 /),d2va,ierr, ideriv=2)
               ! array args for debugger
          d2v = d2va(1)
          if (ierr/=0) then
             call xplasma_errmsg_append(s, &
                  ' ? xnc_get_bigtheta: error calling xplasma_volume')
             ier=1 ; goto 50
          end if
          if (zbmod_zero<=0._r8) then
             call xplasma_errmsg_append(s, &
                  ' ? xnc_get_bigtheta: rho points do not include the axis???')
             ier=1 ; goto 50
          end if
          zgamma(k) = zbmod_zero*d2v     ! replace <B>dV/dxi with <B>d2V/dxi2
          zdvol(k)  = d2v                ! prevent divide by zero later on
          zngb2(k)  = 0._r8
          zb2(k)    = zbmod_zero*zbmod_zero
          zbigtheta(1:nc_theta,k) = ztheta(1:nc_theta)  ! not quite right but does it matter?
       else
          do j = 2, nc_theta-1
             zresult1(j,k)  = zresult1(j,k)+zresult1(j-1,k)    ! accumulate interval integrations
          end do
       
          ! -- 2pi comes from phi integration -- 
          zgamma(k)= zresult1(nc_theta-1,k)               ! (dV/dxi)*<B>, not gamma yet
          zdvol(k) = zresult2(1,k)                        ! (dV/dxi)
          zngb2(k) = max(0._r8,zresult3(1,k)/zdvol(k))    ! <(n.grad(B))**2>
          zb2(k)   = zresult4(1,k)/zdvol(k)               ! <B**2>
          
          zbigtheta(1,k) = zstart
          zs = 2.0_r8*znc_pi/zresult1(nc_theta-1,k) ! force THETA to have 2pi domain
          do j = 2, nc_theta
             zbigtheta(j,k) = zstart + zs*zresult1(j-1,k)
          end do
       end if
    end do

    ! --- get gamma and dpsi/dxi ---
    call xplasma_eval_prof(s,id_psi,zpoints,zdpsi,ierr, ideriv1=1)
    !print *, 'zdpsi=',zdpsi
    if (ierr /= 0) then
       call xplasma_errmsg_append(s, &
            '? xnc_get_bigtheta: error fetching dpsi/dxi')
       ier=1 ; goto 50
    end if

    !print *, 'ichi_ccw=',ichi_ccw,'  nsnccwi=',nsnccwi
    do i = 1, nc_points
       if (zpoints(i)<zrho_axis) then
          call xplasma_eval_prof(s,id_psi,(/ 0.0_r8 /),zdpsi(i:i),ierr, &
               ideriv1=2)  ! replace dpsi/dxi with d2psi/dxi2, on axis
          if (ierr /= 0) then
             call xplasma_errmsg_append(s, &
                  '? xnc_get_bigtheta: error d2psi/dxi2')
             ier=1 ; goto 50
          end if
       end if
       zdpsi(i)  = (-ichi_ccw*nsnccwi)*zdpsi(i)
       zgamma(i) = 4.0_r8*znc_pi*znc_pi*zdpsi(i)/zgamma(i)
       !print *, 'zgamma(',i,')=',zgamma(i), '   zdpsi=',zdpsi(i)
    end do

    ! --- register curves ---
    if (is_rhob .and. itest>0) then
       call xplasma_create_2dprof(s,"BIGTHETA",id_chi,id_rho,zbigtheta, &
            id_bigtheta,ierr, &
            ispline=2,ibcx1a=0,ibcx1b=0)
       if(ierr.ne.0) then
          call xplasma_errmsg_append(s, &
               '? xnc_get_bigtheta: Error registering BIGTHETA.')
          ier=1; goto 50
       endif

       call xplasma_create_1dprof(s,"XNC_GAMMA",id_rho,zgamma,id_gamma,ierr, &
            ispline=1,ibca=0,ibcb=0)
       if (ierr /= 0) then
          call xplasma_errmsg_append(s, &
               '? xnc_get_bigtheta: Error registering XNC_GAMMA.')
          ier=1 ; goto 50
       end if
    else
       id_bigtheta = 0
       id_gamma    = 0
    end if

50  continue   ! there used to be a deallocation statment here
    if(idtmpf.gt.0) call xplasma_remove_item(s,idtmpf,iertmp)
    if(idi.gt.0) call xplasma_remove_item(s,idi,iertmp)
    if(idi_2d.gt.0) call xplasma_remove_item(s,idi_2d,iertmp)
    if(iauth.gt.0) call xplasma_author_clear(s,"xplasma_nclass",iertmp)  
    return

100 call xplasma_errmsg_append(s,'? xnc_get_bigtheta: Error in setup')
    ier=1
    goto 50
  end subroutine xnc_get_bigtheta


  !
  ! ------------------------- xnc_get_abcd ------------------------------------
  ! compute the Fm moments using an FFT after having computed the THETA(theta) function.
  ! The process is to use a spline of theta(THETA) to evaluate theta at a uniform set of
  ! THETA FFT points.  Find the integrand values at these points then perform the FFT
  ! to get the moments.
  !
  subroutine xnc_get_abcd(s,ier)

    type (xplasma), pointer :: s   ! object for which to compute profiles...

    integer, intent(out) :: ier    ! error flag

    integer, parameter :: ncroll=4 ! increase fft density to account for aliasing

    integer :: i,j,k               ! loop variable
    integer :: ilin                ! linearity return code
    integer :: ierr                ! error code
    integer :: nfft                ! size of fft to compute
    integer :: mwk                 ! size of work and output arrays

    real(kind=r8), allocatable, dimension(:)   :: big_uniform   ! uniformly spaced THETA
    real(kind=r8), allocatable, dimension(:,:) :: little_spline ! spline coefficients for theta(THETA)
    real(kind=r8), allocatable, dimension(:)   :: zwork
    real(kind=r8), allocatable, dimension(:)   :: little   ! theta(THETA)
    real(kind=r8), allocatable, dimension(:)   :: dlittle  ! dtheta(THETA)/dTHETA
    real(kind=r8), allocatable, dimension(:)   :: fft_a,fft_b ! arguments to fft coeficients
    real(kind=r8) :: b               ! THETA
    real(kind=r8) :: blast           ! last THETA in loop
    real(kind=r8) :: pi2             ! 2.*pi
    real(kind=r8) :: zmin,  zmax     ! allowed range for spline theta
    real(kind=r8) :: zbmin, zbmax    ! allowed range for spline THETA
    real(kind=r8) :: db              ! delta THETA in spline interval
    real(kind=r8) :: zs              ! scaling
    real(kind=r8) :: zadet           ! absolute value of jacobian

    real(kind=r8),    allocatable, dimension(:) :: st,ct  ! fft results

    ier = 0
    nfft = 64
    do while((ncroll*nc_mom)>(nfft/2))
       nfft = 2*nfft            ! get space for fft
    end do
    mwk = (nfft/2)+1

    if (nfft>size(zrho,1) .or. nc_theta<2) then
       call xplasma_errmsg_append(s, &
            '? xnc_get_abcd: Not enough points to support fft')
       ier=1 ; return
    end if

    ! --- allocation ---
    allocate(st(mwk), ct(mwk))
    allocate(big_uniform(nfft), little(nfft), dlittle(nfft))
    allocate(fft_a(nfft), fft_b(nfft))
    allocate(little_spline(4,nc_theta), zwork(nc_theta))

    do j = 1, nfft
       big_uniform(j) = (2.0_r8*znc_pi*(j-1))/nfft
    end do

    zmin  = ztheta(1)        - zmax_theta_error
    zmax  = ztheta(nc_theta) + zmax_theta_error
    pi2 = 2.0_r8*znc_pi
    do i = 1, nc_points
       ! -- form a nonuniform spline theta(THETA) --
       little_spline(1,:) = ztheta(:)
       call cspline(zbigtheta(:,i), nc_theta, little_spline, -1, 0.0_r8, -1, 0.0_r8, &
            zwork, nc_theta, ilin, ierr)
       if (ierr /= 0) then
          call xplasma_errmsg_append(s, &
               '? xnc_get_abcd:  Error forming spline of theta with BigTheta axis')
          call xplasma_errmsg_append(s, &
               '? xnc_get_abcd:  this could be due to a negative mod(B) or jacobian after interpolation')          
          ier=1 ; goto 50
       end if

       ! --- find values of theta,BR,BZ,BMOD,J at fft point of THETA ---
       zbmin = zbigtheta(1,i)        - zmax_theta_error
       zbmax = zbigtheta(nc_theta,i) + zmax_theta_error
       k = 1
       blast = zbmin-2.0_r8*pi2  ! force computation of new k
       do j = 1, nfft
          ! -- evaluate theta(THETA), dtheta(THETA) --
          b = big_uniform(j)

          ! -- bring b in range of zbigtheta --
          do while (b>zbmax)
             b = b-pi2
          end do
          do while (b<zbmin)
             b = b+pi2
          end do
             
          ! - find k so that zbigtheta(k,i)<b<zbigtheta(k+1,i) -
          !   k restricted to [1,nc_theta-1] interval
          if (abs(b-blast)>znc_pi) then
             k = int(nc_theta*(b-zbmin)/pi2)     ! guess spline interval
             k = max(1,min(nc_theta-1,k))
          end if
          do while (b<zbigtheta(k,i) .and. k>1)
             k = k-1
          end do
          do while (b>zbigtheta(k+1,i) .and. k<(nc_theta-1))
             k = k+1
          end do

          db = b - zbigtheta(k,i)
          little(j)  = little_spline(1,k) + db*(little_spline(2,k) + &
               db*(little_spline(3,k) + db*little_spline(4,k)))
          dlittle(j) = little_spline(2,k) + db*(2.0_r8*little_spline(3,k) + &
               3.0_r8*db*little_spline(4,k))

          ! -- bring little(j) in range --
          do while(little(j)>zmax)
             little(j) = little(j)-pi2
          end do
          do while(little(j)<zmin)
             little(j) = little(j)+pi2
          end do

          zrho(j) = zpoints(i)
          zchi(j) = little(j)
          blast = b
       end do

       ! -- BR, BZ, BMOD --
       call xplasma_eval_prof(s, (/id_br, id_bz, id_bmod/), &
            xplasma_rho_coord, zrho(1:nfft), &
            xplasma_theta_coord, zchi(1:nfft), &
            zans(1:nfft,1:3),ierr)
       if (ierr /= 0) then
          call xplasma_errmsg_append(s, &
               '? xnc_get_abcd:  Error in call to xplasma_eval_prof (1)')
          ier=1 ; goto 50
       end if
 
       ! -- dBMOD/drho, dBMOD/dtheta --
       call xplasma_eval_prof(s, (/id_bmod, id_bmod/), &
            xplasma_rho_coord, zrho(1:nfft), &
            xplasma_theta_coord, zchi(1:nfft), &
            zgans(1:nfft,1:2,1), ierr, &
            ideriv1s=(/1,0/), ideriv2s=(/0,1/))
       if (ierr /= 0) then
          call xplasma_errmsg_append(s, &
               '? xnc_get_abcd:  Error in call to xplasma_eval_prof (2)')
          ier=1 ; goto 50
       end if
       
       ! -- J matrix, -J --
       call xplasma_rzjac(s, zrho(1:nfft), zchi(1:nfft), ierr, &
            r=ztens(3,3,1:nfft), rzdetj=zdet(1:nfft), &
            drdrho=  ztens(1,1,1:nfft) ,dzdrho=  ztens(1,2,1:nfft), &
            drdtheta=ztens(2,1,1:nfft) ,dzdtheta=ztens(2,2,1:nfft)  )

       zdet(1:nfft)=zdet(1:nfft)*ztens(3,3,1:nfft)
       if (ierr /= 0) then
          call xplasma_errmsg_append(s, &
               '? xnc_get_abcd:  Error in call to xplasma_rzjac')
          ier=1 ; goto 50
       end if

       ! -- fill array for argument to fft --
       if (zpoints(i)<zrho_axis) then
          fft_b = 0._r8
          fft_a = 0._r8
       else
          do j=1, nfft
             br   = zans(j,1)
             bz   = zans(j,2)
             bmod = zans(j,3)
             zadet= abs(zdet(j))
             
             db_drho   = zgans(j,1,1)
             db_dtheta = zgans(j,2,1)
             
             ! -- inverse jacobian matrix --
             jacob = ztens(1,1,j)*ztens(2,2,j)-ztens(1,2,j)*ztens(2,1,j)    ! 2d jacobian -- sqrt(g)/R, axisymmetry warning
             
             drho_dR   =  ztens(2,2,j)/jacob
             drho_dZ   = -ztens(2,1,j)/jacob  ! note ztens(2,1,j) = dR/dchi
             dtheta_dR = -ztens(1,2,j)/jacob  !      ztens(1,2,j) = dZ/drho
             dtheta_dZ =  ztens(1,1,j)/jacob
             
             db_dR = db_drho*drho_dR + db_dtheta*dtheta_dR
             db_dZ = db_drho*drho_dZ + db_dtheta*dtheta_dZ
             
             fft_b(j) = (br*db_dR+bz*db_dZ)*zadet*dlittle(j)
             fft_a(j) = fft_b(j)/bmod
          end do
       end if

       ! get Am,Bm,Cm,Dm moments from FFT
       zs = (2.0_r8*znc_pi*znc_pi)/(nfft*zdvol(i))  ! common factor
       call r8fftsc(fft_a, nfft, st, ct, ierr)
       do k = 1, nc_mom
          zmom_a(k,i) = zs*st(k+1)
          zmom_c(k,i) = zs*ct(k+1)
       end do

       zs = zs * zgamma(i)
       call r8fftsc(fft_b, nfft, st, ct, ierr)
       do k = 1, nc_mom
          zmom_b(k,i) = zs*st(k+1)
          zmom_d(k,i) = zs*ct(k+1)
       end do

       ! finish off the Fm moment
       zs = zdvol(i)/(2.0_r8*znc_pi*znc_pi*zdpsi(i)*zb2(i))
       zbgrth(i) = 2.0_r8*znc_pi*znc_pi*zdpsi(i)/zdvol(i)
       !print *, 'zbgrth(',i,')=',zbgrth(i)
       do k = 1, nc_mom
          zmom_f(k,i) = zs*(zmom_a(k,i)*zmom_b(k,i)+zmom_c(k,i)*zmom_d(k,i))
       end do

    end do  ! end loop over points i

    ! --- deallocation ---
50  deallocate(st, ct)
    deallocate(big_uniform, little, dlittle)
    deallocate(fft_a, fft_b)
    deallocate(little_spline, zwork)

  end subroutine xnc_get_abcd

end module xplasma_nclass

      INTEGER FUNCTION MCSORT_ORDER(INDX,N,MAXN,IEXACT,
     >     ORDER_RULE,DATA1,ELEMENT1)
C---------------------------------------------------------------
C  MCSORT_ORDER
C  ------------
C
C
C  BINARY SEARCH ALGORITHM
C   ORDERING RULE SPECIFIED BY *EXTERNAL PASSED ROUTINE*
C      ORDER_RULE
C
C  VSN DMC 6 DEC 1985 ** ASSUMING SORTING ON CHARACTER DATA **
C
C  INPUT:
      INTEGER INDX(MAXN)	! SORTED INDEX ARRAY
      INTEGER N		! NUMBER OF ELEMENTS CURRENTLY SORTED
C
C	MAXN = MAX NUMBER OF ELEMENTS IN SORTED LIST
C
      CHARACTER*(*) DATA1(MAXN)
      CHARACTER*(*) ELEMENT1
C
C	DATAn= LIST CHARACTER DATA ARRAY
C       ELEMENTn = ELEMENT CHARACTER DATA
C
      INTEGER ORDER_RULE
      EXTERNAL ORDER_RULE
C
C  **EXTERNAL USER SUPPLIED INTEGER FUNCTION ORDER_RULE**
C	L = ORDER_RULE(I,INDX,MAXN,DATA1,ELEMENT1)
C
C       L = -1 IF ELEMENT IS "LESS THAN" DATA...(INDX(I))
C       L = 0  IF ELEMENT IS "EQUAL TO"  DATA...(INDX(I))
C	L = +1 IF ELEMENT IS "GREATER THAN" DATA...(INDX(I))
C
C  OUTPUT:
C       IEXACT=1 IF ELEMENT MATCHES EXISTING DATA ELEMENT PRECISELY
C             =0 O.W.
C
C       MCSORT_ORDER PTS TO SORT ARRAY INDX
C  ELEMENT... IS "LESS THAN OR EQUAL TO"  DATA...(INDX(MCSORT_ORDER))
C  IF ELEMENT IS "GREATER THAN" ALL DATA...ELEMENTS,
C       MCSERT_ORDER = N+1 IS RETURNED
C
C--------------------------------------------
C  EXECUTABLE CODE
C
C  CHECK FOR ZERO DATA IN LIST, OR ELEMENT .GT. GREATEST ELEMENT IN LIST
C
      IF(N.EQ.0) THEN
        IENDL=1
      ELSE
        L = ORDER_RULE(N,INDX,MAXN,DATA1,ELEMENT1)
        IF(L.EQ.1) THEN
          IENDL=1
        ELSE
          IENDL=0
        ENDIF
      ENDIF
C
C  SPECIFY ELEMENT OFF END OF LIST...
      IF(IENDL.EQ.1) THEN
        IEXACT=0
        MCSORT_ORDER=N+1
        RETURN
      ENDIF
C
C  BINARY SEARCH LOOP
C
 100  CONTINUE
C
C  ITOP,IBOT= RANGE REMAINING TO BE SEARCHED
C
      ITOP=N
      IBOT=1
      ITER=0
C
 110  CONTINUE
C
      ITER=ITER+1
C  ERROR CHECK
      IF(ITER.GT.N) THEN
        write(6,9902)
 9902 FORMAT(' ?MCSORT_ORDER FAILED:  TOO MANY ITERATIONS')
        ZANS=-FLOAT(ITER**2)
        ZANSI=1.0/SQRT(ZANS)  ! BRING ABOUT AN ABNORMAL PROGRAM TERMINATION
        WRITE(6,'(1PE11.4)') ZANSI
      ENDIF
C
      IMID=(ITOP+IBOT)/2
C
        L = ORDER_RULE(IMID,INDX,MAXN,DATA1,ELEMENT1)
C
      IF(L) 140,120,150
C
C  EQUALITY
C
 120  CONTINUE
      IEXACT=1
      MCSORT_ORDER=IMID
      RETURN
C
C  ELEMENT... .LT. DATA...(INDX(IMID))
C
 140  CONTINUE
      ITOP=IMID
C  DONE ?
      IF(IBOT.EQ.ITOP) THEN
        IEXACT=0
        MCSORT_ORDER=ITOP
        RETURN
      ENDIF
C
      GO TO 110  ! KEEP LOOKING
C
C  ELEMENT... .GT. DATA...(INDX(IMID))
 150  CONTINUE
      IBOT=IMID+1
C  ERROR CHECK
      IF(IBOT.GT.ITOP) THEN
        write(6,9901)
 9901 FORMAT(' ?MCSORT_ORDER FAILED:  OUT OF ORDER')
        ZANS=-FLOAT(ITER**2)
        ZANSI=1.0/SQRT(ZANS)  ! BRING ABOUT AN ABNORMAL PROGRAM TERMINATION
        WRITE(6,'(1PE11.4)') ZANSI
      ENDIF
      GO TO 110
C
      END

      REAL*8 function feqi_1int(iorder,zrho,zspl,nrho,j,zdelx)
c
c  compute integral from zrho(j) to zrho(j)+zdelx
c  zrho(j)+zdelx .le. zrho(j+1) expected.
c
      use xdistrib_mod
c
      IMPLICIT NONE
c
c  input:
      integer iorder                    ! order (1:Hermite, 2:Spline)
      integer nrho                      ! no. of pts.
      REAL*8 zrho(nrho)                 ! indep coord.
      REAL*8 zspl(ncdim(iorder),nrho) ! spline of function
c
      integer j                         ! index to zone
      REAL*8 zdelx                      ! displacement w/in the zone
c
c-------------------------
c
      REAL*8 zh,zhi,zh2,zh3
c
      REAL*8 f0,f1,fx0,fx1,fxx0,fxx1
      REAL*8 p,p2
      REAL*8 zterm1,zterm2,zterm3,zterm4,zsum
c
      real*8, parameter :: cone=1,ctwo=2,cthree=3,cfour=4,csix=6
      real*8, parameter :: chalf=1/ctwo, cthird=1/cthree, c4th=1/cfour
c
c-------------------------
c
      f0=zspl(1,j)
      if((iorder.ge.0).and.(iorder.le.2)) then
         zh=zrho(j+1)-zrho(j)
         zhi=cone/zh
         p=zhi*zdelx
         p2=p*p
         f1=zspl(1,j+1)
      endif
c
      if(iorder.eq.3) then
c
         zsum=zdelx*(f0+ chalf*zdelx*(zspl(2,j) +
     >      cthird*zdelx*(zspl(3,j) + c4th*zdelx*zspl(4,j))))
c
c  explicit spline formulation
c
      else if(iorder.eq.2) then
c
c  compact spline formulation
c
         zh3=zh*zh*zh
c
         fxx0=zspl(1,j)
         fxx1=zspl(1,j+1)
c
         zterm1=zh*f0*(p-p2/ctwo)
         zterm2=zh*f1*(p2/ctwo)
         zterm3=zh3*fxx0*p2*(-cone+p-p2/cfour)/csix
         zterm4=zh3*fxx1*p2*(p2/cfour-cone/ctwo)/csix
         zsum=zterm1+zterm2+zterm3+zterm4
c
      else if(iorder.eq.1) then
c
c  Hermite formulation
c
         zh2=zh*zh
c
         fx0=zspl(1,j)
         fx1=zspl(1,j+1)
c
         zterm1=zh*f0*(p2*(p2/ctwo-p)+p)
         zterm2=zh*f1*(p2*(p-p2/ctwo))
         zterm3=zh2*fx0*p2*(p2/cfour-ctwo*p/cthree+chalf)
         zterm4=zh2*fx1*p2*(p2/cfour-p/cthree)
         zsum=zterm1+zterm2+zterm3+zterm4
c
      else if(iorder.eq.0) then
c
         zsum=zh*p*(f0 + p*(f1-f0)/ctwo)
c
      else if(iorder.eq.-1) then
c
         zsum=zdelx*f0
c
      else
         write(6,'(a)') ' ?eqi_1int:  iorder out of range!'  ! RGA:dep remove eq_errmsg()
      endif
c
      feqi_1int=zsum
c
      return
      end

subroutine eqm_rzordr_set(iorder)

  !  set fit order for R(rho,chi), Z(rho,chi), and B(rho,chi) component

  !      iorder = 1 ==> Hermite fits
  !      iorder = 2 ==> (default) Spline fits
 
  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: iorder

  !-----------------------
  integer :: iord_use,ier
  !-----------------------

  iord_use = max(1,min(2,iorder))

  call xplasma_rzOrder_set(s,iord_use,ier)

  if(ier.ne.0) then
     write(lunerr,*) ' ?eqm_rzordr_set: unexpected error.'
     call xplasma_error(s,ier,lunerr)
  endif

end subroutine eqm_rzordr_set

subroutine eq_rzordr_get(iorder)

  !  get fit order for R(rho,chi), Z(rho,chi), and B(rho,chi) component

  !      iorder = 1 ==> Hermite fits
  !      iorder = 2 ==> (default) Spline fits
 
  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(out) :: iorder

  !-----------------------
  integer :: ier
  !-----------------------

  call xplasma_global_info(s,ier, rzOrder=iorder)

  if(ier.ne.0) then
     write(lunerr,*) ' ?eqm_rzordr_set: unexpected error.'
     call xplasma_error(s,ier,lunerr)
  endif

end subroutine eq_rzordr_get

      SUBROUTINE MCSORT_INSERT(INDX,NMAX,IVAL,IADR,N,IER)
C
      INTEGER INDX(NMAX)	! SORT ARRAY
C
C  INSERT VALUE IVAL AT ADDRESS IADR IN INDX ARRAY
C  INCREASE THE NUMBER N OF ELEMENTS RECORDED AS STORED IN INDX.
C  RETURN IER=1 IF N IS ALREADY .GE.NMAX
C
      IF(N.GE.NMAX) THEN
C  NUMBER CHECK
        IER=1
      ELSE IF((IADR.LT.1).OR.(IADR.GT.(N+1))) THEN
C  ADDRESS RANGE CHECK
        IER=2
      ELSE
        IER=0
        IF(IADR.EQ.(N+1)) THEN
C  STICK AT END
          INDX(IADR)=IVAL
        ELSE
C  MAKE ROOM FOR INSERTION
          DO 10 I=N,IADR,-1
            IP1=I+1
            INDX(IP1)=INDX(I)
 10       CONTINUE
C  INSERT
          INDX(IADR)=IVAL
        ENDIF
C  INCREMENT NUMBER
        N=N+1
      ENDIF
C
      RETURN
      END

subroutine eq_limcon(imax,inum,rlim,zlim,dtol,ierr)

  !  for any limiter configuration, convert to a closed piecewise
  !  linear representation.  This will contain up to (imax) pieces
  !  but will be reduced by eliminating points that are colinear to
  !  tolerance (dtol); to prevent a reduction & get the maximum number
  !  of points, set dtol.le.0.0d0

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  !  input:

  integer imax                      ! max no. of contour points output

  !  output:

  integer inum                      ! actual no. of contour points output
  real*8 rlim(imax),zlim(imax)      ! the contour points

  !  input:

  real*8 dtol                       ! tolerance for estimating colinearity

  !  output:

  integer ierr                      ! completion code, 0=OK
  !---------------------------------------

  call xplasma_limcon(s,rlim,zlim,inum,ierr, &
       tol=dtol,maptype = 2)

end subroutine eq_limcon

! 30Nov1999 fgtok
#include "fpreproc/f77_dcomplx.h"
! 30Nov1999 fgtok -s r8_precision.sub r8bloat_names.sub "r8con.csh conversion"
C******************** START FILE TKBRYS.FOR ; GROUP TKBLOAT ******************
C-- END FILE #TKBRY2# ************************************
CFORMFEEDC-- START FILE #TKBRYS# ************************************
C-----------------------------------------------------------------
C  DMC - UTILITY ROUTINE FOR MOMENT SURFACES EXTRAPOLATION.
C
C  mod dmc 29 Dec 1996:  add passed args, to avoid necessity of later
C  reference to COMMON...
C
C  GIVEN A SURFACE AT THE SPECIFIED MOMENTS INDEX LOCATION THIS
C  ROUTINE RETURNS THE (R,Y) AS A FCN OF THETA, NTK PTS. FROM 0 TO
C  NTK-1/NTK * TWOPI; AND GIVES A ROUGH ESTIMATE OF THE CENTROID
C  (R0,Y0) DEFINED FROM AN APPROXIMATE PT TO PT LINE INTEGRATION.
C
      SUBROUTINE r8tkbrys(ISURF,zrmc,zymc,locmax,nmom,
     >                    ZR,ZY,ZR0,ZY0)
C
C============
C idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      INTEGER locmax,nmom,isurf,ith,ithm1
C============
C idecl:  explicitize implicit REAL declarations:
      REAL*8 zr0,zy0,twopi,zl,zth,zdl
C============
      REAL*8 zrmc(3,0:locmax,2)
      REAL*8 zymc(3,0:locmax,2)
C
      include 'r8tkbparm.inc'
      REAL*8 ZR(NTK),ZY(NTK)
C
      DATA TWOPI/6.283185E0_R8/
C
C------------------------------------
C
      CALL r8tkbmry(3,ISURF,0.0E0_R8,zrmc,zymc,locmax,nmom,ZR(1),ZY(1))
C
      ZR0=0.0E0_R8
      ZY0=0.0E0_R8
      ZL=0.0E0_R8
C
      DO 100 ITH=2,NTK
        ITHM1=ITH-1
C
        ZTH=TWOPI*AREAL(ITH-1)/AREAL(NTK)
        CALL r8tkbmry(3,ISURF,ZTH,zrmc,zymc,locmax,nmom,
     >                ZR(ITH),ZY(ITH))
C
        ZDL=SQRT((ZR(ITH)-ZR(ITHM1))**2+(ZY(ITH)-ZY(ITHM1))**2)
C
        ZL=ZL+ZDL
        ZR0=ZR0+ZDL*0.5E0_R8*(ZR(ITH)+ZR(ITHM1))
        ZY0=ZY0+ZDL*0.5E0_R8*(ZY(ITH)+ZY(ITHM1))
C
 100  CONTINUE
C
C  COMPLETE THE LOOP
C
        ZDL=SQRT((ZR(1)-ZR(NTK))**2+(ZY(1)-ZY(NTK))**2)
C
        ZL=ZL+ZDL
        ZR0=ZR0+ZDL*0.5E0_R8*(ZR(1)+ZR(NTK))
        ZY0=ZY0+ZDL*0.5E0_R8*(ZY(1)+ZY(NTK))
C
        ZR0=ZR0/ZL
        ZY0=ZY0/ZL
C
      RETURN
      END
C******************** END FILE TKBRYS.FOR ; GROUP TKBLOAT ******************

program xplasma2_test

  ! Quick and dirty test program for xplasma2 module & library

  ! DMC Feb 2008: remove "*" format for floating point outputs

  use xplasma_obj_instance

  implicit NONE

  integer :: ier

  character*32 zname,zauthor
  character*75 zlabel
  integer :: id,ilun,iaxi,iscr,i,ioff
  real*8 ztime,ztime2,dmax

  character*32 elem_names(10),list_names(10)
  character*40 elem_labels(10)
  integer :: elem_ivals(10)
  real*8 :: elem_r8vals(10)

  integer :: id_list,id_listb,list_ids(10),ict(10),ict2(10)
  integer :: id_chi,id_rho,id_rho2,id_phi,ideriv,ideriv1,ideriv2,ideriv3
  integer :: inum,isize,igot,imax,itmax,itest

  integer, parameter :: inrho=21,inchi=41,inphi=35,inxtest=51
  real*8 zrho(inrho),zrho2(inrho+1),zchi(inchi),zphi(inphi)
  real*8 ztmp(max(inrho+1,inchi)),zsinx(inrho),zcosx(inrho),zsinx2(inrho+1)
  real*8 zsinx1(inrho+1),zcoeff1(inrho+1)
  real*8, parameter :: z2pi = 6.2831853071795862D+00
  real*8, parameter :: zero = 0.0d0
  real*8 :: ztol = 1.0d-8

  real*8 :: zxtest(inxtest)
  real*8 :: zans1(inxtest),zans2(inxtest),zans3(inxtest),zans4(inxtest,4)
  real*8 :: zscale,zfac,zpart1,zpart2

  integer :: id_fun,id_fun1,ix,ichi,iphi,irank,ispline,idum,icount
  integer :: id_funs,id_funsc,id_funh,id_funl
  integer :: ifuns(4)
  real*8 :: zdum

  real*8 :: x2d(9),th2d(9),vals2d(9,4),vals2da(9),valtmp2d(1,12)
  real*8 :: yy2d(9),yy2e(9)
  real*8 :: f2d(inrho,inchi)  ! exp(x)*sin(theta)
  real*8 :: f2dret(inrho,inchi),f2dcoeff(3,inrho,inchi)
  integer :: id_f2dlin,id_f2dherm,id_f2dspl
  real*8,parameter :: x2dcen=0.525d0,th2dcen=1.635d0,zd=1.0d-4

  real*8 :: x3d(27),th3d(27),ph3d(27),vals3d(27,4),vals3da(27),zsum1,zsum2
  real*8 :: yy3d(27),yy3e(27)
  real*8 :: f3d(inphi,inrho,inchi)  ! exp(x)*cos(theta)*sin(phi)
  real*8 :: f3dret(inphi,inrho,inchi),f3dcoeff(7,inphi,inrho,inchi)
  integer :: id_f3dlin,id_f3dherm,id_f3dspl
  real*8,parameter :: x3dcen=0.625d0,th3dcen=0.5d0,ph3dcen=1.235d0

  integer :: idxxc,idxxg,idyyc,idyyg,ii
  real*8 :: xx(4),yy(3),ff(4),ff1(4)

  !--------------------------------------------------
  !  pointers for pack/unpack test...
  integer, dimension(:), pointer :: ipack
  real*8, dimension(:), pointer :: r8pack
  !--------------------------------------------------

  zrho2(1)=0
  zrho2(inrho+1)=1

  do i=1,size(zrho)
     zrho(i)=(i-1)*1.0d0/(size(zrho)-1)
     if(i.gt.1) then
        zrho2(i)=(zrho(i)+zrho(i-1))/2
     endif
  enddo

  do i=1,size(zchi)
     zchi(i)=(i-1)*z2pi/(size(zchi)-1)
  enddo

  do i=1,size(zphi)
     zphi(i)=(i-1)*z2pi/(size(zphi)-1)
  enddo

  do i=1,size(xx)
     xx(i)=(i-1)*1.0d0/(size(xx)-1)
  enddo

  do i=1,size(yy)
     yy(i)=(i-1)*1.0d0/(size(yy)-1)
  enddo

  xplasma_trace_name = 'yygrid'

  zlabel=' '

  write(6,*) ' => here an error is expected (s has not been initialized):'
  call xplasma_global_info(s,ier, initLabel=zlabel)
  if(ier.ne.0) then
     call xplasma_error(s,ier,6)
  else
     write(6,*) ' zlabel = "',trim(zlabel),'"'
  endif

  write(6,*) ' '

  !----
  ! init s pointer
  call xoi_init(ier); call ckerr(s)  ! set up xplasma instance pointers

  !----
  ! init object pointed to by s...

  call xplasma_init(s,'test xplasma',ier); call ckerr(s)

  call xplasma_global_info(s,ier, initLabel=zlabel); call ckerr(s)
  write(6,*) ' zlabel = "',trim(zlabel),'"'

  call xplasma_init(s,'test xplasma #2',ier); call ckerr(s)

  call xplasma_global_info(s,ier, initLabel=zlabel); call ckerr(s)
  write(6,*) ' zlabel = "',trim(zlabel),'"'

  !-----------------------------------------------------
  !  traditional xplasma interface test

  call eqm_select("eqm_select_test",1)
  call eqm_premsg("eqm_premsg string")

  call eq_get_lunerr(ilun)
  write(6,*) ' eq_get_lunerr returned: ',ilun

  call eq_ident(zlabel,iaxi,iscr)
  write(6,*) ' eq_ident: "',trim(zlabel),'" iaxi,iscr=',iaxi,iscr

  ztime = 1.2345
  call eqm_time(ztime)
  call eq_time(ztime2)
  if(ztime.ne.ztime2) then
     write(6,*) ' ?eq_time did not return time set by eqm_time:'
     write(6,*) '  input to eqm_time: ',ztime,'; returned from eq_time:',  &
          ztime2
  else
     write(6,*) ' eqm_time/eq_time test passed OK.'
  endif
  !-----------------------------------------------------
  !  list creation and retrieval...

  write(6,*) ' '
  write(6,*) ' testing: eqm_list methods... '

  elem_names=' '
  elem_labels=' '
  elem_ivals=0
  elem_r8vals=0.0d0

  do i=1,4
     write(elem_names(i),1001) i
     write(elem_labels(i),1002) i
     elem_ivals(i)=i
     elem_r8vals(i)=elem_ivals(i)*1.0d0 + 0.1d0
  enddo

  write(6,*) ' creating: LIST_A'
  call eqm_list_create('list_a','a list soon to have 9 values', &
       4,elem_names,id_list,ier); call ckerr(s)

  call eqm_list_chval(id_list,4,elem_labels,ier); call ckerr(s)
  call eqm_list_ival(id_list,4,elem_ivals,ier); call ckerr(s)
  call eqm_list_r8val(id_list,4,elem_r8vals,ier); call ckerr(s)

  ioff=3
  do i=1,6
     write(elem_names(i),1001) i+ioff
     write(elem_labels(i),1002) i+ioff
     elem_ivals(i)=i+ioff
     elem_r8vals(i)=elem_ivals(i)*1.0d0 + 0.2d0
  enddo
     
  write(6,*) ' creating: LIST_B'
  call eqm_list_create('list_b','a supplemental list', &
       6,elem_names,id_listb,ier); call ckerr(s)

  call eqm_list_chval(id_listb,6,elem_labels,ier); call ckerr(s)
  call eqm_list_ival(id_listb,6,elem_ivals,ier); call ckerr(s)
  call eqm_list_r8val(id_listb,6,elem_r8vals,ier); call ckerr(s)

1001 format('item_',i1)
1002 format('label for item #',i1)

  write(6,*) ' merging: LIST_A and LIST_B'
  call eqm_list_merge(id_list,id_listb,.FALSE.,ier); call ckerr(s)
  if(ier.lt.0) then
     write(6,*) ' %warning -- list element was replaced.'
  endif

  write(6,*) ' '
  write(6,*) ' list readback tests...'

  call eq_nlist(inum)
  write(6,*) ' Number of known lists: ',inum
  call eq_list_maxsize(isize)
  write(6,*) ' Maximum list size: ',isize

  call eq_lists(size(list_names),list_names,list_ids,ier); call ckerr(s)

  do i=1,inum
     call eq_list_size(list_ids(i),isize)
     write(6,*) i,list_names(i),' id=',list_ids(i),' size=',isize
  enddo

  call eq_glistnum('List_A',inum)
  if(inum.eq.0) call bad_exit

  call eq_list_label(inum,elem_labels(10))
  write(6,*) ' LIST_A generic label: ',trim(elem_labels(10))

  call eq_list_size(inum,isize)

  call eq_list_enames(inum,isize,elem_names,ier); call ckerr(s)
  call eq_list_chvals(inum,isize,elem_labels,ier); call ckerr(s)
  call eq_list_ivals(inum,isize,elem_ivals,ier); call ckerr(s)
  call eq_list_r8vals(inum,isize,elem_r8vals,ier); call ckerr(s)

  write(6,'(a,a,1x,i3,1x,1pe20.13)') &
       ' LIST elem 1 name & values: ',trim(elem_names(1)), &
       elem_ivals(1),elem_r8vals(1)
  write(6,*) ' LIST A elem_labels(',isize,')=',trim(elem_labels(isize))

  call xplasma_getList_names(s,inum,elem_names(1:isize),ier, &
       ivals=elem_ivals(1:isize),chvals=elem_labels(1:isize), &
       r8vals=elem_r8vals(1:isize))

  write(6,'(a,a,1x,i3,1x,1pe20.13)') &
       ' LIST elem 1 name & values: ',trim(elem_names(1)), &
       elem_ivals(1),elem_r8vals(1)
  write(6,*) ' LIST A elem_labels(',isize,')=',trim(elem_labels(isize))

  write(6,*) ' LIST_A:'
  do i=1,isize
     write(6,'(3x,i3,1x,a,1x,i3,1x,1pe15.8,1x,a,a,a)') &
          i,trim(elem_names(i)),elem_ivals(i),elem_r8vals(i),' "', &
          trim(elem_labels(i)),'"'
  enddo

  !---------------------------
  ! test removal operation-- steal it from F77_USER -- the generic legacy
  ! author name for eqm_ calls...

  ! this may be a BAD EXAMPLE of xplasma usage-- normally one module
  ! should not fetch an identity to "impersonate" another module!

  call xplasma_get_item_info(s,id_list,ier,author=zauthor); call ckerr(s)
  call xplasma_author_set(s,zauthor,ier); call ckerr(s)

  call xplasma_remove_item(s,id_list,ier)
  if(ier.ne.0) then
     write(6,*) ' %xplasma2_test: error deleting LIST_A'
  else
     write(6,*) ' %xplasma2_test: LIST_A deleted.'
  endif
  call ckerr(s)

  call xplasma_author_clear(s,zauthor,ier); call ckerr(s)

  inum=id_listb
  call eq_list_label(inum,elem_labels(10))
  write(6,*) ' LIST_B generic label: ',trim(elem_labels(10))

  call eq_list_size(inum,isize)

  call eq_list_enames(inum,isize,elem_names,ier); call ckerr(s)
  call eq_list_chvals(inum,isize,elem_labels,ier); call ckerr(s)
  call eq_list_ivals(inum,isize,elem_ivals,ier); call ckerr(s)
  call eq_list_r8vals(inum,isize,elem_r8vals,ier); call ckerr(s)

  write(6,*) ' LIST_B:'
  do i=1,isize
     write(6,'(3x,i3,1x,a,1x,i3,1x,1pe15.8,1x,a,a,a)') &
          i,trim(elem_names(i)),elem_ivals(i),elem_r8vals(i),' "', &
          trim(elem_labels(i)),'"'
  enddo

  call eqm_rho(zrho,inrho,ztol,id_rho,ier); call ckerr(s)

  call eqm_chi(zchi,0,inchi,ztol,id_chi,ier); call ckerr(s)

  call eqm_uaxis('RHO2',id_rho,0,zrho2,inrho+1,ztol,id_rho2,ier); call ckerr(s)

  call xplasma_author_set(s,'xplasma2_test',ier); call ckerr(s)

  call xplasma_create_coord(s,'xxcoord',.FALSE.,idxxc,ier,label='XX')
  call ckerr(s)

  call xplasma_create_coord(s,'yycoord',.FALSE.,idyyc,ier,label='YY')
  call ckerr(s)

  call xplasma_create_grid(s,'xxgrid',idxxc,xx,idxxg,ier,label='XX')
  call ckerr(s)

  call xplasma_create_grid(s,'yygrid',idyyc,yy,idyyg,ier,label='YY')
  call ckerr(s)

  call xplasma_create_grid(s,'Phi_grid',xplasma_phi_coord,zphi, &
       id_phi,ier); call ckerr(s)

  call xplasma_author_clear(s,'xplasma2_test',ier); call ckerr(s)

  write(6,*) ' '
  write(6,*) ' theta:'
  call ckgrid(xplasma_theta_coord)

  write(6,*) ' '
  write(6,*) ' rho:'
  call ckgrid(xplasma_rho_coord)

  call eq_ngrid(id_rho,inum)
  imax=max(inrho+1,inchi)

  call eq_grid_zc(id_rho,ztmp,imax,igot,ier); call ckerr(s)
  write(6,*) ' id_rho -> eq_grid_zc -> zone centers:'
  write(6,'(3(1x,1pe20.13))') ztmp(1:igot)

  call eq_get_aname(id_rho,zname)
  write(6,*) ' eq_get_aname(',id_rho,',...) returned zname="',trim(zname),'"'
  call eq_ganum(zname,id_rho)
  write(6,*) ' eq_ganum("',trim(zname),'",...) returned id_rho=',id_rho

  !=========================================================
  !  profile tests...

  do ix=1,inrho
     zsinx(ix)=sin(z2pi*zrho(ix))
     zcosx(ix)=cos(z2pi*zrho(ix))
  enddo
  do ix=1,inrho+1
     zsinx2(ix)=sin(z2pi*zrho2(ix))
  enddo

  call eqm_rhofun(2,id_rho,'SINX',zsinx, &
       0,zdum,0,zdum, id_fun,ier); call ckerr(s)

  call eqm_rhofun(99,id_rho2,'SINX',zsinx2, &
       0,zdum,0,zdum, id_fun,ier); call ckerr(s)

  call xplasma_getProf_1data(s,id_fun,zsinx1,ier, zcoeff=zcoeff1)
  call ckerr(s)

  call xplasma_author_set(s,'xplasma2_test',ier); call ckerr(s)

  call xplasma_create_prof(s,'SINX1',id_rho2,zsinx1,id_fun1,ier, &
       ispline=2, coeffs=zcoeff1); call ckerr(s)

  call xplasma_author_clear(s,'xplasma2_test',ier); call ckerr(s)

  do ideriv=0,2
     call xplasma_eval_prof(s,id_fun,xx,ff,ier,  ideriv1=ideriv); call ckerr(s)
     call xplasma_eval_prof(s,id_fun1,xx,ff1,ier,ideriv1=ideriv); call ckerr(s)

     do ix=1,size(xx)
        if(ff(ix).ne.ff1(ix)) then
           write(6,*) ' ?unexpected difference: ideriv=',ideriv
           write(6,*) '    ff, ff1 (',ix,'): ',ff(ix),ff1(ix)
        endif
     enddo
  enddo

  ! test: convert spline to hermite (C2 maintained)
  call xplasma_hermitize(s,id_fun1,ier);  call ckerr(s)

  do ideriv=0,1
     call xplasma_eval_prof(s,id_fun,xx,ff,ier,  ideriv1=ideriv); call ckerr(s)
     call xplasma_eval_prof(s,id_fun1,xx,ff1,ier,ideriv1=ideriv); call ckerr(s)

     zscale = maxval(abs(ff))

     do ix=1,size(xx)
        if(abs(ff(ix)-ff1(ix)).gt.(1.0d-14*zscale)) then
           write(6,*) ' ?unexpected difference: ideriv=',ideriv
           write(6,*) '    ff, ff1 (',ix,'): ',ff(ix),ff1(ix)
        endif
     enddo
  enddo

  call xplasma_author_set(s,'xplasma2_test',ier); call ckerr(s)
  call xplasma_remove_item(s,id_fun1,ier); call ckerr(s)
  call xplasma_author_clear(s,'xplasma2_test',ier); call ckerr(s)

  call eqm_rhofun(2,id_rho,'SINX_SPL',zsinx, &
       1,z2pi,1,z2pi, id_funs,ier); call ckerr(s)  ! explicit BC

  call eqm_rhofun(2,id_rho,'COSX_SPL',zcosx, &
       1,zero,1,zero, id_funsc,ier); call ckerr(s)  ! explicit BC

  call eqm_rhofun(1,id_rho,'SINX_HERM',zsinx, &
       1,z2pi,1,z2pi, id_funh,ier); call ckerr(s)  ! explicit BC

  call eqm_rhofun(0,id_rho,'SINX_LIN',zsinx, &
       0,zdum,0,zdum, id_funl,ier); call ckerr(s)

  call xplasma_prof_info(s,id_fun,ier, rank=irank); call ckerr(s)
  write(6,*) '  SINX rank: ',irank

  call xplasma_prof_info(s,id_fun,ier, splineType=ispline); call ckerr(s)
  write(6,*) '  SINX spline type: ',ispline

  call xplasma_prof_info(s,id_fun,ier, gridId1=id_rho2); call ckerr(s)
  call xplasma_get_item_info(s,id_rho2,ier,name=zname); call ckerr(s)
  write(6,*) '  SINX x axis name: ',trim(zname)

  call eq_get_fname(id_fun,zname)
  write(6,*) '  SINX name fetched: ',trim(zname)

  call eq_gfnum(zname,idum)
  write(6,*) '  SINX number twice: ',id_fun,idum

  call xplasma_get_counter(s,icount,ier); call ckerr(s)
  write(6,*) ' Xplasma profile counter: ',icount
  
  call xplasma_prof_info(s,id_funs,ier, counter=icount); call ckerr(s)
  write(6,*) ' Profile counter for "SINX_SPL": ',icount

  call xplasma_eval_prof(s,id_funs,zans1(1:inrho),ier); call ckerr(s)
  write(6,*) ' Profile retrieve test: '
  write(6,'(a,2(1x,1pe20.13))') '   2-> ',zsinx(2),zans1(2)
  write(6,'(a,2(1x,1pe20.13))') '  12-> ',zsinx(12),zans1(12)

  do ix=1,inxtest
     zxtest(ix)=(ix-1)*0.25d0/(inxtest-1)
  enddo

  ifuns(1)=id_funsc
  ifuns(2)=id_funs
  ifuns(3)=id_funh
  ifuns(4)=id_funl

  call eq_rgetff(inxtest,zxtest,4,ifuns(1:4),0,inxtest,zans4, &
       ier); call ckerr(s)
  write(6,'(a,1pe20.13,a)') '    p = ',z2pi,'  ... function interpolations:'
  write(6,*) ' i  x             cos(px)_spl   sin(px)_spl   sin(px)_herm  sin(px)_lin'
  do ix=1,inxtest
    write(6,1005) ix,zxtest(ix),zans4(ix,1),zans4(ix,2),zans4(ix,3),zans4(ix,4)
  enddo

  !------------
  !  2d & 3d hybrid  zone-spline, zone-hermite, zone-pclin tests
  !  all have just 1 dimension of cubic interpolation

  itest=0
  itmax=0
  dmax=0.0d0

  call hyb2dzon(id_funs,idxxg,zxtest,zans4(:,2),0)
  call hyb2dzon(idxxg,id_funs,zxtest,zans4(:,2),0)

  call hyb2dzon(id_funh,idxxg,zxtest,zans4(:,3),0)
  call hyb2dzon(idxxg,id_funh,zxtest,zans4(:,3),0)

  call hyb2dzon(id_funl,idxxg,zxtest,zans4(:,4),0)
  call hyb2dzon(idxxg,id_funl,zxtest,zans4(:,4),0)

  !-------------
  call hyb2dlin(id_funs,idxxg,zxtest,zans4(:,2),0)
  call hyb2dlin(idxxg,id_funs,zxtest,zans4(:,2),0)

  call hyb2dlin(id_funh,idxxg,zxtest,zans4(:,3),0)
  call hyb2dlin(idxxg,id_funh,zxtest,zans4(:,3),0)

  !-------------
  call hyb3dzon(id_funs,idxxg,idyyg,zxtest,zans4(:,2),0)
  call hyb3dzon(idxxg,id_funs,idyyg,zxtest,zans4(:,2),0)
  call hyb3dzon(idxxg,idyyg,id_funs,zxtest,zans4(:,2),0)

  call hyb3dzon(id_funh,idxxg,idyyg,zxtest,zans4(:,3),0)
  call hyb3dzon(idxxg,id_funh,idyyg,zxtest,zans4(:,3),0)
  call hyb3dzon(idxxg,idyyg,id_funh,zxtest,zans4(:,3),0)

  call hyb3dzon(id_funl,idxxg,idyyg,zxtest,zans4(:,4),0)
  call hyb3dzon(idxxg,id_funl,idyyg,zxtest,zans4(:,4),0)
  call hyb3dzon(idxxg,idyyg,id_funl,zxtest,zans4(:,4),0)

  !-------------
  call hyb3dlin(id_funs,idxxg,idyyg,zxtest,zans4(:,2),0)
  call hyb3dlin(idxxg,id_funs,idyyg,zxtest,zans4(:,2),0)
  call hyb3dlin(idxxg,idyyg,id_funs,zxtest,zans4(:,2),0)

  call hyb3dlin(id_funh,idxxg,idyyg,zxtest,zans4(:,3),0)
  call hyb3dlin(idxxg,id_funh,idyyg,zxtest,zans4(:,3),0)
  call hyb3dlin(idxxg,idyyg,id_funh,zxtest,zans4(:,3),0)

  !-------------
  call hyb3dzln(id_funs,idxxg,idyyg,zxtest,zans4(:,2),0)
  call hyb3dzln(idxxg,id_funs,idyyg,zxtest,zans4(:,2),0)
  call hyb3dzln(idxxg,idyyg,id_funs,zxtest,zans4(:,2),0)

  call hyb3dzln(id_funh,idxxg,idyyg,zxtest,zans4(:,3),0)
  call hyb3dzln(idxxg,id_funh,idyyg,zxtest,zans4(:,3),0)
  call hyb3dzln(idxxg,idyyg,id_funh,zxtest,zans4(:,3),0)

  !-------------
  call hyb3dlzn(id_funs,idxxg,idyyg,zxtest,zans4(:,2),0)
  call hyb3dlzn(idxxg,id_funs,idyyg,zxtest,zans4(:,2),0)
  call hyb3dlzn(idxxg,idyyg,id_funs,zxtest,zans4(:,2),0)

  call hyb3dlzn(id_funh,idxxg,idyyg,zxtest,zans4(:,3),0)
  call hyb3dlzn(idxxg,id_funh,idyyg,zxtest,zans4(:,3),0)
  call hyb3dlzn(idxxg,idyyg,id_funh,zxtest,zans4(:,3),0)

  write(6,*) ' 2d & 3d hybrid interpolation (no derivative)'
  write(6,'(3x,a,i4,a,1pe14.7)') &
       ' number of hybrid tests: ',itest,'; max deviation: ',dmax
  write(6,*) ' '

  if(dmax.gt.1.0d-10) then
     write(6,*) '   MAX DEVIATION:  test#: ',itmax
  endif
  !------------

  call eq_rgetff(inxtest,zxtest,4,ifuns(1:4),1,inxtest,zans4, &
       ier); call ckerr(s)
  write(6,'(a,1pe20.13,a)') '    p = ',z2pi,'  ... df/dx interpolations:'
  write(6,*) ' i  x             cos(px)_spl   sin(px)_spl   sin(px)_herm  sin(px)_lin'
  do ix=1,inxtest
    write(6,1005) ix,zxtest(ix),zans4(ix,1),zans4(ix,2),zans4(ix,3),zans4(ix,4)
  enddo
  !------------
  !  2d & 3d hybrid  zone-spline, zone-hermite, zone-pclin tests
  !  all have just 1 dimension of cubic interpolation

  itest=0
  itmax=0
  dmax=0.0d0

  call hyb2dzon(id_funs,idxxg,zxtest,zans4(:,2),1)
  call hyb2dzon(idxxg,id_funs,zxtest,zans4(:,2),1)

  call hyb2dzon(id_funh,idxxg,zxtest,zans4(:,3),1)
  call hyb2dzon(idxxg,id_funh,zxtest,zans4(:,3),1)

  call hyb2dzon(id_funl,idxxg,zxtest,zans4(:,4),1)
  call hyb2dzon(idxxg,id_funl,zxtest,zans4(:,4),1)

  !-------------
  call hyb2dlin(id_funs,idxxg,zxtest,zans4(:,2),1)
  call hyb2dlin(idxxg,id_funs,zxtest,zans4(:,2),1)

  call hyb2dlin(id_funh,idxxg,zxtest,zans4(:,3),1)
  call hyb2dlin(idxxg,id_funh,zxtest,zans4(:,3),1)

  !-------------
  call hyb3dzon(id_funs,idxxg,idyyg,zxtest,zans4(:,2),1)
  call hyb3dzon(idxxg,id_funs,idyyg,zxtest,zans4(:,2),1)
  call hyb3dzon(idxxg,idyyg,id_funs,zxtest,zans4(:,2),1)

  call hyb3dzon(id_funh,idxxg,idyyg,zxtest,zans4(:,3),1)
  call hyb3dzon(idxxg,id_funh,idyyg,zxtest,zans4(:,3),1)
  call hyb3dzon(idxxg,idyyg,id_funh,zxtest,zans4(:,3),1)

  call hyb3dzon(id_funl,idxxg,idyyg,zxtest,zans4(:,4),1)
  call hyb3dzon(idxxg,id_funl,idyyg,zxtest,zans4(:,4),1)
  call hyb3dzon(idxxg,idyyg,id_funl,zxtest,zans4(:,4),1)

  !-------------
  call hyb3dlin(id_funs,idxxg,idyyg,zxtest,zans4(:,2),1)
  call hyb3dlin(idxxg,id_funs,idyyg,zxtest,zans4(:,2),1)
  call hyb3dlin(idxxg,idyyg,id_funs,zxtest,zans4(:,2),1)

  call hyb3dlin(id_funh,idxxg,idyyg,zxtest,zans4(:,3),1)
  call hyb3dlin(idxxg,id_funh,idyyg,zxtest,zans4(:,3),1)
  call hyb3dlin(idxxg,idyyg,id_funh,zxtest,zans4(:,3),1)

  !-------------
  call hyb3dzln(id_funs,idxxg,idyyg,zxtest,zans4(:,2),1)
  call hyb3dzln(idxxg,id_funs,idyyg,zxtest,zans4(:,2),1)
  call hyb3dzln(idxxg,idyyg,id_funs,zxtest,zans4(:,2),1)

  call hyb3dzln(id_funh,idxxg,idyyg,zxtest,zans4(:,3),1)
  call hyb3dzln(idxxg,id_funh,idyyg,zxtest,zans4(:,3),1)
  call hyb3dzln(idxxg,idyyg,id_funh,zxtest,zans4(:,3),1)

  !-------------
  call hyb3dlzn(id_funs,idxxg,idyyg,zxtest,zans4(:,2),1)
  call hyb3dlzn(idxxg,id_funs,idyyg,zxtest,zans4(:,2),1)
  call hyb3dlzn(idxxg,idyyg,id_funs,zxtest,zans4(:,2),1)

  call hyb3dlzn(id_funh,idxxg,idyyg,zxtest,zans4(:,3),1)
  call hyb3dlzn(idxxg,id_funh,idyyg,zxtest,zans4(:,3),1)
  call hyb3dlzn(idxxg,idyyg,id_funh,zxtest,zans4(:,3),1)

  write(6,*) ' 2d & 3d hybrid interpolation (1st derivative)'
  write(6,'(3x,a,i4,a,1pe14.7)') &
       ' number of hybrid tests: ',itest,'; max deviation: ',dmax
  write(6,*) ' '

  if(dmax.gt.1.0d-10) then
     write(6,*) '   MAX DEVIATION:  test#: ',itmax
  endif
  !------------

  !  test using 2d evaluator for 1d profile -- answer should not change...
  !  reverse order of rho & chi... answer should not change...
  call xplasma_eval_prof(s,ifuns(2),id_chi,zxtest,id_rho,zxtest,zans1,ier, &
       ideriv2=1); call ckerr(s)

  write(6,'(2x,a,2(1x,1pe20.13))') &
       '1d 2d eval compare pt. 13: ',zans4(13,2),zans1(13)
  write(6,'(2x,a,2(1x,1pe20.13))') &
       '1d 2d eval compare pt. 37: ',zans4(37,2),zans1(37)

  call xplasma_eval_prof(s,ifuns,id_rho,zxtest,id_chi,zxtest,zans4,ier, &
       ideriv1=1); call ckerr(s)

  write(6,'(2x,a,2(1x,1pe20.13))') &
       '1d 2d eval compare pt. 13: ',zans4(13,2),zans1(13)
  write(6,'(2x,a,2(1x,1pe20.13))') &
       '1d 2d eval compare pt. 37: ',zans4(37,2),zans1(37)


  !  only splines have 2nd and 3rd derivatives...
  call xplasma_eval_prof(s,id_funs,zxtest,zans4(1:inxtest,1),ier, &
       ideriv1=0); call ckerr(s)
  call xplasma_eval_prof(s,id_funs,zxtest,zans4(1:inxtest,2),ier, &
       ideriv1=1); call ckerr(s)
  call xplasma_eval_prof(s,id_funs,zxtest,zans4(1:inxtest,3),ier, &
       ideriv1=2); call ckerr(s)
  call xplasma_eval_prof(s,id_funs,zxtest,zans4(1:inxtest,4),ier, &
       ideriv1=3); call ckerr(s)

  write(6,'(a,1pe20.13,a)') '    p = ',z2pi,'  ... function interpolations:'
  write(6,*) ' i  x         f(x)=sin(px)_spl  df/dx         d2f/dx2       d3f/dx3'
  do ix=1,inxtest
     write(6,1005) ix,zxtest(ix),zans4(ix,1),zans4(ix,2),zans4(ix,3),zans4(ix,4)
  enddo

1005 format(1x,i2,5(1x,1pe13.6))
  !------------
  !  2d & 3d hybrid  zone-spline, zone-hermite, zone-pclin tests
  !  all have just 1 dimension of cubic interpolation

  itest=0
  itmax=0
  dmax=0.0d0

  call hyb2dzon(id_funs,idxxg,zxtest,zans4(:,3),2)
  call hyb2dzon(idxxg,id_funs,zxtest,zans4(:,3),2)

  !-------------
  call hyb2dlin(id_funs,idxxg,zxtest,zans4(:,3),2)
  call hyb2dlin(idxxg,id_funs,zxtest,zans4(:,3),2)

  !-------------
  call hyb3dzon(id_funs,idxxg,idyyg,zxtest,zans4(:,3),2)
  call hyb3dzon(idxxg,id_funs,idyyg,zxtest,zans4(:,3),2)
  call hyb3dzon(idxxg,idyyg,id_funs,zxtest,zans4(:,3),2)

  !-------------
  call hyb3dlin(id_funs,idxxg,idyyg,zxtest,zans4(:,3),2)
  call hyb3dlin(idxxg,id_funs,idyyg,zxtest,zans4(:,3),2)
  call hyb3dlin(idxxg,idyyg,id_funs,zxtest,zans4(:,3),2)

  !-------------
  call hyb3dzln(id_funs,idxxg,idyyg,zxtest,zans4(:,3),2)
  call hyb3dzln(idxxg,id_funs,idyyg,zxtest,zans4(:,3),2)
  call hyb3dzln(idxxg,idyyg,id_funs,zxtest,zans4(:,3),2)

  !-------------
  call hyb3dlzn(id_funs,idxxg,idyyg,zxtest,zans4(:,3),2)
  call hyb3dlzn(idxxg,id_funs,idyyg,zxtest,zans4(:,3),2)
  call hyb3dlzn(idxxg,idyyg,id_funs,zxtest,zans4(:,3),2)

  write(6,*) ' 2d & 3d hybrid interpolation (2nd derivative)'
  write(6,'(3x,a,i4,a,1pe14.7)') &
       ' number of hybrid tests: ',itest,'; max deviation: ',dmax
  write(6,*) ' '

  if(dmax.gt.1.0d-10) then
     write(6,*) '   MAX DEVIATION:  test#: ',itmax
  endif
  !------------
  !=========================================================
  ! f(rho,chi) profile test

  do ichi=1,inchi
     do ix=1,inrho
        f2d(ix,ichi)=exp(zrho(ix))*sin(zchi(ichi))
     enddo
  enddo

  !  zchi args here are actually dummies but with right dimensionality--
  !  to pass lf95 arg consistency check...

  call eqm_frhochi(0,id_rho,id_chi,'f2dlin',f2d,inrho, &
       0,zchi,0,zchi,id_f2dlin,ier); call ckerr(s)

  call eqm_frhochi(1,id_rho,id_chi,'f2dherm',f2d,inrho, &
       0,zchi,0,zchi,id_f2dherm,ier); call ckerr(s)

  call eqm_frhochi(2,id_rho,id_chi,'f2dspl',f2d,inrho, &
       0,zchi,0,zchi,id_f2dspl,ier); call ckerr(s)

  call xplasma_eval_prof(s,id_f2dspl,f2dret,ier, zcoeff=f2dcoeff)
  call ckerr(s)
  write(6,'(1x,a,2(1x,1pe20.13))') 'f2d[ret](3,4)   =',f2d(3,4),f2dret(3,4)
  write(6,'(1x,a,2(1x,1pe20.13))') 'f2d[ret](11,35) =',f2d(11,35),f2dret(11,35)

  call xplasma_author_set(s,'xplasma2_test',ier); call ckerr(s)

  call xplasma_create_prof(s,'f2dspl2',id_rho,id_chi,f2dret,id_fun1,ier, &
       ispline=2,coeffs=f2dcoeff); call ckerr(s)

  call xplasma_author_clear(s,'xplasma2_test',ier); call ckerr(s)

  x2d(1)=x2dcen-zd; th2d(1)=th2dcen-zd
  x2d(2)=x2dcen;    th2d(2)=th2dcen-zd
  x2d(3)=x2dcen+zd; th2d(3)=th2dcen-zd

  x2d(4)=x2dcen-zd; th2d(4)=th2dcen
  x2d(5)=x2dcen;    th2d(5)=th2dcen
  x2d(6)=x2dcen+zd; th2d(6)=th2dcen

  x2d(7)=x2dcen-zd; th2d(7)=th2dcen+zd
  x2d(8)=x2dcen;    th2d(8)=th2dcen+zd
  x2d(9)=x2dcen+zd; th2d(9)=th2dcen+zd

  ifuns(1)=id_f2dlin
  ifuns(2)=id_f2dherm
  ifuns(3)=id_f2dspl
  ifuns(4)=id_fun1

  call eq_frhochi(9,x2d,th2d,4,ifuns(1:4),9,vals2d,ier); call ckerr(s)
  do i=1,9
     if(vals2d(i,3).ne.vals2d(i,4)) then
        write(6,*) ' f2dspl/f2dspl2 mismatch: i,val,val2=', &
             i,vals2d(i,2),vals2d(i,4)
     endif
     vals2da(i)=exp(x2d(i))*sin(th2d(i))
  enddo

  write(6,1400) '   values: L H S A: ',vals2d(5,1:3),vals2da(5)

  ztmp(1:3)=(vals2d(6,1:3)-vals2d(4,1:3))/(2*zd)
  ztmp(4)=(vals2da(6)-vals2da(4))/(2*zd)
  write(6,1400) '        f.d. df/dx: ',ztmp(1:4)

  ztmp(1:3)=(vals2d(8,1:3)-vals2d(2,1:3))/(2*zd)
  ztmp(4)=(vals2da(8)-vals2da(2))/(2*zd)
  write(6,1400) '    f.d. df/dtheta: ',ztmp(1:4)

  ztmp(1:3)=(vals2d(9,1:3)-vals2d(7,1:3)-vals2d(3,1:3)+vals2d(1,1:3))/(4*zd*zd)
  ztmp(4)=(vals2da(9)-vals2da(7)-vals2da(3)+vals2da(1))/(4*zd*zd)
  write(6,1400) ' f.d. d2f/dxdtheta: ',ztmp(1:4)

1400 format(1x,a,4(1x,1pe13.6))
1401 format(1x,a,3(1x,1pe13.6))

  ict=0
  ict(2:3)=1
  ict(6)=1
  call eq_hrhochi(1,x2d(5:5),th2d(5:5),4,ifuns(1:4),ict,1,valtmp2d,ier)
  call ckerr(s)

  write(6,*) ' '
  write(6,1401) '     interp. df/dx: ',valtmp2d(1,1),valtmp2d(1,4),valtmp2d(1,7)
  write(6,1401) ' interp. df/dtheta: ',valtmp2d(1,2),valtmp2d(1,5),valtmp2d(1,8)
  write(6,1401) ' interp. d2f/dthdx: ',valtmp2d(1,3),valtmp2d(1,6),valtmp2d(1,9)
  do ii=7,9
     if(valtmp2d(1,ii).ne.valtmp2d(1,ii+3)) then
        write(6,*) ' ? f2dspl/f2dspl2 derivative mismatch: ', &
             valtmp2d(1,ii),valtmp2d(1,ii+3)
     endif
  enddo

  call xplasma_hermitize(s,id_fun1,ier); call ckerr(s)
  do ideriv2=0,1
     do ideriv1=0,1
        call xplasma_eval_prof(s,id_f2dspl, &
             id_chi,th2d, id_rho,x2d, yy2d, ier, &
             ideriv1=ideriv1, ideriv2=ideriv2); call ckerr(s)
        call xplasma_eval_prof(s,id_fun1, &
             id_chi,th2d, id_rho,x2d, yy2e, ier, &
             ideriv1=ideriv1, ideriv2=ideriv2); call ckerr(s)

        zscale = maxval(abs(yy2d))
        zfac=1.0d-14
        if(ideriv1+ideriv2.eq.2) zfac=1.0d-12

        do ix=1,size(x2d)
           if(abs(yy2d(ix)-yy2e(ix)).gt.(zfac*zscale)) then
              write(6,*) ' ?unexpected difference: ideriv1,2=',ideriv1,ideriv2
              write(6,*) '    yy2d, yy2e (',ix,'): ',yy2d(ix),yy2e(ix)
           endif
        enddo
     enddo
  enddo

  call xplasma_author_set(s,'xplasma2_test',ier); call ckerr(s)
  call xplasma_remove_item(s,id_fun1,ier); call ckerr(s)
  call xplasma_author_clear(s,'xplasma2_test',ier); call ckerr(s)

  ! 3d hybrid interpolation comparisons
  !  Zone-linear, Zone-Hermite, and Zone-Spline hybrids

  itest=0
  itmax=0
  dmax=0.0d0

  ict=0
  ict(1)=1  ! value
  call eq_hrhochi(9,x2d,th2d,3,ifuns(1:3),ict,9,vals2d,ier); call ckerr(s)

  call hyb3z2(1,id_f2dlin,x2d,th2d,vals2d(:,1),0,0)
  call hyb3z2(2,id_f2dlin,x2d,th2d,vals2d(:,1),0,0)
  call hyb3z2(3,id_f2dlin,x2d,th2d,vals2d(:,1),0,0)

  call hyb3z2(1,id_f2dherm,x2d,th2d,vals2d(:,2),0,0)
  call hyb3z2(2,id_f2dherm,x2d,th2d,vals2d(:,2),0,0)
  call hyb3z2(3,id_f2dherm,x2d,th2d,vals2d(:,2),0,0)

  call hyb3z2(1,id_f2dspl,x2d,th2d,vals2d(:,3),0,0)
  call hyb3z2(2,id_f2dspl,x2d,th2d,vals2d(:,3),0,0)
  call hyb3z2(3,id_f2dspl,x2d,th2d,vals2d(:,3),0,0)

  ict(1)=0
  ict(2)=1  ! d/drho
  call eq_hrhochi(9,x2d,th2d,3,ifuns(1:3),ict,9,vals2d,ier); call ckerr(s)

  call hyb3z2(1,id_f2dlin,x2d,th2d,vals2d(:,1),1,0)
  call hyb3z2(2,id_f2dlin,x2d,th2d,vals2d(:,1),1,0)
  call hyb3z2(3,id_f2dlin,x2d,th2d,vals2d(:,1),1,0)

  call hyb3z2(1,id_f2dherm,x2d,th2d,vals2d(:,2),1,0)
  call hyb3z2(2,id_f2dherm,x2d,th2d,vals2d(:,2),1,0)
  call hyb3z2(3,id_f2dherm,x2d,th2d,vals2d(:,2),1,0)

  call hyb3z2(1,id_f2dspl,x2d,th2d,vals2d(:,3),1,0)
  call hyb3z2(2,id_f2dspl,x2d,th2d,vals2d(:,3),1,0)
  call hyb3z2(3,id_f2dspl,x2d,th2d,vals2d(:,3),1,0)

  ict(2)=0
  ict(3)=1  ! d/dchi
  call eq_hrhochi(9,x2d,th2d,3,ifuns(1:3),ict,9,vals2d,ier); call ckerr(s)

  call hyb3z2(1,id_f2dlin,x2d,th2d,vals2d(:,1),0,1)
  call hyb3z2(2,id_f2dlin,x2d,th2d,vals2d(:,1),0,1)
  call hyb3z2(3,id_f2dlin,x2d,th2d,vals2d(:,1),0,1)

  call hyb3z2(1,id_f2dherm,x2d,th2d,vals2d(:,2),0,1)
  call hyb3z2(2,id_f2dherm,x2d,th2d,vals2d(:,2),0,1)
  call hyb3z2(3,id_f2dherm,x2d,th2d,vals2d(:,2),0,1)

  call hyb3z2(1,id_f2dspl,x2d,th2d,vals2d(:,3),0,1)
  call hyb3z2(2,id_f2dspl,x2d,th2d,vals2d(:,3),0,1)
  call hyb3z2(3,id_f2dspl,x2d,th2d,vals2d(:,3),0,1)

  ict(3)=0
  ict(6)=1  ! d2/drhodchi
  call eq_hrhochi(9,x2d,th2d,3,ifuns(1:3),ict,9,vals2d,ier); call ckerr(s)

  call hyb3z2(1,id_f2dlin,x2d,th2d,vals2d(:,1),1,1)
  call hyb3z2(2,id_f2dlin,x2d,th2d,vals2d(:,1),1,1)
  call hyb3z2(3,id_f2dlin,x2d,th2d,vals2d(:,1),1,1)

  call hyb3z2(1,id_f2dherm,x2d,th2d,vals2d(:,2),1,1)
  call hyb3z2(2,id_f2dherm,x2d,th2d,vals2d(:,2),1,1)
  call hyb3z2(3,id_f2dherm,x2d,th2d,vals2d(:,2),1,1)

  call hyb3z2(1,id_f2dspl,x2d,th2d,vals2d(:,3),1,1)
  call hyb3z2(2,id_f2dspl,x2d,th2d,vals2d(:,3),1,1)
  call hyb3z2(3,id_f2dspl,x2d,th2d,vals2d(:,3),1,1)

  ict(6)=0
  ict(4)=1  ! d2/drho2
  call eq_hrhochi(9,x2d,th2d,1,ifuns(3:3),ict,9,vals2d,ier); call ckerr(s)

  call hyb3z2(1,id_f2dspl,x2d,th2d,vals2d(:,1),2,0)
  call hyb3z2(2,id_f2dspl,x2d,th2d,vals2d(:,1),2,0)
  call hyb3z2(3,id_f2dspl,x2d,th2d,vals2d(:,1),2,0)

  ict(4)=0
  ict(5)=1  ! d2/dchi2
  call eq_hrhochi(9,x2d,th2d,1,ifuns(3:3),ict,9,vals2d,ier); call ckerr(s)

  call hyb3z2(1,id_f2dspl,x2d,th2d,vals2d(:,1),0,2)
  call hyb3z2(2,id_f2dspl,x2d,th2d,vals2d(:,1),0,2)
  call hyb3z2(3,id_f2dspl,x2d,th2d,vals2d(:,1),0,2)

  write(6,*) ' '
  write(6,*) ' 3d (zonal + 2d interpolant)'
  write(6,'(3x,a,i4,a,1pe14.7)') &
       ' number of hybrid tests: ',itest,'; max deviation: ',dmax
  write(6,*) ' '

  if(dmax.gt.1.0d-10) then
     write(6,*) '   MAX DEVIATION:  test#: ',itmax
     write(6,*) ' '
  endif

  ! 3d hybrid interpolation comparisons
  !   Linear-Hermite, and Linear-Spline hybrids

  itest=0
  itmax=0
  dmax=0.0d0

  ict=0
  ict(1)=1  ! value
  call eq_hrhochi(9,x2d,th2d,3,ifuns(1:3),ict,9,vals2d,ier); call ckerr(s)

  call hyb3lin2(1,id_f2dherm,x2d,th2d,vals2d(:,2),0,0)
  call hyb3lin2(2,id_f2dherm,x2d,th2d,vals2d(:,2),0,0)
  call hyb3lin2(3,id_f2dherm,x2d,th2d,vals2d(:,2),0,0)

  call hyb3lin2(1,id_f2dspl,x2d,th2d,vals2d(:,3),0,0)
  call hyb3lin2(2,id_f2dspl,x2d,th2d,vals2d(:,3),0,0)
  call hyb3lin2(3,id_f2dspl,x2d,th2d,vals2d(:,3),0,0)

  ict(1)=0
  ict(2)=1  ! d/drho
  call eq_hrhochi(9,x2d,th2d,3,ifuns(1:3),ict,9,vals2d,ier); call ckerr(s)

  call hyb3lin2(1,id_f2dherm,x2d,th2d,vals2d(:,2),1,0)
  call hyb3lin2(2,id_f2dherm,x2d,th2d,vals2d(:,2),1,0)
  call hyb3lin2(3,id_f2dherm,x2d,th2d,vals2d(:,2),1,0)

  call hyb3lin2(1,id_f2dspl,x2d,th2d,vals2d(:,3),1,0)
  call hyb3lin2(2,id_f2dspl,x2d,th2d,vals2d(:,3),1,0)
  call hyb3lin2(3,id_f2dspl,x2d,th2d,vals2d(:,3),1,0)

  ict(2)=0
  ict(3)=1  ! d/dchi
  call eq_hrhochi(9,x2d,th2d,3,ifuns(1:3),ict,9,vals2d,ier); call ckerr(s)

  call hyb3lin2(1,id_f2dherm,x2d,th2d,vals2d(:,2),0,1)
  call hyb3lin2(2,id_f2dherm,x2d,th2d,vals2d(:,2),0,1)
  call hyb3lin2(3,id_f2dherm,x2d,th2d,vals2d(:,2),0,1)

  call hyb3lin2(1,id_f2dspl,x2d,th2d,vals2d(:,3),0,1)
  call hyb3lin2(2,id_f2dspl,x2d,th2d,vals2d(:,3),0,1)
  call hyb3lin2(3,id_f2dspl,x2d,th2d,vals2d(:,3),0,1)

  ict(3)=0
  ict(6)=1  ! d2/drhodchi
  call eq_hrhochi(9,x2d,th2d,3,ifuns(1:3),ict,9,vals2d,ier); call ckerr(s)

  call hyb3lin2(1,id_f2dherm,x2d,th2d,vals2d(:,2),1,1)
  call hyb3lin2(2,id_f2dherm,x2d,th2d,vals2d(:,2),1,1)
  call hyb3lin2(3,id_f2dherm,x2d,th2d,vals2d(:,2),1,1)

  call hyb3lin2(1,id_f2dspl,x2d,th2d,vals2d(:,3),1,1)
  call hyb3lin2(2,id_f2dspl,x2d,th2d,vals2d(:,3),1,1)
  call hyb3lin2(3,id_f2dspl,x2d,th2d,vals2d(:,3),1,1)

  ict(6)=0
  ict(4)=1  ! d2/drho2
  call eq_hrhochi(9,x2d,th2d,1,ifuns(3:3),ict,9,vals2d,ier); call ckerr(s)

  call hyb3lin2(1,id_f2dspl,x2d,th2d,vals2d(:,1),2,0)
  call hyb3lin2(2,id_f2dspl,x2d,th2d,vals2d(:,1),2,0)
  call hyb3lin2(3,id_f2dspl,x2d,th2d,vals2d(:,1),2,0)

  ict(4)=0
  ict(5)=1  ! d2/dchi2
  call eq_hrhochi(9,x2d,th2d,1,ifuns(3:3),ict,9,vals2d,ier); call ckerr(s)

  call hyb3lin2(1,id_f2dspl,x2d,th2d,vals2d(:,1),0,2)
  call hyb3lin2(2,id_f2dspl,x2d,th2d,vals2d(:,1),0,2)
  call hyb3lin2(3,id_f2dspl,x2d,th2d,vals2d(:,1),0,2)

  write(6,*) ' 3d (piecewise linear + 2d cubic interpolant)'
  write(6,'(3x,a,i4,a,1pe14.7)') &
       ' number of hybrid tests: ',itest,'; max deviation: ',dmax
  write(6,*) ' '

  if(dmax.gt.1.0d-10) then
     write(6,*) '   MAX DEVIATION:  test#: ',itmax
     write(6,*) ' '
  endif
  !=========================================================
  !  f(phi,rho,theta) test (3d)
  !  no f77 interface

  do ichi=1,inchi
     do ix=1,inrho
        do iphi=1,inphi
           f3d(iphi,ix,ichi)=exp(zrho(ix))*cos(zchi(ichi))*sin(zphi(iphi))
        enddo
     enddo
  enddo

  call xplasma_author_set(s,'xplasma2_test',ier); call ckerr(s)

  !  linear
  call xplasma_create_prof(s,'f3dlin',id_phi,id_rho,id_chi,f3d,id_f3dlin,ier)
  call ckerr(s)

  !  Hermite w/BCs

  call xplasma_create_prof(s,'f3dherm',id_phi,id_rho,id_chi,f3d,id_f3dherm, &
       ier,  ispline=1,ibcx2a=1,zbcx2a=f3d(1:inphi,1,1:inchi), &
       ibcx2b=1,zbcx2b=f3d(1:inphi,inrho,1:inchi))
  call ckerr(s)
  
  !  Spline w/BCs

  call xplasma_create_prof(s,'f3dspl',id_phi,id_rho,id_chi,f3d,id_f3dspl, &
       ier,  ispline=2,ibcx2a=1,zbcx2a=f3d(1:inphi,1,1:inchi), &
       ibcx2b=1,zbcx2b=f3d(1:inphi,inrho,1:inchi))
  call ckerr(s)

  call xplasma_author_clear(s,'xplasma2_test',ier); call ckerr(s)

  ! sanity check... return profile verbatim on original grid...

  call xplasma_eval_prof(s,id_f3dspl,f3dret,ier, zcoeff=f3dcoeff)
  call ckerr(s)

  zsum1=0; zsum2=0
  do ichi=1,inchi
     do ix=1,inrho
        do iphi=1,inphi
           zsum1=zsum1+abs(f3d(iphi,ix,ichi))
           zsum2=zsum2+abs(f3dret(iphi,ix,ichi))
        enddo
     enddo
  enddo
  write(6,'(1x,a,2(1x,1pe20.13))') ' f3d/f3dret checksums: ',zsum1,zsum2

  call xplasma_author_set(s,'xplasma2_test',ier); call ckerr(s)

  call xplasma_create_prof(s,'f3dspl2',id_phi,id_rho,id_chi, &
       f3dret,id_fun1,ier, &
       ispline=2,coeffs=f3dcoeff); call ckerr(s)

  call xplasma_author_clear(s,'xplasma2_test',ier); call ckerr(s)

  x3d(1)=x3dcen-zd; th3d(1)=th3dcen-zd; ph3d(1)=ph3dcen-zd
  x3d(2)=x3dcen;    th3d(2)=th3dcen-zd; ph3d(2)=ph3dcen-zd
  x3d(3)=x3dcen+zd; th3d(3)=th3dcen-zd; ph3d(3)=ph3dcen-zd

  x3d(4)=x3dcen-zd; th3d(4)=th3dcen;    ph3d(4)=ph3dcen-zd
  x3d(5)=x3dcen;    th3d(5)=th3dcen;    ph3d(5)=ph3dcen-zd
  x3d(6)=x3dcen+zd; th3d(6)=th3dcen;    ph3d(6)=ph3dcen-zd

  x3d(7)=x3dcen-zd; th3d(7)=th3dcen+zd; ph3d(7)=ph3dcen-zd
  x3d(8)=x3dcen;    th3d(8)=th3dcen+zd; ph3d(8)=ph3dcen-zd
  x3d(9)=x3dcen+zd; th3d(9)=th3dcen+zd; ph3d(9)=ph3dcen-zd

  x3d(10)=x3dcen-zd; th3d(10)=th3dcen-zd; ph3d(10)=ph3dcen
  x3d(11)=x3dcen;    th3d(11)=th3dcen-zd; ph3d(11)=ph3dcen
  x3d(12)=x3dcen+zd; th3d(12)=th3dcen-zd; ph3d(12)=ph3dcen

  x3d(13)=x3dcen-zd; th3d(13)=th3dcen;    ph3d(13)=ph3dcen
  x3d(14)=x3dcen;    th3d(14)=th3dcen;    ph3d(14)=ph3dcen
  x3d(15)=x3dcen+zd; th3d(15)=th3dcen;    ph3d(15)=ph3dcen

  x3d(16)=x3dcen-zd; th3d(16)=th3dcen+zd; ph3d(16)=ph3dcen
  x3d(17)=x3dcen;    th3d(17)=th3dcen+zd; ph3d(17)=ph3dcen
  x3d(18)=x3dcen+zd; th3d(18)=th3dcen+zd; ph3d(18)=ph3dcen

  x3d(19)=x3dcen-zd; th3d(19)=th3dcen-zd; ph3d(19)=ph3dcen+zd
  x3d(20)=x3dcen;    th3d(20)=th3dcen-zd; ph3d(20)=ph3dcen+zd
  x3d(21)=x3dcen+zd; th3d(21)=th3dcen-zd; ph3d(21)=ph3dcen+zd

  x3d(22)=x3dcen-zd; th3d(22)=th3dcen;    ph3d(22)=ph3dcen+zd
  x3d(23)=x3dcen;    th3d(23)=th3dcen;    ph3d(23)=ph3dcen+zd
  x3d(24)=x3dcen+zd; th3d(24)=th3dcen;    ph3d(24)=ph3dcen+zd

  x3d(25)=x3dcen-zd; th3d(25)=th3dcen+zd; ph3d(25)=ph3dcen+zd
  x3d(26)=x3dcen;    th3d(26)=th3dcen+zd; ph3d(26)=ph3dcen+zd
  x3d(27)=x3dcen+zd; th3d(27)=th3dcen+zd; ph3d(27)=ph3dcen+zd

  ifuns(1)=id_f3dlin
  ifuns(2)=id_f3dherm
  ifuns(3)=id_f3dspl
  ifuns(4)=id_fun1

  do i=1,27
     vals3da(i)=exp(x3d(i))*cos(th3d(i))*sin(ph3d(i))
  enddo

  call xplasma_eval_prof(s,id_f3dspl,id_rho,x3d(14),id_phi,ph3d(14), &
       id_chi,th3d(14),ztmp(1),ier); call ckerr(s)
  write(6,1400) '   3d spline singleton: ',ztmp(1)

  call xplasma_eval_prof(s,ifuns(1:4),id_chi,th3d,id_phi,ph3d,id_rho,x3d, &
       vals3d,ier); call ckerr(s)

  do ii=1,27
     if(vals3d(ii,3).ne.vals3d(ii,4)) then
        write(6,*) ' ? 3d Spline clone profile eval not identical: ', &
             ii,vals3d(ii,2),vals3d(ii,4)
     endif
  enddo

  write(6,1400) '   values: L H S A: ',vals3d(14,1:3),vals3da(14)

  ztmp(1:3)=(vals3d(15,1:3)-vals3d(13,1:3))/(2*zd)
  ztmp(4)=(vals3da(15)-vals3da(13))/(2*zd)
  write(6,1400) '        f.d. df/dx: ',ztmp(1:4)

  ztmp(1:3)=(vals3d(17,1:3)-vals3d(11,1:3))/(2*zd)
  ztmp(4)=(vals3da(17)-vals3da(11))/(2*zd)
  write(6,1400) '       f.d. df/dth: ',ztmp(1:4)

  ztmp(1:3)=(vals3d(23,1:3)-vals3d(5,1:3))/(2*zd)
  ztmp(4)=(vals3da(23)-vals3da(5))/(2*zd)
  write(6,1400) '       f.d. df/dph: ',ztmp(1:4)

  ztmp(1:3)=(vals3d(24,1:3)-vals3d(6,1:3)-vals3d(22,1:3)+vals3d(4,1:3))/ &
       (4*zd*zd)
  ztmp(4)=(vals3da(24)-vals3da(6)-vals3da(22)+vals3da(4))/ &
       (4*zd*zd)
  write(6,1400) '    f.d. d2f/dxdph: ',ztmp(1:4)

  ztmp(1:3)=(vals3d(18,1:3)-vals3d(16,1:3)-vals3d(12,1:3)+vals3d(10,1:3))/ &
       (4*zd*zd)
  ztmp(4)=(vals3da(18)-vals3da(16)-vals3da(12)+vals3da(10))/ &
       (4*zd*zd)
  write(6,1400) '    f.d. d2f/dxdth: ',ztmp(1:4)

  ztmp(1:3)=(vals3d(26,1:3)-vals3d(8,1:3)-vals3d(20,1:3)+vals3d(2,1:3))/ &
       (4*zd*zd)
  ztmp(4)=(vals3da(26)-vals3da(8)-vals3da(20)+vals3da(2))/ &
       (4*zd*zd)
  write(6,1400) '   f.d. d2f/dthdph: ',ztmp(1:4)

  ztmp(1:3)=(vals3d(27,1:3)-vals3d(9,1:3)-vals3d(21,1:3)+vals3d(3,1:3) &
       -vals3d(25,1:3)+vals3d(7,1:3)+vals3d(19,1:3)-vals3d(1,1:3))/ &
       (8*zd*zd*zd)

  ztmp(4)=(vals3da(27)-vals3da(9)-vals3da(21)+vals3da(3) &
       -vals3da(25)+vals3da(7)+vals3da(19)-vals3da(1))/ &
       (8*zd*zd*zd)

  write(6,*) ' ...platform to platform variation likely in following line:'
  write(6,1400) ' f.d. d3f/dxdthdph: ',ztmp(1:4)

  write(6,*) ' '

  call xplasma_eval_prof(s,ifuns(1:4),id_chi,th3d(14),id_rho,x3d(14), &
       id_phi,ph3d(14),ztmp(1:4),ier,ideriv2=1)
  write(6,1401) '     interp. df/dx: ',ztmp(1:3)
  if(ztmp(3).ne.ztmp(4)) then
     write(6,*) ' clone 3dspl fcn ideriv2=1 eval difference: ',ztmp(2),ztmp(4)
  endif

  call xplasma_eval_prof(s,ifuns(1:4),id_chi,th3d(14),id_rho,x3d(14), &
       id_phi,ph3d(14),ztmp(1:4),ier,ideriv1=1)
  write(6,1401) '    interp. df/dth: ',ztmp(1:3)
  if(ztmp(3).ne.ztmp(4)) then
     write(6,*) ' clone 3dspl fcn ideriv1=1 eval difference: ',ztmp(2),ztmp(4)
  endif

  call xplasma_eval_prof(s,ifuns(1:4),id_chi,th3d(14),id_rho,x3d(14), &
       id_phi,ph3d(14),ztmp(1:4),ier,ideriv3=1)
  write(6,1401) '    interp. df/dph: ',ztmp(1:3)
  if(ztmp(3).ne.ztmp(4)) then
     write(6,*) ' clone 3dspl fcn ideriv3=1 eval difference: ',ztmp(2),ztmp(4)
  endif

  call xplasma_eval_prof(s,ifuns(1:3),id_chi,th3d(14),id_rho,x3d(14), &
       id_phi,ph3d(14),ztmp(1:3),ier,ideriv2=1,ideriv3=1)
  write(6,1401) ' interp. d2f/dxdph: ',ztmp(1:3)

  call xplasma_eval_prof(s,ifuns(1:3),id_chi,th3d(14),id_rho,x3d(14), &
       id_phi,ph3d(14),ztmp(1:3),ier,ideriv2=1,ideriv1=1)
  write(6,1401) ' interp. d2f/dxdth: ',ztmp(1:3)

  call xplasma_eval_prof(s,ifuns(1:3),id_chi,th3d(14),id_rho,x3d(14), &
       id_phi,ph3d(14),ztmp(1:3),ier,ideriv1=1,ideriv3=1)
  write(6,1401) 'interp. d2f/dthdph: ',ztmp(1:3)

  call xplasma_eval_prof(s,ifuns(1:3),id_chi,th3d(14),id_rho,x3d(14), &
       id_phi,ph3d(14),ztmp(1:3),ier,ideriv3=1,ideriv1=1,ideriv2=1)
  write(6,1401) 'intrp d3f/dxdthdph: ',ztmp(1:3)

  call xplasma_hermitize(s,id_fun1,ier); call ckerr(s)
  do ideriv3=0,1
     do ideriv2=0,1
        do ideriv1=0,1
           call xplasma_eval_prof(s,id_f3dspl, &
                id_chi,th3d, id_rho,x3d, id_phi, ph3d, yy3d, ier, &
                ideriv1=ideriv1, ideriv2=ideriv2, ideriv3=ideriv3)
           call ckerr(s)
           call xplasma_eval_prof(s,id_fun1, &
                id_chi,th3d, id_rho,x3d, id_phi, ph3d, yy3e, ier, &
                ideriv1=ideriv1, ideriv2=ideriv2, ideriv3=ideriv3)
           call ckerr(s)

           zscale = maxval(abs(yy3d))
           zfac=1.0d-14
           if(ideriv1+ideriv2+ideriv3.eq.1) zfac=1.0d-12
           if(ideriv1+ideriv2+ideriv3.eq.2) zfac=1.0d-11
           if(ideriv1+ideriv2+ideriv3.eq.3) zfac=1.0d-10

           do ix=1,size(x3d)
              if(abs(yy3d(ix)-yy3e(ix)).gt.(zfac*zscale)) then
                 write(6,*) ' ?unexpected difference: ideriv1,2,3=', &
                      ideriv1,ideriv2,ideriv3
                 write(6,*) '    yy3d, yy3e (',ix,'): ',yy3d(ix),yy3e(ix)
              endif
           enddo
        enddo
     enddo
  enddo

  call xplasma_author_set(s,'xplasma2_test',ier); call ckerr(s)
  call xplasma_remove_item(s,id_fun1,ier); call ckerr(s)
  call xplasma_author_clear(s,'xplasma2_test',ier); call ckerr(s)

  !=========================================================
  !  step function tests -- separate routine

  call test_stepfuns

  !=========================================================
  !  final tests:  copy and i/o -- 3 identical files should be created.
  !  if they are not identical then there is an error in the code...

  call xplasma_copy(s,s1,ier); call ckerr(s)

  call xplasma_write(s,'foo.cdf',ier); call ckerr(s)

  call xplasma_write(s1,'foo1.cdf',ier); call ckerr(s1)

  call xplasma_read(s2,'foo1.cdf',ier); call ckerr(s2)

  call xplasma_write(s2,'foo2.cdf',ier); call ckerr(s2)

  call xplasma_pack(s2, ipack, r8pack, ier); call ckerr(s2)
  call xplasma_unpack(s2, ipack, r8pack, ier); call ckerr(s2)

  call xplasma_write(s2,'foo3.cdf',ier); call ckerr(s2)

  deallocate(ipack,r8pack)

  call xplasma_init(s2,'empty s2',ier,total=.TRUE.); call ckerr(s2)
  call xplasma_init(s1,'empty s1',ier,total=.TRUE.); call ckerr(s1)

  write(6,*) ' '
  write(6,*) ' xpdebug: '
  call xpdebug(s)
  call xplasma_init(s,'empty s',ier); call ckerr(s)

  write(6,*) ' '
  write(6,*) ' all done.'

  !---------------------------

  contains

    subroutine ckerr(t)
      type (xplasma), pointer :: t
      if(ier.ne.0) then
         call xplasma_error(t,ier,6)
         if(ier.gt.0) call bad_exit
      endif
    end subroutine ckerr

    !---------------------------

    subroutine ckgrid(icoord)

      integer,  intent(in) :: icoord

      !  info on a coordinate & 1 grid for the coordinate...

      integer :: inum,idg,jcoord
      character*32 zname
      logical periodic
      real*8 :: xmin,xmax
      real*8, dimension(:), allocatable :: xgrid

      call xplasma_coord_info(s,icoord,ier, &
           periodic=periodic, ngrids=inum, xmin=xmin, xmax=xmax)

      if(periodic) write(6,*) ' ...periodic coordinate.'
      write(6,'(2x,a,2(1pe20.13))') ' nominal range: ',xmin,xmax
      write(6,*) ' #grids = ',inum

      call xplasma_coord_gridId(s,icoord,inum,idg,ier); call ckerr(s)
      call xplasma_get_item_info(s,idg,ier,name=zname); call ckerr(s)
      write(6,*) '  grid#',inum,' is: ',trim(zname)

      call xplasma_grid_size(s,idg,inum,ier); call ckerr(s)
      write(6,*) '    no. of pts in grid: ', inum

      allocate(xgrid(inum))
      call xplasma_grid(s,idg,xgrid,ier); call ckerr(s)
      write(6,'(3(1x,1pe20.13))') xgrid
      deallocate(xgrid)

      call xplasma_grid_info(s,idg,ier, coord=jcoord); call ckerr(s)
      if(icoord.ne.jcoord) then
         write(6,*) ' ?ckgrid(xplasma2_test): icoord/jcoord mismatch.'
         call bad_exit
      endif

    end subroutine ckgrid

    subroutine hyb2dzon(id1,id2,zxtest,zresult,ideriv)
      integer, intent(in) :: id1  ! id for 1st dimension (profile or XX)
      integer, intent(in) :: id2  ! id for 2nd dimension (XX or profile)
      real*8, intent(in), dimension(:) :: zxtest  ! profile dim test vector
      real*8, intent(in), dimension(:) :: zresult ! profile dim values expected
      integer, intent(in) :: ideriv

      ! construct zone-pclin or zone-spline or zone-hermite 2d Hybrid; evaluate
      ! and compare to expected result.

      !----------------------
      integer :: itype1,itype2,isize_xx,ii,idprof,hspline(2),idg,irank,inx
      integer :: idtmp,idt2(2),idt2a(2)
      real*8 :: result_local(size(zresult),2),zxxwk(size(zresult))
      real*8, dimension(:), allocatable :: xxzc,xxfac,xxoff,bcvals
      real*8, dimension(:,:), allocatable :: pdata
      real*8, parameter :: xxincr = 2.5d0
      real*8 :: xxoffs,dmaxp
      !----------------------

      itest = itest + 1  ! increment test counter

      isize_xx=size(xx)
      allocate(xxzc(isize_xx-1),xxfac(isize_xx-1),xxoff(isize_xx-1))
      allocate(bcvals(isize_xx-1))

      xxzc = (xx(1:isize_xx-1)+xx(2:isize_xx))/2

      xxoffs = xx(isize_xx)/(isize_xx-1)/10.0d0
      xxfac(1)=1.0d0
      xxoff(1)=-xxoffs/2
      do ii=2,isize_xx-1
         xxfac(ii) = xxfac(ii-1) + xxincr
         xxoff(ii) = xxoff(ii-1) + xxoffs
      enddo

      call xplasma_get_item_info(s,id1,ier, itype=itype1); call ckerr(s)
      call xplasma_get_item_info(s,id2,ier, itype=itype2); call ckerr(s)

      if(itype1.eq.xplasma_gridType) then
         idprof=id2
      else
         idprof=id1
      endif
      idt2(1)=idprof

      call xplasma_prof_info(s,idprof,ier, splineType=ispline, &
           rank=irank, gridId1=idg); call ckerr(s)
      if(irank.ne.1) then
         write(6,*) ' ?hyb2dzon: input profile not 1d, id=',idprof
         call bad_exit
      endif

      call xplasma_grid_info(s,idg,ier, size=inx)

      call xplasma_author_set(s,'hyb2dzon',ier); call ckerr(s)

      bcvals(1)=z2pi
      if(itype1.eq.xplasma_gridType) then
         hspline(1)=-1
         hspline(2)=ispline
         allocate(pdata(isize_xx-1,inx))
         call xplasma_getprof_1data(s,idprof,pdata(1,1:inx),ier); call ckerr(s)
         do ii=2,isize_xx-1
            pdata(ii,1:inx)=xxfac(ii)*pdata(1,1:inx)
            bcvals(ii)=xxfac(ii)*bcvals(1)
         enddo

         if(ispline.gt.0) then
            call xplasma_create_2dprof(s,'_TMP_HYB2', &
                 idxxg,idg,pdata,idtmp,ier, &
                 hspline=hspline,ibcx2a=1,zbcx2a=bcvals,ibcx2b=1,zbcx2b=bcvals)
         else
            call xplasma_create_2dprof(s,'_TMP_HYB2', &
                 idxxg,idg,pdata,idtmp,ier, &
                 hspline=hspline)
         endif
         call ckerr(s)

      else
         hspline(1)=ispline
         hspline(2)=-1
         allocate(pdata(inx,isize_xx-1))
         call xplasma_getprof_1data(s,idprof,pdata(1:inx,1),ier); call ckerr(s)
         do ii=2,isize_xx-1
            pdata(1:inx,ii)=xxfac(ii)*pdata(1:inx,1)
            bcvals(ii)=xxfac(ii)*bcvals(1)
         enddo

         if(ispline.gt.0) then
            call xplasma_create_2dprof(s,'_TMP_HYB2', &
                 idg,idxxg,pdata,idtmp,ier, &
                 hspline=hspline,ibcx1a=1,zbcx1a=bcvals,ibcx1b=1,zbcx1b=bcvals)
         else
            call xplasma_create_2dprof(s,'_TMP_HYB2', &
                 idg,idxxg,pdata,idtmp,ier, &
                 hspline=hspline)
         endif
         call ckerr(s)

      endif

      idt2(2)=idtmp

      idt2a(1)=idt2(2)
      idt2a(2)=idt2(1)

      dmaxp=dmax
      do ii=1,isize_xx-1
         zxxwk=xxzc(ii)+xxoff(ii)
         call xplasma_eval_prof(s,idtmp, &
              idxxg,zxxwk, idg,zxtest, result_local(:,1),ier, &
              ideriv2=ideriv); call ckerr(s)
         dmax = max(dmax, &
              maxval(abs(result_local(:,1)/xxfac(ii) - zresult)) )
         
         call xplasma_eval_prof(s,idt2, &
              idxxg,zxxwk, idg,zxtest, result_local,ier, &
              ideriv2=ideriv); call ckerr(s)
         dmax = max(dmax, maxval(abs(result_local(:,1) - zresult)) )
         dmax = max(dmax, &
              maxval(abs(result_local(:,2)/xxfac(ii) - zresult)) )

         call xplasma_eval_prof(s,idt2a, &
              idg,zxtest, idxxg,zxxwk, result_local,ier, &
              ideriv1=ideriv); call ckerr(s)
         dmax = max(dmax, maxval(abs(result_local(:,2) - zresult)) )
         dmax = max(dmax, &
              maxval(abs(result_local(:,1)/xxfac(ii) - zresult)) )
      enddo
      if(dmax.gt.dmaxp) itmax=itest

      deallocate(xxzc,xxfac,xxoff,bcvals,pdata)

      call xplasma_remove_item(s,idtmp,ier)
      call xplasma_author_clear(s,'hyb2dzon',ier); call ckerr(s)

    end subroutine hyb2dzon

    subroutine hyb2dlin(id1,id2,zxtest,zresult,ideriv)
      integer, intent(in) :: id1  ! id for 1st dimension (profile or XX)
      integer, intent(in) :: id2  ! id for 2nd dimension (XX or profile)
      real*8, intent(in), dimension(:) :: zxtest  ! profile dim test vector
      real*8, intent(in), dimension(:) :: zresult ! profile dim values expected
      integer, intent(in) :: ideriv

      ! construct pclin-spline or pclin-hermite 2d Hybrid; evaluate
      ! and compare to expected result.

      !----------------------
      integer :: itype1,itype2,isize_xx,ii,idprof,hspline(2),idg,irank,inx
      integer :: idtmp,idt2(2),idt2a(2)
      real*8 :: result_local(size(zresult),2),zxxwk(size(zresult))
      real*8, dimension(:), allocatable :: xxzc,xxfac,xxoff,bcvals,fxfac
      real*8, dimension(:,:), allocatable :: pdata
      real*8 :: xxincr
      real*8 :: xxoffs,dmaxp
      !----------------------

      itest = itest + 1  ! increment test counter

      isize_xx=size(xx)
      allocate(xxzc(isize_xx-1),xxfac(isize_xx),xxoff(isize_xx-1))
      allocate(bcvals(isize_xx),fxfac(isize_xx-1))

      xxzc = (xx(1:isize_xx-1)+xx(2:isize_xx))/2

      xxoffs = xx(isize_xx)/(isize_xx-1)/10.0d0
      xxfac(1)=1.0d0
      xxoff(1)=-xxoffs/2
      xxincr = 2.5d0
      do ii=2,isize_xx-1
         xxfac(ii) = xxfac(ii-1) + xxincr
         xxoff(ii) = xxoff(ii-1) + xxoffs
         xxincr = xxincr - 0.5d0
      enddo
      xxfac(isize_xx)=xxfac(isize_xx-1) + xxincr
      do ii=1,isize_xx-1
         !  linear interpolation factor
         fxfac(ii) = (xxzc(ii)+xxoff(ii)-xx(ii))/(xx(ii+1)-xx(ii))
         fxfac(ii) = xxfac(ii) + fxfac(ii)*(xxfac(ii+1)-xxfac(ii))
      enddo

      call xplasma_get_item_info(s,id1,ier, itype=itype1); call ckerr(s)
      call xplasma_get_item_info(s,id2,ier, itype=itype2); call ckerr(s)

      if(itype1.eq.xplasma_gridType) then
         idprof=id2
      else
         idprof=id1
      endif
      idt2(1)=idprof

      call xplasma_prof_info(s,idprof,ier, splineType=ispline, &
           rank=irank, gridId1=idg); call ckerr(s)
      if(irank.ne.1) then
         write(6,*) ' ?hyb2dlin: input profile not 1d, id=',idprof
         call bad_exit
      endif

      call xplasma_grid_info(s,idg,ier, size=inx)

      call xplasma_author_set(s,'hyb2dlin',ier); call ckerr(s)

      bcvals(1)=z2pi
      if(itype1.eq.xplasma_gridType) then
         hspline(1)=0
         hspline(2)=ispline
         allocate(pdata(isize_xx,inx))
         call xplasma_getprof_1data(s,idprof,pdata(1,1:inx),ier); call ckerr(s)
         do ii=2,isize_xx
            pdata(ii,1:inx)=xxfac(ii)*pdata(1,1:inx)
            bcvals(ii)=xxfac(ii)*bcvals(1)
         enddo

         if(ispline.gt.0) then
            call xplasma_create_2dprof(s,'_TMP_HYB2', &
                 idxxg,idg,pdata,idtmp,ier, &
                 hspline=hspline,ibcx2a=1,zbcx2a=bcvals,ibcx2b=1,zbcx2b=bcvals)
         else
            call xplasma_create_2dprof(s,'_TMP_HYB2', &
                 idxxg,idg,pdata,idtmp,ier, &
                 hspline=hspline)
         endif
         call ckerr(s)

      else
         hspline(1)=ispline
         hspline(2)=0
         allocate(pdata(inx,isize_xx))
         call xplasma_getprof_1data(s,idprof,pdata(1:inx,1),ier); call ckerr(s)
         do ii=2,isize_xx
            pdata(1:inx,ii)=xxfac(ii)*pdata(1:inx,1)
            bcvals(ii)=xxfac(ii)*bcvals(1)
         enddo

         if(ispline.gt.0) then
            call xplasma_create_2dprof(s,'_TMP_HYB2', &
                 idg,idxxg,pdata,idtmp,ier, &
                 hspline=hspline,ibcx1a=1,zbcx1a=bcvals,ibcx1b=1,zbcx1b=bcvals)
         else
            call xplasma_create_2dprof(s,'_TMP_HYB2', &
                 idg,idxxg,pdata,idtmp,ier, &
                 hspline=hspline)
         endif
         call ckerr(s)

      endif

      idt2(2)=idtmp

      idt2a(1)=idt2(2)
      idt2a(2)=idt2(1)

      dmaxp=dmax
      do ii=1,isize_xx-1
         zxxwk=xxzc(ii)+xxoff(ii)
         call xplasma_eval_prof(s,idtmp, &
              idxxg,zxxwk, idg,zxtest, result_local(:,1),ier, &
              ideriv2=ideriv); call ckerr(s)
         dmax = max(dmax, &
              maxval(abs(result_local(:,1)/fxfac(ii) - zresult)) )
         
         call xplasma_eval_prof(s,idt2, &
              idxxg,zxxwk, idg,zxtest, result_local,ier, &
              ideriv2=ideriv); call ckerr(s)
         dmax = max(dmax, maxval(abs(result_local(:,1) - zresult)) )
         dmax = max(dmax, &
              maxval(abs(result_local(:,2)/fxfac(ii) - zresult)) )

         call xplasma_eval_prof(s,idt2a, &
              idg,zxtest, idxxg,zxxwk, result_local,ier, &
              ideriv1=ideriv); call ckerr(s)
         dmax = max(dmax, maxval(abs(result_local(:,2) - zresult)) )
         dmax = max(dmax, &
              maxval(abs(result_local(:,1)/fxfac(ii) - zresult)) )
      enddo
      if(dmax.gt.dmaxp) itmax=itest

      deallocate(xxzc,xxfac,xxoff,bcvals,pdata,fxfac)

      call xplasma_remove_item(s,idtmp,ier)
      call xplasma_author_clear(s,'hyb2dlin',ier); call ckerr(s)

    end subroutine hyb2dlin

    subroutine hyb3dzon(id1,id2,id3,zxtest,zresult,ideriv)
      integer, intent(in) :: id1  ! id for 1st dimension (profile or XX)
      integer, intent(in) :: id2  ! id for 2nd dimension (XX or YY or profile)
      integer, intent(in) :: id3  ! id for 3rd dimension (YY or profile)
      real*8, intent(in), dimension(:) :: zxtest  ! profile dim test vector
      real*8, intent(in), dimension(:) :: zresult ! profile dim values expected
      integer, intent(in) :: ideriv

      ! construct zone-pclin or zone-spline or zone-hermite 2d Hybrid; evaluate
      ! and compare to expected result.

      !----------------------
      integer :: itype1,itype2,itype3,isize_xx,isize_yy
      integer :: ii,jj,idprof,hspline(3),idg,irank,inx
      integer :: idtmp,idt2(2),idt2a(2)
      real*8 :: result_local(size(zresult),2),zxxwk(size(zresult))
      real*8 :: zyywk(size(zresult))
      real*8, dimension(:), allocatable :: xxzc,xxfac,xxoff
      real*8, dimension(:), allocatable :: yyzc,yyfac,yyoff
      real*8, dimension(:,:), allocatable :: bcvals
      real*8, dimension(:,:,:), allocatable :: pdata
      real*8, parameter :: xxincr = 2.5d0
      real*8 :: xxoffs,dmaxp
      !----------------------

      itest = itest + 1  ! increment test counter

      isize_xx=size(xx)
      allocate(xxzc(isize_xx-1),xxfac(isize_xx-1),xxoff(isize_xx-1))

      isize_yy=size(yy)
      allocate(yyzc(isize_yy-1),yyfac(isize_yy-1),yyoff(isize_yy-1))

      allocate(bcvals(isize_xx-1,isize_yy-1))

      xxzc = (xx(1:isize_xx-1)+xx(2:isize_xx))/2
      yyzc = (yy(1:isize_yy-1)+yy(2:isize_yy))/2

      xxoffs = xx(isize_xx)/(isize_xx-1)/10.0d0
      xxfac(1)=1.0d0
      xxoff(1)=-xxoffs/2
      yyfac(1)=1.0d0
      yyoff(1)=-3*xxoffs/2

      do ii=2,isize_xx-1
         xxfac(ii) = xxfac(ii-1) + xxincr
         xxoff(ii) = xxoff(ii-1) + xxoffs
      enddo

      do ii=2,isize_yy-1
         yyfac(ii) = yyfac(ii-1) + xxincr
         yyoff(ii) = yyoff(ii-1) + xxoffs
      enddo

      call xplasma_get_item_info(s,id1,ier, itype=itype1); call ckerr(s)
      call xplasma_get_item_info(s,id2,ier, itype=itype2); call ckerr(s)
      call xplasma_get_item_info(s,id3,ier, itype=itype3); call ckerr(s)

      if(itype3.eq.xplasma_profType) then
         idprof=id3
      else if(itype2.eq.xplasma_profType) then
         idprof=id2
      else
         idprof=id1
      endif
      idt2(1)=idprof

      call xplasma_prof_info(s,idprof,ier, splineType=ispline, &
           rank=irank, gridId1=idg); call ckerr(s)
      if(irank.ne.1) then
         write(6,*) ' ?hyb3dzon: input profile not 1d, id=',idprof
         call bad_exit
      endif

      call xplasma_grid_info(s,idg,ier, size=inx)

      call xplasma_author_set(s,'hyb3dzon',ier); call ckerr(s)

      bcvals(1,1)=z2pi
      if(itype1.eq.xplasma_profType) then
         hspline(1)=ispline
         hspline(2)=-1
         hspline(3)=-1
         allocate(pdata(inx,isize_xx-1,isize_yy-1))
         call xplasma_getprof_1data(s,idprof,pdata(1:inx,1,1),ier)
         call ckerr(s)
         do jj=1,isize_yy-1
            do ii=1,isize_xx-1
               pdata(1:inx,ii,jj)=xxfac(ii)*yyfac(jj)*pdata(1:inx,1,1)
               bcvals(ii,jj)=xxfac(ii)*yyfac(jj)*bcvals(1,1)
            enddo
         enddo

         if(ispline.gt.0) then
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idg,idxxg,idyyg,pdata,idtmp,ier, &
                 hspline=hspline,ibcx1a=1,zbcx1a=bcvals,ibcx1b=1,zbcx1b=bcvals)
         else
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idg,idxxg,idyyg,pdata,idtmp,ier, &
                 hspline=hspline)
         endif
         call ckerr(s)
      endif

      if(itype2.eq.xplasma_profType) then
         hspline(1)=-1
         hspline(2)=ispline
         hspline(3)=-1
         allocate(pdata(isize_xx-1,inx,isize_yy-1))
         call xplasma_getprof_1data(s,idprof,pdata(1,1:inx,1),ier)
         call ckerr(s)
         do jj=1,isize_yy-1
            do ii=1,isize_xx-1
               pdata(ii,1:inx,jj)=xxfac(ii)*yyfac(jj)*pdata(1,1:inx,1)
               bcvals(ii,jj)=xxfac(ii)*yyfac(jj)*bcvals(1,1)
            enddo
         enddo

         if(ispline.gt.0) then
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idxxg,idg,idyyg,pdata,idtmp,ier, &
                 hspline=hspline,ibcx2a=1,zbcx2a=bcvals,ibcx2b=1,zbcx2b=bcvals)
         else
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idxxg,idg,idyyg,pdata,idtmp,ier, &
                 hspline=hspline)
         endif
         call ckerr(s)
      endif

      if(itype3.eq.xplasma_profType) then
         hspline(1)=-1
         hspline(2)=-1
         hspline(3)=ispline
         allocate(pdata(isize_xx-1,isize_yy-1,inx))
         call xplasma_getprof_1data(s,idprof,pdata(1,1,1:inx),ier)
         call ckerr(s)
         do jj=1,isize_yy-1
            do ii=1,isize_xx-1
               pdata(ii,jj,1:inx)=xxfac(ii)*yyfac(jj)*pdata(1,1,1:inx)
               bcvals(ii,jj)=xxfac(ii)*yyfac(jj)*bcvals(1,1)
            enddo
         enddo

         if(ispline.gt.0) then
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idxxg,idyyg,idg,pdata,idtmp,ier, &
                 hspline=hspline,ibcx3a=1,zbcx3a=bcvals,ibcx3b=1,zbcx3b=bcvals)
         else
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idxxg,idyyg,idg,pdata,idtmp,ier, &
                 hspline=hspline)
         endif
         call ckerr(s)
      endif

      idt2(2)=idtmp

      idt2a(1)=idt2(2)
      idt2a(2)=idt2(1)

      dmaxp=dmax
      do jj=1,isize_yy-1
         zyywk=yyzc(jj)+yyoff(jj)
         do ii=1,isize_xx-1
            zxxwk=xxzc(ii)+xxoff(ii)
            call xplasma_eval_prof(s,idtmp, &
                 idxxg,zxxwk, idyyg,zyywk, idg,zxtest, result_local(:,1),ier, &
                 ideriv3=ideriv); call ckerr(s)
            dmax = max(dmax, &
                 maxval(abs(result_local(:,1)/xxfac(ii)/yyfac(jj) - zresult)) )
         
            call xplasma_eval_prof(s,idt2, &
                 idxxg,zxxwk, idyyg,zyywk, idg,zxtest, result_local,ier, &
                 ideriv3=ideriv); call ckerr(s)
            dmax = max(dmax, maxval(abs(result_local(:,1) - zresult)) )
            dmax = max(dmax, &
                 maxval(abs(result_local(:,2)/xxfac(ii)/yyfac(jj) - zresult)) )

            call xplasma_eval_prof(s,idt2a, &
                 idg,zxtest, idxxg,zxxwk, idyyg,zyywk, result_local,ier, &
                 ideriv1=ideriv); call ckerr(s)
            dmax = max(dmax, maxval(abs(result_local(:,2) - zresult)) )
            dmax = max(dmax, &
                 maxval(abs(result_local(:,1)/xxfac(ii)/yyfac(jj) - zresult)) )
         enddo
      enddo
      if(dmax.gt.dmaxp) itmax=itest

      deallocate(xxzc,xxfac,xxoff,bcvals,pdata)
      deallocate(yyzc,yyfac,yyoff)

      call xplasma_remove_item(s,idtmp,ier)
      call xplasma_author_clear(s,'hyb3dzon',ier); call ckerr(s)

    end subroutine hyb3dzon

    subroutine hyb3dlin(id1,id2,id3,zxtest,zresult,ideriv)
      integer, intent(in) :: id1  ! id for 1st dimension (profile or XX)
      integer, intent(in) :: id2  ! id for 2nd dimension (XX or YY or profile)
      integer, intent(in) :: id3  ! id for 3rd dimension (YY or profile)
      real*8, intent(in), dimension(:) :: zxtest  ! profile dim test vector
      real*8, intent(in), dimension(:) :: zresult ! profile dim values expected
      integer, intent(in) :: ideriv

      ! construct lin-hermite or lin-spline hybrid interpolant
      ! and compare evaluation to expected result.

      !----------------------
      integer :: itype1,itype2,itype3,isize_xx,isize_yy
      integer :: ii,jj,idprof,hspline(3),idg,irank,inx
      integer :: idtmp,idt2(2),idt2a(2)
      real*8 :: result_local(size(zresult),2),zxxwk(size(zresult))
      real*8 :: zyywk(size(zresult))
      real*8, dimension(:), allocatable :: xxzc,xxfac,xxoff
      real*8, dimension(:), allocatable :: yyzc,yyfac,yyoff
      real*8, dimension(:,:), allocatable :: bcvals,fffac
      real*8, dimension(:,:,:), allocatable :: pdata
      real*8, parameter :: xxincr = 2.5d0
      real*8 :: xxoffs,dmaxp,fjj,fii
      !----------------------

      itest = itest + 1  ! increment test counter

      isize_xx=size(xx)
      allocate(xxzc(isize_xx-1),xxfac(isize_xx),xxoff(isize_xx-1))

      isize_yy=size(yy)
      allocate(yyzc(isize_yy-1),yyfac(isize_yy),yyoff(isize_yy-1))

      allocate(bcvals(isize_xx,isize_yy),fffac(isize_xx-1,isize_yy-1))

      xxzc = (xx(1:isize_xx-1)+xx(2:isize_xx))/2
      yyzc = (yy(1:isize_yy-1)+yy(2:isize_yy))/2

      xxoffs = xx(isize_xx)/(isize_xx-1)/10.0d0
      xxfac(1)=1.0d0
      xxoff(1)=-xxoffs/2
      yyfac(1)=1.0d0
      yyoff(1)=-3*xxoffs/2

      do ii=2,isize_xx-1
         xxfac(ii) = xxfac(ii-1) + xxincr
         xxoff(ii) = xxoff(ii-1) + xxoffs
      enddo
      xxfac(isize_xx)=xxfac(isize_xx-1) + xxincr

      do ii=2,isize_yy-1
         yyfac(ii) = yyfac(ii-1) + xxincr
         yyoff(ii) = yyoff(ii-1) + xxoffs
      enddo
      yyfac(isize_yy)=yyfac(isize_yy-1) + xxincr

      do jj=1,isize_yy-1
         fjj = (yyzc(jj)+yyoff(jj)-yy(jj))/(yy(jj+1)-yy(jj))
         do ii=1,isize_xx-1
            fii = (xxzc(ii)+xxoff(ii)-xx(ii))/(xx(ii+1)-xx(ii))
            fffac(ii,jj) = &
                 (1-fjj)*yyfac(jj)*((1-fii)*xxfac(ii)+fii*xxfac(ii+1)) + &
                 fjj*yyfac(jj+1)*((1-fii)*xxfac(ii)+fii*xxfac(ii+1))
         enddo
      enddo

      call xplasma_get_item_info(s,id1,ier, itype=itype1); call ckerr(s)
      call xplasma_get_item_info(s,id2,ier, itype=itype2); call ckerr(s)
      call xplasma_get_item_info(s,id3,ier, itype=itype3); call ckerr(s)

      if(itype3.eq.xplasma_profType) then
         idprof=id3
      else if(itype2.eq.xplasma_profType) then
         idprof=id2
      else
         idprof=id1
      endif
      idt2(1)=idprof

      call xplasma_prof_info(s,idprof,ier, splineType=ispline, &
           rank=irank, gridId1=idg); call ckerr(s)
      if(irank.ne.1) then
         write(6,*) ' ?hyb3dlin: input profile not 1d, id=',idprof
         call bad_exit
      endif

      call xplasma_grid_info(s,idg,ier, size=inx)

      call xplasma_author_set(s,'hyb3dlin',ier); call ckerr(s)

      bcvals(1,1)=z2pi
      if(itype1.eq.xplasma_profType) then
         hspline(1)=ispline
         hspline(2)=0
         hspline(3)=0
         allocate(pdata(inx,isize_xx,isize_yy))
         call xplasma_getprof_1data(s,idprof,pdata(1:inx,1,1),ier)
         call ckerr(s)
         do jj=1,isize_yy
            do ii=1,isize_xx
               pdata(1:inx,ii,jj)=xxfac(ii)*yyfac(jj)*pdata(1:inx,1,1)
               bcvals(ii,jj)=xxfac(ii)*yyfac(jj)*bcvals(1,1)
            enddo
         enddo

         if(ispline.gt.0) then
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idg,idxxg,idyyg,pdata,idtmp,ier, &
                 hspline=hspline,ibcx1a=1,zbcx1a=bcvals,ibcx1b=1,zbcx1b=bcvals)
         else
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idg,idxxg,idyyg,pdata,idtmp,ier, &
                 hspline=hspline)
         endif
         call ckerr(s)
      endif

      if(itype2.eq.xplasma_profType) then
         hspline(1)=0
         hspline(2)=ispline
         hspline(3)=0
         allocate(pdata(isize_xx,inx,isize_yy))
         call xplasma_getprof_1data(s,idprof,pdata(1,1:inx,1),ier)
         call ckerr(s)
         do jj=1,isize_yy
            do ii=1,isize_xx
               pdata(ii,1:inx,jj)=xxfac(ii)*yyfac(jj)*pdata(1,1:inx,1)
               bcvals(ii,jj)=xxfac(ii)*yyfac(jj)*bcvals(1,1)
            enddo
         enddo

         if(ispline.gt.0) then
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idxxg,idg,idyyg,pdata,idtmp,ier, &
                 hspline=hspline,ibcx2a=1,zbcx2a=bcvals,ibcx2b=1,zbcx2b=bcvals)
         else
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idxxg,idg,idyyg,pdata,idtmp,ier, &
                 hspline=hspline)
         endif
         call ckerr(s)
      endif

      if(itype3.eq.xplasma_profType) then
         hspline(1)=0
         hspline(2)=0
         hspline(3)=ispline
         allocate(pdata(isize_xx,isize_yy,inx))
         call xplasma_getprof_1data(s,idprof,pdata(1,1,1:inx),ier)
         call ckerr(s)
         do jj=1,isize_yy
            do ii=1,isize_xx
               pdata(ii,jj,1:inx)=xxfac(ii)*yyfac(jj)*pdata(1,1,1:inx)
               bcvals(ii,jj)=xxfac(ii)*yyfac(jj)*bcvals(1,1)
            enddo
         enddo

         if(ispline.gt.0) then
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idxxg,idyyg,idg,pdata,idtmp,ier, &
                 hspline=hspline,ibcx3a=1,zbcx3a=bcvals,ibcx3b=1,zbcx3b=bcvals)
         else
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idxxg,idyyg,idg,pdata,idtmp,ier, &
                 hspline=hspline)
         endif
         call ckerr(s)
      endif

      idt2(2)=idtmp

      idt2a(1)=idt2(2)
      idt2a(2)=idt2(1)

      dmaxp=dmax
      do jj=1,isize_yy-1
         zyywk=yyzc(jj)+yyoff(jj)
         do ii=1,isize_xx-1
            zxxwk=xxzc(ii)+xxoff(ii)
            call xplasma_eval_prof(s,idtmp, &
                 idxxg,zxxwk, idyyg,zyywk, idg,zxtest, result_local(:,1),ier, &
                 ideriv3=ideriv); call ckerr(s)
            dmax = max(dmax, &
                 maxval(abs(result_local(:,1)/fffac(ii,jj) - zresult)) )
         
            call xplasma_eval_prof(s,idt2, &
                 idxxg,zxxwk, idyyg,zyywk, idg,zxtest, result_local,ier, &
                 ideriv3=ideriv); call ckerr(s)
            dmax = max(dmax, maxval(abs(result_local(:,1) - zresult)) )
            dmax = max(dmax, &
                 maxval(abs(result_local(:,2)/fffac(ii,jj) - zresult)) )

            call xplasma_eval_prof(s,idt2a, &
                 idg,zxtest, idxxg,zxxwk, idyyg,zyywk, result_local,ier, &
                 ideriv1=ideriv); call ckerr(s)
            dmax = max(dmax, maxval(abs(result_local(:,2) - zresult)) )
            dmax = max(dmax, &
                 maxval(abs(result_local(:,1)/fffac(ii,jj) - zresult)) )
         enddo
      enddo
      if(dmax.gt.dmaxp) itmax=itest

      deallocate(xxzc,xxfac,xxoff,bcvals,pdata)
      deallocate(yyzc,yyfac,yyoff,fffac)

      call xplasma_remove_item(s,idtmp,ier)
      call xplasma_author_clear(s,'hyb3dlin',ier); call ckerr(s)

    end subroutine hyb3dlin

    subroutine hyb3dlzn(id1,id2,id3,zxtest,zresult,ideriv)
      integer, intent(in) :: id1  ! id for 1st dimension (profile or XX)
      integer, intent(in) :: id2  ! id for 2nd dimension (XX or YY or profile)
      integer, intent(in) :: id3  ! id for 3rd dimension (YY or profile)
      real*8, intent(in), dimension(:) :: zxtest  ! profile dim test vector
      real*8, intent(in), dimension(:) :: zresult ! profile dim values expected
      integer, intent(in) :: ideriv

      ! construct lin-zone-hermite or lin-zone-spline hybrid interpolant
      ! and compare evaluation to expected result.

      !----------------------
      integer :: itype1,itype2,itype3,isize_xx,isize_yy
      integer :: ii,jj,idprof,hspline(3),idg,irank,inx
      integer :: idtmp,idt2(2),idt2a(2)
      real*8 :: result_local(size(zresult),2),zxxwk(size(zresult))
      real*8 :: zyywk(size(zresult))
      real*8, dimension(:), allocatable :: xxzc,xxfac,xxoff
      real*8, dimension(:), allocatable :: yyzc,yyfac,yyoff
      real*8, dimension(:,:), allocatable :: bcvals,fffac
      real*8, dimension(:,:,:), allocatable :: pdata
      real*8, parameter :: xxincr = 2.5d0
      real*8 :: xxoffs,dmaxp,fjj,fii
      !----------------------

      itest = itest + 1  ! increment test counter

      isize_xx=size(xx)
      allocate(xxzc(isize_xx-1),xxfac(isize_xx),xxoff(isize_xx-1))

      isize_yy=size(yy)
      allocate(yyzc(isize_yy-1),yyfac(isize_yy-1),yyoff(isize_yy-1))

      allocate(bcvals(isize_xx,isize_yy-1),fffac(isize_xx-1,isize_yy-1))

      xxzc = (xx(1:isize_xx-1)+xx(2:isize_xx))/2
      yyzc = (yy(1:isize_yy-1)+yy(2:isize_yy))/2

      xxoffs = xx(isize_xx)/(isize_xx-1)/10.0d0
      xxfac(1)=1.0d0
      xxoff(1)=-xxoffs/2
      yyfac(1)=1.0d0
      yyoff(1)=-3*xxoffs/2

      do ii=2,isize_xx-1
         xxfac(ii) = xxfac(ii-1) + xxincr
         xxoff(ii) = xxoff(ii-1) + xxoffs
      enddo
      xxfac(isize_xx)=xxfac(isize_xx-1) + xxincr

      do ii=2,isize_yy-1
         yyfac(ii) = yyfac(ii-1) + xxincr
         yyoff(ii) = yyoff(ii-1) + xxoffs
      enddo

      do jj=1,isize_yy-1
         do ii=1,isize_xx-1
            fii = (xxzc(ii)+xxoff(ii)-xx(ii))/(xx(ii+1)-xx(ii))
            fffac(ii,jj) = &
                 yyfac(jj)*((1-fii)*xxfac(ii)+fii*xxfac(ii+1))
         enddo
      enddo

      call xplasma_get_item_info(s,id1,ier, itype=itype1); call ckerr(s)
      call xplasma_get_item_info(s,id2,ier, itype=itype2); call ckerr(s)
      call xplasma_get_item_info(s,id3,ier, itype=itype3); call ckerr(s)

      if(itype3.eq.xplasma_profType) then
         idprof=id3
      else if(itype2.eq.xplasma_profType) then
         idprof=id2
      else
         idprof=id1
      endif
      idt2(1)=idprof

      call xplasma_prof_info(s,idprof,ier, splineType=ispline, &
           rank=irank, gridId1=idg); call ckerr(s)
      if(irank.ne.1) then
         write(6,*) ' ?hyb3dlzn: input profile not 1d, id=',idprof
         call bad_exit
      endif

      call xplasma_grid_info(s,idg,ier, size=inx)

      call xplasma_author_set(s,'hyb3dlzn',ier); call ckerr(s)

      bcvals(1,1)=z2pi
      if(itype1.eq.xplasma_profType) then
         hspline(1)=ispline
         hspline(2)=0
         hspline(3)=-1
         allocate(pdata(inx,isize_xx,isize_yy-1))
         call xplasma_getprof_1data(s,idprof,pdata(1:inx,1,1),ier)
         call ckerr(s)
         do jj=1,isize_yy-1
            do ii=1,isize_xx
               pdata(1:inx,ii,jj)=xxfac(ii)*yyfac(jj)*pdata(1:inx,1,1)
               bcvals(ii,jj)=xxfac(ii)*yyfac(jj)*bcvals(1,1)
            enddo
         enddo

         if(ispline.gt.0) then
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idg,idxxg,idyyg,pdata,idtmp,ier, &
                 hspline=hspline,ibcx1a=1,zbcx1a=bcvals,ibcx1b=1,zbcx1b=bcvals)
         else
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idg,idxxg,idyyg,pdata,idtmp,ier, &
                 hspline=hspline)
         endif
         call ckerr(s)
      endif

      if(itype2.eq.xplasma_profType) then
         hspline(1)=0
         hspline(2)=ispline
         hspline(3)=-1
         allocate(pdata(isize_xx,inx,isize_yy-1))
         call xplasma_getprof_1data(s,idprof,pdata(1,1:inx,1),ier)
         call ckerr(s)
         do jj=1,isize_yy-1
            do ii=1,isize_xx
               pdata(ii,1:inx,jj)=xxfac(ii)*yyfac(jj)*pdata(1,1:inx,1)
               bcvals(ii,jj)=xxfac(ii)*yyfac(jj)*bcvals(1,1)
            enddo
         enddo

         if(ispline.gt.0) then
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idxxg,idg,idyyg,pdata,idtmp,ier, &
                 hspline=hspline,ibcx2a=1,zbcx2a=bcvals,ibcx2b=1,zbcx2b=bcvals)
         else
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idxxg,idg,idyyg,pdata,idtmp,ier, &
                 hspline=hspline)
         endif
         call ckerr(s)
      endif

      if(itype3.eq.xplasma_profType) then
         hspline(1)=0
         hspline(2)=-1
         hspline(3)=ispline
         allocate(pdata(isize_xx,isize_yy-1,inx))
         call xplasma_getprof_1data(s,idprof,pdata(1,1,1:inx),ier)
         call ckerr(s)
         do jj=1,isize_yy-1
            do ii=1,isize_xx
               pdata(ii,jj,1:inx)=xxfac(ii)*yyfac(jj)*pdata(1,1,1:inx)
               bcvals(ii,jj)=xxfac(ii)*yyfac(jj)*bcvals(1,1)
            enddo
         enddo

         if(ispline.gt.0) then
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idxxg,idyyg,idg,pdata,idtmp,ier, &
                 hspline=hspline,ibcx3a=1,zbcx3a=bcvals,ibcx3b=1,zbcx3b=bcvals)
         else
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idxxg,idyyg,idg,pdata,idtmp,ier, &
                 hspline=hspline)
         endif
         call ckerr(s)
      endif

      idt2(2)=idtmp

      idt2a(1)=idt2(2)
      idt2a(2)=idt2(1)

      dmaxp=dmax
      do jj=1,isize_yy-1
         zyywk=yyzc(jj)+yyoff(jj)
         do ii=1,isize_xx-1
            zxxwk=xxzc(ii)+xxoff(ii)
            call xplasma_eval_prof(s,idtmp, &
                 idxxg,zxxwk, idyyg,zyywk, idg,zxtest, result_local(:,1),ier, &
                 ideriv3=ideriv); call ckerr(s)
            dmax = max(dmax, &
                 maxval(abs(result_local(:,1)/fffac(ii,jj) - zresult)) )
         
            call xplasma_eval_prof(s,idt2, &
                 idxxg,zxxwk, idyyg,zyywk, idg,zxtest, result_local,ier, &
                 ideriv3=ideriv); call ckerr(s)
            dmax = max(dmax, maxval(abs(result_local(:,1) - zresult)) )
            dmax = max(dmax, &
                 maxval(abs(result_local(:,2)/fffac(ii,jj) - zresult)) )

            call xplasma_eval_prof(s,idt2a, &
                 idg,zxtest, idxxg,zxxwk, idyyg,zyywk, result_local,ier, &
                 ideriv1=ideriv); call ckerr(s)
            dmax = max(dmax, maxval(abs(result_local(:,2) - zresult)) )
            dmax = max(dmax, &
                 maxval(abs(result_local(:,1)/fffac(ii,jj) - zresult)) )
         enddo
      enddo
      if(dmax.gt.dmaxp) itmax=itest

      deallocate(xxzc,xxfac,xxoff,bcvals,pdata)
      deallocate(yyzc,yyfac,yyoff,fffac)

      call xplasma_remove_item(s,idtmp,ier)
      call xplasma_author_clear(s,'hyb3dlzn',ier); call ckerr(s)

    end subroutine hyb3dlzn

    subroutine hyb3dzln(id1,id2,id3,zxtest,zresult,ideriv)
      integer, intent(in) :: id1  ! id for 1st dimension (profile or XX)
      integer, intent(in) :: id2  ! id for 2nd dimension (XX or YY or profile)
      integer, intent(in) :: id3  ! id for 3rd dimension (YY or profile)
      real*8, intent(in), dimension(:) :: zxtest  ! profile dim test vector
      real*8, intent(in), dimension(:) :: zresult ! profile dim values expected
      integer, intent(in) :: ideriv

      ! construct zone-lin-hermite or zone-lin-spline hybrid interpolant
      ! and compare evaluation to expected result.

      !----------------------
      integer :: itype1,itype2,itype3,isize_xx,isize_yy
      integer :: ii,jj,idprof,hspline(3),idg,irank,inx
      integer :: idtmp,idt2(2),idt2a(2)
      real*8 :: result_local(size(zresult),2),zxxwk(size(zresult))
      real*8 :: zyywk(size(zresult))
      real*8, dimension(:), allocatable :: xxzc,xxfac,xxoff
      real*8, dimension(:), allocatable :: yyzc,yyfac,yyoff
      real*8, dimension(:,:), allocatable :: bcvals,fffac
      real*8, dimension(:,:,:), allocatable :: pdata
      real*8, parameter :: xxincr = 2.5d0
      real*8 :: xxoffs,dmaxp,fjj,fii
      !----------------------

      itest = itest + 1  ! increment test counter

      isize_xx=size(xx)
      allocate(xxzc(isize_xx-1),xxfac(isize_xx-1),xxoff(isize_xx-1))

      isize_yy=size(yy)
      allocate(yyzc(isize_yy-1),yyfac(isize_yy),yyoff(isize_yy-1))

      allocate(bcvals(isize_xx-1,isize_yy),fffac(isize_xx-1,isize_yy-1))

      xxzc = (xx(1:isize_xx-1)+xx(2:isize_xx))/2
      yyzc = (yy(1:isize_yy-1)+yy(2:isize_yy))/2

      xxoffs = xx(isize_xx)/(isize_xx-1)/10.0d0
      xxfac(1)=1.0d0
      xxoff(1)=-xxoffs/2
      yyfac(1)=1.0d0
      yyoff(1)=-3*xxoffs/2

      do ii=2,isize_xx-1
         xxfac(ii) = xxfac(ii-1) + xxincr
         xxoff(ii) = xxoff(ii-1) + xxoffs
      enddo

      do ii=2,isize_yy-1
         yyfac(ii) = yyfac(ii-1) + xxincr
         yyoff(ii) = yyoff(ii-1) + xxoffs
      enddo
      yyfac(isize_yy)=yyfac(isize_yy-1) + xxincr

      do jj=1,isize_yy-1
         fjj = (yyzc(jj)+yyoff(jj)-yy(jj))/(yy(jj+1)-yy(jj))
         do ii=1,isize_xx-1
            fffac(ii,jj) = xxfac(ii)*((1-fjj)*yyfac(jj)+fjj*yyfac(jj+1))
         enddo
      enddo

      call xplasma_get_item_info(s,id1,ier, itype=itype1); call ckerr(s)
      call xplasma_get_item_info(s,id2,ier, itype=itype2); call ckerr(s)
      call xplasma_get_item_info(s,id3,ier, itype=itype3); call ckerr(s)

      if(itype3.eq.xplasma_profType) then
         idprof=id3
      else if(itype2.eq.xplasma_profType) then
         idprof=id2
      else
         idprof=id1
      endif
      idt2(1)=idprof

      call xplasma_prof_info(s,idprof,ier, splineType=ispline, &
           rank=irank, gridId1=idg); call ckerr(s)
      if(irank.ne.1) then
         write(6,*) ' ?hyb3dzln: input profile not 1d, id=',idprof
         call bad_exit
      endif

      call xplasma_grid_info(s,idg,ier, size=inx)

      call xplasma_author_set(s,'hyb3dzln',ier); call ckerr(s)

      bcvals(1,1)=z2pi
      if(itype1.eq.xplasma_profType) then
         hspline(1)=ispline
         hspline(2)=-1
         hspline(3)=0
         allocate(pdata(inx,isize_xx-1,isize_yy))
         call xplasma_getprof_1data(s,idprof,pdata(1:inx,1,1),ier)
         call ckerr(s)
         do jj=1,isize_yy
            do ii=1,isize_xx-1
               pdata(1:inx,ii,jj)=xxfac(ii)*yyfac(jj)*pdata(1:inx,1,1)
               bcvals(ii,jj)=xxfac(ii)*yyfac(jj)*bcvals(1,1)
            enddo
         enddo

         if(ispline.gt.0) then
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idg,idxxg,idyyg,pdata,idtmp,ier, &
                 hspline=hspline,ibcx1a=1,zbcx1a=bcvals,ibcx1b=1,zbcx1b=bcvals)
         else
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idg,idxxg,idyyg,pdata,idtmp,ier, &
                 hspline=hspline)
         endif
         call ckerr(s)
      endif

      if(itype2.eq.xplasma_profType) then
         hspline(1)=-1
         hspline(2)=ispline
         hspline(3)=0
         allocate(pdata(isize_xx-1,inx,isize_yy))
         call xplasma_getprof_1data(s,idprof,pdata(1,1:inx,1),ier)
         call ckerr(s)
         do jj=1,isize_yy
            do ii=1,isize_xx-1
               pdata(ii,1:inx,jj)=xxfac(ii)*yyfac(jj)*pdata(1,1:inx,1)
               bcvals(ii,jj)=xxfac(ii)*yyfac(jj)*bcvals(1,1)
            enddo
         enddo

         if(ispline.gt.0) then
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idxxg,idg,idyyg,pdata,idtmp,ier, &
                 hspline=hspline,ibcx2a=1,zbcx2a=bcvals,ibcx2b=1,zbcx2b=bcvals)
         else
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idxxg,idg,idyyg,pdata,idtmp,ier, &
                 hspline=hspline)
         endif
         call ckerr(s)
      endif

      if(itype3.eq.xplasma_profType) then
         hspline(1)=-1
         hspline(2)=0
         hspline(3)=ispline
         allocate(pdata(isize_xx-1,isize_yy,inx))
         call xplasma_getprof_1data(s,idprof,pdata(1,1,1:inx),ier)
         call ckerr(s)
         do jj=1,isize_yy
            do ii=1,isize_xx-1
               pdata(ii,jj,1:inx)=xxfac(ii)*yyfac(jj)*pdata(1,1,1:inx)
               bcvals(ii,jj)=xxfac(ii)*yyfac(jj)*bcvals(1,1)
            enddo
         enddo

         if(ispline.gt.0) then
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idxxg,idyyg,idg,pdata,idtmp,ier, &
                 hspline=hspline,ibcx3a=1,zbcx3a=bcvals,ibcx3b=1,zbcx3b=bcvals)
         else
            call xplasma_create_3dprof(s,'_TMP_HYB3', &
                 idxxg,idyyg,idg,pdata,idtmp,ier, &
                 hspline=hspline)
         endif
         call ckerr(s)
      endif

      idt2(2)=idtmp

      idt2a(1)=idt2(2)
      idt2a(2)=idt2(1)

      dmaxp=dmax
      do jj=1,isize_yy-1
         zyywk=yyzc(jj)+yyoff(jj)
         do ii=1,isize_xx-1
            zxxwk=xxzc(ii)+xxoff(ii)
            call xplasma_eval_prof(s,idtmp, &
                 idxxg,zxxwk, idyyg,zyywk, idg,zxtest, result_local(:,1),ier, &
                 ideriv3=ideriv); call ckerr(s)
            dmax = max(dmax, &
                 maxval(abs(result_local(:,1)/fffac(ii,jj) - zresult)) )
         
            call xplasma_eval_prof(s,idt2, &
                 idxxg,zxxwk, idyyg,zyywk, idg,zxtest, result_local,ier, &
                 ideriv3=ideriv); call ckerr(s)
            dmax = max(dmax, maxval(abs(result_local(:,1) - zresult)) )
            dmax = max(dmax, &
                 maxval(abs(result_local(:,2)/fffac(ii,jj) - zresult)) )

            call xplasma_eval_prof(s,idt2a, &
                 idg,zxtest, idxxg,zxxwk, idyyg,zyywk, result_local,ier, &
                 ideriv1=ideriv); call ckerr(s)
            dmax = max(dmax, maxval(abs(result_local(:,2) - zresult)) )
            dmax = max(dmax, &
                 maxval(abs(result_local(:,1)/fffac(ii,jj) - zresult)) )
         enddo
      enddo
      if(dmax.gt.dmaxp) itmax=itest

      deallocate(xxzc,xxfac,xxoff,bcvals,pdata)
      deallocate(yyzc,yyfac,yyoff,fffac)

      call xplasma_remove_item(s,idtmp,ier)
      call xplasma_author_clear(s,'hyb3dzln',ier); call ckerr(s)

    end subroutine hyb3dzln

    subroutine hyb3z2(idimz,idf,zxtest,zthtest,zresult,derivx,derivth)

      !  hybrid: bicubic or bilinear with one addl zonal dimension

      integer, intent(in) :: idimz  ! 1, 2, or 3  -- zonal dimension

      integer, intent(in) :: idf  ! id for 2d model profile

      real*8, intent(in), dimension(:) :: zxtest  ! profile dim test vector
      real*8, intent(in), dimension(:) :: zthtest ! profile dim test vector
      real*8, intent(in), dimension(:) :: zresult ! profile dim values expected

      integer, intent(in) :: derivx,derivth  ! derivative selection in x, th

      !----------------------
      integer :: isize_xx,ii,ispline,hspline(3),irank
      integer :: idtmp,idt2(2),idt2a(2)
      integer :: inrho,inchi
      real*8 :: result_local(size(zresult),2),zxxwk(size(zresult))
      real*8, dimension(:), allocatable :: xxzc,xxfac,xxoff
      real*8, dimension(:,:,:), allocatable :: pdata
      real*8 :: xxincr
      real*8 :: xxoffs,dmaxp
      !----------------------

      itest = itest + 1  ! increment test counter

      isize_xx=size(xx)
      allocate(xxzc(isize_xx-1),xxfac(isize_xx-1),xxoff(isize_xx-1))

      xxzc = (xx(1:isize_xx-1)+xx(2:isize_xx))/2

      xxincr = 2.5d0
      xxoffs = xx(isize_xx)/(isize_xx-1)/10.0d0
      xxfac(1)=1.0d0
      xxoff(1)=-xxoffs/2
      do ii=2,isize_xx-1
         xxfac(ii) = xxfac(ii-1) + xxincr
         xxoff(ii) = xxoff(ii-1) + xxoffs
         xxincr = xxincr - 0.5d0
      enddo

      idt2(1)=idf

      call xplasma_prof_info(s,idf,ier, splineType=ispline, &
           rank=irank); call ckerr(s)
      if(irank.ne.2) then
         write(6,*) ' ?hyb3z2: input profile not 1d, id=',idf
         call bad_exit
      endif

      call xplasma_grid_info(s,id_rho,ier, size=inrho); call ckerr(s)
      call xplasma_grid_info(s,id_chi,ier, size=inchi); call ckerr(s)

      call xplasma_author_set(s,'hyb3z2',ier); call ckerr(s)

      if(idimz.eq.1) then
         hspline(1)=-1
         hspline(2)=ispline
         hspline(3)=ispline
         allocate(pdata(isize_xx-1,inrho,inchi))
         call xplasma_getprof_2data(s,idf,pdata(1,1:inrho,1:inchi),ier)
         call ckerr(s)

         do ii=2,isize_xx-1
            pdata(ii,1:inrho,1:inchi)=xxfac(ii)*pdata(1,1:inrho,1:inchi)
         enddo

         call xplasma_create_3dprof(s,'_TMP_HYB3A', &
              idxxg,id_rho,id_chi,pdata,idtmp,ier, &
              hspline=hspline)
         call ckerr(s)
      endif

      if(idimz.eq.2) then
         hspline(1)=ispline
         hspline(2)=-1
         hspline(3)=ispline
         allocate(pdata(inrho,isize_xx-1,inchi))
         call xplasma_getprof_2data(s,idf,pdata(1:inrho,1,1:inchi),ier)
         call ckerr(s)

         do ii=2,isize_xx-1
            pdata(1:inrho,ii,1:inchi)=xxfac(ii)*pdata(1:inrho,1,1:inchi)
         enddo

         call xplasma_create_3dprof(s,'_TMP_HYB3A', &
              id_rho,idxxg,id_chi,pdata,idtmp,ier, &
              hspline=hspline)
         call ckerr(s)
      endif

      if(idimz.eq.3) then
         hspline(1)=ispline
         hspline(2)=ispline
         hspline(3)=-1
         allocate(pdata(inrho,inchi,isize_xx-1))
         call xplasma_getprof_2data(s,idf,pdata(1:inrho,1:inchi,1),ier)
         call ckerr(s)

         do ii=2,isize_xx-1
            pdata(1:inrho,1:inchi,ii)=xxfac(ii)*pdata(1:inrho,1:inchi,1)
         enddo

         call xplasma_create_3dprof(s,'_TMP_HYB3A', &
              id_rho,id_chi,idxxg,pdata,idtmp,ier, &
              hspline=hspline)
         call ckerr(s)
      endif

      idt2(2)=idtmp

      idt2a(1)=idt2(2)
      idt2a(2)=idt2(1)

      dmaxp=dmax
      do ii=1,isize_xx-1
         zxxwk=xxzc(ii)+xxoff(ii)
         call xplasma_eval_prof(s,idtmp, &
              idxxg,zxxwk, id_rho,zxtest, id_chi,zthtest, &
              result_local(:,1),ier, &
              ideriv2=derivx, ideriv3=derivth); call ckerr(s)
         dmax = max(dmax, &
              maxval(abs(result_local(:,1)/xxfac(ii) - zresult)) )
         
         call xplasma_eval_prof(s,idt2, &
              idxxg,zxxwk, id_chi,zthtest, id_rho,zxtest, &
              result_local,ier, &
              ideriv2=derivth, ideriv3=derivx); call ckerr(s)
         dmax = max(dmax, maxval(abs(result_local(:,1) - zresult)) )
         dmax = max(dmax, &
              maxval(abs(result_local(:,2)/xxfac(ii) - zresult)) )

         call xplasma_eval_prof(s,idt2a, &
              id_rho,zxtest, id_chi,zthtest, idxxg,zxxwk, &
              result_local,ier, &
              ideriv1=derivx, ideriv2=derivth); call ckerr(s)
         dmax = max(dmax, maxval(abs(result_local(:,2) - zresult)) )
         dmax = max(dmax, &
              maxval(abs(result_local(:,1)/xxfac(ii) - zresult)) )
      enddo
      if(dmax.gt.dmaxp) itmax=itest

      deallocate(xxzc,xxfac,xxoff,pdata)

      call xplasma_remove_item(s,idtmp,ier)
      call xplasma_author_clear(s,'hyb3z2',ier); call ckerr(s)

    end subroutine hyb3z2

    subroutine hyb3lin2(idimz,idf,zxtest,zthtest,zresult,derivx,derivth)

      !  hybrid: bicubic with one addl piecewise linear dimension

      integer, intent(in) :: idimz  ! 1, 2, or 3  -- pc-lin dimension

      integer, intent(in) :: idf  ! id for 2d model profile

      real*8, intent(in), dimension(:) :: zxtest  ! profile dim test vector
      real*8, intent(in), dimension(:) :: zthtest ! profile dim test vector
      real*8, intent(in), dimension(:) :: zresult ! profile dim values expected

      integer, intent(in) :: derivx,derivth  ! derivative selection in x, th

      !----------------------
      integer :: isize_xx,ii,ispline,hspline(3),irank
      integer :: idtmp,idt2(2),idt2a(2)
      integer :: inrho,inchi
      real*8 :: result_local(size(zresult),2),zxxwk(size(zresult))
      real*8, dimension(:), allocatable :: xxzc,xxfac,xxoff,fffac
      real*8, dimension(:,:,:), allocatable :: pdata
      real*8 :: xxincr
      real*8 :: xxoffs,dmaxp
      !----------------------

      itest = itest + 1  ! increment test counter

      isize_xx=size(xx)
      allocate(xxzc(isize_xx-1),xxfac(isize_xx),xxoff(isize_xx-1))
      allocate(fffac(isize_xx-1))

      xxzc = (xx(1:isize_xx-1)+xx(2:isize_xx))/2

      xxincr = 2.5d0
      xxoffs = xx(isize_xx)/(isize_xx-1)/10.0d0
      xxfac(1)=1.0d0
      xxoff(1)=-xxoffs/2
      do ii=2,isize_xx-1
         xxfac(ii) = xxfac(ii-1) + xxincr
         xxoff(ii) = xxoff(ii-1) + xxoffs
         xxincr = xxincr - 0.5d0
      enddo
      xxfac(isize_xx) = xxfac(isize_xx-1) + xxincr

      do ii=1,isize_xx-1
         fffac(ii) = (xxzc(ii)+xxoff(ii)-xx(ii))/(xx(ii+1)-xx(ii))
         fffac(ii) = xxfac(ii) + fffac(ii)*(xxfac(ii+1)-xxfac(ii))
      enddo

      idt2(1)=idf

      call xplasma_prof_info(s,idf,ier, splineType=ispline, &
           rank=irank); call ckerr(s)
      if(irank.ne.2) then
         write(6,*) ' ?hyb3lin2: input profile not 1d, id=',idf
         call bad_exit
      endif

      call xplasma_grid_info(s,id_rho,ier, size=inrho); call ckerr(s)
      call xplasma_grid_info(s,id_chi,ier, size=inchi); call ckerr(s)

      call xplasma_author_set(s,'hyb3lin2',ier); call ckerr(s)

      if(idimz.eq.1) then
         hspline(1)=0
         hspline(2)=ispline
         hspline(3)=ispline
         allocate(pdata(isize_xx,inrho,inchi))
         call xplasma_getprof_2data(s,idf,pdata(1,1:inrho,1:inchi),ier)
         call ckerr(s)

         do ii=2,isize_xx
            pdata(ii,1:inrho,1:inchi)=xxfac(ii)*pdata(1,1:inrho,1:inchi)
         enddo

         call xplasma_create_3dprof(s,'_TMP_HYB3A', &
              idxxg,id_rho,id_chi,pdata,idtmp,ier, &
              hspline=hspline)
         call ckerr(s)
      endif

      if(idimz.eq.2) then
         hspline(1)=ispline
         hspline(2)=0
         hspline(3)=ispline
         allocate(pdata(inrho,isize_xx,inchi))
         call xplasma_getprof_2data(s,idf,pdata(1:inrho,1,1:inchi),ier)
         call ckerr(s)

         do ii=2,isize_xx
            pdata(1:inrho,ii,1:inchi)=xxfac(ii)*pdata(1:inrho,1,1:inchi)
         enddo

         call xplasma_create_3dprof(s,'_TMP_HYB3A', &
              id_rho,idxxg,id_chi,pdata,idtmp,ier, &
              hspline=hspline)
         call ckerr(s)
      endif

      if(idimz.eq.3) then
         hspline(1)=ispline
         hspline(2)=ispline
         hspline(3)=0
         allocate(pdata(inrho,inchi,isize_xx))
         call xplasma_getprof_2data(s,idf,pdata(1:inrho,1:inchi,1),ier)
         call ckerr(s)

         do ii=2,isize_xx
            pdata(1:inrho,1:inchi,ii)=xxfac(ii)*pdata(1:inrho,1:inchi,1)
         enddo

         call xplasma_create_3dprof(s,'_TMP_HYB3A', &
              id_rho,id_chi,idxxg,pdata,idtmp,ier, &
              hspline=hspline)
         call ckerr(s)
      endif

      idt2(2)=idtmp

      idt2a(1)=idt2(2)
      idt2a(2)=idt2(1)

      dmaxp=dmax
      do ii=1,isize_xx-1
         zxxwk=xxzc(ii)+xxoff(ii)
         call xplasma_eval_prof(s,idtmp, &
              idxxg,zxxwk, id_rho,zxtest, id_chi,zthtest, &
              result_local(:,1),ier, &
              ideriv2=derivx, ideriv3=derivth); call ckerr(s)
         dmax = max(dmax, &
              maxval(abs(result_local(:,1)/fffac(ii) - zresult)) )
         
         call xplasma_eval_prof(s,idt2, &
              idxxg,zxxwk, id_chi,zthtest, id_rho,zxtest, &
              result_local,ier, &
              ideriv2=derivth, ideriv3=derivx); call ckerr(s)
         dmax = max(dmax, maxval(abs(result_local(:,1) - zresult)) )
         dmax = max(dmax, &
              maxval(abs(result_local(:,2)/fffac(ii) - zresult)) )

         call xplasma_eval_prof(s,idt2a, &
              id_rho,zxtest, id_chi,zthtest, idxxg,zxxwk, &
              result_local,ier, &
              ideriv1=derivx, ideriv2=derivth); call ckerr(s)
         dmax = max(dmax, maxval(abs(result_local(:,2) - zresult)) )
         dmax = max(dmax, &
              maxval(abs(result_local(:,1)/fffac(ii) - zresult)) )
      enddo
      if(dmax.gt.dmaxp) itmax=itest

      deallocate(xxzc,xxfac,xxoff,pdata,fffac)

      call xplasma_remove_item(s,idtmp,ier)
      call xplasma_author_clear(s,'hyb3lin2',ier); call ckerr(s)

    end subroutine hyb3lin2

end program xplasma2_test

subroutine test_stepfuns

  !  test step function profiles over some very simple grids

  use xplasma_obj_instance
  implicit NONE

  integer, parameter :: n1=11, n2=4, n3=3, nvec=30

  real*8 :: x1(n1),x2(n2),x3(n3)
  real*8 :: x1vec(nvec),x2vec(nvec),x3vec(nvec),xvec(nvec)
  real*8 :: ans1(nvec),ans2(nvec),ans3(nvec)

  real*8 :: fun1(n1-1),fun1ret(n1-1)
  real*8 :: fun2(n1-1,n2-1),fun2ret(n1-1,n2-1)
  real*8 :: fun3(n1-1,n2-1,n3-1),fun3ret(n1-1,n2-1,n3-1)

  integer :: i1,i2,i3,ivec,idiff,idifft
  integer :: id1g,id2g,id3g,id1c,id2c,id3c,id1f,id2f,id3f
  integer :: ii,ier

  !--------------------------------------------------
  call xplasma_author_set(s,'xplasma2_test',ier); call ckerr(s)

  do i1=1,n1
     x1(i1)=(i1-1)*1.0d0/(n1-1)
  enddo

  do i2=1,n2
     x2(i2)=(i2-1)*1.0d0/(n2-1)
  enddo

  do i3=1,n3
     x3(i3)=(i3-1)*1.0d0/(n3-1)
  enddo

  do ivec=1,nvec
     xvec(ivec) = (ivec-0.5d0)/nvec
  enddo
  call xplasma_create_coord(s,'x1coord',.FALSE.,id1c,ier,label='X1')
  call ckerr(s)

  call xplasma_create_coord(s,'x2coord',.FALSE.,id2c,ier,label='X2')
  call ckerr(s)

  call xplasma_create_coord(s,'x3coord',.FALSE.,id3c,ier,label='X3')
  call ckerr(s)

  call xplasma_create_grid(s,'x1grid',id1c,x1,id1g,ier,label='X1')
  call ckerr(s)

  call xplasma_create_grid(s,'x2grid',id2c,x2,id2g,ier,label='X2')
  call ckerr(s)

  call xplasma_create_grid(s,'x3grid',id3c,x3,id3g,ier,label='X3')
  call ckerr(s)

  ii = 0
  do i3=1,n3-1
     do i2=1,n2-1
        do i1=1,n1-1

           ii = ii + 1

           if((i2.eq.1).and.(i3.eq.1)) fun1(i1)=ii
           if(i3.eq.1) fun2(i1,i2)=ii
           fun3(i1,i2,i3)=ii

        enddo
     enddo
  enddo

  call xplasma_create_prof(s,'Fun1',id1g,fun1,id1f,ier,label='fun1')
  call ckerr(s)

  call xplasma_create_prof(s,'Fun2',id1g,id2g,fun2,id2f,ier,label='fun2')
  call ckerr(s)

  call xplasma_create_prof(s,'Fun3',id1g,id2g,id3g,fun3,id3f,ier,label='fun3')
  call ckerr(s)

  !  accurate retrieval test

  call xplasma_eval_prof(s,id1f,fun1ret,ier)
  call ckerr(s)

  call xplasma_eval_prof(s,id2f,fun2ret,ier)
  call ckerr(s)

  call xplasma_eval_prof(s,id3f,fun3ret,ier)
  call ckerr(s)

  idifft=0

  idiff=0
  do i1=1,n1-1
     if(fun1ret(i1).ne.fun1(i1)) then
        idiff=idiff+1
        write(6,*) ' fun1 diff ',i1,fun1(i1),fun1ret(i1)
     endif
  enddo
  if(idiff.gt.0) write(6,*) ' **fun1** compare: ',idiff,' differences!'
  idifft=idifft + idiff

  idiff=0
  do i2=1,n2-1
     do i1=1,n1-1
        if(fun2ret(i1,i2).ne.fun2(i1,i2)) then
           idiff=idiff+1
           write(6,*) ' fun2 diff ',i1,i2,fun2(i1,i2),fun2ret(i1,i2)
        endif
     enddo
  enddo
  if(idiff.gt.0) write(6,*) ' **fun2** compare: ',idiff,' differences!'
  idifft=idifft + idiff

  idiff=0
  do i3=1,n3-1
     do i2=1,n2-1
        do i1=1,n1-1
           if(fun3ret(i1,i2,i3).ne.fun3(i1,i2,i3)) then
              idiff=idiff+1
              write(6,*) ' fun3 diff ',i1,i2,i3,fun3(i1,i2,i3),fun3ret(i1,i2,i3)
           endif
        enddo
     enddo
  enddo
  if(idiff.gt.0) write(6,*) ' **fun3** compare: ',idiff,' differences!'
  idifft=idifft + idiff

  if(idifft.gt.0) then
     write(6,*) ' ?? unexpected differences in retrieved data'
     call bad_exit
  endif

  !---------------------
  !  eval along x dimension

  x1vec=xvec
  x2vec=0.8d0
  x3vec=0.75d0

  call xplasma_eval_prof(s,id1f,x1vec,ans1,ier); call ckerr(s)

  call xplasma_eval_prof(s,id2f,id1g,x1vec,id2g,x2vec,ans2,ier); call ckerr(s)

  call xplasma_eval_prof(s,id3f,id3g,x3vec,id1g,x1vec,id2g,x2vec,ans3,ier)
  call ckerr(s)

  write(6,*) ' '
  write(6,'(a,1pe12.5,a,1pe12.5)') &
       ' variation along x1; x2=',x2vec(1),'; x3=',x3vec(1)
  write(6,*) ' '
  write(6,*) '  x1              ans1            ans2            ans3'
  do ivec=1,nvec
     write(6,'(4(1x,1pe15.8))') x1vec(ivec),ans1(ivec),ans2(ivec),ans3(ivec)
  enddo

  x1vec=0.55d0
  x2vec=xvec
  x3vec=1.00d0

  call xplasma_eval_prof(s,id1f,x1vec,ans1,ier); call ckerr(s)

  call xplasma_eval_prof(s,id2f,id1g,x1vec,id2g,x2vec,ans2,ier); call ckerr(s)

  call xplasma_eval_prof(s,id3f,id3g,x3vec,id1g,x1vec,id2g,x2vec,ans3,ier)
  call ckerr(s)

  write(6,*) ' '
  write(6,'(a,1pe12.5,a,1pe12.5)') &
       ' variation along x2; x1=',x1vec(1),'; x3=',x3vec(1)
  write(6,*) ' '
  write(6,*) '  x2              ans1            ans2            ans3'
  do ivec=1,nvec
     write(6,'(4(1x,1pe15.8))') x2vec(ivec),ans1(ivec),ans2(ivec),ans3(ivec)
  enddo

  x1vec=0.15d0
  x2vec=0.45d0
  x3vec=xvec

  call xplasma_eval_prof(s,id1f,x1vec,ans1,ier); call ckerr(s)

  call xplasma_eval_prof(s,id2f,id1g,x1vec,id2g,x2vec,ans2,ier); call ckerr(s)

  call xplasma_eval_prof(s,id3f,id3g,x3vec,id1g,x1vec,id2g,x2vec,ans3,ier)
  call ckerr(s)

  write(6,*) ' '
  write(6,'(a,1pe12.5,a,1pe12.5)') &
       ' variation along x3; x1=',x1vec(1),'; x2=',x2vec(1)
  write(6,*) ' '
  write(6,*) '  x3              ans1            ans2            ans3'
  do ivec=1,nvec
     write(6,'(4(1x,1pe15.8))') x3vec(ivec),ans1(ivec),ans2(ivec),ans3(ivec)
  enddo

  call xplasma_author_clear(s,'xplasma2_test',ier); call ckerr(s)

  contains

    subroutine ckerr(t)
      type (xplasma), pointer :: t
      if(ier.ne.0) then
         call xplasma_error(t,ier,6)
         if(ier.gt.0) call bad_exit
      endif

    end subroutine ckerr

end subroutine test_stepfuns

SUBROUTINE scrfixaraydes
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, one, two
  use scrunch_inc1
  implicit none
  integer :: m
  integer :: n
  integer :: nn0
  integer :: ntor
  integer :: l
  !**********************************************************************
  !       This routine store toroidal and poloidal mode number arrays
  !**********************************************************************
  l = 0
  ntor = max(1,nphi-1)
  nn0 = 1 - (ntor+1)/2
  do n=1,ntor
    nn(n) = (nn0 + (n-1))*nfp
  end do
  do 40 m=1,mpolx
    mm(m)=m-1
    do 40 n=1,ntor
      if(mm(m).eq.0 .and. nn(n) .lt. 0) go to 40
      l=l+1
30    continue
      m1(l)=mm(m)
      n1(l)=nn(n)
40 continue
  mpnt=l
  dnorm=two/nthetax
  do m=1,mpolx
    dm1(m)=m-1
    faccon(m) = .125_fp*dnorm/(one+dm1(m))**pexp
    if(m.eq.1) cycle
    xmpq(m,1) = dm1(m)**pexp
    xmpq(m,2) = dm1(m)**qexp
    xmpq(m,4) = xmpq(m,1)
    if(m.le.2) xmpq(m,4) = zero
    xmpq(m,3) = sqrt(xmpq(m,4))
  end do
  return
end subroutine scrfixaraydes

subroutine eqm_mark_pmhd(id,ier)

  ! mark specified profile as being the MHD pressure...

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  integer, intent(in) :: id
  integer, intent(out) :: ier

  call xplasma_set_pressure_id(s,id,ier)
  if(ier.ne.0) then

     call xplasma_error(s,ier,lunerr)

  endif

end subroutine eqm_mark_pmhd

subroutine eq_rgetf(ivec,zrho,ifcn,iwant,zval,ierr)

  !  f(rho) interpolation routine -- with error checking

  use xplasma_obj_instance
  use eq_module
  IMPLICIT NONE

  !  input:

  integer ivec                      ! vector dimension
  REAL*8 zrho(ivec)                 ! argument

  integer ifcn                      ! function id number
  integer iwant                     ! 0:  value, 1: df/drho, 2: d2f/drho2

  !  output:
  REAL*8 zval(ivec)                 ! result of interpolation
  integer ierr                      ! =0: OK, =1: zrho out of range
  !  ... or some other error...
  !----------------------------

  integer :: ioutside

  !----------------------------

  call xplasma_eval_prof(s,ifcn,zrho,zval,ierr, &
       ideriv1=iwant, n_out_of_bounds=ioutside)

  if(ierr.ne.0) then
     write(lunerr,*) ' %eq_rgetf: error flag set: ',ierr
     call xplasma_error(s,ierr,lunerr)
     if(ioutside.gt.0) write(lunerr,*) &
          '  number of target points out of bounds: ',ioutside
  endif
  
  return
end subroutine eq_rgetf

subroutine eqm_time(ztime)

  !  set the time (seconds)

  use xplasma_obj_instance
  use eq_module

  real*8, intent(in) :: ztime

  !-------------------
  integer :: ier
  !-------------------

  call xplasma_time_set(s,ztime,ier)
  if(ier.ne.0) then
     write(lunerr,*) ' %eqm_time: failed to set xplasma time, ier=',ier
     call xplasma_error(s,ier,lunerr)
  endif

end subroutine eqm_time

subroutine mcgrid_find(id)

  !  look for a unique mcgrid ID in current "s"
  !  return the ID which will be greater than zero.

  !  if none is found, return 0.

  !  if there are multiple mcgrids defined return -N, where N are defined.

  use xplasma_obj_instance

  !-----------------------
  integer :: ierr
  !-----------------------

  id=0
  call xoi_init(ierr)
  if(ierr.ne.0) return

  call xplasma_mcgrid_find(s,ierr, id_mcgrid1=id)
  if(ierr.ne.0) id=0

end subroutine mcgrid_find

subroutine mcgrid_define(inphi,iudsym,inth0,inznbmri,inznbmr,id)
 
  !  define a 2d irregular "MC" polar grid
  !  fewer zones near the axis, more zones towards the edge, each
  !  zone has roughly the same volume... see mcgrid_mod.f90

  implicit NONE
 
  integer, intent(in) :: inphi      ! no. of phi zones
  integer, intent(in) :: iudsym     ! =1: updown symmetry; =2: no symmetry
  integer, intent(in) :: inth0      ! no. of zones spanning theta=[0,pi] @axis
  integer, intent(in) :: inznbmri   ! no. of radial zones spanning [axis,bdy]
  integer, intent(out) :: inznbmr   ! total no. of radial zones
  !  inznbmr = inznbmri + inznbmri/3 -- extension of grid beyond plasma
  !    boundary; usage is optional.
 
  integer, intent(out) :: id        ! grid id, positive integer; 0 means error

  !----------------------

  CALL mcgrid_named_define(' ',inphi,iudsym,inth0,inznbmri,inznbmr,id)

end subroutine mcgrid_define

subroutine mcgrid_named_define(zname,inphi,iudsym,inth0,inznbmri,inznbmr,id)
 
  !  define a 2d irregular "MC" polar grid
  !  fewer zones near the axis, more zones towards the edge, each
  !  zone has roughly the same volume... see mcgrid_mod.f90

  use xplasma_obj_instance
  use eq_module
 
  implicit NONE
 
  character*(*), intent(in) :: zname  ! author name -- or blank for default

  integer, intent(in) :: inphi      ! no. of phi zones
  integer, intent(in) :: iudsym     ! =1: updown symmetry; =2: no symmetry
  integer, intent(in) :: inth0      ! no. of zones spanning theta=[0,pi] @axis
  integer, intent(in) :: inznbmri   ! no. of radial zones spanning [axis,bdy]
  integer, intent(in) :: inznbmr   ! total no. of radial zones
!MG 08/21/2018  integer, intent(out) :: inznbmr   ! total no. of radial zones
  !  inznbmr = inznbmri + inznbmri/3 -- extension of grid beyond plasma
  !    boundary; usage is optional.
 
  integer, intent(out) :: id        ! grid id, positive integer; 0 means error
 
  !-----------------------------------------
  integer :: ierr
  !-----------------------------------------
 
!MG 08/21/2018   inznbmr = inznbmri+max(3,inznbmri/3)

  if(zname.eq.' ') then
     call xoi_author_set(ierr)
  else
     call xplasma_author_set(s,zname,ierr)
  endif

  call xplasma_mcgrid_define(s,'F77_MCGRID', &
       inth0,inznbmri,id,ierr, &
       nphi = inphi, &
       udsym = (iudsym.eq.1), &
       nrow_ext_in = inznbmr-inznbmri)
 
  if(zname.eq.' ') then
     call xoi_author_clear(ierr)
  else
     call xplasma_author_clear(s,zname,ierr)
  endif

end subroutine mcgrid_named_define
 
subroutine mcgrid_getsym(id,iudsym)
 
  !  for specified mcgrid, return
  !        iudsym=2  if the grid is updown Asymmetric
  !        iudsym=1  if the grid is updown symmetric
 
  use xplasma_obj_instance
  use eq_module
 
  implicit NONE
 
  integer, intent(in) :: id      ! mcgrid id
  integer, intent(out) :: iudsym
 
  !-----------------------------------------------------
  logical :: klsym
  integer :: ierr
  !-----------------------------------------------------

  call xplasma_mcgrid_info(s,id,ierr, udsym = klsym)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?mcgrid_getsym error:'
     call xplasma_error(s,ierr,lunerr)
     iudsym=0
  else
     if(klsym) then
        iudsym=1
     else
        iudsym=2
     endif
  endif
 
end subroutine mcgrid_getsym
 
subroutine mcgrid_getnumr(id,iznbmr,iznbmri)
 
  !  for specified mcgrid, return
  !        iznbmr= # of zone rows
  !        iznbmri= # of zone rows *inside plasma*
 
  use xplasma_obj_instance
  use eq_module
 
  implicit NONE
 
  integer, intent(in) :: id      ! mcgrid id
  integer, intent(out) :: iznbmr,iznbmri
 
  !-----------------------------------------------------
  integer :: ierr
  !-----------------------------------------------------

  call xplasma_mcgrid_info(s,id,ierr, nzrow=iznbmri, nzrow_ext=iznbmr)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?mcgrid_getnumr error:'
     call xplasma_error(s,ierr,lunerr)
     iznbmr=0
     iznbmri=0
  endif
 
end subroutine mcgrid_getnumr
 
subroutine mcgrid_getnumz(id,ifbzns,ifbznsi)
 
  !  for specified mcgrid, return
  !        ifbzns= total # of zones
  !        ifbznsi= total # of zones *inside plasma*
 
  use xplasma_obj_instance
  use eq_module
 
  implicit NONE
 
  integer, intent(in) :: id      ! mcgrid id
  integer, intent(out) :: ifbzns,ifbznsi
 
  !-----------------------------------------------------
  integer :: ierr
  !-----------------------------------------------------

  call xplasma_mcgrid_info(s,id,ierr, nzons=ifbznsi, nzons_ext=ifbzns)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?mcgrid_getnumz error:'
     call xplasma_error(s,ierr,lunerr)
     ifbzns=0
     ifbznsi=0
  endif
  
end subroutine mcgrid_getnumz
 
subroutine mcgrid_getnuma(id,inth0,inphi)
 
  !  for specified mcgrid, return
  !        inth0 = # of theta zones covering [0,pi] in first row at axis
  !        inphi = # of phi zones (usually: 1)
 
  use xplasma_obj_instance
  use eq_module
 
  implicit NONE
 
  integer, intent(in) :: id      ! mcgrid id
  integer, intent(out) :: inth0,inphi
 
  !-----------------------------------------------------
  integer :: ierr
  !-----------------------------------------------------

  call xplasma_mcgrid_info(s,id,ierr, nth0=inth0, nphi=inphi)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?mcgrid_getnuma error:'
     call xplasma_error(s,ierr,lunerr)
     inth0=0
     inphi=0
  endif
  
end subroutine mcgrid_getnuma
 
subroutine mcgrid_getnumzns(id,inthzns)
 
  !  id<0:  return information on zone rows inside plasma only
  !  id>0:  return information on all zone rows
  ! 
  !  for specified mcgrid, return
  !        inthzns(1) = # of theta zones in first row at axis
  !        inthzns(2) = # of theta zones in second row from axis
  !            ...
  !        inthzns(N) = # of theta zones in last row at edge of region

  !  see mcgrid_getnumr to find number of zone rows
 
  use xplasma_obj_instance
  use eq_module
 
  implicit NONE
 
  integer, intent(in) :: id      ! mcgrid id
  integer, intent(out) :: inthzns(*)
 
  ! -----------------------------------------------------
  integer inum,inumx,ida,ierr
  ! -----------------------------------------------------

  ida=abs(id)

  call mcgrid_getnumr(ida,inumx,inum)
  if(inum.eq.0) then
     inthzns(1)=0
     return
  endif

  if(id.eq.ida) then
     ! all zone rows
     call xplasma_mcgrid_info(s,ida,ierr, nths=inthzns(1:inumx))
  else
     ! interior zone rows only
     call xplasma_mcgrid_info(s,ida,ierr, nths=inthzns(1:inum))
  endif

  if(ierr.ne.0) then
     write(lunerr,*) ' ?mcgrid_getnumzns error:'
     call xplasma_error(s,ierr,lunerr)
     if(id.eq.ida) then
        inthzns(1:inumx)=0
     else
        inthzns(1:inum)=0
     endif
  endif
 
end subroutine mcgrid_getnumzns

real(fp) function scrYceptcon(x,Rtest,Ztest)
  !
  !  evaluate y(x):  theta line fit in some reference frame
  !  also return the (x,y) rotated back to (R,Z) space.
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, two
  use mintrp
  implicit none
  real(fp), intent(in)  :: x
  real(fp), intent(out) :: rtest
  real(fp), intent(out) :: ztest
  real(fp) :: zdydx
  real(fp) :: zdx
  real(fp) :: zref
  real(fp) :: rref
  real(fp) :: zsin
  real(fp) :: zcos
  real(fp) :: y
  real(fp) :: zxx
  real(fp) :: zx
  !
  !  for spvec (moption=3)...
  !
  integer :: ict(3)
  integer :: iwarn
  integer :: ier
  data ict/1,0,0/
  !
  !---------------------------------------------
  !
  zx=max(xspl(1),min(xmax,x))
  if(zx.gt.xbrk) then
    zxx=zx-xbrk
    y=d2+zxx*(c2+zxx*(b2+zxx*a2))
    zcos=zcosa2
    zsin=zsina2
    rref=r1
    zref=z1
    zx=zxx
  else
    if(moption.eq.2) then
      y=d+zx*(c+zx*(b+zx*a))
    else
      call spvec(ict,1,zx,1,y,5,xpkg,yspl,iwarn,ier)
      if(ier.ne.0) then
        call scraborter(6,'?scryceptcon: spvec error.')
        return
      end if
    end if
    zcos=zcosa
    zsin=zsina
    rref=r0
    zref=z0
  end if
  !
  !  linear extrapolation
  !
  if(x.gt.xmax) then
    zdx=x-xmax
    if(xmax.gt.xbrk) then
      zx=xmax-xbrk
      zdydx= c2 + two*zx*(b2 + 1.5_fp*zx*a2)
    else
      zx=x
      zdydx= c + two*xmax*(b + 1.5_fp*xmax*a)
    end if
  else
    zdx=zero
    zdydx=zero
  end if
  !
  y=y+zdx*zdydx
  scrYceptcon=y
  !
  !  transform to (R,Z)
  !
  Rtest = rref + zcos*(zx+zdx) - zsin*y
  Ztest = zref + zsin*(zx+zdx) + zcos*y
  !
  return
end function scrYceptcon

      INTEGER FUNCTION MCSTR_FINDNC(STR,CHAR)
C
C  FIND FIRST CHARACTER IN STR WHICH IS .NE. CHAR
C
      CHARACTER*(*) STR
      CHARACTER*1 CHAR
C
      L=LEN(STR)
      DO 10 I=1,L
        IF(STR(I:I).NE.CHAR) GO TO 20
 10   CONTINUE
C
C  NOT FOUND
C
      I=0
C
C  FOUND
C
 20   CONTINUE
      MCSTR_FINDNC=I
      RETURN
      END

subroutine eqm_brzx(ivec,zR,zZ,zphi,init,BR,BZ,BPHI,zpsi,ipsi,ierr)

  !  **vectorized**
  !  compute B vector on (R,Z,phi) grid -- using psi extrapolation technique
  !  also return psi(pol) -- this routine assumes an axisymmetric geometry

  !  **NOTE** algorithm replaced: call eqm_brz_adhoc instead!!

  !  COMMENTS DESCRIBING OLD ALGORITHM:
  !  extrapolation uses del.B=0, delxB=j=0 until current has to be re-intro-
  !  duced to force smoothness.  (Reality is that there are coils out there
  !  which control the plasma position and shape.  Their presence is essential
  !  and delxB=0 extrapolation is exponentially unstable without them.  But,
  !  as their positions are unknown, j is re-introduced in such a way as to
  !  smooth out the field extrapolation and act in their place.  Even so, 
  !  the field extrapolation can still be rough.  Therefore, the alternative
  !    "eqm_brz_adhoc"
  !  is also provided -- even less physical, but numerically better behaved).

  !  see subroutine eqm_brz_adhoc, below...

  !  axisymmetry is assumed... phi argument is ignored, but left in so
  !  that the routine can be used as an argument of the eqm_brz subroutine
  !--------------------------

  implicit NONE

  integer ivec                      ! vector lengths
  real*8 zR(ivec),zZ(ivec),zphi(ivec) ! locations to evaluate B vector

  integer init                      ! init-cleanup-compute control flag

  !  init=1  -- initialize
  !  init=2  -- cleanup
  !  init=0  -- compute

  !  ...a vector of B vectors...
  real*8 BR(ivec),BZ(ivec),BPHI(ivec) ! field vectors components (returned)

  real*8 zpsi(ivec)                 ! psi(poloidal) returned
  integer ipsi                      ! =1 returned, psi(poloidal) flag

  integer ierr                      ! completion code, 0=OK

  !--------------------------------

  call eqm_brz_adhoc(ivec,zR,zZ,zphi,init,BR,BZ,BPHI,zpsi,ipsi,ierr)

end subroutine eqm_brzx

!----------------------------------------------------------------------
subroutine eqm_brz_adhoc(ivec,zR,zZ,zphi,init,BR,BZ,BPHI,zpsi,ipsi,ierr)

  !  **vectorized**
  !  compute B vector on (R,Z,phi) grid -- using ad hoc extrapolation technique
  !  also return psi(pol) -- this routine assumes an axisymmetric geometry

  !  axisymmetry is assumed... phi argument is ignored, but left in so
  !  that the routine can be used as an argument of the eqm_brz subroutine

  !  the flux surface grid is extrapolated using a TRANSP-style "bloat"
  !  algorithm-- creating a fiction of closed "flux surfaces" beyond the
  !  plasma boundary.  These aren't real flux surfaces but serve as a
  !  convenient numerical grid.

  !  for rho > rhobdy, Bpol(rho,theta) = Bpol(rhobdy,theta)*L(rhobdy)/L(rho)
  !  is assumed (this determines the magnitude; the direction is tangent to
  !  the external (pseudo) flux surface with sign consistent with the interior
  !  plasma current.  L(rhobdy) = poloidal path length around plasma boundary;
  !  L(rho) = poloidal path length around rho surface.

  !  also, for rho > rhobdy, psi(rho) is integrated from dR*2pi*R*Bz, selected
  !  at R=Rmax of each extrapolated pseudo-flux surface

  implicit NONE

  integer ivec                      ! vector lengths
  real*8 zR(ivec),zZ(ivec),zphi(ivec) ! locations to evaluate B vector

  integer init                      ! init-cleanup-compute control flag

  !  init=1  -- initialize
  !  init=2  -- cleanup
  !  init=0  -- compute

  !  ...a vector of B vectors...
  real*8 BR(ivec),BZ(ivec),BPHI(ivec) ! field vectors components (returned)

  real*8 zpsi(ivec)                 ! psi(poloidal) returned
  integer ipsi                      ! =1 returned, psi(poloidal) flag

  integer ierr                      ! completion code, 0=OK

  !--------------------------------

  call eqm_brz_exec(ivec,zR,zZ,zphi,init,BR,BZ,BPHI,zpsi,ipsi,ierr)

end subroutine eqm_brz_adhoc

!--------------------------------
subroutine eqm_brz_exec(ivec,zR,zZ,zphi,init,BR,BZ,BPHI,zpsi,ipsi,ierr)

  !  **vectorized**
  !  compute B vector on (R,Z,phi) grid -- using psi extrapolation technique
  !  also return psi(pol) -- this routine assumes an axisymmetric geometry

  !  axisymmetry is assumed... phi argument is ignored, but left in so
  !  that the routine can be used as an argument of the eqm_brz subroutine

  use xplasma_definitions
  use eqi_rzbox_module

  implicit NONE

  integer ivec                      ! vector lengths
  real*8 zR(ivec),zZ(ivec),zphi(ivec) ! locations to evaluate B vector

  integer init                      ! init-cleanup-compute control flag

  !  init=1  -- initialize
  !  init=2  -- cleanup
  !  init=0  -- compute

  !  ...a vector of B vectors...
  real*8 BR(ivec),BZ(ivec),BPHI(ivec) ! field vectors components (returned)

  real*8 zpsi(ivec)                 ! psi(poloidal) returned
  integer ipsi                      ! =1 returned, psi(poloidal) flag

  integer ierr                      ! completion code, 0=OK

  !--------------------------------

  real*8 zrho,zindx,zdi
  integer :: indxR,indxZ,itype,i,iadr
  real*8 :: zrmin,zrmax,zzmin,zzmax

  integer :: id_Rg,id_Zg,id_g,id_psi,id_bmod
  integer :: bphi_ccw,jphi_ccw,iertmp,id_bb,nR,nZ
  logical :: axisymm,sol

  real*8, pointer, dimension(:) :: eqbuf
  integer, pointer, dimension(:) :: idata
  
  character*32 :: bbxname

  !--------------------------------

  ipsi=1
  bbxname='__BBXTRAP_TMP'

  call xplasma_global_info(sp,ierr, axisymm=axisymm, scrapeoff=sol, &
       bphi_ccw=bphi_ccw, jphi_ccw=jphi_ccw)

  if(ierr.ne.0) return

  call xplasma_find_item(sp,bbxname,id_bb,iertmp,nf_noerr=.TRUE.)
  if(ierr.ne.0) return

  !  cleanup call-- remove temporary black box

  if(init.eq.2) then
     call xplasma_author_set(sp,xplasma_xmhd,iertmp)
     if(id_bb.gt.0) then
        call xplasma_remove_item(sp,id_bb,iertmp)
     endif
     call xplasma_author_clear(sp,xplasma_xmhd,iertmp)

     BR=0
     BZ=0
     Bphi=0
     zpsi=0

     return
  endif

  !  initialization; error checks done once...

  if(init.eq.1) then

     if(.not.axisymm) then
        call xplasma_errmsg_append(sp,'  ...error in eqm_brz_exec')
        ierr=107
        return
     endif

     if(.not.sol) then
        call xplasma_errmsg_append(sp,'  ...error in eqm_brz_exec')
        ierr=109
        return
     endif

     !  B field SIGN factors must be set
     if((jphi_ccw.eq.0).or.(bphi_ccw.eq.0)) then
        call xplasma_errmsg_append(sp, &
             ' ?eqm_brzx/eqm_brz_adhoc:  set B sign factors first!')
        ierr=9999
        return
     endif

     call xplasma_find_item(sp,'BMOD',id_bmod,ierr,nf_noerr=.TRUE.)
     if(id_bmod.eq.0) then
        call xplasma_errmsg_append(sp, &
             ' ?eqm_brzx/eqm_brz_adhoc:  "BMOD" undefined.')
        call xplasma_errmsg_append(sp, &
             '  it is likely that equilibrium is not defined.')
        ierr=9999
        return
     endif

  !  create B(R,Z) & psi temporary space

     nR=0
     nZ=0

     call xplasma_find_item(sp,'__Rgrid',id_Rg,ierr)
     if(ierr.ne.0) return

     call xplasma_find_item(sp,'__Zgrid',id_Zg,ierr)
     if(ierr.ne.0) return

     call xplasma_grid_size(sp,id_Rg,nR,ierr)
     if(ierr.ne.0) return

     call xplasma_grid_size(sp,id_Zg,nZ,ierr)
     if(ierr.ne.0) return

     call xplasma_author_set(sp,xplasma_xmhd,iertmp)

     itype=9999
     call xplasma_create_blackBox(sp,bbxname,itype,id_bb,ierr, &
          iasize=5, r8asize= 4*nR*nZ+nR+nZ+2, ia_ptr=idata, r8a_ptr=eqbuf)

     call xplasma_author_clear(sp,xplasma_xmhd,iertmp)

     if(ierr.ne.0) then
        nullify(eqbuf,idata)
        return
     endif

     idata(1)=nR
     idata(2)=nZ
     idata(3)=4*nR*nZ+1
     idata(4)=idata(3)+nR
     idata(5)=idata(4)+nZ

     call xplasma_grid(sp,id_Rg,eqbuf(idata(3):idata(3)+nR-1),ierr)
     if(ierr.ne.0) then
        nullify(eqbuf,idata)
        return
     endif

     call xplasma_grid(sp,id_Zg,eqbuf(idata(4):idata(4)+nZ-1),ierr)
     if(ierr.ne.0) then
        nullify(eqbuf,idata)
        return
     endif

     !  g(edge)

     call xplasma_common_ids(sp,ierr, id_g=id_g, id_psi=id_psi)

     zrho=1.0d0
     call xplasma_eval_prof(sp,id_g,zrho,eqbuf(idata(5)),ierr)
     if(ierr.ne.0) then
        nullify(eqbuf,idata)
        return
     endif

     zrho=1.0d0
     call xplasma_eval_prof(sp,id_psi,zrho,eqbuf(idata(5)+1),ierr)
     if(ierr.ne.0) then
        nullify(eqbuf,idata)
        return
     endif

     if(ierr.ne.0) return

     call xplasma_blackBox_retrieve(sp,id_bb,ierr, &
          ia_ptr=idata, r8a_ptr=eqbuf)

     !  fill in the fields  BR  BZ  Bphi  Psi -- outside plasma only...

     call eqi_xpsi(nR,nZ,eqbuf(idata(3)),eqbuf(idata(4)), &
          eqbuf(idata(5)),eqbuf(idata(5)+1),bphi_ccw, jphi_ccw, &
          eqbuf(1),eqbuf(1+nR*nZ),eqbuf(1+2*nR*nZ),eqbuf(1+3*nR*nZ),ierr)

     BR=0
     BZ=0
     Bphi=0
     zpsi=0

     nullify(idata)
     nullify(eqbuf)

     return
  endif

  !-----------------------------
  !  normal evaluation, using precomputed data (init=0)

  if(id_bb.eq.0) then
     call xplasma_errmsg_append(sp,' ?eqm_brzx-- never initialized.')
     ierr=9999
     return
  endif

  call xplasma_blackBox_retrieve(sp,id_bb,ierr, &
       ia_ptr=idata, r8a_ptr=eqbuf)

  nR=idata(1)
  nZ=idata(2)

  zrmin=eqbuf(idata(3)); zrmax=eqbuf(idata(3)+nR-1)
  zzmin=eqbuf(idata(4)); zzmax=eqbuf(idata(4)+nZ-1)

  do i=1,ivec
     zindx=1.0d0+(nR-1)*(zR(i)-zRmin)/(zRmax-zRmin)
     indxR=zindx+0.01d0
     zdi=zindx-indxR
     zindx=1.0d0+(nZ-1)*(zZ(i)-zZmin)/(zZmax-zZmin)
     indxZ=zindx+0.01d0
     zdi=max(zdi,(zindx-indxZ))
     if(zdi.gt.1.0d-5) then
        call xplasma_errmsg_append(sp, &
             '  ?eqm_brzx: expected (R,Z) to be at a grid point.')
        ierr=9999
        exit
     endif

     iadr=indxR+nR*(indxZ-1)
     BR(i)=eqbuf(iadr)
     BZ(i)=eqbuf(iadr+nR*nZ)
     BPHI(i)=eqbuf(iadr+2*nR*nZ)
     zpsi(i)=eqbuf(iadr+3*nR*nZ)
  enddo

  nullify(eqbuf)
  nullify(idata)

end subroutine eqm_brz_exec

C******************** START FILE UERMSF.FOR ; GROUP URDUTS ******************
C
C& UERMSF UREAD ERROR MESSAGE WITH FLOATING PT VALUE ECHO
      SUBROUTINE UERMSR8(MSG,FNUM,ICOD)
C
      CHARACTER*(*) MSG
      real*8 fnum
      CHARACTER*20 FBUF
C
      WRITE(FBUF,1001,ERR=10) FNUM
 1001 FORMAT(1PE20.13)
      GO TO 20
C
 10   CONTINUE
      FBUF='**.GT.E20******'
C
 20   CALL UERMSG(MSG,FBUF,ICOD)
      RETURN
      END
C******************** END FILE UERMSF.FOR ; GROUP URDUTS ******************

 
#include "fpreproc/byte_declare.h"
 
!----------------------------------------------------------
! cface  -- generated (f90 fixed form) C interface to:  EQM_RZFUNDA
      SUBROUTINE  C_EQM_RZFUNDA(
     > C_ZNAME_LEN,C_ZNAME,IFUN,ZDATA,INR,INZ,IORDER,ZSM,IERR)
 
      external EQM_RZFUNDA
 
! argument declarations
 ! scalar char*(*) type, input only:
      INTEGER C_ZNAME_LEN
      BYTE_DECLARE C_ZNAME(C_ZNAME_LEN)
 
      INTEGER IFUN
      INTEGER INR
      INTEGER INZ
      INTEGER IORDER
      REAL*8 ZSM
      INTEGER IERR
      REAL*8 ZDATA(INR,INZ)
 
! local (automatic array) declarations
      CHARACTER(C_ZNAME_LEN) :: ZNAME_act
 
! executable code:  copy for input
 
      call cstring(ZNAME_act, C_ZNAME,'2F')
! call to original routine:  EQM_RZFUNDA
 
      CALL EQM_RZFUNDA(
     > ZNAME_act,IFUN,ZDATA,INR,INZ,IORDER,ZSM,IERR)
 
! copy back outputs if modified.
 
! exit
      return
      end

subroutine eqm_bset(isnccwb,isnccwi)

  use xplasma_obj_instance
  use eq_module

  !  setup B field signs

  IMPLICIT NONE

  !  input:
  integer isnccwb                   ! toroidal field sign factor...
  integer isnccwi                   ! plasma current sign factor...

  !  CCW = counter-clockwise
  !  isnccwb=+1 -- TF is CCW looking down from top of machine
  !         =-1 -- TF is clockwise

  !  isnccwi=+1 -- Ip is CCW looking down from top of machine
  !         =-1 -- Ip is clockwise

  !  if isnccwi=+1 Bpol points down on the large major radius side
  !  of the machine...

  !-------------------------------------

  INTEGER ierr
  integer :: nsnccwb,nsnccwi,icount
  logical :: iforce = .FALSE.
  !-------------------------------------

  ierr=0
  nsnccwb=0
  if((isnccwb.ne.1).and.(isnccwb.ne.-1)) then
     ierr=1
     call eq_errmsg(' ?eqm_bset:  isnccwb must be +/- 1')
     write(lunerr,*) '  instead, isnccwb = ',isnccwb
  else
     nsnccwb=isnccwb
  endif

  nsnccwi=0
  if((isnccwi.ne.1).and.(isnccwi.ne.-1)) then
     ierr=1
     call eq_errmsg(' ?eqm_bset:  isnccwi must be +/- 1')
     write(lunerr,*) '  instead, isnccwi = ',isnccwi
  else
     nsnccwi=isnccwi
  endif

  call xplasma_field_ccw_set(s,ierr, bphi_ccw=nsnccwb, jphi_ccw=nsnccwi)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqm_bset: xplasma_field_ccw_set returned status: ',ierr
     call xplasma_error(s,ierr,lunerr)
  else
     call xplasma_eqcheck(s,iforce,icount,ierr)
     if(icount.gt.0) then
        write(lunerr,*) ' %eqm_bset: equilibrium specification completed.'
     endif
  endif

end subroutine eqm_bset

subroutine eq_bchk_sign(isnccwb,isnccwi)

  ! retrieve field and current direction signs e.g. as set by eqm_bset...

  use xplasma_obj_instance
  use eq_module

  !--------------
  integer :: ierr
  !--------------

  call xplasma_global_info(s,ierr, bphi_ccw=isnccwb, jphi_ccw=isnccwi)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqm_bchk_sign: xplasma_global_info status: ',ierr
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_bchk_sign

      program plot_xplasma

!  read "xplasma" module from NetCDF file, and plot...

      character*128 filename
      integer i,ier,inum_lists

      character*32, dimension(:), allocatable :: list_names
      integer, dimension(:), allocatable :: list_ids

      logical lchar,lxout
!---------------------------------------------

      call uinitg("PLOT_XPLASMA")
      call urdext('tmi')

      do

         if(lxout(0)) then
            write(6,*) ' precede filename with "-" character to call'
            write(6,*) ' "example" subroutine which will try to read'
            write(6,*) ' and print TR_PBI data from the named file.'
         endif

         call ureadLw('plot_xplasma:  enter filename or "Q" to quit:$',
     >        filename)
!
         if((filename.eq.'q ').or.(filename.eq.'Q ')) then
            call uexita(0)
            stop
         endif

         if(filename(1:1).eq.'-') then
            call xplasma_example(filename(2:))
            cycle
         endif

         call eq_restore(filename,ier)
         if(ier.ne.0) then
            write(6,*) ' %plot_xplasma:  open failure:  ', filename

         else
            call eqdbg_plot     ! as before...

         endif

      enddo

      end

module xplasma_mcgrid

  !  xplasma module for "MCgrid" objects-- these are objects defined
  !  over the irregular MC grid of NUBEAM, etc.  At the xplasma kernel
  !  level these are implemented as blackbox objects.

  !  Comments from original f77 implementation:
  !  ------------------------------------------
  !  module for implementation of a set of "MC" grids within the xplasma
  !  environment.  These are semi-irregular grids that partition an
  !  (x,theta,phi) space into zones of roughly equal volume, by setting
  !  up a series of "zone rows" in the x direction, with a variable number
  !  of "theta zones" in each zone row, proportional to the value of x
  !
  !  there are two variants:  updown symmetric and updown asymmetric.
  !    NTH0 = no. of theta zones from 0 to pi in the zone row touching
  !    the magnetic axis (this is HALF the number of zones in the first
  !    row, for updown asymmetric cases).
  !
  !            0 to pi                               0 to 2pi
  !            updown symmetric:                     asymmetric:
  !  1st x row:  NTH0 zones                            2*NTH0 zones
  !  2nd x row:  2*NTH0 zones                          2*2*NTH0 zones
  !  3rd x row:  3*NTH0 zones                          3*2*NTH0 zones
  !                ...                                   ...
  !  Nth x row: N*NTH0 zones                           N*2*NTH0 zones
  !
  !     (the above figures are for axisymmetry, nphi=1; if there
  !     are more than one toroidal (phi) zones, all numbers are
  !     multiplied by the factor nphi)
  !
  !  although x=1 is the normal boundary of the space, the grid is
  !  allowed to extend beyond x=1 into xplasma's "extrapolated" polar
  !  region.  But, zone volumes are only evaluated for the region
  !  inside the boundary.

  use xplasma_obj
  use xplasma_flxint, only: xplasma_2d_zonint
  implicit NONE

  private

  public :: xplasma_mcgrid_find
  public :: xplasma_mcgrid_findProfs
  public :: xplasma_mcgrid_define
  public :: xplasma_mcgrid_info
  public :: xplasma_mcgrid_profInfo
  public :: xplasma_mcgrid_volumes
  public :: xplasma_mcgrid_putobj
  public :: xplasma_mcgrid_getobj

  real*8, parameter :: ONE = 1.0d0
  real*8, parameter :: ZERO= 0.0d0
  real*8, parameter :: EPS7= 1.0d-7
  real*8, parameter :: CPI=  3.1415926535897931D+00
  real*8, parameter :: C2PI= 6.2831853071795862D+00
  integer, parameter, public :: xplasma_bbgtype=17  ! MC grid blackbox type
  integer, parameter, public :: xplasma_bbftype=18  ! MC profile blackbox type

  contains

    subroutine xplasma_mcgrid_find(s,ierr, author_only, &
         id_mcgrid1,num_mcgrids,id_mcgrids)

      !  find MCgrid grid definitions that are available in the current
      !  xplasma-- usually there will be only one we think.

      type(xplasma), pointer :: s
      integer, intent(out) :: ierr          ! status code returned (0=OK)

      character*(*), intent(in), optional :: author_only
      !  restrict search to MCgrid objects written by this author or code

      integer, intent(out), optional :: id_mcgrid1  ! MCgrid id returned, if...
      !  if exactly one exists.  If none exist, id_mcgrid1=0 is returned; if
      !  >1 exists,id_mcgrid1=-<the number of MCgrids> is returned.

      integer, intent(out), optional :: num_mcgrids ! number of MCgrids found.

      integer, dimension(:), optional :: id_mcgrids ! MCgrid ids returned.

      !-----------------------
      integer :: inum,ids(1)
      !-----------------------

      ierr=0
      if(present(id_mcgrid1)) id_mcgrid1=0
      if(present(num_mcgrids)) num_mcgrids=0
      if(present(id_mcgrids)) id_mcgrids=0

      call xplasma_find_blkbxs(s,ierr, author_only, itype=xplasma_bbgtype, &
           num_blkbxs=inum)

      if(ierr.ne.0) return
      if(inum.eq.0) return

      if(present(num_mcgrids)) num_mcgrids=inum

      if(present(id_mcgrids)) then
         call xplasma_find_blkbxs(s,ierr, author_only, itype=xplasma_bbgtype, &
              id_blkbxs=id_mcgrids)

         if(present(id_mcgrid1)) then
            if(inum.eq.1) then
               id_mcgrid1=id_mcgrids(1)
            else
               id_mcgrid1=-inum
            endif
         endif

      else
         if(present(id_mcgrid1)) then
            if(inum.eq.1) then
               call xplasma_find_blkbxs(s,ierr, author_only, itype=xplasma_bbgtype, &
                    id_blkbxs=ids)
               id_mcgrid1=ids(1)
            else
               id_mcgrid1=-inum
            endif
         endif
      endif

    end subroutine xplasma_mcgrid_find

    subroutine xplasma_mcgrid_findProfs(s,id_mcgrid,ierr, &
         author_only, num_profs, id_profs)

      ! find profiles defined over given MCgrid

      type(xplasma), pointer :: s
      integer, intent(in) :: id_mcgrid      ! MC grid id
      integer, intent(out) :: ierr          ! status code returned (0=OK)

      character*(*), intent(in), optional :: author_only
      !  restrict search to MCgrid profiles written by this author or code

      integer, intent(out), optional :: num_profs ! number of profiles found.

      integer, dimension(:), optional :: id_profs ! profile ids returned.

      !-----------------------
      integer :: isize,inum,ii,jj,iertmp
      integer, dimension(:), allocatable :: ids
      integer, dimension(:), pointer :: iadata
      !-----------------------

      ierr=0
      if(present(num_profs)) num_profs=0
      if(present(id_profs)) then
         id_profs=0
         isize=size(id_profs)
      endif

      call xplasma_find_blkbxs(s,ierr,author_only, itype=xplasma_bbftype, &
           num_blkbxs=inum)

      if(ierr.ne.0) return
      if(inum.eq.0) return

      allocate(ids(inum))

      call xplasma_find_blkbxs(s,iertmp,author_only, itype=xplasma_bbftype, &
           id_blkbxs=ids)

      ii=0
      do jj=1,inum

         call xplasma_blackBox_retrieve(s,ids(jj),iertmp, ia_ptr=iadata)

         if(iadata(1).ne.id_mcgrid) cycle

         ii=ii+1
         if(present(id_profs)) then
            if(isize.lt.ii) then
               ierr=61
            else
               id_profs(ii)=ids(jj)
            endif
         endif

      enddo

      if(present(num_profs)) num_profs = ii

    end subroutine xplasma_mcgrid_findProfs

    subroutine xplasma_mcgrid_define(s,mcname,inth0,inrow,id,ierr, &
         nphi,udsym,label,nrow_ext_in,nrow_ext_out)

      type(xplasma), pointer :: s
      character*(*), intent(in) :: mcname   ! name of MC grid

      integer, intent(in) :: inth0          ! no. of zones covering [0,pi]
                                            ! in 1st row at axis

      integer, intent(in) :: inrow          ! no. of rows covering plasma

      integer, intent(out) :: id            ! MC grid id returned (0 if error)
      integer, intent(out) :: ierr          ! status code returned (0=OK)

      integer, intent(in), optional :: nphi ! number of Phi=const zones
      !  default:1 (axisymmetry)

      logical, intent(in), optional :: udsym   ! updown symmetry flag
      !  default:.FALSE. (do not assume updown symmetric MHD equilibrium).

      character*(*), intent(in), optional :: label  ! optional label for MCgrid

      integer, intent(in), optional :: nrow_ext_in   ! no. of external rows
      !  requested (default: 0, meaning: use internal calculation).  If non-
      !  zero value is given, inrow >= nrow_ext_in >= 3 will be enforced.

      integer, intent(out), optional :: nrow_ext_out ! actual no. of external
      !  zone rows created.

      !---------------------------------------------------
      !  define a 2d irregular "MC" polar grid
      !  fewer zones near the axis, more zones towards the edge, each
      !  zone has roughly the same volume...
      !-----------------------------------------
      
      integer :: inznbmr,inznbmri,inphi,idum,iudsym,idi,ir,ifac,ifbznsi,isize
      character*120 zmsg

      integer, dimension(:), allocatable :: idata,nthzns,nthzsum
      real*8, dimension(:), allocatable :: zx,zvols
      real*8 :: zxmin
      logical :: axisymm

      !-----------------------------------------
 
      id = 0
      call xplasma_global_info(s,ierr,axisymm=axisymm)
      if(ierr.ne.0) return

      if(.not.axisymm) then
         ierr=107
         call xplasma_errmsg_append(s,' ?xplasma_mcgrid_define: axisymmetry still required.')
         return
      endif

      ierr = 0
      if(inrow.le.0) then
         zmsg=' '
         write(zmsg,*) ' ?xplasma mcgrid_define:  inrow=',inrow
         call xplasma_errmsg_append(s,trim(zmsg))
         zmsg=' '
         write(zmsg,*) '  inrow.gt.0 required!'
         call xplasma_errmsg_append(s,trim(zmsg))
         ierr = 9999
      endif

      inznbmri = inrow
      idum=0
      if(present(nrow_ext_in)) idum=max(3,min(inznbmri,nrow_ext_in))
      if(idum.eq.0) idum = max(3,inznbmri/3)

      inznbmr = inznbmri+idum
      if(present(nrow_ext_out)) nrow_ext_out = idum
 
      if(inth0.le.0) then
         zmsg=' '
         write(zmsg,*) ' ?xplasma_mcgrid_define:  inth0=',inth0
         call xplasma_errmsg_append(s,trim(zmsg))
         zmsg=' '
         write(zmsg,*) '  inth0.gt.0 required!'
         call xplasma_errmsg_append(s,trim(zmsg))
         ierr = 9999
      endif

      inphi=1
      if(present(nphi)) inphi=max(1,inphi)
 
      if(max(inznbmr,inth0,inphi).gt.1000) then
         zmsg=' '
         write(zmsg,*) ' ?xplasma_mcgrid_define: sanity check:'
         call xplasma_errmsg_append(s,trim(zmsg))
         zmsg=' '
         write(zmsg,*) '  max(inznbmr,inth0,inphi) = ',max(inznbmr,inth0,inphi)
         call xplasma_errmsg_append(s,trim(zmsg))
         zmsg=' '
         write(zmsg,*) '  inznbmr = ',inznbmr
         call xplasma_errmsg_append(s,trim(zmsg))
         zmsg=' '
         write(zmsg,*) '  inth0 = ',inth0
         call xplasma_errmsg_append(s,trim(zmsg))
         zmsg=' '
         write(zmsg,*) '  inphi = ',inphi
         call xplasma_errmsg_append(s,trim(zmsg))
         ierr = 9999
      endif
 
      iudsym=2
      if(present(udsym)) then
         if(udsym) then
            iudsym=1
         else
            iudsym=2
         endif
      endif

      if (ierr.ne.0) return

      !--------------------------------------------
      ! error checks complete.

      ! generate evenly spaced extrapolated x grid
 
      allocate(zx(0:inznbmr))
      zx(0)=ZERO
      zx(inznbmri)=ONE
      zxmin=EPS7

      do ir=1,inznbmri-1
         zx(ir)=((inznbmri-ir)*zx(0) + ir*zx(inznbmri))/(inznbmri)
      enddo
      do ir=inznbmri+1,inznbmr
         zx(ir)=zx(ir-1)+(zx(inznbmri)-zx(inznbmri-1))
      enddo

      ! generate integer array for blackbox containing necessary information
      ! to characterize the grid + some addl info for convenience

      isize = 10 + 2*inznbmr
      allocate(idata(isize))

      !  set grid sizes
 
      idata(1) = inznbmri
      idata(2) = inznbmr
      idata(3) = inphi
      idata(4) = inth0
      if(iudsym.eq.1) then
         idata(5) = 1
         ifac=1
      else
         idata(5) = 0
         ifac=2
      endif
 
      idata(8:10) = 0  ! spares...

      !  get the no. of theta zones per zone row and total no. of zones

      allocate(nthzns(inznbmr),nthzsum(0:inznbmr))
 
      nthzsum(0)=0
 
      do ir=1,inznbmr
 
         nthzns(ir)=ifac*ir*inth0
         nthzsum(ir)=nthzsum(ir-1) + inphi*nthzns(ir)
 
         if(ir.eq.inznbmri) then
            idata(6)=nthzsum(ir)  ! total #zones inside plasma
         endif

         if(ir.eq.inznbmr) then
            idata(7)=nthzsum(ir)  ! total #zones inside & outside
         endif
      enddo
 
      idata(8:10) = 0  ! spares...

      idum=10+inznbmr
      idata(11:idum)=nthzns
      idata(idum+1:idum+inznbmr)=nthzsum(1:inznbmr)

      !  OK: create blackbox

      call xplasma_create_blackbox(s,mcname,xplasma_bbgtype,id,ierr, &
           iarray=idata, r8array=zx, label=label)

      deallocate(zx,idata,nthzns,nthzsum)
      if(ierr.ne.0) return
 
      !  get space for the zone volumes

      call xplasma_mcgrid_info(s,id,ierr, nzons=ifbznsi)
      if(ierr.ne.0) return

      allocate(zvols(ifbznsi))
      call xplasma_mcgrid_volumes(s,id,zvols,ierr)
      deallocate(zvols)

    end subroutine xplasma_mcgrid_define
 
    subroutine xplasma_mcgrid_volumes(s,id_mcgrid,vols,ierr, &
         lstart0_th,ccwflag_th)

      !  return the zone volumes associated with a MCgrid.  Compute them
      !  if necessary.

      type(xplasma), pointer :: s
      integer, intent(in) :: id_mcgrid   ! MC grid id
      real*8, dimension(:) :: vols       ! the array of volume elements
      integer, intent(out) :: ierr       ! status code (0=OK)

      ! theta indexing options
      logical, intent(in), optional :: lstart0_th ! default depends on symmetry
      logical, intent(in), optional :: ccwflag_th ! default: T

      ! lstart0_th=T means user's first theta zone lower bdy is 0; F means it
      ! is -pi.  If defaulted: updown symmetric data assumed to start at 0;
      ! updown asymmetric data assumed to start at -pi.

      ! ccwflag_th=T means zone index increases as one goes along a row of
      ! zones at fixed radial index in a counter-clockwise direction; F means
      ! the opposite.  T is the default.

      !----------------------------------------------
      integer :: ifbznsi  ! number of zones inside plasma
      integer :: inznbmri ! number of zone rows inside plasma
      integer :: inznbmr  ! total number of zone rows
      integer :: idv,idmc,idint,idin2,isizf,inumf,itype,inumchis,iertmp
      integer :: inthz,inths,izp,izn,ir,ith,inzr,id
      character*32 volname,mcname
      character*120 zmsg
      integer, dimension(:), pointer :: idata
      real*8, dimension(:), pointer :: r8data
      real*8, dimension(:), allocatable :: zchis
      real*8, dimension(:,:), allocatable :: voltmp
      real*8 :: x2(2),zfac
      logical :: udsym
      !----------------------------------------------

      id=id_mcgrid

      call xplasma_mcgrid_info(s,id,ierr, &
           nzons=ifbznsi, nzrow=inznbmri, nzrow_ext=inznbmr, name=mcname, &
           udsym=udsym)
      if(ierr.ne.0) return

      if(size(vols).ne.ifbznsi) then
         ierr=9999
         write(zmsg,*) ' ?xplasma_mcgrid_volume: #of MCgrid zones in plasma:',&
              ifbznsi
         call xplasma_errmsg_append(s,trim(zmsg))
         write(zmsg,*) '  size of passed array "vols": ',size(vols), &
              ' does not match.'
         return
      endif

      volname = trim(mcname)//'_DVOL'

      call xplasma_find_item(s,volname,idv,ierr,nf_noerr=.TRUE.)
      if(ierr.ne.0) return

      if(idv.gt.0) then
         call xplasma_get_item_info(s,idv,ierr,itype=itype)
         if(ierr.ne.0) return
         if(itype.ne.xplasma_blkbxType) then
            ierr=9999
            call xplasma_errmsg_append(s,' ?xplasma_mcgrid_volume: internal error looking for volumes: '//trim(volname))
            return
         endif

         call xplasma_blackBox_retrieve(s,idv,ierr, itype=itype, &
              ia_ptr=idata, r8a_ptr=r8data)

         if(itype.ne.xplasma_bbftype) then
            ierr=9999
            call xplasma_errmsg_append(s,' ?xplasma_mcgrid_volume: internal error volumes not a MCgrid profile: '//trim(volname))
            nullify(idata,r8data)
            return
         endif

         idmc=idata(1)
         isizf=idata(2)
         inumf=idata(3)

         if(idmc.ne.id) then
            ierr=9999
            call xplasma_errmsg_append(s,' ?xplasma_mcgrid_volume: internal error: MCgrid id mismatch: '//trim(volname))
            nullify(idata,r8data)
            return
         endif

         if(isizf.ne.ifbznsi) then
            ierr=9999
            call xplasma_errmsg_append(s,' ?xplasma_mcgrid_volume: internal error: profile size mismatch: '//trim(volname))
            nullify(idata,r8data)
            return
         endif

         if(inumf.gt.0) then
            ierr=9999
            call xplasma_errmsg_append(s,' ?xplasma_mcgrid_volume: internal error: profile rank mismatch: '//trim(volname))
            nullify(idata,r8data)
            return
         endif

         !  OK -- actual retrieve below...

         nullify(idata,r8data)

      else

         !  OK, volumes not found: compute them...

         allocate(idata(inznbmri))
         call xplasma_mcgrid_info(s,id,ierr, &
              nths=idata)

         call xplasma_author_set(s,xplasma_xmhd,iertmp)

         izp=1
         idint=0
         idin2=0
         do ir=1,inznbmri
 
            x2(1)=(ir-1)*ONE/(inznbmri)
            x2(2)=ir*ONE/(inznbmri)
            call xplasma_create_integ(s,trim(mcname)//'_VOLINT', &
                 x2, idint, ierr, &
                 rhomin=EPS7)

            if(ierr.ne.0) then
               call xplasma_errmsg_append(s, &
                    ' ?xplasma_mcgrid_volumes: integrator setup failed for:'//&
                    ' '//trim(mcname)//' (1d)')
               exit
            endif

            inthz= idata(ir)
            inths= inthz + 1

            allocate(zchis(inths))
            if(udsym) then
               do ith=1,inths
                  zchis(ith)= (ith-1)*CPI/(inthz)
               enddo
               zfac=2.0d0   ! multiply upper half volume by two
            else
               do ith=1,inths
                  zchis(ith)= -CPI + (ith-1)*C2PI/(inthz)
               enddo
               zfac=1.0d0
            endif

            call xplasma_augment_integ(s,trim(mcname)//'_VOLIN2',idint, &
                 zchis, idin2,ierr)

            deallocate(zchis)

            if(ierr.ne.0) then
               call xplasma_errmsg_append(s, &
                    ' ?xplasma_mcgrid_volumes: integrator setup failed for:'//&
                    ' '//trim(mcname)//' (2d)')
               exit
            endif

            izn = izp+inthz-1

            allocate(voltmp(inthz,1))

            call xplasma_2d_zonint(s,idin2,'dVol',voltmp,ierr)

            if(ierr.ne.0) then
               deallocate(voltmp)
               call xplasma_errmsg_append(s, &
                    ' ?xplasma_mcgrid_volumes: integration failed for:'//&
                    ' '//trim(mcname))
               exit
            else
               vols(izp:izn)=voltmp(1:inthz,1)*zfac
               deallocate(voltmp)
            endif

            izp=izn+1
         enddo

         if(idin2.gt.0) call xplasma_remove_item(s,idin2,iertmp)
         if(idint.gt.0) call xplasma_remove_item(s,idint,iertmp)

         if(ierr.eq.0) then

            call xplasma_mcgrid_putobj(s,id,volname,idv,ierr, &
                 data_1d=vols, &
                 label = trim(mcname)//' zone volumes', units = 'm**3')

         endif

         call xplasma_author_clear(s,xplasma_xmhd,iertmp)

         deallocate(idata)

      endif

      ! retrieve here with ordering as specified by user optional
      ! arguments...

      if(ierr.eq.0) then
         call xplasma_mcgrid_getobj(s,idv,ierr, &
              data_1d=vols,lstart0_th=lstart0_th,ccwflag_th=ccwflag_th)
      endif

    end subroutine xplasma_mcgrid_volumes

    subroutine xplasma_mcgrid_info(s,id_mcgrid,ierr, &
         nzrow,nzrow_ext, nzons,nzons_ext, nth0,nphi, nths, udsym, &
         name,label,author)

      ! fetch information on xplasma_mcgrid grid

      type(xplasma), pointer :: s
      integer, intent(in) :: id_mcgrid  ! id of MCgrid object to be queried
      integer, intent(out):: ierr       ! status code 0=OK

      integer, intent(out), optional :: nzrow  ! # of zone rows in plasma
      integer, intent(out), optional :: nzrow_ext  ! # inside and outside

      integer, intent(out), optional :: nzons  ! # of zones in plasma
      integer, intent(out), optional :: nzons_ext  ! # inside and outside

      integer, intent(out), optional :: nth0   ! # of zones @axis cover [0:pi]
      integer, intent(out), optional :: nphi   ! # of phi zones (1:axisymmetry)

      integer, dimension(:), intent(out), optional :: nths
      ! number of theta zones in each zone row

      logical, intent(out), optional :: udsym

      character*(*), intent(out), optional :: name
      character*(*), intent(out), optional :: label
      character*(*), intent(out), optional :: author

      !-------------------------------------------------------
      integer :: itype,inznbmr,inznbmri,isize,id

      integer, dimension(:), pointer :: ia_ptr
      real*8, dimension(:), pointer :: r8a_ptr
      !-------------------------------------------------------

      id = id_mcgrid

      if(present(nzrow)) nzrow = 0
      if(present(nzrow_ext)) nzrow_ext = 0

      if(present(nzons)) nzons = 0
      if(present(nzons_ext)) nzons_ext = 0

      if(present(nth0)) nth0 = 0
      if(present(nphi)) nphi = 0

      if(present(nths)) nths = 0

      if(present(udsym)) udsym=.FALSE.

      if(present(name)) name=' '
      if(present(label)) label=' '
      if(present(author)) author=' '

      ierr = 0

      if(present(name)) call xplasma_get_item_info(s,id,ierr,name=name)
      if(ierr.ne.0) return

      if(present(label)) call xplasma_get_item_info(s,id,ierr,label=label)
      if(ierr.ne.0) return

      if(present(author)) call xplasma_get_item_info(s,id,ierr,author=author)
      if(ierr.ne.0) return

      call xplasma_blackBox_retrieve(s,id,ierr, itype=itype, &
           ia_ptr=ia_ptr, r8a_ptr=r8a_ptr)

      if(ierr.ne.0) return
      if(itype.ne.xplasma_bbgtype) then
         ierr=9999
         call xplasma_errmsg_append(s, &
              ' ?xplasma_mcgrid_info: not a MCgrid object: '//trim(name))
         nullify(ia_ptr,r8a_ptr)
         return
      endif

      inznbmri= ia_ptr(1)
      inznbmr = ia_ptr(2)

      if(present(nzrow)) nzrow=inznbmri
      if(present(nzrow_ext)) nzrow_ext=inznbmr

      if(present(nth0)) nth0=ia_ptr(4)
      if(present(nphi)) nphi=ia_ptr(3)

      if(present(udsym)) udsym = (ia_ptr(5).eq.1)  ! updown symmetry flag

      if(present(nzons)) nzons= ia_ptr(10+inznbmr+inznbmri)
      if(present(nzons_ext)) nzons_ext= ia_ptr(10+inznbmr+inznbmr)

      if(present(nths)) then
         isize=min(size(nths),inznbmr)
         nths(1:isize)=ia_ptr(10+1:10+isize)
      endif

      nullify(ia_ptr,r8a_ptr)

    end subroutine xplasma_mcgrid_info

    subroutine xplasma_mcgrid_profInfo(s,id_mcprof,ierr, &
         id_mcgrid,nzons,irank,idim1,idim2, &
         gridId1,gridId2,normcode, &
         name,label,units,author)

      ! fetch information on a single profile defined over an MCgrid...

      type (xplasma), pointer :: s
      integer, intent(in) :: id_mcprof   ! profile ID
      integer, intent(out) :: ierr       ! status code returned: 0=OK

      integer, intent(out), optional :: id_mcgrid   ! MCgrid ID
      integer, intent(out), optional :: nzons       ! #spatial zones
      integer, intent(out), optional :: irank       ! #non-spatial dimensions
      integer, intent(out), optional :: idim1,idim2 ! non-spatial dim. sizes

      !  grid IDs for non-spatial dimensions (if available)

      integer, intent(out), optional :: gridId1
      integer, intent(out), optional :: gridId2

      ! normalization code

      integer, intent(out), optional :: normcode

      !-------------

      character*(*), intent(out), optional :: name
      character*(*), intent(out), optional :: label
      character*(*), intent(out), optional :: units
      character*(*), intent(out), optional :: author

      !---------------------------------------
      integer, dimension(:), pointer :: iadata
      integer :: itype,iertmp
      character*32 :: zname
      !---------------------------------------

      if(present(id_mcgrid)) id_mcgrid=0
      if(present(nzons)) nzons=0
      if(present(irank)) irank=0
      if(present(idim1)) idim1=0
      if(present(idim2)) idim2=0

      if(present(gridId1)) gridId1=0
      if(present(gridId2)) gridId2=0

      if(present(normcode)) normcode=0

      if(present(name)) name=' '
      if(present(label)) label=' '
      if(present(units)) units=' '
      if(present(author)) author=' '

      call xplasma_blackbox_info(s,id_mcprof,ierr, type=itype, name=zname)
      if((ierr.ne.0).or.(itype.ne.xplasma_bbftype)) then
         if(ierr.ne.0) then
            zname='(no name)'
         else
            ierr=9999
         endif
         call xplasma_errmsg_append(s, &
              ' %xplasma_mcgrid_profInfo: not a MCgrid profile: '//trim(zname))
         return
      endif

      if(present(name)) name=zname

      call xplasma_blackbox_retrieve(s,id_mcprof,iertmp, ia_ptr=iadata)

      if(present(id_mcgrid)) id_mcgrid=iadata(1)
      if(present(nzons)) nzons=iadata(2)
      if(present(irank)) irank=iadata(3)
      if(present(idim1)) idim1=iadata(4)
      if(present(idim2)) idim2=iadata(5)

      call xplasma_get_item_info(s,id_mcprof,iertmp, &
           label=label, units=units, author=author)

      if(size(iadata).gt.6) then
         if(present(gridId1)) gridId1=iadata(10)
         if(present(gridId2)) gridId2=iadata(11)
         if(present(normcode)) normcode=iadata(15)
      endif

    end subroutine xplasma_mcgrid_profInfo

    subroutine xplasma_mcgrid_putobj(s,id_mcgrid,pname,id_p,ierr, &
         lstart0_th,ccwflag_th, &
         data_1d,data_2d,data_3d, &
         gridId1,gridId2,normcode, &
         label,units)

      ! define a profile "object" over a MCgrid.  This can define
      ! a single data value per grid zone (use data_1d), or a vector of
      ! of data values per grid zone (use data_2d) or a 2d array of values
      ! per grid zone (use data_3d).

      type(xplasma), pointer :: s
      integer, intent(in) :: id_mcgrid  ! MCgrid over which profile is defined.
      character*(*), intent(in) :: pname ! name of profile
      integer, intent(out) :: id_p      ! xplasma ID of profile returned
      integer, intent(out) :: ierr      ! status code (0=OK)

      ! theta indexing options
      logical, intent(in), optional :: lstart0_th ! default depends on symmetry
      logical, intent(in), optional :: ccwflag_th ! default: T

      ! lstart0_th=T means user's first theta zone lower bdy is 0; F means it
      ! is -pi.  If defaulted: updown symmetric data assumed to start at 0;
      ! updown asymmetric data assumed to start at -pi.

      ! ccwflag_th=T means zone index increases as one goes along a row of
      ! zones at fixed radial index in a counter-clockwise direction; F means
      ! the opposite.  T is the default.

      ! NOTE: similar options for phi mapping could be defined but that has
      ! not yet been done; may be an issue if/when we get beyond axisymmetry
      ! in XPLASMA...

      ! Although following arguments are optional, exactly one must be
      ! provided.  The last dimension of the array must match the size
      ! of the entire grid, or of the subset of the grid covering the
      ! plasma (either or)

      real*8, intent(in), dimension(:), optional :: data_1d
      real*8, intent(in), dimension(:,:), optional :: data_2d
      real*8, intent(in), dimension(:,:,:), optional :: data_3d

      !  if data_2d or data_3d is specified-- it is desirable to specify
      !  a grid which corresponds to the 1st dimension of the data (default
      !  0, meaning no grid was specified).

      integer, intent(in), optional :: gridId1

      !  if data_3d is specified-- it is desirable to specify a grid which
      !  corresponds to the 2nd dimension of the data 

      integer, intent(in), optional :: gridId2
      
      !  (the actual data_2d or data_3d array dimensions will be one less 
      !  than the corresponding grid sizes, for zone oriented "binned" data).

      !-------------------
      !  normalization code
      !     0 - none -- default -- no information
      !    -1 - divide by vol(...) to get a density
      !    +1 - multiply by vol(...) to integrate a density
      !    +2 -- multiply by vol(...)*d[grid1]*d[grid2]/2 (FBM normalization)
      
      integer, intent(in), optional :: normcode

      !-----------------
      character*(*), intent(in), optional :: label
      character*(*), intent(in), optional :: units

      !---------------------------------------------------
      integer :: icount,irank,isizp,idims(3),isize_all,iertmp
      integer :: nzons,nzons_ext,nzrow_ext,ii,jj,kk,iadr,itot,ir,kth
      real*8, dimension(:), pointer :: r8buf
      integer :: intbuf(15)
      integer, dimension(:), allocatable :: nths
      character*120 zmsg
      logical :: udsym,istart0,ccwflag,pishift,reverse
      !---------------------------------------------------

      ierr=0

      call xplasma_mcgrid_info(s,id_mcgrid,iertmp, &
           udsym=udsym,nzons=nzons,nzons_ext=nzons_ext,nzrow_ext=nzrow_ext)
      if(iertmp.ne.0) then
         call xplasma_errmsg_append(s,' ?xplasma_mcgrid: valid MCgrid ID must be provided.')
         ierr=iertmp
      endif

      icount=0

      if(present(data_1d)) then
         irank=0
         isizp=size(data_1d)
         icount=icount + 1
         isize_all=isizp
      endif

      if(present(data_2d)) then
         irank=1
         isizp=size(data_2d,2)
         idims(1)=size(data_2d,1)
         icount = icount + 1
         isize_all = isizp*idims(1)
      endif

      if(present(data_3d)) then
         irank=2
         isizp=size(data_3d,3)
         idims(1)=size(data_3d,1)
         idims(2)=size(data_3d,2)
         icount = icount + 1
         isize_all = isizp*idims(1)*idims(2)
      endif

      if(icount.eq.0) then
         ierr = 9999
         call xplasma_errmsg_append(s, &
              ' ?xplasma_mcgrid_putobj: no input data provided.')
         call xplasma_errmsg_append(s, &
              '  one of the arguments "data_1d", "data_2d", or "data_3d" must be provided.')

      else if(icount.gt.1) then
         ierr = 9999
         call xplasma_errmsg_append(s, &
              ' ?xplasma_mcgrid_putobj: multiple input data objects provided.')
         call xplasma_errmsg_append(s, &
              '  only one of the arguments "data_1d", "data_2d", "data_3d" can be provided.')

      endif

      if(ierr.ne.0) return

      if((isizp.ne.nzons).and.(isizp.ne.nzons_ext)) then
         ierr=9999
         zmsg=' '
         write(zmsg,*) &
              ' ?xplasma_mcgrid_putobj: MCgrid sizes (in plasma, total): ', &
              nzons,nzons_ext
         call xplasma_errmsg_append(s,zmsg)

         zmsg=' '
         write(zmsg,*) &
              '  data object grid dimension: ',isizp,' does not match.'
         call xplasma_errmsg_append(s,zmsg)
         return
      endif

      intbuf = 0
      intbuf(1)=id_mcgrid
      intbuf(2)=isizp
      intbuf(3)=irank
      if(irank.gt.0) then
         intbuf(4:4+irank-1)=idims(1:irank)
      endif

      if(irank.ge.1) then
         if(present(gridId1)) intbuf(10)=gridId1

         if(irank.ge.2) then
            if(present(gridId2)) intbuf(11)=gridId2
         endif
      endif

      if(present(normcode)) intbuf(15)=normcode

      !  create storage for this data...

      call xplasma_create_blackbox(s,pname,xplasma_bbftype,id_p,ierr, &
           iarray=intbuf, r8asize=isize_all, &
           label=label, units=units, r8a_ptr=r8buf)
      if(ierr.ne.0) return

      allocate(nths(nzrow_ext))
      call xplasma_mcgrid_info(s,id_mcgrid,iertmp,nths=nths)

      ccwflag=.TRUE.
      if(present(ccwflag_th)) ccwflag=ccwflag_th

      if(udsym) then
         istart0=.TRUE.
         if(present(lstart0_th)) istart0=lstart0_th
         pishift=.FALSE.
         reverse=.not.istart0
      else
         istart0=.FALSE.
         if(present(lstart0_th)) istart0=lstart0_th
         pishift=istart0
         reverse=.not.ccwflag
      endif

      itot=0
      do ir=1,nzrow_ext
         if(itot.eq.isizp) exit

         do kk=1,nths(ir)
            kth=kk
            if(pishift) then
               kth=kth+nths(ir)/2
               if(kth.gt.nths(ir)) kth=kth-nths(ir)
            endif
            if(reverse) then
               kth=nths(ir)+1-kth
            endif

            if(present(data_1d)) then
               r8buf(itot+kk)=data_1d(itot+kth)

            else if(present(data_2d)) then
               iadr=itot*idims(1)
               do jj=1,idims(1)
                  r8buf(iadr+idims(1)*(kk-1)+jj)=data_2d(jj,itot+kth)
               enddo

            else if(present(data_3d)) then
               iadr=itot*idims(1)*idims(2)
               do jj=1,idims(2)
                  do ii=1,idims(1)
                     r8buf(iadr+idims(1)*idims(2)*(kk-1)+idims(1)*(jj-1)+ii)=&
                          data_3d(ii,jj,itot+kth)
                  enddo
               enddo
               
            endif
         enddo
         itot=itot+nths(ir)

      enddo

      deallocate(nths)
      nullify(r8buf)

    end subroutine xplasma_mcgrid_putobj

    subroutine xplasma_mcgrid_getobj(s,id_p,ierr, &
         lstart0_th,ccwflag_th, &
         data_1d,data_2d,data_3d,name,label,units,author)

      !  retrieve previously stored MCgrid profile
      !  (see xplasma_mcgrid_putobj)

      type (xplasma), pointer :: s
      integer, intent(in) :: id_p  ! MCgrid profile ID
      integer, intent(out) :: ierr ! exit status code (0=OK)

      ! theta indexing options
      logical, intent(in), optional :: lstart0_th ! default depends on symmetry
      logical, intent(in), optional :: ccwflag_th ! default: T

      ! lstart0_th=T means user's first theta zone lower bdy is 0; F means it
      ! is -pi.  If defaulted: updown symmetric data assumed to start at 0;
      ! updown asymmetric data assumed to start at -pi.

      ! ccwflag_th=T means zone index increases as one goes along a row of
      ! zones at fixed radial index in a counter-clockwise direction; F means
      ! the opposite.

      ! NOTE: similar options for phi mapping could be defined but that has
      ! not yet been done; may be an issue if/when we get beyond axisymmetry
      ! in XPLASMA...

      !-----------------
      !  one of the optional arguments data_1d, data_2d, data_3d must
      !  be provided to receive the data.

      !  the provided data array sizes must match the stored data.

      real*8, dimension(:), intent(out), optional :: data_1d
      real*8, dimension(:,:), intent(out), optional :: data_2d
      real*8, dimension(:,:,:), intent(out), optional :: data_3d

      !-----------------
      character*(*), intent(out), optional :: name
      character*(*), intent(out), optional :: label
      character*(*), intent(out), optional :: units
      character*(*), intent(out), optional :: author

      !---------------------------------------------------
      integer :: icount,irank,isizp,idims(3),isize_all,ipages,ipaged,iertmp
      integer :: nzons,nzons_ext,ii,jj,kk,kth,ir,iadr,itype,isize_r8,isize_int
      integer :: isizd,ialloc,ip

      real*8, dimension(:), pointer :: r8a_ptr,r8b_ptr

      integer :: id_mcgrid,nzrow_ext,itot
      integer, dimension(:), allocatable :: nths
      integer, dimension(:), pointer :: ia_ptr
      character*120 zmsg
      character*32 zname
      logical :: udsym,ccwflag,istart0,pishift,reverse
      !---------------------------------------------------

      ialloc=0
      ierr=0

      call xplasma_blackBox_info(s,id_p,iertmp, type=itype, name=zname, &
           isize=isize_int, r8size=isize_r8)

      if(iertmp.ne.0) then
         ierr=iertmp
      else
         if(itype.ne.xplasma_bbftype) then
            ierr=9999
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_mcgrid_getobj: id not for a MCgrid profile: '// &
                 trim(zname))
         endif
      endif

      if(present(name)) name=' '
      if(present(label)) label=' '
      if(present(units)) units=' '
      if(present(author)) author=' '

      icount=0

      if(present(data_1d)) then
         irank=0
         isizp=size(data_1d)
         icount=icount + 1
         isize_all=isizp
         ipages=1
      endif

      if(present(data_2d)) then
         irank=1
         isizp=size(data_2d,2)
         idims(1)=size(data_2d,1)
         icount = icount + 1
         ipages=idims(1)
         isize_all = isizp*ipages
      endif

      if(present(data_3d)) then
         irank=2
         isizp=size(data_3d,3)
         idims(1)=size(data_3d,1)
         idims(2)=size(data_3d,2)
         icount = icount + 1
         ipages=idims(1)*idims(2)
         isize_all = isizp*ipages
      endif

      if(icount.eq.0) then
         ierr = 9999
         call xplasma_errmsg_append(s, &
              ' ?xplasma_mcgrid_getobj: no output data array provided.')
         call xplasma_errmsg_append(s, &
              '  one of the arguments "data_1d", "data_2d", or "data_3d" must be provided.')

      else if(icount.gt.1) then
         ierr = 9999
         call xplasma_errmsg_append(s, &
              ' ?xplasma_mcgrid_getobj: multiple output data arrays provided.')
         call xplasma_errmsg_append(s, &
              '  only one of the arguments "data_1d", "data_2d", "data_3d" can be provided.')

      endif

      if(ierr.ne.0) return

      call xplasma_blackBox_retrieve(s,id_p,ierr, &
           ia_ptr=ia_ptr,r8a_ptr=r8a_ptr)

      if(ierr.ne.0) return

      id_mcgrid=ia_ptr(1)
      isizd=ia_ptr(2)

      if(irank.ne.ia_ptr(3)) then
         ierr=9999
         call xplasma_errmsg_append(s, &
              ' ?xplasma_mcgrid_getobj: rank mismatch in data.')

         zmsg=' '
         write(zmsg,*) '  item "'//trim(zname)//'" rank is: ',ia_ptr(3), &
              ' (dimensionality per spatial grid pt.)'
         call xplasma_errmsg_append(s,zmsg)

         zmsg=' '
         write(zmsg,*) '  rank of passed array is: ',irank
         call xplasma_errmsg_append(s,zmsg)
      endif

      if(isize_all.eq.isize_r8) then

         r8b_ptr => r8a_ptr   ! size is correct

      else

         ipaged=1
         if(irank.eq.1) ipaged=ia_ptr(4)
         if(irank.eq.2) ipaged=ia_ptr(4)*ia_ptr(5)

         call xplasma_mcgrid_info(s,id_mcgrid,ierr, &
              nzons=nzons,nzons_ext=nzons_ext)

         if((isizp.ne.nzons).and.(isizp.ne.nzons_ext)) then

            ierr=9999

            call xplasma_errmsg_append(s, &
                 ' ?xplasma_mcgrid_getobj: size mismatch in data.')

            zmsg=' '
            write(zmsg,*) '  item "'//trim(zname)//'" size is: ',isize_r8
            call xplasma_errmsg_append(s,zmsg)

            zmsg=' '
            write(zmsg,*) '  size of passed array to receive data: ',isize_all
            call xplasma_errmsg_append(s,zmsg)

            zmsg=' '
            write(zmsg,*) '  rank of passed array to receive data: ',irank+1
            call xplasma_errmsg_append(s,zmsg)

            zmsg=' '
            write(zmsg,*) '  grid size implied by passed array: ',isizp
            call xplasma_errmsg_append(s,zmsg)

            zmsg=' '
            write(zmsg,*) '  available mcgrid sizes: ',nzons,nzons_ext
            call xplasma_errmsg_append(s,zmsg)

            if(present(data_1d)) data_1d=ZERO
            if(present(data_2d)) data_2d=ZERO
            if(present(data_3d)) data_3d=ZERO

         else if(ipages.ne.ipaged) then

            ierr=9999

            call xplasma_errmsg_append(s, &
                 ' ?xplasma_mcgrid_getobj: #data pts per grid pt not correct.')

            zmsg=' '
            write(zmsg,*) '  item "'//trim(zname)//'" has: ',ipaged, &
                 ' data pts per grid pt.'
            call xplasma_errmsg_append(s,zmsg)

            zmsg=' '
            write(zmsg,*) '  passed array has: ',ipages, &
                 ' data pts per grid pt.'
            call xplasma_errmsg_append(s,zmsg)

         else

            ialloc=1
            allocate(r8b_ptr(isizp*ipages))

            ii=0
            jj=0
            do ip=1,ipages
               r8b_ptr(ii+1:ii+isizp)=r8a_ptr(jj+1:jj+isizp)
               ii=ii+isizp
               jj=jj+isizd
            enddo
         endif
      endif

      if(present(name)) call xplasma_get_item_info(s,id_p,iertmp,name=name)
      if(present(label)) call xplasma_get_item_info(s,id_p,iertmp,label=label)
      if(present(units)) call xplasma_get_item_info(s,id_p,iertmp,units=units)
      if(present(author)) call xplasma_get_item_info(s,id_p,iertmp,author=author)

      if(ierr.ne.0) then
         if(present(data_1d)) data_1d=ZERO
         if(present(data_2d)) data_2d=ZERO
         if(present(data_3d)) data_3d=ZERO

      else
         call xplasma_mcgrid_info(s,id_mcgrid,iertmp, udsym=udsym, &
              nzrow_ext=nzrow_ext)
         allocate(nths(nzrow_ext))
         call xplasma_mcgrid_info(s,id_mcgrid,iertmp, nths=nths)

         ccwflag=.TRUE.
         if(present(ccwflag_th)) ccwflag=ccwflag_th

         if(udsym) then
            istart0=.TRUE.
            if(present(lstart0_th)) istart0=lstart0_th
            pishift=.FALSE.
            reverse=.not.istart0
         else
            istart0=.FALSE.
            if(present(lstart0_th)) istart0=lstart0_th
            pishift=istart0
            reverse=.not.ccwflag
         endif

         itot=0
         do ir=1,nzrow_ext
            if(itot.eq.isizp) exit

            do kk=1,nths(ir)
               kth=kk
               if(pishift) then
                  kth=kth+nths(ir)/2
                  if(kth.gt.nths(ir)) kth=kth-nths(ir)
               endif
               if(reverse) then
                  kth=nths(ir)+1-kth
               endif
               
               if(present(data_1d)) then
                  data_1d(itot+kth)=r8b_ptr(itot+kk)
               else if(present(data_2d)) then
                  iadr=itot*idims(1)
                  do jj=1,idims(1)
                     data_2d(jj,itot+kth)=r8b_ptr(iadr+idims(1)*(kk-1)+jj)
                  enddo
               else if(present(data_3d)) then
                  iadr=itot*idims(1)*idims(2)
                  do jj=1,idims(2)
                     do ii=1,idims(1)
                        data_3d(ii,jj,itot+kth)= &
                             r8b_ptr(iadr+idims(1)*idims(2)*(kk-1) + &
                             idims(1)*(jj-1)+ii)
                     enddo
                  enddo
               endif

            enddo
            itot=itot+nths(ir)
         enddo
         deallocate(nths)
      endif

      if(ialloc.eq.1) deallocate(r8b_ptr)
      nullify(r8a_ptr,r8b_ptr)

    end subroutine xplasma_mcgrid_getobj

end module xplasma_mcgrid

      subroutine eqxyz_bget(ivec,xx,yy,zz,ztol,bvec,nregion,ierr)
C
c  vectorized interpolation routine.
c  get (Bx,By,Bz) vector @ (x,y,z)
c
c      since this involves an inverse map to (rho,chi,phi)
c      a relative accuracy tolerance is required.
c
c      inverse map results not returned.
C
C  transform to (R,Z,phi), get BR,BZ,Bphi
C  then transform back to Bx,By,Bz
C
      IMPLICIT NONE
c
c  input:
      integer ivec                      ! vector dimensioning
      REAL*8 xx(ivec),yy(ivec),zz(ivec) ! (x,y,z) location
      REAL*8 ztol                       ! rel. tol. for x,y,z -> flux coords
C
C  output:
      REAL*8 bvec(3,ivec)               ! B vector (Bx,By,Bz)
C
      integer nregion(ivec)             ! region code for (x,y,z) (cf eq_xinv).
      integer ierr                      ! completion code, 0=OK
C
C--------------------------
C
      REAL*8 zrho(ivec),zchi(ivec),zphi(ivec) ! (rho,chi,[phi]) (flux coords)
      real*8 zR(ivec),zdum,btmp(3),zcosphi,zsinphi
      integer iv
C
C--------------------------
C
      call eqxyzmap_bget(ivec,xx,yy,zz,zrho,zchi,zphi,ztol,
     >   bvec,nregion,ierr)
C
      return
      end
C----------------------------------------------------------------------
      subroutine eqxyzmap_bget(ivec,xx,yy,zz,zrho,zchi,zphi,ztol,
     >   bvec,nregion,ierr)
c
c  vectorized interpolation routine.
c  get (Bx,By,Bz) vector @ (x,y,z)
c
c      since this involves an inverse map to (rho,chi,phi)
c      a relative accuracy tolerance is required.
c
c      inverse map results are returned.
C
C  transform to (R,Z,phi), get BR,BZ,Bphi
C  then transform back to Bx,By,Bz
C
      implicit NONE
c
c  input:
      integer ivec                      ! vector dimensioning
      REAL*8 xx(ivec),yy(ivec),zz(ivec) ! (x,y,z) location
      REAL*8 zrho(ivec),zchi(ivec),zphi(ivec) ! (rho,chi,[phi]) (flux coords)
      REAL*8 ztol                       ! rel. tol. for x,y,z -> flux coords
C
C  output:
      REAL*8 bvec(3,ivec)               ! B vector (Bx,By,Bz)
C
      integer nregion(ivec)             ! region code for (x,y,z) (cf eq_xinv).
      integer ierr                      ! completion code, 0=OK
c
C-----------------------------------------
c
      integer iv
      real*8 zR(ivec),zcosphi,zsinphi,btmp(3)
c
c-----------------------------------------
c
C  transform to cylindric coords
      call eq_rcyl(ivec,xx,yy,zR,zphi)
C
C  get vectors
      call eqrzmap_bget(ivec,zR,zZ,zphi,zrho,zchi,ztol,
     >   bvec,nregion,ierr)
C
C  map (R,Z,phi) vectors to (x,y,z) system
C
      do iv=1,ivec
         zcosphi=cos(zphi(iv))
         zsinphi=sin(zphi(iv))
C
C  back transform B field
C
         btmp(3)=bvec(2,iv)
         btmp(1)=bvec(1,iv)*zcosphi -bvec(3,iv)*zsinphi
         btmp(2)=bvec(1,iv)*zsinphi +bvec(3,iv)*zcosphi
C
         bvec(1:3,iv)=btmp
      enddo
C
      return
      end
C---------------------------------------------------------------------
      subroutine eqxyz_bgrad(ivec,xx,yy,zz,ztol,bvec,gbtensr,nregion,
     >   ierr)
C
c  vectorized interpolation routine.
c  get (Bx,By,Bz) vector @ (x,y,z)
c
c      since this involves an inverse map to (rho,chi,phi)
c      a relative accuracy tolerance is required.
c
c      inverse map results not returned.
C
C  transform to (R,Z,phi), get BR,BZ,Bphi
C  then transform back to Bx,By,Bz
C
      IMPLICIT NONE
c
c  input:
      integer ivec                      ! vector dimensioning
      REAL*8 xx(ivec),yy(ivec),zz(ivec) ! (x,y,z) location
      REAL*8 ztol                       ! rel. tol. for x,y,z -> flux coords
C
C  output:
      REAL*8 bvec(3,ivec)               ! B vector (Bx,By,Bz)
      REAL*8 gbtensr(3,3,ivec)          ! gbtensor(i,j)=d[bvec(j)]/d[x,y,z]
C
      integer nregion(ivec)             ! region code for (x,y,z) (cf eq_xinv).
      integer ierr                      ! completion code, 0=OK
C
C--------------------------
C
      REAL*8 zrho(ivec),zchi(ivec),zphi(ivec) ! (rho,chi,[phi]) (flux coords)
      real*8 zR(ivec),zdum,btmp(3),zcosphi,zsinphi
      integer iv
C
C--------------------------
C
      call eqxyzmap_bgrad(ivec,xx,yy,zz,zrho,zchi,zphi,ztol,
     >   bvec,gbtensr,nregion,ierr)
C
      return
      end
C---------------------------------------------------------------------
      subroutine eqxyzmap_bgrad(ivec,xx,yy,zz,zrho,zchi,zphi,ztol,
     >   bvec,gbtensr,nregion,ierr)
C
C  **Vectorized**
C  get vector B(x,y,z) and tensor grad(Bx)/grad(By)/grad(Bz)
C
C  transform to (R,Z,phi), get BR,BZ,Bphi and the gradient in this space,
C  then transform back to (x,y,z)
C
      IMPLICIT NONE
c
c  input:
      integer ivec                      ! vector dimensioning
      REAL*8 xx(ivec),yy(ivec),zz(ivec) ! (x,y,z) location
      REAL*8 ztol                       ! rel. tol. for x,y,z -> flux coords
C
C  output:
      REAL*8 zrho(ivec),zchi(ivec),zphi(ivec) ! (rho,chi,[phi]) (flux coords)
      REAL*8 bvec(3,ivec)               ! B vector (Bx,By,Bz)
      REAL*8 gbtensr(3,3,ivec)          ! gbtensor(i,j)=d[bvec(j)]/d[x,y,z]
C
      integer nregion(ivec)             ! region code for (x,y,z) (cf eq_xinv).
      integer ierr                      ! completion code, 0=OK
C
C--------------------------
C
      real*8 zR(ivec),zdum
C
C--------------------------
C  transform to cylindric coords
      call eq_rcyl(ivec,xx,yy,zR,zphi)
C
C  get vectors
      call eqrzmap_bgrad(ivec,zR,zZ,zphi,zrho,zchi,ztol,
     >   bvec,gbtensr,nregion,ierr)
C
C  map (R,Z,phi) vectors to (x,y,z) system
C
      if(ierr.eq.0) then
         call eqi_rzxvec(ivec,zR,zZ,zphi,1,bvec,gbtensr,
     >      0,ivec,zdum,zdum)
      endif
C
      return
      end

      subroutine eq_ident(eqmodel_o,axisymm_o,scrapeoff_o)
C
      use xplasma_obj_instance
      use eq_module
C
C  return identification of equilibrium data model as currently stored
C
      IMPLICIT NONE
C
      character*(*) eqmodel_o           ! name of model
      integer axisymm_o                 ! axisymmetry flag, =1 for axisymmetry
      integer scrapeoff_o               ! scrapeoff flag, =1: scrapeoff layer
C
C-----------------------------------
      integer :: ier
      logical :: flag
C-----------------------------------
C
      call xplasma_global_info(s,ier, initLabel=eqmodel_o)
      if(ier.ne.0) then
         write(lunerr,*) ' %eq_ident error (xplasma) ier=',ier
         call xplasma_error(s,ier,lunerr)
         axisymm_o=1
         scrapeoff_o=0
      else
         call xplasma_global_info(s,ier,axisymm=flag)
         if(flag) then
            axisymm_o=1
         else
            axisymm_o=0
         endif
         call xplasma_global_info(s,ier,scrapeoff=flag)
         if(flag) then
            scrapeoff_o=1
         else
            scrapeoff_o=0
         endif
      endif
C
      return
      end

      SUBROUTINE MCRDR_RDSS(LUN,LINE,SUBSTR,INSUB,IEOF)
C
C  READ TO FIRST LINE CONTAINING "SUBSTR", EOF CHECK
C
      CHARACTER*(*) LINE
      CHARACTER*(*) SUBSTR
C
      IEOF=0
 10   CONTINUE
      CALL MCRDR_READ(LUN,LINE,IEOF)
      IF(IEOF.EQ.1) GO TO 20
C
      INSUB=INDEX(LINE,SUBSTR)
      IF(INSUB.EQ.0) GO TO 10
C
 20   CONTINUE
C
      RETURN
      END

subroutine eqx_inv(ivec,xx,yy,zz,tol,zrho,zchi,zphi,nregion,ierr)

  !  **vectorized**
  !  mapping:  (x,y,z) -> (R,Z,phi) -> (rho,chi,phi)

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  !  sign of ivec indicates chi reversal.  set ivec = -[# of pts] for the
  !  poloidal angle orientation to be reversed, i.e. tracing clockwise along
  !  a flux surface drawn to the right of the machine centerline...

  integer ivec                      ! vector dimension:  # of pts
  real*8 xx(abs(ivec)),yy(abs(ivec)),zz(abs(ivec)) ! input (x,y,z) target pts
  REAL*8 tol                        ! input relative error tolerance

  REAL*8 zrho(abs(ivec)),zchi(abs(ivec)) ! output (rho,chi) flux coordinates
  real*8 zphi(abs(ivec))                 ! output (phi) toroidal angle
  integer nregion(abs(ivec))             ! output region code

  integer ierr                      ! output error code

  !  on output,
  !     nregion(i) = 1 means:  rho_axis.le.rho.le.rho_bdy (core plasma)
  !     nregion(i) = 2 means:  rho_bdy.lt.rho.le.rho_vac (SOL)
  !     nregion(i) = 3 means:  rho.gt.rho_vac or rho.lt.rho_axis, out of bounds

  !      ierr.ne.0 means a serious error occurred.

  !------------------------
  real*8 zR(abs(ivec))
  !------------------------

  call eq_rcyl(abs(ivec),xx,yy,zR,zphi)
  call eq_inv(ivec,zR,zZ,zphi,tol,zrho,zchi,nregion,ierr)

end subroutine eqx_inv

!-----------------------------------------------------------------
subroutine eq_inv(ivec,zR,zZ,zphi,tol,zrho,zchi,nregion,ierr)

  !  **vectorized**
  !  mapping:  (R,Z,phi) -> (rho,chi,phi)

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  !  sign of ivec indicates chi reversal.  set ivec = -[# of pts] for the
  !  poloidal angle orientation to be reversed, i.e. tracing clockwise along
  !  a flux surface drawn to the right of the machine centerline...

  integer ivec
  REAL*8 zR(abs(ivec)),zZ(abs(ivec)),zphi(abs(ivec)) ! input (R,Z,phi) target
  REAL*8 tol                             ! input relative error tolerance

  !  if tol.gt.1.0d-3 use maptype=2 approximation; otherwise use maptype=1
  !  which is slower but more accurate.

  REAL*8 zrho(abs(ivec)),zchi(abs(ivec)) ! output (rho,chi) flux coords.

  !  on input, if the fast inverse map is disabled, (R,Z,phi) contains the
  !  initial guess.  a good initial guess improves performance, but is
  !  not required for accurate results.

  integer nregion(abs(ivec))             ! output region code
  integer ierr                           ! output error code; 0=OK

  !  on output,
  !      nregion = 1 means:  rho_axis.le.rho.le.rho_bdy
  !      nregion = 2 means:  rho_bdy.lt.rho.le.rho_vac
  !      nregion = 3 or 4 means:  rho.gt.rho_vac or rho.lt.rho_axis

  !   ierr .ne. zero means a serious error in the code
  !--------------------------------------------------------------
  logical :: iccw
  integer :: imaptype
  !--------------------------------------------------------------

  iccw = ivec.gt.0

  if(tol.ge.1.0d-3) then
     imaptype=xp_imap_polar
  else
     imaptype=xp_imap_newton
  endif

  call xplasma_ctrans(s,xp_use_coord_vecsize,ierr, &
       R_in=zR, z_in=zZ, phi_in=zphi, ccw_theta = iccw, i2pi=2, &
       maptype = imaptype, &
       tol=tol, rho_out=zrho, theta_out=zchi, nregion=nregion)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_inv: error in xplasma_ctrans:'
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_inv

subroutine eqi_geq_axis_zsrch(ivec,iok,Z,dPsidZ,ivecd, &
     zinput,ninput,zoutput,noutput)

  ! see comput/zridderx.for -- root finder functional
  ! return Z s.t. dPsidZ=0, along fixed R (see eqi_geq_axis_Rsrch.f90)

  use eqi_geq_axis_data
  implicit NONE

  !-----------------------------

  integer,intent(in) :: ivec
  logical,intent(in) :: iok(ivec)
  real*8, intent(in) :: Z(ivec)
  real*8,intent(out) :: dPsidZ(ivec)

  integer,intent(in) :: ivecd
  integer,intent(in) :: ninput,noutput
  real*8, intent(in) :: zinput(ivecd,ninput)      ! not used
  real*8, intent(inout) :: zoutput(ivecd,noutput) ! not used

  !-----------------------------
  !  local...

  real*8 :: zspl_data(1,1)
  integer :: ifail,idum

  integer :: ict_Zsrch(6) = (/ 0, 0, 1, 0, 0, 0 /)
  !-----------------------------
  !  expecting ivec=1 !!!

  if(ivec.ne.1) call errmsg_exit(' ?? eqi_geq_axis_zsrch: ivec=1 expected !! ')

  call xlookup(1,Z,size(zpkg,1),zpkg,2,jj,zparam,hz,hzi,idum)
  
  ! evaluate spline for dpsi/dR

  call fvbicub(ict_Zsrch,1,1, &
       zspl_data,ii,jj,rparam,zparam,hr,hri,hz,hzi, &
       psirz_spl,size(psirz_spl,2),size(psirz_spl,3))

  dPsidZ = zspl_data(1,1)

end subroutine eqi_geq_axis_zsrch

! 30Nov1999 fgtok -s r8_precision.sub r8bloat_names.sub "r8con.csh conversion"
      subroutine r8tksbcon(xiblo,rmb0,mtbl,rmb2,ymb2,mimom,nmom,
     >                   jzb,jzb0,ziter)
C
C  control routine for Fourier Moments surface extrapolation,
C  up-down symmetry assumed.  Arguments have same meanings as in caller
C  bloats.for, plus:
C
C   jzb -- extrapolated surface to compute now
C   jzb0 -- 1st extrapolated surface
C   ziter -- numerical control
C
C  DMC mod-- constrain # of moments in extrapolation (bugfix for stability)
C            use new local variable "inmom"
C
C  passed:
C============
C idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      INTEGER mimom,nmom,jzb,jzb0,mtbl,locmax,ics,im,ii,isurf0,iter
      INTEGER inmom
C============
C idecl:  explicitize implicit REAL declarations:
      REAL*8 ziter
C============
      REAL*8 xiblo(mtbl),rmb0(mtbl)
      REAL*8 rmb2(mtbl,mimom),ymb2(mtbl,mimom)
C
C  local:  storage for 3 surfaces worth of moments...
      parameter (locmax=64)
      REAL*8 zrmc(3,0:locmax,2)
      REAL*8 zymc(3,0:locmax,2)
C
      logical nlsym
      data nlsym/.true./
C
C--------------------------------------------
C
      if(mimom.gt.locmax)
     >   call errmsg_exit('tksbcon:  locmax too small!')
C
C  copy in
C
      do ics=1,2
         do im=0,nmom
            do ii=1,3
               zrmc(ii,im,ics)=0.0E0_R8
               zymc(ii,im,ics)=0.0E0_R8
            enddo
         enddo
      enddo
C
      isurf0=jzb-3
      do ii=1,2
         zrmc(ii,0,1)=rmb0(isurf0+ii)
         inmom=nmom
         if(isurf0+ii.ge.jzb0) inmom=min(16,inmom)
         if(isurf0+ii.ge.jzb0+2) inmom=min(8,inmom)
         do im=1,inmom
            zrmc(ii,im,1)=rmb2(isurf0+ii,im)
            zymc(ii,im,2)=ymb2(isurf0+ii,im)
         enddo
      enddo
C
      iter=jzb-jzb0
      call r8tkbcon(nlsym,xiblo,jzb,zrmc,zymc,locmax,inmom,iter,ziter)
C
C  copy back
C
      rmb0(jzb)=zrmc(3,0,1)
      do im=1,nmom
         rmb2(jzb,im)=zrmc(3,im,1)
         ymb2(jzb,im)=zymc(3,im,2)
      enddo
C
      return
      end
 
 

subroutine eqi_rzdist(ivec,zR,zZ,zphi,zdist, &
     ilim_type,iwork,r8work, &
     ilpt,rlim,zlim,philim, ierr)

  !  **vectorized**
  !  compute distance from mechanical limiter: .gt.0 means outside 
  !  .lt.0 means inside, # gives actual distance in (R,Z) units
  !  relative to nearest limiting object.

  !  if switch is set, also return coordinates of nearest contact
  !  point on the limiting object.

  implicit NONE

  !  input:

  integer ivec                      ! vector dimension
  real*8 zR(ivec),zZ(ivec),zphi(ivec) ! location

  integer :: ilim_type              ! type of limiter
  !  100= contour limiter; 101= "circles and lines" limiter

  integer :: iwork(6)               ! limiter data pointers
  real*8 :: r8work(*)               ! limiter data

  integer ilpt                      ! =1 to calculate nearest limiter pt

  !  output:
  real*8 zdist(ivec)                ! signed distance from bdy/limiter
  integer ierr                      ! completion code, 0=OK

  real*8 rlim(*),zlim(*),philim(*)  ! (1:ivec) if used:
                 ! nearest limiter contact pt

  !---------------------------------------------------
  real*8 zdist0(ivec)
  real*8 zrlim(ivec),zzlim(ivec),zphilim(ivec)
  integer i,iv,j,iadr,iadz,imin
  real*8 zrnex,zznex,zrcur,zzcur
  real*8 ztest(ivec),zdsum,zdis2(ivec),zdl2nex
  real*8 zrsave(ivec),zzsave(ivec)

  integer :: ilines,icircs,iadrl,iadrc

  real*8, parameter :: czero = 0.0d0
  !---------------------------------------------------

  ierr = 0

  if((ilim_type.lt.100).or.(ilim_type.gt.101)) then
     ierr=9999
     return
  endif

  iadrl =iwork(1)
  ilines=iwork(4)

  iadrc =iwork(2)
  icircs=iwork(5)

  if(ilim_type.eq.101) then

     !  circles and lines...

     if(ilpt.eq.1) then
        philim(1:ivec)=zphi
     endif

     zdist=-1.0d30

     iadr=iadrc
     do i=1,icircs
        call eqi_rzdist_c(ivec,r8work(iadr),zR,zZ,zdist0,ilpt,zrlim,zzlim)
        do iv=1,ivec
           if(zdist0(iv).gt.zdist(iv)) then
              zdist(iv)=zdist0(iv)
              if(ilpt.eq.1) then
                 rlim(iv)=zrlim(iv)
                 zlim(iv)=zzlim(iv)
              endif
           endif
        enddo
        iadr=iadr+4
     enddo

     iadr=iadrl
     do i=1,ilines
        call eqi_rzdist_l(ivec,r8work(iadr),zR,zZ,zdist0,ilpt,zrlim,zzlim)
        do iv=1,ivec
           if(zdist0(iv).gt.zdist(iv)) then
              zdist(iv)=zdist0(iv)
              if(ilpt.eq.1) then
                 rlim(iv)=zrlim(iv)
                 zlim(iv)=zzlim(iv)
              endif
           endif
        enddo
        iadr=iadr+6
     enddo

  else if(ilim_type.eq.100) then

     !  axisymmetric piecewise linear limiter description

     if(ilpt.eq.1) then
        philim(1:ivec)=zphi
     endif

     !  find nearest segment where closest approach of point to infinite
     !  extension of segment is on the segment

     zdis2=1.0d30
     do i=1,ilines-1
        iadr=iadrl+6*(i-1)
        zrcur=r8work(iadr)
        zzcur=r8work(iadr+1)
        zrnex=r8work(iadr+6)
        zznex=r8work(iadr+7)
        zdl2nex=(zrnex-zrcur)**2+(zznex-zzcur)**2

        call eqi_rzdist_l(ivec,r8work(iadr),zR,zZ,zdist,1,zrlim,zzlim)

        do iv=1,ivec
           ztest(iv)=max( &
                ((zRlim(iv)-zRcur)**2+(zZlim(iv)-zZcur)**2), &
                ((zRlim(iv)-zRnex)**2+(zZlim(iv)-zZnex)**2))

           if(ztest(iv).le.zdl2nex) then

              !  qualifying segment

              if(abs(zdist(iv)).lt.abs(zdis2(iv))) then
                 zdis2(iv)=zdist(iv)
                 zrsave(iv)=zrlim(iv)
                 zzsave(iv)=zzlim(iv)
              endif
           endif
        enddo

     enddo

     do iv=1,ivec
        zdist(iv)=zdis2(iv)
        zdis2(iv)=zdist(iv)*zdist(iv)

        !  find nearest endpoint

        imin=0
        do j=2,ilines
           iadr=iadrl+6*(j-1)
           iadz=iadr+1
           zdist0(iv)=(zR(iv)-r8work(iadr))**2+(zZ(iv)-r8work(iadz))**2
           if(zdist0(iv).lt.zdis2(iv)) then
              imin=j
              zdis2(iv)=zdist0(iv)
           endif
        enddo

        if(imin.eq.0) then

           !  segment was closest

           zrlim(iv)=zrsave(iv)
           zzlim(iv)=zzsave(iv)

        else

           !  endpoint was closest

           zdsum=czero
           iadr=iadrl+6*(imin-2)
           call eqi_rzdist_l(1,r8work(iadr),zR(iv),zZ(iv),zdist(iv), &
                0,zrlim(iv),zzlim(iv))
           zdsum=zdsum+zdist(iv)
           iadr=iadr+6
           call eqi_rzdist_l(1,r8work(iadr),zR(iv),zZ(iv),zdist(iv), &
                0,zrlim(iv),zzlim(iv))
           zdsum=zdsum+zdist(iv)

           if(zdsum.ge.czero) then
              zdist(iv)=sqrt(zdis2(iv))
           else
              zdist(iv)=-sqrt(zdis2(iv))
           endif

           zrlim(iv)=r8work(iadr)
           zzlim(iv)=r8work(iadr+1)

        endif
        if(ilpt.eq.1) then
           rlim(iv)=zrlim(iv)
           zlim(iv)=zzlim(iv)
        endif

     enddo

  endif

end subroutine eqi_rzdist

!------------------------
!  xplasma internal routines for eqi_rzdist
!------------------------

subroutine eqi_rzdist_c(ivec,zdata,zR,zZ,zdist,ilpt,zrlim,zzlim)

  !  distance parameter from a circular limiter

  implicit NONE

  !  input:
  integer ivec                      !vector dimension
  real*8 zdata(4)                   ! Rc,Zc,rad,sign
  real*8 zR(ivec),zZ(ivec)          ! points from which to eval distance

  integer ilpt                      ! =1 to calculate nearest limiter pt

  !  output:
  real*8 zdist(ivec)                ! (zR,zZ) distance from limiter

  real*8 zrlim(ivec),zzlim(ivec)    ! nearest limiter contact points

  !  if zdist.lt.0.0 the point is inside
  !  if zdist.gt.0.0 the point is outside
  !-------------------------

  integer iv
  real*8 zrad,zdr,zdz

  !-------------------------

  do iv=1,ivec
     zdr=zR(iv)-zdata(1)
     zdz=zZ(iv)-zdata(2)
     zrad=sqrt(zdr**2+zdz**2)
     zdist(iv)=zdata(4)*(zrad-zdata(3))

     if(ilpt.eq.1) then
        zrlim(iv)=zdata(1)+zdata(3)*(zdr/zrad)
        zzlim(iv)=zdata(2)+zdata(3)*(zdz/zrad)
     endif
  enddo

end subroutine eqi_rzdist_c

!------------------------
subroutine eqi_rzdist_l(ivec,zdata,zR,zZ,zdist,ilpt,zrlim,zzlim)

  !  distance parameter from a line limiter

  implicit NONE

  !  input:
  integer ivec                      ! vector dimension
  real*8 zdata(6)                   ! Rl,Zl,<normal-vec>,param,sign
  real*8 zR(ivec),zZ(ivec)          ! points in question

  integer ilpt                      ! =1 to calculate nearest limiter pt

  !  output:
  real*8 zdist(ivec)                ! (zR,zZ) distance from limiter
  
  real*8 zrlim(ivec),zzlim(ivec)    ! nearest limiter contact point

  !  if zdist.lt.0.0 the point is inside
  !  if zdist.gt.0.0 the point is outside
  !-------------------------

  integer iv
  real*8 ztest

  !-------------------------

  do iv=1,ivec
     ztest = zdata(3)*zR(iv)+zdata(4)*zZ(iv) - zdata(5)
     zdist(iv) = zdata(6)*ztest

     if(ilpt.eq.1) then
        zrlim(iv)=zR(iv)-zdata(3)*ztest
        zzlim(iv)=zz(iv)-zdata(4)*ztest
     endif
  enddo

end subroutine eqi_rzdist_l

subroutine eq_glimb1(rho,phi,b_min,chi_b_min,b_max,chi_b_max,ierr)

  use xplasma_obj_instance
  use eq_module

  !  find the minimum and maximum B on the given surface

  IMPLICIT NONE

  REAL*8 rho                        ! rho of surface (in)
  !  if a negative rho is supplied, reversed theta is implied!

  REAL*8 phi                        ! toroidal angle (in)
  REAL*8 b_min                      ! minimum mod(B) found (out)
  real*8 chi_b_min                  ! chi angle location of min(B)
  REAL*8 b_max                      ! maximum mod(B) found (out)
  real*8 chi_b_max                  ! chi angle location of max(B)
  integer ierr                      ! completion code, 0=OK

  real*8 rho_axis,rho_bdy,zrho

  logical :: axisymm,ccwflag
  real*8, parameter :: ZERO=0.0d0
  real*8, parameter :: ZTOL=1.0d-14
  !---------------------------

  call xplasma_global_info(s,ierr, axisymm=axisymm)
  if(ierr.ne.0) return

  if(.not.axisymm) then
     ierr=107
     call xplasma_error(s,ierr,lunerr)
     call eq_errmsg(' ?eq_glimb1:  non-axisymmetry not supported!')
     return
  endif

  ccwflag = rho.ge.ZERO
  zrho = abs(rho)

  call eq_rholim(rho_axis,rho_bdy)

  if(zrho.gt.rho_bdy+ZTOL) then
     call eq_errmsg(' ?eq_glimb1:  rho argument out of range:')
     write(lunerr,*) ' |rho|=',zrho,' rho_axis=',rho_axis,' rho_bdy=',rho_bdy
     ierr=9999
     return
  else
     zrho=min(rho_bdy,zrho)
  endif

  call xplasma_Bminmax(s,zrho,ierr, phi=phi, &
       ccw_theta=ccwflag, i2pi=2, bmin = B_min, bmax = B_max, &
       thbmin = chi_B_min, thbmax = chi_B_max)

end subroutine eq_glimb1

!******************** START FILE FILTER.FOR ; GROUP FILTR6 ******************
!
!  FILTER
!
!  USE LOCAL AVERAGING FUNCTION OF RADIUS DELTA
!
!  TO SMOOTH DATA CURVE.
!
!-----------------
SUBROUTINE r8filter(X,Y0,Y,N,DELTA,XEND1,XEND2)
  use iso_c_binding, only: fp => c_double
  implicit none
  ! Arguments
  integer, intent(in) :: n
  real(fp), dimension(n), intent(in)  :: x
  real(fp), dimension(n), intent(in)  :: y0
  real(fp), dimension(n), intent(out) :: y
  real(fp), dimension(n), intent(in)  :: delta
  real(fp), intent(in) :: xend1, xend2
  ! Local variables
  integer :: j,jlp
  real(fp), external :: r8filfn6
  !
  DO J=1,N
    JLP=J
    Y(J)=r8filfn6(X,Y0,N,JLP,DELTA,XEND1,XEND2,1)
  END DO
  !
  RETURN
END SUBROUTINE r8filter

subroutine eq_geqdsk(lun_geqdsk,geqdsk_lbl, &
     Rmin,Rmax,Zmin,Zmax,zcur, &
     id_p,id_q,nh,nv,nb,ierr)
  
  !  write GEQDSK file from xplasma module

  !  **correction** dmc 9 Nov 2001:
  !  follow Lang Lao sign convention for G-EQDSK files:
  !  -- psi always increasing
  !  -- direction of current specified in pcur scalar *only*

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)

  !  input:

  integer lun_geqdsk                ! logical unit where to write file

  character*48 geqdsk_lbl           ! 48 character label for GEQDSK file
  real*8 Rmin,Rmax                  ! (Rmin,Rmax) of Psi(R,Z)
  real*8 Zmin,Zmax                  ! (Zmin,Zmax) of Psi(R,Z)
  real*8 zcur                       ! plasma current (amps)

  !  [Rmin,Rmax]x[Zmin,Zmax] must contain the core plasma but not exceed the
  !  available (R,Z) grids.

  integer id_p                      ! xplasma id:  Pressure profile
  integer id_q                      ! xplasma id:  q profile

  integer nh                        ! #of GEQDSK horizontal pts
  integer nv                        ! #of GEQDSK vertical pts

  !  note nh also controls the number of pts in the 1d profiles

  integer nb                        ! #of pts in bdy contour

  !  output:

  integer ierr                      ! completion code (0=OK, file written).

  !------------------------------------------------------
  ! (old f77 xplasma eq_geqdsk code moved into core modules; most arguments
  ! made optional).

  call xplasma_wr_geqdsk(s,ierr, &
       lun_geqdsk=lun_geqdsk, label=geqdsk_lbl, &
       Rmin=Rmin, Rmax=Rmax, Zmin=Zmin, Zmax=Zmax, &
       cur=zcur, id_pprof=id_p, id_qprof=id_q, &
       nh=nh, nv=nv, nbdy=nb)

  if(ierr.ne.0) then
     write(lunerr,*) ' %eq_geqdsk: error in xplasma_wr_geqdsk:'
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_geqdsk

subroutine eq_geqdsk_ipq(lun_geqdsk,geqdsk_lbl,zcur,id_p,id_q,ierr)

  ! another version, with a simplified calling argument list:  I, P, Q...
  !  input:

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)

  integer lun_geqdsk                ! logical unit where to write file

  character*(*) geqdsk_lbl           ! 48 character label for GEQDSK file
  real*8 zcur                       ! plasma current (amps)

  integer id_p                      ! xplasma id:  Pressure profile
  integer id_q                      ! xplasma id:  q profile

  !  output:

  integer ierr                      ! completion code (0=OK, file written).

  !------------------------------------------------------
  ! (old f77 xplasma eq_geqdsk code moved into core modules; most arguments
  ! made optional).

  call xplasma_wr_geqdsk(s,ierr, &
       lun_geqdsk=lun_geqdsk, label=geqdsk_lbl, &
       cur=zcur, id_pprof=id_p, id_qprof=id_q)

  if(ierr.ne.0) then
     write(lunerr,*) ' %eq_geqdsk_ipq: error in xplasma_wr_geqdsk:'
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_geqdsk_ipq

subroutine eqi_inv(ivec,zR,zZ,zphi,reltol,rtol,zrho,zth,nregion,ierr)

  !  **vectorized**
  !  mapping:  (R,Z,phi) -> (rho,chi,phi)

  use xplasma_definitions
  use eqi_rzbox_module
  IMPLICIT NONE

  integer ivec
  REAL*8 zR(ivec),zZ(ivec),zphi(ivec) ! input (R,Z,phi) target
  REAL*8 reltol                       ! error tolerance (relative)
  REAL*8 rtol                         ! error tolerance, R,Z units.

  !  on input, (R,Z,phi) contains the
  !  initial guess.  a good initial guess improves performance, but is
  !  generally not required for accurate results.

  REAL*8 zrho(ivec),zth(ivec)       ! output (rho,theta,(phi unchanged))
  integer nregion(ivec)             ! input/output region code
  ! if fast map is in use: nregion(ivec)=3 means pt is outside RxZ rectangle...

  integer ierr                      ! output error code; 0=OK

  !  on output,
  !      nregion = 1 means:  rho_axis.le.rho.le.rho_bdy
  !      nregion = 2 means:  outside plasma but inside mapped region
  !         rho.gt.rho_bdy is returned at these points
  !      nregion = 3 means:  outside plasma and outside mapped region
  !         rho = rho_vac is returned at these points

  !   ierr .ne. zero means a serious error in the code
  !--------------------------------------------------------------

  integer i,jvec

  logical imask(ivec),iskipi,iskipo,iexact
  integer iregion(ivec)
  real*8 zR_use(ivec),zZ_use(ivec)
  real*8 zrho_use(ivec),zth_use(ivec),zphi_use(ivec),zdist(ivec)
  real*8 zth_bdy1(ivec),zphi_bdy1(ivec)
  real*8 :: zrho_bdy,zrho_plas,zrho_plus,zrho_minus
  real*8 :: rmin,rmax,zmin,zmax,zdnorm
  logical :: sol

  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: ONE = 1.0d0
  real*8, parameter :: EPS = 1.0d-15

  !--------------------------------------------------------------
  !  form vector of points that are not clearly outside...

  ierr=0

  call xplasma_RZminmax_extended(sp, rmin,rmax, zmin,zmax, ierr, sol=sol)
  if(ierr.ne.0) return

  zdnorm=max((rmax-rmin),(zmax-zmin))/2

  zrho_plas = ONE
  zrho_plus = zrho_plas+EPS
  zrho_minus = zrho_plas-EPS

  if(sol) then
     call eqi_extrap_rho_bdy(zrho_bdy)
  else
     zrho_bdy = ONE
  endif

  iskipi=.TRUE.
  iskipo=.FALSE.
  iexact=.TRUE.
  call eqi_bdfind(ivec,zR,zZ,zphi,zrho_bdy,iskipi,iskipo,iexact, &
       zth_use,zphi_use,zdist,ierr)

  if(ierr.ne.0) return

  do i=1,ivec

     if(zdist(i).ge.0.0d0) then
        imask(i)=.TRUE.
        zth(i)=zth_use(i)
        if(zdist(i).gt.0.0d0) then
           zrho(i)=zrho_bdy*(zdnorm+zdist(i))/zdnorm
           nregion(i)=3 ! beyond last surface
        else
           zrho(i)=zrho_bdy
           if(sol) then
              nregion(i)=2 ! at SOL bdy
           else
              nregion(i)=1 ! at plasma bdy
           endif
        endif

     else
        nregion(i)=1  ! may get corrected later...
        imask(i)=.FALSE.
        if(zrho(i).gt.zrho_plas) then
           zrho(i)=min(zrho_bdy,max(zrho_plus,zrho(i)))
        else
           zrho(i)=min(zrho_minus,zrho(i))
        endif

     endif
  enddo

  !  OK all with imask(i)=.FALSE. are in the mapped region and Newton
  !  search can proceed...

  jvec=0
  do i=1,ivec
     if(.not.imask(i)) then
        jvec=jvec+1
        zR_use(jvec)=zR(i)
        zZ_use(jvec)=zZ(i)
        zrho_use(jvec)=zrho(i)
        zth_use(jvec)=zth(i)
        zphi_use(jvec)=zphi(i)
     endif
  enddo

  !  But first, if there is a scrape off region, separate points across
  !  the boundary...

  if(sol) then

     iskipi=.TRUE.
     iskipo=.TRUE.
     iexact=.TRUE.
     call eqi_bdfind(jvec,zR_use,zZ_use,zphi_use,zrho_plas,iskipi,iskipo, &
          iexact,zth_bdy1,zphi_bdy1,zdist,ierr)
     if(ierr.ne.0) return

     do i=1,jvec
        if((zrho_use(i).gt.zrho_plas).and.(zdist(i).lt.ZERO)) then
           zrho_use(i)=zrho_minus
           zth_use(i)=zth_bdy1(i)
        else if((zrho_use(i).lt.zrho_plas).and.(zdist(i).gt.ZERO)) then
           zrho_use(i)=zrho_plus
           zth_use(i)=zth_bdy1(i)
        endif
     enddo
           
  endif

  !  inverse map evaluation by 2x2 Newton's method

  if(jvec.gt.0) then
     call eqi_xinv2d(jvec,zrho_use,zth_use,zphi_use,zR_use,zZ_use,iregion, &
          reltol,rtol,zrho_bdy, &
          ierr)

     jvec=0
     do i=1,ivec
        if(.not.imask(i)) then
           jvec=jvec+1
           zrho(i)=zrho_use(jvec)
           zth(i)=zth_use(jvec)
           nregion(i)=iregion(jvec)
        endif
     enddo
  endif

  !-----------------------

end subroutine eqi_inv

subroutine eq_flxint_init(iauto,inum,zrho,zrhomin,ierr)

  !  fortran-77 interface -- initialize flux surface numerical integration
 
  use xplasma_obj_instance
  use eq_module

  implicit NONE
 
  !   initialize computation of flux surface / flux zone averages / integrals
  !   using xplasma f90 routines...

  ! input:

  integer iauto            ! =1 for automatic generation of rho partitioning
  integer inum             ! number of rho surfaces partitioning region

  ! input/output:
  !   (output if iauto=1, input otherwise)

  real*8 zrho(inum)        ! sequence of rho surfaces (strict ascending)
  real*8 zrhomin           ! minimum safe rho (approach to axial singularity)

  ! output:

  integer ierr             ! completion code, 0=OK

  !-----------------------------------
  !  note (dmc) -- may need to upgrade to support some integrals in 
  !  extrapolated region beyond plasma boundary...
  !-----------------------------------
  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: ONE  = 1.0d0
  real*8, parameter :: CEPS7 = 1.0d-7
  real*8 :: zrhominu

  integer :: i,idi,iertmp
  character*32 :: iiname,authname
  !-----------------------------------
  !  error check...

  if(inum.lt.2) then
     write(lunerr,*) ' ?eq_flxint_init:  #surfaces, inum.ge.2 required!'
     ierr=1
     return
  endif

  !  iauto option...

  if(iauto.eq.1) then
     do i=1,inum
        zrho(i)=(i-1)*ONE/(inum-1)
     enddo
     zrhominu=min(CEPS4*(zrho(2)),CEPS7)

  else
     zrhominu=max(CEPS4*CEPS7,min(10*CEPS7,zrhomin))  ! btw 1.e-6 and 1.e-11
  endif

  !  create integrator information...

  iiname = "__F77_INTEGRATOR_1D"
  call xplasma_blkbxId(s,iiname,idi)
  if(idi.ne.0) then
     call xplasma_get_item_info(s,idi,ierr, author=authname)
     if(authname.ne.xplasma_xmhd) then
        write(lunerr,*) ' %eq_flxint_init: old integrator owned by "', &
             trim(authname),'" removed (OK).'
        call xplasma_author_set(s,authname,ierr)
        call xplasma_remove_item(s,idi,ierr)
        call xplasma_author_clear(s,authname,ierr)
     endif
  endif

  call xplasma_author_set(s,xplasma_xmhd,ierr)
  if(ierr.ne.0) return

  call xplasma_create_integ(s, iiname, zrho, idi, ierr, &
       rhomin=zrhominu, cache_enable = .TRUE.)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_flxint_init-- integration setup failed:'
     call xplasma_error(s,ierr,lunerr)
  endif
 
  call xplasma_author_clear(s,xplasma_xmhd,iertmp)

end subroutine eq_flxint_init

subroutine eq_flxint_chinit(iauto,inumchis,zchi,ierr)

  !  fortran-77 xplasma interface:
  !  supplemental routine:  initialize chi break points for integrations
  !  over chi intervals

  use xplasma_obj_instance
  use eq_module

  implicit NONE

  integer iauto                 ! =1 for automatic generation of zchi values
  integer inumchis              ! no. of chi interval boundaries (at least 3).
  real*8 zchi(inumchis)         ! chi intervals (output if iauto=1).

  integer ierr                  ! completion code:  0 = OK

  !---------------------------------------------------------------------
  integer :: i,idi,inrhoi,inthi,idi_2d,iertmp
  !---------------------------------------------------------------------
  !  error check...

  if(inumchis.lt.2) then
     write(lunerr,*) ' ?eq_flxint_chinit:  #surfaces, inumchis.ge.2 required!'
     ierr=1
     return
  endif

  ! find 1d integrator dataset (which will be extended to form 2d dataset).

  call eq_find_intg(1,idi,inrhoi,inthi,ierr)
  if((ierr.ne.0).or.(idi.eq.0)) then
     write(lunerr,*) ' ?eq_flxint_chinit: no 1d integrator dataset found.'
     write(lunerr,*) '  Perhaps there was no prior eq_flxint_init call.'
     write(lunerr,*) '  More information:'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  !  iauto option...

  if(iauto.eq.1) then
     do i=1,inumchis
        zchi(i)=(i-1)*C2PI/(inumchis-1)
     enddo
  endif
 
  ! OK...
  !  create integrator information...

  call xoi_author_set(ierr)
  if(ierr.ne.0) return
 
  call xplasma_augment_integ(s,"__F77_INTEGRATOR_2D",idi,zchi,idi_2d,ierr)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_flxint_chinit-- integration setup failed:'
     call xplasma_error(s,ierr,lunerr)
  endif
 
  call xoi_author_clear(iertmp)

end subroutine eq_flxint_chinit

subroutine eq_glimb(rho,b_min,b_max,ierr)

  ! find min & max mod(B) on specified flux surface...

  IMPLICIT NONE
  REAL*8 rho                        ! rho of surface (in)
  REAL*8 b_min                      ! minimum mod(B) found (out)
  REAL*8 b_max                      ! maximum mod(B) found (out)
  integer ierr                      ! completion code, 0=OK

  !---------------------------
  real*8 zdum1,zdum2
  real*8, parameter :: ZERO = 0.0d0
  !---------------------------

  call eq_glimb1(rho,ZERO,b_min,zdum1,b_max,zdum2,ierr)

end subroutine eq_glimb

module fluxav
!
  implicit NONE
  SAVE
!
  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
!
!  dmc 8 Sep 2000
!  support module for flux surface & flux zone averaging and integration
!  in context of a toroidal system
!
!  dmc 15 Aug 2006 -- module simplified; reduced role in xplasma2
!-------------------------------------------------------------------
!-------------------------------------------------------------------
!
  integer :: lunerr  = 6        ! unit for error messages
!
!-------------------------------------------------------------------
! theta and phi coordinate limits (should differ by 2pi)
!
  real*8, parameter :: twopi = 6.2831853071795862_R8
 
  real*8 :: theta_min = 0.0_R8       ! minimum poloidal angle
  real*8 :: theta_max = twopi        ! max poloidal angle
 
  real*8 :: phi_min =   0.0_R8       ! minimum toroidal angle
  real*8 :: phi_max =   twopi        ! max toroidal angle
!
!-------------------------------------------------------------------
! break-point lists, in each dimension...
!
  real*8, dimension(:), pointer :: rhobrk,rhobrk_tmp
  real*8, dimension(:), pointer :: thbrk,thbrk_tmp
  real*8, dimension(:), pointer :: phibrk,phibrk_tmp
!
! no. of break-points used, each dimension...
!
  integer :: n_rhobrk = 0
  integer :: n_thbrk = 0
  integer :: n_phibrk = 0
!
! size of (expandable) allocated list array, each dimension...
!
  integer :: n_rhomax = 0
  integer :: n_thmax = 0
  integer :: n_phimax = 0
!
!-------------------------------------------------------------------
end module fluxav

 
#include "fpreproc/byte_declare.h"
 
!----------------------------------------------------------
! cface  -- generated (f90 fixed form) C interface to:  EQM_SELECT
      SUBROUTINE  C_EQM_SELECT(
     > C_MODEL_LEN,C_MODEL,ILAXI)
 
      external EQM_SELECT
 
! argument declarations
 ! scalar char*(*) type, input only:
      INTEGER C_MODEL_LEN
      BYTE_DECLARE C_MODEL(C_MODEL_LEN)
 
      INTEGER ILAXI
 
! local (automatic array) declarations
      CHARACTER(C_MODEL_LEN) :: MODEL_act
 
! executable code:  copy for input
 
      call cstring(MODEL_act, C_MODEL,'2F')
! call to original routine:  EQM_SELECT
 
      CALL EQM_SELECT(
     > MODEL_act,ILAXI)
 
! copy back outputs if modified.
 
! exit
      return
      end

! 21Jul1999 fgtok -impno -s r8_precision.sub "r8con.csh conversion"
c  dmc-- lsode error message routine
c   portability modifications:  21 July 1999
c
c     to set error message unit number (lun),
c     call xsetun_lsode(lun)
c     don't use call xsetun(lun) -- xsetun name conflicts with slatec
c     which has an incompatible messaging system
c
c     to set message level (mesflg=0, no messages, danger!, or mesflg=1),
c     call xsetf_lsode(mesflg)
c     don't use call xsetf(mesflg) -- xsetf name conflicts with slatec
c     which has an incompatible messaging system
c
c     the xerrwv code has been changed for portability, so that
c     conditional compilation or actual code modification is not
c     necessary when moving from machine to machine.  this is done
c     by using the integer function isize_get_lsode which is a C
c     code that calls sizeof(int) to get the number of bytes, characters,
c     per integer word.
c
      subroutine xerrwv_r8 (msg, nmes, nerr, level, ni, i1, i2, nr, 
     1     r1, r2)
 
      IMPLICIT NONE
      integer msg, nmes, nerr, level, ni, i1, i2, nr,
     1   i, lun, lunit, mesflg, ncpw, nch, nwds
      INTEGER isize_get_lsode_r8,idum
      REAL*8 r1, r2
      dimension msg(nmes)
c
c-----------------------------------------------------------------------
c subroutines xerrwv, xsetf, and xsetun, as given here, constitute
c a simplified version of the slatec error handling package.
c written by a. c. hindmarsh at llnl.  version of march 30, 1987.
c
c all arguments are input arguments.
c
c msg    = the message (hollerith literal or integer array).
c nmes   = the length of msg (number of characters).
c nerr   = the error number (not used).
c level  = the error level..
c          0 or 1 means recoverable (control returns to caller).
c          2 means fatal (run is aborted--see note below).
c ni     = number of integers (0, 1, or 2) to be printed with message.
c i1,i2  = integers to be printed, depending on ni.
c nr     = number of reals (0, 1, or 2) to be printed with message.
c r1,r2  = reals to be printed, depending on nr.
c
c note..  this routine is machine-dependent and specialized for use
c in limited context, in the following ways..
c 1. the number of hollerith characters stored per word, denoted
c    by ncpw below, is a data-loaded constant.
c 2. the value of nmes is assumed to be at most 60.
c    (multi-line messages are generated by repeated calls.)
c 3. if level = 2, control passes to the statement   stop
c    to abort the run.  this statement may be machine-dependent.
c 4. r1 and r2 are assumed to be in single precision and are printed
c    in e21.13 format.
c 5. the common block /eh0001/ below is data-loaded (a machine-
c    dependent feature) with default values.
c    this block is needed for proper retention of parameters used by
c    this routine which the user can reset by calling xsetf or xsetun.
c    the variables in this block are as follows..
c       mesflg = print control flag..
c                1 means print all messages (the default).
c                0 means no printing.
c       lunit  = logical unit number for messages.
c                the default is 6 (machine-dependent).
c-----------------------------------------------------------------------
c the following are instructions for installing this routine
c in different machine environments.
c
c to change the default output unit, change the data statement below.
c
c for some systems, the data statement below must be replaced
c by a separate block data subprogram.
c
c for a different number of characters per word, change the
c data statement setting ncpw below, and format 10.  alternatives for
c various computers are shown in comment cards.
c
c for a different run-abort command, change the statement following
c statement 100 at the end.
c-----------------------------------------------------------------------
      external xerrwv_blockd_r8
c
      common /eh0001/ mesflg, lunit
c
ccc   data mesflg/1/, lunit/6/  ! dmc -- see block data
c-----------------------------------------------------------------------
c the following data-loaded value of ncpw is valid for the cdc-6600
c and cdc-7600 computers.
c     data ncpw/10/
c the following is valid for the cray-1 computer.
ccc      data ncpw/8/
c the following is valid for the burroughs 6700 and 7800 computers.
c     data ncpw/6/
c the following is valid for the pdp-10 computer.
c     data ncpw/5/
c the following is valid for the vax computer with 4 bytes per integer,
c and for the ibm-360, ibm-370, ibm-303x, and ibm-43xx computers.
c     data ncpw/4/
c the following is valid for the pdp-11, or vax with 2-byte integers.
c     data ncpw/2/
c-----------------------------------------------------------------------
c  dmc -- local character variables
c
      integer ichari
      character*20 buf0
      character*60 buf1
c
c-----------------------------------------------------------------------
c
      if (mesflg .eq. 0) go to 100
c get logical unit number. ---------------------------------------------
      lun = lunit
c get number of words in message. --------------------------------------
      ncpw = isize_get_lsode_r8(idum)      ! dmc -- get ncpw from C code
      nch = min(nmes,60)
      nwds = nch/ncpw
      if (nch .ne. nwds*ncpw) nwds = nwds + 1
c generate the message
      ichari=0
      do i=1,nwds
         write(buf0,'(A)') msg(i)
         buf1(ichari+1:ichari+ncpw)=buf0(1:ncpw)
         ichari=ichari+ncpw
      enddo
c write the message. ---------------------------------------------------
      write (lun, '(1x,A)') buf1
ccc      write (lun, 10) (msg(i),i=1,nwds)
c-----------------------------------------------------------------------
c the following format statement is to have the form
c 10  format(1x,mmann)
c where nn = ncpw and mm is the smallest integer .ge. 60/ncpw.
c the following is valid for ncpw = 10.
c 10  format(1x,6a10)
c the following is valid for ncpw = 8.
  10  format(1x,8a8)
c the following is valid for ncpw = 6.
c 10  format(1x,10a6)
c the following is valid for ncpw = 5.
c 10  format(1x,12a5)
c the following is valid for ncpw = 4.
c 10  format(1x,15a4)
c the following is valid for ncpw = 2.
c 10  format(1x,30a2)
c-----------------------------------------------------------------------
      if (ni .eq. 1) write (lun, 20) i1
 20   format(6x,23hin above message,  i1 =,i10)
      if (ni .eq. 2) write (lun, 30) i1,i2
 30   format(6x,23hin above message,  i1 =,i10,3x,4hi2 =,i10)
      if (nr .eq. 1) write (lun, 40) r1
 40   format(6x,23hin above message,  r1 =,e21.13)
      if (nr .eq. 2) write (lun, 50) r1,r2
 50   format(6x,15hin above,  r1 =,e21.13,3x,4hr2 =,e21.13)
c abort the run if level = 2. ------------------------------------------
 100  if (level .ne. 2) return
      call errmsg_exit('lsode error exit!')
      !!! stop
c----------------------- end of subroutine xerrwv ----------------------
      end
c-----------------------------------------------------------------------
      block data xerrwv_blockd_r8
c
      IMPLICIT NONE
      INTEGER mesflg,lunit
      common /eh0001/ mesflg, lunit
 
      data mesflg/1/, lunit/6/
c
      end
c-----------------------------------------------------------------------
      subroutine xsetun_lsode_r8(lun)
c
      IMPLICIT NONE
      INTEGER mesflg,lunit,lun
      common /eh0001/ mesflg, lunit
 
      lunit=lun
c
      return
      end
c-----------------------------------------------------------------------
      subroutine xsetf_lsode_r8(imes)
c
      IMPLICIT NONE
      INTEGER mesflg,lunit,imes
      common /eh0001/ mesflg, lunit
 
      if(imes.eq.0) then
         mesflg=0
      else
         mesflg=1
      endif
c
      return
      end
c-----------------------------------------------------------------------

subroutine xplasma_checkName_sub(zname,ier)
  !
  !  check for legal name; no module dependence...
  !
  !  ier=1 means there is an illegal character--
  !   non-trailing blank, non-alphanumeric, not "$" or "_", or,
  !   the first character is a numeric digit.
  !   or, the name is all blank
  !
  !  ier=2 means the non-blank length exceeds the limit (32 characters)
  !
  implicit NONE
  character*(*), intent(in) :: zname
  integer, intent(out) :: ier

  !----------
  ! local:

  character*32 znamu  ! uppercase version

  character*10 :: zdigits = "0123456789"
  character*28 :: zalphpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ_$"

  integer :: i,idig,ialph,ilen
  
  !----------

  ier=0

  ilen=len(trim(zname))
  if(ilen.gt.len(znamu)) then
     ier=2
     return
  endif

  if(ilen.eq.0) then
     ier=1
     return
  endif

  znamu=zname
  call uupper(znamu)

  ialph=index(zalphpp,znamu(1:1))
  if(ialph.eq.0) then
     ier=1
     return
  endif

  do i=2,ilen
     ialph=index(zalphpp,znamu(i:i))
     idig =index(zdigits,znamu(i:i))
     if(max(ialph,idig).eq.0) then
        ier=1
        exit
     endif
  enddo

end subroutine xplasma_checkName_sub

subroutine eqi_geq_axis_rsrch(ivec,iok,R,dPsidR,ivecd, &
     zinput,ninput,zoutput,noutput)

  ! see comput/zriddery.for -- root finder functional
  ! return dPsidR where dPsidZ=0

  use eqi_geq_axis_data
  implicit NONE

  !-----------------------------

  integer,intent(in) :: ivec
  logical,intent(in) :: iok(ivec)
  real*8, intent(in) :: R(ivec)
  real*8,intent(out) :: dPsidR(ivec)

  integer,intent(in) :: ivecd
  integer,intent(in) :: ninput,noutput
  real*8, intent(in) :: zinput(ivecd,ninput)
  real*8, intent(inout) :: zoutput(ivecd,noutput)

  !-----------------------------
  !  local...

  real*8 :: zmin(ivec),zmax(ivec),Z(ivec),zspl_data(1,1)
  integer :: ifail,idum

  integer :: ict_Rsrch(6) = (/ 0, 1, 0, 0, 0, 0 /)

  EXTERNAL eqi_geq_axis_Zsrch

  !-----------------------------
  !  expecting ivec=1 !!!

  if(ivec.ne.1) call errmsg_exit(' ?? eqi_geq_axis_rsrch: ivec=1 expected !! ')

  zmin(1) = zinput(1,1)
  zmax(1) = zinput(1,2)

  call xlookup(1,R,size(rpkg,1),rpkg,2,ii,rparam,hr,hri,idum)
  
  call zridderx(ivec,iok,zmin,zmax,eqi_eps,eqi_eta, &
       eqi_geq_axis_Zsrch,Z,ifail, &
       ivecd,zinput,ninput,zoutput,noutput)

  if(ifail.ne.0) then
#ifdef __DEBUG
     write(6,*) ' ?? eq8_geq_axis_rsrch: zridderx ifail = ',ifail
#endif

     dPsidR = 1000.0d0

  else
     ! search for dPsi/Z = 0 succeeded

     zoutput(1,1) = Z(1)

     ! evaluate spline for dpsi/dR

     call fvbicub(ict_Rsrch,1,1, &
          zspl_data,ii,jj,rparam,zparam,hr,hri,hz,hzi, &
          psirz_spl,size(psirz_spl,2),size(psirz_spl,3))

     dPsidR = zspl_data(1,1)

  endif

end subroutine eqi_geq_axis_rsrch

subroutine eqm_rzmagb(Rarr,Zarr,id1,id2,idrho,  &
     ibcR0,zbcR0,ibcR1,zbcR1,  &
     ibcZ0,zbcZ0,ibcZ1,zbcZ1,  &
     id_R,id_Z,ierr)
 
  use xplasma_obj_instance
  use eq_module
  implicit NONE

  !  establish R(chi,rho) and Z(chi,rho) bicubic splines.
  !  specify spline boundary conditions @ rho(axis) & @ rho(bdy)
  !  independently for R, Z

  !  input arguments:

  integer id1,id2            ! R,Z array dimensions
  real*8 Rarr(id1,id2)       ! R array
  real*8 Zarr(id1,id2)       ! Z array

  integer idrho              ! =1:  id1 is "rho" dimension; =2: id2 is.

  !  ** boundary conditions **

  !  BC controls are as in "pspline":  0 -- default, 1 -- fix df/drho
  !                                    2 -- fix d2f/drho2  ... f is R or Z

  !  for BC types 1 & 2, data must be supplied:  nchi 1st or 2nd derivative
  !  values, repsectively;  for other types the "zbc" arrays are ignored.

  integer ibcR0              ! R BC type @ rho(1)
  real*8 zbcR0(*)            ! R BC data @ rho(1) (if needed)
  integer ibcR1              ! R BC type @ rho(nrho)
  real*8 zbcR1(*)            ! R BC data @ rho(nrho) (if needed)

  integer ibcZ0              ! Z BC type @ rho(1)
  real*8 zbcZ0(*)            ! Z BC data @ rho(1) (if needed)
  integer ibcZ1              ! Z BC type @ rho(nrho)
  real*8 zbcZ1(*)            ! Z BC data @ rho(nrho) (if needed)
 
  !  output arguments:

  integer id_R               ! xplasma id for "R" bicubic spline (returned)
  integer id_Z               ! xplasma id for "Z" bicubic spline (returned)

  integer ierr               ! completion code (0 = OK)

  !------------------------------------------------
  !  local:

  integer inx1,inx2,iertmp,icount
  integer inrho,inchi,id_rho,id_chi
  logical :: iforce=.FALSE.

  !------------------------------------------------

  id_R=0
  id_Z=0
  ierr=0

  call eqm_rzmag_check(id1,id2,idrho,id_rho,id_chi,inrho,inchi,ierr)
  if(ierr.ne.0) return

  if(ibcR0.ne.ibcZ0) then
     write(lunerr,*) &
          ' ?eqm_rzmagb: different rho=0 boundary condition for R & Z:'
     write(lunerr,*) &
          '  ibcR0=',ibcR0,' ibcZ0=',ibcZ0
     write(lunerr,*) &
          '  These must match, i.e. have the same value.'
     ierr=1
  endif

  if(ibcR1.ne.ibcZ1) then
     write(lunerr,*) &
          ' ?eqm_rzmagb: different rho=1 boundary condition for R & Z:'
     write(lunerr,*) &
          '  ibcR0=',ibcR0,' ibcZ0=',ibcZ0
     write(lunerr,*) &
          '  These must match, i.e. have the same value.'
     ierr=1
  endif

  if(ierr.ne.0) return

  call xoi_author_set(iertmp)
  
  if(id_rho.eq.1) then
     call xplasma_rzmag(s,id_rho,id_chi, &
          Rarr(1:inrho,1:inchi),Zarr(1:inrho,1:inchi), &
          id_R,id_Z,ierr, &
          ibc0=ibcR0,Rbc0=zbcR0(1:inchi),Zbc0=zbcZ0(1:inchi), &
          ibc1=ibcR1,Rbc1=zbcR1(1:inchi),Zbc1=zbcZ1(1:inchi))
  else
     call xplasma_rzmag(s,id_chi,id_rho, &
          Rarr(1:inchi,1:inrho),Zarr(1:inchi,1:inrho), &
          id_R,id_Z,ierr, &
          ibc0=ibcR0,Rbc0=zbcR0(1:inchi),Zbc0=zbcZ0(1:inchi), &
          ibc1=ibcR1,Rbc1=zbcR1(1:inchi),Zbc1=zbcZ1(1:inchi))
  endif

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqm_rzmagb: xplasma_rzmag returned ierr=',ierr
     call xplasma_error(s,ierr,lunerr)
  else
     call xplasma_eqcheck(s,iforce,icount,ierr)
     if(icount.gt.0) then
        write(lunerr,*) ' %eqm_rzmagb: equilibrium specification completed.'
     endif
  endif

  call xoi_author_clear(iertmp)

end subroutine eqm_rzmagb

subroutine eq_arc_findarc(ivec,iok,th,ansr,ivecd, &
     zinput,ninput,zoutput,noutput)

  ! subroutine for comput/zridderx root finder

  ! find points at desired arclength along a contour
  ! target arclength passed in input

  use iso_c_binding, only: fp => c_double
  use eq_arc_scrunch_mod
  implicit NONE

  integer, intent(in) :: ivec
  logical, dimension(ivec), intent(in) :: iok
  real(fp), dimension(ivec), intent(in) :: th    ! theta
  real(fp), dimension(ivec), intent(inout) :: ansr  ! L(th)-Ltarget

  integer, intent(in) :: ivecd
  integer, intent(in) :: ninput,noutput
  real(fp), dimension(ivecd,ninput), intent(in) :: zinput
  real(fp), dimension(ivecd,ninput), intent(in) :: zoutput  ! not used here

  !-----------------
  integer, dimension(3) :: ict = (/ 1, 0, 0 /)
  integer :: idum,ier,jvec,ii

  real(fp), dimension(ivec) :: thbuf, abuf
  !-----------------
  jvec=0
  do ii=1,ivec
    if(.not.iok(ii)) then
      jvec=jvec+1
      thbuf(jvec)=th(ii)
    endif
  enddo

  call spvec(ict,jvec,thbuf,jvec,abuf,ntha,tha_pkg,Lspl,idum,ier)

  jvec=0
  do ii=1,ivec
    if(.not.iok(ii)) then
      jvec=jvec+1
      ansr(ii)=abuf(jvec)-Zinput(ii,1)
    endif
  enddo

  return
end subroutine eq_arc_findarc

subroutine eq_bdlims(itype,zRminLim,zRmaxLim,zZminLim,zZmaxLim,ierr)

  !  fetch limiter type and extrema of vacuum region enclosed by
  !  limiter

  use xplasma_obj_instance
  use eq_module

  implicit NONE

  integer, intent(out) :: itype  ! type: 100=contour
  !  101 = lines & circles with possible plasma bdy distance constraint

  real*8, intent(out) :: zRminLim,zRmaxLim  ! R range of vacuum region
  real*8, intent(out) :: zZminLim,zZmaxLim  ! Z range of vacuum region

  integer, intent(out) :: ierr ! status code (0=OK)

  !-----------------------------------------

  call xplasma_lim_RZminmax(s,zRminLim,zRmaxLim,zZminLim,zZmaxLim,ierr, &
       itype=itype)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_bdlims: xplasma_lim_RZminmax failed, ierr=',ierr
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_bdlims

MODULE mintrp
  use iso_c_binding, only: fp => c_double
  implicit none
  integer :: nu, ncmax
!
  real(fp), dimension(:,:), allocatable :: rin ! (nu,ncmax)
  real(fp), dimension(:,:), allocatable :: zin ! (nu,ncmax)
  integer :: ntheta0, numc                 ! no of points in contours
  real(fp) :: raxis,zaxis                   ! the axis location
  real(fp) :: facmid, facedg, facdx0
  !															
  !  recommended value:  moption=3
  integer :: moption                    ! control flag
  !
  !  rotated low order polynomial description of theta line
  !  (for internal use only)
  !
  real(fp) :: r0,z0,r1,z1,r2,z2
  real(fp) :: a,b,c,d,xbrk,a2,b2,c2,d2,xmax,zcosa,zsina
  real(fp) :: zcosa2,zsina2
  !
  real(fp) :: xspl(5),yspl(4,5),xpkg(5,4) ! for moption=3
  !
  !  surface whose intercepts are wanted; last nearby theta interval
  !  (for internal use only)
  !
  integer :: ksurf,kth
  !
  !--------------------------------------------------------------------
END MODULE mintrp

MODULE scrunch_inc1
  use iso_c_binding, only: fp => c_double
  ! begin SCRUNCH_INC1
  ! make mpol = mpolDIM + 1 , where mpolDIM is defined in SCRUNCH_INC0
  implicit none
  integer :: mnd
  integer :: mpnt
  integer :: nphi2
  integer :: nphi
  integer :: mpol
  integer :: nznt
  integer :: ntheta
  integer :: mpol2
  integer :: mpol3
  integer :: mpol4
  integer :: n2
  integer :: nfp
  integer :: nthetax
  integer :: mpolx
  integer :: nresets
  parameter(nphi=1,nphi2=1+nphi/2)
  logical ioflagc
  integer, dimension(:), allocatable :: mm ! (mpol)
  integer :: nn(nphi)
  integer, dimension(:), allocatable :: m1 ! (mnd)
  integer, dimension(:), allocatable :: n1 ! (mnd)
  real(fp), dimension(:), allocatable :: dm1 ! (mpol)
  real(fp) :: r0n(nphi)
  real(fp) :: z0n(nphi)
  real(fp) :: raxis3d(nphi)
  real(fp) :: zaxis3d(nphi)
  real(fp), dimension(:,:), allocatable :: rin3d ! (ntheta,nphi)
  real(fp), dimension(:,:), allocatable :: zin3d ! (ntheta,nphi)
  real(fp), dimension(:,:), allocatable :: angle ! (ntheta,nphi)
  real(fp), dimension(:), allocatable :: faccon ! (mpol)
  real(fp), dimension(:,:), allocatable :: xmpq ! (mpol,4)
  real(fp) :: gnorm
  real(fp) :: specw
  real(fp) :: delt
  real(fp) :: deltf
  real(fp) :: pexp
  real(fp) :: qexp
  real(fp) :: dnorm
  real(fp) :: elongate
  real(fp), dimension(:,:,:), allocatable :: result ! (nphi2,mpol,4)
  real(fp), dimension(:), allocatable :: xvec ! (n2)
  real(fp), dimension(:), allocatable :: gvec ! (n2)
  real(fp), dimension(:), allocatable :: xdot ! (n2)
  real(fp), dimension(:), allocatable :: xstore ! (n2)
 
  integer :: lunmsg = 6
 
END MODULE scrunch_inc1

MODULE scrunch_inc2
  use iso_c_binding, only: fp => c_double
  implicit none
  logical :: lasym
  logical :: lzakharov
  real(fp), dimension(:,:), allocatable :: rmomb ! (mpol,2)
  real(fp), dimension(:,:), allocatable :: zmomb ! (mpol,2)
  real(fp) :: rcent
  real(fp) :: zcent
END MODULE scrunch_inc2

! 30Nov1999 fgtok -s r8_precision.sub r8bloat_names.sub "r8con.csh conversion"
C******************** START FILE TKBMRY.FOR ; GROUP TKBLOAT ******************
 
 
C-- END FILE #TKBMMC# ************************************
CFORMFEEDC-- START FILE #TKBMRY# ************************************
C-----------------------------------------------------------------
C  DMC - UTILITY ROUTINE FOR MOMENT SURFACES EXTRAPOLATION.
C
C  RETURN THE R,Y PT. FOR GIVEN SURFACE, PASSED THETA VALUE
C
      SUBROUTINE r8tkbmry(nsurf,ISURF,ZTHETA,zrmc,zymc,locmax,nmom,
     >                    ZROUT,ZYOUT)
C
C============
C idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      INTEGER locmax,nmom,isurf,locmax2,imn
C============
C idecl:  explicitize implicit REAL declarations:
      REAL*8 ztheta,zrout,zyout,zzrmcc,zzrmcs,zzymcc,zzymcs
C============
      integer nsurf
      REAL*8 zrmc(nsurf,0:locmax,2)
      REAL*8 zymc(nsurf,0:locmax,2)
C
      REAL*8 snthtk(locmax),csthtk(locmax)
C
C--------------------------------------------------
C
C
      CALL r8sincos ( ZTHETA, NMOM, SNTHTK, CSTHTK )
C
C  UP-DOWN ASYMMETRIC CASE (B.BALET JAN 94) :
C
      ZROUT = ZRMC(ISURF,0,1)
      ZYOUT = ZYMC(ISURF,0,1)
      DO 10610 IMN = 1, NMOM
         ZZRMCC = ZRMC(ISURF,IMN,1)
         ZZRMCS = ZRMC(ISURF,IMN,2)
         ZZYMCC = ZYMC(ISURF,IMN,1)
         ZZYMCS = ZYMC(ISURF,IMN,2)
         ZROUT = ZROUT + ZZRMCC * CSTHTK(IMN) + ZZRMCS * SNTHTK(IMN)
         ZYOUT = ZYOUT + ZZYMCC * CSTHTK(IMN) + ZZYMCS * SNTHTK(IMN)
10610 CONTINUE
C
      RETURN
      END
C******************** END FILE TKBMRY.FOR ; GROUP TKBLOAT ******************

subroutine eq_rzlims(Rmin,Rmax,Zmin,Zmax,ierr)

  !  return min/max R & Z of (R,Z) grids
  !  set ierr if grids are not available.

  use xplasma_obj_instance
  use eq_module

  implicit NONE

  !  all output:
  real*8 Rmin,Rmax                  ! min/max R of grids
  real*8 Zmin,Zmax                  ! min/max Z of grids
  integer ierr                      ! completion code:  0 = OK

  !--------------------------------------------------
  integer :: id_Rc,id_Zc,ingrids
  !--------------------------------------------------

  Rmin = 0; Rmax = 0; Zmin = 0; Zmax = 0

  do
     call xplasma_find_item(s,'__R_coord',id_Rc,ierr); if(ierr.ne.0) exit
     call xplasma_find_item(s,'__Z_coord',id_Zc,ierr); if(ierr.ne.0) exit

     call xplasma_coord_info(s,id_Rc,ierr, ngrids=ingrids); if(ierr.ne.0) exit
     if(ingrids.eq.0) then
        write(lunerr,*) ' ?eq_rzlims: R grid has not been defined.'
        exit
     endif

     call xplasma_coord_info(s,id_Zc,ierr, ngrids=ingrids); if(ierr.ne.0) exit
     if(ingrids.eq.0) then
        write(lunerr,*) ' ?eq_rzlims: Z grid has not been defined.'
        exit
     endif

     call xplasma_coord_info(s,id_Rc,ierr, &
          xmin=Rmin,xmax=Rmax); if(ierr.ne.0) exit

     call xplasma_coord_info(s,id_Zc,ierr, &
          xmin=Zmin,xmax=Zmax); if(ierr.ne.0) exit

     exit
  enddo

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_rzlims: unexpected error:'
     call xplasma_error(s,ierr,lunerr)
  else if(ingrids.eq.0) then
     ierr=1
  endif

end subroutine eq_rzlims

module xplasma_flxint

  !  methods for numerical integration
  !
  !  the following produce 1d results:
  !
  !  xplasma_rho_zonint -- f(rho) as a result of integration or average
  !     given a known integration id name, e.g. "Vol" or "dVol" or "<R^2>S".
  !
  !  xplasma_2d_zonint -- f(theta,rho) as a result of integration or average
  !     given a known integration id name, e.g. "dVol" or "<R^2>S".

  !  Added dmc 13 Dec 2006 -- fetch dVol or dArea elements for a rho grid
  !    or... for a 2d theta x rho grid.
  
  use xplasma_obj
  use eqi_intg_module
  implicit NONE

  private

  public :: xplasma_rho_zonint,xplasma_2d_zonint,xplasma_integ_eligible

  public :: xplasma_rhogrid_dva
  public :: xplasma_rhoth_grid_dva

  real*8, parameter :: czero = 0.0d0

  !---------------------------
  contains

    subroutine xplasma_rho_zonint(s,idi,int_name,result,ier, &
         dvol_out,iwarn_dvol,dvdrho_out,iwarn_dvdrho)

      ! integrator -- over rho zones result of form f(rho) indexed by zone
      !                      1 result per zone (#zones)
      !               or rho surfaces, also result of form f(rho)
      !                      1 result per surface (#zones + 1)

      type (xplasma), pointer :: s
      integer, intent(in) :: idi ! integrator data structure ("black box") id
      character*(*),intent(in) :: int_name ! name of desired integration
      real*8, dimension(:), intent(out) :: result
      integer, intent(out) :: ier  ! status code 0=OK

      !  ** optional outputs **

      real*8, dimension(:), optional :: dvol_out   ! zone volumes
      integer, intent(out), optional :: iwarn_dvol ! =0 if zone volumes OK
      ! iwarn_dvol=1: zone volumes not available; =2: array dimension error.

      real*8, dimension(:), optional :: dvdrho_out ! dV/drho @ surfaces
      integer, intent(out), optional :: iwarn_dvdrho ! =0 if dV/drho OK
      ! iwarn_dvdrho=1: dV/drho not available; =2: array dimension error.

      !-----------------------------------
      real*8, dimension(:), allocatable :: rho_int,rho_brk
      real*8, dimension(:), allocatable :: dvol,dvdrho,bmaxa
      integer, dimension(:), allocatable :: indexb

      real*8 :: rhomin
      integer :: inzons,inzonb,insurfs,isizer,isizei,ilen,iertmp,i,j,ii,inum
      integer :: inrho_brk,infine,inumu
      logical :: dvol_avail,dvdrho_avail,dvol_need,dvdrho_need,ilfine
      logical :: bmaxa_avail,bmaxa_need

      character*32 zname,iiname
      character*128 zmsg
      real*8, parameter :: c2pi = 6.2831853071795862D+00
      real*8, dimension(:), allocatable :: zwk
      real*8, dimension(:), allocatable :: rhofine,wrhof
      real*8, dimension(:), pointer :: thvec,wth,cache
      real*8 :: thzon1(2)
      integer :: cache_size
      logical :: cache_init(eqi_intg_nfi),ilsurf,ilocal
      logical :: iret_vol,iret_dvdrho
      !-----------------------------------
      !  info on the integrator dataset

      result=0

      thzon1(1)=0
      thzon1(2)=c2pi

      call xplasma_integ_info(s,idi,ier, &
           dvol_avail=dvol_avail, dvdrho_avail=dvdrho_avail, &
           bmaxa_avail=bmaxa_avail, &
           n_rho_int = insurfs, &
           n_rho_brk = inrho_brk)
      
      if(ier.ne.0) return

      inzons=insurfs-1
      inzonb=inrho_brk-1

      iret_vol=.FALSE.
      if(present(iwarn_dvol)) iwarn_dvol=1  ! for now...
      if(present(dvol_out)) then
         dvol_out=0
         if(size(dvol_out).eq.inzons) then
            iret_vol=.TRUE.
         else
            if(present(iwarn_dvol)) iwarn_dvol=2  ! array size error
         endif
      endif

      iret_dvdrho=.FALSE.
      if(present(iwarn_dvdrho)) iwarn_dvdrho=1  ! for now...
      if(present(dvdrho_out)) then
         dvdrho_out=0
         if(size(dvdrho_out).eq.insurfs) then
            iret_dvdrho=.TRUE.
         else
            if(present(iwarn_dvdrho)) iwarn_dvdrho=2  ! array size error
         endif
      endif

      allocate(rho_int(insurfs),rho_brk(inrho_brk), &
           dvol(inzons),dvdrho(insurfs),bmaxa(insurfs))

      do 

         ilocal = .FALSE.
         ilfine = .FALSE.  ! rho eval at surfaces only if(ilsurf)...

         call xplasma_integ_info(s,idi,ier, &
              rho_int=rho_int,rho_brk=rho_brk, &
              dvol=dvol, dvdrho=dvdrho, bmaxa=bmaxa, &
              thvec_ptr=thvec, thwts_ptr=wth, cache_ptr=cache, &
              rhomin=rhomin,cache_init=cache_init)
      
         if(ier.ne.0) exit

         if(dvol_avail.and.iret_vol) then
            dvol_out = dvol
            if(present(iwarn_dvol)) iwarn_dvol=0
         endif

         if(dvdrho_avail.and.iret_dvdrho) then
            dvdrho_out = dvdrho
            if(present(iwarn_dvol)) iwarn_dvol=0
         endif

         zname = int_name
         call uupper(zname)
         ilen = len(trim(zname))

         !-----------------------
         sp => s   ! *** so integrand routines can see s *** cf eqi_intg_module
         !-----------------------
         call xplasma_integ_num(zname,inum,ilsurf, &
              dvol_need,dvdrho_need,bmaxa_need)

         if(inum.eq.0) then
            call xplasma_errmsg_append(s, &
                 '  unrecognized integration name:  "'//trim(int_name)//'".')
            ier=611
            exit
         endif

         if(.not.ilsurf) then
            nullify(cache)   ! retained cache for surface integrals only...
         endif

         if(.not.associated(cache)) then
            if(ilsurf) then
               cache_size=size(thvec)*insurfs*eqi_intg_nfi
            else
               ilfine=.TRUE.  ! rho eval at many points inside each rho zone
               infine=10*inzonb
               allocate(rhofine(infine),wrhof(infine))
               call xplasma_integ_mkvec(inrho_brk,rho_brk,rhofine,wrhof)
               cache_size=size(thvec)*infine*eqi_intg_nfi
               allocate(indexb(infine))
               call xplasma_integ_mkindex(insurfs,rho_int, &
                    infine,rhofine,indexb)
            endif
            allocate(cache(cache_size))
            ilocal = .TRUE.   ! flags locally allocated CACHE
            cache_init = .FALSE.
         endif

         isizer=size(result)
         if(ilsurf) then
            isizei=insurfs
         else
            isizei=inzons
         endif

         !  check expected size of result against size of array provided...

         if((inum.eq.eqi_intg_dvol).or.(inum.eq.eqi_intg_darea)) then
            if(isizer.ne.inzons) then
               ier=610
               isizei=inzons
            endif
         else if(isizer.ne.isizei) then
            ier=610
         endif

         if(ier.ne.0) then
            zmsg=' '
            call xplasma_get_item_info(s,idi,iertmp, name=iiname)
            write(zmsg,*) '  integrator dataset name: ',trim(iiname)
            call xplasma_errmsg_append(s,zmsg)
            zmsg=' '
            write(zmsg,*) '  expected size of result of "',trim(zname), &
                 '" integral/avg is: ',isizei
            call xplasma_errmsg_append(s,zmsg)
            zmsg=' '
            write(zmsg,*) '  size of result array passed is: ',isizer
            exit
         endif

         if(ilfine) then
            allocate(zwk(infine))
            deallocate(bmaxa,dvdrho)
            allocate(bmaxa(infine)); bmaxa=czero
            allocate(dvdrho(infine))
            !  these to be recalculated on the finer scale:
            dvdrho_avail=.FALSE.
         else
            allocate(zwk(insurfs))
         endif

         !  pre-fetch volume if needed...

         if(ilfine.and.dvol_need) then
            call xplasma_integ_work(eqi_intg_dvdrho,size(thvec),thvec,wth, &
                 2,thzon1,infine,rhofine,rhomin, &
                 cache_init,cache,zwk,bmaxa,dvdrho,ier)  ! zwk not used
            if(ier.ne.0) exit
         endif

         if(dvol_need.and.(.not.dvol_avail)) then

            if(ilfine) then
               dvol=czero
               do i=1,infine
                  ii = indexb(i)
                  dvol(ii)=dvol(ii)+dvdrho(i)*wrhof(i)
               enddo
            else
               !
               call xplasma_integ_work(eqi_intg_vol,size(thvec),thvec,wth, &
                    2,thzon1,insurfs,rho_int,rhomin, &
                    cache_init,cache,dvdrho,bmaxa,zwk,ier) ! dvdrho not used
               dvol(1:inzons)=zwk(2:insurfs)-zwk(1:inzons)
            endif

            if(ier.eq.0) then
               call xplasma_integ_dva(s,idi,iertmp, dvol=dvol)
               if(iret_vol) then
                  dvol_out = dvol
                  if(present(iwarn_dvol)) iwarn_dvol=0
               endif
            endif

         endif
         if(ier.ne.0) exit

         !  pre-fetch dV/drho if needed...
         !  note-- if no cache with integrator, then the dVdrho integral
         !  must be evaluated in order to fill the local cache with local
         !  dV/drho variation information-- hence ".or.ilocal".

         if(dvdrho_need.and.((.not.dvdrho_avail).or.ilocal)) then

            if(ilfine) then
               ier=9999
               call xplasma_errmsg_append(s, &
                    ' ? xplasma_flxint internal error: ilfine.and.dvdrho_need')
               exit
            endif

            call xplasma_integ_work(eqi_intg_dvdrho,size(thvec),thvec,wth, &
                 2,thzon1,insurfs,rho_int,rhomin, &
                 cache_init,cache,zwk,bmaxa,dvdrho,ier)  ! zwk not used..

            if((ier.eq.0).and.(.not.dvdrho_avail)) then
               call xplasma_integ_dva(s,idi,iertmp, dvdrho=dvdrho)
               if(iret_dvdrho) then
                  dvdrho_out = dvdrho
                  if(present(iwarn_dvdrho)) iwarn_dvdrho=0
               endif
            endif

         endif
         if(ier.ne.0) exit

         !  now evaluate the requested integral or average...

         if(inum.eq.eqi_intg_vol) then

            result(1)=0
            do i=2,insurfs
               result(i)=result(i-1)+dvol(i-1)
            enddo

         else if(inum.eq.eqi_intg_dvol) then

            result = dvol

         else if(inum.eq.eqi_intg_dvdrho) then

            result = dvdrho

         else if(ilsurf)then

            if(ilfine) then
               ier=9999
               call xplasma_errmsg_append(s, &
                    ' ? xplasma_flxint internal error: ilfine.and.ilsurf')
               exit
            endif

            inumu=inum
            if(inumu.eq.eqi_intg_darea) inumu=eqi_intg_area ! use Gauss form.

            call xplasma_integ_work(inumu,size(thvec),thvec,wth, &
                 2,thzon1,insurfs,rho_int,rhomin, &
                 cache_init,cache,dvdrho,bmaxa,zwk,ier)

            if(inum.eq.eqi_intg_darea) then
               result(1:inzons)=zwk(2:insurfs)-zwk(1:inzons)
            else
               result(1:insurfs) = zwk(1:insurfs)
            endif

         else

            if(.not.ilfine) then
               ier=9999
               call xplasma_errmsg_append(s, &
                    ' ? xplasma_flxint internal error: .not.(ilfine.or.ilsurf)')
               exit
            endif

            call xplasma_integ_work(inum,size(thvec),thvec,wth, &
                 2,thzon1,infine,rhofine,rhomin, &
                 cache_init,cache,dvdrho,bmaxa,zwk,ier)

            result=czero
            do i=1,infine
               ii=indexb(i)
               if(dvol_need) then
                  result(ii)=result(ii)+dvdrho(i)*zwk(i)*wrhof(i)
               else
                  result(ii)=result(ii)+zwk(i)*wrhof(i)
               endif
            enddo
            if(dvol_need) then
               do i=1,inzons
                  result(i)=result(i)/dvol(i)
               enddo
            endif

         endif
         exit
      enddo

      if(.not.ilfine) then
         if((ier.eq.0).and.bmaxa_need.and.(.not.bmaxa_avail)) then
            ! Bmax(rho) was computed
            call xplasma_integ_dva(s,idi,iertmp, bmaxa=bmaxa)
         endif
      endif

      deallocate(rho_brk,rho_int,dvol,dvdrho,bmaxa)
      if(allocated(zwk)) deallocate(zwk)
      if(ilocal) then
         deallocate(cache)
         if(ilfine) deallocate(rhofine,wrhof,indexb)
      else
         !  record cache markers (saved with integrator dataset).
         if(ier.eq.0) call xplasma_integ_scache(s,idi,cache_init,ier)
      endif

      nullify(thvec,wth,cache)

    end subroutine xplasma_rho_zonint

    subroutine xplasma_2d_zonint(s,idi,int_name,result,ier, &
         dvol_out,iwarn_dvol,dvdrho_out,iwarn_dvdrho)

      ! integrator -- 2d domain; return integrations or averages
      !   over theta^rho zones or across theta zones at rho surfaces.

      type (xplasma), pointer :: s
      integer, intent(in) :: idi ! integrator data structure ("black box") id
      character*(*),intent(in) :: int_name ! name of desired integration
      real*8, dimension(:,:), intent(out) :: result
      integer, intent(out) :: ier  ! status code 0=OK

      ! result is dimension [#theta-zones,#rho-zones] or
      !        [#theta-zones,#rho-surfaces] according as the integrand
      !        specified is zone oriented or surface oriented.
      !          The #zones are defined when the integrator dataset (idi)
      !          is defined.

      !  ** optional outputs **

      real*8, dimension(:,:), optional :: dvol_out   ! zone volumes
      integer, intent(out), optional :: iwarn_dvol   ! =0 if zone volumes OK
      ! iwarn_dvol=1: zone volumes not available; =2: array dimension error.

      real*8, dimension(:,:), optional :: dvdrho_out ! dV/drho @ surfaces
      integer, intent(out), optional :: iwarn_dvdrho ! =0 if dV/drho OK
      ! iwarn_dvdrho=1: dV/drho not available; =2: array dimension error.

      ! Options for integrands is the same as for xplasma_rho_zonint;
      ! Surface oriented results e.g. LPOL are on rho surfaces at each theta 
      ! zone;
      ! Zone orented results e.g. dVol are on rho^theta zones.

      !-----------------------------------
      real*8, dimension(:), allocatable :: rho_int,rho_brk,th_int
      real*8, dimension(:,:), allocatable :: dvol_2d,dvdrho_2d
      real*8, dimension(:), allocatable :: bmaxa
      real*8 :: rhomin

      integer :: inzons,insurfs,isizer,isizei,ilen,iertmp,i,j,ii,inum
      integer :: inzonb,inthzons,inthbdys,isizeth,ith
      integer :: inrho_brk,infine
      logical :: dvol_need,dvdrho_need,ilfine
      logical :: bmaxa_need

      character*32 zname,iiname
      character*128 zmsg
      real*8, parameter :: c2pi = 6.2831853071795862D+00
      real*8, dimension(:,:), allocatable :: zwk
      real*8, dimension(:), allocatable :: rhofine,wrhof
      real*8, dimension(:), pointer :: thvec,wth,cache
      integer, dimension(:), allocatable :: indexb
      integer :: cache_size
      logical :: cache_init(eqi_intg_nfi),ilsurf,ilocal
      logical :: iret_vol,iret_dvdrho
      !-----------------------------------
      !  info on the integrator dataset

      result=0

      call xplasma_integ_info(s,idi,ier, &
           n_rho_int = insurfs, &
           n_rho_brk = inrho_brk, &
           n_th_int = inthbdys)
      
      if(ier.ne.0) return

      inzons=insurfs-1
      inzonb=inrho_brk-1
      inthzons=inthbdys-1

      iret_vol=.FALSE.
      if(present(iwarn_dvol)) iwarn_dvol=1  ! for now...
      if(present(dvol_out)) then
         dvol_out=0
         if((size(dvol_out,1).eq.inthzons).and. &
              (size(dvol_out,2).eq.inzons)) then
            iret_vol=.TRUE.
         else
            if(present(iwarn_dvol)) iwarn_dvol=2  ! array size error
         endif
      endif

      iret_dvdrho=.FALSE.
      if(present(iwarn_dvdrho)) iwarn_dvdrho=1  ! for now...
      if(present(dvdrho_out)) then
         dvdrho_out=0
         if((size(dvdrho_out,1).eq.inthzons).and. &
              (size(dvdrho_out,2).eq.insurfs)) then
            iret_dvdrho=.TRUE.
         else
            if(present(iwarn_dvdrho)) iwarn_dvdrho=2  ! array size error
         endif
      endif

      allocate(rho_int(insurfs),rho_brk(inrho_brk),th_int(inthbdys), &
           dvol_2d(inthzons,inzons),dvdrho_2d(inthzons,insurfs),bmaxa(insurfs))
      dvol_2d=0; dvdrho_2d=0; bmaxa=0

      do 

         ! note local cache only for 2d integration...
         ilocal = .FALSE.   ! set .TRUE. after allocation

         call xplasma_integ_info(s,idi,ier, &
              rho_int=rho_int,rho_brk=rho_brk,th_int=th_int, &
              thvec_ptr=thvec, thwts_ptr=wth, rhomin=rhomin)
      
         if(ier.ne.0) exit

         zname = int_name
         call uupper(zname)
         ilen = len(trim(zname))

         !-----------------------
         sp => s   ! *** so integrand routines can see s *** cf eqi_intg_module
         !-----------------------

         call xplasma_integ_num(zname,inum,ilsurf, &
              dvol_need,dvdrho_need,bmaxa_need)

         if(inum.eq.0) then
            call xplasma_errmsg_append(s, &
                 '  unrecognized integration name:  "'//trim(int_name)//'".')
            ier=611
            exit
         endif

         if((inum.eq.eqi_intg_vol).or.(inum.eq.eqi_intg_area)) then
            call xplasma_errmsg_append(s,' error in xplasma_2d_zonint:')
            call xplasma_errmsg_append(s, &
                 '  integration name invalid for 2d integration:  "'//trim(int_name)//'".')
            ier=611
            exit
         endif

         nullify(cache)

         if(ilsurf) then
            ilfine=.FALSE.
            infine=0
            cache_size=size(thvec)*insurfs*eqi_intg_nfi
         else
            ilfine=.TRUE.
            infine=10*inzonb
            cache_size=size(thvec)*infine*eqi_intg_nfi
         endif

         allocate(cache(cache_size))
         ilocal = .TRUE.   ! flags locally allocated CACHE
         cache_init = .FALSE.

         if((.not.ilsurf).or.(inum.eq.eqi_intg_darea).or.(dvol_need)) then
            infine=10*inzonb
            allocate(rhofine(infine),wrhof(infine))
            call xplasma_integ_mkvec(inrho_brk,rho_brk,rhofine,wrhof)
            allocate(indexb(infine))
            call xplasma_integ_mkindex(insurfs,rho_int, &
                 infine,rhofine,indexb)
         endif

         isizeth=size(result,1)
         isizer=size(result,2)
         if(ilsurf) then
            isizei=insurfs
         else
            isizei=inzons
         endif

         !  check expected size of result against size of array provided...

         if((inum.eq.eqi_intg_dvol).or.(inum.eq.eqi_intg_darea)) then
            if(isizer.ne.inzons) then
               ier=610
               isizei=inzons
            endif
         else if(isizer.ne.isizei) then
            ier=610
         endif

         if(isizeth.ne.inthzons) ier=610

         if(ier.ne.0) then

            zmsg=' '
            call xplasma_get_item_info(s,idi,iertmp, name=iiname)
            write(zmsg,*) '  integrator dataset name: ',trim(iiname)
            call xplasma_errmsg_append(s,zmsg)

            call xplasma_errmsg_append(s, &
                 '  integrand name: "'//trim(int_name)//'".')

            zmsg=' '
            write(zmsg,*) '  expected size of 2d result (dim1): ',inthzons
            call xplasma_errmsg_append(s,zmsg)

            zmsg=' '
            write(zmsg,*) '  result(dim1) size is: ',isizeth
            call xplasma_errmsg_append(s,zmsg)
            
            zmsg=' '
            write(zmsg,*) '  expected size of 2d result (dim2): ',isizei
            call xplasma_errmsg_append(s,zmsg)

            zmsg=' '
            write(zmsg,*) '  size of result(dim2) is: ',isizer

            exit
         endif

         if(ilfine) then
            allocate(zwk(inthzons,infine))
            deallocate(bmaxa,dvdrho_2d)
            allocate(bmaxa(infine)); bmaxa=czero
            allocate(dvdrho_2d(inthzons,infine))
         else
            allocate(zwk(inthzons,insurfs))
         endif

         if(ilfine.and.dvol_need) then
            call xplasma_integ_work(eqi_intg_dvdrho,size(thvec),thvec,wth, &
                 inthbdys,th_int,infine,rhofine,rhomin, &
                 cache_init,cache,zwk,bmaxa,dvdrho_2d,ier)  ! zwk not used
            if(ier.ne.0) exit
         endif

         if(dvol_need) then

            if(ilfine) then
               dvol_2d=czero
               do i=1,infine
                  ii = indexb(i)
                  do ith=1,inthzons
                     dvol_2d(ith,ii)=dvol_2d(ith,ii)+dvdrho_2d(ith,i)*wrhof(i)
                  enddo
               enddo
            else
               ! dvdrho_2d not used...:
               call xplasma_integ_work(eqi_intg_vol,size(thvec),thvec,wth, &
                    inthbdys,th_int,insurfs,rho_int,rhomin, &
                    cache_init,cache,dvdrho_2d,bmaxa,zwk,ier)
               if(ier.eq.0) then
                  call xplasma_integ_gwork(eqi_intg_dvol,inthbdys,th_int, &
                       insurfs,rho_int,infine,rhofine,wrhof,indexb, &
                       zwk,dvol_2d,ier)
               endif
            endif

            if(iret_vol) then
               dvol_out=dvol_2d
               if(present(iwarn_dvol)) iwarn_dvol=0
            endif

         endif
         if(ier.ne.0) exit

         !  pre-fetch dV/drho if needed...
         !  note-- if no cache with integrator, then the dVdrho integral
         !  must be evaluated in order to fill the local cache with local

         if(dvdrho_need) then

            if(ilfine) then
               ier=9999
               call xplasma_errmsg_append(s, &
                    ' ? xplasma_flxint internal error: ilfine.and.dvdrho_need')
               exit
            endif

            call xplasma_integ_work(eqi_intg_dvdrho,size(thvec),thvec,wth, &
                 inthbdys,th_int,insurfs,rho_int,rhomin, &
                 cache_init,cache,zwk,bmaxa,dvdrho_2d,ier)  ! zwk not used..

            if(iret_dvdrho) then
               dvdrho_out=dvdrho_2d
               if(present(iwarn_dvdrho)) iwarn_dvdrho=0
            endif

         endif
         if(ier.ne.0) exit

         !  now evaluate the requested integral or average...

         if(inum.eq.eqi_intg_dvol) then

            result = dvol_2d

         else if(inum.eq.eqi_intg_dvdrho) then

            result = dvdrho_2d

         else if(ilsurf) then

            if(ilfine) then
               ier=9999
               call xplasma_errmsg_append(s, &
                    ' ? xplasma_flxint internal error: ilfine.and.ilsurf')
               exit
            endif

            if(inum.eq.eqi_intg_darea) then
               !  compute rho=const. Gaussian segments...
               call xplasma_integ_work(eqi_intg_area,size(thvec),thvec,wth, &
                    inthbdys,th_int,insurfs,rho_int,rhomin, &
                    cache_init,cache,dvdrho_2d,bmaxa,zwk,ier)
               if(ier.ne.0) exit
               !  compute theta=const. Gaussian segments and combine...
               call xplasma_integ_gwork(eqi_intg_darea,inthbdys,th_int, &
                    insurfs,rho_int,infine,rhofine,wrhof,indexb, &
                    zwk,result,ier)
               if(ier.ne.0) exit

            else
               call xplasma_integ_work(inum,size(thvec),thvec,wth, &
                    inthbdys,th_int,insurfs,rho_int,rhomin, &
                    cache_init,cache,dvdrho_2d,bmaxa,zwk,ier)
               if(ier.ne.0) exit
               result(1:inthzons,1:insurfs) = zwk(1:inthzons,1:insurfs)

            endif

         else

            if(.not.ilfine) then
               ier=9999
               call xplasma_errmsg_append(s, &
                    ' ? xplasma_flxint internal error: .not.(ilfine.or.ilsurf)')
               exit
            endif

            call xplasma_integ_work(inum,size(thvec),thvec,wth, &
                 inthbdys,th_int,infine,rhofine,rhomin, &
                 cache_init,cache,dvdrho_2d,bmaxa,zwk,ier)

            result=czero
            do i=1,infine
               ii=indexb(i)
               if(dvol_need) then
                  do ith=1,inthzons
                     result(ith,ii)=result(ith,ii)+ &
                          dvdrho_2d(ith,i)*zwk(ith,i)*wrhof(i)
                  enddo
               else
                  do ith=1,inthzons
                     result(ith,ii)=result(ith,ii)+zwk(ith,i)*wrhof(i)
                  enddo
               endif
            enddo
            if(dvol_need) then
               do i=1,inzons
                  do ith=1,inthzons
                     result(ith,i)=result(ith,i)/dvol_2d(ith,i)
                  enddo
               enddo
            endif

         endif
         exit
      enddo

      deallocate(rho_brk,rho_int,th_int,dvol_2d,dvdrho_2d,bmaxa)
      if(allocated(zwk)) deallocate(zwk)

      if(ilocal) then
         deallocate(cache)
      else
         !  record cache markers (saved with integrator dataset).
         if(ier.eq.0) call xplasma_integ_scache(s,idi,cache_init,ier)
      endif

      if(infine.gt.0) then
         deallocate(rhofine,wrhof,indexb)
      endif

      nullify(thvec,wth,cache)

    end subroutine xplasma_2d_zonint

    subroutine xplasma_integ_eligible(sp,integ_name,id,ier)

      ! determine if a named function (integ_name) is eligible for 
      ! integration.  At present, this means a function f(rho,theta)
      ! or f(theta,rho).  Eligibility may be extended beyond this at
      ! some point in the future, if the need arises.

      type (xplasma), pointer :: sp
      character*(*), intent(in) :: integ_name  ! name of profile
      integer, intent(out) :: id               ! id of profile if eligible
      integer, intent(out) :: ier              ! status code

      ! if the function is not eligible, id=0 and ier=611 are returned.
      !------------------------------

      character*32 iname

      integer :: iertmp,itype,idx1,idx2,idx3,idcf,icoord,id_R,idcR
      logical :: iok
      !------------------------------

      iname = integ_name
      call uupper(iname)

      call xplasma_find_item(sp,iname,id,iertmp)

      if(id.gt.0) then
         call xplasma_get_item_info(sp,id,iertmp, itype=itype)

         if(itype.eq.xplasma_profType) then
            ! is is a profile-- see if dependents coordinates are (rho,th)

            call xplasma_prof_info(sp,id,iertmp, & 
                 gridId1=idx1, gridId2=idx2, gridId3=idx3, counter=idcf)

            iok=.TRUE.
            call xplasma_grid_info(sp,idx1,iertmp, coord=icoord)
            if(.not.((icoord.eq.xplasma_rho_coord).or. &
                 (icoord.eq.xplasma_theta_coord))) iok=.FALSE.

            call xplasma_grid_info(sp,idx2,iertmp, coord=icoord)
            if(.not.((icoord.eq.xplasma_rho_coord).or. &
                 (icoord.eq.xplasma_theta_coord))) iok=.FALSE.

            if(idx3.gt.0) iok=.FALSE.

            if(.not.iok) then
               call xplasma_errmsg_append(sp, &
                    ' cannot flux surface average profile <'// &
                    iname//'> -- not defined vs. (rho,theta)')
               id = 0
            else
               call xplasma_common_ids(sp,iertmp, id_R=id_R)
               call xplasma_prof_info(sp,id_R,iertmp, counter=idcR)

               if(idcR.gt.idcf) then
                  call xplasma_errmsg_append(sp, &
                       ' cannot flux surface average profile <'// &
                       iname// &
                       '> -- stale, not updated since equilibrium change.')

                  id = 0

               else

                  continue

               endif
            endif

         else
            call xplasma_errmsg_append(sp,'  '//trim(iname)//' not a profile.')
            id=0
         endif
      endif

      if(id.eq.0) ier=611

    end subroutine xplasma_integ_eligible

    subroutine xplasma_rhogrid_dva(s,idrho,ierr, dvol, darea)

      !  retrieve volume elements associated with a grid

      type(xplasma), pointer :: s
      integer, intent(in) :: idrho                ! grid ID
      integer, intent(out) :: ierr                ! completion code, 0=OK

      real*8, dimension(:), intent(out), optional :: dvol   ! volume elements
      real*8, dimension(:), intent(out), optional :: darea  ! area elements
      !---------------------------------------
      character*32 gname,bbname,iname
      character*128 zmsg
      integer :: idbb,idi,inx,iz,inz,icoord,iertmp,idum(4),itype
      real*8, dimension(:), pointer :: r8buf
      real*8, dimension(:), allocatable :: rhogrid
      !---------------------------------------

      if(present(dvol)) dvol=0
      if(present(darea)) darea=0

      call xplasma_grid_info(s,idrho,ierr, size=inx, coord=icoord, name=gname)

      !  the idrho argument must point to a rho grid...
      if((ierr.ne.0).or.(icoord.ne.xplasma_rho_coord)) then
         call xplasma_errmsg_append(s, &
              ' ?xplasma_rhogrid_dva: subroutine argument idrho: not a rho grid.')
         ierr=9999
         return
      endif

      !  the number of zones in the rhogrid (size of grid - 1) must match
      !  the passed array size

      inz=inx-1
      if(present(dvol)) then
         if(size(dvol).ne.inz) then
            zmsg=' '
            write(zmsg,'(" ?xplasma_rhogrid_dva: mismatch: #zones in grid = ",i4,"; dVol array size = ",i4)') &
                 inz,size(dvol)
            call xplasma_errmsg_append(s,zmsg)
            ierr=9999
            return
         endif
      endif

      if(present(darea)) then
         if(size(darea).ne.inz) then
            zmsg=' '
            write(zmsg,'(" ?xplasma_rhogrid_dva: mismatch: #zones in grid = ",i4,"; darea array size = ",i4)') &
                 inz,size(darea)
            call xplasma_errmsg_append(s,zmsg)
            ierr=9999
            return
         endif
      endif


      !  OK:  look up blackbox.  If not found, compute it.

      bbname = '__DVA_'//trim(gname)
      call xplasma_blkbxId(s,bbname,idbb)

      if(idbb.eq.0) then

         !  compute the DVA structure

         iname = '__TMP_DVA'

         call xplasma_author_set(s,xplasma_xmhd,iertmp)

         allocate(rhogrid(inx))
         call xplasma_grid(s,idrho,rhogrid,iertmp)
         call xplasma_create_integ(s,iname,rhogrid,idi,ierr, &
              cache_enable=.TRUE.)
         deallocate(rhogrid)

         if(ierr.ne.0) then
            call xplasma_errmsg_append(s, &
                 '?integrator creation failed in xplasma_rhogrid_dva')
            call xplasma_author_clear(s,xplasma_xmhd,iertmp)
            return
         endif

         idum=0
         itype=15  ! arb. type code

         allocate(r8buf(2*inz))

         call xplasma_rho_zonint(s,idi,'dVol',r8buf(1:inz),iertmp)
         call xplasma_rho_zonint(s,idi,'dArea',r8buf(inz+1:2*inz),ierr)

         ierr=max(ierr,iertmp)
         if(ierr.ne.0) then
            call xplasma_errmsg_append(s, &
                 '?integrator execution failed in xplasma_rhogrid_dva')
         endif

         if(ierr.eq.0) then
            call xplasma_create_blackBox(s,bbname,itype,idbb,ierr, &
                 iarray=idum,r8array=r8buf, &
                 label='dVol and dArea for '//trim(gname),units='mixed MKS')
         endif

         ! cleanup

         deallocate(r8buf)
         call xplasma_remove_item(s,idi,iertmp)
         call xplasma_author_clear(s,xplasma_xmhd,iertmp)

         if(ierr.ne.0) then
            call xplasma_errmsg_append(s,'error in xplasma_rhogrid_dva')
            return
         endif

      endif

      call xplasma_blackBox_retrieve(s,idbb,iertmp, r8a_ptr = r8buf)

      do iz=1,inz
         if(present(dvol)) dvol(iz)=r8buf(iz)
         if(present(darea)) darea(iz)=r8buf(inz+iz)
      enddo

    end subroutine xplasma_rhogrid_dva

    subroutine xplasma_rhoth_grid_dva(s,idg1,idg2,ierr, ccwflag, dvol, darea)

      !  retrieve volume elements associated with combined (rho,th) grids
      !    idg1 can be rho or th; idg2 can be th or rho
      !    to reverse th ordering in output, set ccwflag=.FALSE.

      type(xplasma), pointer :: s
      integer, intent(in) :: idg1,idg2            ! grid IDs
      integer, intent(out) :: ierr                ! completion code, 0=OK

      logical, intent(in), optional :: ccwflag    ! .TRUE. means 
      ! theta is oriented counter-clockwise, as in xplasma2 internal variables;
      ! .FALSE. means clockwise orientation; th index reversal required.

      real*8, dimension(:,:), intent(out), optional :: dvol   ! volume elements
      real*8, dimension(:,:), intent(out), optional :: darea  ! area elements

      !------------------------------------------------------------
      character*32 gname1,gname2,rhoname,thname,bbname,iname,iname2
      character*128 zmsg
      integer :: idbb,idi,idi2,inx1,inx2,icoord1,icoord2,idum(4),itype
      integer :: idrho,idth,inrho,inth,ith,irho,ibuf,ithx
      integer :: ier1,ier2,iertmp
      real*8, dimension(:), pointer :: r8buf
      real*8, dimension(:), allocatable :: rhogrid,thgrid
      real*8, dimension(:,:), allocatable :: zdva
      logical :: iccwflag,rhofirst
      !------------------------------------------------------------

      if(present(dVol)) dVol=0
      if(present(dArea)) dArea=0

      iccwflag = .TRUE.
      if(present(ccwflag)) iccwflag = ccwflag

      call xplasma_grid_info(s,idg1,ier1, size=inx1, coord=icoord1, &
           name=gname1)

      call xplasma_grid_info(s,idg2,ier2, size=inx2, coord=icoord2, &
           name=gname2)

      ierr=max(ier1,ier2)
      if(ierr.ne.0) then
         call xplasma_errmsg_append(s, &
              ' ?xplasma_rhoth_grid_dva: invalid grid IDs received.')
         return
      endif

      if((icoord1.eq.icoord2).or. &
           ((icoord1.ne.xplasma_rho_coord).and.(icoord1.ne.xplasma_theta_coord)).or. &
           ((icoord2.ne.xplasma_rho_coord).and.(icoord2.ne.xplasma_theta_coord))) then
         zmsg = ' ?xplasma_rhoth_grid_dva: "rho" and/or "theta" grid missing: '//trim(gname1)//' '//trim(gname2)
         call xplasma_errmsg_append(s,zmsg)
         ierr=9999
         return
      endif

      if(present(dVol)) call checksize(dVol,'dVol')
      if(present(dArea)) call checksize(dArea,'dArea')
      if(ierr.ne.0) return

      !  OK:  look up blackbox.  If not found, compute it.

      if(icoord1.eq.xplasma_rho_coord) then
         rhoname=gname1
         inrho=inx1
         idrho=idg1
         thname=gname2
         inth=inx2
         idth=idg2
         rhofirst = .TRUE.
      else
         rhoname=gname2
         inrho=inx2
         idrho=idg2
         thname=gname1
         inth=inx1
         idth=idg1
         rhofirst = .FALSE.
      endif

      bbname = '__DVA_'//trim(thname)//'_'//trim(rhoname)
      call xplasma_blkbxId(s,bbname,idbb)

      if(idbb.eq.0) then

         !  compute the DVA structure

         iname = '__TMP_DVA'
         iname2= '__TMP_DVA2'

         call xplasma_author_set(s,xplasma_xmhd,iertmp)

         allocate(rhogrid(inrho))
         call xplasma_grid(s,idrho,rhogrid,iertmp)

         allocate(thgrid(inth))
         call xplasma_grid(s,idth,thgrid,iertmp)

         call xplasma_create_integ(s,iname,rhogrid,idi,ierr, &
              cache_enable=.TRUE.)

         if(ierr.ne.0) then
            call xplasma_errmsg_append(s, &
                 '?integrator creation failed in xplasma_rhoth_grid_dva')
            call xplasma_author_clear(s,xplasma_xmhd,iertmp)
            deallocate(rhogrid,thgrid)
            return
         endif

         call xplasma_augment_integ(s,iname2,idi,thgrid,idi2,ierr)

         if(ierr.ne.0) then
            call xplasma_errmsg_append(s, &
                 '?integrator augmentation failed in xplasma_rhoth_grid_dva')
            call xplasma_author_clear(s,xplasma_xmhd,iertmp)
            deallocate(rhogrid,thgrid)
            return
         endif

         idum=0
         itype=14  ! arb. type code

         allocate(r8buf(2*(inrho-1)*(inth-1)),zdva(inth-1,inrho-1))

         ibuf=0
         call xplasma_2d_zonint(s,idi2,'dVol',zdva,iertmp)
         do irho=1,inrho-1
            do ith=1,inth-1
               ibuf=ibuf+1
               r8buf(ibuf)=zdva(ith,irho)
            enddo
         enddo

         call xplasma_2d_zonint(s,idi2,'dArea',zdva,ierr)
         do irho=1,inrho-1
            do ith=1,inth-1
               ibuf=ibuf+1
               r8buf(ibuf)=zdva(ith,irho)
            enddo
         enddo

         ierr=max(ierr,iertmp)
         if(ierr.ne.0) then
            call xplasma_errmsg_append(s, &
                 '?integrator execution failed in xplasma_rhoth_grid_dva')
         endif

         if(ierr.eq.0) then
            call xplasma_create_blackBox(s,bbname,itype,idbb,ierr, &
                 iarray=idum,r8array=r8buf, &
                 label='dVol and dArea for '//trim(thname)//'x'//trim(rhoname), &
                 units='mixed MKS')
         endif

         ! cleanup

         deallocate(r8buf,zdva,rhogrid,thgrid)
         call xplasma_remove_item(s,idi2,iertmp)
         call xplasma_remove_item(s,idi,iertmp)
         call xplasma_author_clear(s,xplasma_xmhd,iertmp)

         if(ierr.ne.0) then
            call xplasma_errmsg_append(s,'error in xplasma_rhogrid_dva')
            return
         endif

      endif

      call xplasma_blackBox_retrieve(s,idbb,iertmp, r8a_ptr = r8buf)

      if(present(dVol)) then
         ibuf=0
         do irho=1,inrho-1
            do ith=1,inth-1
               ithx=ith
               if(.not.ccwflag) ithx=inth-ith
               ibuf=ibuf+1
               if(rhofirst) then
                  dvol(irho,ithx)=r8buf(ibuf)
               else
                  dvol(ithx,irho)=r8buf(ibuf)
               endif
            enddo
         enddo
      endif

      if(present(dArea)) then
         ibuf=(inth-1)*(inrho-1)
         do irho=1,inrho-1
            do ith=1,inth-1
               ithx=ith
               if(.not.ccwflag) ithx=inth-ith
               ibuf=ibuf+1
               if(rhofirst) then
                  darea(irho,ithx)=r8buf(ibuf)
               else
                  darea(ithx,irho)=r8buf(ibuf)
               endif
            enddo
         enddo
      endif

      contains
        subroutine checksize(arr2d,aname)

          ! verify that arr2d dimensions are correct

          real*8, dimension(:,:), intent(in) :: arr2d
          character*(*), intent(in) :: aname

          if((size(arr2d,1).ne.(inx1-1)).or.(size(arr2d,2).ne.(inx2-1))) then

             call xplasma_errmsg_append(s, &
                  '?xplasma_rhoth_grid_dva: '//aname//' array size error:')
             zmsg=' '
             write(zmsg,1001) '1st',size(arr2d,1),(inx1-1)
             call xplasma_errmsg_append(s,zmsg)
             zmsg=' '
             write(zmsg,1001) '2nd',size(arr2d,2),(inx2-1)
             call xplasma_errmsg_append(s,zmsg)
             ierr=9999
          endif
1001      format(3x,'2d array ',a,' dimension size: ',i4,'; expected: ',i4)

        end subroutine checksize

    end subroutine xplasma_rhoth_grid_dva

end module xplasma_flxint

      INTEGER FUNCTION MCSTR_INDEX(STR,SUBSTR,N)
C
C  FIND THE NTH OCCURRENCE OF SUBSTR IN STR
C  RETURN ZERO IF NOT FOUND;
C  RETURN THE CHARACTER INDEX OF THE START OF NTH OCCURRENCE OF SUBSTR
C  IN STR IF FOUND
C
C  ALL OF SUBSTR IS USED I.E. TRAILING BLANKS COUNT
C
      CHARACTER*(*) STR
      CHARACTER*(*) SUBSTR
C
      LSTR=LEN(STR)
C
      IFIND=0
      ICT=N+1
C
C  LOOP -----
C
 10   CONTINUE
C
      ICT=ICT-1
      IF(ICT.LE.0) GO TO 100
C
      ISTART=IFIND+1
C
      IF(ISTART.GT.LSTR) THEN
        IFIND=0
        GO TO 100
      ELSE
C  NEXT OCCURRENCE
        IFIND=INDEX(STR(ISTART:LSTR),SUBSTR)
        IF(IFIND.EQ.0) GO TO 100
        IFIND=IFIND+ISTART
      ENDIF
      GO TO 10
C
C  EXIT -----
C
 100  CONTINUE
      MCSTR_INDEX=IFIND
      RETURN
      END

SUBROUTINE scrgctnorm(r,y,n,i,vec,inorm)
  !
  !  return normal vector, normalized to unit length if inorm=1
  !
  !  inputs:  (R(j),Y(j)), j going from 1 to n, describes a closed contour,
  !           with periodicity, i.e. one can think of
  !                  (R(n+1),Y(n+1)) = (R(1),Y(1))
  !           i     -- the point where the normal vector is desired
  !           inorm -- flags whether output vector is to be normalized
  !
  !  output:  vec(2) gives the numerically evaluated vector normal to the
  !           contour at point i.
  !
  use iso_c_binding, only: fp => c_double
  implicit none
  real(fp) :: zd
  integer :: inorm
  real(fp) :: zdely
  real(fp) :: zdelr
  integer :: imins
  integer :: i
  integer :: iplus
  integer :: n
  real(fp), dimension(n) :: r, y
  real(fp), dimension(2) :: vec
  !
  !-----------------------------
  !
  iplus=i+1
  if(iplus.gt.n) iplus=iplus-n
  imins=i-1
  if(imins.lt.1) imins=imins+n
  !
  zdelr=r(iplus)-r(imins)
  zdely=y(iplus)-y(imins)
  !
  vec(1)=zdely
  vec(2)=-zdelr
  !
  if(inorm.eq.1) then
    zd=sqrt(vec(1)**2+vec(2)**2)
    vec(1)=vec(1)/zd
    vec(2)=vec(2)/zd
  endif
  !
  return
end SUBROUTINE scrgctnorm

!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL interface to:  EQ_FRHOCHI
      SUBROUTINE R4_EQ_FRHOCHI(
     > IVEC,R4_ZRHO,R4_ZCHI,NLIST,IFLIST,IVECD,R4_ZANS,IERR)
 
      external EQ_FRHOCHI
 
! argument declarations
      INTEGER IVEC
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
 ! floating type, input only:
      REAL R4_ZRHO(abs(IVEC))
 
 ! floating type, input only:
      REAL R4_ZCHI(abs(IVEC))
 
      INTEGER IFLIST(NLIST)
 ! floating type, output only:
      REAL R4_ZANS(IVECD,NLIST)
 
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL*8, allocatable :: ZRHO_act(:)
      REAL*8, allocatable :: ZCHI_act(:)
      REAL*8, allocatable :: ZANS_act(:,:)
 
! allocation of working arrays...
 
      ALLOCATE(ZRHO_act(abs(IVEC))
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_EQ_FRHOCHI -- ZRHO_act ALLOCATE error!')
      ALLOCATE(ZCHI_act(abs(IVEC))
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_EQ_FRHOCHI -- ZCHI_act ALLOCATE error!')
      ALLOCATE(ZANS_act(IVECD,NLIST)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_EQ_FRHOCHI -- ZANS_act ALLOCATE error!')
 
! executable code:  copy for input
 
      ZRHO_act=R4_ZRHO
      ZCHI_act=R4_ZCHI
      ZANS_act=0
! call to original routine:  EQ_FRHOCHI
 
      CALL EQ_FRHOCHI(
     > IVEC,ZRHO_act(1),ZCHI_act(1),NLIST,IFLIST,IVECD,ZANS_act(1,1),
     > IERR)
 
! copy back outputs if modified.
      DEALLOCATE(ZRHO_act)
      DEALLOCATE(ZCHI_act)
      R4_ZANS = ZANS_act
      DEALLOCATE(ZANS_act)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL interface to:  EQ_GRHOCHI
      SUBROUTINE R4_EQ_GRHOCHI(
     > IVEC,R4_ZRHO,R4_ZCHI,NLIST,IFLIST,IVECD,R4_ZANS,IERR)
 
      external EQ_GRHOCHI
 
! argument declarations
      INTEGER IVEC
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
 ! floating type, input only:
      REAL R4_ZRHO(abs(IVEC))
 
 ! floating type, input only:
      REAL R4_ZCHI(abs(IVEC))
 
      INTEGER IFLIST(NLIST)
 ! floating type, output only:
      REAL R4_ZANS(IVECD,2,NLIST)
 
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL*8, allocatable :: ZRHO_act(:)
      REAL*8, allocatable :: ZCHI_act(:)
      REAL*8, allocatable :: ZANS_act(:,:,:)
 
! allocation of working arrays...
 
      ALLOCATE(ZRHO_act(abs(IVEC))
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_EQ_GRHOCHI -- ZRHO_act ALLOCATE error!')
      ALLOCATE(ZCHI_act(abs(IVEC))
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_EQ_GRHOCHI -- ZCHI_act ALLOCATE error!')
      ALLOCATE(ZANS_act(IVECD,2,NLIST)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_EQ_GRHOCHI -- ZANS_act ALLOCATE error!')
 
! executable code:  copy for input
 
      ZRHO_act=R4_ZRHO
      ZCHI_act=R4_ZCHI
      ZANS_act=0
! call to original routine:  EQ_GRHOCHI
 
      CALL EQ_GRHOCHI(
     > IVEC,ZRHO_act(1),ZCHI_act(1),NLIST,IFLIST,IVECD,ZANS_act(1,1,1),
     > IERR)
 
! copy back outputs if modified.
      DEALLOCATE(ZRHO_act)
      DEALLOCATE(ZCHI_act)
      R4_ZANS = ZANS_act
      DEALLOCATE(ZANS_act)
 
! exit
      return
      end

      subroutine eq_fget(ivec,zrho,zchi,zphi,ifcn,
     >   fval,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated function f @ (rho,chi,phi)
c        ivec < 0 indicates reversed chi
c
      implicit NONE
c input:
      integer ivec                      ! vector dimensioning
      real*8 zrho(abs(ivec)),zchi(abs(ivec)),zphi(abs(ivec)) ! (rho,chi,phi) target coords
c
      integer ifcn                      ! xplasma fcn id, function wanted.
c
c output:
      real*8 fval(abs(ivec))                 ! the function values returned
      integer nregion(abs(ivec))             ! region code, 1= inside core
c
      integer ierr                      ! completion code, 0=OK
c
c--------------------------
c
      real*8 zR(abs(ivec)),zZ(abs(ivec))
c
c--------------------------
c
      call eqmap_fget(ivec,zrho,zchi,zphi,zR,zZ,ifcn,
     >   fval,nregion,ierr)
c
      return
      end
c---------------------------------------------------------------------
      subroutine eq_fgrad(ivec,zrho,zchi,zphi,irzmode,ifcn,
     >   fval,fgrad,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated function f @ (rho,chi,phi)
c        ivec < 0 indicates reversed chi
c  get gradient of f
c     if irzmode=1:  (df/dR,df/dZ,(1/R)*df/dphi) @ (rho,chi,phi)
c     if irzmode=0:  (df/dsperp,df/dschi,(1/R)*df/dphi) @ (rho,chi,phi)
c          where sperp = dl in direction normal to flux surface,
c                schi  = dl in chi direction, normal to phi & tangent
c                           to flux surface
c
      implicit NONE
c input:
      integer ivec                      ! vector dimensioning
      real*8 zrho(abs(ivec)),zchi(abs(ivec)),zphi(abs(ivec)) ! (rho,chi,phi) target coords
c
      integer irzmode                   ! =1: grad. vector in cyl coords.
c
      integer ifcn                      ! xplasma fcn id, function wanted.
c
c output:
      real*8 fval(abs(ivec))                 ! the function values returned
      real*8 fgrad(3,abs(ivec))              ! the function gradients returned
      integer nregion(abs(ivec))             ! region code, 1=inside core
c
      integer ierr                      ! completion code, 0=OK
c
c--------------------------
c
      real*8 zR(abs(ivec)),zZ(abs(ivec))
c
c--------------------------
c
      call eqmap_fgrad(ivec,zrho,zchi,zphi,zR,zZ,irzmode,ifcn,
     >   fval,fgrad,nregion,ierr)
c
      return
      end
C--------------------------------------------------------------------
      subroutine eqmap_fget(ivec,zrho,zchi,zphi,zR,zZ,
     >   ifcn,fval,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated function f @ (rho,chi,phi)
c        ivec < 0 indicates reversed chi
c
c  also return (R,Z) of target points
c
      IMPLICIT NONE
c
c  input:
      integer ivec                      ! vector dimensioning
      real*8 zrho(abs(ivec)),zchi(abs(ivec)),zphi(abs(ivec)) ! (rho,chi,phi) target coords
C
      integer ifcn                      ! function number
C
C  output:
      real*8 zR(abs(ivec)),zZ(abs(ivec))          ! (R,Z) of target points
      REAL*8 fval(abs(ivec))                 ! function value
C
      integer nregion(abs(ivec))             ! region code for (R,Z,phi) 1=inside
      integer ierr                      ! completion code, 0=OK
C
C--------------------------
C
      integer nlist
      integer imap
      REAL*8 zdum,ztol
      REAL*8 fgrad(3,abs(ivec))              ! (R,Z,phi) gradient of f
      logical :: ccwflag
      integer :: iveca
C
C--------------------------
C
      nlist=1
      ztol=0.0d0
      imap=2
      iveca=abs(ivec)
      ccwflag = ivec.gt.0
c
      call eqi_getall(iveca,ccwflag,zR,zZ,zphi,imap,zrho,zchi,ztol,0,
     >   0,zdum,zdum,nlist,ifcn,iveca,fval,fgrad,
     >   nregion,ierr)
C
      return
      end
C--------------------------------------------------------------------
      subroutine eqmap_fgrad(ivec,zrho,zchi,zphi,zR,zZ,irzmode,
     >   ifcn,fval,fgrad,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated function f @ (rho,chi,phi)
c        ivec < 0 indicates reversed chi
c  get gradient of f
c     if irzmode=1:  (df/dR,df/dZ,(1/R)*df/dphi) @ (rho,chi,phi)
c     if irzmode=0:  (df/dsperp,df/dschi,(1/R)*df/dphi) @ (rho,chi,phi)
c          where sperp = dl in direction normal to flux surface,
c                schi  = dl in chi direction, normal to phi & tangent
c                           to flux surface
c
c  also return (R,Z) of target points
c
      IMPLICIT NONE
c
c  input:
      integer ivec                      ! vector dimensioning
      real*8 zrho(abs(ivec)),zchi(abs(ivec)),zphi(abs(ivec)) ! (rho,chi,phi) target coords
c
      integer irzmode                   ! =1: grad. vector in cyl coords.
C
      integer ifcn                      ! function number
C
C  output:
      real*8 zR(abs(ivec)),zZ(abs(ivec))          ! (R,Z) of target points
      REAL*8 fval(abs(ivec))                 ! function values returned
      REAL*8 fgrad(3,abs(ivec))              ! function gradients returned
C
      integer nregion(abs(ivec))             ! region code for (R,Z,phi) 1=inside
      integer ierr                      ! completion code, 0=OK
C
C--------------------------
C
      integer nlist
      integer imap
      REAL*8 zdum,ztol
      logical :: ccwflag
      integer :: iveca,lunerr
C
C--------------------------
C
      if((irzmode.lt.0).or.(irzmode.gt.1)) then
         call eq_get_lunerr(lunerr)
         write(lunerr,*) ' ?eqmap_fget:  invalid irzmode=',irzmode
         ierr=1
      endif
c
      if(ierr.eq.1) then
         nregion=0
         fval=0.0d0
         return
      endif
c
      nlist=1
      imap=3-irzmode
      ztol=0.0d0
      iveca=abs(ivec)
      ccwflag = ivec.gt.0
c
      call eqi_getall(iveca,ccwflag,zR,zZ,zphi,imap,zrho,zchi,ztol,1,
     >   0,zdum,zdum,nlist,ifcn,iveca,fval,fgrad,
     >   nregion,ierr)
C
      return
      end

subroutine eqm_f1d(iorder,id_axis,zlbl,zdata, &
     ibc1,zbc1,ibc2,zbc2, &
     id_f1d,ierr)

  ! set up f(x); x = any valid grid

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  integer iorder                    ! interpolation order

  !  iorder = 0 -- piecewise linear
  !  iorder = 1 -- use Hermite piecewise cubics with Akima method for
  !     setting the derivative at the grid points (modified at the bdys)
  !  iorder = 2 or 3 -- use a cubic spline

  !  iorder = 1 -- once differentiable
  !  iorder = 2 or 3 -- twice differentiable (spline)

  !  iorder = 99 -- replacement data for existing f(x) object
  !    (interpolation order will match that of the original object)
  !    (id_axis must match that of the original object)

  !  iorder=100 -- piecewise linear data, may replace  same sized object
  !  iorder=101 -- Akima Hermite (may be replacement of same sized object)
  !  iorder=102 or 103 -- spline (may be replacement of same sized object)

  integer id_axis                   ! axis id -- any axis

  character*(*) zlbl                ! function name (label)
  REAL*8 zdata(*)                   ! data (size must match grid)

  integer ibc1                      ! bc @ 1st x
  real*8 zbc1                       ! bc parameter
  integer ibc2                      ! bc @ last x
  real*8 zbc2                       ! bc parameter

  !                =0:  "standard" boundary condition:  "not a knot" for
  !                     splines, Akima for piecewise Hermite.
  !                =1:  assigned df/dx bc, --> df/dx=zbc1|2
  !                =2:  assigned d2f/dx2 bc (splines only), d2f/dx2=zbc1|2

  !  for iorder.eq.0, bc controls are ignored.

  !  output:

  integer id_f1d                    ! function id, returned
  integer ierr                      ! completion code, 0=OK
  
  !-----------------------------
  integer :: icoord,iorderi,iertmp,inx,icount
  character*32 zname
  logical :: iforce = .FALSE.
  !-----------------------------

  ierr=0

  iorderi=iorder
  if(iorderi.lt.99) iorderi=max(0,min(2,iorderi))
  if(iorderi.ge.100) iorderi=max(0,min(2,(iorderi-100)))

  !  iorderi=99 gets special treatment below...

  !-----------------
  !  check axis id

  call xplasma_grid_info(s,id_axis,ierr, coord=icoord)

  if(ierr.ne.0) then
     call xplasma_error(s,ierr,lunerr)
     write(lunerr,*) &
          ' ?eqm_f1d ("',trim(zlbl),'"): id_axis=',id_axis,' invalid grid.'
     ierr=1
     return
  endif

  call xplasma_grid_size(s,id_axis,inx,iertmp)

  !-----------------
  !  iorderi=99 means request to use prior splining method for this call;
  !  this implies profile must already exist:  check...

  if(iorderi.eq.99) then
     call xplasma_find_item(s,zlbl,id_f1d,iertmp)
     if(iertmp.eq.0) then
        call xplasma_prof_info(s,id_f1d,ierr, splineType=iorderi)
     else
        ierr=iertmp
     endif
     if(ierr.ne.0) then
        call xplasma_error(s,ierr,lunerr)
        call eq_errmsg(' ?eqm_f1d: iorder=99 call failed: '//trim(zlbl)// &
             ' does not exist.')
        ierr=1
     endif
  endif
  if(ierr.ne.0) return

  !-----------------
  !  iorderi now contains the desired spline type in all cases, so...

  call xoi_author_set(iertmp)

  call xplasma_create_1dprof(s,zlbl,id_axis,zdata(1:inx),id_f1d,ierr, &
       iorderi,ibc1,zbc1,ibc2,zbc2)

  call xoi_author_clear(iertmp)

  if(ierr.ne.0) then
     call xplasma_error(s,ierr,lunerr)
     ierr=1
  endif

end subroutine eqm_f1d

subroutine eqi_geq_axis(nh,rgrid,nv,zgrid,psirz,nb,rbdy,zbdy, &
     rmaxis,zmaxis,Psiax,Psibdy,ierr)

  ! use Newton method to find magnetic axis at center min or max of Psi(R,Z)
  ! this is a root finder method using grad(Psi) -> 0 on axis

  ! return the adjusted axis location Psi(rmaxis,zmaxis) value as Psiax
  ! return the edge Psi value evaluate and averaged over the boundary contour

  !------------------
  ! mod DMC: Jan 2011: adding recovery code
  !   (deal with cases where 2d Newton search fails)
  !
  ! to do this, a shared module is created to contain Psi(R,Z) spline
  ! WARNING: thread safety not preserved, concurrent calls in a shared
  ! memory context not expected to survive...

  use eqi_geq_axis_data

  implicit NONE

  !------------------

  integer, intent(in) :: nh   ! R grid size & 1st dim of psiRZ
  integer, intent(in) :: nv   ! Z grid size & 2st dim of psiRZ

  real*8, intent(in) :: rgrid(nh)  ! R grid
  real*8, intent(in) :: zgrid(nv)  ! Z grid
  real*8, intent(in) :: psirz(nh,nv)  ! Psi(R,Z)

  integer, intent(in) :: nb   ! size of boundary contour
  real*8, intent(in) :: rbdy(nb),zbdy(nb)  ! the boundary contour

  !  on input, initial guess; on output, refined values:
  real*8, intent(inout) :: rmaxis  ! R of magnetic axis
  real*8, intent(inout) :: zmaxis  ! Z of magnetic axis

  real*8, intent(out) :: Psiax     ! Psi on axis (as adjusted)
  real*8, intent(out) :: Psibdy    ! Psi averaged along boundary

  integer, intent(out) :: ierr  ! status code 0=OK

  !------------------------
  ! local...
  !  spline information  -- arrays moved to module eqi_geq_axis_data

  integer :: ilinx,iliny,ict(6),idum

  !  spline lookup variables (for bdy eval)

  integer, dimension(:), allocatable :: iia,jja
  real*8, dimension(:), allocatable :: rparama,zparama,hra,hria,hza,hzia
  real*8, dimension(:), allocatable :: psiaa,raa,zaa,wk

  ! Newton search variables
  integer :: iter,itmax,i,j,imin,jmin
  real*8 :: wkrmag(1),wkzmag(1),psidat(1,6)
  real*8 :: ztol,dpsidR,dpsidZ,d2psidR2,d2psidZ2,zrmp,zzmp,zdist,zmin_psi
  real*8 :: zdpsi_sum
  logical :: iexit

  integer :: nbdy,ib,jb

  real*8 xdum,x1(1),x2(1),zinput(1,2),zoutput(1,1)

  real*8 :: Rmin,Rmax,Zmin,Zmax

  logical :: iok0(1)

  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  real*8, parameter :: ZERO = 0.0_R8

  EXTERNAL eqi_geq_axis_Rsrch

  !-------------------------
  ! Newton iteration to adjust magnetic axis to match the bicubic
  ! spline representation over the user specified grids
  !   (flag indicate these differ from the xplasma Psi(R,Z) internal
  !   grids)

#ifdef __DEBUG
  allocate(wk(nv)); wk=0.0d0

  call r8_grf3f1(rgrid,psirz,zgrid,wk,nh,nv,nh, &
       'R','Psi(R,Z)','Z','m','Wb/rad','m', &
       'eqi_geq_axis.f90 debug plot','eqi_geq_axis Psi(R,Z)',0)

  deallocate(wk)
#endif

  Psiax = ZERO
  Psibdy = ZERO
  ierr = 0

  xdum = ZERO

  Rmin = Rgrid(1)
  Rmax = Rgrid(nh)

  Zmin = Zgrid(1)
  Zmax = Zgrid(nv)

  zdist = min((Rmax-Rmin),(Zmax-Zmin))/10

  ztol = 1.0d-12*max(Rmax,max(abs(Zmin),abs(Zmax)))

  ! set up bicubic spline and (R,Z) lookup data

  allocate(rpkg(nh,4),zpkg(nv,4),psirz_spl(4,nh,nv))

  call genxpkg(nh,rgrid,rpkg,0,0,0,xdum,3,ierr)
  if(ierr.ne.0) go to 990

  call genxpkg(nv,zgrid,zpkg,0,0,0,xdum,3,ierr)
  if(ierr.ne.0) go to 990

  psirz_spl(1,:,:) = psirz(:,:)
  call mkbicub(rgrid,nh,zgrid,nv,psirz_spl,nh, &
       0,xdum,0,xdum, 0,xdum,0,xdum, &
       ilinx,iliny, ierr)
  if(ierr.ne.0) go to 990

  ! set up for evaluation of Newton iteration data
  ict = (/ 1,1,1,1,1,0 /)  ! value & 1st & 2nd derivatives
  ! (cross derivative omitted as unnecesary in this context)

  psidat = ZERO
  wkrmag = rmaxis
  wkzmag = zmaxis

  idum = 0

  iexit = .FALSE.
  iter = 0
  itmax = 100  ! max iteration count

  do
     iter = iter + 1
     if(iter.gt.itmax) then
        ierr = 1
#ifdef __DEBUG
        write(6,*) ' *** eqi_geq_axis: 2d Newton loop did not converge *** '
#endif
        exit
     endif

     ! save old value
     zrmp=wkrmag(1)
     zzmp=wkzmag(1)

     call xlookup(1,wkrmag,nh,rpkg,2,ii,rparam,hr,hri,idum)
     call xlookup(1,wkzmag,nv,zpkg,2,jj,zparam,hz,hzi,idum)

     ! evaluate bicubic spline representation of Psi and its derivatives

     call fvbicub(ict,1,1, &
          psidat,ii,jj,rparam,zparam,hr,hri,hz,hzi, &
          psirz_spl,nh,nv)

     ! extract value
     Psiax = psidat(1,1)

     ! extract derivatives
     dPsidR = psidat(1,2)
     dPsidZ = psidat(1,3)
     d2PsidR2 = psidat(1,4)
     d2PsidZ2 = psidat(1,5)

     ! if converged, exit now
     if(iexit) exit

     ! done if 1st derivatives are both zero
     if((dPsidR.eq.ZERO).AND.(dPsidZ.eq.ZERO)) exit

     ! Newton step in R direction
     !   error if 2nd derivative is zero

     if(d2PsidR2.eq.ZERO) then
        iter=itmax
        cycle
     endif

     ! new Rmag
     if(dPsidR.ne.ZERO) then
        wkrmag(1) = zrmp - dPsidR/d2PsidR2
     endif

     ! Newton step in Z direction
     !   error if 2nd derivative is zero

     if(d2PsidZ2.eq.ZERO) then
        iter=itmax
        cycle
     endif

     ! new Zmag
     if(dPsidZ.ne.ZERO) then
        wkzmag(1) = zzmp - dPsidZ/d2PsidZ2
     endif

     ! compare changes to tolerance
     iexit = (max(abs(wkzmag(1)-zzmp),abs(wkrmag(1)-zrmp)).lt.ztol)

     ! force early exit if wandered outside the grid

     if(wkRmag(1).lt.Rmin) iter=itmax
     if(wkRmag(1).gt.Rmax) iter=itmax
     if(wkZmag(1).lt.Zmin) iter=itmax
     if(wkZmag(1).gt.Zmax) iter=itmax

  enddo

  if(ierr.ne.0) then
     ! Newton loop not converged...
     ! try Ridder search

     eqi_eps = 0.000001d0*min((Rgrid(2)-Rgrid(1)),(Zgrid(2)-Zgrid(1)))
     zmin_psi = 1.0d30
     do j=1,nv
        do i=1,nh
           if((abs(Rgrid(i)-Rmaxis).lt.zdist).AND. &
                (abs(Zgrid(j)-Zmaxis).lt.zdist)) then
              if(psiRZ(i,j).lt.zmin_psi) then
                 zmin_psi = psiRZ(i,j)
                 imin=i
                 jmin=j
              endif
           endif
        enddo
     enddo

     zdpsi_sum = &
          (psiRZ(imin+1,jmin)-psiRZ(imin,jmin))/(Rgrid(imin+1)-Rgrid(imin)) +&
          (psiRZ(imin,jmin)-psiRZ(imin-1,jmin))/(Rgrid(imin)-Rgrid(imin-1)) +&
          (psiRZ(imin,jmin+1)-psiRZ(imin,jmin))/(Zgrid(jmin+1)-Zgrid(jmin)) +&
          (psiRZ(imin,jmin)-psiRZ(imin,jmin-1))/(Zgrid(jmin)-Zgrid(jmin-1))

     zdpsi_sum = zdpsi_sum/4
     eqi_eta = 0.001d0*zdpsi_sum

     iok0(1) = .FALSE.
     x1(1) = Rgrid(imin-3)
     x2(1) = Rgrid(imin+3)
     zinput(1,1)=Zgrid(jmin-3)
     zinput(1,2)=Zgrid(jmin+3)

     call zriddery(1,iok0,x1,x2,eqi_eps,eqi_eta, &
          eqi_geq_axis_Rsrch,wkRmag,ierr, &
          1,zinput,2,zoutput,1)

     if(ierr.ne.0) then
#ifdef __DEBUG
        write(6,*) ' *** eqi_geq_axis: 2d Ridder search failed *** '
#endif
        go to 990
     else
#ifdef __DEBUG
        write(6,*) ' but eqi_geq_axis: 2d Ridder search OK. '
#endif
        continue
     endif

     wkZmag = zoutput(1,1)

     call xlookup(1,wkrmag,nh,rpkg,2,ii,rparam,hr,hri,idum)
     call xlookup(1,wkzmag,nv,zpkg,2,jj,zparam,hz,hzi,idum)

     ! evaluate bicubic spline representation of Psi and its derivatives

     call fvbicub(ict,1,1, &
          psidat,ii,jj,rparam,zparam,hr,hri,hz,hzi, &
          psirz_spl,nh,nv)

     ! extract value
     Psiax = psidat(1,1)

  endif

  ! normal exit from Newton loop;
  ! converged: new mag axis for this representation

  rmaxis = wkRmag(1)
  zmaxis = wkZmag(1)

  ! Psiax was evaluated in the Newton loop.

  ! Now evaluate Psibdy by averaging over the boundary contour

  nbdy = nb
  if((rbdy(1).eq.rbdy(nb)).AND.(zbdy(1).eq.zbdy(nb))) nbdy = nbdy - 1

  nbdy = nbdy * 2

  allocate(iia(nbdy),jja(nbdy),rparama(nbdy),zparama(nbdy))
  allocate(hra(nbdy),hria(nbdy),hza(nbdy),hzia(nbdy))

  allocate(psiaa(nbdy),raa(nbdy),zaa(nbdy))
  
  jb=0
  do ib=1,nbdy/2
     jb=jb + 1
     raa(jb) = rbdy(ib)
     zaa(jb) = zbdy(ib)
     jb=jb + 1
     if(ib.lt.nb) then
        raa(jb) = (rbdy(ib)+rbdy(ib+1))/2
        zaa(jb) = (zbdy(ib)+zbdy(ib+1))/2
     else
        raa(jb) = (rbdy(ib)+rbdy(1))/2
        zaa(jb) = (zbdy(ib)+zbdy(1))/2
     endif
  enddo

  call xlookup(nbdy,raa,nh,rpkg,2,iia,rparama,hra,hria,idum)
  call xlookup(nbdy,zaa,nv,zpkg,2,jja,zparama,hza,hzia,idum)

  ! set up for evaluation of Psi values only
  ict = (/ 1,0,0,0,0,0 /)

  call fvbicub(ict,nbdy,nbdy, &
       psiaa,iia,jja,rparama,zparama,hra,hria,hza,hzia, &
       psirz_spl,nh,nv)

  Psibdy = ZERO
  do ib=1,nbdy
     Psibdy = Psibdy + psiaa(ib)
  enddo
  Psibdy = Psibdy/nbdy

  deallocate(iia,jja,rparama,zparama,hra,hria,hza,hzia)
  deallocate(psiaa,raa,zaa)

990 continue
  deallocate(rpkg,zpkg,psirz_spl)

end subroutine eqi_geq_axis

!------------------------------------------------------
subroutine geq_ckrzc(r,z,n,ndim)
  
  !  squeeze out duplicate points, make sure end pts connect
  
  implicit NONE
  
  integer, parameter :: r8 = selected_real_kind(12,100)
  integer, intent(in) :: ndim     ! array dims
  integer, intent(inout) :: n     ! actual number in use
  real(r8), dimension(ndim), intent(inout) :: r,z    ! the contour
  
  integer i,j
  real(r8) zmax,rmax,dl,dlmin
  
  ! --------------------------------------
  
  ! squeeze out consecutive duplicate points
  
  rmax=maxval(abs(r(1:n)))
  zmax=maxval(abs(z(1:n)))
  dlmin=5.0e-6_r8*max(rmax,zmax)
  
  i=0
  do
     i=i+1
     if(i.ge.n) exit
     dl=sqrt((r(i+1)-r(i))**2+(z(i+1)-z(i))**2)
     if(dl.lt.dlmin) then
        do j=i+1,n-1
           r(j)=r(j+1)
           z(j)=z(j+1)
        enddo
        n=n-1
        i=i-1
     endif
  enddo
  
  ! make sure end pts are connected
  
  if((r(1).ne.r(n)).or.(z(1).ne.z(n))) then
     n=n+1
     r(n)=r(1)
     z(n)=z(1)
  endif
  
  ! make sure no NaNs left at high end
  
  do i=n+1,ndim
     r(i)=r(n)
     z(i)=z(n)
  enddo
  
end subroutine geq_ckrzc

      SUBROUTINE MCRDR_READ(LUN,LINE,IEOF)
C
C  READ A LINE, EOF CHECK
C
      CHARACTER*(*) LINE
C
      IEOF=0
      READ(LUN,1001,END=20) LINE
 1001 FORMAT(A)
C
      GO TO 30
C
C  END OF FILE
C
 20   CONTINUE
      IEOF=1
C
C  EXIT
C
 30   CONTINUE
      RETURN
C
      END

SUBROUTINE scrfree
  USE mintrp
  USE scrunch_inc1
  USE scrunch_inc2
  !...begin restore memory
  IF( ALLOCATED(rin) ) DEALLOCATE(rin)
  IF( ALLOCATED(zin) ) DEALLOCATE(zin)
  IF( ALLOCATED(xvec) ) DEALLOCATE(xvec)
  IF( ALLOCATED(gvec) ) DEALLOCATE(gvec)
  IF( ALLOCATED(xdot) ) DEALLOCATE(xdot)
  IF( ALLOCATED(xstore) ) DEALLOCATE(xstore)
  IF( ALLOCATED(m1) ) DEALLOCATE(m1)
  IF( ALLOCATED(n1) ) DEALLOCATE(n1)
  IF( ALLOCATED(rmomb) ) DEALLOCATE(rmomb)
  IF( ALLOCATED(zmomb) ) DEALLOCATE(zmomb)
  IF( ALLOCATED(mm) ) DEALLOCATE(mm)
  IF( ALLOCATED(dm1) ) DEALLOCATE(dm1)
  IF( ALLOCATED(faccon) ) DEALLOCATE(faccon)
  IF( ALLOCATED(xmpq) ) DEALLOCATE(xmpq)
  IF( ALLOCATED(result) ) DEALLOCATE(result)
  IF( ALLOCATED(rin3d) ) DEALLOCATE(rin3d)
  IF( ALLOCATED(zin3d) ) DEALLOCATE(zin3d)
  IF( ALLOCATED(angle) ) DEALLOCATE(angle)
  !...end restore memory
  RETURN
END SUBROUTINE scrfree

 
#include "fpreproc/byte_declare.h"
 
!----------------------------------------------------------
! cface  -- generated (f90 fixed form) C interface to:  EQM_RZFUN2
      SUBROUTINE  C_EQM_RZFUN2(
     > C_ZNAME_LEN,C_ZNAME,IFUN,USERFCN,IARG,IORDER,ZSM,IERR)
 
      external EQM_RZFUN2
 
! argument declarations
 ! scalar char*(*) type, input only:
      INTEGER C_ZNAME_LEN
      BYTE_DECLARE C_ZNAME(C_ZNAME_LEN)
 
      INTEGER IFUN
      REAL*8 USERFCN
      EXTERNAL USERFCN
      INTEGER IARG
      INTEGER IORDER
      REAL*8 ZSM
      INTEGER IERR
 
! local (automatic array) declarations
      CHARACTER(C_ZNAME_LEN) :: ZNAME_act
 
! executable code:  copy for input
 
      call cstring(ZNAME_act, C_ZNAME,'2F')
! call to original routine:  EQM_RZFUN2
 
      CALL EQM_RZFUN2(
     > ZNAME_act,IFUN,USERFCN,IARG,IORDER,ZSM,IERR)
 
! copy back outputs if modified.
 
! exit
      return
      end

c-------------------------------------------------------
c ported from f77 xplasma dmc Feb. 2006
c
      subroutine eqi_rzbox(zrhoi,zphi,
     >     iwant_Rmin,zRmin,zth_Rmin,iwant_Rmax,zRmax,zth_Rmax,
     >     iwant_Zmin,zZmin,zth_Zmin,iwant_Zmax,zZmax,zth_Zmax,
     >     ierr)
c
      use xplasma_definitions
      use eqi_rzbox_module
c
c  given a flux surface (zrho) find a minimal box (zRmin,zRmax)x(zZmin,zZmax)
c  (all toroidal angles) which incloses the surface
c
c  this amounts to finding the Rmin,Rmax,Zmin,Zmax of the surface.
c
      IMPLICIT NONE
c
      REAL*8 zrhoi                      ! surface to be boxed
      REAL*8 zphi                       ! toroidal angle
c
c  note: zphi not currently used-- reserved for future non-azisymmetry upgrade
c
      logical :: iwant_Rmin             ! TRUE for Rmin output
      logical :: iwant_Rmax             ! TRUE for Rmax output
      logical :: iwant_Zmin             ! TRUE for Zmin output
      logical :: iwant_Zmax             ! TRUE for Zmax output
c
c  output as requested-- approximate values *always* returned; set iwant
c  switch for exact (to mach precision) value...
c
      REAL*8 zRmin                      ! Rmin of enclosing box in (R,Z)
      REAL*8 zRmax                      ! Rmax of enclosing box in (R,Z)
      REAL*8 zZmin                      ! Zmin of enclosing box in (R,Z)
      REAL*8 zZmax                      ! Zmax of enclosing box in (R,Z)

c  and corresponding theta (or "chi") values, accurate as requested:
      REAL*8 zth_Rmin
      REAL*8 zth_Rmax
      REAL*8 zth_Zmin
      REAL*8 zth_Zmax
C
      integer ierr                      ! completion code, 0=OK
C
      external feq_Rmmx,feq_Zmmx
C
C---------------------------------------------------
c
      REAL*8 zchi(nsrch1)             ! search points (poloidal angle coord)
      REAL*8 zR(0:1,nsrch1)           ! R,dR/dchi @ each search pt
      REAL*8 zZ(0:1,nsrch1)           ! Z,dZ/dchi @ each search pt
      real*8 zRZbuf(nsrch1,4)         ! interp. buffer
      integer iflist(4),idchis(4)
c
      REAL*8 zchi0,zchi1,zchimmx
c
      REAL*8 zeps,zeta,ztmp,zrho
c
      integer i
      integer iminR,iminZ,imaxR,imaxZ
      integer iminR2,iminZ2,imaxR2,imaxZ2
C
      logical imask
C
      REAL*8 zrhovec(nsrch1)
c-----------------------------------
      integer :: lRnum,lZnum,iertmp
c
      real*8 :: bdy_tol
      logical :: axisymm,bflag
      integer :: id_bdy_info
c
      real*8, parameter :: c2pi = 6.2831853071795862D+00
      real*8, parameter :: csmall = 1.0d-14
      real*8, parameter :: czero = 0.0d0
      real*8, parameter :: cone  = 1.0d0
C---------------------------------------------------
C
      ierr=0
      zrmin=0
      zrmax=0
      zzmin=0
      zzmax=0
C
      zrho=max(100*csmall,zrhoi)
C
      call xplasma_global_info(sp,ierr, axisymm=axisymm, bdytol=bdy_tol)
      if(ierr.ne.0) return
C
      id_bdy_info = 0
      bflag=.FALSE.
      if(abs(cone-zrho).lt.bdy_tol) then
         bflag = axisymm
         call xplasma_find_item(sp,'__RZ_BDY_INFO',id_bdy_info,ierr,
     >        nf_noerr=.TRUE.)
      endif
C
      imask=.FALSE.
c
      zchi0=0
      zchi1=c2pi
C
      do i=1,nsrch1
         zrhovec(i)=zrho
         zchi(i)=zchi0+(i-1)*(zchi1-zchi0)/(nsrch0)
      enddo
      zchi(nsrch1)=zchi1
c
      call xplasma_common_ids(sp,ierr, id_R=lRnum,id_Z=lZnum)
      if((lRnum.eq.0).or.(lZnum.eq.0)) then
         ierr=2504
         return
      endif

      iflist(1)=lRnum
      iflist(2)=lZnum
      iflist(3)=lRnum
      iflist(4)=lZnum
      idchis(1:2)=0
      idchis(3:4)=1

      if(bflag.and.(id_bdy_info.gt.0)) then
         call eqi_rzbox_binfo_get(cone,zrzbuf,ierr)
      else
         call xplasma_RZeval_2d(sp,iflist,
     >        xplasma_rho_coord,zrhovec,xplasma_theta_coord,zchi,
     >        zrzbuf,ierr, ideriv2s=idchis)
      endif
      if(ierr.ne.0) return
c
      if(bflag.and.(id_bdy_info.eq.0)) then
         call eqi_rzbox_binfo_set(cone,zrzbuf,id_bdy_info,ierr)
      endif
      if(ierr.ne.0) return
c
      do i=1,nsrch1
         zR(0,i)=zrzbuf(i,1)    ! R
         zZ(0,i)=zrzbuf(i,2)    ! Z
         zR(1,i)=zrzbuf(i,3)   ! dR/dchi
         zZ(1,i)=zrzbuf(i,4)   ! dZ/dchi
         if(i.eq.1) then
            zRmin=zR(0,1)
            zRmax=zRmin
            zZmin=zZ(0,1)
            zZmax=zZmin
            iminR=1
            imaxR=1
            iminZ=1
            imaxZ=1
         else
            if(zR(0,i).gt.zRmax) then
               imaxR=i
               zRmax=zR(0,i)
            endif
            if(zR(0,i).lt.zRmin) then
               iminR=i
               zRmin=zR(0,i)
            endif
            if(zZ(0,i).gt.zZmax) then
               imaxZ=i
               zZmax=zZ(0,i)
            endif
            if(zZ(0,i).lt.zZmin) then
               iminZ=i
               zZmin=zZ(0,i)
            endif
         endif
      enddo
C
      zth_Rmin=zchi(iminR)
      zth_Rmax=zchi(imaxR)
      zth_Zmin=zchi(iminZ)
      zth_Zmax=zchi(imaxZ)
C
C  check the branch cut
C  the derivatives should match there, but may fail to do so exactly
C  for numerical reasons.  If the derivatives change sign, it is because
C  there is an extrema there and the derivatives are extremely close to
C  zero.
C
      if(zr(1,1)*zr(1,nsrch1).le.czero) then
         zr(1,1)=czero
         zr(1,nsrch1)=zr(1,1)
      else
         zr(1,1)=(zr(1,1)+zr(1,nsrch1))/2
         zr(1,nsrch1)=zr(1,1)
      endif
C
      if(zz(1,1)*zz(1,nsrch1).le.czero) then
         zz(1,1)=czero
         zz(1,nsrch1)=zz(1,1)
      else
         zz(1,1)=(zz(1,1)+zz(1,nsrch1))/2
         zz(1,nsrch1)=zz(1,1)
      endif
C
C  find exact min & max using rootfinder on derivative
C
      zeps=c2pi*csmall
      zeta=csmall*max(zRmax,abs(zZmin),abs(zZmax))/c2pi
C
      do i=1,nsrch0
         if(iwant_Rmax .and. 
     >        zR(1,i).gt.czero .and. zR(1,i+1).lt.czero) then
            call zridderx(1,imask,zchi(i),zchi(i+1),zeps,zeta,
     >         feq_Rmmx,zchimmx,ierr,
     >         1,zrho,1,ztmp,1)
            if(ierr.ne.0) then
               ierr=9999         ! not expected
               return
            endif
            if(ztmp.gt.zRmax) then
               zRmax=ztmp
               zth_Rmax=zchimmx
            endif
         endif
         if(iwant_Rmin .and.
     >        zR(1,i).lt.czero .and. zR(1,i+1).gt.czero) then
            call zridderx(1,imask,zchi(i),zchi(i+1),zeps,zeta,
     >         feq_Rmmx,zchimmx,ierr,
     >         1,zrho,1,ztmp,1)
            if(ierr.ne.0) then
               ierr=9999         ! not expected
               return
            endif
            if(ztmp.lt.zRmin) then
               zRmin=ztmp
               zth_Rmin=zchimmx
            endif
         endif
         if(iwant_Zmax .and.
     >        zZ(1,i).gt.czero .and. zZ(1,i+1).lt.czero) then
            call zridderx(1,imask,zchi(i),zchi(i+1),zeps,zeta,
     >         feq_Zmmx,zchimmx,ierr,
     >         1,zrho,1,ztmp,1)
            if(ierr.ne.0) then
               ierr=9999         ! not expected
               return
            endif
            if(ztmp.gt.zZmax) then
               zZmax=ztmp
               zth_Zmax=zchimmx
            endif
         endif
         if(iwant_Zmin .and. 
     >        zZ(1,i).lt.czero .and. zZ(1,i+1).gt.czero) then
            call zridderx(1,imask,zchi(i),zchi(i+1),zeps,zeta,
     >         feq_Zmmx,zchimmx,ierr,
     >         1,zrho,1,ztmp,1)
            if(ierr.ne.0) then
               ierr=9999         ! not expected
               return
            endif
            if(ztmp.lt.zZmin) then
               zZmin=ztmp
               zth_Zmin=zchimmx
            endif
         endif
      enddo
C
      ierr=0
C
      return
      end
C---------------------------------------------------------------------
      subroutine feq_Rmmx(ivec,imask,zchi,zanswer,
     >   ivecd,zinput,ninput,zoutput,noutput)
c
      use xplasma_definitions
      use eqi_rzbox_module
C
      IMPLICIT NONE
C
C  function for zridderx -- dR/dchi @ some rho; return R also
C  will find extrema by looking for dR/dchi=0
C
      integer ivec,ivecd
      logical imask(ivec)
      integer ninput,noutput
c
c  note do not want "intent(out)"-- not all elements will be set...
c
      REAL*8 zchi(ivec),zanswer(ivec),
     >   zinput(ivecd,ninput),zoutput(ivecd,noutput)
c
c---------------------------
c
      REAL*8 zrho_use(ivec),zchi_use(ivec),zvals(ivec,0:1)
      integer i,jvec,ierr,lRnum
c
      integer :: iflist(2),iderivs(2)
c---------------------------
c
      jvec=0
      do i=1,ivec
         if(.not.imask(i)) then
            jvec=jvec+1
            zrho_use(jvec)=zinput(i,1)
            zchi_use(jvec)=zchi(i)
         endif
      enddo
      if(jvec.eq.0) return              ! nothing to be done
c
      call xplasma_common_ids(sp,ierr, id_R=lRnum)

      iflist=lRnum
      iderivs(1)=0
      iderivs(2)=1

      call xplasma_RZeval_2d(sp,iflist,
     >     xplasma_rho_coord,zrho_use(1:jvec),
     >     xplasma_theta_coord,zchi_use(1:jvec),
     >     zvals(1:jvec,0:1),ierr, ideriv2s=iderivs)
      if(ierr.ne.0) then
         ierr=9999   ! not expected here
         return
      endif

      jvec=0
      do i=1,ivec
         if(.not.imask(i)) then
            jvec=jvec+1
            zoutput(i,1)=zvals(jvec,0)  ! R
            zanswer(i)=zvals(jvec,1)    ! dR/dchi
         endif
      enddo
c
      return
      end
C-----------------------------------------------
      subroutine feq_Zmmx(ivec,imask,zchi,zanswer,
     >   ivecd,zinput,ninput,zoutput,noutput)
c
      use xplasma_definitions
      use eqi_rzbox_module
C
      IMPLICIT NONE
C
C  function for zridderx -- dZ/dchi @ some rho; return Z also
C  will find extrema by looking for dZ/dchi=0
C
      integer ivec,ivecd
      logical imask(ivec)
      integer ninput,noutput
c
c  note do not want "intent(out)"-- not all elements will be set...
c
      REAL*8 zchi(ivec),zanswer(ivec),
     >   zinput(ivecd,ninput),zoutput(ivecd,noutput)
c
c---------------------------
c
      REAL*8 zrho_use(ivec),zchi_use(ivec),zvals(ivec,0:1)
      integer i,jvec,ierr,lZnum
c
      integer :: iflist(2),iderivs(2)
c---------------------------
c
      jvec=0
      do i=1,ivec
         if(.not.imask(i)) then
            jvec=jvec+1
            zrho_use(jvec)=zinput(i,1)
            zchi_use(jvec)=zchi(i)
         endif
      enddo
      if(jvec.eq.0) return              ! nothing to be done
c
      call xplasma_common_ids(sp,ierr, id_Z=lZnum)

      iflist=lZnum
      iderivs(1)=0
      iderivs(2)=1

      call xplasma_RZeval_2d(sp,iflist,
     >     xplasma_rho_coord,zrho_use(1:jvec),
     >     xplasma_theta_coord,zchi_use(1:jvec),
     >     zvals(1:jvec,0:1),ierr, ideriv2s=iderivs)
      if(ierr.ne.0) then
         ierr=9999   ! not expected here
         return
      endif

      jvec=0
      do i=1,ivec
         if(.not.imask(i)) then
            jvec=jvec+1
            zoutput(i,1)=zvals(jvec,0)  ! Z
            zanswer(i)=zvals(jvec,1)    ! dZ/dchi
         endif
      enddo
c
      return
      end
C-----------------------------------------------

SUBROUTINE scrdesreg_clean(rmb_in,zmb_in,nmb_in,mpolin,icon,ioflag, &
     fsq,lasym0,lzsmlonly,nmbout,rmbout,zmbout,ier)
  !
  !  call scrDESCUR -- but first:
  !   a) remove duplicate points
  !   b) using scrdesreg subroutine, regularize the contour using equal
  !  steps in theta as defined by elongation-corrected atan2((Z-Z0),(R-R0))
  !
  !  arguments are as in scrDESCUR.f90
  !  as in scrDESCUR, ier=1 means NORMAL exit
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero
  implicit NONE
  !
  integer, intent(in) :: nmb_in  ! no. of contour (R,Z) data pts
  real(fp), intent(in) :: rmb_in(nmb_in),zmb_in(nmb_in) 
  ! closed contour (R,Z) data pts
  !   expecting rmb(1)=rmb(nmb) and zmb(1)=zmb(nmb)

  integer, intent(in) :: mpolin  ! no. of moments (0:mpolin-1)
  integer, intent(in) :: icon    ! debug arg -- .gt.0 to have scrDESCUR
  !   write a debug file on fortran LUN icon

  logical, intent(in) :: ioflag  ! .TRUE. for extra debug output messages

  real(fp), intent(out) :: fsq  ! output measure of error (fft contour deviation)

  logical, intent(in) :: lasym0  ! .TRUE. -- updown assymmetry
  logical, intent(in) :: lzsmlonly  ! .TRUE. -- Z=Z0+Z1*sin(theta) only
  !   (all other Z moments to be set to zero)

  integer, intent(in) :: nmbout  ! array dimension for output arrays
  !   note FULL DIMESIONS are (0:NMBOUT,2)

  !  R cos & sin moments
  real(fp), intent(out) :: rmbout(0:nmbout,2),zmbout(0:nmbout,2)

  integer, intent(out) :: ier    ! completion code, OK = 1

  !------------------------------------
  !  local:
  real(fp) :: rmb(nmb_in),zmb(nmb_in)
  real(fp) :: zzr,zzrp,zzz,zzzp,zdl
  integer :: i,nmb,lunmsg
  !------------------------------------

  lunmsg = 6

  nmb=1
  rmb(1)=rmb_in(1)
  zmb(1)=zmb_in(1)
  zzr=rmb(1)
  zzz=zmb(1)

  do i=2,nmb_in
     zzrp=zzr
     zzzp=zzz
     zzr=rmb_in(i)
     zzz=zmb_in(i)
     zdl=sqrt((zzr-zzrp)**2+(zzz-zzzp)**2)
     if(zdl.eq.ZERO) then
        continue  ! exact overlap of points...
     else
        nmb=nmb+1
        rmb(nmb)=rmb_in(i)
        zmb(nmb)=zmb_in(i)
     endif
  enddo

  if(nmb.lt.nmb_in) then
     write(lunmsg,*) ' %scrdesreg_clean: ',nmb_in-nmb, &
          ' overlapping points removed.'
  endif

  call scrdesreg(rmb,zmb,nmb,mpolin,icon,ioflag, &
       fsq,lasym0,lzsmlonly,nmbout,rmbout,zmbout,ier)

end SUBROUTINE scrdesreg_clean


SUBROUTINE scrdesreg (rmb,zmb,nmb,mpolin,icon,ioflag, &
     fsq,lasym0,lzsmlonly,nmbout,rmbout,zmbout,ier)
  !
  !  call scrDESCUR -- but first -- regularize the contour using equal
  !  steps in theta as defined by elongation-corrected atan2((Z-Z0),(R-R0))
  !
  !  arguments are as in scrDESCUR.f90
  !  as in scrDESCUR, ier=1 means NORMAL exit
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, half, one, pi
  implicit NONE
  !
  integer, intent(in) :: nmb  ! no. of contour (R,Z) data pts
  real(fp), intent(in) :: rmb(nmb),zmb(nmb) ! closed contour (R,Z) data pts
  !   expecting rmb(1)=rmb(nmb) and zmb(1)=zmb(nmb)

  integer, intent(in) :: mpolin  ! no. of moments (0:mpolin-1)
  integer, intent(in) :: icon    ! debug arg -- .gt.0 to have scrDESCUR
  !   write a debug file on fortran LUN icon

  logical, intent(in) :: ioflag  ! .TRUE. for extra debug output messages

  real(fp), intent(out) :: fsq  ! output measure of error (fft contour deviation)

  logical, intent(in) :: lasym0  ! .TRUE. -- updown assymmetry
  logical, intent(in) :: lzsmlonly  ! .TRUE. -- Z=Z0+Z1*sin(theta) only
  !   (all other Z moments to be set to zero)

  integer, intent(in) :: nmbout  ! array dimension for output arrays
  !   note FULL DIMESIONS are (0:NMBOUT,2)

  !  R cos & sin moments
  real(fp), intent(out) :: rmbout(0:nmbout,2),zmbout(0:nmbout,2)

  integer, intent(out) :: ier    ! completion code, OK = 1

  !--------------------------------------------
  !  local
  integer ith0,ith1
  integer nmb2,i,j,jprev,idir,lunmsg,inter
  real(fp), dimension(:), allocatable :: rmb2,zmb2,rmbx,zmbx,zthx,zdx,zdla
  real(fp) :: zl,zdl,zzl,zzr,zzrp,zzz,zzzp,R0,Z0,ztmp
  real(fp) :: zrmax,zrmin,zzmin,zzmax,zaovb,zaovb2,zintrp
  real(fp) :: zdthmin,zdthmax,zrat,zbranch
  real(fp) :: zddth1,zddth2,zdth,zdelth,za,zb,zth,zd
  !--------------------------------------------
#ifdef __DEBUG

  real(fp) :: r0atan,z0atan,shif2pi
  real(fp) :: thatan(nmb),datan(nmb)
  real(fp), dimension(:), allocatable :: thb2,db2

  integer, parameter :: nthspl=301
  real(fp) :: thvmec(nthspl),thvma(nthspl),dvmec(nthspl), &
       rvmec(nthspl),zvmec(nthspl)
  real(fp) :: thvmcc(nthspl-1),dthth(nthspl-1),ddth(nthspl-1)

  real(fp) :: sinm(mpolin-1),cosm(mpolin-1)

#endif
  !--------------------------------------------

  lunmsg = 6

  ier=1
  rmbout=ZERO
  zmbout=ZERO

  !  double length array for regularized polar angle step
  nmb2=nmb*2
  allocate(rmb2(nmb2),zmb2(nmb2))

  !  extended contour -- 1 point duplicated on each end
  allocate(rmbx(0:nmb+1),zmbx(0:nmb+1),zthx(0:nmb+1),zdx(0:nmb+1))
  allocate(zdla(1:nmb+1))
  rmbx(1:nmb)=rmb; zmbx(1:nmb)=zmb
  rmbx(0)=rmb(nmb-1); rmbx(nmb+1)=rmb(2)
  rmbx(1)=HALF*(rmbx(1)+rmbx(nmb)); rmbx(nmb)=rmbx(1)
  zmbx(0)=zmb(nmb-1); zmbx(nmb+1)=zmb(2)
  zmbx(1)=HALF*(zmbx(1)+zmbx(nmb)); zmbx(nmb)=zmbx(1)

  !  define Z0 estimate: line average
  !  also error check -- all pts distinct
  !  also find min & max

  zl=ZERO
  zzl=ZERO
  zzr=rmbx(1); zrmin=zzr; zrmax=zzr
  zzz=zmbx(1); zzmin=zzz; zzmax=zzz
  do i=2,nmb
    zzrp=zzr
    zzzp=zzz
    zzr=rmbx(i); zrmin=min(zrmin,zzr); zrmax=max(zrmax,zzr)
    zzz=zmbx(i); zzmin=min(zzmin,zzz); zzmax=max(zzmax,zzz)
    zdl=sqrt((zzr-zzrp)**2+(zzz-zzzp)**2)
    zdla(i)=zdl
    if(zdl.eq.ZERO) then
      ier=99
      write(lunmsg,*) '?scrdesreg: 2 consecutive points overlap exactly.'
      exit
    endif
    zl=zl+zdl
    zzl=zzl+zdl*(zzz+zzzp)*HALF
  enddo
  zdla(1)=zdla(nmb)
  zdla(nmb+1)=zdla(2)

  if(ier.ne.1) return

  Z0 = zzl/zl
  zaovb = (zrmax-zrmin)/(zzmax-zzmin)  ! inverse ellipticity approx.
  zaovb2 = zaovb**2

  !  define R0 estimate: half way btw midplane intercepts
  !  via piecewise linear estimation

  inter=0
  zzz=zmbx(1)
  zzr=ZERO
  do i=2,nmb
    zzzp=zzz
    zzz=zmbx(i)
    if(zzz.eq.Z0) cycle
    if((zzz-Z0)*(zzzp-Z0).le.ZERO) then
      zintrp=(Z0-zzzp)/(zzz-zzzp)
      inter=inter+1
      zzr=zzr + rmbx(i-1)*(ONE-zintrp)+rmbx(i)*zintrp
    endif
  enddo

  if(inter.ne.2) then
    write(lunmsg,*) '?scrdesreg: 2 surface/midplane intercepts not found:', &
         inter,' were found.'
    ier=100
    return
  endif

  R0=HALF*zzr

  !  define theta sequence... and distance sequence; (a/b) modified space...

  idir=0
  zbranch=ZERO
  zthx(0)=atan2(zaovb*(zmbx(0)-Z0),(rmbx(0)-R0))
  zdx(0)=sqrt(zaovb2*(zmbx(0)-Z0)**2+(rmbx(0)-R0)**2)
  do i=1,nmb+1
    zthx(i)=atan2(zaovb*(zmbx(i)-Z0),(rmbx(i)-R0)) + zbranch
    zdx(i)=sqrt(zaovb2*(zmbx(i)-Z0)**2+(rmbx(i)-R0)**2)
    if((zthx(i)-zthx(i-1)).gt.PI) then
      zbranch=zbranch-2*pi
      zthx(i)=zthx(i)-2*pi
    endif
    if((zthx(i)-zthx(i-1)).lt.-PI) then
      zbranch=zbranch+2*pi
      zthx(i)=zthx(i)+2*pi
    endif
    if(idir.eq.0) then
      if(zthx(i).gt.zthx(i-1)) then
        idir=1
      else
        idir=-1
      endif
      zdthmin=(zthx(i)-zthx(i-1))/zdla(i)
      zdthmax=zdthmin
    else
      zdthmin=min(zdthmin,(zthx(i)-zthx(i-1))/zdla(i))
      zdthmax=max(zdthmax,(zthx(i)-zthx(i-1))/zdla(i))
    endif
  enddo

  if((zdthmin*zdthmax).le.ZERO) then
    write(lunmsg,*) '?scrdesreg: d(theta)/dl changes direction.'
    ier=101
    return
  endif

  zrat=max(abs(zdthmin),abs(zdthmax))/min(abs(zdthmin),abs(zdthmax))
  if(zrat.gt.nmb) then
    write(lunmsg,*) '?scrdesreg: too much variation in |d(theta)/dl|'
    ier=102
    return
  endif

  !  reverse theta & D(theta) order if necessary

  if(zthx(0).gt.zthx(nmb+1)) then
    ith0=0
    ith1=nmb+1
    do
      ztmp=zthx(ith0)
      zthx(ith0)=zthx(ith1)
      zthx(ith1)=ztmp
      ztmp=zdx(ith0)
      zdx(ith0)=zdx(ith1)
      zdx(ith1)=ztmp
      ith0=ith0+1
      ith1=ith1-1
      if(ith0.ge.ith1) exit
    enddo
  endif

  !  OK  have D(theta) based on original contour; new contour is formed
  !      using equal steps in theta; end points are shared with the old

  rmb2(1)=rmbx(1)
  rmb2(nmb2)=rmbx(nmb)
  zmb2(1)=zmbx(1)
  zmb2(nmb2)=zmbx(nmb)

  !  Hermite interpolation will be used, based on numerical derivatives
  !  dD/dtheta at original contour (R,Z) pts

  j=1
  zddth1=(zdx(j+1)-zdx(j-1))/(zthx(j+1)-zthx(j-1))
  zddth2=(zdx(j+2)-zdx(j))/(zthx(j+2)-zthx(j))
  call deriv(j,zddth1)
  call deriv(j+1,zddth2)
  zdelth=zthx(j+1)-zthx(j)
  za=(2*(zdx(j)-zdx(j+1))/zdelth + (zddth1+zddth2))/(zdelth*zdelth)
  zb=(3*(zdx(j+1)-zdx(j))/zdelth - (zddth2+2*zddth1))/zdelth
  do i=2,nmb2-1
    zth=((i-1)*zthx(nmb)+(nmb2-i)*zthx(1))/(nmb2-1)
    jprev=j
    do
      if(zth.le.zthx(j+1)) exit
      j=j+1
    enddo
    if(j.ne.jprev) then
      zddth1=(zdx(j+1)-zdx(j-1))/(zthx(j+1)-zthx(j-1))
      zddth2=(zdx(j+2)-zdx(j))/(zthx(j+2)-zthx(j))
      call deriv(j,zddth1)
      call deriv(j+1,zddth2)
      zdelth=zthx(j+1)-zthx(j)
      za=(2*(zdx(j)-zdx(j+1))/zdelth + (zddth1+zddth2))/(zdelth*zdelth)
      zb=(3*(zdx(j+1)-zdx(j))/zdelth - (zddth2+2*zddth1))/zdelth
    endif

    !  in interval j

    zdth=zth-zthx(j)

    zd=((za*zdth+zb)*zdth+zddth1)*zdth+zdx(j)
    zzr = zd*cos(zth)
    zzz = zd*sin(zth)/zaovb

    rmb2(i)=zzr+R0
    zmb2(i)=zzz+Z0
  enddo

#ifdef __DEBUG
  !  call r8_grafc2(rmb,zmb,nmb, rmb2,zmb2,nmb2, 'm', 'm', &
  !       'scrDESREG debug plot','zmb(rmb), zmb2(rmb2)','should be similar')
  z0atan=zmb(1)
  r0atan=sum(rmb(1:nmb))/nmb
  call bdtan(nmb,rmb,zmb,thatan,datan)
  !  allocate(thb2(nmb2),db2(nmb2))
  !  call bdtan(nmb2,rmb2,zmb2,thb2,db2)
  !  call r8_grafc2(thatan,datan,nmb, thb2,db2,nmb2, 'rad', 'm', &
  !       'scrDESREG debug plot','d(th)orig, d(th)b2','should be similar')
  !  deallocate(thb2,db2)
#endif

  call scrDESCUR (rmb2,zmb2,nmb2, mpolin, &
       icon,ioflag, &
       fsq,lasym0,lzsmlonly,nmbout,rmbout,zmbout,ier)

#ifdef __DEBUG
  do i=1,nthspl
    thvmec(i)=(i-1)*2*PI/(nthspl-1)
    call r8sincos(thvmec(i),mpolin-1,sinm,cosm)
    rvmec(i)=rmbout(0,1)
    zvmec(i)=zmbout(0,1)
    do j=1,mpolin-1
      rvmec(i)=rvmec(i)+cosm(j)*rmbout(j,1)+sinm(j)*rmbout(j,2)
      zvmec(i)=zvmec(i)+cosm(j)*zmbout(j,1)+sinm(j)*zmbout(j,2)
    enddo
  enddo
  call r8_grafc2(rmb,zmb,nmb, rvmec,zvmec,nthspl, 'm', 'm', &
       'scrDESREG debug plot','zmb(rmb), zvmec(rvmec)','should be similar')
  call bdtan(nthspl,rvmec,zvmec,thvma,dvmec)
  call r8_grafc2(thatan,datan,nmb, thvma,dvmec,nthspl, 'rad', 'm', &
       'scrDESREG debug plot','d(th)orig, d(th)vmec','should be similar')
  do i=1,nthspl-1
    thvmcc(i)=(thvmec(i)+thvmec(i+1))/2
    dthth(i)=(thvma(i+1)-thvma(i))/(thvmec(i+1)-thvmec(i))
    ddth(i)=(dvmec(i+1)-dvmec(i))/(thvmec(i+1)-thvmec(i))
  enddo
  call r8_grafx2(thvmcc,ddth,dthth,nthspl-1,'rad','mixed', &
       'scrDESREG debug plot','d(dvmec)/dth & d(thvmec)/dth',' ')
#endif
  deallocate(rmb2,zmb2,rmbx,zmbx,zthx,zdx)

contains
  subroutine deriv(ij,zddth)
    integer, intent(in) :: ij
    real(fp),intent(out) :: zddth
    real(fp) :: zw1,zw2
    real(fp), parameter :: Z08 = 0.8_fp
    real(fp), parameter :: Z09 = 0.9_fp

    if(zdla(ij).le.zdla(ij+1)) then
      zw1=(ONE/zdla(ij))/(ONE/zdla(ij) + ONE/zdla(ij+1))
      if(zw1.gt.Z09) then
        zw1=ONE
      else if(zw1.gt.Z08) then
        zw1=min(ONE,(zw1+2*(zw1-Z08)))
      endif
      zw2=ONE-zw1
    else
      zw2=(ONE/zdla(ij+1))/(ONE/zdla(ij) + ONE/zdla(ij+1))
      if(zw2.gt.Z09) then
        zw2=ONE
      else if(zw2.gt.Z08) then
        zw2=min(ONE,(zw2+2*(zw2-Z08)))
      endif
      zw1=ONE-zw2
    endif

    zddth=( zw2*(zdx(ij+1)-zdx(ij))/(zthx(ij+1)-zthx(ij)) + &
         zw1*(zdx(ij)-zdx(ij-1))/(zthx(ij)-zthx(ij-1)) )

  end subroutine deriv

#ifdef __DEBUG    
  subroutine bdtan(nmb,rmb,zmb,thatan,datan)
    integer :: nmb
    real(fp) :: rmb(nmb),zmb(nmb),datan(nmb),thatan(nmb)

    shif2pi=0
    do i=1,nmb
      datan(i)=sqrt((rmb(i)-r0atan)**2+(zmb(i)-z0atan)**2)
      thatan(i)=atan2((zmb(i)-z0atan),(rmb(i)-r0atan)) + shif2pi
      if(i.gt.1) then
        if(thatan(i).lt.thatan(i-1)-PI) then
          shif2pi=shif2pi+2*PI
          thatan(i)=thatan(i)+shif2pi
        endif
      endif
    enddo
  end subroutine bdtan
#endif

end SUBROUTINE scrdesreg

subroutine eqi_getall(ivec,ccwflag, &
     zR,zZ,zphi,imap,zrho,zchi,tol,igrad, &
     ibflg,bvec,gbtensr, &
     nlist,inames,ivecd,fvals,fgrads, &
     nregion,ierr)

  !  **vectorized**
  !  get Bvector, grad(B) tensor, list of fcn values & list of fcn gradients
  !  at a particular spatial location

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  integer ivec                        ! vector dimensioning, input
  logical :: ccwflag                  ! T for normal CCW poloidal angle
  ! F means transforms will be applied...

  REAL*8 zR(ivec),zZ(ivec),zphi(ivec) ! (R,Z,phi) point [*]

  integer imap                        ! control flag:
  !           =1 to map (R,Z,phi)->(rho,chi,phi)
  !            return vectors in (R,Z,phi) system, e.g. BR,BZ,Bphi
  !           =2 to map (rho,chi,phi)->(R,Z,phi)
  !            return vectors in (R,Z,phi) system, e.g. BR,BZ,Bphi
  !           =3 to map (rho,chi,phi)->(R,Z,phi)
  !            return vectors in (rho,chi,phi) system, e.g. Bperp=0, Bchi, Bphi

  !          see igrad (below) to determine if gradient is wanted.
  !          see ibflg (below) to determine if B is wanted

  !          see list of functions (below) to see what functions are wanted

  REAL*8 zrho(ivec),zchi(ivec)      ! (rho,chi,[phi]) magnetic flux coords
  !                                         [*]
  !  note that phi(...) is input in either case

  !  input:
  REAL*8 tol                        ! rel. tol. for (R,Z,phi)->flux coords

  !  input:
  integer igrad                     ! =1:  get gradients

  integer ibflg                     ! =1:  get B vector, grad(B) tensor
  !  grad(B) fetched only if igrad=ibflg=1

  !  output  (if ibflg=1):
  REAL*8 bvec(3,ivec)               ! (BR,BZ,Bphi) or (Bperp=0,Bpol,Bphi)
  REAL*8 gbtensr(3,3,ivec)          ! [grad(BR),grad(BZ),grad(Bphi)]

  !  here grad means ( d/dR, d/dZ, (1/R)*d/dphi )

  !  gbtensr(1:3,1)=grad(BR)
  !  gbtensr(1:3,2)=grad(BZ)
  !  gbtensr(1:3,3)=grad(Bphi)

  !  input:
  integer nlist                     ! number of functions to evaluate
  integer inames(*)                 ! function id numbers

  integer ivecd                     ! output vector dimensioning

  !  nlist=0 is allowed

  !  output (if nlist.gt.0):
  REAL*8 fvals(ivecd,*)             ! function values
  REAL*8 fgrads(3,ivecd,*)          ! function gradients

  !  output:
  integer nregion(ivec)             ! =1:  inside, .gt.1: outside core

  !  if input coordinates are (rho,chi,phi), nregion(j)=4 if rho is out of
  !  range of the core plasma, nregion(j)=1 otherwise; nregion(j)=5 for 
  !  rho(j) < 0.0

  !  if input coordinates are (R,Z,phi), nregion(i)=1 if (R,Z,phi)(i) is inside
  !  the core plasma; nregion(i)=2 if (R,Z,phi)(i) is outside the core but
  !  inside the limiters; nregion(i)=3 if (R,Z,phi)(i) is inside
  !  [Rmin,Rmax]x[Zmin,Zmax] but outside the limiters; nregion(i)=4 if
  !  (R,Z,phi)(i) is outside [Rmin,Rmax]x[Zmin,Zmax]

  integer ierr                      ! =0:  OK, .ne.0:  serious error.

  !  NOTE: field and profile evaluations are only for points (i) such that
  !  nregion(i).lt.4; if a profile only exists in f(rho,theta) form and
  !  imap.eq.1 and. nregion(i).gt.1, then, f(1,theta) is evaluated, where
  !  an extrapolated theta value has been chosen.  For points not evaluated,
  !  zeroes are returned for function and field values and gradients alike.
  !---------------------------------------------
  !  local:

  !  coordinates as used (forced to be in range)
  real*8 zrho_use(ivec),zR_use(ivec),zZ_use(ivec)
  real*8 zchi_use(ivec),zphi_use(ivec),zdist(ivec)

  integer :: ii,jj,kk,ifcn,jvec,imap_type

  real*8 :: zRmin,zRmax,zZmin,zZmax

  real*8, parameter :: ZERO=0.0d0
  real*8, parameter :: ONE =1.0d0

  integer id_fRZ(nlist+3),id_fmag(nlist+3),id_alt,igt

  integer :: neval_fRZ,neval_fmag
  integer :: ideval_fRZ(3*(nlist+3)),ideval_fmag(3*(nlist+3))
  integer :: indx,indx_fRZ(3*(nlist+3)),indx_fmag(3*(nlist+3))
  integer :: ideriv,ideriv_mag(3*(nlist+3),2),ideriv_RZ(3*(nlist+3),2)

  real*8, dimension(:), allocatable :: drhodR,drhodZ,dthdR,dthdZ
  real*8, dimension(:,:), allocatable :: zwk
  real*8 :: elrho(2),elth(2),zdenom,zperp,zpll,zdfdr,zdfdz,bdytol
  real*8 :: zBR,zBZ,zBpol,zBpolgR,zBpolgZ

  !---------------------------------------------
  !  eqi_getall "old_xplasma" conversion dmc Jul 2006

  integer :: id_Bmod,id_BR,id_BZ,id_R,id_Z,id_g,itype_lim,itype_obj,iertmp
  integer :: nsnccwB,nsnccwI,nsnccw_th
  logical :: axisymm
  character*32 zname

  logical :: RZpref,RZout,gtrans

  !---------------------------------------------

  RZpref = (imap.eq.1)  ! prefer f(R,Z) evaluation if (R,Z) are input
  !                       otherwise prefer f(rho,theta) evaluation
  !  also means (R,Z) are input, not (rho,theta)

  RZout = (imap.le.2)   ! return [R,Z] gradients & BR, BZ
  !                       otherwise: [perp,pll] gradients & Btheta

  !.... set default outputs

  if(RZpref) then
     zrho=ZERO
     zchi=ZERO
  else
     zR=ZERO
     zZ=ZERO
  endif
  nregion=0

  if((igrad.gt.1).or.(igrad.lt.0)) then
     write(lunerr,*) ' ?eqi_getall: igrad=',igrad
     write(lunerr,*) '  only a value of 0 or 1 should be given.'
     ierr=9999
  endif

  if((ibflg.gt.1).or.(ibflg.lt.0)) then
     write(lunerr,*) ' ?eqi_getall: ibflg=',ibflg
     write(lunerr,*) '  only a value of 0 or 1 should be given.'
     ierr=9999
  endif

  if(ibflg.eq.1) then
     bvec=ZERO
     if(igrad.eq.1) gbtensr=ZERO
  endif

  ierr=0
  if(nlist.lt.0) then
     write(lunerr,*) ' ?eqi_getall: nlist=',nlist
     write(lunerr,*) '  a non-negative value is required.'
     ierr=9999
  else if(nlist.gt.0) then
     fvals(1:ivec,1:nlist)=ZERO
     if(igrad.eq.1) fgrads(1:3,1:ivec,1:nlist)=ZERO
  endif
  if(ierr.ne.0) return

  !-----------------------------------------------------------
  !  now do error checking (other than nlist.ge.0):

  if(ccwflag) then
     nsnccw_th=-1   ! CCW j -> Bpol direction opposite to d[R,Z]/dtheta
  else
     nsnccw_th=1
  endif

  call xplasma_global_info(s,ierr,axisymm=axisymm, &
       bphi_ccw=nsnccwB,jphi_ccw=nsnccwI,bdytol=bdytol)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqi_getall: unexpected xplasma_global_info error:'
     call xplasma_error(s,ierr,lunerr)
     return
  endif
  if(.not.axisymm) then
     call eq_errmsg(' eqi_getall:  non-axisymmetry not supported!')
     ierr=1
     return
  endif

  call xplasma_common_ids(s,ierr, id_Bmod=id_Bmod,id_BR=id_BR,id_BZ=id_BZ, &
       id_g=id_g,id_R=id_R,id_Z=id_Z)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqi_getall: unexpected xplasma_common_ids error:'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  if(min(id_R,id_Z).eq.0) then
     ierr=9999
     write(lunerr,*) ' ?eqi_getall: equilibrium geometry not ready.'
  endif

  if(min(id_Bmod,id_BR,id_BZ).eq.0) then
     ierr=9999
     write(lunerr,*) ' ?eqi_getall: equilibrium B field not ready.'
  endif

  if(ierr.ne.0) return

  if(imap.eq.1) then
     call xplasma_lim_info(s,ierr,itype=itype_lim)
     if(ierr.ne.0) then
        itype_lim=0
        call xplasma_error(s,ierr,lunerr)
     endif
     if(itype_lim.eq.0) then
        write(lunerr,*) ' ?eqi_getall: limiter specification not found.'
        ierr=9999
     endif
  endif

  do ifcn=1,nlist
     id_fRZ(ifcn)=0
     id_fmag(ifcn)=0

     call xplasma_get_item_info(s,inames(ifcn),iertmp,itype=itype_obj, &
          name=zname)

     if((iertmp.ne.0).or.(itype_obj.eq.0)) then
        if(iertmp.ne.0) call xplasma_error(s,iertmp,lunerr)
        write(lunerr,*) ' ?eqi_getall: invalid xplasma id code:'
        write(lunerr,*) '  inames(',ifcn,')=',inames(ifcn)
        ierr=9999

     else if(itype_obj.ne.xplasma_profType) then
        write(lunerr,*) ' ?eqi_getall: not a profile id code:'
        write(lunerr,*) '  inames(',ifcn,')=',inames(ifcn)
        write(lunerr,*) '    name       = "',trim(zname),'".'
        ierr=9999

     else
        ! OK if grid type is recognized...

        call xplasma_prof_info(s,inames(ifcn),iertmp, &
             gridType=igt, profId1=id_alt)

        if(igt.eq.1) then
           id_fmag(ifcn)=inames(ifcn)
           if(id_alt.gt.0) id_fRZ(ifcn)=id_alt

        else if(igt.eq.2) then
           id_fRZ(ifcn)=inames(ifcn)
           if(id_alt.gt.0) id_fmag(ifcn)=id_alt

        else
           ierr=9999
           write(lunerr,*) ' ?eqi_getall: profile "',trim(zname),'" is not'
           write(lunerr,*) '  defined over a supported set of axes;'
           write(lunerr,*) '  only functions of form f(R,Z) and f(rho,theta) are allowed.'
        endif
     endif

  enddo

  if(ierr.ne.0) return

  !------------------------------------------------

  if(ibflg.eq.1) then
     id_fmag(nlist+1)=id_BR
     id_fRZ(nlist+1)=id_BR  ! eval routine will convert
     id_fmag(nlist+2)=id_BZ
     id_fRZ(nlist+2)=id_BZ  ! eval routine will convert

     id_fmag(nlist+3)=id_g
     id_fRZ(nlist+3)=0      ! use g(rho)/R
  else
     id_fmag(nlist+1:nlist+3)=0
     id_fRZ(nlist+1:nlist+3)=0
  endif

  !------------------------------------------------
  !  coordinate mapping...

  call xplasma_RZminmax_extended(s, zRmin,zRmax, zZmin,zZmax, ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqi_getall: unexpected xplasma_RZminmax_extended error!'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  !----------------------------------
  if(RZpref) then

     !  compute (R,Z,phi) -> (rho,theta,phi)

     if(tol.ge.1.0d-3) then
        imap_type=xp_imap_polar              ! approximation OK
     else
        imap_type=xp_imap_newton             ! use slower Newton iteration
     endif

     call xplasma_ctrans(s,xp_use_coord_vecsize,ierr, &
          r_in=zR, z_in=zZ, tol=tol, maptype=imap_type, &
          rho_out=zrho, theta_out=zchi, nregion=nregion, ccw_theta=ccwflag)
     if(ierr.ne.0) then
        write(lunerr,*) ' ?eqi_getall: unexpected xplasma_ctrans(R,Z) error!'
        call xplasma_error(s,ierr,lunerr)
        return
     endif

     !  for points outside, set up nregion category appropriately

     jvec=0
     do ii=1,ivec
        if(nregion(ii).eq.3) then
           nregion(ii)=4
        else if((zR(ii).lt.zRmin).or.(zR(ii).gt.zRmax).or. &
             (zZ(ii).lt.zZmin).or.(zZ(ii).gt.zZmax)) then
           nregion(ii)=4
        endif

        if(nregion(ii).eq.2) then
           jvec=jvec+1
           zR_use(jvec)=zR(ii)
           zZ_use(jvec)=zZ(ii)
        endif
     enddo

     if(jvec.gt.0) then
        call xplasma_lim_distance(s,zR_use(1:jvec),zZ_use(1:jvec), &
             zdist(1:jvec),ierr, maptype=imap_type)
        if(ierr.ne.0) then
           write(lunerr,*) ' ?eqi_getall: unexpected xplasma_lim_distance error!'
           call xplasma_error(s,ierr,lunerr)
           return
        endif
     endif

     jvec=0
     do ii=1,ivec
        if(nregion(ii).eq.2) then
           jvec=jvec+1
           if(zdist(jvec).ge.0.0d0) then
              nregion(ii)=3
           endif
        endif
     enddo

  !----------------------------------
  else

     !  compute (rho,theta,phi) -> (R,Z,phi)

     jvec=0
     do ii=1,ivec
        if((zrho(ii).gt.-bdytol).and.(zrho(ii).lt.ONE+bdytol)) then
           nregion(ii)=1
           jvec=jvec+1
           zrho_use(jvec)=max(ZERO,min(ONE,zrho(ii)))
           zchi_use(jvec)=zchi(ii)

        else if(zrho(ii).le.-bdytol) then
           nregion(ii)=5
           zR(ii)=ZERO
           zZ(ii)=ZERO

        else if(zrho(ii).ge.ONE+bdytol) then
           nregion(ii)=4
           zR(ii)=ZERO
           zZ(ii)=ZERO

        endif
     enddo

     if(jvec.gt.0) then
        call xplasma_ctrans(s,xp_use_coord_vecsize,ierr, &
             rho_in=zrho_use(1:jvec),theta_in=zchi_use(1:jvec), &
             R_out=zR_use(1:jvec),Z_out=zZ_use(1:jvec), ccw_theta=ccwflag)
        if(ierr.ne.0) then
           write(lunerr,*) ' ?eqi_getall: unexpected xplasma_ctrans(rho,theta) error!'
           call xplasma_error(s,ierr,lunerr)
           return
        endif
     endif

     jvec=0
     do ii=1,ivec
        if(nregion(ii).eq.1) then
           jvec=jvec+1
           zR(ii)=zR_use(jvec)
           zZ(ii)=zZ_use(jvec)
        endif
     enddo
  endif

  !-------------------------------------------
  !  function and field evaluation...
  !  for each (id) choose f(R,Z) or f(rho,theta) -- the one available, or,
  !  the one preferred if there is a choice (prior error checking assures
  !  that at least one is available).
        
  neval_fRZ=0
  neval_fmag=0

  do ifcn=1,nlist+3
     if(RZpref) then
        if(id_fRZ(ifcn).gt.0) then
           call add_fRZ
        else
           call add_fmag
        endif
     else
        if(id_fmag(ifcn).gt.0) then
           call add_fmag
        else
           call add_fRZ
        endif
     endif
  enddo

  !----------------------
  ! evaluation points

  jvec=0
  do ii=1,ivec
     if(nregion(ii).lt.4) then
        jvec=jvec+1
        zR_use(jvec)=zR(ii)
        zZ_use(jvec)=zZ(ii)
        zrho_use(jvec)=max(ZERO,min(ONE,zrho(ii)))
        zchi_use(jvec)=zchi(ii)
     endif
  enddo

  if(jvec.eq.0) return

  if(igrad.eq.0) then
     gtrans = .FALSE.
  else
     gtrans = (neval_fmag.gt.0).or.(.not.RZout)
  endif

  ierr=0
  if(gtrans) then
     allocate(drhodR(jvec),drhodZ(jvec),dthdR(jvec),dthdZ(jvec))
     call xplasma_rzjac(s,zrho_use(1:jvec),zchi_use(1:jvec),ierr, &
          drhodr=drhodR,drhodz=drhodZ, dthdr=dthdR,dthdz=dthdZ, &
          ccwflag=ccwflag)
     if(ierr.ne.0) then
        deallocate(drhodR,drhodZ,dthdR,dthdZ)
        return
     endif
  endif
  
  if(neval_fRZ.gt.0) then
     allocate(zwk(jvec,neval_fRZ))
     call xplasma_eval_prof(s,ideval_fRZ(1:neval_fRZ), &
          xplasma_R_coord,zR_use(1:jvec),xplasma_Z_coord,zZ_use(1:jvec), &
          zwk, iertmp, &
          ideriv1s=ideriv_RZ(1:neval_fRZ,1), &
          ideriv2s=ideriv_RZ(1:neval_fRZ,2))
     if(iertmp.ne.0) then
        ierr=iertmp
        write(lunerr,*) ' ?eqi_getall: unexpected xplasma_eval(R,Z) error!'
        call xplasma_error(s,ierr,lunerr)
     else
        jvec=0
        do ii=1,ivec
           if(nregion(ii).lt.4) then
              jvec=jvec+1

              !  indx.eq.-3 will not arise because Bphi is evaluated
              !  using nsnccwB*g(rho)/R (not f(R,Z))

              do jj=1,neval_fRZ
                 indx=indx_fRZ(jj)
                 if(igrad.eq.0) then
                    if(indx.gt.0) then
                       fvals(ii,indx)=zwk(jvec,jj)
                    else if(indx.eq.-1) then
                       bvec(1,ii)=zwk(jvec,jj)
                    else if(indx.eq.-2) then
                       bvec(2,ii)=zwk(jvec,jj)
                    endif
                 else
                    ideriv=1*ideriv_RZ(jj,1) + 2*ideriv_RZ(jj,2)
                    if(indx.gt.0) then
                       if(ideriv.eq.0) then
                          fvals(ii,indx)=zwk(jvec,jj)
                       else if(ideriv.eq.1) then
                          fgrads(1,ii,indx)=zwk(jvec,jj)
                       else if(ideriv.eq.2) then
                          fgrads(2,ii,indx)=zwk(jvec,jj)
                       endif
                    else if(indx.eq.-1) then
                       if(ideriv.eq.0) then
                          bvec(1,ii)=zwk(jvec,jj)
                       else if(ideriv.eq.1) then
                          gbtensr(1,1,ii)=zwk(jvec,jj)
                       else if(ideriv.eq.2) then
                          gbtensr(2,1,ii)=zwk(jvec,jj)
                       endif
                    else if(indx.eq.-2) then
                       if(ideriv.eq.0) then
                          bvec(2,ii)=zwk(jvec,jj)
                       else if(ideriv.eq.1) then
                          gbtensr(1,2,ii)=zwk(jvec,jj)
                       else if(ideriv.eq.2) then
                          gbtensr(2,2,ii)=zwk(jvec,jj)
                       endif
                    endif
                 endif
              enddo
              if((igrad.eq.1).and.(.not.RZout)) then
                 ! transform gradients --> [perp,pll]
                 zdenom=sqrt(drhodR(jvec)**2+drhodZ(jvec)**2)
                 elrho(1)=drhodR(jvec)/zdenom
                 elrho(2)=drhodZ(jvec)/zdenom
                 if(ccwflag) then
                    elth(1)=-elrho(2); elth(2)= elrho(1)
                 else
                    elth(1)= elrho(2); elth(2)=-elrho(1)
                 endif
                 do jj=1,neval_fRZ,3
                    indx=indx_fRZ(jj)
                    if(indx.gt.0) then
                       zperp=elrho(1)*fgrads(1,ii,indx) + &
                             elrho(2)*fgrads(2,ii,indx)
                       zpll =elth(1)*fgrads(1,ii,indx) + &
                             elth(2)*fgrads(2,ii,indx)
                       fgrads(1,ii,indx)=zperp
                       fgrads(2,ii,indx)=zpll
                    endif
                 enddo
              endif
           endif
        enddo
     endif
     deallocate(zwk)
  endif

  if(neval_fmag.gt.0) then
     allocate(zwk(jvec,neval_fmag))
     call xplasma_eval_prof(s,ideval_fmag(1:neval_fmag), &
          xplasma_rho_coord,zrho_use(1:jvec), &
          xplasma_theta_coord,zchi_use(1:jvec), &
          zwk, iertmp, ccwflag2=ccwflag, &
          ideriv1s=ideriv_mag(1:neval_fmag,1), &
          ideriv2s=ideriv_mag(1:neval_fmag,2))
     if(iertmp.ne.0) then
        ierr=iertmp
        write(lunerr,*) ' ?eqi_getall: unexpected xplasma_eval(rho,theta) error!'
        call xplasma_error(s,ierr,lunerr)
     else
        jvec=0
        do ii=1,ivec
           if(nregion(ii).lt.4) then
              jvec=jvec+1

              !  evaluation gives {f,df/drho,df/dtheta}
              !  gradients to be built later--
              !    except Bphi = nsnccwB*g/R
              !    and grad(Bphi) = nsnccwB*(dg/drho)*grad(rho)/R - g/R**2
              !      are evaluated directly

              do jj=1,neval_fmag
                 indx=indx_fmag(jj)
                 if(igrad.eq.0) then
                    if(indx.gt.0) then
                       fvals(ii,indx)=zwk(jvec,jj)
                    else if(indx.eq.-1) then
                       bvec(1,ii)=zwk(jvec,jj)
                    else if(indx.eq.-2) then
                       bvec(2,ii)=zwk(jvec,jj)
                    else if(indx.eq.-3) then
                       bvec(3,ii)=nsnccwB*zwk(jvec,jj)/zR_use(jvec)
                    endif
                 else
                    ideriv=1*ideriv_mag(jj,1) + 2*ideriv_mag(jj,2)
                    if(indx.gt.0) then
                       if(ideriv.eq.0) then
                          fvals(ii,indx)=zwk(jvec,jj)
                       else if(ideriv.eq.1) then
                          fgrads(1,ii,indx)=zwk(jvec,jj)
                       else if(ideriv.eq.2) then
                          fgrads(2,ii,indx)=zwk(jvec,jj)
                       endif
                    else if(indx.eq.-1) then
                       !  BR
                       if(ideriv.eq.0) then
                          bvec(1,ii)=zwk(jvec,jj)
                       else if(ideriv.eq.1) then
                          gbtensr(1,1,ii)=zwk(jvec,jj)
                       else if(ideriv.eq.2) then
                          gbtensr(2,1,ii)=zwk(jvec,jj)
                       endif
                    else if(indx.eq.-2) then
                       !  BZ
                       if(ideriv.eq.0) then
                          bvec(2,ii)=zwk(jvec,jj)
                       else if(ideriv.eq.1) then
                          gbtensr(1,2,ii)=zwk(jvec,jj)
                       else if(ideriv.eq.2) then
                          gbtensr(2,2,ii)=zwk(jvec,jj)
                       endif
                    else if(indx.eq.-3) then
                       !  Bphi
                       if(ideriv.eq.0) then
                          bvec(3,ii)=nsnccwB*zwk(jvec,jj)/zR_use(jvec)
                       else if(ideriv.eq.1) then
                          gbtensr(1,3,ii)=nsnccwB*zwk(jvec,jj)*drhodR(jvec) -&
                               bvec(3,ii)/zR_use(jvec)
                          gbtensr(2,3,ii)=nsnccwB*zwk(jvec,jj)*drhodZ(jvec)
                       endif
                       !  (ideriv.eq.2 refers to theta derivative = 0 here)
                    endif
                 endif
              enddo
              if(igrad.eq.1) then

                 ! convert {df/drho,df/dtheta} to grad(f)

                 do jj=1,neval_fmag,3
                    indx=indx_fmag(jj)
                    if(indx.gt.0) then
                       zdfdr=fgrads(1,ii,indx)*drhodr(jvec) + &
                             fgrads(2,ii,indx)*dthdr(jvec)
                       zdfdz=fgrads(1,ii,indx)*drhodz(jvec) + &
                             fgrads(2,ii,indx)*dthdz(jvec)
                       fgrads(1,ii,indx)=zdfdr
                       fgrads(2,ii,indx)=zdfdz
                    else if((indx.eq.-1).or.(indx.eq.-2)) then
                       kk=-indx
                       zdfdr=gbtensr(1,kk,ii)*drhodr(jvec) + &
                             gbtensr(2,kk,ii)*dthdr(jvec)
                       zdfdz=gbtensr(1,kk,ii)*drhodz(jvec) + &
                             gbtensr(2,kk,ii)*dthdz(jvec)
                       gbtensr(1,kk,ii)=zdfdr
                       gbtensr(2,kk,ii)=zdfdz
                    endif
                 enddo

                 if(.not.RZout) then
                    ! transform gradients --> [perp,pll]
                    zdenom=sqrt(drhodR(jvec)**2+drhodZ(jvec)**2)
                    elrho(1)=drhodR(jvec)/zdenom
                    elrho(2)=drhodZ(jvec)/zdenom
                    if(ccwflag) then
                       elth(1)=-elrho(2); elth(2)= elrho(1)
                    else
                       elth(1)= elrho(2); elth(2)=-elrho(1)
                    endif
                    do jj=1,neval_fmag,3
                       indx=indx_fmag(jj)
                       if(indx.gt.0) then
                          zperp=elrho(1)*fgrads(1,ii,indx) + &
                               elrho(2)*fgrads(2,ii,indx)
                          zpll =elth(1)*fgrads(1,ii,indx) + &
                               elth(2)*fgrads(2,ii,indx)
                          fgrads(1,ii,indx)=zperp
                          fgrads(2,ii,indx)=zpll
                       endif
                    enddo
                 endif
              endif
           endif
        enddo
     endif
     deallocate(zwk)
  endif

  if((.not.RZout).and.(ierr.eq.0).and.(ibflg.eq.1)) then
     jvec=0
     do ii=1,ivec
        if(nregion(ii).lt.4) then
           jvec=jvec+1
           zBR=bvec(1,ii)
           zBZ=bvec(2,ii)
           zBpol=nsnccw_th*nsnccwI*sqrt(zBR**2+zBZ**2)
           bvec(1,ii)=ZERO
           bvec(2,ii)=zBpol
           if(igrad.eq.1) then
              zdenom=sqrt(drhodR(jvec)**2+drhodZ(jvec)**2)
              elrho(1)=drhodR(jvec)/zdenom
              elrho(2)=drhodZ(jvec)/zdenom
              if(ccwflag) then
                 elth(1)=-elrho(2); elth(2)= elrho(1)
              else
                 elth(1)= elrho(2); elth(2)=-elrho(1)
              endif

              !  grad(Bphi) in perp,pll frame...
              zperp=elrho(1)*gbtensr(1,3,ii) + &
                   elrho(2)*gbtensr(2,3,ii)
              zpll =elth(1)*gbtensr(1,3,ii) + &
                   elth(2)*gbtensr(2,3,ii)
              gbtensr(1,3,ii)=zperp
              gbtensr(2,3,ii)=zpll

              !  (R,Z) grad(BR) & grad(BZ) --> (R,Z) grad(Bpol)

              zBpolgR = (zBR*gbtensr(1,1,ii)+zBZ*gbtensr(1,2,ii))/zBpol
              zBpolgZ = (zBR*gbtensr(2,1,ii)+zBZ*gbtensr(2,2,ii))/zBpol

              !  convert to perp,pll frame

              zperp = elrho(1)*zBpolgR + elrho(2)*zBpolgZ
              zpll  = elth(1)*zBpolgR + elth(2)*zBpolgZ
              gbtensr(1,1,ii)=ZERO
              gbtensr(2,1,ii)=ZERO
              gbtensr(1,2,ii)=zperp
              gbtensr(2,2,ii)=zpll
           endif
        endif
     enddo
  endif

  if(allocated(drhodR)) deallocate(drhodR,drhodZ,dthdR,dthdZ)

  contains
    subroutine add_fRZ

      integer :: n

      if(igrad.eq.0) then
         neval_fRZ=neval_fRZ+1
         ideval_fRZ(neval_fRZ)=id_fRZ(ifcn)
         if(ifcn.le.nlist) then
            indx_fRZ(neval_fRZ)=ifcn
         else
            indx_fRZ(neval_fRZ)=-(ifcn-nlist)
         endif
         ideriv_RZ(neval_fRZ,1:2)=0
      else
         n=neval_fRZ
         ideval_fRZ(n+1:n+3)=id_fRZ(ifcn)
         if(ifcn.le.nlist) then
            indx_fRZ(n+1:n+3)=ifcn
         else
            indx_fRZ(n+1:n+3)=-(ifcn-nlist)
         endif
         ideriv_RZ(n+1:n+3,1:2)=0
         ideriv_RZ(n+2,1)=1
         ideriv_RZ(n+3,2)=1
         neval_fRZ=n+3
      endif

    end subroutine add_fRZ

    subroutine add_fmag

      integer :: n

      if(igrad.eq.0) then
         neval_fmag=neval_fmag+1
         ideval_fmag(neval_fmag)=id_fmag(ifcn)
         if(ifcn.le.nlist) then
            indx_fmag(neval_fmag)=ifcn
         else
            indx_fmag(neval_fmag)=-(ifcn-nlist)
         endif
         ideriv_mag(neval_fmag,1:2)=0
      else
         n=neval_fmag
         ideval_fmag(n+1:n+3)=id_fmag(ifcn)
         if(ifcn.le.nlist) then
            indx_fmag(n+1:n+3)=ifcn
         else
            indx_fmag(n+1:n+3)=-(ifcn-nlist)
         endif
         ideriv_mag(n+1:n+3,1:2)=0
         ideriv_mag(n+2,1)=1
         ideriv_mag(n+3,2)=1
         neval_fmag=n+3
      endif

    end subroutine add_fmag

end subroutine eqi_getall

subroutine eqm_dbdy_grid(zdist,zRmini,zRmaxi,zZmini,zZmaxi, &
     inumRi,inumZi,id_R,id_Z,ierr)
  !
  !  f77 xplasma legacy interface:
  !  set up limiter which is a combination of a box and a fixed distance
  !  set back from the plasma boundary (eqm_dbdy); then set up evenly spaced
  !  grid to cover vacuum region (eqm_rzgrid).

  !  mod DMC Jan 2007 -- force Zmin = -Zmax
  !    some physics modules require this Z grid symmetry

  use xplasma_obj_instance
  use eq_module

  implicit NONE

  !  set up evenly spaced (R,Z) grid of specified size, and set up
  !  a limiter which a fixed distance (zdist) from the plasma, except
  !  where a box [zRmini,zRmaxi]x[zZmini,zZmaxi] cuts in

  !  input:

  real*8 zdist           ! fixed distance of limiter from plasma edge
  real*8 zRmini          ! Rmin of enclosing box
  real*8 zRmaxi          ! Rmax of enclosing box
  real*8 zZmini          ! Zmin of enclosing box
  real*8 zZmaxi          ! Zmax of enclosing box

  integer inumRi         ! size of R grid to generate (minimum: 32)
  integer inumZi         ! size of Z grid to generate (minimum: 32)

  !  output:

  integer id_R                      ! R grid id
  integer id_Z                      ! Z grid id

  integer ierr           ! completion code, 0 = OK

  !--------------------------------------
  !  local:
  real*8, dimension(:), allocatable :: zRgrid   ! R grid (generated)
  real*8, dimension(:), allocatable :: zZgrid   ! Z grid (generated)

  real*8 zRmin,zRmax,zZmin,zZmax,zRlim
  real*8 zmidR,zmidZ,zdelR,zdelZ
  integer i,inumR,inumZ

  real*8, parameter :: zrho_bdy = 1.0d0

  !--------------------------------------

  ierr=0

  inumR=inumRi
  inumZ=inumZi

  if(inumR.lt.32) then
     write(lunerr,*) ' %eqm_dbdy_grid:  inumR = ',inumR,' too small.'
     write(lunerr,*) '  minimum grid size allowed:  32; fixup applied.'
     inumR=32
  endif
  if(inumZ.lt.32) then
     write(lunerr,*) ' %eqm_dbdy_grid:  inumZ = ',inumZ,' too small.'
     write(lunerr,*) '  minimum grid size allowed:  32; fixup applied.'
     inumZ=32
  endif

  if(ierr.ne.0) return

  call eq_glimrz(zrho_bdy,zRmin,zRmax,zZmin,zZmax,ierr)
  if(ierr.ne.0) then
     call eq_errmsg(' ?eqm_dbdy_grid:  eq_glimRZ error occurred.')
     return
  endif

  zRlim=0.5*zRmin
  zRmin=max(zRlim,min(zRmin,zRmini)) ! btw .5 & 1.0*Rmin(plasma bdy)
  zRmax=max(zRmax,zRmaxi)
  zZmin=min(zZmin,zZmini)
  zZmax=max(zZmax,zZmaxi)

  ! force Z grid up-down symmetry
  zZmax = max(abs(zZmin),abs(zZmax))
  zZmin = -zZmax

  ! expand mapped region...

  zmidR=chalf*(zRmin+zRmax)
  zdelR=chalf*(inumR-1)*(zRmax-zRmin)/(inumR-4)
  zmidZ=chalf*(zZmin+zZmax)
  zdelZ=chalf*(inumZ-1)*(zZmax-zZmin)/(inumZ-4)

  allocate(zRgrid(inumR),zZgrid(inumZ))

  do i=1,inumR
     zRgrid(i)=zmidR-zdelR + (i-1)*ctwo*zdelR/(inumR-1)
  enddo

  do i=1,inumZ
     zZgrid(i)=zmidZ-zdelZ + (i-1)*ctwo*zdelZ/(inumZ-1)
  enddo

  call eqm_dbdy(zdist,zRmini,zRmaxi,zZmini,zZmaxi,ierr)

  if(ierr.eq.0) then
     call eqm_rzgrid(zRgrid,zZgrid,0,0,inumR,inumZ,ceps4,id_R,id_Z,ierr)
  endif

  deallocate(zRgrid,zZgrid)

end subroutine eqm_dbdy_grid

subroutine eq_gfnum(zname,ifnum)

  use xplasma_obj_instance
  use xplasma_obj,only:xplasma_profId
  use eq_module

  !  given the name of a profile return its number.  if there is no such
  !  profile, silently return ifnum=0

  IMPLICIT NONE

  character*(*), intent(in) :: zname   ! (input) name of profile
  integer, intent(out) :: ifnum        ! (output) profile id or ZERO

  !----------------------------
  integer :: itype,id,ierr
  !----------------------------

  call xplasma_profId(s,zname,ifnum)

end subroutine eq_gfnum
 
!==================================================

subroutine eq_get_fname(ifnum,zname)

  use xplasma_obj_instance
  use xplasma_obj,only:xplasma_get_item_info
  use eq_module

  !  given id, get name of axis profile.  if an invalid id is given,
  !  a blank name is returned.

  IMPLICIT NONE

  integer, intent(in) :: ifnum          ! profile id number
  character*(*), intent(out) :: zname   ! name of profile

  !-------------------------------
  integer :: itype,ierr
  !-------------------------------

  call xplasma_get_item_info(s,ifnum,ierr, nf_noerr=.TRUE., &
       name=zname, itype=itype)

  if((ierr.ne.0).or.(itype.ne.xplasma_profType)) then
     zname=' '
  endif

end subroutine eq_get_fname

subroutine eq_gfitem(zname,ifnum)

  ! return ID of item of indeterminate type
  ! return ID=0 if no such item exists

  use xplasma_obj_instance
  use xplasma_obj,only:xplasma_find_item
  use eq_module


  character*(*), intent(in) :: zname   ! (input) name of profile
  integer, intent(out) :: ifnum        ! (output) item id or ZERO

  !----------------------------
  integer :: ierr
  !----------------------------

  idtmp = 0
  call xplasma_find_item(s,zname,ifnum,ierr,nf_noerr=.TRUE.)

end subroutine eq_gfitem

SUBROUTINE scrdescur(rmb,zmb,nmb,mpolin,icon,ioflag, &
     fsq,lasym0,lzsmlonly,nmbout,rmbout,zmbout,ier)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, half, one
  USE scrunch_inc1
  USE scrunch_inc2
  implicit none
  integer :: m
  integer :: ntoff
  integer :: ntype
  real(fp) :: time_ou
  integer :: modeno
  real(fp) :: gout
  real(fp) :: g11
  real(fp) :: gmin
  integer :: iter
  integer :: imodes
  real(fp) :: r10
  integer :: n
  integer :: nplane
  real(fp) :: time_in
  integer :: ier
  integer :: i
  integer :: irst
  integer :: nmbout
  integer :: nmb

  real(fp) :: gtest  ! dmc APR 2010

  !       THIS IS PROGRAM DESCUR - WHICH USES A STEEPEST DESCENT
  !       ALGORITHM TO FIND A LEAST SQUARES APPROXIMATION TO AN
  !       ARBITRARY 3-D SPACE CURVE. ANGLE CONSTRAINTS, BASED ON A
  !       MINIMUM SPECTRAL WIDTH CRITERION, ARE APPLIED.
  !       THE CONSTRAINT IS SATISFIED BY TANGENTIAL VARIATIONS
  !       ALONG THE CURVE.
  !
  !       Written by Steve Hirshman ORNL
  !       Modifications by Dick Wieland PPPL
  !
  !       Reference:   "Optimized Fourier Representations for
  !                     three-dimensional magnetic surfaces", S.P. Hirshman
  !                     and H.K. Meier, Phys. Fluids 28,1387 (1985)
  !***********************************************************************
  !       REVISION 1:  January 26, 1989
  !                    Compute Fit to individual toroidal planes separately
  !                    and then Fourier decompose in phi, using optimized
  !                    angle representation
  !       REVISION 1.1 September 18, 1990 (Wieland)
  !                    Modularize It.
  !       REVISION 1.2 October 6, 1992 (Wieland)
  !                    Ioflag to optionally turn off IO to screen.
  !                    Ier return to indicate error
  !                    Ier=1;  Ok
  !                    Ier=11; The magnetic axis is not enclosed by boundary
  !                    Ier=12; Incorrect initial angle assignment
  !                    Ier=13; Time step reduced 100 times without convergence
  !                    Ier=99: some other error; message displayed.
  !       REVISION 1.3 March 31, 1993 (Wieland)
  !                    So far unsuccessful attempt to do a hot restart
  !                    C.f. lines with NINIT
  !       REVISION 1.4 May 11, 1993 (Wieland)
  !                    turn on the Rmns and Zmnc terms
  !       REVISION 1.5 Oct 21, 1993 (Wieland)
  !                    modify the constraints per SPH
  !                    ZC(m=1) = RS(m=1)
  !       REVISION 1.6 Feb 7, 1994 (Wieland) final SPH asym update
  !                    If asym terms (RC,ZS) are on, lasym=.true.
  !       REVISION 1.7 Dec 20, 1994 (Wieland) use LZAKHAROV0 to
  !                    prototype UDA with z=z0+z*sin(theta) only
  !       REVISION 1.8 Jan 28, 1997 (Terpstra) Change dimensions in
  !                    Subroutine Funct1des to * from 1 because this
  !                    is flagged as an error on the HP's at GA
  !       REVISION 1.9 Apr 25, 1997 (Wieland) clean up interface and
  !                    incorporate changes made by JPJ at JET
  !
  !***********************************************************************
 
  !**   Input:  rmb(nmb)        real(fp) array of boundary R's (any units)
  !**           zmb(nmb)        real(fp) array of boundary Z's (any units)
  !**           nmb             integer ... number of boundary points
  !**           convention for rmb,zmb is that rmb(1)=rmb(nmb), zmb(1)=zmb(nmb)
  !**           mpolin          number of moments to compute (6 means do 0...5)
  !**           icon            integer ... dummy, not used
  !                (rev dmc -- if icon > 0 icon = LUN for "scrdescur_debug.dat"
  !                a debug binary file)
  !**           ioflag          logical ... TRUE for printout
  !**   Output: fsq             real(fp) ... resulting "force" residue
  !**   Input:  lasym0          logical ... TRUE to calculate Rmc,Rms,Zmc,Zms
  !**                                       FALSE to calc only Rmc,Zms terms
  !**           nmbout          1st dim of rmbout,zmbout
  !**   Output: rmbout(nmbout,2)  rmbout(*,1) = Rmc terms
  !**                             rmbout(*,2) = Rms terms
  !**           zmbout(nmbout,2)  zmbout(*,1) = Zmc terms
  !**                             zmbout(*,2) = Zms terms
  !**           ier               integer ... error return (1 = OK)
  !**
  !**   Fitting the boundary points to :
  !**     R = sum(m=0,mpolin-1){Rmc*cos(m*theta) + Rms*sin(m*theta)}
  !**     Z = sum(m=0,mpolin-1){Zmc*cos(m*theta) + Zms*sin(m*theta)}

  !**           * * * * * * * * * * * * * * * * * * * * *
 
  real(fp) :: rmb(nmb),zmb(nmb),fsq
  real(fp) :: rmbout(0:nmbout,2),zmbout(0:nmbout,2)
  integer :: mpolin,icon
  logical :: ioflag,lasym0,lzsmlonly
  !**********************************************************************
  !       CONTROL DATA THAT CAN BE SPECIFIED BY USER
  !**********************************************************************
  integer, save :: niter=3000, nstep=100, ninit=0
  real(fp), save :: ftol=1.e-5_fp
  !**********************************************************************
  !       DATA USED INTERNALLY (NOT TO BE CHANGED BY CASUAL USER)
  !**********************************************************************
  real(fp), save :: tot_time=zero
  !**********************************************************************
  !  dmc: debug
  if(icon.gt.0) then
    open(unit=icon,file='scrdescur_debug.dat',status='unknown', &
         form='unformatted')
    call scrpreset_wr(icon)
    write(icon) nmb,mpolin
    write(icon) rmb(1:nmb)
    write(icon) zmb(1:nmb)
    write(icon) lasym0
    write(icon) nmbout
    close(unit=icon)
  endif
  !**********************************************************************
  ier=1  ! assume success initially
  fsq=-99.0_fp
 
  nfp=1
  deltf=one
  irst =1
  pexp=4.0_fp
  qexp=one
  !**********************************************************************
  lasym = lasym0
  lzakharov = lzsmlonly
  ninit = 0         ! to turn off non-working hot restart
  nresets = 0
  ioflagc = ioflag
  nthetax = nmb
  mpolx = min(17,mpolin)  ! dmc: >17 seems to be unsafe (Feb. 2005)
  if (nmb.gt.ntheta) then
    write(lunmsg,1) nmb,ntheta
1   format(' Scrunch%% error: # boundary pts (',i4,') exceeds limit (',i4,')')
    CALL scrabwarn(lunmsg,'Scrunch%% error: # boundary pts > limit')
    ier=99
    return
  end if
  if (mpolin.gt.mpol) then
    write(lunmsg,2) mpolin,mpol
2   format(' Scrunch%% error: # moments )',i4,') exceeds limit (',i4,')')
    CALL scrabwarn(lunmsg,' Scrunch%% error: # moments > limit')
    ier=99
    return
  end if

  !**********************************************************************
  !       MPOL = NUMBER OF POLOIDAL MODES USED IN CURVE-FIT
  !
  !       MPNT = NUMBER OF R AND Z MODES APPEARING IN FIT
  !       NTHETA=NUMBER OF THETA POINTS
  !       N2   = TOTAL NUMBER OF RESIDUALS IN FSQ
  !
  !       STACKING OF XVEC ARRAY (FOR FIXED TOROIDAL PLANE)
  !       XVEC(1,mpol):Rmcos            XVEC(1+mpol,2*mpol):Rmsin
  !       XVEC(1+2*mpol,3*mpol):Zmcos   XVEC(1+3*mpol,4*mpol):Zmsin
  !       XVEC(4*mpol,n2): Theta angle
  !**********************************************************************
  !**********************************************************************
  !       INITIALIZE FIXED m,n ARRAYS
  !**********************************************************************
  if (ninit.eq.0) CALL scrfixaraydes
  !**********************************************************************
  !       READ IN POINTS ON CURVE TO BE FIT
  !**********************************************************************
  !       call inptsdes
  do i=1,nmb
    rin3d(i,1) = rmb(i)
    zin3d(i,1) = zmb(i)
  end do
  !**********************************************************************
  !       COMPUTE INITIAL GUESSES (MUST ORDER ANGLES MONOTONICALLY FOR
  !       NON-STARLIKE DOMAINS)
  !**********************************************************************
  if (ninit.eq.0) CALL scringuessdes (ier)
  if (ier.ne.1) Then
    write(lunmsg,*) ' At error return of descur, ier, fsq =', ier, fsq
    return
  endif
  !**********************************************************************
  !       BEGIN MAIN INTEGRATION LOOP
  !**********************************************************************
  CALL cpu_time (time_in)
  if (ioflagc) write(lunmsg,10)
10 format(/' ITERATIONS    RMS ERROR    FORCE GRADIENT    <M>', &
        '    m #''s <= ON')

  do nplane = 1,nphi2
    if (ioflagc) write(lunmsg,200) nplane
200 format(/'                  Fitting toroidal plane # ',i3)
    !**********************************************************************
    !       INITIALIZE M=0 and M=1 MODE AMPLITUDES
    !**********************************************************************
    if (ninit.eq.0) then
      do n = 1,n2
        xstore(n)= zero
        xdot(n)  = zero
        xvec(n)  = zero
      end do
      CALL scramplituddes(r0n(nplane),z0n(nplane),angle(1,nplane), &
           xvec,xvec(1+mpol),xvec(1+mpol2),xvec(1+mpol3), &
           xvec(1+mpol4),rin3d(1,nplane),zin3d(1,nplane),ier)
    end if
    if (ier.ne.1) Then
      write(lunmsg,*) ' At error return of descur, ier, fsq =', ier, fsq
      return
    end if
    r10 = half*(abs(xvec(2      )) + abs(xvec(2+ mpol)) &
         +      abs(xvec(2+mpol2)) + abs(xvec(2+mpol3)))
    imodes = mpolx
    delt=deltf
    ninit = 1
 
    do 30 iter=1,niter
      CALL scrfunct1des(xvec,xvec(1+mpol),xvec(1+mpol2),xvec(1+mpol3), &
           xvec(1+mpol4),gvec,gvec(1+mpol),gvec(1+mpol2), &
           gvec(1+mpol3),gvec(1+mpol4),fsq,r10,imodes)
      go to (50,40) iter
      gmin = MIN(gmin,gnorm)
      CALL screvolvedes(g11)
      !**********************************************************************
      !       RUDIMENTARY TIME STEP CONTROL
      !**********************************************************************
      if(gnorm/gmin.gt.1.e6_fp)irst = 2
      if( (irst.eq.2) .or. (gmin.eq.gnorm) ) &
           CALL scrrestartdes(irst,ier)
 
      !  DMC, experimenting with remedy for intermittent instability
      !  at higher moment counts

      if(imodes.lt.10) then
        gtest=1.e-4_fp
      else
        gtest=1.e-6_fp
      end if

      if((gnorm.lt.gtest).and.(imodes.lt.mpolx))then
        imodes = imodes + 1
        CALL scrrestartdes(irst,ier)
        if (ier.ne.1) Then
          write(lunmsg,*) ' At error return of descur, ier, fsq =', ier, fsq
          return
        end if
        irst = 2
        delt = delt/.95_fp
      end if
      if(mod(iter,nstep).eq.0.or.(gnorm.lt.ftol**2)) go to 60
      go to 30
40    g11=gnorm
      go to 30
50    gmin = gnorm
      imodes = 3
60    gout = sqrt(gnorm)
      modeno = imodes - 1
      if(iter.eq.1)modeno = mpolx-1
      CALL cpu_time(time_ou)
      tot_time = tot_time + (time_ou - time_in)
      if (ioflagc) write(lunmsg,110)iter,fsq,gout,specw,modeno
      CALL cpu_time(time_in)
      if((gnorm.lt.ftol**2.and.imodes.eq.mpolx).or.fsq.lt.ftol) &
           go to 80
30  continue
110 format(i8,1x,2e16.3,f10.2,i8)
    !**********************************************************************
    !       STORE FINAL ANSWER FOR POST-PROCESSING
    !**********************************************************************
80  do ntype = 1,4
      ntoff = mpol*(ntype-1)
      do m = 1,mpolx
        result(nplane,m,ntype) = xvec(m+ntoff)
      end do
    end do
  end do
  !**********************************************************************
  !       FINAL OUTPUT LOOP
  !**********************************************************************
  if (ioflagc) write(lunmsg,90) tot_time
90 format(/,' COMPUTATIONAL TIME = ',1pe12.3,' SECONDS'/)
320 if (ioflagc) write(lunmsg,330)pexp,qexp
330 format(' ANGLE CONSTRAINTS WERE APPLIED ',/, &
         ' BASED ON RM**2 + ZM**2 SPECTRUM WITH P = ', &
         f8.2,' AND Q = ',f8.2,/)
  !call print_it(result(1,1,1),result(1,1,2),result(1,1,3),result(1,1,4))
  CALL scrprintdes
  do i=1,mpolx
    rmbout(i-1,1) = rmomb(i,1)
    rmbout(i-1,2) = rmomb(i,2)
    zmbout(i-1,1) = zmomb(i,1)
    zmbout(i-1,2) = zmomb(i,2)
  end do
  !call plotter
  !write(lunmsg,*) ' %nscrunch:  At the end of descur, fsq =', fsq
  !call scrdesdbg('scrdescur',rmb,zmb,nmb,nmbout,rmbout,zmbout)

  return
END SUBROUTINE scrdescur

subroutine eqi_rzbox_binfo_set(zrho,zrzbuf,id,ierr)

  !  store bdy R & Z data in a labeled xplasma black box

  use xplasma_definitions
  use eqi_rzbox_module
  implicit NONE

  real*8, intent(in) :: zrho
  real*8 :: zrzbuf(nsrch1*4)
  integer, intent(out) :: id
  integer, intent(out) :: ierr

  !-------------------------
  integer :: idata(1),iertmp
  real*8 :: zrho_bdy
  real*8, dimension(:), pointer :: zrz_ptr
  !-------------------------

  idata = nsrch1

  call xplasma_author_set(sp, xplasma_xmhd, ierr)
  if(ierr.ne.0) return

  call eqi_extrap_rho_bdy(zrho_bdy)

  if(abs(zrho-1.0d0).lt.1.0d-14) then

     !  create

     allocate(zrz_ptr(4*nsrch1+1))
     zrz_ptr(1:4*nsrch1)=zrzbuf
     zrz_ptr(4*nsrch1+1)=zrho
     call xplasma_create_blackbox(sp,'__RZ_BDY_INFO',99,id,ierr,&
          iarray=idata, r8array=zrz_ptr, &
          label='(R,Z) plasma bdy search contour', units='m')
     deallocate(zrz_ptr)
  else if(abs(zrho-zrho_bdy).lt.1.0d-14) then

     !  create

     allocate(zrz_ptr(4*nsrch1+1))
     zrz_ptr(1:4*nsrch1)=zrzbuf
     zrz_ptr(4*nsrch1+1)=zrho
     call xplasma_create_blackbox(sp,'__RZ_EXTRAP_BDY_INFO',99,id,ierr, &
          iarray=idata, r8array=zrz_ptr, &
          label='(R,Z) extrapolated bdy search contour', units='m')
     deallocate(zrz_ptr)
  else

     ! update if exists; otherwise: create...

     call xplasma_find_item(sp,'__RZ_SURF_INFO',id,ierr,nf_noerr=.TRUE.)
     if(id.ne.0) then
        call xplasma_blackbox_retrieve(sp,id,ierr, r8a_ptr = zrz_ptr)
        zrz_ptr(1:4*nsrch1) = zrzbuf
        zrz_ptr(4*nsrch1+1) = zrho
     else
        allocate(zrz_ptr(4*nsrch1+1))
        zrz_ptr(1:4*nsrch1)=zrzbuf
        zrz_ptr(4*nsrch1+1)=zrho
        call xplasma_create_blackbox(sp,'__RZ_SURF_INFO',99,id,ierr, &
             iarray=idata, r8array=zrz_ptr, &
             label='(R,Z) plasma surface search contour', units='m')
        deallocate(zrz_ptr)
     endif
  endif

  call xplasma_author_clear(sp, xplasma_xmhd, iertmp)

  nullify(zrz_ptr)

end subroutine eqi_rzbox_binfo_set

subroutine eqi_rzbox_binfo_get(zrho,zrzbuf,ierr)

  !  restore bdy R & Z data from xplasma black box

  use xplasma_definitions
  use eqi_rzbox_module
  implicit NONE

  real*8, intent(in) :: zrho  ! expect 1.00 for bdy;  >1.00 for extrap. bdy.
  real*8 :: zrzbuf(nsrch1*4)
  integer, intent(out) :: ierr

  !-------------------------
  integer :: idata(1),id,icheck
  real*8 :: zrho_bdy
  real*8, dimension(:), pointer :: zrz_ptr
  !-------------------------

  call eqi_extrap_rho_bdy(zrho_bdy)

  if(abs(zrho-1.0d0).lt.1.0d-14) then
     call xplasma_find_item(sp,'__RZ_BDY_INFO',id,ierr)
     icheck=0
  else if(abs(zrho-zrho_bdy).lt.1.0d-14) then
     call xplasma_find_item(sp,'__RZ_EXTRAP_BDY_INFO',id,ierr)
     icheck=0
  else
     call xplasma_find_item(sp,'__RZ_SURF_INFO',id,ierr,nf_noerr=.TRUE.)
     icheck=1
  endif

  if(id.eq.0) ierr=1

  if(ierr.ne.0) then
     zrzbuf = 0
     return
  endif

  call xplasma_blackbox_retrieve(sp,id,ierr, iarray=idata, r8a_ptr=zrz_ptr)
  if(icheck.eq.1) then
     if(zrz_ptr(nsrch1*4+1).ne.zrho) then
        ierr=1
        zrzbuf=0
     endif
  endif
  if(ierr.eq.0) then
     zrzbuf=zrz_ptr(1:nsrch1*4)
  endif

  nullify(zrz_ptr)

end subroutine eqi_rzbox_binfo_get

      INTEGER FUNCTION MCSORT_CH_ORDER(I,INDX,MAXN,CHDATA,CHELEM)
C
C  ORDER RULE FUNCTION FOR *CHARACTER* DATA
C
      INTEGER INDX(MAXN)	! DATA SORT ORDER
      CHARACTER*(*) CHDATA(MAXN)	! CHARACTER DATA ARRAY
      CHARACTER*(*) CHELEM	! CHARACTER ELEMENT TO BE COMPARED
C
      INTEGER I		! POINT OF COMPARISON
C
      II=INDX(I)
      IF(CHELEM.LT.CHDATA(II)) THEN
        GO TO 10
      ELSE IF(CHELEM.GT.CHDATA(II)) THEN
        GO TO 30
      ELSE
        GO TO 20
      ENDIF
C
 10   CONTINUE
        MCSORT_CH_ORDER=-1
        GO TO 100
C
 20   CONTINUE
        MCSORT_CH_ORDER=0
        GO TO 100
C
 30   CONTINUE
        MCSORT_CH_ORDER=+1
        GO TO 100
C
 100  CONTINUE
      RETURN
      END

module geqdsk_nomds_mod
!
! package geqdsk data
! pletzer@ pppl.gov Mon Jul 31 16:04:04 EDT 2000
!
! Refer to http://lithos.gat.com/efit/g_eqdsk.html for a detailed
! description of the data contained in g-eqdsk files. The module
! herein follows the terminology described in the above document; variables
! bear the same name with their units trailing after a underscore (_). A
! double underscore (__) stands for /, as in Wb__Rad (=Weber/rads).
 
  implicit NONE

  integer, parameter :: geq_r8 = selected_real_kind(12,100)
  real(geq_r8), parameter :: geq_pi = 3.141592653589793116
  real(geq_r8), parameter :: geq_2pi = 6.2831853071795862320
  real(geq_r8), parameter :: geq_mu0 = 1.2566370614359172885e-06
 
  type geqdsk
 
 
     integer  :: NW ! Number of horizontal R grid points
     integer  :: NH ! Number of vertical Z grid points
     character*8 :: CASE_(6)
     real(geq_r8) :: RDIM_M, ZDIM_M ! box dimensions
     real(geq_r8) :: RCENTR_M ! Major radius (not magnetic axis!)
     real(geq_r8) :: RLEFT_M ! left side of computational box
     real(geq_r8) :: ZMID_M ! mid elevation of computational box
     real(geq_r8) :: RMAXIS_M, ZMAXIS_M ! Magnetic axis position
     real(geq_r8) :: BCENTR_T, CURRENT_A
     ! poloidal flux/2*pi on magnetic axis and plasma boundary
     real(geq_r8) :: SIMAG_Wb__Rad, SIBRY_Wb__Rad
     real(geq_r8), dimension(:), allocatable :: FPOL_TM ! toroidal current
     real(geq_r8), dimension(:), allocatable :: PRES_Nt__M2 ! pressure
     real(geq_r8), dimension(:), allocatable :: FFPRIM_T2M2Rad__Wb ! F F'(psi)
     real(geq_r8), dimension(:), allocatable :: pprime_NtRad__M2Wb ! p'(psi)
     real(geq_r8), dimension(:,:), allocatable :: psirz_Wb__Rad
     real(geq_r8), dimension(:), allocatable :: QPSI
     integer  :: nbbbs ! Number of plasma-vacuum boundary points
     integer  :: limitr ! Number of limiter points
     real(geq_r8), dimension(:), allocatable :: RBBBS_M, ZBBBS_M ! Plasma-vacuum
     real(geq_r8), dimension(:), allocatable :: RLIM_M, ZLIM_M ! Limiter geometry
 
!  the "original" timebase contains some points for which there is no valid
!    data, and these are excluded from the "actual" timebase.  T_INDEX
!    indexes from the "actual" to the "orginal" time dimension.
 
     integer, dimension(:), allocatable :: T_NW
     integer, dimension(:), allocatable :: T_NH
 
     integer :: kt_max  ! max index for T_RDIM,T_ZDIM ....
 
     integer :: kt_sw2  ! storage ordering for profiles f(psi,t)
     integer :: kt_sw3  ! storage ordering for profile psi(R,Z,t)
 
! affected quantities:  T_NW,T_NH,T_RDIM,T_ZDIM,T_RCENTR,T_RLEFT,T_CMID
!
! kt_sw2,kt_sw3:
! (for some EFIT trees, profiles are stored psi-contiguous; and in
! others, t-contiguous; the code has to adapt)
 
     real(geq_r8), dimension(:), allocatable :: T_RDIM,T_ZDIM
     real(geq_r8), dimension(:), allocatable :: T_RCENTR
     real(geq_r8), dimension(:), allocatable :: T_RLEFT
     real(geq_r8), dimension(:), allocatable :: T_ZMID
     real(geq_r8), dimension(:), allocatable :: T_RMAXIS, T_ZMAXIS
     real(geq_r8), dimension(:), allocatable :: T_BCENTR, T_CURRENT
     real(geq_r8), dimension(:), allocatable :: T_SIMAG, T_SIBRY
 
     real(geq_r8), dimension(:,:), allocatable :: T_FPOL
     real(geq_r8), dimension(:,:), allocatable :: T_PRES
     real(geq_r8), dimension(:,:), allocatable :: T_FFPRIM
     real(geq_r8), dimension(:,:), allocatable :: T_PPRIME
     real(geq_r8), dimension(:,:), allocatable :: T_QPSI
 
     real(geq_r8), dimension(:,:,:), allocatable :: T_PSIRZ
 
     integer, dimension(:), allocatable :: T_NBBBS
     real(geq_r8), dimension(:,:), allocatable :: T_RBBBS,T_ZBBBS
 
!    the "time dependent" limiter data is not read; the limiter is assumed
!    not to move.
 
  end type geqdsk
 
! static items:
 
contains
 
  subroutine geq_xz_is_in_plasma(geq, x, z, iok, reltol)
 
    ! Return iok=0 if (x,z) is within plasma boundary
 
    ! Method: integrate over the plasma boundary,
    ! the angle between the point (x,z)
    ! and a segment of the boundary. If the result is
    ! nearly 2*pi then the point must be inside, if
    ! it's close to zero it must be outside.
 
    ! (dmc) also compute distance from (x,z) to the nearest point
    ! of approach to the boundary (treated as a sequence of line
    ! segments), normalized to the distance of the boundary point
    ! furthest from (x,z)
 
    ! iok = 0 => point inside
    ! iok = 1 => point ouside
    ! iok = 2 => can't tell for sure
 
    ! reltol
 
    implicit none
    type(geqdsk), intent(in) :: geq
    real(geq_r8), intent(in) :: x, z
    integer, intent(out) :: iok
    real(geq_r8), intent(out) :: reltol
 
    real(geq_r8) angle, dotprod, crsprod, x1, x2, z1, z2, tol
    real(geq_r8) distmin2,distmax2,dist2,dist12sq,alpha,beta
    real(geq_r8), parameter :: ZERO = 0.0d0
    real(geq_r8), parameter :: ONE  = 1.0d0
 
    integer i
 
    !------------------------------------------
 
    iok = 1
    reltol = 1000.0_geq_r8
 
    angle = 0._geq_r8
 
    x1=geq%RBBBS_M(geq%NBBBS)
    z1=geq%ZBBBS_M(geq%NBBBS)
 
    ! reference distance:  plasma bdy:  min((Rmax-Rmin),(Zmax-Zmin))
    distmax2=min( &
         maxval(geq%RBBBS_M(1:geq%NBBBS))-minval(geq%RBBBS_M(1:geq%NBBBS)), &
         maxval(geq%ZBBBS_M(1:geq%NBBBS))-minval(geq%ZBBBS_M(1:geq%NBBBS)) )
    distmax2=distmax2*distmax2  ! ref. dist. squared
 
    if(distmax2.eq.0._geq_r8) return   ! assume outside -- degenerate case.
 
    dist2=(x-x1)*(x-x1)+(z-z1)*(z-z1)
    distmin2=dist2
 
    do i = 1, geq%NBBBS - 1
 
       x1 = geq%RBBBS_M(i  ); z1 = geq%ZBBBS_M(i  )
       x2 = geq%RBBBS_M(i+1); z2 = geq%ZBBBS_M(i+1)
 
       dist2=(x-x1)*(x-x1)+(z-z1)*(z-z1)
       distmin2=min(distmin2,dist2)  ! find distance^2 to closest bdy pt
 
       dotprod = (x2-x)*(x1-x) + (z2-z)*(z1-z)
       crsProd = (x2-x)*(z1-z) - (z2-z)*(x1-x)
       dist12sq = (x2-x1)*(x2-x1)+(z2-z1)*(z2-z1)
       !  skip coincident points
       if((crsProd.eq.ZERO).or.(dist12sq.le.ZERO)) cycle
 
       angle = angle + abs(atan2(crsProd, dotprod))
 
       !  refine distance estimate by considering nearest approach to
       !  line segment itself, not just the end pts.
       !     P=(x,z)  P1=(x1,z1)  P2=(x2,z2)  DEL=(P2-P1)
       !     DELperp = vector perpendicular to DEL and of same length
       !
       !  bdy segment is represented by Pseg = P1 + alpha*DEL
       !     with alpha in [0,1]
       !
       !  line from P normal to Pseg is Plin = P + beta*DELperp
       !     and the intersection is found by setting Plin=Pseg and
       !     solving the 2x2 system for alpha & beta...
       !     if alpha in [0,1] then P is closer to the segment than
       !     to the segment end points, and the distance^2 is
       !     abs(beta)*|DEL|.
 
       alpha=-( (x2-x1)*(x1-x)+(z2-z1)*(z1-z) )/dist12sq
       beta = ( (x2-x1)*(z1-z)-(z2-z1)*(x1-x) )/dist12sq
 
       !debug  write(6,*) x1+alpha*(x2-x1), z1+alpha*(z2-z1)
       !debug  write(6,*) x -beta*(z2-z1),  z +beta*(x2-x1)
 
       if((alpha.ge.ZERO).and.(alpha.le.ONE)) then
          distmin2=min(distmin2,(dist12sq*beta*beta))
       endif
 
    enddo
 
 
    ! may need to adjust this tol
    tol = 0.01_geq_r8 * (2._geq_r8 * geq_pi)
 
    iok = 2
    if(abs(angle - geq_2pi) < tol) iok = 0
    if(abs(angle          ) < tol) iok = 1
 
    reltol=sqrt(distmin2/distmax2)
 
  end subroutine geq_xz_is_in_plasma
 
!------------------------------------------------------
! compute GS error
 
  subroutine geq_GSerror(isign, geq, nx1, nz1, x, z, bdist, gserror, ier)
 
    ! Compute rel. Grad Shafranov error *inside* plasma boundary
    ! (error is set to zero outside) (also, points "too close" to
    ! the boundary have error set to zero, see "bdist" control).
    !   ier=1 is set if no points are found (which generally indicates a
    !   very bad input dataset).
 
    use ezspline_obj
    use ezspline
    use geqdsk_nomds_aux

    implicit none
 
    integer, intent(in)      :: isign    ! +1 for EFIT G-eqdsk

    ! if Psi(a) < Psi(0), isign = -1 -- never true for EFIT but it
    !  is true for some imitators...

    type(geqdsk), intent(in) :: geq      ! G-eqdsk object
    integer, intent(in)      :: nx1, nz1 ! X,Z grids...
    real(geq_r8), intent(in) :: x(nx1), z(nz1)
 
    real(geq_r8), intent(in) :: bdist    ! min. relative distance to bdy
 
    real(geq_r8), intent(out) :: gserror(nx1, nz1)
    integer, intent(out) :: ier
 
    !  points within bdist*min((Rmax-Rmin),(Zmax-Zmin)) of the boundary
    !  have their error set to zero.  {Rmin,Rmax,Zmin,Zmax} are taken
    !  from the G-Eqdsk plasma boundary data.
 
    type(ezspline2) :: psispl
    type(ezspline1) :: ppspl, ggpspl
    real(geq_r8), dimension(:,:), allocatable :: d2xPsi, dxPsi, d2zPsi
    real(geq_r8), dimension(:), allocatable :: zwk
    real(geq_r8) :: pprime, ggprime, psi, r_jphi0
    real(geq_r8) :: dist_norm
    real(geq_r8) :: loc_psimin,loc_psimax
    integer iok, i, j, idum1, idum2, ict, ictbb
    character*30 zlabel       ! (for debugging)
 
    iok = 0
    ier = 0
 
    ! compute del^* psi
 
    call ezspline_init(psispl, geq%NW, geq%NH, (/0,0/), (/0,0/), iok)
    if(iok/=0) call ezspline_error(iok)
 
    psispl%x1 = (/ &
         & ( geq%RLEFT_M + &
         & geq%RDIM_M*real(i-1,geq_r8)/real(geq%NW-1, geq_r8), &
         & i = 1, geq%NW)/)
    psispl%x2 = (/ &
         & ( geq%ZMID_M - geq%ZDIM_M/2._geq_r8 + &
         & geq%ZDIM_M*real(i-1,geq_r8)/real(geq%NH-1, geq_r8), &
         & i = 1, geq%NH)/)
 
    call ezspline_setup(psispl, isign*geq%psirz_Wb__Rad, iok)
    if(iok/=0) call ezspline_error(iok)
 
    allocate(d2xPsi(nx1, nz1), stat=iok)
    allocate(dxPsi(nx1, nz1), stat=iok)
    allocate(d2zPsi(nx1, nz1), stat=iok)
 
    call ezspline_derivative(psispl, 1, 0, nx1, nz1, x, z, dxPsi, iok)
    if(iok/=0) call ezspline_error(iok)
 
    call ezspline_derivative(psispl, 2, 0, nx1, nz1, x, z, d2xPsi, iok)
    if(iok/=0) call ezspline_error(iok)
 
    call ezspline_derivative(psispl, 0, 2, nx1, nz1, x, z, d2zPsi, iok)
    if(iok/=0) call ezspline_error(iok)
 
    gserror = 0._geq_r8 ! d2xPsi - dxPsi/x + d2zPsi ! so far only del^* psi
 
    ! compute R^2 p' + g g'
 
    call ezspline_init(ppspl, geq%NW, (/0,0/), iok)
    if(iok/=0) call ezspline_error(iok)
 
    ppspl%x1 = (/ (  geq%SIMAG_Wb__Rad + (geq%SIBRY_Wb__Rad-geq%SIMAG_Wb__Rad) * &
         & real(i-1,geq_r8)/real(geq%NW-1), i = 1, geq%NW) /)
    ppspl%x1 = isign*ppspl%x1
 
    call ezspline_setup(ppspl, isign*geq_mu0*geq%pprime_NtRad__M2Wb, iok)
    if(iok/=0) call ezspline_error(iok)
 
    call ezspline_init(ggpspl, geq%NW, (/0,0/), iok)
    if(iok/=0) call ezspline_error(iok)
 
    ggpspl%x1 = ppspl%x1
 
    call ezspline_setup(ggpspl, isign*geq%FFPRIM_T2M2Rad__Wb, iok)
    if(iok/=0) call ezspline_error(iok)
 
    ! normalization = "nominal r_jphi"
    r_jphi0 = maxval(abs( &
         geq%RMAXIS_M**2 * geq_mu0*geq%pprime_NtRad__M2Wb(1:geq%NW) + &
         geq%FFPRIM_T2M2Rad__Wb(1:geq%NW) ))
    r_jphi0 = isign * r_jphi0
 
    ict = 0
    ictbb = 0
    do j = 1, nz1
       do i = 1, nx1
          ! get psi
          call ezspline_interp(psispl, x(i), z(j), psi, iok)

          if((i*j).eq.1) then
             loc_psimin=psi
             loc_psimax=psi
          else
             loc_psimin=min(loc_psimin,psi)
             loc_psimax=max(loc_psimax,psi)
          endif

          if( (psi>isign*geq%SIMAG_Wb__Rad .and. psi<isign*geq%SIBRY_Wb__Rad)  .or.  &
              (psi>isign*geq%SIBRY_Wb__Rad .and. psi<isign*geq%SIMAG_Wb__Rad) ) then
             ictbb = ictbb + 1

             ! most likely inside the plasma
             iok = 1 ! outside by default
             call geq_xz_is_in_plasma(geq, x(i), z(j), iok, dist_norm)
             if(iok==0 .and. dist_norm > bdist ) then
                ! definitely inside the plasma
                ict = ict + 1
                call ezspline_interp(ppspl, psi, pprime, iok)
                call ezspline_interp(ggpspl, psi, ggprime, iok)
                gserror(i,j) = (d2xPsi(i,j) - dxPsi(i,j)/x(i) + d2zPsi(i,j) &
                     & + x(i)**2 * pprime + ggprime)/r_jphi0
             endif
          endif
       enddo
    enddo
 
    call ezspline_free(psispl, iok)
    if(iok/=0) call ezspline_error(iok)
    call ezspline_free(ppspl, iok)
    if(iok/=0) call ezspline_error(iok)
    call ezspline_free(ggpspl, iok)
    if(iok/=0) call ezspline_error(iok)
 
    deallocate(d2xPsi)
    deallocate(dxPsi)
    deallocate(d2zPsi)
 
    if(ict.eq.0) then
       ier=1
       if(isign.ne.1) then
          write(lunmsg,*) ' %geq_GSerror: EQDSK format variant detected.'
       endif

       if(ictbb.eq.0) then
          write(lunmsg,*) ' ?geq_GSerror: no Psi(R,Z) values in range:'
          write(lunmsg,*) '   (Psi values expected to be in Wb/rad)'
          write(lunmsg,*) '   Psi(axis) data: ',isign*geq%SIMAG_Wb__Rad
          write(lunmsg,*) '   Psi(bdy) data:  ',isign*geq%SIBRY_Wb__Rad
          write(lunmsg,*) '   min value in Psi(R,Z): ',loc_psimin
          write(lunmsg,*) '   max value in Psi(R,Z): ',loc_psimax
       else
          write(lunmsg,*) &
               ' ?geq_GSerror: valid Psi(R,Z) values not found inside bdy'
       endif
    endif

  end subroutine geq_GSerror
 
 !------------------------------------------------------
! set LUN for G-EQdisk file i/o
 
  subroutine geq_setlun(ilun)
 
    use geqdsk_nomds_aux
 
    implicit none
    integer, intent(in) :: ilun    ! unit number
 
    neqdsk=ilun
 
    return
  end subroutine geq_setlun
 
!------------------------------------------------------
! retrieve LUN for G-EQdisk file i/o
 
  subroutine geq_getlun(ilun)
 
    use geqdsk_nomds_aux
 
    implicit none
    integer, intent(out) :: ilun    ! unit number
 
    ilun=neqdsk
 
    return
  end subroutine geq_getlun
 
!------------------------------------------------------
  subroutine geq_writ(geq, filename, ier)
!
! ...write a G-EQDSK file from a stored objec...
!
    use geqdsk_nomds_aux
 
    implicit none
    type(geqdsk), intent(in) :: geq
    character*(*), intent(in) :: filename
    integer, intent(out) :: ier
 
! local stuff
 
    integer iok
    integer :: idum = 0
    real(geq_r8) :: adum = 0.0_geq_r8
    integer i,j
 
! executable code
 
    ier = 0
 
    open(neqdsk, file=filename, status='unknown', action='write', iostat=iok)
 
    if (iok /= 0) then
       write(lunmsg,*) ' %geq_writ: open failure: ',filename
       ier = 1
       return
    endif
 
    write (neqdsk,2000) (geq%case_(i),i=1,6),idum,geq%nw,geq%nh
    write (neqdsk,2020) geq%rdim_m, geq%zdim_m, &
         & geq%rcentr_m, geq%rleft_m, geq%zmid_m
    write (neqdsk,2020) geq%rmaxis_m,geq%zmaxis_m, &
         & geq%simag_Wb__Rad,geq%sibry_Wb__Rad,geq%bcentr_t
    write (neqdsk,2020) geq%current_a,geq%simag_Wb__Rad, &
         & adum,geq%rmaxis_m,adum
    write (neqdsk,2020) geq%zmaxis_m,adum,geq%sibry_Wb__Rad,adum,adum
 
    write (neqdsk,2020) (geq%fpol_tm(i),i=1,geq%nw)
    write (neqdsk,2020) (geq%pres_Nt__M2(i),i=1,geq%nw)
    write (neqdsk,2020) (geq%ffprim_T2M2Rad__Wb(i),i=1,geq%nw)
    write (neqdsk,2020) (geq%pprime_NtRad__M2Wb(i),i=1,geq%nw)
    write (neqdsk,2020) ((geq%psirz_Wb__Rad(i,j),i=1,geq%nw),j=1,geq%nh)
    write (neqdsk,2020) (geq%qpsi(i),i=1,geq%nw)
    write (neqdsk,2022) geq%nbbbs,geq%limitr
 
    write (neqdsk,2020) (geq%rbbbs_m(i),geq%zbbbs_m(i),i=1,geq%nbbbs)
 
    write (neqdsk,2020) (geq%rlim_m(i),geq%zlim_m(i),i=1,geq%limitr)
 
    close(neqdsk)
 
2000 format (6a8,3i4)
2020 format (5e16.9)
2022 format (2i5)
 
  end subroutine geq_writ
!------------------------------------------------------
! initialize a G-EQdisk object from file or MDS+ data
 
  subroutine geq_init(geq, filenami, ier)
 
    use geqdsk_nomds_aux
 
    implicit none
    type(geqdsk), intent(inout) :: geq
    character*(*), intent(in) :: filenami
    integer, intent(out) :: ier
 
! local stuff
 
    character*200 filename,zpath,ztail
    integer iok, i, j, idum, istat, indx, ilast
    character*4 mtest
    real(geq_r8) adum,zsimag
 
! local, for MDSplus support
 
    logical ireduce
    integer icln,ict,ilen,ishot,iopen
    character*10 opt
    character*11 itest
    character*50 mds_server
    character*20 mds_tree
    character*10 mds_id1
    character*10 mds_id2
    character*20 mds_tstr,z20
    real(geq_r8) ztime
 
    character*48 tmplbl
    integer iltmp,iltmp2
 
!-------------------------------------
! executable code
 
    ier = 0

! dmc modification -- translate EFIT_INDEX file specification if given
    itest=filenami(1:11)
    call uupper(itest)
    if(itest.eq.'EFIT_INDEX:') then
       call geqdsk_findex(filenami,ilast,indx)
       call geqdsk_index1_path(neqdsk,filenami(1:ilast),zpath)
       if(zpath.eq.'?') then
          write(lunmsg,*) ' ?geqdsk_mod.geq_init: index file access failure.'
          ier=1
       else
          call geqdsk_index1_gfile(neqdsk,filenami(1:ilast),indx,ztail,ier)
          if(zpath.eq.' ') then
             filename=trim(ztail)
          else
             filename=trim(zpath)//trim(ztail)
          endif
       endif
    else
       filename=filenami
    endif
    if(ier.ne.0) return
 
    mtest=filename(1:4)
    call uupper(mtest)
 
    iopen = 0                ! MDS+ tree open flag
 
    if(mtest.ne.'MDS+') then
 
! prevent memory leaks, in case where G-EQdisk object is reused.
 
       call geq_free(geq,ier)
 
!  ********* file access *************
 
       open(neqdsk, file=filename, action='read', status='old', iostat=iok)
 
       if (iok /= 0) then
          ier = 1
          go to 1001
       endif
  
       read (neqdsk,2000) (geq%case_(i),i=1,6),idum,geq%nw,geq%nh
!dbg       write(6,*) geq%nw,geq%nh
       read (neqdsk,2020) geq%rdim_m, geq%zdim_m, &
            & geq%rcentr_m, geq%rleft_m, geq%zmid_m
!dbg       write(6,*) geq%rdim_m,geq%zdim_m
       read (neqdsk,2020) geq%rmaxis_m,geq%zmaxis_m, &
            & geq%simag_Wb__Rad,geq%sibry_Wb__Rad,geq%bcentr_t
!dbg       write(6,*) geq%rmaxis_m,geq%zmaxis_m
       read (neqdsk,2020) geq%current_a,zsimag, &
            & adum,geq%rmaxis_m,adum
!dbg       write(6,*) geq%current_a
       read (neqdsk,2020) geq%zmaxis_m,adum,geq%sibry_Wb__Rad,adum,adum
!dbg       write(6,*) geq%sibry_Wb__Rad
 
       if(zsimag.ne.geq%simag_Wb__Rad) then
          write(lunmsg,*) &
               'G-eqdsk file warning: simag inconsistency, 1st value taken.'
          write(lunmsg,*) '1st simag(3rd line, 3rd word)=',geq%simag_Wb__Rad
          write(lunmsg,*) '2nd simag(4th line, 2nd word)=',zsimag
       endif
 
       allocate(geq%fpol_tm(geq%nw), stat=iok)
       if(iok /= 0) then
          ier = 2
          go to 1000
       endif
       allocate(geq%pres_Nt__M2(geq%nw), stat=iok)
       if(iok /= 0) then
          ier = 2
          go to 1000
       endif
       allocate(geq%ffprim_T2M2Rad__Wb(geq%nw), stat=iok)
       if(iok /= 0) then
          ier = 2
          go to 1000
       endif
       allocate(geq%pprime_NtRad__M2Wb(geq%nw), stat=iok)
       if(iok /= 0) then
          ier = 2
          go to 1000
       endif
       allocate(geq%qpsi(geq%nw), stat=iok)
       if(iok /= 0) then
          ier = 2
          go to 1000
       endif
 
       allocate(geq%psirz_Wb__Rad(geq%nw, geq%nh), stat=iok)
       if(iok /= 0) then
          ier = 2
          go to 1000
       endif
 
       read (neqdsk,2020) (geq%fpol_tm(i),i=1,geq%nw)
!dbg       write(6,*) 'fpol',(geq%fpol_tm(i),i=1,geq%nw)
       read (neqdsk,2020) (geq%pres_Nt__M2(i),i=1,geq%nw)
!dbg       write(6,*) 'pres',(geq%pres_Nt__M2(i),i=1,geq%nw)
       read (neqdsk,2020) (geq%ffprim_T2M2Rad__Wb(i),i=1,geq%nw)
       read (neqdsk,2020) (geq%pprime_NtRad__M2Wb(i),i=1,geq%nw)
       read (neqdsk,2020) ((geq%psirz_Wb__Rad(i,j),i=1,geq%nw),j=1,geq%nh)
       read (neqdsk,2020) (geq%qpsi(i),i=1,geq%nw)
!dbg       write(6,*) 'qpsi',(geq%qpsi(i),i=1,geq%nw)
       read (neqdsk,2022) geq%nbbbs,geq%limitr
 
       allocate(geq%rbbbs_m(geq%nbbbs+1), geq%zbbbs_m(geq%nbbbs+1), stat=iok)
       if(iok /= 0) then
          ier = 2
          go to 1000
       endif
       allocate(geq%rlim_m(geq%limitr+1), geq%zlim_m(geq%limitr+1), stat=iok)
       if(iok /= 0) then
          ier = 2
          go to 1000
       endif
       geq%rbbbs_m=0
       geq%zbbbs_m=0
 
       read (neqdsk,2020) (geq%rbbbs_m(i),geq%zbbbs_m(i),i=1,geq%nbbbs)
!dbg       write(6,*) 'r,zbbbs', (geq%rbbbs_m(i),geq%zbbbs_m(i),i=1,geq%nbbbs)
       call geq_ckrzc(geq%rbbbs_m(1),geq%zbbbs_m(1),geq%nbbbs,geq%nbbbs+1)
!dbg       write(6,*) 'r,z(ck)', (geq%rbbbs_m(i),geq%zbbbs_m(i),i=1,geq%nbbbs)
 
       read (neqdsk,2020) (geq%rlim_m(i),geq%zlim_m(i),i=1,geq%limitr)
!dbg       write(6,*) 'r,zlim', (geq%rlim_m(i),geq%zlim_m(i),i=1,geq%limitr)
       call geq_ckrzc(geq%rlim_m(1),geq%zlim_m(1),geq%limitr,geq%limitr+1)
 
      ! rotation data not extracted....
 
       close(neqdsk)
 
2000   format (6a8,3i4)
2020   format (5e16.9)
2022   format (2i5)
 
    else
       write(lunmsg,*) ' ?MDS+ not supported'
       call errmsg_exit(' ?geqdsk__nomds_mod -- error')
    endif
 
1000 continue
 
    ! check that bdy is entirely contained inside the grid domain--
    ! flag an error if not.

    if (ier==0) then
       call geq_bchk(geq, 'plasma_bdy(RBBBS_m,ZBBBS_m)', &
            geq%nbbbs, geq%rbbbs_m, geq%zbbbs_m, ier)
    end if

    return
 
1001 continue
 
    ! failed to open the geqdsk file
 
    write(lunmsg,*) ' ?geq_init: file ', filename,' does not exist'
    return
 
  end subroutine geq_init
  subroutine geq_mergbb(rbout,zbout, &
       zf1,inb1,rb1,zb1, zf2,inb2,rb2,zb2)

    real(geq_r8), dimension(:) :: rbout,zbout  ! output contour

    real(geq_r8), intent(in) :: zf1   ! weighting for 1st input contour
    integer, intent(in) :: inb1       ! 1st input contour array dimension
    real(geq_r8), intent(in) :: rb1(inb1),zb1(inb1)  ! 1st contour

    real(geq_r8), intent(in) :: zf2   ! weighting for 2nd input contour
    integer, intent(in) :: inb2       ! 2nd input contour array dimension
    real(geq_r8), intent(in) :: rb2(inb2),zb2(inb2)  ! 2nd contour

    !--------------------------------
    ! local:

    integer :: i,n1,n2,n1a,n2a,nbout
    real(geq_r8), dimension(:), allocatable :: r1,z1,r2,z2
    real(geq_r8), dimension(:), allocatable :: a1,d1,a2,d2
    real(geq_r8) :: rcen1,zcen1,rcen2,zcen2,rcen,zcen
    real(geq_r8) :: rmaxwk,rminwk
    real(geq_r8) :: zdamin,zalim,ztha,dfind1,dfind2,dfind
    !--------------------------------

    nbout=size(rbout)
    zdamin=geq_2pi/(10*nbout-1)

    allocate(r1(inb1+1),z1(inb1+1))
    allocate(r2(inb2+1),z2(inb2+1))

    r1(1:inb1)=rb1; r1(inb1+1)=0.0_geq_r8
    z1(1:inb1)=zb1; z1(inb1+1)=0.0_geq_r8

    r2(1:inb2)=rb2; r2(inb2+1)=0.0_geq_r8
    z2(1:inb2)=zb2; z2(inb2+1)=0.0_geq_r8

    n1=inb1
    n2=inb2

    !  make sure contours are closed with duplicate points removed...

    call geq_ckrzc(r1,z1,n1,inb1+1)
    call geq_ckrzc(r2,z2,n2,inb2+1)

    rmaxwk=maxval(r1(1:n1))
    rminwk=minval(r1(1:n1))

    rcen1=0.55_geq_r8*rmaxwk + 0.45_geq_r8*rminwk  ! shift out 10%
    zcen1=0.5_geq_r8*(maxval(z1(1:n1))+minval(z1(1:n1)))

    rmaxwk=maxval(r2(1:n2))
    rminwk=minval(r2(1:n2))

    rcen2=0.55_geq_r8*rmaxwk + 0.45_geq_r8*rminwk  ! shift out 10%
    zcen2=0.5_geq_r8*(maxval(z2(1:n2))+minval(z2(1:n2)))

    rcen = zf1*rcen1 + zf2*rcen2
    zcen = zf1*zcen1 + zf2*zcen2

    allocate(a1(n1),d1(n1),a2(n2),d2(n2))

    call geq_aseq(rcen1,zcen1,r1,z1,n1,zdamin,a1,d1,n1a)
    call geq_aseq(rcen2,zcen2,r2,z2,n2,zdamin,a2,d2,n2a)

    do i=1,nbout
       ztha=geq_2pi/2 - (i-1)*geq_2pi/(nbout-1)  ! pi ... 0 ... -pi
       call geq_afind(a1,d1,n1a,ztha,dfind1)
       call geq_afind(a2,d2,n2a,ztha,dfind2)
       dfind = zf1*dfind1 + zf2*dfind2

       rbout(i)=rcen+cos(ztha)*dfind
       zbout(i)=zcen+sin(ztha)*dfind
    enddo

  end subroutine geq_mergbb

  subroutine geq_aseq(rcen,zcen,r,z,n,damin,a,d,na)

    ! convert closed sequence to succession of angles and distances
    ! relative to indicated center; force minimum angle change per step

    real(geq_r8), intent(in) :: rcen,zcen
    integer, intent(in) :: n
    real(geq_r8), intent(in) :: r(n),z(n)
    real(geq_r8), intent(in) :: damin
    real(geq_r8) :: a(n),d(n)   ! angles and distances
    integer, intent(out) :: na  ! number spanning +/- 2pi range

    !----------------------
    integer :: isign,i,ishift
    real(geq_r8) :: alast,alim,aa,aprev
    !----------------------

    isign=0
    do i=1,n-1
       a(i)=atan2(z(i)-zcen,r(i)-rcen)
       d(i)=sqrt((z(i)-zcen)**2+(r(i)-rcen)**2)
       if(i.gt.1) then
          if(a(i).gt.a(i-1)) then
             isign=isign+1
          else
             isign=isign-1
          endif
       endif
    enddo

    if(isign.lt.0) then
       isign=-1
       a(1:n-1)=a(1:n-1)*isign
    else
       isign=1
    endif
    
    alast=a(1)+geq_2pi
    alim=alast-damin
    a(n)=alast
    d(n)=d(1)

    ishift=0
    na=1
    i=1
    aprev=a(1)
    do
       i=i+1
       if(i.eq.n) then
          na=na+1
          a(na)=alast
          d(na)=d(n)
          exit
       endif
       aa=a(i)+ishift*geq_2pi
       if(aa.lt.aprev-geq_2pi/2) then
          ishift=1
          aa=aa+geq_2pi
       endif
       if((aa.ge.aprev+damin).and.(aa.le.alim)) then
          na=na+1
          a(na)=aa
          d(na)=d(i)
       endif
    enddo

    if(na.lt.n) then
       a(na+1:n)=0
       d(na+1:n)=0
    endif

    if(isign.eq.-1) a=a*isign

  end subroutine geq_aseq

  subroutine geq_afind(a,d,n,ang,dist)
    ! interpolate distance-- linear interpolation of parabolic fits
    !  as a function of angle

    integer, intent(in) :: n
    real(geq_r8), intent(in) :: a(n),d(n)  ! dist vs. angle
    real(geq_r8), intent(in) :: ang        ! angle in
    real(geq_r8), intent(out) :: dist      ! distance out

    ! a is either monotonic increasing or monotonic decreasing
    !----------------------------
    real(geq_r8) :: zang,zfac1,zfac2,zd1,zd2
    integer :: isign,iest
    !----------------------------
    ! force angle into range

    zang=ang

    if(zang.lt.min(a(1),a(n))) then
       do
          zang = zang + geq_2pi
          if(zang.ge.min(a(1),a(n))) exit
       enddo
    else if(zang.gt.max(a(1),a(n))) then
       do
          zang = zang - geq_2pi
          if(zang.le.max(a(1),a(n))) exit
       enddo
    endif

    if(a(n).gt.a(1)) then
       isign=1
    else
       isign=-1
    endif

    iest = 1 + (zang-a(1))*(n-1)/(a(n)-a(1))
    iest = max(1,min((n-1),iest))

    if(isign*zang.lt.isign*a(iest)) then
       do
          if(iest.eq.1) exit
          iest=iest-1
          if(isign*zang.ge.isign*a(iest)) exit
       enddo
    else if(isign*zang.gt.isign*a(iest+1)) then
       do
          if((iest+1).eq.n) exit
          iest=iest+1
          if(isign*zang.le.isign*a(iest+1)) exit
       enddo
    endif

    zfac2=(zang-a(iest))/(a(iest+1)-a(iest))
    zfac1=1.0_geq_r8-zfac2

    if(iest.eq.1) then
       call dfit(a(n-1)-isign*geq_2pi,d(n-1),a(1),d(1),a(2),d(2), &
            zang,zd1)
    else
       call dfit(a(iest-1),d(iest-1),a(iest),d(iest),a(iest+1),d(iest+1), &
            zang,zd1)
    endif

    if(iest.eq.(n-1)) then
       call dfit(a(n-1),d(n-1),a(n),d(n),a(2)+isign*geq_2pi,d(2), &
            zang,zd2)
    else
       call dfit(a(iest),d(iest),a(iest+1),d(iest+1),a(iest+2),d(iest+2), &
            zang,zd2)
    endif

    dist = zfac1*zd1 + zfac2*zd2

    contains
      subroutine dfit(am,dm,a,d,ap,dp,ang,dist)
        ! parabolic fit; ang btw am and ap; am,a,ap either strict increasing
        ! or strict decreasing.
        !   d(am)=dm; d(a)=d; d(ap)=dp; want d(ang)

        real(geq_r8), intent(in) :: am,dm,a,d,ap,dp,ang
        real(geq_r8), intent(out) :: dist

        real(geq_r8) :: xm,xp,fm,fp,c1,c2,x,den,f
        real(geq_r8) :: dlin,dmin,dmax

        !  f = c1*x**2 + c2*x;  ang = x+a;  dist = f+d

        xm = am-a
        xp = ap-a

        fm = dm-d
        fp = dp-d

        x = ang-a

        den = xp*xm*(xp-xm)
        c1 = (fp*xm-fm*xp)/den
        c2 = (fm*xp*xp-fp*xm*xm)/den

        f = x*(c1*x+c2)

        dist = f + d

        ! mod DMC: limits need to be imposed, for some extreme cases...
        ! these are based on the linear interpolation

        if(x*xm.ge.0.0_geq_r8) then
           f=x/xm
           dlin = f*dm + (1.0_geq_r8-f)*d
        else
           f=x/xp
           dlin = f*dp + (1.0_geq_r8-f)*d
        endif

        dmin = dlin*0.90_geq_r8
        dmax = dlin*1.15_geq_r8

        if((dist.lt.dmin).OR.(dist.gt.dmax)) then
           ! limits...
           !!! write(6,*) 'dm,d,dp = ',dm,d,dp
           !!! write(6,*) ' --> got: ',dist
           dist=max(dmin,min(dmax,dist))
           !!! write(6,*) ' --> use: ',dist
           !!! write(6,*) ' x_ratio: ',min(abs(xm),abs(xp))/max(abs(xm),abs(xp))
           !!! write(6,*) ' '
        endif

      end subroutine dfit

  end subroutine geq_afind

!------------------------------------------------------
!  free memory associated with G-EQdisk object
!  if the object was never initialized: deallocate errors are ignored!
!
  subroutine geq_free(geq, ier)
    implicit none
    type(geqdsk), intent(inout) :: geq
    integer, intent(out) :: ier
 
    ier = 0
 
! basic G-EQdisk items
 
    call geq_free_slice(geq)
 
! items for time dependent G-EQdisk data from MDSplus
 
    call geq_free_tvar(geq)
 
  end subroutine geq_free
 
!-----------------------------------------------
! deallocate G-EQdisk time slice data
 
  subroutine geq_free_slice(geq)
    implicit none
    type(geqdsk), intent(inout) :: geq
 
    integer istat
 
    deallocate(geq%fpol_tm,stat=istat)
    deallocate(geq%pres_Nt__M2,stat=istat)
    deallocate(geq%ffprim_T2M2Rad__Wb,stat=istat)
    deallocate(geq%pprime_NtRad__M2Wb,stat=istat)
    deallocate(geq%qpsi,stat=istat)
 
    deallocate(geq%psirz_Wb__Rad,stat=istat)
 
    deallocate(geq%rbbbs_m,stat=istat)
    deallocate(geq%zbbbs_m,stat=istat)
 
  end subroutine geq_free_slice
 
!-----------------------------------------------
! deallocate (MDS+) time variation data
 
  subroutine geq_free_tvar(geq)
    implicit none
    type(geqdsk), intent(inout) :: geq
 
    integer istat
 
    deallocate(geq%t_nw,stat=istat)
    deallocate(geq%t_nh,stat=istat)
 
    deallocate(geq%t_rdim,stat=istat)
    deallocate(geq%t_zdim,stat=istat)
    deallocate(geq%t_rcentr,stat=istat)
    deallocate(geq%t_rleft,stat=istat)
    deallocate(geq%t_zmid,stat=istat)
    deallocate(geq%t_rmaxis,stat=istat)
    deallocate(geq%t_zmaxis,stat=istat)
    deallocate(geq%t_bcentr,stat=istat)
    deallocate(geq%t_current,stat=istat)
    deallocate(geq%t_simag,stat=istat)
    deallocate(geq%t_sibry,stat=istat)
 
    deallocate(geq%t_fpol,stat=istat)
    deallocate(geq%t_pres,stat=istat)
    deallocate(geq%t_ffprim,stat=istat)
    deallocate(geq%t_pprime,stat=istat)
    deallocate(geq%t_qpsi,stat=istat)
 
    deallocate(geq%t_psirz,stat=istat)
 
    deallocate(geq%t_nbbbs,stat=istat)
 
    deallocate(geq%t_rbbbs,stat=istat)
    deallocate(geq%t_zbbbs,stat=istat)
 
    deallocate(geq%rlim_m,stat=istat)
    deallocate(geq%zlim_m,stat=istat)
 
  end subroutine geq_free_tvar
 
!.............................................................................
 
  subroutine geq_error(ier)
    implicit none
    integer, intent(in) :: ier
 
    integer lunout
 
!.....................
 
    call geqdsk_lunmsg_get(lunout)
 
    select case (ier)
 
       case (1)
          write(lunout,*) &
               & 'geqdsk::geqdsk_init:: ERROR cannot open G-EQDSK file!'
       case (2)
          write(lunout,*) &
               & 'geqdsk::geqdsk_init:: ERROR occurred while allocating!'
       case (3)
          write(lunout,*) &
               & 'geqdsk::geqdsk_init:: MDS+ access string parse error!'
       case (4)
          write(lunout,*) &
               & 'geqdsk::geqdsk_init:: MDS+ slice time request not readable!'
       case (5)
          write(lunout,*) &
               & 'geqdsk::geqdsk_init:: MDS+ error (unspecified)!'
       case (6)
          write(lunout,*) &
               & 'geqdsk::geqdsk_init:: MDS+ i/o error!'
       case (7)
          write(lunout,*) &
               & 'geqdsk::geqdsk_init:: MDS+ data consistency error!'
 
       case default
 
    end select
  end subroutine geq_error
 
!-----------------------------------------------
  subroutine geq_echo(str1,str2)
    implicit none
    character*(*) str1,str2   ! message components
 
    integer lunout,ilen
 
    call geqdsk_lunmsg_get(lunout)
 
    ilen=max(1,len_trim(str1))
    write(lunout,'(a)') str1(1:ilen)
    ilen=max(1,len_trim(str2))
    write(lunout,'(2x,a)') str2(1:ilen)
 
  end subroutine geq_echo
 
  subroutine geq_nanscan(zexpr,inum,zr4buf,ilnanflag)
    character*(*), intent(in) :: zexpr  ! MDSplus expression (for message)
    integer, intent(in) :: inum         ! array dimension
    real, intent(inout) :: zr4buf(inum)       ! array to be scanned for NANs
    logical, intent(inout) :: ilnanflag(inum) ! FLAG any NaN occurrences

    ! detect NaNs by writing value into a character string; if character string
    ! using "*" format.  If this contains no decimal point assume a NaN

    ! a warning message is printed, the element flag is set, and the value
    ! is cleared to prevent FPEs occurring later...

    ! NOTE that the ilnanflag array is NOT cleared to .FALSE. This is the
    ! caller's responsibility; this allows multiple geq_nanscan calls on
    ! multiple equivalently shaped data items, s.t. the flag is a logical OR
    ! of NaNs occurring in any of the data items.

    character*30 :: nantest
    integer :: ii,lunout

    do ii=1,inum
       nantest=' '
       write(nantest,*) zr4buf(ii)
       if(index(nantest,'.').eq.0) then
          ilnanflag(ii)=.TRUE.
          zr4buf(ii)=0.0
          call geqdsk_lunmsg_get(lunout)
          write(lunout,*) ' *** at index ',ii,': ',trim(nantest), &
               ' detected in ',trim(zexpr)
       endif
    enddo

  end subroutine geq_nanscan

  subroutine geq_bchk(geq,zlbl,inum,rb,zb,ier)

    ! scan the bdy data -- report error on any points "outside the box".

    use geqdsk_nomds_aux
    implicit NONE

    type(geqdsk), intent(in) :: geq    ! G-eqdsk data object
    character*(*), intent(in) :: zlbl  ! label for contour
    integer, intent(in) :: inum        ! number of (R,Z) points
    real*8, intent(inout) :: rb(inum),zb(inum)  ! the (R,Z) point sequence

    integer, intent(out) :: ier        ! return code, 0=OK

    real*8, parameter :: threshold = 2.d-5  ! fix up out of bound points which are less than this threshold

    !--------------------------
    ! local:
    real*8 :: zrmin,zrmax,zzmin,zzmax
    integer :: ib,iwarnR,iwarnZ,iwasR,iwasZ
    !--------------------------

    zrmin = geq%Rleft_m
    zrmax = zrmin + geq%Rdim_m

    zzmin = geq%Zmid_m - geq%Zdim_m * 0.5d0
    zzmax = zzmin + geq%Zdim_m

    ier = 0
    iwarnR = 0
    iwarnZ = 0

    do ib = 1,inum
       if((rb(ib).lt.zrmin).or.(rb(ib).gt.zrmax)) then
          iwasR = iwarnR
          if(iwarnR.eq.0) then
             iwarnR=1
             write(lunmsg,*) ' ?geq_bchk: '//trim(zlbl)//' out of R bounds:'
             write(lunmsg,*) '  Rmin, Rmax = ',zRmin,zRmax
          endif
          write(lunmsg,*) '  Rb(',ib,')= ',Rb(ib)
          if (iwasR<=0) then
             if (max(zrmin-rb(ib),rb(ib)-zrmax)<threshold*(zrmax-zrmin)) then
                write(lunmsg,*) '  ---> !fixup applied'
                rb(ib) = min(zrmax,max(rb(ib),zrmin))
                iwarnR = -1
             else
                write(lunmsg,*) '  ---> ?fixup not possible'
             end if
          end if
       endif
       if((zb(ib).lt.zzmin).or.(zb(ib).gt.zzmax)) then
          iwasZ = iwarnZ
          if(iwarnZ.eq.0) then
             iwarnZ=1
             write(lunmsg,*) ' ?geq_bchk: '//trim(zlbl)//' out of Z bounds:'
             write(lunmsg,*) '  Zmin, Zmax = ',zZmin,zZmax
          endif
          write(lunmsg,*) '  Zb(',ib,')= ',Zb(ib)
          if (iwasZ<=0) then
             if (max(zzmin-zb(ib),zb(ib)-zzmax)<threshold*(zzmax-zzmin)) then
                write(lunmsg,*) '  ---> !fixup applied'
                zb(ib) = min(zzmax,max(zb(ib),zzmin))
                iwarnZ = -1
             else
                write(lunmsg,*) '  ---> ?fixup not possible'
             end if
          end if
       endif
    enddo

    if (iwarnR>0 .or. iwarnZ>0) ier=1
  end subroutine geq_bchk

  subroutine geq_curtime(geq,ztime1)

    ! fetch the current time (if MDS+ EFIT tree is in use)
    !  if data was from a G file, no time is available; ztime1=0.00 will be
    !  returned.

    type(geqdsk), intent(in) :: geq ! geqdsk object w/possible MDS+ time series
    real(geq_r8), intent(out) :: ztime1  ! time returned

!    if(.not.allocated(geq%gtime_s)) then
       ztime1=0.00
!    else
!       ztime1=geq%curtime
!    endif

  end subroutine geq_curtime

end module geqdsk_nomds_mod

subroutine eq_rget_binsm(inrho,zrho,id,zdelta,iint,zval,ierr)
  !
  !  given an integrated profile function id,
  !
  !  return an integrated profile, smoothed onto the user's grid
  !  from the step-function defined by binning the density on the function's
  !  original grid.
  !
  implicit NONE
 
  integer, intent(in) :: inrho           ! target gridsize, must be .gt.1
  real*8, intent(in) :: zrho(inrho)      ! target grid-- strict ascending order
 
  integer, intent(in) :: id              ! function id of f(rho) profile
 
  real*8, intent(in) :: zdelta           ! smoothing parameter
                                         ! if <0, zdelta=delta(rho) assumed.
 
  integer, intent(in) :: iint            ! data type id
  !  iint=1 -- area integral profile being smoothed --
  !            Examples: current density profiles
  !  iint=2 -- volume integral profile being smoothed --
  !            Examples: density, energy density, ptcl/power/momentum source
  !                      functions, ...
  !
  !    for iint > 0, the data is binned on the original grid, but smoothed
  !    on the user grid.  The unsmoothed unintegrated profile (e.g. density
  !    profile) becomes a step function with step widths matching the original
  !    grid of the data.  It is smoothed using a triangular weighting function
  !    whose base half-width (smoothing parameter) is  zdelta.
  !
  !    If the smoothing parameter is too small, the step-
  !    function-like behavior of the binned density profile will remain
  !    evident in the result
  !
  !      zdelta =~ delta(rho)
  !
  !    is recommended, where delta(rho) is the stepsize of the function's
  !    underlying rho grid.  The recommended value is used if the passed
  !    value for zdelta is < 0.  If zdelta=0, no smoothing occurs.
  !    if zdelta > 0, smoothing occurs using the user specified zdelta.
  !
  !    note that the result is independent of the interpolating function
  !    xplasma has for the (integrated) profile function #id.
  !
  !  NOTE: smoothing integrated profiles directly, e.g. with eq_rget_sm,
  !    is hazardous, because, if d/dV of the smoothed result is evaluated
  !    near the axis it will generally have a pole singularity there.
 
  real*8, intent(out) :: zval(inrho)     ! results of smoothed interpolation
 
  !  zval(rho) is a weighted average of the original profile over the
  !            range [rho-zdelta,rho+zdelta] with a triangular weighting
  !            function whose weight goes to 0 at the interval enpoints.
 
  integer ierr  ! completion code 0=OK
 
!$r8real_input:  zrho,zdelta
!$r8real_output:  zval
 
  !--------------------------------------------
  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: bcav = 0.5d0  ! smoothing bc
  real*8 zsm,zrhomin,zrhomax
  integer ix,lunerr
 
  !  for integral-constrained smoothing
  real*8, dimension(:), allocatable :: zrhoi  ! user grid, extended/merged
  integer, dimension(:), allocatable :: imapu ! map back to user grid
  real*8, dimension(:), allocatable :: zvali  ! integrated profile at zrhoi
  real*8, dimension(:), allocatable :: zvol   ! associated total vol or area
 
  integer inumloc,inumrho,iuser,iorig
  real*8, dimension(:), allocatable :: zrholoc  ! grid for density profile
  real*8, dimension(:), allocatable :: zdens  ! density profile
 
  real*8 ztol,zdsum,zdens0
 
  !  for checking type of function for integral-constrained smoothing:
  !  must be f(rho) -- mag. coordinate.
 
  integer magdim,magfit,cyldim,cylfit,iwarn
  integer id_grid,ingrid,idum,ixp
  real*8, dimension(:), allocatable :: zrho_orig  ! orig. rho of f(rho)
  integer, dimension(:), allocatable :: imapo ! map back to original grid
 
  !--------------------------------------------

  call eqi_rget_binck(inrho,zrho,id,iint,ierr)
  if(ierr.ne.0) return

  !-------------------------------------------------------
  !  smoothing with integration...
 
  call eq_rholim(zrhomin,zrhomax)
  zsm=min(zdelta,(zrhomax-zrhomin)/4) ! sanity check on smoothing parameter
 
  !--------------------------------------------
 
  if(zsm.eq.ZERO) then
     call eq_rget_bin(inrho,zrho,id,iint,zval,ierr)
     return
  endif

  !--------------------------------------------

  call eq_fun(id,magdim,magfit,cyldim,cylfit,iwarn,ierr)
  if(ierr.ne.0) return
  if(magdim.ne.1) then
     call eq_get_lunerr(lunerr)
     write(lunerr,*) ' ?eq_rget_binsm: iint=',iint
     write(lunerr,*) '  integral-constrained smoothing available only'
     write(lunerr,*) '  for profiles of form f(rho).'
     ierr=1
     return
  endif
  ztol=1.d-8*(zrhomax-zrhomin)
 
  !  get original grid...
 
  call eq_fun_rhogrid(id,id_grid)
  call eq_ngrid(id_grid,ingrid)
 
  allocate(zrho_orig(ingrid))
  call eq_grid(id_grid,zrho_orig,ingrid,idum,ierr)
  if(ierr.ne.0) then
     deallocate(zrho_orig)
     return
  endif

  !  if delta < 0 reset smoothing to match grid spacing

  if(zsm.lt.0.0d0) then
     zsm=zrho_orig(ingrid)-zrho_orig(1) ! safe upper limit
     do ix=1,inrho-1
        zsm=min(zsm,(zrho_orig(ix+1)-zrho_orig(ix)))
     enddo
  endif

  !  merge user grid and data grid
 
  allocate(zrhoi(inrho+ingrid))
  allocate(imapu(inrho+ingrid),imapo(inrho+ingrid)); imapu=0; imapo=0
 
  inumrho=1
  zrhoi(1)=zrhomin
  imapo(1)=1
  iorig=2         ! 1st pt of original grid is always zrhomin
 
  iuser=1         ! 1st pt of user grid might also be at zrhomin
  if(zrho(1).lt.zrhomin+ztol) then
     imapu(1)=1
     iuser=2
  endif
 
  do
     if((iorig.gt.ingrid).and.(iuser.gt.inrho)) exit
     if(iorig.gt.ingrid) then
        ! iuser.le.inrho -- must be last pt...
        if(iuser.lt.inrho) then
           call eq_errmsg('?eq_rget_binsm: grid merge algorithm failure.')
           ierr=99
           deallocate(zrhoi,imapu,imapo)
           return
        endif
        imapu(inumrho)=inrho
        iuser=inrho+1
        cycle
     endif
     if(iuser.gt.inrho) then
        inumrho=inumrho+1
        imapo(inumrho)=iorig
        zrhoi(inumrho)=zrho_orig(iorig)
        iorig=iorig+1
        cycle
     endif
 
     ! pts from both grids available; chose the minimum.
 
     if(zrho(iuser).lt.zrho_orig(iorig)) then
        inumrho=inumrho+1
        imapu(inumrho)=iuser
        zrhoi(inumrho)=zrho(iuser)
        iuser=iuser+1
        if(zrho_orig(iorig).lt.zrho(iuser-1)+ztol) then
           imapo(inumrho)=iorig
           iorig=iorig+1      ! pts are nearly equal
        endif
     else
        inumrho=inumrho+1
        imapo(inumrho)=iorig
        zrhoi(inumrho)=zrho_orig(iorig)
        iorig=iorig+1
        if(zrho(iuser).lt.zrho_orig(iorig-1)+ztol) then
           imapu(inumrho)=iuser
           iuser=iuser+1
        endif
     endif
  enddo
 
  !  now: zrhoi(1:inumrho) contains ordered merger of
  !   zrho(1:inrho) and zrho_orig(1:inorig) with duplicates
  !   (equal to tolerance ztol) removed.
  !  and:
  !   if(imapo(k).gt.0) then zrhoi(k) = zrho_orig(imapo(k))
  !   if(imapu(k).gt.0) then zrhoi(k) = zrho(imapu(k))
  !     point back into the original two grids.
 
  allocate(zvali(inumrho),                &  ! integrated values &
       zvol(inumrho))                        ! integrated volume/area
 
  inumloc=inumrho-1                          ! grid & density profile
  allocate(zrholoc(inumloc),zdens(inumloc))
 
  do ix=1,inumloc
     zrholoc(ix)=(zrhoi(ix)+zrhoi(ix+1))/2
  enddo
 
  do
     !  fetch integrated profile on merged grid
 
     call eq_rgetf(inumrho,zrhoi,id,0,zvali,ierr)
     if(ierr.ne.0) exit
 
     !  fetching volume (area) elements
     !  fetch integrated volumes (areas)
 
     if(iint.eq.1) call eq_area(inumrho,zrhoi,0,zvol,ierr)
     if(iint.eq.2) call eq_volume(inumrho,zrhoi,0,zvol,ierr)
     if(ierr.ne.0) exit
 
     !  compute density profile -- binned as per original grid
 
     ixp=1
     do ix=1,inumloc
        if(imapo(ix+1).gt.0) then
           zdens0=(zvali(ix+1)-zvali(ixp))/(zvol(ix+1)-zvol(ixp))
           zdens(ixp:ix)=zdens0
           ixp=ix+1
        endif
     enddo
 
     !  apply smooth to density profile
 
     call r8_qksmooth(inumloc,zrholoc,zdens,zsm,ZERO,bcav,ierr)
     if(ierr.ne.0) exit
 
     !  integrate and map back to get answer
     if(imapu(1).eq.1) zval(1)=0
     zdsum=0
     do ix=1,inumloc
        zdsum=zdsum+zdens(ix)*(zvol(ix+1)-zvol(ix))
        if(imapu(ix+1).ne.0) then
           zval(imapu(ix+1))=zdsum
        endif
     enddo
     exit  ! normal exit
  enddo
 
  deallocate(zrholoc,zdens)
  deallocate(zvol,zvali)
  deallocate(zrhoi,zrho_orig)
  deallocate(imapo,imapu)
 
end subroutine eq_rget_binsm

subroutine eq_rget_bin(inrho,zrho,id,iint,zval,ierr)
  !
  !  given an integrated profile function id,
  !  return an integrated profile on the user's grid.
  !
  !  if the interpolation order is >1, just do an interpolation.
  !  if the interpolation order is =1 (piecewise linear), do an integration
  !  of the step function of the inferred density
  !
  implicit NONE

  integer, intent(in) :: inrho           ! target gridsize, must be .gt.1
  real*8, intent(in) :: zrho(inrho)      ! target grid-- strict ascending order

  integer, intent(in) :: id              ! function id of f(rho) profile

  integer, intent(in) :: iint            ! data type id
  !  iint=1 -- area integral profile being smoothed -- 
  !            Examples: current density profiles
  !  iint=2 -- volume integral profile being smoothed -- 
  !            Examples: density, energy density, ptcl/power/momentum source
  !                      functions, ...
  !
  real*8, intent(out) :: zval(inrho)     ! results of interpolation/integration

  integer ierr  ! completion code 0=OK

  !----------------------------------------
  real*8 :: zvolarho(inrho),zp,zvolp
  real*8, parameter :: ZERO = 0.0d0
  !----------------------------------------
  integer magdim,magfit,cyldim,cylfit,iwarn,inx,idum,ix,irho
  integer lunerr,id_grid
  real*8, dimension(:), allocatable :: zx,zvola,zfint
  !----------------------------------------

  call eqi_rget_binck(inrho,zrho,id,iint,ierr)
  if(ierr.ne.0) return

  call eq_fun(id,magdim,magfit,cyldim,cylfit,iwarn,ierr)
  if(ierr.ne.0) return

  if(magdim.ne.1) then
     call eq_get_lunerr(lunerr)
     write(lunerr,*) ' ?eq_rget_bin: iint=',iint
     write(lunerr,*) '  integral-binned lookup available only'
     write(lunerr,*) '  for profiles of form f(rho).'
     ierr=1
     return
  endif

  if(magfit.ge.1) then
     !  just do the interpolation of the underlying function...
     call eq_rgetf(inrho,zrho,id,0,zval,ierr)

  else
     !  get original funtion grid and associated volumes or areas
 
     call eq_fun_rhogrid(id,id_grid)
     call eq_ngrid(id_grid,inx)
 
     allocate(zx(inx),zvola(inx),zfint(inx))
     call eq_grid(id_grid,zx,inx,idum,ierr)
     call eq_rgetf(inx,zx,id,0,zfint,ierr)

     if(iint.eq.1) then
        call eq_area(inx,zx,0,zvola,ierr)
        call eq_area(inrho,zrho,0,zvolarho,ierr)
     else
        call eq_volume(inx,zx,0,zvola,ierr)
        call eq_volume(inrho,zrho,0,zvolarho,ierr)
     endif

     !  do the step function integration

     zval(1:2)=ZERO
     zvolp=ZERO

     ix=2
     irho=2
     if(zrho(1).gt.zx(1)) irho=1

     zp = (zfint(ix)-zfint(ix-1))/(zvola(ix)-zvola(ix-1))
     do
        if((zx(ix).lt.zrho(irho)).and.(ix.lt.inx)) then
           zval(irho)=zval(irho)+zp*(zvola(ix)-zvolp)
           zvolp=zvola(ix)
           ix=ix+1
           zp = (zfint(ix)-zfint(ix-1))/(zvola(ix)-zvola(ix-1))
        else
           zval(irho)=zval(irho)+zp*(zvolarho(irho)-zvolp)
           zvolp=zvolarho(irho)

           irho=irho+1
           if(irho.gt.inrho) exit
           zval(irho)=zval(irho-1)
        endif
     enddo

     deallocate(zx,zvola,zfint)

  endif
 
end subroutine eq_rget_bin

subroutine eqi_rget_binck(inrho,zrho,id,iint,ierr)

  ! shared error checking...

  implicit NONE
  integer,intent(in) :: inrho
  real*8,intent(in) :: zrho(inrho)
  integer,intent(in) :: id
  integer,intent(in) :: iint

  integer, intent(out) :: ierr

  !----------------------------------
  integer :: ix,lunerr
  real*8 :: ztol,zrhomax,zrhomin
  !----------------------------------
  call eq_get_lunerr(lunerr)
  ierr=0
 
  if((iint.lt.1).or.(iint.gt.2)) then
     write(lunerr,*) ' ?eq_rget_binck:  iint=1 or iint=2 expected, got: ', &
          'iint = ',iint
     ierr=1
  endif
  if(inrho.le.1) then
     write(lunerr,*) &
          ' ?eq_rget_binck: output grid must contain at least 2 pts.'
     ierr=1
  endif
  do ix=2,inrho
     if(zrho(ix).le.zrho(ix-1)) then
        write(lunerr,*) ' ?eq_rget_binck: zrho(...) not in ascending order.'
        ierr=1
        exit
     endif
  enddo
  if(ierr.ne.0) return
 
  call eq_rholim(zrhomin,zrhomax)
  ztol=1.d-8*(zrhomax-zrhomin)
  !  need extra sanity checks here...
 
  if(zrho(1).lt.zrhomin-ztol) then
     write(lunerr,*) ' ?eq_rget_binck: user zrho(1) < rho_min:'
     write(lunerr,*) '  zrho(1)=',zrho(1),'; rho_min=',zrhomin
     ierr=1
     return
  endif
  if(zrho(inrho).gt.zrhomax+ztol) then
     write(lunerr,*) ' ?eq_rget_binck: user zrho(inrho) > rho_max:'
     write(lunerr,*) '  zrho(inrho)=',zrho(inrho),'; rho_max=',zrhomax
     ierr=1
     return
  endif
  do ix=1,inrho-1
     if(zrho(ix).gt.zrho(ix+1)-2*ztol) then
        write(lunerr,*) ' ?eq_rget_binck: user grid pts too closely spaced:'
        write(lunerr,*) '  zrho(',ix,')=',zrho(ix)
        write(lunerr,*) '  zrho(',ix+1,')=',zrho(ix+1)
        ierr=1
        return
     endif
  enddo

end subroutine eqi_rget_binck

subroutine eqm_rzmag_check(id1,id2,idsw,id_rho,id_chi,inrho,inchi,ierr)

  ! error check routine shared by eqm_rzmag*.f90
  ! find the ids of __RHO and __CHI or report an error

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: id1,id2         ! R & Z array dimensions
  integer, intent(in) :: idsw            ! 1: id1->rho dimension;
  ! 2: id2 ->rho dimension

  integer, intent(out) :: id_rho,id_chi  ! the grid ids
  integer, intent(out) :: inrho,inchi    ! the grid sizes
  integer, intent(out) :: ierr           ! completion code, 0=OK

  !------------------------------------
  integer :: iertmp
  !------------------------------------

  inrho=0
  inchi=0

  iertmp=0

  call xplasma_find_item(s,'__RHO',id_rho,ierr)
  if(ierr.ne.0) then
     iertmp=max(iertmp,ierr)
     write(lunerr,*) ' ?eqm_rzmag: "__RHO" grid not found.'
  endif

  call xplasma_find_item(s,'__CHI',id_chi,ierr)
  if(ierr.ne.0) then
     iertmp=max(iertmp,ierr)
     write(lunerr,*) ' ?eqm_rzmag: "__CHI" grid not found.'
  endif

  ierr=iertmp
  if(ierr.ne.0) then
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  call xplasma_grid_size(s,id_rho,inrho,ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqm_rzmag: "__RHO" grid size fetch failed.'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  call xplasma_grid_size(s,id_chi,inchi,ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqm_rzmag: "__RHO" grid size fetch failed.'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  if(idsw.eq.1) then
     if(id1.lt.inrho) then
        ierr=ierr+1
        write(lunerr,*) ' ?eqm_rzmag: "__RHO" dimension has ',inrho,' pts.'
        write(lunerr,*) '  but data 1st dimension only has: ',id1
     endif
     if(id2.lt.inchi) then
        ierr=ierr+1
        write(lunerr,*) ' ?eqm_rzmag: "__CHI" dimension has ',inchi,' pts.'
        write(lunerr,*) '  but data 2nd dimension only has: ',id2
     endif
  else
     if(id1.lt.inchi) then
        ierr=ierr+1
        write(lunerr,*) ' ?eqm_rzmag: "__CHI" dimension has ',inchi,' pts.'
        write(lunerr,*) '  but data 1st dimension only has: ',id1
     endif
     if(id2.lt.inrho) then
        ierr=ierr+1
        write(lunerr,*) ' ?eqm_rzmag: "__RHO" dimension has ',inrho,' pts.'
        write(lunerr,*) '  but data 2nd dimension only has: ',id2
     endif
  endif

end subroutine eqm_rzmag_check

SUBROUTINE scrphasead(rm,ym,immax,imom,alpha)
  !
  !  adjust moments set by subtracting a phase shift alpha from the
  !  theta parametrization
  !
  use iso_c_binding, only: fp => c_double
  implicit none
  real(fp) :: yjn2
  real(fp) :: yjn1
  real(fp) :: rjn2
  real(fp) :: rjn1
  integer :: im
  integer, intent(in) :: imom
  real(fp), intent(in) :: alpha
  integer, intent(in) :: immax
  real(fp), dimension(0:immax,2), intent(inout) :: rm, ym
  !
  real(fp) :: zsn(100),zcs(100)
  !
  !------------------------------------
  !
  call scrsincos(alpha,imom,zsn,zcs)
  !
  !  0'th moments are unaffected
  !
  do im=1,imom
    rjn1= rm(im,1)*zcs(im) +rm(im,2)*zsn(im)
    rjn2=-rm(im,1)*zsn(im) +rm(im,2)*zcs(im)
    yjn1= ym(im,1)*zcs(im) +ym(im,2)*zsn(im)
    yjn2=-ym(im,1)*zsn(im) +ym(im,2)*zcs(im)
    rm(im,1)=rjn1
    rm(im,2)=rjn2
    ym(im,1)=yjn1
    ym(im,2)=yjn2
  end do

  return
end SUBROUTINE scrphasead

module eqi_vtaub_mod

  !  module to set up splines for faster tau_bounce integral evaluation
  !  adaptive integrator needed due to sqrt singularity at bounce point

  implicit NONE
  SAVE

  integer, parameter :: imax=1024

  real*8, parameter :: bcxmin=0.0d0, bcxmax=0.0d0
  integer, parameter :: ibcxmin=-1, ibcxmax=-1

  !  support independent spline sets for multiple threads (up to imax...)

  type :: vtaub_data
     !  assume f95 OK -- allocatable elements

     integer :: nth = 0
     real*8, dimension(:), allocatable :: th,wk
     real*8, dimension(:,:), allocatable :: fmodb,fbpol,fdldth
  end type vtaub_data

  type (vtaub_data) :: vta(imax)

  real*8, parameter :: ZPI = 3.1415926535897931D+00

  contains

    subroutine elem_alloc(indx,inth,ierr)

      !  check that index is in range 0 to imax; allocate spline arrays

      integer, intent(in) :: indx    ! index of type element to use...
      integer, intent(in) :: inth    ! no. of theta points -pi:pi inclusive
      integer, intent(out) :: ierr   ! 0=OK

      !----------------
      integer :: ith,inthi
      !----------------

      inthi=max(41,min(1001,inth))  ! sanity check

      if((indx.lt.1).or.(indx.gt.imax)) then
         ierr=1
      else
         ierr = 0
         if(allocated(vta(indx)%th)) then
            deallocate(vta(indx)%th)
            deallocate(vta(indx)%wk)
            deallocate(vta(indx)%fmodb)
            deallocate(vta(indx)%fbpol)
            deallocate(vta(indx)%fdldth)
         endif
         vta(indx)%nth = inthi
         allocate(vta(indx)%th(inthi))
         allocate(vta(indx)%wk(inthi))
         allocate(vta(indx)%fmodb(4,inthi))
         allocate(vta(indx)%fbpol(4,inthi))
         allocate(vta(indx)%fdldth(4,inthi))
         do ith=1,inthi
            vta(indx)%th(ith)= -ZPI + (ith-1)*2*ZPI/(inthi-1)
         enddo
      endif

    end subroutine elem_alloc

    subroutine elem_init(indx,fmodb,fbpol,fdldth,ierr)

      !  fill spline arrays for indicated element

      integer, intent(in) :: indx           ! element index
      real*8, dimension(:), intent(in) :: fmodb  ! |B| vs. theta
      real*8, dimension(:), intent(in) :: fbpol  ! |Bpol| vs. theta
      real*8, dimension(:), intent(in) :: fdldth ! |dl/dth| vs. theta
      integer, intent(out) :: ierr          ! exit status, 0=OK

      !-------------------
      integer :: isize_min,isize_max,inth,idum,iertmp
      !-------------------

      ierr=0
      if((indx.lt.1).or.(indx.gt.imax)) then
         ierr=1
      else if(.not.allocated(vta(indx)%th)) then
         ierr=2
      else
         isize_min=size(fmodb)
         isize_max=isize_min

         isize_min=min(isize_min,size(fbpol))
         isize_max=max(isize_max,size(fbpol))

         isize_min=min(isize_min,size(fdldth))
         isize_max=max(isize_max,size(fdldth))

         if((isize_min.ne.vta(indx)%nth).or.(isize_max.ne.vta(indx)%nth)) then
            ierr=3
         endif
      endif

      if(ierr.ne.0) return

      inth=vta(indx)%nth

      vta(indx)%fmodb(1,1:inth) = fmodb
      vta(indx)%fbpol(1,1:inth) = fbpol
      vta(indx)%fdldth(1,1:inth) = fdldth

      call cspline(vta(indx)%th,inth, &
           vta(indx)%fmodb, &
           ibcxmin,bcxmin,ibcxmax,bcxmax, &
           vta(indx)%wk,inth,idum,iertmp)
      if(iertmp.ne.0) ierr=4

      call cspline(vta(indx)%th,inth, &
           vta(indx)%fbpol, &
           ibcxmin,bcxmin,ibcxmax,bcxmax, &
           vta(indx)%wk,inth,idum,iertmp)
      if(iertmp.ne.0) ierr=4

      call cspline(vta(indx)%th,inth, &
           vta(indx)%fdldth, &
           ibcxmin,bcxmin,ibcxmax,bcxmax, &
           vta(indx)%wk,inth,idum,iertmp)
      if(iertmp.ne.0) ierr=4
      
    end subroutine elem_init
      
    subroutine errstr(ierr,str)

      !  return a text string describing an error

      integer, intent(in) :: ierr
      character*(*), intent(out) :: str

      if(ierr.eq.1) then
         str='eqi_vtaub_mod: element index not between 1 and imax.'

      else if(ierr.eq.2) then
         str='eqi_vtaub_mod: element not allocated.'

      else if(ierr.eq.3) then
         str='eqi_vtaub_mod: size of passed data does not match element grid size.'

      else if(ierr.eq.4) then
         str='eqi_vtaub_mod: spline setup error.'

      else if(ierr.ne.0) then
         str='eqi_vtaub_mod: error (unspecified).'

      else
         str=' '
      endif

    end subroutine errstr  

end module eqi_vtaub_mod

module xplasma_fromgeq

  ! module with routines that help to create various types of xplasma profiles

  use xplasma_obj
  use eqi_rzbox_module

  implicit NONE

  public :: xplasma_fromgeqdsk, xplasma_geqdsk_ppadj
  public :: xplasma_save_psi0, xplasma_get_psi0

  contains

    !-------------------------------------------------------
    subroutine xplasma_fromgeqdsk(s,filename,ier, &
         new_device, nrho, nth, i2pi, lhermite, &
         bdy0, cratio_min, rzspace, &
         kpsi_cur,rho_curbreak, &
         kmom, rhobrk_adj_axis, mom_rtol, &
         equal_arc, &
         gs_errmax)

      ! (re)build equilibrium inverse represenation from EFIT g-eqdsk data
      !    R(rho,theta), Z(rho,theta), g(rho),q(rho),P(rho).

      type (xplasma), pointer :: s

      character*(*), intent(in) :: filename  ! Geqdsk filename or MDS+ path
      !                  ...or...EFIT_INDEX:filename(t=<time>) specification
      !                  

      integer, intent(out) :: ier  ! integer status code (returned; 0=OK)

      !---------------
      !  optional...

      logical, intent(in), optional :: new_device ! flag, .TRUE. if reading
      !  equilibrium for a new device.  Default: .TRUE. when reading the
      !  first equilibrium in the history of the xplasma object; .FALSE.
      !  subsequently.  When this is not .TRUE., the limiter data is presumed
      !  already known to xplasma.

      integer, intent(in), optional :: nrho  ! no. of flux surfaces 
      !                                        covering rho = [0:1]
      !  rho = normalized(sqrt(Psi-tor/Psi-tor-at-bdy))
      !        for 20 zones specify nrho=21 -- count includes axis and plasma
      !        boundary-- evenly spaced in rho
      !  DEFAULT: nrho=51 if new_device is .TRUE.; otherwise the value from
      !  the old equilibrium is taken.

      integer, intent(in), optional :: nth   ! no. of theta points -- no. of 
      !        evenly spaced points spanning 0:2pi inclusive.
      !  DEFAULT: nth=101 if new_device is .TRUE.; otherwise the value from
      !  the old equilibrium is taken.

      integer, intent(in), optional :: i2pi  ! set =1 for theta range to
      !  be -pi:pi instead of 0:2pi (the latter is the default).

      logical, intent(in), optional :: lhermite ! flag, .TRUE. for Hermite
      !  interpolation of {R,Z}(rho,theta) -- by default, bicubic spline
      !  interpolation is used.

      real*8, intent(in), optional :: bdy0   ! initial Psi_bdy/Psi_sep
      !  (default 1.0d0) fraction of Psi to enclose in mapped region
      !  The issue here is that a separatrix surface generally cannot be
      !  used as a boundary in an inverse representation, due to q=infinity
      !  and the kink in the surface shape.  So instead one backs off from
      !  the Psi_sep flux, defining a boundary just inside the separatrix.
      !    Recommendation: the default.  "cratio_min" causes the code to
      !  iterate to find a suitable boundary surface.
      !  Accepted range: 0.95d0 to 1.00d0

      real*8, intent(in), optional :: cratio_min  ! minimum curvature ratio
      !  (default 0.080d0) minimum acceptable local curvature radius, 
      !  normalized to midplane half width.  A separatrix kink has a curvature
      !  radius of zero.  This is tested by fitting a circle through successive
      !  sequences of 3 points on the boundary grid [1:nth] and looking at this
      !  circle's radius compared to an estimate of the plasma midplane half-
      !  width.
      !    Recommendation: the default, based on experience.
      !  Accepted range: 0.01d0 to 0.15d0

      logical, intent(in), optional :: rzspace ! .TRUE. to save (R,Z)
      !  grids using the EFIT grids, and compute B(R,Z).  Default = .TRUE.
      !  Setting this .FALSE. may speed some applications.

      integer, intent(in), optional :: kpsi_cur    ! =0 (default) to set
      !  total toroidal current from the EFIT file data (scalar CURRENT_A),
      !  and use EFIT q(psi) data (QPSI) for the q profile in the equilibrium
      !  which affects flux surface spacing.

      !  If instead kpsi_cur = 1 is set, the EFIT total toroidal current 
      !  magnitude and QPSI data are discarded, and the q(psi) and enclosed
      !  current profiles are derived from contour integrals over the 
      !  Psi(R,Z) data.

      !  Advice: if Psi(R,Z) is derived from a high quality free boundary
      !  solution, use kpsi_cur = 1; if unsure, use the defaults.

      real*8, intent(in), optional :: rho_curbreak    ! This number,
      !  constrained to be between 0.75 and 0.95, specifies where to
      !  break the enclosed toroidal current profile and impose a smooth
      !  parabolic interpolation to the edge value (see kpsi_cur for how
      !  this is set).  This is necessary to get smooth dI/drho and <J.B>
      !  profiles out.  Default: 0.90.

      integer, intent(in), optional :: kmom    ! number of Fourier moments
      !  to use in Fourier Spline representation of equilibrium 
      !  (default: not set here; xplasma default is 16).

      real*8, intent(in), optional :: rhobrk_adj_axis ! delta(rho) for
      !  moments trimming operations, and, the maximum rho where flux
      !  surfaces can be touched, in order to assure that d/drho[R0,Z0] --> 0
      !  as rho--> 0, an attributed needed by codes (e.g. RF solvers) that
      !  use the inverted equilibrium.
      !    Default value: 0.15d0.  To disable this feature, set 
      !  rhobrk_adj_axis = -1.0d0 or any other negative number

      real*8, intent(in), optional :: mom_rtol ! moments trimming ratio
      !  (default 1.0d-6).  The EFIT Psi(R,Z) inversion involves a Fourier
      !  representation; this control specifies a method for trimming away
      !  higher order moments that are very small over wide regions of space.
      !  Accepted range: 0.0d0 to 1.0d-4

      logical, intent(in), optional :: equal_arc  ! .TRUE. to use an equal
      !  arc definition for the poloidal angle coordinate; .FALSE. (default)
      !  for VMEC/descur moments power spectrum minimization definition, the
      !  traditional definition for past usage.

      real*8, intent(out), optional :: gs_errmax  ! normalized measure of
      !  Grad Shafranof (GS) error in the EFIT equilibrium.

      !-----------------------------
      real*8 :: zbdy0,zcratio,zmom_rtol,zrhobrk_axis,zerrmax
      integer :: irz,inrho,inth,id,idx,ieq,iertmp,jopt,j2pi
      real*8 :: zdum,xbrki

      logical :: ihermite,inew_device,ienable
      integer :: ipsi_cur

      character*32 :: glist,gelems(7),zauth
      real*8 :: zelems(7)
      character*140 :: ztext(7),zlabel

      real*8 :: rhobrk_min=0.75d0
      real*8 :: rhobrk_max=0.95d0

      !-----------------------------

      ier=0

      call xplasma_global_info(s,ier, initLabel=zlabel, eq_counter=ieq)
      if(ier.ne.0) return

      call xplasma_author_query(s,zauth,ienable,ier)
      if(ier.ne.0) return

      !-----------------------------
      !  check if this an equilibrium for a new device;
      !  if so xplasma re-initialization may be required...

      if(ieq.eq.0) then
         inew_device=.TRUE.
      else 
         inew_device=.FALSE.
         if(present(new_device)) inew_device=new_device
      endif

      if(inew_device.and.(ieq.gt.0)) then
         ! re-initialize xplasma: changing devices!
         call xplasma_init(s,zlabel,iertmp)
         ier=max(ier,iertmp)
         call xplasma_author_set(s,zauth,iertmp)
         ier=max(ier,iertmp)
      endif
      if(ier.ne.0) then
         call xplasma_errmsg_append(s,'error in xplasma_fromgeqdsk.')
         return
      endif

      j2pi=2
      if(present(i2pi)) j2pi=i2pi

      if(present(kmom)) then
         call xplasma_kmom_set(s,kmom,ier)
         if(ier.ne.0) then
            call xplasma_errmsg_append(s,'error in xplasma_fromgeqdsk.')
            return
         endif
      endif

      ipsi_cur=0
      xbrki=0.9d0

      if(present(kpsi_cur)) then
         ipsi_cur = max(0,min(1,kpsi_cur))
      endif

      if(present(rho_curbreak)) then
         xbrki=min(rhobrk_max,max(rhobrk_min, rho_curbreak))
      endif

      !-----------------------------

      if(inew_device) then
         !  use arguments
         if(.not.present(nrho)) then
            inrho=51
         else
            inrho=max(5,nrho)
         endif

         if(.not.present(nth)) then
            inth=101
         else
            inth=max(21,nth)
         endif

      else
         !  use previous equilibrium grid sizes
         call xplasma_gridId(s,'__RHO',idx)
         call xplasma_grid_size(s,idx,inrho,iertmp)
         ier=max(ier,iertmp)

         call xplasma_gridId(s,'__CHI',idx)
         call xplasma_grid_size(s,idx,inth,iertmp)
         ier=max(ier,iertmp)
      endif
      if(ier.ne.0) then
         call xplasma_errmsg_append(s,'error in xplasma_fromgeqdsk.')
         return
      endif

      ihermite=.FALSE.
      if(present(lhermite)) ihermite=lhermite

      irz=1
      if(inew_device.and.present(rzspace)) then
         if(rzspace) then
            irz=1
         else
            irz=0
         endif
      endif

      glist = '__GFILE_INFO'

      gelems(1) = 'FILENAME'
      zelems(1) = 0
      ztext(1) = filename

      zbdy0=1.0d0
      if(present(bdy0)) then
         zdum=0.95d0
         zbdy0=max(zdum,min(zbdy0,bdy0))  ! enforce range 0.95d0 to 1.00d0
      endif
      gelems(2)='BDY0'
      zelems(2)=zbdy0
      ztext(2)='Relative start point of boundary search'

      zcratio=0.080d0  ! **DEFAULT** curvature ratio limit

      if(present(cratio_min)) then
         zdum=0.01d0
         zcratio=max(zdum,cratio_min)
         zdum=0.15d0
         zcratio=min(zdum,zcratio)        ! enforce range 0.01d0 to 0.15d0
      endif
      gelems(3)='CRATIO'
      zelems(3)=zcratio
      ztext(3)='minimum accepted boundary curvature ratio'

      zrhobrk_axis=0.15d0
      if(present(rhobrk_adj_axis)) then
         zdum=0.30d0
         zrhobrk_axis=min(zdum,rhobrk_adj_axis)
      endif
      gelems(4)='RHOBRK_ADJ_AXIS'
      zelems(4)=zrhobrk_axis
      ztext(4)='width of interior region affected by axis adjustment'

      zmom_rtol=1.0d-6
      if(present(mom_rtol)) then
         zdum=0.0d0
         zmom_rtol=max(zdum,mom_rtol)
         zdum=1.0d-4
         zmom_rtol=min(zdum,zmom_rtol)    ! enforce range 0.0 to 1.0d-4
      endif
      gelems(5)='MOM_RTOL'
      zelems(5)=zmom_rtol
      ztext(5)='trimming parameter for Fourier moments representation'

      gelems(6)='QPSI_OPTION'
      zelems(6)=ipsi_cur
      ztext(6)='value of 1.0 indicates Q(psi) & total current from Psi(R,Z)'

      gelems(7)='RHO_CURBREAK'
      zelems(7)=rho_curbreak
      ztext(7)='break location for matching current profile to edge value.'

      zerrmax=0.0d0
      if(present(gs_errmax)) gs_errmax=zerrmax

      !---------------------------------------------
      ! record geqdsk controls in a list... id not saved...

      call xplasma_create_list(s,glist,gelems,id,ier, &
           label='xplasma_fromgeqdsk inputs list', &
           r8vals=zelems, chvals=ztext)
      if(ier.ne.0) then
         call xplasma_errmsg_append(s, &
              'xplasma_fromgeqdsk: '// &
              'error occurred while attempting to define list: '//trim(glist))
         return
      endif

      !---------------------------------------------
      ! OK, build the xplasma equilibrium...

      sp => s

      jopt = 0
      if(present(equal_arc)) then
         if(equal_arc) then
            jopt = 1
            if(.not.present(kmom)) then
               call xplasma_kmom_set(s,64,ier)  ! set FFT moments up to 64
               ! ...for equal arc theta
            endif
         endif
      endif

      call eqi_fromgeqdsk(filename, ihermite, inew_device, &
           inrho, inth, j2pi, zbdy0, zcratio, irz, jopt, &
           ipsi_cur,xbrkI, &
           zrhobrk_axis, zmom_rtol, zerrmax, ier)

      if(ier.ne.0) ier=150

      if(present(gs_errmax)) gs_errmax=zerrmax

    end subroutine xplasma_fromgeqdsk

    subroutine xplasma_geqdsk_ppadj(s,ier,match_auth)

      !  reset G-eqdsk pressure profile "P" using P(bdy) and 
      !  integrating inward using "DPDPSI"; old profile is renamed
      !  "P_ORIG".

      !--------------------------------------------------------
      !  arguments...

      type (xplasma), pointer :: s

      integer, intent(out) :: ier  ! integer status code (returned; 0=OK)

      !---------------
      !  optional...

      logical, intent(in), optional :: match_auth

      !--------------------------------------------------------
      !  local variables:

      logical :: iauth_match
      integer :: id,id_p,id_rho,id_psi,id_dpdpsi,iertmp
      integer :: irho,inrho,irank,icorr
      character*32 :: zauth,zunits
      character*80 :: zlabel

      real*8, dimension(:), allocatable :: zrho,zp,zpsi,zdpdpsi
      real*8 :: zdp,zdpsi,zcorr,zcsum,zpnew,zdelp_norm,zdelp_old,zdelp_new
      real*8, parameter :: ZERO = 0.0d0
      real*8, parameter :: ONE =  1.0d0
      real*8, parameter :: HALF = 0.5d0

      !--------------------------------------------------------
      !  first,check if necessary data is available:

      call xplasma_profId(s,'P',id_p)
      call xplasma_profId(s,'dPdPsi',id_dpdpsi)
      call xplasma_profId(s,'Psi',id_psi)

      ier=0
      if(id_p.eq.0) then
         call xplasma_errmsg_append(s, &
              '?xplasma_geqdsk_ppadj: "P" profile not found.')
         ier=ier+1
      endif
      if(id_psi.eq.0) then
         call xplasma_errmsg_append(s, &
              '?xplasma_geqdsk_ppadj: "Psi" profile not found.')
         ier=ier+1
      endif
      if(id_dpdpsi.eq.0) then
         call xplasma_errmsg_append(s, &
              '?xplasma_geqdsk_ppadj: "dPdPsi" profile not found.')
         ier=ier+1
      endif

      if(ier.ne.0) then
         ier=9999
         return
      endif

      !--------------------------------------------------------
      !  reset authorship if requested

      iauth_match = .FALSE.
      if(present(match_auth)) iauth_match = match_auth

      if(iauth_match) then
         call xplasma_get_item_info(s,id_P,iertmp, author=zauth)
         call xplasma_author_set(s,zauth,iertmp)
      endif

      do

         !--------------------------------------------------------
         !  copy old P profile

         call xplasma_copy_item(s,id_P,'P_ORIG',id,ier)
         if(ier.ne.0) then
            call xplasma_errmsg_append(s, &
                 '?xplasma_geqdsk_ppadj: xplasma_copy_item failed.')
            exit
         endif

         !--------------------------------------------------------
         !  get grid of P profile; allocate working arrays

         call xplasma_prof_info(s,id_P,ier, rank=irank, gridId1=id_rho, &
              label=zlabel, units=zunits)
         if(ier.ne.0) exit

         if(irank.ne.1) then
            call xplasma_errmsg_append(s, &
                 '?xplasma_geqdsk_ppadj: "P" profile rank is not 1.')
            ier=9999
            exit
         endif

         call xplasma_grid_info(s, id_rho, ier, size=inrho)
         if(ier.ne.0) exit

         allocate(zrho(inrho),zp(inrho),zpsi(inrho),zdpdpsi(inrho))

         call xplasma_grid(s, id_rho, zrho, ier)
         if(ier.ne.0) exit

         call xplasma_eval_prof(s,id_p,zrho,zp,ier)
         if(ier.ne.0) exit

         call xplasma_eval_prof(s,id_psi,zrho,zpsi,ier)
         if(ier.ne.0) exit

         call xplasma_eval_prof(s,id_dpdpsi,zrho,zdpdpsi,ier)
         if(ier.ne.0) exit

         !--------------------------------------------------------
         !  compute new P profile in two passes; 1st pass, compute
         !  an averaged correction factor for the integration to reach
         !  the original P(0)...

         zcorr=ONE

         icorr=0
         zcsum=ZERO
         zdelp_norm=(maxval(zp)-zp(inrho))*HALF

         do irho=inrho-1,1,-1
            zdpsi = zpsi(irho+1)-zpsi(irho)
            zdp = zdpsi * (zdpdpsi(irho) + zdpdpsi(irho+1))*HALF

            zdelp_old = zp(irho)-zp(inrho)

            !  minus sign due to inward direction of integration
            zp(irho) = zp(irho+1) - zdp

            if(zdelp_old.gt.zdelp_norm) then
               zdelp_new = zp(irho)-zp(inrho)
               icorr = icorr + 1
               zcsum = zcsum + (zdelp_new/zdelp_old)
            endif
         enddo

         if(icorr.gt.0) then
            zcorr = ONE/(zcsum/icorr)

            do irho=inrho-1,1,-1
               zdpsi = zpsi(irho+1)-zpsi(irho)
               zdp = zdpsi * (zdpdpsi(irho) + zdpdpsi(irho+1))*HALF

               !  minus sign due to inward direction of integration
               zp(irho) = zp(irho+1) - zcorr*zdp
            enddo
         endif
            
         !--------------------------------------------------------
         !  store new P profile

         call xplasma_create_1dprof(s,'P',id_rho,zp,id,ier, &
              ispline=2,ibca=1,zbca=ZERO,ibcb=1, &
              label=trim(zlabel), units=trim(zunits))

         exit
      enddo
      if(ier.ne.0) then
         call xplasma_errmsg_append(s, &
                 '?xplasma_geqdsk_ppadj: an error occurred.')
      endif

      !--------------------------------------------------------
      !  cleanup

      if(allocated(zp)) deallocate(zrho,zp,zpsi,zdpdpsi)

      if(iauth_match) then
         call xplasma_author_clear(s,zauth,iertmp)
      endif

    end subroutine xplasma_geqdsk_ppadj

    subroutine xplasma_save_psi0(s,psi0_val,ierr)

      ! save Psi0 offset to machine axis
      !   Psi(R,Z) is saved in xplasma with Psi=0 @ the magnetic axis
      !   Psi0+psi(R,Z) restores the EFIT conventional Psi = R*A_phi,
      !     which has psi->0 as R->0

      type (xplasma), pointer :: s

      real*8, intent(in) :: psi0_val  ! Psi value to save (pol. flux, Wb/rad).
      integer, intent(out) :: ierr    ! status code returned, 0=OK

      !--------------

      integer :: ivals(1),id_list
      real*8 :: r8vals(1)
      character*64 :: chvals(1)
      character*32 :: enames(1)

      !--------------

      enames(1) = 'Psi0'
      ivals(1)=1
      r8vals(1)=Psi0_val
      chvals(1)='Psi offset to machine axis'

      call xplasma_create_list(s,'Psi0_container',enames,id_list,ierr, &
           label='Container: Psi offset to machine axis', units='Wb/rad', &
           ivals=ivals, r8vals=r8vals, chvals=chvals)

    end subroutine xplasma_save_psi0

    subroutine xplasma_get_psi0(s,psi0_val,ifind,ierr)

      ! retrieve Psi0 offset to machine axis, if available
      ! This is the value saved by xplasma_save_Psi0

      type (xplasma), pointer :: s

      real*8, intent(out) :: psi0_val ! Psi value to save (pol. flux, Wb/rad).
      integer, intent(out) :: ifind   ! =1 if Psi0 value found, 0 otherwise.
      integer, intent(out) :: ierr    ! status code returned, 0=OK

      ! if Psi0 value is not found, ierr=0 and ifind=0 are returned.

      !--------------------------

      integer :: indx_psi0,indx,nlist
      real*8, dimension(:), allocatable :: psi0a
      character*32, dimension(:), allocatable :: enames
      integer id_list                   ! xplasma id:  Psi0 container list

      !--------------------------

      ifind=0
      ierr=0
      psi0_val = 0.0d0

      call xplasma_listID(s,'Psi0_container',id_list)
      if(id_list.eq.0) return

      call xplasma_getList_size(s,id_list,nlist,ierr)
      if(ierr.ne.0) return
  
      allocate(enames(nlist),psi0a(nlist))

      do
         call xplasma_getList_names(s,id_list,enames,ierr)
         if(ierr.ne.0) exit

         call xplasma_getList_r8vals(s,id_list,psi0a,ierr)
         if(ierr.ne.0) exit

         indx_psi0=0
         do indx=1,nlist
            call uupper(enames(indx))
            if(enames(indx).eq.'PSI0') then
               indx_psi0=indx
               exit
            endif
         enddo

         if(indx_psi0.gt.0) then
            psi0_val = psi0a(indx_psi0)
            ifind=1
         endif

         exit
      enddo

      deallocate(enames,psi0a)

    end subroutine xplasma_get_psi0

end module xplasma_fromgeq

subroutine eqi_bdfind(ivec,zR,zZ,zphi,zrho_in,iskipi,iskipo,iexact, &
     zchi_out,zphi_out,zdist,ierr)

  !  **vectorized** dmc Apr 2000

  !  accurately find the point on a boundary surface which is
  !  closest to a target point (zR,zZ,zphi)

  !  to begin the search, evaluate a coarse grid of points and look
  !  for the distance minima; use a root finder to zero in exactly
  !  (to machine precision).

  !  input:

  use xplasma_definitions
  use eqi_rzbox_module
  IMPLICIT NONE

  integer ivec                      ! vector length
  REAL*8 zR(ivec),zZ(ivec),zphi(ivec) ! target point
  REAL*8 zrho_in                    ! the (1) surface to be searched

  logical :: iskipi                 ! .TRUE. to skip accurate solution for
  !  points clearly *inside* the boundary; an approximate solution is
  !  returned.

  logical :: iskipo                 ! .TRUE. to skip accurate solution for
  !  points clearly *outside* the boundary; an approximate solution is
  !  returned.
  
  logical :: iexact                 ! .TRUE. for exact solution using
  !  root finder (for points not affected by iskip* switches); .FALSE.
  !  for distance-circles approximation method (quite accurate, much
  !  faster).

  !  points that are more than about (1/2) a segment length away are
  !  deemed clearly inside or outside.

  !  output:

  REAL*8 zchi_out(ivec)             ! chi of nearest approach
  REAL*8 zphi_out(ivec)             ! phi of nearest approach

  REAL*8 zdist(ivec)                ! distance outside surface;

  integer ierr                      ! completion code, 0=OK

  !  if zdist.lt.0.0 then point is *inside* the surface;
  !  if zdist.eq.0.0 then the point is *on* the surface.

  !------------------------------------------------------------

  real*8, dimension(:), allocatable :: zchi,zrho,zchimin,zdistmin,zdistcut, &
       zsignmin,zchix,zchi1,zchi2,zRsurf,zZsurf,zchi_aug,zdwk
  real*8, dimension(:,:), allocatable :: zdista,zderv,zsign, &
       zrzbuf,zconst1,zout1
  integer, dimension(:), allocatable :: ichimin,iseg

  real*8, dimension(:), pointer :: rzrad
  integer, dimension(:), pointer :: krzrad

  logical imask(nsrch1),jmask(ivec)

  REAL*8 zchi_inc,zdr,zdz,z2seg2,zrho_extrap,zd2,zbogus,zrho_ii

  external feq_bdy2

  REAL*8 zeps,zeta

  integer i,j,nc,ifnd(ivec),iflag,ichi,iertmp,iexec,idum
  integer :: iflist(4),idchis(4)

  real*8 :: Rfastmin,Rfastmax,Zfastmin,Zfastmax
  real*8 :: ztesta,zdervp,zchip

  integer,parameter :: iR=1  ! R index
  integer,parameter :: iZ=2  ! Z index
  integer,parameter :: iRth=3  ! dR/dtheta index
  integer,parameter :: iZth=4  ! dZ/dtheta index

  real*8, parameter :: czero= 0.0d0
  real*8, parameter :: cone = 1.0d0
  real*8, parameter :: c2pi = 6.2831853071795862D+00
  real*8, parameter :: ceps10 = 1.0d-10

  integer :: ibb,id_bb
  integer, parameter :: bbtype = 97
  character*32 bbnames(3)
  data bbnames/'__BDY_CIRC_DATA','__EXTRAP_BDY_CIRC_DATA', &
       '__GEN_CIRC_DATA'/

  !------------------------------------------------------------
  !  only axisymmetric magnetic coordinates based equilibria -- for now

  allocate(zchi(nsrch1),zchimin(ivec),zdistmin(ivec),zsignmin(ivec), &
       zchix(ivec),zchi1(ivec),zchi2(ivec),ichimin(ivec),zrho(nsrch1))
  allocate(zRsurf(0:nsrch1+1),zZsurf(0:nsrch1+1),zchi_aug(0:nsrch1+1))
  allocate(zdista(nsrch1,ivec),zderv(nsrch1,ivec),zsign(nsrch1,ivec), &
       zconst1(ivec,3),zout1(ivec,2),zrzbuf(nsrch1,4))
  allocate(iseg(ivec),zdwk(ivec),zdistcut(ivec))

  ierr=0

  !  ...assuming axisymmetry here; negative zR allowed because of
  !  2d extrapolated surfaces pushed through the axis...

  !  initial search -- nsrch0 pts

  imask=.FALSE.
  jmask=.FALSE.

  zchi(1)=czero
  zchi_aug(1)=czero

  zchi_inc=c2pi/nsrch0
  zrho_ii=max(zrho_in,ceps10)
  do i=1,nsrch0
     zchi(i+1)=zchi(i)+zchi_inc
     zchi_aug(i+1)=zchi(i)+zchi_inc
  enddo

  zchi(nsrch1)=c2pi
  zchi_aug(nsrch1)=c2pi

  zchi_aug(nsrch1+1)=zchi_aug(2)+c2pi
  zchi_aug(0)=zchi(nsrch0)-c2pi

  ibb=3
  iflag=1
  if(abs(zrho_ii-cone).lt.2.0d-15) then
     iflag=-1  ! plasma bdy
     ibb=1
  endif

  call eqi_extrap_rho_bdy(zrho_extrap)
  if(zrho_extrap.gt.cone) then
     if(abs(zrho_ii-zrho_extrap).lt.2.0d-15) then
        iflag=-1  ! extrap. space bdy.
        ibb=2
     endif
  endif

  zbogus = -1.0d10  ! place holder

  call xplasma_common_ids(sp,ierr, id_R=iflist(1), id_Z=iflist(2))
  iflist(3:4)=iflist(1:2)
  idchis(1:2)=0
  idchis(3:4)=1

  call eqi_rzbox_binfo_get(zrho_ii,zrzbuf,ierr)
  if(ierr.ne.0) then
     zrho=zrho_ii   ! vector
     call xplasma_RZeval_2d(sp,iflist, &
             xplasma_rho_coord,zrho, &
             xplasma_theta_coord,zchi, &
             zrzbuf,ierr, ideriv2s=idchis)
     if(ierr.eq.0) call eqi_rzbox_binfo_set(zrho_ii,zrzbuf,idum,ierr)
  endif

  do i=1,nsrch1
     zRsurf(i)=zrzbuf(i,iR)
     zZsurf(i)=zrzbuf(i,iZ)
  enddo
  zRsurf(0)=zRsurf(nsrch1-1)
  zRsurf(nsrch1+1)=zRsurf(2)
  zZsurf(0)=zZsurf(nsrch1-1)
  zZsurf(nsrch1+1)=zZsurf(2)

  do j=1,ivec

     zconst1(j,1)=zR(j)
     zconst1(j,2)=zZ(j)
     zconst1(j,3)=zrho_ii

     ichimin(j)=0
     zdistmin(j)=1.0d30
     do i=1,nsrch1
        zdista(i,j)=(zR(j)-zRZbuf(i,iR))**2+(zZ(j)-zRZbuf(i,iZ))**2
        zderv(i,j)=(zR(j)-zRZbuf(i,iR))*zRZbuf(i,iRth)+ &
             (zZ(j)-zRZbuf(i,iZ))*zRZbuf(i,iZth)
        zsign(i,j)=sign(cone, &
             ((zR(j)-zRZbuf(i,iR))*zRZbuf(i,iZth)- &
             (zZ(j)-zRZbuf(i,iZ))*zRZbuf(i,iRth)))
        if(zdista(i,j).le.zdistmin(j)) then
           ichimin(j)=i
           zchimin(j)=zchi(i)
           zdistmin(j)=zdista(i,j)
           zsignmin(j)=zsign(i,j)
        endif
     enddo
     zdist(j)=zbogus
     zdistcut(j)=2*zdistmin(j)

     ifnd(j)=1
     if(iskipi.or.iskipo) then
        ichi=ichimin(j)
        zdr=zRsurf(ichi+1)-zRsurf(ichi-1)
        zdz=zZsurf(ichi+1)-zZsurf(ichi-1)
        z2seg2=zdr*zdr + zdz*zdz  ! square of distance subtended by 2 segments
     endif

     !  1/16 = 0.0625d0 = ((1/2)/2)**2
     !  if distance**2 is greater than (1/16)*distance**2 subtended by 2
     !  segments, it is deemed not close... this corresponds to (1/2) the
     !  length of a single segment.

     if(iskipi) then
        if(zsignmin(j).lt.0.0d0) then
           if((zdistmin(j)/z2seg2).gt.0.0625d0) then
              jmask(j)=.TRUE. ! definitely inside
              ifnd(j)=nsrch1
           endif
        endif
     endif
     
     if(iskipo) then
        if(zsignmin(j).gt.0.0d0) then
           if((zdistmin(j)/z2seg2).gt.0.0625d0) then
              jmask(j)=.TRUE. ! definitely outside
              ifnd(j)=nsrch1
           endif
        endif
     endif

  enddo

  ! set error tolerances for root finder...

  if(iexact) then
     call xplasma_RZminmax(sp,cone,ierr, &
          rmin=Rfastmin, rmax=Rfastmax, zmin=Zfastmin, zmax=Zfastmax)

     zeps=c2pi*2.5d-14
     zeta=2.5d-15*(Rfastmax-Rfastmin)*(Zfastmax-Zfastmin)

  else

     ! retrieve pretabulated circle fit data if it exists...
     ! otherwise just allocate a workspace for the data which will be computed.

     call xplasma_find_item(sp,bbnames(ibb),id_bb,iertmp,nf_noerr=.TRUE.)

     if(id_bb.eq.0) then

        call xplasma_author_set(sp,xplasma_xmhd,iertmp)

        call xplasma_create_blackBox(sp,bbnames(ibb),bbtype, &
             id_bb,iertmp, &
             iasize=nsrch1, r8asize=3*nsrch1+1, label='circle fit data')

        call xplasma_author_clear(sp,xplasma_xmhd,iertmp)

     endif

     !  retrieve pointers; data may be updated...

     call xplasma_blackBox_retrieve(sp,id_bb,iertmp, &
          ia_ptr=krzrad, r8a_ptr=rzrad)

     !  if just created-- data values are preset to zero...

     if(rzrad(nsrch1*3+1).eq.czero) rzrad(nsrch1*3+1)=zrho_ii

     if(iflag.gt.0) then
        !  not a bdy surface... 1 struct shared by all other surfaces...
        if(zrho_ii.ne.rzrad(nsrch1*3+1)) then
           krzrad=0  ! recompute: new rho value
        endif
     endif

  endif

  ! the search incorporates an overlapping end zone to accomodate
  ! imperfections in periodicity of derivatives...

10 continue
  nc=0
  do j=1,ivec
     do i=ifnd(j),nsrch0
        ztesta=abs(zderv(i,j))
        zdervp=zderv(i+1,j)
        zchip=zchi(i+1)
        iexec=0
        if(iexact) then
           if(ztesta.le.zeta) then
              if(zdista(i,j).lt.zdistmin(j)) then
                 zchimin(j)=zchi(i)
                 zdistmin(j)=zdista(i,j)
                 zsignmin(j)=zsign(i,j)
              endif
           else if((zderv(i,j).gt.czero).and.(zdervp.lt.czero)) then
              iexec=1
           endif
        else
           if((zderv(i,j).ge.czero).and.(zdervp.le.czero)) then
              iexec=1
           endif
        endif
        if(min(zdista(i,j),zdista(i+1,j)).gt.zdistcut(j)) then
           iexec=0
        endif
        if(iexec.eq.1) then
           nc=nc+1
           ifnd(j)=i+1
           iseg(j)=i
           zchi1(j)=zchi(i)
           zchi2(j)=zchip
           go to 20
        endif
     enddo
     ifnd(j)=nsrch1+1
     jmask(j)=.true.
20   continue
  enddo

  if(nc.eq.0) go to 100

  if(iexact) then

     !  root finder

     call zridderx(ivec,jmask,zchi1,zchi2, &
          zeps,zeta,feq_bdy2,zchix,ierr, &
          ivec,zconst1,3,zout1,2)

  else

     !  circles approximation

     call eqi_bdfind_circ(ivec,jmask,zR,zZ,iseg,zchix,zdwk, &
          nsrch1,zRsurf,zZsurf,zchi_aug,krzrad,rzrad,ierr)

  endif

  if(ierr.ne.0) go to 990

  do j=1,ivec
     if(.not.jmask(j)) then

        if(iexact) then
           if(zout1(j,1).lt.zdistmin(j)) then
              zchimin(j)=zchix(j)
              zdistmin(j)=zout1(j,1)
              zsignmin(j)=zout1(j,2)
           endif

        else
           zd2=zdwk(j)*zdwk(j)
           if(zd2.lt.zdistmin(j)) then
              zchimin(j)=zchix(j)
              zdistmin(j)=zd2
              zdist(j)=zdwk(j)
              if(zdist(j).lt.0.0) then
                 zsignmin(j)=-1.0d0
              else
                 zsignmin(j)=1.0d0
              endif
           endif
        endif

     endif
  enddo

  go to 10

  !  ok go with this

100 continue
  do j=1,ivec
     zphi_out(j)=zphi(j)
     zchi_out(j)=zchimin(j)
     if(iexact.or.(zdist(j).eq.zbogus)) then
        zdist(j)=zsignmin(j)*sqrt(zdistmin(j))
     endif
  enddo

990 continue
  deallocate(zchi,zrho,zchimin,ichimin,zdistmin,zsignmin,zchix,zchi1,zchi2)
  deallocate(zdista,zderv,zsign,zrzbuf,zconst1,zout1,zRsurf,zZsurf)
  deallocate(iseg,zdwk,zdistcut)

  nullify(rzrad,krzrad)

end subroutine eqi_bdfind

!-----------------------------------------------------------
subroutine feq_bdy2(iveci,imask,zchi,zanswer,ivecd,zinput,idimi,zoutput,idimo)

  use xplasma_definitions
  use eqi_rzbox_module

  !  given (rho,chi) return d dot d/dchi[(R,Z) along zrho bdy]
  !    where d = displacement vector, [(R,Z)target - (R,Z)(zrho,zchi)]

  !  the quantity is positive if points along the zrho bdy, closer to the
  !  target, are in the +chi direction.

  IMPLICIT NONE
  !  input:
  integer iveci                     ! input vector dimension

  logical imask(abs(iveci))         ! =.FALSE.:  evaluate...
  REAL*8 zchi(abs(iveci))           ! zchi=angle param. on this surface

  !  output:
  real*8 zanswer(abs(iveci))
  !  zanswer:  d dot d/dchi(R,Z)(zchi)|rho=zrho -- function value

  !  more input:
  integer ivecd                     ! auxilliary vector dimension
  integer idimi                     ! aux. input dimension
  real*8 zinput(ivecd,idimi)        ! (R(...),Z(...),rho(...))

  integer idimo                     ! aux. output dimension

  !  output:
  real*8 zoutput(ivecd,idimo)       ! (d**2(...), sign(...))

  !-------------------------------------

  real*8, dimension(:,:), allocatable :: zRZbuf
  integer ierr

  integer i,ivec,jvec,iflist(4),idchis(4),lRnum,lZnum,idtmp
  real*8 zR,zZ
  real*8, dimension(:), allocatable :: zchi_use,zrho_use

  integer,parameter :: iR=1  ! R index
  integer,parameter :: iZ=2  ! Z index
  integer,parameter :: iRth=3  ! dR/dtheta index
  integer,parameter :: iZth=4  ! dZ/dtheta index

  real*8, parameter :: cone = 1.0d0

  !-------------------------------------

  ivec=abs(iveci)

  allocate(zchi_use(ivec),zrho_use(ivec),zRZbuf(ivec,4))

  jvec=0
  do i=1,ivec
     if(.not.imask(i)) then
        jvec=jvec+1
        zrho_use(jvec)=zinput(i,3)
        zchi_use(jvec)=zchi(i)
     endif
  enddo

  call xplasma_common_ids(sp,ierr, id_R=lRnum,id_Z=lZnum)
  if((lRnum.eq.0).or.(lZnum.eq.0)) then
     zanswer=0
     zoutput=0
     go to 900   ! this shouldn't happen!
  endif

  iflist(1)=lRnum
  iflist(2)=lZnum
  iflist(3)=lRnum
  iflist(4)=lZnum
  idchis(1:2)=0
  idchis(3:4)=1

  call xplasma_RZeval_2d(sp,iflist, &
       xplasma_rho_coord,zrho_use(1:jvec), &
       xplasma_theta_coord,zchi_use(1:jvec), &
       zrzbuf(1:jvec,1:4),ierr, ideriv2s=idchis)
  if(ierr.ne.0) go to 900

  jvec=0
  do i=1,ivec
     if(.not.imask(i)) then
        jvec=jvec+1
        zR=zinput(i,1)
        zZ=zinput(i,2)
        zoutput(i,1)= (zR-zRZbuf(jvec,iR))**2 + (zZ-zRZbuf(jvec,iZ))**2
        zanswer(i)=(zR-zRZbuf(jvec,iR))*zRZbuf(jvec,iRth)+ &
             (zZ-zRZbuf(jvec,iZ))*zRZbuf(jvec,iZth)

        !  when near closest approach:  +1 if outside, -1 if inside...

        zoutput(i,2)=sign(cone, &
             ((zR-zRZbuf(jvec,iR))*zRZbuf(jvec,iZth)- &
             (zZ-zRZbuf(jvec,iZ))*zRZbuf(jvec,iRth)))

     endif
  enddo

900 continue

  deallocate(zchi_use,zrho_use,zRZbuf)

end subroutine feq_bdy2

subroutine eqi_extrap_rho_bdy(zrho_out)

  !  return max rho of extrapolated space, or -1 if none is defined

  use xplasma_definitions
  use eqi_rzbox_module

  implicit NONE

  real*8, intent(out) :: zrho_out

  !------------
  integer :: id,ier
  !------------

  zrho_out = -1

  call xplasma_find_item(sp,"__RHOX",id,ier,nf_noerr=.TRUE.)

  if((ier.ne.0).or.(id.eq.0)) return

  call xplasma_grid_info(sp,id,ier, xmax=zrho_out)

end subroutine eqi_extrap_rho_bdy

      SUBROUTINE MCSTR_INSERT(STR1,STR2)
C
C  INSERT STR1 LEFT JUSTIFIED IN STR2
C  IF STR1 IS SHORTER THAN STR2, STR2 IS PADDED WITH BLANKS
C  IF STR2 IS LONGER THAN STR2 A TRUNCATED VSN OF STR1 IS INSERTED
C
      CHARACTER*(*) STR1
      CHARACTER*(*) STR2
C
      L1=LEN(STR1)
      L2=LEN(STR2)
C
      L=MIN0(L1,L2)
C
      STR2(1:L)=STR1(1:L)
C
      IF(L.LT.L2) THEN
        DO 10 IL=L+1,L2
          STR2(IL:IL)=' '
 10     CONTINUE
      ENDIF
C
      RETURN
      END

subroutine eqi_jacheck_maxvar_Set(value)

  !  set the maximum allowed variation of det[J] (metric Jacobian) on a
  !  flux surface

  use xplasma_obj_instance
  use eq_module

  real*8, intent(in) :: value

  !-------------------
  integer :: ier
  !-------------------

  call xplasma_ajac_maxvar_set(s,value,ier)
  if(ier.ne.0) then
     write(lunerr,*) ' %eqi_jacheck_maxvar_set: failed to set xplasma max Jacobian variation, ier=',ier
     call xplasma_error(s,ier,lunerr)
  endif

end subroutine eqi_jacheck_maxvar_Set

subroutine eqi_jacheck_maxvar_Get(value)

  !  fetch the maximum allowed variation of det[J] (metric Jacobian) on a
  !  flux surface

  use xplasma_obj_instance
  use eq_module

  real*8, intent(out) :: value

  !-------------------
  integer :: ier
  !-------------------

  call xplasma_global_info(s,ier, ajac_maxVar=value)
  if(ier.ne.0) then
     write(lunerr,*) ' %eqi_jacheck_maxvar_get: failed to retrieve xplasma max Jacobian variation, ier=',ier
     call xplasma_error(s,ier,lunerr)
  endif

end subroutine eqi_jacheck_maxvar_Get

subroutine eq_xget(ivec,zrho,zchi,zphi,xx,yy,zz,nregion,ierr)

  !  vectorized
  !  mapping:  (rho,chi,phi) -> (R,Z,phi) -> (x,y,z)

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  integer ivec                      ! vector dimensioning (- for reversed chi)
  real*8 zrho(abs(ivec)),zchi(abs(ivec)),zphi(abs(ivec)) ! mag. coordinates
  real*8 xx(abs(ivec)),yy(abs(ivec)),zz(abs(ivec)) ! cartesian coordinates
  
  integer nregion(abs(ivec))             ! output region code
  integer ierr                      ! output error code

  !  on output,
  !      nregion = 1 means:  rho_axis.le.rho.le.rho_bdy  (plasma)
  !      nregion = 2 means:  rho_bdy.lt.rho.le.rho_vac    (scrapeoff.eq.1)
  !      nregion = 3 means:  rho.gt.rho_vac -- out of bounds

  !      ierr=0:  normal exit.  ierr=1 only on a serious error.
  !--------------------------------------------------------------

  REAL*8 zR(abs(ivec))

  !--------------------------------------------------------------

  call eq_rzget(ivec,zrho,zchi,zphi,zR,zZ,nregion,ierr)
  if(ierr.eq.0) call eq_xcyl(abs(ivec),zR,zphi,xx,yy)

end subroutine eq_xget

!--------------------------------------------------------------
subroutine eq_rzget(ivec,zrho,zchi,zphi,zR,zZ,nregion,ierr)

  !  mapping:  (rho,chi,phi) -> (R,Z,[phi])

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  integer ivec                      ! vector dimensioning (- for reversed chi)
  real*8 zrho(abs(ivec)),zchi(abs(ivec)),zphi(abs(ivec)) ! mag. coordinates
  real*8 zR(abs(ivec)),zZ(abs(ivec))          ! Cylindric coordinates (w/phi)

  integer nregion(abs(ivec))             ! output region code
  integer ierr                      ! output error code

  !  on output,
  !      nregion = 1 means:  rho_axis.le.rho.le.rho_bdy  (plasma)
  !      nregion = 2 means:  rho_bdy.lt.rho.le.rho_vac    (scrapeoff.eq.1)
  !      nregion = 3 means:  rho.gt.rho_vac (out of bounds)

  !      ierr=0:  normal exit.  ierr=1 means a serious error.

  !--------------------------------------------------------------
  logical :: iccw
  !--------------------------------------------------------------

  iccw = ivec.gt.0

  call xplasma_ctrans(s,xp_use_coord_vecsize,ierr, &
       rho_in=zrho, theta_in=zchi, phi_in=zphi, ccw_theta=iccw, i2pi=2, &
       r_out=zR, z_out=zZ, nregion=nregion)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqi_rzget: error in xplasma_ctrans:'
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_rzget

subroutine eqi_fxcep(inum,zbdy_info,imaptype,idinit, &
     ra,za,phia,da,rb,zb,phib,db,tol, &
     rx,zx,phix,istat,ierr)

  !  given a set of line segments which straddle a boundary, find the points
  !  lying on the segments which intersect the boundary.

  use xplasma_definitions
  use eqi_rzbox_module

  implicit NONE

  !  input:

  integer inum                      ! number of segments

  real*8 :: zbdy_info               ! if >= 0: rho of surface to seek
                                    ! if  < 0: look for limiter

  integer :: imaptype               ! map accuracy control
  ! for computing distance: 1=slow&exact, 2=medium&accurate, 3=fast&approximate
  integer idinit                    ! =1:  da & db already initialized

  real*8 ra(inum),za(inum),phia(inum) ! end pts A of segments
  real*8 rb(inum),zb(inum),phib(inum) ! end pts B of segments

  !  input if idinit=1, output otherwise:

  real*8 da(inum)                   ! distance of A pts from bdy
  real*8 db(inum)                   ! distance of B pts from bdy

  !  input:

  real*8 tol                        ! relative accuracy tolerance

  !  approx. accuracy of intercept position:  tol*[system size]
  !  system size = 0.5*(Rmax-Rmin)

  !  output:

  real*8 rx(inum),zx(inum),phix(inum) ! the intercepts returned

  !  if (from da,db) a segment does not straddle the boundary,
  !                  for that segment rx,zx contains the nearer endpoint

  integer istat(inum)               ! segment status

  !  istat(j)=2 -- both endpoints outside bdy
  !  istat(j)=1 -- 1st endpoint outside, 2nd endpoint inside
  !  istat(j)=-1 -- 1st endpoint inside, 2nd endpoint outside
  !  istat(j)=-2 -- both endpoints inside bdy
  !    (rx(j),zx(j)) contains bdy intercept if abs(istat(j))=1.

  integer ierr                      ! completion code, 0=OK

  !  ierr only set in case of serious error
  !-----------------------------------------------------------------

  integer i,isave,iersum,itype
  logical imask(inum)
  real*8 mindab,maxdab

  real*8 zinput(inum,9),zdist(inum)
  real*8 zoutput(inum,3)
  real*8 z0(inum),z1(inum),zxx(inum)

  real*8 ztol,Rfastmax,Rfastmin,rhosurf

  real*8, parameter :: ZERO=0.0d0
  real*8, parameter :: ONE= 1.0d0

  !-----------------------------------------------------------------
  !  external subroutines -- for zriddery, root finder

  external eqi_fxcep_bdy
  external eqi_fxcep_lim

  !-----------------------------------------------------------------
  !  surface or limiter search?

  if(zbdy_info.lt.0.0d0) then
     itype=2
     rhosurf=1.0d0
  else
     itype=1
     rhosurf=zbdy_info
  endif
  
  !-----------------------------------------------------------------
  !  get end pt distances if necessary

  iersum = 0
  if(idinit.ne.1) then

     if(itype.eq.1) then
        call xplasma_bdfind(sp,inum,ra,za,ierr, &
             maptype=imaptype, rho_in=rhosurf, phi_in=phia, dist=da)
        iersum=max(ierr,iersum)
        call xplasma_bdfind(sp,inum,rb,zb,ierr, &
             maptype=imaptype, rho_in=rhosurf, phi_in=phia, dist=db)
        iersum=max(ierr,iersum)

     else
        call xplasma_lim_distance(sp,ra,za,da,ierr, maptype=imaptype)
        iersum=max(ierr,iersum)
        call xplasma_lim_distance(sp,rb,zb,db,ierr, maptype=imaptype)
        iersum=max(ierr,iersum)

     endif

  endif
  ierr=iersum
  if(ierr.gt.0) return

  !  determine status of each segment; endpt=0 is considered "outside".

  do i=1,inum
     mindab=min(da(i),db(i))
     maxdab=max(da(i),db(i))
     if(mindab.ge.ZERO) then
        istat(i)=2                  ! all outside
        imask(i)=.TRUE.
     else if(maxdab.lt.ZERO) then
        istat(i)=-2                 ! all inside
        imask(i)=.TRUE.

        !  if we get past the above two clauses, then, either da(i).lt.0 or
        !  db(i).lt.0, and the other end point is .ge.0

     else if(db(i).lt.ZERO) then
        istat(i)=1                  ! A outside, B inside
        imask(i)=.FALSE.
     else
        istat(i)=-1                 ! A outside, B inside
        imask(i)=.FALSE.
     endif

     z0(i)=ZERO
     z1(i)=ONE

     zinput(i,1)=ra(i)
     zinput(i,2)=za(i)
     zinput(i,3)=phia(i)
     zinput(i,4)=rb(i)
     zinput(i,5)=zb(i)
     zinput(i,6)=phib(i)
     zinput(i,7)=tol
     zinput(i,8)=imaptype
     zinput(i,9)=rhosurf

     if(imask(i)) then
        if(abs(da(i)).lt.abs(db(i))) then
           rx(i)=ra(i)
           zx(i)=za(i)
           phix(i)=phia(i)
        else
           rx(i)=rb(i)
           zx(i)=zb(i)
           phix(i)=phib(i)
        endif
     endif

  enddo

  !  each segment is parametrized with x=0 ~ pt A, x=1 ~ pt B
  !  call the vectorized root finder

  call xplasma_RZminmax(sp,ONE,ierr, rmin=Rfastmin, rmax=Rfastmax)
  if(ierr.ne.0) return
  ztol=tol*(Rfastmax-Rfastmin)/2

  !  note using zriddery instead of zridderx because...
  !  passed subroutines can themselves make zridderx calls!
  !  (bugfix dmc July 2003)

  if(itype.eq.1) then
     call zriddery(inum,imask,z0,z1,ZERO,ztol, &
          eqi_fxcep_bdy,zxx,ierr,inum,zinput,9,zoutput,3)
     if(ierr.ne.0) then
        call xplasma_errmsg_append(sp,' ?eqi_fxcep(1) zriddery failure.')
     endif

  else if(itype.eq.2) then
     call zriddery(inum,imask,z0,z1,ZERO,ztol, &
          eqi_fxcep_lim,zxx,ierr,inum,zinput,9,zoutput,3)
     if(ierr.ne.0) then
        call xplasma_errmsg_append(sp,' ?eqi_fxcep(2) zriddery failure.')
     endif

  else
     call xplasma_errmsg_append(sp,' ?eqi_fxcep:  invalid itype (not 1 or 2)')
     ierr=9999
  endif

  if(ierr.ne.0) return

  !  copy results

  do i=1,inum
     if(.not.imask(i)) then
        rx(i)=zoutput(i,1)
        zx(i)=zoutput(i,2)
        phix(i)=zoutput(i,3)
     endif
  enddo

end subroutine eqi_fxcep

!-----------------------------------------------------
subroutine eqi_fxcep_bdy(ivec,imask,zxx,zdist, &
     ivecd,zinput,ninput,zoutput,noutput)

  !  distance lookup routine (for root finder)
  !  search is for plasma bdy

  use xplasma_definitions
  use eqi_rzbox_module

  implicit NONE

  integer ivec                      ! vector dimension
  logical imask(ivec)               ! .TRUE. to skip pts
  real*8 zxx(ivec)                   ! position parameter (in)
  real*8 zdist(ivec)                ! distance to bdy (out)

  integer ivecd
  integer ninput,noutput
  real*8 zinput(ivecd,ninput)       ! R,Z,phi data (in)
  real*8 zoutput(ivecd,noutput)     ! R,Z,phi data (out)

  !------------------------

  call eqi_fxcep_b0(1,ivec,imask,zxx,zdist, &
       ivecd,zinput,ninput,zoutput,noutput)

end subroutine eqi_fxcep_bdy
 
!-----------------------------------------------------
subroutine eqi_fxcep_lim(ivec,imask,zxx,zdist, &
     ivecd,zinput,ninput,zoutput,noutput)

  !  distance lookup routine (for root finder)
  !  search is for plasma limiter

  use xplasma_definitions
  use eqi_rzbox_module

  implicit NONE

  integer ivec                      ! vector dimension
  logical imask(ivec)               ! .TRUE. to skip pts
  real*8 zxx(ivec)                   ! position parameter (in)
  real*8 zdist(ivec)                ! distance to bdy (out)

  integer ivecd
  integer ninput,noutput
  real*8 zinput(ivecd,ninput)       ! R,Z,phi data (in)
  real*8 zoutput(ivecd,noutput)     ! R,Z,phi data (out)

  !------------------------

  call eqi_fxcep_b0(2,ivec,imask,zxx,zdist, &
       ivecd,zinput,ninput,zoutput,noutput)

end subroutine eqi_fxcep_lim
 
!-----------------------------------------------------
subroutine eqi_fxcep_b0(itype,ivec,imask,zxx,zdist, &
     ivecd,zinput,ninput,zoutput,noutput)

  !  distance lookup routine (for root finder)
  !  search is for plasma bdy

  use xplasma_definitions
  use eqi_rzbox_module

  implicit NONE

  integer itype                     ! =1:  bdy, =2:  limiter
  integer ivec                      ! vector dimension
  logical imask(ivec)               ! .TRUE. to skip pts
  real*8 zxx(ivec)                  ! position parameter (in)
  real*8 zdist(ivec)                ! distance to bdy (out)
  
  integer ivecd
  integer ninput,noutput
  real*8 zinput(ivecd,ninput)       ! R,Z,phi data (in)
  real*8 zoutput(ivecd,noutput)     ! R,Z,phi data (out)

  !------------------------

  integer i,jvec,ierr
  integer :: imaptype
  real*8 r(ivec),z(ivec),phi(ivec),zdistwk(ivec),zdumv(ivec),ztol
  real*8 rhotarg(ivec)
  integer idumv(ivec)

  integer, parameter :: ilun_dbg=6
  real*8, parameter :: ONE= 1.0d0
  !------------------------

  jvec=0
  do i=1,ivec
     if(.not.imask(i)) then
        jvec=jvec+1
        r(jvec)=(ONE-zxx(i))*zinput(i,1)+zxx(i)*zinput(i,4)
        z(jvec)=(ONE-zxx(i))*zinput(i,2)+zxx(i)*zinput(i,5)
        phi(jvec)=(ONE-zxx(i))*zinput(i,3)+zxx(i)*zinput(i,6)
        rhotarg(jvec)=zinput(i,9)
     endif
  enddo

  ztol=min(1.0d-5,zinput(jvec,7)) ! all zinput(:,7) values equal
  imaptype=zinput(jvec,8)+0.5d0   ! all zinput(:,8) values equal

  if(itype.eq.1) then
     call xplasma_ctrans(sp,.TRUE.,ierr, &
          r_in=r(1:jvec),z_in=z(1:jvec),tol=ztol,maptype=imaptype, &
          rho_out=zdistwk(1:jvec))
     zdistwk(1:jvec)=zdistwk(1:jvec)-rhotarg(1:jvec)
  else
     call xplasma_lim_distance(sp,r(1:jvec),z(1:jvec),zdistwk(1:jvec),ierr, &
          maptype=imaptype)
     if(ierr.ne.0) then
        write(ilun_dbg,*) &
             ' ?eqi_fxcep: unexpected error inside root finder call:'
        call xplasma_error(sp,ierr,6)
     endif
  endif

  jvec=0
  do i=1,ivec
     if(.not.imask(i)) then
        jvec=jvec+1
        zdist(i)=zdistwk(jvec)
        zoutput(i,1)=r(jvec)
        zoutput(i,2)=z(jvec)
        zoutput(i,3)=phi(jvec)
     endif
  enddo

end subroutine eqi_fxcep_b0

SUBROUTINE scrprintdes
  use iso_c_binding, only: fp => c_double
  use scrunch_inc1
  use scrunch_inc2
  implicit none
  integer :: mn
  real(fp), dimension(nphi2,1) :: rmc, rms, zmc, zms
  real(fp), dimension(nphi2) :: integrate, argi
  if (ioflagc) write(lunmsg,30)
30 format('c  mb  nb    RmncB       RmnsB       ZmncB       ZmnsB')
  do mn=1,mpnt
    if (ioflagc) write(lunmsg,80) mn-1,0,xvec(mn),xvec(mpol+mn), &
         xvec(mpol2+mn),xvec(mpol3+mn)
    rmomb(mn,1)=xvec(mn)
    rmomb(mn,2)=xvec(mpol+mn)
    zmomb(mn,1)=xvec(mpol2+mn)
    zmomb(mn,2)=xvec(mpol3+mn)
  end do
80 format(i5,i4,4e12.4)
  return
end SUBROUTINE scrprintdes

subroutine eqi_tbdy_circs(zdata,inum,rc,zc,rad,zR0,zZ0)

  !  add in circular limiters

  implicit NONE

  !  input:
  integer inum                      ! no. of circular limiters

  !  output:
  real*8 zdata(4,inum)              ! 4 data items / circular limiter

  !  input:
  real*8 rc(inum),zc(inum)          ! (R,Z) of circle centers
  real*8 rad(inum)                  ! circle radii

  real*8 zR0,zZ0                    ! mag. axis of plasma (for sign test)

  !----------------------------
  integer i
  real*8 zradtest
  !----------------------------

  do i=1,inum
     zdata(1,i)=rc(i)
     zdata(2,i)=zc(i)
     zdata(3,i)=rad(i)

     !  set "zsign"

     zradtest=sqrt((zR0-rc(i))**2+(zZ0-zc(i))**2)
     if(zradtest.gt.rad(i)) then
        zdata(4,i)=-1           ! plasma outside the circle
     else
        zdata(4,i)=+1           ! plasma inside the circle
     endif
  enddo

  !  for a given point (R,Z), let r=sqrt((R-Rc)**2+(Z-Zc)**2)
  !  then d = zsign*(r-rad); if d<0, inside plasma-allowed region;
  !  if d>0 then inside plasma-excluded region

end subroutine eqi_tbdy_circs

!-------------------------------------------------------------
subroutine eqi_tbdy_lines(zdata,ilines,rl,zl,thl,zR0,zZ0)

  !  add line limiters, including "sanity" limiters

  implicit NONE

  !  input:
  integer ilines                    ! no. of user specified line limiters

  !  output:
  real*8 zdata(6,ilines)            ! limiter info

  !  input:
  real*8 rl(ilines),zl(ilines)      ! point on line
  real*8 thl(ilines)                ! line orientation, DEGREES

  real*8 zR0,zZ0                    ! plasma mag. axis

  !-----------------------------------------------

  integer i

  real*8 zpi,zconv                      ! radians/degree

  real*8 zrl(4),zzl(4),zthl(4)
  !-----------------------------------------------

  zpi=3.1415926535897931D+00

  zconv=zpi/180

  do i=1,ilines
     call eqi_tbdy_line0(zdata(1,i),rl(i),zl(i),thl(i)*zconv, zR0,zZ0)
  enddo

end subroutine eqi_tbdy_lines

!----------------------------------------------------------------
subroutine eqi_tbdy_line0(zdata,rlin,zlin,ztheta,zR0,zZ0)

  !  set up one line limiter

  implicit NONE

  !  output:
  real*8 zdata(6)                   ! limiter data vector

  !  input:
  real*8 rlin,zlin                  ! point on line
  real*8 ztheta                     ! orientation of line

  real*8 zR0,zZ0                    ! point inside plasma
  real*8 ztest

  !------------------------

  zdata(1)=rlin                     ! point on line...
  zdata(2)=zlin
  zdata(3)=-sin(ztheta)             ! normal vector to line...
  zdata(4)=cos(ztheta)
  zdata(5)=zdata(1)*zdata(3)+zdata(2)*zdata(4)
                                        ! signed distance, (0,0) to line

  ztest = zR0*zdata(3)+zZ0*zdata(4) - zdata(5)
  if(ztest.lt.0.0d0) then
     zdata(6)=1                 ! inside plasma
  else
     zdata(6)=-1
  endif

end subroutine eqi_tbdy_line0

SUBROUTINE scringuessdes (ier)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero
  use scrunch_inc1
  implicit none
  integer :: ier
  integer :: j
  integer :: i
  !**********************************************************************
  !       This subroutine obtains initial guesses for the centroid at each
  !       toroidal plane. By default, the polar axis is set equal to this
  !       centroid.  It is imperative that the polar axis be enclosed by
  !       the surface (otherwise the computed theta angles will not span
  !       [0,2pi]). For certain complex cross-sections, this simple estimate
  !       of the polar axis may fail, and the user must supply values for
  !       raxis3d(i),zaxis3d(i).  In addition, for non-starlike domains, the
  !       points along the curve must be monitonically increasing as a
  !       function of the arclength from any fixed point on the curve. This
  !       ordering is attempted by the subroutine ORDER, but may fail in
  !       general if too few theta points are used.
  !**********************************************************************
  !       COMPUTE CENTROID
  !**********************************************************************
  do i = 1,nphi
    r0n(i) = zero
    z0n(i) = zero
    do j = 1,nthetax
      r0n(i) = r0n(i)+rin3d(j,i)/DBLE(nthetax)
      z0n(i) = z0n(i)+zin3d(j,i)/DBLE(nthetax)
    end do
    raxis3d(i) = r0n(i)
    zaxis3d(i) = z0n(i)
  end do
  !**********************************************************************
  !       ORDER POINTS ON FLUX SURFACE AT EACH TOROIDAL ANGLES
  !**********************************************************************
  if (ioflagc) write(lunmsg,*)'ORDERING SURFACE POINTS'
  DO i = 1,nphi
    CALL scrorderdes(rin3d(1,i),zin3d(1,i), &
         raxis3d(i),zaxis3d(i),ier)
  END DO
  !**********************************************************************
  !       COMPUTE OPTIMUM ANGLE OFFSETS FOR M=1 MODES
  !**********************************************************************
  CALL scrgetangldes(rin3d,zin3d,angle,r0n,z0n)
end SUBROUTINE scringuessdes

SUBROUTINE scrfsetup(ith,icc,rwork,zwork,inpts,idim1,zxmax,ier)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, half, one
  use mintrp
  !
  !  set up theta line fit function for theta line #ith
  !  data points scatterred in rwork and zwork arrays (from
  !  previous scrunch operations by caller)
  !
  !  location specified by icc(...) and ith -- depending on
  !  algorithm selected by moption
  !
  !  experimental code...
  !
  implicit none
  real(fp) :: zxmax
  real(fp) :: dfdx0
  real(fp) :: zsinb
  real(fp) :: zcosb
  real(fp) :: dfdx1
  real(fp) :: zs0
  real(fp) :: zadjust
  real(fp) :: zdz2
  real(fp) :: zdr2
  real(fp) :: zdz1
  real(fp) :: zdr1
  real(fp) :: zs1
  real(fp) :: zdy
  real(fp) :: zdx
  real(fp) :: zdz
  real(fp) :: zdr
  real(fp) :: zxd
  real(fp) :: zdelz
  real(fp) :: zdelr
  real(fp) :: y2
  real(fp) :: x2
  real(fp) :: znorm
  integer :: ith
  integer :: ic2
  integer :: ics
  integer :: ic1
  integer :: ic0
  integer :: idim1
  integer :: inpts
  real(fp) :: rwork(inpts+1,idim1),zwork(inpts+1,idim1),zxax1,zwk(5)
  integer :: icc(6),i,ilinx,ier
  real(fp), dimension(2) :: enorm
  !
  integer lunmsg
  !
  !--------------------------------
  !
  ier = 0  ! assume normal status initially...
  !
  call scrgetlun(lunmsg)
  !
  ic0=icc(1)
  if(moption.eq.2) then
    ic1=icc(2)
    ics=icc(3)
    ic2=icc(4)
  else if(moption.eq.3) then
    ic1=icc(4)
    ics=icc(5)
    ic2=icc(6)
  endif
  !
  r0=rwork(ith,ic0)
  z0=zwork(ith,ic0)
  !
  r2=rwork(ith,ic2)
  z2=zwork(ith,ic2)
  !
  !  normal vector
  !
  enorm(1)=rwork(ith,ic0)-raxis
  enorm(2)=zwork(ith,ic0)-zaxis
  znorm=sqrt(enorm(1)**2+enorm(2)**2)
  zxax1=znorm
  enorm(1)=enorm(1)/znorm
  enorm(2)=enorm(2)/znorm
  !
  if((moption.eq.2).or.(moption.eq.3)) then
    !
    !  will use a two piece curve, C(1), with "x" defined along two legs
    !  of a triangle
    !    for moption.eq.3 the piece nearer the axis is a spline.
    !
    r1=rwork(ith,ic1)
    z1=zwork(ith,ic1)
    !
    zdelr=r1-r0
    zdelz=z1-z0
    xbrk=sqrt(zdelr*zdelr+zdelz*zdelz)
    zcosa=zdelr/xbrk
    zsina=zdelz/xbrk
    !
    zdelr=r2-r1
    zdelz=z2-z1
    zxd=sqrt(zdelr*zdelr+zdelz*zdelz)
    zcosa2=zdelr/zxd
    zsina2=zdelz/zxd
    !
    xmax=xbrk+zxd
    !
    !  segment x = xbrk to xmax -- use low order fit
    !
    zdr=r2-rwork(ith,ics)
    zdz=z2-zwork(ith,ics)
    zdx= zcosa2*zdr +zsina2*zdz
    if(zdx.le.ZERO) then
      CALL scrabwarn(lunmsg,'?momintrp: bdy slope ^ ref angle too large')
      ier=99
      return
    endif
    zdy=-zsina2*zdr +zcosa2*zdz
    !
    zs1=zdy/zdx
    !
    zdy=-zdy
    !
    !  direction in (R,Z) space if (xbrk,xmax) fit is parabalic
    !
    zdr1= zcosa2*zdx -zsina2*zdy
    zdz1= zsina2*zdx +zcosa2*zdy
    znorm=sqrt(zdr1**2+zdz1**2)
    zdr1=zdr1/znorm
    zdz1=zdz1/znorm
    !
    !  direction that parallels the segment (ctr) (R0,Z0) -- (R2,Z2) (bdy)
    !
    zdr2=(r2-r0)
    zdz2=(z2-z0)
    znorm=sqrt(zdr2**2+zdz2**2)
    zdr2=zdr2/znorm
    zdz2=zdz2/znorm
    !
    !  set zadjust=ZERO for parabolic fit if (xbrk,xmax) segment
    !  set zadjust=1.0 to use (R0,Z0) -- (R2,Z2) segment for direction
    !
    zadjust=half
    zdr=(one-zadjust)*zdr1 + zadjust*zdr2
    zdz=(one-zadjust)*zdz1 + zadjust*zdz2
    !
    !  back to ref from for (xbrk,xmax) segment
    !
    zdx= zcosa2*zdr +zsina2*zdz
    if(zdx.le.ZERO) then
      CALL scrabwarn(lunmsg,'?momintrp: brk slope x ref angle too large')
      ier=99
      return
    endif
    zdy=-zsina2*zdr +zcosa2*zdz
    !
    zs0=zdy/zdx
    !
    !  here is the cubic fit  (zadjust=ZERO => zs0=-zs1 & parabolic fit results)
    !
    a2=(zs0+zs1)/(zxd*zxd)
    b2=-(2*zs0+zs1)/zxd
    c2=zs0
    d2=ZERO
    !
    !  use same (zdr,zdz) in the (0,xbrk) segment ref. frame.
    !
    zdx= zcosa*zdr +zsina*zdz
    if(zdx.le.ZERO) then
      CALL scrabwarn(lunmsg,'?momintrp: brk slope ^ ref angle too large')
      ier=99
      return
    endif
    zdy=-zsina*zdr +zcosa*zdz
    !
    dfdx1=zdy/zdx
    !
    !  slope of theta line at ctr -- segment frame
    !
    if(moption.eq.2) then
      zcosb= zcosa*enorm(1) +zsina*enorm(2)
      zsinb=-zsina*enorm(1) +zcosa*enorm(2)
      if(zcosb.le.ZERO) then
        CALL scrabwarn(lunmsg,'?momintrp:  normal dot ref is .le. 0.0')
        ier=99
        return
      endif
      dfdx0=zsinb/zcosb
      !
      !  use cubic fit -- connecting segment reference frame
      !
      a=(dfdx1+dfdx0)/(xbrk*xbrk)
      b=-(2*dfdx0+dfdx1)/xbrk
      c=dfdx0
      d=ZERO
      xspl=ZERO
    else
      !
      !  moption=3 -- use spline for interior region
      !
      xspl(2)=ZERO;   yspl(1,2)=ZERO   ! icc(1) reference pt.
      xspl(5)=xbrk;   yspl(1,5)=ZERO   ! icc(4) reference pt.
      !
      ! axis
      !
      xspl(1)=  -zxax1*( zcosa*enorm(1) +zsina*enorm(2))
      yspl(1,1)=-zxax1*(-zsina*enorm(1) +zcosa*enorm(2))
      !
      ! intermediate surfaces
      !
      do i=2,3
        zdr=rwork(ith,icc(i))-r0
        zdz=zwork(ith,icc(i))-z0
        xspl(i+1)=   zcosa*zdr +zsina*zdz
        yspl(1,i+1)=-zsina*zdr +zcosa*zdz
      enddo
      !
      if((xspl(2)-xspl(1)).lt.1.0D-3*(xspl(3)-xspl(2))) then
        ier=88  ! fit will not work - too much change in direction
      else
        !
        ! setup spline (& uneven x axis)
        !
        call cspline(xspl,5,yspl,0,ZERO,1,dfdx1,zwk,5,ilinx,ier)
        if(ier.ne.0) then
          call scrabwarn(lunmsg,'?fsetup: cspline failure.')
          ier=99
          return
        endif
        call genxpkg(5,xspl,xpkg,0,0,0,ZERO,2,ier)
        if(ier.ne.0) then
          call scrabwarn(lunmsg,'?fsetup: genxpkg failure.')
          ier=99
          return
        endif
      endif
    endif  ! (moption.eq.3)
    !
  else
    CALL scrabwarn(lunmsg,'?fsetup:  illegal moption value.')
    ier=99
    return
  endif
  !
  zxmax=xmax
  !
  return
end SUBROUTINE scrfsetup

module eq_module
  use physconst_mod, only: czero=>zero, chalf=>half, cone=>one, ctwo=>two, &
       cpi=>pi, c2pi=>twopi
  ! private module used in implementation of original f77 style XPLASMA
  ! interface... i.e. private to the xplasma library, not meant for use
  ! by subroutines outside xplasma.

  ! NOTE: this module is meant to be used in the xplasma library along with
  ! the public module "xplasma_obj_instance" which makes a shared xplasma
  ! object available.

  implicit NONE
  save

  logical :: eq_module_init = .FALSE.

  integer :: lunerr = 6

  character*132 :: eq_premsg_text = ' '

  !--------------------------
  !  constants...

  real*8, parameter :: ceps4 = 1.0d-4
 
end module eq_module

subroutine eq_esia(lun_esia,ins,int1,ztflux,id_pmhd,id_nen) 

  implicit NONE

  ! This routine writes the MHD information in the ``compact'' form
  ! required by Leonid's ESI architecture. (One code where
  ! the equilibrium file is used is in Roscoe's new  
  ! (non-Boozer) version of orbit.)
  !  Kumar -- 04202004

  ! integer, parameter :: ins = 21 ! Fixed by ESC
  ! integer, parameter :: int1=65
  integer, parameter :: r8=selected_real_kind(12,100)
  integer ierr,luntrm,lnout
  integer lun_esia       ! logical unit where to write file

  real*8 :: r8time = 1.0d34

  integer :: ik,jk,imid,id_tflux=0,id_pflux=0,id_pmhd,id_q=0,id_g=0,id_nen
  integer :: ins,int1,id_ne=0,ifail,iflag,impol
  integer :: ifcns(3)
  real*8  :: ztime  ! ESC related; not presently used
  real*8 :: zdrho,zpi,zpi2,zxi_axis,zxi_bdy,zraxis,zdum1,zdum2,ztflux
  real*8 :: zrho(ins),zpmhd(ins),zq(ins) 
  real*8 :: zg(ins),zg_r(ins),zg_rr(ins)
  real*8 :: zne(ins),zne_r(ins)
  real*8 :: ztf_r(ins),ztf_rr(ins),zpf_r(ins),zpf_rr(ins)
  real*8 :: zpr_r(ins),zpr_rr(ins),zpf_rb(ins)
  real*8 :: zp(ins),zp_r(ins),zt(ins),zt_r(ins)  
  real*8, dimension(:,:), allocatable :: zrhon,zchin 
  real*8, dimension(:,:), allocatable :: hfun
  real*8, dimension(:,:,:), allocatable :: zfun
  integer :: iregion(int1)
  real*8 :: zrhob(int1),zphi(int1),zchi(int1),zR(int1),zZ(int1)

  luntrm = lnout(0)

! Prepare Rho and Chi coordinates
!  (same as a and gq in Leonid's represenatation)

     zrho(1)=0.0_r8
     zdrho=1.0_r8/(float(ins-1))
     do ik=2,ins
       zrho(ik)=zrho(ik-1)+zdrho
     enddo
     zrho(ins)=1.0_r8

     zpi = 3.14159265358979312_r8 
     zpi2=2.0_r8*zpi
     do ik=1,int1
      zchi(ik)=zpi2*(ik-1)/(int1-1)
     enddo

! Prepare g and g' 
! (same as F and F' in ESI representation]

     ! g=R*Bt (T*m)

     call eq_gfnum('G', id_g)

     call eq_rgetf(ins,zrho,id_g,0,zg,ierr)
     if(ierr.ne.0) then
       write(luntrm,*)  &
         ' ?eq_esia:  error in eq_rgetf("G",...)'
     endif

     call eq_rgetf(ins,zrho,id_g,1,zg_r,ierr)
     if(ierr.ne.0) then
       write(luntrm,*)  &
         ' ?eq_esia:  error in eq_rgetf("G_r",...)'
     endif

     call eq_rgetf(ins,zrho,id_g,2,zg_rr,ierr)
     if(ierr.ne.0) then
       write(luntrm,*)  &
         ' ?eq_esia:  error in eq_rgetf("G_rr",...)'
     endif

! Prepare gF'/a, gF'', gY'/a, (gY'/a)' (ESC) 

!    First get derivatives of poloidal flux

     call eq_gfnum('PSI',id_pflux)
     call eq_rgetf(ins,zrho,id_pflux,1,zpf_r,ierr)
     if(ierr.ne.0) then
       write(luntrm,*)  &
         ' ?eq_esia:  error in eq_rgetf("PF_R",...)'
     endif

!    Store a back-up of unaltered derivative of poloidal flux

     zpf_rb(1:ins)=zpf_r(1:ins)

     call eq_gfnum('PSI',id_pflux)
     call eq_rgetf(ins,zrho,id_pflux,2,zpf_rr,ierr)
     if(ierr.ne.0) then
       write(luntrm,*)  &
         ' ?eq_esia:  error in eq_rgetf("PF_RR",...)'
     endif

!    Calculate derivative of (psi'/a) using
!    quotient rule
 
     do ik=2,ins
      zpf_rr(ik)=-(zrho(ik)*zpf_rr(ik)-zpf_r(ik))/(zrho(ik)*zrho(ik))
     enddo

! Following based on observations of Leonid's data
!  (Zero second derivative is enforced at the center)

     zpf_rr(1)=0.0_r8

     do ik=2,ins
      zpf_r(ik)=-zpf_r(ik)/(zrho(ik))
     enddo
     zpf_r(1)=2.0_r8*zpf_r(2)-zpf_r(3)

! Now derivative of toroidal flux

!    (1/X)d(Phi)/dX=2*tflux from the
!    definition of X=sqrt(Phi/tflux)

     ztf_r=2.0_r8*ztflux/zpi2

     ztf_rr=0.0_r8

! Prepare T,Ta,P, an Pa (ESC) 

     do ik=2,ins
      zt(ik)=-zg(ik)*zg_r(ik)/zpf_rb(ik)
     enddo
     zt(1)=2.0_r8*zt(2)-zt(3)

     do ik=2,ins
      zt_r(ik)= -(zpf_rb(ik)*(zg(ik)*zg_rr(ik)+zg_r(ik)*zg_r(ik))             &
                -zg(ik)*zg_r(ik)*zpf_rr(ik))/(zpf_rb(ik)*zpf_rb(ik))
     enddo
!    zt_r(1)=2.0_r8*zt_r(2)-zt_r(3)

! Following based on observations of Leonid's data
!  (Zero derivative is enforced at the center)

     zt_r(1)=0.0_r8


     ! Pressure in Pascals 

     call eq_rgetf(ins,zrho,id_pmhd,1,zpr_r,ierr)
     if(ierr.ne.0) then
       write(luntrm,*)  &
         ' ?eq_esia:  error in eq_rgetf("zpr_r",...)'
     endif

     call eq_rgetf(ins,zrho,id_pmhd,2,zpr_rr,ierr)
     if(ierr.ne.0) then
       write(luntrm,*)  &
         ' ?eq_esia:  error in eq_rgetf("zpr_rr",...)'
     endif


     ! convert pressure to mu0 Pascal
     ! (4*pi*1.0E-7*1.0E6)
     ! 1.0E6 is for converting 1/cm^3 to 1/m^3 
     ! zpr_r=0.4_r8*zpi*zpr_r
     ! zpr_rr=0.4_r8*zpi*zpr_rr

    zpr_r=0.4_r8*zpi*(1.0e-6*zpr_r)
    zpr_rr=0.4_r8*zpi*(1.0e-6*zpr_rr)

     do ik=2,ins
      zp(ik)=-zpr_r(ik)/zpf_rb(ik)
     enddo
     zp(1)=2.0_r8*zp(2)-zp(3)

     ! Second derivative using quotient rule

     do ik=2,ins
      zp_r(ik)=-(zpf_rb(ik)*zpr_rr(ik)-zpf_rr(ik)*zpr_r(ik))/(zpf_rb(ik)*zpf_rb(ik))
     enddo

!    zp_r(1)=2.0_r8*zp_r(2)-zp_r(3)

! Following based on observations of Leonid's data
!  (Zero derivative is enforced at the center)

     zp_r(1)=0.0_r8

! Prepare r, z and their derivatives

     call eq_gfnum('R',ifcns(1))
     call eq_gfnum('Z',ifcns(2))
     call eq_gfnum('BMOD',ifcns(3))

     allocate(zrhon(int1, ins))
     allocate(zchin(int1, ins))
     allocate(hfun(int1, ins))
     allocate(zfun(int1,ins,12))

     zrhon=spread(zrho,dim=1,ncopies=int1)
     zchin=spread(zchi,dim=2,ncopies=ins) 

     call eq_hrhochi(int1*ins,zrhon,zchin,3,ifcns,                    &
         &                (/1,1,1,0,0,1/),int1*ins,zfun,ierr)
     if(ierr.ne.0) then
       write(luntrm,*)  &
         ' ?eq_esia:  error in eq_rgetf("R,Z, |B| etc.",...)'
     endif

     hfun(:,:)=0.0_r8

     zne(:)=0.0_r8
     zne_r(:)=0.0_r8

! Prepare Ne and d(Ne)/da

     call eq_rgetf(ins,zrho,id_nen,0,zne,ierr)

     if(ierr.ne.0) then
       write(luntrm,*)  &
         ' ?eq_esia:  error in eq_rgetf("NE",...)'
     endif

     call eq_rgetf(ins,zrho,id_nen,1,zne_r,ierr)

     if(ierr.ne.0) then
       write(luntrm,*)  &
         ' ?eq_esia:  error in eq_rgetf("NE_r",...)'
     endif

     zne(1:ins)=zne(1:ins)*1E-20
     zne_r(1:ins)=zne_r(1:ins)*1E-20

     write (lun_esia,'(a)') '!!! Do not edit this file'
     write (lun_esia,'(i3,a,i3,a)') int1,' x ',ins,' - numbers of poloidal x radial data points'
     write (lun_esia,'(a)') 'gq:'

     write (lun_esia,'(4(e24.16))') (zchi(ik),ik=1,int1)

     write (lun_esia,'(TR23,a,TR23,a,TR22,a)') 'a','F','Fa'
     write (lun_esia,'(3(e24.16))') (zrho(ik),zg(ik),zg_r(ik),ik=1,ins)

     write (lun_esia,'(TR19,a,TR20,a,TR19,a,TR16,a)') "gF'/a","gF''","gY'/a","(gY'/a)'"
     write (lun_esia,'(4(e24.16))') (ztf_r(ik),ztf_rr(ik),zpf_r(ik),zpf_rr(ik),ik=1,ins)

     write (lun_esia,'(TR23,a,TR20,a,TR23,a,TR22,a)') "T","Ta''","P","Pa"
     write (lun_esia,'(4(e24.16))') (zt(ik),zt_r(ik),zp(ik),zp_r(ik),ik=1,ins)

     write (lun_esia,'(TR23,a,TR20,a,TR19,a,TR14,a)') "r","r'_a","r'_gq","r''_{a,gq}"
     write (lun_esia,'(4(e24.16))') ((zfun(ik,jk,1),zfun(ik,jk,2),zfun(ik,jk,3),        &
                                 zfun(ik,jk,4),ik=1,int1),jk=1,ins)

     write (lun_esia,'(TR23,a,TR20,a,TR19,a,TR14,a)') "z","z'_a","z'_gq","z''_{a,gq}"
     write (lun_esia,'(4(e24.16))') ((-zfun(ik,jk,5),-zfun(ik,jk,6),-zfun(ik,jk,7),        &
                                 -zfun(ik,jk,8),ik=1,int1),jk=1,ins)

     write (lun_esia,'(TR23,a,TR20,a,TR19,a,TR14,a)') "B","B'_a","B'_gq","B''_{a,gq}"
     write (lun_esia,'(4(e24.16))') ((zfun(ik,jk,9),zfun(ik,jk,10),zfun(ik,jk,11),        &
                                 zfun(ik,jk,12),ik=1,int1),jk=1,ins)

     write (lun_esia,'(TR18,a,TR13,a,TR12,a,TR9,a)') "gh'_gq",         &
                                         "gh''_{a,gq}","gh''_{gq,gq}","gh'''_{a,gq,gq}"
     write (lun_esia,'(4(e24.16))') ((hfun(ik,jk),hfun(ik,jk),hfun(ik,jk),                &
                                 hfun(ik,jk),ik=1,int1),jk=1,ins)

     write (lun_esia,'(a,TR10,a,TR6,a)') "Te=Ti=15keV N=3.26e+20 a",   &
                                                  "ne [10^20/m^3]","dne/da [10^20/m^3]"     
     write (lun_esia,'(3(e24.16))') (zrho(ik),zne(ik),zne_r(ik),ik=1,ins)

     
     deallocate(zrhon)
     deallocate(zchin)
     deallocate(hfun)
     deallocate(zfun)

end subroutine eq_esia 

subroutine eqi_qpsi_regen(gval,inum,rs,zs,qval)

  !  estimate q(psi) from loop integral formula  
  !     q(psi) = 2pi*(R*B_phi)*[integral dl * (R/grad(psi)) * (1/R**2)]
  !  where the integral goes around the flux surface at psi.

  use eqi_geq_mod   ! contains Psi(R,Z) bicubic spline
  implicit NONE
  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)

  !-----------------------------------------------------------
  !  arguments:

  real*8, intent(in) :: gval    ! "g", (R*B_phi), Tesla*m
  integer, intent(in) :: inum   ! #pts on surface
  real*8, intent(in) :: rs(inum),zs(inum)  ! closed flux surface contour
  !                     with rs(1)=rs(inum) and zs(1)=zs(inum)

  real*8, intent(out) :: qval   ! "q" value estimated

  !-----------------------------------------------------------
  !  local:

  real*8, dimension(:,:), allocatable :: grad_psi
  real*8 :: rz1(2),rz2(2),rz3(2),rcen(2),rad,rscale,arc,dl,zrgpsii
  real*8 :: zdot,zcross

  integer :: ii,iok

  real*8, parameter :: zlarge = 1.0e5_R8
  real*8, parameter :: z2pi = 6.2831853071795862_R8

  !-----------------------------------------------------------

  allocate(grad_psi(inum,2))

  call ezspline_gradient(pspl,inum,rs,zs,grad_psi,iok)
  call ezspline_error(iok)

  qval = 0

  rz2(1) = rs(inum-1)   ! (R,Z) point #2
  rz2(2) = zs(inum-1)

  rz3(1) = rs(1) ! = rs(inum)  ! (R,Z) point #3
  rz3(2) = zs(1) ! = zs(inum)

  !  loop around the contour

  do ii=1,inum-1

     rz1 = rz2          ! #2 -> #1
     rz2 = rz3          ! #3 -> #2
     rz3(1) = rs(ii+1)  ! new #3
     rz3(2) = zs(ii+1)

     zdot = (rz3(1)-rz2(1))*(rz2(1)-rz1(1)) + (rz3(2)-rz2(2))*(rz2(2)-rz1(2))
     if(zdot.le.0.0_R8) then
        ! negative dot product; two consective sections at acute angle
        ! for dL use 1/2 sum of lengths

        dl = 0.5_R8*( sqrt((rz3(1)-rz2(1))**2 + (rz3(2)-rz2(2))**2) + &
             sqrt((rz2(1)-rz1(1))**2 + (rz2(2)-rz1(2))**2) )
     else
        rscale = max(abs(rz3(1)-rz1(1)),abs(rz3(2)-rz1(2)))

        !  find radius of curvature; treat points as colinear if iok=1
        !  or if rad > zlarge*rscale

        call r8_trirad(rz1,rz2,rz3, rcen, rad, iok)
        if(iok.eq.0) then
           if(rad.gt.zlarge*rscale) iok=1
        endif

        if(iok.eq.1) then
           ! colinear formula -- half the distance rz1 to rz3
           dl = 0.5_R8*sqrt((rz3(1)-rz1(1))**2 + (rz3(2)-rz1(2))**2)

        else
           ! arc formula: atan2(sin(alpha),cos(alpha));
           !   v1.v3=|v1|*|v3|*cos(alpha); v1^v3=|v1|*|v3|*sin(alpha)

           zcross = (rz1(1)-rcen(1))*(rz3(2)-rcen(2)) - &
                (rz3(1)-rcen(1))*(rz1(2)-rcen(2))
           zdot = (rz1(1)-rcen(1))*(rz3(1)-rcen(1)) + &
                (rz1(2)-rcen(2))*(rz3(2)-rcen(2))

           arc = abs(atan2(zcross,zdot))

           dl = 0.5_R8*arc*rad   ! use half the arc rz1 to rz3
        endif
     endif

     !  R/(R**2*|grad(psi)|) = 1/(R*|grad(psi)|)

     zrgpsii = 1.0_R8/(rs(ii)* &
          max(1.0e-20_R8,(sqrt(grad_psi(ii,1)**2 + grad_psi(ii,2)**2))) )

     qval = qval + dl*zrgpsii

  enddo

  qval = qval * abs(gval)/z2pi

end subroutine eqi_qpsi_regen

subroutine eq_psipqgrz(fpath,ixtra, &
     id_pmhd,id_q, &
     ierr)
 
  !  write J. Menard - style - psipqgRZ file
  !  the radial grid used is the xplasma grid, unless ixtra specifies
  !  extra radial points on a per-zone basis
 
  !  dmc Jan 2002 -- xplasma module not used; using data access routines.
 
  use ezcdf
  implicit NONE
 
  character*(*), intent(in) :: fpath    ! ezcdf filename
 
  integer, intent(in) :: ixtra    ! extra points per zone (can be zero)
 
  integer, intent(in) :: id_pmhd  ! id for pressure profile
  integer, intent(in) :: id_q     ! id for q profile
 
  integer, intent(out) :: ierr    ! completion code, 0=OK
 
  !-------------------
 
  real*8, dimension(:), allocatable :: rhotmp,phitmp
  real*8, dimension(:), allocatable :: rho,chi,psi,pmhd,g,q
  real*8, dimension(:,:), allocatable :: r,z
  integer, dimension(:), allocatable :: nregion
 
  integer :: id_psi=0,id_g=0,id_rho=0,id_chi=0
  integer isnccwb,isnccwi
 
  integer lunerr
 
  integer nrho,nchi,igot,i,j,k,istat
  integer dimlens(3),ncid
 
  real*8 zdchi,ztest
 
  real*8, parameter :: z2pi = 6.2831853071795862D+00
 
  character*20 errstr
 
  !-------------------
 
  ierr=0
 
  call eq_get_lunerr(lunerr)
 
  errstr = ' '
 
  !-------------------
  !  check arguments...
  !-------------------
 
  if((ixtra.lt.0).or.(ixtra.gt.100)) then
     write(lunerr,*) ' ?eq_psipqgrz: "ixtra" argument not in range 0 - 100:', &
          ixtra
     ierr=1
  endif
 
  if(id_pmhd.eq.0) then
     write(lunerr,*) ' ?eq_psipqgrz: pressure profile id (id_pmhd) is zero.'
     ierr=1
  endif
 
  if(id_q.eq.0) then
     write(lunerr,*) ' ?eq_psipqgrz: q profile id (id_q) is zero.'
     ierr=1
  endif
 
  if(ierr.ne.0) return
 
  !-------------------
  !  check xplasma...
  !-------------------
 
  call eq_gfnum('g',id_g)
  call eq_gfnum('psi',id_psi)
 
  if(id_g.eq.0) then
     write(lunerr,*) ' ??eq_psipqgrz:  "g" not in xplasma data.'
     ierr=1
  endif
 
  if(id_psi.eq.0) then
     write(lunerr,*) ' ??eq_psipqgrz:  "psi" not in xplasma data.'
     ierr=1
  endif
 
  call eq_bchk_sign(isnccwb,isnccwi)
 
  if(isnccwb.eq.0) then
     write(lunerr,*) ' ??eq_psipqgrz:  incomplete B field setup in xplasma.'
     ierr=1
  endif
 
  if(ierr.ne.0) return
 
  !--------------------------------------------------------
  ! get grids
  !--------------------------------------------------------
 
  call eq_ganum('__RHO',id_rho)
  call eq_ganum('__CHI',id_chi)
 
  call eq_ngrid(id_rho,nrho)
  call eq_ngrid(id_chi,nchi)
 
  ! allocate extra space for chi; if it is unevenly spaced, a finer grid
  ! will be used.
  ! ***after allocation: go to 999 for cleanup if there is an error.
 
  allocate(rhotmp(nrho),chi(2*nchi+1))
 
  call eq_grid(id_rho,rhotmp,nrho,igot,ierr)
  if(ierr.ne.0) go to 999
 
  call eq_grid(id_chi,chi,nchi,igot,ierr)
  if(ierr.ne.0) go to 999
 
  ! check chi spacing
 
  zdchi = z2pi/(nchi-1)
  igot = nchi
  do i=1,nchi-1
     ztest = ((chi(i+1)-chi(i))-zdchi)/zdchi
     if(abs(ztest).gt.1.0d-3) igot=2*nchi-1
  enddo
 
  ! if chi not evenly spaced, form an evenly spaced grid with more points.
 
  if(igot.gt.nchi) then
     nchi=igot
     do i=1,nchi
        chi(i)=(i-1)*z2pi/(nchi-1)
     enddo
  endif
 
  ! implement ixtra feature-- add extra points to rho grid if requested.
 
  if(ixtra.eq.0) then
     allocate(rho(nrho))
     rho=rhotmp
  else
     igot=nrho
     nrho=1+(ixtra+1)*(igot-1)
     allocate(rho(nrho))
     rho(nrho)=rhotmp(igot)
     k=0
     do i=1,igot-1
        do j=1,ixtra+1
           k=k+1
           rho(k)=rhotmp(i)+(j-1)*(rhotmp(i+1)-rhotmp(i))/(ixtra+1)
        enddo
     enddo
  endif
 
  deallocate(rhotmp)
  allocate(rhotmp(nchi),phitmp(nchi))
 
  !-------------------------------------------------------
  ! get data
  !-------------------------------------------------------
 
  allocate(psi(nrho),pmhd(nrho),g(nrho),q(nrho))
  allocate(r(nchi,nrho),z(nchi,nrho))
 
  errstr = 'eq_rgetf(psi)'
  call eq_rgetf(nrho,rho,id_psi,0,psi,ierr)
  if(ierr.ne.0) go to 999
 
  errstr = 'eq_rgetf(pmhd)'
  call eq_rgetf(nrho,rho,id_pmhd,0,pmhd,ierr)
  if(ierr.ne.0) go to 999
 
  errstr = 'eq_rgetf(g)'
  call eq_rgetf(nrho,rho,id_g,0,g,ierr)
  if(ierr.ne.0) go to 999
 
  errstr = 'eq_rgetf(q)'
  call eq_rgetf(nrho,rho,id_q,0,q,ierr)
  if(ierr.ne.0) go to 999
 
  errstr = 'eq_rzget'
 
  allocate(nregion(nchi))
  phitmp=0
  do i=1,nrho
     rhotmp=rho(i)
     call eq_rzget(nchi,rhotmp,chi,phitmp,r(1:nchi,i),z(1:nchi,i),nregion, &
          ierr)
     if(ierr.ne.0) go to 999
  enddo
 
  !-------------------
  !  try to open file...
  !-------------------
 
  call ezcdf_open(ncid,fpath,'w',ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_psipqgrz: file creation failure: ', fpath
     go to 999
  endif
 
  !-------------------
  !  write file...
  !-------------------
 
  ! define variables
 
  dimlens=0
  call cdfDefVar(ncid,'isnccwb',dimlens,'INT')
  call cdfDefVar(ncid,'isnccwi',dimlens,'INT')
  call cdfDefVar(ncid,'ns',dimlens,'INT')
  call cdfDefVar(ncid,'nt1',dimlens,'INT')
 
  dimlens(1)=nrho
  call cdfDefVar(ncid,'rho',dimlens,'R8')
  call cdfDefVar(ncid,'psi',dimlens,'R8')
  call cdfDefVar(ncid,'p',dimlens,'R8')
  call cdfDefVar(ncid,'q',dimlens,'R8')
  call cdfDefVar(ncid,'g',dimlens,'R8')
 
  dimlens(1)=nchi
  dimlens(2)=nrho
  call cdfDefVar(ncid,'R',dimlens,'R8')
  call cdfDefVar(ncid,'Z',dimlens,'R8')
 
  ! put variables
 
  call cdfPutVar(ncid,'isnccwb',isnccwb)
  call cdfPutVar(ncid,'isnccwi',isnccwi)
  call cdfPutVar(ncid,'ns',nrho)
  call cdfPutVar(ncid,'nt1',nchi)
 
  call cdfPutVar(ncid,'rho',rho)
  psi = -isnccwi * psi
  call cdfPutVar(ncid,'psi',psi)
  call cdfPutVar(ncid,'p',pmhd)
  call cdfPutVar(ncid,'q',q)
  g = isnccwb * g
  call cdfPutVar(ncid,'g',g)
 
  call cdfPutVar(ncid,'R',r)
  call cdfPutVar(ncid,'Z',z)
 
  call ezcdf_close(ncid)
 
  !------------------------------------
  ! cleanup and exit
 
999 continue
 
  deallocate(rhotmp,phitmp,stat=istat)
  deallocate(rho,chi,stat=istat)
  deallocate(psi,pmhd,q,g,stat=istat)
  deallocate(nregion,stat=istat)
  deallocate(r,z,stat=istat)
 
end subroutine eq_psipqgrz

module eqi_geq_mod
 
  use ezspline_obj
  use ezspline
  use geqdsk_nomds_mod
  ! MDS+ dependencies in xplasma2  cleaned
  !  DMC 2000 -- 2008 ... ad hoc data for contouring EFIT-style Psi(R,Z) data

  implicit NONE
  save  !  caution -- not saved/restored by eq_save/eq_restore
  type(ezspline2) :: pspl      ! psi(R,Z) spline
 
  type(geqdsk) :: geq          ! GEQDISK data
 
  real*8 psep                  ! EFIT's Psi @ bdy

  real*8 r0,z0                 ! mag. axis
 
  real*8 :: gs_errmax          ! maximum GS error found in EFIT equilibrium
                               ! (ignoring pts near bdy)
 
  integer :: jwarn = 0         ! warning flag

  integer :: isign_xy          ! trace direction for contouring
  integer :: errflag           ! set if 

  real*8 :: lnorm,lmax         ! normalizing distance for contouring
                               ! or for curvature definition

  integer :: isw               ! toggle btw 2 th_adapt grids & assoc. data
  real*8, dimension(:,:), allocatable :: thadapt
                               ! adaptive th grid -- will concentrate points
                               ! near approach to bdy separatrices in Psi(R,Z)

  integer :: nthad             ! size of data in thadapt(:,isw)
  integer :: nthad0            ! starting size of data in thadapt(:,isw)

  real*8, dimension(:,:), allocatable :: radapt,zadapt,curvad,rzwk
  !  radapt(...) R pts @ thadapt on a chosen surface
  !  zadapt(...) Z pts @ thadapt on a chosen surface
  !  curvad(...) normalized contour curvature on the chosen surface
  !  rzwk(...) work space for eqi_find_curvature routine (see also curvec(...))

  integer, dimension(:), allocatable :: iadapt

  !  auxilliary utility (R,Z) countour
  integer :: nseek
  real*8, dimension(:), allocatable :: rseek,zseek,curvec

  real*8 :: cbdy_chk

  integer :: istep_out

contains
  subroutine nx_thadapt(inref,inmin)

    integer, intent(in) :: inref
    !  inref -- reference gridsize -- faster adaptation if at or below...
    integer, intent(in) :: inmin
    !  inmin -- minimum size of contigous region with curvature <= cbdy_chk
    !           lesser size => grid adaptation

    !----------------------------
    integer :: iswp,imul,ii,jj,kk,ict,indx1,indxn,indxi,indxo,iaprev
    real*8 :: mulfac
    integer, save :: icount = 0
    integer, parameter :: ilun_dbg = 6
    !----------------------------

    icount = icount + 1

    iswp=isw
    isw=3-isw

    if(nthad.le.inref) then
       imul=10
    else
       imul=2
    endif
    mulfac = 1.0d0
    mulfac = mulfac/imul

    iaprev=1
    do ii=1,nthad
       iadapt(ii)=0
       if(curvad(ii,iswp).le.cbdy_chk) iadapt(ii)=1
       if((iadapt(ii).eq.1).and.(iaprev.eq.0)) then
          iadapt(ii-1)=1 ! extend 1 back
       endif
       if(ii.eq.1) iaprev=0
       if((iadapt(ii).eq.0).and.(iaprev.eq.1)) then
          iaprev=0
          iadapt(ii)=1   ! extend forward
       else
          iaprev=iadapt(ii)
       endif
    enddo

    !  see if adapt region straddles end pt
    indx1=0
    indxn=nthad

    if(iadapt(1)*iadapt(nthad).eq.1) then
       ict=-1   ! do not double count common end point
       ii = 1
       do while ( iadapt(ii) == 1 )
          ict = ict + 1
          ii = ii + 1
       enddo
       indx1 = ii-1

       ii = nthad
       do while ( iadapt(ii) == 1 )
          ict = ict + 1
          ii = ii - 1
       enddo
       indxn = ii + 1
    endif
    if(indx1.gt.0) then
       if(ict.ge.inmin) then
          indx1=0
          indxn=nthad
       endif
    endif

    indxi=0
    indxo=0
    ! adapt 1st piece contigous with index 1 if necessary
    do ii=1,indx1
       indxi=indxi+1
       indxo=indxo+1
       thadapt(indxo,isw)=thadapt(indxi,iswp)
       do jj=1,imul-1
          indxo=indxo+1
          thadapt(indxo,isw)=((imul-jj)*thadapt(indxi,iswp) + &
               jj*thadapt(indxi+1,iswp))*mulfac
       enddo
    enddo

    ii=indx1
    ict = 0
    do while ( ii < indxn-1 )
       ! look for more contiguous sections with low curvature radius
       ii = ii + 1
       if(iadapt(ii).eq.0) then
          if(ict.eq.0) then
             ! no adaptation on this point...
             continue
          else if(ict.ge.inmin) then
             ! contiguous section large enough; no adaptation
             do jj=1,ict
                indxi=indxi+1
                indxo=indxo+1
                thadapt(indxo,isw)=thadapt(indxi,iswp)
             enddo
          else
             ! contiguous low curvature region has too few points -- expand
             do jj=1,ict
                indxi=indxi+1
                indxo=indxo+1
                thadapt(indxo,isw)=thadapt(indxi,iswp)
                do kk=1,imul-1
                   indxo=indxo+1
                   thadapt(indxo,isw)=((imul-kk)*thadapt(indxi,iswp) + &
                        kk*thadapt(indxi+1,iswp))*mulfac
                enddo
             enddo
          endif
          ict = 0  ! clear count
          ! include current point
          indxi=indxi+1
          indxo=indxo+1
          thadapt(indxo,isw)=thadapt(indxi,iswp)
       else
          ict = ict + 1  ! keep count
       endif
    enddo

    ! adapt last piece contiguous with index 
    do ii=indxn,nthad-1
       indxi=indxi+1
       indxo=indxo+1
       thadapt(indxo,isw)=thadapt(indxi,iswp)
       do jj=1,imul-1
          indxo=indxo+1
          thadapt(indxo,isw)=((imul-jj)*thadapt(indxi,iswp) + &
               jj*thadapt(indxi+1,iswp))*mulfac
       enddo
    enddo

    ! final end point
    indxi=indxi+1
    if(indxi.ne.nthad) then
       write(ilun_dbg,*) &
            '    nx_thadapt: Error occurred on call icount = ',icount
       call errmsg_exit(' ?? eqi_geq_mod(nx_thadapt) algorithm failure.')
    endif
    indxo=indxo+1

    thadapt(indxo,isw)=thadapt(indxi,iswp)
    nthad=indxo

  end subroutine nx_thadapt

  subroutine quad_minmax(delx12,delx23,f1,f2,f3,fminmax)

    ! given a sequence of 3 consecutive function values {f1,f2,f3} evaluated
    ! at grid points x1 < x2 < x3 (with delx12 = x2-x1; delx23 = x3-x2), and
    ! with f2 a pointwise local minimum or maximum, find the local minimum
    ! or maximum based on a parabolic fit through the 3 points.

    !    f(-delx1) = f2 + aa*delx1**2 - bb*delx1 = f1
    !    f(delx2)  = f2 + aa*delx2**2 + bb*delx2 = f3

    ! f2 **must** be either .le.min(f1,f3) or .ge.max(f1,f3) -- not checked!!

    real*8, intent(in) :: f1,f2,f3,delx12,delx23
    real*8, intent(out) :: fminmax

    real*8 :: xm,xp,fm,fp,aa,bb,denom,xsing
    real*8, parameter :: zero = 0.0d0

    xm = -delx12
    xp =  delx23
    fm = f1-f2
    fp = f3-f2

    denom=xp*xm*(xp-xm)
    aa=(fp*xm-fm*xp)/denom
    bb=(fm*xp*xp-fp*xm*xm)/denom

    if(aa.eq.zero) then
       fminmax=f2   ! assume flat, colinear points f1=f2=f3
    else
       xsing = -bb/(2*aa)
       fminmax = f2 + xsing*(bb + xsing*aa)
    endif

  end subroutine quad_minmax

end module eqi_geq_mod

subroutine eqm_cbdy_grid(ipts,rlim,zlim,inumRi,inumZi,id_R,id_Z,ierr)

  !  (a)
  !  set up an axisymmetric piecewise linear boundary / limiter contour.
  !  the contour must close on itself (rlim(1)=rlim(ipts) &
  !   zlim(1)=zlim(ipts)) and not cross itself.

  !  (b)
  !  set up a rectangular (R,Z) grid, evenly spaced and with the dimensioning
  !  given, which covers the plasma core and "scrapeoff layer" i.e. the space
  !  between the core plasma and the limiters.  The grid is "padded" with
  !  1.5 zones around each edge.  The eqm_rzgrid routine is used to actually
  !  set the grid.

  !  the padding serves two functions:  (1) provides some mapped space
  !  in all directions beyond the limiters, and (2) ameliorates possible
  !  boundary effects in Akima Hermite bicubic fitting over the (R,Z) grid.

  !  ...for more details on the contours, see subroutine eqm_cbdy

  !  mod DMC Jan 2007 -- force Zmin = -Zmax
  !    some physics modules require this Z grid symmetry
  !-----------------------

  use xplasma_obj_instance
  use eq_module

  implicit NONE

  !  input:

  integer ipts                      ! # of (R,Z) points defining contour
  real*8 rlim(ipts),zlim(ipts)      ! (R,Z) points

  integer inumRi                    ! desired no. of points in R grid
  integer inumZi                    ! desired no. of points in Z grid

  !  output:

  integer id_R                      ! R grid xplasma id code
  integer id_Z                      ! Z grid xplasma id code

  integer ierr                      ! completion code, 0=OK

  !-----------------------
  !  local...

  real*8, dimension(:), allocatable :: zRgrid,zZgrid  ! generated R & Z grids

  real*8 zRmin,zRmax,zZmin,zZmax,zRlim
  integer itype

  real*8 zRmid,zZmid
  real*8 zdelR,zdelZ

  integer i,inumR,inumZ

  !-----------------------

  inumR = inumRi
  inumZ = inumZi

  ierr=0
  if(inumR.lt.32) then
     write(lunerr,*) ' ?eqm_tbdy_grid: inumR=',inumR,' .lt. 32: fixup applied.'
     inumR=32
  endif
  if(inumZ.lt.32) then
     write(lunerr,*) ' ?eqm_tbdy_grid: inumZ=',inumZ,' .lt. 32: fixup applied.'
     inumZ=32
  endif
  if(ierr.ne.0) return

  !  1.  set up limiters

  call eqm_cbdy(ipts,rlim,zlim,ierr)
  if(ierr.ne.0) return

  !  2.  fetch the limiter extrema

  call eq_bdlims(itype,zRmin,zRmax,zZmin,zZmax,ierr)

  ! force Z grid up-down symmetry
  zZmax = max(abs(zZmin),abs(zZmax))
  zZmin = -zZmax

  zRmid=chalf*(zRmin+zRmax)
  zZmid=chalf*(zZmin+zZmax)

  !  2a: expand slightly, but check...

  zdelR=(inumR-1)*chalf*(zRmax-zRmin)/(inumR-4)
  zdelZ=(inumZ-1)*chalf*(zZmax-zZmin)/(inumZ-4)

  zRmin=max((zRmin/2),zRmid-zdelR)
  zRmax=zRmid+zdelR

  zZmin=zZmid-zdelZ
  zZmax=zZmid+zdelZ

  !  3.  generate the R,Z grids

  allocate(zRgrid(inumR),zZgrid(inumZ))

  do i=1,inumR
     zRgrid(i)=(zRmin*(inumR-i)+zRmax*(i-1))/(inumR-1)
  enddo

  do i=1,inumZ
     zZgrid(i)=(zZmin*(inumZ-i)+zZmax*(i-1))/(inumZ-1)
  enddo

  call eqm_rzgrid(zRgrid,zZgrid,0,0,inumR,inumZ,ceps4,id_R,id_Z,ierr)

  deallocate(zRgrid,zZgrid)

end subroutine eqm_cbdy_grid

subroutine mcgrid_putobj(id_grid,zname, &
     ist_th,ist_ph,iextend,zmks,zdata,idimi,ierr)
 
  !  (dmc: intent(in) attribute removed from zdata array arguments)
  !  (to make debugger happy: mcgrid_put uses intent(inout)).

  !  put (store) mcgrid scalar field -- one number per grid zone
 
  !  this can cover the plasma out to the boundary (iextend=0) or
  !  beyond the boundary into the extrapolated region (iextend=1)
 
  !  the input data's theta and phi grid are as per user's definitions;
  !  ist_th(ph) = -1 -- user grid starts at -pi (theta, phi)
  !  ist_th(ph) =  0 -- user grid starts at 0   (theta, phi)
  !  theta, phi grids are evenly spaced; no. of phi points and no. of
  !  theta pts per zone row are as specified in mcgrid #id_grid
  !  set up by prior call to mcgrid_define.
 
  !  specify a negative number for "idimi" if object replacement
  !  is to generate a warning.

  use xplasma_obj_instance
  use eq_module

  implicit NONE
 
  integer, intent(in) :: id_grid     ! id from prior mcgrid_define call
  character*(*), intent(in) :: zname ! (unique) name of object to store
  integer, intent(in) :: ist_th,ist_ph  ! angle grid start flags
  integer, intent(in) :: iextend     ! =0: nznbmri rows; =1: nznbmr rows
  integer, intent(in) :: idimi       ! dimension of zdata array

  real*8, intent(in) :: zmks         ! MKS conversion factor to apply to zdata
  !  set zmks.lt.0.0 to specify clockwise orientation of poloidal zones
  !  data scaled by a factor of abs(zmks)

  real*8 :: zdata(abs(idimi))             ! data to store
 
  integer, intent(out) :: ierr       ! completion code (0=OK)
 
  ! -------------------------------------
  integer :: idtmp,idima,nzons,nzons_ext,inzons,iertmp
  ! -------------------------------------
 
  call mcgrid_argcheck('mcgrid_putobj',ist_th,ist_ph,iextend,ierr)
  if(ierr.ne.0) return

  call xplasma_mcgrid_info(s,id_grid,ierr, nzons=nzons,nzons_ext=nzons_ext)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?mcgrid_putobj: xplasma_mcgrid_info error.'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  if(idimi.lt.0) then
     call xplasma_find_item(s,zname,idtmp,ierr,nf_noerr=.TRUE.)
     if(ierr.ne.0) then
        write(lunerr,*) ' ?mcgrid_putobj: xplasma_find_item error.'
        call xplasma_error(s,ierr,lunerr)
        return
     endif
     if(idtmp.gt.0) then
        write(lunerr,*) &
             ' %mcgrid_putobj: warning: "',trim(zname),'" redefined.'
     endif
  endif

  idima=abs(idimi)
  if(iextend.eq.1) then
     inzons=nzons_ext
  else
     inzons=nzons
  endif

  if(inzons.gt.idima) then
     write(lunerr,*) &
          ' ?mcgrid_putobj: array size too small for iextend=',iextend
     write(lunerr,*) '  have: ',idima,'; need: ',inzons
     ierr=1
     return
  endif

  call xoi_author_set(iertmp)

  call xplasma_mcgrid_putobj(s,id_grid,zname,idtmp,ierr, &
       lstart0_th = (ist_th.eq.0), ccwflag_th = (zmks.ge.0.0d0), &
       data_1d = zdata(1:inzons)*abs(zmks))

  call xoi_author_clear(iertmp)
 
end subroutine mcgrid_putobj
 
subroutine mcgrid_putobj_r4(id_grid,zname, &
     ist_th,ist_ph,iextend,zmks,zdata,idimi,ierr)
 
  !  put (store) mcgrid scalar field -- one number per grid zone
 
  !  this can cover the plasma out to the boundary (iextend=0) or
  !  beyond the boundary into the extrapolated region (iextend=1)
 
  !  the input data's theta and phi grid are as per user's definitions;
  !  ist_th(ph) = -1 -- user grid starts at -pi (theta, phi)
  !  ist_th(ph) =  0 -- user grid starts at 0   (theta, phi)
  !  theta, phi grids are evenly spaced; no. of phi points and no. of
  !  theta pts per zone row are as specified in mcgrid #id_grid
  !  set up by prior call to mcgrid_define.
 
  implicit NONE
 
  integer, intent(in) :: id_grid     ! id from prior mcgrid_define call
  character*(*), intent(in) :: zname ! (unique) name of object to store
  integer, intent(in) :: ist_th,ist_ph  ! angle grid start flags
  integer, intent(in) :: iextend     ! =0: nznbmri rows; =1: nznbmr rows
  integer, intent(in) :: idimi       ! dimension of zdata array
  real, intent(in) :: zmks           ! MKS conversion factor to apply to zdata
  !  set zmks.lt.0.0 to specify clockwise orientation of poloidal zones
  !  data scaled by a factor of abs(zmks)

  real :: zdata(abs(idimi))                ! data to store
 
  integer, intent(out) :: ierr       ! completion code (0=OK)
  ! -------------------------------------
  ! local
 
  real*8 zmks8
  real*8, dimension(:), allocatable :: zdata8
  ! -------------------------------------

  allocate(zdata8(abs(idimi)))

  zmks8 = zmks
  zdata8 = zdata

  call mcgrid_putobj(id_grid,zname, &
     ist_th,ist_ph,iextend,zmks8,zdata8,idimi,ierr)

  deallocate(zdata8)

end subroutine mcgrid_putobj_r4
 
subroutine mcgrid_putarr2(id_grid,zname, &
     ist_th,ist_ph,iextend,zmks,zdata,in1,in2,idimi1,idim2,idim3,ierr)
 
  !  put (store) mcgrid 2d array field -- array(in1,in2) per grid zone
 
  !  this can cover the plasma out to the boundary (iextend=0) or
  !  beyond the boundary into the extrapolated region (iextend=1)
 
  !  the input data's theta and phi grid are as per user's definitions;
  !  ist_th(ph) = -1 -- user grid starts at -pi (theta, phi)
  !  ist_th(ph) =  0 -- user grid starts at 0   (theta, phi)
  !  theta, phi grids are evenly spaced; no. of phi points and no. of
  !  theta pts per zone row are as specified in mcgrid #id_grid
  !  set up by prior call to mcgrid_define.
 
  use xplasma_obj_instance
  use eq_module

  implicit NONE
 
  integer, intent(in) :: id_grid     ! id from prior mcgrid_define call
  character*(*), intent(in) :: zname ! (unique) name of object to store
  integer, intent(in) :: ist_th,ist_ph  ! angle grid start flags
  integer, intent(in) :: iextend     ! =0: nznbmri rows; =1: nznbmr rows
  integer, intent(in) :: idimi1,idim2,idim3 ! dimensions of zdata array
  real*8, intent(in) :: zmks         ! MKS conversion factor to apply to zdata
  !  set zmks.lt.0.0 to specify clockwise orientation of poloidal zones
  !  data scaled by a factor of abs(zmks)

  real*8 :: zdata(abs(idimi1),idim2,idim3) ! data to store
  integer, intent(in) :: in1,in2     ! store:  zdata(1:in1,1:in2,j)
 
  integer, intent(out) :: ierr       ! completion code (0=OK)
 
  ! -------------------------------------
  integer :: idtmp,idima,nzons,nzons_ext,inzons,ii,jj,kk,iertmp
  real*8, dimension(:,:,:), allocatable :: zdbuf
  ! -------------------------------------
 
  call mcgrid_argcheck('mcgrid_putarr2',ist_th,ist_ph,iextend,ierr)
  if(ierr.ne.0) return

  call xplasma_mcgrid_info(s,id_grid,ierr, nzons=nzons,nzons_ext=nzons_ext)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?mcgrid_putarr2: xplasma_mcgrid_info error.'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  if(idimi1.lt.0) then
     call xplasma_find_item(s,zname,idtmp,ierr,nf_noerr=.TRUE.)
     if(ierr.ne.0) then
        write(lunerr,*) ' ?mcgrid_putarr2: xplasma_find_item error.'
        call xplasma_error(s,ierr,lunerr)
        return
     endif
     if(idtmp.gt.0) then
        write(lunerr,*) &
             ' %mcgrid_putarr2: warning: "',trim(zname),'" redefined.'
     endif
  endif

  idima=idim3
  if(iextend.eq.1) then
     inzons=nzons_ext
  else
     inzons=nzons
  endif

  if(inzons.gt.idima) then
     write(lunerr,*) &
          ' ?mcgrid_putarr2: array size too small for iextend=',iextend
     write(lunerr,*) '  have: ',idima,'; need: ',inzons
     ierr=1
     return
  endif

  allocate(zdbuf(in1,in2,inzons))

  do kk=1,inzons
     do jj=1,in2
        do ii=1,in1
           zdbuf(ii,jj,kk) = abs(zmks)*zdata(ii,jj,kk)
        enddo
     enddo
  enddo

  call xoi_author_set(iertmp)

  call xplasma_mcgrid_putobj(s,id_grid,zname,idtmp,ierr, &
       lstart0_th = (ist_th.eq.0), ccwflag_th = (zmks.ge.0.0d0), &
       data_3d = zdbuf)

  call xoi_author_clear(iertmp)

  deallocate(zdbuf)

end subroutine mcgrid_putarr2
 
subroutine mcgrid_putarr2_r4(id_grid,zname, &
     ist_th,ist_ph,iextend,zmks,zdata,in1,in2,idimi1,idim2,idim3,ierr)
 
  !  put (store) mcgrid 2d array field -- array(in1,in2) per grid zone
 
  !  this can cover the plasma out to the boundary (iextend=0) or
  !  beyond the boundary into the extrapolated region (iextend=1)
 
  !  the input data's theta and phi grid are as per user's definitions;
  !  ist_th(ph) = -1 -- user grid starts at -pi (theta, phi)
  !  ist_th(ph) =  0 -- user grid starts at 0   (theta, phi)
  !  theta, phi grids are evenly spaced; no. of phi points and no. of
  !  theta pts per zone row are as specified in mcgrid #id_grid
  !  set up by prior call to mcgrid_define.
 
  implicit NONE
 
  integer, intent(in) :: id_grid     ! id from prior mcgrid_define call
  character*(*), intent(in) :: zname ! (unique) name of object to store
  integer, intent(in) :: ist_th,ist_ph  ! angle grid start flags
  integer, intent(in) :: iextend     ! =0: nznbmri rows; =1: nznbmr rows
  integer, intent(in) :: idimi1,idim2,idim3 ! dimensions of zdata array
  real, intent(in) :: zmks           ! MKS conversion factor to apply to zdata
  !  set zmks.lt.0.0 to specify clockwise orientation of poloidal zones
  !  data scaled by a factor of abs(zmks)

  real :: zdata(abs(idimi1),idim2,idim3)   ! data to store
  integer, intent(in) :: in1,in2     ! store:  zdata(1:in1,1:in2,j)
 
  integer, intent(out) :: ierr       ! completion code (0=OK)
 
  ! -------------------------------------
  ! local
 
  real*8 :: zmks8
  real*8, dimension(:,:,:), allocatable :: zdata8
  integer :: idima1
  ! -------------------------------------

  idima1=abs(idimi1)
  allocate(zdata8(idima1,idim2,idim3))

  zmks8 = zmks
  zdata8 = zdata

  call mcgrid_putarr2(id_grid,zname, &
     ist_th,ist_ph,iextend,zmks8,zdata8,in1,in2,idimi1,idim2,idim3,ierr)

  deallocate(zdata8)

end subroutine mcgrid_putarr2_r4

subroutine xplasma_integ_work(integ_num,nth,thvec,wth, &
     nths,ths,nrhos,rhos,rhomin, &
     iavail,wk,dvdrho,bmaxa,result,ier)

  !  compute surface oriented numeric integration, e.g. flux surface 
  !  integrals and averages to yield results of form f(rho) or f(theta,rho)

  !  because certain terms (R, dR/dtheta, etc.) come up repeatedly, a
  !  caching mechanism is supported.

  use xplasma_definitions
  use eqi_intg_module
  implicit NONE

  !-----------------------------------------------------------------------
  integer, intent(in) :: integ_num   ! id of integral/average to be done

  integer, intent(in) :: nth                ! #of theta evaluations
  real*8, intent(in) :: thvec(nth)          ! theta points
  real*8, intent(in) :: wth(nth)            ! associated d(theta)*weights

  integer, intent(in) :: nths               ! #of theta zone bdys
  real*8, intent(in) :: ths(nths)           ! theta zone boundaries
  integer, intent(in) :: nrhos              ! #of rho surfaces
  real*8, intent(in) :: rhos(nrhos)         ! rho surfaces
  real*8, intent(in) :: rhomin              ! minimum safe rho for evaluation

  integer, parameter :: ifuns=10            ! #of functions in cache

  logical, intent(inout) :: iavail(ifuns)      ! cache status flags
  real*8, intent(inout) :: wk(nth,ifuns,nrhos) ! cache

  real*8, intent(in) :: dvdrho(nths-1,nrhos)   ! dV/drho at surfaces (for avgs)
  real*8, intent(inout) :: bmaxa(nrhos)        ! max(|B|) on surfaces
  !  if this is zero, and it is needed here, it will be evaluated...

  real*8, intent(out) :: result(nths-1,nrhos)  ! result of integration or avg
  integer, intent(out) :: ier         ! status code, 0=OK

  !  avg is short for "average".
  !-----------------------------------------------------------------------
  !  local...

  type (xpeval) :: th_intrp, rho_intrp

  integer :: iertmp
  logical :: lav_dvdrho,iflag10,local_eval
  integer :: id_R,id_Z,id_Bmod,id_BR,id_BZ,id_rho,id_th
  character*100 zmsg

  ! cache line codes:
  !   1-- R  2-- dR/dtheta  3-- dR/drho
  !   4-- Z  5-- dZ/dtheta  6-- dZ/drho
  !   7-- Bmod   8-- BR     9-- BZ
  !       10-- R*|det(J)| = 
  !              2*pi*R*abs((dR/drho)*(dZ/dtheta)-(dZ/drho)*(dR/dtheta))
  integer :: icad(ifuns),inca,ica,ii,ith,ithr,ieval,irhos

  integer :: inth0,indexth(nth)
  real*8 :: thdum(nth/10),rhodum(nth/10),fintdum(nth/10)
  real*8, dimension(:), allocatable :: fint, local_wk
  real*8, parameter :: c2pi = 6.2831853071795862D+00

  integer, save :: integ_count = 0  ! for debugging...
  integer, parameter :: debug_count1 = -1
  integer, parameter :: debug_count2 = -1
  integer, parameter :: ilun_dbg=6
  !-----------------------------------------------------------------------

  ier=0

  call xplasma_common_ids(sp,ier, id_R=id_R, id_Z=id_Z, &
       id_Bmod=id_Bmod, id_BR=id_BR, id_BZ=id_BZ)

  if(ier.ne.0) return

  call xplasma_prof_info(sp, id_R, ier,  gridId1=id_th, gridId2=id_rho)

  if(ier.ne.0) return

  call xplasma_integ_mkindex(nths,ths,nth,thvec,indexth)

  ! for averages at the axial singularity...
  inth0 = nth/10
  do ith=1,inth0
     thdum(ith)=(ith-1)*c2pi/inth0
     rhodum(ith)=rhomin
  enddo

  if(id_Bmod.eq.0) call xplasma_find_item(sp,"BMOD",id_Bmod,iertmp,nf_noerr=.TRUE.)
  if(id_BR.eq.0) call xplasma_find_item(sp,"BR",id_BR,iertmp,nf_noerr=.TRUE.)
  if(id_BZ.eq.0) call xplasma_find_item(sp,"BZ",id_BZ,iertmp,nf_noerr=.TRUE.)

  iflag10=.FALSE.
  local_eval=.FALSE.

  ! determine whether an integral or an average; determine what data
  ! items (R,Z, derivatives of R,Z, mod(B), B components...) are needed.

  if(integ_num.eq.eqi_intg_vol) then
     lav_dvdrho=.FALSE.
     inca=3
     icad(1)=eqi_intg_r; icad(2)=eqi_intg_drdth; icad(3)=eqi_intg_z

  else if(integ_num.eq.eqi_intg_dvdrho) then
     lav_dvdrho=.FALSE.
     inca=5
     icad(1)=eqi_intg_r; icad(2)=eqi_intg_drdth; icad(3)=eqi_intg_drdrho
     icad(4)=eqi_intg_dzdth; icad(5)=eqi_intg_dzdrho
     iflag10=.TRUE.

  else if((integ_num.eq.eqi_intg_area).or.(integ_num.eq.eqi_intg_darea)) then
     lav_dvdrho=.FALSE.
     inca=2
     icad(1)=eqi_intg_drdth; icad(2)=eqi_intg_z

  else if(integ_num.eq.eqi_intg_r2i) then
     lav_dvdrho=.TRUE.
     inca=1
     icad(1)=eqi_intg_r

  else if(integ_num.eq.eqi_intg_itor) then
     lav_dvdrho=.FALSE.
     inca=4
     icad(1)=eqi_intg_drdth; icad(2)=eqi_intg_dzdth
     icad(3)=eqi_intg_br; icad(4)=eqi_intg_bz

  else if(integ_num.eq.eqi_intg_lpol) then
     lav_dvdrho=.FALSE.
     inca=2
     icad(1)=eqi_intg_drdth; icad(2)=eqi_intg_dzdth

  else if(integ_num.eq.eqi_intg_surf) then
     lav_dvdrho=.FALSE.
     inca=3
     icad(1)=eqi_intg_r; icad(2)=eqi_intg_drdth; icad(3)=eqi_intg_dzdth

  else if(integ_num.eq.eqi_intg_booz_qovg) then
     lav_dvdrho=.FALSE.
     inca=5
     icad(1)=eqi_intg_r; icad(2)=eqi_intg_drdth; icad(3)=eqi_intg_dzdth
     icad(4)=eqi_intg_br; icad(5)=eqi_intg_bz

  else if(integ_num.eq.eqi_intg_g2r2i) then
     lav_dvdrho=.TRUE.
     inca=5
     icad(1)=eqi_intg_r; icad(2)=eqi_intg_drdth; icad(3)=eqi_intg_drdrho
     icad(4)=eqi_intg_dzdth; icad(5)=eqi_intg_dzdrho

  else if(integ_num.eq.eqi_intg_ri) then
     lav_dvdrho=.TRUE.
     inca=1
     icad(1)=eqi_intg_r

  else if(integ_num.eq.eqi_intg_r3i) then
     lav_dvdrho=.TRUE.
     inca=1
     icad(1)=eqi_intg_r

  else if(integ_num.eq.eqi_intg_r2) then
     lav_dvdrho=.TRUE.
     inca=1
     icad(1)=eqi_intg_r

  else if(integ_num.eq.eqi_intg_r1) then
     lav_dvdrho=.TRUE.
     inca=1
     icad(1)=eqi_intg_r

  else if(integ_num.eq.eqi_intg_br2) then
     lav_dvdrho=.TRUE.
     inca=2
     icad(1)=eqi_intg_r
     icad(2)=eqi_intg_modb

  else if(integ_num.eq.eqi_intg_bi) then
     lav_dvdrho=.TRUE.
     inca=1
     icad(1)=eqi_intg_modb

  else if(integ_num.eq.eqi_intg_b2i) then
     lav_dvdrho=.TRUE.
     inca=1
     icad(1)=eqi_intg_modb

  else if(integ_num.eq.eqi_intg_b2) then
     lav_dvdrho=.TRUE.
     inca=1
     icad(1)=eqi_intg_modb

  else if(integ_num.eq.eqi_intg_b1) then
     lav_dvdrho=.TRUE.
     inca=1
     icad(1)=eqi_intg_modb

  else if(integ_num.eq.eqi_intg_bz2) then
     lav_dvdrho=.TRUE.
     inca=1
     icad(1)=eqi_intg_bz

  else if(integ_num.eq.eqi_intg_g2b2i) then
     lav_dvdrho=.TRUE.
     inca=5
     icad(1)=eqi_intg_drdth; icad(2)=eqi_intg_drdrho
     icad(3)=eqi_intg_dzdth; icad(4)=eqi_intg_dzdrho
     icad(5)=eqi_intg_modb

  else if(integ_num.eq.eqi_intg_g1) then
     lav_dvdrho=.TRUE.
     inca=4
     icad(1)=eqi_intg_drdth; icad(2)=eqi_intg_drdrho
     icad(3)=eqi_intg_dzdth; icad(4)=eqi_intg_dzdrho

  else if(integ_num.eq.eqi_intg_g2) then
     lav_dvdrho=.TRUE.
     inca=4
     icad(1)=eqi_intg_drdth; icad(2)=eqi_intg_drdrho
     icad(3)=eqi_intg_dzdth; icad(4)=eqi_intg_dzdrho

  else if(integ_num.eq.eqi_intg_g2r3i) then
     lav_dvdrho=.TRUE.
     inca=5
     icad(1)=eqi_intg_r; icad(2)=eqi_intg_drdth; icad(3)=eqi_intg_drdrho
     icad(4)=eqi_intg_dzdth; icad(5)=eqi_intg_dzdrho

  else if(integ_num.eq.eqi_intg_g2r2) then
     lav_dvdrho=.TRUE.
     inca=5
     icad(1)=eqi_intg_r; icad(2)=eqi_intg_drdth; icad(3)=eqi_intg_drdrho
     icad(4)=eqi_intg_dzdth; icad(5)=eqi_intg_dzdrho

  else if(integ_num.eq.eqi_intg_giri) then
     lav_dvdrho=.TRUE.
     inca=5
     icad(1)=eqi_intg_r; icad(2)=eqi_intg_drdth; icad(3)=eqi_intg_drdrho
     icad(4)=eqi_intg_dzdth; icad(5)=eqi_intg_dzdrho

  else if(integ_num.eq.eqi_intg_fhnclass) then
     lav_dvdrho=.TRUE.
     inca=1
     icad(1)=eqi_intg_modb

  else if(integ_num.eq.eqi_intg_fhnc_tsc) then
     lav_dvdrho=.TRUE.
     inca=1
     icad(1)=eqi_intg_modb

  else if(integ_num.eq.eqi_intg_fhmmx) then
     lav_dvdrho=.TRUE.
     inca=1
     icad(1)=eqi_intg_modb

  else if((integ_num.gt.eqi_intg_bign).and. &
       (integ_num.le.2*eqi_intg_bign)) then

     ! user defined average

     lav_dvdrho=.TRUE.
     inca=0
     local_eval=.TRUE.

  else if(integ_num.gt.2*eqi_intg_bign) then

     ! user defined integral

     lav_dvdrho=.FALSE.
     inca=0
     local_eval=.TRUE.

  else
     
     ier=611
     zmsg=' '
     write(zmsg,*) '   Passed integration code unrecognized in xplasma_integ_work: ',integ_num
     call xplasma_errmsg_append(sp,zmsg)
     return
  endif

  if(lav_dvdrho.and.(.not.iavail(10))) then
     ier=611
     call xplasma_errmsg_append(sp, &
         ' logic error in xplasma_integ_work: dVdrho integrand not available.')
     return
  endif

  allocate(fint(nth),local_wk(nth))

  ieval=0
  do ii=1,inca
     ica=icad(ii)
     if(.not.iavail(ica)) then
        ieval=ieval+1
     endif
  enddo

  if(local_eval.or.(ieval.gt.0)) then
     !  do theta lookups now -- these do not vary with (rho)

     call xplasma_x_lookup(sp, id_th, thvec, th_intrp, ier)
     if(ier.ne.0) then
        call xpeval_free(th_intrp)
        return
     endif
     
  endif

  do irhos=1,nrhos

     integ_count = integ_count + 1

     if(integ_count.eq.debug_count1) then
        write(ilun_dbg,*) ' reached debug_count1!'
     endif

     if(integ_count.eq.debug_count2) then
        write(ilun_dbg,*) ' reached debug_count2!'
     endif

     if(iflag10.and.iavail(10)) then
        continue                     ! needed data already in hand...

     else

        if(local_eval.or.(ieval.gt.0)) then
           call xplasma_x_lookup(sp, id_rho, rhos(irhos), rho_intrp, ier)
           if(ier.ne.0) then
              call xpeval_free(rho_intrp)
              call xpeval_free(th_intrp)
              return
           endif
        endif

        if(ieval.gt.0) then
           do ii=1,inca
              ica=icad(ii)
              if(iavail(ica)) cycle

              if(rhos(irhos).le.rhomin) then
                 call xplasma_integ_wk1(ica,id_R,id_Z,id_Bmod,id_BR,id_BZ, &
                      inth0,thdum,rhodum,wk(1,ica,irhos),ier)
              else
                 call xplasma_integ_wk2(ica,id_R,id_Z,id_Bmod,id_BR,id_BZ, &
                      nth,th_intrp,rho_intrp,wk(1,ica,irhos),ier)
              endif
              if(ier.ne.0) exit
           enddo
        endif
        if(ier.ne.0) exit

        if(local_eval) then
           if((rhos(irhos).le.rhomin).and.lav_dvdrho) then
              call xplasma_integ_wk1(integ_num,id_R,id_Z,id_Bmod,id_BR,id_BZ, &
                   inth0,thdum,rhodum,local_wk,ier)
           else
              call xplasma_integ_wk2(integ_num,id_R,id_Z,id_Bmod,id_BR,id_BZ, &
                   nth,th_intrp,rho_intrp,local_wk,ier)
           endif
        endif
        if(ier.ne.0) exit

        result(1:nths-1,irhos)=0

        if(rhos(irhos).le.rhomin) then
           if(lav_dvdrho) then
              wk(1:inth0,10,irhos)=1 ! even weighting vs. theta
              call xplasma_integ_fwkdv(integ_num,inth0,nth,wk(1,1,irhos), &
                   local_wk,bmaxa(irhos),fintdum,ier)
              result(1:nths-1,irhos)=sum(fintdum)/inth0 ! avg axial value of
           else

           !  result stays zero for integrals (not averages) @rho=rhomin
           !  exception: 

              if(local_eval) then
                 call xplasma_integ_fwk(integ_num,nth,wk(1,1,irhos),local_wk, &
                      fint,ier)

                 do ith=1,nth
                    ithr=indexth(ith)
                    result(ithr,irhos)=result(ithr,irhos)+fint(ith)*wth(ith)
                 enddo
              endif

           endif

        else
           if(lav_dvdrho) then
              call xplasma_integ_fwkdv(integ_num,nth,nth,wk(1,1,irhos), &
                   local_wk,bmaxa(irhos),fint,ier)
           else
              call xplasma_integ_fwk(integ_num,nth,wk(1,1,irhos),local_wk, &
                   fint,ier)

              if(iflag10) then
                 wk(1:nth,10,irhos) = fint
              endif

           endif

           do ith=1,nth
              ithr=indexth(ith)
              result(ithr,irhos)=result(ithr,irhos)+fint(ith)*wth(ith)
           enddo

           if(lav_dvdrho) then
              do ithr=1,nths-1
                 result(ithr,irhos)=result(ithr,irhos)/dvdrho(ithr,irhos)
              enddo
           endif
        endif
     endif
     if(ier.ne.0) exit

  enddo

  if((ieval.gt.0).and.(ier.eq.0)) then
     do ii=1,inca
        ica=icad(ii)
        iavail(ica)=.TRUE.
     enddo
  endif

  if(iflag10.and.(ier.eq.0)) then
     iavail(10)=.TRUE.
  endif

  deallocate(fint,local_wk)

  call xpeval_free(rho_intrp)
  call xpeval_free(th_intrp)

end subroutine xplasma_integ_work

subroutine xplasma_integ_gwork(inum,inthbdys,thbdys, &
     inrhos,rhos,infine,rhofine,wrhof,indexs,th_result,result,ier)

  ! complete Guass-integration of collection of 2d zones' volumes or
  ! cross sectional areas

  use xplasma_definitions
  use eqi_intg_module
  implicit NONE

  !-----------------------------------------------------------------------

  integer, intent(in) :: inum      ! integration code number

  integer, intent(in) :: inthbdys  ! theta boundaries of zones
  real*8, intent(in) :: thbdys(inthbdys)

  integer, intent(in) :: inrhos    ! rho boundaries of zones
  real*8, intent(in) :: rhos(inrhos)

  integer, intent(in) :: infine    ! rho integration grid, weights, rhos index
  real*8, intent(in) :: rhofine(infine)
  real*8, intent(in) :: wrhof(infine)
  integer, intent(in) ::  indexs(infine)

  !  result of partial integration in theta direction
  real*8, intent(in) :: th_result(inthbdys-1,inrhos)

  !  completed result
  real*8, intent(out) :: result(inthbdys-1,inrhos-1)

  integer, intent(out) :: ier           ! completion code,  0=OK

  !---------------------
  real*8, dimension(:,:), allocatable :: zwk
  real*8, dimension(:), allocatable :: rr,zz,drdrho
  integer :: irho,ii,ith,id_R,id_Z,id_th,id_rho
  real*8 :: zincr

  type (xpeval) :: th_intrp, rho_intrp
  real*8, parameter :: c2pi = 6.2831853071795862D+00
  !---------------------
  
  ier=0

  call xplasma_common_ids(sp,ier, id_R=id_R, id_Z=id_Z)
  if(ier.ne.0) return

  call xplasma_prof_info(sp, id_R, ier,  gridId1=id_th, gridId2=id_rho)

  if((inum.ne.eqi_intg_darea).and.(inum.ne.eqi_intg_dvol)) then
     ier=9999
     call xplasma_errmsg_append(sp, ' xplasma_integ_gwork detected error:')
     call xplasma_errmsg_append(sp, ' dArea or dVol not being computed.')
     return
  endif

  allocate(zwk(inthbdys,inrhos-1),rr(infine),zz(infine),drdrho(infine))

  ! one rho lookup for all evaluations...

  call xplasma_x_lookup(sp, id_rho, rhofine, rho_intrp, ier)
  if(ier.ne.0) then
     call xpeval_free(rho_intrp)
     return
  endif

  do ith=1,inthbdys-1

     call xplasma_x_lookup(sp, id_th, thbdys(ith), th_intrp, ier)
     if(ier.ne.0) exit

     if(inum.ne.eqi_intg_darea) then
        call xplasma_eval_prof(sp,id_R, th_intrp, rho_intrp, rr, ier)
        if(ier.ne.0) exit
     endif

     call xplasma_eval_prof(sp,id_R, th_intrp, rho_intrp, drdrho, ier, &
          ideriv2=1)  ! dR/drho
     if(ier.ne.0) exit

     call xplasma_eval_prof(sp,id_Z, th_intrp, rho_intrp, zz, ier)
     if(ier.ne.0) exit

     zwk(ith,1:inrhos-1)=0
     do ii=1,infine
        if(inum.eq.eqi_intg_darea) then
           ! dArea contribution
           zincr = zz(ii)*drdrho(ii)*wrhof(ii)

        else if(inum.eq.eqi_intg_dvol) then
           ! dVol contribution
           zincr = c2pi*rr(ii)*zz(ii)*drdrho(ii)*wrhof(ii)
        endif

        irho=indexs(ii)
        zwk(ith,irho)=zwk(ith,irho)+zincr
     enddo

     if(ith.eq.1) then
        zwk(inthbdys,1:inrhos-1)=zwk(1,1:inrhos-1)
     endif
  enddo

  if(ier.eq.0) then
     do irho=1,inrhos-1
        do ith=1,inthbdys-1
           result(ith,irho)= &
                th_result(ith,irho+1) - th_result(ith,irho) +&
                zwk(ith+1,irho) - zwk(ith,irho)
        enddo
     enddo

  else
     result = 0
  endif

  deallocate(zwk,rr,zz,drdrho)

  call xpeval_free(rho_intrp)
  call xpeval_free(th_intrp)

end subroutine xplasma_integ_gwork

subroutine xplasma_integ_g10info(x5,w5)

  ! return normalized displacements and weights for 10 point Gauss
  ! non-adaptive integration evaluation

  implicit NONE

  real*8, intent(out) :: x5(5),w5(5)

  !----------------
  real*8 :: x1(5),w10(5)

  ! gauss-kronrod-patterson quadrature coefficients for use in
  ! quadpack routine qng.  these coefficients were calculated with
  ! 101 decimal digit arithmetic by l. w. fullerton, bell labs, nov 1981.

  data x1    (  1) / 0.973906528517171720077964012084452D0/
  data x1    (  2) / 0.865063366688984510732096688423493D0/
  data x1    (  3) / 0.679409568299024406234327365114874D0/
  data x1    (  4) / 0.433395394129247190799265943165784D0/
  data x1    (  5) / 0.148874338981631210884826001129720D0/

  data w10   (  1) / 0.066671344308688137593568809893332D0/
  data w10   (  2) / 0.149451349150580593145776339657697D0/
  data w10   (  3) / 0.219086362515982043995534934228163D0/
  data w10   (  4) / 0.269266719309996355091226921569469D0/
  data w10   (  5) / 0.295524224714752870173892994651338D0/
  !----------------

  x5=x1
  w5=w10

end subroutine xplasma_integ_g10info

subroutine xplasma_integ_mkvec(nxbrk,xbrk,xvec,wx)

  ! generate evaluation vector for segmented integration using 10 point Gauss
  ! formula

  ! for integrating over splines, it is best to set the breaks at the
  ! spline node points, so that each sub interval integrated over is
  ! C-infinity...

  implicit NONE

  integer, intent(in) :: nxbrk        ! no. of x breaks (zone bdys)
  real*8, intent(in) :: xbrk(nxbrk) ! x break points

  real*8, intent(out) :: xvec(10*(nxbrk-1))  ! x evaluation points
  real*8, intent(out) :: wx(10*(nxbrk-1))    ! associated d(x) weights

  !---------------------------------------
  integer :: ixzon,ixp,ii
  real*8 :: zxcen,zdx2
  real*8, parameter :: HALF = 0.5d0
  !---------------------------------------

  real*8 :: x5(5),w5(5)

  call xplasma_integ_g10info(x5,w5)

  ixp = -10
  do ixzon = 1,nxbrk-1

     ixp=ixp+10

     zxcen= (xbrk(ixzon)+xbrk(ixzon+1))*HALF
     zdx2 = (xbrk(ixzon+1)-xbrk(ixzon))*HALF

     do ii=1,5
        xvec(ixp+ii)=zxcen+x5(ii)*zdx2
        xvec(ixp+5+ii)=zxcen-x5(ii)*zdx2
        wx(ixp+ii)=w5(ii)*zdx2
        wx(ixp+5+ii)=w5(ii)*zdx2
     enddo
  enddo

end subroutine xplasma_integ_mkvec

subroutine xplasma_integ_num(integ_name,integ_num,ilsurf, &
     dvol_need,dvdrho_need,bmaxa_need)

  use xplasma_definitions
  use eqi_intg_module
  implicit NONE

  character*(*), intent(in) :: integ_name
  integer, intent(out) :: integ_num
  logical, intent(out) :: ilsurf
  logical, intent(out) :: dvol_need
  logical, intent(out) :: dvdrho_need
  logical, intent(out) :: bmaxa_need

  !  translate integral/average character string name into integer id
  !  no errors-- return 0 if unrecognized.  CALLER should put name into
  !  UPPERCASE first!

  !---------------
  integer :: ilen,idtmp,iertmp
  !---------------

  integ_num=0

  ilen=max(2, len(trim(integ_name)) )

  !  common case: <1/R^2>S vs.  <1/R^2>...
  !    also support:  <fun> <fun>S I(fun) I(fun)S which respectively
  !    denote:  zonal volume average, 
  !             flux surface differential volume average,
  !             zonal integral, 
  !             surface integral
  !    to be applied to user specified function "fun" which will be checked
  !    for eligibility.

  bmaxa_need = .FALSE.

  if(integ_name(max(1,ilen-1):ilen).eq.'>S') then
     ! flux surface differential volume average
     ilsurf=.TRUE.
     ilen=ilen-1
     dvol_need=.FALSE.
     dvdrho_need=.TRUE.

  else if(integ_name(ilen:ilen).eq.'>') then
     ! zonal volume average
     ilsurf=.FALSE.
     dvol_need=.TRUE.
     dvdrho_need=.FALSE.

  else if(integ_name(max(1,ilen-1):ilen).eq.')S') then
     ! surface integral
     ilsurf=.TRUE.
     dvol_need=.FALSE.
     dvdrho_need=.FALSE.
     ilen=ilen-1

  else if(integ_name(ilen:ilen).eq.')') then
     ! zonal integral
     ilsurf=.FALSE.
     dvol_need=.FALSE.
     dvdrho_need=.FALSE.

  endif

  !  more specific names tested here...

  if(integ_name(1:ilen).eq.'VOL') then
     integ_num=eqi_intg_vol
     dvol_need=.TRUE.
     dvdrho_need=.FALSE.
     ilsurf=.TRUE.

  else if(integ_name(1:ilen).eq.'DVOL') then
     integ_num=eqi_intg_dvol
     dvol_need=.TRUE.
     dvdrho_need=.FALSE.
     ilsurf=.TRUE.  ! dVol will be differenced from VOL...

  else if(integ_name(1:ilen).eq.'AREA') then
     integ_num=eqi_intg_area
     dvdrho_need=.FALSE.
     dvol_need=.FALSE.
     ilsurf=.TRUE.

  else if(integ_name(1:ilen).eq.'DAREA') then
     integ_num=eqi_intg_darea
     dvdrho_need=.FALSE.
     dvol_need=.FALSE.
     ilsurf=.TRUE.  ! dAREA will be differenced from AREA...

  else if(integ_name(1:ilen).eq.'DVDRHO') then
     integ_num=eqi_intg_dvdrho
     dvdrho_need=.TRUE.
     dvol_need=.FALSE.
     ilsurf=.TRUE.

  else if(integ_name(1:ilen).eq.'ITOR')  then
     integ_num=eqi_intg_itor
     dvdrho_need=.FALSE.
     dvol_need=.FALSE.
     ilsurf=.TRUE.

  else if(integ_name(1:ilen).eq.'LPOL')  then
     integ_num=eqi_intg_lpol
     dvdrho_need=.FALSE.
     dvol_need=.FALSE.
     ilsurf=.TRUE.

  else if(integ_name(1:ilen).eq.'SURF')  then
     integ_num=eqi_intg_surf
     dvdrho_need=.FALSE.
     dvol_need=.FALSE.
     ilsurf=.TRUE.

  else if(integ_name(1:ilen).eq.'BOOZER_QOVG')  then
     ! integral related to Boozer "zeta"; loop integration -> q/g
     integ_num=eqi_intg_booz_qovg
     dvdrho_need=.FALSE.
     dvol_need=.FALSE.
     ilsurf=.TRUE.

  else if(integ_name(1:ilen).eq.'<1/R^2>') then
     integ_num=eqi_intg_r2i

  else if(integ_name(1:ilen).eq.'<GRAD(RHO)^2/R^2>') then
     integ_num=eqi_intg_g2r2i

  else if(integ_name(1:ilen).eq.'<1/R>') then
     integ_num=eqi_intg_ri

  else if(integ_name(1:ilen).eq.'<1/R^3>') then
     integ_num=eqi_intg_r3i

  else if(integ_name(1:ilen).eq.'<R^2>') then
     integ_num=eqi_intg_r2

  else if(integ_name(1:ilen).eq.'<R>') then
     integ_num=eqi_intg_r1

  else if(integ_name(1:ilen).eq.'<B*R^2>') then
     integ_num=eqi_intg_br2

  else if(integ_name(1:ilen).eq.'<1/B>') then
     integ_num=eqi_intg_bi

  else if(integ_name(1:ilen).eq.'<1/B^2>') then
     integ_num=eqi_intg_b2i

  else if(integ_name(1:ilen).eq.'<B^2>') then
     integ_num=eqi_intg_b2

  else if(integ_name(1:ilen).eq.'<B>') then
     integ_num=eqi_intg_b1

  else if(integ_name(1:ilen).eq.'<BZ^2>') then
     integ_num=eqi_intg_bz2

  else if(integ_name(1:ilen).eq.'<GRAD(RHO)^2/B^2>') then
     integ_num=eqi_intg_g2b2i

  else if(integ_name(1:ilen).eq.'<GRAD(RHO)>') then
     integ_num=eqi_intg_g1

  else if(integ_name(1:ilen).eq.'<GRAD(RHO)^2>') then
     integ_num=eqi_intg_g2

  else if(integ_name(1:ilen).eq.'<GRAD(RHO)^2/R^3>') then
     integ_num=eqi_intg_g2r3i

  else if(integ_name(1:ilen).eq.'<R^2*GRAD(RHO)^2>') then
     integ_num=eqi_intg_g2r2

  else if(integ_name(1:ilen).eq.'<1/(R*GRAD(RHO))>') then
     integ_num=eqi_intg_giri

  else if(integ_name(1:ilen).eq.'<F(H)NCLASS>') then
     bmaxa_need=.TRUE.
     integ_num = eqi_intg_fhnclass

  else if(integ_name(1:ilen).eq.'<F(H)NC_TSC>') then
     bmaxa_need=.TRUE.
     integ_num = eqi_intg_fhnc_tsc

  else if(integ_name(1:ilen).eq.'<SQRT(1-B/BMAX)>') then
     bmaxa_need=.TRUE.
     integ_num = eqi_intg_fhmmx

  else

     if((integ_name(1:1).eq.'<').and.(integ_name(ilen:ilen).eq.'>')) then
        idtmp=0
        if(ilen.gt.2) then
           !  see if item inside brackets is a known "integrable" profile
           !  for now, this means f(rho,theta) or f(theta,rho).

           call xplasma_integ_eligible(sp,integ_name(2:ilen-1),idtmp,iertmp)

        endif
        if(idtmp.eq.0) then
           call xplasma_errmsg_append(sp, &
                'cannot flux surface average '//trim(integ_name)// &
                ' -- not a profile.')
        else
           integ_num=eqi_intg_bign + idtmp
        endif

     else if((integ_name(1:2).eq.'I(').and.(integ_name(ilen:ilen).eq.')')) then
        idtmp=0
        if(ilen.gt.3) then
           !  see if item inside brackets is a known "integrable" profile
           !  for now, this means f(rho,theta) or f(theta,rho).

           call xplasma_integ_eligible(sp,integ_name(3:ilen-1),idtmp,iertmp)

        endif
        if(idtmp.eq.0) then
           call xplasma_errmsg_append(sp, &
                'cannot integrate '//trim(integ_name)// &
                ' -- not a profile.')
        else
           integ_num=2*eqi_intg_bign + idtmp
        endif

     endif

  endif

end subroutine xplasma_integ_num

subroutine xplasma_integ_mkindex(insurfs,rhos,infine,rhof,indexb)
  ! create index vector to point from fine grid to coarse grid
  ! (integration grid -> results grid)

  ! written here as if grid is "rho"; it could be "theta"...

  integer, intent(in) :: insurfs
  real*8, intent(in) :: rhos(insurfs)  ! coarse results grid

  integer, intent(in) :: infine
  real*8, intent(in) :: rhof(infine)   ! fine grid
  integer, intent(out) :: indexb(infine) ! indexing out

  !-----------------------
  integer :: i, cur_index
  !-----------------------

  cur_index=1

  do i=1,infine
     if(rhof(i).gt.rhos(cur_index+1)) cur_index = cur_index + 1

     indexb(i) = cur_index

  enddo
end subroutine xplasma_integ_mkindex

subroutine eq_save(filename,ier)
 
  !  f77 interface -- save xplasma to file

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  character*(*), intent(in) :: filename
  integer, intent(out) :: ier

  call xplasma_write(s,filename,ier)
  if(ier.ne.0) then

     call xplasma_error(s,ier,lunerr)

  endif

end subroutine eq_save

module xplasma_rzgeo

  !  methods for defining flux surface geometry -- 2d axisymmetric tokamak

  use xplasma_obj
  use xplasma_ctran
  use xplasma_flxint, only: xplasma_rho_zonint, xplasma_2d_zonint
  use xplasma_sol, only: xplasma_limcheck,xplasma_lim_RZminmax
  implicit NONE

  private

  public :: xplasma_rzmagf,xplasma_rzmag
  public :: xplasma_jacheck,xplasma_eqClear,xplasma_eqcheck
  public :: xplasma_gen_q,xplasma_gen_p,xplasma_gen_torflx
  public :: xplasma_gen_boozer
  public :: xplasma_volume,xplasma_vol1,xplasma_voln
  public :: xplasma_area,xplasma_area1,xplasma_arean
  public :: xplasma_create_RZgrid
  public :: xplasma_max_maptype
  public :: xplasma_surfgeo

  interface xplasma_volume
     module procedure xplasma_vol1
     module procedure xplasma_voln
  end interface

  interface xplasma_area
     module procedure xplasma_area1
     module procedure xplasma_arean
  end interface

  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: THREE= 3.0d0
  real*8, parameter :: C2PI = 6.2831853071795862D+00

  contains

    !=======================================================================
    subroutine xplasma_rzmagf(s,rzmapper,id_rho,id_theta,id_R,id_Z,ierr, &
         zdiff)

      !  ** public **

      !  create 2d functions R(rho,chi), Z(rho,chi)
      !  using passed external routine "rzmapper"
      !  rzmapper is a dummy argument for a subroutine which MUST have the
      !  following interface:

      !      subroutine rzmapper(rho,chi,R,Z,ierr)

      !      real*8 rho,chi      ! INPUT (rho,chi) - radial, poloid coordinates
      !      real*8 R,Z          ! OUTPUT R(rho,chi), Z(rho,chi)
      !      integer IERR        ! OUTPUT completion code, 0=OK
      !
      !-------------------------------
      !  arguments

      type (xplasma), pointer :: s      ! object, state modified by this call

      ! input:
      external rzmapper                 ! passed subroutine, as described

      integer, intent(in) :: id_rho     ! rho grid id
      integer, intent(in) :: id_theta   ! theta grid id

      ! output:
      integer, intent(out) :: id_R      ! id for R spline
      integer, intent(out) :: id_Z      ! id for Z spline
      integer, intent(out) :: IERR      ! completion code, 0=OK
  
      ! OPTIONAL input (default=1.0d-3)

      real*8, intent(in), optional :: zdiff  ! finite difference factor for 
      ! boundary condition calculation-- use fraction zdiff of the 1st/last
      ! rho grid zone in evaluating dR/drho and dZ/drho finite difference
      ! formulae for first derivative boundary conditions

      !--------------------------
      !  local

      integer :: irho,ith,nrho,nth,ibc

      real*8, dimension(:), allocatable :: zrho,zth
      real*8, dimension(:,:), allocatable :: R,Z
      real*8, dimension(:), allocatable :: Rbc0,Rbc1,Zbc0,Zbc1

      real*8 R0sum,Z0sum,zdiffi,zrho0x,zrho1x,zdrho0,zdrho1

      real*8, parameter :: ONE = 1.0d0
      real*8, parameter :: EPS4 = 1.0d-4
      !--------------------------

      id_R=0
      id_Z=0
      ierr=0

      if(present(zdiff)) then
         zdiffi=min(ONE,max(EPS4,zdiff))
      else
         zdiffi=1.0d-3
      endif

      R0sum=ZERO
      Z0sum=ZERO

      call xplasma_grid_size(s,id_rho,nrho,ierr)
      if(ierr.ne.0) return

      call xplasma_grid_size(s,id_theta,nth,ierr)
      if(ierr.ne.0) return

      allocate(zrho(nrho),zth(nth),R(nrho,nth),Z(nrho,nth))
      allocate(Rbc0(nth),Rbc1(nth),Zbc0(nth),Zbc1(nth))

      do
         call xplasma_grid(s,id_rho,zrho,ierr)
         if(ierr.ne.0) exit

         zdrho0=zdiffi*(zrho(2)-zrho(1))
         zrho0x=zrho(1)+zdrho0

         zdrho1=zdiffi*(zrho(nrho)-zrho(nrho-1))
         zrho1x=zrho(nrho)-zdrho1

         call xplasma_grid(s,id_theta,zth,ierr)
         if(ierr.ne.0) exit

         do ith=1,nth

            call rzmapper(zrho0x,zth(ith),Rbc0(ith),Zbc0(ith),ierr)
            if(ierr.ne.0) exit

            call rzmapper(zrho1x,zth(ith),Rbc1(ith),Zbc1(ith),ierr)
            if(ierr.ne.0) exit

            do irho=1,nrho

               call rzmapper(zrho(irho),zth(ith),R(irho,ith),Z(irho,ith),ierr)
               if(ierr.ne.0) exit

               if(irho.eq.1) then
                  R0sum=R0sum+R(irho,ith)
                  Z0sum=Z0sum+Z(irho,ith)
               endif
            enddo
            if(ierr.ne.0) exit
         enddo
         if(ierr.ne.0) exit

         !  eval finite difference BC derivative estimates

         do ith=1,nth
            Rbc0(ith)=(Rbc0(ith)-R(1,ith))/zdrho0
            Zbc0(ith)=(Zbc0(ith)-Z(1,ith))/zdrho0

            Rbc1(ith)=(R(nrho,ith)-Rbc1(ith))/zdrho1
            Zbc1(ith)=(Z(nrho,ith)-Zbc1(ith))/zdrho1
         enddo

         !  force axis to be exactly fixed vs. chi

         R0sum=R0sum/nth
         Z0sum=Z0sum/nth

         R(1,1:nth)=R0sum
         Z(1,1:nth)=Z0sum

         ibc=1
         call xplasma_rzmag(s,id_rho,id_theta,R,Z,id_R,id_Z,ierr, &
              ibc,Rbc0,Zbc0, ibc,Rbc1,Zbc1)

         exit
      enddo

      if(ierr.ne.0) then
         call xplasma_errmsg_append(s,' error in xplasma_rzmagf')
         deallocate(zrho,zth,R,Z,Rbc0,Rbc1,Zbc0,Zbc1)
      endif

    end subroutine xplasma_rzmagf

    !=======================================================================
    subroutine xplasma_rzmag(s,idx1,idx2,R,Z,id_R,id_Z,ierr, &
              ibc0,Rbc0,Zbc0, ibc1,Rbc1,Zbc1, lhermite, &
              Rderivs, Zderivs)

      !  ** public **

      !  create 2d functions R(x,theta) and Z(x,theta) from data arrays
      !  provided, with optional boundary condition specifications

      !  NOTE: xplasma stores {R,Z} data internally against a poloidal angle
      !  coordinate which increases in the counter-clockwise direction.  IF
      !  {R,Z} data is given with a clockwise orientation, the theta grid
      !  (identified with idx1 or idx2) has to have been defined to xplasma
      !  as having a clockwise orientation as well, for results to be correct.

      !  This code checks the data orientation, but it cannot re-check the 
      !  original theta grid.  NB if theta is evenly spaced, there will
      !  be no error.

      !-------------------------------
      !  arguments

      type (xplasma), pointer :: s      ! object, state modified by this call

      integer, intent(in) :: idx1       ! grid id of 1st dimension of data
      integer, intent(in) :: idx2       ! grid id of 2nd dimension of data

      real*8, intent(in), dimension(:,:) :: R,Z ! R(x,theta) & Z(x,theta)
      !  OR R(theta,x), z(theta,x) -- sized to match specified grids

      ! output:
      integer, intent(out) :: id_R      ! id for R spline
      integer, intent(out) :: id_Z      ! id for Z spline
      integer, intent(out) :: IERR      ! completion code, 0=OK
  
      ! OPTIONAL input

      integer, intent(in), optional :: ibc0  ! boundary condition control
      !  for R & Z at x=rho=0
      !  ibc0=0: default "not a knot" (Rbc0 & Zbc0 not used)
      !  ibc0=1: 1st derivative BC: Rbc0(j) = dR/dx @ x=0,theta=theta(j)
      !          j refers to jth point in theta grid (id_theta)
      !  ibc0=2: 2nd derivative BC: Zbc0(k) = d2Z/dx2 @ x=0, theta=theta(k)
      !          k refers to kth point in theta grid (id_theta)

      real*8, intent(in), dimension(:), optional :: Rbc0,Zbc0  ! BC data
      
      integer, intent(in), optional :: ibc1  ! boundary condition control
      !  for R & Z at x=rho=1
      !  ibc1=0: default "not a knot" (Rbc1 & Zbc1 not used)
      !  ibc1=1: 1st derivative BC: Rbc1(j) = dR/dx @ x=1,theta=theta(j)
      !          j refers to jth point in theta grid (id_theta)
      !  ibc1=2: 2nd derivative BC: Zbc1(k) = d2Z/dx2 @ x=1, theta=theta(k)
      !          k refers to kth point in theta grid (id_theta)

      real*8, intent(in), dimension(:), optional :: Rbc1,Zbc1  ! BC data

      ! OPTION: convert representation to Hermite when done...

      logical, intent(in), optional :: lhermite

      ! OPTIONAL input -- Hermite derivatives at nodal points
      !   Rderivs(1,:,:) d/dx1 (ref idx1)
      !   Rderivs(2,:,:) d/dx2 (ref idx2)
      !   Rderivs(3,:,:) d2/dx1dx2
      !     ...similarly for Zderivs

      ! if one of these is present BOTH must be present
      ! if these are present, BC data must NOT be present

      real*8, intent(in), dimension(:,:,:), optional :: Rderivs,Zderivs

      !---------------------------------------------------
      !  local: 
      integer :: jbc0,jbc1
      real*8, dimension(:), allocatable :: zRbc0,zRbc1,zZbc0,zZbc1
      real*8, dimension(:), allocatable :: rbdy,zbdy,atan00
      real*8, dimension(:,:), allocatable :: ruse,zuse,dist0,atan0
      real*8, dimension(:,:,:), allocatable :: rdduse,zdduse
      integer :: i,inrho,inchi,iertmp,ichi,irho,icount,isign,idiff
      integer :: id_rho,id_chi,icoord,isw_rho,idtmp,ishift
      integer :: ichk_derivs,ichk_bc
      real*8 :: ccwsum,dra,drb,dza,dzb,R0,Z0,raxis,zaxis,zdra,zdza,zatan
      real*8 :: thmin
      logical :: ccwflag,khermite
      real*8, parameter :: CZERO = 0.0d0
      real*8, parameter :: C2PI  = 6.2831853071795862D+00
      character*120 atan00_label,zmsg
      character*32 zname
      !---------------------------------------------------

      ierr=0
      id_R=0
      id_Z=0

      ichk_bc=0
      ichk_derivs=0

      if(present(ibc0)) ichk_bc=ichk_bc + 1
      if(present(ibc1)) ichk_bc=ichk_bc + 1

      if(present(rbc0)) ichk_bc=ichk_bc + 1
      if(present(zbc0)) ichk_bc=ichk_bc + 1

      if(present(rbc1)) ichk_bc=ichk_bc + 1
      if(present(zbc1)) ichk_bc=ichk_bc + 1

      if(present(Rderivs)) ichk_derivs=ichk_derivs + 1
      if(present(Zderivs)) ichk_derivs=ichk_derivs + 1

      ierr = 0
      if((ichk_bc.gt.0).and.(ichk_derivs.gt.0)) then
         ierr = 2001
         call xplasma_errmsg_append(s, &
              ' ?(R,Z) boundary condition data and nodal derivative data cannot BOTH be present!')
      endif

      if(ichk_derivs.eq.1) then
         ierr = 2001
         call xplasma_errmsg_append(s, &
              ' ?If nodal derivative data is provided for either R or Z it must be provide for BOTH!')
      endif

      khermite=.FALSE.
      if(present(lhermite)) khermite=lhermite

      if(ierr.ne.0) return

      do
         id_rho=0
         id_chi=0

         !  check grids; find which one is rho

         call xplasma_grid_info(s,idx1,ierr, coord=icoord); if(ierr.ne.0) exit

         if(icoord.eq.xplasma_rho_coord) then
            id_rho=idx1
            isw_rho=1
         else if(icoord.eq.xplasma_theta_coord) then
            id_chi=idx1
            isw_rho=2
         endif

         call xplasma_grid_info(s,idx2,ierr, coord=icoord); if(ierr.ne.0) exit

         if(icoord.eq.xplasma_rho_coord) then
            id_rho=idx2
         else if(icoord.eq.xplasma_theta_coord) then
            id_chi=idx2
         endif

         if((id_rho.eq.0).or.(id_chi.eq.0)) then
            ierr=2001
            call xplasma_errmsg_append(s, &
                 ' ?both theta and rho grid identifiers are required.')
            exit
         endif

         call xplasma_grid_info(s,id_chi,ierr, xmin=thmin)

         jbc0=0
         if(present(ibc0)) jbc0=ibc0

         jbc1=0
         if(present(ibc1)) jbc1=ibc1

         call xplasma_grid_size(s,id_rho,inrho,ierr)
         if(ierr.ne.0) exit

         call xplasma_grid_size(s,id_chi,inchi,ierr)
         if(ierr.ne.0) exit

         !-------------------------------
         !  for backwards compatibility:  if grid names are not __RHO,__CHI
         !  create copies with these names...

         call xplasma_grid_info(s,id_rho,ierr, name=zname)
         if(ierr.ne.0) exit
         if(zname.ne.'__RHO') call gcopy(id_rho,inrho,'__RHO')
         if(ierr.ne.0) exit

         call xplasma_grid_info(s,id_chi,ierr, name=zname)
         if(ierr.ne.0) exit
         if(zname.ne.'__CHI') call gcopy(id_chi,inchi,'__CHI')
         if(ierr.ne.0) exit

         !-------------------------------
         if(isw_rho.eq.1) then
            if((size(R,1).ne.inrho).or.(size(R,2).ne.inchi)) then
               ierr=ierr+1
               call xplasma_errmsg_append(s, &
                    ' ?R data dimensions inconsistent with grids given.')
            endif
            if((size(Z,1).ne.inrho).or.(size(Z,2).ne.inchi)) then
               ierr=ierr+1
               call xplasma_errmsg_append(s, &
                    ' ?Z data dimensions inconsistent with grids given.')
            endif
            if(ichk_derivs.gt.0) then
               if((size(Rderivs,2).ne.inrho).or.(size(Rderivs,3).ne.inchi)) then
                  ierr=ierr+1
                  call xplasma_errmsg_append(s, &
                       ' ?Rderivs data dimensions inconsistent with grids given.')
               endif
               if((size(Zderivs,2).ne.inrho).or.(size(Zderivs,3).ne.inchi)) then
                  ierr=ierr+1
                  call xplasma_errmsg_append(s, &
                       ' ?Zderivs data dimensions inconsistent with grids given.')
               endif
               if((size(Rderivs,1).ne.3).or.(size(Zderivs,1).ne.3)) then
                  ierr=ierr+1
                  call xplasma_errmsg_append(s, &
                       ' ?1st dimension size of Rderivs & Zderivs should = 3.')
               endif
            endif
         else
            if((size(R,2).ne.inrho).or.(size(R,1).ne.inchi)) then
               ierr=ierr+1
               call xplasma_errmsg_append(s, &
                    ' ?R data dimensions inconsistent with grids given.')
            endif
            if((size(Z,2).ne.inrho).or.(size(Z,1).ne.inchi)) then
               ierr=ierr+1
               call xplasma_errmsg_append(s, &
                    ' ?Z data dimensions inconsistent with grids given.')
            endif
            if(ichk_derivs.gt.0) then
               if((size(Rderivs,3).ne.inrho).or.(size(Rderivs,2).ne.inchi)) then
                  ierr=ierr+1
                  call xplasma_errmsg_append(s, &
                       ' ?Rderivs data dimensions inconsistent with grids given.')
               endif
               if((size(Zderivs,3).ne.inrho).or.(size(Zderivs,2).ne.inchi)) then
                  ierr=ierr+1
                  call xplasma_errmsg_append(s, &
                       ' ?Zderivs data dimensions inconsistent with grids given.')
               endif
               if((size(Rderivs,1).ne.3).or.(size(Zderivs,1).ne.3)) then
                  ierr=ierr+1
                  call xplasma_errmsg_append(s, &
                       ' ?1st dimension size of Rderivs & Zderivs should = 3.')
               endif
            endif
         endif
         if(ierr.ne.0) then
            ierr=2001
            exit
         endif

         if(ichk_derivs.eq.0) then
            allocate(zRbc0(inchi),zZbc0(inchi),zRbc1(inchi),zZbc1(inchi))
            zRbc0=0; zRbc1=0; zZbc0=0; zZbc1=0

            iertmp=0

            if(present(Rbc0)) call bchk('R @ x=0',Rbc0,zRbc0,ierr)
            iertmp=max(iertmp,ierr)

            if(present(Rbc1)) call bchk('R @ x=1',Rbc1,zRbc1,ierr)
            iertmp=max(iertmp,ierr)

            if(present(Zbc0)) call bchk('Z @ x=0',Zbc0,zZbc0,ierr)
            iertmp=max(iertmp,ierr)

            if(present(Zbc1)) call bchk('Z @ x=1',Zbc1,zZbc1,ierr)
            iertmp=max(iertmp,ierr)

            ierr=iertmp
            if(ierr.ne.0) exit
         endif

         !---------------------------------------
         !  OK, determine theta orientation by examining outer bdy.  Does 
         !   increasing theta trace out the boundary counter-clockwise or 
         !   clockwise?

         allocate(rbdy(inchi),zbdy(inchi))
         if(isw_rho.eq.1) then
            rbdy=r(inrho,1:inchi)
            zbdy=z(inrho,1:inchi)
         else
            rbdy=r(1:inchi,inrho)
            zbdy=z(1:inchi,inrho)
         endif

         R0 = sum(rbdy)/inchi
         Z0 = sum(zbdy)/inchi

         ccwsum = 0
         do i = 1,inchi-1
            dra=Rbdy(i)-R0
            dza=Zbdy(i)-Z0
            drb=Rbdy(i+1)-Rbdy(i)
            dzb=Zbdy(i+1)-Zbdy(i)
            ccwsum = ccwsum - dza*drb + dra*dzb
         enddo

         deallocate(rbdy,zbdy)

         if(ccwsum.gt.CZERO) then

            !  normal orientation:  CCW
            ccwflag = .TRUE.
            isign=1

         else if(ccwsum.lt.CZERO) then

            !  reversed orientation:  CW
            ccwflag = .FALSE.
            isign=-1

         else
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_rzgeo: CW/CCW orientation determination failed.')
            call xplasma_errmsg_append(s, &
                 '  is the data all ZERO?')
            ierr=2001
         endif
         if(ierr.ne.0) exit

         ! OK -- proceed...
         ! delete {R,Z} and derived items...

         call xplasma_eqClear(s,.TRUE.,iertmp)

         !  create the {R,Z} splines... set BC on right dimension...

         iertmp = 0

         allocate(ruse(inchi,inrho),zuse(inchi,inrho))
         allocate(dist0(inchi,inrho),atan0(inchi,inrho),atan00(inrho))
         if(ichk_derivs.gt.0) then
            allocate(rdduse(3,inchi,inrho),zdduse(3,inchi,inrho))
         endif

         if(isw_rho.eq.1) then

            do ichi=1,inchi
               do irho=1,inrho
                  ruse(ichi,irho)=r(irho,ichi)
                  zuse(ichi,irho)=z(irho,ichi)
                  if(ichk_derivs.gt.0) then
                     rdduse(2,ichi,irho)=Rderivs(1,irho,ichi) ! note order
                     rdduse(1,ichi,irho)=Rderivs(2,irho,ichi) ! is swapped
                     rdduse(3,ichi,irho)=Rderivs(3,irho,ichi)

                     zdduse(2,ichi,irho)=Zderivs(1,irho,ichi) ! note order
                     zdduse(1,ichi,irho)=Zderivs(2,irho,ichi) ! is swapped
                     zdduse(3,ichi,irho)=Zderivs(3,irho,ichi)
                  endif
               enddo
            enddo

         else

            ruse = R
            zuse = Z
            if(ichk_derivs.gt.0) then
               rdduse = Rderivs
               zdduse = Zderivs
            endif

         endif

         !-----------------------------------
         ! dmc-- added inequality test; only reset axis if any points
         ! are unequal.  This improves reproducibility of representations
         ! as the averaging formula can move the axis ever so slightly even
         ! if all points are equal.

         idiff=0
         do i=2,inchi
            if(ruse(i-1,1).ne.ruse(i,1)) then
               idiff=1
               exit
            endif
         enddo
         if(idiff.gt.0) then
            ruse(1:inchi,1)=sum(ruse(1:inchi,1))/inchi
         endif

         idiff=0
         do i=2,inchi
            if(zuse(i-1,1).ne.zuse(i,1)) then
               idiff=1
               exit
            endif
         enddo
         if(idiff.gt.0) then
            zuse(1:inchi,1)=sum(zuse(1:inchi,1))/inchi
         endif
         !-----------------------------------

         raxis=ruse(1,1)
         zaxis=zuse(1,1)

         ruse(1,1:inrho)=(ruse(1,1:inrho)+ruse(inchi,1:inrho))/2
         ruse(inchi,1:inrho)=ruse(1,1:inrho)
         zuse(1,1:inrho)=(zuse(1,1:inrho)+zuse(inchi,1:inrho))/2
         zuse(inchi,1:inrho)=zuse(1,1:inrho)

         if(ichk_derivs.eq.0) then
            zrbc0(1)=(zrbc0(1)+zrbc0(inchi))/2
            zrbc0(inchi)=zrbc0(1)
            zrbc1(1)=(zrbc1(1)+zrbc1(inchi))/2
            zrbc1(inchi)=zrbc1(1)

            zzbc0(1)=(zzbc0(1)+zzbc0(inchi))/2
            zzbc0(inchi)=zzbc0(1)
            zzbc1(1)=(zzbc1(1)+zzbc1(inchi))/2
            zzbc1(inchi)=zzbc1(1)

         else
            rdduse(1,1:inchi,1)=0  ! d(R,Z)/dtheta = 0 on axis
            zdduse(1,1:inchi,1)=0
         endif

         do irho=inrho,1,-1
            do ichi=1,inchi-1
               if(irho.eq.1) exit
               zdra=ruse(ichi,irho)-raxis
               zdza=zuse(ichi,irho)-zaxis
               dist0(ichi,irho)=sqrt(zdra*zdra+zdza*zdza)
               atan0(ichi,irho)=atan2(zdza,zdra)
               if(irho.eq.2) then
                  dist0(ichi,1)=0.0d0
                  atan0(ichi,1)=atan0(ichi,2)
               endif
            enddo
            dist0(inchi,irho)=dist0(1,irho)
            !  now make atan0(theta,rho) be relative to the 1st theta atan.
            zatan=atan0(1,irho)
            atan00(irho)=zatan  ! arctan at 1st theta
            atan0(1,irho)=0.0d0
            atan0(inchi,irho)=isign*C2PI
            ishift=0
            do ichi=2,inchi-1
               if(ishift.eq.0) then
                  if(isign*(atan0(ichi,irho)-zatan).lt.CZERO) then
                     ishift=1
                  else
                     zatan=atan0(ichi,irho)
                  endif
               endif
               atan0(ichi,irho)=atan0(ichi,irho)-atan00(irho)+isign*ishift*C2PI
            enddo
         enddo

         !  sanity check

         do ichi=2,inchi
            if(isign*(atan0(ichi,inrho)-atan0(ichi-1,inrho)).lt. &
                 C2PI/(100*inchi)) then
               ierr=2003
               zmsg=' '
               write(zmsg,*) ' at boundary interval #',ichi-1
               call xplasma_errmsg_append(s,zmsg)
               zmsg=' '
               write(zmsg,*) ' from (R,Z) = ',ruse(ichi-1,inrho),zuse(ichi-1,inrho)
               call xplasma_errmsg_append(s,zmsg)
               zmsg=' '
               write(zmsg,*) '   to (R,Z) = ',ruse(ichi,inrho),zuse(ichi,inrho)
               call xplasma_errmsg_append(s,zmsg)
               zmsg=' '
               write(zmsg,*) ' distances to mag. axis: ', &
                    dist0(ichi-1,inrho),dist0(ichi,inrho)
               call xplasma_errmsg_append(s,zmsg)
               zmsg=' '
               write(zmsg,*) ' arc-tangent of displacement from axis: ', &
                    atan0(ichi-1,inrho)-atan00(inrho), &
                    atan0(ichi,inrho)-atan00(inrho)
               call xplasma_errmsg_append(s,zmsg)
               exit
            endif
         enddo
         iertmp=max(iertmp,ierr)

         if(ichk_derivs.eq.0) then
            !  these will be splines of order s%rzOrder...

            call xplasma_create_prof(s,'R',id_chi,id_rho, &
                 Ruse,id_R,ierr, &
                 ibcx2a=ibc0,zbcx2a=zRbc0,ibcx2b=ibc1,zbcx2b=zRbc1, &
                 ccwflag1=ccwflag)

            if((ierr.eq.0).and.khermite) call xplasma_hermitize(s,id_R,ierr)

            iertmp=max(iertmp,ierr)

            call xplasma_create_prof(s,'Z',id_chi,id_rho, &
                 Zuse,id_Z,ierr, &
                 ibcx2a=ibc0,zbcx2a=zZbc0,ibcx2b=ibc1,zbcx2b=zZbc1, &
                 ccwflag1=ccwflag)

            if((ierr.eq.0).and.khermite) call xplasma_hermitize(s,id_Z,ierr)

            iertmp=max(iertmp,ierr)
            ierr=iertmp

         else
            !  these will be Hermites with the specified nodal derivatives

            call xplasma_create_prof(s,'R',id_chi,id_rho, &
                 Ruse,id_R,ierr, &
                 ccwflag1=ccwflag, ispline=1, coeffs=Rdduse)
            iertmp=max(iertmp,ierr)
            call xplasma_create_prof(s,'Z',id_chi,id_rho, &
                 Zuse,id_Z,ierr, &
                 ccwflag1=ccwflag, ispline=1, coeffs=Zdduse)

            iertmp=max(iertmp,ierr)
            ierr=iertmp
         endif

         if(ierr.eq.0) then
            call xplasma_rzcheck(s,id_rho,inrho,ierr)
         endif

         if(ierr.eq.0) then
            call xplasma_author_set(s,xplasma_xmhd,iertmp)

            !  these will be piecewise linear functions...

            iertmp=0

            call xplasma_create_prof(s,'__dist_axis',id_chi,id_rho, &
                 dist0,idtmp,ierr, ccwflag1=ccwflag, &
                 label='distance to axis',units='m')
            iertmp=max(iertmp,ierr)

            call xplasma_create_prof(s,'__atan_axis',id_chi,id_rho, &
                 atan0,idtmp,ierr, ccwflag1=ccwflag, &
                 label='adjusted arctan((Z-Zaxis)/(R-Raxis))',units='rad')
            iertmp=max(iertmp,ierr)

            atan00_label=' '
            write(atan00_label, &
                 '(" arctan((Z-Zaxis)/(R-Raxis)) vs. rho @theta=",1pd11.4)') &
                 thmin

            call xplasma_create_prof(s,'__atan00_axis',id_rho, &
                 atan00,idtmp,ierr, &
                 label=trim(atan00_label),units='rad')

            ierr=iertmp

            call xplasma_author_clear(s,xplasma_xmhd,iertmp)

         endif

         deallocate(ruse,zuse,dist0,atan0,atan00)
         exit
      enddo

      if(allocated(zRbc0)) deallocate(zRbc0,zZbc0,zRbc1,zZbc1)
      if(allocated(rdduse)) deallocate(rdduse,zdduse)

      contains
        subroutine bchk(str,bcin,bcuse,ierr)
          character*(*), intent(in) :: str  ! for error msg
          real*8, dimension(:) :: bcin,bcuse
          integer, intent(out) :: ierr
          character*128 msgbuf

          ierr = 0

          if(size(bcin).ne.size(bcuse)) then
             ierr=2001
             call xplasma_errmsg_append(s, ' ?xplasm_rzgeo: '// &
                  str//' boundary condition array data size mismatch.')
             write(msgbuf,*) '   size expected: ',size(bcuse), &
                  '; size received: ',size(bcin)
             call xplasma_errmsg_append(s,msgbuf)
             call xplasma_errmsg_append(s,'  expected:'// &
                  ' boundary condition array dimension = theta dimension.')

          else

             bcuse = bcin

          endif
        end subroutine bchk

        subroutine gcopy(idg,ing,zname)
          ! copy a grid
          integer, intent(in) :: idg,ing  ! id & size
          character*(*), intent(in) :: zname  ! name

          !-----------------------------
          real*8 :: zgrid(ing),zgrid2(ing)
          integer :: id2,ing2
          logical :: imatch
          !-----------------------------

          call xplasma_grid(s,idg,zgrid,ierr)
          if(ierr.ne.0) return

          call xplasma_gridID(s,zname,id2)
          if(id2.eq.0) then
             imatch=.TRUE.
             call xplasma_create_grid(s,zname,idg,zgrid,idtmp,ierr, &
                  label=trim(zname)//': copy of grid with standard name.')
          else
             imatch=.TRUE.
             call xplasma_grid_info(s,id2,ierr,size=ing2)
             if(ierr.ne.0) return
             if(ing.ne.ing2) then
                imatch=.FALSE.
             else
                call xplasma_grid(s,id2,zgrid2,ierr)
                if(ierr.ne.0) return
                if(maxval(abs(zgrid-zgrid2)).gt.1.0d-12) imatch=.FALSE.
             endif
          endif

          if(.not.imatch) then
             ierr=9999
             call xplasma_errmsg_append(s, &
                  'grid supplied to xplasma_rzmag does not match existing grid: '//trim(zname))
          endif
        end subroutine gcopy

    end subroutine xplasma_rzmag

    !=======================================================================
    subroutine xplasma_eqclear(s,rzonly,ier)

      !  ** public **

      ! delete MHD equilibrium from xplasma (e.g. before inserting a new one).
      ! if (rzonly) delete {R,Z} & derived quantities
      ! if (.not.rzonly) delete {g,Psi,P,R,Z} & derived quantities

      type (xplasma), pointer :: s
      logical, intent(in) :: rzonly  ! R,Z only flag
      integer, intent(out) :: ier    ! status code =0 on exit
      !  ier only set if s is uninitialized...

      !------------------
      integer :: id_R,id_Z,id_g,id_psi,id_P
      !------------------

      call xplasma_common_ids(s,ier, &
           id_g=id_g,id_psi=id_psi,id_P=id_P,id_R=id_R,id_Z=id_Z)

      if(ier.ne.0) return

      call xplasma_author_set(s,xplasma_root,ier)
      if(ier.ne.0) return

      if(.not.rzonly) then
         if(id_g.ne.0) call xplasma_remove_item(s,id_g,ier)
         if(id_p.ne.0) call xplasma_remove_item(s,id_p,ier)
         if(id_psi.ne.0) call xplasma_remove_item(s,id_psi,ier)
      endif

      if(id_R.ne.0) call xplasma_remove_item(s,id_R,ier)
      if(id_Z.ne.0) call xplasma_remove_item(s,id_Z,ier)

      call xplasma_author_clear(s,xplasma_root,ier)

      call xplasma_remove_author(s,xplasma_xmhd,ier)

    end subroutine xplasma_eqclear

    !=======================================================================
    subroutine xplasma_rzcheck(s,idrho,inrho,ier)

      !  ** PRIVATE **

      use eqi_rzbox_module

      !  call this when {R,Z} are updated

      ! check update of R(rho,theta) and Z(rho,theta)
      !   check Jacobian
      !   get magnetic axis
      !   get RZ min and max of boundary surface
      !   set up integrator for profiles of enclosed volume and cross 
      !     sectional area
      !   check equilibrium against limiter, if one is present.
      !   if scrapeoff region flag is set, compute extrapolated surfaces.

      type (xplasma), pointer :: s
      integer, intent(in) :: idrho     ! flux surface grid id
      integer, intent(in) :: inrho     ! no. of radial flux surfaces
      integer, intent(out) :: ier      ! completion status 0=OK

      !-------------------------------
      integer :: id_R,id_Z
      integer :: idx1,idc1,idx2,idc2,id_rho,id_integ
      integer :: i,id,iertmp,idlim

      real*8 :: raxis,zaxis
      real*8, dimension(:), allocatable :: zrho

      real*8, parameter :: zero = 0.0d0
      real*8, parameter :: rhobdy = 1.0d0

      logical :: sol
      !-------------------------------

      ier=0

      call xplasma_common_ids(s,ier, id_R=id_R,id_Z=id_Z)
      if(ier.ne.0) return
 
      call xplasma_jacheck(s,idrho,ier)
      if(ier.ne.0) return

      !--------------------------------------------------

      !  get magnetic axis... (stored as xplasma list)

      call xplasma_mag_axis(s,ier, raxis=raxis, zaxis=zaxis)
      if(ier.ne.0) return

      !  get R and Z min and max (stored as list)

      call xplasma_RZminmax(s,rhobdy,ier)
      if(ier.ne.0) return

      !--------------------------------------------------
      !  create area and volume
      !  --converted to surface integral by Gauss scheme...

      call xplasma_author_set(s,xplasma_xmhd,iertmp)

      call xplasma_prof_info(s,id_R,iertmp, gridId1=idx1, gridId2=idx2)

      call xplasma_grid_info(s,idx1,iertmp, coord=idc1)

      if(idc1.eq.xplasma_rho_coord) then
         id_rho=idx1
      else
         id_rho=idx2
      endif

      allocate(zrho(inrho))

      call xplasma_grid(s,id_rho,zrho,iertmp)

      call xplasma_create_integ(s,'__RZ_RHO_INTEGRATOR', &
           zrho,id_integ,ier, cache_enable=.TRUE.)

      if(ier.eq.0) then
         call xplasma_label_item(s,id_integ,iertmp, &
              label='flux surface integrals, rho grid of {R,Z} surfaces.')
         ier = max(ier,iertmp)
      endif

      deallocate(zrho)

      call xplasma_author_clear(s,xplasma_xmhd,iertmp)

      if(ier.eq.0) then
         call xplasma_find_item(s,'__LIMITER',idlim,iertmp,nf_noerr=.TRUE.)
         if(idlim.gt.0) then
            call xplasma_limcheck(s,ier)
         endif
      endif

      if(ier.eq.0) then
         call xplasma_global_info(s,ier, scrapeoff=sol)
         if(sol) then

            sp => s
            call eqi_xtrz(ier)
            
         endif
      endif

    end subroutine xplasma_rzcheck

    !=======================================================================
    subroutine xplasma_vol1(s,ans,ier)
      !  ** public **

      !  return total plasma volume

      type (xplasma), pointer :: s
      real*8, intent(out) :: ans
      integer, intent(out) :: ier

      !------------
      real*8 xv(1),ansv(1)
      !------------

      xv=1

      call xplasma_voln(s,xv,ansv,ier)

      ans=ansv(1)

    end subroutine xplasma_vol1
    
    subroutine xplasma_voln(s,xs,ans,ier, ideriv)

      !  ** public **

      !  return Volume(x) or dVol/dx -- calculate if needed.

      type (xplasma), pointer :: s
      real*8, dimension(:), intent(in) :: xs      ! evaluation vector
      real*8, dimension(:), intent(out) :: ans    ! result of evaluation
      integer, intent(out) :: ier                 ! completion code 0=OK

      integer, intent(in), optional :: ideriv     ! derivative option 0,1,2

      !-------------
      integer :: id_integ,id_vol,iertmp,id_R,id_Z,id_rho,inrho
      integer :: icounter, icount_rz
      real*8, dimension(:), allocatable :: zvol
      !-------------

      ans = 0.0d0

      call xplasma_find_item(s,"__RZ_RHO_INTEGRATOR", id_integ, ier)
      if(ier.ne.0) then
         call xplasma_errmsg_append(s, &
              ' ?xplasma_volume: numeric integration dataset unavailable.')
         return
      endif

      call xplasma_find_item(s,"XPLASMA_VOLUME",id_vol, ier, nf_noerr=.TRUE.)
      !  do not check ier -- id_vol=0, not found, possibility is expected here.

      !  id_R and id_Z must be defined, since __RZ_RHO_INTEGRATOR exists...

      call xplasma_common_ids(s,ier, id_R=id_R, id_Z=id_Z)
      if(ier.ne.0) return

      if(id_vol.gt.0) then

         !  make sure that volume info is not stale

         call xplasma_prof_info(s,id_R,ier, counter=icount_rz)
         call xplasma_prof_info(s,id_Z,ier, counter=icounter)
         icount_rz=max(icount_rz,icounter)
         call xplasma_prof_info(s,id_vol,ier, counter=icounter)

         if(icounter.lt.icount_rz) id_vol=0
      endif

      if(id_vol.eq.0) then

         call xplasma_author_set(s,xplasma_xmhd,iertmp)

         do

            call xplasma_prof_info(s,id_R,ier, gridId2=id_rho)
            if(ier.ne.0) exit

            call xplasma_grid_size(s,id_rho,inrho,ier)
            if(ier.ne.0) exit

            allocate(zvol(inrho))

            call xplasma_rho_zonint(s,id_integ,'VOL',zvol,ier)
            if(ier.ne.0) exit

            call xplasma_create_1dprof(s,'XPLASMA_VOLUME', &
                 id_rho,zvol,id_vol,iertmp, &
                 ispline=2,ibca=1,zbca=zero, &
                 label='Plasma Volume',units='m^3')
            if(ier.ne.0) id_vol=0

            deallocate(zvol)

            exit
         enddo

         call xplasma_author_clear(s,xplasma_xmhd,iertmp)

      endif

      if(id_vol.eq.0) return

      call xplasma_eval_prof(s,id_vol,xs,ans,ier, ideriv1=ideriv)

    end subroutine xplasma_voln

    !=======================================================================
    subroutine xplasma_area1(s,ans,ier)
      !  ** public **

      !  return total plasma poloidal plane cross sectional area

      type (xplasma), pointer :: s
      real*8, intent(out) :: ans
      integer, intent(out) :: ier

      !------------
      real*8 xv(1),ansv(1)
      !------------

      xv=1

      call xplasma_arean(s,xv,ansv,ier)

      ans=ansv(1)

    end subroutine xplasma_area1
    
    subroutine xplasma_arean(s,xs,ans,ier, ideriv)

      !  ** public **

      !  return plasma poloidal plane cross sectional area
      !  return Area(x) or dArea/dx -- calculate if needed.

      type (xplasma), pointer :: s
      real*8, dimension(:), intent(in) :: xs      ! evaluation vector
      real*8, dimension(:), intent(out) :: ans    ! result of evaluation
      integer, intent(out) :: ier                 ! completion code 0=OK

      integer, intent(in), optional :: ideriv     ! derivative option 0,1,2

      !-------------
      integer :: id_integ,id_area,iertmp,id_R,id_Z,id_rho,inrho
      integer :: icounter, icount_rz
      real*8, dimension(:), allocatable :: zarea
      !-------------

      ans = 0.0d0

      call xplasma_find_item(s,"__RZ_RHO_INTEGRATOR", id_integ, ier)
      if(ier.ne.0) then
         call xplasma_errmsg_append(s, &
              ' ?xplasma_area: numeric integration dataset unavailable.')
         return
      endif

      call xplasma_find_item(s,"XPLASMA_AREA",id_area, ier, nf_noerr=.TRUE.)
      !  do not check ier -- id_area=0, not found, is expected here.

      !  id_R and id_Z must be defined, since __RZ_RHO_INTEGRATOR exists...

      call xplasma_common_ids(s,ier, id_R=id_R, id_Z=id_Z)
      if(ier.ne.0) return

      if(id_area.gt.0) then

         !  make sure that volume info is not stale

         call xplasma_prof_info(s,id_R,ier, counter=icount_rz)
         call xplasma_prof_info(s,id_Z,ier, counter=icounter)
         icount_rz=max(icount_rz,icounter)
         call xplasma_prof_info(s,id_area,ier, counter=icounter)

         if(icounter.lt.icount_rz) id_area=0
      endif

      if(id_area.eq.0) then

         call xplasma_author_set(s,xplasma_xmhd,iertmp)

         do

            call xplasma_prof_info(s,id_R,ier, gridId2=id_rho)
            if(ier.ne.0) exit

            call xplasma_grid_size(s,id_rho,inrho,ier)
            if(ier.ne.0) exit

            allocate(zarea(inrho))

            call xplasma_rho_zonint(s,id_integ,'AREA',zarea,ier)
            if(ier.ne.0) exit

            call xplasma_create_1dprof(s,'XPLASMA_AREA', &
                 id_rho,zarea,id_area,iertmp, &
                 ispline=2,ibca=1,zbca=zero, &
                 label='Plasma Area',units='m^2')
            if(ier.ne.0) id_area=0
            exit
         enddo

         call xplasma_author_clear(s,xplasma_xmhd,iertmp)
      endif

      if(id_area.eq.0) return

      call xplasma_eval_prof(s,id_area,xs,ans,ier, ideriv1=ideriv)

    end subroutine xplasma_arean

    !=======================================================================
    subroutine xplasma_gen_boozer(s,id_iboozer,id_zetacor,ierr)

      !  **public**

      !  compute quantities related to Boozer coordinates

      !  compute two 2d spline profiles:
      !     I(theta,rho) (T*m)
      !     nu(theta,rho) (rad) = zeta - phi; Boozer toroidal coord - phi

      !  The formulas are:
      !
      !     (dnu/dtheta) = q - (d(Lp)/dtheta)*g/(R**2*Bpol)
      !     I = Bpol*(d(Lp)/dtheta) - g*(dnu/dtheta)
      !
      !     g = R*Bphi, T*m; q = d[toroidal_flux]/d[poloidal_flux]
      !     Psi = [poloidal_flux]/2pi, Wb/rad.
      !     Lp = poloidal path length around flux surface, m.
      !     (rho,theta) are the radial and poloidal flux coordinates
      !                 used by xplasma.
      !     Bphi and Bpol the (axisymmetric) toroidal and poloidal fields (T).
      !
      !  The above formulas will satisfy covariant and contravariant
      !  formulations of B:
      !    verifying...
      ! 
      !  B = g*grad(zeta) + I*grad(theta) + delta*grad(Psi)
      !         delta*grad(Psi) cancels the components of B*grad(zeta)
      !         and I*grad(theta) in the grad(Psi) direction;
      !             grad(zeta) = grad(phi) + grad(nu)
      !             component of grad(nu) = (dnu/dtheta)*(dtheta/d(Lp))
      !                 (tangent to the flux surface in the poloidal direction)
      !                 (the normal component cancelled by delta*grad(Psi))
      !             component of grad(theta): (dtheta/d(Lp)).
      !                 (tangent to the flux surface in the poloidal direction)
      !  Bphi = g*grad(phi)  -- OK
      !  Bpol = g*(dnu/dtheta)*(dtheta/d(Lp)) + I*(dtheta/d(Lp))
      !       = Bpol when formula for I is substituted -- OK
      !
      !  B = q*grad(Psi)^grad(theta) + grad(zeta)^grad(Psi)
      !  B = q*grad(Psi)^grad(theta) + grad(phi)^grad(Psi) + grad(nu)^grad(Psi)
      !  Bpol = grad(phi)^grad(Psi)  -- OK
      !  Bphi = q*grad(Psi)*(dtheta/d(Lp)) - 
      !                         grad(Psi)*(dnu/dtheta)*(dtheta/d(Lp))
      !
      !  Bphi = (q - (dnu/dtheta))*grad(Psi)*(dtheta/d(Lp))
      !       = (d(Lp)/dtheta)*(g/(R**2*Bpol))*(R*Bpol)*(dtheta/d(Lp))
      !       = g/R  -- OK

      !--------------------------------------
      !  arguments:

      type (xplasma), pointer :: s
      integer, intent(out) :: id_iboozer   ! I spline id
      integer, intent(out) :: id_zetacor   ! nu spline (zetacor, zeta-phi)
      integer, intent(out) :: ierr   ! completion status (0=OK)
      !--------------------------------------
      !  local:
      integer :: id_integ,idi2,id_R,id_g,id_th,id_rho,iertmp
      integer :: ids(5),iderivs(5),id_Z,id_BR,id_BZ,id_nu
      integer :: iderivs_0x(5),iderivs_0t(5)
      integer :: inth,inrho,ith,irho,ith2
      real*8, dimension(:), allocatable :: thgrid,rhogrid
      real*8, dimension(:), allocatable :: qovg    ! q/g from integration
      real*8, dimension(:), allocatable :: gfun    ! g
      real*8, dimension(:), allocatable :: wk1,rhowk
      real*8, dimension(:,:), allocatable :: qovg_2d,fiwk
      real*8, dimension(:,:), allocatable :: ii,nu,wk5
      real*8, dimension(:), pointer :: thvec,wth
      real*8 :: rhomin
      !--------------------------------------
      !  find 1d integrator

      ierr=0

      call xplasma_profId(s,'__I_BOOZER',id_iboozer)
      call xplasma_profId(s,'__NU_BOOZER',id_zetacor)
      if(min(id_iboozer,id_zetacor).gt.0) return

      !  Need to evaluate these profiles and set up their splines...

      call xplasma_find_item(s,"__RZ_RHO_INTEGRATOR", id_integ, ierr)
      if(ierr.ne.0) then
         call xplasma_errmsg_append(s, &
              ' ?xplasma_gen_boozer: numeric integration dataset unavailable.')
         return
      endif

      !  find R and Z and g and BR and BZ
      call xplasma_common_ids(s,iertmp,id_R=id_R,id_g=id_g,id_Z=id_Z, &
           id_BR=id_BR,id_BZ=id_BZ)

      ids(1)=id_BR
      ids(2)=id_BZ
      ids(3)=id_R
      ids(4)=id_Z
      ids(5)=id_R  ! for now

      ! ids(5) will be "nu" after it is computed

      iderivs(1:2)=0    ! no derivative
      iderivs(3:5)=1    ! d/dtheta

      ! for axis limit:  d/dtheta:
      iderivs_0t(1:2)=0; iderivs_0t(3:4)=1; iderivs_0t(5)=0

      ! for axis limit:  d/drho:
      iderivs_0x(1:2)=1; iderivs_0x(3:4)=1; iderivs_0x(5)=0

      !  find theta and rho -- grids used for equilibrium

      call xplasma_prof_info(s,id_R,ierr, gridId1=id_th, gridId2=id_rho)
      if(ierr.ne.0) then
         call xplasma_errmsg_append(s, &
              ' ?xplasma_gen_boozer: could not find grids from "R"')
         return
      endif

      !  grid sizes

      call xplasma_grid_size(s,id_th,inth,iertmp)
      call xplasma_grid_size(s,id_rho,inrho,iertmp)

      !  copy of theta grid

      allocate(thgrid(inth),rhogrid(inrho))

      call xplasma_grid(s,id_rho,rhogrid,ierr)
      if(ierr.ne.0) then
         call xplasma_errmsg_append(s, &
              ' ?xplasma_gen_boozer: could not fetch rho grid from "R"')
         deallocate(rhogrid,thgrid)
         return
      endif

      call xplasma_grid(s,id_th,thgrid,ierr)
      if(ierr.ne.0) then
         call xplasma_errmsg_append(s, &
              ' ?xplasma_gen_boozer: could not fetch theta grid from "R"')
         deallocate(rhogrid,thgrid)
         return
      endif

      !  extend to 2d integrator

      call xplasma_author_set(s,xplasma_xmhd,iertmp)

      call xplasma_augment_integ(s,"__RZ_RHOTH_INTEGRATOR", id_integ, &
           thgrid,idi2,ierr)

      call xplasma_author_clear(s,xplasma_xmhd,iertmp)

      if(ierr.ne.0) then
         call xplasma_errmsg_append(s, &
              ' ?xplasma_gen_boozer: failed to setup (rho,th) integrator.')
         deallocate(rhogrid,thgrid)
         return
      endif

      !  allocate work arrays

      allocate(qovg(inrho),gfun(inrho))
      allocate(qovg_2d(inth-1,inrho),wk1(inth),wk5(inth,5))
      allocate(ii(inth,inrho),nu(inth,inrho))

      !  explicit integration for axis ...L'Hopital rule expression, avoid 0/0:
      !  (dl/dtheta)/(R**2*Bpol) -> (d2l/dtheta*drho)/(R**2*d(Bpol)/dtheta)

      call xplasma_integ_info(s,idi2,iertmp, &
           thvec_ptr=thvec, thwts_ptr=wth, rhomin=rhomin)
      
      allocate(fiwk(size(thvec),5),rhowk(size(thvec))); rhowk=ZERO

      do
         !  compute integral contributions over theta grid

         ierr=0
         call xplasma_2d_zonint(s,idi2,'BOOZER_QOVG',qovg_2d,iertmp)
         if(iertmp.ne.0) then
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_gen_boozer: BOOZER_QOVG integration failed.')
            ierr=max(ierr,iertmp)
         endif

         if(ierr.ne.0) exit

         ! fill in axial data

         call xplasma_eval_prof(s,ids, &
              xplasma_theta_coord,thvec, xplasma_rho_coord, rhowk, &
              fiwk, ierr, ideriv1s=iderivs_0t, ideriv2s=iderivs_0x)
         if(ierr.ne.0) exit

         ith=1
         do ith2=1,size(thvec)
            if(ith.lt.inth) then
               if(thvec(ith2).gt.thgrid(ith+1)) ith=ith+1
            endif
            qovg_2d(ith,1)=qovg_2d(ith,1) + wth(ith2) * &
                 sqrt(fiwk(ith2,3)**2+fiwk(ith2,4)**2)/ &
                 (sqrt(fiwk(ith2,1)**2+fiwk(ith2,2)**2)* &
                 C2PI*fiwk(ith2,5)**2)
         enddo

         call xplasma_eval_prof(s,id_G,rhogrid,gfun,iertmp)

         qovg=ZERO
         do ith=1,inth-1
            qovg = qovg + qovg_2d(ith,1:inrho)     ! (q/g)
         enddo

         nu(1,1:inrho)=ZERO
         nu(inth,1:inrho)=ZERO

         !  ii = I*thB    -- periodic derivative
         !  nu = zeta-phi -- strictly periodic; nu(theta(1))=nu(theta(inth))=0

         do irho=1,inrho
            do ith=2,inth-1
               nu(ith,irho)=nu(ith-1,irho) + &
                    qovg(irho)*gfun(irho)*(thgrid(ith)-thgrid(ith-1)) - &
                    qovg_2d(ith-1,irho)*gfun(irho)*C2PI
            enddo
         enddo

         ierr=0
         call xplasma_author_set(s,xplasma_xmhd,iertmp)
         ierr=max(ierr,iertmp)

         !  create profiles with default Bdy Conds in rho, periodic in theta

         call xplasma_create_2dprof(s,'__NU_BOOZER', &
              id_th,id_rho,nu,id_zetacor,iertmp, &
              ispline=2, &
              label='Toroidal coordinate adjust: Zeta_Boozer - Phi', &
              units='rad')
         ierr=max(ierr,iertmp)

         call xplasma_author_clear(s,xplasma_xmhd,iertmp)
         ierr=max(ierr,iertmp)

         if(ierr.ne.0) then
            call xplasma_errmsg_append(s, &
                 'xplasma_gen_boozer: 2d nu profile creation failure.')
            exit
         endif

         id_nu=id_zetacor
         ids(5)=id_nu

         !  compute I(theta,rho)

         do irho=1,inrho
            wk1 = rhogrid(irho)
            call xplasma_eval_prof(s,ids, &
                 xplasma_theta_coord,thgrid, xplasma_rho_coord,wk1, &
                 wk5, ierr, ideriv1s=iderivs)
            if(ierr.ne.0) exit
            do ith = 1,inth
               ii(ith,irho) = sqrt((wk5(ith,1)**2+wk5(ith,2)**2)* &
                    (wk5(ith,3)**2+wk5(ith,4)**2)) - gfun(irho)*wk5(ith,5)
            enddo
         enddo

         if(ierr.eq.0) then
            call xplasma_author_set(s,xplasma_xmhd,iertmp)
            ierr=max(ierr,iertmp)

            !  create profiles with default rho boundary conditions;
            !  automatic periodic boundary condition in theta direction.

            call xplasma_create_2dprof(s,'__I_BOOZER', &
                 id_th,id_rho,ii,id_iboozer,iertmp, &
                 ispline=2, &
                 label='Boozer I(theta,rho) profile', &
                 units='Amps*mu0/2pi')
            ierr=max(ierr,iertmp)

            call xplasma_author_clear(s,xplasma_xmhd,iertmp)
            ierr=max(ierr,iertmp)
         endif

         if(ierr.ne.0) then
            call xplasma_errmsg_append(s, &
                 'xplasma_gen_boozer: 2d I profile creation failure.')
            exit
         endif

         exit

      enddo
      deallocate(qovg,gfun,rhogrid,thgrid)
      deallocate(qovg_2d,ii,nu,wk1,wk5)
      deallocate(fiwk,rhowk)

    end subroutine xplasma_gen_boozer

    !=======================================================================
    subroutine xplasma_jacheck(s,idrho,ierr)
 
      !  ** public **

      ! check for singular or near singular Jacobian
      ! axisymmetric equilibrium only
 
      !-------------------------------------------
      !  arguments
 
      type (xplasma), pointer :: s
      integer, intent(in) :: idrho   ! flux surface grid
      integer, intent(out) :: ierr   ! completion status (0=OK)
 
      !-------------------------------------------
      !  local stuff
 
      logical allzones_ok,badzone
      integer inrow
      integer inth,nrho
      integer izone,istat,iertmp
 
      real*8 zrho,zth,detj,detjav,ajac_maxvar

      logical, dimension(:), allocatable :: zone_ok ! (nrho-1)
      real*8, dimension(:), allocatable :: xrho     ! (nrho)
 
      real*8  zscreen1
 
      real*8, parameter :: c2pi = 6.2831853071795862D+00
      real*8, parameter :: czero = 0.0d0

      character*80 zmsg1

      !-------------------------------------------
      !  executable code
 
      !  first screen jacobian values at modest resolution
      !  if this shows a lot of variation, try again at higher resolution
 
      inrow=4
      inth=100
 
      allzones_ok=.TRUE.
      badzone=.FALSE.
 
      call xplasma_grid_size(s,idrho,nrho,ierr)
      if(ierr.ne.0) return

      allocate(zone_ok(nrho-1),xrho(nrho))
      zone_ok=.FALSE.

      call xplasma_grid(s,idrho,xrho,ierr)
      if(ierr.ne.0) return
 
      call xplasma_global_info(s,iertmp, ajac_maxvar=ajac_maxvar)

      zscreen1=4*ajac_maxvar

      do izone=1,nrho-1
 
         call jac_screen(izone,zscreen1,istat,zrho,zth,detj,detjav)
         if(istat.eq.0) then
            zone_ok(izone)=.TRUE.
         else if(istat.eq.1) then
            allzones_ok=.FALSE.   ! det(J) stays positive but varies too much
         else
            allzones_ok=.FALSE.   ! det(J) changes sign
            badzone=.TRUE.
            call jac_error('changes sign')
         endif
 
      enddo
 
      if(allzones_ok) then
         ierr=0
      else
         if(badzone) then
            ierr=2002
         endif
      endif
 
      ! result ambiguous
      ! some zones may not be OK -- look with higher resolution
      
      if((.not.badzone).and.(.not.allzones_ok)) then

         inrow=40
         inth=1000
 
         allzones_ok=.TRUE.

         do izone=1,nrho-1
 
            if(.not.zone_ok(izone)) then
 
               call jac_screen(izone,ajac_maxvar,istat,zrho,zth,detj,detjav)
               if(istat.eq.0) then
                  zone_ok(izone)=.true.
               else if(istat.eq.1) then
                  allzones_ok=.FALSE.
                  call jac_error( &
                       'too small -- may need to adjust tol via xplasma_ajac_maxvar_set')
                  call xplasma_errmsg_append(s, &
                       ' f77 style maxvar adjust call: eqi_jacheck_maxvar_set')
               else
                  allzones_ok=.FALSE.
                  call jac_error('changes sign')
               endif
 
            endif
 
         enddo
 
         if(allzones_ok) then
            ierr=0
         else
            ierr=2002
         endif
      endif

      if(ierr.eq.2002) then
         write(zmsg1,'(a,1x,1pe13.6)') &
              'max variation parameter (ajac_maxvar):',ajac_maxvar
         call xplasma_errmsg_append(s,zmsg1)
      endif

      deallocate(xrho,zone_ok)

    contains
 
      subroutine jac_error(zmsg)
        character*(*) zmsg      ! error message about det(J)

        character*128 zmsg2

        call xplasma_errmsg_append(s, &
             '===========================================')
        call xplasma_errmsg_append(s, &
             ' Xplasma (xplasma_jacheck): det(J) '//trim(zmsg)//'.')
        zmsg2=' '
        write(zmsg2,1001) zrho,zth,detj
        call xplasma_errmsg_append(s,trim(zmsg2))
        zmsg2=' '
        write(zmsg2,1002) detjav
        call xplasma_errmsg_append(s,trim(zmsg2))
        call xplasma_errmsg_append(s, &
             '===========================================')

1001    format(' ==> at rho=',1pd12.5,' theta=',1pd12.5,' det(J)=',1pd12.5)
1002    format('     average det(J) in vicinity: ',1pd12.5)
 
      end subroutine jac_error
 
      subroutine jac_screen(izone,zscreen,istat,zrho,zth,detj,detjav)
        integer,intent(in) :: izone    ! rho(izone:izone+1)
        real*8, intent(in) :: zscreen  ! max allowed rel. variation
 
        integer,intent(out) :: istat  ! 0:ok,1:too much variation,2:sign change
        real*8, intent(out) :: zrho,zth ! location of min det(J)
        real*8, intent(out) :: detj,detjav ! min det(J), avg det(J) in region
 
        !--------------
        real*8, dimension(:), allocatable :: zrhovec,zthvec,zphvec,zdetjvec
        real*8 zrhocur,zrho1,zrho2,zsign,zdetjmax
        integer ierr,ith,ir
        integer ithmax,irmax
        !--------------
 
        allocate(zrhovec(inth),zthvec(inth),zphvec(inth),zdetjvec(inth))
 
        zphvec = 0
        do ith=1,inth
           zthvec(ith)=(ith-1)*c2pi/inth
        enddo
 
        zrho1=xrho(izone)
        zrho2=xrho(izone+1)
 
        istat=0
 
        do ir=1,inrow
           zrhocur=(zrho1*(inrow-ir)+zrho2*ir)/inrow  ! zrho1+drho to zrho2
           zrhovec=zrhocur
 
           call xplasma_rzjac(s,zrhovec,zthvec,ierr, rzdetj=zdetjvec)
 
           if(izone.eq.1) then
              !  1/rho scaling of det(J), izone=1 only.
              zdetjvec=(zrho2/(zrhocur-xrho(izone)))*zdetjvec
           endif
 
           if(ierr.ne.0) then
            
              call xplasma_errmsg_append(s, &
                   ' ?? unexpected xplasma_rzjac error in xplasma_jacheck.')
              zrho=0; zth=0; detj=0; detjav=0; istat=2
              exit
           endif
 
           if(ir.eq.1) then
 
              !  first row; init avgs & min/max scans
              !  determine predominant sign of det(J)
 
              detjav=sum(zdetjvec)/(inth*inrow)
              if(detjav.lt.0.0) then
                 zsign=-1
                 zdetjvec=zdetjvec*zsign
                 detjav=detjav*zsign
              else if(detjav.gt.0.0) then
                 zsign=1
              else
                 call xplasma_errmsg_append(s, &
                      ' ?? xplasma_rzjac returned zeroes in xplasma_jacheck.')
                 zrho=0; zth=0; detj=0; detjav=0; istat=2
                 exit
              endif
 
              zrho=zrhovec(1)
              zth=zthvec(1)
              detj=zdetjvec(1)
 
              ithmax=1
              irmax=1
              zdetjmax=detj
 
           else
              zdetjvec=zdetjvec*zsign
              detjav = detjav + sum(zdetjvec)/(inth*inrow)
           endif
 
           do ith=1,inth
              if(zdetjvec(ith).gt.zdetjmax) then
                 zdetjmax=zdetjvec(ith)
                 ithmax=ith
                 irmax=ir
              endif
              if(zdetjvec(ith).lt.detj) then
                 zrho=zrhovec(ith)
                 zth=zthvec(ith)
                 detj=zdetjvec(ith)
              endif
           enddo
 
        enddo
 
        if(detj.le.czero) then
           istat=2
        else if((detj/zdetjmax).lt.zscreen) then
           istat=1
        endif
 
        deallocate(zrhovec,zthvec,zphvec,zdetjvec)
 
      end subroutine jac_screen
 
    end subroutine xplasma_jacheck

    !=======================================================================
    subroutine xplasma_eqcheck(s,iforce,icount,ier)

      !  **public**

      ! update equilibrium and increment counter IF all input profiles are
      ! available, and if Bphi and Jphi directions are set, and if one or more
      ! of the input profiles are new

      type (xplasma), pointer :: s
      logical, intent(in) :: iforce    ! TRUE to FORCE equilibrium update
      integer, intent(out) :: icount   ! counter set if equilibrium updated
      integer, intent(out) :: ier      ! completion status 0=OK

      ! use iforce=T to force an equilibrium update (i.e. calculation of
      ! field profiles) even if it appears that not all profiles have been
      ! modified.  If necessary data is missing, an error code will be set.

      !-------------------------------
      integer :: bccw,jccw,ieq_prev,inmax_inp
      integer :: iinp_R,iinp_RZ,iinp_Z,iinp_g,iinp_psi
      integer :: id_g,id_psi,id_R,id_Z,idtmp,ix,ith
      integer :: iertmp
      integer :: idx1,idx2,idrho,inrho,idth,inth,ispline,jcoord
      integer :: id5(5),idth5(5),idrho5(5)

      real*8,dimension(:), allocatable :: xrho,xth,xwk,fg,fpsi
      real*8,dimension(:), allocatable :: fr,fdrdrho,fdrdth,fdzdrho,fdzdth
      real*8,dimension(:), allocatable :: fdPsidrho,zdeti
      real*8,dimension(:,:), allocatable :: bmod,br,bz,f5

      real*8, parameter :: rhobdy = 1.0d0

      !-------------------------------

      ier=0
      icount=0

      call xplasma_global_info(s,ier, bphi_ccw=bccw,jphi_ccw=jccw, &
           eq_counter=ieq_prev)
      if(ier.ne.0) return

      if((bccw.eq.0).or.(jccw.eq.0)) then
         if(iforce) then
            ier=2003
            call xplasma_errmsg_append(s, &
                 '   Signs of toroidal field and current unspecified.')
         endif
         return   ! signs not specified
      endif

      !  see if all required profiles are present...

      call xplasma_common_ids(s,iertmp, &
           id_g=id_g,id_psi=id_psi,id_R=id_R,id_Z=id_Z)

      if(min(id_g,id_psi,id_R,id_Z).eq.0) then
         if(iforce) then
            ier=2003
            call xplasma_errmsg_append(s, &
                 '   Not all profiles in set {G,PSI,R,Z} are defined.')
         endif
         return ! don't have all needed profiles.
      endif

      !--------------------------------------------------
      !  see if any of the profiles are newer than the derived field profiles...
      inmax_inp=0

      call xplasma_prof_info(s,id_g,iertmp, counter=iinp_g)
      inmax_inp=max(inmax_inp,iinp_g)

      call xplasma_prof_info(s,id_psi,iertmp, counter=iinp_psi)
      inmax_inp=max(inmax_inp,iinp_psi)

      call xplasma_prof_info(s,id_R,iertmp, counter=iinp_R)

      call xplasma_prof_info(s,id_Z,iertmp, counter=iinp_Z)

      iinp_RZ=min(iinp_R,iinp_Z)

      inmax_inp=max(inmax_inp,iinp_RZ)

      if((.not.iforce).and.(inmax_inp.le.ieq_prev)) return

      !--------------------------------------------------
      !  *** an input profile has changed *** or iforce=T
  
      !  B field components... writing as xplasma_xmhd

      call xplasma_global_info(s,iertmp,rzOrder=ispline)

      call xplasma_author_set(s,xplasma_xmhd,iertmp)

      !  use same x axes as R(rho,theta)

      call xplasma_prof_info(s,id_R,iertmp,gridId1=idx1,gridId2=idx2)

      call xplasma_grid_info(s,idx1,iertmp, coord=jcoord)
      if(jcoord.eq.xplasma_rho_coord) then
         idrho=idx1
         idth=idx2
      else
         idrho=idx2
         idth=idx1
      endif

      !  get grid sizes

      call xplasma_grid_size(s,idrho,inrho,ier)
      if(ier.ne.0) return

      call xplasma_grid_size(s,idth,inth,ier)
      if(ier.ne.0) return

      !  get grids

      allocate(xrho(inrho),xth(inth),xwk(inth))

      call xplasma_grid(s,idrho,xrho,ier)
      if(ier.ne.0) return

      call xplasma_grid(s,idth,xth,ier)
      if(ier.ne.0) return

      do

         !  compute B_phi = g/R; use to start bmod...

         allocate(bmod(inth,inrho),fg(inrho),fr(inth))

         call xplasma_eval_prof(s,id_g,xrho,fg,ier)
         do ix=1,inrho
            xwk = xrho(ix)
            call xplasma_eval_prof(s,id_R,idth,xth,idrho,xwk,fr,ier)
            if(ier.ne.0) exit
            if(ix.eq.1) then
               fr=sum(fr)/inth
            endif
            bmod(1:inth,ix)=bccw*fg(ix)/fr(1:inth)  ! just BPHI at present
         enddo

         deallocate(fg,fr)
         if(ier.ne.0) then
            deallocate(bmod)
            exit
         endif

         call xplasma_create_prof(s,'BPHI',idth,idrho,bmod,idtmp,ier, &
              ispline=ispline,label='B_phi',units='T')

         !  compute [BR,BZ] = (1/R)grad(Psi) ^ e_phi

         allocate(br(inth,inrho),bz(inth,inrho),fr(inth))
         allocate(fdPsidrho(inrho),zdeti(inth),f5(inth,5))
         allocate(fdRdrho(inth),fdRdth(inth),fdZdrho(inth),fdZdth(inth))

         call xplasma_eval_prof(s,id_psi,xrho,fdPsidrho,ier, ideriv1=1)
         do ix=1,inrho

            if(ix.eq.1) then

               bR(1:inth,1)=0
               bZ(1:inth,1)=0
               bmod(1:inth,1)=abs(bmod(1:inth,1))
            else

               id5(1:3)=id_R ! fetch: R, dR/dtheta, dR/drho, dZ/dtheta, dZ/drho
               id5(4:5)=id_Z
               idth5 = (/ 0, 1, 0, 1, 0/)
               idrho5= (/ 0, 0, 1, 0, 1/)

               xwk=xrho(ix)
               call xplasma_eval_prof(s,id5,idth,xth,idrho,xwk,f5,ier, &
                    ideriv1s=idth5, ideriv2s=idrho5)
               if(ier.ne.0) exit

               fr = f5(1:inth,1)
               fdrdth = f5(1:inth,2)
               fdrdrho = f5(1:inth,3)
               fdzdth = f5(1:inth,4)
               fdzdrho = f5(1:inth,5)

               zdeti = -1/(fdrdth*fdzdrho-fdrdrho*fdzdth)

               bR(1:inth,ix) = -jccw*fdPsidrho(ix)*fdrdth*zdeti/fr
               bZ(1:inth,ix) = -jccw*fdPsidrho(ix)*fdzdth*zdeti/fr

               do ith=1,inth

                  bmod(ith,ix)=sqrt(bmod(ith,ix)*bmod(ith,ix) + &
                       br(ith,ix)*br(ith,ix) + bz(ith,ix)*bz(ith,ix))

               enddo

            endif
         enddo

         if(ier.eq.0) then
            call xplasma_create_prof(s,'BR',idth,idrho,bR,idtmp,ier, &
                 ispline=ispline,label='B_R',units='T')
            call xplasma_create_prof(s,'BZ',idth,idrho,bZ,idtmp,ier, &
                 ispline=ispline,label='B_Z',units='T')
            call xplasma_create_prof(s,'BMOD',idth,idrho,bmod,idtmp,ier, &
                 ispline=ispline,label='mod(B)',units='T')
         endif

         deallocate(br,bz,bmod,fr,fdpsidrho,fdrdrho,fdrdth,fdzdrho,fdzdth,zdeti,f5)
         exit

      enddo

      call xplasma_author_clear(s,xplasma_xmhd,iertmp)

      deallocate(xth,xrho,xwk)

      if(ier.eq.0) then
         icount = inmax_inp
         call xplasma_eqCount_incr(s,ier)
      endif
      
    end subroutine xplasma_eqcheck

    subroutine xplasma_gen_q(s,qname,iorder,id_q,ier)

      !  create a q profile from equilibrium information-- this involves a
      !  flux surface integral; the standard equilibrium grid is used for this.

      type (xplasma), pointer :: s

      character*(*), intent(in) :: qname  ! user selected name for profile
      integer, intent(in) :: iorder       ! fit order
      !  0 for piecewise linear, 1 for Hermite, 2 for Spline

      integer, intent(out) :: id_q        ! id of q profile created 
      integer, intent(out) :: ier         ! status code 0=OK

      !  if an error occurs, id_q=0 will be returned.

      !------------------------------
      integer :: id_rho,id_psi,id_g,id_R,id_integ,inrho,i,iertmp
      real*8, dimension(:), allocatable :: zrho,zg,zdvdrho,zr2i,zq
      real*8, dimension(:,:), allocatable :: zpsi
      real*8 :: zdpsmin
      integer :: ids(3),iderivs(3)
      real*8, parameter :: C2PI=6.2831853071795862D+00
      !------------------------------

      id_q=0
      call xplasma_common_ids(s,ier,id_psi=id_psi,id_g=id_g,id_R=id_R)
      if(ier.ne.0) return

      if(id_psi.eq.0) then
         ier=106
         call xplasma_errmsg_append(s,' ?xplasma_gen_q: no Psi(x) profile.')
      endif

      if(id_g.eq.0) then
         ier=106
         call xplasma_errmsg_append(s,' ?xplasma_gen_q: no R*Bphi(x) profile.')
      endif

      if(id_R.eq.0) then
         ier=106
         call xplasma_errmsg_append(s,' ?xplasma_gen_q: no R(theta,x).')
      endif
      if(ier.ne.0) return

      call xplasma_prof_info(s,id_R,ier, gridId2=id_rho)
      if(ier.ne.0) return

      call xplasma_grid_size(s,id_rho,inrho,ier)
      if(ier.ne.0) return

      allocate(zrho(inrho),zpsi(inrho,3),zg(inrho),zdvdrho(inrho),zr2i(inrho))
      allocate(zq(inrho))

      ids(1:2)=id_psi; iderivs(1)=0; iderivs(2)=1
      ids(3)=id_g; iderivs(3)=0

      do
         call xplasma_grid(s,id_rho,zrho, ier)
         if(ier.ne.0) exit

         !  get zpsi(:,1)=Psi(rho); zpsi(:,2)=d(psi)/d(rho).
         !    also putting zpsi(:,3)=g(rho) ***

         call xplasma_eval_prof(s,ids,zrho,zpsi,ier, ideriv1s=iderivs)
         if(ier.ne.0) exit

         !  force dPsi/drho > 0 everywhere...

         do i=2,inrho
            zdpsmin=zpsi(i,1)/zrho(i)/10
            if(zdpsmin.gt.0) exit
         enddo

         zpsi(2:inrho,2)=max(zdpsmin,zpsi(2:inrho,2))

         zg=zpsi(1:inrho,3)  ! and copy g

         !  get (dV/drho); this also sets up the flux surface integrator

         call xplasma_voln(s,zrho,zdvdrho,ier, ideriv=1)
         if(ier.ne.0) exit

         call xplasma_find_item(s,"__RZ_RHO_INTEGRATOR", id_integ, ier)
         if(ier.ne.0) then
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_gen_q: xplasma_voln call failed to create integrator.')
            exit
         endif

         call xplasma_rho_zonint(s,id_integ,'<1/R^2>S',zr2i,ier)
         if(ier.ne.0) exit

         zq(2:inrho)=zdvdrho(2:inrho)*zr2i(2:inrho)* &
              zg(2:inrho)/(zpsi(2:inrho,2)*C2PI*C2PI)
         zq(1)=(4*zq(2)-zq(3))/3  ! simple extrapolation to axis

         call xplasma_author_set(s,xplasma_xmhd,iertmp)

         call xplasma_create_prof(s,qname,id_rho,zq,id_q,ier, &
              ispline=iorder,label='q profile (xplasma_gen_q)',units=' ')

         call xplasma_author_clear(s,xplasma_xmhd,iertmp)

         exit
      enddo
      deallocate(zrho,zpsi,zg,zdvdrho,zr2i,zq)

    end subroutine xplasma_gen_q

    subroutine xplasma_gen_torflx(s,tfname,iorder,id_tf,ier)

      !  create a profile of enclosed toroidal flux -- this involves a
      !  flux surface integral; the standard equilibrium grid is used for this.

      type (xplasma), pointer :: s

      character*(*), intent(in) :: tfname ! user selected name for profile
      integer, intent(in) :: iorder       ! fit order
      !  0 for piecewise linear, 1 for Hermite, 2 for Spline

      integer, intent(out) :: id_tf       ! id of tf profile created 
      integer, intent(out) :: ier         ! status code 0=OK

      !  if an error occurs, id_tf=0 will be returned.

      !------------------------------
      integer :: id_rho,id_g,id_R,id_integ,inrho,i,iertmp
      real*8, dimension(:), allocatable :: zrho,zg,zdvdrho,zr2i,ztf
      real*8 :: zdrho,zrhoav,zgav,zr2iav,zdvdrhoav
      real*8, parameter :: C2PI=6.2831853071795862D+00
      !------------------------------

      id_tf=0
      call xplasma_common_ids(s,ier,id_g=id_g,id_R=id_R)
      if(ier.ne.0) return

      if(id_g.eq.0) then
         ier=106
         call xplasma_errmsg_append(s,' ?xplasma_gen_q: no R*Bphi(x) profile.')
      endif

      if(id_R.eq.0) then
         ier=106
         call xplasma_errmsg_append(s,' ?xplasma_gen_q: no R(theta,x).')
      endif
      if(ier.ne.0) return

      call xplasma_prof_info(s,id_R,ier, gridId2=id_rho)
      if(ier.ne.0) return

      call xplasma_grid_size(s,id_rho,inrho,ier)
      if(ier.ne.0) return

      allocate(zrho(inrho),zg(inrho),zdvdrho(inrho),zr2i(inrho))
      allocate(ztf(inrho))

      do
         call xplasma_grid(s,id_rho,zrho, ier)
         if(ier.ne.0) exit

         !  get g(rho)

         call xplasma_eval_prof(s,id_g,zrho,zg,ier)
         if(ier.ne.0) exit

         !  get (dV/drho); this also sets up the flux surface integrator

         call xplasma_voln(s,zrho,zdvdrho,ier, ideriv=1)
         if(ier.ne.0) exit

         call xplasma_find_item(s,"__RZ_RHO_INTEGRATOR", id_integ, ier)
         if(ier.ne.0) then
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_gen_q: xplasma_voln call failed to create integrator.')
            exit
         endif

         call xplasma_rho_zonint(s,id_integ,'<1/R^2>S',zr2i,ier)
         if(ier.ne.0) exit

         ztf(1)=0
         do i=1,inrho-1
            zdrho=zrho(i+1)-zrho(i)
            zrhoav=(zrho(i)+zrho(i+1))/2
            zgav=(zg(i)+zg(i+1))/2
            zr2iav=(zr2i(i)+zr2i(i+1))/2
            zdvdrhoav=zdvdrho(i)+ &
                 (zrhoav+zrho(i))*(zrhoav-zrho(i))*(zdvdrho(i+1)-zdvdrho(i))/ &
                 (zrho(i+1)+zrho(i))*(zrho(i+1)-zrho(i))
            ztf(i+1)=ztf(i) + zdrho*zgav*zdvdrhoav*zr2iav/C2PI
         enddo

         call xplasma_author_set(s,xplasma_xmhd,iertmp)

         call xplasma_create_prof(s,tfname,id_rho,ztf,id_tf,ier, &
              ispline=iorder, &
              label='enclosed toroidal flux (xplasma_gen_torflx)',units='Wb')

         call xplasma_author_clear(s,xplasma_xmhd,iertmp)

         exit
      enddo
      deallocate(zrho,zg,zdvdrho,zr2i,ztf)

    end subroutine xplasma_gen_torflx

    subroutine xplasma_gen_p(s,pname,iorder,id_p,ier)

      !  create a P profile from equilibrium information-- this involves use
      !  of flux surface integrals, to solve the surface averaged 
      !  Grad-Shafronov equation JxB = grad(P)

      type (xplasma), pointer :: s

      character*(*), intent(in) :: pname  ! user selected name for profile
      integer, intent(in) :: iorder       ! fit order
      !  0 for piecewise linear, 1 for Hermite, 2 for Spline

      integer, intent(out) :: id_p        ! id of p profile created 
      integer, intent(out) :: ier         ! status code 0=OK

      !  if an error occurs, id_q=0 will be returned.

      !------------------------------
      integer :: id_rho,id_psi,id_g,id_R,id_integ,inrho,i,iertmp
      real*8, dimension(:), allocatable :: zrho,zg,zr2i,zarea,zp
      real*8, dimension(:), allocatable :: zpsi,zri,zx2r2i,zb2,zitor
      real*8 :: zmu0,zga,zr2ia,zria,zdpsidx,zdgdx,zx2r2ia,zb2a,zja,zjdotb
      real*8 :: zdpdxm
      real*8 :: get_jdotb_from_j   ! source/comput utility function
      real*8, parameter :: C2PI=6.2831853071795862D+00
      !------------------------------

      id_p=0
      call xplasma_common_ids(s,ier,id_psi=id_psi,id_g=id_g,id_R=id_R)
      if(ier.ne.0) return

      if(id_psi.eq.0) then
         ier=106
         call xplasma_errmsg_append(s,' ?xplasma_gen_q: no Psi(x) profile.')
      endif

      if(id_g.eq.0) then
         ier=106
         call xplasma_errmsg_append(s,' ?xplasma_gen_q: no R*Bphi(x) profile.')
      endif

      if(id_R.eq.0) then
         ier=106
         call xplasma_errmsg_append(s,' ?xplasma_gen_q: no R(theta,x).')
      endif
      if(ier.ne.0) return

      call xplasma_prof_info(s,id_R,ier, gridId2=id_rho)
      if(ier.ne.0) return

      call xplasma_grid_size(s,id_rho,inrho,ier)
      if(ier.ne.0) return

      allocate(zrho(inrho),zpsi(inrho),zg(inrho),zr2i(inrho),zp(inrho))
      allocate(zri(inrho),zx2r2i(inrho),zarea(inrho),zitor(inrho))

      do
         call xplasma_grid(s,id_rho,zrho, ier)
         if(ier.ne.0) exit

         !  get zpsi(:)=Psi(rho); get zg(:)=g(rho)

         call xplasma_eval_prof(s,id_psi,zrho,zpsi,ier)
         if(ier.ne.0) exit

         call xplasma_eval_prof(s,id_g,zrho,zg,ier)
         if(ier.ne.0) exit

         !  get (dV/drho); this also sets up the flux surface integrator

         call xplasma_arean(s,zrho,zarea,ier)
         if(ier.ne.0) exit

         call xplasma_find_item(s,"__RZ_RHO_INTEGRATOR", id_integ, ier)
         if(ier.ne.0) then
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_gen_q: xplasma_voln call failed to create integrator.')
            exit
         endif

         call xplasma_rho_zonint(s,id_integ,'<1/R^2>S',zr2i,ier)
         if(ier.ne.0) exit

         call xplasma_rho_zonint(s,id_integ,'<1/R>S',zri,ier)
         if(ier.ne.0) exit

         call xplasma_rho_zonint(s,id_integ,'<GRAD(RHO)^2/R^2>S',zx2r2i,ier)
         if(ier.ne.0) exit

         call xplasma_rho_zonint(s,id_integ,'ITOR',zitor,ier)
         zp(inrho)=0

         zmu0 = C2PI*2.0d-7

         do i=inrho-1,1,-1
            !  g, <1/R^2>, <1/R>, dPsi/dx, dg/dx, <grad(x)^2/R^2>, <B^2>, j
            zga=(zg(i)+zg(i+1))/2
            zr2ia=(zr2i(i)+zr2i(i+1))/2
            zria=(zri(i)+zri(i+1))/2
            zdpsidx=(zpsi(i+1)-zpsi(i))/(zrho(i+1)-zrho(i))
            zdgdx=(zg(i+1)-zg(i))/(zrho(i+1)-zrho(i))
            zx2r2ia=(zx2r2i(i)+zx2r2i(i+1))
            zb2a=zga*zga*zr2ia + zdpsidx*zdpsidx*zx2r2ia
            zja=(zitor(i+1)-zitor(i))/(zarea(i+1)-zarea(i))

            !  <j> -> <j.B>
            zjdotb = get_jdotb_from_j(zga,zr2ia,zb2a,zria,zja)

            ! -dP/dx

            zdpdxm = zb2a*zdgdx/(zmu0*zga) + zdpsidx*zjdotb/zga

            zp(i) = zp(i+1) + zdpdxm*(zrho(i+1)-zrho(i))
         enddo

         call xplasma_author_set(s,xplasma_xmhd,iertmp)

         call xplasma_create_prof(s,pname,id_rho,zp,id_p,ier, &
              ispline=iorder,label='P profile (xplasma_gen_p)',units='Pascals')

         call xplasma_author_clear(s,xplasma_xmhd,iertmp)

         exit
      enddo
      deallocate(zrho,zpsi,zg,zr2i,zri,zx2r2i,zarea,zp,zitor)

    end subroutine xplasma_gen_p
      
    subroutine xplasma_create_RZgrid(s,Rgrid,Zgrid,id_Rgrid,id_Zgrid,ier)

      !  create (R,Z) rectangular grid
      !  this should at least cover the plasma & limiters.
      !  the R grid should start at a point greater than zero.

      use eqi_rzbox_module

      type (xplasma), pointer :: s
      real*8, dimension(:), intent(in) :: Rgrid,Zgrid  ! R & Z grids
      integer, intent(out) :: id_Rgrid,id_Zgrid        ! ids returned
      integer, intent(out) :: ier

      !---------------------
      integer :: id_lim,itype,iwarn,inr,inz
      real*8 :: zrmin,zrmax,zzmin,zzmax
      character*128 zmsg
      !---------------------
      !  limiter must be defined first...

      call xplasma_find_item(s,'__LIMITER',id_lim,ier, nf_noerr=.TRUE.)
      if(ier.ne.0) return

      if(id_lim.eq.0) then
         ier=3004
         call xplasma_errmsg_append(s, &
              '  need to define limiter prior to specifying R & Z rectangle grid.')
         return
      endif

      inr=size(Rgrid)
      inz=size(Zgrid)
      call xplasma_lim_RZminmax(s,zRmin,zRmax,zZmin,zZmax,ier,itype=itype)
      if(ier.ne.0) return

      if((zRmin.lt.Rgrid(1)).or.(zRmax.gt.Rgrid(inr)).or. &
           (zZmin.lt.Zgrid(1)).or.(zZmax.gt.Zgrid(inz))) then
         iwarn=1
      else
         iwarn=0
      endif

      if(Rgrid(1).le.0.0d0) iwarn=2

      call xplasma_create_grid(s, &
           '__Rgrid',xplasma_R_coord,Rgrid,id_Rgrid,ier, &
           label="R grid")
      if(ier.ne.0) return

      call xplasma_create_grid(s, &
           '__Zgrid',xplasma_Z_coord,Zgrid,id_Zgrid,ier, &
           label="Z grid")
      if(ier.ne.0) return

      if(iwarn.ne.0) then
         ier=3006
         if(iwarn.eq.1) then
            zmsg=' '
            write(zmsg,*) ' Rmin & Rmax of limiter: ',zRmin,zRmax
            call xplasma_errmsg_append(s,zmsg)
            zmsg=' '
            write(zmsg,*) ' Rmin & Rmax of grid: ',Rgrid(1),Rgrid(inr)
            call xplasma_errmsg_append(s,zmsg)
            zmsg=' '
            write(zmsg,*) ' Zmin & Zmax of limiter: ',zZmin,zZmax
            call xplasma_errmsg_append(s,zmsg)
            zmsg=' '
            write(zmsg,*) ' Zmin & Zmax of grid: ',Zgrid(1),Zgrid(inz)
            call xplasma_errmsg_append(s,zmsg)
         endif
      else

         sp => s
         call xplasma_misc_set(s,ier, scrapeoff=.TRUE.)
         call eqi_xtrz(ier)

      endif

    end subroutine xplasma_create_RZgrid

    subroutine xplasma_max_maptype(s,maptype,ier)

      !  return the maximum maptype: 2 if there is no SOL; 3 if R&Z grids
      !  for SOL exist, so that bilinear maps can be constructed.

      type(xplasma), pointer :: s

      integer, intent(out) :: maptype
      integer, intent(out) :: ier

      !--------------------
      logical :: sol,axisymm
      !--------------------

      maptype=0

      call xplasma_global_info(s,ier, scrapeoff=sol,axisymm=axisymm)
      if(ier.ne.0) then
         sol=.FALSE.
         axisymm=.TRUE.
         return
      endif

      if(.not.axisymm) then
         ier=2509
         return
      endif

      if(sol) then
         maptype=3
      else
         maptype=2
      endif

    end subroutine xplasma_max_maptype

    ! DMC Apr 2011: surfgeo wrapper imported into xplasma module...
    ! original comments copied here...

    ! compute various flux surface parameters derived from the position of 
    ! the flux surface on the R,Z grid
    !
    ! the midplane intercepts are defined as the major radiaus at the height
    ! of the centroid of the flux surface.
    !
    ! the rho value will be forced to be larger then  1.e-5*(rho_bdy-rho_axis)
    !
    ! notes from gelong:
    !c
    !c> Date: Wed, 22 Sep 1999 11:59:40 -0400
    !c> From: Glenn Bateman <bateman@fusion.physics.lehigh.edu>
    !c> 	Consider a toroidal magnetic surface (also called a flux 
    !c>              surface).
    !c> Use the following variables
    !c>
    !c> R_out   = major radius to the outboard edge of the flux surface
    !c>           that is, the largest value of major radius anywhere on the 
    !c>           surface
    !c> R_in    = major radius to the inboard edge (ie, smallest value of major
    !c>           radius)
    !c> R_top   = major radius to the top edge of the flux surface
    !c>           that is, to the highest point on the flux surface cross 
    !c>           section
    !c> R_bottom = major radius to the lowest point on the flux surface
    !c> height  = distance between the elevations of the highest point
    !c>           and the lowest point
    !c> R_dent_in  = major radius to the most indented inboard part of the 
    !c>           surface;
    !c>           in cases where the flux surface is bean shaped
    !c>           with a dent on the inboard edge
    !c>           Note: R_dent_in = R_in whenever the flux surface is not 
    !c>                 indented
    !c> R_dent_out = major radius to the most indented outboard part of the 
    !c>           surface
    !c>
    !c> r_minor = half width = (R_out - R_in ) / 2     
    !c>           (usually called minor radius)
    !c> r_major = ( R_out + R_in ) / 2
    !c>           (usually called major radius)
    !c>
    !c> elongation:	kappa = height / ( R_out - R_in )
    !c>
    !c> tiangularity:	delta = ( r_major - min ( R_top, R_bottom ) ) / r_minor
    !c>
    !c> indentation:	indent = max ( ( R_dent_in - R_in ) / rminor ,
    !c> 			       ( R_dent_out - R_out ) / rminor )
    !c>
    !c> 	Note: for normal convex surfaces, indent = 0.0
    !c> For bean-shaped surfaces with indentation on inboard edge, indent > 0
    !c> For bean-shaped surfaces with indentation on outboard edge, indent < 0
    !c>
    !c> 	For surfaces with the point of the triangle facing outward,
    !c> delta > 0.0, while if the triangle points inward, delta < 0.0
    !c>
    !c> 	For vertically elongated surfaces, kappa > 1.0
    !c> For horizontally elongated surfaces, kappa < 1.0.
    !c>
    !c> squareness based on Holcomb Phys. Plasmas 16, 056116 (2009), see fig. 1
    !c>
    !c> Z_rmax = elevation where R==R_out
    !c>
    !c> Mikkelsen squareness attempts to match moment representation
    !c>
    !c>    R = Rmajor + Rminor*cos(theta + asin(triang)sin(theta))
    !c>    Z = Rmajor + elong*Rminor*sin(theta + square*sin(2*theta))
    !c>
    !c> by finding the point Rmk = R(pi/4.), interpolating from the boundary
    !c> data to Zmk and then using the moment representation at Z(pi/4.) to
    !c> derive the squareness.
    !c>

    subroutine xplasma_surfgeo(s, rho, &
         elong, triang, indent, &
         zmidp, rin_midp, rout_midp, &
         ierr, &
         ntheta, phival, auxdata, idebug)

      !------------------------------------
      type (xplasma), pointer :: s
      !------------------------------------

      ! NOTE: all 1d arrays must be of the same size;
      ! this size must also match size(auxdata,2) if auxdata is present

      real*8, dimension(:), intent(in) :: rho ! radial coord. of flux surfaces


      real*8, dimension(:), intent(out) :: elong    ! surface elongation
      real*8, dimension(:), intent(out) :: triang   ! triangularity
      real*8, dimension(:), intent(out) :: indent   ! indentation
      
      real*8, dimension(:), intent(out) :: zmidp    ! height of centroid
                                                    ! of each flux surface
      real*8, dimension(:), intent(out) :: rin_midp ! inner midplane intercept 
                                                    ! at centroid height
      real*8, dimension(:), intent(out) :: rout_midp ! outer midplane intercept
                                                    ! at centroid height

      !----------------
      integer, intent(out) :: ierr        ! completion status; 0=OK
      !----------------

      ! OPTIONAL arguments...

      integer, intent(in), optional :: ntheta ! #theta pts to evaluate
                                              ! (default 400)

      real*8, dimension(:), intent(in), optional :: phival  ! toroidal coord.
                                              ! of flux surfaces

      real*8, dimension(:,:), intent(out), optional :: auxdata  ! aux. outputs
                                          ! (item index, surface index)
                                          !   decoding of item index:
                                          ! 1  -> R_in
                                          ! 2  -> R_out
                                          ! 3  -> R_top
                                          ! 4  -> Z_top
                                          ! 5  -> R_bottom
                                          ! 6  -> Z_bottom
                                          ! 7  -> R_dent_in
                                          ! 8  -> R_dent_out
                                          ! 9  -> R_centroid
                                          ! 10 -> Z_centroid
                                          ! 11 -> lower Holcomb squareness
                                          ! 12 -> upper Holcomb squareness
                                          ! 13 -> Z_rmax
                                          ! 14 -> Rmk_low
                                          ! 15 -> Zmk_low
                                          ! 16 -> lower Mikkelsen squareness
                                          ! 17 -> Rmk_upp
                                          ! 18 -> Zmk_upp
                                          ! 19 -> upper Mikkelsen squareness
                                          !   NOTE: if actual index dimension
                                          !         is <19, there is no error:
                                          !         less information is output

      logical, intent(in), optional :: idebug   ! .TRUE. for extra debugging output


      !-------------------------------------------
      !  local declarations

      integer, parameter :: R8=SELECTED_REAL_KIND(12,100)
      integer, parameter :: ntheta_def = 400    ! default ntheta
      real*8,  parameter :: ZERO       = 0.0d0
      real*8,  parameter :: TWOPI      = 6.2831853071795862d0
      real*8,  parameter :: PI4        = TWOPI/8.d0
      real*8,  parameter :: RHOZERO    = 1.D-5  ! minimum allowed rho

      character*128 :: mline    ! for messages

      logical :: jdebug         ! .true. for some debug output

      real*8,  allocatable :: phi(:)
      real*8,  allocatable :: zrho(:),zphi(:),ztheta(:),zr(:),zz(:)
      real*8,  allocatable :: ar(:,:), az(:,:), locdata(:,:)
      integer, allocatable :: nregion(:)       ! xplasma region code

      integer :: i,iv        ! loop variable
      integer :: itheta      ! number of poloidal points

      real*8  :: rrmin       ! minimum allowed rmin
      real*8  :: tr,tz       ! temp

      integer :: ivec        ! 1d array dimension
      integer :: ivec_min,ivec_max  ! for error checking...
      !-------------------------------------------
      !  executable code

      !  clear output variables...

      ierr = 0
      elong = ZERO
      triang = ZERO
      indent = ZERO

      zmidp = ZERO
      rin_midp = ZERO
      rout_midp = ZERO

      if(present(auxdata)) auxdata = ZERO

      !-------------------------------
      !  dimension size check

      ivec_min = size(rho)
      ivec_max = ivec_min

      if(present(phival)) then
         ivec_min = min(ivec_min,size(phival))
         ivec_max = max(ivec_max,size(phival))
      endif

      if(present(auxdata)) then
         ivec_min = min(ivec_min,size(auxdata,2))
         ivec_max = max(ivec_max,size(auxdata,2))
      endif

      ivec_min = min(ivec_min,size(elong))
      ivec_min = min(ivec_min,size(triang))
      ivec_min = min(ivec_min,size(indent))

      ivec_min = min(ivec_min,size(zmidp))
      ivec_min = min(ivec_min,size(rin_midp))
      ivec_min = min(ivec_min,size(rout_midp))

      ivec_max = max(ivec_max,size(elong))
      ivec_max = max(ivec_max,size(triang))
      ivec_max = max(ivec_max,size(indent))

      ivec_max = max(ivec_max,size(zmidp))
      ivec_max = max(ivec_max,size(rin_midp))
      ivec_max = max(ivec_max,size(rout_midp))

      if(ivec_min.ne.ivec_max) then
         ierr=524
         mline = 'xplasma_rzgeo:xplasma_surfgeo argument array sizes do not match.'
         call xplasma_errmsg_append(s,mline)
         return
      endif

      !-------------------------------
      ! OK... array sizes match

      ivec = ivec_min ! = ivec_max

      !-------------------------------
      !  initial allocations...

      mline = ' '
      jdebug = .false.
      if(present(idebug)) jdebug=idebug

      if(.NOT.present(ntheta)) then
         itheta = ntheta_def
      else
         if (ntheta>16) then
            itheta = ntheta
         else
            itheta = ntheta_def
         endif
      endif

      allocate(phi(ivec))
      if(present(phival)) then
         phi = phival
      else
         phi = ZERO
      endif

      allocate(ar(itheta,ivec), az(itheta,ivec))
      allocate(zrho(itheta),ztheta(itheta),zphi(itheta))
      allocate(zr(itheta), zz(itheta), nregion(itheta))

      if(.NOT.present(auxdata)) then
         allocate(locdata(19,ivec))
      endif

      !
      ! i=1,itheta -> theta=0.0
      do i = 1, itheta-1
         ztheta(i) = TWOPI*(i-1)/(itheta-1)  ! equal steps in theta
      end do
      ztheta(itheta)=0.D0

      rrmin = RHOZERO

      !
      ! all exits through 999
      !
      do iv = 1, ivec
         !
         ! --- grab R,Z points ---
         !
         zrho = max(rho(iv),rrmin)
         zphi = phi(iv)

         nregion=0

         call xplasma_ctrans(s,.TRUE.,ierr, &
              rho_in=zrho, theta_in=ztheta, phi_in=zphi, &
              R_out=zR, Z_out=zZ, nregion=nregion)

         if (ierr/=0) then
            write(mline,'(a,f10.5)') &
                 ' ?xplasma_surfgeo: xplasma_ctrans returned error, rho = ',zrho(1)
            call xplasma_errmsg_append(s,trim(mline))
            ierr=9999
            go to 999
         endif
     
         if (maxval(nregion)>1) then
            write(mline,'(a,f10.5)') &
                 ' ?xplasma_surfgeo: surface is beyond magnetic coordinates, rho = ',zrho(1)
            call xplasma_errmsg_append(s,trim(mline))
            ierr=9999
            go to 999
         endif

         zr(itheta) = zr(1)   ! i=itheta is the same point as i=1
         zz(itheta) = zz(1)
     
         ar(:,iv) = zr
         az(:,iv) = zz
      end do

      if(present(auxdata)) then
         call surfgeo(itheta, ivec, ar, az, &
              elong, triang, indent, zmidp, rin_midp, rout_midp, &
              size(auxdata,1), auxdata, &
              jdebug, mline, ierr)
      else
         call surfgeo(itheta, ivec, ar, az, &
              elong, triang, indent, zmidp, rin_midp, rout_midp, &
              size(locdata,1), locdata, &
              jdebug, mline, ierr)
      endif

      if(ierr/=0) then
         call xplasma_errmsg_append(s,mline)
         call xplasma_errmsg_append(s,'error detected in xplasma_rzgeo(xplasma_surfgeo)')
         ierr=9999
         goto 999
      endif

999   continue
      deallocate(ar,az,zrho,ztheta,zphi,zr,zz,nregion,phi)
      if(.NOT.present(auxdata)) then
         deallocate(locdata)
      endif

    end subroutine xplasma_surfgeo

end module xplasma_rzgeo

subroutine eq_inquire_author(id,zauth,ier)

  ! find the author of an existing item

  use xplasma_obj_instance
  use eq_module

  implicit NONE

  integer, intent(in) :: id
  character*(*), intent(out) :: zauth
  integer, intent(out) :: ier

  !---------------------------------------
  integer :: iertmp
  !---------------------------------------

  call xplasma_get_item_info(s,id,ier, author=zauth)
  if(ier.ne.0) then
     write(lunerr,*) ' ?eq_inquire_author: error code detected.'
     call xplasma_error(s,ier,lunerr)
     return
  endif

end subroutine eq_inquire_author

program genxpl
  !
  !  this program allows an xplasma representation of a user specified
  !  equilibrium and profile set to be created.  Then outputs (e.g. as
  !  required for reflectometry calculations) can be generated as well.
  !
  !----------------------------------

  implicit NONE

  !----------------------------------
  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: HALF = 0.5d0
  real*8, parameter :: ONE  = 1.0d0
  real*8, parameter :: C2PI = 6.2831853071795862D+00
  real*8, parameter :: EPS6 = 1.0d-6

  !  labeling info
  character*30, parameter :: glabel = "GENXPL:analytic_profiles"
  character*30, parameter :: gtmplab = "GENXPL:temporary"
  character*30 cur_label

  real*8, parameter :: ztime = ZERO
  real*8, parameter :: ztavg = ZERO

  !  -------shape-------
  real*8 :: R0_mp   ! major radius (geometric center of plasma midplane) (m)
  real*8 :: a_mp    ! minor radius (plasma midplane half width) (m)
  real*8 :: ellip   ! ellipticity (b/a) (dimensionless)
  real*8 :: shift   ! relative axis shift (profile: 1-x**2) (dimensionless)

  !  -------field-------
  real*8 :: B0_vac  ! vacuum B field at R0_mp (T)
  real*8 :: q0,qa   ! q profile (dimensionless)
  real*8 :: g0,ga   ! para/diamagnetism (dimensionless)
  !                          i.e. deviation from vacuum field;
  !                          B(x,theta) = R0_mp*B0_vac*g(x)/R(x,theta)
  integer :: nsnccwi,nsnccwb   ! ccw flags for Itor, Btor...
  logical :: pol_field         ! .TRUE. to include poloidal field

  !  -------numerics-------
  real*8 :: extra   ! (extra-1)*a_mp = amount of (R,Z) enclosing rectangle
  !                   beyond plasma boundary (dimensionless)

  integer :: nx     ! no. of x grid pts to use
  integer :: nth    ! no. of theta grid pts to use

  !----------------------------------
  !  working quantities...

  real*8, dimension(:), allocatable :: g,q,polflx,torflx,x,xfs,xflux,th
  real*8, dimension(:), allocatable :: dx,dvol,xfs_new,zr2i,wk1,wk2
  integer, dimension(:), allocatable :: iwk
  real*8, dimension(:,:), allocatable :: Rarr,Zarr

  real*8 r,zth,zmax,tflux
  integer ix,ith,ierr,ixn,niter,nok,inx
  integer :: id_rho=0,id_chi=0,id_R=0,id_Z=0,id=0

  real*8 rdum(1),zdum(1),rlin(4),zlin(4),thlin(4),extrap

  !----------------------------------
  !  xplasma field extrapolator

  external eqm_brz_adhoc

  !----------------------------------
  !  uread; tty i/o

  logical lxout,lchar
  integer lnout,luntty
  real*8 ztmp

  !----------------------------------
  !  UREAD initialization

  call uinitg("GENXPL")
  luntty = lnout(0)

  !----------------------------------
  !  defaults...

  !  ...geometry:
  R0_mp = 2.5d0
  a_mp = 0.9d0
  ellip = ONE
  shift = ZERO

  !  ...field:
  B0_vac = 5.0d0
  nsnccwi = 1
  nsnccwb = 1

  q0 = ONE
  qa = 5.0d0
  pol_field = .TRUE.

  g0 = ONE
  ga = ONE

  !  ...numerical options:
  nx = 101
  nth = 101
  extra = 1.05d0

  !----------------------------------
  !  interactive user modifications to parameters...

1000 continue

  do
     if(lxout(0)) then
        write(luntty,1001)
1001    format(/ &
             ' genxpl main options:'/ &
             '  "A" -- set plasma shape (geometry)'/ &
             '  "B" -- set magnetic field'/ &
             '  "N" -- set numerical controls'/ &
             '  "P" -- print current settings'/ &
             '  "Q" -- QUIT, i.e. EXIT program.'/ &
             '  "X" -- execute (xplasma setup; plotting and ouput options).'/ &
             '         Te and ne will be specified after xplasma setup.'/)
     endif
     call uread('genxpl: please specify desired menu option:$')

     if(lchar('A')) then
        call set_shape
     else if(lchar('B')) then
        call set_field
     else if(lchar('N')) then
        call set_numerics
     else if(lchar('P')) then
        call printout
     else if(lchar('Q')) then
        call uexita(0)
        stop
     else if(lchar('X')) then
        exit
     else
        call uermsg(' ?GENXPL: unrecognized menu option:',' ',0)
     endif
  enddo

  !----------------------------------
  !  set up initial xplasma geometry; iterate to find x ~ sqrt(tor.flux)

  allocate(x(nx),xfs(nx),xflux(nx),g(nx),q(nx),polflx(nx),torflx(nx),th(nth))
  allocate(dx(nx-1),dvol(nx-1),zr2i(nx))
  allocate(Rarr(nth,nx),Zarr(nth,nx))

  x(1)=ZERO; x(nx)=ONE
  g(1)=g0;   g(nx)=ga
  q(1)=q0;   q(nx)=qa
  Rarr(1:nth,1)=R0_mp + a_mp*shift; Zarr(1:nth,1)=ZERO

  do ix=2,nx-1
     x(ix)=(ix-1)*ONE/(nx-1)
     g(ix)=(g0-ga)*(ONE-x(ix)**2)**2 + ga
     q(ix)=(q0-qa)*(ONE-x(ix)**2) + qa
  enddo

  do ix=2,nx
     dx(ix-1)=x(ix)-x(ix-1)
     r=x(ix)*a_mp
     do ith=1,nth
        zth=(ith-1)*C2PI/(nth-1)
        th(ith)=zth
        Rarr(ith,ix)=R0_mp + a_mp*shift*(ONE-x(ix)**2) + r*cos(zth)
        Zarr(ith,ix)=ellip*r*sin(zth)
     enddo
  enddo

  if(pol_field) then
     cur_label=gtmplab
  else
     cur_label=glabel
  endif
  call eqm_select(cur_label,1)
  call eqm_time(ZERO)

  call eqm_rho(x,nx,EPS6,id_rho,ierr)
  if(ierr.ne.0) call errmsg_exit('?genxpl: unexpected eqm_rho failure.')

  call eqm_chi(th,0,nth,EPS6,id_chi,ierr)
  if(ierr.ne.0) call errmsg_exit('?genxpl: unexpected eqm_chi failure.')

  call eqm_rzmag(Rarr,Zarr,nth,nx,2,id_R,id_Z,ierr)
  if(ierr.ne.0) call errmsg_exit('?genxpl: unexpected eqm_rzmag failure.')

  if(pol_field) then
     !  find the location of flux surfaces that give equal steps in 
     !  sqrt toroidal flux (skipped if no poloidal field is present)

     xfs=x
     niter=0
     nok=0
     do
        call eq_flxint_init(0,nx,xfs,EPS6,ierr)
        if(ierr.ne.0) call errmsg_exit( &
             '?genxpl: unexpected eq_flxint_init failure.')

        call eq_flxint('DVOL',1,dvol,1,nx-1,ierr)
        if(ierr.ne.0) call errmsg_exit( &
             '?genxpl: unexpected eq_flxint_init(dvol) failure.')

        call eq_flxint('<1/R^2>S',1,zr2i,1,nx,ierr)
        if(ierr.ne.0) call errmsg_exit( &
             '?genxpl: unexpected eq_flxint_init(zr2i) failure.')

        xflux(1)=ZERO
        do ix=2,nx
           xflux(ix)=xflux(ix-1)+R0_mp*B0_vac*HALF*(g(ix-1)+g(ix))* &
                HALF*(zr2i(ix-1)+zr2i(ix))*dvol(ix-1)/c2pi
        enddo
        tflux = xflux(nx)
        xflux = xflux/xflux(nx)
        xflux = sqrt(xflux)

        zmax=maxval(abs(xflux-x))
        write(luntty,*) ' iteration = ',niter,' rho deviation = ',zmax
        if(zmax.le.EPS6) then
           nok=nok+1
           if(nok.ge.3) exit
        endif

        niter=niter+1
        if(niter.gt.100) then
           call errmsg_exit( &
                '?genxpl: too many iterations seeking equispaced sqrt(phi/philim) grid')
        endif

        allocate(xfs_new(nx))
        xfs_new(1)=ZERO
        xfs_new(nx)=ONE
        inx=1
        do ix=2,nx-1
           do
              if(xflux(inx+1).lt.x(ix)) then
                 inx=inx+1
                 cycle
              else
                 exit
              endif
           enddo
           xfs_new(ix)=(xfs(inx)*(xflux(inx+1)-x(ix)) + &
                xfs(inx+1)*(x(ix)-xflux(inx)))/(xflux(inx+1)-xflux(inx))
        enddo
        xfs=xfs_new
        deallocate(xfs_new)
     enddo
     !
     !  OK -- redefine geometry to have surfaces in equal steps of 
     !  sqrt(tor.flux)
     !
     allocate(wk1(nth),wk2(nth),iwk(nth))
     wk2=ZERO  ! phi coord.
     do ix=2,nx-1
        wk1=xfs(ix)  ! old x...
        call eq_rzget(nth,wk1,th,wk2,Rarr(1:nth,ix),Zarr(1:nth,ix),iwk,ierr)
        if(ierr.ne.0) call errmsg_exit( &
             '?genxpl: unexpected eq_RZget failure.')
     enddo
     deallocate(wk1,wk2,iwk)
        
     cur_label=glabel

     call eqm_select(cur_label,1)
     call eqm_time(ZERO)

     call eqm_rho(x,nx,EPS6,id_rho,ierr)
     if(ierr.ne.0) call errmsg_exit('?genxpl: unexpected eqm_rho failure.')

     call eqm_chi(th,0,nth,EPS6,id_chi,ierr)
     if(ierr.ne.0) call errmsg_exit('?genxpl: unexpected eqm_chi failure.')

     call eqm_rzmag(Rarr,Zarr,nth,nx,2,id_R,id_Z,ierr)
     if(ierr.ne.0) call errmsg_exit('?genxpl: unexpected eqm_rzmag failure.')

  else
     !  no poloidal field; still want toroidal flux
     call eq_flxint_init(0,nx,x,EPS6,ierr)
     if(ierr.ne.0) call errmsg_exit( &
          '?genxpl: unexpected eq_flxint_init failure.')

     call eq_flxint('DVOL',1,dvol,1,nx-1,ierr)
     if(ierr.ne.0) call errmsg_exit( &
          '?genxpl: unexpected eq_flxint_init(dvol) failure.')

     call eq_flxint('<1/R^2>S',1,zr2i,1,nx,ierr)
     if(ierr.ne.0) call errmsg_exit( &
          '?genxpl: unexpected eq_flxint_init(zr2i) failure.')

     xflux(1)=ZERO
     do ix=2,nx
        xflux(ix)=xflux(ix-1)+R0_mp*B0_vac*HALF*(g(ix-1)+g(ix))* &
             HALF*(zr2i(ix-1)+zr2i(ix))*dvol(ix-1)/c2pi
     enddo
     tflux = xflux(nx)

  endif

  !----------------------------------------------------------
  !  OK geometry is defined; add the field information...

  call eq_ganum('__RHO',id_rho)

  call eqm_rhofun(2,id_rho,'g',R0_mp*B0_vac*g,1,ZERO,1,ZERO,id,ierr)
  if(ierr.ne.0) call errmsg_exit('?genxpl: unexpected eqm_rhofun(g) failure.')

  call eqm_rhofun(2,id_rho,'q',q,1,ZERO,0,ZERO,id,ierr)
  if(ierr.ne.0) call errmsg_exit('?genxpl: unexpected eqm_rhofun(q) failure.')

  call eqm_rhofun(2,id_rho,'torflx',x*x*tflux,1,ZERO,0,ZERO,id,ierr)
  if(ierr.ne.0) call errmsg_exit( &
       '?genxpl: unexpected eqm_rhofun(torflx) failure.')

  polflx(1)=ZERO
  do ix=2,nx
     polflx(ix)=polflx(ix-1)+dx(ix-1)*(x(ix)+x(ix-1))*tflux/ &
          ((q(ix)+q(ix-1))*(C2PI*HALF))
  enddo

  call eqm_rhofun(2,id_rho,'psi',polflx,1,ZERO,0,ZERO,id,ierr)
  if(ierr.ne.0) call errmsg_exit( &
       '?genxpl: unexpected eqm_rhofun(polflx) failure.')

  !----------------------------------------------------------
  !  define the limiter (rectangular box limiter)
  extrap=(extra-1)*a_mp

  Rlin(1:2)=R0_mp-a_mp-extrap
  Zlin(1:2)=ellip*a_mp+extrap
  Rlin(3:4)=R0_mp+a_mp+extrap
  Zlin(3:4)=-ellip*a_mp-extrap
  thlin(1)=ZERO
  thlin(3)=ZERO
  thlin(2)=90
  thlin(4)=90

  call eqm_tbdy_grid(4,Rlin,Zlin,thlin, &
       0,rdum,zdum,rdum, &
       2*nx,2*nx,id_R,id_Z,ierr)
  if(ierr.ne.0) call errmsg_exit('?genxpl: unexpected eqm_tbdy_grid failure.')

  !----------------------------------------------------------
  !  compute interior field

  call eqm_bset(nsnccwb,nsnccwi)

  !----------------------------------------------------------
  !  compute field extrapolation

  call eqm_brz(eqm_brz_adhoc, ZERO, ierr)
  if(ierr.ne.0) call errmsg_exit('?genxpl: unexpected eqm_brz failure.')

  !----------------------------------------------------------
  !  xplasma setup done; get Te and ne & write Reflectometry data

  do
     if(lxout(0)) then
        write(luntty,1005)
1005    format(/ &
             ' xplasma equilibrium & field complete.'/ &
             ' genxpl post-xplasma options:'/ &
             '  "P" -- plot xplasma contents'/ &
             '  "R" -- specify Te & ne; write reflectometry data.'/ &
             '  "Q" -- QUIT, i.e. go back to start of program.'/ &
             )
     endif
     call uread('genxpl: please specify post-xplasma option:$')

     if(lchar('P')) then
        call eqdbg_plot

     else if(lchar('R')) then
        call trxpl_fwr2d_cdf(glabel,ztime,ztavg)

     else if(lchar('Q')) then
        go to 1000

     else
        call uermsg(' ?GENXPL: unrecognized menu option:',' ',0)
     endif
  enddo

  deallocate(x,xfs,xflux,g,q,polflx,torflx,th,dx,dvol,zr2i,Rarr,Zarr)
  go to 1000  ! back to top...


  contains

    !-------------------------------------------------

    subroutine printout
      call print_shape
      call print_field(0)
      call print_numeric
    end subroutine printout

    subroutine print_shape
      write(luntty,1101) 'Midplane Major Radius','R0_mp',R0_mp,'(m)'
      write(luntty,1101) 'Midplane Minor Radius','a_mp',a_mp,'(m)'
      write(luntty,1101) 'Ellipticity','ellip',ellip,'(-)'
      write(luntty,1101) 'Relative axial shift','shift',shift,'(-)'
1101 format(1x,a,t30,a8,' = ',1pe11.4,1x,a)
      write(luntty,*) ' '
    end subroutine print_shape

    subroutine print_field(iarg)
      integer, intent(in) :: iarg   ! =1 to print major radius
      if(iarg.eq.1) then
         write(luntty,1101) 'Midplane Major Radius','R0_mp',R0_mp,'(m)'
      endif
      write(luntty,1101) 'Vacuum Field at R0_mp','B0_vac',B0_vac,'(T)'
      write(luntty,1101) 'B_tor/B_vac on axis','g0',g0,'(-)'
      write(luntty,1101) 'B_tor/B_vac at edge','ga',ga,'(-)'
      write(luntty,*) '  g(x) = (g0-ga)*(1-x**2)**2 + ga'
      write(luntty,1101) 'q on axis','q0',q0,'(-)'
      write(luntty,1101) 'q at edge','qa',qa,'(-)'
      write(luntty,*) '  q(x) = (q0-qa)*(1-x**2) + qa'
      write(luntty,*) &
           '  nsnCCWx = 1 means "counter-clockwise viewed from above".'
      write(luntty,1102) 'toroidal field direction','nsnCCWb',nsnccwb
      write(luntty,1102) 'toroidal current direction','nsnCCWi',nsnccwi
1101 format(1x,a,t30,a8,' = ',1pe11.4,1x,a)
1102 format(1x,a,t30,a8,' = ',i2)
      write(luntty,*) ' '
    end subroutine print_field

    subroutine print_numeric
      write(luntty,1191) nx,nth
1191  format(' Number of x points in radial profiles:  ',i4/ &
           ' Number of poloidal grid (theta) points: ',i4)
      write(luntty,1192) extra
      write(luntty,1193) (extra-ONE)*a_mp
1192  format(' Minor radius expansion factor to define (R,Z) rectangle:', &
           1pe11.4)
1193  format(' expansion of (R,Z) rectangle beyond plasma boundary:', &
           1pe11.4,' (m)')
      write(luntty,*) ' '
    end subroutine print_numeric

    !-------------------------------------------------
      
    subroutine set_shape
      do
         if(lxout(0)) then
            call print_shape
            write(luntty,1201)
1201        format(/' (the code imposes "sanity limits" on all values)'// &
                 ' "R" -- set R0_mp'/ &
                 ' "A" -- set a_mp'/ &
                 ' "E" -- set ellipticity'/ &
                 ' "S" -- set shift'/ &
                 ' "Q" -- quit this menu (accept current values)'/)
         endif
         call uread('genxpl: set_shape option:$')
         if(lchar('R')) then
            call ugr8rng(1.0d-2,1.0d2,'genxpl: enter R0_mp value:$',R0_mp)
            a_mp=max(1.0d-2*r0_mp,a_mp)
            a_mp=min(0.95d0*r0_mp,a_mp)
         else if(lchar('A')) then
            call ugr8rng(1.0d-2*r0_mp,0.95d0*r0_mp, &
                 'genxpl: enter a_mp value:$',a_mp)
         else if(lchar('E')) then
            call ugr8rng(0.1d0,10.0d0,'genxpl: enter ellip value:$',ellip)
         else if(lchar('S')) then
            call ugr8rng(ZERO,0.7d0,'genxpl: enter shift value:$',shift)
         else if(lchar('Q')) then
            exit
         else
            call uermsg('?genxpl: set_shape menu: unrecognized option.',' ',0)
         endif
      enddo
    end subroutine set_shape

    !-------------------------------------------------

    subroutine set_field
      logical lyes
      do
         if(lxout(0)) then
            call print_field(1)
            write(luntty,1301)
1301        format(/' (the code imposes "sanity limits" on all values)'// &
                 ' "B" -- set B0_vac'/ &
                 ' "G" -- set g profile'/ &
                 ' "H" -- set q profile'/ &
                 ' "K" -- kill the poloidal field (make q very large)'/ &
                 ' "N" -- set directions of Btor and Itor'/ &
                 ' "Q" -- quit this menu (accept current values)'/)
         endif
         call uread('genxpl: set_field option:$')
         if(lchar('B')) then
            call ugr8rng(1.0d-3,1.0d3,'genxpl: vacuum Btor at R0_mp:$',B0_vac)
         else if(lchar('G')) then
            ga=ONE
            call ugr8rng(0.1d0,2.0d0,'genxpl: B/Bvac at plasm axis:$',g0)
         else if(lchar('H')) then
            call ugr8rng(0.5d0,10.0d0,'genxpl: q on axis:$',q0)
            call ugr8rng(0.1d0,200.0d0,'genxpl: q at edge:$',qa)
            pol_field=.TRUE.
         else if(lchar('K')) then
            q0=1.0d20
            qa=1.0d20
            pol_field=.FALSE.
         else if(lchar('N')) then
            call uread( &
                 'genxpl: enter "Y" to make Btor CCW viewed from above:$')
            if(lyes(0)) then
               nsnccwb=1
            else
               nsnccwb=-1
            endif
            call uread( &
                 'genxpl: enter "Y" to make Itor CCW viewed from above:$')
            if(lyes(0)) then
               nsnccwi=1
            else
               nsnccwi=-1
            endif
         else if(lchar('Q')) then
            exit
         else
            call uermsg('?genxpl: set_numerics menu: unrecognized option.', &
                 ' ',0)
         endif
      enddo
    end subroutine set_field

    !-------------------------------------------------

    subroutine set_numerics
      do
         if(lxout(0)) then
            call print_numeric
            write(luntty,1401)
1401        format(/' (the code imposes "sanity limits" on all values)'// &
                 ' "E" -- set (R,Z) rectangle expansion factor'/ &
                 ' "N" -- set size of radial working grids'/ &
                 ' "Q" -- quit this menu (accept current values)'/)
         endif
         call uread('genxpl: set_numerics option:$')
         if(lchar('E')) then
            call ugr8rng(1.01d0,1.5d0,'genxpl: expansion factor:$',extra)
         else if(lchar('N')) then
            call ureadi('genxpl: nx (btw 21 and 1001):$',nx)
            nx=max(21,min(1001,nx))
            call ureadi('genxpl: nth (btw 21 and 1001):$',nth)
            nth=max(21,min(1001,nth))
         else if(lchar('Q')) then
            exit
         else
            call uermsg('?genxpl: set_numerics menu: unrecognized option.', &
                 ' ',0)
         endif
      enddo
    end subroutine set_numerics

    !-------------------------------------------------

end program genxpl

!  ** dummy subroutine ** (for trxpl_fwr2d_cdf)

subroutine trxpl_add_profile(zname)
  character*(*), intent(in) :: zname

  call errmsg_exit( &
       ' ?genxpl: unexpected call to trxpl_add_profile("'//zname//'")')

end subroutine trxpl_add_profile

module eqm_mds_fromgeqdsk_mod
  use xplasma2_calls
contains
subroutine eqm_mds_fromgeqdsk(label,zfile,ns,nt1,fbdy,cbdy,irz, &
     ier)

  !  make an xplasby X.Zhang (PPPL)ma equilibrium representation from contents of
  !  a G-EQDSK file or MDSplus EFIT data.  This is done by finding an
  !  appropriately spaced set of fieldline contours psi=constant from
  !  EFIT's psi(R,Z) data.

  !  dmc Feb. 2001

  use xplasma2_calls
  implicit NONE

  character*(*), intent(in) :: label     ! xplasma eq. label
  character*(*), intent(in) :: zfile     ! path to G-EQDSK file / MDSplus
 
  integer, intent(in) :: ns              ! no. of surfaces incl. axis
         ! abs(ns)= no. of surfaces; if ns.lt.0 use Hermite fit for surfaces
 
  integer, intent(in) :: nt1             ! abs(nt1) = no. of theta pts /surface
  !  sign(nt1): +1 for traditional moments; -1 for moments based on equal arc
  !                                            theta definition
 
  integer, intent(in) :: irz             ! =1 for B(R,Z) calculation
 
  real*8, intent(in) :: fbdy             ! bdy back-off parameter (to start)
  real*8, intent(in) :: cbdy             ! min. curvature parameter
 
  integer, intent(out) :: ier            ! completion code, 0=OK

  !----------------------------------------------

  integer :: icur_psi = 0
  real*8, parameter :: xbrki = 0.9d0

  !----------------------------------------------

  call eqm_mds_fromgeqdsk_iadj(label,zfile,ns,nt1,fbdy,cbdy,icur_psi,xbrki,irz, &
     ier)

end subroutine eqm_mds_fromgeqdsk

subroutine eqm_mds_fromgeqdsk_iadj(label,zfile,ns,nt1,fbdy,cbdy, &
     icur_psi,xbrki,irz, &
     ier)

  !  make an xplasma equilibrium representation from contents of
  !  a G-EQDSK file or MDSplus EFIT data.  This is done by finding an
  !  appropriately spaced set of fieldline contours psi=constant from
  !  EFIT's psi(R,Z) data.

  !  dmc Feb. 2001
  use xplasma2_calls
  use xplasma_obj
  use xplasma_obj_instance, only: s
  use xplasma_obj_instance_mod
  use eq_module
  implicit NONE
  character*(*), intent(in) :: label     ! xplasma eq. label
  character*(*), intent(in) :: zfile     ! path to G-EQDSK file / MDSplus
 
  integer, intent(in) :: ns              ! no. of surfaces incl. axis
         ! abs(ns)= no. of surfaces; if ns.lt.0 use Hermite fit for surfaces
 
  integer, intent(in) :: nt1             ! abs(nt1) = no. of theta pts /surface
  !  sign(nt1): +1 for traditional moments; -1 for moments based on equal arc
  !                                            theta definition
 
  integer, intent(in) :: icur_psi        ! =0: use EFIT file data QPSI for
  ! q(psi) and EFIT file data CURRENT_A for total enclosed toroidal current;
  ! =1:  discard file values and re-derive q(psi) and enclosed current from
  ! analysis of the Psi(R,Z) data.

  ! Advice: if the Psi(R,Z) data in the EFIT input is from a high quality
  ! free boundary GS solution, icur_psi=1 is better; if not, icur_psi=0 is
  ! better.  EFIT datasets extracted from TRANSP time slices are not based
  ! on a free boundary solution, and, icur_psi=0 should be used.

  !  Most experimental EFIT data can be safely processed either way.

  real*8, intent(in) :: xbrki            ! break location for current profile;
  !  enclosed toroidal current is a smooth parabolic interpolation to the 
  !  edge value, matching point and slope with the current profile computed
  !  from Psi(R,Z), at normalized toroidal flux (xbrki).  Recommended value
  !  is: xbrki=0.9; constraint: 0.75 <= xbrki <= 0.95.

  integer, intent(in) :: irz             ! =1 for B(R,Z) calculation
 
  real*8, intent(in) :: fbdy             ! bdy back-off parameter (to start)
  real*8, intent(in) :: cbdy             ! min. curvature parameter
 
  integer, intent(out) :: ier            ! completion code, 0=OK

  !----------------------------------------------

  !  input arguments
  !  ---------------

  !  label ~ 30 characters -- a label for xplasma

  !  zfile - a file path, e.g. /u/efit/nstx/g123456_6800.eqdsk
  !         i.e. a path to a single EFIT G-EQDSK file...

  !               --or--

  !     EFIT_INDEX:<file-path>(<index>)

  !       where <file-path> is [<directory-path>/]<filename>
  !       gives an "EFIT INDEX ascii file" that associates a set of time
  !       points with a set of separate G-EQDSK files; the file format
  !       is illustrated in this example; "|" denotes start of each text
  !       lines:

  !         |ntimes=4
  !         |path='/pub/outgoing/pshare'
  !         |time=0.15   filename=g008500.00150
  !         |time=0.20   filename=g008500.00200
  !         |time=0.25   filename=g008500.00250
  !         |time=0.294  filename=g008500.00294

  !      and the listed files are G-EQDSK files associated with each time.
  !      The times *must* be in ascending order.

  !      The full path to each G-EQDSK file will be <directory-path>/<filename>
  !      where <directory-path> is what leads to the index file itself (i.e.
  !      the index file and the G-EQDSK files are expected all to be in the
  !      same directory; the path record in the index file is *ignored*).

  !      The field <index> should decode as integer and refers to the
  !      time index; 1 => 1st time, 2 => 2nd time, etc.

  !               --or--

  !          an MDSplus path:

  !     MDS+[/reduce|/noreduce]:<server[:port]|LOCAL>:<tree>(<shot>;t=<time>)

  !    where the initial MDS+ specifies MDSplus not a file;

  !    /reduce means just read the specified timeslice (this is the default)
  !    /noreduce means read and cache data from all available EFIT times

  !    <server...> specifies the MDSplus server, can be "LOCAL"
  !                or "CONNECTED", which means the server connection has
  !                already been made

  !    <tree> specifies the MDSplus tree, e.g. "EFIT01" or "EFIT02"
  !           value can be "OPENED", which means, the tree is already open.
  !           if value "OPENED" is provided, the correct shot number should
  !           still be provided, for information/identification purposes.

  !    <shot> specifies the MDSplus (or experiment) shot number
  !    <time> is an ascii encoding of the currently desired time of interest

  !       examples of valid MDSplus paths:

  !       1.  MDS+:LOCAL:EFIT01(104370;t=0.15)
  !       2.  MDS+:CONNECTED:OPENED(104370;t=0.15)
  !       3.  MDS+/reduce:europa.pppl.gov:8501:EFIT01(104370;t=1.0e-1)
  !       4.  MDS+/noreduce:cmoda.psfc.mit.edu:EFIT09(123456789;t=2.3)

  !     notes:  => in cases 3 & 4, the code connects to the server, opens
  !             the tree, reads the data, closes the tree, and disconnects
  !             from the server.
  !             => in case 1, the code opens the tree, reads the data, and
  !             closes the tree.
  !             => in case 2, the code just reads the data; the caller is
  !             expected to have taken care of any MDS+ connect or open 
  !             operations.

  !  ns -- abs(ns)=number of surfaces, spaced in equal steps of sqrt(tor.flux),
  !       to be generated in the xplasma representation, from the EFIT data
  !       if ns.lt.0, use Hermite instead of Spline fits for R(rho,chi),
  !       Z(rho,chi), and B(rho,chi) components computed in xplasma
  !       NOTE: spline is still calculated; it is replaced with a Hermite
  !       representation.

  !  nt1 -- abs(nt1) = number of theta points per surface in the xplasma 
  !         representation; sign(nt1) = -1 for moments based on equal arc
  !         definition of theta; +1 for traditional VMEC/descur power
  !         spectrum minimization definition
  !         

  !  fbdy -- delta_psi(use)/delta_psi(EFIT-bdy), btw 0.95 and 1.00
  !         use this to specify a plasma boundary "slightly in from" the
  !         plasma boundary given by EFIT.

  !    note that eqi_fromgeqdsk will also back off from the nominal EFIT
  !    boundary, if when calculating its fieldline contour it is found not
  !    to close.  So:  fbdy=1.0d0 as input is safe and usually desirable.

  !  cbdy -- minimum allowed boundary contour local curvature, normalized
  !    to boundary midplane half radius.  Setting this .gt.0 is another way
  !    to bind the boundary surface away from the separatrix-- the software
  !    will automatically reduce delta_psi(use) as needed to satisfy this
  !    condition.

  !  irz -- =1: extend the xplasma representation and coordinate scheme to
  !    cover EFIT's R,Z box; define psi(R,Z), B(R,Z) as xplasma objects
  !         =0: just form R(theta,rho),Z(theta,rho), psi(rho), g(rho), q(rho)
  !    P(rho) but do not save the (R,Z) information.
  !    ...irz=1 requires more work

  !----------------

  !  output argument:  ier=0 denotes success

  !    if successful, xplasma interpolation routines are available for
  !    evaluation of metrics, field, g, q, etc.,

  !----------------
  integer :: iertmp,iwarn,ikmom,ibrki
  real*8, parameter :: mom_rtol = 1.0d-6
  real*8, parameter :: xbrk_ax0 = 0.15d0
  !----------------
  !  access the EFIT data; build xplasma

  call xoi_init(ier)
  if(ier.ne.0) write(lunerr,*)&
       ' ?eqm_select: xplasma_init returned ier = ',ier
  eq_module_init = .TRUE.
  call xoi_kmom_get(ikmom)
  call xplasma_kmom_set(s,ikmom,ier)  ! error not checked...
 
  call xplasma_init(s,label,ier)
  if(ier.ne.0) write(lunerr,*)&
       ' ?eqm_select: xplasma_init returned ier = ',ier
  
  call xoi_author_set(iertmp)

  call xplasma_mds_fromgeqdsk(s,zfile,ier, &
       new_device=.TRUE., nrho=abs(ns), nth=abs(nt1), &
       bdy0=fbdy, cratio_min=cbdy, rzspace = (irz.eq.1), &
       kpsi_cur=icur_psi, rho_curbreak=xbrki, &
       kmom = ikmom, mom_rtol=mom_rtol, rhobrk_adj_axis = xbrk_ax0, &
       equal_arc = (nt1.lt.0), lhermite = (ns.lt.0) )

  call xoi_author_clear(iertmp)

  call eqi_mds_fromg_warn(iwarn)
  if((iwarn.gt.0).or.(ier.ne.0)) call xplasma_error(s,ier,lunerr)

#ifdef __DEBUG
  call eqdbg_plot
#endif

end subroutine eqm_mds_fromgeqdsk_iadj
subroutine eqm_geqdsk_ppadj(ier)

  !  Replace presure profile (based on P(psi) from G-eqdsk file originally)
  !  Use P(bdy) and integrate inward using dP/dPsi with a finite difference
  !  approximation.  The profile "DPDPSI" must be defined.  The original
  !  "P" profile is renamed "P_ORIG".

  use xplasma2_calls
  use xplasma_obj_instance
  use xplasma_obj_instance_mod
  use xplasma_fromgeq
  use eq_module
  implicit NONE

  integer, intent(out) :: ier
  !----------------------------------
  integer :: iertmp
  !----------------------------------

  call xoi_author_set(iertmp)

  call xplasma_geqdsk_ppadj(s,ier)
  if(ier.ne.0) then
     write(lunerr,*) ' ?eqm_geqdsk_ppadj: xplasma routine reports error:'
     call xplasma_error(s,ier,lunerr)
  endif

  call xoi_author_clear(iertmp)

#ifdef __DEBUG
  call eqdbg_plot
#endif

end subroutine eqm_geqdsk_ppadj
  ! module with routines that help to create various types of xplasma profiles
  subroutine xplasma_mds_fromgeqdsk(s,filename,ier, &
       new_device, nrho, nth, i2pi, lhermite, &
       bdy0, cratio_min, rzspace, &
       kpsi_cur,rho_curbreak, &
       kmom, rhobrk_adj_axis, mom_rtol, &
       equal_arc, &
       gs_errmax)
    
  use xplasma2_calls
  use xplasma_obj
  use eqi_rzbox_module

  implicit NONE
  
    
    ! (re)build equilibrium inverse represenation from EFIT g-eqdsk data
    !    R(rho,theta), Z(rho,theta), g(rho),q(rho),P(rho).
    
    type (xplasma), pointer :: s
    
    character*(*), intent(in) :: filename  ! Geqdsk filename or MDS+ path
    !                  ...or...EFIT_INDEX:filename(t=<time>) specification
    !                  see comments in source/xplasma/eqm_fromgeqdsk.f90
    
    integer, intent(out) :: ier  ! integer status code (returned; 0=OK)
    
    !---------------
    !  optional...
    
    logical, intent(in), optional :: new_device ! flag, .TRUE. if reading
    !  equilibrium for a new device.  Default: .TRUE. when reading the
    !  first equilibrium in the history of the xplasma object; .FALSE.
    !  subsequently.  When this is not .TRUE., the limiter data is presumed
    !  already known to xplasma.
    
    integer, intent(in), optional :: nrho  ! no. of flux surfaces 
    !                                        covering rho = [0:1]
    !  rho = normalized(sqrt(Psi-tor/Psi-tor-at-bdy))
    !        for 20 zones specify nrho=21 -- count includes axis and plasma
    !        boundary-- evenly spaced in rho
    !  DEFAULT: nrho=51 if new_device is .TRUE.; otherwise the value from
    !  the old equilibrium is taken.
    
    integer, intent(in), optional :: nth   ! no. of theta points -- no. of 
    !        evenly spaced points spanning 0:2pi inclusive.
    !  DEFAULT: nth=101 if new_device is .TRUE.; otherwise the value from
    !  the old equilibrium is taken.
    
    integer, intent(in), optional :: i2pi  ! set =1 for theta range to
    !  be -pi:pi instead of 0:2pi (the latter is the default).
    
    logical, intent(in), optional :: lhermite ! flag, .TRUE. for Hermite
    !  interpolation of {R,Z}(rho,theta) -- by default, bicubic spline
    !  interpolation is used.
    
    real*8, intent(in), optional :: bdy0   ! initial Psi_bdy/Psi_sep
    !  (default 1.0d0) fraction of Psi to enclose in mapped region
    !  The issue here is that a separatrix surface generally cannot be
    !  used as a boundary in an inverse representation, due to q=infinity
    !  and the kink in the surface shape.  So instead one backs off from
    !  the Psi_sep flux, defining a boundary just inside the separatrix.
    !    Recommendation: the default.  "cratio_min" causes the code to
    !  iterate to find a suitable boundary surface.
    !  Accepted range: 0.95d0 to 1.00d0
    
    real*8, intent(in), optional :: cratio_min  ! minimum curvature ratio
    !  (default 0.080d0) minimum acceptable local curvature radius, 
    !  normalized to midplane half width.  A separatrix kink has a curvature
    !  radius of zero.  This is tested by fitting a circle through successive
    !  sequences of 3 points on the boundary grid [1:nth] and looking at this
    !  circle's radius compared to an estimate of the plasma midplane half-
    !  width.
    !    Recommendation: the default, based on experience.
    !  Accepted range: 0.01d0 to 0.15d0
    
    logical, intent(in), optional :: rzspace ! .TRUE. to save (R,Z)
    !  grids using the EFIT grids, and compute B(R,Z).  Default = .TRUE.
    !  Setting this .FALSE. may speed some applications.
    
    integer, intent(in), optional :: kpsi_cur    ! =0 (default) to set
    !  total toroidal current from the EFIT file data (scalar CURRENT_A),
    !  and use EFIT q(psi) data (QPSI) for the q profile in the equilibrium
    !  which affects flux surface spacing.
    
    !  If instead kpsi_cur = 1 is set, the EFIT total toroidal current 
    !  magnitude and QPSI data are discarded, and the q(psi) and enclosed
    !  current profiles are derived from contour integrals over the 
    !  Psi(R,Z) data.
    
    !  Advice: if Psi(R,Z) is derived from a high quality free boundary
    !  solution, use kpsi_cur = 1; if unsure, use the defaults.
    
    real*8, intent(in), optional :: rho_curbreak    ! This number,
    !  constrained to be between 0.75 and 0.95, specifies where to
    !  break the enclosed toroidal current profile and impose a smooth
    !  parabolic interpolation to the edge value (see kpsi_cur for how
    !  this is set).  This is necessary to get smooth dI/drho and <J.B>
    !  profiles out.  Default: 0.90.
    
    integer, intent(in), optional :: kmom    ! number of Fourier moments
    !  to use in Fourier Spline representation of equilibrium 
    !  (default: not set here; xplasma default is 16).
    
    real*8, intent(in), optional :: rhobrk_adj_axis ! delta(rho) for
    !  moments trimming operations, and, the maximum rho where flux
    !  surfaces can be touched, in order to assure that d/drho[R0,Z0] --> 0
    !  as rho--> 0, an attributed needed by codes (e.g. RF solvers) that
    !  use the inverted equilibrium.
    !    Default value: 0.15d0.  To disable this feature, set 
    !  rhobrk_adj_axis = -1.0d0 or any other negative number
    
    real*8, intent(in), optional :: mom_rtol ! moments trimming ratio
    !  (default 1.0d-6).  The EFIT Psi(R,Z) inversion involves a Fourier
    !  representation; this control specifies a method for trimming away
    !  higher order moments that are very small over wide regions of space.
    !  Accepted range: 0.0d0 to 1.0d-4
    
    logical, intent(in), optional :: equal_arc  ! .TRUE. to use an equal
    !  arc definition for the poloidal angle coordinate; .FALSE. (default)
    !  for VMEC/descur moments power spectrum minimization definition, the
    !  traditional definition for past usage.
    
    real*8, intent(out), optional :: gs_errmax  ! normalized measure of
    !  Grad Shafranof (GS) error in the EFIT equilibrium.
    
    !-----------------------------
    real*8 :: zbdy0,zcratio,zmom_rtol,zrhobrk_axis,zerrmax
    integer :: irz,inrho,inth,id,idx,ieq,iertmp,jopt,j2pi
    real*8 :: zdum,xbrki
    
    logical :: ihermite,inew_device,ienable
    integer :: ipsi_cur
    
    character*32 :: glist,gelems(7),zauth
    real*8 :: zelems(7)
    character*140 :: ztext(7),zlabel
    
    real*8 :: rhobrk_min=0.75d0
    real*8 :: rhobrk_max=0.95d0
    
    !-----------------------------
    
    ier=0
    
    call xplasma_global_info(s,ier, initLabel=zlabel, eq_counter=ieq)
    if(ier.ne.0) return
    
    call xplasma_author_query(s,zauth,ienable,ier)
    if(ier.ne.0) return
    
    !-----------------------------
    !  check if this an equilibrium for a new device;
    !  if so xplasma re-initialization may be required...
    
    if(ieq.eq.0) then
       inew_device=.TRUE.
    else 
       inew_device=.FALSE.
       if(present(new_device)) inew_device=new_device
    endif
    
    if(inew_device.and.(ieq.gt.0)) then
       ! re-initialize xplasma: changing devices!
       call xplasma_init(s,zlabel,iertmp)
       ier=max(ier,iertmp)
       call xplasma_author_set(s,zauth,iertmp)
       ier=max(ier,iertmp)
    endif
    if(ier.ne.0) then
       call xplasma_errmsg_append(s,'error in xplasma_mds_fromgeqdsk.')
       return
    endif
    
    j2pi=2
    if(present(i2pi)) j2pi=i2pi
    
    if(present(kmom)) then
       call xplasma_kmom_set(s,kmom,ier)
       if(ier.ne.0) then
          call xplasma_errmsg_append(s,'error in xplasma_mds_fromgeqdsk.')
          return
       endif
    endif
    
    ipsi_cur=0
    xbrki=0.9d0
    
    if(present(kpsi_cur)) then
       ipsi_cur = max(0,min(1,kpsi_cur))
    endif
    
    if(present(rho_curbreak)) then
       xbrki=min(rhobrk_max,max(rhobrk_min, rho_curbreak))
    endif
    
    !-----------------------------
    
    if(inew_device) then
       !  use arguments
       if(.not.present(nrho)) then
          inrho=51
       else
          inrho=max(5,nrho)
       endif
       
       if(.not.present(nth)) then
          inth=101
       else
          inth=max(21,nth)
       endif
       
    else
       !  use previous equilibrium grid sizes
       call xplasma_gridId(s,'__RHO',idx)
       call xplasma_grid_size(s,idx,inrho,iertmp)
       ier=max(ier,iertmp)
       
       call xplasma_gridId(s,'__CHI',idx)
       call xplasma_grid_size(s,idx,inth,iertmp)
       ier=max(ier,iertmp)
    endif
    if(ier.ne.0) then
       call xplasma_errmsg_append(s,'error in xplasma_mds_fromgeqdsk.')
       return
    endif
    
    ihermite=.FALSE.
    if(present(lhermite)) ihermite=lhermite
    
    irz=1
    if(inew_device.and.present(rzspace)) then
       if(rzspace) then
          irz=1
       else
          irz=0
       endif
    endif
    
    glist = '__GFILE_INFO'
    
    gelems(1) = 'FILENAME'
    zelems(1) = 0
    ztext(1) = filename
    
    zbdy0=1.0d0
    if(present(bdy0)) then
       zdum=0.95d0
       zbdy0=max(zdum,min(zbdy0,bdy0))  ! enforce range 0.95d0 to 1.00d0
    endif
    gelems(2)='BDY0'
    zelems(2)=zbdy0
    ztext(2)='Relative start point of boundary search'
    
    zcratio=0.080d0  ! **DEFAULT** curvature ratio limit
    
    if(present(cratio_min)) then
       zdum=0.01d0
       zcratio=max(zdum,cratio_min)
       zdum=0.15d0
       zcratio=min(zdum,zcratio)        ! enforce range 0.01d0 to 0.15d0
    endif
    gelems(3)='CRATIO'
    zelems(3)=zcratio
    ztext(3)='minimum accepted boundary curvature ratio'
  
    zrhobrk_axis=0.15d0
    if(present(rhobrk_adj_axis)) then
       zdum=0.30d0
       zrhobrk_axis=min(zdum,rhobrk_adj_axis)
    endif
    gelems(4)='RHOBRK_ADJ_AXIS'
    zelems(4)=zrhobrk_axis
    ztext(4)='width of interior region affected by axis adjustment'
    
    zmom_rtol=1.0d-6
    if(present(mom_rtol)) then
       zdum=0.0d0
       zmom_rtol=max(zdum,mom_rtol)
       zdum=1.0d-4
       zmom_rtol=min(zdum,zmom_rtol)    ! enforce range 0.0 to 1.0d-4
    endif
    gelems(5)='MOM_RTOL'
    zelems(5)=zmom_rtol
    ztext(5)='trimming parameter for Fourier moments representation'
    
    gelems(6)='QPSI_OPTION'
    zelems(6)=ipsi_cur
    ztext(6)='value of 1.0 indicates Q(psi) & total current from Psi(R,Z)'
    
    gelems(7)='RHO_CURBREAK'
    zelems(7)=rho_curbreak
    ztext(7)='break location for matching current profile to edge value.'
    
    zerrmax=0.0d0
    if(present(gs_errmax)) gs_errmax=zerrmax
    
    !---------------------------------------------
    ! record geqdsk controls in a list... id not saved...
    
    call xplasma_create_list(s,glist,gelems,id,ier, &
         label='xplasma_mds_fromgeqdsk inputs list', &
         r8vals=zelems, chvals=ztext)
    if(ier.ne.0) then
       call xplasma_errmsg_append(s, &
            'xplasma_mds_fromgeqdsk: '// &
            'error occurred while attempting to define list: '//trim(glist))
       return
    endif
    
    !---------------------------------------------
    ! OK, build the xplasma equilibrium...
    
    sp => s
    
    jopt = 0
    if(present(equal_arc)) then
       if(equal_arc) then
          jopt = 1
          if(.not.present(kmom)) then
             call xplasma_kmom_set(s,64,ier)  ! set FFT moments up to 64
             ! ...for equal arc theta
          endif
       endif
    endif
    
    call eqi_mds_fromgeqdsk(filename, ihermite, inew_device, &
         inrho, inth, j2pi, zbdy0, zcratio, irz, jopt, &
         ipsi_cur,xbrkI, &
         zrhobrk_axis, zmom_rtol, zerrmax, ier)
    
    if(ier.ne.0) ier=150
    
    if(present(gs_errmax)) gs_errmax=zerrmax
    
  end subroutine xplasma_mds_fromgeqdsk

end module eqm_mds_fromgeqdsk_mod

subroutine equigs_write(idi_xpsi,idi_q,ilun,filepath,ierr)

  ! write the ascii equilibrium data file used as input by TORIC4
  ! mod dmc Sept 2005 -- require at least 80 radial grid points
  ! MOD DMC March 2006 -- write on normalized Psi grid not normalized Phi grid.

  implicit NONE

  integer, intent(in) :: idi_xpsi        ! id of x_psi(rho) profile
  !  if zero, construct this locally

  integer, intent(in) :: idi_q           ! id of q(rho) profile
  !  if zero, construct this locally

  integer, intent(in) :: ilun            ! i/o unit number
  character*(*), intent(in) :: filepath  ! path to file to be written
  integer, intent(out) :: ierr           ! exit status, 0=OK

  integer :: inx0,ingrid0,iper,iwarn
  integer, parameter :: inx_min = 120
  integer :: id_rho=0,id_g=0,id_q=0,ingrid,inx,kmom,iopen,idum,i,j,m
  integer :: id_xpsi=0

  real*8 :: zdum,zraxis,zr0,zrmin,zrmax,zb0

  real*8, dimension(:), allocatable :: zxgrid,zxgrid0,zxpsi,zicur,zg,zq,mombuf
  real*8, dimension(:,:), allocatable :: zrx,zzx          ! R & Z expanded
  real*8, dimension(:,:), allocatable :: zrc,zrs,zzc,zzs  ! R & Z moments

  real*8, dimension(:), allocatable :: zrho,ztheta,zphi
  integer, dimension(:), allocatable :: iregion

  integer :: inthx
  integer :: ith,ix,ibrk,im
  real*8, parameter :: cpi = 3.1415926535897931D+00

  logical, parameter :: ipatch = .TRUE.
  real*8, parameter :: zxpatch = 0.15D0
  real*8, parameter :: zxrtol = 1.0d-6

  integer :: id_locrho
  character*32 :: loc_rho_name,loc_xpsi_name
  !---------------------------

  ierr=1
  if(filepath.eq.' ') return

  ! fetch from xplasma: grid for data
  call eq_ganum('__RHO',id_rho)
  if(id_rho.eq.0) return
  call eq_ngrid(id_rho,ingrid0)
  inx0=ingrid0-1  ! xplasma native gridsize

  inx=0          ! compute grid size to use...
  iper=0
  do
     inx=inx+inx0
     iper=iper+1
     if(inx.ge.inx_min) exit
  enddo
  ingrid=inx+1

  ! also get "G" fcn id (for R*Bphi)
  call eq_gfnum('G',id_g)
  if(id_g.eq.0) return

  ! also get "Q" fcn id (for q profile)
  id_q = idi_q
  if(id_q.eq.0) call eqm_gen_q('q_equigs_write',id_q,ierr)
  if(id_q.eq.0) return

  ! and get xpsi id
  id_xpsi = idi_xpsi  ! could be zero; deal with this below...

  allocate(zxgrid0(0:inx0))
  call eq_grid(id_rho,zxgrid0,ingrid0,idum,ierr)

  allocate(zxgrid(0:inx),zicur(0:inx),zg(0:inx),zq(0:inx),zxpsi(0:inx))
  zxgrid(0)=zxgrid0(0)
  m=0
  do i=1,inx0
     do j=1,iper
        m=m+1
        zxgrid(m)=(zxgrid0(i-1)*(iper-j)+zxgrid0(i)*j)/iper
     enddo
  enddo

  if(id_xpsi.eq.0) then
     loc_xpsi_name = 'xpsi_equigs_write'
     loc_rho_name = 'rho_equigs_write'
     call eq_gfnum(loc_xpsi_name,id_xpsi)

     if(id_xpsi.eq.0) then
        !  build xpsi = sqrt(Psipol/Psipol(a)) vs. rho

        call eq_ganum(loc_rho_name,id_locrho)
        if(id_locrho.eq.0) then
           call eqm_uaxis(loc_rho_name,id_rho,0,zxgrid,ingrid,zxrtol, &
                id_locrho,ierr)
           if(ierr.ne.0) return
        endif

        call equigs_xpsi(id_locrho,id_q,loc_xpsi_name,id_xpsi,ierr)
        if(ierr.ne.0) return
     endif
  endif

  call eq_rgetf(ingrid,zxgrid,id_xpsi,0,zxpsi,ierr)
  call eq_rgetf(ingrid,zxgrid,id_g,0,zg,ierr)
  call eq_rgetf(ingrid,zxgrid,id_q,0,zq,ierr)

  zdum=1.0d-7*zxgrid(inx)
  call eq_flxint_init(0,ingrid,zxgrid,zdum,ierr)
  call eq_flxint('ITOR',1,zicur,1,ingrid,ierr)
  zicur = zicur*(4*cpi)*1.0d-7   ! "I2MEX" units, (T/m), from (A)

  call xmoments_kmom_get(kmom)
  
  !  note constraints on moment count:  5.le.kmom.le.16

  kmom=min(16,max(5,kmom))

  inthx=max(80,10*kmom)+1

  allocate(zrho(inthx),ztheta(inthx),zphi(inthx),iregion(inthx))
  allocate(zrx(inthx,0:inx),zzx(inthx,0:inx))
  allocate(zrc(0:kmom,0:inx),zrs(0:kmom,0:inx),mombuf(0:inx))
  allocate(zzc(0:kmom,0:inx),zzs(0:kmom,0:inx))

  do
     zphi = 0
     do ith=1,inthx
        ztheta(ith)=((ith-1)*2*cpi)/(inthx-1)
     enddo

     ix=inx
     zrho = zxgrid(ix)
     call eq_rzget(inthx,zrho,ztheta,zphi,zrx(1:inthx,ix),zzx(1:inthx,ix), &
          iregion,ierr)
     if(ierr.ne.0) exit

     zrmin=minval(zrx(1:inthx,ix))
     zrmax=maxval(zrx(1:inthx,ix))
     zr0=(zrmin+zrmax)/2
     zb0=zg(inx)/zr0

     zrs(0,0:inx)=0
     zzs(0,0:inx)=0
     call eqmom_rcos(zxgrid,ingrid,0,0,mombuf,iwarn); zrc(0,0:inx)=mombuf
     call eqmom_zcos(zxgrid,ingrid,0,0,mombuf,iwarn); zzc(0,0:inx)=mombuf
     do im=1,kmom
        call eqmom_rcos(zxgrid,ingrid,0,im,mombuf,iwarn); zrc(im,0:inx)=mombuf
        call eqmom_rsin(zxgrid,ingrid,0,im,mombuf,iwarn); zrs(im,0:inx)=mombuf
        call eqmom_zcos(zxgrid,ingrid,0,im,mombuf,iwarn); zzc(im,0:inx)=mombuf
        call eqmom_zsin(zxgrid,ingrid,0,im,mombuf,iwarn); zzs(im,0:inx)=mombuf
     enddo

     if(ipatch) then
        !
        !  patch the 0'th moment behavior towards the mag. axis:
        !  assure dR0/dx -->0, dZ0/dx -->0 as x -->0
        !
        !  also make moments smaller zxrtol*R0(0) go away...

        call scrunch_cleanup(zxgrid,ingrid,zrc,zrs,zzc,zzs, kmom, &
             .TRUE., zxpatch,zxrtol, ierr)

        if(ierr.ne.0) exit

     endif
     zRaxis=zrc(0,0)

     iopen = 0

     open(unit=ilun, file=trim(filepath), status='unknown', iostat=ierr)
     if(ierr.ne.0) exit

     iopen = 1

     write(ilun,'(A)')  'Major radius (central)'
     write(ilun,'(E18.9)') zr0

     write(ilun,'(A)')  'Major radius (axis)'
     write(ilun,'(E18.9)') zraxis

     write(ilun,'(A)')  'Magnetic field at major radius'
     write(ilun,'(E18.9)') zb0

     write(ilun,'(A)')  'Total toroidal current'
     write(ilun,'(E18.9)') zicur(inx)

     write(ilun,'(A)')  'Number of poloidal modes'
     write(ilun,'(I5)') kmom

     write(ilun,'(A)')  'Number of radial mesh points'
     write(ilun,'(I5)') ingrid

     write(ilun,'(A)')  'Radial mesh: sqrt(Psi/Psilim)'
     write(ilun,'(4E18.9)') (zxpsi(i), i=0,inx)

     write(ilun,'(A)')  'Fourier equilibrium coefficients'
     write(ilun,'(4E18.9)') (zrc(0,i),i=0,inx)
     write(ilun,'(4E18.9)') (zzc(0,i),i=0,inx)
     do  m=1,kmom
        write(ilun,'(4E18.9)') (zrc(m,i),i=0,inx)
        write(ilun,'(4E18.9)') (zzs(m,i),i=0,inx)
        write(ilun,'(4E18.9)') (zrs(m,i),i=0,inx)
        write(ilun,'(4E18.9)') (zzc(m,i),i=0,inx)
     enddo

     write(ilun,'(A)')  'Safety factor'
     write(ilun,'(4E18.9)') (zq(i), i=0,inx)

     write(ilun,'(A)')  'Current profile'
     write(ilun,'(4E18.9)') (zicur(i), i=0,inx)

     write(ilun,'(A)')  'R*B_phi (m*T)'
     write(ilun,'(4E18.9)') (zg(i), i=0,inx)

     write(ilun,'(A)')  'Radial mesh: sqrt(Phi/Philim)'
     write(ilun,'(4E18.9)') (zxgrid(i), i=0,inx)

     write(ilun,'(A)')  'Last surface (set to 1: TRANSP)'
     write(ilun,'(E18.9)')  zxpsi(inx)

     exit
  enddo

  if(iopen.eq.1) close(unit=ilun)
  deallocate(zxgrid,zxgrid0,zicur,zg,zq,zxpsi,mombuf)
  deallocate(zrho,ztheta,zphi,iregion)
  deallocate(zrx,zzx)
  deallocate(zrc,zrs,zzc,zzs)

end subroutine equigs_write

program test_xplasma
!
!  read ascii form TRANSP equilibrium file & populate xplasma module
!  via xplasma api; then call plot test program
!
  use xplasma_obj_instance
  implicit NONE
!
  character*10 runid
!
! TRANSP data scalars
!
  real :: pcur,tflux,time,tavg
!
! grid sizes
!
  integer :: ntheta,nsurf
  integer, parameter :: nRZ = 100
!
! REAL arrays -- from TRANSP data (single precision)
!
  real, dimension(:), allocatable :: theta,rho,psi,pmhd,qmhd,gmhd
  real, dimension(:,:), allocatable :: R,Z
!
! REAL*8 arrays -- for xplasma
!
  real*8, dimension(:), allocatable :: theta_r8,rho_r8,psi_r8, &
       pmhd_r8,qmhd_r8,gmhd_r8
  real*8, dimension(:,:), allocatable :: R_r8,Z_r8
!
! plasma extrema
!
  real*8 zrhomax,zRmin,zRmax,zZmin,zZmax,zincr
  real*8 :: zRbdy_test(5),zZbdy_test(5),thbdy_test(4)
!
! even spacing tolerance for xplasma grids
!
  real*8 ztol,ztime
!
! grid ids
!
  integer id_rho,id_chi,id_Rgrid,id_Zgrid
!
! fcn ids
!
  integer id_psi,id_pmhd,id_qmhd,id_gmhd,id_R,id_Z
!
  integer, parameter :: ibc0 = 0  ! "not a knot" bdy condition code
  integer, parameter :: ibc1 = 1  ! "specify 1st derivative" bdy cond. code
!
  integer, parameter :: ispline = 2 ! code for "spline" interpolation
  integer, parameter :: iakherm = 1 ! code for "Akima Hermite" interpolation
!
  integer idir,isnccw               ! Ip direction, 1 = CCW
  integer bdir,bsnccw               ! Bt direction, 1 = CCW
  real*8 distlim                    ! distance, plasma edge -> limiter
  real*8 scrape_len                 ! scrapeoff length = max(0.01,0.5*distlim)
!
! misc...
!
  real*8 zr,zz,zphi,zrho,zth
  integer iregion
!
!  CCW/CW label
!
  character(3), dimension(2), parameter :: ccw = (/"CCW", " CW"/)
!
  logical :: lxout

!------------------------------
  external eqm_brz_adhoc     ! BR,BZ extrapolator (used in absence of data)
!------------------------------
  integer ilr
  integer lun
  integer ierr,iermax,istat,itest
  integer iordrz
  real*8 zdum,zsm_edge
  real ztime1,ztime2
!
  integer :: ido_test = 1
!---------------------------------
! show runs in current working directory
!
  call execute_command_line('ls *.treq_data',exitstat=istat)
!
! prompt for runid
!
  call uinitg("TEST_XPLASMA")
!
  idir=1
  bdir=1
  distlim=0.01d0
  scrape_len=0.01d0
  zsm_edge=0.0d0
!
  call xoi_init(ierr)
  if(ierr.ne.0) then
     write(6,*) ' ? xplasma_obj_instance initialization failure.'
     call bad_exit
  endif
  
  do
     if(lxout(0)) then
        write(6,*) '%test_xplasma program.  enter TRANSP runid, or...'
        write(6,*) ' "Q" to quit'
        write(6,*) ' "I" to change direction of plasma current (',ccw(idir),')'
        write(6,*) ' "B" to change direction of toroidal field (',ccw(bdir),')'
        write(6,*) ' "X" to toggle "extra debugging" switch (',(ido_test.eq.2),')'
        write(6,*) ' "D" to set distance (m), plasma edge to limiter (',distlim,')'
        write(6,*) ' "E" to set edge smoothing width (m) for f(R,Z) (',zsm_edge,')'
        write(6,*) '     (P(R,Z) and field components B(R,Z) will be computed).'
     endif
     call ureadw('enter TRANSP runid nnnnnAmm (.treq_data file must exist):$',&
          runid)
     if(runid.eq.'Q ') then
        call uexita(0)
        stop
     else if(runid.eq.'I ') then
        idir=3-idir
        cycle
     else if(runid.eq.'B ') then
        bdir=3-bdir
        cycle
     else if(runid.eq.'X ') then
        ido_test=3-ido_test
        cycle
     else if(runid.eq.'D ') then
        call ureadr8('enter distance (m), plasma edge to limiter:$',distlim)
        distlim=max(0.0d0,distlim)
        scrape_len=max(0.01d0,0.5d0*distlim)
        cycle
     else if(runid.eq.'E ') then
        call ureadr8('enter edge smoothing width (m), btw 0.0 and 0.2:$', &
             zsm_edge)
        zsm_edge=max(0.0d0,min(0.2d0,zsm_edge))
        cycle
     endif
!
     call ulower(runid)
     ilr=len_trim(runid)
!
     lun=99
     open(lun,file=runid(1:ilr)//'.treq_data',status='old',iostat=istat)
     if(istat.ne.0) then
        write(6,*) ' %test_xplasma:  file open error:  ',runid(1:ilr), &
             '.treq_data'
        cycle
     endif
!
!  read header info
!
     call rdtreq_hdr(lun,runid,time,tavg,pcur,tflux,ntheta,nsurf)
     write(6,*) ' rdtreq_hdr call completed OK.'
     write(6,*) '   runid = ',runid
     write(6,*) '    time = ',time
     write(6,*) '    tavg = ',tavg
     write(6,*) '    pcur = ',pcur
     write(6,*) '   tflux = ',tflux
     write(6,*) '  ntheta = ',ntheta
     write(6,*) '   nsurf = ',nsurf
!
!  as per header info, allocate arrays
!
     allocate(theta(ntheta))
     allocate(rho(nsurf))
     allocate(psi(nsurf))
     allocate(pmhd(nsurf))
     allocate(qmhd(nsurf))
     allocate(gmhd(nsurf))
     allocate(R(ntheta,nsurf))
     allocate(Z(ntheta,nsurf))
!
     allocate(theta_r8(ntheta))
     allocate(rho_r8(nsurf))
     allocate(psi_r8(nsurf))
     allocate(pmhd_r8(nsurf))
     allocate(qmhd_r8(nsurf))
     allocate(gmhd_r8(nsurf))
     allocate(R_r8(ntheta,nsurf))
     allocate(Z_r8(ntheta,nsurf))
!
!  read equilibrium data
!
     call rdtreq_data(lun,ntheta,nsurf,theta,rho,psi,pmhd,qmhd,gmhd,R,Z)
     write(6,*) ' rdtreq_data call completed OK.'
!
!-------------------> time xplasma operations...
!
     call cpu_time(ztime1)
!
     theta_r8 = theta
     rho_r8   = rho
     psi_r8   = psi
     pmhd_r8  = pmhd
     qmhd_r8  = qmhd
     gmhd_r8  = gmhd
     R_r8     = R
     Z_r8     = Z
!
     zrhomax=rho(nsurf)
!
!  OK, now we load xplasma...
!
     call eqm_select('test_xplasma '//trim(runid),1)

     ztime=time
     call eqm_time(ztime)
!
     ztol=1.0d-4
!
!  rho grid
     call eqm_rho(rho_r8,nsurf,ztol,id_rho,ierr)
     if(ierr.ne.0) then
        write(6,*) ' ?eqm_rho:  ierr=',ierr
        go to 100
     endif
!
!  theta (or chi) grid
     call eqm_chi(theta_r8,0,ntheta,ztol,id_chi,ierr)
     if(ierr.ne.0) then
        write(6,*) ' ?eqm_chi:  ierr=',ierr
        go to 100
     endif
!
!  1d profiles
!
     iermax=0
!
     do itest = 1,ido_test
        ! pass through twice; delete & replace everything; test
        ! xplasma garbage collection..

        !  spline, 1st deriv = 0 on axis, not-a-knot at edge

        call eqm_rhofun(ispline,id_rho,'PSI',psi_r8,ibc1,0.0d0,ibc0,zdum, &
             id_psi,ierr)

        iermax=max(iermax,ierr)
        if(iermax.eq.0) then
           call eqm_flabel(id_psi,'Poloidal Flux','Wb/rad',ierr)
           iermax=max(iermax,ierr)
        endif

        !  Akima Hermite, 1st deriv = 0 on axis, fit at edge

        call eqm_rhofun(iakherm,id_rho,'P',pmhd_r8,ibc1,0.0d0,ibc0,zdum, &
             id_pmhd,ierr)
        iermax=max(iermax,ierr)
        if(iermax.eq.0) then
           call eqm_flabel(id_pmhd,'Equilibrium Pressure','Pascals',ierr)
           iermax=max(iermax,ierr)
        endif

        !  spline, 1st deriv = 0 on axis, 1st deriv = 0 at edge

        call eqm_rhofun(ispline,id_rho,'G',gmhd_r8,ibc1,0.0d0,ibc1,0.0d0, &
             id_gmhd,ierr)
        iermax=max(iermax,ierr)
        if(iermax.eq.0) then
           call eqm_flabel(id_gmhd,'B_phi*R','T*m',ierr)
           iermax=max(iermax,ierr)
        endif

        !  spline, not-a-knot at axis and at edge

        call eqm_rhofun(ispline,id_rho,'Q',qmhd_r8,ibc0,zdum,ibc0,zdum, &
             id_qmhd,ierr)
        iermax=max(iermax,ierr)
        if(iermax.eq.0) then
           call eqm_flabel(id_qmhd,'Q profile','-',ierr)
           iermax=max(iermax,ierr)
        endif

        if(iermax.gt.0) then
           write(6,*) ' ?eqm_rhofun -- 1d interpolation setup errors!'
           go to 100
        endif

        !  R(theta,rho), Z(theta,rho)
        !  bicubic splines, periodic in theta, not-a-knot bdy conds in rho

        iermax=0

        call eqm_rzmag(R_R8,Z_R8,ntheta,nsurf,2,id_R,id_Z,ierr)

        call eqm_flabel(id_R,'R of flux surfaces','m',ierr)
        call eqm_flabel(id_Z,'Z of flux surfaces','m',ierr)

!  compute B field... note signs (clockwise / counter-clockwise)

        isnccw=3-2*idir          ! +1 -- CCW looking down on machine
        bsnccw=3-2*bdir          ! -1 -- CW looking down on machine

        if(itest.eq.1) call eqm_bset(bsnccw,isnccw)

        if(itest.lt.ido_test) then
           write(6,*) ' -> basic equilibrium set.'
           write(6,*) '    test: delete and reset equilibrium...'
           call xplasma_eqClear(s,.FALSE.,ierr)  ! delete & reset equilibrium
        endif

     enddo

     call cpu_time(ztime2)
     write(6,*) ' %test_xplasma:  R(theta,rho) & Z(theta,rho) splines done.'
     write(6,*) '  BR(theta,rho), BZ(theta,rho), mod(B)(theta,rho) done.'
     write(6,*) '  xplasma cpu time so far:  ',ztime2-ztime1

     if(ido_test.eq.2) then
        write(6,*) ' ... extra testing ... save, delete, restore from file...'

        call execute_command_line('rm -f foo.cdf',exitstat=ierr)
        call eq_save('foo.cdf',ierr)
        write(6,*) ' eq_save status: ierr = ',ierr

        call eq_save('foo.cdf',ierr)
        write(6,*) ' eq_restore status: ierr = ',ierr
        call execute_command_line('rm -f foo.cdf',exitstat=ierr)

        write(6,*) ' '
        write(6,*) ' test f77 interface to numeric integration... '
        call test_eq_flxint(ntheta,nsurf)

        write(6,*) ' '
        write(6,*) ' test coordinate transformation routines... '
        call test_eq_ctrans('BEFORE scrape off layer setup')
     endif

     !  set up limiter; first find plasma bdy min/max R,Z

     call eq_glimrz(zrhomax,zRmin,zRmax,zZmin,zZmax,ierr)
     if(ierr.ne.0) then
        write(6,*) ' ?eq_glimrz:  ierr = ',ierr
        go to 100
     else
        write(6,*) ' '
        write(6,*) ' ---------------------------------------------- '
        write(6,'(" Rmin,max: ",2(1x,1pe13.6)," Zmin,max: ",2(1x,1pe13.6))') &
             zRmin,zRmax,zZmin,zZmax
     endif

!  here I define the limiter as being a fixed distance from the
!  plasma, except at the inner wall, which is vertical & touches
!  the plasma boundary ... many other limiter configurations are
!  possible...
!
     zRbdy_test(1)=zRmin; zZbdy_test(1)=zZmin; thbdy_test(1)=0.0
     zRbdy_test(2)=zRmax; zZbdy_test(2)=zZmin; thbdy_test(2)=90.0
     zRbdy_test(3)=zRmax; zZbdy_test(3)=zZmax; thbdy_test(3)=0.0
     zRbdy_test(4)=zRmin; zZbdy_test(4)=zZmax; thbdy_test(4)=90.0
     zRbdy_test(5)=zRmin; zZbdy_test(5)=zZmin

!  test f77 limiter definition calls

     call eqm_tbdy(4,zRbdy_test(1:4),zZbdy_test(1:4),thbdy_test, &
          0,zRbdy_test,zZbdy_test,thbdy_test,ierr)  ! dummy args for circ. lims
     if(ierr.ne.0) then
        write(6,*) ' ?eqm_tbdy: ierr = ',ierr
        call xplasma_error(s,ierr,6)
        go to 100
     endif

     call eqm_cbdy(5,zRbdy_test,zZbdy_test,ierr)
     if(ierr.ne.0) then
        write(6,*) ' ?eqm_cbdy: ierr = ',ierr
        call xplasma_error(s,ierr,6)
        go to 100
     endif

     call eqm_dbdy(distlim,zRmin,zRmax+distlim,zZmin-distlim,zZmax+distlim, &
          ierr)
     if(ierr.ne.0) then
        write(6,*) ' ?eqm_dbdy: ierr = ',ierr
        call xplasma_error(s,ierr,6)
        go to 100
     endif

!  set up a limiter, and at the same time...
!  a 100x100 evenly spaced (R,Z) grid is set
!  up to cover both the plasma and the SOL between the plasma
!  and limiter

     call eqm_dbdy_grid(distlim, &
          zRmin,zRmax+distlim,zZmin-distlim,zZmax+distlim, &
          nRZ,nRZ,id_Rgrid,id_Zgrid,  &
          ierr)
     if(ierr.ne.0) then
        write(6,*) ' ?eqm_dbdy_grid:  ierr = ',ierr
        go to 100
     endif

     if(ido_test.eq.2) then
        call test_eq_ctrans('AFTER scrape off layer setup')
     endif

     if(ido_test.eq.2) then
        call test_misc
     endif

     call cpu_time(ztime2)
     write(6,*) ' %test_xplasma:  limiter & (R,Z) grid setup complete.'
     write(6,*) '  xplasma cpu time so far:  ',ztime2-ztime1

!  extrapolate pressure using a scrape-off length of 0.5*distlim
!  ...to the (R,Z) grid
!
     iordrz=1   ! Hermite
     call eqm_rzfun(id_pmhd,scrape_len,iordrz,zsm_edge,ierr)
     if(ierr.ne.0) then
        write(6,*) ' ?eqm_rzfun:  ierr = ',ierr
        go to 100
     endif
!
!  and extrapolate the field to R,Z grid
!  here, a stabilized vacuum field extrapolator is used.  If actual field
!  data were available it would be better to use it.
!
     call eqm_brz(eqm_brz_adhoc,zsm_edge,ierr)
     if(ierr.ne.0) then
        write(6,*) ' ?eqm_brz:  ierr = ',ierr
        go to 100
     endif

     if(ido_test.eq.2) then
        call test_eq_get
        call test_mcgrid
        call test_vtaub
     endif

     call cpu_time(ztime2)
     write(6,*) ' %test_xplasma:  B field extrapolation done.'
     write(6,*) '  xplasma cpu time so far:  ',ztime2-ztime1

!  all done -- call plotting routine
!
     call eqdbg_plot
!
100  continue
     deallocate(theta)
     deallocate(rho)
     deallocate(psi)
     deallocate(pmhd)
     deallocate(qmhd)
     deallocate(gmhd)
     deallocate(R)
     deallocate(Z)
!
     deallocate(theta_r8)
     deallocate(rho_r8)
     deallocate(psi_r8)
     deallocate(pmhd_r8)
     deallocate(qmhd_r8)
     deallocate(gmhd_r8)
     deallocate(R_r8)
     deallocate(Z_r8)
!
     close(unit=lun)
  end do
end program test_xplasma

subroutine test_eq_flxint(ntheta,nsurf)

  !  test legacy f77 numerical flux surface averaging & integration
  !  interfaces...

  use xplasma_obj_instance
  implicit NONE
  
  integer, intent(in) :: ntheta,nsurf   ! equilibrium grid sizes

  !-------------------------------------------
  integer :: ierr,i,j,idx11,id_B
  integer :: inth,inxi
  real*8 :: z1 = 1.0d0
  real*8 :: zarea,zvol,bavg,zrhomin
  real*8 :: x11(11),x4(4),t4(4),wk11(11),wk4(4),dvs4(4)
  real*8 :: bav10(10),dvol10(10),darea10(10)
  real*8 :: bav3(3),dvol3(3),darea3(3)
  real*8 :: bav2d(3,3),dvol2d(3,3),darea2d(3,3)
  real*8 :: dvd2d(3,4),bvs2d(3,4)
  real*8, parameter :: ONE = 1.0d0, C2PI = 6.2831853071795862D+00
  real*8 :: bmodf(ntheta,nsurf)
  !-------------------------------------------

  do i=1,size(x11)
     x11(i)=(i-1)*ONE/(size(x11)-1)
  enddo

  do i=1,size(x4)
     x4(i)=(i-1)*ONE/(size(x4)-1)
  enddo

  do i=1,size(t4)
     t4(i)=(i-1)*C2PI/(size(t4)-1)
  enddo
  
1001 format(a,1pe17.10)

  call eq_volume(1,z1,0,zvol,ierr); call ckerr('eq_volume')
  write(6,1001) ' eq_area: plasma enclosed volume (m^3): ',zvol

  call eq_area(1,z1,0,zarea,ierr); call ckerr('eq_area')
  write(6,1001) ' eq_area: plasma cross sectional area (m^2): ',zarea

  !---------------------------------------------
  ! some xplasma f90 based reference data

  call xplasma_author_set(s,'test_xplasma',ierr); call ckerr('author_set')

  call xplasma_create_integ(s,'test_integ11',x11,idx11,ierr)
  call ckerr('xplasma_create_integ')

  call xplasma_rho_zonint(s,idx11,'<B>',bav10,ierr,dvol_out=dvol10)
  call ckerr('xplasma_rho_zonint')

  call xplasma_rho_zonint(s,idx11,'dArea',darea10,ierr)
  call ckerr('xplasma_rho_zonint')

  zvol = 0
  zarea = 0
  bavg = 0
  do i=1,size(bav10)
     bavg = bavg + dvol10(i)*bav10(i)
     zvol = zvol + dvol10(i)
     zarea = zarea + darea10(i)
  enddo
  bavg = bavg/zvol

  write(6,1001) ' '
  write(6,1001) '   -> fortran-90 interface:'
  write(6,1001) ' integ11: <<B>> = ',bavg
  write(6,1001) ' integ11: summed volume = ',zvol
  write(6,1001) ' integ11: summed area   = ',zarea

  call xplasma_rho_zonint(s,idx11,'dVdrho',wk11,ierr)
  call ckerr('xplasma_rho_zonint')
  write(6,1001) ' integ11: dV/drho @bdy  = ',wk11(11)

  call xplasma_rho_zonint(s,idx11,'<B>S',wk11,ierr)
  call ckerr('xplasma_rho_zonint')
  write(6,1001) ' integ11: <B> @bdy      = ',wk11(11)

  !---------------------------------------------
  ! some f77 tests

  zrhomin = 1.0d-7

  call eq_flxint_init(0,4,x4,zrhomin,ierr); call ckerr('eq_flxint_init')
  call fluxav_nsurfs_get(inth,inxi)
  write(6,*) ' after eq_flxint_init: #th_zones = ',inth,'; #x_surfs = ',inxi

  call eq_flxint('dVol',1,dvol3,1,3,ierr); call ckerr('eq_flxint(dVol)')
  call eq_flxint('dArea',1,dArea3,1,3,ierr); call ckerr('eq_flxint(dArea)')
  call eq_flxint('<B>',1,bav3,1,3,ierr); call ckerr('eq_flxint(<B>)')

  zvol = 0
  zarea = 0
  bavg = 0
  do i=1,size(bav3)
     bavg = bavg + dvol3(i)*bav3(i)
     zvol = zvol + dvol3(i)
     zarea = zarea + darea3(i)
  enddo
  bavg = bavg/zvol

  write(6,1001) ' '
  write(6,1001) ' <<>> denotes volume average over entire plasma.'
  write(6,1001) ' '
  write(6,1001) '   -> fortran-77 legacy interface:'
  write(6,1001) ' integ77: <<B>> = ',bavg
  write(6,1001) ' integ77: summed volume = ',zvol
  write(6,1001) ' integ77: summed area   = ',zarea

  call eq_flxint('dVdrho',1,dvs4,1,4,ierr); call ckerr('eq_flxint(dVdrho)')
  write(6,1001) ' integ77: dV/drho @bdy  = ',dvs4(4)

  call eq_flxint('<B>S',1,wk4,1,4,ierr); call ckerr('eq_flxint(<B>S)')
  write(6,1001) ' integ77: <B> @bdy      = ',wk4(4)

  call eq_flxint_chinit(0,4,t4,ierr); call ckerr('eq_flxint_chinit')
  call fluxav_nsurfs_get(inth,inxi)
  write(6,*) ' after eq_flxint_chinit: #th_zones = ',inth,'; #x_surfs = ',inxi

  call eq_flxint('dVol',1,dvol2d,3,3,ierr); call ckerr('eq_flxint(dVol)')
  call eq_flxint('dArea',1,dArea2d,3,3,ierr); call ckerr('eq_flxint(dArea)')
  call eq_flxint('<B>',1,bav2d,3,3,ierr); call ckerr('eq_flxint(<B>)')

  write(6,1001)
  write(6,1001) '   -> fortran-77 legacy: 2d tests:'
  write(6,1001) ' integ2d: <B> zone(1,3): ',bav2d(1,3)
  write(6,1001) ' integ2d: <B> zone(2,3): ',bav2d(2,3)
  write(6,1001) ' integ2d: <B> zone(3,3): ',bav2d(3,3)

  zvol = 0
  zarea = 0
  bavg = 0
  do j=1,size(bav2d,2)
     do i=1,size(bav2d,1)
        bavg = bavg + dvol2d(i,j)*bav2d(i,j)
        zvol = zvol + dvol2d(i,j)
        zarea = zarea + darea2d(i,j)
     enddo
  enddo
  bavg = bavg/zvol

  write(6,1001) ' '
  write(6,1001) ' integ2d: <<B>> = ',bavg
  write(6,1001) ' integ2d: summed volume = ',zvol
  write(6,1001) ' integ2d: summed area   = ',zarea

  call eq_flxint('dVdrho',1,dvd2d,3,4,ierr); call ckerr('eq_flxint(dVdrho)')
  call eq_flxint('<B>S',1,bvs2d,3,4,ierr); call ckerr('eq_flxint(<B>S)')

  zvol=0
  bavg=0
  do i=1,3
     bavg=bavg+bvs2d(i,4)*dvd2d(i,4)
     zvol=zvol+dvd2d(i,4)
  enddo
  bavg=bavg/zvol

  write(6,1001) ' integ2d: dV/drho @bdy  = ',zvol
  write(6,1001) ' integ2d: <B> @bdy      = ',bavg

  call xplasma_find_item(s,'BMOD',id_B,ierr); call ckerr('find(BMOD)')
  call xplasma_eval_prof(s,id_B,bmodf,ierr); call ckerr('retrieve BMOD')

  call eq_flxint('dVol',1,dvol3,1,3,ierr); call ckerr('eq_flxint(dVol)')
  call eq_flxint_arr2(bmodf,4,bav3,1,3,ierr); call ckerr('eq_flxint_arr2 #1')

  zvol = 0
  bavg = 0
  do i=1,size(bav3)
     bavg = bavg + bav3(i)*dvol3(i)
     zvol = zvol + dvol3(i)
  enddo
  bavg = bavg/zvol
  write(6,1001) ' '
  write(6,1001) '   -> fortran-77 interface, "user" provided copy of BMOD:'
  write(6,1001) ' intarr2: <<BMOD>> = ',bavg
  write(6,1001) ' intarr2: summed volume = ',zvol

  call eq_flxint_arr2(bmodf,6,wk4,1,4,ierr); call ckerr('eq_flxint_arr2 #2')
  write(6,1001) ' intarr2: <BMOD> @bdy   = ',wk4(4)

  call eq_flxint_arr2(bmodf,4,bav2d,3,3,ierr); call ckerr('eq_flxint_arr2 #3')

  zvol = 0
  bavg = 0
  do j=1,size(bav2d,2)
     do i=1,size(bav2d,1)
        bavg = bavg + dvol2d(i,j)*bav2d(i,j)
        zvol = zvol + dvol2d(i,j)
     enddo
  enddo
  bavg = bavg/zvol

  write(6,*) '   -> from calculation of <BMOD> on 2d grid:'
  write(6,1001) ' intarr2: <<BMOD>> = ',bavg

  call xplasma_remove_item(s,idx11,ierr); call ckerr('remove integrator idx11')

  call xplasma_author_clear(s,'test_xplasma',ierr); call ckerr('author_clear')

  !---------------------------------------------

  contains
    subroutine ckerr(lbl)

      character*(*), intent(in) :: lbl

      if(ierr.ne.0) then
         write(6,*) '  ** test_eq_flxint.ckerr ** ierr = ',ierr,' in ',lbl
         call xplasma_error(s,ierr,6)
      endif
    end subroutine ckerr

end subroutine test_eq_flxint

subroutine test_eq_ctrans(str)

  !  test legacy f77 xplasma coordinate transform interfaces...

  use xplasma_obj_instance
  implicit NONE

  character*(*), intent(in) :: str

  !---------------------------------------------
  integer, parameter :: nvec=17
  real*8 :: r_in(nvec),phi_in(nvec),zcosphi,zsinphi
  real*8 :: x_out(nvec),y_out(nvec),r_out(nvec),phi_out(nvec)
  real*8 :: xi_in(nvec),th_in(nvec),z_out(nvec)
  real*8 :: xi_out(nvec),th_out(nvec)
  real*8 :: th_out2(nvec),d1(nvec),d2(nvec),wk(nvec)
  real*8 :: rwk(nvec),zwk(nvec),drz(2)
  real*8 :: zrzbuf(nvec,4)
  real*8 :: zr,zphi

  integer :: nregion(nvec),ierr

  real*8, parameter :: ONE = 1.0d0, C2PI = 6.2831853071795862D+00
  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: ztol_rz = 1.0d-10

  integer :: i,iflist(4),idchis(4),id_R,id_Z
  !---------------------------------------------

  call xplasma_common_ids(s,ierr,id_R=id_R,id_Z=id_Z)
  if(ierr.ne.0) then
     write(6,*) ' ?xplasma_common_ids error in test_eq_ctrans.'
     return
  endif
  
  iflist(1)=id_R; iflist(2)=id_Z; idchis(1:2)=0  ! R & Z
  iflist(3)=id_R; iflist(4)=id_Z; idchis(3:4)=1  ! dR/dtheta & dZ/dtheta

  write(6,*) ' ============================== '
  write(6,*) '  ',trim(str)
  write(6,*) ' '

  do i=1,nvec
     r_in(i)=ONE
     wk(i)=ONE
     xi_in(i)=0.975d0
     phi_in(i)=(i-1)*C2PI/(nvec-1)
     th_in(i)=(i-1)*C2PI/(nvec-1)
  enddo

  call eq_rcylcs(1,ZERO,ZERO,zr,zphi,zcosphi,zsinphi)
  write(6,1001) zr,zphi,zcosphi,zsinphi
1001 format(" [0,0] -> R=",1pe14.7," phi=",1pe14.7/ &
          " cos & sin(phi) are:",2(1x,1pe14.7))

  write(6,*) ' .......... '
  write(6,*) ' in following, R_in=1.000:'
  write(6,*) ' #  phi_in         x_out          y_out          R_back         phi_back'

  call eq_xcyl(nvec,r_in,phi_in,x_out,y_out)
  call eq_rcyl(nvec,x_out,y_out,r_out,phi_out)

  do i=1,nvec
     write(6,1002) i,phi_in(i),x_out(i),y_out(i),r_out(i),phi_out(i)
  enddo

  write(6,*) ' .......... '
  write(6,*) ' distance test -- expect distance = 1.00; th match or +/- 2pi'
  write(6,*) ' #  th_in          d(rho=0.975)   th_out(0.975)  d(rho=1)      th_out(1)'

  call dtest(xi_in,th_out,d1)
  if(ierr.ne.0) return

  call dtest(wk,th_out2,d2)
  if(ierr.ne.0) return

  do i=1,nvec
     write(6,1002) i,th_in(i),d1(i),th_out(i),d2(i),th_out2(i)
  enddo

  write(6,*) ' .......... '
  write(6,*) ' inverse map test: in following, xi_in=0.975:'
  write(6,*) ' #  th_in          R_out          Z_out          xi_back        th_back'

  nregion = 0

  call eq_rzget(nvec,xi_in,th_in,phi_in,r_out,z_out,nregion,ierr)
  if(ierr.ne.0) then
     write(6,*) ' ?? error in rzget: ',ierr
  else
     call eq_inv(nvec,r_out,z_out,phi_in,ztol_rz,xi_out,th_out,nregion,ierr)
     if(ierr.ne.0) then
        write(6,*) ' ?? error in eq_inv: ',ierr
     else
        do i=1,nvec
           write(6,1002) i,th_in(i),R_out(i),Z_out(i),xi_out(i),th_out(i)
        enddo
        write(6,*) ' (nregion range: ',minval(nregion),maxval(nregion),')'
        write(6,*) ' '
     endif
  endif

1002 format(1x,i2,5(1x,1pe14.7))

  contains

    subroutine dtest(rhovec,th_out,d_out)

      real*8, dimension(:), intent(in) :: rhovec   ! surface vector
      ! (all elements equal)

      real*8, dimension(:), intent(out) :: th_out,d_out
      ! theta locations and distances -- nearest points on surface

      call xplasma_RZeval_2d(s,iflist, &
           xplasma_rho_coord,rhovec, xplasma_theta_coord,th_in, &
           zrzbuf,ierr, ideriv2s=idchis)
      if(ierr.ne.0) then
         write(6,*) ' ?error in xplasma_eval_prof: '
         call xplasma_error(s,ierr,6)
         return
      endif

      do i=1,nvec
         drz(1)=zrzbuf(i,4)
         drz(2)=-zrzbuf(i,3)
         drz = drz/sqrt(drz(1)**2+drz(2)**2)
         rwk(i)=zrzbuf(i,1)+drz(1)
         zwk(i)=zrzbuf(i,2)+drz(2)
      enddo
  
      call eq_bdfind(nvec,rwk,zwk,phi_in,rhovec(1),th_out,phi_out,d_out,ierr)
      if(ierr.ne.0) then
         write(6,*) ' ?error in eq_bdfind: '
         call xplasma_error(s,ierr,6)
         return
      endif

    end subroutine dtest

end subroutine test_eq_ctrans

subroutine test_misc

  use xplasma_obj_instance
  implicit NONE

  !-----------------
  real*8 :: ztime,zrho0,zrho1
  real*8 :: zRmaxlim,zRminlim,zZmaxlim,zZminlim,zRmid,zZmid,zdum,zdist,zdist2
  real*8 :: ra,za,phia,da,rb,zb,phib,db,tol,rx,zx,rx2,zx2,phix
  integer :: id,ierr,itype,istat,id_Bg
  character*32 zname
  real*8 :: zbdum(41),ztol
  !-----------------

  write(6,*) ' ---------------------- '
  write(6,*) ' test miscellaneous f77 xplasma legacy calls... '

  write(6,*) ' '
  call eq_time(ztime)
  write(6,*) '    eq_time yields time = ',ztime
  
  write(6,*) ' '
  call eq_rholim(zrho0,zrho1)
  write(6,*) '    eq_rholim gives: ',zrho0,zrho1
  call eq_rhoxlim(zrho0,zrho1)
  write(6,*) '    eq_rhoxlim gives: ',zrho0,zrho1
  call eq_rholima(zrho0,zrho1)
  write(6,*) '    eq_rholima gives: ',zrho0,zrho1

  write(6,*) ' '
  call eq_ganum('__RHO',id)
  write(6,*) '    "__RHO" id from eq_ganum: ',id
  call eq_get_aname(id,zname)
  write(6,*) '    eq_get_aname(id,...)=> "',trim(zname),'".'
  call eq_gfnum('R',id)
  write(6,*) '    "R" id from eq_ganum: ',id
  call eq_get_fname(id,zname)
  write(6,*) '    eq_get_fname(id,...)=> "',trim(zname),'".'
  
  write(6,*) ' '
  call eq_bdlims(itype,zRminlim,zRmaxlim,zZminlim,zZmaxlim,ierr)
  if(ierr.ne.0) then
     write(6,*) ' ?? eq_bdlims returned ierr=',ierr
     return
  else
     write(6,*) '    eq_bdlims: limiter type: ',itype
     write(6,*) '    limiter extrema: Rmin&max, Zmin&max: '
     write(6,'(10x,4(1pe12.5,1x))') zRminlim,zRmaxlim,zZminlim,zZmaxlim
  endif

  write(6,*) ' '
  zdum=0
  call eq_dfast(1,zRmaxlim,zZmaxlim,zdum,zdist,ierr)
  if(ierr.ne.0) then
     write(6,*) ' ?? eq_dfast returned ierr=',ierr
     return
  else
     write(6,*) '    distance (m) from plasma bdy to (Rmax,Zmax): ',zdist
  endif

  zRmid=(zRmaxlim+zRminlim)/2
  zZmid=(zZmaxlim+zZminlim)/2
  call eq_dfast(1,zRmid,zZmid,zdum,zdist2,ierr)

  zdum=sqrt((zRmaxlim-zRmid)**2+(zZmaxlim-zZmid)**2)

  ra=zRmid-(zdist2/2)*(zRmaxlim-zRmid)/zdum   ! move towards bdy from inside
  za=zZmid-(zdist2/2)*(zZmaxlim-zZmid)/zdum
  phia=0
  da=0

  rb=zRmaxlim-(zdist/2)*(zRmaxlim-zRmid)/zdum
  zb=zZmaxlim-(zdist/2)*(zZmaxlim-zZmid)/zdum
  phib=0
  db=0

  tol=1.0d-5
  call eq_fxcep(1,1,0, &
       ra,za,phia,da, rb,zb,phib,db, tol, &
       rx,zx,phix,istat, ierr)

  write(6,*) ' eq_fxcep istat, ierr: ',istat,ierr
  write(6,*) '   R,Z at bdy: ',rx,zx

  call eq_fxcep(1,2,0, &
       ra,za,phia,da, rb,zb,phib,db, tol, &
       rx2,zx2,phix,istat, ierr)

  write(6,*) ' eq_fxcep istat, ierr: ',istat,ierr
  write(6,*) '   R,Z at limiter: ',rx2,zx2
  write(6,*) '   (diff: ',sqrt((rx2-rx)**2+(zx2-zx)**2),')'
  write(6,*) ' '
  write(6,*) ' ---------------------- '
  write(6,*) ' '

  ztol=1.0d-5
  call eqm_bbin(zbdum,4,size(zbdum),ztol,id_Bg,ierr)

  write(6,*) ' eqm_bbin ierr, id_Bgrid = ',ierr,id_Bg
  if(ierr.eq.0) then
     call xplasma_grid(s,id_Bg,zbdum,ierr)
     write(6,*) '   Bgrid range: min=',zbdum(1),'; max=',zbdum(size(zbdum)), &
          ' Tesla.'
  endif
  write(6,*) ' '
  write(6,*) ' ---------------------- '
  write(6,*) ' '

end subroutine test_misc

subroutine test_eq_get

  implicit NONE

  integer, parameter :: ivec=8
  integer, parameter :: nlist=6

  real*8 :: zrho(ivec),zchi(ivec),zphi(ivec),zR(ivec),zZ(ivec)

  real*8 :: bvec1(3,ivec),gbtens1(3,3,ivec),bpol1(ivec,3)
  real*8 :: fvals1(ivec,nlist),fgrads1(3,ivec,nlist)

  real*8 :: bvec2(3,ivec),gbtens2(3,3,ivec),bpol2(ivec,3)
  real*8 :: fvals2(ivec,nlist),fgrads2(3,ivec,nlist)

  real*8 :: bvec3(3,ivec),gbtens3(3,3,ivec)
  real*8 :: fvals3(ivec,nlist),fgrads3(3,ivec,nlist)

  real*8 :: bvec4(3,ivec),gbtens4(3,3,ivec),bpol4(ivec,3)
  real*8 :: fvals4(ivec,nlist),fgrads4(3,ivec,nlist)

  real*8 :: bvec5(3,ivec),gbtens5(3,3,ivec)
  real*8 :: fvals5(ivec,nlist),fgrads5(3,ivec,nlist)

  integer :: nregion(ivec),ifcns(nlist)

  integer :: ii,ierr

  real*8, parameter :: ONE = 1.0d0, C2PI = 6.2831853071795862D+00
  real*8, parameter :: ZERO= 0.0d0
  real*8, parameter :: ztol= 1.0d-10
  real*8 :: zwk3a,zwk3b,zwk5a
  real*8 :: zbpol,zsum1,zsum2,zwkp(5)
  !------------------------

  zrho = 0.98d0
  do ii=1,ivec
     zchi(ii)=(ii-1)*C2PI/(ivec-1)
     zphi(ii)=ZERO
  enddo

  call eq_rzget(ivec,zrho,zchi,zphi,zR,zZ,nregion,ierr)
  if(ierr.ne.0) then
     write(6,*) ' ?? test_eq_get: preliminary eq_rzget call failed!'
     return
  endif

1002 format(1x,i2,5(1x,1pe14.7))

  write(6,*) ' .......... '
  write(6,*) ' eq*_get* test: coordinate points used:'
  write(6,*) ' #  x              theta          phi            R              Z'

  do ii=1,ivec
     write(6,1002) ii,zrho(ii),zchi(ii),zphi(ii),zR(ii),zZ(ii)
  enddo

  write(6,*) ' '
  write(6,*) ' eq*_get* tests follow.  B values should match approximately'
  write(6,*) ' (or precisely but only if the same underlying representation'
  write(6,*) '  is used).'
  write(6,*) ' '

  !----------------------

  call eq_gfnum('BR',ifcns(1))
  call eq_gfnum('BR_RZ',ifcns(2))

  call eq_gfnum('BZ',ifcns(3))
  call eq_gfnum('BZ_RZ',ifcns(4))

  call eq_gfnum('Bphi',ifcns(5))
  call eq_gfnum('Bphi_RZ',ifcns(6))

  !----------------------

  call eqrz_bffgrad(ivec,zR,zZ,zphi,ztol, &
       bvec1,gbtens1, &
       nlist,ifcns,ivec,fvals1,fgrads1,nregion,ierr)
  if(ierr.ne.0) then
     write(6,*) 'eqrz_bffgrad call error'
     return
  endif
  call bpolgen(bvec1,fvals1,bpol1)

  call eq_bffgrad(ivec,zrho,zchi,zphi,1, &
       bvec2,gbtens2, &
       nlist,ifcns,ivec,fvals2,fgrads2,nregion,ierr)
  if(ierr.ne.0) then
     write(6,*) 'eq_bffgrad call error (1)'
     return
  endif
  call bpolgen(bvec2,fvals2,bpol2)

  call eq_bffgrad(ivec,zrho,zchi,zphi,0, &
       bvec3,gbtens3, &
       nlist,ifcns,ivec,fvals3,fgrads3,nregion,ierr)
  if(ierr.ne.0) then
     write(6,*) 'eq_bffgrad call error (2)'
     return
  endif

  call eq_bffgrad(-ivec,zrho,zchi,zphi,1, &
       bvec4,gbtens4, &
       nlist,ifcns,ivec,fvals4,fgrads4,nregion,ierr)
  if(ierr.ne.0) then
     write(6,*) 'eq_bffgrad call error (3)'
     return
  endif
  call bpolgen(bvec4,fvals4,bpol4)

  call eq_bffgrad(-ivec,zrho,zchi,zphi,0, &
       bvec5,gbtens5, &
       nlist,ifcns,ivec,fvals5,fgrads5,nregion,ierr)
  if(ierr.ne.0) then
     write(6,*) 'eq_bffgrad call error (4)'
     return
  endif

  write(6,*) ' '
  write(6,*) ' #  BR(eqrz)       BR(eqrz:f)     BR(eqrz:frz)   BR(eq)         BR(eq:f)'

  do ii=1,ivec
     write(6,1002) ii,bvec1(1,ii),fvals1(ii,1),fvals1(ii,2),bvec2(1,ii),fvals2(ii,1)
  enddo

  write(6,*) ' '
  write(6,*) ' #  BR(eq:frz)     BR(-eq)        BR(-eq:f)      BR(-eq:frz)    dummy'

  do ii=1,ivec
     write(6,1002) ii,fvals2(ii,2),bvec4(1,ii),fvals4(ii,1),fvals4(ii,2),ZERO
  enddo

  write(6,*) ' '
  write(6,*) ' #  BZ(eqrz)       BZ(eqrz:f)     BZ(eqrz:frz)   BZ(eq)         BZ(eq:f)'

  do ii=1,ivec
     write(6,1002) ii,bvec1(2,ii),fvals1(ii,3),fvals1(ii,4),bvec2(2,ii),fvals2(ii,3)
  enddo

  write(6,*) ' '
  write(6,*) ' #  BZ(eq:frz)     BZ(-eq)        BZ(-eq:f)      BZ(-eq:frz)    dummy'

  do ii=1,ivec
     write(6,1002) ii,fvals2(ii,4),bvec4(2,ii),fvals4(ii,3),fvals4(ii,4),ZERO
  enddo

  write(6,*) ' '
  write(6,*) ' #  Bphi(eqrz)     Bphi(eqrz:f)   Bphi(eqrz:frz) Bphi(eq)       Bphi(eq:f)'

  do ii=1,ivec
     write(6,1002) ii,bvec1(3,ii),fvals1(ii,5),fvals1(ii,6),bvec2(3,ii),fvals2(ii,5)
  enddo

  write(6,*) ' '
  write(6,*) ' #  Bphi(eq:frz)   Bphi(-eq)      Bphi(-eq:f)    Bphi(-eq:frz)  dummy'

  do ii=1,ivec
     write(6,1002) ii,fvals2(ii,6),bvec4(3,ii),fvals4(ii,5),fvals4(ii,6),ZERO
  enddo

  write(6,*) ' '
  write(6,*) ' #  Bpol(eqrz)     Bpol(eqrz:f)   Bpol(eqrz:frz) Bpol(eq)       Bpol(eq:f)'

  do ii=1,ivec
     write(6,1002) ii,bpol1(ii,1),bpol1(ii,2),bpol1(ii,3),bpol2(ii,1),bpol2(ii,2)
  enddo

  write(6,*) ' '
  write(6,*) ' #  Bpol(eq:frz)   Bpol(-eq)      Bpol(-eq:f)    Bpol(-eq:frz)  dummy'

  do ii=1,ivec
     write(6,1002) ii,bpol2(ii,3),bpol4(ii,1),bpol4(ii,2),bpol4(ii,3),ZERO
  enddo

  write(6,*) ' '
  write(6,*) ' #  Bpol(eq0)      Bperp(eq0)     |Bpol(eq0:f)|  |Bpol(eq0:frz)|  dummy'

  do ii=1,ivec
     write(6,1002) ii,bvec3(2,ii),bvec3(1,ii), &
          sqrt(fvals3(ii,1)**2+fvals3(ii,3)**2), &
          sqrt(fvals3(ii,2)**2+fvals3(ii,4)**2), &
          ZERO
  enddo

  write(6,*) ' '
  write(6,*) ' #  Bpol(-eq0)     Bperp(-eq0)    |Bpol(-eq0:f)| |Bpol(-eq0:frz)| dummy'

  do ii=1,ivec
     write(6,1002) ii,bvec5(2,ii),bvec5(1,ii), &
          sqrt(fvals5(ii,1)**2+fvals5(ii,3)**2), &
          sqrt(fvals5(ii,2)**2+fvals5(ii,4)**2), &
          ZERO
  enddo

  write(6,*) ' '
  write(6,*) ' d(Bphi)/dR'
  write(6,*) ' #  eqrz           eqrz:f         eqrz:frz       eq             eq:f'

  do ii=1,ivec
     write(6,1002) ii,gbtens1(1,3,ii),fgrads1(1,ii,5),fgrads1(1,ii,6), &
          gbtens2(1,3,ii),fgrads2(1,ii,5)
  enddo

  write(6,*) ' '
  write(6,*) ' #  eq:frz         -eq            -eq:f          -eq:frz        dummy'

  do ii=1,ivec
     write(6,1002) ii,fgrads2(1,ii,6), &
          gbtens4(1,3,ii),fgrads4(1,ii,5),fgrads4(1,ii,6),ZERO
  enddo

  write(6,*) ' '
  write(6,*) ' d(Bphi)/dZ'
  write(6,*) ' #  eqrz           eqrz:f         eqrz:frz       eq             eq:f'

  do ii=1,ivec
     write(6,1002) ii,gbtens1(2,3,ii),fgrads1(2,ii,5),fgrads1(2,ii,6), &
          gbtens2(2,3,ii),fgrads2(2,ii,5)
  enddo

  write(6,*) ' '
  write(6,*) ' #  eq:frz         -eq            -eq:f          -eq:frz        dummy'

  do ii=1,ivec
     write(6,1002) ii,fgrads2(2,ii,6), &
          gbtens4(2,3,ii),fgrads4(2,ii,5),fgrads4(2,ii,6),ZERO
  enddo

  write(6,*) ' '
  write(6,*) ' d(Bphi)/dsperp'
  write(6,*) ' #  eq0            eq0:f          eq0:frz        -eq0           -eq0:f'

  do ii=1,ivec
     write(6,1002) ii,gbtens3(1,3,ii),fgrads3(1,ii,5),fgrads3(1,ii,6), &
          gbtens5(1,3,ii),fgrads5(1,ii,5)
  enddo

  write(6,*) ' '
  write(6,*) ' |grad(Bphi)|'
  write(6,*) ' #  eqrz           eqrz:f         eqrz:frz       eq             eq:f'

  do ii=1,ivec
     write(6,1002) ii,sqrt(gbtens1(1,3,ii)**2+gbtens1(2,3,ii)**2), &
          sqrt(fgrads1(1,ii,5)**2+fgrads1(2,ii,5)**2), &
          sqrt(fgrads1(1,ii,6)**2+fgrads1(2,ii,6)**2), &
          sqrt(gbtens2(1,3,ii)**2+gbtens2(2,3,ii)**2), &
          sqrt(fgrads2(1,ii,5)**2+fgrads2(2,ii,5)**2)
  enddo

  write(6,*) ' '
  write(6,*) ' #  eq:frz         -eq            -eq:f          -eq:frz        eq0'

  do ii=1,ivec
     write(6,1002) ii,sqrt(fgrads2(1,ii,6)**2+fgrads2(2,ii,6)**2), &
          sqrt(gbtens4(1,3,ii)**2+gbtens4(2,3,ii)**2), &
          sqrt(fgrads4(1,ii,5)**2+fgrads4(2,ii,5)**2), &
          sqrt(fgrads4(1,ii,6)**2+fgrads4(2,ii,6)**2), &
          sqrt(gbtens3(1,3,ii)**2+gbtens3(2,3,ii)**2)
  enddo

  write(6,*) ' '
  write(6,*) ' #  eq0:f          eq0:frz        -eq0           -eq0:f         -eq0:frz'

  do ii=1,ivec
     write(6,1002) ii,sqrt(fgrads3(1,ii,5)**2+fgrads3(2,ii,5)**2), &
          sqrt(fgrads3(1,ii,6)**2+fgrads3(2,ii,6)**2), &
          sqrt(gbtens5(1,3,ii)**2+gbtens5(2,3,ii)**2), &
          sqrt(fgrads5(1,ii,5)**2+fgrads5(2,ii,5)**2), &
          sqrt(fgrads5(1,ii,6)**2+fgrads5(2,ii,6)**2)
  enddo

  write(6,*) ' '
  write(6,*) ' d(BR)/dR'
  write(6,*) ' #  eqrz           eqrz:f         eqrz:frz       eq             eq:f'

  do ii=1,ivec
     write(6,1002) ii,gbtens1(1,1,ii),fgrads1(1,ii,1),fgrads1(1,ii,2), &
          gbtens2(1,1,ii),fgrads2(1,ii,1)
  enddo

  write(6,*) ' '
  write(6,*) ' #  eq:frz         -eq            -eq:f          -eq:frz        dummy'

  do ii=1,ivec
     write(6,1002) ii,fgrads2(1,ii,2), &
          gbtens4(1,1,ii),fgrads4(1,ii,1),fgrads4(1,ii,2),ZERO
  enddo

  write(6,*) ' '
  write(6,*) ' d(BR)/dZ'
  write(6,*) ' #  eqrz           eqrz:f         eqrz:frz       eq             eq:f'

  do ii=1,ivec
     write(6,1002) ii,gbtens1(2,1,ii),fgrads1(2,ii,1),fgrads1(2,ii,2), &
          gbtens2(2,1,ii),fgrads2(2,ii,1)
  enddo

  write(6,*) ' '
  write(6,*) ' #  eq:frz         -eq            -eq:f          -eq:frz        dummy'

  do ii=1,ivec
     write(6,1002) ii,fgrads2(2,ii,2), &
          gbtens4(2,1,ii),fgrads4(2,ii,1),fgrads4(2,ii,2),ZERO
  enddo

  write(6,*) ' '
  write(6,*) ' d(BZ)/dR'
  write(6,*) ' #  eqrz           eqrz:f         eqrz:frz       eq             eq:f'

  do ii=1,ivec
     write(6,1002) ii,gbtens1(1,2,ii),fgrads1(1,ii,3),fgrads1(1,ii,4), &
          gbtens2(1,2,ii),fgrads2(1,ii,3)
  enddo

  write(6,*) ' '
  write(6,*) ' #  eq:frz         -eq            -eq:f          -eq:frz        dummy'

  do ii=1,ivec
     write(6,1002) ii,fgrads2(1,ii,4), &
          gbtens4(1,2,ii),fgrads4(1,ii,3),fgrads4(1,ii,4),ZERO
  enddo

  write(6,*) ' '
  write(6,*) ' d(BZ)/dZ'
  write(6,*) ' #  eqrz           eqrz:f         eqrz:frz       eq             eq:f'

  do ii=1,ivec
     write(6,1002) ii,gbtens1(2,2,ii),fgrads1(2,ii,3),fgrads1(2,ii,4), &
          gbtens2(2,2,ii),fgrads2(2,ii,3)
  enddo

  write(6,*) ' '
  write(6,*) ' #  eq:frz         -eq            -eq:f          -eq:frz        dummy'

  do ii=1,ivec
     write(6,1002) ii,fgrads2(2,ii,4), &
          gbtens4(2,2,ii),fgrads4(2,ii,3),fgrads4(2,ii,4),ZERO
  enddo

  write(6,*) ' '
  write(6,*) ' d(Bpol)/dsperp'
  write(6,*) ' #  eq0            eq0:f          eq0:frz        -eq0           -eq0:f'

  do ii=1,ivec
     zwk3a=(fvals3(ii,1)*fgrads3(1,ii,1)+fvals3(ii,3)*fgrads3(1,ii,3))/ &
          bvec3(2,ii)
     zwk3b=(fvals3(ii,2)*fgrads3(1,ii,2)+fvals3(ii,4)*fgrads3(1,ii,4))/ &
          bvec3(2,ii)
     zwk5a=(fvals5(ii,1)*fgrads5(1,ii,1)+fvals5(ii,3)*fgrads5(1,ii,3))/ &
          bvec5(2,ii)
     write(6,1002) ii,gbtens3(1,2,ii),zwk3a,zwk3b,gbtens5(1,2,ii),zwk5a
  enddo

  write(6,*) ' '
  write(6,*) ' d(Bpol)/dspol'
  write(6,*) ' #  eq0            eq0:f          eq0:frz        -eq0           -eq0:f'

  do ii=1,ivec
     zwk3a=(fvals3(ii,1)*fgrads3(2,ii,1)+fvals3(ii,3)*fgrads3(2,ii,3))/ &
          bvec3(2,ii)
     zwk3b=(fvals3(ii,2)*fgrads3(2,ii,2)+fvals3(ii,4)*fgrads3(2,ii,4))/ &
          bvec3(2,ii)
     zwk5a=(fvals5(ii,1)*fgrads5(2,ii,1)+fvals5(ii,3)*fgrads5(2,ii,3))/ &
          bvec5(2,ii)
     write(6,1002) ii,gbtens3(2,2,ii),zwk3a,zwk3b,gbtens5(2,2,ii),zwk5a
  enddo

  write(6,*) ' '
  write(6,*) ' |grad(Bpol)|'
  write(6,*) ' #  eqrz           eqrz:f         eqrz:frz       eq             eq:f'

  do ii=1,ivec
     zbpol=sqrt(bvec1(1,ii)**2+bvec1(2,ii)**2)
     zwk3a=(bvec1(1,ii)*gbtens1(1,1,ii)+bvec1(2,ii)*gbtens1(1,2,ii))/zbpol
     zwk3b=(bvec1(1,ii)*gbtens1(2,1,ii)+bvec1(2,ii)*gbtens1(2,2,ii))/zbpol
     zwkp(1)=sqrt(zwk3a**2+zwk3b**2)

     zbpol=sqrt(fvals1(ii,1)**2+fvals1(ii,3)**2)
     zwk3a=(fvals1(ii,1)*fgrads1(1,ii,1)+fvals1(ii,3)*fgrads1(1,ii,3))/zbpol
     zwk3b=(fvals1(ii,1)*fgrads1(2,ii,1)+fvals1(ii,3)*fgrads1(2,ii,3))/zbpol
     zwkp(2)=sqrt(zwk3a**2+zwk3b**2)

     zbpol=sqrt(fvals1(ii,2)**2+fvals1(ii,4)**2)
     zwk3a=(fvals1(ii,2)*fgrads1(1,ii,2)+fvals1(ii,4)*fgrads1(1,ii,4))/zbpol
     zwk3b=(fvals1(ii,2)*fgrads1(2,ii,2)+fvals1(ii,4)*fgrads1(2,ii,4))/zbpol
     zwkp(3)=sqrt(zwk3a**2+zwk3b**2)

     zbpol=sqrt(bvec2(1,ii)**2+bvec2(2,ii)**2)
     zwk3a=(bvec2(1,ii)*gbtens2(1,1,ii)+bvec2(2,ii)*gbtens2(1,2,ii))/zbpol
     zwk3b=(bvec2(1,ii)*gbtens2(2,1,ii)+bvec2(2,ii)*gbtens2(2,2,ii))/zbpol
     zwkp(4)=sqrt(zwk3a**2+zwk3b**2)

     zbpol=sqrt(fvals2(ii,1)**2+fvals2(ii,3)**2)
     zwk3a=(fvals2(ii,1)*fgrads2(1,ii,1)+fvals2(ii,3)*fgrads2(1,ii,3))/zbpol
     zwk3b=(fvals2(ii,1)*fgrads2(2,ii,1)+fvals2(ii,3)*fgrads2(2,ii,3))/zbpol
     zwkp(5)=sqrt(zwk3a**2+zwk3b**2)

     write(6,1002) ii,zwkp(1:5)
  enddo

  write(6,*) ' '
  write(6,*) ' #  eq:frz         -eq            -eq:f          -eq:frz        eq0'

  do ii=1,ivec
     zbpol=sqrt(fvals2(ii,2)**2+fvals2(ii,4)**2)
     zwk3a=(fvals2(ii,2)*fgrads2(1,ii,2)+fvals2(ii,4)*fgrads2(1,ii,4))/zbpol
     zwk3b=(fvals2(ii,2)*fgrads2(2,ii,2)+fvals2(ii,4)*fgrads2(2,ii,4))/zbpol
     zwkp(1)=sqrt(zwk3a**2+zwk3b**2)

     zbpol=sqrt(bvec4(1,ii)**2+bvec4(2,ii)**2)
     zwk3a=(bvec4(1,ii)*gbtens4(1,1,ii)+bvec4(2,ii)*gbtens4(1,2,ii))/zbpol
     zwk3b=(bvec4(1,ii)*gbtens4(2,1,ii)+bvec4(2,ii)*gbtens4(2,2,ii))/zbpol
     zwkp(2)=sqrt(zwk3a**2+zwk3b**2)

     zbpol=sqrt(fvals4(ii,1)**2+fvals4(ii,3)**2)
     zwk3a=(fvals4(ii,1)*fgrads4(1,ii,1)+fvals4(ii,3)*fgrads4(1,ii,3))/zbpol
     zwk3b=(fvals4(ii,1)*fgrads4(2,ii,1)+fvals4(ii,3)*fgrads4(2,ii,3))/zbpol
     zwkp(3)=sqrt(zwk3a**2+zwk3b**2)

     zbpol=sqrt(fvals4(ii,2)**2+fvals4(ii,4)**2)
     zwk3a=(fvals4(ii,2)*fgrads4(1,ii,2)+fvals4(ii,4)*fgrads4(1,ii,4))/zbpol
     zwk3b=(fvals4(ii,2)*fgrads4(2,ii,2)+fvals4(ii,4)*fgrads4(2,ii,4))/zbpol
     zwkp(4)=sqrt(zwk3a**2+zwk3b**2)

     zwkp(5)=sqrt(gbtens3(1,2,ii)**2+gbtens3(2,2,ii)**2)

     write(6,1002) ii,zwkp(1:5)
  enddo

  write(6,*) ' '
  write(6,*) ' #  eq0:f          eq0:frz        -eq0           -eq0:f         -eq0:frz'

  do ii=1,ivec

     zbpol=sqrt(fvals3(ii,1)**2+fvals3(ii,3)**2)
     zwk3a=(fvals3(ii,1)*fgrads3(1,ii,1)+fvals3(ii,3)*fgrads3(1,ii,3))/ &
          zbpol
     zwk3b=(fvals3(ii,1)*fgrads3(2,ii,1)+fvals3(ii,3)*fgrads3(2,ii,3))/ &
          zbpol
     zwkp(1)=sqrt(zwk3a**2+zwk3b**2)

     zbpol=sqrt(fvals3(ii,2)**2+fvals3(ii,4)**2)
     zwk3a=(fvals3(ii,2)*fgrads3(1,ii,2)+fvals3(ii,4)*fgrads3(1,ii,4))/ &
          zbpol
     zwk3b=(fvals3(ii,2)*fgrads3(2,ii,2)+fvals3(ii,4)*fgrads3(2,ii,4))/ &
          zbpol
     zwkp(2)=sqrt(zwk3a**2+zwk3b**2)

     zwkp(3)=sqrt(gbtens5(1,2,ii)**2+gbtens5(2,2,ii)**2)

     zbpol=sqrt(fvals5(ii,1)**2+fvals5(ii,3)**2)
     zwk3a=(fvals5(ii,1)*fgrads5(1,ii,1)+fvals5(ii,3)*fgrads5(1,ii,3))/ &
          zbpol
     zwk3b=(fvals5(ii,1)*fgrads5(2,ii,1)+fvals5(ii,3)*fgrads5(2,ii,3))/ &
          zbpol
     zwkp(4)=sqrt(zwk3a**2+zwk3b**2)

     zbpol=sqrt(fvals5(ii,2)**2+fvals5(ii,4)**2)
     zwk3a=(fvals5(ii,2)*fgrads5(1,ii,2)+fvals5(ii,4)*fgrads5(1,ii,4))/ &
          zbpol
     zwk3b=(fvals5(ii,2)*fgrads5(2,ii,2)+fvals5(ii,4)*fgrads5(2,ii,4))/ &
          zbpol
     zwkp(5)=sqrt(zwk3a**2+zwk3b**2)

     write(6,1002) ii,zwkp(1:5)
  enddo

  contains
    subroutine bpolgen(bvec,fvals,bpol)
      real*8, dimension(:,:) :: bvec,fvals,bpol
      integer :: ii

      do ii=1,ivec
         bpol(ii,1)=sqrt(bvec(1,ii)**2+bvec(2,ii)**2)
         bpol(ii,2)=sqrt(fvals(ii,1)**2+fvals(ii,3)**2)
         bpol(ii,3)=sqrt(fvals(ii,2)**2+fvals(ii,4)**2)
      enddo
    end subroutine bpolgen
      
end subroutine test_eq_get

subroutine test_mcgrid
  !  test f77 xplasma "mcgrid" grid & profile create/retrieve subroutines

  use xplasma_obj_instance
  implicit NONE

  real*8, dimension(:), allocatable :: mcprof

  integer :: iudsym = 2   ! assume no updown symmetry
  integer :: inth0 = 2    ! poloidal zones in [0:pi] of first row around axis
  integer :: inznbmri = 10   ! radial zone rows in plasma
  integer :: inphi = 1    ! no toroidal variation

  integer :: id_mcgrid

  integer :: judsym,inrow,inrow_ext,inzon,inzon_ext,jnth0,jnphi,idum,ierr
  integer :: inth,ith,ir,ii,jj,itot,itmp,iftest(12),in1,in2,inum
  integer, dimension(:), allocatable :: inthzns,ids

  real*8, dimension(:), allocatable :: zvols
  real*8, dimension(:,:,:), allocatable :: zftest

  real*8, parameter :: ONE = 1.0d0
  character*32 zname
  !----------------------------------------------------

  call mcgrid_define(inphi,iudsym,inth0,inznbmri,idum,id_mcgrid)
  write(6,*) ' after mcgrid_define call id_mcgrid = ',id_mcgrid
  if(id_mcgrid.eq.0) then
     write(6,*) ' ==> an ERROR occurred.'
     return
  endif

  call mcgrid_getsym(id_mcgrid,judsym)
  write(6,*) ' iudsym (1 means updown symmetric): ',judsym

  call mcgrid_getnumr(id_mcgrid,inrow_ext,inrow)
  write(6,*) ' #zone rows (internal, total): ',inrow,inrow_ext

  call mcgrid_getnumz(id_mcgrid,inzon_ext,inzon)
  write(6,*) ' #zones (internal, total): ',inzon,inzon_ext

  call mcgrid_getnuma(id_mcgrid,jnth0,jnphi)
  write(6,*) ' #theta zones in 1st row at axis: ',jnth0
  write(6,*) ' #toroidal zones (1 for axisymmetric): ',jnphi

  allocate(inthzns(inrow_ext))

  call mcgrid_getnumzns(id_mcgrid,inthzns)
  write(6,*) ' #theta zones in all zone rows: '
  write(6,*) inthzns

  allocate(zvols(inzon))
  call mcgrid_getobj(id_mcgrid,'Zone_Volumes',-1,0,ONE,zvols,inzon,ierr)
  if(ierr.ne.0) then
     write(6,*) ' ?mcgrid_getobj failure:'
     call xplasma_error(s,ierr,6)
     return
  endif

  write(6,*) ' '
  write(6,*) ' zvols (1st row): ',zvols(1:4)
  write(6,*) ' '
  write(6,*) ' zvols (2nd row): ',zvols(5:12)
  write(6,*) ' '

  deallocate(zvols)

  !  test function

  allocate(zftest(2,2,inzon))
  itot=0
  do ir=1,inrow
     inth=inthzns(ir)
     do ith=1,inth
        zftest(1,1,itot+ith)=ith
        zftest(2,1,itot+ith)=inth+1-ith
        itmp=ith+inth/2
        if(itmp.gt.inth) itmp=itmp-inth
        zftest(1,2,itot+ith)=itmp
        zftest(2,2,itot+ith)=inth+1-itmp
     enddo
     itot=itot+inth
  enddo

  call mcgrid_putarr2(id_mcgrid,'ftest_mcgrid', &
       -1,0,0,ONE,zftest,2,2,2,2,inzon,ierr)
  if(ierr.ne.0) then
     write(6,*) ' ?mcgrid_putarr2 error.'
  else
     in1=0
     in2=0
     zftest=0
     call mcgrid_getarr2(id_mcgrid,'ftest_mcgrid', &
          -1,0,ONE,zftest,2,2,inzon,in1,in2,ierr)
     call out3('normal')

     zftest=0
     call mcgrid_getarr2(id_mcgrid,'ftest_mcgrid', &
          -1,0,-ONE,zftest,2,2,inzon,in1,in2,ierr)
     call out3('th_ reverse')

     zftest=0
     call mcgrid_getarr2(id_mcgrid,'ftest_mcgrid', &
          0,0,ONE,zftest,2,2,inzon,in1,in2,ierr)
     call out3('shift')

     zftest=0
     call mcgrid_getarr2(id_mcgrid,'ftest_mcgrid', &
          0,0,-ONE,zftest,2,2,inzon,in1,in2,ierr)
     call out3('shift+th_reverse')
  endif

  deallocate(inthzns,zftest)
  write(6,*) ' '
  write(6,*) ' (test_mcgrid done).'
  write(6,*) ' '

  !------------------------------------------------

  call xplasma_find_grids(s,ierr, &
       icoord=xplasma_rho_coord, num_grids=inum)
  allocate(ids(inum))
  call xplasma_find_grids(s,ierr, &
       icoord=xplasma_rho_coord, id_grids=ids)

  write(6,*) ' grids discretizing "rho":'
  do ii=1,inum
     call xplasma_get_item_info(s,ids(ii),ierr,name=zname)
     write(6,*) ii,trim(zname)
  enddo

  deallocate(ids)

  !------------------------------------------------

  call xplasma_find_profs(s,ierr, &
       icoord1=xplasma_rho_coord,num_profs=inum)
  allocate(ids(inum))
  call xplasma_find_profs(s,ierr, &
       icoord1=xplasma_rho_coord, id_profs=ids)

  write(6,*) ' '
  write(6,*) ' profiles vs. "rho" only:'
  do ii=1,inum
     call xplasma_get_item_info(s,ids(ii),ierr,name=zname)
     write(6,*) ii,trim(zname)
  enddo

  deallocate(ids)
  !------------------------------------------------

  call xplasma_find_blkbxs(s,ierr, &
       itype=17,num_blkbxs=inum)
  allocate(ids(inum))
  call xplasma_find_blkbxs(s,ierr, &
       itype=17, id_blkbxs=ids)

  write(6,*) ' '
  write(6,*) ' black boxes of type # 17:'
  do ii=1,inum
     call xplasma_get_item_info(s,ids(ii),ierr,name=zname)
     write(6,*) ii,trim(zname)
  enddo

  deallocate(ids)
  !------------------------------------------------
  write(6,*) ' '

  contains
    subroutine out3(zlbl)
      character*(*), intent(in) :: zlbl

      integer :: itot,inum,irow(100)

      if(ierr.ne.0) then
         write(6,*) ' mcgrid_getarr2 "',zlbl,'" call had an error.'
      else

         inum=inthzns(3)
         itot=inthzns(1)+inthzns(2)

         write(6,*) ' '
         write(6,*) ' "',zlbl,'" (1,1) row 3:'
         irow(1:inum)=zftest(1,1,itot+1:itot+inum)+0.1
         write(6,*) irow(1:inum)

         write(6,*) ' '
         write(6,*) ' "',zlbl,'" (2,1) row 3:'
         irow(1:inum)=zftest(2,1,itot+1:itot+inum)+0.1
         write(6,*) irow(1:inum)

         write(6,*) ' '
         write(6,*) ' "',zlbl,'" (1,2) row 3:'
         irow(1:inum)=zftest(1,2,itot+1:itot+inum)+0.1
         write(6,*) irow(1:inum)

         write(6,*) ' '
         write(6,*) ' "',zlbl,'" (2,2) row 3:'
         irow(1:inum)=zftest(2,2,itot+1:itot+inum)+0.1
         write(6,*) irow(1:inum)

      endif

    end subroutine out3

end subroutine test_mcgrid

subroutine test_vtaub

  implicit NONE

  integer, parameter :: itsize = 6
  real*8 :: xb(itsize) = (/ 0.1d0, 0.3d0, 0.5d0, 0.7d0, 0.9d0, 1.1d0 /)
  real*8 :: vtaub(itsize)

  real*8 :: tol=1.0d-4
  real*8 :: cut=1.0d-8

  real*8 :: zrho=0.75d0

  real*8 :: zbmin,zbmax

  integer :: i,ierr
  !-------------------------

  call eq_tau_bounce(zrho,itsize,xb,tol,cut,zbmin,zbmax,vtaub,ierr)
  if(ierr.ne.0) then
     write(6,*) ' ?test_vtaub: ierr= ',ierr,' after eq_tau_bounce call.'
     return
  endif

  write(6,*) ' eq_tau_bounce OK: rho=',zrho
  write(6,*) ' zbmin,zbmax = ',zbmin,zbmax

  write(6,*) ' v*tau_bounce vs. x = (Brefl-Bmin)/(Bmax-Bmin)'
  write(6,*) '     trapped/passing boundary at x=1.'
  write(6,*) ' '
  write(6,*) '   #   x              v*taub'
  
  do i=1,itsize
     write(6,'(3x,i2,2(1x,1pe13.6))') i,xb(i),vtaub(i)
  enddo

  write(6,*) ' '

end subroutine test_vtaub

subroutine eq_get_psi0(psi0,ifind,ierr)

  ! retrieve Psi0 -- EFIT Psi offset, mag. axis to machine axis
  !  ...if available

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  real*8, intent(out) :: psi0       ! Psi0 value, Wb/rad
  integer, intent(out) :: ifind     ! =1 if value is found, =0 otherwise
  integer, intent(out) :: ierr      ! error status code; 0=OK

  ! if no Psi0 data exists, ifind=ierr=0 are returned.

  !----------------------

  call xplasma_get_psi0(s,psi0,ifind,ierr)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_get_psi0: error detected in xplasma: '
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_get_psi0

subroutine eqm_bpsi(ivec,zR,zZ,zphi,init,BR,BZ,BPHI,zpsi,ipsi,ierr)

  !  compute B vector on (R,Z) grid -- psi(R,Z) presumed known.

  !  **valid only for axisymmetric equilibria**

  !  axisymmetry is assumed... phi argument is ignored, but left in so
  !  that the routine can be used as an argument of the eqm_brz subroutine

  use xplasma_definitions
  use eqi_rzbox_module
  implicit NONE

  integer ivec                      ! vector lengths
  real*8 zR(ivec),zZ(ivec),zphi(ivec) ! locations to evaluate B vector

  integer init                      ! init-cleanup-compute control flag

  !  init=1  -- initialize
  !  init=2  -- cleanup
  !  init=0  -- compute

  !  ...a vector of B vectors...
  real*8 BR(ivec),BZ(ivec),BPHI(ivec) ! field vectors components (returned)

  real*8 zpsi(ivec)                 ! psi(poloidal) returned.
  !  for this routine, zpsi is a placeholder, it is not touched.
  !  the place holder is necessary to make this routine usable as a passed
  !  argument "userbvec" in xplasma_brz.

  integer ipsi                      ! =0 returned, no psi(poloidal) flag
  !  Psi is input, not output, in this routine.

  integer ierr                      ! completion code, 0=OK

  !--------------------------------

  real*8, dimension(:), allocatable :: zg,zrho,zchi,zRloc,zZloc,zdeti
  real*8, dimension(:,:), allocatable :: f2,f5
  real*8 zRaxis,zZaxis,zdum

  logical ioutsid(ivec),axisymm

  integer i,id_bmod,id_psi,id_g,id_Rgrid,id_Zgrid,id_R,id_Z,id_map

  integer :: id5(5),idth(5),idrho(5)
  integer :: id2(2),idR(2),idZ(2)
  integer,parameter :: idRdth=1,idRdrho=2,idZdth=3,idZdrho=4,idpsidrho=5

  integer :: nsnccwb,nsnccwi

  integer ivecin,ivecout
  integer, dimension(:), allocatable :: iregion

  real*8, parameter :: zrhomin = 1.0d-12
  !--------------------------------

  call xplasma_global_info(sp,ierr, axisymm=axisymm, &
       bphi_ccw=nsnccwb, jphi_ccw=nsnccwi)
  if(ierr.ne.0) return

  if(.not.axisymm) then
     ierr=107
     call xplasma_errmsg_append(sp,' ?eqm_bpsi: plasma must be axisymmetric!')
     go to 900
  endif

  ipsi=0

  !  cleanup call

  if(init.eq.2) then
     !  nothing need be done
     go to 900
  endif

  !  initialization; error checks done once...

  call xplasma_common_ids(sp,ierr, id_bmod=id_bmod,id_psi=id_psi,id_g=id_g, &
       id_R=id_R,id_Z=id_Z)

  if(init.eq.1) then

     if(min(id_bmod,id_psi,abs(nsnccwi),abs(nsnccwb)).eq.0) then
        call xplasma_errmsg_append(sp, &
             ' ?eqm_bpsi: core plasma equilibrium & fields must be defined!')
        ierr=608
        go to 900
     endif

     call xplasma_find_item(sp,'__RGRID',id_Rgrid,ierr,nf_noerr=.TRUE.)
     call xplasma_find_item(sp,'__ZGRID',id_Zgrid,ierr,nf_noerr=.TRUE.)

     if(min(id_Rgrid,id_Zgrid).eq.0) then
        call xplasma_errmsg_append(sp, &
             ' ?eqm_bpsi: R & Z external grids must be defined first.')
        ierr=615
        go to 900
     endif

     call xplasma_mag_axis(sp,ierr, zRaxis,zZaxis)
     if(ierr.ne.0) then
        ierr=9999
        call xplasma_errmsg_append(sp, &
             ' ?eqm_bpsi: unexpected error in xplasma_mag_axis call.')
        go to 900
     endif

     !  psi(R,Z) must exist

     call xplasma_eval_prof(sp,id_psi, &
          xplasma_R_coord,zRaxis,xplasma_Z_coord,zZaxis, &
          zdum,ierr)
     if(ierr.ne.0) then
        call xplasma_errmsg_append(sp, &
             ' ?eqm_bpsi: test evaluation of Psi(R,Z) failed.')
        go to 900
     endif

     !----------------------------------
     !  OK...
     go to 900                      ! exit initialization
  endif

  !  evaluation...

  allocate(zrho(ivec),zchi(ivec),zg(ivec),iregion(ivec))
  call eqi_fastinv(ivec,zR,zZ,zphi,zrhomin,zrho,zchi,iregion,ierr)
  if(ierr.ne.0) then
     deallocate(zrho,zchi,zg,iregion)
     go to 900
  endif

  do i=1,ivec
     if(zrho(i).gt.(1.0d0)) then
        !  outside core region
        ioutsid(i)=.TRUE.
        zrho(i)=1.00d0
     else
        !  inside core region and...
        ioutsid(i)=.FALSE.       ! core BR,BZ are available
     endif
  enddo

  !  ioutsid(i)=.FALSE. means (BR,BZ) will be evaluated by interpolating
  !    core BR(chi,phi) and BZ(chi,phi) functions;
  !  ioutsid(i)=.TRUE. means (BR,BZ) will be evaluated via 1/R * grad(psi)

  !  do Bphi now...

  call xplasma_eval_prof(sp,id_g,zrho,zg,ierr)
  if(ierr.ne.0) then
     deallocate(zrho,zchi,zg,iregion)
     go to 900
  endif

  do i=1,ivec
     Bphi(i)=nsnccwb*zg(i)/zR(i)
  enddo

  !  OK for (1/R)grad(Psi) ^ e_phi need to sort inside and outside pts...

  allocate(zRloc(ivec),zZloc(ivec))

  ivecin=0
  ivecout=0
  do i=1,ivec
     if(ioutsid(i)) then
        ivecout=ivecout+1
        zRloc(ivecout)=zR(i)
        zZloc(ivecout)=zZ(i)
     else
        ivecin=ivecin+1
        zrho(ivecin)=zrho(i)
        zchi(ivecin)=zchi(i)
     endif
  enddo

  !  evaluate inside pts

  if(ivecin.gt.0) then

     !  set up to evaluate {R,Z,Psi} derivatives; settings must be consistent
     !  with parameters idRdrho, etc.
     id5(1:2)=id_R
     id5(3:4)=id_Z
     id5(5)=id_psi
     idth = (/1, 0, 1, 0, 0/)  ! d/dth controls
     idrho= (/0, 1, 0, 1, 1/)  ! d/drho controls

     allocate(f5(ivecin,5),zdeti(ivecin))

     call xplasma_eval_prof(sp,id5, &
          xplasma_theta_coord,zchi(1:ivecin),xplasma_rho_coord,zrho(1:ivecin),&
          f5,ierr, ideriv1s=idth, ideriv2s=idrho)

     if(ierr.eq.0) then
        ! fold in sign factor (direction of current) & 1/det[metric Jacobian]

        zdeti = nsnccwi/(f5(1:ivecin,idRdth)*f5(1:ivecin,idZdrho) - &
             f5(1:ivecin,idZdth)*f5(1:ivecin,idRdrho))

        !  copy back

        ivecin=0
        do i=1,ivec
           if(.not.ioutsid(i)) then
              ivecin=ivecin+1
              BR(i)=f5(ivecin,idpsidrho)*f5(ivecin,idRdth)*zdeti(ivecin)/zR(i)
              BZ(i)=f5(ivecin,idpsidrho)*f5(ivecin,idZdth)*zdeti(ivecin)/zR(i)
           endif
        enddo
     endif
     deallocate(f5,zdeti)
  endif
  if(ierr.ne.0) then
     deallocate(zrho,zchi,zg,iregion,zRloc,zZloc)
     go to 900
  endif

  !  evaluate outside points using gradpsi & note sign factor...

  if(ivecout.gt.0) then

     !  lookup on psi's R,Z grid

     allocate(f2(ivecout,2))

     id2(1:2)=id_psi
     idR = (/ 1, 0 /)
     idZ = (/ 0, 1 /)

     call xplasma_eval_prof(sp,id2, &
          xplasma_R_coord,zRloc(1:ivecout),xplasma_Z_coord,zZloc(1:ivecout), &
          f2,ierr, ideriv1s=idR, ideriv2s=idZ)

     if(ierr.eq.0) then

        !  f2(:,1) = dPsi/dR
        !  f2(:,2) = dPsi/dZ

        ivecout=0
        do i=1,ivec
           if(ioutsid(i)) then
              ivecout=ivecout+1
              BR(i)=nsnccwi*f2(ivecout,2)/zRloc(ivecout)  ! or /zR(i)
              BZ(i)=-nsnccwi*f2(ivecout,1)/zRloc(ivecout) ! or /zR(i)
           endif
        enddo
     endif

  endif

  deallocate(zrho,zchi,zg,iregion,zRloc,zZloc)
  if(ierr.ne.0) then
     go to 900
  else
     go to 1000
  endif

900 continue
  bphi=0.0d0
  bz=0.0d0
  br=0.0d0

1000 continue

end subroutine eqm_bpsi

subroutine eq_arc_scrunch(r,z,nth,ns,rmc1d,rms1d,zmc1d,zms1d,imom,ier)

  ! remap {R(theta,rho),Z(theta,rho)} to an evenly spaced theta grid [0:2pi]
  ! defined by equal arclengh on each surface, i.e.
  !
  !     L(theta1,theta2)/L(0,2pi) = (theta2-theta)/2pi

  ! on each surface contour, theta=0 is defined as the point where the
  ! contour passes Z=0 on the large major radius side.

  ! algorithm:  the contour {R(:,j),Z(:,j)} is remapped surface-by-surface;
  !             moments are only calculated at the end.  The FFT is not used
  !             in any intermediate calculation, so there is no moments 
  !             truncation error in the {R,Z} contour regeneration.

  ! minimal error checking here -- this is a "private" routine of the
  ! nscrunch library -- this should be called from scrunch_rz.f90 only

  use iso_c_binding, only: fp => c_double
  use eq_arc_scrunch_mod
  implicit NONE

  !-------------------------------------------------------
  !  arguments

  integer, intent(in) :: nth    ! no. of theta pts
  integer, intent(in) :: ns     ! no. of surfaces

  ! numerical surfaces, modified on output:
  real(fp), dimension(nth,ns), intent(inout) :: r, z

  integer, intent(in) :: imom   ! no. of moments not counting 0'th moment

  real(fp), dimension(0:imom,ns), intent(out) :: rmc1d
  real(fp), dimension(0:imom,ns), intent(out) :: rms1d
  real(fp), dimension(0:imom,ns), intent(out) :: zmc1d
  real(fp), dimension(0:imom,ns), intent(out) :: zms1d

  integer, intent(out) :: ier   ! completion code: 0 = OK

  !-------------------------------------------------------
  !  local

  real(fp) :: Raxis, Zaxis
  integer :: is
  !-------------------------------------------------------

  Raxis = R(1,1)
  Zaxis = Z(1,1)
  R(2:nth,1)=Raxis
  Z(2:nth,1)=Zaxis

  rmc1d(0:imom,1)=0
  rms1d(0:imom,1)=0
  zmc1d(0:imom,1)=0
  zms1d(0:imom,1)=0

  rmc1d(0,1)=Raxis
  zmc1d(0,1)=Zaxis

  do is = 2,ns

    call eq_arc_scrunch1(Raxis, Zaxis, &
         R(1:nth,is), Z(1:nth,is), &
         rmc1d(0:imom,is), rms1d(0:imom,is), &
         zmc1d(0:imom,is), zms1d(0:imom,is), &
         imom, ier)

    if(ier.ne.0) then
      R(1:nth,is:ns)=0
      Z(1:nth,is:ns)=0
      rmc1d(0:imom,is:ns)=0
      rms1d(0:imom,is:ns)=0
      zmc1d(0:imom,is:ns)=0
      zms1d(0:imom,is:ns)=0
      exit
    end if
  end do

  return
end subroutine eq_arc_scrunch

subroutine eqi_cbdy_pts(zdata,ipts,rlim,zlim,ierr)

  !  create the piecewise linear contour limiter data array.
  !  make the following checks:
  !    ipts.gt.2
  !    rlim(1)=rlim(ipts)
  !    zlim(1)=zlim(ipts)
  !    adjacent points are not equal
  !    sum of angles btween pieces = +/- 2*pi

  use xplasma_obj, only: xplasma_errmsg_append
  use eqi_rzbox_module
  implicit NONE

  !  input:
  integer ipts                      ! 1 + number of linear pieces
  real*8 rlim(ipts),zlim(ipts)      ! the (R,Z) contour point sequence

  !  output:
  integer ierr                      ! completion code, 0=OK
  real*8 zdata(6,ipts)              ! limiter data

  !        zdata(1,i) -- Rlim(i)
  !        zdata(2,i) -- Zlim(i)
  !        zdata(3,i) -- -sin(theta)
  !        zdata(4,i) --  cos(theta)
  !                             theta=atan2(dZ,dR), (dR,dZ)=displacement
  !                                                  from pt i to pt i+1
  !        zdata(5,i) -- -sin(theta)*Rlim(i)+cos(theta)*Zlim(i)
  !        zdata(6,i) -- +/- 1

  !  with elements 3-5 can quickly compute distance from any point to the
  !  infinite line which is a continuation of the given segment, and the
  !  location on that infinite line of the nearest approach, which we can
  !  quickly determine if its in the segment or out.

  !----------------------------------------------
  real*8 zR0,zZ0     ! a test point presumed inside the plasma, computed here

  real*8 zR,zZ,zdr,zdz,zth,zthp,zdth,zthsum,zsdlsum,zdl
  real*8 zsign,period
  integer i
  character*128 zmsg

  !----------------------------------------------
  real*8, parameter :: cone = 1.0d0
  real*8, parameter :: czero = 0.0d0
  real*8, parameter :: ceps4 = 1.0d-4
  real*8, parameter :: cpi = 3.1415926535897931D+00
  real*8, parameter :: c2pi= 6.2831853071795862D+00
  !----------------------------------------------

  ierr=0

  if(ipts.le.2) then
     zmsg=' '
     write(zmsg,*) ' ?eqm_cbdy:  ipts=',ipts,'.  At least 3 pts are required.'
     call xplasma_errmsg_append(sp,zmsg)
     ierr=3000
     return
  endif

  if((rlim(ipts).ne.rlim(1)).or.(zlim(ipts).ne.zlim(1))) then
     zmsg=' '
     write(zmsg,*) ' ?eqm_cbdy:  limiter contour not closed:'
     call xplasma_errmsg_append(sp,zmsg)
     zmsg=' '
     write(zmsg,*) '  R1,Z1 = ',rlim(1),zlim(1), &
          '  Rn,Zn = ',rlim(ipts),zlim(ipts)
     call xplasma_errmsg_append(sp,zmsg)
     ierr=3000
     return
  endif

  do i=1,ipts-1
     if((rlim(i).eq.rlim(i+1)).and.(zlim(i).eq.zlim(i+1))) then
        zmsg=' '
        write(zmsg,*) ' ?eqm_cbdy:  (R,Z) pts identical:  ',i,i+1, &
             '  (R,Z)=',rlim(i),zlim(i)
        call xplasma_errmsg_append(sp,zmsg)
        ierr=3000
        return
     endif
  enddo

  !  OK... loop through the points

  call find_ref_pt  ! find (R0,Z0) estimate first...

  zthsum=czero
  zsdlsum=czero

  zdr=rlim(ipts)-rlim(ipts-1)
  zdz=zlim(ipts)-zlim(ipts-1)
  zth=atan2(zdz,zdr)

  do i=2,ipts
     zthp=zth
     zR=rlim(i-1)
     zZ=zlim(i-1)
     zdr=rlim(i)-rlim(i-1)
     zdz=zlim(i)-zlim(i-1)
     zth=atan2(zdz,zdr)
     zdth=zth-zthp
!  check range
     period=c2pi
     if((zdth.lt.-cpi).or.(zdth.gt.cpi)) then
        zdth=mod(zdth+cpi,period)
        if(zdth.lt.czero) zdth=zdth+period
        zdth=zdth-cpi
     endif
     zdl=sqrt(zdr**2+zdz**2)
     zthsum=zthsum+zdth

     call eqi_tbdy_line0(zdata(1,i-1),zR,zZ,zth,zR0,zZ0)
     zsdlsum=zsdlsum+zdata(6,i-1)*zdl
  enddo

  do i=1,6
     zdata(i,ipts)=zdata(i,1)
  enddo

  !  check sum

  if(min(abs(zthsum-c2pi),abs(zthsum+c2pi)).gt.ceps4) then
     zmsg=' '
     write(zmsg,*) ' ?eqm_cbdy:  contour bend angle check sum failure!'
     call xplasma_errmsg_append(sp,zmsg)
     zmsg=' '
     write(zmsg,*) '  zthsum=',zthsum,' not +/- 2pi'
     ierr=3000
     return
  endif

  !  OK, looks good...
  !  standardize segment plasma side signs...

  if(zsdlsum.lt.czero) then
     zsign=-cone
  else
     zsign=+cone
  endif
  do i=1,ipts
     zdata(6,i)=zsign
  enddo

  contains
    subroutine find_ref_pt

      !  find a reference point that is considered to be "inside" the
      !  limiter contour.  This is defined as follows:
      !     Zmid = (Zmax+Zmin)/2
      !     R = (R2+R1)/2
      !  where R2 is the contour intercept of Zmid with the largest R value
      !  and R1 is the contour intercept of Zmid with the next largest R value.

      integer :: ii
      real*8 :: zmin,zmax,zmid,zintrp,rintrp,r1,r2

      real*8, parameter :: bigneg = -1.0d34
      real*8, parameter :: half = 0.5d0
      real*8, parameter :: one = 1.0d0

      zmin=zlim(1)
      zmax=zlim(1)
      do ii=2,ipts-1
         zmin=min(zmin,zlim(ii))
         zmax=max(zmax,zlim(ii))
      enddo

      zmid = (zmin+zmax)*half

      r1 = bigneg
      r2 = bigneg

      do ii=1,ipts-1
         if ( ((zlim(ii).lt.zmid).and.(zmid.le.zlim(ii+1))) .or. &
              ((zlim(ii).gt.zmid).and.(zmid.ge.zlim(ii+1))) ) then
            if(zlim(ii).eq.zlim(ii+1)) then
               zintrp=half
            else
               zintrp=(zmid-zlim(ii))/(zlim(ii+1)-zlim(ii))
            endif
            rintrp = rlim(ii)*(one-zintrp) + rlim(ii+1)*zintrp

            if(r1<0.d0) then
               r1=rintrp
            else if(r2<0.d0) then
               r2=rintrp
            else
               call errmsg_exit("?find_ref_pt: too many midplane crossings")
            endif
         endif
      enddo

      zR0 = half*(r1+r2)
      zZ0 = zmid

      if (zR0<0.d0) call errmsg_exit("?find_ref_pt: failed to find two limiter crossings??")
    end subroutine find_ref_pt

end subroutine eqi_cbdy_pts

subroutine eqm_chi_cwdir_set(iswitch,idstring)

  implicit NONE
  integer,intent(in) :: iswitch         ! =0:  CCW (normal), =1:  CW (inverted)
  character*(*), intent(in) :: idstring ! caller's id string

  write(6,*) ' Detected call to defunct xplasma routine "eqm_chi_cwdir_set"'
  write(6,*) '    with idstring= "',trim(idstring),'" and'
  write(6,*) '    with iswitch = ',iswitch,'; NO ACTION TAKEN.'

end subroutine eqm_chi_cwdir_set


subroutine eqm_chi_cwdir_restore(idstring,ierr)
 
  implicit NONE
  character*(*), intent(in) :: idstring ! caller's id string
  integer,intent(out) :: ierr           ! =0:  normal

  write(6,*) ' Detected call to defunct xplasma routine "eqm_chi_cwdir_restore"'
  write(6,*) '    with idstring= "',trim(idstring),'"; NO ACTION TAKEN.'
  ierr=9999

end subroutine eqm_chi_cwdir_restore


subroutine eqm_chi_cwdir(iswitch)
 
  implicit NONE
  integer iswitch         ! =0:  CCW (normal), =1:  CW (inverted)

  write(6,*) ' Detected call to defunct xplasma routine "eqm_chi_cwdir"'
  write(6,*) '   with iswitch = ',iswitch,'; NO ACTION TAKEN.'

end subroutine eqm_chi_cwdir


subroutine eq_get_chi_cwdir(iswitch_value)

  implicit NONE
  integer, intent(out) :: iswitch_value

  iswitch_value = 0
  write(6,*) ' Detected call to defunct xplasma routine "eq_get_chi_cwdir"!'

end subroutine eq_get_chi_cwdir

!-------------------------------------------------

subroutine eqm_phi_cwdir_set(iswitch,idstring)

  implicit NONE
  integer,intent(in) :: iswitch         ! =0:  CCW (normal), =1:  CW (inverted)
  character*(*), intent(in) :: idstring ! caller's id string

  write(6,*) ' Detected call to defunct xplasma routine "eqm_phi_cwdir_set"'
  write(6,*) '    with idstring= "',trim(idstring),'" and'
  write(6,*) '    with iswitch = ',iswitch,'; NO ACTION TAKEN.'

end subroutine eqm_phi_cwdir_set


subroutine eqm_phi_cwdir_restore(idstring,ierr)
 
  implicit NONE
  character*(*), intent(in) :: idstring ! caller's id string
  integer,intent(out) :: ierr           ! =0:  normal

  write(6,*) ' Detected call to defunct xplasma routine "eqm_phi_cwdir_restore"'
  write(6,*) '    with idstring= "',trim(idstring),'"; NO ACTION TAKEN.'
  ierr=9999

end subroutine eqm_phi_cwdir_restore


subroutine eqm_phi_cwdir(iswitch)
 
  implicit NONE
  integer iswitch         ! =0:  CCW (normal), =1:  CW (inverted)

  write(6,*) ' Detected call to defunct xplasma routine "eqm_phi_cwdir"'
  write(6,*) '   with iswitch = ',iswitch,'; NO ACTION TAKEN.'

end subroutine eqm_phi_cwdir


subroutine eq_get_phi_cwdir(iswitch_value)

  implicit NONE
  integer, intent(out) :: iswitch_value

  iswitch_value = 0
  write(6,*) ' Detected call to defunct xplasma routine "eq_get_phi_cwdir"!'

end subroutine eq_get_phi_cwdir

!-------------------------------------------------

subroutine eqm_flxbdy(iwarn)

  implicit NONE
  integer, intent(out) :: iwarn

  iwarn=9999

  write(6,*) ' Detected call to defunct xplasma routine "eqm_flxbdy".'

end subroutine eqm_flxbdy


subroutine eqm_rbdy(iwarn)

  implicit NONE
  integer, intent(out) :: iwarn

  iwarn=9999

  write(6,*) ' Detected call to defunct xplasma routine "eqm_rbdy".'

end subroutine eqm_rbdy

!-------------------------------------------------

subroutine eqm_spordr_set(ival)

  implicit NONE

  integer, intent(in) :: ival

  write(6,*) ' Detected call to defunct xplasma routine "eqm_spordr_set"'
  write(6,*) '    with ival = ',ival,'; NO ACTION TAKEN.'

end subroutine eqm_spordr_set


subroutine eqm_spordr_get(ival)

  implicit NONE

  integer, intent(out) :: ival

  write(6,*) ' Detected call to defunct xplasma routine "eqm_spordr_get"'
  write(6,*) ' (All cubic splines are in compact form now).'

  ival=0

end subroutine eqm_spordr_get

!-------------------------------------------------

subroutine eqm_nfast(inR,inZ,ierr)

  implicit NONE

  integer inR,inZ                   ! desired grid size in R and Z
  integer ierr                      ! completion code, 0=OK

  !  the "nfast" map no longer exists.

  ierr=9999
  write(6,*) ' Detected call to defunct xplasma routine "eqm_nfast"'
  write(6,*) '    with inR,inZ = ',inR,inZ,'; NO ACTION TAKEN.'

end subroutine eqm_nfast

subroutine eq_ganum(zname,ianum)

  use xplasma_obj_instance
  use eq_module

  !  given the name of a grid (axis) return its number.  if there is no such
  !  grid, silently return ianum=0

  IMPLICIT NONE

  character*(*), intent(in) :: zname   ! (input) name of grid
  integer, intent(out) :: ianum        ! (output) grid id or ZERO

  !----------------------------
  integer :: itype,id,ierr
  !----------------------------

  call xplasma_gridId(s,zname,ianum)

end subroutine eq_ganum
 
!==================================================

subroutine eq_get_aname(ianum,zname)

  use xplasma_obj_instance
  use eq_module

  !  given id, get name of axis grid.  if an invalid id is given,
  !  a blank name is returned.

  IMPLICIT NONE

  integer, intent(in) :: ianum          ! grid id number
  character*(*), intent(out) :: zname   ! name of grid

  !-------------------------------
  integer :: itype,ierr
  !-------------------------------

  zname=' '

  call xplasma_get_item_info(s,ianum,ierr, nf_noerr=.TRUE., &
       name=zname, itype=itype)

  if((ierr.ne.0).or.(itype.ne.xplasma_gridType)) then
     zname=' '
  endif

end subroutine eq_get_aname

subroutine xpblind_copy(isize,afrom,ato)

  ! blind contiguous copy from array (afrom) to array (ato)

  implicit NONE
  integer, intent(in) :: isize
  real*8,  intent(in) :: afrom(isize)
  real*8, intent(out) :: ato(isize)

  ato = afrom

end subroutine xpblind_copy

subroutine eqi_contour(xp, yp, cbdy, errscale, cbdy_got, psiav, istat, ier)
 
  ! Using the function Psi(x,y) (already set up in bicubic spline pspl
  ! in the eqi_geq_mod module), compute values (xs, ys) where
  ! f(xs, ys) = f(xp, yp).
  !
  ! values are set at points where 
  !    atan2((ys(j)-y0),(xs(j)-x0)) = thadapt(j,isw)
  !    ...where thadapt(1:nthad,isw) is a grid spanning [0,2pi]
  !       declared in eqi_geq_mod
  !
  ! Method: Hamilton's equation dx/dt=dF/dy; dy/dt=-dF/fx are integrated
  ! starting from (xp, yp) until the cummulative angle between (x-x0, y-y0)
  ! and (xnew-x0, ynew-y0) reaches 2*pi, where (xnew, ynew) are new coordinates
  ! along the trajectory.
  ! 
  ! As a second step, the (xnew, ynew) coordinates are interpolated onto
  ! the thadapt angle grid to yield the (xs, ys).
  !
  ! We are looking for a set of closed contours.  If a contour leads
  ! off the grid, set an error code.
 
  ! dmc modifications -- integrand direction:  counterclockwise around
  !   (x0,y0); integrand "speed" normalized s.t. t is O(1) to go all the
  !   way around-- error flag is set if dF/dx=dF/dy=0.
 
  ! ier=123 exit denotes one of a variety of contour features:
  !   (a) direction of contour reversed: d/dt(arctan((y-y0)/(x-x0)))
  !   (b) contour escaped (R,Z) box
  !   (c) contour landed on grad(psi)=0 point
 
  ! ier=123 is **normal** for a contour corresponding to an open field line
 
  !------------------------------
  !  DMC note: this routine has been carefully tested and has a number
  !  of complexities.  For example, the zeroing-in on the final end point
  !  of a closed contour has to be, and is, carefully handled; the end
  !  point treatment can affect the spline contour accuracy test.
  !
  !  If you work in here, Handle with care!
  !------------------------------

  use eqi_geq_mod
 
  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), intent(in) :: xp, yp ! starting point
  real(r8), intent(in) :: cbdy   ! min. curvature parameter
  real(r8), intent(in) :: errscale ! accuracy test scale
  real(r8), intent(out) :: cbdy_got ! min. curvature observed
  real(r8), intent(out) :: psiav ! avg Psi value along contour
  integer, intent(out) :: istat
  !                        =0 -- closed surface, curvature OK
  !                              (psiav,cbdy_got) computed
  !                        =1 -- closed surface, curvature too sharp
  !                              (psiav,cbdy_got) computed
  !                        =2 -- open surface or grad(Psi)=0 encountered
  !                              (psiav computed; cbdy_got=0)
  !                        =3 -- some other error
  !                              (psiav=0; cbdy_got=0)
  integer, intent(out) :: ier
 
  real(r8) :: x0,y0,xxmin,xxmax,yymin,yymax
  !
  !  foreach i, |f(xs(i),ys(i)) - f(xp,yp)| < 0.0001*errscale
  !     recommend errscale = max(f)-min(f)
  !
  !--------------------------------------------
 
  integer, parameter :: neq=2, mf=10, itmax=10
  integer itol, itask, istate, iopt, lrw, iwork(20), liw, ieq, iter, iout
  integer irevers,igrad0,ilsode
  real(r8) atol, rtol, rwork(20 + 16*neq)
 
  real(r8), dimension(:), allocatable :: psis
 
  real(r8), parameter :: twopi=6.28318530717958623_r8, eps=1.e-10_r8
  integer, parameter :: nsteps0 = 2500   ! no. of steps for ns=32
  integer :: nsteps                      ! actual number of integration steps
  integer i, iok, npoints, npoints_save, ichk, iang, iangp
  real(r8), dimension(:), allocatable :: aa
  real(r8), dimension(:,:), allocatable :: xy
  real(r8) :: dx(neq), dxnew(neq), xx(neq), xx0(neq)
  real(r8) :: lenscale, t, dt, tout, angle, a, const, vecprod, scaprod
 
  real(r8) :: diff, aver, corr, dtest, radius, minrat, radmax
  real(r8) :: rminc,rmaxc
 
  type(ezspline1), save :: xspl, yspl
 
  character*120 msgbuf
 
  external eqi_xydot, eqi_xyjac
 
#ifdef __DEBUG
  integer, parameter :: lun_dbg = 6   ! used iff __DEBUG macro is set
  integer :: icount_calls = 0
  integer :: icount_debug = -1

  !-------------------------------------------
  icount_calls = icount_calls + 1
  if(icount_calls.eq.icount_debug) then
     write(lun_dbg,*) ' eqi_contour: reached icount_debug: ',icount_debug
  endif
#endif
  !-------------------------------------------

  ier = 0
  iopt = 0
 
  istat = 3

  cbdy_got = 0.0_r8
  psiav = 0.0_r8

  if( errscale <= 0.0_r8 ) then
     ier=999
     go to 1001
  endif
 
  x0=r0
  y0=z0

  rminc=xp
  rmaxc=xp

  xxmin=pspl%x1(1)
  xxmax=pspl%x1(pspl%n1)

  yymin=pspl%x2(1)
  yymax=pspl%x2(pspl%n2)
 
!  DMC: dt halved; nsteps doubled: Feb 2008

  dt = twopi/max(64._r8,2.0_r8*nthad0)
  iter=0
!
  nsteps = 2*nsteps0*max(1.0_r8,nthad0/32.0_r8)
  allocate(xy(neq,nsteps),aa(nsteps))
!
!  initialize integrand
!
  lnorm=sqrt((xp-x0)**2+(yp-y0)**2)
  lmax=1.0_r8/errscale
  errflag=0

  radmax = 10*lnorm
!
!  check direction from eqi_xydot.  If the reverse of the expected
!  direction, change signs.
!
!  starting at (xp,yp), we want to "orbit" around (x0,y0) in a
!  counterclockwise direction  (dmc 5 Feb 2001)
!
  isign_xy=1      ! element of the "eqi_geq_mod" module used by eqi_xydot...
  call eqi_xydot(2, 0.0_r8, (/xp, yp/), dxnew)
  if(errflag.ne.0) then
     istat=2   ! grad(Psi) = 0
     call ezspline_interp(pspl,xp,yp,psiav,iok)
     call ezspline_error(iok)
     ier=123
     go to 1000
  endif
  dtest = (xp-x0)*dxnew(2) - (yp-y0)*dxnew(1)
  if(dtest.lt.0.0_r8) isign_xy = -isign_xy
!
!  in this loop, timesteps are shortened until desired accuracy
!  is achieved.  Mod DMC Mar 2008: this is done even for open contours.
!
  do
     istat=0
     ier=0
     iter=iter+1
     if(iter.gt.itmax) then
        istat=3
        ier=999
        go to 1000
     endif
 
     curvad(1:nthad,isw) = radmax
     iang=1

     dt = dt/2.0_r8
 
     ! lsode stuff
     rtol=eps
     atol=eps*errscale
     itask = 1
     istate = 1
     itol = 1
     iopt = 0
     lrw  = 20 + 16*neq
     liw = 20
 
     t = 0.0_r8
     xy = 0.0_r8
     xx0 = (/x0, y0/)
     xx  = (/xp, yp/)
     i = 1

     npoints= 1
     npoints_save = 0  ! used for end pt.

     lenscale = sqrt( (xp-x0)**2 + (yp-y0)**2 )
 
     angle = 0.0_r8
     const = 1.0_r8
     aa = 0.0_r8
     xy(:,1) = xx
 
     iout = 0
     irevers = 0
     ilsode = 0
     igrad0 = 0
 
     minrat = radmax
 
     do while (npoints < nsteps .and. abs(const*dt) > eps)
        dx = xx - xx0
        tout = t + const*dt
        call lsode_r8 (eqi_xydot, neq, xx, t, tout, itol, rtol, atol, itask, &
             & istate, iopt, rwork, lrw, iwork, liw, eqi_xyjac, mf)
        if(istate<=0) then
           ilsode=1
           exit
        endif
        if(errflag.ne.0) then
           igrad0=1
           exit
        endif
        if((xx(1).lt.xxmin).or.(xx(1).gt.xxmax).or. &
             & (xx(2).lt.yymin).or.(xx(2).gt.yymax)) then
           iout=1
           exit
        endif
        dxnew = xx - xx0
        vecprod = dx(1)*dxnew(2)-dx(2)*dxnew(1)
        scaprod = dx(1)*dxnew(1)+dx(2)*dxnew(2)
        a = atan2(vecprod, scaprod)
! (detect but do not prevent angular velocity reversal -- dmc Feb 2001)
!!!        if(a < 0) then
!!!           a = a + twopi
!!!        endif
        angle = angle + a
        if(abs(angle) > twopi) then
           if(const.ge.0.99_R8) then
              !  enter here when first past end point; step has not yet been
              !  reduced to search for exact end point

              !  npoints points to start of current step, which is now known
              !  to be within a const=1 step of the boundary closing
              npoints_save = npoints

              ! end point curvature: evaluate at *start* of zeroing-in to
              ! angle=twopi end point of closed contour
              if(npoints.ge.10) then
                 call r8_trirad(xy(:,npoints-1),xy(:,npoints),xy(:,2), &
                      dxnew,radius,ichk)
                 if(ichk.eq.0) then
                    curvad(1,isw)=min(curvad(1,isw),radius)
                    curvad(nthad,isw)=min(curvad(nthad,isw),radius)
                    if(nthad.gt.(iang+1)) then
                       curvad(iang+1:nthad-1,isw)=curvad(iang,isw)
                    endif
                    minrat=min(minrat,radius)
                 endif
              endif
           endif
           ! back off
           t = t - const*dt
           const = const/2.0_r8
           angle = angle - a
           xx = xy(:,npoints)
           ! reset lsode state
           istate = 1
        else
           if(angle.le.aa(npoints)) then
              irevers=1
              exit
           endif
           npoints = npoints + 1 ! forward counter
           aa(npoints) = angle

           iangp=iang
           do while(angle.gt.thadapt(iang+1,isw))
              iang = iang + 1
           enddo
           if(iangp.lt.(iang-1)) then
              ! deal with skipped index space
              curvad(iangp+1:iang-1,isw)=curvad(iangp,isw)
           endif

           rminc=min(rminc,xx(1))
           rmaxc=max(rmaxc,xx(1))
           xy(:, npoints) = xx
           if((npoints.ge.3).and.(const.ge.0.99_R8)) then
              ! inaccurate to evaluate curvature at end point where const << 1
              call r8_trirad(xy(:,npoints-2),xy(:,npoints-1),xy(:,npoints), &
                   dxnew,radius,ichk)
              if(ichk.eq.0) then
                 curvad(iang,isw)=min(curvad(iang,isw),radius)
                 curvad(iang+1,isw)=min(curvad(iang+1,isw),radius)
                 minrat=min(minrat,radius)
              endif
           endif
        endif
        i = i + 1
     enddo
     if(iout.eq.1) then
#ifdef __DEBUG        
        write(lun_dbg,*) '%eqi_contour:  contour escapes mapped region.'
#endif
        istat=2
     else if(irevers.eq.1) then
#ifdef __DEBUG        
        write(lun_dbg,*) '%eqi_contour:  contour angular velocity reversed.'
#endif
        istat=2
     else if(igrad0.eq.1) then
#ifdef __DEBUG        
        write(lun_dbg,*) '%eqi_contour:  contour hit grad(psi)=0'
#endif
        istat=2
     else if(ilsode.eq.1) then
#ifdef __DEBUG        
        msgbuf=' '
        write(msgbuf,*) '%eqi_contour:  LSODE error', istate
        write(lun_dbg,*) trim(msgbuf)
#endif
        istat=3
        iter=itmax
     else if(npoints < nsteps) then
        npoints = npoints + 1
        aa(npoints) = twopi
        xy(:, npoints) = xx
        lnorm=(rmaxc-rminc)/2
        minrat=minrat/lnorm
        curvad(1:nthad,isw) = curvad(1:nthad,isw)/lnorm
        if(minrat.lt.cbdy) then
           istat=1
#ifdef __DEBUG        
           msgbuf=' '
           write(msgbuf,*) ' *** minimum normalized curvature = ',minrat
           write(lun_dbg,*) trim(msgbuf)
           msgbuf=' '
           write(msgbuf,*) &
                & '%eqi_contour:  contour violates sharp curvature limit.'
           write(lun_dbg,*) trim(msgbuf)
#endif
        endif
     else
#ifdef __DEBUG        
        msgbuf=' '
        write(msgbuf,*) '%eqi_contour:  nsteps limit reached:', nsteps
        write(lun_dbg,*) trim(msgbuf)
#endif
        istat=3
        iter=itmax
     endif

     if(iter.eq.itmax) cycle
 
     if(istat.eq.2) then
        if(allocated(psis)) deallocate(psis)
        allocate(psis(npoints))
        call ezspline_interp(pspl, npoints, &
             xy(1,1:npoints), xy(2,1:npoints), psis, iok)
        call ezspline_error(iok)

        aver = sum(psis)/real(npoints, r8)
        psiav = aver

     else
        ! contour is closed...
        ! interpolate onto equal angle grid
 
        ! avoid closely packed points at end of contour
        ! these can screw up the spline boundary condition

        if(npoints_save.gt.0) then
           npoints = npoints_save
        endif
        xy(:,npoints)=xy(:,1)  ! enforce exact closing
        aa(npoints)=aa(1)+twopi

        call ezspline_init(xspl, npoints, (/-1, -1/), iok)   ! periodic BC
        call ezspline_error(iok)
        call ezspline_init(yspl, npoints, (/-1, -1/), iok)   ! periodic BC
        call ezspline_error(iok)
 
        xspl%x1 = aa(1:npoints)
        yspl%x1 = aa(1:npoints)
 
        xy(:,npoints) = xy(:,1) ! make periodic
 
        call ezspline_setup(xspl, xy(1,1:npoints), iok)
        call ezspline_error(iok)
        call ezspline_setup(yspl, xy(2,1:npoints), iok)
        call ezspline_error(iok)
 
        call ezspline_interp(xspl, nthad, thadapt(1:nthad,isw), &
             radapt(1:nthad,isw), iok)
        call ezspline_error(iok)
        call ezspline_interp(yspl, nthad, thadapt(1:nthad,isw), &
             zadapt(1:nthad,isw), iok)
        call ezspline_error(iok)
 
        call ezspline_free(xspl, iok)
        call ezspline_error(iok)
        call ezspline_free(yspl, iok)
        call ezspline_error(iok)
 
        ! check
 
        if(allocated(psis)) deallocate(psis)
        allocate(psis(nthad))
        call ezspline_interp(pspl, nthad, &
             radapt(1:nthad,isw), zadapt(1:nthad,isw), psis, iok)
        call ezspline_error(iok)

        aver = sum(psis)/real(nthad, r8)
        psiav = aver
     endif

     diff = maxval(abs(psis-aver))
     if(diff/errscale > 0.0001) then
        ier = 124  ! redo: insufficient accuracy: too much Psi variation.
     else
        if(istat.gt.1) ier = 123
        exit
     endif
 
  enddo
 
  ! clean up
 
1000 continue
 
  deallocate(xy,aa)
  if(allocated(psis)) deallocate(psis)

1001 continue
  if(istat.le.1) then
     cbdy_got=minrat
  else
     cbdy_got=0.0
  endif

  return
 
end subroutine eqi_contour
 
 
subroutine eqi_xydot(neq, t, y, ydot)
 
  use eqi_geq_mod
 
  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  integer neq, iok
  real(r8) t, y(neq), ydot(neq)
  real(r8) df(2)
  real(r8) v,zero,norm,rr,zz
  integer :: in1,in2
 
  !-----------------
  rr=y(1)
  zz=y(2)

  in1 = pspl%n1
  in2 = pspl%n2

  if(rr.lt.pspl%x1(1)) then
     rr=pspl%x1(1)
     istep_out = istep_out + 1
  else if(rr.gt.pspl%x1(in1)) then
     rr=pspl%x1(in1)
     istep_out = istep_out + 1
  endif

  if(zz.lt.pspl%x2(1)) then
     zz=pspl%x2(1)
     istep_out = istep_out + 1
  else if(zz.gt.pspl%x2(in2)) then
     zz=pspl%x2(in2)
     istep_out = istep_out + 1
  endif

  call ezspline_gradient(pspl, rr, zz, df, iok)
  call ezspline_error(iok)
 
  ydot(1) = -df(2)*isign_xy
  ydot(2) = +df(1)*isign_xy
 
  zero = 0
  v = sqrt(ydot(1)**2+ydot(2)**2)
  if(v.le.zero) then
     errflag=1
  else
     norm=min(lmax,lnorm/v)
     ydot=norm*ydot
  endif
 
end subroutine eqi_xydot
 
subroutine eqi_xyjac
end subroutine eqi_xyjac

subroutine eq_hRZ(ivec,zR,zZ,nlist,iflist,ictwant,ivecd,zans,ierr)

  !  evaluate 1 or more functions f(R,Z) and derivatives

  use xplasma_obj_instance
  use eq_module
  IMPLICIT NONE

  !  input:

  integer ivec                      ! input vector dimension

  REAL*8 zR(ivec)                   ! argument -- where to evaluate
  REAL*8 zZ(ivec)                   ! argument -- where to evaluate
  integer nlist                     ! number of functions
  integer iflist(nlist)             ! functions to evaluate

  integer ictwant(6)                ! output selector (pspline style)

  !  each element of ictwant(1:6) should be 0 or 1
  !  use 1 to indicate a desired item:

  !   ictwant(1) -- function values            ...1 if wanted, 0 otherwise
  !   ictwant(2) -- functions' df/dR values
  !   ictwant(3) -- functions' df/dZ values
  !   ictwant(4) -- functions' d2f/dR2 values
  !   ictwant(5) -- functions' d2f/dZ2 values
  !   ictwant(6) -- functions' d2f/dRdZ values

  integer ivecd                     ! output vector dimension

  !  output:

  REAL*8 zans(ivecd,*)              ! evaluation results
  integer ierr                      ! completion code (0=OK)

  !  ** let ictnum = # of non-zero elements of ictwant.
  !         (ictnum=sum(ictwant)).  Then...
  !  zans(1:ivec,1)   = value or derivative for function id iflist(1)
  !                     indicated by first non-zero value of ictwant(...)
  !  zans(1:ivec,2)   = value or derivative for function id iflist(1)
  !                     indicated by second non-zero value of ictwant(...)
  !    ...
  !  zans(1:ivec,ictnum)   = value or derivative for function id iflist(1)
  !                     indicated by last non-zero value of ictwant(...)

  !  or generally, for 1 .le. k .le. ictnum,
  !    ...
  !  zans(1:ivec,(j-1)*ictnum+k) = value or derivative for function
  !                                id iflist(j), corresponding to k'th
  !                                non-zero element of ictwant(...)

  !--------------------------------------------
  integer :: iveca,i,id_R,id_Z,ii,igrp,inumd,itot,ideriv1f(6),ideriv2f(6)
  integer, dimension(:), allocatable :: ids,idRs,idZs
  !--------------------------------------------

  iveca=ivec

  if(ivecd.lt.iveca) then
     ierr=1
     write(lunerr,*) ' ?eq_fRZ: answer array dimension ivecd too small:'
     write(lunerr,*) '  ivec = ',abs(ivec),'; ivecd = ',ivecd
     return
  endif

  inumd=0
  if(ictwant(1).eq.1) then
     inumd=inumd+1
     ideriv1f(inumd)=0
     ideriv2f(inumd)=0
  endif
  if(ictwant(2).eq.1) then
     inumd=inumd+1
     ideriv1f(inumd)=1
     ideriv2f(inumd)=0
  endif
  if(ictwant(3).eq.1) then
     inumd=inumd+1
     ideriv1f(inumd)=0
     ideriv2f(inumd)=1
  endif
  if(ictwant(4).eq.1) then
     inumd=inumd+1
     ideriv1f(inumd)=2
     ideriv2f(inumd)=0
  endif
  if(ictwant(5).eq.1) then
     inumd=inumd+1
     ideriv1f(inumd)=0
     ideriv2f(inumd)=2
  endif
  if(ictwant(6).eq.1) then
     inumd=inumd+1
     ideriv1f(inumd)=1
     ideriv2f(inumd)=1
  endif

  itot=inumd*nlist
  allocate(ids(itot),idRs(itot),idZs(itot))

  igrp=-inumd
  do ii=1,nlist
     igrp=igrp+inumd
     ids(igrp+1:igrp+inumd)=iflist(ii)
     idRs(igrp+1:igrp+inumd)=ideriv1f(1:inumd)
     idZs(igrp+1:igrp+inumd)=ideriv2f(1:inumd)
  enddo

  call xplasma_eval_prof(s,ids, &
       xplasma_R_coord,zR, xplasma_Z_coord,zZ, &
       zans(1:iveca,1:itot),ierr, &
       ideriv1s=idRs, ideriv2s=idZs)

  deallocate(ids,idRs,idZs)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_fRZ: interpolation call unsuccessful, ierr=',ierr
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_hRZ

module xplasma_definitions

  ! public interface module for xplasma library
  ! kernel is in xplasma_obj; auxilliary routine interfaces defined here...

  use xplasma_fromgeq, only :xplasma_fromgeqdsk,xplasma_geqdsk_ppadj,&
                             xplasma_save_psi0, xplasma_get_psi0! xplasma_fromgeqdsk (separated for debugging)

  use xplasma_avg1dmod   ! 1d volume avg (separated for debugging)

  use xplasma_profs   ! routines that aid in creation of profile functions

  use xplasma_mcgrid  ! routines for MCgrid irregular grids & assoc. profiles.

  use xplasma_nclass  ! calculate Pfirsch-Schlutter moments for NCLASS

  ! also used by xplasma_profs:
  use xplasma_rzgeo   ! RZ flux surface geometry definition

  ! also used by xplasma_profs, xplasma_rzgeo, xplasma_mcgrid, xplasma_nclass:
  use xplasma_flxint  ! numerical integrator routines

  ! also used by xplasma_profs, xplasma_rzgeo:
  use xplasma_sol     ! scrape off layer data -- e.g. limiters

  ! also used by xplasma_profs, xplasma_sol, xplasma_rzgeo:
  use xplasma_ctran   ! coordinate transformations & extrema

  !-------------------------------------
  !  **kernel** used by all
  use xplasma_obj
       
! xplasma data types & kernel routines

end module xplasma_definitions

 
#include "fpreproc/byte_declare.h"
 
!----------------------------------------------------------
! cface  -- generated (f90 fixed form) C interface to:  EQM_UAXIS
      SUBROUTINE  C_EQM_UAXIS(
     > C_ANAME_LEN,C_ANAME,IKIN,IPER,ZAXIS,INUM,ZTOL,ID,IERR)
 
      external EQM_UAXIS
 
! argument declarations
 ! scalar char*(*) type, input only:
      INTEGER C_ANAME_LEN
      BYTE_DECLARE C_ANAME(C_ANAME_LEN)
 
      INTEGER IKIN
      INTEGER IPER
      INTEGER INUM
      REAL*8 ZTOL
      INTEGER ID
      INTEGER IERR
      REAL*8 ZAXIS(INUM)
 
! local (automatic array) declarations
      CHARACTER(C_ANAME_LEN) :: ANAME_act
 
! executable code:  copy for input
 
      call cstring(ANAME_act, C_ANAME,'2F')
! call to original routine:  EQM_UAXIS
 
      CALL EQM_UAXIS(
     > ANAME_act,IKIN,IPER,ZAXIS,INUM,ZTOL,ID,IERR)
 
! copy back outputs if modified.
 
! exit
      return
      end

SUBROUTINE scrfunct1des(rmc,rms,zmc,zms,xpts,grc,grs, &
     gzc,gzs,gpts,fsq,r10,mmax)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, half, one
  use scrunch_inc1
  use scrunch_inc2
  implicit none
  intrinsic DOT_PRODUCT
  real(fp) :: fac
  integer :: i
  real(fp) :: tcon
  real(fp), intent(in) :: r10
  real(fp), intent(out) :: fsq
  real(fp) :: t1
  real(fp) :: t2
  integer, intent(in) :: mmax
  integer :: m
  integer :: l
  integer :: j
  real(fp) :: denom
  real(fp), dimension(mpol) :: yc, ys
  real(fp), dimension(ntheta) :: gcon, gtt, r1, z1, rt1, zt1, arg, rcon, zcon
  real(fp), dimension(ntheta,mpol) :: cosa, sina
  real(fp), dimension(*), intent(in) :: rmc, rms, zmc, zms, xpts
  real(fp), dimension(*), intent(inout) :: grc, grs, gzc, gzs, gpts
  !
  !	FORCES: dW/dRmn = SUM(i)[ R(i) - RIN3D(i)]*cos(m*u[i]) ....
  !		dW/dZmn = SUM(i)[ Z(i) - ZIN3D(i)]*sin(m*u[i]) ....
  !		dW/du[i]=    rt(i)*[R(i)-RIN3D(i)] + zt(i)*[Z(i) - ZIN3D(i)]
  !	THE NORM ON THE ANGLE FORCE (dW/du[i]) FOLLOWS FROM NEWTON S
  !	LAW AND IS APPROXIMATELY GTT = RT**2 + ZT**2
  !
  denom = zero
  gnorm = zero
  specw = zero
  do j = 1,nthetax
    r1(j) = -rin3d(j,1)
    z1(j) = -zin3d(j,1)
    rcon(j) = zero
    zcon(j) = zero
    rt1(j)  = zero
    zt1(j)  = zero
  end do
  do l = 1,n2
    grc(l) = zero
  end do
  !**********************************************************************
  !       COMPUTE SPECTRAL WIDTH OF CURVE
  !**********************************************************************
  do m = 2,mmax
    t2 = (rmc(m)*rmc(m)+zmc(m)*zmc(m)+ &
         rms(m)*rms(m)+zms(m)*zms(m))*xmpq(m,1)
    denom = denom+t2
    specw = specw+xmpq(m,2)*t2
  end do
  specw = specw/denom
  !**********************************************************************
  !       COMPUTE CURVE AND CONSTRAINT FORCES
  !**********************************************************************
  do m = 1,mmax
    do l = 1,nthetax
      arg(l)    = dm1(m) * xpts(l)
      cosa(l,m) = cos(arg(l))
      sina(l,m) = sin(arg(l))
      gtt(l)  = rmc(m)*cosa(l,m) + rms(m)*sina(l,m)
      gcon(l) = zmc(m)*cosa(l,m) + zms(m)*sina(l,m)
      r1(l)   = r1(l)  + gtt(l)
      z1(l)   = z1(l)  + gcon(l)
      rt1(l)  = rt1(l) + dm1(m)*(rms(m)*cosa(l,m) - rmc(m)*sina(l,m))
      zt1(l)  = zt1(l) + dm1(m)*(zms(m)*cosa(l,m) - zmc(m)*sina(l,m))
      rcon(l) = rcon(l) + xmpq(m,4)*gtt(l)
      zcon(l) = zcon(l) + xmpq(m,4)*gcon(l)
    end do
  end do
  do l = 1,nthetax
    gtt(l)  = rt1(l)*rt1(l) + zt1(l)*zt1(l)
    gpts(l) = r1(l)*rt1(l)+z1(l)*zt1(l)
    gcon(l) = rcon(l)*rt1(l) + zcon(l)*zt1(l)
  end do
  t1 = -one
  do l = 1,nthetax
    t1 = max(t1,gtt(l))
  end do
  !**********************************************************************
  !       COMPUTE MEAN-SQUARE DEVIATION BETWEEN POINTS AND FIT
  !**********************************************************************
  fsq = zero
  do l = 1,nthetax
    gpts(l) = gpts(l)/t1
    fsq = fsq + half*(r1(l)**2 + z1(l)**2)
  end do
  fsq = sqrt(dnorm*fsq)/r10
  !**********************************************************************
  !       FILTER CONSTRAINT FORCE TO REMOVE ALIASING
  !**********************************************************************
  tcon = one/(t1*sqrt(one+xmpq(mmax,3)))
  do m = 2,mmax-1
    yc(m) = DOT_PRODUCT(cosa(1:nthetax,m),gcon(1:nthetax))*faccon(m)*tcon
    ys(m) = DOT_PRODUCT(sina(1:nthetax,m),gcon(1:nthetax))*faccon(m)*tcon
  end do
  do l = 1,nthetax
    gcon(l) = zero
  end do
  do m = 2,mmax-1
    do l = 1,nthetax
      gcon(l) = gcon(l) + yc(m)*cosa(l,m) + ys(m)*sina(l,m)
    end do
  end do
  !**********************************************************************
  !       ADD CURVE AND CONSTRAINT FORCES
  !**********************************************************************
  do m = 1,mmax
    do l = 1,nthetax
      rcon(l) = r1(l)  + gcon(l)*rt1(l)*xmpq(m,3)
      zcon(l) = z1(l)  + gcon(l)*zt1(l)*xmpq(m,3)
      grc(m)  = grc(m) + cosa(l,m)*rcon(l)
      if ((lasym.and. .not.lzakharov).or.m.eq.1) &
           gzc(m)  = gzc(m) + cosa(l,m)*zcon(l)
      if (lasym) grs(m)  = grs(m) + sina(l,m)*rcon(l)
      if (.not.lzakharov .or. m.le.2) gzs(m)  = gzs(m) + &
           sina(l,m)*zcon(l)
    end do
  end do
  !**********************************************************************
  !       COMPUTE m=1 CONSTRAINT (ZC(m=1)=RS(m=1)) to the Forces
  !**********************************************************************
  if(.not.lzakharov) then
    gzc(2) = grs(2) + gzc(2)
    grs(2) = gzc(2)
    grc(1) = half*grc(1)
  end if
 
  do i = 1,mpol4
    grc(i) = dnorm*grc(i)
  enddo
  do j=1,mmax
    gnorm = gnorm + grc(j)*grc(j) + gzc(j)*gzc(j) &
         + grs(j)*grs(j) + gzs(j)*gzs(j)
  end do
  gnorm = gnorm/r10**2
  do j = 1,nthetax
    gnorm = gnorm + dnorm*gpts(j)*gpts(j)
  end do
  do m = 2,mmax
    fac = one/(one + tcon*xmpq(m,3))
    grc(m) = grc(m)*fac
    gzc(m) = gzc(m)*fac
    grs(m) = grs(m)*fac
    gzs(m) = gzs(m)*fac
  end do

end SUBROUTINE scrfunct1des

subroutine eqm_cbdy(ipts,rlim,zlim,ierr)

  !  xplasma f77 legacy interface
  !  set up an axisymmetric piecewise linear boundary / limiter contour
  !-----------------------

  use xplasma_obj_instance
  use eq_module
  
  implicit NONE

  !  input:

  integer ipts                      ! # of (R,Z) points defining contour
  real*8 rlim(ipts),zlim(ipts)      ! (R,Z) points

  !  output:

  integer ierr                      ! completion code, 0=OK

  !-----------------------
  integer :: iwarn   ! warning code is ignored...
  !-----------------------

  call xplasma_mklim_contour(s,rlim,zlim,iwarn,ierr)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqm_cbdy: xplasma_mklim_contour error:'
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eqm_cbdy

subroutine xmoments_kmom_set(ikmom)
 
  !  set no. of moments for Fourier representation of 2d equilibrium
  !  xplasma will accept 2 <= ikmom <= 64 (dmc: as of May 2006)
  !  There is no error check, this routine assumes "s" has been initialized.

  use xplasma_obj_instance
  use eq_module
  implicit NONE
 
  integer, intent(in) :: ikmom
 
  !------------------
  integer :: ier
  !------------------

  call xoi_init(ier)
  call xoi_kmom_set(ikmom)
  call xplasma_kmom_set(s,ikmom,ier)  ! error not checked...

end subroutine xmoments_kmom_set
 
!--------------------
 
subroutine xmoments_kmom_get(ikmom)
 
  !  get no. of moments for Fourier representation of 2d equilibrium
  !  (if there is an error, ikmom=0 is returned).

  use xplasma_obj_instance
  use eq_module
  implicit NONE
 
  integer, intent(out) :: ikmom
 
  !------------------
  integer :: ier
  !------------------

  call xoi_init(ier)
  call xoi_kmom_get(ikmom)
  call xplasma_kmom_set(s,ikmom,ier)  ! error not checked...
 
end subroutine xmoments_kmom_get

#ifdef __DEBUG

subroutine scrdesdbg(zlabel,rmb,zmb,nmb,nmbout,rmbout,zmbout)

  ! descur/desreg debug plotting tool
  ! plot vs. theta of: arclength, dist from (R0,Z0), arctan((Z-Z0)/(R-R0))
  ! for both moments and for the original data in which "theta" is defined
  ! as twopi*(i-1)/(nmb-1)

  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: twopi
  implicit NONE
  character(len=*), intent(in) :: zlabel
  integer, intent(in) :: nmb
  real(fp), dimension(nmb), intent(in) :: rmb, zmb
  integer, intent(in) :: nmbout
  real(fp), dimension(0:nmbout,2), intent(in) :: rmbout, zmbout

  !-----------
  !  automatic...
  real(fp), dimension(nmb) :: thmb, arclen, arcleno
  real(fp), dimension(nmb) :: dist, disto, angtan, angtano
  real(fp), dimension(nmbout) :: zsin, zcos
  character(len=60), dimension(3) :: mnlab
  real(fp) :: zr0,zz0,zdl,zcorr
  real(fp) :: zrcur,zzcur,zrpre,zzpre
  integer :: i,j
  !-----------

  mnlab=' '
  mnlab(1) = zlabel//' debug plot '

  ! from input data construct arclength and [R0,Z0]

  zr0=0; zz0=0
  do i=1,nmb
    thmb(i)=(i-1)*twopi/(nmb-1)
    if(i.eq.1) then
      arclen(i)=0
    else
      zdl=sqrt((rmb(i)-rmb(i-1))**2+(zmb(i)-zmb(i-1))**2)
      arclen(i)=arclen(i-1)+zdl
      zr0=zr0+zdl*(rmb(i)+rmb(i-1))/2
      zz0=zz0+zdl*(zmb(i)+zmb(i-1))/2
    endif
  enddo
  zr0=zr0/arclen(nmb)
  zz0=zz0/arclen(nmb)

  ! dist. vs. theta & arctan vs. theta for input data

  zcorr=0
  do i=1,nmb
    dist(i)=sqrt((rmb(i)-zr0)**2+(zmb(i)-zz0)**2)
    angtan(i)=atan2(zmb(i)-zz0,rmb(i)-zr0) + zcorr
    if(i.eq.1) then
      if(angtan(1).lt.-twopi/2) angtan(i)=angtan(i)+twopi
      if(angtan(i).gt.twopi/2) angtan(i)=angtan(i)-twopi
    else
      if((angtan(i)-angtan(i-1)).gt.twopi/2) then
        angtan(i)=angtan(i)-twopi
        zcorr=zcorr-twopi
      else if((angtan(i)-angtan(i-1)).lt.-twopi/2) then
        angtan(i)=angtan(i)+twopi
        zcorr=zcorr+twopi
      endif
    endif
  enddo

  ! same stuff for the output data

  zcorr=0
  do i=1,nmb
    if(i.gt.1) then
      zrpre=zrcur
      zzpre=zzcur
    endif
    call r8sincos(thmb(i),nmbout,zsin,zcos)
    zrcur=rmbout(0,1)
    zzcur=zmbout(0,1)
    do j=1,nmbout
      zrcur=zrcur+rmbout(j,1)*zcos(j)+rmbout(j,2)*zsin(j)
      zzcur=zzcur+zmbout(j,1)*zcos(j)+zmbout(j,2)*zsin(j)
    enddo
    disto(i)=sqrt((zrcur-zr0)**2+(zzcur-zz0)**2)
    angtano(i)=atan2(zzcur-zz0,zrcur-zr0) + zcorr
    if(i.eq.1) then
      if(angtano(1).lt.-twopi/2) angtano(i)=angtano(i)+twopi
      if(angtano(i).gt.twopi/2) angtano(i)=angtano(i)-twopi
      arcleno(i)=0
    else
      if((angtano(i)-angtano(i-1)).gt.twopi/2) then
        angtano(i)=angtano(i)-twopi
        zcorr=zcorr-twopi
      else if((angtano(i)-angtano(i-1)).lt.-twopi/2) then
        angtano(i)=angtano(i)+twopi
        zcorr=zcorr+twopi
      endif
      zdl=sqrt((zrcur-zrpre)**2+(zzcur-zzpre)**2)
      arcleno(i)=arcleno(i-1)+zdl
    endif
  enddo

  mnlab(3)='arclength vs. theta'
  call r8_grafx2(thmb,arclen,arcleno,nmb,' ','L',mnlab(1),mnlab(2),mnlab(3))

  mnlab(3)='distance from [R0,Z0] vs. theta'
  call r8_grafx2(thmb,dist,disto,nmb,' ','L',mnlab(1),mnlab(2),mnlab(3))

  mnlab(3)='arctan to [R0,Z0] vs. theta'
  call r8_grafx2(thmb,angtan,angtano,nmb,' ','L',mnlab(1),mnlab(2),mnlab(3))

  return
end subroutine scrdesdbg

#else

subroutine scrdesdbg

   write(6,*) ' %NOTE: dummy scrdesdbg call: compiled w/o __DEBUG '
   return

end subroutine scrdesdbg

#endif

module xpl_dbg_module

  !  mechanism for getting xplasma object pointer to xplasma_debug_r4momry...

  use xplasma_obj
  implicit NONE

  private
  public :: sp

  type (xplasma), pointer :: sp

end module xpl_dbg_module

 
#include "fpreproc/byte_declare.h"
 
!----------------------------------------------------------
! cface  -- generated (f90 fixed form) C interface to:  EQ_RESTORE
      SUBROUTINE  C_EQ_RESTORE(
     > C_FILENAME_LEN,C_FILENAME,IER)
 
      external EQ_RESTORE
 
! argument declarations
 ! scalar char*(*) type, input only:
      INTEGER C_FILENAME_LEN
      BYTE_DECLARE C_FILENAME(C_FILENAME_LEN)
 
      INTEGER IER
 
! local (automatic array) declarations
      CHARACTER(C_FILENAME_LEN) :: FILENAME_act
 
! executable code:  copy for input
 
      call cstring(FILENAME_act, C_FILENAME,'2F')
! call to original routine:  EQ_RESTORE
 
      CALL EQ_RESTORE(
     > FILENAME_act,IER)
 
! copy back outputs if modified.
 
! exit
      return
      end

subroutine eqm_set_units(id,zuns,ier)

  ! add units label to xplasma item

  use xplasma_obj_instance
  use eq_module

  implicit NONE

  integer, intent(in) :: id
  character*(*), intent(in) :: zuns
  integer, intent(out) :: ier

  !---------------------------------------
  integer :: iertmp
  character*32 zauth
  !---------------------------------------

  call xplasma_get_item_info(s,id,ier, author=zauth)
  if(ier.ne.0) then
     write(lunerr,*) ' ?eqm_set_units: error code detected.'
     call xplasma_error(s,ier,lunerr)
     return
  endif

  call xplasma_author_set(s,zauth,iertmp)

  call xplasma_label_item(s,id,ier, units=zuns)

  call xplasma_author_clear(s,zauth,iertmp)

  if(ier.ne.0) then
     write(lunerr,*) ' ?eqm_set_units: error code detected.'
     call xplasma_error(s,ier,lunerr)
  endif

end subroutine eqm_set_units

subroutine eqi_fromg_err(zmsg)

  !  append error or warning message & increment counter

  use xplasma_definitions
  use eqi_rzbox_module
  use eqi_geq_mod  ! contains jwarn counter
  
  implicit NONE

  character*(*), intent(in) :: zmsg

  !---------------------------

  jwarn = jwarn + 1
  if(jwarn.eq.0) then
     call xplasma_errmsg_append(sp,' --> messages from eqi_fromgeqdsk:')
  endif

  call xplasma_errmsg_append(sp,zmsg)

end subroutine eqi_fromg_err

subroutine eqi_fromg_warn(iwarn)

  use eqi_geq_mod  ! contains jwarn counter

  iwarn = jwarn

end subroutine eqi_fromg_warn

subroutine eqm_geq_curtime(ztime1)

  ! return the currently selected G-eqdsk time from MDS+ data
  ! if a file was read (i.e. no MDS+, no time dependence), 
  !   ztime1=0.00 will be returned.

  use eqi_geq_mod
  implicit NONE

  real*8, intent(out) :: ztime1

  call geq_curtime(geq,ztime1)

end subroutine eqm_geq_curtime

subroutine eq_flxint_arr2s(zdata, &
     ibcrho0,zbcrho0,ibcrho1,zbcrho1, &
     iwant,result,inumchi,inumrho,ierr)

  !  integration of user defined data with user specified boundary conditions
  !  legacy f77 xplasma interface

  use xplasma_obj_instance
  use eq_module
  IMPLICIT NONE

  !  given zdata(1:nchi,1:nrho) represent f(chi,rho), use eq_flxint_arr2d
  !  to (a) setup a spline representation, and (b) do the chosen set of
  !  numeric integrations using this representation.

  !  *** iwant *** specifies the type of integration desired:
  !    here "f" denotes the interpolating function generated from the
  !    passed array data.

  !    iwant=1:  surface integral:
  !       int[phi=0 to 2pi] dphi * {
  !            int[chi=0 to 2pi] dchi * f }

  !    iwant=5:  volume weighted surface integral:
  !        int[phi=0 to 2pi] dphi * {
  !            int[chi=0 to 2pi] dchi * f * det(Jacobian) }

  !      **caution** if rho(1) corresponds to the mag. axis, a
  !        det(Jacobian)=0 and a value of 0.0 is always returned!

  !    iwant=6:  volume weighted surface average:

  !        int[phi=0 to 2pi] dphi * {
  !            int[chi=0 to 2pi] dchi * f * det(Jacobian)}
  !        -----------------------------------------------
  !        int[phi=0 to 2pi] dphi * {
  !            int[chi=0 to 2pi] dchi * det(Jacobian)}

  !      **caution** if rho(1) corresponds to the mag. axis,
  !        the value "f" evaluated at the axis is returned there.

  !  zonal integrals:  result(1:nrho-1) are computed; result(j)
  !                    corresponds to the integral from rho(j) to rho(j+1)

  !    iwant=2:  integrate f*drho*dtheta*dphi:

  !       int[rho=rho(j) to rho(j+1)] drho * {
  !          int[phi=0 to 2pi] dphi * {
  !               int[chi=0 to 2pi] dchi * f } }

  !    iwant=3:  integrate f*dV (use det(Jacobian))

  !       int[rho=rho(j) to rho(j+1)] drho * {
  !          int[phi=0 to 2pi] dphi * {
  !               int[chi=0 to 2pi] dchi * f * det(Jacobian) } }

  !    iwant=4:  compute <f> = (integrated f*dV)/dVol
  !              where dVol is the volume btw rho(j) and rho(j+1)

  !  **caution** in axisymmetric case there is no variation with phi,
  !  but a factor of 2pi still arises from the phi integration...

  !  **input**

  real*8 zdata(*)

  integer ibcrho0,ibcrho1      ! BC controls
  real*8 zbcrho0(*),zbcrho1(*) ! BC data values

  !  BC type values:  for ibcrho0:
  !     =0 -- use "not a knot", zbcrho0(...) ignored
  !     =1 -- match slope, given at x(1),chi(ichi) by zbcrho0(ichi)
  !     =2 -- match 2nd deriv., given at x(1),chi(ichi) by zbcrho0(ichi)
  !     =3 -- boundary condition is slope=0 (df/dx=0) at x(1), all chi(j)
  !           (zbcrho0(...) ignored).
  !  and similarly for (ibcrho1,zbcrho1(...)).

  integer iwant                ! type of integrations wanted

  integer inumchi              ! 1st (chi) dim of result
  integer inumrho              ! 2nd (rho) dim of result

  !  if inumchi=1, do integrations over the entire flux zone / flux surface
  !  if inumchi>1, do integrations over chi segments.

  !  **output**

  real*8 result(inumchi,inumrho) ! results of integrations
  integer ierr                   ! completion code, 0=OK
  !                                  ! see description, above...

  !  this routine has a simplified argument list; eq_flxint_arr2d
  !  is more complex, with more control options.

  !  **note** the number of values returned by result is set by a prior
  !  call to eq_flxint_init -- #integration zones if iwant.gt.1;
  !  #integration zones + 1 if iwant.eq.1
  !-------------------------------------
  integer idbc0,idbc1
  integer :: nchi,nrho,iertmp
  integer :: id_R,id_rho,id_chi
  !-------------------------------------

  call xplasma_common_ids(s,ierr, id_R=id_R)
  if(ierr.ne.0) then
     write(lunerr,*) ' ** error detected in eq_flxint_arr2s:'
     call xplasma_error(s,ierr,lunerr)
     return
  else if(id_R.eq.0) then
     write(lunerr,*) ' ** equilibrium R(x,theta) not found in ex_flxint_arr2s.'
     ierr=1
     return
  endif

  call xplasma_prof_info(s,id_R,iertmp, gridId1=id_chi, gridId2=id_rho)
  call xplasma_grid_size(s,id_chi,nchi,iertmp)
  call xplasma_grid_size(s,id_rho,nrho,iertmp)

  if((ibcrho0.eq.1).or.(ibcrho0.eq.2)) then
     idbc0=nchi
  else
     idbc0=1
  endif

  if((ibcrho1.eq.1).or.(ibcrho1.eq.2)) then
     idbc1=nchi
  else
     idbc1=1
  endif

  call eq_flxint_arr2d(2,2,zdata,nchi,nrho, &
       ibcrho0,idbc0,zbcrho0,ibcrho1,idbc1,zbcrho1, &
       iwant,result,inumchi,inumrho,ierr)

  if(ierr.ne.0) then
     write(lunerr,*) ' ** eq_flxint_arr2s: error in eq_flxint_arr2d: '
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_flxint_arr2s

subroutine eqi_bdfind_circ(ivec,imask,zR,zZ,iseg, &
     ztheta_near,zdist, &
     nsrch1,zRsurf,zZsurf,zTheta,krzrad,rzrad,ierr)

  ! internal routine to compute distance based on circles interpolation
  ! approximation: each sequence of the consecutive points in
  ! {zRsurf,zZsurf} is fit to a circle, which defines a distance to each
  ! target point.  This gives two distances-- one for each end of the
  ! segment to which the target point is closest.  A single distance is
  ! chosen as an interpolation between these two, linearly according to 
  ! the average of 2 locations of intersection of lines from target points
  ! to the fit circles's centers.  I.e. if these intersections are 75% of
  ! the way to segment endpoint #2, then 
  !    d = 75%*[distance to circle fit to endpoint #2] +
  !        25%*[distance to circle fit to endpoint #1]
  ! is used.

  implicit NONE

  integer, intent(in) :: ivec   ! size of vector of target points
  logical, intent(in) :: imask(ivec) ! skip vector elements j if imask(j) TRUE

  real*8, intent(in) :: zR(ivec) ! target points' R coordinates
  real*8, intent(in) :: zZ(ivec) ! target points' Z coordinates
  integer, intent(in) :: iseg(ivec)    ! segment to use (cf eqi_bdfind)

  !  the following are intent(inout) so that outputs corresponding to masked
  !  points are unmodified:

  real*8, intent(inout) :: ztheta_near(ivec)   ! estimated nearest theta
  real*8, intent(inout) :: zdist(ivec)         ! estimated distance

  integer, intent(in) :: nsrch1  ! # of search segment end points

  real*8, intent(in) :: zRsurf(0:nsrch1+1),zZsurf(0:nsrch1+1) ! segment end pts
  !  augmented at start and end so that the triple involving an end point and
  !  its nearest neighbours is always available.

  real*8, intent(in) :: zTheta(0:nsrch1+1) ! poloidal angle at each seg end pt.

  integer, intent(inout) :: krzrad(nsrch1) ! status for each end point:
  !  0 -- circle fit not done
  !  1 -- circle fit done
  !  2 -- circle fit deemed "degenerate"; treat end pt triple as colinear
  !    status may be updated here...

  real*8, intent(inout) :: rzrad(nsrch1,3) ! circle data [Rcen,Zcen,radius]
  !  for each segment end point... may be updated here... 

  integer, intent(out) :: ierr    ! error status code, 0=OK
  !----------------------------------------------------------------
  integer :: i,jsrch1,jsrch2
  real*8 :: d1,d2,thet1,thet2,thetav

  real*8, parameter :: TWO = 2.0d0
  real*8, parameter :: HALF = 0.5d0
  real*8, parameter :: C4TH = 0.25d0
  real*8, parameter :: EPS10= 1.0d-10
  real*8, parameter :: ZERO = 0.0d0
  !----------------------------------------------------------------

  ierr=0

  do i=1,ivec
     if(imask(i)) cycle

     jsrch1=iseg(i)
     jsrch2=jsrch1+1

     if(krzrad(jsrch1).eq.0) call circ_fit(jsrch1)
     if(krzrad(jsrch2).eq.0) call circ_fit(jsrch2)

     call dist(jsrch1,zR(i),zZ(i),d1,thet1)
     call dist(jsrch2,zR(i),zZ(i),d2,thet2)

     thetav=HALF*(thet1+thet2)

     ztheta_near(i)=thetav

     zdist(i)=(d1*(zTheta(jsrch2)-thetav) + d2*(thetav-zTheta(jsrch1)))/ &
          (zTheta(jsrch2)-zTheta(jsrch1))
  enddo

  contains

    subroutine circ_fit(j)

      !  circle fit the three points j-1:j+1 on the search contour
      !  finding the 1 point that is equidistant from 3 consecutive
      !  boundary points is pretty quick-- reduces to a linear equation.

      !  on exit, the sign of the radius indicates if the center of
      !  the circle is displaced towards the inside or the outside of
      !  the plasma.

      !  if the radius is too large a flag is set and the sequence of 3
      !  points is treated as being colinear.

      integer, intent(in) :: j

      !-------------------
      integer :: jp1,jm1
      real*8 :: Rp,Zp,Rm,Zm,Rhalf,Zhalf,Rj,Zj,delR,delZ,del2
      real*8 :: delRj,delZj,delc2
      real*8 :: zrhs,zlamd,zcoeff
      !-------------------

      jp1=j+1
      Rp=zRsurf(jp1); Zp=zZsurf(jp1)

      jm1=j-1
      Rm=zRsurf(jm1); Zm=zZsurf(jm1)

      Rhalf=HALF*(Rm+Rp)
      Zhalf=Half*(Zm+Zp)

      Rj=zRsurf(j)
      Zj=zZsurf(j)

      delR = Rp-Rm
      delZ = Zp-Zm
      del2 = delR*delR + delZ*delZ

      delRj=(Rhalf-Rj)
      delZj=(Zhalf-Zj)
      delc2= delRj*delRj + delZj*delZj

      zrhs = delc2 - del2*C4TH
      zcoeff = TWO*(delZ*delRj-delR*delZj)
      if(abs(zcoeff).lt.1.0d-6*abs(zrhs)) then
         !  treat as colinear segment
         krzrad(j)=2
         
      else
         krzrad(j)=1
         zlamd = zrhs/zcoeff
         rzrad(j,1)=Rhalf - delZ*zlamd
         rzrad(j,2)=Zhalf + delR*zlamd

         ! **testing** only one is needed: all should have the same value
         ! (verified dmc May 2006)

         rzrad(j,3)=sqrt((Rj-rzrad(j,1))**2+(Zj-rzrad(j,2))**2)
         ! rzrad(j,3)=sqrt((Rp-rzrad(j,1))**2+(Zp-rzrad(j,2))**2)
         ! rzrad(j,3)=sqrt((Rm-rzrad(j,1))**2+(Zm-rzrad(j,2))**2)

         if(zlamd.lt.0.0d0) rzrad(j,3)=-rzrad(j,3)
      endif

    end subroutine circ_fit

    subroutine dist(j,Rpt,Zpt,d,th)

      !  distance and theta of nearest approach estimate
      !  relative to point j on the search contour

      integer, intent(in) :: j       ! search contour point
      real*8, intent(in) :: Rpt,Zpt  ! point from which distance is wanted

      real*8, intent(out) :: d       ! distance estimate
      !  signed: +1 for outside & -1 for inside the contour...

      real*8, intent(out) :: th      ! theta (interp. zTheta of search contour)

      !--------------------------
      integer :: j1,j2,jm1,jp1
      real*8 :: dmsq,dpsq,th1,th2
      real*8 :: delR,delZ,znum,zdenom,zlamd,Rx,Zx,d1,d2,R1,Z1,R2,Z2,zdir
      real*8 :: Rc,Zc
      real*8 :: dc,rad,signtest
      !--------------------------
      jm1=j-1
      jp1=j+1

      if(krzrad(j).eq.2) then

         ! pts treated as colinear (very rare in practice)

         dmsq = (Rpt-zRsurf(jm1))**2 + (Zpt-zZsurf(jm1))**2
         dpsq = (Rpt-zRsurf(jp1))**2 + (Zpt-zZsurf(jp1))**2

         ! use segment with nearer end point...
         if(dmsq.lt.dpsq) then
            j1=jm1
            j2=j
         else
            j1=j
            j2=jp1
         endif
         th1=zTheta(j1)
         th2=zTheta(j2)
         R1=zRsurf(j1); Z1=zZsurf(j1)
         R2=zRsurf(j2); Z2=zZsurf(j2)

         delR = R2-R1
         delZ = Z2-Z1

         ! find intersection of line through (Rpt,Zpt) normal to the segment
         ! with the segment itself or a linear extension thereof

         zdenom = delR*delR + delZ*delZ  ! guaranteed non-zero
         znum = (Z1-Zpt)*delR - (R1-Rpt)*delZ

         zlamd = znum/zdenom

         ! this is the intercept

         Rx = Rpt - delZ*zlamd
         Zx = Zpt + delR*zlamd

         ! this is the distance: + for outside, - for inside the plasma surface
         ! (this sign convention applies because the surfaces are drawn
         ! counter-clockwise around the plasma).

         if(zlamd.gt.ZERO) then
            d=sqrt((Rx-Rpt)**2+(Zx-Zpt)**2)
         else
            d=-sqrt((Rx-Rpt)**2+(Zx-Zpt)**2)
         endif

         ! find which end point is closer.  Extrapolate if past an endpoint;
         ! this should be rare/small.  Define output theta by interpolation 
         ! using ratio of distances from the end points to the intercept.

         if((delR*(Rx-R1)+delZ*(Zx-Z1)).ge.ZERO) then
            d1=sqrt((Rx-R1)**2+(Zx-Z1)**2)
         else
            d1=-sqrt((Rx-R1)**2+(Zx-Z1)**2)  ! this should be rare
         endif

         d2=sqrt(delR**2+delZ**2)-d1

         th = (d2*th1 + d1*th2)/(d1+d2)

      else

         ! normal case -- use circle fit data associated with point j

         ! signtest: usually (Rpt,Zpt) is on the same side of the circle
         ! center as the bdy points, but... not always...

         Rc = rzrad(j,1)  ! circle center...
         Zc = rzrad(j,2)

         signtest = (Rpt-Rc)*(zRsurf(j)-Rc) + &
              (Zpt-Zc)*(zZsurf(j)-Zc)
         if(signtest.lt.0.0d0) then
            signtest=-1.0d0
         else
            signtest=1.0d0
         endif

         dc = sqrt((Rpt-Rc)**2+(Zpt-Zc)**2)*signtest

         rad = rzrad(j,3)

         if(rad.lt.ZERO) then
            d = -(rad+dc)  ! - if inside surface, + if outside
         else
            d = dc-rad     ! - if inside surface, + if outside
         endif
         
         if(abs(dc).lt.EPS10*rad) then
            th=zTheta(j)
         else
            Rx=Rc + abs(rad)*(Rpt-Rc)/dc
            Zx=Zc + abs(rad)*(Zpt-Zc)/dc
         endif

         zdir = (zRsurf(jp1)-zRsurf(j))*(Rx-zRsurf(j)) + &
              (zZsurf(jp1)-zZsurf(j))*(Zx-zZsurf(j))

         if(zdir.ge.ZERO) then
            j1=j
            j2=jp1
         else
            j1=jm1
            j2=j
         endif
         th1=zTheta(j1)
         th2=zTheta(j2)
         R1=zRsurf(j1); Z1=zZsurf(j1)
         R2=zRsurf(j2); Z2=zZsurf(j2)

         d1=(Rx-Rc)*(Zx-Z1)-(Zx-Zc)*(Rx-R1)
         d2=(Rx-Rc)*(Z2-Zx)-(Zx-Zc)*(R2-Rx)

         th = (d2*th1 + d1*th2)/(d1+d2)

      endif
    end subroutine dist

end subroutine eqi_bdfind_circ

subroutine eqm_list_create(zlist_name,zlist_label,inum,elem_names,id,ierr)
  !
  !  create new list object in XPLASMA

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  character*(*), intent(in) :: zlist_name   ! name of list
  character*(*), intent(in) :: zlist_label  ! label for list
  integer, intent(in) :: inum               ! size of list (1 or more)
  character*(*), dimension(inum), intent(in) :: elem_names ! list element names

  integer, intent(out) :: id                ! id of newly created list
  integer, intent(out) :: ierr              ! completion code: 0=OK

  ! id=0 on exit if an error occurs.
  !
  ! list name must be unique.  Duplicate name => error.
  ! inum > 0 required.
  !
  ! internally, all names are set to uppercase; comparisons e.g. for
  ! duplication are all done in uppercase.
  !-------------------------------------------------
  integer :: iertmp
  !-------------------------------------------------

  ierr=0
  id=0

  call xplasma_find_item(s,zlist_name,id,ierr)
  if(ierr.eq.0) then
     !  error -- item already exists
     write(lunerr,*) ' ?eqm_list_create: cannot make list named "', &
          trim(zlist_name),'":'
     write(lunerr,*) '  name is already in use.'
     ierr=1
     return
  endif

  call xoi_author_set(iertmp)

  call eqm_list_replace(zlist_name,zlist_label,inum,elem_names,id,ierr)

  call xoi_author_clear(iertmp)

end subroutine eqm_list_create

subroutine eqm_list_replace(zlist_name,zlist_label,inum,elem_names,id,ierr)
  !
  !  replace list object in XPLASMA or if does not exist
  !  create new list object in XPLASMA

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  character*(*), intent(in) :: zlist_name   ! name of list
  character*(*), intent(in) :: zlist_label  ! label for list
  integer, intent(in) :: inum               ! size of list (1 or more)
  character*(*), dimension(inum), intent(in) :: elem_names ! list element names

  integer, intent(out) :: id                ! id of newly created list
  integer, intent(out) :: ierr              ! completion code: 0=OK

  ! id=0 on exit if an error occurs.
  !
  ! list name must be unique.  Duplicate name => error.
  ! inum > 0 required.
  !
  ! internally, all names are set to uppercase; comparisons e.g. for
  ! duplication are all done in uppercase.
  !-------------------------------------------------
  integer :: iertmp
  !-------------------------------------------------

  ierr=0
  id=0

  call xoi_author_set(iertmp)

  call xplasma_create_list(s,zlist_name,elem_names,id,ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqm_list_create: error creating list named "', &
          trim(zlist_name),'":'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  call xplasma_label_item(s,id,ierr, label=zlist_label)

  call xoi_author_clear(iertmp)

end subroutine eqm_list_replace

subroutine eqm_list_merge(id1,id2,idelete,ierr)
  ! merge lists
  ! list (id2) is appended to list (id1); when done (id2) is deleted
  !   if (idelete) is set.
  ! if an element in (id2) has the same name as an element in the original
  ! (id1), then the values in the original are replaced with the values in
  ! the element from (id2).

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: id1  ! id of list to be expanded
  integer, intent(in) :: id2  ! id of list to be added to list (id1)
  logical, intent(in) :: idelete  ! .TRUE. to delete (id2) when done.
  integer, intent(out) :: ierr    ! completion code (0=OK)

  !  ierr < 0 means a warning: there were duplicate names btw (id1) and
  !           (id2); (id2) list elements replaced.

  !----------------
  integer :: iertmp
  !-------------------------------------------------

  call xoi_author_set(iertmp)

  call xplasma_merge_lists(s,id1,id2,ierr, idelete)
  if(ierr.gt.0) then
     write(lunerr,*) ' ?eqm_list_merge: list merge failure, list ids:'
     write(lunerr,*) '  id1=',id1,'; id2=',id2
     call xplasma_error(s,ierr,lunerr)
  endif

  call xoi_author_clear(iertmp)

end subroutine eqm_list_merge

subroutine eqm_list_chval(ident,inum,zchvals,ierr)

  ! set list element character data for list #idlist

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: ident   ! list ID
  integer, intent(in) :: inum    ! number of elements in zchvals
  character*(*), dimension(inum), intent(in) :: zchvals  ! character data in
  integer, intent(out) :: ierr   ! completion code, 0=OK

  !-------------------------------
  integer :: iertmp
  !-------------------------------------------------

  call xoi_author_set(iertmp)

  call xplasma_setlist(s,ident,zchvals,ierr)
  if(ierr.ne.0) call eqm_list_errors(ident,ierr,'character string')

  call xoi_author_clear(iertmp)

end subroutine eqm_list_chval

subroutine eqm_list_ival(ident,inum,ivals,ierr)

  ! set list element integer data for list #idlist

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: ident   ! list ID
  integer, intent(in) :: inum    ! number of elements in ivals
  integer, dimension(inum), intent(in) :: ivals  ! integer data in
  integer, intent(out) :: ierr   ! completion code, 0=OK

  !-------------------------------
  integer :: iertmp
  !-------------------------------------------------

  call xoi_author_set(iertmp)

  call xplasma_setlist(s,ident,ivals,ierr)
  if(ierr.ne.0) call eqm_list_errors(ident,ierr,'integer')

  call xoi_author_clear(iertmp)

end subroutine eqm_list_ival

subroutine eqm_list_r8val(ident,inum,r8vals,ierr)

  ! set list element real*8 data for list #idlist

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: ident   ! list ID
  integer, intent(in) :: inum    ! number of elements in r8vals
  real*8, dimension(inum), intent(in) :: r8vals  ! real*8 data in
  integer, intent(out) :: ierr   ! completion code, 0=OK

  !-------------------------------
  integer :: iertmp
  !-------------------------------------------------

  call xoi_author_set(iertmp)

  call xplasma_setlist(s,ident,r8vals,ierr)
  if(ierr.ne.0) call eqm_list_errors(ident,ierr,'r8 floating point')

  call xoi_author_clear(iertmp)

end subroutine eqm_list_r8val

subroutine eqm_list_r4val(ident,inum,r4vals,ierr)

  ! set list element real*8 data for list #idlist (real data passed)

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: ident   ! list ID
  integer, intent(in) :: inum    ! number of elements in r8vals
  real, dimension(inum), intent(in) :: r4vals  ! floating point data in
  integer, intent(out) :: ierr   ! completion code, 0=OK

  !-------------------------------
  integer :: iertmp
  !-------------------------------------------------

  call xoi_author_set(iertmp)

  call xplasma_setlist(s,ident,r4vals,ierr)
  if(ierr.ne.0) call eqm_list_errors(ident,ierr,'r4 floating point')

  call xoi_author_clear(iertmp)

end subroutine eqm_list_r4val

subroutine eqm_list_errors(id,ierr,zstr)

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  !  error reporting routine for eqm_list.f90

  integer, intent(in) :: id   ! ID of list where error occurred
  integer, intent(in) :: ierr ! INPUT error status code
  character*(*), intent(in) :: zstr   ! type of data intended for insertion

  !-------------------------------
  character*32 znamel
  integer :: iertmp
  !-------------------------------

  if(ierr.ne.0) then
     call xplasma_get_item_info(s,id,iertmp, name=znamel)
     write(lunerr,*) &
          ' ?eqm_list_chval: error inserting ',trim(zstr),' data in list "', &
          trim(znamel),'":'
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eqm_list_errors

subroutine eqm_rzfunf(ifun,userfcn,iarg,iorder,zsm,ierr)

  !  set up function "ifun" on (R,Z) grid, Akima-Hermite interpolation
  !         "ifun" is already in form f(rho).

  !    data values from user supplied function  of form:

  !        real*8 function userfcn(iarg,zR,zZ,zphi,ierr)

  !        integer iarg          ! pass thru code (input to userfcn)
  !        real*8 zR,zZ,zphi     ! coords (input to userfcn)
  !        integer ierr          ! completion code (output by userfcn)

  !    note userfcn is only called with (R,Z,phi) values for points which
  !    are OUTSIDE the plasma last closed flux surface but INSIDE the
  !    user specified limiters

  !  pass the function number (ifun):  e.g.
  !     call eq_gfnum('TE',ifun)       ! get TE function number
  !     call eqm_rzfunf(ifun,userfcn,iorder,zsm,ierr)

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  !  input:
  integer ifun                      ! function number (existing f(rho))
  external userfcn                  ! user supplied function
  real*8 userfcn
  integer iarg                      ! arg. passed through to userfcn
  
  integer iorder                    ! order of interpolating function

  !  iorder=0  -- piecewise bilinear function
  !  iorder=1  -- piecewise bicubic hermite function
  !  iorder=2  -- piecewise bicubic spline function

  !  iorder=99 -- redefinition of existing f(R,Z) function

  real*8 zsm                        ! smoothing parameter for edge (m)

  !  output:
  integer ierr                      ! completion code, 0=OK

  !---------------------------------------------
  character*32 pname,units
  character*80 label
  integer :: itype,iorderi,iertmp,idnew
  !---------------------------------------------

  call xplasma_prof_info(s,ifun,ierr, name=pname, gridType=itype, &
       label=label, units=units)

  if(label.eq.' ') label=pname

  if(ierr.ne.0) then
     call xplasma_error(s,ierr,lunerr)
     ierr=1
     return
  endif

  if(itype.ne.xplasma_flux_coords) then
     write(lunerr,*) ' ?eqm_rzfunf: cannot do scrapeoff region extrapolation on: ',trim(pname)
     write(lunerr,*) '  Profile is not defined vs. flux coordinates.'
     ierr=1
     return
  endif

  pname = trim(pname)//'_FRZ'   ! name for f(R,Z) derived from f(rho)...

  iorderi=iorder
  if(iorderi.lt.99) iorderi=max(0,min(2,iorderi))
  if(iorderi.ge.100) iorderi=max(0,min(2,(iorderi-100)))

  !-----------------
  !  iorderi=99 means request to use prior splining method for this call;
  !  this implies profile must already exist:  check...

  if(iorderi.eq.99) then
     call xplasma_find_item(s,pname,ifun,iertmp)
     if(iertmp.eq.0) then
        call xplasma_prof_info(s,ifun,ierr, splineType=iorderi)
     else
        ierr=iertmp
     endif
     if(ierr.ne.0) then
        call xplasma_error(s,ierr,lunerr)
        call eq_errmsg(' ?eqm_rhofun: iorder=99 call failed: '//trim(pname)// &
             ' does not exist.')
        ierr=1
     endif
  endif
  if(ierr.ne.0) return

  !-----------------
  !  OK...

  call xoi_author_set(iertmp)

  call xplasma_rzprof_fun(s,pname,userfcn,iarg,idnew,ierr, &
       ispline=iorderi, sm_edge=zsm, id_fun_in=ifun, &
       label=trim(label)//' mapped to (R,Z).', units=units)

  call xoi_author_clear(iertmp)

  if(ierr.ne.0) then
     call xplasma_error(s,ierr,lunerr)
     ierr=1
  endif

end subroutine eqm_rzfunf

 
#include "fpreproc/byte_declare.h"
 
!----------------------------------------------------------
! cface  -- generated (f90 fixed form) C interface to:  EQM_IRHOFUN
      SUBROUTINE  C_EQM_IRHOFUN(
     > ID_AXIS,C_ZLBL_LEN,C_ZLBL,INPROF,ZPROF,IFLAG,ID,IERR)
 
      external EQM_IRHOFUN
 
! argument declarations
      INTEGER ID_AXIS
 ! scalar char*(*) type, input/output:
      INTEGER C_ZLBL_LEN
      BYTE_DECLARE C_ZLBL(C_ZLBL_LEN)
 
      INTEGER INPROF
      INTEGER IFLAG
      INTEGER ID
      INTEGER IERR
      REAL*8 ZPROF(INPROF)
 
! local (automatic array) declarations
      CHARACTER(C_ZLBL_LEN) :: ZLBL_act
 
! executable code:  copy for input
 
      call cstring(ZLBL_act, C_ZLBL,'2F')
! call to original routine:  EQM_IRHOFUN
 
      CALL EQM_IRHOFUN(
     > ID_AXIS,ZLBL_act,INPROF,ZPROF,IFLAG,ID,IERR)
 
! copy back outputs if modified.
      call cstring(ZLBL_act, C_ZLBL,'2C')
 
! exit
      return
      end

subroutine eqm_flabel(id,label,units,ier)
  !
  ! set descriptive and units label for item (usually a profile function)

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  integer, intent(in) :: id   ! id of item to be labeled
  character*(*), intent(in) :: label   ! desired label
  character*(*), intent(in) :: units   ! desired units label

  integer, intent(out) :: ier ! completion code, 0=OK

  !-----------------------
  integer :: iertmp
  !-----------------------

  call xoi_author_set(iertmp)

  call xplasma_label_item(s,id,ier, &
       label=label,units=units)

  if(ier.ne.0) call xplasma_error(s,ier,lunerr)

  call xoi_author_clear(iertmp)

end subroutine eqm_flabel

      program geqxpl2
c
c  create an xplasma from a (hard coded) geqdsk file
c  ...dmc May 2001
c
c  this code is meant as an example illustrating use of xplasma to
c  construct an equilibrium representation from an EFIT G-EQDSK file.
c
c  all floats are REAL*8 (or f90 SELECTED_REAL_KIND(12,100))
c
c..#   sample compile-load script -- Linux alpha workstation --
c..set f90opt = "fort -fast -assume no2underscore"
c..set libdir = /usr/ntcc/lib
c..$f90opt geqxpl2.for -L $libdir
c..                   -lxplasma -lfluxav -lmclib -lsmlib -ltrgraf \
c..                   -lureadsub -lsg -ljc -lnscrunch -lr8bloat -lfftsub \
c..                   -lcomput -lvaxonly -lpspline -lezcdf -llsode  \
c..                   -llsode_linpack -lportlib \
c..                -L/usr/local/lib
c..                   -lnetcdf -llapack -lblas \
c..                   -lreadline -lhistory -ltermcap
c
c  on your system:  the location of the installed NTCC libraries might
c                   not be /usr/ntcc/lib
c  and... your compiler switches might be different.
c  and... netcdf, lapack, blas might not be in the same place
c
c  gnu libraries (readline, history, termcap) are "optional" but recommended.
c  these enable command line editing & filename completion when answering
c  prompts inside interactive fortran programs.
c
      use eqm_mds_fromgeqdsk_mod
      implicit NONE
c
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
c
      character*150 zfile
      integer ns,nt1,irz,ier
      character*20 label
c
      real*8 fbdy,crat
      real*8 zadjust
c
c---------------------------------------------------------------------
c
      call uinitg('GEQXPL2')
c
      label = 'geqxpl2_test'      ! arbitrary label string for xplasma
 
      zfile = 'g103875.nstx'      ! *** name or path of G-EQDSK file ***
                                  !   MDS+ path also OK on systems with MDS+
 
      fbdy=1.00_r8                ! =1.00 to start with EFIT boundary
                                  ! =0.99 to start with a boundary
                                  !  enclosing 1% less flux than EFIT's
                                  ! boundary
 
      crat=0.080_r8               ! minimum curvature ratio; local curvature
                                  ! of boundary surface .gt. crat*a, where
                                  ! a= midplane half width of plasma; code
                                  ! will reduce enclosed flux if necessary
                                  ! to find a boundary satisfying this
                                  ! condition
 
      ns= 41                      ! number of "rho" surfaces including axis
                                  ! surfaces equally spaced in rho which is
                                  ! defined as sqrt(normalized toroidal flux).
                                  ! abs(ns) is the actual no. of surfaces; if
                                  ! ns.lt.0 use Hermite instead of Spline for
                                  ! surface fits in xplasma.
 
      nt1=51                      ! number of (evenly spaced) "theta" points
                                  ! in (rho,theta) bicubic spline grids.
                                  ! theta chosen by eqm_mds_fromgeqdsk for
                                  ! numerical reasons -- no special
                                  ! properties of physical significance
                                  ! this is a "periodic" grid with
                                  ! theta(nt1)=theta(1)+2pi.  Data splined
                                  ! over this grid will have periodic
                                  ! boundary conditions in the theta
                                  ! direction.
 
      irz=1                       ! =1 to form B(R,Z), psi(R,Z)
c
c---------------
c
c  the curvature-based boundary selection seems to do well in terms of
c  avoiding future problems due to choosing a boundary which is kinked
c  at a separatrix.  It also has the advantage that for non-diverted
c  discharges the actual, unreduced boundary can be used.  In our older
c  codes a constant psi-reduction parameter (to move the boundary in a
c  little) was used, which had the disadvantages (a) sometimes we didn't
c  move it in enough; and (b) other times we moved it in more than was
c  necessary so we lost some of the plasma edge.
c
c-------------------------------------
c
c  OK this is the xplasma call which reads the G-EQDSK file and sets
c  up the equilibrium
c
      write(6,1002) crat,zfile(1:len_trim(zfile))
 1002 format(' (eqm_mds_fromgeqdsk call)'/
     >   ' adjust boundary so that minimum local curvature is at least'/
     >   1x,f12.6,' * [the midplane half-width of the plasma]'//
     >   ' --> eqm_mds_fromgeqdsk sets up xplasma g-eqdsk data: ',a/
     >   '     (note eqm_mds_fromgeqdsk can also acquire EFIT data'/
     >   '     over the network from standard EFIT MDSplus trees).'/)
c
      write(6,*) ' '
      write(6,*) ' ...reading & converting G-eqdsk... '
c
      call eqm_mds_fromgeqdsk(label,zfile,ns,nt1,fbdy,crat,irz,ier)
c
      write(6,*) ' '
c
c-------------------------------------
c
      if(ier.ne.0) then
         write(6,*) ' ?eqm_mds_fromgeqdsk error, ier=',ier
         call bad_exit
      endif
c
c  make some analytic profiles... illustrate how to define some functions
c
      call geqxpl2_pro
c
c  print out some stuff... illustrate xplasma data lookup calls...
c
      call geqxpl2_print
c
c  interactive SG-plotting of the geometry, fields and their derivatives...
c  this also shows the full xplasma contents and the names of individual
c  items...
c
      call eqdbg_plot
c
      write(6,*) ' --------------- all done --------------- '
c
      stop
      end
c-----------------------------------------------------------------
      subroutine geqxpl2_pro
c
c  the following header file should be used!
c  it allows the compiler to check that xplasma calls have the right
c  calling arguments.  However, there is a possible performance issue:
c  contact dmccune@pppl.gov for details.
c
c  make some profiles
c
c  electron density... #/m**3
c
      implicit NONE
c
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
c
      real*8, parameter :: ONE = 1.0_R8, ZERO = 0.0_R8
c
      real*8, parameter :: ne0 = 4.0e19_r8   ! central density
      real*8, parameter :: nea = 1.0e19_r8   ! edge density
      real*8, parameter :: neexp = 1.0_r8    ! exponent
c
c  ne(rho) = (ne0-nea)*(ONE-rho**2)**neexp + nea
c
c  and a similar formula for TE and TI (keV)
c
      real*8, parameter :: Ti0 = 5.0_r8, Tia=0.1_r8, tiexp=1.5_r8
      real*8, parameter :: Te0 = 5.0_r8, Tea=0.1_r8, teexp=1.5_r8
c
c  ratios for various ion densities n_i/n_e
c  I am enforcing quasineutrality by hand...
c
      real*8, parameter :: nc_rat = 0.05_r8   ! carbon (Z=6)
      real*8, parameter :: nh_rat = 0.01_r8   ! H "minority"
      real*8, parameter :: nd_rat = 0.69_r8   ! D "majority"
c
c  for all profiles...
c
      integer, parameter :: ibc0 = 1    ! central boundary condition:
      real*8, parameter :: zbc0 = ZERO  ! df/d(rho) = 0
      integer, parameter :: ibc1 = 0    ! default boundary condition at edge
                                        ! spline "not a knot" boundary cond.
      real*8 zdum                       ! edge BC data (not used)
c
      integer, parameter :: iorder = 2  ! spline, C2
c
c         iorder=1  --> Hermite cubics, C1 but less likely to "ring"
c                       in case of noisy data
c
c         iorder=0  --> piecewise linear, C0 and really safe.
c
c  working variables...
c
      real*8, dimension(:), allocatable :: rho,fun,fne
c
      real*8 :: ztol = 1.0e-8_r8        ! a small number...
c
      integer ngrid    ! size of grid currently in use
c
      integer :: id_rho=0   ! xplasma id for "rho" grid (equilibrium version)
      integer :: id_myrho=0 ! xplasma id for another "rho" grid (created here)
c
      integer :: id_te=0,id_ti=0,id_ne=0,id_nc=0,id_nd=0,id_nh=0  ! profile xplasma id's
c
c  the xplasma id's could be saved in a COMMON or module for another part
c  of the program to use, but this is not essential since the id's can
c  also retrieved by translating from the profile names...
c
      integer igot,ierr
      integer i
c
c-----------------------------------------------------------
c
      write(6,*) 'geqxpl2_pro...'
c
c  one can define profiles on the same grid as the equilibrium is defined
c  on, or... on a different grid.
c
c  first I show code using the same grid, and use this to set up TE and TI
c
      call eq_ganum('__RHO',id_rho)   ! this gets the equilibrium rho grid
c                                     ! name is always "__RHO".
c
      call eq_ngrid(id_rho,ngrid)     ! get size of the grid
c
      allocate(rho(ngrid),fun(ngrid)) ! allocate arrays
c
      call eq_grid(id_rho,rho,ngrid,igot,ierr)  ! get the grid
      if(ierr.ne.0) call errmsg_exit(' ?? eq_grid error.')
c
c  igot is guaranteed to equal ngrid, because I just allocated the array
c  of the right size.  But in an f77 code I might have been using a fixed
c  size static array; ierr would be set if this array size were not sufficient
c  to hold the requested grid.
c
c  errmsg_exit is a `portlib' routine that writes an error message, sets
c  an exit status code (testable by shell scripts) and exits the program.
c
c  OK... compute the functions, f90 style...
c
      write(6,*) '...define TE and TI'
c
      fun = (te0-tea)*(ONE-rho*rho)**teexp + tea ! this is an array expression
c
c  now define a 1d profile for "TE"
      call eqm_rhofun(iorder,                 ! fit order (e.g. spline)
     >                id_rho,                 ! "x axis" grid
     >                'TE',                   ! name of item
     >                fun(1:ngrid),           ! the data itself
     >                ibc0,zbc0,              ! d(TE)/drho = 0 on axis
     >                ibc1,zdum,              ! default BC for edge
     >                id_te,                  !  **TE xplasma id returned**
     >                ierr)                   ! completion code, 0=OK
      if(ierr.ne.0) call errmsg_exit(' ?? "TE" eqm_rhofun error.')
c
c  similarly for "TI"
c
      fun = (ti0-tia)*(ONE-rho*rho)**tiexp + tia ! this is an array expression
c
      call eqm_rhofun(iorder,id_rho,'TI',fun,ibc0,zbc0,ibc1,zdum,
     >   id_ti,ierr)
      if(ierr.ne.0) call errmsg_exit(' ?? "TI" eqm_rhofun error.')
c
c----------------
c
      deallocate(rho,fun)
c
c----------------
c
c  now suppose I want to use my own grid to define my own function f(rho).
c  the grid covers the same range [0,1] and has the same physical association
c  (sqrt(normalized toroidal flux)) but the number of points and spacing
c  can be different; grids are never required to be evenly spaced... but
c  for simplicity I make a 26 point evenly spaced grid here...
c
      ngrid=26
c
      allocate(rho(ngrid),fun(ngrid),fne(ngrid))
c
c  there is a more compact f90 way of doing this...
c
      do i = 1,ngrid
         rho(i)=(i-1)*ONE/(ngrid-1)  ! 0.00, 0.04, 0.08, ..., 1.00
      enddo
c
      write(6,*) '...setting up alternate rho grid'
c
c  define this grid to xplasma and give it the name "my_rho".
c  note that the grid is associated with the original grid:  it covers
c  the same space and has the same physical association; just a different
c  partitioning...
c
      call eqm_uaxis('my_rho',            ! the name
     >                id_rho,             ! "associated" grid ("__RHO").
     >                0,                  ! 0="not periodic" 1="periodic"
     >                rho(1:ngrid),       ! the grid points...
     >                ngrid,              ! number of points in this grid...
     >                ztol,               ! even spacing tolerance...
     >                id_myrho,           ! *** xplasma id of new grid ***
     >                ierr)
      if(ierr.ne.0) call errmsg_exit(' ?? eqm_uaxis "my_rho" error.')
c
c  once the grid id_myrho exists, profiles f(rho) can be defined using
c  this grid; these splines can be used interchangeably with splines
c  defined against the original (MHD equilibrium) rho grid.
c
c  the 3rd argument of eqm_uaxis is "periodicity"; xplasma also grids
c  which represent poloidal angle-- these are "periodic" grids; splines
c  on periodic grids satisfy e.g.
c     f'(theta(0))=f'(theta(ntheta))
c     f''(theta(0))=f''(theta(ntheta))
c  i.e. a periodic boundary condition.
c
c  but this is a digression, because here we deal with f(rho) profiles
c  only.
c
c  the electron density:
c
      write(6,*) '...define NE and ion density profiles.'
c
      fne = (ne0-nea)*(ONE-rho*rho)**neexp + nea ! this is an array expression
c
c  note use of "id_myrho" tells eqm_rhofun that item is defined on the
c  26 point rho grid just defined...
c
      call eqm_rhofun(iorder,id_myrho,'NE',fne,ibc0,zbc0,ibc1,zdum,
     >   id_ti,ierr)
      if(ierr.ne.0) call errmsg_exit(' ?? "NE" eqm_rhofun error.')
c
c  ion densities...
c
      fun = nd_rat*fne   ! array expression
      call eqm_rhofun(iorder,id_myrho,'ND',fun,ibc0,zbc0,ibc1,zdum,
     >   id_ti,ierr)
      if(ierr.ne.0) call errmsg_exit(' ?? "ND" eqm_rhofun error.')
c
      fun = nh_rat*fne   ! array expression
      call eqm_rhofun(iorder,id_myrho,'NH',fun,ibc0,zbc0,ibc1,zdum,
     >   id_ti,ierr)
      if(ierr.ne.0) call errmsg_exit(' ?? "NH" eqm_rhofun error.')
c
      fun = nc_rat*fne   ! array expression
      call eqm_rhofun(iorder,id_myrho,'NC',fun,ibc0,zbc0,ibc1,zdum,
     >   id_ti,ierr)
      if(ierr.ne.0) call errmsg_exit(' ?? "NC" eqm_rhofun error.')
c
      deallocate(rho,fun,fne)
c
c  OK thats enough...
c
      return
      end
c------------------------------------------------------------------------
      subroutine geqxpl2_print
c
      implicit NONE
c
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
c
c  demo the xplasma data access routines; print results
c
      integer i,j,id,id_rho,idgrid,ngrid,igot
c
      integer, parameter :: nlist=20
      integer idlist(nlist),n1,n,nf
      character*20 namlist(nlist),zname
      integer inumrho,inumchi,inumphi,inumR,inumZ
c
      integer nregion(nlist)
      real*8 xlist(nlist),ylist(nlist),zlist(nlist)
      real*8 rlist(nlist),philist(nlist),rholist(nlist),chilist(nlist)
      real*8 glist(nlist),datbuf(nlist,nlist),dist(nlist)
      real*8 tol
      real*8 b_axis,r_axis,z_axis
      real*8 rho_axis,rho_bdy
      real*8 Rmin,Zmin,Bmin,Rmax,Zmax,Bmax
      real*8 Rming,Zming,Rmaxg,Zmaxg
c
      real*8 Rc(1),Rs(1),Zc(1),Zs(1),x(1)
      integer kmom,im
c
      real*8, dimension(:), allocatable :: xbuf,xbuf_zc
      integer, dimension(:), allocatable :: kindx
c
      integer il1,il2,ierr,iwarn,iwant,ictwant(6)
      integer magdim,magfit,cyldim,cylfit
c------------------
c  name translation
c
      datbuf=0
c
      write(6,1001)
 1001 format(/' xplasma data access routines are described at:'/
     >   '  http://w3.pppl.gov/~pshare/help/xplasma_hlp.html'/)
c
      write(6,1002)
 1002 format(' ========>> axis & function name translation.'/
     >   '  (a) given name, fetch xplasma id.'/
     >   '      eq_ganum:  axis;  eq_gfnum:  function.'/
     >   '      eq_gflist:  list of funcionts.'/)
c
      call eq_ganum("__RHO",id_rho)
      write(6,999) ' call eq_ganum("__RHO",id_rho) --> id_rho=',id_rho
 999  format(a,1x,i4)
      write(6,*) ' '
c
      call eq_gfnum("Te",id)
      write(6,999) ' call eq_gfnum("Te",id) -> id=',id
      call eq_gfnum("TE",id)
      write(6,999) ' call eq_gfnum("TE",id) -> id=',id
      write(6,*) ' ... the name matching is case-insensitive.'
      write(6,*) ' '
c
      n=2
      namlist(1)='TE'
      namlist(2)='NE'
      call eq_gflist(n,namlist(1:n),idlist(1:n),ierr)
      write(6,1003) ierr,n
 1003 format(' call eq_gflist(n,namlist(1:n),idlist(1:n),ierr)'/
     >   '   ierr=',i4,' (set if any name is unknown)'/
     >   '   a list of length n=',i4,' was processed:')
      do i=1,n
         il1=len_trim(namlist(i))
         write(6,1005) i,namlist(i)(1:il1),i,idlist(i)
 1005    format('     namlist(',i1,')="',a,
     >      '" -> idlist(',i1,')=',i4)
      enddo
      write(6,*) ' '
c
      write(6,1006) id_rho,id
 1006 format('  (b) given id, fetch name (reverse translation).'/
     >   '      id_rho=',i4,'  id=',i4/)
c
      call eq_get_aname(id_rho,zname)
      write(6,998) ' call eq_get_aname(id_rho,zname) -> zname = "',
     >   zname(1:len_trim(zname)),'"'
c
      call eq_get_fname(id,zname)
      write(6,998) ' call eq_get_fname(id,zname) -> zname = "',
     >   zname(1:len_trim(zname)),'"'
 998  format(a,a,a)
c
      write(6,*) ' '
      call eq_fun(id,magdim,magfit,cyldim,cylfit,iwarn,ierr)
      write(6,1007) zname(1:len_trim(zname)),
     >   magdim,magfit,cyldim,cylfit,iwarn,ierr
 1007 format('  (c) given id, fetch characteristics:'/
     >   '      magdim=1 => f(rho), magdim=2 => f(rho,chi) ',
     >                     'magdim=0 => (none)'/
     >   '      magfit=[Cn of fit, e.g 2 for C2 spline]'/
     >   '      cyldim=2 => f(R,Z), magdim=0 => (none)'/
     >   '      cylfit=[Cn of fit, e.g 2 for C2 spline]'/
     >   '      iwarn set if an xplasma "private" function;'/
     >   '      ierr set if no such function for given id.'//
     >   '      for "',a,'":'/
     >   ' call eq_fun(id,magdim,magfit,cyldim,cylfit,iwarn,ierr)'/
     >   '      magdim=',i1,' magfit=',i1/
     >   '      cyldim=',i1,' cylfit=',i1/
     >   '       iwarn=',i1,'   ierr=',i1//
     >   ' a named object can exist in both f(rho) and f(R,Z) form,'/
     >   ' and sometimes this is advantageous for performance reasons.')
c
      write(6,*) ' '
      write(6,*) ' ========>> axis (grid) information.'
      write(6,*) ' '
c
      call eq_ganum("my_rho",idgrid)
      write(6,999) ' call eq_ganum("my_rho",idgrid) --> idgrid=',idgrid
      write(6,*) ' '
c
      call eq_ngrid(idgrid,ngrid)
      write(6,999) ' eq_ngrid(idgrid,ngrid) --> ngrid=',ngrid
      write(6,*) ' '
c
      allocate(xbuf(ngrid),xbuf_zc(ngrid-1))
      write(6,*) ' allocate(xbuf(ngrid),xbuf_zc(ngrid-1))'
      write(6,*) ' '
      call eq_grid(idgrid,xbuf(1:ngrid),ngrid,igot,ierr)
      write(6,997)
     >   ' call eq_grid(idgrid,xbuf(1:ngrid),ngrid,igot,ierr)  -->',
     >   '      igot=',igot,' ierr=',ierr
 997  format(a/a,i4,a,10(1x,i4))
      write(6,2001) ' xbuf=',(xbuf(i),i=1,ngrid)
      write(6,*) ' '
      call eq_grid_zc(idgrid,xbuf_zc(1:ngrid-1),ngrid-1,igot,ierr)
      write(6,997)
     >   ' call eq_grid_zc(idgrid,xbuf_zc(1:ngrid-1),'//
     >   'ngrid-1,igot,ierr) -->','      igot=',igot,' ierr=',ierr
      write(6,2001) ' xbuf_zc=',(xbuf_zc(i),i=1,ngrid-1)
      write(6,*) ' '
 2001 format(1x,a,' = '/6(1x,f10.6))
c
      call eq_ngrids(inumrho,inumchi,inumphi,inumR,inumZ)
      write(6,*)
     >   ' call eq_ngrds(inumrho,inumchi,inumphi,inumR,inumZ) ->'
      write(6,*) ' xplasma "common grid" sizes:'
      write(6,1008) inumrho,inumchi,inumphi,inumr,inumz
 1008 format(
     >   '   MHD equilibrium rho grid:    ',i4/
     >   '   MHD equilibrium theta grid:  ',i4/
     >   '     poloidal angle is sometimes called "chi" in xplasma.'/
     >   '   MHD equilibrium phi grid:    ',i4/
     >   '     (inumphi=1 means axisymmetry).'/
     >   '     (xplasma requires axisymmetry at present).'/
     >   '   (R,Z) grids:  inumR, inumZ:  ',i4,i4//
     >   ' although xplasma grid information is available, it'/
     >   ' is not necessary to use it, in order to perform'/
     >   ' interpolations...'/)
c
      n1=ngrid-1
      allocate(kindx(n1))
      write(6,*) ' n1=ngrid-1'
      write(6,*) ' allocate(kindx(n1))'
      write(6,*) ' '
      call eq_nindx(id_rho,n1,xbuf_zc(1:n1),kindx(1:n1),ierr)
      write(6,997) ' call eq_nindx('//
     >   'id_rho,n1,xbuf_zc(1:n1),kindx(1:n1),ierr) -->',
     >   '      ierr=',ierr,' kindx=',kindx
      write(6,*) ' ..these indices show which zones in the MHD rho grid'
      write(6,*) ' ..contain the zone center points from "my_rho" grid.'
      write(6,*) ' '
c
      write(6,*) ' ========>> coordinate transformation.'
      write(6,*) '  coordinates:'
      write(6,*) '    cartesian:  (x,y,z)'
      write(6,*) '    cylindric:  (R,Z,phi)'
      write(6,*) '    magnetic:   (rho,chi,phi)'
      write(6,*) '  all coordinate transformations are vectorized,'
      write(6,*) '  i.e. transform lists of coordinate tuples.'
      write(6,*) '   ***>> vectorization helps performance'
      write(6,*) '         on workstations as well as vector machines.'
      write(6,*) ' '
      write(6,*) '  ---not all routines demonstrated---'
      write(6,*) '  ---see the documentation---'
      write(6,*) ' '
      write(6,*) '  (rho,chi,phi) -> (R,Z,[phi])'
c
      n=3
      rholist(1)=0.5_r8
      chilist(1)=0.0_r8
      philist(1)=0.0_r8
      rholist(n)=0.6_r8
      chilist(n)=1.0_r8
      philist(n)=1.0_r8
      do i=2,n-1
         rholist(i)=rholist(1)+(i-1)*(rholist(n)-rholist(1))/(n-1)
         chilist(i)=chilist(1)+(i-1)*(chilist(n)-chilist(1))/(n-1)
         philist(i)=philist(1)+(i-1)*(philist(n)-philist(1))/(n-1)
      enddo
c
      call eq_rzget(n,rholist,chilist,philist,rlist,zlist,nregion,ierr)
      write(6,*) ' call eq_rzget(n,rholist,chilist,philist,'//
     >   'rlist,zlist,nregion,ierr)'
      do i=1,n
         write(6,2002) i,rholist(i),chilist(i),philist(i),
     >      rlist(i),zlist(i),philist(i)
      enddo
 2002 format(2x,i1,'.  (',3(f9.5,1x),') --> (',3(f9.5,1x),')')
      write(6,*) ' '
c
      write(6,*) '  (R,[Z],phi) -> (x,y,[z])'
      call eq_xcyl(n,rlist,philist,xlist,ylist)
      write(6,*) ' call eq_xcyl(n,rlist,philist,xlist,ylist)'
      do i=1,n
         write(6,2002) i,rlist(i),zlist(i),philist(i),
     >      xlist(i),ylist(i),zlist(i)
      enddo
      write(6,*) ' '
c
      write(6,*) '  (x,y,[z]) -> (R,[Z],phi)'
      call eq_rcyl(n,xlist,ylist,rlist,philist)
      write(6,*) ' call eq_rcyl(n,xlist,ylist,rlist,philist)'
      do i=1,n
         write(6,2002) i,xlist(i),ylist(i),zlist(i),
     >      rlist(i),zlist(i),philist(i)
      enddo
c
      tol=1.0e-10_r8
      write(6,*) '  (R,Z,phi) -> (rho,chi,[phi])'
      write(6,1009) tol
 1009 format('    [ tol = ',1pe11.4,' ]')
      call eq_inv(n,rlist,zlist,philist,tol,
     >   rholist,chilist,nregion,ierr)
      write(6,*) ' call eq_inv(n,rlist,zlist,philist,tol, &'
      write(6,*) '             rholist,chilist,nregion,ierr)'
      do i=1,n
         write(6,2002) i,rlist(i),zlist(i),philist(i),
     >      rholist(i),chilist(i),philist(i)
      enddo
      write(6,*) ' "tol" controls the accuracy of the Newton iteration'
      write(6,*) ' used to compute the "inverse map".'
      write(6,*) '   (caution: performance issue).'
      write(6,*) ' '
c
      write(6,*) ' also available:'
      write(6,*) '   eqx_inv:  (x,y,z) -> (rho,chi,phi)'
      write(6,*) '   eq_xget:  (rho,chi,phi) -> (x,y,z)'
      write(6,*) ' '
c
      write(6,*) ' '
      write(6,*) ' ========>> min/max information.'
      write(6,*) ' '
      write(6,*) ' ...axis and boundary "rho" coordinate:'
      call eq_rholim(rho_axis,rho_bdy)
      write(6,1011) rho_axis,rho_bdy
 1011 format(' call eq_rholim(rho_axis,rho_bdy)'/
     >   '  -->  rho_axis,rho_bdy = ',2(f10.4))
      write(6,*) ' '
c
      write(6,*) ' ...min and max R and Z on a flux surface:'
      call eq_glimrz(rho_bdy,Rmin,Rmax,Zmin,Zmax,ierr)
      write(6,1013) ierr,Rmin,Rmax,Zmin,Zmax
 1013 format('     [rho = rho_bdy]'/
     >   ' call eq_glimrz(rho,Rmin,Rmax,Zmin,Zmax,ierr)'/
     >   '  --> ierr=',i3/
     >   '      Rmin,Rmax,Zmin,Zmax =',4(1x,f10.4)/)
      write(6,*) ' ...min and max mod(B) on a flux surface:'
      call eq_glimb(rho_bdy,Bmin,Bmax,ierr)
      write(6,1015) ierr,Bmin,Bmax
 1015 format('     [rho = rho_bdy]'/
     >   ' call eq_glimb(rho,Bmin,Bmax,ierr)'/
     >   '  --> ierr=',i3/
     >   '      Bmin,Bmax =',2(1x,f10.4)/)
c
      write(6,*)
     >   ' ...extrema of (R,Z) rectangular grid covering plasma:'
      write(6,*) ' call eq_rzlims(Rming,Rmaxg,Zming,Zmaxg,ierr)'
      call eq_rzlims(Rming,Rmaxg,Zming,Zmaxg,ierr)
      write(6,1017) ' ...min and max R of grid: ',Rming,Rmaxg
 1017 format(a,2(1x,f10.4))
      write(6,1017) ' ...min and max Z of grid: ',Zming,Zmaxg
      write(6,*) ' '
c
      write(6,*) ' ...magnetic axis information:'
      write(6,*) ' ...assuming axisymmetry...'
      write(6,*) ' call eq_sgaxis(B_axis,R_axis,Z_axis)'
      call eq_sgaxis(B_axis,R_axis,Z_axis)
      write(6,1018) b_axis,r_axis,z_axis
 1018 format(' ...at the magnetic axis:'/
     >   '   mod(B)=',f10.4,' (R,Z) = (',f10.4,',',f10.4,')'/
     >   ' ...note this is the actual mod(B), not the vacuum field.')
      write(6,*) ' '
      write(6,*) ' ========>> f(rho) interpolation.'
      write(6,*) ' '
c
      call eq_gfnum("G",id)
      iwant=0
      call eq_rgetf(n,rholist,id,iwant,glist,ierr)
      write(6,1019) ierr
 1019 format(
     >   '   to interpolate g(rho) = R*Bphi at n rho values:'/
     >   '      use iwant=0 for g, iwant=1 for dg/drho, '/
     >   '      use iwant=2 for d2g/drho2 (splines only).'//
     >   ' iwant = 0'/
     >   ' call eq_gfnum("G",id)'/
     >   ' call eq_rgetf(n,rholist,id,iwant,glist,ierr)'/
     >   '   ---> ierr=',i4)
      do i=1,n
         write(6,1020) i,rholist(i),i,glist(i)
 1020    format('        rholist(',i1,')=',f10.4,' -> ',
     >      'glist(',i1,')=',f10.4)
      enddo
      write(6,1021)
 1021 format(/
     >'   to interpolate multiple functions {f(rho)} pass a list of'/
     >'   function ids and receive a buffer datbuf(1:n,1:nfcns);'/
     >'   see xplasma documentation of eq_rgetff (1d interpolation).'/)
c
      write(6,*) ' '
      write(6,*) ' ========>> f(rho,chi) interpolation.'
      write(6,*) ' '
c
      write(6,1025)
 1025 format(
     >   ' to interpolate sets of fucntions {f(rho,chi)}:'/
     >   '   (a) determine list of desired functions;'/
     >   '   (b) determine if {f}, {df/drho,df/dchi}, or'/
     >   '       some other combination of values and derivatives'/
     >   '       is wanted.'/
     >   '   (c) set up vectors rho(1:n) and chi(1:n), and call:'/
     >   '          eq_frhochi -- get {f} values'/
     >   '          eq_grhochi -- get {df/drho,df/dchi} values'/
     >   '          eq_hrhochi -- get combination up to 2nd order.'/
     >   '               (2nd order derivatives for splines only).'/)
c
      call eq_gfnum("R",idlist(1))
      call eq_gfnum("BR",idlist(2))
      call eq_gfnum("BZ",idlist(3))
      nf=3
      call eq_frhochi(n,rholist,chilist,nf,idlist,nlist,datbuf,ierr)
c
      write(6,1026) n,nlist,nf,ierr
 1026 format(
     >' When using these functions one must be careful with the '/
     >' dimensioning of the data buffer or array which is to contain'/
     >' the results of the interpolations.'//
     >' In this example, we are using a list of 3 functions, a'/
     >' rho,chi vector length of ',i1,', and an output buffer which'/
     >' is dimensioned   datbuf(nlist,nlist)  where nlist=',i3,'.'//
     >'    ** first example **'/
     >' call eq_gfnum("R",idlist(1))'/
     >' call eq_gfnum("BR",idlist(2))'/
     >' call eq_gfnum("BZ",idlist(3))'/
     >' nf=',i1/
     >' call eq_frhochi(n,rholist,chilist,nf,idlist,  &'/
     >'                 nlist,datbuf,ierr)'//
     >' (note that the 1st dimension of datbuf, "nlist", must be'/
     >' passed).  The result is ierr=',i4,', and:')
      do i=1,n
         write(6,1028) i,rholist(i),i,chilist(i),
     >      i,datbuf(i,1),i,datbuf(i,2),i,datbuf(i,3),
     >      i,glist(i)/datbuf(i,1)
      enddo
 1028 format(
     >   ' at rholist(',i1,')=',f10.4,', chilist(',i1,')=',f10.4,','/
     >   '     R  = datbuf(',i1,',1)=',f10.4/
     >   '     BR = datbuf(',i1,',2)=',f10.4/
     >   '     BZ = datbuf(',i1,',3)=',f10.4/
     >   '     and, glist(',i1,')/R = Bphi =',f10.4/)
c
      ictwant = (/ 0, 1, 1, 1, 1, 1 /)
      call eq_gfnum("R",idlist(1))
      call eq_gfnum("Z",idlist(2))
      nf=2
      call eq_hrhochi(n,rholist,chilist,nf,idlist,ictwant,
     >   nlist,datbuf,ierr)
      write(6,1030) ierr
 1030 format('    ** second example **'/
     >   ' call eq_gfnum("R",idlist(1))'/
     >   ' call eq_gfnum("Z",idlist(2))'/
     >   ' nf=2'/
     >   ' ictwant = (/ 0, 1, 1, 1, 1, 1 /)'/
     >   ' call eq_hrhochi(n,rholist,chilist,nf,idlist,ictwant,  &'/
     >   '                 nlist,datbuf,ierr)'//
     >   ' yields ierr=',i4,'.  "ictwant" is interpreted as follows:'/
     >   '    ictwant(1)=0 --> do NOT return R,Z values.'/
     >   '    ictwant(2)=1 --> do return d{R,Z}/drho.'/
     >   '    ictwant(3)=1 --> do return d{R,Z}/dchi.'/
     >   '    ictwant(4)=1 --> do return d2{R,Z}/drho2.'/
     >   '    ictwant(5)=1 --> do return d2{R,Z}/dchi2.'/
     >   '    ictwant(6)=1 --> do return d2{R,Z}/drhodchi.'/
     >   ' so we get:')
      do i=1,n
         write(6,1032) i,rholist(i),i,chilist(i),
     >      (i,datbuf(i,j),j=1,10)
      enddo
 1032 format(
     >   ' at rholist(',i1,')=',f10.4,', chilist(',i1,')=',f10.4,','/
     >   '    dR/drho = datbuf(',i1,',1)=',f10.4/
     >   '    dR/dchi = datbuf(',i1,',2)=',f10.4/
     >   '    d2R/drho2 =    datbuf(',i1,',3)=',f10.4/
     >   '    d2R/dchi2 =    datbuf(',i1,',4)=',f10.4/
     >   '    d2R/drhodchi = datbuf(',i1,',5)=',f10.4//
     >   '    dZ/drho = datbuf(',i1,',6)=',f10.4/
     >   '    dZ/dchi = datbuf(',i1,',7)=',f10.4/
     >   '    d2Z/drho2 =    datbuf(',i1,',8)=',f10.4/
     >   '    d2Z/dchi2 =    datbuf(',i1,',9)=',f10.4/
     >   '    d2Z/drhodchi = datbuf(',i1,',10)=',f10.4/)
c
      write(6,*) ' Note:  "eq_gfnum" is used in these examples for'
      write(6,*) '  the sake of clarity, but, name translation calls'
      write(6,*) '  should be kept out of inner loops for performance'
      write(6,*) '  reasons...'
      write(6,*) ' '
c
      write(6,*) ' ========>> demo of routines to compute distance from'
      write(6,*) ' plasma boundary.  Input: lists of (R,Z,phi) values:'
      do i=1,nlist
         rlist(i)=r_axis+(i-1)*(rmax-r_axis)/(nlist-1)
         zlist(i)=z_axis+(i-1)*(zmax-z_axis)/(nlist-1)
         philist(i)=0.0_r8
      enddo
c
      write(6,*) ' '
      write(6,*) ' call eq_dfast(nlist,rlist,zlist,philist,dist,ierr)'
      write(6,*) ' '
c
      call eq_dfast(nlist,rlist,zlist,philist,dist,ierr)
c
      write(6,1034) nlist,ierr
 1034 format(' nlist=',i4,' on input; on output ierr=',i4/
     >   '  #    R          Z          phi        distance (output)')
      do i=1,nlist
         write(6,1035) i,rlist(i),zlist(i),philist(i),dist(i)
      enddo
 1035 format(1x,i2,4(1x,f10.4))
c
      write(6,*) ' positive distance gives how far outside the plasma;'
      write(6,*) ' negative distance gives how rar inside.  The numbers'
      write(6,*) ' from eq_dfast are approximate; a slower but more'
      write(6,*) ' accurate calculation is also available.'
c
      deallocate(kindx)
c
      deallocate(xbuf,xbuf_zc)
c
c  data on Fourier representation of equilibrium...
c
      write(6,*) ' '
      write(6,*) ' Fourier moments representation of flux geometry'
      write(6,*) ' can be retrieved via calls to eqmom_rcos, etc...'
c
      call xmoments_kmom_get(kmom)  ! get no. of moments
c
      do i=1,3
         x(1)=(i-1)/2.0d0
         write(6,*) ' '
         write(6,*) ' ===> x=',x
         write(6,*)
     >      ' Moment#    Rcos         Rsin         Zcos         Zsin'
         do im=0,kmom
            !  usually would call these routines with a longer x vector...
            call eqmom_rcos(x,1,0,im,Rc,iwarn)
            call eqmom_rsin(x,1,0,im,Rs,iwarn)
            call eqmom_zcos(x,1,0,im,Zc,iwarn)
            call eqmom_zsin(x,1,0,im,Zs,iwarn)
            write(6,1100) im,Rc(1),Rs(1),Zc(1),Zs(1)
         enddo
      enddo
 1100 format(3x,i2,7x,4(1x,1pe12.5))
c
      write(6,*)
      write(6,*) ' end of geqxpl2_print demo.'
      write(6,*) ' *** not all xplasma routines shown ***'
      write(6,*) ' *** see NTCC xplasma documentation for full list ***'
      write(6,*)
c
      return
      end

subroutine eq_getjac(ivec,zrho,zchi,zphi,irzmode,jtens,detj,ierr)

  use xplasma_obj_instance
  use eq_module

  !  get metric tensor and determinant, given mag. coordinate

  implicit NONE

!  input:
  integer ivec                      ! vector dimensioning
  real*8 zrho(abs(ivec)),zchi(abs(ivec)),zphi(abs(ivec)) ! (rho,chi,phi)
  integer irzmode                   ! =1: d[R,Z,Lphi]/d[rho,chi,phi]

!  output:
  real*8 jtens(3,3,abs(ivec))            ! d[x,y,z]/d[rho,chi,phi]
  real*8 detj(abs(ivec))                 ! determinant of jtens

  integer ierr                      ! error code, 0=OK

  ! irzmode=0:
  !  jtens(1:3,1,j) = (dx/drho,dx/dchi,dx/dphi) at j'th vector element
  !  jtens(1:3,2,j) = (dy/drho,dy/dchi,dy/dphi) at j'th vector element
  !  jtens(1:3,3,j) = (dz/drho,dz/dchi,dz/dphi) at j'th vector element

  ! irzmode=1:
  !  jtens(1:3,1,j) = (dR/drho,dR/dchi,dR/dphi) at j'th vector element
  !  jtens(1:3,2,j) = (dZ/drho,dZ/dchi,dZ/dphi) at j'th vector element
  !  jtens(1:3,3,j) = R*(dphi/drho,dphi/dchi,1) at j'th vector element
  !               for axisymmetric cases jtens(1:3,3,j) = (0,0,R)
  !
  ! for compatibility with existing f77 xplasma codes:
  ! if irzmode=2, jtens(1:3,3) = (Z,0,R) is returned.

  !---------------------------

  logical :: ccwflag,axisymm
  integer :: jvec,j
  real*8 :: zr(abs(ivec)),zz(abs(ivec)),zdetj(abs(ivec)),zcos,zsin
  real*8 :: drdrho(abs(ivec)),dzdrho(abs(ivec))
  real*8 :: drdchi(abs(ivec)),dzdchi(abs(ivec))
 
  !--------------------------------
 
  jvec=abs(ivec)
  ccwflag = (ivec.gt.0)

  call xplasma_global_info(s,ierr, axisymm=axisymm)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?error detected in eq_getjac:'
     call xplasma_error(s,ierr,lunerr)
  else if(.not.axisymm) then
     ierr=1
     write(lunerr,*) ' ?eq_getjac: only available for axisymmetric geometry!'
  endif
  if(ierr.eq.0) then

     if(irzmode.eq.2) then
        call xplasma_rzjac(s,zrho,zchi,ierr, &
             ccwflag=ccwflag, &
             z=zz,r=zr,rzdetj=zdetj, &
             drdrho=drdrho,dzdrho=dzdrho, &
             drdtheta=drdchi,dzdtheta=dzdchi)
     else
        call xplasma_rzjac(s,zrho,zchi,ierr, &
             ccwflag=ccwflag, &
             r=zr,rzdetj=zdetj, &
             drdrho=drdrho,dzdrho=dzdrho, &
             drdtheta=drdchi,dzdtheta=dzdchi)
     endif

     if(ierr.eq.0) then

        detj=zr*zdetj

        if(irzmode.eq.0) then
           do j=1,jvec
              zcos=cos(zphi(j))
              zsin=sin(zphi(j))

              jtens(1,1,j)=drdrho(j)*zcos
              jtens(2,1,j)=drdchi(j)*zcos
              jtens(3,1,j)=-zr(j)*zsin

              jtens(1,2,j)=drdrho(j)*zsin
              jtens(2,2,j)=drdchi(j)*zsin
              jtens(3,2,j)=zr(j)*zcos

              jtens(1,3,j)=dzdrho(j)
              jtens(2,3,j)=dzdchi(j)
              jtens(3,3,j)=0
           enddo
           
        else
           do j=1,jvec
              jtens(1,1,j)=drdrho(j)
              jtens(2,1,j)=drdchi(j)
              jtens(3,1,j)=0

              jtens(1,2,j)=dzdrho(j)
              jtens(2,2,j)=dzdchi(j)
              jtens(3,2,j)=0

              if(irzmode.eq.2) then
                 jtens(1,3,j)=zz(j)
              else
                 jtens(1,3,j)=0
              endif
              jtens(2,3,j)=0
              jtens(3,3,j)=zr(j)
           enddo

        endif

     else
        write(lunerr,*) ' ?error detected in eq_getjac xplasm_rzjac call:'
        call xplasma_error(s,ierr,lunerr)
     endif

  endif

  if(ierr.ne.0) then
     jtens = 0.0d0
     detj  = 0.0d0
  endif

end subroutine eq_getjac

subroutine eqi_geq_getlun(ilun)

  !  get GEQ module I/O unit number

  use eqi_geq_mod
  implicit NONE

  integer :: ilun

  !--------------------------

  call geq_getlun(ilun)

end subroutine eqi_geq_getlun

subroutine eqm_rzmag2(rzmapper,id_R,id_Z,ierr)

  !  legacy xplasma f77 interface...
  !  create 2d functions R(rho,chi), Z(rho,chi)
  !  using passed external routine "rzmapper"
  !  rzmapper is a dummy argument for a subroutine which MUST have the
  !  following interface:

  !      subroutine rzmapper(rho,chi,R,Z,ierr)

  !      real*8 rho,chi      ! INPUT (rho,chi) - radial, poloid coordinates
  !      real*8 R,Z          ! OUTPUT R(rho,chi), Z(rho,chi)
  !      integer IERR        ! OUTPUT completion code, 0=OK

  !--------------------------------------------------------------

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  ! input:
  external rzmapper                 ! passed subroutine

  ! output:
  integer id_R                      ! id for R spline
  integer id_Z                      ! id for Z spline
  integer IERR                      ! completion code, 0-OK
  
  !--------------------------
  !  local

  integer :: id_rho,id_chi,inrho,inchi,iertmp,icount
  real*8, parameter :: zdiff=1.0d0
  integer, parameter :: ninfin=1000000000
  logical :: iforce=.FALSE.
  !--------------------------

  id_R=0
  id_Z=0

  call eqm_rzmag_check(ninfin,ninfin,1,id_rho,id_chi,inrho,inchi,ierr)
  if(ierr.ne.0) return

  call xoi_author_set(iertmp)

  call xplasma_rzmagf(s,rzmapper,id_rho,id_chi, &
       id_R,id_Z,ierr, zdiff=zdiff)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqm_rzmag2: error in xplasma_rzmagf call.'
     call xplasma_error(s,ierr,lunerr)
  else
     call xplasma_eqcheck(s,iforce,icount,ierr)
     if(icount.gt.0) then
        write(lunerr,*) ' %eqm_rzmag2: equilibrium specification completed.'
     endif
  endif

  call xoi_author_clear(iertmp)

end subroutine eqm_rzmag2

subroutine geqdsk_index1_ntimes(ilun,filename,ntimes)

  use geqdsk_aux
  use geqdsk_index_mod
  implicit NONE

  integer, intent(in) :: ilun  ! fortran LUN for file input
  character*(*), intent(in) :: filename  ! file to read (index of G-eqdsks...)
  integer, intent(out) :: ntimes  ! no. of times indexed in the file

  !  get number of times; return ntimes=0 if there is an error...

  !---------------
  integer :: ilun_msg,ierr
  !---------------

  if(.not.geqdsk_index1_init) then
     call geqdsk_index_preset(geqdsk_index1)
     geqdsk_index1_init=.TRUE.
  endif

  call geqdsk_index_init(ilun,filename,geqdsk_index1,ierr)
  if(ierr.ne.0) then
     ilun_msg=lunmsg
     write(ilun_msg,*) ' ?geqdsk_index1_ntimes: error reading file: ',trim(filename)
     call geqdsk_index_msg(geqdsk_index1,ierr,ilun_msg)
     ntimes=0
  else
     ntimes=geqdsk_index1%ntimes
  endif

end subroutine geqdsk_index1_ntimes

subroutine geqdsk_index1_path(ilun,filename,path)

  use geqdsk_aux
  use geqdsk_index_mod
  implicit NONE

  integer, intent(in) :: ilun  ! fortran LUN for file input
  character*(*), intent(in) :: filename  ! file to read (index of G-eqdsks...)
  character*(*), intent(out) :: path     ! path to files (blank if $cwd)

  !  get number of times; return path=0 if there is an error...
  !---------------
  integer :: ilun_msg,ierr
  !---------------

  if(.not.geqdsk_index1_init) then
     call geqdsk_index_preset(geqdsk_index1)
     geqdsk_index1_init=.TRUE.
  endif

  call geqdsk_index_init(ilun,filename,geqdsk_index1,ierr)
  if(ierr.ne.0) then
     ilun_msg=lunmsg
     write(ilun_msg,*) ' ?geqdsk_index1_path: error reading file: '&
          &,trim(filename)
     call geqdsk_index_msg(geqdsk_index1,ierr,ilun_msg)
     path='?'
  else
     path=geqdsk_index1%path
  endif

end subroutine geqdsk_index1_path

subroutine geqdsk_index1_gtime_r4(ilun,filename,itime,gtime,ierr)
  implicit NONE

  integer, intent(in) :: ilun  ! fortran LUN for file input
  character*(*), intent(in) :: filename  ! file to read (index of G
  !-eqdsks...)
  integer, intent(in) :: itime           ! time index
  real, intent(out) :: gtime             ! time value returned (r4)
  integer, intent(out) :: ierr           ! completion code (0=OK)

  real*8 :: gtime_r8

  call geqdsk_index1_gtime(ilun,filename,itime,gtime_r8,ierr)
  gtime=gtime_r8

end subroutine geqdsk_index1_gtime_r4

subroutine geqdsk_index1_gtime(ilun,filename,itime,gtime,ierr)

  ! return the itime'th time in the index file (filename)

  use geqdsk_aux
  use geqdsk_index_mod
  implicit NONE

  integer, intent(in) :: ilun  ! fortran LUN for file input
  character*(*), intent(in) :: filename  ! file to read (index of G
  !-eqdsks...)
  integer, intent(in) :: itime           ! time index
  real*8, intent(out) :: gtime           ! time value returned
  integer, intent(out) :: ierr           ! completion code (0=OK)

  !  get time associated with index "itime" in the index file "filename".

  !---------------
  integer :: ilun_msg
  !---------------

  if(.not.geqdsk_index1_init) then
     call geqdsk_index_preset(geqdsk_index1)
     geqdsk_index1_init=.TRUE.
  endif

  call geqdsk_index_init(ilun,filename,geqdsk_index1,ierr)

  gtime=0
  if(ierr.ne.0) then
     ilun_msg=lunmsg
     write(ilun_msg,*) ' ?geqdsk_index1_gtime: error reading file: ',trim(filename)
     call geqdsk_index_msg(geqdsk_index1,ierr,ilun_msg)
  else if((itime.le.0).or.(itime.gt.geqdsk_index1%ntimes)) then
     ilun_msg=lunmsg
     write(ilun_msg,*) ' ?geqdsk_index1_gtime: ',trim(filename)
     write(ilun_msg,*) '  time index: ',itime,' out of file index range: ', &
          '1 to ',geqdsk_index1%ntimes
  else
     gtime=geqdsk_index1%times(itime)
  endif

end subroutine geqdsk_index1_gtime

subroutine geqdsk_index1_gfile(ilun,filename,itime,gfile,ierr)

  ! return the itime'th gfile filename in the index file (filename)
  use geqdsk_aux
  use geqdsk_index_mod
  implicit NONE

  integer, intent(in) :: ilun  ! fortran LUN for file input
  character*(*), intent(in) :: filename  ! file to read (index of G-eqdsks...)
  integer, intent(in) :: itime           ! time index
  character*(*), intent(out) :: gfile    ! G-eqdsk filename returned
  integer, intent(out) :: ierr           ! completion code (0=OK)

  !  get number of times; return ntimes=0 if there is an error...

  !---------------
  integer :: ilun_msg
  !---------------

  if(.not.geqdsk_index1_init) then
     call geqdsk_index_preset(geqdsk_index1)
     geqdsk_index1_init=.TRUE.
  endif

  call geqdsk_index_init(ilun,filename,geqdsk_index1,ierr)

  gfile=' '
  if(ierr.ne.0) then
     ilun_msg=lunmsg
     write(ilun_msg,*) ' ?geqdsk_index1_gfile: error reading file: ',trim(filename)
     call geqdsk_index_msg(geqdsk_index1,ierr,ilun_msg)
  else if((itime.le.0).or.(itime.gt.geqdsk_index1%ntimes)) then
     ilun_msg=lunmsg
     write(ilun_msg,*) ' ?geqdsk_index1_gfile: ',trim(filename)
     write(ilun_msg,*) '  time index: ',itime,' out of file index range: ', &
          '1 to ',geqdsk_index1%ntimes
  else
     gfile=geqdsk_index1%efiles(itime)
  endif

end subroutine geqdsk_index1_gfile

subroutine geqdsk_findex(fstring,iend,indx)

  ! given a string of the form "EFIT_INDEX:<file-path>(<integer-index>)
  ! return the start and stop string indices of <file-path>, and decode
  ! the integer index inside the parentheses; return iend=indx=0 if an
  ! error occurs; write no messages.

  implicit NONE
  character*(*), intent(in) :: fstring  ! input string
  integer,intent(out) :: iend           ! output loc. end of <file-path> string
  integer,intent(out) :: indx           ! output decoded <integer-index> value

  character*10 zstr
  integer i,j,ilparen,irparen,ili,istat

  iend=0
  indx=0

  zstr=fstring(1:10)
  call uupper(zstr)
  if(zstr//fstring(11:11).ne.'EFIT_INDEX:') then
     return   ! no lead string
  endif

  ilparen=index(fstring,'(')
  irparen=index(fstring,')')
  if(min(ilparen,irparen).le.0) then
     return   ! no index value or missing parentheses
  endif

  j=11
  zstr=' '
  do i=irparen-1,ilparen+1,-1
     if(fstring(i:i).ne.' ') then
        j=j-1
        if(j.eq.0) exit
        zstr(j:j)=fstring(i:i)
     endif
  enddo
  if((j.eq.11).or.(j.eq.0)) then
     return   ! empty or too long integer string
  endif

  read(zstr,'(i10)',iostat=istat) indx
  if(istat.ne.0) then
     indx=0
     return   ! decode failure
  endif

  ! if we made it this far, the index decode was successful
  ! although it is still possible for the value to be out of range
  ! with respect to the contents of the named file...

  ! find end of filename and exit...

  do i=ilparen-1,11,-1
     if(fstring(i:i).ne.' ') then
        iend=i
        exit
     endif
  enddo

end subroutine geqdsk_findex

subroutine eqi_bprobe(inum,itype,imaptype,ra,za,da,rb,zb,db,ierr)

  !  generate a set of probe segments (Ra,Za)--(Rb,Zb) such that
  !  the (Ra,Za) are all inside, and the (Rb,Zb) all outside, the
  !  given surface:

  !    itype=1:  plasma boundary
  !    itype=2:  limiter

  !  also make sure to get (inum) segments with start and stop point
  !  monotonically increasing in poloidal angle, and, a sequence whose
  !  bdy intersections will procede in an orderly manner around the
  !  boundary contour.

  use xplasma_definitions
  use eqi_rzbox_module
  implicit NONE

  !  input:
  integer inum                      ! number of segments wanted
  integer itype                     ! bdy to straddle
  integer imaptype                  ! mapping accuracy control
  ! for computing distance: 1=slow&exact, 2=medium&accurate, 3=fast&approximate

  !  output:
  real*8 ra(inum),za(inum)          ! segment points just inside bdy
  real*8 da(inum)                   ! distance inside bdy (.lt.0)
  real*8 rb(inum),zb(inum)          ! segment points just outside bdy
  real*8 db(inum)                   ! distance outside bdy (.gt.0)

  integer ierr                      ! completion code, 0=OK

  !---------------------------------

  integer :: nrhox,nchix
  real*8, dimension(:), allocatable :: zrho,zchi,zphi,zdist,zchix,zrhox
  real*8, dimension(:), allocatable :: zchiv
  real*8, dimension(:,:), allocatable :: zbuf,zbuf2

  integer i,j,id_rhox,id_chix,ilist(4),idchis(4)
  integer ifnd,imiss,indx

  real*8 zdx,znorm,Rfastmin,Rfastmax,Zfastmin,Zfastmax,zindx,zxchi

  logical :: sol,axisymm

  real*8, parameter :: ZERO=0.0d0
  real*8, parameter :: ONE=1.0d0

  !---------------------------------

  ierr=0

  call xplasma_global_info(sp,ierr, scrapeoff=sol, axisymm=axisymm)
  if(ierr.ne.0) return

  if(.not.axisymm) then
     call xplasma_errmsg_append(sp,' ?eqi_bprobe: axisymmetry required.')
     ierr=107
  endif

  if(.not.sol) then
     call xplasma_errmsg_append(sp, &
          ' ?eqi_bprobe: scrapeoff region must be defined before this routine can beused.')
     ierr=109
  endif
  if(ierr.ne.0) return

  call xplasma_find_item(sp,'__RHOX',id_rhox,ierr)
  if(ierr.ne.0) return

  call xplasma_find_item(sp,'__THETAX',id_chix,ierr)
  if(ierr.ne.0) return

  call xplasma_grid_size(sp,id_rhox,nrhox,ierr)
  if(ierr.ne.0) return

  call xplasma_grid_size(sp,id_chix,nchix,ierr)
  if(ierr.ne.0) return

  allocate(zchix(nchix))
  call xplasma_grid(sp,id_chix,zchix,ierr)

  allocate(zrhox(nrhox))
  call xplasma_grid(sp,id_rhox,zrhox,ierr)

  call xplasma_RZminmax_extended(sp, &
       Rfastmin,Rfastmax,Zfastmin,Zfastmax, ierr)
  if(ierr.ne.0) return

  allocate(zrho(inum),zchi(inum))
  allocate(zchiv(nrhox))
  allocate(zbuf(inum,4),zbuf2(0:nrhox,2),zdist(0:nrhox))

  !  (R,Z) function nos.

  call xplasma_common_ids(sp,ierr, id_R=ilist(1), id_Z=ilist(2))
  ilist(3)=ilist(1)
  ilist(4)=ilist(2)
  idchis(1)=0; idchis(2)=0
  idchis(3)=1; idchis(4)=1

  !  straddle plasma bdy
  !  this is also done initially for the limiter calculation (itype=2)
  !  in case the limiter is on the plasma bdy

  zdx=min((Rfastmax-Rfastmin),(Zfastmax-Zfastmin))/(10*nchix) ! small step

  do i=1,inum
     zindx=ONE+(i-1)*(nchix-ONE)/(inum)   ! last pt short of 1st pt
     indx=max(1,min((nchix-1),int(zindx)))
     zxchi=max(ZERO,min(ONE,(zindx-indx)))

     zrho(i)=ONE
     zchi(i)=zchix(indx)+zxchi*(zchix(indx+1)-zchix(indx))

  enddo

  call xplasma_RZeval_2d(sp,ilist, &
       xplasma_theta_coord,zchi(1:inum),xplasma_rho_coord,zrho(1:inum), &
       zbuf,ierr, ideriv1s=idchis)

  if(ierr.ne.0) return

  !  zbuf(1:ivec,1):  Rbdy
  !  zbuf(1:ivec,2):  Zbdy
  !  zbuf(1:ivec,3):  dR/dchi
  !  zbuf(1:ivec,4):  dZ/dchi

  do i=1,inum
     znorm=ONE/sqrt(zbuf(i,2)**2+zbuf(i,4)**2)
     ra(i)=zbuf(i,1)-zdx*zbuf(i,4)*znorm
     za(i)=zbuf(i,2)+zdx*zbuf(i,3)*znorm
     da(i)=-zdx
     rb(i)=zbuf(i,1)+zdx*zbuf(i,4)*znorm
     zb(i)=zbuf(i,2)-zdx*zbuf(i,3)*znorm
     db(i)=zdx
  enddo

  if(itype.eq.2) then

     !  limiter spec is known to exist, as it is a prerequisite for 
     !  setting up a scrapeoff region

     imiss=0
     do i=1,inum

        !  find point, along each theta line, to straddle limiter.

        zchiv=zchi(i)
        call xplasma_RZeval_2d(sp,ilist(1:2), &
             xplasma_theta_coord,zchiv,xplasma_rho_coord,zrhox, &
             zbuf2(1:nrhox,1:2),ierr)

        if(ierr.ne.0) return

        !  zbuf2(1:nrhox,1):  R along external theta line
        !  zbuf2(1:nrhox,2):  Z along external theta line

        !  provide an extra point on the inside
        zbuf2(0,1) = 2*zbuf2(1,1) - zbuf2(2,1)
        zbuf2(0,2) = 2*zbuf2(1,2) - zbuf2(2,2)

        call xplasma_lim_distance(sp, zbuf2(0:nrhox,1),zbuf2(0:nrhox,2), &
             zdist(0:nrhox), ierr, maptype=imaptype)

        if(ierr.ne.0) return

        !  find straddling segment-- error if not found.
        !  take first one if more than one.

        ifnd=-1
        do j=0,nrhox-1
           if((zdist(j).le.ZERO).and.(zdist(j+1).gt.ZERO)) then
              if(ifnd.eq.-1) then
                 ifnd=j
                 ra(i)=zbuf2(j,1)
                 za(i)=zbuf2(j,2)
                 da(i)=zdist(j)
                 rb(i)=zbuf2(j+1,1)
                 zb(i)=zbuf2(j+1,2)
                 db(i)=zdist(j+1)
              endif
           endif
        enddo
        if(ifnd.eq.-1) then
           !  use precomputed bdy straddle -- but correct the distances
           call xplasma_lim_distance(sp,ra(i),za(i),da(i),ierr, &
                maptype=imaptype)
           if(ierr.ne.0) return

           call xplasma_lim_distance(sp,rb(i),zb(i),db(i),ierr, &
                maptype=imaptype)
           if(ierr.ne.0) return

           !  verify the straddle

           if(da(i)*db(i).gt.ZERO) then
              imiss=imiss+1         ! record miss
           endif
        endif

     enddo                          ! chi loop

     if(imiss.gt.0) then
        call xplasma_errmsg_append(sp,' ?eqi_bprobe: algorithm failure.')
        call xplasma_errmsg_append(sp,'  failed to straddle limiter everywhere')
        call xplasma_errmsg_append(sp,'  plasma boundary might be crossing the limiter')
        ierr=9999
     endif

  endif                             ! itype

end subroutine eqi_bprobe

subroutine eqm_rzgrid(zR,zZ,iautoR,iautoZ,inumR,inumZ,ztol,id_R,id_Z,ierr)

  !  set up (R,Z) grid to cover plasma and scrape-off layer
  !  *** mechanical boundary must be specified first (eqm_cbdy or eqm_tbdy) ***

  use xplasma_obj_instance
  use eq_module

  !  for R & Z... (iautoR & iautoZ referred to as "iauto" here...)

  !  if iauto=0, use the user specified grid, after order & coverage tests
  !    two rows of "guard points" are added at either end of the R and Z grids
  !  if iauto=-1 the user supplied grids are used verbatim

  !  if iauto=1, use an automatically generated, evenly spaced grid

  !  note:  on each end of each grid, two extra points are tacked on; this
  !  is for the benefit of Akima/Hermite interpolation:  avoidance of grid
  !  boundary effects.

  IMPLICIT NONE

  !  input:

  integer inumR,inumZ               ! #of grid bdy pts for R, Z
  integer iautoR,iautoZ             ! =1 to generate R, Z grids
  REAL*8 zR(inumR),zZ(inumZ)        ! the grids; output if iauto=1.
  REAL*8 ztol                       ! tolerance **defunct -- now ignored**

  integer id_R,id_Z                 ! axis id codes (returned)
  integer ierr                      ! =0: OK

  !-----------------

  integer i,iwarn,itype,iertmp
  integer ista,iinc,istaz,iincz

  real*8 zRuse(-1:inumR+2),zZuse(-1:inumZ+2)
  real*8 :: bdy_Rmin,bdy_Rmax,bdy_Zmin,bdy_Zmax

  integer :: id_lim
  !-------------------------------------------------------------

  !  error checks:

  if(min(inumR,inumZ).lt.10) then
     write(lunerr,*) ' eqm_rzgrid:  inumR=',inumR,' inumZ=',inumZ
     write(lunerr,*) '   a minimum value of  10  is expected for each grid.'
     ierr=1
     return
  endif

  call xplasma_find_item(s,'__LIMITER',id_lim,ierr, nf_noerr=.TRUE.)

  if((id_lim.le.0).and.((iautoR.gt.0).or.(iautoZ.gt.0))) then
     call eq_errmsg(' ?eqm_rzgrid:  specify limiter/wall boundary first:')
     write(lunerr,*) &
          '  ...automatic (R,Z) grid requires prior bdy specification.'
     write(lunerr,*) '  ...see e.g.:  eqm_cbdy or eqm_tbdy subroutines.'
     ierr=1
     return
  endif

  if(max(iautoR,iautoZ).gt.0) then
     call eq_bdlims(itype,bdy_Rmin,bdy_Rmax,bdy_Zmin,bdy_Zmax,iwarn)
  endif

  if(iautoR.gt.0) then
     do i=1,inumR
        zR(i)=bdy_Rmin+(i-1)*(bdy_Rmax-bdy_Rmin)/(inumR-1)
     enddo
  endif

  if(iautoZ.gt.0) then
     do i=1,inumZ
        zZ(i)=bdy_Zmin+(i-1)*(bdy_Zmax-bdy_Zmin)/(inumZ-1)
     enddo
  endif

  ierr=0
  iwarn=0

  if(ierr.gt.0) return

  zRuse(1:inumR)=zR
  zZuse(1:inumZ)=zZ

  zRuse(0)=zRuse(1)-(zRuse(2)-zRuse(1))
  zRuse(-1)=zRuse(1)-ctwo*(zRuse(2)-zRuse(1))
  zZuse(0)=zZuse(1)-(zZuse(2)-zZuse(1))
  zZuse(-1)=zZuse(1)-ctwo*(zZuse(2)-zZuse(1))

  zRuse(inumR+1)=zRuse(inumR)+(zRuse(inumR)-zRuse(inumR-1))
  zRuse(inumR+2)=zRuse(inumR)+ctwo*(zRuse(inumR)-zRuse(inumR-1))
  zZuse(inumZ+1)=zZuse(inumZ)+(zZuse(inumZ)-zZuse(inumZ-1))
  zZuse(inumZ+2)=zZuse(inumZ)+ctwo*(zZuse(inumZ)-zZuse(inumZ-1))

  if(iautoR.ge.0) then

     !  don't use small R guard points if the R value is too low...

     ista=-1
     iinc=2
     if(zRuse(0).lt.0.5*zRuse(1)) then
        ista=1
     else if(zRuse(-1).lt.0.5*zRuse(1)) then
        ista=0
     endif
  else
     !  use the user R vector verbatim

     ista=1
     iinc=0

  endif

  if(iautoZ.ge.0) then

     !  extended Z vector

     istaz=-1
     iincz=2

  else

     !  user Z vector, verbatim

     istaz=1
     iincz=0

  endif

  !  OK, create grids...

  call xoi_author_set(iertmp)

  call xplasma_create_RZgrid(s, &
       zRuse(ista:inumR+iinc),zZuse(istaz:inumZ+iincz),id_R,id_Z,ierr)

  call xoi_author_clear(iertmp)

  if(ierr.ne.0) then

     id_R=0
     id_Z=0

     write(lunerr,*) ' ?eqm_rzgrid: error creating R and/or Z grids: '
     call xplasma_error(s,ierr,lunerr)

     ierr=1
  endif

end subroutine eqm_rzgrid

subroutine eq_rholim(zrho_axis,zrho_bdy)

  !  return the radial coordinate value at:
  !    the magnetic axis (zrho_axis)
  !    the plasma bdy    (zrho_bdy)

  !----------------------------------------------

  IMPLICIT NONE

  REAL*8, intent(out) :: zrho_axis,zrho_bdy

  !----------------------------------------------

  zrho_axis = 0
  zrho_bdy = 1

end subroutine eq_rholim

!================================================================

subroutine eq_rhoxlim(zrho_bdy,zrho_extend)

  use xplasma_obj_instance
  use eq_module

  !  return the external rho range covered (if any)
  !  if none, return (0,0)
  !----------------------------------------------

  IMPLICIT NONE

  REAL*8, intent(out) :: zrho_bdy,zrho_extend
  

  !----------------------------------------------
  integer :: id,ierr
  !----------------------------------------------

  zrho_bdy=0
  zrho_extend=0

  call xplasma_find_item(s,"__RHOX",id,ierr,nf_noerr=.TRUE.)
  if(id.eq.0) return

  zrho_bdy=1
  call xplasma_grid_info(s,id,ierr, xmax=zrho_extend)

end subroutine eq_rhoxlim

!================================================================

subroutine eq_rholima(zrho_axis,zrho_extend)

  use xplasma_obj_instance
  use eq_module

  !  return the rho range covered, including extrapolated region
  !----------------------------------------------

  IMPLICIT NONE

  real*8, intent(out) :: zrho_axis,zrho_extend

  !----------------------------------------------
  real*8 zrho_bdy
  !----------------------------------------------

  call eq_rhoxlim(zrho_bdy,zrho_extend)
  if((zrho_bdy.eq.czero).and.(zrho_extend.eq.czero)) then
     call eq_rholim(zrho_axis,zrho_extend)
  else
     call eq_rholim(zrho_axis,zrho_bdy)
  endif

end subroutine eq_rholima

module xplasma_ctran

  !  methods for defining coordinate transformations
  !    [Cartesian] <--> [Cylindric] <--> [Magnetic Flux Coordinates]

  !  related methods:
  !    magnetic axis location
  !    methods for extrema:  min/max R,Z of chosen flux surfaces

  use xplasma_obj
  implicit NONE

  private

  public :: xplasma_ctran1,xplasma_ctrann,xplasma_ctrans
  public :: xplasma_mag_axis
  public :: xplasma_RZminmax,xplasma_Bminmax
  public :: xplasma_RZminmax_plasma,xplasma_RZminmax_extended
  public :: xplasma_bdfind,xplasma_bdfind1,xplasma_bdfindn
  public :: xplasma_rzjac,xplasma_rzjac1,xplasma_rzjacn
  public :: xplasma_vtaub

  integer, parameter, public :: xp_imap_newton = 1
  integer, parameter, public :: xp_imap_polar = 2
  integer, parameter, public :: xp_imap_rzlinear = 3

  interface xplasma_ctrans

     module procedure xplasma_ctran1   ! scalar
     module procedure xplasma_ctrann   ! vector

  end interface

  interface xplasma_bdfind

     module procedure xplasma_bdfind1   ! scalar
     module procedure xplasma_bdfindn   ! vector

  end interface

  interface xplasma_rzjac

     module procedure xplasma_rzjac1   ! scalar
     module procedure xplasma_rzjacn   ! vector

  end interface

  real*8, parameter :: czero = 0.0d0
  real*8, parameter :: cone = 1.0d0
  real*8, parameter :: c2pi = 6.2831853071795862D+00
  real*8, parameter :: cpi = 3.1415926535897931D+00
  real*8, parameter :: ceps4 = 1.0d-4
  real*8, parameter :: ceps13= 1.0d-13

  contains

    subroutine xplasma_mag_axis(s,ier, raxis,zaxis,baxis)

      ! return mag. axis location (scalar, AXISYMMETRY assumed...)
      ! mod(B) can optionally be returned as well

      type (xplasma), pointer :: s
      integer, intent(out) :: ier

      real*8, intent(out), optional :: raxis,zaxis,baxis

      !------------------------------
      integer :: id_axis,id_R,id_Z,id_g,iertmp
      character*32 elemnames(2),elemlabels(2)
      real*8 elemvals(2),zg
      real*8, parameter :: ZERO = 0.0d0
      !------------------------------

      if(present(raxis)) raxis=0
      if(present(zaxis)) zaxis=0
      if(present(baxis)) baxis=0

      call xplasma_common_ids(s,ier, id_axis=id_axis)
      if(ier.ne.0) return

      if(id_axis.eq.0) then

         !  make the mag. axis list object

         call xplasma_ctrans(s,ier, rho_in=czero,theta_in=czero, &
              r_out=elemvals(1),z_out=elemvals(2))

         if(ier.ne.0) return

         call xplasma_author_set(s,xplasma_xmhd,iertmp)

         elemnames(1)='Raxis'
         elemnames(2)='Zaxis'

         elemlabels(1)='R of magnetic axis'
         elemlabels(2)='Z of magnetic axis'

         call xplasma_create_list(s,"MAG_AXIS", &
              elemnames,id_axis,ier, &
              label='magnetic axis location', units='m', &
              r8vals=elemvals, chvals=elemlabels)

         call xplasma_author_clear(s,xplasma_xmhd,iertmp)

      else
         
         call xplasma_getList(s,id_axis,elemvals,ier)

      endif

      if(ier.eq.0) then
         if(present(raxis)) raxis=elemvals(1)
         if(present(zaxis)) zaxis=elemvals(2)
         if(present(baxis)) then
            call xplasma_common_ids(s,ier,id_g=id_g)
            if(ier.eq.0) then
               call xplasma_eval_prof(s,id_g,ZERO,zg,ier)
               baxis=zg/elemvals(1)
            endif
         endif
      endif

    end subroutine xplasma_mag_axis

    !======================================================================
    subroutine xplasma_ctran1(s,ier, &
         x_in,y_in,z_in, r_in,phi_in, rho_in,theta_in, &
         tol, maptype, ccw_theta,ccw_phi, i2pi, &
         x_out,y_out,z_out, r_out,phi_out, rho_out,theta_out, &
         nregion,cosphi,sinphi)

      ! SCALAR coordinate mapping interface

      type (xplasma), pointer :: s
      integer, intent(out) :: ier   ! completion code 0=OK

      !------------------------
      ! optional inputs...

      real*8, intent(in), optional :: x_in,y_in,z_in  ! Cartesian Coords in
      real*8, intent(in), optional :: r_in,phi_in   ! Cylindric Coords (z also)
      real*8, intent(in), optional :: rho_in,theta_in ! Flux Coords (phi also)

      !------------------------------------------------------------
      ! the following applies to (R,Z) -> (rho,theta) "inverse" map:

      real*8, intent(in), optional :: tol           ! map tolerance
      
      ! tol applies to Newton map (maptype = xp_imap_newton = default) ONLY

      ! (R_in,Z_in)->(rho_out,theta_out): 
      !         |R_in-R(rho_out,theta_out)| < tol*max(R_in,|Z_in|) 
      !         |Z_in-Z(rho_out,theta_out)| < tol*max(R_in,|Z_in|) 
      ! default: s%bdytol

      integer, intent(in), optional :: maptype

      !  = 1 = xp_imap_newton = default -- iterative Newton root finder
      !        with initial guess generator using polar map (slowest but 
      !        most accurate, accuracy can be controlled with tol.
      !  = 2 = xp_imap_polar -- polar map inversion method
      !        much faster, not as accurate as Newton map
      !  = 3 = xp_imap_rzlinear -- bilinear inverse map -- after 
      !        initialization (using polar map), the fastest, but less
      !        accurate still (depends on R,Z grid resolution).  This 
      !        method requires a user defined (R,Z) rectangle grid; if 
      !        none is available the polar map is used instead.

      !------------------------------------------------------------

      logical, intent(in), optional :: ccw_phi  ! Phi CCW view from above, default=T
      logical, intent(in), optional :: ccw_theta ! Theta CCW in poloidal plane, default=T

      integer, intent(in), optional :: i2pi ! angle coord normalization options
      !  i2pi=1 (default) returned value in range [0,2pi]
      !  i2pi=2 returned value in range [-pi,pi]

      !-------------------------
      ! optional outputs...

      real*8, intent(out), optional :: x_out,y_out,z_out  ! Cartesian Coords in
      real*8, intent(out), optional :: r_out,phi_out   ! Cyl. Coords (z also)
      real*8, intent(out), optional :: rho_out,theta_out ! Flux Coords (phi also)
      real*8, intent(out), optional :: cosphi,sinphi   ! phi sin & cos
      integer, intent(out), optional :: nregion        ! region code
      ! 0=not checked; 1=inside core plasma; 2=outside plasma but inside
      ! mapped region; 3=beyond mapped region.

      !-----------------
      logical :: car_in,cyl_in,flx_in
      logical :: car_out,cyl_out,flx_out
      integer :: intypes_in,intypes_out
      logical :: jccw_phi,jccw_theta

      logical :: car2cyl,cyl2flx
      logical :: flx2cyl,cyl2car

      logical :: sol
      integer :: imap_type

      real*8 :: ztol
      real*8 :: xv(1),yv(1),zv(1),rv(1),phiv(1),rhov(1),thetav(1)
      integer :: iregion(1),j2pi

      integer :: id_R,id_Z
      !-----------------

      !  clear outputs as needed

      ier = 0
      if(present(x_out)) x_out = 0
      if(present(y_out)) y_out = 0
      if(present(z_out)) z_out = 0

      if(present(r_out)) r_out = 0
      if(present(phi_out)) phi_out = 0

      if(present(rho_out)) rho_out = 0
      if(present(theta_out)) theta_out = 0

      !  set CCW flags & tolerance

      jccw_phi=.TRUE.
      jccw_theta=.TRUE.
      if(present(ccw_phi)) jccw_phi=ccw_phi
      if(present(ccw_theta)) jccw_theta=ccw_theta

      imap_type=xp_imap_newton

      call xplasma_global_info(s,ier, scrapeoff=sol)
      if(present(maptype)) then
         if(sol) then
            imap_type=max(xp_imap_newton,min(xp_imap_rzlinear,maptype))
         else
            imap_type=max(xp_imap_newton,min(xp_imap_polar,maptype))
         endif
      endif

      call xplasma_global_info(s,ier, bdytol=ztol)
      if(ier.ne.0) return
      if(present(tol)) ztol=tol
      ztol=max(ceps13,min(ceps4,ztol))

      j2pi=1
      if(present(i2pi)) j2pi=i2pi

      !  check input-- must be from just one of the three possible
      !  coordinate systems.

      !  check output-- there must be some output.

      car_in = .FALSE.
      cyl_in = .FALSE.
      flx_in = .FALSE.

      car_out = .FALSE.
      cyl_out = .FALSE.
      flx_out = .FALSE.

      if(present(x_in).or.present(y_in)) car_in = .TRUE.
      if(present(R_in)) cyl_in = .TRUE.
      if(present(rho_in).or.present(theta_in)) flx_in = .TRUE.

      if((.not.car_in).and.(.not.cyl_in)) then
         if(present(z_in)) cyl_in=.TRUE.
      endif

      if((.not.cyl_in).and.(.not.flx_in)) then
         if(present(phi_in)) cyl_in=.TRUE.
      endif

      if(present(x_out).or.present(y_out)) car_out = .TRUE.
      if(present(R_out)) cyl_out = .TRUE.
      if(present(rho_out).or.present(theta_out)) flx_out = .TRUE.

      if((.not.car_out).and.(.not.cyl_out)) then
         if(present(z_out)) cyl_out=.TRUE.
      endif

      if((.not.cyl_out).and.(.not.flx_out)) then
         if(present(phi_out)) cyl_out=.TRUE.
      endif

      intypes_in = 0
      intypes_out = 0
      if(car_in) then
         intypes_in = intypes_in + 1
         if(cyl_out) intypes_out = intypes_out + 1
         if(flx_out) intypes_out = intypes_out + 1
      endif

      if(cyl_in) then
         intypes_in = intypes_in + 1
         if(car_out) intypes_out = intypes_out + 1
         if(flx_out) intypes_out = intypes_out + 1
      endif

      if(flx_in) then
         intypes_in = intypes_in + 1
         if(cyl_out) intypes_out = intypes_out + 1
         if(car_out) intypes_out = intypes_out + 1
      endif

      if(intypes_in.gt.1) then

         ier=2501

      else if(intypes_out.eq.0) then

         ier=2502

      endif

      if(ier.gt.0) then

         if(car_in) call xplasma_errmsg_append(s, &
              '  cartesian coordinate inputs {x,y,z} detected.')

         if(cyl_in) call xplasma_errmsg_append(s, &
              '  cylindrical coordinate inputs {R,phi,Z} detected.')

         if(flx_in) call xplasma_errmsg_append(s, &
              '  flux coordinate inputs {rho,phi,theta} detected.')

         return

      endif

      !-------------------------------
      ! most error checks done.  See what transforms are needed...

      car2cyl=.FALSE.
      cyl2flx=.FALSE.

      flx2cyl=.FALSE.
      cyl2car=.FALSE.
      
      if(car_in) then
         car2cyl=.TRUE.
         if(flx_out) cyl2flx=.TRUE.
      endif

      if(flx_in) then
         flx2cyl=.TRUE.
         if(car_out) cyl2car=.TRUE.
      endif

      if(cyl_in) then
         if(car_out) cyl2car=.TRUE.
         if(flx_out) cyl2flx=.TRUE.
      endif

      id_R=0; id_Z=0
      if(cyl2flx.or.flx2cyl) then
         call xplasma_common_ids(s,ier,id_R=id_R,id_Z=id_Z)
         if(min(id_R,id_Z).eq.0) then

            ier=2504  ! no flux surfaces...
            return

         endif
      endif

      !-------------------------
      ! load working variables...

      if(car_in) then
         if(present(x_in)) then
            xv(1)=x_in
         else
            xv(1)=0
         endif
         if(present(y_in)) then
            yv(1)=y_in
         else
            yv(1)=0
         endif
         if(present(z_in)) then
            zv(1)=z_in
         else
            zv(1)=0
         endif
      endif

      if(cyl_in) then
         if(present(r_in)) then
            rv(1)=r_in
         else
            rv(1)=0
         endif
         if(present(phi_in)) then
            phiv(1)=phi_in
         else
            phiv(1)=0
         endif
         if(present(z_in)) then
            zv(1)=z_in
         else
            zv(1)=0
         endif
      endif

      if(flx_in) then
         if(present(rho_in)) then
            rhov(1)=rho_in
         else
            rhov(1)=0
         endif
         if(present(phi_in)) then
            phiv(1)=phi_in
         else
            phiv(1)=0
         endif
         if(present(theta_in)) then
            thetav(1)=theta_in
         else
            thetav(1)=0
         endif
      endif


      !-------------------------
      ! compute transformations
      
      call trans(s,id_R,id_Z,car2cyl,cyl2flx,flx2cyl,cyl2car, &
           xv,yv,zv,rv,phiv,rhov,thetav,ztol,imap_type, &
           iregion,jccw_theta,jccw_phi,j2pi, ier)

      !-------------------------
      ! copy results to output

      if(present(nregion)) nregion=iregion(1)

      if(car_out) then
         if(present(x_out)) x_out=xv(1)
         if(present(y_out)) y_out=yv(1)
         if(present(z_out)) z_out=zv(1)
      endif

      if(cyl_out) then
         if(present(r_out)) r_out=rv(1)
         if(present(phi_out)) phi_out=phiv(1)
         if(present(z_out)) z_out=zv(1)
      endif

      if(flx_out) then
         if(present(rho_out)) rho_out=rhov(1)
         if(present(phi_out)) phi_out=phiv(1)
         if(present(theta_out)) theta_out=thetav(1)
      endif

      if(present(cosphi)) cosphi = cos(phiv(1))
      if(present(sinphi)) sinphi = sin(phiv(1))

    end subroutine xplasma_ctran1

    !======================================================================
    subroutine xplasma_ctrann(s,vsize_flag,ier, &
         isize, &
         x_in,y_in,z_in, r_in,phi_in, rho_in,theta_in, &
         tol, maptype, ccw_theta,ccw_phi, i2pi, &
         x_out,y_out,z_out, r_out,phi_out, rho_out,theta_out, &
         nregion,cosphi,sinphi)

      !  VECTOR coordinate mapping interface

      type (xplasma), pointer :: s
      logical, intent(in) :: vsize_flag  ! vector size flag
      !  .TRUE. means size is to be inferred from passed vector sizes,
      !  all of which must match;
      !  .FALSE. means size is to be set by optional argument "isize";
      !  all vectors must size.ge.isize then.

      integer, intent(out) :: ier   ! completion code 0=OK

      !------------------------
      ! optional inputs...

      integer, intent(in), optional :: isize  ! vector size if(vsize_flag)

      real*8, intent(in), dimension(:), optional :: x_in,y_in,z_in  ! Cartesian Coords in
      real*8, intent(in), dimension(:), optional :: r_in,phi_in   ! Cylindric Coords (z also)
      real*8, intent(in), dimension(:), optional :: rho_in,theta_in ! Flux Coords (phi also)

      !------------------------------------------------------------
      ! the following applies to (R,Z) -> (rho,theta) "inverse" map:

      real*8, intent(in), optional :: tol           ! map tolerance
      
      ! tol applies to Newton map (maptype = xp_imap_newton = default) ONLY

      ! (R_in,Z_in)->(rho_out,theta_out): 
      !         |R_in-R(rho_out,theta_out)| < tol*max(R_in,|Z_in|) 
      !         |Z_in-Z(rho_out,theta_out)| < tol*max(R_in,|Z_in|) 
      ! default: s%bdytol; s%bdytol's own default value is 1.0d-10

      integer, intent(in), optional :: maptype

      !  = 1 = xp_imap_newton = default -- iterative Newton root finder
      !        with initial guess generator using polar map (slowest but 
      !        most accurate, accuracy can be controlled with tol.
      !  = 2 = xp_imap_polar -- polar map inversion method
      !        much faster, not as accurate as Newton map
      !  = 3 = xp_imap_rzlinear -- bilinear inverse map -- after 
      !        initialization (using polar map), the fastest, but less
      !        accurate still (depends on R,Z grid resolution).  This 
      !        method requires a user defined (R,Z) rectangle grid; if 
      !        none is available the polar map is used instead.

      !------------------------------------------------------------

      logical, intent(in), optional :: ccw_phi  ! Phi CCW view from above, default=T
      logical, intent(in), optional :: ccw_theta ! Theta CCW in poloidal plane, default=T

      integer, intent(in), optional :: i2pi ! angle coord normalization options
      !  i2pi=1 (default) returned value in range [0,2pi]
      !  i2pi=2 returned value in range [-pi,pi]

      !-------------------------
      ! optional outputs...

      real*8, intent(out), dimension(:), optional :: x_out,y_out,z_out  ! Cartesian Coords in
      real*8, intent(out), dimension(:), optional :: r_out,phi_out   ! Cyl. Coords (z also)
      real*8, intent(out), dimension(:), optional :: rho_out,theta_out ! Flux Coords (phi also)

      real*8, intent(out), dimension(:), optional :: cosphi,sinphi   ! phi sin & cos
      integer, intent(out), dimension(:), optional :: nregion        ! region code
      ! 0=not checked; 1=inside core plasma; 2=outside plasma but inside
      ! mapped region; 3=beyond mapped region.

      !-----------------
      logical :: car_in,cyl_in,flx_in
      logical :: car_out,cyl_out,flx_out
      integer :: intypes_in,intypes_out,isize_min,isize_max,j2pi,jsize
      logical :: jccw_phi,jccw_theta
      character*80 zmsg

      logical :: car2cyl,cyl2flx
      logical :: flx2cyl,cyl2car

      logical :: sol
      integer :: imap_type

      real*8 :: ztol
      real*8, dimension(:), allocatable :: xv,yv,zv,rv,phiv,rhov,thetav
      integer, dimension(:), allocatable :: iregion

      integer :: id_R,id_Z
      !-----------------

      !  clear outputs as needed

      ier = 0
      if(present(x_out)) x_out = 0
      if(present(y_out)) y_out = 0
      if(present(z_out)) z_out = 0

      if(present(r_out)) r_out = 0
      if(present(phi_out)) phi_out = 0

      if(present(rho_out)) rho_out = 0
      if(present(theta_out)) theta_out = 0

      !  set CCW flags & ztol

      jccw_phi=.TRUE.
      jccw_theta=.TRUE.
      if(present(ccw_phi)) jccw_phi=ccw_phi
      if(present(ccw_theta)) jccw_theta=ccw_theta


      imap_type=xp_imap_newton

      call xplasma_global_info(s,ier, scrapeoff=sol)
      if(present(maptype)) then
         if(sol) then
            imap_type=max(xp_imap_newton,min(xp_imap_rzlinear,maptype))
         else
            imap_type=max(xp_imap_newton,min(xp_imap_polar,maptype))
         endif
      endif

      call xplasma_global_info(s,ier, bdytol=ztol)
      if(ier.ne.0) return
      if(present(tol)) ztol=tol
      ztol=max(ceps13,min(ceps4,ztol))

      j2pi=1
      if(present(i2pi)) j2pi=i2pi

      !  check input-- must be from just one of the three possible
      !  coordinate systems.

      !  check output-- there must be some output.

      car_in = .FALSE.
      cyl_in = .FALSE.
      flx_in = .FALSE.

      car_out = .FALSE.
      cyl_out = .FALSE.
      flx_out = .FALSE.

      if(present(x_in).or.present(y_in)) car_in = .TRUE.
      if(present(R_in)) cyl_in = .TRUE.
      if(present(rho_in).or.present(theta_in)) flx_in = .TRUE.

      if((.not.car_in).and.(.not.cyl_in)) then
         if(present(z_in)) cyl_in=.TRUE.
      endif

      if((.not.cyl_in).and.(.not.flx_in)) then
         if(present(phi_in)) cyl_in=.TRUE.
      endif

      if(present(x_out).or.present(y_out)) car_out = .TRUE.
      if(present(R_out)) cyl_out = .TRUE.
      if(present(rho_out).or.present(theta_out)) flx_out = .TRUE.

      if((.not.car_out).and.(.not.cyl_out)) then
         if(present(z_out)) cyl_out=.TRUE.
      endif

      if((.not.cyl_out).and.(.not.flx_out)) then
         if(present(phi_out)) cyl_out=.TRUE.
      endif

      intypes_in = 0
      intypes_out = 0
      if(car_in) then
         intypes_in = intypes_in + 1
         if(cyl_out) intypes_out = intypes_out + 1
         if(flx_out) intypes_out = intypes_out + 1
      endif

      if(cyl_in) then
         intypes_in = intypes_in + 1
         if(car_out) intypes_out = intypes_out + 1
         if(flx_out) intypes_out = intypes_out + 1
      endif

      if(flx_in) then
         intypes_in = intypes_in + 1
         if(cyl_out) intypes_out = intypes_out + 1
         if(car_out) intypes_out = intypes_out + 1
      endif

      if(intypes_in.gt.1) then

         ier=2501

      else if(intypes_out.eq.0) then

         ier=2502

      endif

      if(ier.gt.0) then

         if(car_in) call xplasma_errmsg_append(s, &
              '  cartesian coordinate inputs {x,y,z} detected.')

         if(cyl_in) call xplasma_errmsg_append(s, &
              '  cylindrical coordinate inputs {R,phi,Z} detected.')

         if(flx_in) call xplasma_errmsg_append(s, &
              '  flux coordinate inputs {rho,phi,theta} detected.')

         return

      endif

      !  check sizes of input vectors...

      isize_min=999999999
      isize_max=0

      if(car_in) then
         if(present(x_in)) call ssize(x_in,isize_min,isize_max)
         if(present(y_in)) call ssize(y_in,isize_min,isize_max)
         if(present(z_in)) call ssize(z_in,isize_min,isize_max)
      endif

      if(cyl_in) then
         if(present(R_in)) call ssize(R_in,isize_min,isize_max)
         if(present(phi_in)) call ssize(phi_in,isize_min,isize_max)
         if(present(Z_in)) call ssize(Z_in,isize_min,isize_max)
      endif

      if(flx_in) then
         if(present(rho_in)) call ssize(rho_in,isize_min,isize_max)
         if(present(phi_in)) call ssize(phi_in,isize_min,isize_max)
         if(present(theta_in)) call ssize(theta_in,isize_min,isize_max)
      endif

      if(present(x_out)) call ssize(x_out,isize_min,isize_max)
      if(present(y_out)) call ssize(y_out,isize_min,isize_max)
      if(present(z_out)) call ssize(z_out,isize_min,isize_max)

      if(present(r_out)) call ssize(r_out,isize_min,isize_max)
      if(present(phi_out)) call ssize(phi_out,isize_min,isize_max)
      if(present(cosphi)) call ssize(cosphi,isize_min,isize_max)
      if(present(sinphi)) call ssize(sinphi,isize_min,isize_max)

      if(present(rho_out)) call ssize(rho_out,isize_min,isize_max)
      if(present(theta_out)) call ssize(theta_out,isize_min,isize_max)

      if(present(nregion)) then
         isize_min=min(isize_min,size(nregion))
         isize_max=max(isize_max,size(nregion))
      endif

      jsize=isize_min
      if(.not.vsize_flag) then
         if(present(isize)) then
            jsize=isize
            if(isize_min.lt.jsize) then

               ier=2503
               zmsg=' '
               write(zmsg,*) ' ?xplasma_ctrann: isize argument: ', &
                    jsize,'; min vector size:',isize_min
               call xplasma_errmsg_append(s,zmsg)
            endif
         else
            ier=2503
            zmsg=' '
            write(zmsg,*) ' ?xplasma_ctrann: vsize_flag=.FALSE., but ', &
                 'argument "isize" was not provided.'
            call xplasma_errmsg_append(s,zmsg)
         endif

      else if(vsize_flag) then
         if(isize_min.ne.isize_max) then
            ier=2503
            zmsg=' '
            write(zmsg,*) ' vsize_flag=.TRUE. but input vector sizes ', &
                 'do not match: min, max = ',isize_min, isize_max
            call xplasma_errmsg_append(s,zmsg)
         endif
      endif

      if(ier.ne.0) return

      !-------------------------------
      ! most error checks done.  See what transforms are needed...

      car2cyl=.FALSE.
      cyl2flx=.FALSE.

      flx2cyl=.FALSE.
      cyl2car=.FALSE.
      
      if(car_in) then
         car2cyl=.TRUE.
         if(flx_out) cyl2flx=.TRUE.
      endif

      if(flx_in) then
         flx2cyl=.TRUE.
         if(car_out) cyl2car=.TRUE.
      endif

      if(cyl_in) then
         if(car_out) cyl2car=.TRUE.
         if(flx_out) cyl2flx=.TRUE.
      endif

      id_R=0; id_Z=0
      if(cyl2flx.or.flx2cyl) then
         call xplasma_common_ids(s,ier,id_R=id_R,id_Z=id_Z)
         if(min(id_R,id_Z).eq.0) then

            ier=2504  ! no flux surfaces...
            return

         endif
      endif

      !-------------------------
      ! load working variables...
      if(allocated(iregion)) deallocate(iregion)
      if(allocated(xv)) deallocate(xv)
      if(allocated(yv)) deallocate(yv)
      if(allocated(zv)) deallocate(zv)
      if(allocated(rv)) deallocate(rv)
      if(allocated(phiv)) deallocate(phiv)
      if(allocated(rhov)) deallocate(rhov)
      if(allocated(thetav)) deallocate(thetav)
      allocate(iregion(jsize),xv(jsize),yv(jsize),zv(jsize), &
           rv(jsize),phiv(jsize),rhov(jsize),thetav(jsize))

      if(car_in) then
         if(present(x_in)) then
            xv=x_in(1:jsize)
         else
            xv=0
         endif
         if(present(y_in)) then
            yv=y_in(1:jsize)
         else
            yv=0
         endif
         if(present(z_in)) then
            zv=z_in(1:jsize)
         else
            zv=0
         endif
      endif

      if(cyl_in) then
         if(present(r_in)) then
            rv=r_in(1:jsize)
         else
            rv=0
         endif
         if(present(phi_in)) then
            phiv=phi_in(1:jsize)
         else
            phiv=0
         endif
         if(present(z_in)) then
            zv=z_in(1:jsize)
         else
            zv=0
         endif
      endif

      if(flx_in) then
         if(present(rho_in)) then
            rhov=rho_in(1:jsize)
         else
            rhov=0
         endif
         if(present(phi_in)) then
            phiv=phi_in(1:jsize)
         else
            phiv=0
         endif
         if(present(theta_in)) then
            thetav=theta_in(1:jsize)
         else
            thetav=0
         endif
      endif


      !-------------------------
      ! compute transformations
      
      call trans(s,id_R,id_Z,car2cyl,cyl2flx,flx2cyl,cyl2car, &
           xv,yv,zv,rv,phiv,rhov,thetav,ztol,imap_type, &
           iregion,jccw_theta,jccw_phi,j2pi, ier)

      !-------------------------
      ! copy results to output

      if(present(nregion)) nregion(1:jsize)=iregion

      if(car_out) then
         if(present(x_out)) x_out(1:jsize)=xv
         if(present(y_out)) y_out(1:jsize)=yv
         if(present(z_out)) z_out(1:jsize)=zv
      endif

      if(cyl_out) then
         if(present(r_out)) r_out(1:jsize)=rv
         if(present(phi_out)) phi_out(1:jsize)=phiv
         if(present(z_out)) z_out(1:jsize)=zv
      endif


      if(flx_out) then
         if(present(rho_out)) rho_out(1:jsize)=rhov
         if(present(phi_out)) phi_out(1:jsize)=phiv
         if(present(theta_out)) theta_out(1:jsize)=thetav
      endif

      if(present(cosphi)) cosphi(1:jsize) = cos(phiv)
      if(present(sinphi)) sinphi(1:jsize) = sin(phiv)

      contains
        subroutine ssize(r8vec,isize_min,isize_max)
          real*8, dimension(:), intent(in) :: r8vec
          integer, intent(inout) :: isize_min,isize_max
          integer :: jsize

          jsize=size(r8vec)
          isize_min=min(isize_min,jsize)
          isize_max=max(isize_max,jsize)

        end subroutine ssize

    end subroutine xplasma_ctrann

    !--------------------------------------------------------------------
    !--------------------------------------------------------------------

    subroutine trans(s,id_R,id_Z,car2cyl,cyl2flx,flx2cyl,cyl2car, &
         xv,yv,zv,rv,phiv,rhov,thetav,tol,maptype, &
         iregion,jccw_theta,jccw_phi,j2pi,ier)

      ! **private**
      ! coord transform routine, almost no error checking...

      type(xplasma), pointer :: s
      integer, intent(in) :: id_R,id_Z  ! R(rho,theta) & Z(rho,theta)

      ! flags selecting which transforms to evaluate:
      logical, intent(in) :: car2cyl    
      logical, intent(in) :: cyl2flx
      logical, intent(in) :: flx2cyl
      logical, intent(in) :: cyl2car

      ! coord transform working variables -- mix of input and output depending
      ! on switch settings; all the same size...

      real*8, dimension(:) :: xv,yv,zv,rv,phiv,rhov,thetav

      ! inverse map tolerance

      real*8, intent(in) :: tol
      integer, intent(in) :: maptype  ! type of (R,Z)->(rho,theta) inv. map.

      ! location flag

      integer, intent(out), dimension(:) :: iregion

      ! CCW transforms for angle variables

      logical, intent(in) :: jccw_theta,jccw_phi

      ! range options for angle variables

      integer, intent(in) :: j2pi

      ! completion code -- only set on failure of convergence of inverse
      ! map (generally indicates invalid flux surface geometry)

      integer, intent(out) :: ier

      !--------------------------------------------------
      real*8, dimension(:,:),allocatable :: wkv
      integer :: ii,ids(2)
      !--------------------------------------------------
      
      ier=0
      iregion=0

      if(car2cyl) then

         ! Cartesian -> Cylindrical

         rv = sqrt(xv**2 + yv**2)
         where(rv.eq.czero)
            phiv=czero
         end where
         where(rv.gt.czero)
            phiv = atan2(yv,xv)
         end where

         call angle_trans(phiv,xplasma_phi_coord,jccw_phi,j2pi)

      endif

      if(cyl2flx) then

         if(.not.car2cyl) call angle_trans( &
              phiv,xplasma_phi_coord,jccw_phi,j2pi)

         call cyl2flx_exec(s,rv,phiv,zv,rhov,thetav,tol,maptype,iregion,ier)
         if(ier.ne.0) return

         call angle_trans(thetav,xplasma_theta_coord,jccw_theta,j2pi)
      endif

      if(flx2cyl) then

         call angle_trans(thetav,xplasma_theta_coord,jccw_theta,j2pi)
         call angle_trans(phiv,xplasma_phi_coord,jccw_phi,j2pi)

         ids(1)=id_R
         ids(2)=id_Z

         allocate(wkv(size(rv),2))

         call xplasma_RZeval_2d(s,ids, &
              xplasma_theta_coord,thetav,xplasma_rho_coord,rhov,wkv,ier, &
              force_bounds=.TRUE.)

         rv=wkv(1:size(rv),1)
         zv=wkv(1:size(rv),2)

         deallocate(wkv)

         do ii=1,size(rhov)
            if(rhov(ii).lt.czero) then
               iregion(ii)=5
            else if(rhov(ii).gt.cone) then
               iregion(ii)=4  ! ** refine this **
            else
               iregion(ii)=1
            endif
         enddo

      endif

      if(cyl2car) then
         if(.not.flx2cyl) call angle_trans( &
              phiv,xplasma_phi_coord,jccw_phi,j2pi)

         xv = rv*cos(phiv)
         yv = rv*sin(phiv)

      endif

    end subroutine trans

    subroutine angle_trans(zangl,jcoord,jccw,j2pi)

      type (xplasma), pointer :: s
      real*8, dimension(:) :: zangl  ! angle with range to be normalized...
      integer :: jcoord              ! coordinate id (not currently used)
      logical :: jccw                ! CCW option
      integer :: j2pi                ! range option

      !-------------------
      real*8 :: amin,amax
      integer :: ii,icyc,icheck
      !-------------------

      if((j2pi.le.1).or.(j2pi.gt.2)) then
         amin=czero
         amax=c2pi

      else if(j2pi.eq.2) then
         amin=-cpi
         amax=+cpi

      endif

      do ii=1,size(zangl)

         if(zangl(ii).lt.amin) then
            icyc=(amax-zangl(ii))/c2pi
            zangl(ii)=zangl(ii)+icyc*c2pi
            icheck=1

         else if(zangl(ii).gt.amax) then
            icyc=(zangl(ii)-amin)/c2pi
            zangl(ii)=zangl(ii)-icyc*c2pi
            icheck=1

         else
            icheck=0  ! in range now
         endif

         if(icheck.eq.1) then
            if(zangl(ii).lt.amin) then
               do
                  zangl(ii)=zangl(ii)+c2pi
                  if(zangl(ii).ge.amin) exit
               enddo

            else if(zangl(ii).gt.amax) then
               do 
                  zangl(ii)=zangl(ii)-c2pi
                  if(zangl(ii).le.amax) exit
               enddo
            endif
         endif

         ! now in range...

         if(.not.jccw) then
            zangl(ii)=amax-(zangl(ii)-amin)
         endif

      enddo

    end subroutine angle_trans

    subroutine cyl2flx_exec(s,rv,phiv,zv,rhov,thetav,tol,maptype,iregion,ier)

      use eqi_rzbox_module

      ! *private*
      ! generate initial guess of flux coords (rhov,thetav) corresponding to
      ! real space locations (rv,zv).

      ! then...
      ! refine solution of flux coords (rhov,thetav) corresponding to
      ! real space locations (rv,zv), such that the R & Z of the flux
      ! coordinates returned are within tol*[R of mag. axis] of the
      ! original input values (where possible -- i.e. for all elements
      ! of (rv,zv) in the mapped region.

      ! array dimensions have been set but individual elements of (rv,zv)
      ! could be out of range.

      type(xplasma), pointer :: s

      real*8, dimension(:) :: rv,phiv,zv
      real*8, dimension(:) :: rhov,thetav
      real*8, intent(in) :: tol      ! relative accuracy tolerance
      integer, intent(in) :: maptype ! type of (R,Z)->(rho,theta) map
      integer, dimension(:) :: iregion
      integer, intent(out) :: ier

      !------------------------
      real*8, dimension(:,:), allocatable :: r_orig,z_orig
      real*8 :: rtol,reltol,raxis,zaxis
      real*8, parameter :: czero = 0.0d0
      !------------------------

      !  Method of generating initial guess depends on whether there is
      !  a scrape off layer (SOL) or not...

      sp => s

      if(maptype.eq.xp_imap_rzlinear) then

         call eqi_fastinv(size(rv),rv,zv,phiv,czero,rhov,thetav,iregion,ier)

      else

         iregion=0
         call xplasma_rhoth_inv(s,rv,zv,rhov,thetav,iregion,ier)

      endif
      if(maptype.ne.xp_imap_newton) return

      call xplasma_mag_axis(s,ier, raxis, zaxis)
      if(ier.ne.0) return

      reltol = max(ceps13,min(ceps4,tol))
      rtol = reltol*raxis

      call eqi_inv(size(rv),rv,zv,phiv,reltol,rtol, &
           rhov,thetav,iregion,ier)

    end subroutine cyl2flx_exec

    subroutine xplasma_RZminmax_extended(s, rmin,rmax, zmin,zmax, ier, &
         sol, id_Rgrid, id_Zgrid)

      !  return the R & Z min & max of the extended mapped region; if
      !  there is no such region return the R & Z min & max of the
      !  plasma

      type(xplasma), pointer :: s

      real*8, intent(out) :: Rmin,Rmax
      real*8, intent(out) :: Zmin,Zmax

      integer, intent(out) :: ier

      !----------------------

      logical, intent(out), optional :: sol  ! T if scrape off layer defined
      integer, intent(out), optional :: id_Rgrid,id_Zgrid ! SOL grid ids

      !-------------------------------------
      logical :: isol
      integer :: jd_Rgrid,jd_Zgrid
      real*8, parameter :: zrho_bdy = 1.0d0
      !-------------------------------------

      rmin=0
      rmax=0
      zmin=0
      zmax=0
      if(present(id_Rgrid)) id_Rgrid = 0
      if(present(id_Zgrid)) id_Zgrid = 0

      call xplasma_global_info(s,ier, scrapeoff=isol)
      if(present(sol)) sol = isol
      if(ier.ne.0) return

      if(.not.isol) then

         call xplasma_RZminmax(s,zrho_bdy,ier, &
              rmin=Rmin,rmax=Rmax, zmin=Zmin,zmax=Zmax)

      else

         call xplasma_find_item(s,'__Rgrid',jd_Rgrid,ier, nf_noerr=.TRUE.)
         if(ier.ne.0) return
         if(present(id_Rgrid)) id_Rgrid=jd_Rgrid

         call xplasma_find_item(s,'__Zgrid',jd_Zgrid,ier, nf_noerr=.TRUE.)
         if(ier.ne.0) return
         if(present(id_Zgrid)) id_Zgrid=jd_Rgrid

         call xplasma_grid_info(s,jd_Rgrid,ier, xmin=rmin,xmax=rmax)
         call xplasma_grid_info(s,jd_Zgrid,ier, xmin=zmin,xmax=zmax)
      endif

    end subroutine xplasma_RZminmax_extended

    subroutine xplasma_RZminmax_plasma(s, rmin,rmax, zmin,zmax, ier, &
         ccw_theta,i2pi, thRmin,thRmax, thZmin,thZmax)

      !  return the plasma boundary R & Z min & max

      type(xplasma), pointer :: s

      real*8, intent(out) :: Rmin,Rmax
      real*8, intent(out) :: Zmin,Zmax

      integer, intent(out) :: ier

      !  optionally return the poloidal angle locations

      logical, intent(in), optional :: ccw_theta ! Theta CCW in poloidal plane, default=T

      integer, intent(in), optional :: i2pi ! angle coord normalization options
      !  i2pi=1 (default) returned value in range [0,2pi]
      !  i2pi=2 returned value in range [-pi,pi]

      real*8, intent(out), optional :: thRmin,thRmax
      real*8, intent(out), optional :: thZmin,thZmax

      !-------------------------------------
      real*8, parameter :: zrho_bdy = 1.0d0
      !-------------------------------------

      call xplasma_RZminmax(s,zrho_bdy,ier, &
           rmin=Rmin,rmax=Rmax, zmin=Zmin,zmax=Zmax, &
           ccw_theta=ccw_theta,i2pi=i2pi, &
           thRmin=thRmin,thRmax=thRmax, thZmin=thZmin,thZmax=thZmax)

    end subroutine xplasma_RZminmax_plasma

    subroutine xplasma_RZminmax(s,rho,ier, phi, &
         ccw_theta,i2pi, &
         rmin,rmax, zmin,zmax, &
         thRmin,thRmax, thZmin,thZmax)

      use eqi_rzbox_module

      !  very accurately determine Rmin/max, Zmin/max of a flux surface.

      type (xplasma), pointer :: s
      real*8, intent(in) :: rho       ! required input: flux surface.
      integer, intent(out) :: ier     ! completion code

      real*8, intent(in), optional :: phi   ! toroidal angle location

      real*8, intent(out), optional :: rmin,rmax  ! Rmin & Rmax of surface
      real*8, intent(out), optional :: zmin,zmax  ! Zmin & Zmax of surface

      !  optionally return the poloidal angle locations

      logical, intent(in), optional :: ccw_theta ! Theta CCW in poloidal plane, default=T

      integer, intent(in), optional :: i2pi ! angle coord normalization options
      !  i2pi=1 (default) returned value in range [0,2pi]
      !  i2pi=2 returned value in range [-pi,pi]

      real*8, intent(out), optional :: thRmin,thRmax
      real*8, intent(out), optional :: thZmin,thZmax

      !-------------------
      real*8 :: zrho,zphi,elemvals(8),zrmin,zrmax,zzmin,zzmax,bdytol
      real*8 :: zthRmin,zthRmax,zthZmin,zthZmax
      character*32 elemNames(8),elemLabels(8)
      logical :: ibdy,iwant_R,iwant_Z,jccw
      integer :: id_rzmmx,iertmp,j2pi,inum_elems
      !-------------------

      ier = 0

      if(present(rmin)) rmin=0
      if(present(rmax)) rmax=0

      if(present(thRmin)) thRmin=0
      if(present(thRmax)) thRmax=0

      if(present(zmin)) zmin=0
      if(present(zmax)) zmax=0

      if(present(thZmin)) thZmin=0
      if(present(thZmax)) thZmax=0

      j2pi=1
      if(present(i2pi)) j2pi=i2pi

      jccw=.TRUE.
      if(present(ccw_theta)) jccw=ccw_theta

      !-----------
      !  non-axisymmetry upgrade needed here someday...
      zphi = 0
      if(present(phi)) zphi=phi
      !-----------
      
      call xplasma_global_info(s,ier, bdytol=bdytol)
      if(abs(rho-1.0d0).lt.bdytol) then
         ibdy=.TRUE.
         iwant_R=.TRUE.
         iwant_Z=.TRUE.
         zrho=1.0d0

         call xplasma_common_ids(s,ier, id_RZminmax=id_rzmmx)
         if(ier.ne.0) return

         if(id_rzmmx.gt.0) then
            call xplasma_getList_size(s,id_rzmmx,inum_elems,ier)
            if(inum_elems.ne.8) id_rzmmx=0  ! recompute...
         endif

         if(id_rzmmx.gt.0) then

            ! answer has been saved already: retrieve it.
            call xplasma_getList(s,id_rzmmx,elemvals,ier)

            if(present(rmin)) rmin = elemvals(1)
            if(present(rmax)) rmax = elemvals(2)
            if(present(zmin)) zmin = elemvals(3)
            if(present(zmax)) zmax = elemvals(4)

            if(present(thRmin)) thRmin = set_th(elemvals(5))
            if(present(thRmax)) thRmax = set_th(elemvals(6))
            if(present(thZmin)) thZmin = set_th(elemvals(7))
            if(present(thZmax)) thZmax = set_th(elemvals(8))

            return
         endif
      else
         ibdy=.FALSE.
         iwant_R = present(rmin).or.present(rmax)
         iwant_R = iwant_R.or.present(thRmin).or.present(thRmax)
         iwant_Z = present(zmin).or.present(zmax)
         iwant_Z = iwant_Z.or.present(thZmin).or.present(thZmax)
         zrho=rho
      endif

      if(.not.(iwant_R.or.iwant_Z)) return

      !  compute the extrema

      sp => s   ! module pointer used to pass "s" to root finder argument fcn

      call eqi_rzbox(zrho,zphi, &
           iwant_R,zrmin,zthrmin,iwant_R,zrmax,zthrmax, &
           iwant_Z,zzmin,zthzmin,iwant_Z,zzmax,zthzmax, &
           ier)
      if(ier.ne.0) return

      !  store the result as a list if flag is set

      if(ibdy) then

         elemnames(1)='RMIN'
         elemnames(2)='RMAX'
         elemnames(3)='ZMIN'
         elemnames(4)='ZMAX'

         elemnames(5)='THRMIN'
         elemnames(6)='THRMAX'
         elemnames(7)='THZMIN'
         elemnames(8)='THZMAX'

         elemLabels(1)='minimum R of bdy flux surface'
         elemLabels(2)='maximum R of bdy flux surface'
         elemLabels(3)='minimum Z of bdy flux surface'
         elemLabels(4)='maximum Z of bdy flux surface'

         elemLabels(5)='minimum R of bdy flux surface'
         elemLabels(6)='maximum R of bdy flux surface'
         elemLabels(7)='minimum Z of bdy flux surface'
         elemLabels(8)='maximum Z of bdy flux surface'

         elemvals(1)=zrmin
         elemvals(2)=zrmax
         elemvals(3)=zzmin
         elemvals(4)=zzmax

         elemvals(5)=zthrmin
         elemvals(6)=zthrmax
         elemvals(7)=zthzmin
         elemvals(8)=zthzmax

         call xplasma_author_set(s,xplasma_xmhd,iertmp)

         call xplasma_create_list(s,"BDY_RZ_MINMAX", &
              elemnames,id_rzmmx,ier, &
              label='R & Z extrema of bdy flux surface', units='m', &
              r8vals=elemvals, chvals=elemLabels)

         call xplasma_author_clear(s,xplasma_xmhd,iertmp)
      endif

      !  return the requested
      if(present(rmin)) rmin=zrmin
      if(present(rmax)) rmax=zrmax

      if(present(zmin)) zmin=zzmin
      if(present(zmax)) zmax=zzmax

      if(present(thRmin)) thRmin = set_th(zthrmin)
      if(present(thRmax)) thRmax = set_th(zthrmax)

      if(present(thZmin)) thZmin = set_th(zthzmin)
      if(present(thZmax)) thZmax = set_th(zthzmax)

      contains
        real*8 function set_th(zth_in)
          real*8, intent(in) :: zth_in

          real*8 :: zth(1)

          zth=zth_in
          call angle_trans(zth,xplasma_theta_coord,jccw,j2pi)
          set_th=zth(1)

        end function set_th

    end subroutine xplasma_RZminmax

    subroutine xplasma_Bminmax(s,rho,ier, phi, &
         ccw_theta,i2pi, bmin,bmax, thbmin,thbmax)

      use eqi_rzbox_module

      !  very accurately determine Bmin/max of a flux surface

      type (xplasma), pointer :: s
      real*8, intent(in) :: rho       ! required input: flux surface.
      integer, intent(out) :: ier     ! completion code

      real*8, intent(in), optional :: phi   ! toroidal angle location

      logical, intent(in), optional :: ccw_theta ! Theta CCW in poloidal plane, default=T

      integer, intent(in), optional :: i2pi ! angle coord normalization options
      !  i2pi=1 (default) returned value in range [0,2pi]
      !  i2pi=2 returned value in range [-pi,pi]

      real*8, intent(out), optional :: Bmin,Bmax  ! Bmin & Bmax of surface
      real*8, intent(out), optional :: thBmin,thBmax

      !------------------------
      integer :: id_Bmod,j2pi
      real*8 :: zphi,zbmin,zbmax,zthbmin,zthbmax,zth(1)
      logical :: ccwflag
      !------------------------

      call xplasma_common_ids(s,ier, id_Bmod=id_Bmod)
      if(ier.ne.0) return

      if(id_Bmod.eq.0) then
         ier=106
         call xplasma_errmsg_append(sp, &
              '  xplasma_Bminmax: Bmin & Bmax unavailable: no Bmod profile.')
         return
      endif

      if(present(Bmin)) Bmin=0
      if(present(Bmax)) Bmax=0

      if(present(thBmin)) thBmin=0
      if(present(thBmax)) thBmax=0

      zphi=0.0d0
      if(present(phi)) zphi=phi  ! not used now (axisymmetry assumed).

      ccwflag=.TRUE.
      if(present(ccw_theta)) ccwflag=ccw_theta

      j2pi=1
      if(present(i2pi)) j2pi=max(1,min(2,i2pi))

      sp => s

      call eqi_bbox(rho, zbmin,zthbmin, zbmax,zthbmax, ier)

      if(ier.ne.0) return

      if(present(Bmin)) Bmin=zbmin
      if(present(Bmax)) Bmax=zbmax

      if(present(thBmin)) then
         zth=zthbmin
         call angle_trans(zth,xplasma_theta_coord,ccwflag,j2pi)
         thBmin=zth(1)
      endif

      if(present(thBmax)) then
         zth=zthbmax
         call angle_trans(zth,xplasma_theta_coord,ccwflag,j2pi)
         thBmax=zth(1)
      endif

    end subroutine xplasma_Bminmax

    subroutine xplasma_vtaub(s,rho,xb,vtaub,ierr, &
         tol,bcut,indx,bmin,bmax)

      !  evaluate zero banana width approximation to v*tau_bounce

      !  this is the integral over the limits of the orbit of
      !     dtheta*(dlp/dtheta)*(B/Bp)*(1/sqrt(1-B/Brefl))

      !  where Brefl is a trapped orbit's reflection point (vpll=0,v=vperp)
      !  for passing orbits (Brefl > Bmax) the integrand is over the
      !  entire surface contour; for trapped orbits the integrand is
      !  twice the value from theta_lower to theta_upper where these
      !  limits need to be found by a root finder so that
      !     B(theta_lower)=B(theta_upper)=Brefl

      !  the integrand formula follows from the assumptions that v
      !  and mu=vperp**2/B are constants of motion
 
      !  axisymmetry is assumed...

      use eqi_rzbox_module
 
      !-----------
      type (xplasma), pointer :: s

      real*8, intent(in) :: rho  ! surface on which to calculate
      !  note -- must not be magnetic axis; non-singular surface required.

      real*8, dimension(:), intent(in) :: xb  ! evaluation points:
      !   xb(j) = (Brefl(j)-Bmin)/(Bmax-Bmin)
      ! where Bmin and Bmax, the min and mod(B) on the zrho surface, will
      ! be found; xb > 0 is required AND
      !    xb(j+1) > xb(j) required for all j < size(xb).

      real*8, dimension(:), intent(out) :: vtaub ! integral values (m).
      !  (divide by ion velocity (m/sec) to get bounce time, seconds).

      !  size of xb and vtaub must match.

      integer, intent(out) :: ierr   ! completion status, 0=OK

      real*8, intent(in), optional :: tol  ! rel. integration error tolerance
      ! default & recommended value: 1.0d-4; permitted range 1.0d-6 to 1.0d-3

      real*8, intent(in), optional :: bcut ! minimum allowed value for 
      ! approaching singularity at (1-B/Brefl); 
      ! default & recommended value: 1.0d-8; permitted range 1.0d-10 to 1.0d-6.

      integer, intent(in), optional :: indx ! evaluation element index
      ! thread index (for parallelization over surfaces)

      real*8, intent(out), optional :: bmin ! minimum mod(B) on rho surface (T)
      real*8, intent(out), optional :: bmax ! maximum mod(B) on rho surface (T)

      !--------------------------------------
      integer :: i,inum,itrap,indxe
      real*8 :: ztol,zcut,zbmin,zbmax
      real*8, parameter :: ZERO=0.0d0, ONE=1.0d0
      real*8, parameter :: eps3=1.0d-3,eps4=1.0d-4,eps6=1.0d-6
      real*8, parameter :: eps8=1.0d-8,eps10=1.0d-10,eps12=1.0d-12
      character*120 zmsg
      !--------------------------------------

      ztol=eps4
      if(present(tol)) ztol=max(eps6,min(eps3,tol))

      zcut=eps8
      if(present(bcut)) zcut=max(eps12,min(eps6,bcut))

      ierr=0

      if((rho.le.ZERO).or.(rho.gt.ONE)) then
         zmsg=' '
         write(zmsg,*) ' ?xplasma_vtaub: rho out of range 0 < rho <= 1: ',rho
         call xplasma_errmsg_append(s,zmsg)
         ierr=9999
      endif

      inum=size(xb)
      if(inum.ne.size(vtaub)) then
         ierr=9999
         zmsg=' '
         write(zmsg,*) ' ?xplasma_vtaub: size(xb)<>size(vtaub): ', &
              size(xb),' ',size(vtaub)
         call xplasma_errmsg_append(s,zmsg)
      endif
 
      itrap=0
      do i=1,inum
         if(xb(i).le.ZERO) then
            zmsg=' '
            write(zmsg,*) ' ?xplasma_vtaub: "xb" not positive: ', &
                 'xb(',i,')=',xb(i)
            call xplasma_errmsg_append(s,zmsg)
            ierr=9999
         endif
         if(i.lt.inum) then
            if(xb(i).ge.xb(i+1)) then
               zmsg=' '
               write(zmsg,*) ' ?xplasma_vtaub: "xb" not strict ascending: ', &
                    'xb(',i,')=',xb(i),'  xb(',i+1,')=',xb(i+1)
               ierr=9999
            endif
         endif
         if(ierr.ne.0) exit
         if(xb(i).le.ONE) itrap=i
      enddo
      if(ierr.ne.0) return

      ! ----- OK

      indxe=1
      if(present(indx)) indxe=indx

      sp => s
      call eqi_tau_bounce(rho,indxe, &
           itrap,inum,xb,ztol,zcut,zbmin,zbmax,vtaub,ierr)

      if(present(bmin)) bmin=zbmin
      if(present(bmax)) bmax=zbmax

    end subroutine xplasma_vtaub

    subroutine xplasma_bdfind1(s,zR,zZ,ier, &
         maptype, phi_in, rho_in, ccw_theta, ccw_phi, i2pi, outside_only, &
         theta_out, phi_out, dist)

      ! scalar xplasma_bdfind
      ! see xplasma_bdfindn for arg descriptions

      type (xplasma), pointer :: s

      real*8, intent(in) :: zR,zZ
      integer, intent(out) :: ier

      integer, intent(in), optional :: maptype
      real*8, intent(in), optional :: phi_in,rho_in

      logical, intent(in), optional :: ccw_theta,ccw_phi
      integer, intent(in), optional :: i2pi

      logical, intent(in), optional :: outside_only ! flag that caller only
      !  expects to need data from beyond plasma boundary (default .FALSE.)
      !  (this switch only useful for optimization of maptype=3 calls).

      real*8, intent(out), optional :: theta_out,phi_out,dist

      !-----------------
      real*8 :: zR1(1),zZ1(1),phi_in1(1),theta_out1(1),phi_out1(1),dist1(1)
      !-----------------

      zR1 = zR
      zZ1 = zZ

      if(present(phi_in)) then
         phi_in1 = phi_in
      else
         phi_in1 = 0
      endif

      call xplasma_bdfindn(s, 1, zR1, zZ1, ier, &
           maptype=maptype, phi_in=phi_in1, rho_in=rho_in, &
           ccw_theta=ccw_theta, ccw_phi=ccw_phi, i2pi=i2pi, &
           outside_only=outside_only, &
           theta_out=theta_out1, phi_out=phi_out1, dist=dist1)

      if(present(theta_out)) then
         theta_out = theta_out1(1)
      endif

      if(present(phi_out)) then
         phi_out = phi_out1(1)
      endif

      if(present(dist)) then
         dist = dist1(1)
      endif

    end subroutine xplasma_bdfind1

    subroutine xplasma_bdfindn(s,isize,zR,zZ,ier, &
         maptype, phi_in, rho_in, ccw_theta, ccw_phi, i2pi, outside_only, &
         theta_out, phi_out, dist)

      ! accurately find the distance of points (R,Z) from a flux surface
      ! and the closest point on the flux surface

      ! although phi arguments are supplied to support a possible future
      ! upgrade to 3d, these have no effect on axisymmetric calculations.

      use eqi_rzbox_module

      type (xplasma), pointer :: s
      integer, intent(in) :: isize   ! vector size
      !  all array arguments' sizes must be .ge.isize

      !  the target points whose distances from a surface are to be
      !  calculated:

      real*8, dimension(:), intent(in) :: zR   ! R values
      real*8, dimension(:), intent(in) :: zZ   ! Z values

      integer, intent(out) :: ier       ! completion code 0=OK

      !------------
      !  optional arguments

      integer, intent(in), optional :: maptype

      !  = 1 = xp_imap_newton = default -- iterative Newton root finder
      !        with initial guess by searching method, accurate w.r.t.
      !        spline fit of R & Z, to machine precision, but costly...

      !  = 2 = xp_imap_polar -- polar "circle-fit" distance estimate:
      !        The boundary is treated as a piecewise linear interpolation
      !        between circles fit to nearby points on the boundary
      !        much faster, not as accurate as Newton map

      !  = 3 = xp_imap_rzlinear -- bilinear inverse map -- after 
      !        initialization (using polar map), the fastest, but less
      !        accurate still (depends on R,Z grid resolution).  This 
      !        method requires a user defined (R,Z) rectangle grid; if 
      !        none is available the polar map is used instead.

      real*8, dimension(:), intent(in), optional :: phi_in  ! toroidal angle 
      !  (not needed for axisymmetric equilibria)

      real*8, intent(in), optional :: rho_in  ! **SCALAR** -- the surface from
      !  which to calculate distances.  DEFAULT is the boundary surface rho=1.0

      logical, intent(in), optional :: ccw_phi  ! Phi CCW view from above, default=T
      logical, intent(in), optional :: ccw_theta ! Theta CCW in poloidal plane, default=T

      integer, intent(in), optional :: i2pi ! angle coord normalization options
      !  i2pi=1 (default) returned value in range [0,2pi]
      !  i2pi=2 returned value in range [-pi,pi]

      logical, intent(in), optional :: outside_only ! flag that caller only
      !  expects to need data from beyond plasma boundary (default .FALSE.)
      !  (this switch only useful for optimization of maptype=3 calls).

      !-------------
      !  results-- optional but at least one should be present

      real*8, dimension(:), intent(out), optional :: theta_out  ! theta of
      !  nearest point on surface

      real*8, dimension(:), intent(out), optional :: phi_out    ! phi of
      !  nearest point on surface

      real*8, dimension(:), intent(out), optional :: dist       ! distance to
      !  surface.  If dist(j) > 0.0 then (zR(j),zZ(j)) is outside the test
      !  surface; if dist(j) < 0.0 then the point is inside the test surface;
      !  if dist(j) = 0.0 then the point is on the test flux surface.

      !-------------------------
      logical :: axisymm
      integer :: isize_min,j2pi,imap_type,id_Rgrid,iwant
      character*128 zmsg
      real*8, dimension(:), allocatable :: zphi,zth_out,zph_out,zdist
      real*8 :: zrho_in,zrho_bdy,ztol
      logical :: jccw_phi,jccw_theta,iskipi,iskipo,iexact
      !-------------------------

      ier=0
      if(present(theta_out)) theta_out=0
      if(present(phi_out)) phi_out=0
      if(present(dist)) dist=0

      call xplasma_global_info(s,ier, axisymm=axisymm, bdytol=ztol)
      if(ier.ne.0) return

      if(.not.axisymm) then
         ier=2509
         call xplasma_errmsg_append(s, &
              ' xplasma_bdfind requires an axisymmetric equilibrium.')
         return
      endif

      ! check vector sizes

      isize_min = isize

      isize_min = min(isize_min,size(zR))
      isize_min = min(isize_min,size(zZ))
      if(present(phi_in)) isize_min = min(isize_min,size(phi_in))

      if(present(theta_out)) isize_min = min(isize_min,size(theta_out))
      if(present(phi_out)) isize_min = min(isize_min,size(phi_out))
      if(present(dist)) isize_min = min(isize_min,size(dist))

      if(isize_min.lt.isize) then

         ier=2503
         call xplasma_errmsg_append(s,' ...error in xplasma_bdfind:')
         zmsg=' '
         write(zmsg,*) ' isize argument: ',isize,'; min vector size:',isize_min
         call xplasma_errmsg_append(s,zmsg)
         return

      endif

      if(present(rho_in)) then
         zrho_in=rho_in
      else
         zrho_in=1.0d0
      endif

      sp => s
      call eqi_extrap_rho_bdy(zrho_bdy)
      if(zrho_bdy.lt.0.0d0) zrho_bdy=1.0d0

      if((zrho_in.lt.-ztol).or.zrho_in.gt.(zrho_bdy+ztol)) then
         ier=306
         zmsg=' '
         write(zmsg,*) ' xplasma_bdfind: input argument rho_in = ',rho_in, &
              ' not in expected range, typically [0,1].'
         return

      else

         zrho_in=max(ztol,min(zrho_bdy,zrho_in))

      endif

      !  OK...

      j2pi=1
      if(present(i2pi)) j2pi=i2pi

      !  set CCW flags & tolerance

      jccw_phi=.TRUE.
      jccw_theta=.TRUE.
      if(present(ccw_phi)) jccw_phi=ccw_phi
      if(present(ccw_theta)) jccw_theta=ccw_theta

      imap_type = 1
      if(present(maptype)) then
         imap_type=max(1,min(3,maptype))
      endif

      iexact = imap_type.eq.1

      if(imap_type.eq.3) then
         ! fast bilinear map for rho_in=1 only
         if(abs(zrho_in-1.0d0).gt.ztol) then
            imap_type=2
         else
            ! R & Z grids have to have been defined...
            call xplasma_find_item(s,'__ZGRID',id_rgrid,ier,nf_noerr=.TRUE.)
            if(id_rgrid.eq.0) imap_type=2
            call xplasma_find_item(s,'__RGRID',id_rgrid,ier,nf_noerr=.TRUE.)
            if(id_rgrid.eq.0) imap_type=2
         endif
      endif

      !  allocate vectors for eqi_bdfind...

      allocate(zphi(isize),zth_out(isize),zph_out(isize),zdist(isize))

      if(present(phi_in)) then
         zphi=phi_in(1:isize)
      else
         zphi=0
      endif

      if(imap_type.le.2) then

         iskipi=.FALSE.
         iskipo=.FALSE.
         call eqi_bdfind(isize,zR,zZ,zphi,zrho_in,iskipi,iskipo,iexact, &
              zth_out,zph_out,zdist,ier)

      else

         iwant=2
         if(present(outside_only)) then
            if(outside_only) iwant=1
         endif
         zph_out=zphi
         call eqi_bdfast(isize,zR,zZ,iwant,present(theta_out),zdist,zth_out, &
              ier)

      endif

      if(present(theta_out)) then
         call angle_trans(zth_out,xplasma_theta_coord,jccw_theta,j2pi)
         theta_out(1:isize)=zth_out
      endif
      if((.not.axisymm).and.present(phi_out)) then
         call angle_trans(zph_out,xplasma_phi_coord,jccw_phi,j2pi)
         phi_out(1:isize)=zph_out
      endif

      if(present(dist)) dist(1:isize)=zdist

      deallocate(zphi,zth_out,zph_out,zdist)

    end subroutine xplasma_bdfindn

    subroutine xplasma_rzjac1(s,rho_in,theta_in,ier, ccwflag1, &
         r1,z1,drdrho1,dzdrho1,drdtheta1,dzdtheta1, &
         rzdetj1,drhodr1,drhodz1,dthdr1,dthdz1)

      ! evaluate terms associated with 2d Jacobean -- scalar version
      !   [dR/drho dR/dtheta]
      !   [dZ/drho dZ/dtheta]

      type (xplasma), pointer :: s
      real*8 :: rho_in   ! radial coordinate in
      real*8 :: theta_in ! poloidal angle coordinate in
      !  (see ccwflag below)

      integer, intent(out) :: ier      ! completion code 0=OK

      !  Poloidal angle orientation: TRUE (default) if dZ/dtheta is
      !  positive on the large major radius size and negative on the
      !  small major radius side of each flux surface; FALSE for the
      !  reverse.

      logical, intent(in), optional :: ccwflag1

      real*8, intent(out), optional :: r1,z1   ! (R,Z) values if desired
      real*8, intent(out), optional :: drdrho1,dzdrho1 ! rho derivatives
      real*8, intent(out), optional :: drdtheta1,dzdtheta1 ! theta deriv.
      real*8, intent(out), optional :: rzdetj1 ! determinant of 2x2 matrix
      real*8, intent(out), optional :: drhodr1,drhodz1 ! grad(rho)
      real*8, intent(out), optional :: dthdr1,dthdz1   ! grad(theta)
      
      !-----------------
      real*8, dimension(1) :: zwkrho,zwkth,zwkr,zwkz
      real*8, dimension(1) :: zwkrrho,zwkzrho,zwkrth,zwkzth
      real*8, dimension(1) :: zdrhodr,zdrhodz,zdthdr,zdthdz
      logical :: jccwflag,idetj
      real*8 :: zdetj,zdenom
      !-----------------

      ier=0

      jccwflag=.TRUE.
      if(present(ccwflag1)) jccwflag = ccwflag1

      zwkrho=rho_in
      zwkth=theta_in

      if(present(r1)) r1=0
      if(present(r1)) z1=0

      if(present(drdrho1)) drdrho1=0
      if(present(dzdrho1)) dzdrho1=0

      if(present(drdtheta1)) drdtheta1=0
      if(present(dzdtheta1)) dzdtheta1=0

      idetj=.FALSE.

      if(present(rzdetj1)) then
         idetj=.TRUE.
         rzdetj1=0
      endif

      if(present(drhodr1)) then
         idetj=.TRUE.
         drhodr1=0
      endif

      if(present(drhodz1)) then
         idetj=.TRUE.
         drhodz1=0
      endif

      if(present(dthdr1)) then
         idetj=.TRUE.
         dthdr1=0
      endif

      if(present(dthdz1)) then
         idetj=.TRUE.
         dthdz1=0
      endif

      if(present(r1).or.present(z1)) then
         call xplasma_rzjacn(s,zwkrho,zwkth,ier, ccwflag=jccwflag, &
              r=zwkr,z=zwkz)
         if(ier.ne.0) return
         if(present(r1)) r1=zwkr(1)
         if(present(z1)) z1=zwkz(1)
      endif

      if(idetj.or. &
           present(drdrho1).or.present(dzdrho1)) then
         call xplasma_rzjacn(s,zwkrho,zwkth,ier, ccwflag=jccwflag, &
              drdrho=zwkrrho,dzdrho=zwkzrho)
         if(ier.ne.0) return
         if(present(drdrho1)) drdrho1=zwkrrho(1)
         if(present(dzdrho1)) dzdrho1=zwkzrho(1)
      endif

      if(idetj.or. &
           present(drdtheta1).or.present(dzdtheta1)) then
         call xplasma_rzjacn(s,zwkrho,zwkth,ier, ccwflag=jccwflag, &
              drdtheta=zwkrth,dzdtheta=zwkzth)
         if(ier.ne.0) return
         if(present(drdtheta1)) drdtheta1=zwkrth(1)
         if(present(dzdtheta1)) dzdtheta1=zwkzth(1)
      endif

      if(idetj) then

         zdetj=(zwkzrho(1)*zwkrth(1)-zwkrrho(1)*zwkzth(1))
         if(present(rzdetj1)) rzdetj1=zdetj

         if(abs(zdetj).gt.0.0d0) then
            if(present(drhodr1)) drhodr1 = zwkzth(1)/zdetj
            if(present(drhodz1)) drhodz1 =-zwkrth(1)/zdetj
            if(present(dthdr1)) dthdr1 =-zwkrrho(1)/zdetj
            if(present(dthdz1)) dthdz1 = zwkzrho(1)/zdetj
         else
            zdenom=(zwkrrho(1)*zwkrrho(1)+zwkzrho(1)*zwkzrho(1))
            if(present(drhodr1)) drhodr1 = zwkrrho(1)/zdenom
            if(present(drhodz1)) drhodz1 = zwkzrho(1)/zdenom
            if(present(dthdr1)) dthdr1 = 0.0d0
            if(present(dthdz1)) dthdz1 = 0.0d0
         endif
      endif
    end subroutine xplasma_rzjac1

    subroutine xplasma_rzjacn(s,rho_in,theta_in,ier, &
         ccwflag, r,z,drdrho,dzdrho,drdtheta,dzdtheta, &
         rzdetj, drhodr,drhodz, dthdr,dthdz)

      ! evaluate terms associated with 2d Jacobean -- vector version
      !   [dR/drho dR/dtheta]
      !   [dZ/drho dZ/dtheta]

      ! *** all vectors must be of the same length ***

      type (xplasma), pointer :: s
      real*8, dimension(:) :: rho_in   ! vector of radial coordinate in
      real*8, dimension(:) :: theta_in ! vector of poloidal angle coordinate in
      !  (see ccwflag below)

      integer, intent(out) :: ier      ! completion code 0=OK

      !  Poloidal angle orientation: TRUE (default) if dZ/dtheta is
      !  positive on the large major radius size and negative on the
      !  small major radius side of each flux surface; FALSE for the
      !  reverse.

      logical, intent(in), optional :: ccwflag

      real*8, intent(out), dimension(:), optional :: r,z
      ! (R,Z) values if desired

      real*8, intent(out), dimension(:), optional :: drdrho,dzdrho
      ! rho derivatives if desired

      real*8, intent(out), dimension(:), optional :: drdtheta,dzdtheta
      ! theta derivatives if desired

      real*8, intent(out), dimension(:), optional :: rzdetj 
      ! determinant of 2x2 jacobian matrix

      real*8, intent(out), dimension(:), optional :: drhodr,drhodz
      ! grad(rho) components if desired

      real*8, intent(out), dimension(:), optional :: dthdr,dthdz
      ! grad(theta) components if desired

      !--------------------
      real*8, dimension(:,:), allocatable :: zwkbuf
      real*8, dimension(:), allocatable :: zdetj
      real*8 :: zdenom
      integer :: isize_min,isize_max,isize,id_R,id_Z,ids(6),inbuf
      integer :: iddrho(6),iddth(6)
      integer :: ii
      logical :: jccwflag,iaxi,idetj
      integer :: indR,indZ,indRrho,indRth,indZrho,indZth
      !-----------------

      call xplasma_global_info(s,ier, axisymm=iaxi)
      if(ier.ne.0) return
      
      if(.not.iaxi) then
         ier=2509
         call xplasma_errmsg_append(s,'  cannot use xplasma_rzjac...')
         return
      endif

      call xplasma_common_ids(s,ier,id_R=id_R,id_Z=id_Z)
      if(min(id_R,id_Z).eq.0) then

         ier=2504  ! no flux surfaces...
         return

      endif

      inbuf=0
      !-----------------------------

      ! check poloidal angle orientation; set sign term...

      jccwflag=.TRUE.
      if(present(ccwflag)) jccwflag = ccwflag

      !-----------------------------
      ! check vector sizes & clear output vectors that are present...

      isize_min=size(rho_in)
      isize_max=isize_min

      isize_min=min(isize_min,size(theta_in))
      isize_max=max(isize_max,size(theta_in))

      if(present(r)) then
         r=0
         isize_min=min(isize_min,size(r))
         isize_max=max(isize_max,size(r))
         inbuf=inbuf+1
         indR=inbuf
         ids(inbuf)=id_R
         iddrho(inbuf)=0
         iddth(inbuf)=0
      endif

      if(present(z)) then
         z=0
         isize_min=min(isize_min,size(z))
         isize_max=max(isize_max,size(z))
         inbuf=inbuf+1
         indZ=inbuf
         ids(inbuf)=id_Z
         iddrho(inbuf)=0
         iddth(inbuf)=0
      endif

      idetj = present(rzdetj).or. &
           present(drhodr).or.present(drhodz).or. &
           present(dthdr).or.present(dthdz)

      if(present(drdrho)) then
         drdrho=0
         isize_min=min(isize_min,size(drdrho))
         isize_max=max(isize_max,size(drdrho))
      endif

      if(present(drdrho).or.idetj) then
         inbuf=inbuf+1
         indRrho=inbuf
         ids(inbuf)=id_R
         iddrho(inbuf)=1
         iddth(inbuf)=0
      endif

      if(present(dzdrho)) then
         dzdrho=0
         isize_min=min(isize_min,size(dzdrho))
         isize_max=max(isize_max,size(dzdrho))
      endif

      if(present(dzdrho).or.idetj) then
         inbuf=inbuf+1
         indZrho=inbuf
         ids(inbuf)=id_Z
         iddrho(inbuf)=1
         iddth(inbuf)=0
      endif

      if(present(drdtheta)) then
         drdtheta=0
         isize_min=min(isize_min,size(drdtheta))
         isize_max=max(isize_max,size(drdtheta))
      endif

      if(present(drdtheta).or.idetj) then
         inbuf=inbuf+1
         indRth=inbuf
         ids(inbuf)=id_R
         iddrho(inbuf)=0
         iddth(inbuf)=1
      endif

      if(present(dzdtheta)) then
         dzdtheta=0
         isize_min=min(isize_min,size(dzdtheta))
         isize_max=max(isize_max,size(dzdtheta))
      endif

      if(present(dzdtheta).or.idetj) then
         inbuf=inbuf+1
         indZth=inbuf
         ids(inbuf)=id_Z
         iddrho(inbuf)=0
         iddth(inbuf)=1
      endif

      if(present(rzdetj)) then
         rzdetj=0
         isize_min=min(isize_min,size(rzdetj))
         isize_max=max(isize_max,size(rzdetj))
      endif

      if(present(drhodr)) then
         drhodr=0
         isize_min=min(isize_min,size(drhodr))
         isize_max=max(isize_max,size(drhodr))
      endif

      if(present(drhodz)) then
         drhodz=0
         isize_min=min(isize_min,size(drhodz))
         isize_max=max(isize_max,size(drhodz))
      endif

      if(present(dthdr)) then
         dthdr=0
         isize_min=min(isize_min,size(dthdr))
         isize_max=max(isize_max,size(dthdr))
      endif

      if(present(dthdz)) then
         dthdz=0
         isize_min=min(isize_min,size(dthdz))
         isize_max=max(isize_max,size(dthdz))
      endif

      if(isize_min.ne.isize_max) then
         ier=510
         call xplasma_errmsg_append(s, &
              'vector length inconsistency detected in xplasma_rzjac')
         return
      endif

      isize=isize_min

      if(inbuf.eq.0) return

      !-------------------------------------------------------
      !  OK -- allocate workspace

      allocate(zwkbuf(isize,inbuf))

      !  evaluate (R,Z) if requested

      call xplasma_RZeval_2d(s,ids(1:inbuf), &
           xplasma_rho_coord,rho_in,xplasma_theta_coord,theta_in, &
           zwkbuf,ier, ccwflag2=jccwflag, &
           ideriv1s=iddrho(1:inbuf),ideriv2s=iddth(1:inbuf))

      if(present(r)) r = zwkbuf(1:isize,indR)
      if(present(z)) z = zwkbuf(1:isize,indZ)
      if(present(drdrho)) drdrho = zwkbuf(1:isize,indRrho)
      if(present(dzdrho)) dzdrho = zwkbuf(1:isize,indZrho)
      if(present(drdtheta)) drdtheta = zwkbuf(1:isize,indRth)
      if(present(dzdtheta)) dzdtheta = zwkbuf(1:isize,indZth)

      if(idetj) then

         allocate(zdetj(isize))

         zdetj = zwkbuf(1:isize,indZrho)*zwkbuf(1:isize,indRth) - &
              zwkbuf(1:isize,indRrho)*zwkbuf(1:isize,indZth)

         if(present(rzdetj)) rzdetj = zdetj

         do ii=1,isize
            if(abs(zdetj(ii)).gt.0.0d0) then
               if(present(drhodr)) drhodr(ii) =-zwkbuf(ii,indZth)/zdetj(ii)
               if(present(drhodz)) drhodz(ii) = zwkbuf(ii,indRth)/zdetj(ii)
               if(present(dthdr)) dthdr(ii) = zwkbuf(ii,indZrho)/zdetj(ii)
               if(present(dthdz)) dthdz(ii) =-zwkbuf(ii,indRrho)/zdetj(ii)
            else
               zdenom=(zwkbuf(ii,indRrho)**2+zwkbuf(ii,indZrho)**2)
               if(present(drhodr)) drhodr(ii) = zwkbuf(ii,indRrho)/zdenom
               if(present(drhodz)) drhodz(ii) = zwkbuf(ii,indZrho)/zdenom
               if(present(dthdr)) dthdr(ii) = 0.0d0
               if(present(dthdz)) dthdz(ii) = 0.0d0
            endif
         enddo

         deallocate(zdetj)
      endif

      deallocate(zwkbuf)

    end subroutine xplasma_rzjacn

end module xplasma_ctran

module xplasma_avg1dmod

  !  Added dmc 16 Oct 2006 -- 1d averager "xplasma_avg1d"
  !   compute int[f*dV]/int[dV] or int[f*w*dV]/int[w*dV]

  use xplasma_obj
  use xplasma_profs

  implicit NONE

  private

  public :: xplasma_avg1d,xplasma_avg1d_single,xplasma_avg1d_vec

  interface xplasma_avg1d
     module procedure xplasma_avg1d_single,xplasma_avg1d_vec
  end interface

  contains

    subroutine xplasma_avg1d_single(s,xtarg,idd,idf,answr,ierr,idw,ismoo)

      !  1d average
      !   unweighted:
      !               int[xtarg(j):xtarg(j+1)]{dx*(d(f[idd](x))/dx)*f[idf](x)}
      !    answr(j) = ------------------------------------------------------
      !                   int[xtarg(j):xtarg(j+1)]{dx*(d(f[idd](x))/dx)}
      !
      !   weighted -- multiply numerator and denominator integrands by
      !               w[idw](x).

      type(xplasma), pointer :: s

      real*8, dimension(:), intent(in) :: xtarg  ! integration boundaries
      !  xtarg(1:2) -- 1st zone; xtarg(2:3) -- 2nd zone, etc.

      integer, intent(in) :: idd    ! ID of differential function
      ! typically Volume(rho) or Area(rho); integral will then be 
      ! weighted by dVolume/drho or dArea/drho.

      integer, intent(in) :: idf    ! ID of function to be averaged

      real*8, dimension(:), intent(out) :: answr ! result of averaging

      integer, intent(out) :: ierr  ! completion code (0=OK)

      integer, intent(in), optional :: idw   ! weighting function ID (optional)

      logical, intent(in), optional :: ismoo ! optional smoothing (default: F)

      ! if SMOOTHING is selected, all functions and weighting functions must
      ! be defined over the same GRID; if not, it is sufficient if they are
      ! defined over the same COORDINATE.

      !---------------------------------------------------
      !  local:
      integer :: idfa(1),idwa(1)
      logical :: jsmoo
      real*8 :: ansa(size(answr),1)
      real*8, parameter :: ZERO = 0.0d0
      !---------------------------------------------------

      idfa = idf
      if(present(idw)) then
         idwa = idw
      else
         idwa = 0
      endif

      jsmoo=.FALSE.
      if(present(ismoo)) jsmoo=ismoo

      call xplasma_avg1d_vec(s,xtarg,idd,idfa,ansa,ierr,idw=idwa,ismoo=jsmoo)

      if(ierr.ne.0) then
         answr = ZERO
      else
         answr = ansa(:,1)
      endif

    end subroutine xplasma_avg1d_single

    subroutine xplasma_avg1d_vec(s,xtarg,idd,idf,answr,ierr,idw,ismoo)

      !  1d averager -- same as xplasma_avg1d_single but apply averaging
      !        operator to a list of profile functions idf(...).

      type(xplasma), pointer :: s

      real*8, dimension(:), intent(in) :: xtarg  ! integration boundaries
      !  xtarg(1:2) -- 1st zone; xtarg(2:3) -- 2nd zone, etc.

      integer, intent(in) :: idd    ! ID of differential function
      ! typically Volume(rho) or Area(rho); integral will then be 
      ! weighted by dVolume/drho or dArea/drho.

      integer, intent(in), dimension(:) :: idf ! ID of functions to be averaged

      real*8, dimension(:,:), intent(out) :: answr ! results of averaging

      integer, intent(out) :: ierr  ! completion code (0=OK)

      integer, intent(in), dimension(:), optional :: idw  ! weighting functions

      logical, intent(in), optional :: ismoo ! optional smoothing (default: F)

      ! if SMOOTHING is selected, all functions and weighting functions must
      ! be defined over the same GRID of "rho"; if smoothing is not selected,
      ! it is sufficient if all functions are defined over the same COORDINATE.

      !---------------------------------------------------
      ! local:
      integer :: ixid(100),isizes(100),inxid,icoord,jcoord,idx,jdx,irank,isize
      integer :: ii,ix,inx,inf,id,isizex,inbrk,inbrk_new,inint,iertmp,invec
      integer :: jj,isize_total,iaoff,ixtarg,inmap,imap,iadr,inxu,idarea,iflag
      integer :: idtmp,idvol
      logical :: perio
      logical :: jsmoo
      real*8 :: xmin,xmax,bdytol,ztol,zwgt
      real*8, dimension(:), allocatable :: x,xu,xgrid,xbrk,xbrk_new
      real*8, dimension(:), allocatable :: xvec,wvec,wkf
      real*8, dimension(:,:), allocatable :: eval_arr,fu,denoma
      integer, dimension(:), allocatable :: idint,ideriv,idwa,idwmap

      real*8 :: wkx(size(xtarg)),wkd(size(xtarg))

      real*8, parameter :: ZERO = 0.0d0
      real*8, parameter :: c2pi = 6.2831853071795862D+00
      character*32 profname
      !---------------------------------------------------

      ierr=0
      answr=0

      jsmoo=.FALSE.
      if(present(ismoo)) jsmoo=ismoo

      !----------------------------
      ! check rank of differential element

      call xplasma_prof_info(s,idd,ierr, gridId1=idx, rank=irank, &
           name=profname)

      if(irank.gt.1) then
         ierr=512

         call xplasma_errmsg_append(s, &
              ' ?xplasma_avg1d: rank of profile >1: '//trim(profname))
      endif
      if(ierr.ne.0) return

      !-----------------------------
      !  check argument array sizes

      inx=size(xtarg)
      if(inx.ne.(size(answr,1)+1)) then
         ierr=510
         call xplasma_errmsg_append(s, &
              ' ?xplasma_avg1d: size of result vector must be 1 less than size of the "xtarg".')
      endif

      inf=size(idf)
      if(inf.ne.size(answr,2)) then
         ierr=510
         call xplasma_errmsg_append(s, &
              ' ?xplasma_avg1d: number of result vectors must match number of profile input IDs.')
      endif
      if(ierr.ne.0) return
         
      if(present(idw)) then
         if(inf.ne.size(idw)) then
            ierr=510
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_avg1d: the number of weight profiles must match')
            call xplasma_errmsg_append(s, &
                 '  the number of integrand profiles.')
         endif
      endif
      if(ierr.ne.0) return

      call xplasma_global_info(s,ierr, bdytol=bdytol)
      if(ierr.ne.0) return

      !------------------------------
      !  check grid zone bdy inputs
      !    make reference to grid of "idd" profile

      call xplasma_grid_info(s,idx,ierr, &
           size=isizex, xmin=xmin, xmax=xmax, perio=perio, &
           coord=icoord)

      ztol = bdytol*max(abs(xmin),abs(xmax))

      do ix=1,inx-1
         if(xtarg(ix+1).le.xtarg(ix)+2*ztol) then
            ierr=603
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_avg1d: "xtarg" values must be strict ascending.')
            exit
         endif
      enddo
      if(ierr.ne.0) return

      if(.not.perio) then
         if((xtarg(1).lt.xmin-ztol).or.(xtarg(inx).gt.xmax+ztol)) then
            ierr=609
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_avg1d: out-of-range "xtarg" values detected.')
         endif

      else
         if((xtarg(inx)-xtarg(1)).gt.c2pi+ztol) then
            ierr=609
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_avg1d: periodic "xtarg" coordinate range exceeds 2pi.')
         endif
      endif

      if(ierr.ne.0) return

      allocate(x(inx))
      x = xtarg

      if(.not.perio) then
         x(1)=max(xmin,x(1))
         x(inx)=min(xmax,x(inx))
      else
         x(inx)=min(x(inx),x(1)+c2pi)
      endif

      !------------------------------
      !  OK, form list of grids; all must be over the same coordinate
      !  Check that all profiles are rank 1 over the same coordinate

      inxid=1
      ixid(1)=idx
      isizes(1)=isizex
      jdx=0

      if(present(idw)) then
         do ii=1,inf
            id=idw(ii)
            if(id.eq.0) cycle
            call xplasma_prof_info(s,id,ierr, rank=irank, gridId1=idx)
            if(ierr.ne.0) then
               call xplasma_errmsg_append(s, &
                    ' ?xplasma_avg1d: error looking up weight profile info.')
            else
               if(irank.gt.1) then
                  ierr=512
                  call xplasma_errmsg_append(s, &
                       ' ?xplasma_avg1d: weight profile rank exceeds 1')
               endif
            endif
            if(ierr.eq.0) then
               call xplasma_grid_info(s,idx,ierr, coord=jcoord, size=isizex)
               if(icoord.ne.jcoord) then
                  ierr=511
                  call xplasma_errmsg_append(s, &
                       ' ?xplasma_avg1d: weight and differential profiles (idd) and (idw)')
                  call xplasma_errmsg_append(s, &
                       '  must be defined over a common coordinate.')
               endif
               if(jsmoo) then
                  if(jdx.eq.0) jdx=idx
                  if(jcoord.ne.xplasma_rho_coord) then
                     ierr=511
                     call xplasma_errmsg_append(s, &
                          ' ?xplasma_avg1d: only functions of form f(rho)')
                     call xplasma_errmsg_append(s, &
                          '  can be smoothed with this software.')
                  endif
                  if(idx.ne.jdx) then
                     ierr=511
                     call xplasma_errmsg_append(s, &
                          ' ?xplasma_avg1d: when smoothing is activated,')
                     call xplasma_errmsg_append(s, &
                          '  all profiles must be defined over the same grid.')
                  endif
               endif
            endif
            if(ierr.eq.0) call addx(ixid,isizes,inxid,idx,isizex)
            if(ierr.ne.0) exit
         enddo

         if(ierr.ne.0) then
            deallocate(x)
            return
         endif
      endif

      do ii=1,inf
         id=idf(ii)
         call xplasma_prof_info(s,id,ierr, rank=irank, gridId1=idx)
         if(ierr.ne.0) then
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_avg1d: error looking up profile information.')
            exit
         else if(irank.gt.1) then
            ierr=512
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_avg1d: an integrand profile rank exceeds 1')
            exit
         endif
         call xplasma_grid_info(s,idx,ierr, coord=jcoord, size=isizex)
         if(icoord.ne.jcoord) then
            ierr=511
            call xplasma_errmsg_append(s, &
                 ' ?xplasma_avg1d: all integrand profiles must be defined over a common coordinate.')
            exit
         endif
         if(jsmoo) then
            if(jdx.eq.0) jdx=idx
            if(jcoord.ne.xplasma_rho_coord) then
               ierr=511
               call xplasma_errmsg_append(s, &
                    ' ?xplasma_avg1d: only functions of form f(rho)')
               call xplasma_errmsg_append(s, &
                    '  can be smoothed with this software.')
            endif
            if(idx.ne.jdx) then
               ierr=511
               call xplasma_errmsg_append(s, &
                    ' ?xplasma_avg1d: when smoothing is activated,')
               call xplasma_errmsg_append(s, &
                    '  all profiles must be defined over the same grid.')
            endif
            if(ierr.ne.0) exit
         endif

         call addx(ixid,isizes,inxid,idx,isizex)
      enddo

      if(ierr.ne.0) then
         deallocate(x)
         return
      endif

      !------------------------------------
      ! having gotten this far, all grids are over the same coordinate, and
      ! a list of distinct grids has been formed.
      !
      ! make a compressed list of weighting functions (if any)

      inmap=0
      allocate(idwa(inf),idwmap(inf))

      if(present(idw)) then
         do ii=1,inf
            if(idw(ii).eq.0) then
               idwmap(ii)=0
            else
               imap=0
               do jj=1,inmap
                  if(idwmap(jj).eq.idw(ii)) then
                     imap=jj
                     exit
                  endif
               enddo
               if(imap.gt.0) then
                  idwmap(ii)=imap
               else
                  inmap=inmap+1
                  idwa(inmap)=idw(ii)
                  idwmap(ii)=inmap
               endif
            endif
         enddo
      else
         idwa=0
         idwmap=0
      endif

      ! now "inmap" is the number of unique weighting profiles; could be zero

      ! now form a single grid which spans the user requested integration
      ! range but also has all interior grid boundaries added to it...

      !--------------
      ! choose a safe upper limit on the number of x break points in the
      ! integration

      if(jsmoo) then
         inxu=isizex
         allocate(xu(inxu))
         call xplasma_grid(s,idx,xu,ierr)
         call xplasma_profId(s,'XPLASMA_AREA',idarea)
         call xplasma_profId(s,'XPLASMA_VOLUME',idvol)
         if(idd.eq.idarea) then
            iflag=2
         else if(idd.eq.idvol) then
            iflag=1
         else
            iflag=idd  ! assumed >2 and will be...
         endif
      else
         inxu=inx
         allocate(xu(inxu))
         xu=x
      endif

      isize_total=inxu
      do ii=1,inxid
         isize_total=isize_total+isizes(ii)
      enddo

      allocate(xbrk(isize_total),xbrk_new(isize_total))

      inbrk=inxu
      xbrk(1:inxu)=xu(1:inxu)

      !--------------
      ! use library routine to insert break points without duplicates

      do ii=1,inxid
         allocate(xgrid(isizes(ii)))
         call xplasma_grid(s,ixid(ii),xgrid,iertmp)
         if(perio) then
            call fluxav_brk_addperio(xbrk,inbrk,xgrid,isizes(ii), &
                 xbrk_new,inbrk_new)
         else
            call fluxav_brk_addsub(xbrk,inbrk,xgrid,isizes(ii), &
                 xbrk_new,inbrk_new)
         endif
         call fluxav_brktol(xbrk_new,inbrk_new,ztol)
         if(inbrk_new.gt.inbrk) then
            inbrk = inbrk_new
            xbrk(1:inbrk)=xbrk_new(1:inbrk)
         endif
         deallocate(xgrid)
      enddo

      !  gather information needed to interpolate profile to necessary
      !  locations

      inint = inf + 1 + inmap

      allocate(idint(inint),ideriv(inint))
      ideriv(1)=1
      ideriv(2:inint)=0
      idint(1)=idd
      idint(2:inf+1) = idf
      if(inmap.gt.0) then
         idint(inf+2:inf+2+inmap-1) = idwa(1:inmap)
      endif

      !  x vector -- 10 gauss points per break interval

      invec = 10*(inbrk-1)
      allocate(xvec(invec),wvec(invec),eval_arr(invec,inint))

      !  get Gauss integration vector and weights

      call xplasma_integ_mkvec(inbrk,xbrk,xvec,wvec)

      !  interpolate the data needed for the integration
      !  this includes the differential profile, integrand profiles, and
      !  whatever weighting profiles (if any) that were specified...

      do
         call xplasma_eval_prof(s,idint,xvec,eval_arr,ierr, ideriv1s=ideriv)
         if(ierr.ne.0) exit

         if(.not.jsmoo) then
            !  compute the integration
            !   (answr array already was cleared to zero

            allocate(denoma(inx-1,inf)); denoma=ZERO

            ixtarg = 1

            do ix=1,invec
               if(xvec(ix).gt.xu(ixtarg+1)) then
                  ! start next zone
                  ixtarg = ixtarg + 1
               endif

               do ii=1,inf
                  if(idwmap(ii).gt.0) then
                     iadr=inf+1+idwmap(ii)
                     zwgt = eval_arr(ix,1)*eval_arr(ix,iadr)*wvec(ix)
                  else
                     zwgt = eval_arr(ix,1)*wvec(ix)
                  endif
                  zwgt=abs(zwgt)
                  denoma(ixtarg,ii)=denoma(ixtarg,ii)+zwgt
                  answr(ixtarg,ii)=answr(ixtarg,ii)+zwgt*eval_arr(ix,ii+1)
               enddo
            enddo

            do ii=1,inf
               call zclean(denoma(:,ii),1)
               call zclean(answr(:,ii),2)
               do ixtarg=1,inx-1
                  if(denoma(ixtarg,ii) == ZERO) then
                     answr(ixtarg,ii) = ZERO
                  else
                   !  write(*,'(I2,1x,I2,4(1x,E13.6))') ixtarg,ii,answr(ixtarg,ii),denoma(ixtarg,ii) &
                   !       ,answr(ixtarg,ii)/denoma(ixtarg,ii),eval_arr((ixtarg-1)*10+5,ii+1)

                     answr(ixtarg,ii)=answr(ixtarg,ii)/denoma(ixtarg,ii)
                  endif
               enddo
            enddo

         else
            ! calculate on original grid...

            allocate(fu(inxu-1,inf)); fu=ZERO
            allocate(denoma(inxu-1,inf)); denoma=ZERO

            ixtarg = 1

            do ix=1,invec
               if(xvec(ix).gt.xu(ixtarg+1)) then
                  ! start next zone; inherit sum from prior zone
                  ixtarg = ixtarg + 1
               endif

               do ii=1,inf
                  if(idwmap(ii).gt.0) then
                     iadr=inf+1+idwmap(ii)
                     zwgt = eval_arr(ix,1)*eval_arr(ix,iadr)*wvec(ix)
                  else
                     zwgt = eval_arr(ix,1)*wvec(ix)
                  endif
                  zwgt=abs(zwgt)
                  fu(ixtarg,ii)=fu(ixtarg,ii)+eval_arr(ix,ii+1)*zwgt
                  denoma(ixtarg,ii)=denoma(ixtarg,ii)+zwgt
               enddo
            enddo

            do ii=1,inf
               call zclean(denoma(:,ii),1)
               call zclean(fu(:,ii),2)
               do ixtarg=1,inxu-1
                  if(denoma(ixtarg,ii).eq.ZERO) then
                     fu(ixtarg,ii)=ZERO
                  else
                     fu(ixtarg,ii)=fu(ixtarg,ii)/denoma(ixtarg,ii)
                  endif
               enddo
            enddo

            ! compute smoothed integrals of functions
            call xplasma_author_set(s,'xplasma_profs',iertmp)
            do ii=1,inf
               if(idwmap(ii).eq.0) then
                  allocate(wkf(inxu))
                  call xplasma_eval_prof(s,idd,xu,wkf,ierr)
                  if(ierr.ne.0) exit
                  fu(1,ii)=fu(1,ii)*(wkf(2)-wkf(1))  ! multiply in *dV
                  do ix=2,inxu-1
                     fu(ix,ii)=fu(ix-1,ii)+fu(ix,ii)*(wkf(ix+1)-wkf(ix))
                  enddo
                  deallocate(wkf)
                  call xplasma_irhofun(s,idx,'___TMP',inxu-1,fu(1:inxu-1,ii), &
                       iflag,idtmp,ierr)
                  if(ierr.ne.0) exit
                  call xplasma_eval_prof(s,idtmp,x,wkx,ierr)
                  if(ierr.ne.0) exit
                  call xplasma_eval_prof(s,idd,x,wkd,ierr)
                  if(ierr.ne.0) exit
                  answr(1:inx-1,ii)=(wkx(2:inx)-wkx(1:inx-1))/ &
                       (wkd(2:inx)-wkd(1:inx-1))
               else
                  allocate(wkf(inxu))
                  wkf(2:inxu-1)=(fu(1:inxu-2,ii)+fu(2:inxu-1,ii))/2
                  call fextrap(xu,fu(:,ii),wkf(1),wkf(inxu))
                  call xplasma_create_1dprof(s,'___TMP',idx,wkf,idtmp,ierr, &
                       ispline=1,ibca=1,zbca=ZERO)   ! Hermite interpolation
                  deallocate(wkf)
                  if(ierr.ne.0) exit
                  call xplasma_eval_prof(s,idtmp, &
                       (x(1:inx-1)+x(2:inx))/2, answr(1:inx-1,ii), ierr)
                  if(ierr.ne.0) exit
               endif
            enddo
            call xplasma_remove_item(s,idtmp,iertmp)
            call xplasma_author_clear(s,'xplasma_profs',iertmp)

            deallocate(fu)
         endif
         exit
      enddo

      if(allocated(xu)) deallocate(xu)
      deallocate(xvec,wvec,eval_arr,xbrk,xbrk_new,x)
      deallocate(idint,ideriv,idwa,idwmap)
      if(allocated(denoma)) deallocate(denoma)

    contains
      subroutine fextrap(xbdy,fzon,f0,f1)
        real*8, dimension(:), intent(in) :: xbdy
        real*8, dimension(:), intent(in) :: fzon
        real*8, intent(out) :: f0,f1

        ! quadratic extrap to center; linear extrap to edge; constrain
        ! against sign change

        !---------------------------------
        real*8 :: dx1,dx2
        integer :: inz,inb
        real*8, parameter :: tenth = 0.1d0
        !---------------------------------

        inz=size(fzon)
        inb=size(xbdy)

        dx1=xbdy(2)/2
        dx2=(xbdy(2)+xbdy(3))/2
        f0 = (dx2*dx2*fzon(1)-dx1*dx1*fzon(2))/(dx2*dx2-dx1*dx1)
        if((f0-tenth*fzon(1))*fzon(1).le.0.0d0) then
           f0=tenth*fzon(1)
        endif

        dx1=(xbdy(inb)-xbdy(inb-1))/2
        dx2=xbdy(inb) - (xbdy(inb-1)+xbdy(inb-2))/2
        f1 = (dx2*fzon(inz)-dx1*fzon(inz-1))/(dx2-dx1)
        if((f1-tenth*fzon(inz))*fzon(inz).le.0.0d0) then
           f1=tenth*fzon(inz)
        endif
      end subroutine fextrap

      subroutine zclean(arr,itest)
        ! any value less than 10**-10 * max(abs(arr)) set to zero

        real*8, dimension(:) :: arr
        integer :: itest

        !-------------------------
        integer :: ixi,isizi
        real*8 :: amaxa,ztest
        real*8, parameter :: small_rat = 1.0d-10
        !-------------------------

        isizi=size(arr)
        amaxa=ZERO

        do ixi=1,isizi
           amaxa=max(amaxa,abs(arr(ixi)))
        enddo

        do ixi=1,isizi
           if(itest.eq.1) then
              ztest=arr(ixi)
           else if(itest.eq.2) then
              ztest=abs(arr(ixi))/itest
           endif
           if(ztest.lt.small_rat*amaxa) then
              arr(ixi)=ZERO
           endif
        enddo

      end subroutine zclean

    end subroutine xplasma_avg1d_vec
         
    subroutine addx(ixid,isizes,inxid,idx,isizex)
      ! **private**
      ! add to list of x axis IDs

      integer, dimension(:) :: ixid    ! the list of grid IDs
      integer, dimension(:) :: isizes  ! the list of grid sizes
      integer :: inxid  ! list size (possibly incremented on output
      integer :: idx    ! grid to add IF it is not there already.
      integer :: isizex ! grid size

      integer :: ii,imatch

      imatch=0
      do ii=1,inxid
         if(idx.eq.ixid(ii)) then
            imatch=ii
            exit
         endif
      enddo

      if(imatch.eq.0) then
         inxid=inxid+1
         ixid(inxid)=idx
         isizes(inxid)=isizex
      endif

    end subroutine addx

end module xplasma_avg1dmod

subroutine eq_gaxis(ivec,phi,b_axis,R_axis,Z_axis)

  !  (vectorized)
  !  given a toroidal angle coordinate (phi), return B and (R,Z) at the
  !  magnetic axis.

  !  if the equilibrium is AXISYMMETRIC then the value of the input variable
  !  phi is immaterial

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  integer ivec
  REAL*8 phi(ivec)                  ! (input) toroidal angle coordinate

  REAL*8 b_axis(ivec)               ! (output) B @ magnetic axis
  REAL*8 R_axis(ivec)               ! (output) R @ magnetic axis
  REAL*8 Z_axis(ivec)               ! (output) Z @ magnetic axis

  !-------------------------
  integer :: ier
  logical :: axisymm
  integer :: iv
  !-------------------------

  if(ivec.le.0) return

  call xplasma_global_info(s,ier,axisymm=axisymm)
  if(ier.ne.0) then
     write(lunerr,*) ' ?eq_gaxis: xplasma error:'
     call xplasma_error(s,ier,lunerr)
     call all_zero

  else if(.not.axisymm) then
     write(lunerr,*) ' ?eq_gaxis: non-axisymmetry not yet supported.'
     call all_zero

  else

     call eq_sgaxis(b_axis(1),r_axis(1),z_axis(1))
     do iv=2,ivec
        b_axis(iv)=b_axis(1)
        r_axis(iv)=r_axis(1)
        z_axis(iv)=z_axis(1)
     enddo
  endif

  contains

    subroutine all_zero

      b_axis = 0
      r_axis = 0
      z_axis = 0

    end subroutine all_zero
end subroutine eq_gaxis

subroutine eq_sgaxis(zB,zR,zZ)

  !  get mod(B), R, and Z on the magnetic axis -- axisymmetry expected.

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  real*8, intent(out) :: zB,zR,zZ  ! axial values of mod(B), R, Z

  !-------------------------
  integer :: ier
  logical :: axisymm
  !-------------------------

  call xplasma_global_info(s,ier,axisymm=axisymm)
  if(.not.axisymm) then
     write(lunerr,*) ' ?eq_sgaxis: non-axisymmetry, axial values of mod(B)', &
          ' R and Z not unique.'
     zB=0
     zR=0
     zZ=0
  else

     call xplasma_mag_axis(s,ier, raxis=zR,zaxis=zZ,baxis=zB)
     if(ier.ne.0) then
        write(lunerr,*) ' ?eq_sgaxis: xplasma error:'
        call xplasma_error(s,ier,lunerr)
        zB=0
        zR=0
        zZ=0
     endif

  endif

end subroutine eq_sgaxis

module xplasma_obj_instance_mod

  ! declare an instance of an xplasma object; make this static, shared
  ! global instance publicly available.

  use xplasma_obj, only : xplasma,xpeval, &
       xplasma_init, xplasma_free, xplasma_relabel, &
       xplasma_write, xplasma_read, xplasma_copy, xplasma_avg_elements, &
       xplasma_pack, xplasma_unpack, &
       xpdebug, &
       xplasma_label_item, &
       xplasma_copy_item, xplasma_remove_item, &
       xplasma_find_item, xplasma_get_item_info, &
       xplasma_num_items, xplasma_contents, &
       xplasma_find_grids, xplasma_find_profs, xplasma_find_blkbxs, &
       xplasma_get_counter, xplasma_reset_author, &
       xplasma_listId,xplasma_coordId,xplasma_gridId,xplasma_profId, &
       xplasma_blkbxId, &
       xplasma_author_set, xplasma_author_pause, &
       xplasma_author_resume, xplasma_author_clear, &
       xplasma_author_query, xplasma_remove_author, &
       xplasma_time_set, xplasma_time_get, &
       xplasma_bdytol_set, xplasma_rzOrder_set, &
       xplasma_ajac_maxvar_set, xplasma_field_ccw_set, &
       xplasma_kmom_set, xplasma_misc_set, &
       xplasma_eqCount_incr, &
       xplasma_global_info, xplasma_common_ids, xplasma_set_pressure_id, &
       xplasma_error,xplasma_errmsg_append,xplasma_clear_msgs, &
       xpmom_init,xpmom_setup,xpmom_info,xpmom_get1,xpmom_free, &
       xpmom_protect,xpmom_unprotect, &
       xplasma_create_list,xplasma_merge_lists, &
       xplasma_list_info, xplasma_getList_size, xplasma_getList_names, &
       xplasma_setList_ivals,xplasma_setList_r8vals,&
       xplasma_setList_chvals,xplasma_setList_r4vals, &
       xplasma_getList_ivals,xplasma_getList_r8vals, &
       xplasma_getList_chvals,xplasma_getList_r4vals, &
       xplasma_getList,xplasma_setList

  implicit NONE
  save
  private

  !-----------------------
  ! # of Fourier moments
  !   in Fourier spline equilibrium representation

  integer :: kmom = 16

  !-----------------------
  ! base object pointer

  type (xplasma), public, pointer :: s => NULL()

  ! a couple of spares...

  type (xplasma), public, pointer :: s1 => NULL()
  type (xplasma), public, pointer :: s2 => NULL()

  !----------------------------------
  ! a 100-high stack (private)

  private :: ptr_container

  type :: ptr_container 
     type(xplasma), pointer :: s => NULL()
  end type ptr_container

  integer, parameter, private :: nmax_sstack = 100
  type (ptr_container), dimension(nmax_sstack), private :: sstack
  integer, private :: ncur_sstack = 0

  !-----------------------
  ! private flag if "F77_USER" has been asserted as an author

  logical :: iflag_f77_user = .FALSE.
  
  !-----------------------
  !  the objects themselves...
  !   (these are large objects and so just the pointers will be passed
  !   between subroutine calls).

  type (xplasma), target :: s_obj,s1_obj,s2_obj

  !-----------------------
  
  logical, private :: xplasma_obj_init = .FALSE.

  public :: xoi_init, grab_f77_xplasma, release_f77_xplasma
  public :: xoi_kmom_get, xoi_kmom_set
  public :: xoi_author_set, xoi_author_clear

  contains

    subroutine xoi_init(ier)

      !  check if xplasma instances and pointers are initialized...

      integer, intent(out) :: ier  ! completion code

      integer :: iertmp
      iertmp = 0

      ier = 0
      if(.not.xplasma_obj_init) then

         s => s_obj
         s1 => s1_obj
         s2 => s2_obj

         xplasma_obj_init = .TRUE.

      endif

    end subroutine xoi_init

    subroutine grab_f77_xplasma(swant,ierr)

      ! reset f77 xplasma pointer to point to "swant"; push old pointer
      ! onto stack.  Possible error: stack overflow.

      ! calls to this routine should be paired with "release_f77_xplasma"
      ! calls.

      type (xplasma), pointer :: swant
      integer, intent(out) :: ierr

      !------------------------

      if(.not.xplasma_obj_init) then
         call xoi_init(ierr)
         if(ierr.ne.0) return
      endif

      if(ncur_sstack.eq.nmax_sstack) then
         ierr = 1  ! stack overflow

      else
         ierr = 0
         ncur_sstack = ncur_sstack + 1
         sstack(ncur_sstack)%s => s
         s => swant
      endif

    end subroutine grab_f77_xplasma

    subroutine release_f77_xplasma(ierr)

      ! restore prior xplasma pointer
      ! possible error: stack underflow.  Calls to this routine should
      ! be paired with "grab_f77_xplasma" calls...

      integer, intent(out) :: ierr

      !------------------------

      if(.not.xplasma_obj_init) then
         call xoi_init(ierr)
         if(ierr.ne.0) return
      endif

      if(ncur_sstack.eq.0) then
         ierr = 1  ! stack underflow

      else
         ierr = 0
         s => sstack(ncur_sstack)%s
         ncur_sstack = ncur_sstack - 1
      endif

    end subroutine release_f77_xplasma

    !----------------------------------------------------

    subroutine xoi_kmom_get(ikmom)

      integer, intent(out) :: ikmom

      ikmom = kmom

    end subroutine xoi_kmom_get

    subroutine xoi_kmom_set(ikmom)

      integer, intent(in) :: ikmom

      kmom = max(2,min(64,ikmom))

    end subroutine xoi_kmom_set

    !----------------------------------------------------

    subroutine xoi_author_set(ierr)

      !  see if a write-enabled author is defined; if not, define as F77_USER

      integer, intent(out) :: ierr

      character*32 :: zauth
      logical :: ienable

      call xplasma_author_query(s,zauth,ienable,ierr)
      if(ierr.ne.0) return

      if(.not.ienable) then
         iflag_f77_user = .TRUE.
         call xplasma_author_set(s,'F77_USER',ierr)
      endif

    end subroutine xoi_author_set

    subroutine xoi_author_clear(ierr)

      ! clear F77_USER author, if flag is set

      integer, intent(out) :: ierr

      ierr = 0

      if(iflag_f77_user) then
         iflag_f77_user = .FALSE.
         call xplasma_author_clear(s,'F77_USER',ierr)
      endif

    end subroutine xoi_author_clear
         
end module xplasma_obj_instance_mod

subroutine eqm_rho(zrho,ibdy,ztol,id,ierr)

  use xplasma_obj_instance
  use eq_module

  !  set up rho grid -- must be strict ascending
  !
  !  must be the first discretization of the "rho" coordinate
  !  must span the range [0,1]

  IMPLICIT NONE

  !  input:

  integer, intent(in) :: ibdy       ! #of grid bdy pts -- out to boundary
  REAL*8, intent(in) :: zrho(ibdy)  ! the grid (zone bdys, ibdy-1 zones).
  REAL*8, intent(in) ::  ztol       ! even spacing tolerance

  !  because of spline requirements:
  !    ibdy.ge.4 required

  !  the core plasma is covered by zrho(1:ibdy)

  !  output:

  integer, intent(out) :: id        ! axis id code (returned)
  integer, intent(out) :: ierr      ! =0: OK

  !-----------------

  integer i,inrho,iertmp
  REAL*8 zzrho(ibdy)

  !-------------------------------------------------------------
  !  error checks:

  ierr=0
  id=0

  if(.not.eq_module_init) then
     write(lunerr,*) ' ?eqm_rho: initialization: call eqm_select first!'
     ierr=1
     return
  else 
     call xplasma_coord_info(s,xplasma_rho_coord,ierr, ngrids=inrho)
     if(ierr.ne.0) then
        call xplasma_error(s,ierr,lunerr)
     else if(inrho.gt.0) then
        write(lunerr,*) ' ?eqm_rho: rho already defined!'
        write(lunerr,*) '  re-initialization: call eqm_select first.'
        ierr=1
        return
     endif
  endif
  if(ierr.ne.0) return

  zzrho=zrho
  if(abs(zzrho(1)).le.max(ceps4,ztol)) zzrho(1)=0
  if(abs(zzrho(ibdy)-1).le.max(ceps4,ztol)) zzrho(ibdy)=1
  call eqi_evenx(zzrho,ibdy,ztol)

  call xoi_author_set(ierr)

  call xplasma_create_grid(s,'__RHO',xplasma_rho_coord,zzrho, &
       id,ierr)

  call xoi_author_clear(iertmp)

  return
end subroutine eqm_rho

subroutine eqi_geq_psfind(psi_geq, q_geq, ngeq, xi, ns, fbdy, &
     & psi, phi, q, ier)
  !
  !  EFIT G-EQDSK post-processing routine
  !
  !  find ns psi surfaces which are equally spaced in sqrt toroidal flux,
  !  and which span from psi(mag. axis) to
  !                      fbdy*(psi(separatrix)-psi(mag. axis)), where
  !  `fbdy' is a parameter, slightly less than one, which specifies how
  !  far to pull back from the separatrix (last closed flux surface).
  use xdistrib_mod
  implicit none
  integer, parameter :: r8=selected_real_kind(12,100)
 
  ! ------------------ arguments ---------------------------------
 
  integer, intent(in) :: ngeq        ! no. of pts in G-EQDSK 1d profiles
  real(r8), intent(in) :: psi_geq(ngeq)  ! G-EQDSK psi grid (strict ascending)
  real(r8), intent(in) :: q_geq(ngeq)    ! G-EQDSK q(psi)
 
  integer, intent(in) :: ns          ! no. of surfaces wanted
  real(r8), intent(in) :: xi(ns)     ! spacing of surfaces in sqrt(tor.flux)
                                     ! strict ascending, xi(1)=0, xi(ns)=1
 
  real(r8), intent(in) :: fbdy       ! back-off parameter for outermost surface
 
                                     ! on output psi(1)=0, psi(ns)=
                                     !   fbdy*(psi_geq(ngeq)-psi_geq(1))
 
  real(r8), intent(out) :: psi(ns)   ! the selected psi surfaces
  real(r8), intent(out) :: phi(ns)   ! the enclosed toroidal flux (Wb)
                                     !   satisfying xi(j)=sqrt(phi(j)/phi(ns))
  real(r8), intent(out) :: q(ns)     ! the q profile at {psi(1),...,psi(ns)}
 
  integer, intent(out) :: ier        ! completion code, 0=OK
 
  ! ------------------ local variables and arrays ----------------
 
  integer :: intmp,ixtra(ngeq)
  real(r8), dimension(:), allocatable :: psi_tmp,q_tmp
  !  psi grid (a) truncated for bdy adjustment & (b) with extra points
  !  to resolve sqrt(flux) near axis.

  real(r8) psi_bdy,r8ns,zdpsi
 
  real(r8) xi2(ns)                   ! xi squared ~ normalized tor. flux
  real(r8) tflux
 
  real(r8) zdum,tol,twopi
 
  integer luntty                     ! for messages
 
  integer i,j,ii,iglb,ibrk
 
  ! ------------------ executable code ---------------------------
 
  ! sanity checks
 
  ier = 0
 
  if((fbdy.lt.0.95_R8).or.(fbdy.gt.1.00_R8)) then
     call eqi_fromg_err( &
          ' ?eqi_geq_psfind:  fbdy not between 0.95 and 1.00')
     ier=120
  endif
 
  if((xi(1).ne.0.0_R8).or.(abs(xi(ns)-1.0_R8).gt.0.000001_R8)) then
     call eqi_fromg_err( &
          ' ?eqi_geq_psfind:  xi does not range from 0.00 to 1.00')
     ier=120
  endif
 
  do i=1,ngeq-1
     if(psi_geq(i+1).le.psi_geq(i)) then
        call eqi_fromg_err( &
             & ' ?eqi_geq_psfind:  G-EQDSK psi not in ascending order.')
        ier=1
        exit
     endif
  enddo
 
  do i=1,ns-1
     if(xi(i+1).le.xi(i)) then
        call eqi_fromg_err( &
             & ' ?eqi_geq_psfind:  xi coordinate not in ascending order.')
        ier=1
        exit
     endif
  enddo
 
  if(ier.ne.0) then
     ier=120
     return
  endif
 
  !
  !  ok......... last G-EQDSK psi value wanted:
 
  psi_bdy=psi_geq(1)+fbdy*(psi_geq(ngeq)-psi_geq(1))
 
  ! find GLB of selected psi_bdy in orig. G-EQDSK grid.
 
  do i=1,ngeq
     if(psi_geq(i).lt.psi_bdy) iglb=i
  enddo
 
  ! from this construct a temporary grid which is the same as the
  ! original, except in the edge region
 
  ibrk=max(1,(iglb-1))
  ixtra(ibrk:ngeq)=0
  intmp=ngeq
  if(ibrk.gt.1) then
     r8ns = ns
     ixtra(1) = sqrt(r8ns) - 1   ! pack extra pts near axis due to sqrt
     intmp = intmp + ixtra(1)    ! singularity in resolution
     do i=2,ibrk-1           
        ixtra(i)=ixtra(i-1)/2
        intmp = intmp + ixtra(i)
     enddo
  endif
 
  allocate(psi_tmp(intmp),q_tmp(intmp))

  ii = 0
  do i=1,ngeq
     if(i.le.ibrk) then
        ii=ii+1
        psi_tmp(ii)=psi_geq(i)
        if(ixtra(i).gt.0) then
           !  pack in extrap points
           zdpsi=(psi_geq(i+1)-psi_geq(i))/(ixtra(i)+1)
           do j=1,ixtra(i)
              ii=ii+1
              psi_tmp(ii)=psi_tmp(ii-1)+zdpsi
           enddo
        endif
     else
        ii=ii+1
        psi_tmp(ii)=psi_geq(ibrk) + &
             (i-ibrk)*(psi_bdy-psi_geq(ibrk))/(ngeq-ibrk)
     endif
  enddo
 
  ! interpolate q to this grid
 
  call eqi_geq_intrp(psi_geq, q_geq, ngeq, psi_tmp, intmp, q_tmp, ier)
  if(ier.ne.0) return
 
  !
  ! using relation dphi = q*dpsi, find the desired surfaces
  !
 
  xi2 = xi*xi
 
  tol=1.0e-12_R8
  zdum=0.0_R8
  call xdistrib(2, intmp,psi_tmp,q_tmp, 0,zdum,0,zdum, &
       & ns,xi2,psi, tflux, tol, ier)
  if(ier.ne.0) then
     ier=120
     return
  endif
 
  deallocate(q_tmp,psi_tmp)

  !
  ! ok get the q profile on this grid
  !
 
  call eqi_geq_intrp(psi_geq, q_geq, ngeq, psi, ns, q, ier)
  if(ier.ne.0) return
 
  !
  ! and the toroidal flux...  Wb, not Wb/rad -> factor of 2pi
  !
 
  twopi=6.2831853071795862_R8
  phi = twopi*tflux*xi2
 
  return
 
end subroutine eqi_geq_psfind

module eqi_geq_axis_data

  ! module to contain spline variables used by eqi_geq_axis.f90
  ! and additional routines passed to a rootfinder by eqi_geq_axis
  ! DMC Jan 2011 -- effort to improve reliability of root finder

  implicit NONE
  SAVE

  real*8, dimension(:,:), allocatable :: rpkg,zpkg
  real*8, dimension(:,:,:), allocatable :: psirz_spl

  ! for single point evaluation:

  integer :: ii(1),jj(1)
  real*8 :: rparam(1),zparam(1),hr(1),hri(1),hz(1),hzi(1)

  real*8 :: eqi_eta,eqi_eps

end module eqi_geq_axis_data

subroutine itrans_ptr(isize,iarray)

  ! convert the old_xplasma instance pointer "s" to an integer array
  ! this allows the pointer value to be held in routines that do not
  ! use xplasma definition modules.

  ! the caller must provide an integer array of sufficient size.
  ! for codes using Plasma State definitions, the parameter ps_container_size
  ! defines a safe value.

  use xplasma_obj_instance
  implicit NONE

  integer, intent(in) :: isize   ! integer array size
  integer :: iarray(isize)       ! array to receive pointer data

  !---------------------------
  type :: interp_object

     type (xplasma), pointer :: s_xpobj => NULL()

  end type interp_object
  type (interp_object) :: xobj
  !---------------------------

  xobj%s_xpobj => s

  iarray = 0
  iarray = transfer(xobj, iarray)

end subroutine itrans_ptr

subroutine eqm_tbdy(ilines,rl,zl,thl,icircs,rc,zc,rad,ierr)

  !  set up a TRANSP-style machine boundary specification.  This consists
  !  two lists:  a list of circles (R,Z) & radius, and a list of infinite
  !  lines (R,Z) and inclination angle, thl (degrees).

  !  for each circle, the plasma is excluded from the space inside
  !  the circle (sign=-1.) or is excluded from the space outside
  !  (sign=+1.).  The sign is determined by whether the plasma magnetic
  !  axis point (R0,Z0) is inside or outside the circle.

  !  for each infinite line, a start point and orientation angle are
  !  given.  the angle (thl) is in degrees, with convention:

  !    thl(i)=0.0d0 -- horizontal orientation
  !    thl(i)=45.0d0 -- line goes up & to right (+R,+Z) & down to left (-R,-Z)
  !    thl(i)=90.0d0 -- vertical orientation

  !  **CAUTION TRANSP USERS** in TRANSP limiters theta=45.0d is up and to
  !  the left (-R,+Z). -- this is a different convention ***

  !  each line partitions space into two regions, from one of which the
  !  plasma is excluded.  Using (R0,Z0) to test, a sign value is assigned
  !  which determines which half plane is excluded.

  !  the result:  excluded space = union of all excluded spaces of
  !                 individual circle/line "limiters".

  !               included space = all space - excluded space

  !  the plasma boundary must lie entirely inside the included space.
  !  this routine test for this-- if this test fails the error flag is
  !  set.

  !  NOTE -- this routine also makes a "sanity limiter" with ample space
  !  around the plasma equilibrium boundary (which is presumed known).
  !  Because of this, it would be well to call this routine after each
  !  equilibrium update, if it is used at all.
  !-----------------------

  use xplasma_obj_instance
  use eq_module
 
  implicit NONE

  !  input:

  integer ilines                    ! # of line limiters (can be zero)
  real*8 rl(ilines),zl(ilines)      ! (R,Z) starting point of line(s)
  real*8 thl(ilines)                ! in DEGREES, line orientation

  integer icircs                    ! # of circle limiters (can be zero)
  real*8 rc(icircs),zc(icircs)      ! (R,Z) center of circle(s)
  real*8 rad(icircs)                ! radius of circle(s)

  !  output:

  integer ierr                      ! completion code, 0=OK
      
  !-----------------------
  integer iwarn
  real*8 zrmin,zrmax,zzmin,zzmax,zdelr,zdelz
  !-----------------------

  call eq_glimrz(cone,zrmin,zrmax,zzmin,zzmax,ierr)
  if(ierr.ne.0) return

  if((ilines.le.0).and.(icircs.le.0)) then
     call eq_errmsg(' ?eqm_tbdy:  no limiters specified.')
     ierr=2
     return
  endif

  !  4 line-type "sanity check" limiters:
  !  horizontal, vertical from expanded (zrmin,zzmin), &
  !  horizontal, vertical from expanded (zrmax,zzmax)

  zdelr=chalf*(zrmax-zrmin)
  zdelz=chalf*(zzmax-zzmin)

  zrmin=max(chalf*zrmin,zrmin-zdelr)
  zrmax=zrmax+zdelr

  zzmax=zzmax+min(zdelr,zdelz)
  zzmin=zzmin-min(zdelr,zdelz)

  !-----------------------------------------

  call xplasma_mklim_special(s,iwarn,ierr, &
       Rmin=zRmin, Rmax=zRmax, Zmin=zZmin, Zmax=zZmax, &
       nlines=ilines, Rl=rl, Zl=zl, thl=thl, &
       ncircs=icircs, Rc=rc, Zc=zc, rad=rad)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqm_tbdy: xplasma_mklim_special error:'
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eqm_tbdy

subroutine eqi_irhofun(id_axis,zlbl,inprof,zprof,iflag,zsm,id,ierr)

  use xplasma_definitions
  use eqi_rzbox_module

  !  make XPLASMA profile -- integrated quantity; smooth by 1/2 zone width
  !  to insure smooth derivative from spline; preserve integrated result.

  !  the input quantity is I(x) = integral[0 to x]{f(x)*(dV/dx)*dx}
  !  where V is volume (iflag=1), area (iflag=2), or a suitable user defined 
  !  quantity (iflag=<xplasma profile id>)

  !  the output quanity is a spline of a smoothed version of I(x) which
  !  preserves the integral at x=1.

  !  mod DMC Apr 2009 -- recoded (too many artifacts in the old method)
  !  synopsis:
  !    infer f(x), smooth this, recompute I(x), apply renormalization

  !  details: we actually treat a positive definite function
  !    g(x) = f(x) - min(f), min(f)=<minimum value of f(x) over x in [0:1]>
  !    g(x) is smoothed, its integral is preserved, I(min(f)) is added back in.

  implicit NONE
  integer, intent(in) :: id_axis    ! axis id -- must be rho or akin to rho
  character*(*), intent(in) :: zlbl ! name for profile function to be created
  integer, intent(in) :: inprof     ! size of the integrated data profile
  real*8, intent(in) :: zprof(inprof) ! the integrated data provided
                         ! if inprof = size(x_axis) zprof(1)=0 is expected
                         ! if inprof = size(x_axis)-1 the axial data point
                         !    is presumed to be omitted.
  integer, intent(in) :: iflag      ! =1 -- volume normalization;
                         ! derivative evaluations -> W/m^3, #/sec/m^3, etc.
                                    ! =2 -- area normalization;
                         ! derivative evaluations -> A/m^2 (current density).
                                    ! = <id> -- user provided normalization.

  real*8, intent(in) :: zsm         ! smoothing width
  !  a multiplier of max(1,zsm/(x(2)-x(1))) is applied to the smoothing
  !  width (= the local grid spacing); if zsm=0.0 use the standard 1/2 zone 
  !  width smooth, i.e. smoothing delta = local grid spacing.

  integer, intent(out) :: id        ! id of stored profile (if successful)
  integer, intent(out) :: ierr      ! completion code, 0=OK.

  !  if an error occurs and ierr is set, id=0 will be returned.

  !-------------------------
  !  local variables:
  integer isize                ! orig. gridsize, including mag. axis
  integer isizp                ! augmented gridsize = isize + 1

  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  real*8, parameter :: ZERO = 0.0_R8
  real*8, parameter :: HALF = 0.5_R8
  real*8, parameter :: ONE = 1.0_R8
  real*8, parameter :: TWO = 2.0_R8
  real*8, parameter :: THREE = 3.0_R8
  real*8, parameter :: QUARTER = 0.25_R8
  real*8, parameter :: zltol = 1.0e-9_R8

  real*8 :: zsmul

  !  the x axis grid and corresponding volumes (or analogous V(x)).
  real*8, dimension(:), allocatable :: zxgrid0,zv0

  real*8 :: zfmin,zfmax,zdv,zvol,zgnorm

  !  the derived function on a shifted grid, and its smoothed version:
  real*8, dimension(:), allocatable :: zxgrid,zg,zgsm

  !  the original & reconstructed profiles I(x); latter is splined
  real*8, dimension(:), allocatable :: zi0,zi1
  
  !  delta & epsln profiles for smoothing...
  real*8, dimension(:), allocatable :: zdelta,zepsln
  real*8 :: zdum1,zx
  integer :: ix,i,j,idum2,idum3

  integer :: idum,ier0
  character*120 zmsg

  !-------------------------

#ifdef __DEBUG

  integer :: inbdbg
  common/nbdbg_com1/ inbdbg   ! zeroed in nbstart; set .gt.0 for plots

  integer :: inzons,inxx,inext,iprev
  real*8, dimension(:), allocatable :: zxx,zf1,zf2

#endif
  
  id = 0
  ierr = 0

  call xplasma_grid_size(sp,id_axis,isize,ierr)
  if((ierr.ne.0).or.(isize.eq.0)) then
     zmsg=' '
     write(zmsg,*) ' ?eqi_irhofun: invalid id_axis: ',id_axis
     call xplasma_errmsg_append(sp,trim(zmsg))
     ierr=501
     return
  endif

  if(inprof.eq.isize) then
     if(zprof(1).ne.ZERO) then
        zmsg=' '
        write(zmsg,*) ' ?eqi_irhofun: integrated profile expected, value'
        call xplasma_errmsg_append(sp,trim(zmsg))
        zmsg=' '
        write(zmsg,*) '  on axis should be ZERO, instead got: ',zprof(1)
        call xplasma_errmsg_append(sp,trim(zmsg))
        ierr=9999
        return
     endif
  else if(inprof.ne.(isize-1)) then
     zmsg=' '
     write(zmsg,*) ' ?eqi_irhofun: # of points in profile (inprof): ',inprof
     call xplasma_errmsg_append(sp,trim(zmsg))
     zmsg=' '
     write(zmsg,*) '  inconsistent with gridsize (axis id, size): ', &
          id_axis,isize
     call xplasma_errmsg_append(sp,trim(zmsg))
     ierr=9999
     return
  endif

  ! OK........

  allocate(zxgrid0(isize),zv0(isize),zi0(isize),zi1(isize))
  call xplasma_grid(sp,id_axis,zxgrid0,ier0)

  zi0(1)=ZERO
  if(inprof.eq.(isize-1)) then
     zi0(2:isize)=zprof
  else
     zi0 = zprof
  endif

  if(max(abs(zxgrid0(1)),abs(zxgrid0(isize)-ONE)).gt.zltol) then
     zmsg=' '
     write(zmsg,*) ' ?eqi_irhofun: base grid does not cover range [0,1]: ', &
          zxgrid0(1),zxgrid0(isize)
     call xplasma_errmsg_append(sp,trim(zmsg))
     ierr=9999
     deallocate(zv0,zi0,zi1,zxgrid0)
     return
  endif

  ! smoothing width factor: based on central zone spacing, zone spacing
  ! could vary radially

  ! minimum smoothing based on grid spacing; maximum is (1/4) the profile
  ! width, with the multiplier corresponding to this estimated at rho=0:

  zsmul = max(ONE,min( zsm/(zxgrid0(2)-zxgrid0(1)), &
       QUARTER*(zxgrid0(isize)-zxgrid0(1))/(zxgrid0(2)-zxgrid0(1)) ))

  ! V(x)

  if(iflag.eq.1) then
     call xplasma_volume(sp,zxgrid0,zv0,ier0)
  else if(iflag.eq.2) then
     call xplasma_area(sp,zxgrid0,zv0,ier0)
  else
     call xplasma_eval_prof(sp,iflag,zxgrid0,zv0,ier0)
  endif

  zvol = zv0(isize)

  do ix=2,isize
     zdv = zv0(ix)-zv0(ix-1)
     if(zdv.le.ZERO) then
        zmsg=' '
        write(zmsg,*) &
             ' ?eqi_irhofun: volume weighting not monotonic increasing:'
        call xplasma_errmsg_append(sp,trim(zmsg))
        zmsg=' '
        write(zmsg,'(" V(",i4,")=",1pe11.4," V(",i4,")=",1pe11.4)') &
             ix-1,zv0(ix-1),ix,zv0(ix)
        call xplasma_errmsg_append(sp,trim(zmsg))
        ierr=9999
        deallocate(zv0,zi0,zi1,zxgrid0)
        return
     endif
  enddo

  ! form working grid: zone centers + extra point at bdys

  isizp=isize+1

  allocate(zxgrid(isizp),zg(isizp),zgsm(isizp))
  allocate(zepsln(isizp),zdelta(isizp))
  zxgrid(1)=ZERO
  zxgrid(isizp)=ONE
  do ix=2,isize
     zxgrid(ix)=HALF*(zxgrid0(ix-1)+zxgrid0(ix))
     zdelta(ix)=zsmul*(zxgrid0(ix)-zxgrid0(ix-1))
     zdv = zv0(ix)-zv0(ix-1)
     zg(ix) = (zi0(ix)-zi0(ix-1))/zdv
     if(ix.eq.2) then
        zfmin = zg(ix)
        zfmax = zg(ix)
     else
        zfmin = min(zfmin,zg(ix))
        zfmax = max(zfmax,zg(ix))
     endif
  enddo

  if(zfmin.eq.zfmax) then
     ! no radial variation
     zi1 = zi0

  else
     zg(1)=zg(2)
     zg(isizp)=zg(isize)

     zdelta(1)=zdelta(2)
     zdelta(isizp)=zdelta(isize)

     do ix=1,isizp
        zepsln(ix)=zfmax-zfmin
        zg(ix)=zg(ix)-zfmin
     enddo

     zgnorm = zi0(isize) - zfmin*zvol

     call r8filtr6(zxgrid,zg,zgsm,isizp,zepsln,isizp,zepsln,0,zdelta, &
       0,ZERO,0,ZERO,ONE,ONE,zdum1,idum2,idum3)

     ! reconstruct integrated profile

     zi1(1)=ZERO
     do ix=2,isize
        zdv = zv0(ix)-zv0(ix-1)
        zi1(ix)=zi1(ix-1) + zdv*zgsm(ix)
     enddo

     ! check normalization (zg,zgsm were constructed positive definite)

     zgnorm = zgnorm/zi1(isize)

     ! apply
     do ix=2,isize
        zx=zxgrid0(ix)
        zi1(ix)=zi1(ix)*zgnorm
     enddo

     ! add in constant part
     zvol=ZERO
     do ix=2,isize
        zdv=zv0(ix)-zv0(ix-1)
        zvol=zvol+zdv
        zi1(ix)=zi1(ix)+zfmin*zvol
     enddo
  endif

  !  now create the function as a spline; f'(x)=0 on axis, not a knot @bdy

  call xplasma_create_1dprof(sp,zlbl,id_axis,zi1,id,ierr, &
       ispline=2,ibca=1,zbca=ZERO)

#ifdef __DEBUG
  if((ierr.eq.0).and.(id.gt.0).and.(inbdbg.gt.0)) then
     inzons=isize-1
     allocate(zxx(10*inzons+1),zf1(10*inzons+1),zf2(10*inzons+1))

     zxx(1)=zxgrid0(1)
     zf1(1)=zi0(1)
     inext=1
     do i=1,inzons
        iprev=inext
        inext=iprev+10
        zxx(inext)=zxgrid0(1+i)
        zf1(inext)=zi0(1+i)
        do j=1,9
           zxx(iprev+j)=zxx(iprev)+j*(zxgrid0(1+i)-zxgrid0(i))/10
           zf1(iprev+j)=zi0(i)+j*(zi0(i+1)-zi0(i))/10
        enddo
     enddo

     call xplasma_eval_prof(sp,id,zxx,zf2,ierr)

     call r8_grafx2(zxx,zf1,zf2,10*inzons+1,'x',' ', &
          'eqi_irhofun debug plot',' ',zlbl)

     deallocate(zxx,zf1,zf2)
  endif
#endif

  deallocate(zxgrid0,zv0,zi0,zi1)
  deallocate(zxgrid,zg,zgsm,zepsln,zdelta)

end subroutine eqi_irhofun

subroutine eqx_dfast(ivec,xx,yy,zz,zdist,ierr)

  !  using fast map, find approximate distance to plasma boundary

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  integer ivec
  REAL*8 xx(ivec),yy(ivec),zz(ivec) ! cartesian target points

  !  output:

  REAL*8 zdist(ivec)                ! distance outside surface;

  integer ierr                      ! completion code, 0=OK

  !  if zdist.lt.0.0 then point is *inside* the surface;
  !  if zdist.eq.0.0 then the point is *on* the surface.
  !--------------------------
  integer :: maptype
  real*8 :: zR(ivec)
  !--------------------------
  
  call xplasma_max_maptype(s,maptype,ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' xplasma_max_maptype call error in eqx_dfast:'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  call xplasma_ctrans(s,xp_use_coord_vecsize,ierr, &
       x_in=xx, y_in=yy, r_out=zR)
  if(ierr.ne.0) then
     write(lunerr,*) ' xplasma_ctrans call error in eqx_dfast:'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  call xplasma_bdfind(s,ivec,zR,zZ,ierr, maptype=maptype, dist=zdist)
  if(ierr.ne.0) then
     write(lunerr,*) ' xplasma_bdfind call error in eqx_dfast:'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

end subroutine eqx_dfast

!--------------------------------------------------------------------
subroutine eq_dfast(ivec,zR,zZ,zphi,zdist,ierr)

  !  **vectorized** dmc Apr 2000
  !  using fast map, find approximate distance to plasma boundary

  !  to begin the search, evaluate a coarse grid of points and look
  !  for the distance minima; use a root finder to zero in exactly
  !  (to machine precision).

  !  input:

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  integer ivec                        ! vector length
  REAL*8 zR(ivec),zZ(ivec),zphi(ivec) ! target point

  !  output:

  REAL*8 zdist(ivec)                  ! distance outside surface;

  integer ierr                        ! completion code, 0=OK

  !  if zdist.lt.0.0 then point is *inside* the surface;
  !  if zdist.eq.0.0 then the point is *on* the surface.
  !------------------------------------------------------------
  integer :: maptype
  !--------------------------
  
  call xplasma_max_maptype(s,maptype,ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' xplasma_max_maptype call error in eq_dfast:'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  call xplasma_bdfind(s,ivec,zR,zZ,ierr, maptype=maptype, dist=zdist)
  if(ierr.ne.0) then
     write(lunerr,*) ' xplasma_bdfind call error in eq_dfast:'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

end subroutine eq_dfast

module geqdsk_index_mod

  implicit NONE
  save

  !  compound data type contains all information in an EFIT_INDEX file
  !  sample contents:
  !    "ntimes=4"
  !    "path='/pub/outgoing/pshare'"
  !    "time=0.15   filename=g008500.00150"
  !    "time=0.20   filename=g008500.00200"
  !    "time=0.25   filename=g008500.00250"
  !    "time=0.294  filename=g008500.00294"

  !  file contains list of EFIT G-eqdsk files, each associated with a time
  !  value.

  type geqdsk_index
     character*128 :: path      ! path to index file itself
     character*128 :: ifname    ! index filename (not including directory path)

     integer :: ntimes          ! no. of time points "ntimes"
     integer :: nguard          ! initialization state (-999 = OK)
     integer :: ntime2          ! no. of time points (file records)

     real*8, dimension(:), allocatable :: times         ! time vector
     character*20, dimension(:), allocatable :: ctimes  ! time vector (char)
     character*128, dimension(:), allocatable :: efiles ! associated filenames

  end type geqdsk_index

  !---------------------------------------------------------
  ! a single instance is provided here...

  logical :: geqdsk_index1_init = .FALSE.
  type (geqdsk_index) :: geqdsk_index1

  !---------------------------------------------------------

  private :: fn_split,parse,rshift,g1val  ! private methods...

  contains

    subroutine geqdsk_index_preset(geqi)

      !  put geqdsk_index object into defined but empty state

      type(geqdsk_index), intent(inout) :: geqi ! geqdsk_index object

      geqi%path=' '
      geqi%ifname=' '
      geqi%ntimes=0
      geqi%ntime2=0
      geqi%nguard=-999
      if(allocated(geqi%times)) deallocate(geqi%times)
      if(allocated(geqi%ctimes)) deallocate(geqi%ctimes)
      if(allocated(geqi%efiles)) deallocate(geqi%efiles)

    end subroutine geqdsk_index_preset

    subroutine geqdsk_index_clear(geqi)

      !  clear contents of geqdsk_index object

      type(geqdsk_index), intent(inout) :: geqi ! geqdsk_index object

      if(geqi%nguard.eq.-999) then
         geqi%path=' '
         geqi%ifname=' '
         geqi%ntimes=0
         geqi%ntime2=0
         if(allocated(geqi%times)) deallocate(geqi%times)
         if(allocated(geqi%ctimes)) deallocate(geqi%ctimes)
         if(allocated(geqi%efiles)) deallocate(geqi%efiles)
      else
         call geqdsk_index_preset(geqi)
      endif
    end subroutine geqdsk_index_clear

    subroutine geqdsk_index_msg(geqi,ierr,ilunmsg)

      type(geqdsk_index), intent(inout) :: geqi ! geqdsk_index object
      integer, intent(in) :: ierr     ! error code
      integer, intent(in) :: ilunmsg  ! logical unit for message

      !  CONTENTS of geqi are cleared at end of this routine ***

      if(ierr.eq.1) then
         write(ilunmsg,*) ' ?geqdsk_index_mod: blank filename.'
      else if(ierr.eq.2) then
         write(ilunmsg,*) ' ?geqdsk_index_mod: file open failure.'
      else if(ierr.eq.3) then
         write(ilunmsg,*) ' ?geqdsk_index_mod: file record parse failure.'
      else if(ierr.eq.4) then
         write(ilunmsg,*) ' ?geqdsk_index_mod: time value before ntimes defined.'
      else if(ierr.eq.5) then
         write(ilunmsg,*) ' ?geqdsk_index_mod: time records out of order.'
      else if(ierr.eq.6) then
         write(ilunmsg,*) ' ?geqdsk_index_mod: no. of times does not match ntimes.'
         write(ilunmsg,*) '  "ntimes" in file: ',geqi%ntimes
         write(ilunmsg,*) '  From counting EFITS: ',geqi%ntime2
      else
         write(ilunmsg,*) ' ?geqdsk_index_mod: error (unspecified).'
      endif

      call geqdsk_index_clear(geqi)

    end subroutine geqdsk_index_msg

    subroutine geqdsk_index_init(ilun,filename,geqi,ierr)

      !  initialize a geqdsk_index object from an ascii file
      !  if there is a leading string "EFIT_INDEX:" ignore it.

      integer, intent(in) :: ilun               ! fortran i/o unit no. to use.
      character*(*), intent(in) :: filename     ! file containing data for geqi
      type(geqdsk_index), intent(inout) :: geqi ! geqdsk_index object
      integer, intent(out) :: ierr              ! completion code, 0=OK

      !-----------------------
      character*128 ifpath
      character*128 ifname
      character*128 zbuf,zval1,zval2
      character*10 :: cival
      character*20 :: cgval
      integer i,j,ilen,istat,itimes,itype
      !-----------------------
      !  get filename...

      call fn_split(filename,ifname,ifpath,ierr)  ! split into path & filename
      if(ierr.ne.0) return

      ! does it match object current object contents?
      if((ifpath.eq.geqi%path).and.(ifname.eq.geqi%ifname)) then
         return  ! object already initialized from file
      endif

      ! no: initialize object from file.  First, open the file...
      call geqdsk_index_clear(geqi)  ! and clear old object contents

      open(unit=ilun,file=trim(ifpath)//trim(ifname),status='old',iostat=istat)
      if(istat.ne.0) then
         close(unit=ilun,iostat=istat)
         ierr=2
         return  ! open failure.
      endif

      ! opened OK; read contents

      itimes=-1

      do
         read(ilun,'(A)',end=888) zbuf

         if (len_trim(zbuf)==0) cycle

         call parse(zbuf,itype,zval1,zval2)

         if(itype.eq.0) then
            ierr=3
            exit

         else if(itype.eq.1) then
            ! ntimes=<no. of times> record
            if(zval2.ne.' ') then
               ierr=3
               exit
            endif
            call rshift(zval1,cival)
            read(cival,'(i10)',iostat=istat) geqi%ntimes
            if(istat.ne.0) then
               ierr=3
               exit
            endif
            itimes=0  ! OK can read times now...
            allocate(geqi%times(geqi%ntimes))
            allocate(geqi%ctimes(geqi%ntimes))
            allocate(geqi%efiles(geqi%ntimes))

         else if(itype.eq.2) then
            ! path=<file-path> record  -- ignore
            continue

         else if(itype.eq.3) then
            ! time=<time-val> filename=<filename>
            if(itimes.lt.0) then
               ierr=4
               exit
            endif
            itimes=itimes+1

            if(itimes.gt.geqi%ntimes) cycle

            geqi%ctimes(itimes)=zval1
            geqi%efiles(itimes)=zval2
            call rshift(zval1,cgval)
            read(cgval,'(g20.0)',iostat=istat) geqi%times(itimes)
            if(istat.ne.0) then
               ierr=3
               exit
            endif
            if(itimes.gt.1) then
               if(geqi%times(itimes-1).ge.geqi%times(itimes)) then
                  ierr=5
                  exit
               endif
            endif
         endif
      enddo
888   continue
      close(unit=ilun)
      geqi%ntime2 = itimes
      if(ierr.eq.0) then
         if(itimes.ne.geqi%ntimes) then
            ierr=6
         endif
      endif

      geqi%path=ifpath
      geqi%ifname=ifname
    end subroutine geqdsk_index_init

    subroutine fn_split(filename,ifname,ifpath,ierr)

      ! split into path & filename

      character*(*), intent(in) :: filename
      character*(*), intent(out) :: ifname
      character*(*), intent(out) :: ifpath
      integer, intent(out) :: ierr

      integer i,ilen,istart
      character*10 ztest

      ierr=0
      ifname=' '
      ifpath=' '
      ilen=len_trim(filename)
      if(ilen.eq.0) then
         ierr=1  ! non-blank input expected
         return
      endif

      ! exclude leading "EFIT_INDEX:" if present...

      istart=1
      i=index(filename,':')
      if(i.gt.0) then
         ztest=filename(1:10)
         call uupper(ztest)
         if(ztest.eq.'EFIT_INDEX') then
            istart=i+1
         endif
      endif

      if(index(filename,'/').eq.0) then
         ifname=filename(istart:)
         ifpath=' '
      else
         do i=ilen,istart,-1
            if(filename(i:i).eq.'/') then
               if(i.eq.ilen) then
                  ierr=1  ! trailing "/" not expected...
               else
                  ifname=filename(i+1:ilen)
                  ifpath=filename(istart:i)
               endif
               exit
            endif
         enddo
      endif

    end subroutine fn_split

    subroutine rshift(zinval,zrsval)
      character*(*), intent(in) :: zinval  ! input value
      character*(*), intent(out) :: zrsval ! value right shifted

      integer :: irlen,iilen

      zrsval=' '
      iilen=len_trim(zinval)
      if(iilen.eq.0) return

      irlen=len(zrsval)
      if(iilen.gt.irlen) return

      zrsval(irlen-iilen+1:irlen)=zinval(1:iilen)
    end subroutine rshift

    subroutine parse(zbuf,itype,zval1,zval2)
      character*(*), intent(in) :: zbuf    ! line read from file
      integer, intent(out) :: itype
      character*(*), intent(out) :: zval1,zval2

      !  parse line:
      !   type 1:   ntimes=<no. of times>
      !   type 2:   path=<path-string>
      !   type 3:   time=<time-value>  filename=<filename-string>

      character*10 :: ztest
      character*128 :: part2
      integer :: ieqs,i,ii,ifin

      zval1=' '
      zval2=' '
      itype=0

      ieqs=index(zbuf,'=')
      if(ieqs.eq.0) return

      ztest=' '
      ii=0
      do i=1,ieqs-1
         if(zbuf(i:i).ne.' ') then
            ii=ii+1
            if(ii.gt.len(ztest)) exit
            ztest(ii:ii)=zbuf(i:i)
         endif
      enddo

      call uupper(ztest)
      if(ztest.eq.'NTIMES') then
         itype=1
         call g1val(zbuf,ieqs+1,zval1,ifin)
      else if(ztest.eq.'PATH') then
         itype=2
         call g1val(zbuf,ieqs+1,zval1,ifin)
      else if(ztest.eq.'TIME') then
         itype=3
         call g1val(zbuf,ieqs+1,zval1,ifin)
         ieqs=index(zbuf(ifin:),'=')
         if(ieqs.eq.0) then
            itype=0
            zval1=' '
         else
            ieqs=ieqs+ifin-1
            ii=0
            do i=ifin,ieqs-1
               if(zbuf(i:i).ne.' ') then
                  ii=ii+1
                  if(ii.gt.len(ztest)) exit
                  ztest(ii:ii)=zbuf(i:i)
               endif
            enddo
            call uupper(ztest)
            if(ztest.ne.'FILENAME') then
               itype=0
               zval1=' '
            else
               call g1val(zbuf,ieqs+1,zval2,ifin)
            endif
         endif
      else
         itype=0
      endif

    end subroutine parse

    subroutine g1val(zbuf,istart,zval,ifin)
      character*(*), intent(in) :: zbuf  ! input buffer
      integer, intent(in) :: istart      ! scan start
      character*(*), intent(out) :: zval ! value extracted
      integer, intent(out) :: ifin       ! position beyond end of value

      integer :: ii,jj,ilen

      ilen=len_trim(zbuf)

      zval=' '
      ii=istart-1
      jj=0
      do 
         ii=ii+1
         if(ii.gt.ilen) exit

         if((zbuf(ii:ii).ne.' ').and.(zbuf(ii:ii).ne."'").and. &
              (zbuf(ii:ii).ne.'"')) then
            jj=jj+1
            zval(jj:jj)=zbuf(ii:ii)
         else
            if((zbuf(ii:ii).eq.' ').and.(jj.gt.0)) exit
         endif
      enddo
      ifin=ii

    end subroutine g1val

end module geqdsk_index_mod

subroutine eqi_geq_mds_psiminr(ns,lmask,rr,dpsidr,idum,zerr,idum2,dpsidz,id2)
 
  use eqi_geq_mds_mod
  implicit NONE
  integer, parameter :: r8=selected_real_kind(12,100)
 
  !
  ! rootfinder (zridderx) subroutine -- 
  !    find minimum (dpsi/dR = 0) point along line of fixed Z=z0.
  !
  ! z0 and psi spline, are all in eqi_geq_mds_mod
  !
  !------------------------------ passed
 
  integer, intent(in) :: ns        ! no. of surfaces
  logical, intent(in) :: lmask(ns) ! mask surfaces where soln is known
 
  real(r8), intent(in) :: rr(ns)   ! R value to try now
 
  real(r8), intent(out) :: dpsidr(ns) ! d(psi)/dR returned
 
  integer, intent(in) :: idum,idum2,id2
 
  real(r8), intent(out) :: zerr(ns)   ! =0; set =1 if error occurs
 
  real(r8), intent(out) :: dpsidz(ns) ! d(psi)/dZ returned
 
  !------------------------------ local
 
  integer jvec,j,ier
  real(r8) rtmp(ns),ztmp(ns),psitmp(ns),zgrad(ns,2)
 
  !------------------------------ executable code
 
  jvec=0
  do j=1,ns
     if(.not.lmask(j)) then
        jvec=jvec+1
        rtmp(jvec)=rr(j)
        ztmp(jvec)=z0
     endif
  enddo
 
  !
  !  R0,Z0 and RPP,ZPP are inside the mapped region
  !  0 < x(j) < 1  --> rtmp,ztmp are inside mapped region
  !  so spline call should be safe
  !
 
  call ezspline_gradient(pspl, jvec, rtmp, ztmp, zgrad, ier)
  if(ier.ne.0) then
     zgrad=0
     zerr=1
  else
     zerr=0
  endif
 
  jvec=0
  do j=1,ns
     if(.not.lmask(j)) then
        jvec=jvec+1
        dpsidr(j)=zgrad(jvec,1)
        dpsidz(j)=zgrad(jvec,2)
     endif
  enddo
 
  return
end subroutine eqi_geq_mds_psiminr

SUBROUTINE scrmomintrp(rmcx,zmcx,xsize,imomuse,ic0,icc,idim1,immax,inpts,ier)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, one, two, twopi
  use mintrp
  implicit none
  integer :: idim1
  integer :: itheta
  real(fp) :: ztest
  real(fp) :: rtest
  real(fp) :: scrYceptcon
  real(fp) :: y
  real(fp) :: x
  real(fp) :: zstat
  real(fp) :: xguessp
  real(fp) :: zftol
  real(fp) :: zxtol
  real(fp) :: delx
  real(fp) :: xguess
  real(fp) :: zxmax
  integer :: ic2
  integer :: ics
  integer :: ic0  ! index to axis
  integer :: im
  real(fp)   :: xsize(idim1)
  integer :: imomuse(idim1)
  real(fp) :: ztheta
  integer :: ith
  integer :: ic
  integer :: i
  integer :: ier
  integer :: ichkn
  integer :: inpts
  integer :: immax
  integer :: icskip,icx,ica

  !
  !  dmc 26 June 1997
  !  use a low order rotated polynomial interpolation to fill theta
  !  lines btw scrunched surfaces; use fft to extract moments at
  !  interpolated (non-scrunched) surfaces, truncating to use only
  !  imomuse(j) moments at the j'th surface
  !
  real(fp) :: rmcx(idim1,0:immax,2),zmcx(idim1,0:immax,2)
  integer icc(6)

  real(fp) :: rmcx1(0:immax,2),zmcx1(0:immax,2),xsw,wsw,xsrch0
  !
  real(fp), dimension(:,:), allocatable :: rwork, zwork
  !
  ! !
  !  ncmax -- max no. of surfaces (array dimension) in MINTRP
  !  immax -- max no. of moments  (array dimension) in MINTRP
  !
  !  imomuse(...)  -- actual no. of moments to use
  !  icc (moption.eq.2)
  !           icc(1) gives index of inmost scrunched surface
  !           icc(4) gives index of outermost scrunched surface
  !           icc(2) gives a scrunched surface at r/a ~ 0.5
  !           icc(3) gives index of surface near outside for numerical
  !                  diffentiation of theta line direction...
  !  icc (moption.eq.3)
  !           icc(1:3) gives ordered index of near-axis surfaces
  !           icc(6) gives index of outermost scrunched surface
  !           icc(4) gives a scrunched surface at r/a ~ 0.5
  !           icc(5) gives index of surface near outside for numerical
  !                  diffentiation of theta line direction...
  !
  ! input and modified:
  !  rmcx(...) and zmcx(...) -- on input, moments at the scrunched surfaces
  !           only; on output, moments sets for all surfaces
  !
  ! output:
  !  ier -- completion code.  0=success.
  !
  ! workspace:
  !  rwork(...) and zwork(...) (R,Y) expansions workspaces
  !  inpts -- 1st dimension of workspaces
  !
  !  an fft is used with rows of rwork and zwork to get the intermediate
  !  moments sets.
  !
  !---------------------------------------
  !  external function f(x), solve f(x)=0 for x to find the
  !  theta-line | flux-surface intercept
  !
  external scrXceptcon
  !
  !---------------------------------------
  !  local:
  !
  !  for moments expansion evaluation:  sincos ladder
  real(fp) :: zsn(100),zcs(100)
  !
  !  fft output arrays -- dimension should match largest value of ichk!
  !
  real(fp) :: zs1d(128),zc1d(128)
  !
  !  fft workspace arrays -- largest value of ichk, +1
  !
  real(fp) :: zsq,zdel,ztol

  parameter(ichkn=4)
  integer ichk(ichkn)
  integer ilim,imoms
  !
  integer lunmsg
  !
  logical lyes
  !------
  !
  data ichk/16,32,64,128/
  !
  !-------------------------------------------------------------------
  !
  call scrgetlun(lunmsg)
  !
  ! local stack arrays
  ALLOCATE(rwork(inpts+1,idim1),zwork(inpts+1,idim1)); rwork=0; zwork=0
  !
  !
  !  0.  error check
  !
  ier=0
  if(moption.eq.3) then
    if(icc(1).ge.icc(2)) ier=1
    if(icc(2).ge.icc(3)) ier=1
    if(icc(3).ge.icc(4)) ier=1
    if(icc(4).ge.icc(5)) ier=1
    if(icc(5).ge.icc(6)) ier=1
    if(icc(6).gt.ncmax) ier=2
    ilim=0
    icskip=5
  else if(moption.eq.2) then
    if(icc(1).ge.icc(2)) ier=1
    if(icc(2).ge.icc(3)) ier=1
    if(icc(3).ge.icc(4)) ier=1
    if(icc(4).gt.ncmax) ier=2
    ilim=0
    icskip=3
  endif
  !
  if(ier.eq.1) then
    write(lunmsg,'('' ?momintrp -- icc argument order error'')')
  else if(ier.eq.2) then
    write(lunmsg,'('' ?momintrp -- icc argument limit error'')')
  endif
  if(ier.gt.0) go to 1000
  !
  ier=3
  do i=1,ichkn
    if(inpts.eq.ichk(i)) ier=0
  enddo
  !
  if(ier.eq.3) then
    write(lunmsg, &
         '('' ?momintrp -- 1st work array dimension not of form 2**N'')')
    write(lunmsg, &
         '('' ?            or too small or too large.'')')
    go to 1000
  endif
  !
  !  1.  expand the already scrunched surfaces
  !
  do i=1,6
    ic=icc(i)
    if(ic.gt.0) then
      do ith=1,inpts
        ztheta=(ith-1)*twopi/inpts
        imoms=max(ilim,imomuse(ic))
        CALL scrsincos(ztheta,imoms,zsn,zcs)
        rwork(ith,ic)=rmcx(ic,0,1)
        zwork(ith,ic)=zmcx(ic,0,1)
        do im=1,imoms
          rwork(ith,ic)=rwork(ith,ic)+rmcx(ic,im,1)*zcs(im)+ &
               rmcx(ic,im,2)*zsn(im)
          zwork(ith,ic)=zwork(ith,ic)+zmcx(ic,im,1)*zcs(im)+ &
               zmcx(ic,im,2)*zsn(im)
        enddo
7701    format(' ith=',i3,' ic=',i3,' R=',1pe11.4,' Y=',1pe11.4)
      enddo
      rwork(inpts+1,ic)=rwork(1,ic)
      zwork(inpts+1,ic)=zwork(1,ic)
    endif
  enddo
  !
  !  2.  interpolate the theta lines
  !
  if(moption.eq.2) then
    ic2=icc(4)
  else if(moption.eq.3) then
    ic2=icc(6)
  endif
  !
  !  loop over theta lines
  !
  do ith=1,inpts
    !
    !  transform to rotated frame
    !  2x2 rotations
    !   T = ( zcosa -zsina )      Tinv = ( zcosa  zsina )
    !       ( zsina  zcosa )             (-zsina  zcosa )
    !
    !  ( x ) = Tinv * ( R - R0 )   ( R ) = ( R0 ) + T * ( x )
    !  ( y )          ( Z - Z0 )   ( Z )   ( Z0 )       ( y )
    !
    !  origin is 1st surface point
    !
    CALL scrfsetup(ith,icc,rwork,zwork,inpts,idim1,zxmax,ier)
    if(ier.ne.0) then
      write(lunmsg,*) ' ?scrmomintrp: theta line fit failure, ith=',ith
      go to 1000
    endif
    !
    !  find theta-line | flux surface intercepts
    !  first initial guess
    xguess=xmax
    delx=0.25_fp*xmax
    !
    zxtol=1.0e-10_fp*xmax               ! x error tolerance
    zftol=1.0e-10_fp*r0                 ! f(x) an error tolerance
    !
    do ic=ic2,ic0+1,-1
      !
      !  use numeric intercept finder on each surface
      !  scrunched surfaces are also probed, so that treatment is consistent on
      !  all surfaces
      !    see scrXceptcon(x,zdum) function
      !
      xguessp=xguess
      xguess=xguess-delx
      !
      ksurf=ic
      CALL scrmfalsi(scrXceptcon,xguess,zftol,zxtol, &
           xspl(1),1.05_fp*xmax,100,lunmsg,0,zstat)
      if(zstat.ne.zero) then
        write(lunmsg,*) &
             ' ?momintrp:  MFALSI error (check input data).'
        ier=99
        exit
      endif
      delx=xguessp-xguess
      !  intercept in (x,y) space
      x=xguess
      y=scrYceptcon(x,Rtest,Ztest)
      !  transform back to (R,Y) and save
      rwork(ith,ic) = Rtest
      zwork(ith,ic) = Ztest
      !
      if(ier.ne.0) exit
    enddo                          ! loop over surfaces, out -> in
    !
    if(ier.ne.0) exit
  enddo                             ! loop over theta angles

  !  close all contours
  rwork(inpts+1,1:idim1)=rwork(1,1:idim1)
  zwork(inpts+1,1:idim1)=zwork(1,1:idim1)
  !
  if(ier.ne.0) go to 1000
  !
  !  OK now information is available to do an fft to get moments back
  !
  !  3.  compute the unscrunched moments set from the interpolation results
  !
  itheta=inpts
  do ic=ic0+1,ic2
    !
    !  do this on all surfaces, for consistency...
    !
    imoms=max(ilim,imomuse(ic))
    !  R moments
    call r8fftsc(rwork(1,ic),itheta,zs1d,zc1d,ier)
    if(ier.ne.0) go to 1000
    rmcx(ic,0,1)=zc1d(1)/(two*itheta)
    do im=1,imoms
      rmcx(ic,im,1)=zc1d(im+1)/(itheta)
      rmcx(ic,im,2)=zs1d(im+1)/(itheta)
    enddo
    !  Z moments
    call r8fftsc(zwork(1,ic),itheta,zs1d,zc1d,ier)
    if(ier.ne.0) go to 1000
    zmcx(ic,0,1)=zc1d(1)/(two*itheta)
    do im=1,imoms
      zmcx(ic,im,1)=zc1d(im+1)/(itheta)
      zmcx(ic,im,2)=zs1d(im+1)/(itheta)
    enddo
  enddo
  !
  ! moption.eq.3 -- cleanup higher order moments' approach to axis
  !
  if(moption.eq.3) then
    !  2nd moment:

    call a2smoo(rmcx(1:idim1,2,1))
    call a2smoo(rmcx(1:idim1,2,2))
    call a2smoo(zmcx(1:idim1,2,1))
    call a2smoo(zmcx(1:idim1,2,2))

    !  moments 3 and up
    ztol=rmcx(ic0,0,1)*1.0d-6
    do im=3,imomuse(ic2)
      xsrch0=zero
      if(im.gt.ilim) then
        do i=ic2-1,ic0+1,-1
          if(imomuse(i).lt.im) then
            xsrch0=xsize(i)
            exit
          endif
        enddo
      endif
      call axsmoo(rmcx(1:idim1,im,1),im)
      call axsmoo(rmcx(1:idim1,im,2),im)
      call axsmoo(zmcx(1:idim1,im,1),im)
      call axsmoo(zmcx(1:idim1,im,2),im)
    enddo
  endif
  !
1000 continue
  !
  !---------------------------------------------------------------
  !
  DEALLOCATE(rwork, zwork)
  !
  return

contains
  subroutine a2smoo(zmoms)
    real(fp), dimension(:) :: zmoms  ! moments on these surfaces

    integer :: icbrk,ic

    real(fp) :: x2,x2sum,x2sum2,ssum,scav,wav

    do ic=ic0+1,ic2
      if(imomuse(ic).gt.2) then
        icbrk=ic
        exit
      endif
    enddo

    x2sum=0
    ssum=0
    do ic=ic0+1,icbrk
      x2=xsize(ic)*xsize(ic)
      ssum=ssum+zmoms(ic)   ! /x2 *x2
      x2sum=x2sum+x2
    enddo

    scav=ssum/x2sum  ! avg scaled moment

    x2sum2=0
    do ic=ic0+1,icbrk-1
      x2=xsize(ic)*xsize(ic)
      x2sum2=x2sum2+x2
      wav = 1 - x2sum2/x2sum
      zmoms(ic)=x2*scav*wav + zmoms(ic)*(1-wav)
    enddo

  end subroutine a2smoo

  subroutine axsmoo(zmoms,im)

    real(fp), dimension(:) :: zmoms  ! moments on these surfaces
    integer :: im          ! order of moments

    ! local...

    real(fp) :: zdelx,xbrk1,xbrk2
    integer i

    !-----------------------
    zdelx=0.15_fp

    do i=ic0+1,ic2
      if(abs(zmoms(i)).gt.ztol) then
        if(xsrch0.gt.zero) then
          xbrk2=max(xsrch0+zdelx,xsize(i-1))
        else
          xbrk2=xsize(i-1)
        endif
        xbrk1=xbrk2-zdelx
        exit
      endif
    enddo

    if(xbrk1.lt.zero) then
      if(im.lt.3) then
        return  ! no change
      else
        xbrk1=zero
        xbrk2=zdelx
      endif
    endif

    do i=ic0+1,ic2
      if(xsize(i).le.xbrk1) then
        zmoms(i)=zero
      else if(xsize(i).lt.xbrk2) then
        xsw=(xbrk2-xsize(i))/(xbrk2-xbrk1)
        wsw=xsw*xsw*xsw*(xsw*(15.0_fp-6.0_fp*xsw)-10.0_fp) + one
        zmoms(i)=zmoms(i)*wsw
      endif
    enddo

  end subroutine axsmoo
end SUBROUTINE scrmomintrp

      subroutine eqrz_bffget(ivec,zR,zZ,zphi,ztol,
     >   bvec,nlist,ifcns,ivecd,fvals,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated functions f @ (R,Z,phi)
c  get (BR,BZ,Bphi) (BR,BZ,Bphi) @ (R,Z,phi)
c
c      since this involves an inverse map to (rho,chi,phi)
c      a relative accuracy tolerance is required.
c
c  inverse map results not returned.
c
      implicit NONE
c input:
      integer ivec                      ! vector dimensioning
      real*8 zR(ivec),zZ(ivec),zphi(ivec) ! (R,Z,phi) target coordinates
c
      real*8 ztol                       ! rel. tolerance for inv. map
c
c (R,Z,phi)->(rho,chi,phi) by Newton's method
c          (rho,cho) maps to (R',Z'); Newton iteration stops when
c                          max(|R-R'|,|Z-Z'|).le.ztol*Raxis
c
      integer nlist                     ! no. of functions to evaluate
      integer ifcns(nlist)              ! list of function ids
c
      integer ivecd                     ! output vector dimension
c
c output:
      real*8 bvec(3,ivec)               ! the B field values returned
      real*8 fvals(ivecd,nlist)         ! the function values returned
      integer nregion(ivec)             ! region code, 1= inside core
c
      integer ierr                      ! completion code, 0=OK
c
c--------------------------
c
      real*8 zrho(ivec),zchi(ivec)
c
c--------------------------
c
      call eqrzmap_bffget(ivec,zR,zZ,zphi,zrho,zchi,ztol,
     >   bvec,nlist,ifcns,ivecd,fvals,nregion,ierr)
c
      return
      end
c---------------------------------------------------------------------
      subroutine eqrz_bffgrad(ivec,zR,zZ,zphi,ztol,
     >   bvec,gbtensr,nlist,ifcns,ivecd,fvals,fgrads,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated functions f @ (R,Z,phi)
c  get cylindric coord.gradient of f (df/dR,df/dZ,(1/R)*df/dphi) @ (R,Z,phi)
c  get indicated (BR,BZ,Bphi) @ (R,Z,phi)
c  get [d/dR,d/dZ,(1/R)d/dphi) of each B field coordinate also.
c      gbtensr(1:3,j,k)=(d/dR,d/dZ,(1/R)d/dphi)(bvec(j,k))
c
c      since this involves an inverse map to (rho,chi,phi)
c      a relative accuracy tolerance is required.
c
c  inverse map results not returned.
c
      implicit NONE
c input:
      integer ivec                      ! vector dimensioning
      real*8 zR(ivec),zZ(ivec),zphi(ivec) ! (R,Z,phi) target coordinates
c
      real*8 ztol                       ! rel. tolerance for inv. map
c
c (R,Z,phi)->(rho,chi,phi) by Newton's method
c          (rho,cho) maps to (R',Z'); Newton iteration stops when
c                          max(|R-R'|,|Z-Z'|).le.ztol*Raxis
c
      integer nlist                     ! no. of functions to evaluate
      integer ifcns(nlist)              ! list of function ids
c
      integer ivecd                     ! output vector dimension
c
c output:
      real*8 bvec(3,ivec)               ! the field values returned
      REAL*8 gbtensr(3,3,ivec)          ! gbtensor(*,j)=d[bvec(j)]/d[R,Z,phi]
      real*8 fvals(ivecd,nlist)         ! the function values returned
      real*8 fgrads(3,ivecd,nlist)      ! the function gradients returned
      integer nregion(ivec)             ! region code, 1=inside core
c
      integer ierr                      ! completion code, 0=OK
c
c--------------------------
c
      real*8 zrho(ivec),zchi(ivec)
c
c--------------------------
c
      call eqrzmap_bffgrad(ivec,zR,zZ,zphi,zrho,zchi,ztol,
     >   bvec,gbtensr,nlist,ifcns,ivecd,fvals,fgrads,nregion,ierr)
c
      return
      end
C--------------------------------------------------------------------
      subroutine eqrzmap_bffget(ivec,zR,zZ,zphi,zrho,zchi,ztol,
     >   bvec,nlist,ifcns,ivecd,fvals,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated functions f @ (R,Z,phi)
c  get indicated (BR,BZ,Bphi) @ (R,Z,phi)
c
c      since this involves an inverse map to (rho,chi,phi)
c      a relative accuracy tolerance is required.
c
c      inverse map results *are* returned.
c
c  method:
C  transform to (R,Z,phi), get fcn value in this space
C
      IMPLICIT NONE
c
c  input:
      integer ivec                      ! vector dimensioning
      REAL*8 zR(ivec),zZ(ivec),zphi(ivec) ! (R,Z,phi) location
      REAL*8 ztol                       ! rel. tol. for (R,Z,phi)->flux coords
C
c (R,Z,phi)->(rho,chi,phi) by Newton's method
c          (rho,cho) maps to (R',Z'); Newton iteration stops when
c                          max(|R-R'|,|Z-Z'|).le.ztol*Raxis
c
      integer nlist                     ! no. of functions to evaluate
      integer ifcns(nlist)              ! list of function ids
c
      integer ivecd                     ! output vector dimension
C
C  output:
      REAL*8 zrho(ivec),zchi(ivec)      ! (rho,chi,[phi]) (flux coords)
      real*8 bvec(3,ivec)               ! the field values returned
      REAL*8 fvals(ivecd,nlist)         ! function value
C
      integer nregion(ivec)             ! region code for (R,Z,phi) 1=inside
      integer ierr                      ! completion code, 0=OK
C
C--------------------------
C
      REAL*8 gbtensr(3,3,ivec)          ! dummy gbtensor
      REAL*8 fgrads(3,ivecd,max(1,nlist)) ! dummy gradients array
C
C--------------------------
C
      call eqi_getall(ivec,.TRUE.,zR,zZ,zphi,1,zrho,zchi,ztol,0,
     >   1,bvec,gbtensr,nlist,ifcns,ivecd,fvals,fgrads,
     >   nregion,ierr)
C
      return
      end
C--------------------------------------------------------------------
      subroutine eqrzmap_bffgrad(ivec,zR,zZ,zphi,zrho,zchi,ztol,
     >   bvec,gbtensr,nlist,ifcns,ivecd,fvals,fgrads,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated functions f @ (R,Z,phi)
c  get cylindric coord.gradient of f (df/dR,df/dZ,(1/R)*df/dphi) @ (R,Z,phi)
c  get indicated (BR,BZ,Bphi) @ (R,Z,phi)
c  get [d/dR,d/dZ,(1/R)d/dphi) of each B field coordinate also.
c      gbtensr(1:3,j,k)=(d/dR,d/dZ,(1/R)d/dphi)(bvec(j,k))
c
c      since this involves an inverse map to (rho,chi,phi)
c      a relative accuracy tolerance is required.
c
c  inverse map results *are* returned.
c
      IMPLICIT NONE
c
c  input:
      integer ivec                      ! vector dimensioning
      REAL*8 zR(ivec),zZ(ivec),zphi(ivec) ! (R,Z,phi) location
      REAL*8 ztol                       ! rel. tol. for (R,Z,phi)->flux coords
C
c (R,Z,phi)->(rho,chi,phi) by Newton's method
c          (rho,cho) maps to (R',Z'); Newton iteration stops when
c                          max(|R-R'|,|Z-Z'|).le.ztol*Raxis
c
      integer nlist                     ! no. of functions to evaluate
      integer ifcns(nlist)              ! list of function ids
c
      integer ivecd                     ! output vector dimension
C
C  output:
      REAL*8 zrho(ivec),zchi(ivec)      ! (rho,chi,phi) (flux coords)
      real*8 bvec(3,ivec)               ! the field values returned
      REAL*8 gbtensr(3,3,ivec)          ! gbtensor(*,j)=d[bvec(j)]/d[R,Z,phi]
      REAL*8 fvals(ivecd,nlist)         ! function value
      REAL*8 fgrads(3,ivecd,nlist)      ! cartesian gradient of f
C
      integer nregion(ivec)             ! region code for (R,Z,phi) 1=inside
      integer ierr                      ! completion code, 0=OK
C
C--------------------------
C--------------------------
C
      call eqi_getall(ivec,.TRUE.,zR,zZ,zphi,1,zrho,zchi,ztol,1,
     >   1,bvec,gbtensr,nlist,ifcns,ivecd,fvals,fgrads,
     >   nregion,ierr)
C
      return
      end
C--------------------------------------------------------------------

C******************** START FILE GRFUF1.FOR ; GROUP GRFUF1 *************
C  GRAFC3 - DMC - REWRITTEN BASIC F(X) GRAPHICS INTERFACE ROUTINE
C    THIS ROUTINE CONTROLS DRAWING AND LABELING OF A 1 PAGE PLOT
C    OF two contours (x(i),y(i),i=1,N) and
C    (x2(i),y2(i),i=1,N2) , AND GENERATION OF A REPLOT/RESCALE
C    (UREAD) OPTION MENU
C
C    A NEW CALLING ARGUMENT LIST IS PROVIDED
C
      SUBROUTINE GRAFC3(X,Y,N,X2,Y2,N2,X3,Y3,N3,XUN,YUN,
     >       LBL1,LBL2,LBL3)
C
C  DATA:
      REAL X(N),Y(N),X2(N2),Y2(N2),X3(N3),Y3(N3)
C  LABELS:
      CHARACTER*(*) XUN,YUN,LBL1,LBL2,LBL3
C
C  CONTROL:
      INTEGER IMENU
C
C  IF IMENU=1 JUMP DIRECTLY TO REPLOT MENU (DO NOT DRAW GRAPH 1ST)
C
      integer icounter
      integer, save :: iopcod=0
C
C  SCALE SETTING COMMON BLOCKS --
C
      INCLUDE 'GSCALE_BLK'
C
      INCLUDE 'PLOT1MMX'
C
      EXTERNAL GRADUM  ! FOR GRAOPT CALL INTERFACE
C
      DATA IMENU/0/
C
C-------------------------------------------------------------
C
      icounter=0
C-------------------------------------
C
C  SCALE SET SWITCHE CLEARED:
C
      ILOCSC=0
C
C  GET DEFAULT AXIS SELECTION
C
      CALL GAXGDF(ISEL)
C
      IF(IMENU.EQ.1) GO TO 200
C
C----------------------------------------------------------------
C  AUTOMATIC GENERATION OF PLOT
C
 100  CONTINUE
      icounter=icounter+1
C
C  SET AXES
C
      CALL GAXCUR(ISEL)
C
      IF(ILOCSC.EQ.0) THEN
C  COMPUTE X AND Y PLOT SCALE (USE GSCALE DEFAULTS)
        CALL GSCSET(X,Y,Y,0,N)
      ELSE IF(ILOCSC.EQ.1) THEN
C  COMPUTE Y AUTOSCALE ONLY
        CALL GSCMMX(X,N,Y,Y,0,N,1,1,1,1,N,XMIN,XMAX,1)
        CALL GSCYDF(1)
      ENDIF
C
      zxmin=xmin
      zxmax=xmax
      zymin=ymin
      zymax=ymax
C
      IF(ILOCSC.EQ.0) THEN
C  COMPUTE X AND Y PLOT SCALE (USE GSCALE DEFAULTS)
        CALL GSCSET(X2,Y2,Y2,0,N2)
      ELSE IF(ILOCSC.EQ.1) THEN
C  COMPUTE Y AUTOSCALE ONLY
        CALL GSCMMX(X2,N2,Y2,Y2,0,N2,1,1,1,1,N2,XMIN,XMAX,1)
        CALL GSCYDF(1)
      ENDIF
C
      xmin=amin1(xmin,zxmin)
      xmax=amax1(xmax,zxmax)
      ymin=amin1(ymin,zymin)
      ymax=amax1(ymax,zymax)
C
      IF(ILOCSC.EQ.0) THEN
C  COMPUTE X AND Y PLOT SCALE (USE GSCALE DEFAULTS)
        CALL GSCSET(X3,Y3,Y3,0,N3)
      ELSE IF(ILOCSC.EQ.1) THEN
C  COMPUTE Y AUTOSCALE ONLY
        CALL GSCMMX(X3,N3,Y3,Y3,0,N3,1,1,1,1,N3,XMIN,XMAX,1)
        CALL GSCYDF(1)
      ENDIF
C
      xmin=amin1(xmin,zxmin)
      xmax=amax1(xmax,zxmax)
      ymin=amin1(ymin,zymin)
      ymax=amax1(ymax,zymax)
C
      CALL GSCSEP(XMIN,XMAX)
      CALL GSCSEP(YMIN,YMAX)
C
      LUNTRM=LNOUT(0)
      CALL GAXCHK(LUNTRM,ISEL,ICOD) ! AXIS (LOG/LIN) CHECK
C
      CALL GSCREC  ! RECORD PLOT SCALE IN MEMORY
C
      CALL DPLOT1(X,Y,N,ICOD) ! DRAW GRID AND F(X) CURVE
      CALL DPLOT1(X2,Y2,N2,2)
      CALL DPLOT1(X3,Y3,N3,2)
C
      CALL GRALBL(XUN,YUN,LBL1,LBL2,LBL3)  ! LABEL THE PLOT
C
      CALL UPAUST(2)  ! PAUSE AFTER PLOT
      GO TO 200
C
C  POST PLOT OPTIONS
C
 200  CONTINUE
C
C  GENERATE MENU AND FETCH USER REPLY
C
      CALL GRAOPT('SA',ISEL,ILOCSC,IOPCOD,GRADUM)
C
C  ACT ON USER REPLY - REPLOT?
C
      IF(IOPCOD.EQ.1) THEN
         GO TO 100
      ELSE IF(IOPCOD.EQ.2) THEN
         RETURN
      ENDIF
C
      CALL UERMSI(' ?GRAFC3 *FATAL BUG* UNANTICIPATED OPERATION CODE',
     >              IOPCOD,1)
      call bad_exit
C
      END

SUBROUTINE scrpreset(jmax,ns,imom)
  use physconst_mod, only: zero
  use mintrp
  use scrunch_inc1
  implicit none
  integer, intent(in) :: jmax, ns, imom
  ntheta = jmax
  mpol = imom+1
  mnd=mpol*(nphi+1)
  mpol2=2*mpol
  mpol3=3*mpol
  mpol4=4*mpol
  n2=mpol4+ntheta
  nu      = jmax
  ntheta0 = jmax
  ncmax   = ns
  moption = 3
  numc = ns
  facmid = zero  ! magic numbers
  facedg = zero  ! don't change
  facdx0 = zero  ! (defaults set in scriscrunch).
  return
END SUBROUTINE scrpreset


subroutine scrpreset_wr(icon)

  ! write on LUN icon the info needed to call scrpreset

  use mintrp
  use scrunch_inc1
  implicit none
  integer, intent(in) :: icon

  write(icon) ncmax,nu,mpol
  return
end subroutine scrpreset_wr

subroutine eqm_rzmag(Rarr,Zarr,id1,id2,idrho,id_R,id_Z,ierr)
 
  use xplasma_obj_instance
  use eq_module
  implicit NONE

  !  establish R(chi,rho) and Z(chi,rho) bicubic splines.
  !  periodic in chi, not-a-knot BC @ rho bdys
  !    (for more control of rho BCs use eqm_rzmagb)

  !  input arguments:

  integer id1,id2            ! R,Z array dimensions
  real*8 Rarr(id1,id2)       ! R array
  real*8 Zarr(id1,id2)       ! Z array

  integer idrho              ! =1:  id1 is "rho" dimension; =2: id2 is.
                             ! =-1: id1 is "rho"; use finite diff BC
                             ! =-2: id2 is "rho"; use finite diff BC

  !  output arguments:

  integer id_R               ! xplasma id for "R" bicubic spline (returned)
  integer id_Z               ! xplasma id for "Z" bicubic spline (returned)

  integer ierr               ! completion code (0 = OK)
  
  !----------------------------------------------------------------

  real*8, dimension(:), allocatable :: zrbc0,zrbc1,zzbc0,zzbc1,zrho
  real*8 :: zdrho0,zdrho1
  integer ibc  ! will use 1st derivative BC
  integer i,inrho,inchi,id_rho,id_chi,inchi_err

  !----------------------------------------------------------------

  call eqm_rzmag_check(id1,id2,abs(idrho),id_rho,id_chi,inrho,inchi,ierr)
  if(ierr.ne.0) return
  
  allocate(zrho(inrho))
  call xplasma_grid(s,id_rho,zrho,ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqm_rzmag: "__RHO" grid fetch failed.'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  ! use finite difference formula for 1st derivative BCs.  This seems to
  ! be safest for preserving the 2x2 Jacobian sign...

  zdrho0=zrho(2)-zrho(1)
  zdrho1=zrho(inrho)-zrho(inrho-1)

  if(idrho.eq.-1) then
     allocate(zrbc0(id2),zrbc1(id2),zzbc0(id2),zzbc1(id2))
     if(id2.lt.inchi) then
        ierr=1
        inchi_err=id2
     else
        do i=1,id2
           if(i.le.inchi) then
              zrbc0(i)=(Rarr(2,i)-Rarr(1,i))/zdrho0
              zrbc1(i)=(Rarr(inrho,i)-Rarr(inrho-1,i))/zdrho1
              zzbc0(i)=(Zarr(2,i)-Zarr(1,i))/zdrho0
              zzbc1(i)=(Zarr(inrho,i)-Zarr(inrho-1,i))/zdrho1
           else
              zrbc0(i)=0
              zrbc1(i)=0
              zzbc0(i)=0
              zzbc1(i)=0
           endif
        enddo
     endif

  else if(idrho.eq.-2) then
     allocate(zrbc0(id1),zrbc1(id1),zzbc0(id1),zzbc1(id1))
     if(id1.lt.inchi) then
        ierr=1
        inchi_err=id1
     else
        do i=1,id1
           if(i.le.inchi) then
              zrbc0(i)=(Rarr(i,2)-Rarr(i,1))/zdrho0
              zrbc1(i)=(Rarr(i,inrho)-Rarr(i,inrho-1))/zdrho1
              zzbc0(i)=(Zarr(i,2)-Zarr(i,1))/zdrho0
              zzbc1(i)=(Zarr(i,inrho)-Zarr(i,inrho-1))/zdrho1
           else
              zrbc0(i)=0
              zrbc1(i)=0
              zzbc0(i)=0
              zzbc1(i)=0
           endif
        enddo
     endif

  else
     allocate(zrbc0(inchi),zrbc1(inchi),zzbc0(inchi),zzbc1(inchi))
     zrbc0=0
     zrbc1=0
     zzbc0=0
     zzbc1=0
  endif

  if(ierr.eq.1) then
     write(lunerr,*) ' ?eqm_rzmag: too few chi points in passed array.'
     write(lunerr,*) '  needed: ',inchi,' got: ',inchi_err
     write(lunerr,*) '  dimension error in poloidal angle coordinate.'

  else

     if(abs(idrho).lt.0) then
        ibc=1
     else
        ibc=0
     endif

     call eqm_rzmagb(Rarr,Zarr,id1,id2,idrho,  &
          ibc,zrbc0,ibc,zrbc1,  &
          ibc,zzbc0,ibc,zzbc1,  &
          id_R,id_Z,ierr)

  endif

  deallocate(zrbc0,zrbc1,zzbc0,zzbc1)

end subroutine eqm_rzmag

      subroutine eqxyz_bffget(ivec,xx,yy,zz,ztol,bvec,nlist,ifcns,
     >   ivecd,fvals,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated functions f @ (x,y,z)
c
c      since this involves an inverse map to (rho,chi,phi)
c      a relative accuracy tolerance is required.
c
c      inverse map results not returned.
c
      implicit NONE
c input:
      integer ivec                      ! vector dimensioning
      real*8 xx(ivec),yy(ivec),zz(ivec) ! (x,y,z) target coordinates
c
      real*8 ztol                       ! rel. tolerance for inv. map
c
c (x,y,z)->(rho,chi,phi) by Newton's method
c          (rho,cho,phi) maps to (x',y',z'); Newton iteration stops when
c                          max(|x-x'|,|y-y'|,|z-z'|).le.ztol*Raxis
c
      integer nlist                     ! number of functions
      integer ifcns(nlist)              ! xplasma fcn ids, functions wanted.
c
      integer ivecd                     ! vector dimension -- output arrays
c
c output:
      REAL*8 bvec(3,ivec)               ! B vector (Bx,By,Bz)
      real*8 fvals(ivecd,nlist)         ! the function values returned
      integer nregion(ivec)             ! region code
c
      integer ierr                      ! completion code, 0=OK
c
c--------------------------
c
      real*8 zrho(ivec),zchi(ivec),zphi(ivec)
c
c--------------------------
c
      call eqxyzmap_bffget(ivec,xx,yy,zz,zrho,zchi,zphi,ztol,
     >   bvec,nlist,ifcns,
     >   ivecd,fvals,nregion,ierr)
c
      return
      end
c---------------------------------------------------------------------
      subroutine eqxyz_bffgrad(ivec,xx,yy,zz,ztol,bvec,gbtensr,
     >   nlist,ifcns,
     >   ivecd,fvals,fgrads,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated function f @ (x,y,z)
c  get cartesian gradient of f (df/dx,df/dy,df/dz) @ (x,y,z)
c
c      since this involves an inverse map to (rho,chi,phi)
c      a relative accuracy tolerance is required.
c
c  inverse map results not returned.
c
      implicit NONE
c input:
      integer ivec                      ! vector dimensioning
      real*8 xx(ivec),yy(ivec),zz(ivec) ! (x,y,z) target coordinates
c
      real*8 ztol                       ! rel. tolerance for inv. map
c
c (x,y,z)->(rho,chi,phi) by Newton's method
c          (rho,cho,phi) maps to (x',y',z'); Newton iteration stops when
c                          max(|x-x'|,|y-y'|,|z-z'|).le.ztol*Raxis
c
      integer nlist                     ! no. of fcns in list
      integer ifcns(nlist)              ! xplasma fcn ids, functions wanted.
c
      integer ivecd                     ! vector dimension -- output arrays
c
c output:
      REAL*8 bvec(3,ivec)               ! B vector (Bx,By,Bz)
      REAL*8 gbtensr(3,3,ivec)          ! gbtensor(i,j)=d[bvec(j)]/d[x,y,z]
      real*8 fvals(ivecd,nlist)         ! the function values returned
      real*8 fgrads(3,ivecd,nlist)      ! the function gradients returned
      integer nregion(ivec)             ! region code
c
      integer ierr                      ! completion code, 0=OK
c
c--------------------------
c
      real*8 zrho(ivec),zchi(ivec),zphi(ivec)
c
c--------------------------
c
      call eqxyzmap_bffgrad(ivec,xx,yy,zz,zrho,zchi,zphi,ztol,
     >   bvec,gbtensr,nlist,ifcns,
     >   ivecd,fvals,fgrads,nregion,ierr)
c
      return
      end
C--------------------------------------------------------------------
      subroutine eqxyzmap_bffget(ivec,xx,yy,zz,zrho,zchi,zphi,
     >   ztol,bvec,nlist,ifcns,
     >   ivecd,fvals,nregion,ierr)
C
c  vectorized interpolation routine.
c  get indicated function f @ (x,y,z)
c
c      since this involves an inverse map to (rho,chi,phi)
c      a relative accuracy tolerance is required.
c
c      inverse map results are returned.
c
      IMPLICIT NONE
c
c  input:
      integer ivec                      ! vector dimensioning
      REAL*8 xx(ivec),yy(ivec),zz(ivec) ! (x,y,z) location
      REAL*8 ztol                       ! rel. tol. for x,y,z -> flux coords
C
c (x,y,z)->(rho,chi,phi) by Newton's method
c          (rho,cho,phi) maps to (x',y',z'); Newton iteration stops when
c                          max(|x-x'|,|y-y'|,|z-z'|).le.ztol*Raxis
c
      integer nlist                     ! number of functions
      integer ifcns(nlist)              ! function id numbers
c
      integer ivecd                     ! output vector dimension, .ge.ivec
C
C  output:
      REAL*8 zrho(ivec),zchi(ivec),zphi(ivec) ! (rho,chi,phi) (flux coords)
      REAL*8 bvec(3,ivec)               ! B vector (Bx,By,Bz)
      REAL*8 fvals(ivecd,nlist)         ! function values
C
      integer nregion(ivec)             ! region code for (x,y,z) (cf eq_xinv).
      integer ierr                      ! completion code, 0=OK
C
C--------------------------
C
      integer iv
      real*8 zR(ivec),zcosphi,zsinphi,btmp(3)
C
C--------------------------
C  transform to cylindric coords
      call eq_rcyl(ivec,xx,yy,zR,zphi)
C
C  get values & vectors
C
      call eqrzmap_bffget(ivec,zR,zZ,zphi,zrho,zchi,ztol,
     >   bvec,nlist,ifcns,
     >   ivecd,fvals,nregion,ierr)
C
C  map (R,Z,phi) vectors to (x,y,z) system
C
      do iv=1,ivec
         zcosphi=cos(zphi(iv))
         zsinphi=sin(zphi(iv))
C
C  back transform B field
C
         btmp(3)=bvec(2,iv)
         btmp(1)=bvec(1,iv)*zcosphi -bvec(3,iv)*zsinphi
         btmp(2)=bvec(1,iv)*zsinphi +bvec(3,iv)*zcosphi
C
         bvec(1:3,iv)=btmp
      enddo
C
      return
      end
C--------------------------------------------------------------------
      subroutine eqxyzmap_bffgrad(ivec,xx,yy,zz,zrho,zchi,zphi,
     >   ztol,bvec,gbtensr,nlist,ifcns,
     >   ivecd,fvals,fgrads,nregion,ierr)
c
c  vectorized interpolation routine.
c  get indicated function f @ (x,y,z)
c  get cartesian gradient of f (df/dx,df/dy,df/dz) @ (x,y,z)
c
c      since this involves an inverse map to (rho,chi,phi)
c      a relative accuracy tolerance is required.
c
c  inverse map results are returned.
C
C  transform to (R,Z,phi), get fcn values and gradients in this space,
C  then transform back to (x,y,z)
C
      IMPLICIT NONE
c
c  input:
      integer ivec                      ! vector dimensioning
      REAL*8 xx(ivec),yy(ivec),zz(ivec) ! (x,y,z) location
      REAL*8 ztol                       ! rel. tol. for x,y,z -> flux coords
C
c (x,y,z)->(rho,chi,phi) by Newton's method
c          (rho,cho,phi) maps to (x',y',z'); Newton iteration stops when
c                          max(|x-x'|,|y-y'|,|z-z'|).le.ztol*Raxis
c
      integer nlist                     ! number of functions
      integer ifcns(nlist)              ! function id numbers
c
      integer ivecd                     ! output vector dimension, .ge.ivec
C
C  output:
      REAL*8 zrho(ivec),zchi(ivec),zphi(ivec) ! (rho,chi,phi) (flux coords)
      REAL*8 bvec(3,ivec)               ! B vector (Bx,By,Bz)
      REAL*8 gbtensr(3,3,ivec)          ! gbtensor(i,j)=d[bvec(j)]/d[x,y,z]
      REAL*8 fvals(ivecd,nlist)         ! function values
      REAL*8 fgrads(3,ivecd,nlist)      ! cartesian gradients of functions
C
      integer nregion(ivec)             ! region code for (x,y,z) (cf eq_xinv).
      integer ierr                      ! completion code, 0=OK
C
C--------------------------
C
      REAL*8 zR(ivec),zdum
C
C--------------------------
C  transform to cylindric coords
      call eq_rcyl(ivec,xx,yy,zR,zphi)
C
C  get values & vectors
C
      call eqrzmap_bffgrad(ivec,zR,zZ,zphi,zrho,zchi,ztol,
     >   bvec,gbtensr,
     >   nlist,ifcns,
     >   ivecd,fvals,fgrads,nregion,ierr)
C
C  map (R,Z,phi) vectors to (x,y,z) system
C
      if(ierr.eq.0) then
         call eqi_rzxvec(ivec,zR,zZ,zphi,1,bvec,gbtensr,
     >      nlist,ivecd,fvals,fgrads)
      endif
C
      return
      end
C--------------------------------------------------------------------

subroutine eq_frhochi(ivec,zrho,zchi,nlist,iflist,ivecd,zans,ierr)

  !  evaluate 1 or more functions f(rho,chi) (f(rho) also allowed).
  !  see also eq_grhochi (below) to evaluate 1st derivatives

  use xplasma_obj_instance
  use eq_module
  IMPLICIT NONE

  !  input:

  integer ivec                      ! input vector dimension
  !  input negative number for clockwise chi specification

  REAL*8 zrho(abs(ivec))            ! argument -- where to evaluate
  REAL*8 zchi(abs(ivec))            ! argument -- where to evaluate
  integer nlist                     ! number of functions
  integer iflist(nlist)             ! functions to evaluate

  integer ivecd                     ! output vector dimension

  !  output:

  REAL*8 zans(ivecd,nlist)          ! evaluation results
  integer ierr                      ! completion code (0=OK)

  !--------------------------------------------
  logical :: ccw_chi,rzeval
  integer :: iveca,id_R,id_Z,i
  !--------------------------------------------

  iveca=abs(ivec)
  ccw_chi = (ivec.gt.0)

  if(ivecd.lt.iveca) then
     ierr=1
     write(lunerr,*) ' ?eq_frhochi: answer array dimension ivecd too small:'
     write(lunerr,*) '  ivec = ',abs(ivec),'; ivecd = ',ivecd
     return
  endif

  call xplasma_common_ids(s,ierr, id_R=id_R,id_Z=id_Z)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_frhochi: interpolation call unsuccessful, ierr=',ierr
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  rzeval=.TRUE.
  do i=1,nlist
     if((iflist(i).ne.id_R).and.(iflist(i).ne.id_Z)) then
        rzeval=.FALSE.
        exit
     endif
  enddo

  if(rzeval) then
     call xplasma_RZeval_2d(s,iflist(1:nlist), &
          xplasma_rho_coord,zrho, xplasma_theta_coord,zchi, &
          zans(1:iveca,1:nlist),ierr, ccwflag2=ccw_chi)
  else
     call xplasma_eval_prof(s,iflist(1:nlist), &
          xplasma_rho_coord,zrho, xplasma_theta_coord,zchi, &
          zans(1:iveca,1:nlist),ierr, ccwflag2=ccw_chi)
  endif


  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_frhochi: interpolation call unsuccessful, ierr=',ierr
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_frhochi

!===================================================================
subroutine eq_grhochi(ivec,zrho,zchi,nlist,iflist,ivecd,zans,ierr)

  !  evaluate 1 or more functions f(rho,chi) derivatives df/drho, df/dchi
  !    f(rho) also allowed, in which case df/dchi=0 is returned.

  use xplasma_obj_instance
  use eq_module
  IMPLICIT NONE

  !  input:

  integer ivec                      ! input vector dimension
  REAL*8 zrho(abs(ivec))            ! argument -- where to evaluate
  REAL*8 zchi(abs(ivec))            ! argument -- where to evaluate
  integer nlist                     ! number of functions
  integer iflist(nlist)             ! functions to evaluate

  integer ivecd                     ! output vector dimension

  !  output:

  REAL*8 zans(ivecd,2,nlist)        ! evaluation results
  integer ierr                      ! completion code (0=OK)

  !  zans(1:ivec,1,j) = df/drho for function id iflist(j)
  !  zans(1:ivec,2,j) = df/dchi for function id iflist(j)

  !--------------------------------------------
  logical :: ccw_chi,rzeval
  integer :: iveca,i,id_R,id_Z
  integer, dimension(:), allocatable :: iflist2,iderivs1,iderivs2
  real*8,dimension(:,:), allocatable :: zabuf
  !--------------------------------------------

  iveca=abs(ivec)
  ccw_chi = (ivec.gt.0)

  if(ivecd.lt.iveca) then
     ierr=1
     write(lunerr,*) ' ?eq_frhochi: answer array dimension ivecd too small:'
     write(lunerr,*) '  ivec = ',abs(ivec),'; ivecd = ',ivecd
     return
  endif

  allocate(iflist2(2*nlist),zabuf(1:iveca,2*nlist))
  allocate(iderivs1(2*nlist),iderivs2(2*nlist))

  iflist2(1:nlist)=iflist(1:nlist)
  iflist2(nlist+1:2*nlist)=iflist(1:nlist)

  iderivs1(1:nlist)=1
  iderivs1(nlist+1:2*nlist)=0

  iderivs2(1:nlist)=0
  iderivs2(nlist+1:2*nlist)=1

  call xplasma_common_ids(s,ierr, id_R=id_R,id_Z=id_Z)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_grhochi: interpolation call unsuccessful, ierr=',ierr
     call xplasma_error(s,ierr,lunerr)
     return
  endif
  rzeval=.TRUE.
  do i=1,nlist
     if((iflist(i).ne.id_R).and.(iflist(i).ne.id_Z)) then
        rzeval=.FALSE.
        exit
     endif
  enddo

  if(rzeval) then
     call xplasma_RZeval_2d(s,iflist2, &
       xplasma_rho_coord,zrho, xplasma_theta_coord,zchi, &
       zabuf,ierr, ccwflag2=ccw_chi, &
       ideriv1s=iderivs1, ideriv2s=iderivs2)

  else
     call xplasma_eval_prof(s,iflist2, &
          xplasma_rho_coord,zrho, xplasma_theta_coord,zchi, &
          zabuf,ierr, ccwflag2=ccw_chi, &
          ideriv1s=iderivs1, ideriv2s=iderivs2)
  endif

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_frhochi: interpolation call unsuccessful, ierr=',ierr
     call xplasma_error(s,ierr,lunerr)
  else
     do i=1,nlist
        zans(1:iveca,1,i)=zabuf(1:iveca,i)
        zans(1:iveca,2,i)=zabuf(1:iveca,i+nlist)
     enddo
  endif

end subroutine eq_grhochi

!******************** START FILE FILEPS.FOR ; GROUP FILTR6 ******************
!
!   FILEPS   IMPLIMENT ERROR BAR FEATURE OF ALGORITHM
!
!   THE SMOOTHING RADIUS ARRAY DELTA IS LOCALLY
!   ADJUSTED WHEREVER THE SMOOTHED DATA FUNCTION IS
!   OUTSIDE THE ERROR BARS OF THE ORIGINAL DATA, UNTIL
!   ALL ERROR BAR VIOLATIONS ARE REMOVED
!
!   THE DATA INITIALIZED VARIABLE RITER IS THE FACTOR BY
!   WHICH THE LOCAL DELTA IS TO BE REDUCED WHERE VIOLATIONS
!   ARE DETECTED.  RITER SHOULD BE SET BETWEEN 0. AND 1.
!   VALUES CLOSER TO ONE MAY PRODUCE BETTER SMOOTHING EFECT,
!   VALUES CLOSER TO ZERO WILL SPEED THE ALGORITHM.
!
!
SUBROUTINE r8fileps(X,Y,YSM,N,DELTA,EPS,NE,EPS2,NE2,XEND1,XEND2)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: ZERO, HALF, ONE
  implicit none
  ! Arguments
  integer, intent(in) :: N, NE, NE2
  real(fp), dimension(n), intent(in)  :: x, y
  real(fp), dimension(ne), intent(in) :: eps
  real(fp), dimension(1), intent(in)  :: eps2
  real(fp), dimension(n), intent(out) :: ysm, delta
  real(fp), intent(in) :: xend1,xend2
  ! Local variables
  integer, dimension(6) :: ind0,ind
  integer :: js0,ij,jc1,js,jc2,i,jd1,j,jd2,j1,j2,jlp
  real(fp) :: riter,xisol,d1,d2,zs, &
       zds,zdsb,zp,zz,riterl,riterm,zdx,r8filfn6
!
!  THE "IND" ARRAYS WILL CONTAIN INFORMATION ON
!   ANY ERROR BAR VIOLATIONS.
!   THEY POINT TO LOCATIONS IN X,Y, AND YSM.
!    IND(3)=STARTING POINT OF AN ERROR BAR VIOLATION
!    IND(4)=END PT OF SAME VIOLATION IN CONTIGUOUS REGION
!           OF DIVERGENCE (Y-YSM) OF SAME SIGN
!    IND(2)=START POINT OF REGION OF SAME SIGN DIVERGENCE
!    IND(5)=END POINT OF REGION
!    IND(1)=LOCATION OF REGION DELTA(IND(3)) DISTANT FROM X(IND(3))
!           DEFINING END OF REGION WHERE DATA WILL BE RESMOOTHED
!    IND(6)=SAME AS IND(1), RIGHT ENDPT.
!  IND IS GENERALLY IN INCREASING ORDER
!
!
  riter = 0.9_fp
!  RITER= CONVERGENCE FACTOR IN REDIFINING DELTA ARRAY
!
  xisol = ONE
!  XISOL= ISOLATION PARAMETER IN DETERMINING SEPERATION
!         OF NEIGHBOURING REGIONS OF EPSILON VIOLATIONS
!
  JS0=1
!
  DO IJ=1,6
    IND(IJ)=0
    IND0(IJ)=0
  END DO
 10   CONTINUE
!  SEEK ERROR
9901 FORMAT(' FILERS--A')
  CALL r8filers(X,Y,YSM,N,DELTA,EPS,NE,EPS2,NE2,IND0,JS0)
  !
  !  IND0(0)=0==> NO MORE ERRORS
  !
  IF(IND0(1).EQ.0) RETURN
  !
  JC1=IND0(3)
  !  CHECK RELATIVE LOCATION OF LEFT ENDPOINT OF DATA
  IF(JS0.GT.1) GO TO 20
  D1=max(DELTA(IND0(1)),DELTA(1))
  IF((X(IND0(1))-X(1)).LT.(XISOL*(D1))) JC1=1
!
20 CONTINUE
  !  SEEK NEXT ERROR
25 CONTINUE
  JS=IND0(5)+1
9902 FORMAT(' FILERS--B')
  CALL r8filers(X,Y,YSM,N,DELTA,EPS,NE,EPS2,NE2,IND,JS)
  IF(IND(1).NE.0) GO TO 30
  JC2=IND0(4)
  !  CHECK RIGHT ENDPT OF DATA
  D1=max(DELTA(IND0(6)),DELTA(N))
  IF((X(N)-X(IND0(6))).LT.(XISOL*(D1))) JC2=N
  GO TO 90
  !  YES NEXT ERROR:  JOINT TREATMENT WITH LAST ERROR ?
30 CONTINUE
  JC2=IND0(4)
  D2=max(DELTA(IND0(6)),DELTA(IND(1)) )
  IF((X(IND(1))-X(IND0(6))).GE.(XISOL*(D2))) GO TO 90
  !  YES:  JOINT TREATMENT
  DO I=4,6
    IND0(I)=IND(I)
  END DO
  !  CHECK FOR ANOTHER ERROR
  GO TO 25
  !
  !  ERROR TREATMENT
  !
90 CONTINUE
  JD1=JC1-1
  IF(JC1.EQ.1) GO TO 95
  JD1=IND0(1)
  IF(JD1.GE.(JC1-1) ) GO TO 95
  ZS=X(JC1)-X(JC1-1)
  ZDS=DELTA(JC1)-ZS
  ZDSB=DELTA(JC1)*RITER-ZS
  IF(ZDSB.LE.ZERO) GO TO 95
  ZP=ZDSB/(RITER*ZDS)
  DO J=JD1+1,JC1-1
    ZS=X(JC1)-X(J)
    ZDS=DELTA(J)-ZS
    ZZ=ZP*ZDS/DELTA(J)
    RITERL=ZS*(ONE+ZZ)/DELTA(J)
    RITERM=min(ONE,max(RITERL,RITER))
    DELTA(J)=DELTA(J)*RITERM
  end do
95 CONTINUE
  DO J=JC1,JC2
    DELTA(J)=DELTA(J)*RITER
  END DO
!
  JD2=JC2+1
  IF(JC2.EQ.N) GO TO 100
  JD2=IND0(6)
  IF(JD2.LE.(JC2+1)) GO TO 100
  ZS=X(JC2+1)-X(JC2)
  ZDS=DELTA(JC2)-ZS
  ZDSB=RITER*DELTA(JC2)-ZS
  IF(ZDSB.LE.ZERO) GO TO 100
  ZP=ZDSB/(RITER*ZDS)
  DO J=JC2+1,JD2-1
    ZS=X(J)-X(JC2)
    ZDS=DELTA(J)-ZS
    ZZ=ZP*ZDS/DELTA(J)
    RITERL=ZS*(ONE+ZZ)/DELTA(J)
    RITERM=min(ONE,max(RITER,RITERL))
    DELTA(J)=RITERM*DELTA(J)
  END DO
  !
100 CONTINUE
  !  REEVALUATE SMOOTHED DATA IN REGION OF ERROR BAR VIOLATION(S)
  J1=min(JC1,(JD1+1))
  J2=max(JC2,(JD2-1))
  DO J=J1,J2
    !  DO NOT ALLOW DELTA(J) TO GET TOO SMALL -- RESET TO ZERO FOR SPEED
    JLP=J
    IF(JLP.EQ.1) ZDX=X(2)-X(1)
    IF(JLP.EQ.N) ZDX=X(N)-X(N-1)
    IF((JLP.GT.1).AND.(JLP.LT.N)) ZDX=HALF*(X(JLP+1)-X(JLP-1))
    IF(DELTA(J).LT.0.01E0_fp*ZDX) DELTA(J)=ZERO
    YSM(J)=r8filfn6(X,Y,N,JLP,DELTA,XEND1,XEND2,1)
  END DO
  GO TO 10
END SUBROUTINE r8fileps

! 30Nov1999 fgtok
#include "fpreproc/f77_dcomplx.h"
! 30Nov1999 fgtok -s r8_precision.sub r8bloat_names.sub "r8con.csh conversion"
C******************** START FILE TKBMMC.FOR ; GROUP TKBLOAT ******************
C-- END FILE #TKBCON# ************************************
CFORMFEEDC-- START FILE #TKBMMC# ************************************
C-------------------------------------------------------------
C
      SUBROUTINE r8tkbmmc(NLSYM,zrmc,zymc,locmax,nmom,ZR,ZY)
C
C  local moments coeffs, nmom moments active:
C============
C idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      INTEGER nmom,locmax,itheta,j,ierr
C============
      REAL*8 zrmc(3,0:locmax,2),zymc(3,0:locmax,2)
C
C  updown symmetry flag:
      logical nlsym
C
C  dmc 27 Dec 1996:  remove TRCOM! and add calling arguments
C
C  B.BALET  FEB 1994 : UPDATE TO DEAL WITH UP-DOWN ASYMMETRIC CASE
C
C  FROM R,Y CONTOUR DATA DEFINE THE MOMENTS ARRAYS FOR 1 SURFACE
C
      include 'r8tkbparm.inc'
C
      REAL*8 ZR(NTK),ZY(NTK)  ! input contour
C
      REAL*8 ZS1D(NTK)
      REAL*8 ZC1D(NTK)
C
C---------------------------------
C
      ITHETA=NTK
C
C  IMSL FFT
C
      CALL r8fftsc(ZR, ITHETA, ZS1D, ZC1D, ierr)
C
C  NORMALIZE
C
      zrmc(3,0,1) = ZC1D(1)/(2.0E0_R8*ITHETA)
C
      DO 20310 J = 2, NMOM+1
C
         zrmc(3,J-1,1) = ZC1D(J)/AREAL(ITHETA)
         if(.not.nlsym) zrmc(3,J-1,2) = ZS1D(J)/AREAL(ITHETA)
C
20310 CONTINUE
C
C  IMSL FFT
C
      CALL r8fftsc(ZY, ITHETA, ZS1D, ZC1D, ierr)
C
C  NORMALIZE
C
      if(.not.nlsym) zymc(3,0,1)=ZC1D(1)/(2.0E0_R8*ITHETA)
C
      DO 20410 J = 2, NMOM+1
C
         if(.not.nlsym) ZYMC(3,J-1,1) = ZC1D(J)/AREAL(ITHETA)
         ZYMC(3,J-1,2) = ZS1D(J)/AREAL(ITHETA)
C
20410 CONTINUE
C
      RETURN
      END
C******************** END FILE TKBMMC.FOR ; GROUP TKBLOAT ******************

subroutine eqm_brz(userbvec,zsm,ierr)

  !  Legacy f77 Xplasma interface...

  !  set up Bphi(R,Z), BR(R,Z), and BZ(R,Z) -- Akima-Hermite interpolation
  !  for axisymmetric case, setup psi(pol) also.

  !    data values from user supplied function  of form:

  !        subroutine userbvec(iv,zR,zZ,zphi,init,BR,BZ,BPHI,aux,kaux,ierr)
  !          iv -- vector dimension
  !          zR(iv),zZ(iv),zphi(iv)   ! coordinates at which to evaluate
  !          init -- action code
  !          BR(iv),BZ(iv),BPHI(iv)   ! field components returned
  !          aux(iv)                  ! aux. values returned
  !          kaux                     ! =1 if aux. values were set
  !          ierr                     ! completion code, 0=OK

  !  unlike the eqm_rzfunf and eqm_rzfun2 "userfcn" routines, this routine
  !  is called and must return good values for all (Ri,Zj) on the (R,Z) grid
  !  (established by the user with and eqm_rzgrid call, earlier)--where (Ri,Zj)
  !  are beyond the plasma boundary; it may return Bphi=BR=BZ=Psi=0 for (Ri,Zj)
  !  which are inside the plasma.

  !     normal calls to userbvec use init=0
  !         returns BR,BZ,BPHI, and (possibly) psi(pol) in aux.
  !     an initialization call uses init=1, returns BR=BZ=BPHI=czero
  !         also returns naux=1 if a poloidal flux function is to be
  !         returned.
  !         **note** for axisymmetric equilibria, naux=1 & psi(pol.)
  !         is expected.

  !     a cleanup call uses init=2, returns BR=BZ=BPHI=czero

  use xplasma_obj_instance
  use eq_module

  implicit NONE

  !  input:
  external userbvec                 ! user supplied Bvec subroutine
  real*8 zsm                        ! smoothing parameter for edge (m)

  !  output:
  integer ierr                      ! completion code, 0=OK

  !---------------------------------------------
  integer :: iertmp
  !---------------------------------------------

  call xplasma_brz(s,userbvec,ierr, sm_edge=zsm)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqm_brz: error in xplasma_brz:'
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eqm_brz

subroutine r8filtr90(x,y1,y,n,epslon,delta,iddf,ddv,iblf,blv,xenda,xendb)
  !
  !  a simplified interface to filtr6 -- fortran-90
  !
  !  all of the arguments correspond to filtr6.for arguments (see the
  !  extensive comments in filtr6.for).
  !
  !  the following simplifications are present:
  !    1.  epslon is a scalar; epslon=0.0 => epslon feature not used;
  !        there is no "eps2" feature.
  !    2.  delta is a scalar
  !    3.  the output quantities sm,ndrop,nblrs are dropped.
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: ZERO, HALF, ONE
  implicit none
  ! Arguments
  integer, intent(in) :: n
  real(fp), dimension(n), intent(in)  :: x  ! indep. coordinate (input), x must be strict ascending
  real(fp), dimension(n), intent(in)  :: y1 ! data to be smoothed (input)
  real(fp), dimension(n), intent(out) :: y  ! the data as smoothed (output)
  real(fp), intent(in) :: epslon            ! limit on abs(y(i)-y1(i)), epslon.le.0  =>  epslon = infinity
  real(fp), intent(in) :: delta             ! smoothing parameter
  !  on output each y(j) is a triangular weighted average of the piecewise
  !  linear interpolant of y1 over the range x(j)-delta to x(j)+delta.
  !
  integer,  intent(in) :: iddf              ! data drop flag (=1 to enable)
  real(fp), intent(in) :: ddv               ! drop criterion
  integer,  intent(in) :: iblf              ! baseline flag (=1 to enable)
  real(fp), intent(in) :: blv               ! baseline value
  real(fp), intent(in) :: xenda             ! LHS boundary condition
  real(fp), intent(in) :: xendb             ! RHS boundary condition
  !
  !  xend[a,b]=0.0 => endpoint is fixed, e.g. y(1)=y1(1) on output
  !  xend[a,b]=1.0 => dy/dx --> 0 as x--> the boundary
  !  intermediate values => intermediate action at end point.
  !
  ! Local variables
  real(fp) :: sm
  integer :: ndrop,nblrs
  !
  real(fp) :: epslim
  real(fp), parameter :: r8large = 1.0e36_fp
  real(fp), dimension(:), allocatable :: epsarr, delarr
  !
  integer :: stat_alloc
  !
  allocate(epsarr(n),stat=stat_alloc)
  if(stat_alloc.ne.0) then
    write(6,*) ' ?filtr90:  epsarr array allocation failed!'
    call flush(6)
    stop
  endif
  !
  allocate(delarr(n),stat=stat_alloc)
  if(stat_alloc.ne.0) then
    write(6,*) ' ?filtr90:  delarr array allocation failed!'
    call flush(6)
    stop
  endif
  !
  epslim=r8large
  if(epslon.le.ZERO) then
    epsarr=epslim
  else
    epsarr=epslon
  endif
  !
  delarr=delta
  !
  call r8filtr6(x,y1,y,n,epsarr,n,epsarr,0,delarr,iddf,ddv, &
       iblf,blv,xenda,xendb,sm,ndrop,nblrs)
  !
  deallocate(epsarr)
  deallocate(delarr)
  !
  return
end subroutine r8filtr90

subroutine fluxav_brk_add(control,brklist,inum,ierr)
 
  use fluxav
  implicit NONE
 
!
!   add internal break point(s) for numeric integration, in the
!   given coordinate direction.
!
!   these would be typically at the spline nodes, but, additional points
!   can be added as needed.
!
!   the idea is to break up integrands to subregions with smoothly varying
!   behaviour, for accuracy of the Gauss-Legendre quadrature method.
!
!   input:
!
  character*(*) control          ! coordinate select ("rho", "theta", "phi")
!
  integer inum                   ! number of break points in list
  real*8 brklist(inum)           ! the break points in *ascending* order
!
!   output:
!
  integer ierr                   ! completion code, 0=OK
!
!-----------------------------------------------------------
!
  integer i,inew
  real*8 brknew(inum+max(n_rhobrk,n_thbrk,n_phibrk))
!
!-----------------------------------------------------------
!
  ierr=0
  do i=1,inum
     if(i.gt.1) then
        if(brklist(i-1).ge.brklist(i)) then
           ierr=1
           write(lunerr,*) ' ?fluxav_brk_add:  ',control,' break list'
           write(lunerr,*) '  out of order:'
           write(lunerr,*) '    brklist(',i-1,')=',brklist(i-1)
           write(lunerr,*) '    brklist(',i,')=',brklist(i)
        endif
     endif
     if(control.eq.'th') then
        if((brklist(i).lt.theta_min).or.(brklist(i).gt.theta_max)) then
           ierr=1
           write(lunerr,*) ' ?fluxav_brk_add:  ',control,' break list item'
           write(lunerr,*) '  out of range:  ',theta_min,' to ',theta_max
           write(lunerr,*) '    brklist(',i,')=',brklist(i)
        endif
     endif
     if(control.eq.'phi') then
        if((brklist(i).lt.phi_min).or.(brklist(i).gt.phi_max)) then
           ierr=1
           write(lunerr,*) ' ?fluxav_brk_add:  ',control,' break list item'
           write(lunerr,*) '  out of range:  ',phi_min,' to ',phi_max
           write(lunerr,*) '    brklist(',i,')=',brklist(i)
        endif
     endif
  enddo
!
  if(ierr.ne.0) return
!
!  OK -- add the items
!
  if(control.eq.'rho') then
     call fluxav_brk_add0(rhobrk,n_rhobrk,brklist,inum,brknew,inew)
     if(inew.gt.n_rhomax) call fluxav_balloc('rho',inew)
     rhobrk(1:inew)=brknew(1:inew)
     n_rhobrk=inew
!
  else if(control.eq.'th') then
     call fluxav_brk_add0(thbrk,n_thbrk,brklist,inum,brknew,inew)
     if(inew.gt.n_thmax) call fluxav_balloc('th',inew)
     thbrk(1:inew)=brknew(1:inew)
     n_thbrk=inew
!
  else if(control.eq.'phi') then
     call fluxav_brk_add0(phibrk,n_phibrk,brklist,inum,brknew,inew)
     if(inew.gt.n_phimax) call fluxav_balloc('phi',inew)
     phibrk(1:inew)=brknew(1:inew)
     n_phibrk=inew
!
  else
     ierr=1
     write(lunerr,*) ' ?fluxav_brk_add:  invalid control string:  ',control
  endif
!
  return
!
end subroutine fluxav_brk_add

module xdistrib_mod
 
  !  module for xdistrib.f90 -- share information with function passed
  !  to root finder
 
  integer, dimension(-1:3), parameter :: ncdim = (/ 1, 1, 2, 2, 4 /)
 
  !  to aid interpolation evaluations...
  real*8, dimension(:,:), allocatable :: xpkg
 
  !  interpolating function coefficients array...
  real*8, dimension(:,:), allocatable :: splcoef
 
  !  table of integral results at node points...
  real*8, dimension(:), allocatable :: ftabl
 
  integer nx_spl,iorder_spl   ! no. of pts in spline, & order (type of spline)
contains
subroutine xdistrib(iorder, nx,x,fprime, ibcxmin,bcxmin,ibcxmax,bcxmax,  &
     &  ntarg,ztarg,xtarg, fnorm, tol, ier)
!
!  find a set of roots F(xtarg)=ztarg  (to rel. tolerance tol), where
!  F is constructed from fprime as follows:
!
!     f'(x) = interpolating function of order "iorder" (see below) of
!              {[x(1),fprime(1)],...,[x(nx),fprime(nx)]}
!             **assumed positive definite** fprime(1:nx) are checked
!              and satisfying the given boundary conditions
!
!     (nx,x(1:nx),fprime(1:nx), iorder & BCs given, x strict ascending).
!
!     Then,
!               integral[x(1) to x](f'(x')dx')
!     F(x) =  ---------------------------------  (ranging from 0.0 to 1.0)
!             inregral[x(1) to x(nx)](f'(x')dx')
!
!     is constructed from f', and, the vectorized solver "zridderx" is
!     used to find the roots xtarg(1:ntarg) satisfying
!
!         (F(xtarg(i)) = ztarg(i), i=1,ntarg)
!
!     to x accuracy tol*(x(nx)-x(1)) and F accuracy tol.
!
!     (ztarg(1:ntarg) are given, represent the normalized integral values,
!     and need not be ordered, though 0.0<=ztarg(i)<=1.0 is expected)
!
!     the normalizing integral[x(1) to x(nx)](f'(x')dx') is returned as
!     `fnorm'.
!
!---------------------------------------------
!
!     outputs: xtarg(1:ntarg), ier
!
!     no error messages are written here; call xdistrib_error(lun,ier)
!     to write a message on unit lun
!
!---------------------------------------------
!
!  the interpolating function -- constructed with pspline library routines
!
!    iorder=-1 -- step function:  btw x(j) & x(j+1) f = fprime(j)
!      (boundary condition arguments ignored)
!
!    iorder=0  -- piecewise linear interpolant
!      (boundary condition arguments ignored)
!
!    iorder=1  -- Akima Hermite interpolation
!      (boundary condition codes -1, 0, 1 are OK, but ibcxmin=ibcxmax
!       is expected!)
!
!    iorder=2 or 3 -- spline
!      (boundary condition codes -1, 0, 1, 2, ... 7 all OK)
!
!    ibcxmin -- boundary condition code for left endpoint x(1)
!     bcxmin -- associated parameter (if 1<=ibcxmin<=4)
!    ibcxmax -- boundary condition code for right endpoint x(nx)
!     bcxmax -- associated parameter (if 1<=ibcxmax<=4)
!
!    boundary condition codes are as described in "cspline" in the
!    pspline library.  see:  http://w3.pppl.gov/~pshare/help/pspline_hlp.html
!
!    The most common BC choices are:
!
!     ibcxmin=ibcxmax=-1 -- periodic boundary condition
!        f''(x(1))=f''(x(nx))  f'''(x(1))=f'''(x(nx))
!
!     ibcxmin(max)=0     -- default boundary condition
!        "not a knot" for Spline, divided difference for Hermite
!
!     ibcxmin(max)=1, bcxmin(max)= f'' at indicated boundary
!        specify the slope of f' (i.e. f'') in the argument.
!
!     except for periodic, the boundary conditions are independent
!     of eachother.
!
!---------------------------------------------
!
!
  implicit NONE
!
!  ***arguments***
!
  integer, intent(in) :: iorder       ! interpolating function order
  integer, intent(in) :: nx           ! dimension of x & fprime arrays
  real*8, intent(in) :: x(nx)         ! x coordinate -- STRICT ASCENDING
  real*8, intent(in) :: fprime(nx)    ! fprime -- all values .GE. ZERO
!
!  BC data -- ignored for some values of iorder
!
  integer, intent(in) :: ibcxmin,ibcxmax  ! boundary condition codes
  real*8, intent(in) :: bcxmin,bcxmax ! boundary condition data
!
!  target data
!
  integer, intent(in) :: ntarg        ! no. of target points
  real*8, intent(in) :: ztarg(ntarg)  ! F targets all values BTW 0.0 and 1.0
!
!  roots found
!
  real*8, intent(out) :: xtarg(ntarg)
!
!  normalizing integral
!
  real*8, intent(out) :: fnorm
!
  real*8, intent(in) :: tol           ! rel. accuracy tolerance
!
  integer, intent(out) :: ier         ! completion code, 0=OK
!
!    error codes -- see xdistrib_error
!
!-----------------------------------------------------------------
!  local...
!
  integer i,j,ilinx,ipx,iwarn,ifail
  integer, parameter, dimension(3) :: ict = (/ 1,0,0 /)
  integer, parameter :: ivec=10
  real*8 zero,one
  real*8 fmin,fmax,xmin,xmax
!
  real*8 feqi_1int
!
  real*8 wk(max(ivec,nx))
!
  real*8 fspv(ivec)  ! for test evaluations of interpolating function
!
  logical lmask(ntarg)
  real*8 zero_vec(ntarg),one_vec(ntarg),dum_vec(ntarg)
!
!-----------------------------------------------------------------
 
  external xdistrib_sub            ! for zridderx
 
!-----------------------------------------------------------------
!
  ier = 0
  zero = ier
  one = 1
  xtarg = zero
!
!  ...simple error checks...
!
  if(ntarg.le.0) ier=98
  if(nx.le.1) ier=99
  if(ier.ne.0) return
!
  if((iorder.lt.-1).or.(iorder.gt.3)) then
     ier=100
     return
  endif
!
  do i=1,nx-1
     if(x(i).ge.x(i+1)) then
        ier=101
        return
     endif
     if((fprime(i).eq.zero).and.(fprime(i+1).eq.zero)) ier=106
  enddo
  if(ier.ne.0) return
!
  xmin=x(1)
  xmax=x(nx)
!
  fmin=fprime(1)
  fmax=fprime(1)
!
  do i=2,nx
     fmin=min(fmin,fprime(i))
     fmax=max(fmax,fprime(i))
  enddo
  if(fmin.lt.zero) ier=102
  if((iorder.eq.-1).and.(fmin.eq.zero)) ier=106
!
  if(iorder.eq.1) then
     if((ibcxmin.lt.-1).or.(ibcxmin.gt.1)) ier=103
     if((ibcxmax.lt.-1).or.(ibcxmax.gt.1)) ier=104
     if(ibcxmin.ne.ibcxmax) ier=109
  else if(iorder.gt.1) then
     if((ibcxmin.lt.-1).or.(ibcxmin.gt.7)) ier=103
     if((ibcxmax.lt.-1).or.(ibcxmax.gt.7)) ier=104
  endif
  if(ier.ne.0) return
!
  do i=1,ntarg
     if((ztarg(i).lt.zero).or.(ztarg(i).gt.one)) then
        ier=105
        return
     endif
  enddo
!
  if(ier.ne.0) return
!
!---------------------------------------------------------------
! set up interpolating function
!
  allocate(splcoef(ncdim(iorder),nx))
  if(iorder.eq.-1) then
     splcoef(1,1:nx-1)=fprime(1:nx-1)
     splcoef(1,nx)=splcoef(1,nx-1)
  else
     splcoef(1,1:nx)=fprime(1:nx)
  endif
!
! compute hermite/spline coefficients
!
  if(iorder.eq.3) then
     call cspline(x,nx,splcoef,ibcxmin,bcxmin,ibcxmax,bcxmax, &
          wk,nx,ilinx,ier)
     if(ier.ne.0) ier=111
!
  else if(iorder.eq.2) then
     call mkspline(x,nx,splcoef,ibcxmin,bcxmin,ibcxmax,bcxmax, &
          ilinx,ier)
     if(ier.ne.0) ier=111
!
  else if(iorder.eq.1) then
     ipx=0
     if(ibcxmin.eq.-1) ipx=1
     if(ibcxmin.eq.1) then
        ipx=2
        splcoef(2,1)=bcxmin
        splcoef(2,nx)=bcxmax
     endif
     call akherm1p(x,nx,splcoef,ilinx,ipx,ier)
     if(ier.ne.0) ier=111
  endif
!
  if(ier.ne.0) go to 1000
!
  nx_spl=nx
  iorder_spl=iorder
!
!  setup interpolation zone lookup data
!
  if(ibcxmin.eq.-1) then
     ipx=1
  else
     ipx=0
  endif
!
  allocate(xpkg(nx,4))
!
  call genxpkg(nx,x,xpkg,ipx,0,1,tol,-3,ier)
  if(ier.ne.0) then
     ier=112
     go to 1000
  endif
!
!  negative evaluations test
!  evaluate ivec pts btw each successive node pair and check if the
!  min. is negative.
!
  if(iorder.ge.1) then
     do i=1,nx-1
 
        wk(1:ivec)=x(i) + (x(i+1)-x(I))*(/ (j/(one*(ivec+1)), j=1,ivec) /)
 
        if(iorder.eq.3) then
           call spvec(ict,ivec,wk,ivec,fspv,nx,xpkg,splcoef,iwarn,ier)
        else if(iorder.eq.2) then
           call vecspline(ict,ivec,wk,ivec,fspv,nx,xpkg,splcoef,iwarn,ier)
        else if(iorder.eq.1) then
           call vecherm1(ict,ivec,wk,ivec,fspv,nx,xpkg,splcoef,iwarn,ier)
        endif
 
        if(ier.ne.0) then
           ier=120
        else
           if(minval(fspv).lt.zero) ier=121
        endif
     enddo
  endif
!---------------------------------------------------------------
! integrate fprime*dx through each zone
!
  allocate(ftabl(nx))
!
  ftabl(1)=zero
  do i=1,nx-1
     ftabl(i+1)=ftabl(i)+feqi_1int(iorder,x,splcoef,nx,i,x(i+1)-x(i))
  enddo
  fnorm=ftabl(nx)
!
!---------------------------------------------------------------
! find the roots...
!
  lmask=.false.                   ! mask array
  do i=1,ntarg
     if(ztarg(i).eq.zero) then
        lmask(i)=.true.           ! left end point
        xtarg(i)=x(1)
     else if(ztarg(i).eq.one) then
        lmask(i)=.true.           ! right end point
        xtarg(i)=x(nx)
     endif
     zero_vec(i)=x(1)
     one_vec(i)=x(nx)
  enddo
!
  call zridderx(ntarg,lmask,zero_vec,one_vec,tol*(x(nx)-x(1)),tol, &
       xdistrib_sub, xtarg, ifail, ntarg, ztarg, 1, dum_vec, 1)
!
  if(ifail.ne.0) ier=120
!
!---------------------------------------------------------------
!  exit...
 
1000 continue
 
  if(allocated(xpkg)) deallocate(xpkg)
  if(allocated(splcoef)) deallocate(splcoef)
  if(allocated(ftabl)) deallocate(ftabl)
!
  return
!
end subroutine xdistrib
 
 
subroutine xdistrib_error(lun,ier)
!
!  report errors
!
  select case(ier)
 
     case(98)
        write(lun,*) '?xdistrib: at least one target element required.'
 
     case(99)
        write(lun,*) '?xdistrib: at least two x array elements required.'
 
     case(100)
        write(lun,*) '?xdistrib: "iorder" argument out of range.'
 
     case(101)
        write(lun,*) '?xdistrib:  x array not strict ascending.'
 
     case(102)
        write(lun,*) '?xdistrib:  fprime array has negative element.'
 
     case(103)
        write(lun,*) '?xdistrib:  invalid bdy cond: left end point.'
 
     case(104)
        write(lun,*) '?xdistrib:  invalid bdy cond: right end point.'
 
     case(105)
        write(lun,*) '?xdistrib:  target element not btw zero and one.'
 
     case(106)
        write(lun,*) '?xdistrib:  fprime array has consecutive zero elements.'
 
     case(109)
        write(lun,*) '?xdistrib:  when using Hermite, iorder=1,'
        write(lun,*) '            ibcxmin .eq. ibcxmax is required.'
 
     case(111)
        write(lun,*) '?xdistrib:  spline setup routine returned an error.'
 
     case(112)
        write(lun,*) '?xdistrib:  zone lookup setup routine returned an error.'
 
     case(120)
        write(lun,*) '?xdistrib:  error code during interpolation test.'
 
     case(121)
        write(lun,*) '?xdistrib:  interpolation test yields negative value.'
 
     case default
 
  end select
 
  return
 
end subroutine xdistrib_error
 

end module xdistrib_mod

subroutine eqi_geq_intrp(psi_geq, f_geq, ngeq, psi, ns, f, ier)
  !
  !  EFIT 1d profile interpolation routine
  !  (Hermite interpolation used, default boundary conditions)
  !
 
  use ezspline_obj
  use ezspline
 
  implicit none
  integer, parameter :: r8=selected_real_kind(12,100)
 
  ! ------------------ arguments ---------------------------------
 
  integer, intent(in) :: ngeq        ! no. of pts in G-EQDSK 1d profiles
  real(r8), intent(in) :: psi_geq(ngeq)  ! G-EQDSK psi grid (strict ascending)
  real(r8), intent(in) :: f_geq(ngeq)    ! G-EQDSK f(psi) profile
 
  integer, intent(in) :: ns          ! no. of psi-surfaces wanted
  real(r8), intent(in) :: psi(ns)    ! psi values at psi-surfaces
 
  real(r8), intent(out) :: f(ns)     ! profile values at psi-surfaces
 
  integer, intent(out) :: ier        ! completion code:  0 = OK
 
  ! ------------------ local items -------------------------------
 
  type(ezspline1) :: fspl
  integer iok
 
  ! ------------------ executable code ---------------------------
 
  ier=0
 
  call ezspline_init(fspl, ngeq, (/0,0/), iok)
  call ezspline_error(iok)
  if(iok.ne.0) ier=ier+1
 
  ! fspl%isHermite = 1  ! comment out to use spline
  fspl%x1 = psi_geq
 
  call ezspline_setup(fspl, f_geq, iok)
  call ezspline_error(iok)
  if(iok.ne.0) ier=ier+1
 
  call ezspline_interp(fspl, ns, psi, f, iok)
  call ezspline_error(iok)
  if(iok.ne.0) ier=ier+1
 
  call ezspline_free(fspl,iok)
  call ezspline_error(iok)
  if(iok.ne.0) ier=ier+1
 
  if(ier.ne.0) ier=120
 
  return
 
end subroutine eqi_geq_intrp

subroutine eq_xcyl(ivec,zR,zphi,xx,yy)

  !  vectorized
  !  cylindric to cartesian map.

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  integer ivec       ! vector dimension; ivec>0: normal Phi; ivec<0 -- reversed
  REAL*8 zR(abs(ivec)),zphi(abs(ivec))        ! input: (R,[Z],phi)
  REAL*8 xx(abs(ivec)),yy(abs(ivec))          ! output:  (x,y,[z])

  !-----------
  integer :: ier
  logical :: iccw
  !-----------

  iccw=ivec.gt.0
  call xplasma_ctrans(s,xp_use_coord_vecsize,ier, &
       r_in=zR,phi_in=zphi, ccw_phi=iccw, &
       x_out=xx,y_out=yy)

  if(ier.ne.0) then
     write(lunerr,*) ' ?eq_xcyl: error in xplasma_ctrans:'
     call xplasma_error(s,ier,lunerr)
  endif

end subroutine eq_xcyl

!----------------------------------------------------------------

subroutine eq_xcylcs(ivec,zR,zphi,xx,yy,zcosphi,zsinphi)

  !  vectorized.
  !  convert from cylindric coordinates (R,Z,phi) to
  !  cartesian coordinates (x,y,z).  also return cos(phi),sin(phi)

  !  z->Z
  !  x = R*cos(phi)
  !  y = R*sin(phi)

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  integer ivec       ! vector dimension; ivec>0: normal Phi; ivec<0 -- reversed
  REAL*8 zR(abs(ivec)),zphi(abs(ivec))         ! input: (R,phi)
  REAL*8 xx(abs(ivec)),yy(abs(ivec))           ! output:  (x,y)
  real*8 zcosphi(abs(ivec)),zsinphi(abs(ivec)) ! output:  cos(phi),sin(phi)

  !-------------------------------
  integer :: ier
  logical :: iccw
  !-----------

  iccw=ivec.gt.0
  call xplasma_ctrans(s,xp_use_coord_vecsize,ier, &
       r_in=zR,phi_in=zphi, ccw_phi=iccw, &
       x_out=xx,y_out=yy, cosphi=zcosphi,sinphi=zsinphi)

  if(ier.ne.0) then
     write(lunerr,*) ' ?eq_xcylcs: error in xplasma_ctrans:'
     call xplasma_error(s,ier,lunerr)
  endif

end subroutine eq_xcylcs

subroutine eq_nlist(inum_lists)

  !  Return the number of known lists in the current XPLASMA.

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(out) :: inum_lists

  integer :: ierr

  call xplasma_num_items(s,ierr, num_lists=inum_lists)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_nlist: xplasma_num_lists returned ierr=',ierr
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_nlist

subroutine eq_nlist_p(inum_lists)

  !  Return the number of lists containing plottable data

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(out) :: inum_lists

  integer :: ierr

  call xplasma_num_items(s,ierr, num_plists=inum_lists)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_nlist: xplasma_num_lists returned ierr=',ierr
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_nlist_p

subroutine eq_lists(inum_lists,list_names,list_ids,ierr)

  !  Return sorted list of list names and associated list id numbers.
  !  This is a "list of lists".

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: inum_lists  ! max no. of lists (array dimension)
  character*(*), intent(out) :: list_names(inum_lists)  ! sorted names returned
  integer, intent(out) :: list_ids(inum_lists)  ! list ids returned
  integer, intent(out) :: ierr       ! completion code, 0=OK

  !--------------------------------------
  integer :: inum_act,inum_tot,i,ii,ilist,itype
  !--------------------------------------

  list_names = ' '
  list_ids = 0

  call eq_nlist(inum_act)
  if(inum_act.gt.inum_lists) then
     ierr=1
     write(lunerr,*) ' ?eq_lists: array dimension = ',inum_lists,' is not'
     write(lunerr,*) '  big enough for actual # of lists: ',inum_act
     return
  else
     ierr = 0
  endif

  if(inum_act.eq.0) return

  call xplasma_contents(s,ierr, id_lists=list_ids)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_lists: xplasma_contents returned ierr=',ierr
     call xplasma_error(s,ierr,lunerr)
  endif

  do i=1,inum_act
     call xplasma_get_item_info(s,list_ids(i),ierr, name=list_names(i))
  enddo

end subroutine eq_lists

subroutine eq_lists_p(inum_lists,list_names,list_ids,ierr)

  !  Return sorted list of list names and associated list id numbers.
  !  ** return only lists containing plottable datasets **
  !  This is a "list of lists".

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: inum_lists  ! max no. of lists (array dimension)
  character*(*), intent(out) :: list_names(inum_lists)  ! sorted names returned
  integer, intent(out) :: list_ids(inum_lists)  ! list ids returned
  integer, intent(out) :: ierr       ! completion code, 0=OK

  !-------------------------------
  integer :: inum_act,inum_tot,i,ii,ilist,itype
  !--------------------------------------

  list_names = ' '
  list_ids = 0

  call eq_nlist_p(inum_act)
  if(inum_act.gt.inum_lists) then
     ierr=1
     write(lunerr,*) ' ?eq_lists_p: array dimension = ',inum_lists,' is not'
     write(lunerr,*) '  big enough for actual # of lists: ',inum_act
     return
  else
     ierr = 0
  endif

  if(inum_act.eq.0) return

  call xplasma_contents(s,ierr, id_plists=list_ids)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_lists: xplasma_contents returned ierr=',ierr
     call xplasma_error(s,ierr,lunerr)
  endif

  do i=1,inum_act
     call xplasma_get_item_info(s,list_ids(i),ierr, name=list_names(i))
  enddo

end subroutine eq_lists_p

subroutine eq_glistnum(list_name,list_id)

  !  return id of a specific named list
  !  return 0 if no such list

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  character*(*), intent(in) :: list_name
  integer, intent(out) :: list_id

  !--------------------

  integer :: itype,ierr

  !--------------------

  call xplasma_listId(s,list_name,list_id)

end subroutine eq_glistnum

subroutine eq_list_size(id,list_size)

  !  return size of individual list specified by "id".
  !  return size=0 if no such list

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: id    ! list id
  integer, intent(out) :: list_size

  !--------------------
  integer :: iertmp

  call xplasma_getlist(s,id,list_size,iertmp)
  if(iertmp.ne.0) then
     list_size = 0
  endif

end subroutine eq_list_size

subroutine eq_list_label(id,zlabel)

  !  return label of individual list specified by "id".
  !  return blank label if no such list

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: id    ! list id
  character*(*), intent(out) :: zlabel

  !--------------------
  integer :: ilen,itype,ierr
  !--------------------

  zlabel=' '
  call xplasma_get_item_info(s,id,ierr, itype=itype)
  if(ierr.ne.0) then
     call xplasma_error(s,ierr,lunerr)
  else if(itype.ne.xplasma_listType) then
     write(lunerr,*) ' ?eq_list_label: item# ',id,' not a list.'
  else
     call xplasma_get_item_info(s,id,ierr, label=zlabel)
  endif

end subroutine eq_list_label

subroutine eq_list_maxsize(list_size)

  !  return the maximum size of any list in XPLASMA

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(out) :: list_size

  integer :: i,ierr,inum_tot,isize
  integer,dimension(:), allocatable :: id_lists

  list_size = 0

  !  cycle through all items in alphabetic order, get list item names only...

  call eq_nlist(inum_tot)
  if(inum_tot.eq.0) return

  allocate(id_lists(inum_tot))
  call xplasma_contents(s,ierr, id_lists=id_lists)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_lists: xplasma_contents returned ierr=',ierr
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  do i=1,inum_tot
     call eq_list_size(id_lists(i),isize)
     list_size=max(list_size,isize)
  enddo

  deallocate(id_lists)

end subroutine eq_list_maxsize

subroutine eq_list_enames(id,list_size,enames,ierr)

  !  return names of list elements in enames(1:list_size)
  !  return ierr.ne.0 & enames blank if list_size < actual size of list.

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: id    ! list id
  integer, intent(in) :: list_size                 ! size of list passed in
  character*(*), intent(out) :: enames(list_size)  ! element names out
  integer, intent(out) :: ierr ! completion code, 0=OK

  !--------------------
  integer :: isize
  !--------------------

  call eq_list_size(id,isize)
  isize=min(max(1,isize),list_size)

  call xplasma_getlist_names(s,id,enames(1:isize),ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_list_enames -- access to list element names failed.'
     write(lunerr,*) '  list id: ',id,' ierr: ',ierr
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_list_enames

subroutine eq_list_chvals(id,list_size,chvals,ierr)

  !  return character data values of list elements in chvals(1:list_size)
  !  return ierr.ne.0 & chvals blank if list_size < actual size of list.

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: id    ! list id
  integer, intent(in) :: list_size                 ! size of list passed in
  character*(*), intent(out) :: chvals(list_size)  ! character data values out
  integer, intent(out) :: ierr ! completion code, 0=OK

  !--------------------
  integer :: isize
  !--------------------

  call eq_list_size(id,isize)
  isize=min(max(1,isize),list_size)

  call xplasma_getlist(s,id,chvals(1:isize),ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_list_chvals-- access to list character data failed.'
     write(lunerr,*) '  list id: ',id,' ierr: ',ierr
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_list_chvals

subroutine eq_list_r8vals(id,list_size,r8vals,ierr)

  !  return floating pt data values of list elements in r8vals(1:list_size)
  !  return ierr.ne.0 & r8vals blank if list_size < actual size of list.

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: id    ! list id
  integer, intent(in) :: list_size                 ! size of list passed in
  real*8, intent(out) :: r8vals(list_size)         ! character data values out
  integer, intent(out) :: ierr ! completion code, 0=OK

  !--------------------
  integer :: isize
  !--------------------

  call eq_list_size(id,isize)
  isize=min(max(1,isize),list_size)

  call xplasma_getlist(s,id,r8vals(1:isize),ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_list_r8vals-- access to list r8 float data failed.'
     write(lunerr,*) '  list id: ',id,' ierr: ',ierr
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_list_r8vals

subroutine eq_list_r4vals(id,list_size,r4vals,ierr)

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: id    ! list id
  integer, intent(in) :: list_size                 ! size of list passed in
  real*4, intent(out) :: r4vals(list_size)         ! real*4 data values out
  integer, intent(out) :: ierr ! completion code, 0=OK
  
  !--------------------
  integer :: isize
  !--------------------

  call eq_list_size(id,isize)
  isize=min(max(1,isize),list_size)

  call xplasma_getlist(s,id,r4vals(1:isize),ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_list_r4vals -- access to list r4 float data failed.'
     write(lunerr,*) '  list id: ',id,' ierr: ',ierr
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_list_r4vals

subroutine eq_list_ivals(id,list_size,ivals,ierr)

  !  return integer data values of list elements in ivals(1:list_size)
  !  return ierr.ne.0 & ivals blank if list_size < actual size of list.

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: id    ! list id
  integer, intent(in) :: list_size                 ! size of list passed in
  integer, intent(out) :: ivals(list_size)         ! integer data values out
  integer, intent(out) :: ierr ! completion code, 0=OK

  !--------------------
  integer :: isize
  !--------------------

  call eq_list_size(id,isize)
  isize=min(max(1,isize),list_size)

  call xplasma_getlist(s,id,ivals(1:isize),ierr)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_list_ivals -- access to list integer data failed.'
     write(lunerr,*) '  list id: ',id,' ierr: ',ierr
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_list_ivals

subroutine equigs_xpsi(id_xphi,id_q,xpsi_name,id_xpsi,ierr)

  !  using an xplasma sqrt(Phi/Philim) grid (id_xphi) and
  !  a q profile (id_q) construct a function sqrt(Psi/Psilim) with
  !  name (xpsi_name) and return its xplasma id (id_xpsi)

  implicit NONE

  integer, intent(in) :: id_xphi    ! xplasma id: x=sqrt(Phi/Philim) grid
  integer, intent(in) :: id_q       ! xplasma id: q(x) profile
  character*(*), intent(in) :: xpsi_name    ! name for sqrt(Psi/Psilim)

  integer, intent(out) :: id_xpsi   ! id of sqrt(Psi/Psilim) profile created.
  integer, intent(out) :: ierr      ! status code, 0=OK

  !----------------------------------------------------
  integer :: ix,ixqmin,inx,id_rho,lunmsg,inrho,idum
  real*8 :: zdelta,zqlim,zqi,zx,zdx,zs1,zs2
  real*8, dimension(:), allocatable :: x,q,qsm,xpsi

  real*8, parameter :: QLIM0=10.0d0 ! limit axial q value
  real*8, parameter :: ZERO=0.0d0
  real*8, parameter :: ONE=1.0d0
  real*8, parameter :: TWO=1.0d0
  real*8, parameter :: ZDMIN=0.05d0 ! min smoothing
  !----------------------------------------------------

  call eq_get_lunerr(lunmsg)

  id_xpsi=0
  ierr=1

  !--------------------------------------
  !  look up equilibrium grid to set smoothing parameter

  call eq_ganum('__RHO',id_rho)
  if(id_rho.eq.0) then
     write(lunmsg,*) ' ?equigs_xpsi: could not find __RHO grid.'
     return
  endif

  call eq_ngrid(id_rho,inrho)

  !  smoothing parameter:
  zdelta = max(ZDMIN,ONE/(inrho-1))

  !--------------------------------------
  !  fetch xphi grid (may or not be same as __RHO grid) and allocate
  !  and fetch q profile

  call eq_ngrid(id_xphi,inx)
  if(inx.eq.0) then
     write(lunmsg,*) ' ?equigs_xpsi: grid id_xphi = ',id_xphi,' shows 0 size.'
     return
  endif

  allocate(x(inx),q(inx),qsm(inx),xpsi(inx))
  
  do
     call eq_grid(id_xphi,x,inx,idum,ierr)
     if(ierr.ne.0) exit

     call eq_rgetf(inx,x,id_q,0,q,ierr)
     exit
  enddo

  if(ierr.ne.0) then
     deallocate(x,q,qsm,xpsi)
     return
  endif

  !--------------------------------------
  !  smooth q profile; impose QLIM0 inbound from a q profile local minimum...

  ixqmin=1

  do ix=inx,2,-1
     if(q(ix-1).gt.q(ix)) then
        ixqmin=ix
        exit
     endif
  enddo

  zqlim=max(QLIM0,2*q(ixqmin))

  do ix=1,ixqmin-1
     q(ix)=min(zqlim,q(ix))
  enddo

  qsm = q

  call r8_qksmooth(inx,x,qsm,zdelta,ZERO,ZERO,ierr) ! fix end pts

  if(ierr.ne.0) then
     deallocate(x,q,qsm,xpsi)
     return
  endif

  !--------------------------------------
  ! compute xpsi = Psi/Psilim = integral[0,x](dx*x/q) / integral[0,1](dx*x/q)

  xpsi(1) = 0
  do ix = 2,inx
     zdx=x(ix)-x(ix-1)
     zx=(x(ix)+x(ix-1))/TWO
     zqi=TWO/(qsm(ix)+qsm(ix-1))

     xpsi(ix) = xpsi(ix-1) + zdx*zx*zqi
  enddo

  ! normalize to [0,1]

  xpsi = xpsi/xpsi(inx)

  ! sqrt

  xpsi(2:inx) = sqrt(xpsi(2:inx))

  !--------------------------------------
  !  create profile

  zs1=(xpsi(2)-xpsi(1))/(x(2)-x(1))
  zs2=(xpsi(inx)-xpsi(inx-1))/(x(inx)-x(inx-1))

  call eqm_rhofun(101,id_xphi,xpsi_name,xpsi, &    ! Akima Hermite, xpsi' BC
       1,zs1,1,zs2,id_xpsi,ierr)

  deallocate(x,q,qsm,xpsi)

  return
end subroutine equigs_xpsi

subroutine xplasma_debug_r4momry(zxi,zth,ijac,zR,zZ,zjac)

  use xplasma_definitions
  use xpl_dbg_module
  implicit NONE

  !  interface for 2d equilibrium data -- arguments like the old
  !  TRANSP momry routine -- note REAL not REAL*8 arguments!

  !  this is used for debug plot purposes only...

  ! input:
  real zxi                          ! radial mag. coordinate
  real zth                          ! poloidal angle coordinate
  integer ijac                      ! =1 if 2x2 Jacobian is desired

  ! output:
  real zR
  real zZ
  real zjac(2,2)

  !---------------------------------

  real*8 zR8(1),zZ8(1),zRdx8(1),zZdx8(1),zRdth8(1),zZdth8(1),zx8(1),zth8(1)
  real*8 zRZ8(1,2)

  integer ierr,id_R,id_Z,id2(2)

  !---------------------------------

  zR=0.0
  zZ=0.0
  zjac=0.0

  zx8=zxi
  zth8=zth

  if(ijac.eq.0) then

     call xplasma_common_ids(sp,ierr, id_R=id_R,id_Z=id_Z)
     if(min(id_R,id_Z).eq.0) return
     if(ierr.ne.0) return

     id2(1)=id_R; id2(2)=id_Z

     call xplasma_RZeval_2d(sp,id2, &
          xplasma_theta_coord,zth8,xplasma_rho_coord,zx8, &
          zRZ8,ierr)

     zR=zRZ8(1,1)
     zZ=zRZ8(1,2)

  else

     call xplasma_rzjac(sp,zx8,zth8,ierr, &
          r=zR8,z=zZ8, &
          drdrho=zRdx8,dzdrho=zZdx8,drdtheta=zRdth8,dzdtheta=zZdth8)

     zR=zR8(1)
     zZ=zZ8(1)

     zjac(1,1)=zRdx8(1)
     zjac(2,1)=zRdth8(1)

     zjac(1,2)=zZdx8(1)
     zjac(2,2)=zZdth8(1)

  endif

end subroutine xplasma_debug_r4momry

subroutine scrmemory
  use mintrp
  use scrunch_inc1
  use scrunch_inc2
  !...begin heap allocation
  implicit none

  integer :: ialloc

  ialloc = 0
  allocate(rin(nu,ncmax), STAT=ialloc)
  if(ialloc.ne.0) then
    call scraborter('ERROR allocating rin(nu,ncmax)')
  end if
  allocate(zin(nu,ncmax), STAT=ialloc)
  if(ialloc.ne.0) then
    call scraborter('ERROR allocating zin(nu,ncmax)')
  end if
  allocate(xvec(n2), STAT=ialloc)
  if(ialloc.ne.0) then
    call scraborter('ERROR allocating xvec(n2)')
  end if
  allocate(gvec(n2), STAT=ialloc)
  if(ialloc.ne.0) then
    call scraborter('ERROR allocating gvec(n2)')
  end if
  allocate(xdot(n2), STAT=ialloc)
  if(ialloc.ne.0) then
    call scraborter('ERROR allocating xdot(n2)')
  end if
  allocate(xstore(n2), STAT=ialloc)
  if(ialloc.ne.0) then
    call scraborter('ERROR allocating xstore(n2)')
  end if
  allocate(m1(mnd), STAT=ialloc)
  if(ialloc.ne.0) then
    call scraborter('ERROR allocating m1(mnd)')
  end if
  allocate(n1(mnd), STAT=ialloc)
  if(ialloc.ne.0) then
    call scraborter('ERROR allocating n1(mnd)')
  end if
  allocate(rmomb(mpol,2), STAT=ialloc)
  if(ialloc.ne.0) then
    call scraborter('ERROR allocating rmomb(mpol,2)')
  end if
  allocate(zmomb(mpol,2), STAT=ialloc)
  if(ialloc.ne.0) then
    call scraborter('ERROR allocating zmomb(mpol,2)')
  end if
  allocate(mm(mpol), STAT=ialloc)
  if(ialloc.ne.0) then
    call scraborter('ERROR allocating mm(mpol)')
  end if
  allocate(dm1(mpol), STAT=ialloc)
  if(ialloc.ne.0) then
    call scraborter('ERROR allocating dm1(mpol)')
  end if
  allocate(faccon(mpol), STAT=ialloc)
  if(ialloc.ne.0) then
    call scraborter('ERROR allocating faccon(mpol)')
  end if
  allocate(xmpq(mpol,4), STAT=ialloc)
  if(ialloc.ne.0) then
    call scraborter('ERROR allocating xmpq(mpol,4)')
  end if
  allocate(result(nphi2,mpol,4), STAT=ialloc)
  if(ialloc.ne.0) then
    call scraborter('ERROR allocating result(nphi2,mpol,4)')
  end if
  allocate(rin3d(ntheta,nphi), STAT=ialloc)
  if(ialloc.ne.0) then
    call scraborter('ERROR allocating rin3d(ntheta,nphi)')
  end if
  allocate(zin3d(ntheta,nphi), STAT=ialloc)
  if(ialloc.ne.0) then
    call scraborter('ERROR allocating zin3d(ntheta,nphi)')
  end if
  allocate(angle(ntheta,nphi), STAT=ialloc)
  if(ialloc.ne.0) then
    call scraborter('ERROR allocating angle(ntheta,nphi)')
  end if
  !...end heap allocation
  return
end subroutine scrmemory

subroutine eqm_bbin(zbb,iauto,inum,ztol,id,ierr)

  use xplasma_obj_instance
  use eq_module

  !  set up mod(B) grid -- must be strict ascending

  IMPLICIT NONE

  !  input:

  integer inum                      ! #of grid bdy pts
  integer iauto                     ! .ge.1 for automatic grid generation
  REAL*8 zbb(inum)                  ! the B grid (zone bdys, inum-1 zones).
  REAL*8 ztol                       ! even spacing tolerance

  !  zbb is output if iauto is set .gt.0.
  !    if iauto=1, every surface is searched for Bmin,Bmax.
  !    if iauto.gt.1, every iauto'th surface is searched, starting with
  !    the outermost surface.

  !  output:

  integer id                        ! axis id code (returned)
  integer ierr                      ! =0: OK

  !-----------------

  integer i,iwarn,inrho,id_rho,iertmp
  real*8 zbmin,zbmax,zbmin1,zbmax1
  real*8, dimension(:), allocatable :: zrho
  real*8, parameter :: ZERO = 0.0d0
  !-------------------------------------------------------------
  !  error checks:

  ierr=0
  iwarn=0

  call xplasma_find_item(s,'__RHO',id_rho,ierr)
  if(ierr.ne.0) then
     call xplasma_error(s,ierr,lunerr)
     write(lunerr,*) ' ?eqm_bbin: radial flux coordinate not found.'
     return
  endif

  call xplasma_grid_size(s,id_rho,inrho,ierr)
  if(ierr.ne.0) return

  allocate(zrho(inrho))
  call xplasma_grid(s,id_rho,zrho,iertmp)

  if(iauto.gt.0) then

     !  automatic generation of B grid -- search every iauto'th surface
     !  for Bmin, Bmax; create grid to span the range.

     do i=inrho,1,-iauto
        call eq_glimb(zrho(i),zbmin1,zbmax1,ierr)
        if(ierr.ne.0) then
           write(lunerr,*) ' ?eqm_bbin -- Bmin/Bmax search failed.'
           return
        endif
        if(i.eq.inrho) then
           zbmin=zbmin1
           zbmax=zbmax1
        else
           zbmin=min(zbmin,zbmin1)
           zbmax=max(zbmax,zbmax1)
        endif
     enddo
     
     if((zbmin.eq.ZERO).and.(zbmax.eq.ZERO)) then
        zbmin=0.1d0
        zbmax=0.1d0
     endif

     !  spread the range a bit...

     zbmin=0.95d0*zbmin
     zbmax=1.05d0*zbmax

     !  generate the grid

     do i=1,inum
        zbb(i)=zbmin+(i-1)*(zbmax-zbmin)/(inum-1)
     enddo

  endif

  deallocate(zrho)

  !  monotonicity check

  do i=1,inum-1
     if(zbb(i+1).le.zbb(i)) then
        iwarn=iwarn+1
        ierr=ierr+1
        if(iwarn.le.3) then
           call eq_errmsg(' ?eqm_bbin:  mod(B) grid not strict ascending.')
           write(lunerr,*) ' zbb(',i,')=',zbb(i),' zbb(',i,'+1)=',zbb(i+1)
        endif
     endif
  enddo

  if(inum.le.4) then
     ierr=ierr+1
     call eq_errmsg(' ?eqm_bbin:  less than 4 points in mod(B) grid.')
     write(lunerr,*) ' inum=',inum
  endif

  if(ierr.gt.0) then
     ierr=9999
     return
  endif

  !  OK, create grid

  call xoi_author_set(iertmp)
  call xplasma_create_grid(s,'Bgrid',xplasma_B_coord,zbb,id,ierr, &
       label='Grid of B values based on plasma Bmin & Bmax')
  call xoi_author_clear(iertmp)

  if(ierr.gt.0) return

end subroutine eqm_bbin

      SUBROUTINE MCRDR_RDNB(LUN,LINE,IEOF)
C
C  READ TO FIRST NON-BLANK LINE, EOF CHECK
C
      CHARACTER*(*) LINE
C
      IEOF=0
 10   CONTINUE
      CALL MCRDR_READ(LUN,LINE,IEOF)
      IF(IEOF.EQ.1) GO TO 20
C
      INB=MCSTR_FINDND(LINE,' ')
      IF(INB.EQ.0) GO TO 10
C
 20   CONTINUE
C
      RETURN
      END

      subroutine eqm_msgs(ilun,zfile,ierr)
C
      use eq_module
C
C  set error message i/o unit, and, optionally, open a file
C  *** caller should check error code returned ***
C
      IMPLICIT NONE
C
C  input:
C
      integer ilun                      ! unit on which to write messages
      character*(*) zfile               ! (optional) file for messages
C
C  output:
C
      integer ierr                      ! error code (open iostat, 0=normal)
C
c$cface_input:  zfile
C------------------------------------
C
      ierr=0
      lunerr=ilun
C
      if(zfile.ne.' ') then
         open(unit=lunerr,file=zfile,status='unknown',iostat=ierr)
      endif
C
      return
      end

 
#include "fpreproc/byte_declare.h"
 
!----------------------------------------------------------
! cface  -- generated (f90 fixed form) C interface to:  EQM_MSGS
      SUBROUTINE  C_EQM_MSGS(
     > ILUN,C_ZFILE_LEN,C_ZFILE,IERR)
 
      external EQM_MSGS
 
! argument declarations
      INTEGER ILUN
 ! scalar char*(*) type, input only:
      INTEGER C_ZFILE_LEN
      BYTE_DECLARE C_ZFILE(C_ZFILE_LEN)
 
      INTEGER IERR
 
! local (automatic array) declarations
      CHARACTER(C_ZFILE_LEN) :: ZFILE_act
 
! executable code:  copy for input
 
      call cstring(ZFILE_act, C_ZFILE,'2F')
! call to original routine:  EQM_MSGS
 
      CALL EQM_MSGS(
     > ILUN,ZFILE_act,IERR)
 
! copy back outputs if modified.
 
! exit
      return
      end

 
#include "fpreproc/byte_declare.h"
 
!----------------------------------------------------------
! cface  -- generated (f90 fixed form) C interface to:  EQM_FRHOCHI
      SUBROUTINE  C_EQM_FRHOCHI(
     > IORDER,ID_AX1,ID_AX2,C_ZLBL_LEN,C_ZLBL,ZDATA,ID1,IBCRHO0,ZBCRHO0,
     > IBCRHO1,ZBCRHO1,ID_FUN,IERR)
 
      external EQM_FRHOCHI
 
! argument declarations
      INTEGER IORDER
      INTEGER ID_AX1
      INTEGER ID_AX2
 ! scalar char*(*) type, input only:
      INTEGER C_ZLBL_LEN
      BYTE_DECLARE C_ZLBL(C_ZLBL_LEN)
 
      INTEGER ID1
      INTEGER IBCRHO0
      INTEGER IBCRHO1
      INTEGER ID_FUN
      INTEGER IERR
      REAL*8 ZDATA(ID1,*)
      REAL*8 ZBCRHO0(*)
      REAL*8 ZBCRHO1(*)
 
! local (automatic array) declarations
      CHARACTER(C_ZLBL_LEN) :: ZLBL_act
 
! executable code:  copy for input
 
      call cstring(ZLBL_act, C_ZLBL,'2F')
! call to original routine:  EQM_FRHOCHI
 
      CALL EQM_FRHOCHI(
     > IORDER,ID_AX1,ID_AX2,ZLBL_act,ZDATA,ID1,IBCRHO0,ZBCRHO0,IBCRHO1,
     > ZBCRHO1,ID_FUN,IERR)
 
! copy back outputs if modified.
 
! exit
      return
      end

!  hand maintained R4 interfaces ... for eqm_rhofun & eqm_frhochi
!                                ... and eq_hrhochi ... etc ...
c----------------------------------------------
      subroutine r4_eqm_rhofun(iorder,id_axis,zlbl,r4_zdata,
     >   ibc1,r4_zbc1,ibc2,r4_zbc2,
     >   id_rhofun,ierr)
c
c  REAL (usually real*4) interface
cc  establish a function of "rho" -- axis to plasma bdy
c
c  input:
      IMPLICIT NONE
c
      integer iorder                    ! interpolation order
c
c     for all of the following, (nrho) values are to be provided.
c
c  iorder = 0 -- piecewise linear
c  iorder = 1 -- use Hermite piecewise cubics with Akima method for
c     setting the derivative at the grid points (modified at the bdys)
c  iorder = 2 or 3 -- use a cubic spline
c
c  iorder = 1 -- once differentiable
c  iorder = 2 or 3 -- twice differentiable (spline)
c
      integer id_axis                   ! axis id -- must be rho or akin to rho
c
c  if id_axis is not rho, then the size of the object is not nrho but the
c  size of the given axis.  The given axis must be "kin" to rho, i.e. it
c  must map the same space, but perhaps with a larger or smaller number of
c  points differently distributed.
c
      character*(*) zlbl                ! function name (label)
      REAL r4_zdata(*)                  ! data (at least `nrho' words)
c
      integer ibc1                      ! bc @ rho_axis
      real r4_zbc1                      ! bc parameter
      integer ibc2                      ! bc @ rho_bdy
      real r4_zbc2                      ! bc parameter
c
c                =0:  "standard" boundary condition:  "not a knot" for
c                     splines, Akima for piecewise Hermite.
c                =1:  assigned df/drho bc, --> df/drho=zbc1|2
c                =2:  assigned d2f/drho2 bc (splines only), d2f/drho2=zbc1|2
c
c  for iorder.le.0, bc controls are ignored.
c
c  output:
c
      integer id_rhofun                 ! function id, returned
      integer ierr                      ! completion code, 0=OK
c
c-----------------------------
c
      real*8, dimension(:), allocatable :: zdata
      real*8 zbc1,zbc2
c
      integer ixsize
c
c-----------------------------
c
      call eq_ngrid(id_axis,ixsize)
c
      if(ixsize.gt.0) then
         allocate(zdata(ixsize))
         zdata=r4_zdata(1:ixsize)
      else
         allocate(zdata(1))
         zdata=0  ! there will be an error...
      endif
c
      zbc1=r4_zbc1
      zbc2=r4_zbc2
c
      call eqm_rhofun(iorder,id_axis,zlbl,zdata,
     >   ibc1,zbc1,ibc2,zbc2,
     >   id_rhofun,ierr)
c
      deallocate(zdata)
c
      return
      end
c----------------------------------------------
      subroutine r4_eqm_f1d(iorder,id_axis,zlbl,r4_zdata,
     >   ibc1,r4_zbc1,ibc2,r4_zbc2,
     >   id_f1d,ierr)
c
c  REAL (usually real*4) interface
cc  establish a function of "rho" -- axis to plasma bdy
c
c  input:
      IMPLICIT NONE
c
      integer iorder                    ! interpolation order
c
c     for all of the following, (nrho) values are to be provided.
c
c  iorder = 0 -- piecewise linear
c  iorder = 1 -- use Hermite piecewise cubics with Akima method for
c     setting the derivative at the grid points (modified at the bdys)
c  iorder = 2 or 3 -- use a cubic spline
c
c  iorder = 1 -- once differentiable
c  iorder = 2 or 3 -- twice differentiable (spline)
c
      integer id_axis                   ! axis id -- must be rho or akin to rho
c
c  if id_axis is not rho, then the size of the object is not nrho but the
c  size of the given axis.  The given axis must be "kin" to rho, i.e. it
c  must map the same space, but perhaps with a larger or smaller number of
c  points differently distributed.
c
      character*(*) zlbl                ! function name (label)
      REAL r4_zdata(*)                  ! data (at least `nrho' words)
c
      integer ibc1                      ! bc @ rho_axis
      real r4_zbc1                      ! bc parameter
      integer ibc2                      ! bc @ rho_bdy
      real r4_zbc2                      ! bc parameter
c
c                =0:  "standard" boundary condition:  "not a knot" for
c                     splines, Akima for piecewise Hermite.
c                =1:  assigned df/drho bc, --> df/drho=zbc1|2
c                =2:  assigned d2f/drho2 bc (splines only), d2f/drho2=zbc1|2
c
c  for iorder.le.0, bc controls are ignored.
c
c  output:
c
      integer id_f1d                 ! function id, returned
      integer ierr                      ! completion code, 0=OK
c
c-----------------------------
c
      real*8, dimension(:), allocatable :: zdata
      real*8 zbc1,zbc2
c
      integer ixsize
c
c-----------------------------
c
      call eq_ngrid(id_axis,ixsize)
c
      if(ixsize.gt.0) then
         allocate(zdata(ixsize))
         zdata=r4_zdata(1:ixsize)
      else
         allocate(zdata(1))
         zdata=0  ! there will be an error...
      endif
c
      zbc1=r4_zbc1
      zbc2=r4_zbc2
c
      call eqm_f1d(iorder,id_axis,zlbl,zdata,
     >   ibc1,zbc1,ibc2,zbc2,
     >   id_f1d,ierr)
c
      deallocate(zdata)
c
      return
      end
c----------------------------------------------------------
      subroutine r4_eqm_frhochi(iorder,id_ax1,id_ax2,zlbl,r4_zdata,id1,
     >   ibcrho0,r4_zbcrho0,ibcrho1,r4_zbcrho1,id_fun,ierr)
c
c  REAL (usually real*4) interface to eqm_frhochi
c
c  establish a function of "rho & chi" -- axis to plasma bdy
c
      use xplasma_obj_instance
c
      IMPLICIT NONE
c
c  input:
      integer iorder                    ! desired interpolation order
c
c  [in these comments nrho & nchi refer to the axes of the data passed]
c  iorder=-1: (nrho-1)x(nchi-1) pts supplied -- binned data, with
c        f(i,j) constant in [rho(i),rho(i+1)]x[chi(j),chi(j+1)]
c
c  iorder=0:  bilinear interpolation on data on (nrho)x(nchi) grid
c  iorder=1:  Akima Hermite interpolation on data on(nrho)x(nchi) grid
c  iorder=2 or 3:  Spline interpolation on data on (nrho)x(nchi) grid
c
      integer id_ax1                    ! axis id -- 1st dimension of zdata
      integer id_ax2                    ! axis id -- 2nd dimension of zdata
c
c  id_ax1 or id_ax2 must give a rho coordinate; the other coordinate must
c  be a chi (poloidal angle) coordinate.  Regardless of the ordering of
c  zdata, the module is data is stored with chi = 1st dimension, rho =
c  2nd dimension.
c
      character*(*) zlbl                ! function name (label)
      integer id1                       ! size of 1st dimension of zdata
c
      REAL r4_zdata(id1,*)              ! data (at least nrho*nchi words)
c
c  id1 must be .ge. size of axis (id_ax1)
c
c  bdy conditions are enforced only for iorder.ge.1
c
      integer ibcrho0,ibcrho1           ! BC's at extrema
c
c  BC controls are as in "pspline":  0 -- default, 1 -- fix df/drho
c                                    2 -- fix d2f/drho2
c
      REAL r4_zbcrho0(*)                ! if ibc>0:  df/drho @ rho(1)
      REAL r4_zbcrho1(*)                ! ditto:  df/drho @ rho(nrho)
c
c  output:
c
      integer id_fun                    ! function id code
      integer ierr                      ! completion code, 0=OK
c
c-----------------------------
c  local copy
c
      real*8, dimension(:,:), allocatable :: zdata
      real*8, dimension(:), allocatable :: zbcrho0,zbcrho1
c
      integer i,in1,in2,inrho,inchi,iflag,icoord
c
c-----------------------------
c
c  find dimensions...
c
      call eq_ngrid(id_ax1,in1)
      call eq_ngrid(id_ax2,in2)

      iflag=0
      if((in1.eq.0).or.(in2.eq.0)) iflag=1

      if(iflag.eq.0) then
c
c  axes look OK; which one is "rho"?
c
         iflag=1
c
         call xplasma_grid_info(s,id_ax1,ierr, coord=icoord)
         if(icoord.eq.xplasma_rho_coord) then
            inrho=in1
            inchi=in2
            iflag=0

         else
            call xplasma_grid_info(s,id_ax2,ierr, coord=icoord)
            if(icoord.eq.xplasma_rho_coord) then
               inrho=in2
               inchi=in1
               iflag=0
            endif
         endif
      endif

      if(iflag.eq.1) then
         allocate(zbcrho0(1),zbcrho1(1),zdata(id1,1))
         zbcrho0=0; zbcrho1=0; zdata=0
      else
         allocate(zbcrho0(inchi))
         allocate(zbcrho1(inchi))
         zbcrho0=0
         zbcrho1=0
         if(ibcrho0.gt.0) zbcrho0=r4_zbcrho0(1:inchi)
         if(ibcrho1.gt.0) zbcrho1=r4_zbcrho1(1:inchi)
c
         allocate(zdata(id1,in2))
         zdata=0
         do i=1,in2
            zdata(1:in1,i)=r4_zdata(1:in1,i)
         enddo
c
      endif
c
      call eqm_frhochi(iorder,id_ax1,id_ax2,zlbl,zdata,id1,
     >     ibcrho0,zbcrho0,ibcrho1,zbcrho1,id_fun,ierr)
c
      deallocate(zdata)
      deallocate(zbcrho1)
      deallocate(zbcrho0)
c
      return
      end
c------------------------------------------------------
      subroutine r4_eq_hrhochi(ivec,r4_zrho,r4_zchi,nlist,iflist,
     >   ictwant,ivecd,r4_zans,ierr)
c
c  hand maintained real*4 interface to eq_hrhochi
c  (dmc 25 Aug 2000)
c
      implicit NONE
c
c  input:
c
      integer ivec                      ! input vector dimension
      !  ivec.lt.0 to indicate CW-reversed chi

      REAL r4_zrho(abs(ivec))
      REAL r4_zchi(abs(ivec))
      integer nlist                     ! number of functions
      integer iflist(nlist)             ! functions to evaluate
c
      integer ictwant(6)                ! output selector (pspline style)
c
c  each element of ictwant(1:6) should be 0 or 1
c  use 1 to indicate a desired item:
c
c   ictwant(1) -- function values            ...1 if wanted, 0 otherwise
c   ictwant(2) -- functions' df/drho values
c   ictwant(3) -- functions' df/dchi values
c   ictwant(4) -- functions' d2f/drho2 values
c   ictwant(5) -- functions' d2f/dchi2 values
c   ictwant(6) -- functions' d2f/drhodchi values
c
      integer ivecd                     ! output vector dimension
c
c  output:
c
      REAL r4_zans(ivecd,*)              ! evaluation results
      integer ierr                      ! completion code (0=OK)
c
c  ** let ictnum = # of non-zero elements of ictwant.
c         (ictnum=sum(ictwant)).  Then...
c  zans(1:ivec,1)   = value or derivative for function id iflist(1)
c                     indicated by first non-zero value of ictwant(...)
c  zans(1:ivec,2)   = value or derivative for function id iflist(1)
c                     indicated by second non-zero value of ictwant(...)
c    ...
c  zans(1:ivec,ictnum)   = value or derivative for function id iflist(1)
c                     indicated by last non-zero value of ictwant(...)
c
c  or generally, for 1 .le. k .le. ictnum,
c    ...
c  zans(1:ivec,(j-1)*ictnum+k) = value or derivative for function
c                                id iflist(j), corresponding to k'th
c                                non-zero element of ictwant(...)
c
c--------------------------------------------------
c
      REAL*8 zrho(abs(ivec))                 ! argument -- where to evaluate
      REAL*8 zchi(abs(ivec))                 ! argument -- where to evaluate
c
      REAL*8, dimension(:,:), allocatable :: zans
c
      integer ictnum,i
c
c----------------------------------
c
c  copy to REAL*8 argument arrays
c
      zrho=r4_zrho
      zchi=r4_zchi
c
c  allocate REAL*8 output buffer
c
      ictnum=sum(ictwant)
      allocate(zans(ivecd,max(1,ictnum)*nlist))
c
c  call eq_hrhochi using REAL*8 arguments
c
      call eq_hrhochi(ivec,zrho,zchi,nlist,iflist,ictwant,
     >   ivecd,zans,ierr)
c
c  copy answer back
c
      if(ierr.eq.0) then
c
         do i=1,max(1,ictnum)*nlist
            r4_zans(1:abs(ivec),i)=zans(1:abs(ivec),i)
         enddo
c
      endif
c
c  deallocate buffer
c
      deallocate(zans)
c
      return
      end
c------------------------------------------------------
      subroutine r4_eq_hRZ(ivec,r4_zR,r4_zZ,nlist,iflist,
     >   ictwant,ivecd,r4_zans,ierr)
c
c  hand maintained real*4 interface to eq_hRZ
c  (dmc 25 Aug 2000)
c
      implicit NONE
c
c  input:
c
      integer ivec                      ! input vector dimension
      REAL r4_zR(ivec)
      REAL r4_zZ(ivec)
      integer nlist                     ! number of functions
      integer iflist(nlist)             ! functions to evaluate
c
      integer ictwant(6)                ! output selector (pspline style)
c
c  each element of ictwant(1:6) should be 0 or 1
c  use 1 to indicate a desired item:
c
c   ictwant(1) -- function values            ...1 if wanted, 0 otherwise
c   ictwant(2) -- functions' df/dR values
c   ictwant(3) -- functions' df/dZ values
c   ictwant(4) -- functions' d2f/dR2 values
c   ictwant(5) -- functions' d2f/dZ2 values
c   ictwant(6) -- functions' d2f/dRdZ values
c
      integer ivecd                     ! output vector dimension
c
c  output:
c
      REAL r4_zans(ivecd,*)             ! evaluation results
      integer ierr                      ! completion code (0=OK)
c
c  ** let ictnum = # of non-zero elements of ictwant.
c         (ictnum=sum(ictwant)).  Then...
c  zans(1:ivec,1)   = value or derivative for function id iflist(1)
c                     indicated by first non-zero value of ictwant(...)
c  zans(1:ivec,2)   = value or derivative for function id iflist(1)
c                     indicated by second non-zero value of ictwant(...)
c    ...
c  zans(1:ivec,ictnum)   = value or derivative for function id iflist(1)
c                     indicated by last non-zero value of ictwant(...)
c
c  or generally, for 1 .le. k .le. ictnum,
c    ...
c  zans(1:ivec,(j-1)*ictnum+k) = value or derivative for function
c                                id iflist(j), corresponding to k'th
c                                non-zero element of ictwant(...)
c
c--------------------------------------------------
c
      REAL*8 zR(ivec)                   ! argument -- where to evaluate
      REAL*8 zZ(ivec)                   ! argument -- where to evaluate
c
      REAL*8, dimension(:,:), allocatable :: zans
c
      integer ictnum,i
c
c----------------------------------
c
c  copy to REAL*8 argument arrays
c
      zR=r4_zR
      zZ=r4_zZ
c
c  allocate REAL*8 output buffer
c
      ictnum=sum(ictwant)
      allocate(zans(ivecd,max(1,ictnum)*nlist))
c
c  call eq_hRZ using REAL*8 arguments
c
      call eq_hRZ(ivec,zR,zZ,nlist,iflist,ictwant,
     >   ivecd,zans,ierr)
c
c  copy answer back
c
      if(ierr.eq.0) then
c
         do i=1,max(1,ictnum)*nlist
            r4_zans(1:ivec,i)=zans(1:ivec,i)
         enddo
c
      endif
c
c  deallocate buffer
c
      deallocate(zans)
c
      return
      end

subroutine eqi_bbox(zrhoi, zBmin,zchiBmin, zBmax,zchiBmax, ierr)

  use xplasma_definitions
  use eqi_rzbox_module

  !  given a flux surface (zrho) find Bmin and Bmax -- axisymmetry assumed.

  IMPLICIT NONE

  !  input:

  REAL*8 zrhoi                      ! surface to be examined

  !  output:
  REAL*8 zBmin                      ! Bmin on surface
  real*8 zchiBmin                   ! (chi) of minimum
  REAL*8 zBmax                      ! Bmax on surface
  real*8 zchiBmax                   ! (chi) of maximum

  integer ierr                      ! completion code, 0=OK

  external feq_Bmmx

  !---------------------------------------------------

  REAL*8 zchi(nsrch1)             ! search points (poloidal angle coord)
  REAL*8 zB(0:1,nsrch1)           ! Z,dZ/dchi @ each search pt

  REAL*8 zchi0,zchi1,zchimmx

  REAL*8 zeps,zeta,ztmp,zrho

  integer i,nsrch,id_Bmod
  integer iminB,imaxB,iflag

  REAL*8 zrhovec(nsrch1),zbvec(nsrch1,2)

  logical imask,axisymm

  real*8, parameter :: C2PI = 6.2831853071795862D+00
  real*8, parameter :: ZERO = 0.0d0
  !---------------------------------------------------

  zrho=max(1.0d-12,zrhoi)

  imask=.FALSE.
  ierr=0

  call xplasma_global_info(sp,ierr, axisymm=axisymm)
  if(ierr.ne.0) return

  if(.not.axisymm) then
     ierr=107
     call xplasma_errmsg_append(sp, &
          ' ?eqi_bbox:  non-axisymmetry not yet supported!')
  endif
  if(ierr.ne.0) return

  call xplasma_find_item(sp,'Bmod',id_bmod,ierr)
  if(ierr.ne.0) then
     call xplasma_errmsg_append(sp,' ?eqi_bbox:  mod(B) spline not found.')
  endif
  if(ierr.ne.0) return

  zchi0=ZERO
  zchi1=C2PI
  nsrch=nsrch0

  do i=1,nsrch
     zrhovec(i)=zrho
     zchi(i)=zchi0+(i-1)*(zchi1-zchi0)/nsrch
  enddo
  zchi(nsrch1)=zchi1
  zrhovec(nsrch1)=zrhovec(1)

  call eqi_fBmod(nsrch1,zrhovec,zchi,2,nsrch1,zBvec,ierr)
  if(ierr.ne.0) return

  do i=1,nsrch1
     zb(0:1,i)=zbvec(i,1:2)
     if(i.eq.1) then
        zBmin=zB(0,1)
        zBmax=zBmin
        iminB=1
        imaxB=1
        zchiBmin=zchi(1)
        zchiBmax=zchi(1)
     else
        if(zB(0,i).gt.zBmax) then
           imaxB=i
           zBmax=zB(0,i)
           zchiBmax=zchi(i)
        endif
        if(zB(0,i).lt.zBmin) then
           iminB=i
           zBmin=zB(0,i)
           zchiBmin=zchi(i)
        endif
     endif
  enddo

  !  find exact min & max using rootfinder on derivative

  zeps=C2PI*2.0d-15
  zeta=zBmax*2.0d-15

  !  cobble for if extrema is at end point and there is a small numerical
  !  discrepancy (could happen for problems with "symmetry"

  iflag=0
  if(zB(1,1)*zB(1,nsrch1).lt.0.0) then
     if(abs(zB(1,1)-zB(1,nsrch1)).lt.(10*zeta)) then
        zeta=1.1*max(zeta,abs(zB(1,1)),abs(zB(1,nsrch1)))
     else
        call xplasma_errmsg_append(sp, &
             ' %eqi_bbox: dB/dchi inconsistent at theta extrema.')
        iflag=1
     endif
  endif

  do i=1,nsrch
     if(zB(1,i).gt.ZERO .and. zB(1,i+1).lt.ZERO) then
        call zridderx(1,imask,zchi(i),zchi(i+1),zeps,zeta, &
             feq_Bmmx,zchimmx,ierr, 1,zrho,1,ztmp,1)
        if(ierr.ne.0) return
        if(ztmp.gt.zBmax) then
           zBmax=ztmp
           zchiBmax=zchimmx
        endif
     endif
     if(zB(1,i).lt.ZERO .and. zB(1,i+1).gt.ZERO) then
        call zridderx(1,imask,zchi(i),zchi(i+1),zeps,zeta, &
             feq_Bmmx,zchimmx,ierr, 1,zrho,1,ztmp,1)
        if(ierr.ne.0) return
        if(ztmp.lt.zBmin) then
           zBmin=ztmp
           zchiBmin=zchimmx
        endif
     endif
  enddo

  ierr=0
  if(iflag.eq.1) ierr=9999

end subroutine eqi_bbox

!-----------------------------------------------
subroutine feq_Bmmx(ivec,imask,zchi,zanswer, &
     ivecd,zinput,ninput,zoutput,noutput)

  use xplasma_definitions
  use eqi_rzbox_module

  IMPLICIT NONE

  !  function for zridderx -- dR/dchi @ some rho; return mod(B); also
  !  will find extrema by looking for dB/dchi=0

  integer ivec,ivecd
  logical imask(ivec)
  integer ninput,noutput
  real*8 zanswer(ivec)
  REAL*8 zchi(ivec),zinput(ivecd,ninput),zoutput(ivecd,noutput)

  !---------------------------

  REAL*8 zrho_use(ivec),zchi_use(ivec),zvals(ivec,0:1)
  integer ict_vald(10),ierr,i,jvec

  !---------------------------

  jvec=0
  do i=1,ivec
     if(.not.imask(i)) then
        jvec=jvec+1
        zrho_use(jvec)=zinput(i,1)
        zchi_use(jvec)=zchi(i)
     endif
  enddo
  if(jvec.eq.0) return              ! nothing to be done

  call eqi_fBmod(jvec,zrho_use,zchi_use,2,jvec,zvals(1:jvec,0:1),ierr)
  if(ierr.ne.0) return

  jvec=0
  do i=1,ivec
     if(.not.imask(i)) then
        jvec=jvec+1
        zoutput(i,1)=zvals(jvec,0)  ! B field
        zanswer(i)=zvals(jvec,1)    ! dB/dchi
     endif
  enddo

end subroutine feq_Bmmx

!---------------------------------------------------
subroutine eqi_bbvec(zrho,ivec,znormb,zbmin,zbmax,zbvals,zthbr1,zthbr2,ierr)

  !  find vector of B values and corresponding theta locations on
  !  a rho surface (axisymmetry assumed).  Only non-singular flux
  !  surfaces should be specified (i.e. avoid magnetic axis).

  use xplasma_definitions
  use eqi_rzbox_module

  implicit NONE

  real*8, intent(in) :: zrho  ! flux surface
  integer, intent(in) :: ivec ! size of input/output vectors
  real*8, intent(in) :: znormb(ivec) ! ascending sequence in range [0,1]

  !  znormb(j) indicates j'th B value wanted, per the formula
  !      znormb(j) = (zbvals(j)-Bmin)/(Bmax-Bmin)
  !  where Bmin, Bmax are the min & max mod(B) on the zrho surface.

  !  i.e. znormb(1) = 0 refers to Bmin;
  !       znormb(ivec) = 1 refers to Bmax.

  !  Bmin and Bmax will be found during execution of this routine.

  real*8, intent(out) :: zbmin,zbmax   ! min & max mod(B) on surface
  real*8, intent(out) :: zbvals(ivec)  ! B values corresponding to znormb
  real*8, intent(out) :: zthbr1(ivec)  ! "lower branch" theta sequence
  real*8, intent(out) :: zthbr2(ivec)  ! "upper branch" theta sequence

  integer, intent(out) :: ierr      ! status code (0=OK)

  !  B(thrbr1(j))=B(thrbr2(j))=zbvals(j) will be satisfied.

  !  if theta(Bmax) > theta(Bmin) then
  !      {thbr1} in [theta(Bmax)-2*pi,theta(Bmin)]
  !      {thbr2} in [theta(Bmin),theta(Bmax)]

  !  if theta(Bmax) < theta(Bmin) then
  !      {thbr1} in [theta(Bmax),theta(Bmin)]
  !      {thbr2} in [theta(Bmin),theta(Bmax)+2*pi]

  !-------------------------------------------------------------
  external f_eqi_bfind

  logical imask(ivec)
  integer i,ichk,ibr,j
  real*8 zeps,zeta,ztol,zrhoi,ztest
  real*8 zthbmin,zthbmax(2)

  real*8 zth_srch0(nsrch0),zb_srch0(nsrch0),zrho_srch0(nsrch0)
  real*8 ztha(ivec),zthb(ivec),zthans(ivec),zinput(ivec,2)
  real*8 zdum(ivec,1)

  logical :: axisymm

  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: ONE = 1.0d0
  real*8, parameter :: C2PI = 6.2831853071795862D+00
  !-------------------------------------------------------------

  !  perform error checks...

  zbmin=0
  zbmax=0
  zbvals=0
  zthbr1=0
  zthbr2=0

  ierr=0
  call xplasma_global_info(sp,ierr,axisymm=axisymm)
  if(ierr.ne.0) return

  if(.not.axisymm) then
     ierr=107
     call xplasma_errmsg_append(sp, &
          ' ?eqi_bbvec:  non-axisymmetry not yet supported!')
     return
  endif

  if(ivec.le.0) then
     call xplasma_errmsg_append(sp, &
          ' ?eqi_bbvec: "ivec" is not a positive number.')
     ierr=9999
  endif
  if(ierr.gt.0) return

  ztol=2.0d-15

  zrhoi=max(100*ztol,min(ONE,zrho))

  if((maxval(znormb).gt.1.0d0+ztol).or.(minval(znormb).lt.-ztol)) then
     call xplasma_errmsg_append(sp,' ?eqi_bbvec: "znormb" not in range [0,1].')
     ierr=ierr+1
  endif

  do i=1,ivec-1
     if(znormb(i+1).le.znormb(i)) then
        ierr=ierr+1
        call xplasma_errmsg_append(sp, &
             ' ?eqi_bbvec: "znormb" not strict ascending.')
        exit
     endif
  enddo

  if(ierr.ne.0) return
  !---------------------------------------
  !  OK.  get Bmin & Bmax & corresponding theta values

  call eqi_bbox(zrhoi,zbmin,zthbmin,zbmax,zthbmax(1),ierr)
  if(ierr.ne.0) return

  zeps=C2PI*ztol
  zeta=ztol*zBmax

  if(zthbmax(1).gt.zthbmin) then
     zthbmax(2)=zthbmax(1)
     zthbmax(1)=zthbmax(2)-C2PI
  else
     zthbmax(2)=zthbmax(1)+C2PI
  endif

  !  the target B values:

  do i=1,ivec
     zbvals(i) = zBmin + znormb(i)*(zBmax-zBmin)
  enddo

  !  set up for vectorized root finder call to find theta values
  !  corresponding to desired B values

  imask=.FALSE.

  !  check output extrema

  ierr=0
  ichk=0

  if(znormb(1).le.ztol) then
     imask(1)=.TRUE.
     ichk=ichk+1
     zbvals(1)=zBmin
     zthbr1(1)=zthBmin
     zthbr2(1)=zthBmin
  endif

  if(znormb(ivec).ge.1.0d0-ztol) then
     imask(ivec)=.TRUE.
     ichk=ichk+1
     zbvals(ivec)=zBmax
     zthbr1(ivec)=zthbmax(1)
     zthbr2(ivec)=zthbmax(2)
  endif

  if(ichk.ge.ivec) return

  !  set up initial search grid: both sides...

  zrho_srch0=zrhoi
  do ibr=1,2
     do i=1,nsrch0
        zth_srch0(i)=(zthbmin*(nsrch0-i)+zthbmax(ibr)*(i-1))/(nsrch0-1)
     enddo
     call eqi_fBmod(nsrch0,zrho_srch0,zth_srch0,1,nsrch0,zb_srch0,ierr)
     if(ierr.ne.0) exit
     do i=1,ivec
        do j=1,nsrch0-1
           ztest=(zb_srch0(j)-zbvals(i))*(zb_srch0(j+1)-zbvals(i))
           if(ztest.le.ZERO) then
              ztha(i)=min(zth_srch0(j),zth_srch0(j+1))
              zthb(i)=max(zth_srch0(j),zth_srch0(j+1))
              if(abs(zb_srch0(j)-zbvals(i)).lt.zeta) then
                 if(ibr.eq.1) then
                    zthbr1(i)=zth_srch0(j)
                 else
                    zthbr2(i)=zth_srch0(j)
                 endif
                 imask(i)=.TRUE.
              else if(abs(zb_srch0(j+1)-zbvals(i)).lt.zeta) then
                 if(ibr.eq.1) then
                    zthbr1(i)=zth_srch0(j+1)
                 else
                    zthbr2(i)=zth_srch0(j+1)
                 endif
                 imask(i)=.TRUE.
              endif
              exit                  ! take the first valid interval
           endif
        enddo
        if(ibr.eq.1) then
           zthans(i)=zthbr1(i)
        else
           zthans(i)=zthbr2(i)
        endif
        zinput(i,1)=zrhoi
        zinput(i,2)=zbvals(i)
     enddo

     call zridderx(ivec,imask,ztha,zthb,zeps,zeta,f_eqi_bfind, &
          zthans,ierr,ivec,zinput,2,zdum,1)
     if(ierr.ne.0) exit

     if(ibr.eq.1) then
        zthbr1=zthans
     else
        zthbr2=zthans
     endif
  enddo

end subroutine eqi_bbvec

!-----------------------------------------------
subroutine f_eqi_Bfind(ivec,imask,zchi,zanswer, &
     ivecd,zinput,ninput,zoutput,noutput)

  use xplasma_definitions
  use eqi_rzbox_module

  IMPLICIT NONE

  !  function for zridderx -- dR/dchi @ some rho; return mod(B); also
  !  will find extrema by looking for dB/dchi=0

  integer ivec,ivecd
  logical imask(ivec)
  integer ninput,noutput
  real*8 zanswer(ivec)
  REAL*8 zchi(ivec),zinput(ivecd,ninput),zoutput(ivecd,noutput)

  !---------------------------

  REAL*8 zrho_use(ivec),zchi_use(ivec),zvals(ivec,1)
  integer ierr,i,jvec

  !---------------------------

  jvec=0
  do i=1,ivec
     if(.not.imask(i)) then
        jvec=jvec+1
        zrho_use(jvec)=zinput(i,1)
        zchi_use(jvec)=zchi(i)
     endif
  enddo
  if(jvec.eq.0) return              ! nothing to be done

  call eqi_fBmod(jvec,zrho_use,zchi_use,1,jvec,zvals,ierr)
  if(ierr.ne.0) return

  jvec=0
  do i=1,ivec
     if(.not.imask(i)) then
        jvec=jvec+1
        zanswer(i)=zvals(jvec,1)-zinput(i,2)  ! B field - Btarget
     endif
  enddo

end subroutine f_eqi_Bfind

subroutine eqm_uaxis(aname,ikin,iper,zaxis,inum,ztol,id,ierr)

  use xplasma_obj_instance
  use eq_module

!  set up user defined grid -- must be strict ascending

  IMPLICIT NONE

!  input:

  character*(*), intent(in):: aname ! name of axis (max 20 chars)
  integer, intent(in) :: ikin       ! id of "related" axis (0 if none)
  integer, intent(in) :: iper       ! =1 if a periodic dimension, 0 o.w.
                                    ! =-1 periodic, CW instead of CCW
                                    !  -1 ignored unless ikin specifies
                                    !     theta or phi coordinate

  integer, intent(in) :: inum       ! #of grid bdy pts
  REAL*8, intent(in) :: zaxis(inum) ! the grid (zone bdys, inum-1 zones).
  REAL*8, intent(in) :: ztol        ! even spacing tolerance

!  the user defined grid can be "related" to another grid, whose id is
!  specified by the argument "ikin".  When two "related" grids exist,
!  a data "rebinning" operation can be enabled.

!  output:

  integer id                        ! axis id code (returned)
  integer ierr                      ! =0: OK

!-----------------

  real*8 zaxis_use(inum)
  real*8 :: ztolx
  real*8, dimension(:), allocatable :: zaxis_prev

  integer icoord,itype,ilen,jper,iertmp,idgrid,ingrid,ix,ixdiff
  character*32 zcoord
  logical :: lccw,lper

!-------------------------------------------------------------
!  error checks:

  ierr=0
  id=0

  call xoi_author_set(ierr)
  if(ierr.ne.0) return

  !  see if coordinate is already defined...
  !  if so, do not try to redefine it (avoid "grid in use" error).

  call xplasma_gridId(s,aname,idgrid)
  if(idgrid.gt.0) then

     call xplasma_grid_size(s,idgrid,ingrid,iertmp)
     if(ingrid.eq.inum) then
        call xplasma_global_info(s,iertmp,bdytol=ztolx)
        allocate(zaxis_prev(ingrid))
        call xplasma_grid(s,idgrid,zaxis_prev,iertmp)
        if(iertmp.eq.0) then
           ixdiff=0
           do ix=1,ingrid
              if(abs(zaxis(ix)-zaxis_prev(ix)).gt.ztolx) then
                 ixdiff=ix
                 exit
              endif
           enddo

           deallocate(zaxis_prev)
           if(ixdiff.eq.0) then
              ! infer that axis is already defined.
              id = idgrid
              return
           endif
        endif
     endif
  endif

!  get coordinate corresponding to ikin argument (if non-zero)
!  or create coordinate to contain this grid (if ikin is zero)

  jper=min(1,abs(iper))

  if(ikin.eq.0) then
     icoord=0
     ilen=len(trim(aname))
     if(ilen.le.len(zcoord)-6) then
        zcoord = trim(aname)//'_COORD'
     else
        zcoord = aname
        ilen=len(zcoord)
        zcoord(ilen-5:ilen)='_COORD'
     endif

     call xplasma_create_coord(s,zcoord,(jper.ne.0),icoord,ierr)
     if(ierr.ne.0) call xplasma_error(s,ierr,lunerr)

  else

     !  find coordinate implied by "ikin" grid id

     call xplasma_get_item_info(s,ikin,ierr, itype=itype)
     if(ierr.ne.0) then
        call xplasma_error(s,ierr,lunerr)
        
     else

        if(itype.eq.xplasma_gridType) then
           call xplasma_grid_info(s,ikin,ierr, coord=icoord)
           if(ierr.ne.0) call xplasma_error(s,ierr,lunerr) ! no error expected.
        else if(itype.eq.xplasma_coordType) then
           icoord = ikin
        else
           write(lunerr,*) ' ?eqm_uaxis: argument "ikin" invalid: ',ikin
           ierr=1
        endif

        if(ierr.eq.0) then

           !  verify consistency of "iper" argument with associated coordinate

           call xplasma_coord_isPeriodic(s,icoord,lper,ierr)
           if(lper) then
              if(jper.eq.0) then
                 ierr=1
                 write(lunerr,*) &
                      ' ?eqm_uaxis: iper.eq.0 but ikin indicates periodic coordinate.'
              endif
           else
              if(jper.ne.0) then
                 ierr=1
                 write(lunerr,*) &
                      ' ?eqm_uaxis: iper.ne.0 but ikin indicates non-periodic coordinate.'
              endif
           endif

        endif
     endif
  endif

  if(ierr.eq.0) then

!  OK, see if ccw reversal is needed
!  this could be, if the axis is kin to iaxis_chi or iaxis_phi
!  first-- find ancestral kin (the one with no further kin)

     if((iper.eq.-1).and. &
          ((icoord.eq.xplasma_theta_coord).or.(icoord.eq.xplasma_phi_coord))) then

        lccw = .FALSE.

     else

        lccw = .TRUE.
        
     endif

!  OK, copy to module; call genxpkg

     zaxis_use = zaxis
     call eqi_evenx(zaxis_use,inum,ztol)

     call xplasma_create_grid(s,aname,icoord,zaxis_use, id,ierr, lccw)

  endif

  call xoi_author_clear(iertmp)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqm_uaxis: error detected.'
     call xplasma_error(s,ierr,lunerr)
  endif

  return

end subroutine eqm_uaxis

#include "fpreproc/f77_dcomplx.h"
!
!  NTCC REAL*8 LSODE
!
!  dmc -- this is netlib's lsode with NTCC real*8 conversion.  The
!  result is the same whether derived from netlib odepack double precision
!  lsode, or netlib sodepack single precision lsode.
!
!  ..caveat on conversion -- hollerith strings in arguments to xerrwv
!    calls were not recognized by r8 conversion as string constants,
!    so a 0.0 -> 0.0D0 mapping was done which had to be undone by hand.
!
!  note also:  as per GA suggestion:  added lsode_block_data initializer
!
c-----------------------------------------------------------------------
      subroutine lsode_r8 (f, neq, y, t, tout, itol, rtol, atol, itask,
     1            istate, iopt, rwork, lrw, iwork, liw, jac, mf)
c-----------------------------------------------------------------------

C============
C idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER jac
C============
      external f, jac
      external lsode_r8_block_data
      integer neq, itol, itask, istate, iopt, lrw, iwork, liw, mf
      REAL*8 y, t, tout, rtol, atol, rwork
      dimension neq(*), y(*), rtol(*), atol(*), rwork(lrw), iwork(liw)
c-----------------------------------------------------------------------
c this is the march 30, 1987 version of
c lsode.. livermore solver for ordinary differential equations.
c this version is in double precision.
c
c lsode solves the initial value problem for stiff or nonstiff
c systems of first order ode-s,
c     dy/dt = f(t,y) ,  or, in component form,
c     dy(i)/dt = f(i) = f(i,t,y(1),y(2),...,y(neq)) (i = 1,...,neq).
c lsode is a package based on the gear and gearb packages, and on the
c october 23, 1978 version of the tentative odepack user interface
c standard, with minor modifications.
c-----------------------------------------------------------------------
c reference..
c     alan c. hindmarsh,  odepack, a systematized collection of ode
c     solvers, in scientific computing, r. s. stepleman et al. (eds.),
c     north-holland, amsterdam, 1983, pp. 55-64.
c-----------------------------------------------------------------------
c author and contact.. alan c. hindmarsh,
c                      computing and mathematics research div., l-316
c                      lawrence livermore national laboratory
c                      livermore, ca 94550.
c-----------------------------------------------------------------------
c summary of usage.
c
c communication between the user and the lsode package, for normal
c situations, is summarized here.  this summary describes only a subset
c of the full set of options available.  see the full description for
c details, including optional communication, nonstandard options,
c and instructions for special situations.  see also the example
c problem (with program and output) following this summary.
c
c a. first provide a subroutine of the form..
c               subroutine f (neq, t, y, ydot)
c               dimension y(neq), ydot(neq)
c which supplies the vector function f by loading ydot(i) with f(i).
c
c b. next determine (or guess) whether or not the problem is stiff.
c stiffness occurs when the jacobian matrix df/dy has an eigenvalue
c whose real part is negative and large in magnitude, compared to the
c reciprocal of the t span of interest.  if the problem is nonstiff,
c use a method flag mf = 10.  if it is stiff, there are four standard
c choices for mf, and lsode requires the jacobian matrix in some form.
c this matrix is regarded either as full (mf = 21 or 22),
c or banded (mf = 24 or 25).  in the banded case, lsode requires two
c half-bandwidth parameters ml and mu.  these are, respectively, the
c widths of the lower and upper parts of the band, excluding the main
c diagonal.  thus the band consists of the locations (i,j) with
c i-ml .le. j .le. i+mu, and the full bandwidth is ml+mu+1.
c
c c. if the problem is stiff, you are encouraged to supply the jacobian
c directly (mf = 21 or 24), but if this is not feasible, lsode will
c compute it internally by difference quotients (mf = 22 or 25).
c if you are supplying the jacobian, provide a subroutine of the form..
c               subroutine jac (neq, t, y, ml, mu, pd, nrowpd)
c               dimension y(neq), pd(nrowpd,neq)
c which supplies df/dy by loading pd as follows..
c     for a full jacobian (mf = 21), load pd(i,j) with df(i)/dy(j),
c the partial derivative of f(i) with respect to y(j).  (ignore the
c ml and mu arguments in this case.)
c     for a banded jacobian (mf = 24), load pd(i-j+mu+1,j) with
c df(i)/dy(j), i.e. load the diagonal lines of df/dy into the rows of
c pd from the top down.
c     in either case, only nonzero elements need be loaded.
c
c d. write a main program which calls subroutine lsode once for
c each point at which answers are desired.  this should also provide
c for possible use of logical unit 6 for output of error messages
c by lsode.  on the first call to lsode, supply arguments as follows..
c f      = name of subroutine for right-hand side vector f.
c          this name must be declared external in calling program.
c neq    = number of first order ode-s.
c y      = array of initial values, of length neq.
c t      = the initial value of the independent variable.
c tout   = first point where output is desired (.ne. t).
c itol   = 1 or 2 according as atol (below) is a scalar or array.
c rtol   = relative tolerance parameter (scalar).
c atol   = absolute tolerance parameter (scalar or array).
c          the estimated local error in y(i) will be controlled so as
c          to be roughly less (in magnitude) than
c             ewt(i) = rtol*abs(y(i)) + atol     if itol = 1, or
c             ewt(i) = rtol*abs(y(i)) + atol(i)  if itol = 2.
c          thus the local error test passes if, in each component,
c          either the absolute error is less than atol (or atol(i)),
c          or the relative error is less than rtol.
c          use rtol = 0.0 for pure absolute error control, and
c          use atol = 0.0 (or atol(i) = 0.0) for pure relative error
c          control.  caution.. actual (global) errors may exceed these
c          local tolerances, so choose them conservatively.
c itask  = 1 for normal computation of output values of y at t = tout.
c istate = integer flag (input and output).  set istate = 1.
c iopt   = 0 to indicate no optional inputs used.
c rwork  = real work array of length at least..
c             20 + 16*neq                    for mf = 10,
c             22 +  9*neq + neq**2           for mf = 21 or 22,
c             22 + 10*neq + (2*ml + mu)*neq  for mf = 24 or 25.
c lrw    = declared length of rwork (in user-s dimension).
c iwork  = integer work array of length at least..
c             20        for mf = 10,
c             20 + neq  for mf = 21, 22, 24, or 25.
c          if mf = 24 or 25, input in iwork(1),iwork(2) the lower
c          and upper half-bandwidths ml,mu.
c liw    = declared length of iwork (in user-s dimension).
c jac    = name of subroutine for jacobian matrix (mf = 21 or 24).
c          if used, this name must be declared external in calling
c          program.  if not used, pass a dummy name.
c mf     = method flag.  standard values are..
c          10 for nonstiff (adams) method, no jacobian used.
c          21 for stiff (bdf) method, user-supplied full jacobian.
c          22 for stiff method, internally generated full jacobian.
c          24 for stiff method, user-supplied banded jacobian.
c          25 for stiff method, internally generated banded jacobian.
c note that the main program must declare arrays y, rwork, iwork,
c and possibly atol.
c
c e. the output from the first call (or any call) is..
c      y = array of computed values of y(t) vector.
c      t = corresponding value of independent variable (normally tout).
c istate = 2  if lsode was successful, negative otherwise.
c          -1 means excess work done on this call (perhaps wrong mf).
c          -2 means excess accuracy requested (tolerances too small).
c          -3 means illegal input detected (see printed message).
c          -4 means repeated error test failures (check all inputs).
c          -5 means repeated convergence failures (perhaps bad jacobian
c             supplied or wrong choice of mf or tolerances).
c          -6 means error weight became zero during problem. (solution
c             component i vanished, and atol or atol(i) = 0.)
c
c f. to continue the integration after a successful return, simply
c reset tout and call lsode again.  no other parameters need be reset.
c
c-----------------------------------------------------------------------
c example problem.
c
c the following is a simple example problem, with the coding
c needed for its solution by lsode.  the problem is from chemical
c kinetics, and consists of the following three rate equations..
c     dy1/dt = -.04*y1 + 1.e4*y2*y3
c     dy2/dt = .04*y1 - 1.e4*y2*y3 - 3.e7*y2**2
c     dy3/dt = 3.e7*y2**2
c on the interval from t = 0.0 to t = 4.e10, with initial conditions
c y1 = 1.0, y2 = y3 = 0.  the problem is stiff.
c
c the following coding solves this problem with lsode, using mf = 21
c and printing results at t = .4, 4., ..., 4.e10.  it uses
c itol = 2 and atol much smaller for y2 than y1 or y3 because
c y2 has much smaller values.
c at the end of the run, statistical quantities of interest are
c printed (see optional outputs in the full description below).
c
c     external fex, jex
c     double precision atol, rtol, rwork, t, tout, y
c     dimension y(3), atol(3), rwork(58), iwork(23)
c     neq = 3
c     y(1) = 1.d0
c     y(2) = 0.d0
c     y(3) = 0.d0
c     t = 0.d0
c     tout = .4d0
c     itol = 2
c     rtol = 1.d-4
c     atol(1) = 1.d-6
c     atol(2) = 1.d-10
c     atol(3) = 1.d-6
c     itask = 1
c     istate = 1
c     iopt = 0
c     lrw = 58
c     liw = 23
c     mf = 21
c     do 40 iout = 1,12
c       call lsode(fex,neq,y,t,tout,itol,rtol,atol,itask,istate,
c    1     iopt,rwork,lrw,iwork,liw,jex,mf)
c       write(6,20)t,y(1),y(2),y(3)
c 20    format(7h at t =,e12.4,6h   y =,3e14.6)
c       if (istate .lt. 0) go to 80
c 40    tout = tout*10.d0
c     write(6,60)iwork(11),iwork(12),iwork(13)
c 60  format(/12h no. steps =,i4,11h  no. f-s =,i4,11h  no. j-s =,i4)
c     stop
c 80  write(6,90)istate
c 90  format(///22h error halt.. istate =,i3)
c     stop
c     end
c
c     subroutine fex (neq, t, y, ydot)
c     double precision t, y, ydot
c     dimension y(3), ydot(3)
c     ydot(1) = -.04d0*y(1) + 1.d4*y(2)*y(3)
c     ydot(3) = 3.d7*y(2)*y(2)
c     ydot(2) = -ydot(1) - ydot(3)
c     return
c     end
c
c     subroutine jex (neq, t, y, ml, mu, pd, nrpd)
c     double precision pd, t, y
c     dimension y(3), pd(nrpd,3)
c     pd(1,1) = -.04d0
c     pd(1,2) = 1.d4*y(3)
c     pd(1,3) = 1.d4*y(2)
c     pd(2,1) = .04d0
c     pd(2,3) = -pd(1,3)
c     pd(3,2) = 6.d7*y(2)
c     pd(2,2) = -pd(1,2) - pd(3,2)
c     return
c     end
c
c the output of this program (on a cdc-7600 in single precision)
c is as follows..
c
c   at t =  4.0000e-01   y =  9.851726e-01  3.386406e-05  1.479357e-02
c   at t =  4.0000e+00   y =  9.055142e-01  2.240418e-05  9.446344e-02
c   at t =  4.0000e+01   y =  7.158050e-01  9.184616e-06  2.841858e-01
c   at t =  4.0000e+02   y =  4.504846e-01  3.222434e-06  5.495122e-01
c   at t =  4.0000e+03   y =  1.831701e-01  8.940379e-07  8.168290e-01
c   at t =  4.0000e+04   y =  3.897016e-02  1.621193e-07  9.610297e-01
c   at t =  4.0000e+05   y =  4.935213e-03  1.983756e-08  9.950648e-01
c   at t =  4.0000e+06   y =  5.159269e-04  2.064759e-09  9.994841e-01
c   at t =  4.0000e+07   y =  5.306413e-05  2.122677e-10  9.999469e-01
c   at t =  4.0000e+08   y =  5.494529e-06  2.197824e-11  9.999945e-01
c   at t =  4.0000e+09   y =  5.129458e-07  2.051784e-12  9.999995e-01
c   at t =  4.0000e+10   y = -7.170586e-08 -2.868234e-13  1.000000e+00
c
c   no. steps = 330  no. f-s = 405  no. j-s =  69
c-----------------------------------------------------------------------
c full description of user interface to lsode.
c
c the user interface to lsode consists of the following parts.
c
c i.   the call sequence to subroutine lsode, which is a driver
c      routine for the solver.  this includes descriptions of both
c      the call sequence arguments and of user-supplied routines.
c      following these descriptions is a description of
c      optional inputs available through the call sequence, and then
c      a description of optional outputs (in the work arrays).
c
c ii.  descriptions of other routines in the lsode package that may be
c      (optionally) called by the user.  these provide the ability to
c      alter error message handling, save and restore the internal
c      common, and obtain specified derivatives of the solution y(t).
c
c iii. descriptions of common blocks to be declared in overlay
c      or similar environments, or to be saved when doing an interrupt
c      of the problem and continued solution later.
c
c iv.  description of two routines in the lsode package, either of
c      which the user may replace with his own version, if desired.
c      these relate to the measurement of errors.
c
c-----------------------------------------------------------------------
c part i.  call sequence.
c
c the call sequence parameters used for input only are
c     f, neq, tout, itol, rtol, atol, itask, iopt, lrw, liw, jac, mf,
c and those used for both input and output are
c     y, t, istate.
c the work arrays rwork and iwork are also used for conditional and
c optional inputs and optional outputs.  (the term output here refers
c to the return from subroutine lsode to the user-s calling program.)
c
c the legality of input parameters will be thoroughly checked on the
c initial call for the problem, but not checked thereafter unless a
c change in input parameters is flagged by istate = 3 on input.
c
c the descriptions of the call arguments are as follows.
c
c f      = the name of the user-supplied subroutine defining the
c          ode system.  the system must be put in the first-order
c          form dy/dt = f(t,y), where f is a vector-valued function
c          of the scalar t and the vector y.  subroutine f is to
c          compute the function f.  it is to have the form
c               subroutine f (neq, t, y, ydot)
c               dimension y(1), ydot(1)
c          where neq, t, and y are input, and the array ydot = f(t,y)
c          is output.  y and ydot are arrays of length neq.
c          (in the dimension statement above, 1 is a dummy
c          dimension.. it can be replaced by any value.)
c          subroutine f should not alter y(1),...,y(neq).
c          f must be declared external in the calling program.
c
c          subroutine f may access user-defined quantities in
c          neq(2),... and/or in y(neq(1)+1),... if neq is an array
c          (dimensioned in f) and/or y has length exceeding neq(1).
c          see the descriptions of neq and y below.
c
c          if quantities computed in the f routine are needed
c          externally to lsode, an extra call to f should be made
c          for this purpose, for consistent and accurate results.
c          if only the derivative dy/dt is needed, use intdy instead.
c
c neq    = the size of the ode system (number of first order
c          ordinary differential equations).  used only for input.
c          neq may be decreased, but not increased, during the problem.
c          if neq is decreased (with istate = 3 on input), the
c          remaining components of y should be left undisturbed, if
c          these are to be accessed in f and/or jac.
c
c          normally, neq is a scalar, and it is generally referred to
c          as a scalar in this user interface description.  however,
c          neq may be an array, with neq(1) set to the system size.
c          (the lsode package accesses only neq(1).)  in either case,
c          this parameter is passed as the neq argument in all calls
c          to f and jac.  hence, if it is an array, locations
c          neq(2),... may be used to store other integer data and pass
c          it to f and/or jac.  subroutines f and/or jac must include
c          neq in a dimension statement in that case.
c
c y      = a real array for the vector of dependent variables, of
c          length neq or more.  used for both input and output on the
c          first call (istate = 1), and only for output on other calls.
c          on the first call, y must contain the vector of initial
c          values.  on output, y contains the computed solution vector,
c          evaluated at t.  if desired, the y array may be used
c          for other purposes between calls to the solver.
c
c          this array is passed as the y argument in all calls to
c          f and jac.  hence its length may exceed neq, and locations
c          y(neq+1),... may be used to store other real data and
c          pass it to f and/or jac.  (the lsode package accesses only
c          y(1),...,y(neq).)
c
c t      = the independent variable.  on input, t is used only on the
c          first call, as the initial point of the integration.
c          on output, after each call, t is the value at which a
c          computed solution y is evaluated (usually the same as tout).
c          on an error return, t is the farthest point reached.
c
c tout   = the next value of t at which a computed solution is desired.
c          used only for input.
c
c          when starting the problem (istate = 1), tout may be equal
c          to t for one call, then should .ne. t for the next call.
c          for the initial t, an input value of tout .ne. t is used
c          in order to determine the direction of the integration
c          (i.e. the algebraic sign of the step sizes) and the rough
c          scale of the problem.  integration in either direction
c          (forward or backward in t) is permitted.
c
c          if itask = 2 or 5 (one-step modes), tout is ignored after
c          the first call (i.e. the first call with tout .ne. t).
c          otherwise, tout is required on every call.
c
c          if itask = 1, 3, or 4, the values of tout need not be
c          monotone, but a value of tout which backs up is limited
c          to the current internal t interval, whose endpoints are
c          tcur - hu and tcur (see optional outputs, below, for
c          tcur and hu).
c
c itol   = an indicator for the type of error control.  see
c          description below under atol.  used only for input.
c
c rtol   = a relative error tolerance parameter, either a scalar or
c          an array of length neq.  see description below under atol.
c          input only.
c
c atol   = an absolute error tolerance parameter, either a scalar or
c          an array of length neq.  input only.
c
c             the input parameters itol, rtol, and atol determine
c          the error control performed by the solver.  the solver will
c          control the vector e = (e(i)) of estimated local errors
c          in y, according to an inequality of the form
c                      rms-norm of ( e(i)/ewt(i) )   .le.   1,
c          where       ewt(i) = rtol(i)*abs(y(i)) + atol(i),
c          and the rms-norm (root-mean-square norm) here is
c          rms-norm(v) = sqrt(sum v(i)**2 / neq).  here ewt = (ewt(i))
c          is a vector of weights which must always be positive, and
c          the values of rtol and atol should all be non-negative.
c          the following table gives the types (scalar/array) of
c          rtol and atol, and the corresponding form of ewt(i).
c
c             itol    rtol       atol          ewt(i)
c              1     scalar     scalar     rtol*abs(y(i)) + atol
c              2     scalar     array      rtol*abs(y(i)) + atol(i)
c              3     array      scalar     rtol(i)*abs(y(i)) + atol
c              4     array      array      rtol(i)*abs(y(i)) + atol(i)
c
c          when either of these parameters is a scalar, it need not
c          be dimensioned in the user-s calling program.
c
c          if none of the above choices (with itol, rtol, and atol
c          fixed throughout the problem) is suitable, more general
c          error controls can be obtained by substituting
c          user-supplied routines for the setting of ewt and/or for
c          the norm calculation.  see part iv below.
c
c          if global errors are to be estimated by making a repeated
c          run on the same problem with smaller tolerances, then all
c          components of rtol and atol (i.e. of ewt) should be scaled
c          down uniformly.
c
c itask  = an index specifying the task to be performed.
c          input only.  itask has the following values and meanings.
c          1  means normal computation of output values of y(t) at
c             t = tout (by overshooting and interpolating).
c          2  means take one step only and return.
c          3  means stop at the first internal mesh point at or
c             beyond t = tout and return.
c          4  means normal computation of output values of y(t) at
c             t = tout but without overshooting t = tcrit.
c             tcrit must be input as rwork(1).  tcrit may be equal to
c             or beyond tout, but not behind it in the direction of
c             integration.  this option is useful if the problem
c             has a singularity at or beyond t = tcrit.
c          5  means take one step, without passing tcrit, and return.
c             tcrit must be input as rwork(1).
c
c          note..  if itask = 4 or 5 and the solver reaches tcrit
c          (within roundoff), it will return t = tcrit (exactly) to
c          indicate this (unless itask = 4 and tout comes before tcrit,
c          in which case answers at t = tout are returned first).
c
c istate = an index used for input and output to specify the
c          the state of the calculation.
c
c          on input, the values of istate are as follows.
c          1  means this is the first call for the problem
c             (initializations will be done).  see note below.
c          2  means this is not the first call, and the calculation
c             is to continue normally, with no change in any input
c             parameters except possibly tout and itask.
c             (if itol, rtol, and/or atol are changed between calls
c             with istate = 2, the new values will be used but not
c             tested for legality.)
c          3  means this is not the first call, and the
c             calculation is to continue normally, but with
c             a change in input parameters other than
c             tout and itask.  changes are allowed in
c             neq, itol, rtol, atol, iopt, lrw, liw, mf, ml, mu,
c             and any of the optional inputs except h0.
c             (see iwork description for ml and mu.)
c          note..  a preliminary call with tout = t is not counted
c          as a first call here, as no initialization or checking of
c          input is done.  (such a call is sometimes useful for the
c          purpose of outputting the initial conditions.)
c          thus the first call for which tout .ne. t requires
c          istate = 1 on input.
c
c          on output, istate has the following values and meanings.
c           1  means nothing was done, as tout was equal to t with
c              istate = 1 on input.  (however, an internal counter was
c              set to detect and prevent repeated calls of this type.)
c           2  means the integration was performed successfully.
c          -1  means an excessive amount of work (more than mxstep
c              steps) was done on this call, before completing the
c              requested task, but the integration was otherwise
c              successful as far as t.  (mxstep is an optional input
c              and is normally 500.)  to continue, the user may
c              simply reset istate to a value .gt. 1 and call again
c              (the excess work step counter will be reset to 0).
c              in addition, the user may increase mxstep to avoid
c              this error return (see below on optional inputs).
c          -2  means too much accuracy was requested for the precision
c              of the machine being used.  this was detected before
c              completing the requested task, but the integration
c              was successful as far as t.  to continue, the tolerance
c              parameters must be reset, and istate must be set
c              to 3.  the optional output tolsf may be used for this
c              purpose.  (note.. if this condition is detected before
c              taking any steps, then an illegal input return
c              (istate = -3) occurs instead.)
c          -3  means illegal input was detected, before taking any
c              integration steps.  see written message for details.
c              note..  if the solver detects an infinite loop of calls
c              to the solver with illegal input, it will cause
c              the run to stop.
c          -4  means there were repeated error test failures on
c              one attempted step, before completing the requested
c              task, but the integration was successful as far as t.
c              the problem may have a singularity, or the input
c              may be inappropriate.
c          -5  means there were repeated convergence test failures on
c              one attempted step, before completing the requested
c              task, but the integration was successful as far as t.
c              this may be caused by an inaccurate jacobian matrix,
c              if one is being used.
c          -6  means ewt(i) became zero for some i during the
c              integration.  pure relative error control (atol(i)=0.0)
c              was requested on a variable which has now vanished.
c              the integration was successful as far as t.
c
c          note..  since the normal output value of istate is 2,
c          it does not need to be reset for normal continuation.
c          also, since a negative input value of istate will be
c          regarded as illegal, a negative output value requires the
c          user to change it, and possibly other inputs, before
c          calling the solver again.
c
c iopt   = an integer flag to specify whether or not any optional
c          inputs are being used on this call.  input only.
c          the optional inputs are listed separately below.
c          iopt = 0 means no optional inputs are being used.
c                   default values will be used in all cases.
c          iopt = 1 means one or more optional inputs are being used.
c
c rwork  = a real working array (double precision).
c          the length of rwork must be at least
c             20 + nyh*(maxord + 1) + 3*neq + lwm    where
c          nyh    = the initial value of neq,
c          maxord = 12 (if meth = 1) or 5 (if meth = 2) (unless a
c                   smaller value is given as an optional input),
c          lwm   = 0             if miter = 0,
c          lwm   = neq**2 + 2    if miter is 1 or 2,
c          lwm   = neq + 2       if miter = 3, and
c          lwm   = (2*ml+mu+1)*neq + 2 if miter is 4 or 5.
c          (see the mf description for meth and miter.)
c          thus if maxord has its default value and neq is constant,
c          this length is..
c             20 + 16*neq                  for mf = 10,
c             22 + 16*neq + neq**2         for mf = 11 or 12,
c             22 + 17*neq                  for mf = 13,
c             22 + 17*neq + (2*ml+mu)*neq  for mf = 14 or 15,
c             20 +  9*neq                  for mf = 20,
c             22 +  9*neq + neq**2         for mf = 21 or 22,
c             22 + 10*neq                  for mf = 23,
c             22 + 10*neq + (2*ml+mu)*neq  for mf = 24 or 25.
c          the first 20 words of rwork are reserved for conditional
c          and optional inputs and optional outputs.
c
c          the following word in rwork is a conditional input..
c            rwork(1) = tcrit = critical value of t which the solver
c                       is not to overshoot.  required if itask is
c                       4 or 5, and ignored otherwise.  (see itask.)
c
c lrw    = the length of the array rwork, as declared by the user.
c          (this will be checked by the solver.)
c
c iwork  = an integer work array.  the length of iwork must be at least
c             20        if miter = 0 or 3 (mf = 10, 13, 20, 23), or
c             20 + neq  otherwise (mf = 11, 12, 14, 15, 21, 22, 24, 25).
c          the first few words of iwork are used for conditional and
c          optional inputs and optional outputs.
c
c          the following 2 words in iwork are conditional inputs..
c            iwork(1) = ml     these are the lower and upper
c            iwork(2) = mu     half-bandwidths, respectively, of the
c                       banded jacobian, excluding the main diagonal.
c                       the band is defined by the matrix locations
c                       (i,j) with i-ml .le. j .le. i+mu.  ml and mu
c                       must satisfy  0 .le.  ml,mu  .le. neq-1.
c                       these are required if miter is 4 or 5, and
c                       ignored otherwise.  ml and mu may in fact be
c                       the band parameters for a matrix to which
c                       df/dy is only approximately equal.
c
c liw    = the length of the array iwork, as declared by the user.
c          (this will be checked by the solver.)
c
c note..  the work arrays must not be altered between calls to lsode
c for the same problem, except possibly for the conditional and
c optional inputs, and except for the last 3*neq words of rwork.
c the latter space is used for internal scratch space, and so is
c available for use by the user outside lsode between calls, if
c desired (but not for use by f or jac).
c
c jac    = the name of the user-supplied routine (miter = 1 or 4) to
c          compute the jacobian matrix, df/dy, as a function of
c          the scalar t and the vector y.  it is to have the form
c               subroutine jac (neq, t, y, ml, mu, pd, nrowpd)
c               dimension y(1), pd(nrowpd,1)
c          where neq, t, y, ml, mu, and nrowpd are input and the array
c          pd is to be loaded with partial derivatives (elements of
c          the jacobian matrix) on output.  pd must be given a first
c          dimension of nrowpd.  t and y have the same meaning as in
c          subroutine f.  (in the dimension statement above, 1 is a
c          dummy dimension.. it can be replaced by any value.)
c               in the full matrix case (miter = 1), ml and mu are
c          ignored, and the jacobian is to be loaded into pd in
c          columnwise manner, with df(i)/dy(j) loaded into pd(i,j).
c               in the band matrix case (miter = 4), the elements
c          within the band are to be loaded into pd in columnwise
c          manner, with diagonal lines of df/dy loaded into the rows
c          of pd.  thus df(i)/dy(j) is to be loaded into pd(i-j+mu+1,j).
c          ml and mu are the half-bandwidth parameters (see iwork).
c          the locations in pd in the two triangular areas which
c          correspond to nonexistent matrix elements can be ignored
c          or loaded arbitrarily, as they are overwritten by lsode.
c               jac need not provide df/dy exactly.  a crude
c          approximation (possibly with a smaller bandwidth) will do.
c               in either case, pd is preset to zero by the solver,
c          so that only the nonzero elements need be loaded by jac.
c          each call to jac is preceded by a call to f with the same
c          arguments neq, t, and y.  thus to gain some efficiency,
c          intermediate quantities shared by both calculations may be
c          saved in a user common block by f and not recomputed by jac,
c          if desired.  also, jac may alter the y array, if desired.
c          jac must be declared external in the calling program.
c               subroutine jac may access user-defined quantities in
c          neq(2),... and/or in y(neq(1)+1),... if neq is an array
c          (dimensioned in jac) and/or y has length exceeding neq(1).
c          see the descriptions of neq and y above.
c
c mf     = the method flag.  used only for input.  the legal values of
c          mf are 10, 11, 12, 13, 14, 15, 20, 21, 22, 23, 24, and 25.
c          mf has decimal digits meth and miter.. mf = 10*meth + miter.
c          meth indicates the basic linear multistep method..
c            meth = 1 means the implicit adams method.
c            meth = 2 means the method based on backward
c                     differentiation formulas (bdf-s).
c          miter indicates the corrector iteration method..
c            miter = 0 means functional iteration (no jacobian matrix
c                      is involved).
c            miter = 1 means chord iteration with a user-supplied
c                      full (neq by neq) jacobian.
c            miter = 2 means chord iteration with an internally
c                      generated (difference quotient) full jacobian
c                      (using neq extra calls to f per df/dy value).
c            miter = 3 means chord iteration with an internally
c                      generated diagonal jacobian approximation.
c                      (using 1 extra call to f per df/dy evaluation).
c            miter = 4 means chord iteration with a user-supplied
c                      banded jacobian.
c            miter = 5 means chord iteration with an internally
c                      generated banded jacobian (using ml+mu+1 extra
c                      calls to f per df/dy evaluation).
c          if miter = 1 or 4, the user must supply a subroutine jac
c          (the name is arbitrary) as described above under jac.
c          for other values of miter, a dummy argument can be used.
c-----------------------------------------------------------------------
c optional inputs.
c
c the following is a list of the optional inputs provided for in the
c call sequence.  (see also part ii.)  for each such input variable,
c this table lists its name as used in this documentation, its
c location in the call sequence, its meaning, and the default value.
c the use of any of these inputs requires iopt = 1, and in that
c case all of these inputs are examined.  a value of zero for any
c of these optional inputs will cause the default value to be used.
c thus to use a subset of the optional inputs, simply preload
c locations 5 to 10 in rwork and iwork to 0.0 and 0 respectively, and
c then set those of interest to nonzero values.
c
c name    location      meaning and default value
c
c h0      rwork(5)  the step size to be attempted on the first step.
c                   the default value is determined by the solver.
c
c hmax    rwork(6)  the maximum absolute step size allowed.
c                   the default value is infinite.
c
c hmin    rwork(7)  the minimum absolute step size allowed.
c                   the default value is 0.  (this lower bound is not
c                   enforced on the final step before reaching tcrit
c                   when itask = 4 or 5.)
c
c maxord  iwork(5)  the maximum order to be allowed.  the default
c                   value is 12 if meth = 1, and 5 if meth = 2.
c                   if maxord exceeds the default value, it will
c                   be reduced to the default value.
c                   if maxord is changed during the problem, it may
c                   cause the current order to be reduced.
c
c mxstep  iwork(6)  maximum number of (internally defined) steps
c                   allowed during one call to the solver.
c                   the default value is 500.
c
c mxhnil  iwork(7)  maximum number of messages printed (per problem)
c                   warning that t + h = t on a step (h = step size).
c                   this must be positive to result in a non-default
c                   value.  the default value is 10.
c-----------------------------------------------------------------------
c optional outputs.
c
c as optional additional output from lsode, the variables listed
c below are quantities related to the performance of lsode
c which are available to the user.  these are communicated by way of
c the work arrays, but also have internal mnemonic names as shown.
c except where stated otherwise, all of these outputs are defined
c on any successful return from lsode, and on any return with
c istate = -1, -2, -4, -5, or -6.  on an illegal input return
c (istate = -3), they will be unchanged from their existing values
c (if any), except possibly for tolsf, lenrw, and leniw.
c on any error return, outputs relevant to the error will be defined,
c as noted below.
c
c name    location      meaning
c
c hu      rwork(11) the step size in t last used (successfully).
c
c hcur    rwork(12) the step size to be attempted on the next step.
c
c tcur    rwork(13) the current value of the independent variable
c                   which the solver has actually reached, i.e. the
c                   current internal mesh point in t.  on output, tcur
c                   will always be at least as far as the argument
c                   t, but may be farther (if interpolation was done).
c
c tolsf   rwork(14) a tolerance scale factor, greater than 1.0,
c                   computed when a request for too much accuracy was
c                   detected (istate = -3 if detected at the start of
c                   the problem, istate = -2 otherwise).  if itol is
c                   left unaltered but rtol and atol are uniformly
c                   scaled up by a factor of tolsf for the next call,
c                   then the solver is deemed likely to succeed.
c                   (the user may also ignore tolsf and alter the
c                   tolerance parameters in any other way appropriate.)
c
c nst     iwork(11) the number of steps taken for the problem so far.
c
c nfe     iwork(12) the number of f evaluations for the problem so far.
c
c nje     iwork(13) the number of jacobian evaluations (and of matrix
c                   lu decompositions) for the problem so far.
c
c nqu     iwork(14) the method order last used (successfully).
c
c nqcur   iwork(15) the order to be attempted on the next step.
c
c imxer   iwork(16) the index of the component of largest magnitude in
c                   the weighted local error vector ( e(i)/ewt(i) ),
c                   on an error return with istate = -4 or -5.
c
c lenrw   iwork(17) the length of rwork actually required.
c                   this is defined on normal returns and on an illegal
c                   input return for insufficient storage.
c
c leniw   iwork(18) the length of iwork actually required.
c                   this is defined on normal returns and on an illegal
c                   input return for insufficient storage.
c
c the following two arrays are segments of the rwork array which
c may also be of interest to the user as optional outputs.
c for each array, the table below gives its internal name,
c its base address in rwork, and its description.
c
c name    base address      description
c
c yh      21             the nordsieck history array, of size nyh by
c                        (nqcur + 1), where nyh is the initial value
c                        of neq.  for j = 0,1,...,nqcur, column j+1
c                        of yh contains hcur**j/factorial(j) times
c                        the j-th derivative of the interpolating
c                        polynomial currently representing the solution,
c                        evaluated at t = tcur.
c
c acor     lenrw-neq+1   array of size neq used for the accumulated
c                        corrections on each step, scaled on output
c                        to represent the estimated local error in y
c                        on the last step.  this is the vector e in
c                        the description of the error control.  it is
c                        defined only on a successful return from lsode.
c
c-----------------------------------------------------------------------
c part ii.  other routines callable.
c
c the following are optional calls which the user may make to
c gain additional capabilities in conjunction with lsode.
c (the routines xsetun and xsetf are designed to conform to the
c slatec error handling package.)
c
c     form of call                  function
c   call xsetun(lun)          set the logical unit number, lun, for
c                             output of messages from lsode, if
c                             the default is not desired.
c                             the default value of lun is 6.
c
c   call xsetf(mflag)         set a flag to control the printing of
c                             messages by lsode.
c                             mflag = 0 means do not print. (danger..
c                             this risks losing valuable information.)
c                             mflag = 1 means print (the default).
c
c                             either of the above calls may be made at
c                             any time and will take effect immediately.
c
c   call srcom(rsav,isav,job) saves and restores the contents of
c                             the internal common blocks used by
c                             lsode (see part iii below).
c                             rsav must be a real array of length 218
c                             or more, and isav must be an integer
c                             array of length 41 or more.
c                             job=1 means save common into rsav/isav.
c                             job=2 means restore common from rsav/isav.
c                                srcom is useful if one is
c                             interrupting a run and restarting
c                             later, or alternating between two or
c                             more problems solved with lsode.
c
c   call intdy(,,,,,)         provide derivatives of y, of various
c        (see below)          orders, at a specified point t, if
c                             desired.  it may be called only after
c                             a successful return from lsode.
c
c the detailed instructions for using intdy are as follows.
c the form of the call is..
c
c   call intdy (t, k, rwork(21), nyh, dky, iflag)
c
c the input parameters are..
c
c t         = value of independent variable where answers are desired
c             (normally the same as the t last returned by lsode).
c             for valid results, t must lie between tcur - hu and tcur.
c             (see optional outputs for tcur and hu.)
c k         = integer order of the derivative desired.  k must satisfy
c             0 .le. k .le. nqcur, where nqcur is the current order
c             (see optional outputs).  the capability corresponding
c             to k = 0, i.e. computing y(t), is already provided
c             by lsode directly.  since nqcur .ge. 1, the first
c             derivative dy/dt is always available with intdy.
c rwork(21) = the base address of the history array yh.
c nyh       = column length of yh, equal to the initial value of neq.
c
c the output parameters are..
c
c dky       = a real array of length neq containing the computed value
c             of the k-th derivative of y(t).
c iflag     = integer flag, returned as 0 if k and t were legal,
c             -1 if k was illegal, and -2 if t was illegal.
c             on an error return, a message is also written.
c-----------------------------------------------------------------------
c part iii.  common blocks.
c
c if lsode is to be used in an overlay situation, the user
c must declare, in the primary overlay, the variables in..
c   (1) the call sequence to lsode,
c   (2) the two internal common blocks
c         /ls0001/  of length  257  (218 double precision words
c                         followed by 39 integer words),
c         /eh0001/  of length  2 (integer words).
c
c if lsode is used on a system in which the contents of internal
c common blocks are not preserved between calls, the user should
c declare the above two common blocks in his main program to insure
c that their contents are preserved.
c
c if the solution of a given problem by lsode is to be interrupted
c and then later continued, such as when restarting an interrupted run
c or alternating between two or more problems, the user should save,
c following the return from the last lsode call prior to the
c interruption, the contents of the call sequence variables and the
c internal common blocks, and later restore these values before the
c next lsode call for that problem.  to save and restore the common
c blocks, use subroutine srcom (see part ii above).
c
c-----------------------------------------------------------------------
c part iv.  optionally replaceable solver routines.
c
c below are descriptions of two routines in the lsode package which
c relate to the measurement of errors.  either routine can be
c replaced by a user-supplied version, if desired.  however, since such
c a replacement may have a major impact on performance, it should be
c done only when absolutely necessary, and only with great caution.
c (note.. the means by which the package version of a routine is
c superseded by the user-s version may be system-dependent.)
c
c (a) ewset.
c the following subroutine is called just before each internal
c integration step, and sets the array of error weights, ewt, as
c described under itol/rtol/atol above..
c     subroutine ewset (neq, itol, rtol, atol, ycur, ewt)
c where neq, itol, rtol, and atol are as in the lsode call sequence,
c ycur contains the current dependent variable vector, and
c ewt is the array of weights set by ewset.
c
c if the user supplies this subroutine, it must return in ewt(i)
c (i = 1,...,neq) a positive quantity suitable for comparing errors
c in y(i) to.  the ewt array returned by ewset is passed to the
c vnorm routine (see below), and also used by lsode in the computation
c of the optional output imxer, the diagonal jacobian approximation,
c and the increments for difference quotient jacobians.
c
c in the user-supplied version of ewset, it may be desirable to use
c the current values of derivatives of y.  derivatives up to order nq
c are available from the history array yh, described above under
c optional outputs.  in ewset, yh is identical to the ycur array,
c extended to nq + 1 columns with a column length of nyh and scale
c factors of h**j/factorial(j).  on the first call for the problem,
c given by nst = 0, nq is 1 and h is temporarily set to 1.0.
c the quantities nq, nyh, h, and nst can be obtained by including
c in ewset the statements..
c     double precision h, rls
c     common /ls0001/ rls(218),ils(39)
c     nq = ils(35)
c     nyh = ils(14)
c     nst = ils(36)
c     h = rls(212)
c thus, for example, the current value of dy/dt can be obtained as
c ycur(nyh+i)/h  (i=1,...,neq)  (and the division by h is
c unnecessary when nst = 0).
c
c (b) vnorm.
c the following is a real function routine which computes the weighted
c root-mean-square norm of a vector v..
c     d = vnorm (n, v, w)
c where..
c   n = the length of the vector,
c   v = real array of length n containing the vector,
c   w = real array of length n containing weights,
c   d = sqrt( (1/n) * sum(v(i)*w(i))**2 ).
c vnorm is called with n = neq and with w(i) = 1.0/ewt(i), where
c ewt is as set by subroutine ewset.
c
c if the user supplies this function, it should return a non-negative
c value of vnorm suitable for use in the error control in lsode.
c none of the arguments should be altered by vnorm.
c for example, a user-supplied vnorm routine might..
c   -substitute a max-norm of (v(i)*w(i)) for the rms-norm, or
c   -ignore some components of v in the norm, with the effect of
c    suppressing the error control on those components of y.
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
c other routines in the lsode package.
c
c in addition to subroutine lsode, the lsode package includes the
c following subroutines and function routines..
c  intdy    computes an interpolated value of the y vector at t = tout.
c  stode    is the core integrator, which does one step of the
c           integration and the associated error control.
c  cfode    sets all method coefficients and test constants.
c  prepj    computes and preprocesses the jacobian matrix j = df/dy
c           and the newton iteration matrix p = i - h*l0*j.
c  solsy    manages solution of linear system in chord iteration.
c  ewset    sets the error weight vector ewt before each step.
c  vnorm    computes the weighted r.m.s. norm of a vector.
c  srcom    is a user-callable routine to save and restore
c           the contents of the internal common blocks.
c  dgefa and dgesl   are routines from linpack for solving full
c           systems of linear algebraic equations.
c  dgbfa and dgbsl   are routines from linpack for solving banded
c           linear systems.
c  daxpy, dscal, idamax, and ddot   are basic linear algebra modules
c           (blas) used by the above linpack routines.
c  d1mach   computes the unit roundoff in a machine-independent manner.
c  xerrwv, xsetun, and xsetf   handle the printing of all error
c           messages and warnings.  xerrwv is machine-dependent.
c note..  vnorm, idamax, ddot, and d1mach are function routines.
c all the others are subroutines.
c
c the intrinsic and external routines used by lsode are..
c dabs, dmax1, dmin1, dfloat, max0, min0, mod, dsign, dsqrt, and write.
c
c a block data subprogram is also included with the package,
c for loading some of the variables in internal common.
c
c-----------------------------------------------------------------------
c the following card is for optimized compilation on llnl compilers.
clll. optimize
c-----------------------------------------------------------------------
      external prepj_r8, solsy_r8
      integer illin, init, lyh, lewt, lacor, lsavf, lwm, liwm,
     1   mxstep, mxhnil, nhnil, ntrep, nslast, nyh, iowns
      integer icf, ierpj, iersl, jcur, jstart, kflag, l, meth, miter,
     1   maxord, maxcor, msbp, mxncf, n, nq, nst, nfe, nje, nqu
      integer i, i1, i2, iflag, imxer, kgo, lf0,
     1   leniw, lenrw, lenwm, ml, mord, mu, mxhnl0, mxstp0
      REAL*8 rowns,
     1   ccmax, el0, h, hmin, hmxi, hu, rc, tn, uround
      REAL*8 atoli, ayi, big, ewti, h0, hmax, hmx, rh, rtoli,
     1   tcrit, tdist, tnext, tol, tolsf, tp, size, sum, w0,
     2   d1mach, vnorm_r8
      dimension mord(2)
      logical ihit
c-----------------------------------------------------------------------
c the following internal common block contains
c (a) variables which are local to any subroutine but whose values must
c     be preserved between calls to the routine (own variables), and
c (b) variables which are communicated between subroutines.
c the structure of the block is as follows..  all real variables are
c listed first, followed by all integers.  within each type, the
c variables are grouped with those local to subroutine lsode first,
c then those local to subroutine stode, and finally those used
c for communication.  the block is declared in subroutines
c lsode, intdy, stode, prepj, and solsy.  groups of variables are
c replaced by dummy arrays in the common declarations in routines
c where those variables are not used.
c-----------------------------------------------------------------------
      common /ls0001/ rowns(209),
     1   ccmax, el0, h, hmin, hmxi, hu, rc, tn, uround,
     2   illin, init, lyh, lewt, lacor, lsavf, lwm, liwm,
     3   mxstep, mxhnil, nhnil, ntrep, nslast, nyh, iowns(6),
     4   icf, ierpj, iersl, jcur, jstart, kflag, l, meth, miter,
     5   maxord, maxcor, msbp, mxncf, n, nq, nst, nfe, nje, nqu
c
      data  mord(1),mord(2)/12,5/, mxstp0/500/, mxhnl0/10/
c-----------------------------------------------------------------------
c block a.
c this code block is executed on every call.
c it tests istate and itask for legality and branches appropriately.
c if istate .gt. 1 but the flag init shows that initialization has
c not yet been done, an error return occurs.
c if istate = 1 and tout = t, jump to block g and return immediately.
c-----------------------------------------------------------------------
      if (istate .lt. 1 .or. istate .gt. 3) go to 601
      if (itask .lt. 1 .or. itask .gt. 5) go to 602
      if (istate .eq. 1) go to 10
      if (init .eq. 0) go to 603
      if (istate .eq. 2) go to 200
      go to 20
 10   init = 0
      if (tout .eq. t) go to 430
 20   ntrep = 0
c-----------------------------------------------------------------------
c block b.
c the next code block is executed for the initial call (istate = 1),
c or for a continuation call with parameter changes (istate = 3).
c it contains checking of all inputs and various initializations.
c
c first check legality of the non-optional inputs neq, itol, iopt,
c mf, ml, and mu.
c-----------------------------------------------------------------------
      if (neq(1) .le. 0) go to 604
      if (istate .eq. 1) go to 25
      if (neq(1) .gt. n) go to 605
 25   n = neq(1)
      if (itol .lt. 1 .or. itol .gt. 4) go to 606
      if (iopt .lt. 0 .or. iopt .gt. 1) go to 607
      meth = mf/10
      miter = mf - 10*meth
      if (meth .lt. 1 .or. meth .gt. 2) go to 608
      if (miter .lt. 0 .or. miter .gt. 5) go to 608
      if (miter .le. 3) go to 30
      ml = iwork(1)
      mu = iwork(2)
      if (ml .lt. 0 .or. ml .ge. n) go to 609
      if (mu .lt. 0 .or. mu .ge. n) go to 610
 30   continue
c next process and check the optional inputs. --------------------------
      if (iopt .eq. 1) go to 40
      maxord = mord(meth)
      mxstep = mxstp0
      mxhnil = mxhnl0
      if (istate .eq. 1) h0 = 0.0d0
      hmxi = 0.0d0
      hmin = 0.0d0
      go to 60
 40   maxord = iwork(5)
      if (maxord .lt. 0) go to 611
      if (maxord .eq. 0) maxord = 100
      maxord = min(maxord,mord(meth))
      mxstep = iwork(6)
      if (mxstep .lt. 0) go to 612
      if (mxstep .eq. 0) mxstep = mxstp0
      mxhnil = iwork(7)
      if (mxhnil .lt. 0) go to 613
      if (mxhnil .eq. 0) mxhnil = mxhnl0
      if (istate .ne. 1) go to 50
      h0 = rwork(5)
      if ((tout - t)*h0 .lt. 0.0d0) go to 614
 50   hmax = rwork(6)
      if (hmax .lt. 0.0d0) go to 615
      hmxi = 0.0d0
      if (hmax .gt. 0.0d0) hmxi = 1.0d0/hmax
      hmin = rwork(7)
      if (hmin .lt. 0.0d0) go to 616
c-----------------------------------------------------------------------
c set work array pointers and check lengths lrw and liw.
c pointers to segments of rwork and iwork are named by prefixing l to
c the name of the segment.  e.g., the segment yh starts at rwork(lyh).
c segments of rwork (in order) are denoted  yh, wm, ewt, savf, acor.
c-----------------------------------------------------------------------
 60   lyh = 21
      if (istate .eq. 1) nyh = n
      lwm = lyh + (maxord + 1)*nyh
      if (miter .eq. 0) lenwm = 0
      if (miter .eq. 1 .or. miter .eq. 2) lenwm = n*n + 2
      if (miter .eq. 3) lenwm = n + 2
      if (miter .ge. 4) lenwm = (2*ml + mu + 1)*n + 2
      lewt = lwm + lenwm
      lsavf = lewt + n
      lacor = lsavf + n
      lenrw = lacor + n - 1
      iwork(17) = lenrw
      liwm = 1
      leniw = 20 + n
      if (miter .eq. 0 .or. miter .eq. 3) leniw = 20
      iwork(18) = leniw
      if (lenrw .gt. lrw) go to 617
      if (leniw .gt. liw) go to 618
c check rtol and atol for legality. ------------------------------------
      rtoli = rtol(1)
      atoli = atol(1)
      do 70 i = 1,n
        if (itol .ge. 3) rtoli = rtol(i)
        if (itol .eq. 2 .or. itol .eq. 4) atoli = atol(i)
        if (rtoli .lt. 0.0d0) go to 619
        if (atoli .lt. 0.0d0) go to 620
 70     continue
      if (istate .eq. 1) go to 100
c if istate = 3, set flag to signal parameter changes to stode. --------
      jstart = -1
      if (nq .le. maxord) go to 90
c maxord was reduced below nq.  copy yh(*,maxord+2) into savf. ---------
      do 80 i = 1,n
 80     rwork(i+lsavf-1) = rwork(i+lwm-1)
c reload wm(1) = rwork(lwm), since lwm may have changed. ---------------
 90   if (miter .gt. 0) rwork(lwm) = sqrt(uround)
      if (n .eq. nyh) go to 200
c neq was reduced.  zero part of yh to avoid undefined references. -----
      i1 = lyh + l*nyh
      i2 = lyh + (maxord + 1)*nyh - 1
      if (i1 .gt. i2) go to 200
      do 95 i = i1,i2
 95     rwork(i) = 0.0d0
      go to 200
c-----------------------------------------------------------------------
c block c.
c the next block is for the initial call only (istate = 1).
c it contains all remaining initializations, the initial call to f,
c and the calculation of the initial step size.
c the error weights in ewt are inverted after being loaded.
c-----------------------------------------------------------------------
 100  uround = d1mach(4)
      tn = t
      if (itask .ne. 4 .and. itask .ne. 5) go to 110
      tcrit = rwork(1)
      if ((tcrit - tout)*(tout - t) .lt. 0.0d0) go to 625
      if (h0 .ne. 0.0d0 .and.
     1   (t + h0 - tcrit)*h0 .gt. 0.0d0)
     2   h0 = tcrit - t
 110  jstart = 0
      if (miter .gt. 0) rwork(lwm) = sqrt(uround)
      nhnil = 0
      nst = 0
      nje = 0
      nslast = 0
      hu = 0.0d0
      nqu = 0
      ccmax = 0.3d0
      maxcor = 3
      msbp = 20
      mxncf = 10
c initial call to f.  (lf0 points to yh(*,2).) -------------------------
      lf0 = lyh + nyh
      call f (neq, t, y, rwork(lf0))
      nfe = 1
c load the initial value vector in yh. ---------------------------------
      do 115 i = 1,n
 115    rwork(i+lyh-1) = y(i)
c load and invert the ewt array.  (h is temporarily set to 1.0.) -------
      nq = 1
      h = 1.0d0
      call ewset_r8 (n, itol, rtol, atol, rwork(lyh), rwork(lewt))
      do 120 i = 1,n
        if (rwork(i+lewt-1) .le. 0.0d0) go to 621
 120    rwork(i+lewt-1) = 1.0d0/rwork(i+lewt-1)
c-----------------------------------------------------------------------
c the coding below computes the step size, h0, to be attempted on the
c first step, unless the user has supplied a value for this.
c first check that tout - t differs significantly from zero.
c a scalar tolerance quantity tol is computed, as max(rtol(i))
c if this is positive, or max(atol(i)/abs(y(i))) otherwise, adjusted
c so as to be between 100*uround and 1.0e-3.
c then the computed value h0 is given by..
c                                      neq
c   h0**2 = tol / ( w0**-2 + (1/neq) * sum ( f(i)/ywt(i) )**2  )
c                                       1
c where   w0     = max ( abs(t), abs(tout) ),
c         f(i)   = i-th component of initial value of f,
c         ywt(i) = ewt(i)/tol  (a weight for y(i)).
c the sign of h0 is inferred from the initial values of tout and t.
c-----------------------------------------------------------------------
      if (h0 .ne. 0.0d0) go to 180
      tdist = abs(tout - t)
      w0 = max(abs(t),abs(tout))
      if (tdist .lt. 2.0d0*uround*w0) go to 622
      tol = rtol(1)
      if (itol .le. 2) go to 140
      do 130 i = 1,n
 130    tol = max(tol,rtol(i))
 140  if (tol .gt. 0.0d0) go to 160
      atoli = atol(1)
      do 150 i = 1,n
        if (itol .eq. 2 .or. itol .eq. 4) atoli = atol(i)
        ayi = abs(y(i))
        if (ayi .ne. 0.0d0) tol = max(tol,atoli/ayi)
 150    continue
 160  tol = max(tol,100.0d0*uround)
      tol = min(tol,0.001d0)
      sum = vnorm_r8 (n, rwork(lf0), rwork(lewt))
      sum = 1.0d0/(tol*w0*w0) + tol*sum**2
      h0 = 1.0d0/sqrt(sum)
      h0 = min(h0,tdist)
      h0 = sign(h0,tout-t)
c adjust h0 if necessary to meet hmax bound. ---------------------------
 180  rh = abs(h0)*hmxi
      if (rh .gt. 1.0d0) h0 = h0/rh
c load h with h0 and scale yh(*,2) by h0. ------------------------------
      h = h0
      do 190 i = 1,n
 190    rwork(i+lf0-1) = h0*rwork(i+lf0-1)
      go to 270
c-----------------------------------------------------------------------
c block d.
c the next code block is for continuation calls only (istate = 2 or 3)
c and is to check stop conditions before taking a step.
c-----------------------------------------------------------------------
 200  nslast = nst
      go to (210, 250, 220, 230, 240), itask
 210  if ((tn - tout)*h .lt. 0.0d0) go to 250
      call intdy_r8 (tout, 0, rwork(lyh), nyh, y, iflag)
      if (iflag .ne. 0) go to 627
      t = tout
      go to 420
 220  tp = tn - hu*(1.0d0 + 100.0d0*uround)
      if ((tp - tout)*h .gt. 0.0d0) go to 623
      if ((tn - tout)*h .lt. 0.0d0) go to 250
      go to 400
 230  tcrit = rwork(1)
      if ((tn - tcrit)*h .gt. 0.0d0) go to 624
      if ((tcrit - tout)*h .lt. 0.0d0) go to 625
      if ((tn - tout)*h .lt. 0.0d0) go to 245
      call intdy_r8 (tout, 0, rwork(lyh), nyh, y, iflag)
      if (iflag .ne. 0) go to 627
      t = tout
      go to 420
 240  tcrit = rwork(1)
      if ((tn - tcrit)*h .gt. 0.0d0) go to 624
 245  hmx = abs(tn) + abs(h)
      ihit = abs(tn - tcrit) .le. 100.0d0*uround*hmx
      if (ihit) go to 400
      tnext = tn + h*(1.0d0 + 4.0d0*uround)
      if ((tnext - tcrit)*h .le. 0.0d0) go to 250
      h = (tcrit - tn)*(1.0d0 - 4.0d0*uround)
      if (istate .eq. 2) jstart = -2
c-----------------------------------------------------------------------
c block e.
c the next block is normally executed for all calls and contains
c the call to the one-step core integrator stode.
c
c this is a looping point for the integration steps.
c
c first check for too many steps being taken, update ewt (if not at
c start of problem), check for too much accuracy being requested, and
c check for h below the roundoff level in t.
c-----------------------------------------------------------------------
 250  continue
      if ((nst-nslast) .ge. mxstep) go to 500
      call ewset_r8 (n, itol, rtol, atol, rwork(lyh), rwork(lewt))
      do 260 i = 1,n
        if (rwork(i+lewt-1) .le. 0.0d0) go to 510
 260    rwork(i+lewt-1) = 1.0d0/rwork(i+lewt-1)
 270  tolsf = uround*vnorm_r8 (n, rwork(lyh), rwork(lewt))
      if (tolsf .le. 1.0d0) go to 280
      tolsf = tolsf*2.0d0
      if (nst .eq. 0) go to 626
      go to 520
 280  if ((tn + h) .ne. tn) go to 290
      nhnil = nhnil + 1
      if (nhnil .gt. mxhnil) go to 290
      call xerrwv_r8(
     1     'lsode--  warning..internal t (=r1) and h (=r2) are',
     1     50, 101, 0, 0, 0, 0, 0, 0.0d0, 0.0d0)
      call xerrwv_r8(
     1  '      such that in the machine, t + h = t on the next step  ',
     1     60, 101, 0, 0, 0, 0, 0, 0.0d0, 0.0d0)
      call xerrwv_r8(
     1     '      (h = step size). solver will continue anyway',
     1     50, 101, 0, 0, 0, 0, 2, tn, h)
      if (nhnil .lt. mxhnil) go to 290
      call xerrwv_r8(
     1     'lsode--  above warning has been issued i1 times.  ',
     1     50, 102, 0, 0, 0, 0, 0, 0.0d0, 0.0d0)
      call xerrwv_r8(
     1     '      it will not be issued again for this problem',
     1     50, 102, 0, 1, mxhnil, 0, 0, 0.0d0, 0.0d0)
 290  continue
c-----------------------------------------------------------------------
c     call stode(neq,y,yh,nyh,yh,ewt,savf,acor,wm,iwm,f,jac,prepj,solsy)
c-----------------------------------------------------------------------
      call stode_r8 (neq, y, rwork(lyh), nyh, rwork(lyh), rwork(lewt),
     1   rwork(lsavf), rwork(lacor), rwork(lwm), iwork(liwm),
     2   f, jac, prepj_r8, solsy_r8)
      kgo = 1 - kflag
      go to (300, 530, 540), kgo
c-----------------------------------------------------------------------
c block f.
c the following block handles the case of a successful return from the
c core integrator (kflag = 0).  test for stop conditions.
c-----------------------------------------------------------------------
 300  init = 1
      go to (310, 400, 330, 340, 350), itask
c itask = 1.  if tout has been reached, interpolate. -------------------
 310  if ((tn - tout)*h .lt. 0.0d0) go to 250
      call intdy_r8 (tout, 0, rwork(lyh), nyh, y, iflag)
      t = tout
      go to 420
c itask = 3.  jump to exit if tout was reached. ------------------------
 330  if ((tn - tout)*h .ge. 0.0d0) go to 400
      go to 250
c itask = 4.  see if tout or tcrit was reached.  adjust h if necessary.
 340  if ((tn - tout)*h .lt. 0.0d0) go to 345
      call intdy_r8 (tout, 0, rwork(lyh), nyh, y, iflag)
      t = tout
      go to 420
 345  hmx = abs(tn) + abs(h)
      ihit = abs(tn - tcrit) .le. 100.0d0*uround*hmx
      if (ihit) go to 400
      tnext = tn + h*(1.0d0 + 4.0d0*uround)
      if ((tnext - tcrit)*h .le. 0.0d0) go to 250
      h = (tcrit - tn)*(1.0d0 - 4.0d0*uround)
      jstart = -2
      go to 250
c itask = 5.  see if tcrit was reached and jump to exit. ---------------
 350  hmx = abs(tn) + abs(h)
      ihit = abs(tn - tcrit) .le. 100.0d0*uround*hmx
c-----------------------------------------------------------------------
c block g.
c the following block handles all successful returns from lsode.
c if itask .ne. 1, y is loaded from yh and t is set accordingly.
c istate is set to 2, the illegal input counter is zeroed, and the
c optional outputs are loaded into the work arrays before returning.
c if istate = 1 and tout = t, there is a return with no action taken,
c except that if this has happened repeatedly, the run is terminated.
c-----------------------------------------------------------------------
 400  do 410 i = 1,n
 410    y(i) = rwork(i+lyh-1)
      t = tn
      if (itask .ne. 4 .and. itask .ne. 5) go to 420
      if (ihit) t = tcrit
 420  istate = 2
      illin = 0
      rwork(11) = hu
      rwork(12) = h
      rwork(13) = tn
      iwork(11) = nst
      iwork(12) = nfe
      iwork(13) = nje
      iwork(14) = nqu
      iwork(15) = nq
      return
c
 430  ntrep = ntrep + 1
      if (ntrep .lt. 5) return
      call xerrwv_r8(
     1  'lsode--  repeated calls with istate = 1 and tout = t (=r1)  ',
     1   60, 301, 0, 0, 0, 0, 1, t, 0.0d0)
      go to 800
c-----------------------------------------------------------------------
c block h.
c the following block handles all unsuccessful returns other than
c those for illegal input.  first the error message routine is called.
c if there was an error test or convergence test failure, imxer is set.
c then y is loaded from yh, t is set to tn, and the illegal input
c counter illin is set to 0.  the optional outputs are loaded into
c the work arrays before returning.
c-----------------------------------------------------------------------
c the maximum number of steps was taken before reaching tout. ----------
 500  call xerrwv_r8(
     1     'lsode--  at current t (=r1), mxstep (=i1) steps   ',
     1   50, 201, 0, 0, 0, 0, 0, 0.0d0, 0.0d0)
      call xerrwv_r8(
     1     '      taken on this call before reaching tout     ',
     1   50, 201, 0, 1, mxstep, 0, 1, tn, 0.0d0)
      istate = -1
      go to 580
c ewt(i) .le. 0.0 for some i (not at start of problem). ----------------
 510  ewti = rwork(lewt+i-1)
      call xerrwv_r8(
     1     'lsode--  at t (=r1), ewt(i1) has become r2 .le. 0.',
     1   50, 202, 0, 1, i, 0, 2, tn, ewti)
      istate = -6
      go to 580
c too much accuracy requested for machine precision. -------------------
 520  call xerrwv_r8(
     1     'lsode--  at t (=r1), too much accuracy requested  ',
     1   50, 203, 0, 0, 0, 0, 0, 0.0d0, 0.0d0)
      call xerrwv_r8(
     1     '      for precision of machine..  see tolsf (=r2) ',
     1   50, 203, 0, 0, 0, 0, 2, tn, tolsf)
      rwork(14) = tolsf
      istate = -2
      go to 580
c kflag = -1.  error test failed repeatedly or with abs(h) = hmin. -----
 530  call xerrwv_r8(
     1     'lsode--  at t(=r1) and step size h(=r2), the error',
     1   50, 204, 0, 0, 0, 0, 0, 0.0d0, 0.0d0)
      call xerrwv_r8(
     1     '      test failed repeatedly or with abs(h) = hmin',
     1   50, 204, 0, 0, 0, 0, 2, tn, h)
      istate = -4
      go to 560
c kflag = -2.  convergence failed repeatedly or with abs(h) = hmin. ----
 540  call xerrwv_r8(
     1     'lsode--  at t (=r1) and step size h (=r2), the    ',
     1   50, 205, 0, 0, 0, 0, 0, 0.0d0, 0.0d0)
      call xerrwv_r8(
     1     '      corrector convergence failed repeatedly     ',
     1   50, 205, 0, 0, 0, 0, 0, 0.0d0, 0.0d0)
      call xerrwv_r8(
     1     '      or with abs(h) = hmin   ',
     1   30, 205, 0, 0, 0, 0, 2, tn, h)
      istate = -5
c compute imxer if relevant. -------------------------------------------
 560  big = 0.0d0
      imxer = 1
      do 570 i = 1,n
        size = abs(rwork(i+lacor-1)*rwork(i+lewt-1))
        if (big .ge. size) go to 570
        big = size
        imxer = i
 570    continue
      iwork(16) = imxer
c set y vector, t, illin, and optional outputs. ------------------------
 580  do 590 i = 1,n
 590    y(i) = rwork(i+lyh-1)
      t = tn
      illin = 0
      rwork(11) = hu
      rwork(12) = h
      rwork(13) = tn
      iwork(11) = nst
      iwork(12) = nfe
      iwork(13) = nje
      iwork(14) = nqu
      iwork(15) = nq
      return
c-----------------------------------------------------------------------
c block i.
c the following block handles all error returns due to illegal input
c (istate = -3), as detected before calling the core integrator.
c first the error message routine is called.  then if there have been
c 5 consecutive such returns just before this call to the solver,
c the run is halted.
c-----------------------------------------------------------------------
 601  call xerrwv_r8('lsode--  istate (=i1) illegal ',
     1   30, 1, 0, 1, istate, 0, 0, 0.0d0, 0.0d0)
      go to 700
 602  call xerrwv_r8('lsode--  itask (=i1) illegal  ',
     1   30, 2, 0, 1, itask, 0, 0, 0.0d0, 0.0d0)
      go to 700
 603  call xerrwv_r8(
     1     'lsode--  istate .gt. 1 but lsode not initialized  ',
     1   50, 3, 0, 0, 0, 0, 0, 0.0d0, 0.0d0)
      go to 700
 604  call xerrwv_r8('lsode--  neq (=i1) .lt. 1     ',
     1   30, 4, 0, 1, neq(1), 0, 0, 0.0d0, 0.0d0)
      go to 700
 605  call xerrwv_r8(
     1     'lsode--  istate = 3 and neq increased (i1 to i2)  ',
     1   50, 5, 0, 2, n, neq(1), 0, 0.0d0, 0.0d0)
      go to 700
 606  call xerrwv_r8('lsode--  itol (=i1) illegal   ',
     1   30, 6, 0, 1, itol, 0, 0, 0.0d0, 0.0d0)
      go to 700
 607  call xerrwv_r8('lsode--  iopt (=i1) illegal   ',
     1   30, 7, 0, 1, iopt, 0, 0, 0.0d0, 0.0d0)
      go to 700
 608  call xerrwv_r8('lsode--  mf (=i1) illegal     ',
     1   30, 8, 0, 1, mf, 0, 0, 0.0d0, 0.0d0)
      go to 700
 609  call xerrwv_r8(
     1     'lsode--  ml (=i1) illegal.. .lt.0 or .ge.neq (=i2)',
     1   50, 9, 0, 2, ml, neq(1), 0, 0.0d0, 0.0d0)
      go to 700
 610  call xerrwv_r8(
     1     'lsode--  mu (=i1) illegal.. .lt.0 or .ge.neq (=i2)',
     1   50, 10, 0, 2, mu, neq(1), 0, 0.0d0, 0.0d0)
      go to 700
 611  call xerrwv_r8('lsode--  maxord (=i1) .lt. 0  ',
     1   30, 11, 0, 1, maxord, 0, 0, 0.0d0, 0.0d0)
      go to 700
 612  call xerrwv_r8('lsode--  mxstep (=i1) .lt. 0  ',
     1   30, 12, 0, 1, mxstep, 0, 0, 0.0d0, 0.0d0)
      go to 700
 613  call xerrwv_r8('lsode--  mxhnil (=i1) .lt. 0  ',
     1   30, 13, 0, 1, mxhnil, 0, 0, 0.0d0, 0.0d0)
      go to 700
 614  call xerrwv_r8('lsode--  tout (=r1) behind t (=r2)      ',
     1   40, 14, 0, 0, 0, 0, 2, tout, t)
      call xerrwv_r8(
     1     '      integration direction is given by h0 (=r1)  ',
     1   50, 14, 0, 0, 0, 0, 1, h0, 0.0d0)
      go to 700
 615  call xerrwv_r8('lsode--  hmax (=r1) .lt. 0.0  ',
     1   30, 15, 0, 0, 0, 0, 1, hmax, 0.0d0)
      go to 700
 616  call xerrwv_r8('lsode--  hmin (=r1) .lt. 0.0  ',
     1   30, 16, 0, 0, 0, 0, 1, hmin, 0.0d0)
      go to 700
 617  call xerrwv_r8(
     1  'lsode--  rwork length needed, lenrw (=i1), exceeds lrw (=i2)',
     1   60, 17, 0, 2, lenrw, lrw, 0, 0.0d0, 0.0d0)
      go to 700
 618  call xerrwv_r8(
     1  'lsode--  iwork length needed, leniw (=i1), exceeds liw (=i2)',
     1   60, 18, 0, 2, leniw, liw, 0, 0.0d0, 0.0d0)
      go to 700
 619  call xerrwv_r8('lsode--  rtol(i1) is r1 .lt. 0.0        ',
     1   40, 19, 0, 1, i, 0, 1, rtoli, 0.0d0)
      go to 700
 620  call xerrwv_r8('lsode--  atol(i1) is r1 .lt. 0.0        ',
     1   40, 20, 0, 1, i, 0, 1, atoli, 0.0d0)
      go to 700
 621  ewti = rwork(lewt+i-1)
      call xerrwv_r8('lsode--  ewt(i1) is r1 .le. 0.0         ',
     1   40, 21, 0, 1, i, 0, 1, ewti, 0.0d0)
      go to 700
 622  call xerrwv_r8(
     1  'lsode--  tout (=r1) too close to t(=r2) to start integration',
     1   60, 22, 0, 0, 0, 0, 2, tout, t)
      go to 700
 623  call xerrwv_r8(
     1  'lsode--  itask = i1 and tout (=r1) behind tcur - hu (= r2)  ',
     1   60, 23, 0, 1, itask, 0, 2, tout, tp)
      go to 700
 624  call xerrwv_r8(
     1  'lsode--  itask = 4 or 5 and tcrit (=r1) behind tcur (=r2)   ',
     1   60, 24, 0, 0, 0, 0, 2, tcrit, tn)
      go to 700
 625  call xerrwv_r8(
     1  'lsode--  itask = 4 or 5 and tcrit (=r1) behind tout (=r2)   ',
     1   60, 25, 0, 0, 0, 0, 2, tcrit, tout)
      go to 700
 626  call xerrwv_r8(
     1     'lsode--  at start of problem, too much accuracy   ',
     1   50, 26, 0, 0, 0, 0, 0, 0.0d0, 0.0d0)
      call xerrwv_r8(
     1  '      requested for precision of machine..  see tolsf (=r1) ',
     1   60, 26, 0, 0, 0, 0, 1, tolsf, 0.0d0)
      rwork(14) = tolsf
      go to 700
 627  call xerrwv_r8(
     1     'lsode--  trouble from intdy. itask = i1, tout = r1',
     1   50, 27, 0, 1, itask, 0, 1, tout, 0.0d0)
c
 700  if (illin .eq. 5) go to 710
      illin = illin + 1
      istate = -3
      return
 710  call xerrwv_r8(
     1     'lsode--  repeated occurrences of illegal input    ',
     1   50, 302, 0, 0, 0, 0, 0, 0.0d0, 0.0d0)
c
 800  call xerrwv_r8(
     1     'lsode--  run aborted.. apparent infinite loop     ',
     1   50, 303, 2, 0, 0, 0, 0, 0.0d0, 0.0d0)
      return
c----------------------- end of subroutine lsode -----------------------
      end
      subroutine cfode_r8 (meth, elco, tesco)
clll. optimize
      IMPLICIT NONE
      integer meth
      integer i, ib, nq, nqm1, nqp1
      REAL*8 elco, tesco
      REAL*8 agamq, fnq, fnqm1, pc, pint, ragq,
     1   rqfac, rq1fac, tsign, xpin
      dimension elco(13,12), tesco(3,12)
c-----------------------------------------------------------------------
c cfode is called by the integrator routine to set coefficients
c needed there.  the coefficients for the current method, as
c given by the value of meth, are set for all orders and saved.
c the maximum order assumed here is 12 if meth = 1 and 5 if meth = 2.
c (a smaller value of the maximum order is also allowed.)
c cfode is called once at the beginning of the problem,
c and is not called again unless and until meth is changed.
c
c the elco array contains the basic method coefficients.
c the coefficients el(i), 1 .le. i .le. nq+1, for the method of
c order nq are stored in elco(i,nq).  they are given by a genetrating
c polynomial, i.e.,
c     l(x) = el(1) + el(2)*x + ... + el(nq+1)*x**nq.
c for the implicit adams methods, l(x) is given by
c     dl/dx = (x+1)*(x+2)*...*(x+nq-1)/factorial(nq-1),    l(-1) = 0.
c for the bdf methods, l(x) is given by
c     l(x) = (x+1)*(x+2)* ... *(x+nq)/k,
c where         k = factorial(nq)*(1 + 1/2 + ... + 1/nq).
c
c the tesco array contains test constants used for the
c local error test and the selection of step size and/or order.
c at order nq, tesco(k,nq) is used for the selection of step
c size at order nq - 1 if k = 1, at order nq if k = 2, and at order
c nq + 1 if k = 3.
c-----------------------------------------------------------------------
      dimension pc(12)
c
      go to (100, 200), meth
c
 100  elco(1,1) = 1.0d0
      elco(2,1) = 1.0d0
      tesco(1,1) = 0.0d0
      tesco(2,1) = 2.0d0
      tesco(1,2) = 1.0d0
      tesco(3,12) = 0.0d0
      pc(1) = 1.0d0
      rqfac = 1.0d0
      do 140 nq = 2,12
c-----------------------------------------------------------------------
c the pc array will contain the coefficients of the polynomial
c     p(x) = (x+1)*(x+2)*...*(x+nq-1).
c initially, p(x) = 1.
c-----------------------------------------------------------------------
        rq1fac = rqfac
        rqfac = rqfac/AREAL(nq)
        nqm1 = nq - 1
        fnqm1 = AREAL(nqm1)
        nqp1 = nq + 1
c form coefficients of p(x)*(x+nq-1). ----------------------------------
        pc(nq) = 0.0d0
        do 110 ib = 1,nqm1
          i = nqp1 - ib
 110      pc(i) = pc(i-1) + fnqm1*pc(i)
        pc(1) = fnqm1*pc(1)
c compute integral, -1 to 0, of p(x) and x*p(x). -----------------------
        pint = pc(1)
        xpin = pc(1)/2.0d0
        tsign = 1.0d0
        do 120 i = 2,nq
          tsign = -tsign
          pint = pint + tsign*pc(i)/AREAL(i)
 120      xpin = xpin + tsign*pc(i)/AREAL(i+1)
c store coefficients in elco and tesco. --------------------------------
        elco(1,nq) = pint*rq1fac
        elco(2,nq) = 1.0d0
        do 130 i = 2,nq
 130      elco(i+1,nq) = rq1fac*pc(i)/AREAL(i)
        agamq = rqfac*xpin
        ragq = 1.0d0/agamq
        tesco(2,nq) = ragq
        if (nq .lt. 12) tesco(1,nqp1) = ragq*rqfac/AREAL(nqp1)
        tesco(3,nqm1) = ragq
 140    continue
      return
c
 200  pc(1) = 1.0d0
      rq1fac = 1.0d0
      do 230 nq = 1,5
c-----------------------------------------------------------------------
c the pc array will contain the coefficients of the polynomial
c     p(x) = (x+1)*(x+2)*...*(x+nq).
c initially, p(x) = 1.
c-----------------------------------------------------------------------
        fnq = AREAL(nq)
        nqp1 = nq + 1
c form coefficients of p(x)*(x+nq). ------------------------------------
        pc(nqp1) = 0.0d0
        do 210 ib = 1,nq
          i = nq + 2 - ib
 210      pc(i) = pc(i-1) + fnq*pc(i)
        pc(1) = fnq*pc(1)
c store coefficients in elco and tesco. --------------------------------
        do 220 i = 1,nqp1
 220      elco(i,nq) = pc(i)/pc(2)
        elco(2,nq) = 1.0d0
        tesco(1,nq) = rq1fac
        tesco(2,nq) = AREAL(nqp1)/elco(1,nq)
        tesco(3,nq) = AREAL(nq+2)/elco(1,nq)
        rq1fac = rq1fac/fnq
 230    continue
      return
c----------------------- end of subroutine cfode -----------------------
      end
      subroutine ewset_r8 (n, itol, rtol, atol, ycur, ewt)
clll. optimize
c-----------------------------------------------------------------------
c this subroutine sets the error weight vector ewt according to
c     ewt(i) = rtol(i)*abs(ycur(i)) + atol(i),  i = 1,...,n,
c with the subscript on rtol and/or atol possibly replaced by 1 above,
c depending on the value of itol.
c-----------------------------------------------------------------------
      IMPLICIT NONE
      integer n, itol
      integer i
      REAL*8 rtol, atol, ycur, ewt
      dimension rtol(*), atol(*), ycur(n), ewt(n)
c
      go to (10, 20, 30, 40), itol
 10   continue
      do 15 i = 1,n
 15     ewt(i) = rtol(1)*abs(ycur(i)) + atol(1)
      return
 20   continue
      do 25 i = 1,n
 25     ewt(i) = rtol(1)*abs(ycur(i)) + atol(i)
      return
 30   continue
      do 35 i = 1,n
 35     ewt(i) = rtol(i)*abs(ycur(i)) + atol(1)
      return
 40   continue
      do 45 i = 1,n
 45     ewt(i) = rtol(i)*abs(ycur(i)) + atol(i)
      return
c----------------------- end of subroutine ewset -----------------------
      end
      subroutine intdy_r8 (t, k, yh, nyh, dky, iflag)
clll. optimize

      IMPLICIT NONE
      integer k, nyh, iflag
      integer iownd, iowns,
     1   icf, ierpj, iersl, jcur, jstart, kflag, l, meth, miter,
     2   maxord, maxcor, msbp, mxncf, n, nq, nst, nfe, nje, nqu
      integer i, ic, j, jb, jb2, jj, jj1, jp1
      REAL*8 t, yh, dky
      REAL*8 rowns,
     1   ccmax, el0, h, hmin, hmxi, hu, rc, tn, uround
      REAL*8 c, r, s, tp
      dimension yh(nyh,*), dky(*)
      common /ls0001/ rowns(209),
     2   ccmax, el0, h, hmin, hmxi, hu, rc, tn, uround,
     3   iownd(14), iowns(6),
     4   icf, ierpj, iersl, jcur, jstart, kflag, l, meth, miter,
     5   maxord, maxcor, msbp, mxncf, n, nq, nst, nfe, nje, nqu
c-----------------------------------------------------------------------
c intdy computes interpolated values of the k-th derivative of the
c dependent variable vector y, and stores it in dky.  this routine
c is called within the package with k = 0 and t = tout, but may
c also be called by the user for any k up to the current order.
c (see detailed instructions in the usage documentation.)
c-----------------------------------------------------------------------
c the computed values in dky are gotten by interpolation using the
c nordsieck history array yh.  this array corresponds uniquely to a
c vector-valued polynomial of degree nqcur or less, and dky is set
c to the k-th derivative of this polynomial at t.
c the formula for dky is..
c              q
c  dky(i)  =  sum  c(j,k) * (t - tn)**(j-k) * h**(-j) * yh(i,j+1)
c             j=k
c where  c(j,k) = j*(j-1)*...*(j-k+1), q = nqcur, tn = tcur, h = hcur.
c the quantities  nq = nqcur, l = nq+1, n = neq, tn, and h are
c communicated by common.  the above sum is done in reverse order.
c iflag is returned negative if either k or t is out of bounds.
c-----------------------------------------------------------------------
      iflag = 0
      if (k .lt. 0 .or. k .gt. nq) go to 80
      tp = tn - hu -  100.0d0*uround*(tn + hu)
      if ((t-tp)*(t-tn) .gt. 0.0d0) go to 90
c
      s = (t - tn)/h
      ic = 1
      if (k .eq. 0) go to 15
      jj1 = l - k
      do 10 jj = jj1,nq
 10     ic = ic*jj
 15   c = AREAL(ic)
      do 20 i = 1,n
 20     dky(i) = c*yh(i,l)
      if (k .eq. nq) go to 55
      jb2 = nq - k
      do 50 jb = 1,jb2
        j = nq - jb
        jp1 = j + 1
        ic = 1
        if (k .eq. 0) go to 35
        jj1 = jp1 - k
        do 30 jj = jj1,j
 30       ic = ic*jj
 35     c = AREAL(ic)
        do 40 i = 1,n
 40       dky(i) = c*yh(i,jp1) + s*dky(i)
 50     continue
      if (k .eq. 0) return
 55   r = h**(-k)
      do 60 i = 1,n
 60     dky(i) = r*dky(i)
      return
c
 80   call xerrwv_r8('intdy--  k (=i1) illegal      ',
     1   30, 51, 0, 1, k, 0, 0, 0.0d0, 0.0d0)
      iflag = -1
      return
 90   call xerrwv_r8('intdy--  t (=r1) illegal      ',
     1   30, 52, 0, 0, 0, 0, 1, t, 0.0d0)
      call xerrwv_r8(
     1  '      t not in interval tcur - hu (= r1) to tcur (=r2)      ',
     1   60, 52, 0, 0, 0, 0, 2, tp, tn)
      iflag = -2
      return
c----------------------- end of subroutine intdy -----------------------
      end
      subroutine prepj_r8 (neq, y, yh, nyh, ewt, ftem, savf, wm, iwm,
     1   f, jac)
clll. optimize
      IMPLICIT NONE
      external f, jac
      integer neq, nyh, iwm
      integer iownd, iowns,
     1   icf, ierpj, iersl, jcur, jstart, kflag, l, meth, miter,
     2   maxord, maxcor, msbp, mxncf, n, nq, nst, nfe, nje, nqu
      integer i, i1, i2, ier, ii, j, j1, jj, lenp,
     1   mba, mband, meb1, meband, ml, ml3, mu, np1
      REAL*8 y, yh, ewt, ftem, savf, wm
      REAL*8 rowns,
     1   ccmax, el0, h, hmin, hmxi, hu, rc, tn, uround
      REAL*8 con, di, fac, hl0, r, r0, srur, yi, yj, yjj,
     1   vnorm_r8
      dimension neq(*), y(*), yh(nyh,*), ewt(*), ftem(*), savf(*),
     1   wm(*), iwm(*)
      common /ls0001/ rowns(209),
     2   ccmax, el0, h, hmin, hmxi, hu, rc, tn, uround,
     3   iownd(14), iowns(6),
     4   icf, ierpj, iersl, jcur, jstart, kflag, l, meth, miter,
     5   maxord, maxcor, msbp, mxncf, n, nq, nst, nfe, nje, nqu
c-----------------------------------------------------------------------
c prepj is called by stode to compute and process the matrix
c p = i - h*el(1)*j , where j is an approximation to the jacobian.
c here j is computed by the user-supplied routine jac if
c miter = 1 or 4, or by finite differencing if miter = 2, 3, or 5.
c if miter = 3, a diagonal approximation to j is used.
c j is stored in wm and replaced by p.  if miter .ne. 3, p is then
c subjected to lu decomposition in preparation for later solution
c of linear systems with p as coefficient matrix. this is done
c by dgefa if miter = 1 or 2, and by dgbfa if miter = 4 or 5.
c
c in addition to variables described previously, communication
c with prepj uses the following..
c y     = array containing predicted values on entry.
c ftem  = work array of length n (acor in stode).
c savf  = array containing f evaluated at predicted y.
c wm    = real work space for matrices.  on output it contains the
c         inverse diagonal matrix if miter = 3 and the lu decomposition
c         of p if miter is 1, 2 , 4, or 5.
c         storage of matrix elements starts at wm(3).
c         wm also contains the following matrix-related data..
c         wm(1) = sqrt(uround), used in numerical jacobian increments.
c         wm(2) = h*el0, saved for later use if miter = 3.
c iwm   = integer work space containing pivot information, starting at
c         iwm(21), if miter is 1, 2, 4, or 5.  iwm also contains band
c         parameters ml = iwm(1) and mu = iwm(2) if miter is 4 or 5.
c el0   = el(1) (input).
c ierpj = output error flag,  = 0 if no trouble, .gt. 0 if
c         p matrix found to be singular.
c jcur  = output flag = 1 to indicate that the jacobian matrix
c         (or approximation) is now current.
c this routine also uses the common variables el0, h, tn, uround,
c miter, n, nfe, and nje.
c-----------------------------------------------------------------------
      nje = nje + 1
      ierpj = 0
      jcur = 1
      hl0 = h*el0
      go to (100, 200, 300, 400, 500), miter
c if miter = 1, call jac and multiply by scalar. -----------------------
 100  lenp = n*n
      do 110 i = 1,lenp
 110    wm(i+2) = 0.0d0
      call jac (neq, tn, y, 0, 0, wm(3), n)
      con = -hl0
      do 120 i = 1,lenp
 120    wm(i+2) = wm(i+2)*con
      go to 240
c if miter = 2, make n calls to f to approximate j. --------------------
 200  fac = vnorm_r8 (n, savf, ewt)
      r0 = 1000.0d0*abs(h)*uround*AREAL(n)*fac
      if (r0 .eq. 0.0d0) r0 = 1.0d0
      srur = wm(1)
      j1 = 2
      do 230 j = 1,n
        yj = y(j)
        r = max(srur*abs(yj),r0/ewt(j))
        y(j) = y(j) + r
        fac = -hl0/r
        call f (neq, tn, y, ftem)
        do 220 i = 1,n
 220      wm(i+j1) = (ftem(i) - savf(i))*fac
        y(j) = yj
        j1 = j1 + n
 230    continue
      nfe = nfe + n
c add identity matrix. -------------------------------------------------
 240  j = 3
      np1 = n + 1
      do 250 i = 1,n
        wm(j) = wm(j) + 1.0d0
 250    j = j + np1
c do lu decomposition on p. --------------------------------------------
      call dgefa (wm(3), n, n, iwm(21), ier)
      if (ier .ne. 0) ierpj = 1
      return
c if miter = 3, construct a diagonal approximation to j and p. ---------
 300  wm(2) = hl0
      r = el0*0.1d0
      do 310 i = 1,n
 310    y(i) = y(i) + r*(h*savf(i) - yh(i,2))
      call f (neq, tn, y, wm(3))
      nfe = nfe + 1
      do 320 i = 1,n
        r0 = h*savf(i) - yh(i,2)
        di = 0.1d0*r0 - h*(wm(i+2) - savf(i))
        wm(i+2) = 1.0d0
        if (abs(r0) .lt. uround/ewt(i)) go to 320
        if (abs(di) .eq. 0.0d0) go to 330
        wm(i+2) = 0.1d0*r0/di
 320    continue
      return
 330  ierpj = 1
      return
c if miter = 4, call jac and multiply by scalar. -----------------------
 400  ml = iwm(1)
      mu = iwm(2)
      ml3 = ml + 3
      mband = ml + mu + 1
      meband = mband + ml
      lenp = meband*n
      do 410 i = 1,lenp
 410    wm(i+2) = 0.0d0
      call jac (neq, tn, y, ml, mu, wm(ml3), meband)
      con = -hl0
      do 420 i = 1,lenp
 420    wm(i+2) = wm(i+2)*con
      go to 570
c if miter = 5, make mband calls to f to approximate j. ----------------
 500  ml = iwm(1)
      mu = iwm(2)
      mband = ml + mu + 1
      mba = min(mband,n)
      meband = mband + ml
      meb1 = meband - 1
      srur = wm(1)
      fac = vnorm_r8 (n, savf, ewt)
      r0 = 1000.0d0*abs(h)*uround*AREAL(n)*fac
      if (r0 .eq. 0.0d0) r0 = 1.0d0
      do 560 j = 1,mba
        do 530 i = j,n,mband
          yi = y(i)
          r = max(srur*abs(yi),r0/ewt(i))
 530      y(i) = y(i) + r
        call f (neq, tn, y, ftem)
        do 550 jj = j,n,mband
          y(jj) = yh(jj,1)
          yjj = y(jj)
          r = max(srur*abs(yjj),r0/ewt(jj))
          fac = -hl0/r
          i1 = max(jj-mu,1)
          i2 = min(jj+ml,n)
          ii = jj*meb1 - ml + 2
          do 540 i = i1,i2
 540        wm(ii+i) = (ftem(i) - savf(i))*fac
 550      continue
 560    continue
      nfe = nfe + mba
c add identity matrix. -------------------------------------------------
 570  ii = mband + 2
      do 580 i = 1,n
        wm(ii) = wm(ii) + 1.0d0
 580    ii = ii + meband
c do lu decomposition of p. --------------------------------------------
      call dgbfa (wm(3), meband, n, ml, mu, iwm(21), ier)
      if (ier .ne. 0) ierpj = 1
      return
c----------------------- end of subroutine prepj -----------------------
      end
      subroutine solsy_r8 (wm, iwm, x, tem)
clll. optimize
      IMPLICIT NONE
      integer iwm
      integer iownd, iowns,
     1   icf, ierpj, iersl, jcur, jstart, kflag, l, meth, miter,
     2   maxord, maxcor, msbp, mxncf, n, nq, nst, nfe, nje, nqu
      integer i, meband, ml, mu
      REAL*8 wm, x, tem
      REAL*8 rowns,
     1   ccmax, el0, h, hmin, hmxi, hu, rc, tn, uround
      REAL*8 di, hl0, phl0, r
      dimension wm(*), iwm(*), x(*), tem(*)
      common /ls0001/ rowns(209),
     2   ccmax, el0, h, hmin, hmxi, hu, rc, tn, uround,
     3   iownd(14), iowns(6),
     4   icf, ierpj, iersl, jcur, jstart, kflag, l, meth, miter,
     5   maxord, maxcor, msbp, mxncf, n, nq, nst, nfe, nje, nqu
c-----------------------------------------------------------------------
c this routine manages the solution of the linear system arising from
c a chord iteration.  it is called if miter .ne. 0.
c if miter is 1 or 2, it calls dgesl to accomplish this.
c if miter = 3 it updates the coefficient h*el0 in the diagonal
c matrix, and then computes the solution.
c if miter is 4 or 5, it calls dgbsl.
c communication with solsy uses the following variables..
c wm    = real work space containing the inverse diagonal matrix if
c         miter = 3 and the lu decomposition of the matrix otherwise.
c         storage of matrix elements starts at wm(3).
c         wm also contains the following matrix-related data..
c         wm(1) = sqrt(uround) (not used here),
c         wm(2) = hl0, the previous value of h*el0, used if miter = 3.
c iwm   = integer work space containing pivot information, starting at
c         iwm(21), if miter is 1, 2, 4, or 5.  iwm also contains band
c         parameters ml = iwm(1) and mu = iwm(2) if miter is 4 or 5.
c x     = the right-hand side vector on input, and the solution vector
c         on output, of length n.
c tem   = vector of work space of length n, not used in this version.
c iersl = output flag (in common).  iersl = 0 if no trouble occurred.
c         iersl = 1 if a singular matrix arose with miter = 3.
c this routine also uses the common variables el0, h, miter, and n.
c-----------------------------------------------------------------------
      iersl = 0
      go to (100, 100, 300, 400, 400), miter
 100  call dgesl (wm(3), n, n, iwm(21), x, 0)
      return
c
 300  phl0 = wm(2)
      hl0 = h*el0
      wm(2) = hl0
      if (hl0 .eq. phl0) go to 330
      r = hl0/phl0
      do 320 i = 1,n
        di = 1.0d0 - r*(1.0d0 - 1.0d0/wm(i+2))
        if (abs(di) .eq. 0.0d0) go to 390
 320    wm(i+2) = 1.0d0/di
 330  do 340 i = 1,n
 340    x(i) = wm(i+2)*x(i)
      return
 390  iersl = 1
      return
c
 400  ml = iwm(1)
      mu = iwm(2)
      meband = 2*ml + mu + 1
      call dgbsl (wm(3), meband, n, ml, mu, iwm(21), x, 0)
      return
c----------------------- end of subroutine solsy -----------------------
      end
      subroutine stode_r8 (neq, y, yh, nyh, yh1, ewt, savf, acor,
     1   wm, iwm, f, jac, pjac, slvs)
clll. optimize
C============
C idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER jac
C============
      external f, jac, pjac, slvs
      integer neq, nyh, iwm
      integer iownd, ialth, ipup, lmax, meo, nqnyh, nslp,
     1   icf, ierpj, iersl, jcur, jstart, kflag, l, meth, miter,
     2   maxord, maxcor, msbp, mxncf, n, nq, nst, nfe, nje, nqu
      integer i, i1, iredo, iret, j, jb, m, ncf, newq
      REAL*8 y, yh, yh1, ewt, savf, acor, wm
      REAL*8 conit, crate, el, elco, hold, rmax, tesco,
     2   ccmax, el0, h, hmin, hmxi, hu, rc, tn, uround
      REAL*8 dcon, ddn, del, delp, dsm, dup, exdn, exsm, exup,
     1   r, rh, rhdn, rhsm, rhup, told, vnorm_r8
      dimension neq(*), y(*), yh(nyh,*), yh1(*), ewt(*), savf(*),
     1   acor(*), wm(*), iwm(*)
      common /ls0001/ conit, crate, el(13), elco(13,12),
     1   hold, rmax, tesco(3,12),
     2   ccmax, el0, h, hmin, hmxi, hu, rc, tn, uround, iownd(14),
     3   ialth, ipup, lmax, meo, nqnyh, nslp,
     4   icf, ierpj, iersl, jcur, jstart, kflag, l, meth, miter,
     5   maxord, maxcor, msbp, mxncf, n, nq, nst, nfe, nje, nqu
c-----------------------------------------------------------------------
c stode performs one step of the integration of an initial value
c problem for a system of ordinary differential equations.
c note.. stode is independent of the value of the iteration method
c indicator miter, when this is .ne. 0, and hence is independent
c of the type of chord method used, or the jacobian structure.
c communication with stode is done with the following variables..
c
c neq    = integer array containing problem size in neq(1), and
c          passed as the neq argument in all calls to f and jac.
c y      = an array of length .ge. n used as the y argument in
c          all calls to f and jac.
c yh     = an nyh by lmax array containing the dependent variables
c          and their approximate scaled derivatives, where
c          lmax = maxord + 1.  yh(i,j+1) contains the approximate
c          j-th derivative of y(i), scaled by h**j/factorial(j)
c          (j = 0,1,...,nq).  on entry for the first step, the first
c          two columns of yh must be set from the initial values.
c nyh    = a constant integer .ge. n, the first dimension of yh.
c yh1    = a one-dimensional array occupying the same space as yh.
c ewt    = an array of length n containing multiplicative weights
c          for local error measurements.  local errors in y(i) are
c          compared to 1.0/ewt(i) in various error tests.
c savf   = an array of working storage, of length n.
c          also used for input of yh(*,maxord+2) when jstart = -1
c          and maxord .lt. the current order nq.
c acor   = a work array of length n, used for the accumulated
c          corrections.  on a successful return, acor(i) contains
c          the estimated one-step local error in y(i).
c wm,iwm = real and integer work arrays associated with matrix
c          operations in chord iteration (miter .ne. 0).
c pjac   = name of routine to evaluate and preprocess jacobian matrix
c          and p = i - h*el0*jac, if a chord method is being used.
c slvs   = name of routine to solve linear system in chord iteration.
c ccmax  = maximum relative change in h*el0 before pjac is called.
c h      = the step size to be attempted on the next step.
c          h is altered by the error control algorithm during the
c          problem.  h can be either positive or negative, but its
c          sign must remain constant throughout the problem.
c hmin   = the minimum absolute value of the step size h to be used.
c hmxi   = inverse of the maximum absolute value of h to be used.
c          hmxi = 0.0 is allowed and corresponds to an infinite hmax.
c          hmin and hmxi may be changed at any time, but will not
c          take effect until the next change of h is considered.
c tn     = the independent variable. tn is updated on each step taken.
c jstart = an integer used for input only, with the following
c          values and meanings..
c               0  perform the first step.
c           .gt.0  take a new step continuing from the last.
c              -1  take the next step with a new value of h, maxord,
c                    n, meth, miter, and/or matrix parameters.
c              -2  take the next step with a new value of h,
c                    but with other inputs unchanged.
c          on return, jstart is set to 1 to facilitate continuation.
c kflag  = a completion code with the following meanings..
c               0  the step was succesful.
c              -1  the requested error could not be achieved.
c              -2  corrector convergence could not be achieved.
c              -3  fatal error in pjac or slvs.
c          a return with kflag = -1 or -2 means either
c          abs(h) = hmin or 10 consecutive failures occurred.
c          on a return with kflag negative, the values of tn and
c          the yh array are as of the beginning of the last
c          step, and h is the last step size attempted.
c maxord = the maximum order of integration method to be allowed.
c maxcor = the maximum number of corrector iterations allowed.
c msbp   = maximum number of steps between pjac calls (miter .gt. 0).
c mxncf  = maximum number of convergence failures allowed.
c meth/miter = the method flags.  see description in driver.
c n      = the number of first-order differential equations.
c-----------------------------------------------------------------------
      kflag = 0
      told = tn
      ncf = 0
      ierpj = 0
      iersl = 0
      jcur = 0
      icf = 0
      delp = 0.0d0
      if (jstart .gt. 0) go to 200
      if (jstart .eq. -1) go to 100
      if (jstart .eq. -2) go to 160
c-----------------------------------------------------------------------
c on the first call, the order is set to 1, and other variables are
c initialized.  rmax is the maximum ratio by which h can be increased
c in a single step.  it is initially 1.e4 to compensate for the small
c initial h, but then is normally equal to 10.  if a failure
c occurs (in corrector convergence or error test), rmax is set at 2
c for the next increase.
c-----------------------------------------------------------------------
      lmax = maxord + 1
      nq = 1
      l = 2
      ialth = 2
      rmax = 10000.0d0
      rc = 0.0d0
      el0 = 1.0d0
      crate = 0.7d0
      hold = h
      meo = meth
      nslp = 0
      ipup = miter
      iret = 3
      go to 140
c-----------------------------------------------------------------------
c the following block handles preliminaries needed when jstart = -1.
c ipup is set to miter to force a matrix update.
c if an order increase is about to be considered (ialth = 1),
c ialth is reset to 2 to postpone consideration one more step.
c if the caller has changed meth, cfode is called to reset
c the coefficients of the method.
c if the caller has changed maxord to a value less than the current
c order nq, nq is reduced to maxord, and a new h chosen accordingly.
c if h is to be changed, yh must be rescaled.
c if h or meth is being changed, ialth is reset to l = nq + 1
c to prevent further changes in h for that many steps.
c-----------------------------------------------------------------------
 100  ipup = miter
      lmax = maxord + 1
      if (ialth .eq. 1) ialth = 2
      if (meth .eq. meo) go to 110
      call cfode_r8 (meth, elco, tesco)
      meo = meth
      if (nq .gt. maxord) go to 120
      ialth = l
      iret = 1
      go to 150
 110  if (nq .le. maxord) go to 160
 120  nq = maxord
      l = lmax
      do 125 i = 1,l
 125    el(i) = elco(i,nq)
      nqnyh = nq*nyh
      rc = rc*el(1)/el0
      el0 = el(1)
      conit = 0.5d0/AREAL(nq+2)
      ddn = vnorm_r8 (n, savf, ewt)/tesco(1,l)
      exdn = 1.0d0/AREAL(l)
      rhdn = 1.0d0/(1.3d0*ddn**exdn + 0.0000013d0)
      rh = min(rhdn,1.0d0)
      iredo = 3
      if (h .eq. hold) go to 170
      rh = min(rh,abs(h/hold))
      h = hold
      go to 175
c-----------------------------------------------------------------------
c cfode is called to get all the integration coefficients for the
c current meth.  then the el vector and related constants are reset
c whenever the order nq is changed, or at the start of the problem.
c-----------------------------------------------------------------------
 140  call cfode_r8 (meth, elco, tesco)
 150  do 155 i = 1,l
 155    el(i) = elco(i,nq)
      nqnyh = nq*nyh
      rc = rc*el(1)/el0
      el0 = el(1)
      conit = 0.5d0/AREAL(nq+2)
      go to (160, 170, 200), iret
c-----------------------------------------------------------------------
c if h is being changed, the h ratio rh is checked against
c rmax, hmin, and hmxi, and the yh array rescaled.  ialth is set to
c l = nq + 1 to prevent a change of h for that many steps, unless
c forced by a convergence or error test failure.
c-----------------------------------------------------------------------
 160  if (h .eq. hold) go to 200
      rh = h/hold
      h = hold
      iredo = 3
      go to 175
 170  rh = max(rh,hmin/abs(h))
 175  rh = min(rh,rmax)
      rh = rh/max(1.0d0,abs(h)*hmxi*rh)
      r = 1.0d0
      do 180 j = 2,l
        r = r*rh
        do 180 i = 1,n
 180      yh(i,j) = yh(i,j)*r
      h = h*rh
      rc = rc*rh
      ialth = l
      if (iredo .eq. 0) go to 690
c-----------------------------------------------------------------------
c this section computes the predicted values by effectively
c multiplying the yh array by the pascal triangle matrix.
c rc is the ratio of new to old values of the coefficient  h*el(1).
c when rc differs from 1 by more than ccmax, ipup is set to miter
c to force pjac to be called, if a jacobian is involved.
c in any case, pjac is called at least every msbp steps.
c-----------------------------------------------------------------------
 200  if (abs(rc-1.0d0) .gt. ccmax) ipup = miter
      if (nst .ge. nslp+msbp) ipup = miter
      tn = tn + h
      i1 = nqnyh + 1
      do 215 jb = 1,nq
        i1 = i1 - nyh
cdir$ ivdep
        do 210 i = i1,nqnyh
 210      yh1(i) = yh1(i) + yh1(i+nyh)
 215    continue
c-----------------------------------------------------------------------
c up to maxcor corrector iterations are taken.  a convergence test is
c made on the r.m.s. norm of each correction, weighted by the error
c weight vector ewt.  the sum of the corrections is accumulated in the
c vector acor(i).  the yh array is not altered in the corrector loop.
c-----------------------------------------------------------------------
 220  m = 0
      do 230 i = 1,n
 230    y(i) = yh(i,1)
      call f (neq, tn, y, savf)
      nfe = nfe + 1
      if (ipup .le. 0) go to 250
c-----------------------------------------------------------------------
c if indicated, the matrix p = i - h*el(1)*j is reevaluated and
c preprocessed before starting the corrector iteration.  ipup is set
c to 0 as an indicator that this has been done.
c-----------------------------------------------------------------------
      call pjac (neq, y, yh, nyh, ewt, acor, savf, wm, iwm, f, jac)
      ipup = 0
      rc = 1.0d0
      nslp = nst
      crate = 0.7d0
      if (ierpj .ne. 0) go to 430
 250  do 260 i = 1,n
 260    acor(i) = 0.0d0
 270  if (miter .ne. 0) go to 350
c-----------------------------------------------------------------------
c in the case of functional iteration, update y directly from
c the result of the last function evaluation.
c-----------------------------------------------------------------------
      do 290 i = 1,n
        savf(i) = h*savf(i) - yh(i,2)
 290    y(i) = savf(i) - acor(i)
      del = vnorm_r8 (n, y, ewt)
      do 300 i = 1,n
        y(i) = yh(i,1) + el(1)*savf(i)
 300    acor(i) = savf(i)
      go to 400
c-----------------------------------------------------------------------
c in the case of the chord method, compute the corrector error,
c and solve the linear system with that as right-hand side and
c p as coefficient matrix.
c-----------------------------------------------------------------------
 350  do 360 i = 1,n
 360    y(i) = h*savf(i) - (yh(i,2) + acor(i))
      call slvs (wm, iwm, y, savf)
      if (iersl .lt. 0) go to 430
      if (iersl .gt. 0) go to 410
      del = vnorm_r8 (n, y, ewt)
      do 380 i = 1,n
        acor(i) = acor(i) + y(i)
 380    y(i) = yh(i,1) + el(1)*acor(i)
c-----------------------------------------------------------------------
c test for convergence.  if m.gt.0, an estimate of the convergence
c rate constant is stored in crate, and this is used in the test.
c-----------------------------------------------------------------------
 400  if (m .ne. 0) crate = max(0.2d0*crate,del/delp)
      dcon = del*min(1.0d0,1.5d0*crate)/
     1   (tesco(2,nq)*conit)
      if (dcon .le. 1.0d0) go to 450
      m = m + 1
      if (m .eq. maxcor) go to 410
      if (m .ge. 2 .and. del .gt. 2.0d0*delp) go to 410
      delp = del
      call f (neq, tn, y, savf)
      nfe = nfe + 1
      go to 270
c-----------------------------------------------------------------------
c the corrector iteration failed to converge.
c if miter .ne. 0 and the jacobian is out of date, pjac is called for
c the next try.  otherwise the yh array is retracted to its values
c before prediction, and h is reduced, if possible.  if h cannot be
c reduced or mxncf failures have occurred, exit with kflag = -2.
c-----------------------------------------------------------------------
 410  if (miter .eq. 0 .or. jcur .eq. 1) go to 430
      icf = 1
      ipup = miter
      go to 220
 430  icf = 2
      ncf = ncf + 1
      rmax = 2.0d0
      tn = told
      i1 = nqnyh + 1
      do 445 jb = 1,nq
        i1 = i1 - nyh
cdir$ ivdep
        do 440 i = i1,nqnyh
 440      yh1(i) = yh1(i) - yh1(i+nyh)
 445    continue
      if (ierpj .lt. 0 .or. iersl .lt. 0) go to 680
      if (abs(h) .le. hmin*1.00001d0) go to 670
      if (ncf .eq. mxncf) go to 670
      rh = 0.25d0
      ipup = miter
      iredo = 1
      go to 170
c-----------------------------------------------------------------------
c the corrector has converged.  jcur is set to 0
c to signal that the jacobian involved may need updating later.
c the local error test is made and control passes to statement 500
c if it fails.
c-----------------------------------------------------------------------
 450  jcur = 0
      if (m .eq. 0) dsm = del/tesco(2,nq)
      if (m .gt. 0) dsm = vnorm_r8 (n, acor, ewt)/tesco(2,nq)
      if (dsm .gt. 1.0d0) go to 500
c-----------------------------------------------------------------------
c after a successful step, update the yh array.
c consider changing h if ialth = 1.  otherwise decrease ialth by 1.
c if ialth is then 1 and nq .lt. maxord, then acor is saved for
c use in a possible order increase on the next step.
c if a change in h is considered, an increase or decrease in order
c by one is considered also.  a change in h is made only if it is by a
c factor of at least 1.1.  if not, ialth is set to 3 to prevent
c testing for that many steps.
c-----------------------------------------------------------------------
      kflag = 0
      iredo = 0
      nst = nst + 1
      hu = h
      nqu = nq
      do 470 j = 1,l
        do 470 i = 1,n
 470      yh(i,j) = yh(i,j) + el(j)*acor(i)
      ialth = ialth - 1
      if (ialth .eq. 0) go to 520
      if (ialth .gt. 1) go to 700
      if (l .eq. lmax) go to 700
      do 490 i = 1,n
 490    yh(i,lmax) = acor(i)
      go to 700
c-----------------------------------------------------------------------
c the error test failed.  kflag keeps track of multiple failures.
c restore tn and the yh array to their previous values, and prepare
c to try the step again.  compute the optimum step size for this or
c one lower order.  after 2 or more failures, h is forced to decrease
c by a factor of 0.2 or less.
c-----------------------------------------------------------------------
 500  kflag = kflag - 1
      tn = told
      i1 = nqnyh + 1
      do 515 jb = 1,nq
        i1 = i1 - nyh
cdir$ ivdep
        do 510 i = i1,nqnyh
 510      yh1(i) = yh1(i) - yh1(i+nyh)
 515    continue
      rmax = 2.0d0
      if (abs(h) .le. hmin*1.00001d0) go to 660
      if (kflag .le. -3) go to 640
      iredo = 2
      rhup = 0.0d0
      go to 540
c-----------------------------------------------------------------------
c regardless of the success or failure of the step, factors
c rhdn, rhsm, and rhup are computed, by which h could be multiplied
c at order nq - 1, order nq, or order nq + 1, respectively.
c in the case of failure, rhup = 0.0 to avoid an order increase.
c the largest of these is determined and the new order chosen
c accordingly.  if the order is to be increased, we compute one
c additional scaled derivative.
c-----------------------------------------------------------------------
 520  rhup = 0.0d0
      if (l .eq. lmax) go to 540
      do 530 i = 1,n
 530    savf(i) = acor(i) - yh(i,lmax)
      dup = vnorm_r8 (n, savf, ewt)/tesco(3,nq)
      exup = 1.0d0/AREAL(l+1)
      rhup = 1.0d0/(1.4d0*dup**exup + 0.0000014d0)
 540  exsm = 1.0d0/AREAL(l)
      rhsm = 1.0d0/(1.2d0*dsm**exsm + 0.0000012d0)
      rhdn = 0.0d0
      if (nq .eq. 1) go to 560
      ddn = vnorm_r8 (n, yh(1,l), ewt)/tesco(1,nq)
      exdn = 1.0d0/AREAL(nq)
      rhdn = 1.0d0/(1.3d0*ddn**exdn + 0.0000013d0)
 560  if (rhsm .ge. rhup) go to 570
      if (rhup .gt. rhdn) go to 590
      go to 580
 570  if (rhsm .lt. rhdn) go to 580
      newq = nq
      rh = rhsm
      go to 620
 580  newq = nq - 1
      rh = rhdn
      if (kflag .lt. 0 .and. rh .gt. 1.0d0) rh = 1.0d0
      go to 620
 590  newq = l
      rh = rhup
      if (rh .lt. 1.1d0) go to 610
      r = el(l)/AREAL(l)
      do 600 i = 1,n
 600    yh(i,newq+1) = acor(i)*r
      go to 630
 610  ialth = 3
      go to 700
 620  if ((kflag .eq. 0) .and. (rh .lt. 1.1d0)) go to 610
      if (kflag .le. -2) rh = min(rh,0.2d0)
c-----------------------------------------------------------------------
c if there is a change of order, reset nq, l, and the coefficients.
c in any case h is reset according to rh and the yh array is rescaled.
c then exit from 690 if the step was ok, or redo the step otherwise.
c-----------------------------------------------------------------------
      if (newq .eq. nq) go to 170
 630  nq = newq
      l = nq + 1
      iret = 2
      go to 150
c-----------------------------------------------------------------------
c control reaches this section if 3 or more failures have occured.
c if 10 failures have occurred, exit with kflag = -1.
c it is assumed that the derivatives that have accumulated in the
c yh array have errors of the wrong order.  hence the first
c derivative is recomputed, and the order is set to 1.  then
c h is reduced by a factor of 10, and the step is retried,
c until it succeeds or h reaches hmin.
c-----------------------------------------------------------------------
 640  if (kflag .eq. -10) go to 660
      rh = 0.1d0
      rh = max(hmin/abs(h),rh)
      h = h*rh
      do 645 i = 1,n
 645    y(i) = yh(i,1)
      call f (neq, tn, y, savf)
      nfe = nfe + 1
      do 650 i = 1,n
 650    yh(i,2) = h*savf(i)
      ipup = miter
      ialth = 5
      if (nq .eq. 1) go to 200
      nq = 1
      l = 2
      iret = 3
      go to 150
c-----------------------------------------------------------------------
c all returns are made through this section.  h is saved in hold
c to allow the caller to change h on the next step.
c-----------------------------------------------------------------------
 660  kflag = -1
      go to 720
 670  kflag = -2
      go to 720
 680  kflag = -3
      go to 720
 690  rmax = 10.0d0
 700  r = 1.0d0/tesco(2,nqu)
      do 710 i = 1,n
 710    acor(i) = acor(i)*r
 720  hold = h
      jstart = 1
      return
c----------------------- end of subroutine stode -----------------------
      end
      REAL*8 function vnorm_r8 (n, v, w)
clll. optimize
c-----------------------------------------------------------------------
c this function routine computes the weighted root-mean-square norm
c of the vector of length n contained in the array v, with weights
c contained in the array w of length n..
c   vnorm = sqrt( (1/n) * sum( v(i)*w(i) )**2 )
c-----------------------------------------------------------------------
      IMPLICIT NONE
      integer n,   i
      REAL*8 v, w,   sum
      dimension v(n), w(n)
      sum = 0.0d0
      do 10 i = 1,n
 10     sum = sum + (v(i)*w(i))**2
      vnorm_r8 = sqrt(sum/AREAL(n))
      return
c----------------------- end of function vnorm -------------------------
      end
c----------------------- begin lsode_block_data ------------------------
      block data lsode_r8_block_data
c
      implicit NONE
c
      integer iowns,
     2   illin, init, lyh, lewt, lacor, lsavf, lwm, liwm,
     3   mxstep, mxhnil, nhnil, ntrep, nslast, nyh,
     1   icf, ierpj, iersl, jcur, jstart, kflag, l, meth, miter,
     2   maxord, maxcor, msbp, mxncf, n, nq, nst, nfe, nje, nqu
c
      REAL*8 rowns,
     2   ccmax, el0, h, hmin, hmxi, hu, rc, tn, uround
c
      common /ls0001/ rowns(209),
     1   ccmax, el0, h, hmin, hmxi, hu, rc, tn, uround,
     2   illin, init, lyh, lewt, lacor, lsavf, lwm, liwm,
     3   mxstep, mxhnil, nhnil, ntrep, nslast, nyh, iowns(6),
     4   icf, ierpj, iersl, jcur, jstart, kflag, l, meth, miter,
     5   maxord, maxcor, msbp, mxncf, n, nq, nst, nfe, nje, nqu
c
      data illin/0/
      data ntrep/0/
c
      end
c-----------------------------------------------------------------------
! 21Jul1999 fgtok -impno -s r8_precision.sub "r8con.csh conversion"
! 21Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

subroutine eq_rhopsin(npsi,rhovals,ierr)

  !  generate an evenly spaced psi grid and return the corresponding
  !  rho values.  The first point in the psi grid corresponds to the
  !  magnetic axis; the last point, the plasma boundary.

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer npsi                      ! no. of psi pts; rho(psi) pts returned
  real*8 rhovals(npsi)              ! the rho values returned

  integer ierr                      ! completion code (0=OK)

  !--------------------------------------

  call xplasma_rhopsi_gen(s,npsi,ierr, rhovals=rhovals)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_rhopsin: xplasma_rhopsi_gen failed: '
     call xplasma_error(s,ierr,lunerr)
  endif
end subroutine eq_rhopsin

!----------------------------------------------------------------------
subroutine eq_rhopsi(npsi,psivals,rhovals,ztol,ierr)

  ! given a vector of psi values find the corresponding rho values
  ! -- to the indicated accuracy tolerance in rho

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  !  input:

  integer npsi                      ! no. of psivals (vector size)
  real*8 psivals(npsi)              ! the psi's for which rho's are wanted.

  !  output:
  real*8 rhovals(npsi)              ! the rho values returned

  !  input:
  real*8 ztol                       ! accuracy tolerance

  !  output:
  integer ierr                      ! completion code, 0=OK

  !------------------------------------

  call xplasma_rhopsi_find(s,psivals,rhovals,ierr, tol=ztol)
  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_rhopsin: xplasma_rhopsi failed: '
     call xplasma_error(s,ierr,lunerr)
  endif
end subroutine eq_rhopsi

      INTEGER FUNCTION MCSTR_LASTX(STR,SUBSTR)
C
C  SIMILAR TO FORTRAN INDEX(STR,SUBSTR) FCN BUT INSTEAD OF RETURNING
C  THE ADDRESS OF THE FIRST OCCURRENCE OF THE SUBSTR IN STR THIS
C  RETURNS THE ADDRESS OF THE *LAST* OCCURRENCE
C
      CHARACTER*(*) STR
      CHARACTER*(*) SUBSTR
C
      L=LEN(STR)
      LSUB=LEN(SUBSTR)
C
      ICHECK=L-LSUB+1
C
      IFND=0
      IF(ICHECK.LE.0) GO TO 100
C
C  MATCH TEST LOOP
C
      DO 10 I=ICHECK,1,-1
        I2=I+LSUB-1
        IF(STR(I:I2).EQ.SUBSTR) THEN
          IFND=I
          GO TO 100
        ENDIF
 10   CONTINUE
C
 100  CONTINUE
      MCSTR_LASTX=IFND
      RETURN
      END

module geqdsk_aux
  !
  ! support module for geqdsk_mod  ---  static items, constants
  ! see geqdsk_mod.f90
  !   (dmc Jan 2001)
  !
  implicit NONE
  SAVE

  integer :: neqdsk = 77          ! LUN for G-EQdisk file i/o
 
  integer :: lunmsg = 6           ! LUN for messages
 
  integer, parameter :: auxr8 = selected_real_kind(12,100)
 
  integer, parameter :: file_access = 1
  integer, parameter :: mds_full_access = 2
  integer, parameter :: mds_slice_access = 3
 
  integer, parameter :: ctable_max = 20
 
  ! units conversion tables to support G-EQdisk MDSplus i/o
 
  type ctable
 
     integer :: n
     character*16 :: id
     character*32 :: units_string(ctable_max)
     real(auxr8) :: conversion_factor(ctable_max)
 
  end type ctable
 
  type(ctable) :: time_units,length_units,bfield_units,current_units
  type(ctable) :: psi_units,fpol_units,pressure_units,energy_units
  type(ctable) :: pprime_units,ffprime_units,no_units

  logical :: ctable_init_flag = .FALSE.
 
contains
 
  subroutine ctable_init
 
    implicit NONE
 
    !  **hand maintained** tables --
    !  **goal is to support conversions for G-EQDSK quantities from all
    !    EFIT MDSplus trees at all experimenal sites
    !       (dmc 1 Feb 2001)
    !
    !    first entry for each table should be the "standard" MKS label
 
    if(ctable_init_flag) return
 
    call ctable_clear(time_units,'time')
    call ctable_add(time_units, 's', 1.0_auxr8)
    call ctable_add(time_units, 'sec', 1.0_auxr8)
    call ctable_add(time_units, 'seconds', 1.0_auxr8)
    call ctable_add(time_units, 'ms', 1.0e-3_auxr8)
    call ctable_add(time_units, 'msec', 1.0e-3_auxr8)
 
    call ctable_clear(length_units,'length')
    call ctable_add(length_units, 'm', 1.0_auxr8)
    call ctable_add(length_units, 'meters', 1.0_auxr8)
    call ctable_add(length_units, 'cm', 1.0e-2_auxr8)
 
    call ctable_clear(bfield_units,'B_field')
    call ctable_add(bfield_units, 't', 1.0_auxr8)
    call ctable_add(bfield_units, 'gauss', 1.0e-4_auxr8)
    call ctable_add(bfield_units, 'kgauss', 1.0e-1_auxr8)
 
    call ctable_clear(current_units,'current')
    call ctable_add(current_units, 'a', 1.0_auxr8)
    call ctable_add(current_units, 'ka', 1.0e3_auxr8)
 
    call ctable_clear(psi_units,'pol_flux_stream_fcn')
    call ctable_add(psi_units, 'Wb/rad', 1.0_auxr8)
    call ctable_add(psi_units, 'v s / rad', 1.0_auxr8)
 
    call ctable_clear(fpol_units,'fpol')
    call ctable_add(fpol_units, 'mT', 1.0_auxr8)
    call ctable_add(fpol_units, 'Tm', 1.0_auxr8)
    call ctable_add(fpol_units, 'm*T', 1.0_auxr8)
    call ctable_add(fpol_units, 'T*m', 1.0_auxr8)
    call ctable_add(fpol_units, 'cm*gauss', 1.0e-6_auxr8)
 
    call ctable_clear(pressure_units,'Pressure')
    call ctable_add(pressure_units, 'Pa', 1.0_auxr8)
    call ctable_add(pressure_units, 'N/m^2', 1.0_auxr8)
 
    call ctable_clear(energy_units,'Energy')
    call ctable_add(pressure_units, 'J', 1.0_auxr8)
    call ctable_add(pressure_units, 'Jles', 1.0_auxr8)
 
    call ctable_clear(pprime_units,'PPrime')
    call ctable_add(pprime_units, 'Pa*rad/Wb', 1.0_auxr8)
    call ctable_add(pprime_units, 'Pa/Wb/rad', 1.0_auxr8)
    call ctable_add(pprime_units, '(N/m^2)/(V s / rad)', 1.0_auxr8)
    call ctable_add(pprime_units, '(N/m^2)/(Wb/rad)', 1.0_auxr8)
 
    call ctable_clear(ffprime_units,'ffprime')
    call ctable_add(ffprime_units, '(mT)^2*rad/Wb', 1.0_auxr8)
    call ctable_add(ffprime_units, '(Tm)^2*rad/Wb', 1.0_auxr8)
    call ctable_add(ffprime_units, '(mT)^2/(Wb/rad)', 1.0_auxr8)
    call ctable_add(ffprime_units, '(Tm)^2/(Wb/rad)', 1.0_auxr8)
    call ctable_add(ffprime_units, '(Tm)^2/(V s / rad)', 1.0_auxr8)
    call ctable_add(ffprime_units, 'Rad/m', 1.0_auxr8)
 
    call ctable_clear(no_units,'no_units')
    call ctable_add(no_units, ' ', 1.0_auxr8)
    call ctable_add(no_units, '-', 1.0_auxr8)
 
    ctable_init_flag = .TRUE.

  end subroutine ctable_init
 
!----------------------------------------------
 
  subroutine ctable_clear(ct,lbl)
 
    implicit NONE
 
    ! clear a conversion table
 
    type(ctable), intent(out) :: ct
    character*(*), intent(in) :: lbl
 
    ct%id = lbl
    ct%n = 0
    ct%units_string = ' '
    ct%conversion_factor = 0.0_auxr8
 
  end subroutine ctable_clear
 
!----------------------------------------------
 
  subroutine ctable_add(ct, string, factor)
 
    implicit NONE
 
    !
    ! add an entry (string, conversion factor) to a units conversion table
    !
 
    type(ctable), intent(inout) :: ct    ! conversion table object
    character*(*), intent(in) :: string  ! new units label
    real(auxr8), intent(in) :: factor    ! conversion factor
 
    integer i,j
    character*32 cbuf
 
    if( ct%n .ge. ctable_max ) then
       write(lunmsg,*) ' warning on conversion table for "',ct%id,'".'
       write(lunmsg,*) '%geqdsk_aux:  table full, cannot add string: ', &
            & string,' factor: ',factor
       write(lunmsg,*) ' ctable_max = ',ctable_max, &
            & ' -> increase ctable_max parameter in geqdsk_aux module.'
 
    else if(ct%n.lt.0) then
       write(lunmsg,*) ' warning on conversion table for "',ct%id,'".'
       write(lunmsg,*) '?geqdsk_aux:  program error, call ctable_clear first!'
 
    else
 
       ! strip out white space; convert to uppercase
 
       j=0
       cbuf=' '
       do i=1,len_trim(string)
          if((string(i:i).ne.' ').and.(string(i:i).ne.char(0)).and. &
               & string(i:i).ne.char(9)) then
             j=j+1
             cbuf(j:j)=string(i:i)
          endif
       enddo
       call uupper(cbuf)
 
       ct%n = ct%n + 1
       ct%units_string(ct%n) = cbuf
       ct%conversion_factor(ct%n) = factor
 
    endif
 
  end subroutine ctable_add
 
!----------------------------------------------
 
  subroutine ctable_check(ct, string, factor)
 
    !
    ! check a units string against contents of conversion table;
    ! output corresponding conversion factor
    ! ...if no match found, output warning and assume factor=1.0
    !
    ! caution:  side effect:  string is converted to uppercase
    !
 
    implicit NONE
 
    type(ctable), intent(in) :: ct       ! conversion table object
    character*(*), intent(inout) :: string  ! units label to be tested
    real(auxr8), intent(out) :: factor   ! conversion factor
 
    integer imatch
 
    if((ct%n.le.0).or.(ct%n.gt.ctable_max)) then
       write(lunmsg,*) ' warning on conversion table for "',ct%id,'".'
       write(lunmsg,*) '?geqdsk_aux:  program error, call ctable_init first.'
       write(lunmsg,*) ' conversion factor = 1.0 assumed.'
       factor = 1.0_auxr8
 
    else
 
       call ctable_match(ct, string, imatch)
 
       if(imatch.gt.0) then
          factor = ct%conversion_factor(imatch)
 
       else
          write(lunmsg,*) '%geqdsk_aux:  no match for units label:  "', &
               & string,'"'
          write(lunmsg,*) ' warning from conversion table for "',ct%id,'".'
          write(lunmsg,*) ' conversion factor = 1.0 assumed.'
          factor = 1.0_auxr8
       endif
 
    endif
 
  end subroutine ctable_check
 
!----------------------------------------------
 
  subroutine ctable_match(ct, string, imatch)
 
    !
    ! check a units string against contents of conversion table;
    ! output index to matching table entry
    ! or imatch=0 if there is no match
    ! or imatch=-1 if there is an error
    !
    ! caution:  side effect:  string is converted to uppercase
    !
    ! this routine writes no warning messages
    !
 
    implicit NONE
 
    type(ctable), intent(in) :: ct       ! conversion table object
    character*(*), intent(inout) :: string  ! units label to be tested
    integer, intent(out) :: imatch
 
    integer i,j
    character*32 cbuf
 
    imatch=-1
    if(ct%n.le.0) return
    if(ct%n.gt.ctable_max) return
 
    imatch=0
 
    j=0
    cbuf=' '
    do i=1,len_trim(string)
       if((string(i:i).ne.' ').and.(string(i:i).ne.char(0)).and. &
            & string(i:i).ne.char(9)) then
          j=j+1
          cbuf(j:j)=string(i:i)
       endif
    enddo
    call uupper(cbuf)
 
    do i=1,ct%n
       if(cbuf.eq.ct%units_string(i)) then
          imatch=i
          exit
       endif
    enddo
 
  end subroutine ctable_match
 
end module geqdsk_aux

subroutine eq_arc_fmidplane(ivec,iok,th,ansr,ivecd, &
     zinput,ninput,zoutput,noutput)

  ! subroutine for comput/zridderx root finder

  ! find midplane intercept; zinput contains midplane Z value

  use iso_c_binding, only: fp => c_double
  use eq_arc_scrunch_mod
  implicit NONE

  integer :: ivec
  logical :: iok(ivec)  ! mask
  real(fp) :: th(ivec)    ! theta
  real(fp) :: ansr(ivec)  ! Z(th)-Zmidplane

  integer :: ivecd
  integer :: ninput,noutput
  real(fp) :: zinput(ivecd,ninput)
  real(fp) :: zoutput(ivecd,noutput)  ! not used here

  !-----------------
  real(fp) :: Zmidplane
  integer, dimension(3) :: ict = (/ 1, 0, 0 /)
  integer :: idum,ier,jvec,ii

  real(fp) :: thbuf(ivec),abuf(ivec)
  !-----------------

  Zmidplane = zinput(1,1)

  jvec=0
  do ii=1,ivec
    if(.not.iok(ii)) then
      jvec=jvec+1
      thbuf(jvec)=th(ii)
    endif
  enddo

  call spvec(ict,jvec,thbuf,jvec,abuf,ntha,tha_pkg,Zspl,idum,ier)

  jvec=0
  do ii=1,ivec
    if(.not.iok(ii)) then
      jvec=jvec+1
      ansr(ii)=abuf(jvec)-Zmidplane
    endif
  enddo

  return
end subroutine eq_arc_fmidplane

subroutine geqxpl_rawplot(gfile)

  use geqdsk_mod
  implicit NONE

  !-------------------------------------------------------------------
  character*(*), intent(in) :: gfile  ! g-eqdsk filename or MDS+ path
  !-------------------------------------------------------------------

  !  Plot G-file data "raw" without processing.  This should help explain
  !  certain failures that can occur with EFIT data...

  integer :: iok,ipsi,npsi,ipass,nR,nZ,ising,inbmax

  integer :: luntty,lnout
  logical :: lchar,lxout

  type(geqdsk) :: geq

  real(geq_r8), dimension(:), allocatable :: psi_grid,Rgrid,Zgrid,zwk
  real(geq_r8), dimension(:,:), allocatable :: rbdc,zbdc

  real(geq_r8) :: zc(2)
  integer :: iself(2),nc(2)

  real(geq_r8) :: Rmin,Rmax,Zmin,Zmax,psimin,psimax,psimin0,psimax0,ztolpsi

  !----------------------------------
  character*75 mnlab(3)
  character*17 kylab(5)
  character*10 bdclab(2)

  character*48 :: efit_label
  !----------------------------------

  luntty = lnout(0)

  call geq_init(geq, gfile, iok)
  call geq_error(iok)
  if(iok/=0) return

  efit_label(1:8) = geq%CASE_(1)
  efit_label(9:16) = geq%CASE_(2)
  efit_label(17:24) = geq%CASE_(3)
  efit_label(25:32) = geq%CASE_(4)
  efit_label(33:40) = geq%CASE_(5)
  efit_label(41:48) = geq%CASE_(6)

  mnlab(1) = gfile
  mnlab(2) = 'EFIT_LABEL: '//efit_label
  mnlab(3) = 'geqxpl_rawplot.f90 "raw" EFIT data plot'

  kylab = ' '
  kylab(1) = ' G-file contours '

  bdclab(1) = 'boundary'
  bdclab(2) = 'limiter'

  iself(1)=1
  iself(2)=2

  zc(1) = 1.0d0
  zc(2) = 2.0d0

  ! G file read OK (but it might be rubbish...)

  nR = geq%nw
  nZ = geq%nh

  Rmin = geq%Rleft_m
  Rmax = Rmin + geq%Rdim_m

  Zmin = geq%Zmid_m - geq%Zdim_m/2
  Zmax = geq%Zmid_m + geq%Zdim_m/2

  npsi = geq%nw
  if(npsi.lt.2) then
     write(luntty,*) ' ?? geqxpl_rawplot: geq%nw < 2: ',geq%nw,'; must exit.'
     return
  endif

  allocate(psi_grid(npsi),Rgrid(nR),Zgrid(nZ),zwk(nZ)); zwk=0.0d0

  call mkgrid('Psi',psi_grid,geq%SIMAG_WB__Rad,geq%SIBRY_WB__Rad)
  call mkgrid('R',Rgrid,geq%Rleft_m,geq%Rleft_m + geq%Rdim_m)
  call mkgrid('Z',Zgrid,geq%Zmid_m-geq%Zdim_m/2,geq%Zmid_m+geq%Zdim_m/2)

  call psirz_minmax(nR,nZ, Rgrid, Zgrid, geq%psiRZ_Wb__Rad, &
       geq%NBBBS,geq%RBBBS_M,geq%ZBBBS_M, psimin,psimax, ising)

  inbmax = max(geq%NBBBS,geq%LIMITR)

  allocate(rbdc(inbmax,2),zbdc(inbmax,2))
  rbdc = 0.0
  zbdc = 0.0

  nc(1)=geq%NBBBS
  nc(2)=geq%LIMITR

  rbdc(1:geq%NBBBS,1) = geq%RBBBS_M(1:geq%NBBBS)
  rbdc(1:geq%LIMITR,2) = geq%RLIM_M(1:geq%LIMITR)

  zbdc(1:geq%NBBBS,1) = geq%ZBBBS_M(1:geq%NBBBS)
  zbdc(1:geq%LIMITR,2) = geq%ZLIM_M(1:geq%LIMITR)

  ipass=0
  do
     ipass = ipass + 1

     if(ipass.eq.1) then
        write(luntty,*) ' EFIT path: ',trim(gfile)
        write(luntty,*) ' EFIT label: ',trim(efit_label)
        write(luntty,*) ' '
        write(luntty,*) ' EFIT G-file scalars values: '
        write(luntty,'(3x,2(1x,a,1pe11.4))') 'Rdim (m): ',geq%rdim_m, &
             'Zdim (m): ',geq%zdim_m
        write(luntty,'(3x,2(1x,a,1pe11.4))') 'Rleft (m): ',geq%rleft_m, &
             'Zmid (m): ',geq%zmid_m
        write(luntty,'(4x,a,1pe11.4)') 'vacuum R*BPhi (T*m): ', &
             geq%rcentr_m*geq%bcentr_t
        write(luntty,'(3x,2(1x,a,1pe11.4))') 'Raxis (m): ',geq%rmaxis_m, &
             'Zaxis (m):',geq%zmaxis_m
        write(luntty,'(4x,a,1pe11.4)') 'Toroidal Current (A): ', geq%current_a
        write(luntty,'(/3x,2(1x,a,1pe11.4)/)') &
             'Psi(0) (Wb/rad): ',geq%SIMAG_Wb__Rad, &
             'Psi(a) (Wb/rad): ',geq%SIBRY_Wb__Rad

        write(luntty,'(4x,a,1pe11.4)') ' min(Psi) w/in bdy: ',psimin
        write(luntty,'(4x,a,1pe11.4)') ' max(Psi) w/in bdy: ',psimax

        psimin0=min(geq%SIMAG_Wb__Rad,geq%SIBRY_Wb__Rad)
        psimax0=max(geq%SIMAG_Wb__Rad,geq%SIBRY_Wb__Rad)

        ztolpsi = (psimax0-psimin0)/20

        if((psimin.le.psimin0-ztolpsi).or.(psimax.ge.psimax0+ztolpsi)) then
           write(luntty,*) ' *** Boundary enclosed Psi(R,Z) range warning *** '
        endif

        if(ising.gt.1) then
           write(luntty,*) ' *** Singularity warning, #extrema.gt.1: ',ising
        endif

        write(luntty,*) ' '

     endif

     if(lxout(0)) then
        write(luntty,*) ' '
        write(luntty,*) ' Geqxpl_RAWplot options: '
        write(luntty,*) '  P -- plot Psi(R,Z) '
        write(luntty,*) '  B -- boundary & limiter plot '
        write(luntty,*) '  S -- print out scalar data '
        write(luntty,*) '  1 -- f(Psi) plot (R*B_phi) '
        write(luntty,*) '  2 -- P(psi) plot '
        write(luntty,*) '  3 -- f*fprime plot '
        write(luntty,*) '  4 -- Pprime plot '
        write(luntty,*) '  5 -- q(Psi) plot '
        write(luntty,*) '  Q -- quit '
     endif

     call uread('Geqxpl_RAWplot option select:$')

     if(lchar('S')) then
        ipass=0
 
     else if(lchar('Q')) then
        exit

     else if(lchar('B')) then

        call r8_grfmm1(rbdc,zbdc,inbmax,nc,2,zc,2,iself,2, &
             'm','m',mnlab,kylab,bdclab)

     else if(lchar('P')) then

        call r8_grf3f1(Rgrid, geq%psirz_Wb__Rad, Zgrid, zwk, nR, nZ, nR, &
             'R','EFIT Psi_poloidal','Z', &
             'm','Wb/rad','m', &
             gfile,efit_label,0)

     else if(lchar('1')) then

        call r8_grafx1(Psi_grid,geq%FPOL_TM,npsi, &
             'Wb/rad','T*m',' Fpol (R*B_phi) vs. Psi',mnlab(1),mnlab(2))

     else if(lchar('2')) then

        call r8_grafx1(Psi_grid,geq%PRES_Nt__M2,npsi, &
             'Wb/rad','Nt/m^2',' Pressure vs. Psi',mnlab(1),mnlab(2))

     else if(lchar('3')) then

        call r8_grafx1(Psi_grid,geq%FFPRIM_T2M2Rad__Wb,npsi, &
             'Wb/rad','(T*m)^2/(Wb/Rad)',' F*Fprime vs. Psi',mnlab(1),mnlab(2))

     else if(lchar('4')) then

        call r8_grafx1(Psi_grid,geq%pprime_NtRad__M2Wb,npsi, &
             'Wb/rad','Nt/m^2/(Wb/rad)',' Pprime vs. Psi',mnlab(1),mnlab(2))

     else if(lchar('5')) then

        call r8_grafx1(Psi_grid,geq%QPSI,npsi, &
             'Wb/rad',' ',' q profile vs. Psi',mnlab(1),mnlab(2))

     else
        call uermsg(' %geqxpl_rawplot: unrecognized option code.',' ',0)
     endif

     cycle

  enddo

  deallocate(psi_grid,Rgrid,Zgrid,zwk)
  deallocate(rbdc,zbdc)

CONTAINS
  subroutine mkgrid(lbl,grid,gmin,gmax)

    !  create equispaced grid

    character*(*), intent(in) :: lbl
    real*8, dimension(:), intent(out) :: grid
    real*8, intent(in) :: gmin,gmax

    integer :: ii,isize

    isize = size(grid)

    if(isize.lt.2) then
       grid=gmin
       write(luntty,*) ' ?geqxpl_rawplot(mkgrid) abnormal '//trim(lbl)// &
            ' grid size: ',isize
       return
    endif

    ! extrema must be different.
    !  gmin -> grid(1); gmax -> grid(isize)
    !   not checked if gmax < gmin

    if(gmin.eq.gmax) then
       write(luntty,*) ' %geqxpl_rawplot(mkgrid) zero range in '//trim(lbl)// &
            ' grid range: '
       write(luntty,*) '  min = max = ',gmin
       grid=gmin
       return
    endif

    grid(1)=gmin
    grid(isize)=gmax

    do ii=2,isize-1
       grid(ii) = ((isize-ii)*gmin + (ii-1)*gmax)/(isize-1)
    enddo

  end subroutine mkgrid

end subroutine geqxpl_rawplot

SUBROUTINE scrorderdes(rval,zval,xaxis,yaxis,ier)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, half, twopi
  use scrunch_inc1
  implicit none
  real(fp), intent(inout), dimension(*) :: rval
  real(fp), intent(inout), dimension(*) :: zval
  real(fp), intent(in) :: xaxis
  real(fp), intent(in) :: yaxis
  integer, intent(inout) :: ier
  real(fp) :: dy
  real(fp) :: dx
  real(fp) :: y
  real(fp) :: x
  real(fp) :: residue
  real(fp) :: save_z
  real(fp) :: save_r
  integer :: next
  integer :: j
  real(fp) :: shortest
  integer :: i1
  integer :: ip1
  integer :: i
  real(fp) :: old_dist
  real(fp) :: new_dist
  real(fp), dimension(ntheta) :: tempr
  real(fp), dimension(ntheta) :: tempz
  !**********************************************************************
  !       Program ORDER : orders points on a magnetic surface at a
  !       fixed toroidal plane and assigns right-handed circulation
  !       around flux surface. XAXIS, YAXIS:  Polar-type axis (must lie
  !       inside curve to check sign of rotation)
  !**********************************************************************
  old_dist = 1.e20_fp
  do i = 1,nthetax-1
    ip1 = i + 1
    i1 = i
    shortest = 1.e20_fp
15  continue
    do j = ip1,nthetax
      if(i1.gt.1)old_dist = (rval(i1-1)-rval(j))**2 &
           + (zval(i1-1)-zval(j))**2
      new_dist =(rval(i1)-rval(j))**2 + (zval(i1)-zval(j))**2
      if((new_dist.le.old_dist).and. &
           (new_dist.lt.shortest)) then
        next = j
        shortest = new_dist
      end if
    end do
    !**********************************************************************
    !       Swap nearest point (next) with current point (ip1)
    !**********************************************************************
    if(shortest.ge.1.e10_fp) then
      save_r = rval(i-1)
      rval(i-1) = rval(i)
      rval(i)= save_r
      save_z = zval(i-1)
      zval(i-1) = zval(i)
      zval(i)= save_z
      i1 = i1 - 1
      ip1 = ip1 - 1
      go to 15
    end if
    save_r = rval(ip1)
    rval(ip1) = rval(next)
    rval(next)= save_r
    save_z = zval(ip1)
    zval(ip1) = zval(next)
    zval(next)= save_z
  end do
  !**********************************************************************
  !       Check that xaxis,yaxis is inside surface and
  !       ascertain that the angle rotates counterclockwise
  !       using Cauchy's theorem in "complex"-plane
  !**********************************************************************
  residue = zero
  do i = 1,nthetax-1
    x = half*(rval(i)+rval(i+1)) - xaxis
    y = half*(zval(i)+zval(i+1)) - yaxis
    dx= rval(i+1) - rval(i)
    dy= zval(i+1) - zval(i)
    residue = residue + (x*dy - y*dx)/(x**2 + y**2 + 1.e-10_fp)
  end do
  x = half*(rval(1)+rval(nthetax)) - xaxis
  y = half*(zval(1)+zval(nthetax)) - yaxis
  dx= rval(1) - rval(nthetax)
  dy= zval(1) - zval(nthetax)
  residue = residue + (x*dy - y*dx)/(x**2 + y**2 + 1.e-10_fp)

  if( residue .lt.(-.9_fp*twopi))then
    do i = 2,nthetax
      j = nthetax - i + 2
      tempr(i) = rval(j)
      tempz(i) = zval(j)
    end do
    do i = 2,nthetax
      rval(i) = tempr(i)
      zval(i) = tempz(i)
    end do
  else if( abs(residue) .lt. (.9_fp*twopi) )then
    write(lunmsg,*)' The magnetic axis is not enclosed by boundary '
    ier=11
    return
  end if

  return
end SUBROUTINE scrorderdes

subroutine eqm_tbdy_grid(ilines,rl,zl,thl,icircs,rc,zc,rad, &
     inumRi,inumZi,id_R,id_Z,ierr)

  !  a)
  !  set up a TRANSP-style machine boundary specification.  This consists
  !  two lists:  a list of circles (R,Z) & radius, and a list of infinite
  !  lines (R,Z) and inclination angle, thl (degrees).

  !  ...see eqm_tbdy subroutine for details on the limiter definition

  !  b)
  !  set up a rectangular (R,Z) grid, evenly spaced and with the dimensioning
  !  given, which covers the plasma core and "scrapeoff layer" i.e. the space
  !  between the core plasma and the limiters.  The grid is "padded" with
  !  1.5 zones around each edge.  The eqm_rzgrid routine is used to actually
  !  set the grid.

  !  the padding serves two functions:  (1) provides some mapped space
  !  in all directions beyond the limiters, and (2) ameliorates possible
  !  boundary effects in Akima Hermite bicubic fitting over the (R,Z) grid.

  !  mod DMC Jan 2007 -- force Zmin = -Zmax
  !    some physics modules require this Z grid symmetry

  !----------------

  !  details of the circle and lines limiters:  see eqm_tbdy subroutine.
  !  the limiters define an excluded space -- regions behind limiters
  !  with respect to the plasma magnetic axis.  The plasma boundary must
  !  not intersect the excluded space.

  !-----------------------

  use xplasma_obj_instance
  use eq_module

  implicit NONE

  !  input:

  integer ilines                    ! # of line limiters (can be zero)
  real*8 rl(ilines),zl(ilines)      ! (R,Z) starting point of line(s)
  real*8 thl(ilines)                ! in DEGREES, line orientation

  integer icircs                    ! # of circle limiters (can be zero)
  real*8 rc(icircs),zc(icircs)      ! (R,Z) center of circle(s)
  real*8 rad(icircs)                ! radius of circle(s)

  integer inumRi                    ! size of R grid -- at least 32 pts
  integer inumZi                    ! size of Z grid -- at least 32 pts

  !  output:

  integer id_R                      ! R grid xplasma id code
  integer id_Z                      ! Z grid xplasma id code

  integer ierr                      ! completion code, 0=OK

  !-----------------------
  !  local...

  real*8, dimension(:), allocatable :: zRgrid,zZgrid ! evenly spaced R&Z grids

  real*8 zRmin,zRmax,zZmin,zZmax
  integer itype

  real*8 zRmid,zZmid,zRlim
  real*8 zdelR,zdelZ

  integer i,inumR,inumZ

  !-----------------------

  ierr=0
  inumR=inumRi
  inumZ=inumZi

  if(inumR.lt.32) then
     write(lunerr,*) ' ?eqm_tbdy_grid:  inumR=',inumR,' .lt. 32: fixed.'
     inumR=32
  endif
  if(inumZ.lt.32) then
     write(lunerr,*) ' ?eqm_tbdy_grid:  inumZ=',inumZ,' .lt. 32: fixed.'
     inumZ=32
  endif
  if(ierr.ne.0) return

  !  1.  set up limiters

  call eqm_tbdy(ilines,rl,zl,thl,icircs,rc,zc,rad,ierr)
  if(ierr.ne.0) return

  !  2.  fetch the limiter extrema

  call eq_bdlims(itype,zRmin,zRmax,zZmin,zZmax,ierr)

  ! force Z grid up-down symmetry
  zZmax = max(abs(zZmin),abs(zZmax))
  zZmin = -zZmax

  zRmid=chalf*(zRmin+zRmax)
  zZmid=chalf*(zZmin+zZmax)

  zdelR=(inumR-1)*chalf*(zRmax-zRmin)/(inumR-4)
  zdelZ=(inumZ-1)*chalf*(zZmax-zZmin)/(inumZ-4)
  
  !  3.  generate the R,Z grids

  zRmin=max((zRmin/2),zRmid-zdelR)
  zRmax=zRmid+zdelR

  zZmin=zZmid-zdelZ
  zZmax=zZmid+zdelZ

  !  3.  generate the R,Z grids

  allocate(zRgrid(inumR),zZgrid(inumZ))

  do i=1,inumR
     zRgrid(i)=(zRmin*(inumR-i)+zRmax*(i-1))/(inumR-1)
  enddo

  do i=1,inumZ
     zZgrid(i)=(zZmin*(inumZ-i)+zZmax*(i-1))/(inumZ-1)
  enddo

  call eqm_rzgrid(zRgrid,zZgrid,0,0,inumR,inumZ,ceps4,id_R,id_Z,ierr)

  deallocate(zRgrid,zZgrid)

end subroutine eqm_tbdy_grid

module xplasma2_calls
  interface eqi_qpsi_regen
     subroutine eqi_qpsi_regen(gval,inum,rs,zs,qval)
       implicit NONE
       real*8, intent(in) :: gval    ! "g", (R*B_phi), Tesla*m
       integer, intent(in) :: inum   ! #pts on surface
       real*8, intent(in) :: rs(inum),zs(inum)  ! closed flux surface contour
       !                     with rs(1)=rs(inum) and zs(1)=zs(inum)
       real*8, intent(out) :: qval   ! "q" value estimatedend subroutine eqi_qpsi_regen
     end subroutine eqi_qpsi_regen
  end interface eqi_qpsi_regen
  
  interface eqi_geq_findrzs
     subroutine eqi_geq_findrzs(ns,lmask,x,dif,idum,psi,idum2,rzvec,id2)
       implicit NONE
       integer, parameter :: r8=selected_real_kind(12,100)
       integer, intent(in) :: ns        ! no. of segments
       logical, intent(in) :: lmask(ns) ! mask segments where target psi was reached
       
       real(r8), intent(in) :: x(ns)    ! parameter, 0->(r0,z0), 1->(r/zseek*(:))
       
       real(r8), intent(out) :: dif(ns) ! psi difference at surfaces
       
       integer, intent(in) :: idum,idum2,id2
       real(r8), intent(in) :: psi(ns)  ! target psi values
       
       real(r8), intent(out) :: rzvec(ns,id2)  ! (R,Z) valuesend subroutine eqi_geq_findrzs
     end subroutine eqi_geq_findrzs
  end interface eqi_geq_findrzs
  
  interface eqi_geq_intrp
     subroutine eqi_geq_intrp(psi_geq, f_geq, ngeq, psi, ns, f, ier)
       implicit none
       integer, parameter :: r8=selected_real_kind(12,100)
       integer, intent(in) :: ngeq        ! no. of pts in G-EQDSK 1d profiles
       real(r8), intent(in) :: psi_geq(ngeq)  ! G-EQDSK psi grid (strict ascending)
       real(r8), intent(in) :: f_geq(ngeq)    ! G-EQDSK f(psi) profile
       
       integer, intent(in) :: ns          ! no. of psi-surfaces wanted
       real(r8), intent(in) :: psi(ns)    ! psi values at psi-surfaces
       
       real(r8), intent(out) :: f(ns)     ! profile values at psi-surfaces
       
       integer, intent(out) :: ier        ! completion code:  0 = OK
     end subroutine eqi_geq_intrp
  end interface eqi_geq_intrp
  interface eqi_find_curv
     subroutine eqi_find_curv(nsrch, lmask, psivec, result, id1, zinput, id2i, &
          zoutput, id2o)
       implicit NONE
       integer, parameter :: r8=selected_real_kind(12,100)
       integer, intent(in) :: nsrch   ! number of searches, must = 1
       logical, intent(in) :: lmask(nsrch) ! mask searches where soln is known
       
       real*8, intent(in) :: psivec(nsrch)    ! psi location to try next
       
       real*8, intent(out) :: result(nsrch)   ! curvature difference at surfaces
       
       integer, intent(in) :: id1,id2i,id2o   ! auxilliary array dimensions
       
       real*8, intent(in) :: zinput(id1,id2i) ! target curvature value here
       real*8, intent(out) :: zoutput(id1,id2o)  ! output: 0=OK, 1= arg error
     end subroutine eqi_find_curv
  end interface eqi_find_curv
  interface eqi_find_curvature
     subroutine eqi_find_curvature(ns,psi,xmin,psi_range,rzvec,curvature,mincurv)
       implicit NONE
       
       integer, intent(in) :: ns  ! number of rays; should be equal to nthad
       
       real*8, intent(in) :: psi  ! target psi value 
       
       real*8, intent(in) :: xmin ! minimum normalized distance from (r0,z0) at
       !  which to start search (in range [0:1]; could be 0; less than 1).
       !  0 corresponds to (r0,z0); 1 corresponds to r/zadapt.
       
       real*8, intent(in) :: psi_range  ! Psi(max)-Psi(min) in domain sought over
       real*8, intent(out) :: rzvec(ns,2)   ! (R,Z) values of psi surface found
       real*8, intent(out) :: curvature(ns) ! curvature along surface
       real*8, intent(out) :: mincurv       ! extrapolated minimum curvature
     end subroutine eqi_find_curvature
  end interface eqi_find_curvature
  interface eqi_contour
     subroutine eqi_contour(xp, yp, cbdy, errscale, cbdy_got, psiav, istat, ier)
       implicit none
       integer, parameter :: r8 = selected_real_kind(12,100)
       real(r8), intent(in) :: xp, yp ! starting point
       real(r8), intent(in) :: cbdy   ! min. curvature parameter
       real(r8), intent(in) :: errscale ! accuracy test scale
       real(r8), intent(out) :: cbdy_got ! min. curvature observed
       real(r8), intent(out) :: psiav ! avg Psi value along contour
       integer, intent(out) :: istat
       !                        =0 -- closed surface, curvature OK
       !                              (psiav,cbdy_got) computed
       !                        =1 -- closed surface, curvature too sharp
       !                              (psiav,cbdy_got) computed
       !                        =2 -- open surface or grad(Psi)=0 encountered
       !                              (psiav computed; cbdy_got=0)
       !                        =3 -- some other error
       !                              (psiav=0; cbdy_got=0)
       integer, intent(out) :: ier
     end subroutine eqi_contour
  end interface eqi_contour
  interface eqi_geq_psfind
     subroutine eqi_geq_psfind(psi_geq, q_geq, ngeq, xi, ns, fbdy, &
          & psi, phi, q, ier)
       implicit none
       integer, parameter :: r8=selected_real_kind(12,100)
       
       ! ------------------ arguments ---------------------------------
       
       integer, intent(in) :: ngeq        ! no. of pts in G-EQDSK 1d profiles
       real(r8), intent(in) :: psi_geq(ngeq)  ! G-EQDSK psi grid (strict ascending)
       real(r8), intent(in) :: q_geq(ngeq)    ! G-EQDSK q(psi)
       
       integer, intent(in) :: ns          ! no. of surfaces wanted
       real(r8), intent(in) :: xi(ns)     ! spacing of surfaces in sqrt(tor.flux)
       ! strict ascending, xi(1)=0, xi(ns)=1
       
       real(r8), intent(in) :: fbdy       ! back-off parameter for outermost surface
       
                                     ! on output psi(1)=0, psi(ns)=
       !   fbdy*(psi_geq(ngeq)-psi_geq(1))
       
       real(r8), intent(out) :: psi(ns)   ! the selected psi surfaces
       real(r8), intent(out) :: phi(ns)   ! the enclosed toroidal flux (Wb)
       !   satisfying xi(j)=sqrt(phi(j)/phi(ns))
       real(r8), intent(out) :: q(ns)     ! the q profile at {psi(1),...,psi(ns)}
       
       integer, intent(out) :: ier        ! completion code, 0=OK
       
       
     end subroutine eqi_geq_psfind
  end interface eqi_geq_psfind
end module xplasma2_calls

subroutine eqm_wr_geqdsk(filename,ier)
 
!
!  write a G-EQDSK file; data read earlier by eqm_fromgeqdsk
!
  use eqi_geq_mds_mod
  implicit NONE
 
  character*(*), intent(in) :: filename
  integer, intent(out) :: ier             ! completion code, 0=OK
 
!----------------
 
  ier = 0
  call geq_writ(geq, filename, ier)
 
  return
 
end subroutine eqm_wr_geqdsk

! (xplasma) eq_r4gen.csh generated code -- Mon Oct 31 13:18:50 EST 2005
 
      MODULE XPLASMA_CALLS
! ( eq_area )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_AREA
!
       INTERFACE EQ_AREA
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_AREA ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_AREA(
     > IVEC,ZRHO,IWANT,ZVAL,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IWANT
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZVAL(IVEC)
 
      end subroutine EQ_AREA
!
         END INTERFACE
! ( eq_bdfind )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQX_BDFIND
!
       INTERFACE EQX_BDFIND
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQX_BDFIND ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQX_BDFIND(
     > IVEC,XX,YY,ZZ,ZRHO_IN,ZCHI_OUT,ZPHI_OUT,ZDIST,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZRHO_IN
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZCHI_OUT(IVEC)
      REAL*8 ZPHI_OUT(IVEC)
      REAL*8 ZDIST(IVEC)
 
      end subroutine EQX_BDFIND
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_BDFIND
!
       INTERFACE EQ_BDFIND
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_BDFIND ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_BDFIND(
     > IVEC,ZR,ZZ,ZPHI,ZRHO_IN,ZCHI_OUT,ZPHI_OUT,ZDIST,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZRHO_IN
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZCHI_OUT(IVEC)
      REAL*8 ZPHI_OUT(IVEC)
      REAL*8 ZDIST(IVEC)
 
      end subroutine EQ_BDFIND
!
         END INTERFACE
! ( eq_bdlims )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_BDLIMS
!
       INTERFACE EQ_BDLIMS
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_BDLIMS ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_BDLIMS(
     > ITYPE,ZRMIN,ZRMAX,ZZMIN,ZZMAX,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER ITYPE
      REAL*8 ZRMIN
      REAL*8 ZRMAX
      REAL*8 ZZMIN
      REAL*8 ZZMAX
      INTEGER IERR
 
      end subroutine EQ_BDLIMS
!
         END INTERFACE
! ( eq_bffget )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_BFFGET
!
       INTERFACE EQ_BFFGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_BFFGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_BFFGET(
     > IVEC,ZRHO,ZCHI,ZPHI,IRZMODE,BVEC,NLIST,IFCNS,IVECD,FVALS,NREGION,
     > IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IRZMODE
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 BVEC(3,IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQ_BFFGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_BFFGRAD
!
       INTERFACE EQ_BFFGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_BFFGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_BFFGRAD(
     > IVEC,ZRHO,ZCHI,ZPHI,IRZMODE,BVEC,GBTENSR,NLIST,IFCNS,IVECD,FVALS,
     > FGRADS,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IRZMODE
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 BVEC(3,IVEC)
      REAL*8 GBTENSR(3,3,IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      REAL*8 FGRADS(3,IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQ_BFFGRAD
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQMAP_BFFGET
!
      INTERFACE EQMAP_BFFGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQMAP_BFFGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQMAP_BFFGET(
     > IVEC,ZRHO,ZCHI,ZPHI,ZR,ZZ,IRZMODE,BVEC,NLIST,IFCNS,IVECD,FVALS,
     > NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IRZMODE
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 BVEC(3,IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQMAP_BFFGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQMAP_BFFGRAD
!
      INTERFACE EQMAP_BFFGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQMAP_BFFGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQMAP_BFFGRAD(
     > IVEC,ZRHO,ZCHI,ZPHI,ZR,ZZ,IRZMODE,BVEC,GBTENSR,NLIST,IFCNS,IVECD,
     > FVALS,FGRADS,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IRZMODE
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 BVEC(3,IVEC)
      REAL*8 GBTENSR(3,3,IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      REAL*8 FGRADS(3,IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQMAP_BFFGRAD
!
      END INTERFACE
! ( eq_bget )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_BGET
!
      INTERFACE EQ_BGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_BGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_BGET(
     > IVEC,ZRHO,ZCHI,ZPHI,IRZMODE,BVEC,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IRZMODE
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 BVEC(3,IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQ_BGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_BGRAD
!
      INTERFACE EQ_BGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_BGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_BGRAD(
     > IVEC,ZRHO,ZCHI,ZPHI,IRZMODE,BVEC,GBTENSR,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IRZMODE
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 BVEC(3,IVEC)
      REAL*8 GBTENSR(3,3,IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQ_BGRAD
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQMAP_BGET
!
      INTERFACE EQMAP_BGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQMAP_BGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQMAP_BGET(
     > IVEC,ZRHO,ZCHI,ZPHI,ZR,ZZ,IRZMODE,BVEC,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IRZMODE
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 BVEC(3,IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQMAP_BGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQMAP_BGRAD
!
      INTERFACE EQMAP_BGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQMAP_BGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQMAP_BGRAD(
     > IVEC,ZRHO,ZCHI,ZPHI,ZR,ZZ,IRZMODE,BVEC,GBTENSR,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IRZMODE
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 BVEC(3,IVEC)
      REAL*8 GBTENSR(3,3,IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQMAP_BGRAD
!
      END INTERFACE
! ( eq_dfast )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQX_DFAST
!
      INTERFACE EQX_DFAST
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQX_DFAST ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQX_DFAST(
     > IVEC,XX,YY,ZZ,ZDIST,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZDIST(IVEC)
 
      end subroutine EQX_DFAST
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_DFAST
!
      INTERFACE EQ_DFAST
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_DFAST ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_DFAST(
     > IVEC,ZR,ZZ,ZPHI,ZDIST,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZDIST(IVEC)
 
      end subroutine EQ_DFAST
!
      END INTERFACE
! ( eq_ffget )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_FFGET
!
      INTERFACE EQ_FFGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_FFGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_FFGET(
     > IVEC,ZRHO,ZCHI,ZPHI,NLIST,IFCNS,IVECD,FVALS,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQ_FFGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_FFGRAD
!
      INTERFACE EQ_FFGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_FFGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_FFGRAD(
     > IVEC,ZRHO,ZCHI,ZPHI,IRZMODE,NLIST,IFCNS,IVECD,FVALS,FGRADS,
     > NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IRZMODE
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      REAL*8 FGRADS(3,IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQ_FFGRAD
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQMAP_FFGET
!
       INTERFACE EQMAP_FFGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQMAP_FFGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQMAP_FFGET(
     > IVEC,ZRHO,ZCHI,ZPHI,ZR,ZZ,NLIST,IFCNS,IVECD,FVALS,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQMAP_FFGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQMAP_FFGRAD
!
      INTERFACE EQMAP_FFGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQMAP_FFGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQMAP_FFGRAD(
     > IVEC,ZRHO,ZCHI,ZPHI,ZR,ZZ,IRZMODE,NLIST,IFCNS,IVECD,FVALS,FGRADS,
     > NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IRZMODE
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      REAL*8 FGRADS(3,IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQMAP_FFGRAD
!
      END INTERFACE
! ( eq_fget )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_FGET
!
      INTERFACE EQ_FGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_FGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_FGET(
     > IVEC,ZRHO,ZCHI,ZPHI,IFCN,FVAL,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IFCN
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 FVAL(IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQ_FGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_FGRAD
!
      INTERFACE EQ_FGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_FGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_FGRAD(
     > IVEC,ZRHO,ZCHI,ZPHI,IRZMODE,IFCN,FVAL,FGRAD,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IRZMODE
      INTEGER IFCN
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 FVAL(IVEC)
      REAL*8 FGRAD(3,IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQ_FGRAD
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQMAP_FGET
!
      INTERFACE EQMAP_FGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQMAP_FGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQMAP_FGET(
     > IVEC,ZRHO,ZCHI,ZPHI,ZR,ZZ,IFCN,FVAL,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IFCN
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 FVAL(IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQMAP_FGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQMAP_FGRAD
!
      INTERFACE EQMAP_FGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQMAP_FGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQMAP_FGRAD(
     > IVEC,ZRHO,ZCHI,ZPHI,ZR,ZZ,IRZMODE,IFCN,FVAL,FGRAD,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IRZMODE
      INTEGER IFCN
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 FVAL(IVEC)
      REAL*8 FGRAD(3,IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQMAP_FGRAD
!
      END INTERFACE
! ( eq_flxint_arr2d )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_FLXINT_ARR2D
!
       INTERFACE EQ_FLXINT_ARR2D
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_FLXINT_ARR2D ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_FLXINT_ARR2D(
     > IORDER,IRHOAX,ZDATA,ID1,ID2,IBCRHO0,IDZ0,ZBCRHO0,IBCRHO1,IDZ1,
     > ZBCRHO1,IWANT,RESULT,INUMCHI,INUMRHO,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IORDER
      INTEGER IRHOAX
      INTEGER ID1
      INTEGER ID2
      INTEGER IBCRHO0
      INTEGER IDZ0
      INTEGER IBCRHO1
      INTEGER IDZ1
      INTEGER IWANT
      INTEGER INUMCHI
      INTEGER INUMRHO
      INTEGER IERR
      REAL*8 ZDATA(ID1,ID2)
      REAL*8 ZBCRHO0(IDZ0)
      REAL*8 ZBCRHO1(IDZ1)
      REAL*8 RESULT(INUMCHI,INUMRHO)
 
      end subroutine EQ_FLXINT_ARR2D
!
      END INTERFACE
! ( eq_flxint )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_FLXINT
!
      INTERFACE EQ_FLXINT
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_FLXINT ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_FLXINT(
     > NAME,NOPTION,RESULT,INUMCHI,INUMRHO,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      CHARACTER*(*) NAME
      INTEGER NOPTION
      INTEGER INUMCHI
      INTEGER INUMRHO
      INTEGER IERR
      REAL*8 RESULT(INUMCHI,INUMRHO)
 
      end subroutine EQ_FLXINT
!
      END INTERFACE
! ( eq_flxint_init )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_FLXINT_INIT
!
      INTERFACE EQ_FLXINT_INIT
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_FLXINT_INIT ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_FLXINT_INIT(
     > IAUTO,INUM,ZRHO,ZRHOMIN,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IAUTO
      INTEGER INUM
      REAL*8 ZRHOMIN
      INTEGER IERR
      REAL*8 ZRHO(INUM)
 
      end subroutine EQ_FLXINT_INIT
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_FLXINT_CHINIT
!
      INTERFACE EQ_FLXINT_CHINIT
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_FLXINT_CHINIT ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_FLXINT_CHINIT(
     > IAUTO,INUMCHIS,ZCHI,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IAUTO
      INTEGER INUMCHIS
      INTEGER IERR
      REAL*8 ZCHI(INUMCHIS)
 
      end subroutine EQ_FLXINT_CHINIT
!
      END INTERFACE
! ( eq_frhochi )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_FRHOCHI
!
      INTERFACE EQ_FRHOCHI
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_FRHOCHI ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_FRHOCHI(
     > IVEC,ZRHO,ZCHI,NLIST,IFLIST,IVECD,ZANS,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      INTEGER IFLIST(NLIST)
      REAL*8 ZANS(IVECD,NLIST)
 
      end subroutine EQ_FRHOCHI
!
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  R4_EQ_FRHOCHI ... for meaning of arguments see the documentation
 
      SUBROUTINE    R4_EQ_FRHOCHI(
     > IVEC,R4_ZRHO,R4_ZCHI,NLIST,IFLIST,IVECD,R4_ZANS,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL R4_ZRHO(IVEC)
      REAL R4_ZCHI(IVEC)
      INTEGER IFLIST(NLIST)
      REAL R4_ZANS(IVECD,NLIST)
 
      end subroutine R4_EQ_FRHOCHI
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_GRHOCHI
!
      INTERFACE EQ_GRHOCHI
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_GRHOCHI ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_GRHOCHI(
     > IVEC,ZRHO,ZCHI,NLIST,IFLIST,IVECD,ZANS,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      INTEGER IFLIST(NLIST)
      REAL*8 ZANS(IVECD,2,NLIST)
 
      end subroutine EQ_GRHOCHI
!
      END INTERFACE
! ( eq_frz )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_FRZ
!
      INTERFACE EQ_FRZ
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_FRZ ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_FRZ(
     > IVEC,ZR,ZZ,NLIST,IFLIST,IVECD,ZANS,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      INTEGER IFLIST(NLIST)
      REAL*8 ZANS(IVECD,NLIST)
 
      end subroutine EQ_FRZ
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_GRZ
!
      INTERFACE EQ_GRZ
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_GRZ ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_GRZ(
     > IVEC,ZR,ZZ,NLIST,IFLIST,IVECD,ZANS,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      INTEGER IFLIST(NLIST)
      REAL*8 ZANS(IVECD,2,NLIST)
 
      end subroutine EQ_GRZ
!
      END INTERFACE
! ( eq_fxcep )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_FXCEP
!
      INTERFACE EQ_FXCEP
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_FXCEP ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_FXCEP(
     > INUM,ITYPE,IDINIT,RA,ZA,PHIA,DA,RB,ZB,PHIB,DB,TOL,RX,ZX,PHIX,
     > ISTAT,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER INUM
      INTEGER ITYPE
      INTEGER IDINIT
      REAL*8 TOL
      INTEGER IERR
      REAL*8 RA(INUM)
      REAL*8 ZA(INUM)
      REAL*8 PHIA(INUM)
      REAL*8 DA(INUM)
      REAL*8 RB(INUM)
      REAL*8 ZB(INUM)
      REAL*8 PHIB(INUM)
      REAL*8 DB(INUM)
      REAL*8 RX(INUM)
      REAL*8 ZX(INUM)
      REAL*8 PHIX(INUM)
      INTEGER ISTAT(INUM)
 
      end subroutine EQ_FXCEP
!
      END INTERFACE
! ( eq_ganum )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_GANUM
!
      INTERFACE EQ_GANUM
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_GANUM ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_GANUM(
     > ZNAME,IANUM)
 
      IMPLICIT NONE
 
! argument declarations
      CHARACTER*(*) ZNAME
      INTEGER IANUM
 
      end subroutine EQ_GANUM
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_GET_ANAME
!
       INTERFACE EQ_GET_ANAME
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_GET_ANAME ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_GET_ANAME(
     > IANUM,ZNAME)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IANUM
      CHARACTER*(*) ZNAME
 
      end subroutine EQ_GET_ANAME
!
         END INTERFACE
! ( eq_gaxis )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_GAXIS
!
       INTERFACE EQ_GAXIS
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_GAXIS ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_GAXIS(
     > IVEC,PHI,B_AXIS,R_AXIS,Z_AXIS)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 PHI(IVEC)
      REAL*8 B_AXIS(IVEC)
      REAL*8 R_AXIS(IVEC)
      REAL*8 Z_AXIS(IVEC)
 
      end subroutine EQ_GAXIS
!
      END INTERFACE
! ( eq_geqdsk )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_GEQDSK
!
      INTERFACE EQ_GEQDSK
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_GEQDSK ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_GEQDSK(
     > LUN_GEQDSK,GEQDSK_LBL,RMIN,RMAX,ZMIN,ZMAX,ZCUR,ID_P,ID_Q,NH,NV,
     > NB,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER LUN_GEQDSK
      CHARACTER*48 GEQDSK_LBL
      REAL*8 RMIN
      REAL*8 RMAX
      REAL*8 ZMIN
      REAL*8 ZMAX
      REAL*8 ZCUR
      INTEGER ID_P
      INTEGER ID_Q
      INTEGER NH
      INTEGER NV
      INTEGER NB
      INTEGER IERR
 
      end subroutine EQ_GEQDSK
!
      END INTERFACE
! ( eq_getdetj )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_GETDETJ
!
      INTERFACE EQ_GETDETJ
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_GETDETJ ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_GETDETJ(
     > IVEC,ZRHO,ZCHI,ZPHI,ZSCALE,DETJ,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZSCALE
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 DETJ(IVEC)
 
      end subroutine EQ_GETDETJ
!
      END INTERFACE
! ( eq_getjac )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_GETJAC
!
      INTERFACE EQ_GETJAC
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_GETJAC ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_GETJAC(
     > IVEC,ZRHO,ZCHI,ZPHI,IRZMODE,JTENS,DETJ,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IRZMODE
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 JTENS(3,3,IVEC)
      REAL*8 DETJ(IVEC)
 
      end subroutine EQ_GETJAC
!
      END INTERFACE
! ( eq_gflist )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_GFLIST
!
      INTERFACE EQ_GFLIST
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_GFLIST ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_GFLIST(
     > NLIST,FNAMES,INAMES,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER NLIST
      INTEGER IERR
      CHARACTER*(*) FNAMES(NLIST)
      INTEGER INAMES(NLIST)
 
      end subroutine EQ_GFLIST
!
         END INTERFACE
! ( eq_gfnum )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_GFNUM
!
       INTERFACE EQ_GFNUM
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_GFNUM ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_GFNUM(
     > ZNAME,IFNUM)
 
      IMPLICIT NONE
 
! argument declarations
      CHARACTER*(*) ZNAME
      INTEGER IFNUM
 
      end subroutine EQ_GFNUM
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_GET_FNAME
!
       INTERFACE EQ_GET_FNAME
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_GET_FNAME ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_GET_FNAME(
     > IFNUM,ZNAME)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IFNUM
      CHARACTER*(*) ZNAME
 
      end subroutine EQ_GET_FNAME
!
         END INTERFACE
! ( eq_glimb1 )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_GLIMB1
!
       INTERFACE EQ_GLIMB1
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_GLIMB1 ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_GLIMB1(
     > RHO,PHI,B_MIN,CHI_B_MIN,B_MAX,CHI_B_MAX,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      REAL*8 RHO
      REAL*8 PHI
      REAL*8 B_MIN
      REAL*8 B_MAX
      INTEGER IERR
      REAL*8 CHI_B_MIN(1)
      REAL*8 CHI_B_MAX(1)
 
      end subroutine EQ_GLIMB1
!
      END INTERFACE
! ( eq_glimb )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_GLIMB
!
      INTERFACE EQ_GLIMB
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_GLIMB ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_GLIMB(
     > RHO,B_MIN,B_MAX,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      REAL*8 RHO
      REAL*8 B_MIN
      REAL*8 B_MAX
      INTEGER IERR
 
      end subroutine EQ_GLIMB
!
      END INTERFACE
! ( eq_glimrz )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_GLIMRZ
!
      INTERFACE EQ_GLIMRZ
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_GLIMRZ ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_GLIMRZ(
     > RHO,R_MIN,R_MAX,Z_MIN,Z_MAX,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      REAL*8 RHO
      REAL*8 R_MIN
      REAL*8 R_MAX
      REAL*8 Z_MIN
      REAL*8 Z_MAX
      INTEGER IERR
 
      end subroutine EQ_GLIMRZ
!
      END INTERFACE
! ( eq_grid )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_GRID
!
      INTERFACE EQ_GRID
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_GRID ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_GRID(
     > ID_AXIS,ZDATA,NMAX,NGOT,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER ID_AXIS
      INTEGER NMAX
      INTEGER NGOT
      INTEGER IERR
      REAL*8 ZDATA(NMAX)
 
      end subroutine EQ_GRID
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_GRID_ZC
!
      INTERFACE EQ_GRID_ZC
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_GRID_ZC ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_GRID_ZC(
     > ID_AXIS,ZDATA,NMAX,NGOT,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER ID_AXIS
      INTEGER NMAX
      INTEGER NGOT
      INTEGER IERR
      REAL*8 ZDATA(NMAX)
 
      end subroutine EQ_GRID_ZC
!
      END INTERFACE
! ( eq_hrhochi )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_HRHOCHI
!
      INTERFACE EQ_HRHOCHI
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_HRHOCHI ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_HRHOCHI(
     > IVEC,ZRHO,ZCHI,NLIST,IFLIST,ICTWANT,IVECD,ZANS,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      INTEGER IFLIST(NLIST)
      INTEGER ICTWANT(6)
      REAL*8 ZANS(IVECD,*)
 
      end subroutine EQ_HRHOCHI
!
      END INTERFACE
! ( eq_hrz )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_HRZ
!
      INTERFACE EQ_HRZ
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_HRZ ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_HRZ(
     > IVEC,ZR,ZZ,NLIST,IFLIST,ICTWANT,IVECD,ZANS,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      INTEGER IFLIST(NLIST)
      INTEGER ICTWANT(6)
      REAL*8 ZANS(IVECD,*)
 
      end subroutine EQ_HRZ
!
      END INTERFACE
! ( eq_inv )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQX_INV
!
      INTERFACE EQX_INV
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQX_INV ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQX_INV(
     > IVEC,XX,YY,ZZ,TOL,ZRHO,ZCHI,ZPHI,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 TOL
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQX_INV
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_INV
!
      INTERFACE EQ_INV
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_INV ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_INV(
     > IVEC,ZR,ZZ,ZPHI,TOL,ZRHO,ZCHI,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 TOL
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQ_INV
!
      END INTERFACE
! ( eq_limcon )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_LIMCON
!
      INTERFACE EQ_LIMCON
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_LIMCON ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_LIMCON(
     > IMAX,INUM,RLIM,ZLIM,DTOL,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IMAX
      INTEGER INUM
      REAL*8 DTOL
      INTEGER IERR
      REAL*8 RLIM(IMAX)
      REAL*8 ZLIM(IMAX)
 
      end subroutine EQ_LIMCON
!
      END INTERFACE
! ( eq_list )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_NLIST
!
      INTERFACE EQ_NLIST
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_NLIST ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_NLIST(
     > INUM_LISTS)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER INUM_LISTS
 
      end subroutine EQ_NLIST
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_NLIST_P
!
       INTERFACE EQ_NLIST_P
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_NLIST_P ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_NLIST_P(
     > INUM_LISTS)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER INUM_LISTS
 
      end subroutine EQ_NLIST_P
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_LISTS
!
       INTERFACE EQ_LISTS
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_LISTS ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_LISTS(
     > INUM_LISTS,LIST_NAMES,LIST_IDS,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER INUM_LISTS
      INTEGER IERR
      CHARACTER*(*) LIST_NAMES(INUM_LISTS)
      INTEGER LIST_IDS(INUM_LISTS)
 
      end subroutine EQ_LISTS
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_LISTS_P
!
       INTERFACE EQ_LISTS_P
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_LISTS_P ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_LISTS_P(
     > INUM_LISTS,LIST_NAMES,LIST_IDS,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER INUM_LISTS
      INTEGER IERR
      CHARACTER*(*) LIST_NAMES(INUM_LISTS)
      INTEGER LIST_IDS(INUM_LISTS)
 
      end subroutine EQ_LISTS_P
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_GLISTNUM
!
       INTERFACE EQ_GLISTNUM
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_GLISTNUM ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_GLISTNUM(
     > LIST_NAME,LIST_ID)
 
      IMPLICIT NONE
 
! argument declarations
      CHARACTER*(*) LIST_NAME
      INTEGER LIST_ID
 
      end subroutine EQ_GLISTNUM
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_LIST_SIZE
!
       INTERFACE EQ_LIST_SIZE
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_LIST_SIZE ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_LIST_SIZE(
     > ID,LIST_SIZE)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER ID
      INTEGER LIST_SIZE
 
      end subroutine EQ_LIST_SIZE
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_LIST_LABEL
!
       INTERFACE EQ_LIST_LABEL
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_LIST_LABEL ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_LIST_LABEL(
     > ID,ZLABEL)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER ID
      CHARACTER*(*) ZLABEL
 
      end subroutine EQ_LIST_LABEL
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_LIST_MAXSIZE
!
       INTERFACE EQ_LIST_MAXSIZE
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_LIST_MAXSIZE ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_LIST_MAXSIZE(
     > LIST_SIZE)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER LIST_SIZE
 
      end subroutine EQ_LIST_MAXSIZE
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_LIST_ENAMES
!
       INTERFACE EQ_LIST_ENAMES
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_LIST_ENAMES ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_LIST_ENAMES(
     > ID,LIST_SIZE,ENAMES,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER ID
      INTEGER LIST_SIZE
      INTEGER IERR
      CHARACTER*(*) ENAMES(LIST_SIZE)
 
      end subroutine EQ_LIST_ENAMES
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_LIST_CHVALS
!
       INTERFACE EQ_LIST_CHVALS
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_LIST_CHVALS ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_LIST_CHVALS(
     > ID,LIST_SIZE,CHVALS,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER ID
      INTEGER LIST_SIZE
      INTEGER IERR
      CHARACTER*(*) CHVALS(LIST_SIZE)
 
      end subroutine EQ_LIST_CHVALS
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_LIST_R8VALS
!
       INTERFACE EQ_LIST_R8VALS
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_LIST_R8VALS ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_LIST_R8VALS(
     > ID,LIST_SIZE,R8VALS,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER ID
      INTEGER LIST_SIZE
      INTEGER IERR
      REAL*8 R8VALS(LIST_SIZE)
 
      end subroutine EQ_LIST_R8VALS
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_LIST_R4VALS
!
       INTERFACE EQ_LIST_R4VALS
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_LIST_R4VALS ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_LIST_R4VALS(
     > ID,LIST_SIZE,R4VALS,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER ID
      INTEGER LIST_SIZE
      INTEGER IERR
      REAL*4 R4VALS(LIST_SIZE)
 
      end subroutine EQ_LIST_R4VALS
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_LIST_IVALS
!
       INTERFACE EQ_LIST_IVALS
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_LIST_IVALS ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_LIST_IVALS(
     > ID,LIST_SIZE,IVALS,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER ID
      INTEGER LIST_SIZE
      INTEGER IERR
      INTEGER IVALS(LIST_SIZE)
 
      end subroutine EQ_LIST_IVALS
!
         END INTERFACE
! ( eqm_bbin )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_BBIN
!
       INTERFACE EQM_BBIN
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_BBIN ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_BBIN(
     > ZBB,IAUTO,INUM,ZTOL,ID,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IAUTO
      INTEGER INUM
      REAL*8 ZTOL
      INTEGER ID
      INTEGER IERR
      REAL*8 ZBB(INUM)
 
      end subroutine EQM_BBIN
!
      END INTERFACE
! ( eqm_brz )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_BRZ
!
      INTERFACE EQM_BRZ
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_BRZ ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_BRZ(
     > USERBVEC,ZSM,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      EXTERNAL USERBVEC
      REAL*8 ZSM
      INTEGER IERR
 
      end subroutine EQM_BRZ
!
      END INTERFACE
! ( eqm_cbdy )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_CBDY
!
      INTERFACE EQM_CBDY
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_CBDY ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_CBDY(
     > IPTS,RLIM,ZLIM,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IPTS
      INTEGER IERR
      REAL*8 RLIM(IPTS)
      REAL*8 ZLIM(IPTS)
 
      end subroutine EQM_CBDY
!
      END INTERFACE
! ( eqm_cbdy_grid )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_CBDY_GRID
!
      INTERFACE EQM_CBDY_GRID
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_CBDY_GRID ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_CBDY_GRID(
     > IPTS,RLIM,ZLIM,INUMR,INUMZ,ID_R,ID_Z,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IPTS
      INTEGER INUMR
      INTEGER INUMZ
      INTEGER ID_R
      INTEGER ID_Z
      INTEGER IERR
      REAL*8 RLIM(IPTS)
      REAL*8 ZLIM(IPTS)
 
      end subroutine EQM_CBDY_GRID
!
      END INTERFACE
! ( eqm_chi )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_CHI
!
      INTERFACE EQM_CHI
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_CHI ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_CHI(
     > ZCHI,IAUTO,INUM,ZTOL,ID,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IAUTO
      INTEGER INUM
      REAL*8 ZTOL
      INTEGER ID
      INTEGER IERR
      REAL*8 ZCHI(INUM)
 
      end subroutine EQM_CHI
!
      END INTERFACE
! ( eqm_dbdy )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_DBDY
!
      INTERFACE EQM_DBDY
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_DBDY ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_DBDY(
     > ZDIST,ZRMINI,ZRMAXI,ZZMINI,ZZMAXI,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      REAL*8 ZDIST
      REAL*8 ZRMINI
      REAL*8 ZRMAXI
      REAL*8 ZZMINI
      REAL*8 ZZMAXI
      INTEGER IERR
 
      end subroutine EQM_DBDY
!
      END INTERFACE
! ( eqm_dbdy_grid )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_DBDY_GRID
!
      INTERFACE EQM_DBDY_GRID
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_DBDY_GRID ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_DBDY_GRID(
     > ZDIST,ZRMINI,ZRMAXI,ZZMINI,ZZMAXI,INUMR,INUMZ,ID_R,ID_Z,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      REAL*8 ZDIST
      REAL*8 ZRMINI
      REAL*8 ZRMAXI
      REAL*8 ZZMINI
      REAL*8 ZZMAXI
      INTEGER INUMR
      INTEGER INUMZ
      INTEGER ID_R
      INTEGER ID_Z
      INTEGER IERR
 
      end subroutine EQM_DBDY_GRID
!
      END INTERFACE
! ( eqm_f1d )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_F1D
!
      INTERFACE EQM_F1D
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_F1D ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_F1D(
     > IORDER,ID_AXIS,ZLBL,ZDATA,IBC1,ZBC1,IBC2,ZBC2,ID_F1D,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IORDER
      INTEGER ID_AXIS
      CHARACTER*(*) ZLBL
      INTEGER IBC1
      REAL*8 ZBC1
      INTEGER IBC2
      REAL*8 ZBC2
      INTEGER ID_F1D
      INTEGER IERR
      REAL*8 ZDATA(*)
 
      end subroutine EQM_F1D
!
      END INTERFACE
! ( eqm_frhochi )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_FRHOCHI
!
      INTERFACE EQM_FRHOCHI
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_FRHOCHI ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_FRHOCHI(
     > IORDER,ID_AX1,ID_AX2,ZLBL,ZDATA,ID1,IBCRHO0,ZBCRHO0,IBCRHO1,
     > ZBCRHO1,ID_FUN,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IORDER
      INTEGER ID_AX1
      INTEGER ID_AX2
      CHARACTER*(*) ZLBL
      INTEGER ID1
      INTEGER IBCRHO0
      INTEGER IBCRHO1
      INTEGER ID_FUN
      INTEGER IERR
      REAL*8 ZDATA(ID1,*)
      REAL*8 ZBCRHO0(*)
      REAL*8 ZBCRHO1(*)
 
      end subroutine EQM_FRHOCHI
!
      END INTERFACE

! ( eqm_irhofun )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_IRHOFUN
!
      INTERFACE EQM_IRHOFUN
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_IRHOFUN ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_IRHOFUN(
     > ID_AXIS,ZLBL,INPROF,ZPROF,IFLAG,ID,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER ID_AXIS
      CHARACTER*(*) ZLBL
      INTEGER INPROF
      INTEGER IFLAG
      INTEGER ID
      INTEGER IERR
      REAL*8 ZPROF(INPROF)
 
      end subroutine EQM_IRHOFUN
!
      END INTERFACE
! ( eqm_list )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_LIST_CREATE
!
      INTERFACE EQM_LIST_CREATE
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_LIST_CREATE ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_LIST_CREATE(
     > ZLIST_NAME,ZLIST_LABEL,INUM,ELEM_NAMES,ID,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      CHARACTER*(*) ZLIST_NAME
      CHARACTER*(*) ZLIST_LABEL
      INTEGER INUM
      CHARACTER*(*) ELEM_NAMES
      INTEGER ID
      INTEGER IERR
 
      end subroutine EQM_LIST_CREATE
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQM_LIST_CHVAL
!
       INTERFACE EQM_LIST_CHVAL
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_LIST_CHVAL ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_LIST_CHVAL(
     > IDENT,INUM,ZCHVALS,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IDENT
      INTEGER INUM
      CHARACTER*(*) ZCHVALS
      INTEGER IERR
 
      end subroutine EQM_LIST_CHVAL
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQM_LIST_IVAL
!
       INTERFACE EQM_LIST_IVAL
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_LIST_IVAL ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_LIST_IVAL(
     > IDENT,INUM,IVALS,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IDENT
      INTEGER INUM
      INTEGER IVALS
      INTEGER IERR
 
      end subroutine EQM_LIST_IVAL
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQM_LIST_R8VAL
!
       INTERFACE EQM_LIST_R8VAL
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_LIST_R8VAL ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_LIST_R8VAL(
     > IDENT,INUM,R8VALS,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IDENT
      INTEGER INUM
      REAL*8 R8VALS
      INTEGER IERR
 
      end subroutine EQM_LIST_R8VAL
!
         END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQM_LIST_R4VAL
!
       INTERFACE EQM_LIST_R4VAL
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_LIST_R4VAL ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_LIST_R4VAL(
     > IDENT,INUM,R4VALS,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IDENT
      INTEGER INUM
      REAL R4VALS
      INTEGER IERR
 
      end subroutine EQM_LIST_R4VAL
!
         END INTERFACE
! ( eqm_msgs )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_MSGS
!
       INTERFACE EQM_MSGS
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_MSGS ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_MSGS(
     > ILUN,ZFILE,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER ILUN
      CHARACTER*(*) ZFILE
      INTEGER IERR
 
      end subroutine EQM_MSGS
!
         END INTERFACE
! ( eqmom_getall )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQMOM_RCOS
!
       INTERFACE EQMOM_RCOS
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQMOM_RCOS ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQMOM_RCOS(
     > X,NX,INORM,IM,MOMARR,IWARN)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER NX
      INTEGER INORM
      INTEGER IM
      INTEGER IWARN
      REAL*8 X(NX)
      REAL*8 MOMARR(NX)
 
      end subroutine EQMOM_RCOS
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQMOM_RSIN
!
      INTERFACE EQMOM_RSIN
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQMOM_RSIN ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQMOM_RSIN(
     > X,NX,INORM,IM,MOMARR,IWARN)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER NX
      INTEGER INORM
      INTEGER IM
      INTEGER IWARN
      REAL*8 X(NX)
      REAL*8 MOMARR(NX)
 
      end subroutine EQMOM_RSIN
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQMOM_ZCOS
!
      INTERFACE EQMOM_ZCOS
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQMOM_ZCOS ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQMOM_ZCOS(
     > X,NX,INORM,IM,MOMARR,IWARN)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER NX
      INTEGER INORM
      INTEGER IM
      INTEGER IWARN
      REAL*8 X(NX)
      REAL*8 MOMARR(NX)
 
      end subroutine EQMOM_ZCOS
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQMOM_ZSIN
!
      INTERFACE EQMOM_ZSIN
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQMOM_ZSIN ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQMOM_ZSIN(
     > X,NX,INORM,IM,MOMARR,IWARN)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER NX
      INTEGER INORM
      INTEGER IM
      INTEGER IWARN
      REAL*8 X(NX)
      REAL*8 MOMARR(NX)
 
      end subroutine EQMOM_ZSIN
!
      END INTERFACE
! ( eqm_rho )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_RHO
!
      INTERFACE EQM_RHO
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_RHO ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_RHO(
     > ZRHO,IBDY,ZTOL,ID,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IBDY
      REAL*8 ZTOL
      INTEGER ID
      INTEGER IERR
      REAL*8 ZRHO(IBDY)
 
      end subroutine EQM_RHO
!
      END INTERFACE
! ( eqm_rhofun )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_RHOFUN
!
      INTERFACE EQM_RHOFUN
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_RHOFUN ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_RHOFUN(
     > IORDER,ID_AXIS,ZLBL,ZDATA,IBC1,ZBC1,IBC2,ZBC2,ID_RHOFUN,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IORDER
      INTEGER ID_AXIS
      CHARACTER*(*) ZLBL
      INTEGER IBC1
      REAL*8 ZBC1
      INTEGER IBC2
      REAL*8 ZBC2
      INTEGER ID_RHOFUN
      INTEGER IERR
      REAL*8 ZDATA(*)
 
      end subroutine EQM_RHOFUN
!
      END INTERFACE
! ( eqm_rzfun2 )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_RZFUN2
!
      INTERFACE EQM_RZFUN2
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_RZFUN2 ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_RZFUN2(
     > ZNAME,IFUN,USERFCN,IARG,IORDER,ZSM,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      CHARACTER*(*) ZNAME
      INTEGER IFUN
      REAL*8 USERFCN
      EXTERNAL USERFCN
      INTEGER IARG
      INTEGER IORDER
      REAL*8 ZSM
      INTEGER IERR
 
      end subroutine EQM_RZFUN2
      END INTERFACE
! ( eqm_rzfunda )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_RZFUNDA
!
      INTERFACE EQM_RZFUNDA
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_RZFUNDA ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_RZFUNDA(
     > ZNAME,IFUN,ZDATA,INR,INZ,IORDER,ZSM,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      CHARACTER*(*) ZNAME
      INTEGER IFUN
      INTEGER INR
      INTEGER INZ
      INTEGER IORDER
      REAL*8 ZSM
      INTEGER IERR
      REAL*8 ZDATA(INR,INZ)
 
      end subroutine EQM_RZFUNDA
!
      END INTERFACE
! ( eqm_rzfun )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_RZFUN
!
      INTERFACE EQM_RZFUN
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_RZFUN ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_RZFUN(
     > IFUN,LAMDA,IORDER,ZSM,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IFUN
      REAL*8 LAMDA
      INTEGER IORDER
      REAL*8 ZSM
      INTEGER IERR
 
      end subroutine EQM_RZFUN
!
      END INTERFACE
! ( eqm_rzfunf )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_RZFUNF
!
      INTERFACE EQM_RZFUNF
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_RZFUNF ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_RZFUNF(
     > IFUN,USERFCN,IARG,IORDER,ZSM,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IFUN
      REAL*8 USERFCN
      EXTERNAL USERFCN
      INTEGER IARG
      INTEGER IORDER
      REAL*8 ZSM
      INTEGER IERR
 
      end subroutine EQM_RZFUNF
!
      END INTERFACE
! ( eqm_rzgrid )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_RZGRID
!
      INTERFACE EQM_RZGRID
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_RZGRID ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_RZGRID(
     > ZR,ZZ,IAUTOR,IAUTOZ,INUMR,INUMZ,ZTOL,ID_R,ID_Z,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IAUTOR
      INTEGER IAUTOZ
      INTEGER INUMR
      INTEGER INUMZ
      REAL*8 ZTOL
      INTEGER ID_R
      INTEGER ID_Z
      INTEGER IERR
      REAL*8 ZR(INUMR)
      REAL*8 ZZ(INUMZ)
 
      end subroutine EQM_RZGRID
!
      END INTERFACE
! ( eqm_rzmagb )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_RZMAGB
!
      INTERFACE EQM_RZMAGB
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_RZMAGB ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_RZMAGB(
     > RARR,ZARR,ID1,ID2,IDRHO,IBCR0,ZBCR0,IBCR1,ZBCR1,IBCZ0,ZBCZ0,
     > IBCZ1,ZBCZ1,ID_R,ID_Z,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER ID1
      INTEGER ID2
      INTEGER IDRHO
      INTEGER IBCR0
      INTEGER IBCR1
      INTEGER IBCZ0
      INTEGER IBCZ1
      INTEGER ID_R
      INTEGER ID_Z
      INTEGER IERR
      REAL*8 RARR(ID1,ID2)
      REAL*8 ZARR(ID1,ID2)
      REAL*8 ZBCR0(*)
      REAL*8 ZBCR1(*)
      REAL*8 ZBCZ0(*)
      REAL*8 ZBCZ1(*)
 
      end subroutine EQM_RZMAGB
!
      END INTERFACE
! ( eqm_rzmag )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_RZMAG
!
      INTERFACE EQM_RZMAG
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_RZMAG ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_RZMAG(
     > RARR,ZARR,ID1,ID2,IDRHO,ID_R,ID_Z,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER ID1
      INTEGER ID2
      INTEGER IDRHO
      INTEGER ID_R
      INTEGER ID_Z
      INTEGER IERR
      REAL*8 RARR(ID1,ID2)
      REAL*8 ZARR(ID1,ID2)
 
      end subroutine EQM_RZMAG
!
      END INTERFACE
! ( eqm_select )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_SELECT
!
      INTERFACE EQM_SELECT
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_SELECT ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_SELECT(
     > MODEL,ILAXI)
 
      IMPLICIT NONE
 
! argument declarations
      CHARACTER*(*) MODEL
      INTEGER ILAXI
 
      end subroutine EQM_SELECT
!
      END INTERFACE
! ( eqm_tbdy )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_TBDY
!
       INTERFACE EQM_TBDY
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_TBDY ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_TBDY(
     > ILINES,RL,ZL,THL,ICIRCS,RC,ZC,RAD,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER ILINES
      INTEGER ICIRCS
      INTEGER IERR
      REAL*8 RL(ILINES)
      REAL*8 ZL(ILINES)
      REAL*8 THL(ILINES)
      REAL*8 RC(ICIRCS)
      REAL*8 ZC(ICIRCS)
      REAL*8 RAD(ICIRCS)
 
      end subroutine EQM_TBDY
!
      END INTERFACE
! ( eqm_tbdy_grid )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_TBDY_GRID
!
      INTERFACE EQM_TBDY_GRID
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_TBDY_GRID ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_TBDY_GRID(
     > ILINES,RL,ZL,THL,ICIRCS,RC,ZC,RAD,INUMR,INUMZ,ID_R,ID_Z,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER ILINES
      INTEGER ICIRCS
      INTEGER INUMR
      INTEGER INUMZ
      INTEGER ID_R
      INTEGER ID_Z
      INTEGER IERR
      REAL*8 RL(ILINES)
      REAL*8 ZL(ILINES)
      REAL*8 THL(ILINES)
      REAL*8 RC(ICIRCS)
      REAL*8 ZC(ICIRCS)
      REAL*8 RAD(ICIRCS)
 
      end subroutine EQM_TBDY_GRID
!
      END INTERFACE
! ( eqm_time )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_TIME
!
      INTERFACE EQM_TIME
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_TIME ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_TIME(
     > ZTIME)
 
      IMPLICIT NONE
 
! argument declarations
      REAL*8 ZTIME
 
      end subroutine EQM_TIME
!
      END INTERFACE
! ( eqm_uaxis )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQM_UAXIS
!
      INTERFACE EQM_UAXIS
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQM_UAXIS ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQM_UAXIS(
     > ANAME,IKIN,IPER,ZAXIS,INUM,ZTOL,ID,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      CHARACTER*(*) ANAME
      INTEGER IKIN
      INTEGER IPER
      INTEGER INUM
      REAL*8 ZTOL
      INTEGER ID
      INTEGER IERR
      REAL*8 ZAXIS(INUM)
 
      end subroutine EQM_UAXIS
!
      END INTERFACE
! ( eq_nindx )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_NINDX
!
       INTERFACE EQ_NINDX
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_NINDX ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_NINDX(
     > IAXIS,IVEC,ZVAL,KINDX,IWARN)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IAXIS
      INTEGER IVEC
      INTEGER IWARN
      REAL*8 ZVAL(IVEC)
      INTEGER KINDX(IVEC)
 
      end subroutine EQ_NINDX
!
      END INTERFACE
! ( eq_psmom )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_PSMOM
!
      INTERFACE EQ_PSMOM
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_PSMOM ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_PSMOM(
     > IVEC,RHO,RHOMIN,NMOM,PHI1,IDMOM,PSMOM,GAMMA,NGRDB2,B2,ZERROR,IER)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 RHOMIN
      INTEGER NMOM
      REAL*8 PHI1
      INTEGER IDMOM
      INTEGER IER
      REAL*8 RHO(IVEC)
      REAL*8 PSMOM(IDMOM,IVEC)
      REAL*8 GAMMA(IVEC)
      REAL*8 NGRDB2(IVEC)
      REAL*8 B2(IVEC)
      REAL*8 ZERROR(IVEC)
 
      end subroutine EQ_PSMOM
!
      END INTERFACE
! ( eq_rcyl )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_RCYL
!
      INTERFACE EQ_RCYL
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_RCYL ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_RCYL(
     > IVEC,XX,YY,ZR,ZPHI)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZR(IVEC)
      REAL*8 ZPHI(IVEC)
 
      end subroutine EQ_RCYL
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_RCYLCS
!
      INTERFACE EQ_RCYLCS
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_RCYLCS ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_RCYLCS(
     > IVEC,XX,YY,ZR,ZPHI,ZCOSPHI,ZSINPHI)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZR(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZCOSPHI(IVEC)
      REAL*8 ZSINPHI(IVEC)
 
      end subroutine EQ_RCYLCS
!
      END INTERFACE
! ( eq_restore )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_RESTORE
!
      INTERFACE EQ_RESTORE
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_RESTORE ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_RESTORE(
     > FILENAME,IER)
 
      IMPLICIT NONE
 
! argument declarations
      CHARACTER*(*) FILENAME
      INTEGER IER
 
      end subroutine EQ_RESTORE
!
         END INTERFACE
! ( eq_rget_binsm )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_RGET_BINSM
!
       INTERFACE EQ_RGET_BINSM
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_RGET_BINSM ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_RGET_BINSM(
     > INRHO,ZRHO,ID,ZDELTA,IINT,ZVAL,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER INRHO
      INTEGER ID
      REAL*8 ZDELTA
      INTEGER IINT
      INTEGER IERR
      REAL*8 ZRHO(INRHO)
      REAL*8 ZVAL(INRHO)
 
      end subroutine EQ_RGET_BINSM
!
      END INTERFACE
! ( eq_rgetf )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_RGETF
!
      INTERFACE EQ_RGETF
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_RGETF ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_RGETF(
     > IVEC,ZRHO,IFCN,IWANT,ZVAL,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IFCN
      INTEGER IWANT
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZVAL(IVEC)
 
      end subroutine EQ_RGETF
!
      END INTERFACE
! ( eq_rgetff )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_RGETFF
!
      INTERFACE EQ_RGETFF
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_RGETFF ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_RGETFF(
     > IVEC,ZRHO,NLIST,IFCNS,IWANT,IVECD,ZVALS,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER NLIST
      INTEGER IWANT
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 ZVALS(IVECD,NLIST)
 
      end subroutine EQ_RGETFF
!
      END INTERFACE
! ( eq_rget_sm )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_RGET_SM
!
      INTERFACE EQ_RGET_SM
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_RGET_SM ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_RGET_SM(
     > INRHO,ZRHO,ID,ZDELTA,ZVAL,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER INRHO
      INTEGER ID
      REAL*8 ZDELTA
      INTEGER IERR
      REAL*8 ZRHO(INRHO)
      REAL*8 ZVAL(INRHO)
 
      end subroutine EQ_RGET_SM
!
      END INTERFACE
! ( eq_rholim )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_RHOLIM
!
      INTERFACE EQ_RHOLIM
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_RHOLIM ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_RHOLIM(
     > ZRHO_AXIS,ZRHO_BDY)
 
      IMPLICIT NONE
 
! argument declarations
      REAL*8 ZRHO_AXIS
      REAL*8 ZRHO_BDY
 
      end subroutine EQ_RHOLIM
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_RHOXLIM
!
      INTERFACE EQ_RHOXLIM
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_RHOXLIM ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_RHOXLIM(
     > ZRHO_BDY,ZRHO_EXTEND)
 
      IMPLICIT NONE
 
! argument declarations
      REAL*8 ZRHO_BDY
      REAL*8 ZRHO_EXTEND
 
      end subroutine EQ_RHOXLIM
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_RHOLIMA
!
      INTERFACE EQ_RHOLIMA
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_RHOLIMA ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_RHOLIMA(
     > ZRHO_AXIS,ZRHO_EXTEND)
 
      IMPLICIT NONE
 
! argument declarations
      REAL*8 ZRHO_AXIS
      REAL*8 ZRHO_EXTEND
 
      end subroutine EQ_RHOLIMA
!
      END INTERFACE
! ( eqrz_bffget )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQRZ_BFFGET
!
      INTERFACE EQRZ_BFFGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQRZ_BFFGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQRZ_BFFGET(
     > IVEC,ZR,ZZ,ZPHI,ZTOL,BVEC,NLIST,IFCNS,IVECD,FVALS,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 BVEC(3,IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQRZ_BFFGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQRZ_BFFGRAD
!
      INTERFACE EQRZ_BFFGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQRZ_BFFGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQRZ_BFFGRAD(
     > IVEC,ZR,ZZ,ZPHI,ZTOL,BVEC,GBTENSR,NLIST,IFCNS,IVECD,FVALS,FGRADS,
     > NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 BVEC(3,IVEC)
      REAL*8 GBTENSR(3,3,IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      REAL*8 FGRADS(3,IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQRZ_BFFGRAD
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQRZMAP_BFFGET
!
      INTERFACE EQRZMAP_BFFGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQRZMAP_BFFGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQRZMAP_BFFGET(
     > IVEC,ZR,ZZ,ZPHI,ZRHO,ZCHI,ZTOL,BVEC,NLIST,IFCNS,IVECD,FVALS,
     > NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 BVEC(3,IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQRZMAP_BFFGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQRZMAP_BFFGRAD
!
      INTERFACE EQRZMAP_BFFGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQRZMAP_BFFGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQRZMAP_BFFGRAD(
     > IVEC,ZR,ZZ,ZPHI,ZRHO,ZCHI,ZTOL,BVEC,GBTENSR,NLIST,IFCNS,IVECD,
     > FVALS,FGRADS,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 BVEC(3,IVEC)
      REAL*8 GBTENSR(3,3,IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      REAL*8 FGRADS(3,IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQRZMAP_BFFGRAD
!
      END INTERFACE
! ( eqrz_bget )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQRZ_BGET
!
      INTERFACE EQRZ_BGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQRZ_BGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQRZ_BGET(
     > IVEC,ZR,ZZ,ZPHI,ZTOL,BVEC,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 BVEC(3,IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQRZ_BGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQRZ_BGRAD
!
      INTERFACE EQRZ_BGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQRZ_BGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQRZ_BGRAD(
     > IVEC,ZR,ZZ,ZPHI,ZTOL,BVEC,GBTENSR,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 BVEC(3,IVEC)
      REAL*8 GBTENSR(3,3,IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQRZ_BGRAD
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQRZMAP_BGET
!
      INTERFACE EQRZMAP_BGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQRZMAP_BGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQRZMAP_BGET(
     > IVEC,ZR,ZZ,ZPHI,ZRHO,ZCHI,ZTOL,BVEC,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 BVEC(3,IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQRZMAP_BGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQRZMAP_BGRAD
!
      INTERFACE EQRZMAP_BGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQRZMAP_BGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQRZMAP_BGRAD(
     > IVEC,ZR,ZZ,ZPHI,ZRHO,ZCHI,ZTOL,BVEC,GBTENSR,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 BVEC(3,IVEC)
      REAL*8 GBTENSR(3,3,IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQRZMAP_BGRAD
!
      END INTERFACE
! ( eq_rzdist )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQX_DIST
!
      INTERFACE EQX_DIST
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQX_DIST ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQX_DIST(
     > IVEC,XX,YY,ZZ,ZDIST,ILPT,RLIM,ZLIM,PHILIM,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER ILPT
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZDIST(IVEC)
      REAL*8 RLIM(IVEC)
      REAL*8 ZLIM(IVEC)
      REAL*8 PHILIM(IVEC)
 
      end subroutine EQX_DIST
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_RZDIST
!
      INTERFACE EQ_RZDIST
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_RZDIST ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_RZDIST(
     > IVEC,ZR,ZZ,ZPHI,ZDIST,ILPT,RLIM,ZLIM,PHILIM,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER ILPT
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZDIST(IVEC)
      REAL*8 RLIM(IVEC)
      REAL*8 ZLIM(IVEC)
      REAL*8 PHILIM(IVEC)
 
      end subroutine EQ_RZDIST
!
      END INTERFACE
! ( eqrz_ffget )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQRZ_FFGET
!
      INTERFACE EQRZ_FFGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQRZ_FFGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQRZ_FFGET(
     > IVEC,ZR,ZZ,ZPHI,ZTOL,NLIST,IFCNS,IVECD,FVALS,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQRZ_FFGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQRZ_FFGRAD
!
      INTERFACE EQRZ_FFGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQRZ_FFGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQRZ_FFGRAD(
     > IVEC,ZR,ZZ,ZPHI,ZTOL,NLIST,IFCNS,IVECD,FVALS,FGRADS,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      REAL*8 FGRADS(3,IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQRZ_FFGRAD
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQRZMAP_FFGET
!
      INTERFACE EQRZMAP_FFGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQRZMAP_FFGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQRZMAP_FFGET(
     > IVEC,ZR,ZZ,ZPHI,ZRHO,ZCHI,ZTOL,NLIST,IFCNS,IVECD,FVALS,NREGION,
     > IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQRZMAP_FFGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQRZMAP_FFGRAD
!
      INTERFACE EQRZMAP_FFGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQRZMAP_FFGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQRZMAP_FFGRAD(
     > IVEC,ZR,ZZ,ZPHI,ZRHO,ZCHI,ZTOL,NLIST,IFCNS,IVECD,FVALS,FGRADS,
     > NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      REAL*8 FGRADS(3,IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQRZMAP_FFGRAD
!
      END INTERFACE
! ( eqrz_fget )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQRZ_FGET
!
      INTERFACE EQRZ_FGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQRZ_FGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQRZ_FGET(
     > IVEC,ZR,ZZ,ZPHI,ZTOL,IFCN,FVAL,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER IFCN
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 FVAL(IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQRZ_FGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQRZ_FGRAD
!
      INTERFACE EQRZ_FGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQRZ_FGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQRZ_FGRAD(
     > IVEC,ZR,ZZ,ZPHI,ZTOL,IFCN,FVAL,FGRAD,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER IFCN
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 FVAL(IVEC)
      REAL*8 FGRAD(3,IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQRZ_FGRAD
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQRZMAP_FGET
!
      INTERFACE EQRZMAP_FGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQRZMAP_FGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQRZMAP_FGET(
     > IVEC,ZR,ZZ,ZPHI,ZRHO,ZCHI,ZTOL,IFCN,FVAL,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER IFCN
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 FVAL(IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQRZMAP_FGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQRZMAP_FGRAD
!
      INTERFACE EQRZMAP_FGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQRZMAP_FGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQRZMAP_FGRAD(
     > IVEC,ZR,ZZ,ZPHI,ZRHO,ZCHI,ZTOL,IFCN,FVAL,FGRAD,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER IFCN
      INTEGER IERR
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 FVAL(IVEC)
      REAL*8 FGRAD(3,IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQRZMAP_FGRAD
!
      END INTERFACE
! ( eq_rzlims )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_RZLIMS
!
      INTERFACE EQ_RZLIMS
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_RZLIMS ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_RZLIMS(
     > RMIN,RMAX,ZMIN,ZMAX,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      REAL*8 RMIN
      REAL*8 RMAX
      REAL*8 ZMIN
      REAL*8 ZMAX
      INTEGER IERR
 
      end subroutine EQ_RZLIMS
!
      END INTERFACE
! ( eq_save )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_SAVE
!
      INTERFACE EQ_SAVE
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_SAVE ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_SAVE(
     > FILENAME,IER)
 
      IMPLICIT NONE
 
! argument declarations
      CHARACTER*(*) FILENAME
      INTEGER IER
 
      end subroutine EQ_SAVE
!
         END INTERFACE
! ( eq_sgaxis )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_SGAXIS
!
       INTERFACE EQ_SGAXIS
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_SGAXIS ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_SGAXIS(
     > B_AXIS,R_AXIS,Z_AXIS)
 
      IMPLICIT NONE
 
! argument declarations
      REAL*8 B_AXIS
      REAL*8 R_AXIS
      REAL*8 Z_AXIS
 
      end subroutine EQ_SGAXIS
!
      END INTERFACE
! ( eq_surfgeo )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_SURFGEO
!
      INTERFACE EQ_SURFGEO
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_SURFGEO ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_SURFGEO(
     > IVEC,RHO,PHI,NTHETA,ELONG,TRIANG,INDENT,ZMIDP,RMNMIDP,RMJMIDP,
     > LIMITS,IER)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER NTHETA
      INTEGER IER
      REAL*8 RHO(IVEC)
      REAL*8 PHI(IVEC)
      REAL*8 ELONG(IVEC)
      REAL*8 TRIANG(IVEC)
      REAL*8 INDENT(IVEC)
      REAL*8 ZMIDP(IVEC)
      REAL*8 RMNMIDP(IVEC)
      REAL*8 RMJMIDP(IVEC)
      REAL*8 LIMITS(20,IVEC)
 
      end subroutine EQ_SURFGEO
!
      END INTERFACE
! ( eq_time )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_TIME
!
      INTERFACE EQ_TIME
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_TIME ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_TIME(
     > ZTIME)
 
      IMPLICIT NONE
 
! argument declarations
      REAL*8 ZTIME
 
      end subroutine EQ_TIME
!
      END INTERFACE
! ( eq_volume )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_VOLUME
!
      INTERFACE EQ_VOLUME
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_VOLUME ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_VOLUME(
     > IVEC,ZRHO,IWANT,ZVAL,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IWANT
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZVAL(IVEC)
 
      end subroutine EQ_VOLUME
!
      END INTERFACE
! ( eq_xcyl )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_XCYL
!
      INTERFACE EQ_XCYL
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_XCYL ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_XCYL(
     > IVEC,ZR,ZPHI,XX,YY)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZR(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
 
      end subroutine EQ_XCYL
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_XCYLCS
!
      INTERFACE EQ_XCYLCS
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_XCYLCS ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_XCYLCS(
     > IVEC,ZR,ZPHI,XX,YY,ZCOSPHI,ZSINPHI)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZR(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZCOSPHI(IVEC)
      REAL*8 ZSINPHI(IVEC)
 
      end subroutine EQ_XCYLCS
!
      END INTERFACE
! ( eq_xget )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQ_XGET
!
      INTERFACE EQ_XGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_XGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_XGET(
     > IVEC,ZRHO,ZCHI,ZPHI,XX,YY,ZZ,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQ_XGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQ_RZGET
!
      INTERFACE EQ_RZGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQ_RZGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQ_RZGET(
     > IVEC,ZRHO,ZCHI,ZPHI,ZR,ZZ,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      INTEGER IERR
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 ZR(IVEC)
      REAL*8 ZZ(IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQ_RZGET
!
      END INTERFACE
! ( eqxyz_bffget )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQXYZ_BFFGET
!
      INTERFACE EQXYZ_BFFGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQXYZ_BFFGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQXYZ_BFFGET(
     > IVEC,XX,YY,ZZ,ZTOL,BVEC,NLIST,IFCNS,IVECD,FVALS,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 BVEC(3,IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQXYZ_BFFGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQXYZ_BFFGRAD
!
      INTERFACE EQXYZ_BFFGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQXYZ_BFFGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQXYZ_BFFGRAD(
     > IVEC,XX,YY,ZZ,ZTOL,BVEC,GBTENSR,NLIST,IFCNS,IVECD,FVALS,FGRADS,
     > NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 BVEC(3,IVEC)
      REAL*8 GBTENSR(3,3,IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      REAL*8 FGRADS(3,IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQXYZ_BFFGRAD
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQXYZMAP_BFFGET
!
      INTERFACE EQXYZMAP_BFFGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQXYZMAP_BFFGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQXYZMAP_BFFGET(
     > IVEC,XX,YY,ZZ,ZRHO,ZCHI,ZPHI,ZTOL,BVEC,NLIST,IFCNS,IVECD,FVALS,
     > NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 BVEC(3,IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQXYZMAP_BFFGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQXYZMAP_BFFGRAD
!
      INTERFACE EQXYZMAP_BFFGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQXYZMAP_BFFGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQXYZMAP_BFFGRAD(
     > IVEC,XX,YY,ZZ,ZRHO,ZCHI,ZPHI,ZTOL,BVEC,GBTENSR,NLIST,IFCNS,IVECD,
     > FVALS,FGRADS,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 BVEC(3,IVEC)
      REAL*8 GBTENSR(3,3,IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      REAL*8 FGRADS(3,IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQXYZMAP_BFFGRAD
!
      END INTERFACE
! ( eqxyz_bget )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQXYZ_BGET
!
      INTERFACE EQXYZ_BGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQXYZ_BGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQXYZ_BGET(
     > IVEC,XX,YY,ZZ,ZTOL,BVEC,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 BVEC(3,IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQXYZ_BGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQXYZMAP_BGET
!
      INTERFACE EQXYZMAP_BGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQXYZMAP_BGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQXYZMAP_BGET(
     > IVEC,XX,YY,ZZ,ZRHO,ZCHI,ZPHI,ZTOL,BVEC,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 BVEC(3,IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQXYZMAP_BGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQXYZ_BGRAD
!
      INTERFACE EQXYZ_BGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQXYZ_BGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQXYZ_BGRAD(
     > IVEC,XX,YY,ZZ,ZTOL,BVEC,GBTENSR,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 BVEC(3,IVEC)
      REAL*8 GBTENSR(3,3,IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQXYZ_BGRAD
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQXYZMAP_BGRAD
!
      INTERFACE EQXYZMAP_BGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQXYZMAP_BGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQXYZMAP_BGRAD(
     > IVEC,XX,YY,ZZ,ZRHO,ZCHI,ZPHI,ZTOL,BVEC,GBTENSR,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 BVEC(3,IVEC)
      REAL*8 GBTENSR(3,3,IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQXYZMAP_BGRAD
!
      END INTERFACE
! ( eqxyz_ffget )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQXYZ_FFGET
!
      INTERFACE EQXYZ_FFGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQXYZ_FFGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQXYZ_FFGET(
     > IVEC,XX,YY,ZZ,ZTOL,NLIST,IFCNS,IVECD,FVALS,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQXYZ_FFGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQXYZ_FFGRAD
!
      INTERFACE EQXYZ_FFGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQXYZ_FFGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQXYZ_FFGRAD(
     > IVEC,XX,YY,ZZ,ZTOL,NLIST,IFCNS,IVECD,FVALS,FGRADS,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      REAL*8 FGRADS(3,IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQXYZ_FFGRAD
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQXYZMAP_FFGET
!
      INTERFACE EQXYZMAP_FFGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQXYZMAP_FFGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQXYZMAP_FFGET(
     > IVEC,XX,YY,ZZ,ZRHO,ZCHI,ZPHI,ZTOL,NLIST,IFCNS,IVECD,FVALS,
     > NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQXYZMAP_FFGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQXYZMAP_FFGRAD
!
      INTERFACE EQXYZMAP_FFGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQXYZMAP_FFGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQXYZMAP_FFGRAD(
     > IVEC,XX,YY,ZZ,ZRHO,ZCHI,ZPHI,ZTOL,NLIST,IFCNS,IVECD,FVALS,FGRADS,
     > NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER NLIST
      INTEGER IVECD
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      INTEGER IFCNS(NLIST)
      REAL*8 FVALS(IVECD,NLIST)
      REAL*8 FGRADS(3,IVECD,NLIST)
      INTEGER NREGION(IVEC)
 
      end subroutine EQXYZMAP_FFGRAD
!
      END INTERFACE
! ( eqxyz_fget )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQXYZ_FGET
!
      INTERFACE EQXYZ_FGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQXYZ_FGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQXYZ_FGET(
     > IVEC,XX,YY,ZZ,ZTOL,IFCN,FVAL,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER IFCN
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 FVAL(IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQXYZ_FGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQXYZ_FGRAD
!
      INTERFACE EQXYZ_FGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQXYZ_FGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQXYZ_FGRAD(
     > IVEC,XX,YY,ZZ,ZTOL,IFCN,FVAL,FGRAD,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER IFCN
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 FVAL(IVEC)
      REAL*8 FGRAD(3,IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQXYZ_FGRAD
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQXYZMAP_FGET
!
      INTERFACE EQXYZMAP_FGET
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQXYZMAP_FGET ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQXYZMAP_FGET(
     > IVEC,XX,YY,ZZ,ZRHO,ZCHI,ZPHI,ZTOL,IFCN,FVAL,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER IFCN
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 FVAL(IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQXYZMAP_FGET
!
      END INTERFACE
!==============================================================
!  iface -- generated interface body module:  EQXYZMAP_FGRAD
!
      INTERFACE EQXYZMAP_FGRAD
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQXYZMAP_FGRAD ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQXYZMAP_FGRAD(
     > IVEC,XX,YY,ZZ,ZRHO,ZCHI,ZPHI,ZTOL,IFCN,FVAL,FGRAD,NREGION,IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER IVEC
      REAL*8 ZTOL
      INTEGER IFCN
      INTEGER IERR
      REAL*8 XX(IVEC)
      REAL*8 YY(IVEC)
      REAL*8 ZZ(IVEC)
      REAL*8 ZRHO(IVEC)
      REAL*8 ZCHI(IVEC)
      REAL*8 ZPHI(IVEC)
      REAL*8 FVAL(IVEC)
      REAL*8 FGRAD(3,IVEC)
      INTEGER NREGION(IVEC)
 
      end subroutine EQXYZMAP_FGRAD
!
      END INTERFACE
! ( eqxyz_fxcep )
 ! block file generated by iface.for -- 31Oct2005
!==============================================================
!  iface -- generated interface body module:  EQXYZ_FXCEP
!
      INTERFACE EQXYZ_FXCEP
 
!----------------------------------------------------------
!  iface:  interface block generated segment for subroutine
!  EQXYZ_FXCEP ... for meaning of arguments see the documentation
 
      SUBROUTINE    EQXYZ_FXCEP(
     > INUM,ITYPE,IDINIT,XA,YA,ZA,DA,XB,YB,ZB,DB,TOL,XX,YX,ZX,ISTAT,
     > IERR)
 
      IMPLICIT NONE
 
! argument declarations
      INTEGER INUM
      INTEGER ITYPE
      INTEGER IDINIT
      REAL*8 TOL
      INTEGER IERR
      REAL*8 XA(INUM)
      REAL*8 YA(INUM)
      REAL*8 ZA(INUM)
      REAL*8 DA(INUM)
      REAL*8 XB(INUM)
      REAL*8 YB(INUM)
      REAL*8 ZB(INUM)
      REAL*8 DB(INUM)
      REAL*8 XX(INUM)
      REAL*8 YX(INUM)
      REAL*8 ZX(INUM)
      INTEGER ISTAT(INUM)
 
      end subroutine EQXYZ_FXCEP
!
      END INTERFACE
      END MODULE XPLASMA_CALLS

SUBROUTINE scramplituddes(rcenter,zcenter,angin,rmc,rms, &
     zmc,zms,xpts,xin,yin,ier)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: half, two
  use scrunch_inc1
  use scrunch_inc2
  implicit none
  integer :: ier
  integer :: m
  real(fp) :: yi
  real(fp) :: xi
  real(fp) :: arg
  integer :: j
  real(fp) :: xmult
  real(fp), intent(in) :: zcenter
  real(fp), intent(in) :: rcenter
  real(fp), intent(inout), dimension(*) :: rmc,rms,zmc,zms,xpts
  real(fp), intent(in), dimension(*) :: angin,xin,yin
  !*****************************************************************
  !       This subroutine assigns initial guesses for angles and
  !       Fourier mode amplitudes to the appropriate components of
  !       the xvec array ... use Fourier Analysis to project out
  !       each coefficient, below.
  !*****************************************************************
  rmc(1) = rcenter
  zmc(1) = zcenter
  xpts(1:ntheta) = angin(1:ntheta)
  xmult = two/DBLE(nthetax)
  do j = 1,nthetax
    arg = angin(j)
    xi = xmult*(xin(j) - rcenter)
    yi = xmult*(yin(j) - zcenter)
    do m = 2,mpolx
      rmc(m) = rmc(m) + cos((m-1)*arg)*xi
      if (lasym) rms(m) = rms(m) + sin((m-1)*arg)*xi
      if (lasym.and. .not.lzakharov) &
           zmc(m) = zmc(m) + cos((m-1)*arg)*yi
      if (.not.lzakharov.or. m.eq.2) zms(m) = zms(m) + &
           sin((m-1)*arg)*yi
    end do
  end do
  !
  !	INITIALIZE RMS = ZMC FOR M=1
  !
  rms(2) = half*(rms(2) + zmc(2))
  if (.not. lzakharov) zmc(2) = rms(2)

end SUBROUTINE scramplituddes

subroutine eqm_dbdy(zdist,zrmini,zrmaxi,zzmini,zzmaxi,ierr)

  !  f77 xplasma legacy interface.

  !  set up a limiter which is a combination of a box and
  !  a fixed distance set back from the plasma last closed flux surface

  !  The equilibrium must already be known to xplasma.

  !  A sanity box limiter is imposed -- one midplane half-width away from the
  !  R and Z min and max of the plasma equilibrium boundary.  The user
  !  supplied box limiter (zrmini, zrmaxi, zzmini, zzmaxi) is constrained
  !  by this.
  !-----------------------

  use xplasma_obj_instance
  use eq_module

  implicit NONE

  !  input:

  real*8 zdist                      ! setback distance of limiter
  real*8 zrmini,zrmaxi              ! R limits of enclosing box
  real*8 zzmini,zzmaxi              ! Z limits of enclosing box

  !  output:

  integer ierr                      ! completion code, 0=OK

  !-----------------------
  integer :: iwarn   ! ignored...
  real*8 zrmin,zrmax,zzmin,zzmax,zdelr,zdelz
  real*8 zrminu,zrmaxu,zzminu,zzmaxu
  !-----------------------

  call eq_glimrz(cone,zrmin,zrmax,zzmin,zzmax,ierr)
  if(ierr.ne.0) return

  !  4 line-type "sanity check" limiters:
  !  horizontal, vertical from expanded (zrmin,zzmin), &
  !  horizontal, vertical from expanded (zrmax,zzmax)

  zdelr=chalf*(zrmax-zrmin)
  zdelz=chalf*(zzmax-zzmin)

  zrmin=max(chalf*zrmin,zrmin-zdelr)
  zrmax=zrmax+zdelr

  zzmax=zzmax+min(zdelr,zdelz)
  zzmin=zzmin-min(zdelr,zdelz)

  !  The RZ box limiter used is the input limiter constrained by the
  !  sanity limiter.  This prevents the limiter from being drawn "too far"
  !  from the plasma.  It is still the caller's responsibility to make sure
  !  that the limiter does not cut into the plasma itself.

  zrminu=max(zrmin,min(zrmax,zrmini))
  zrmaxu=max(zrmin,min(zrmax,zrmaxi))

  zzminu=max(zzmin,min(zzmax,zzmini))
  zzmaxu=max(zzmin,min(zzmax,zzmaxi))

  call xplasma_mklim_special(s,iwarn,ierr, &
       dist = zdist, &
       Rmin = zRminu, Rmax = zRmaxu, Zmin = zZminu, Zmax = zZmaxu)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eqm_dbdy: xplasma_mklim_special error:'
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eqm_dbdy

subroutine eq_volume(ivec,zrho,iwant,zval,ierr)

  !  Volume(rho) interpolation routine -- with error checking
  !  units: m**3

  !  see also subroutine eq_area (very similar)

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  !  input:

  integer ivec                      ! vector dimension
  REAL*8 zrho(ivec)                 ! argument
  integer iwant                     ! 0:  value, 1: df/drho, 2: d2f/drho2

  !  output:

  REAL*8 zval(ivec)                 ! result of interpolation
  integer ierr                      ! =0: OK, =1: zrho out of range

  !--------------------------

  call xplasma_volume(s,zrho,zval,ierr, ideriv=iwant)
  if(ierr.ne.0) then

     write(lunerr,*) ' ?eq_volume: error detected:'
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_volume

subroutine eqm_clear

  ! delete contents of xplasma object "s"; free up memory

  use xplasma_obj_instance
  use eq_module

  integer :: ier

  if(.not.eq_module_init) then

     call xoi_init(ier)
     if(ier.ne.0) write(lunerr,*) &
          ' ?eqm_clear: xplasma_init returned ier = ',ier
     eq_module_init = .TRUE.

  else

     call xplasma_free(s,ier)

  endif

  eq_premsg_text = ' '

end subroutine eqm_clear

subroutine eqxyz_fxcep(inum,itype,idinit, &
     xa,ya,za,da,xb,yb,zb,db,tol, &
     xx,yx,zx,istat,ierr)

  !  Cartesian interface to eq_fxcep

  implicit NONE

  !  input:

  integer inum                      ! number of segments
  integer itype                     ! =1:  plasma bdy; =2:  limiter
  integer idinit                    ! =1:  da & db already initialized

  real*8 xa(inum),ya(inum),za(inum) ! end pts A of segments
  real*8 xb(inum),yb(inum),zb(inum) ! end pts B of segments

  !  input if idinit=1, output otherwise:

  real*8 da(inum)                   ! distance of A pts from bdy
  real*8 db(inum)                   ! distance of B pts from bdy

  !  input:

  real*8 tol                        ! relative accuracy tolerance

  !  approx. accuracy of intercept position:  tol*[system size]
  !  system size = 0.5*(Rmax-Rmin)

  !  output:

  real*8 xx(inum),yx(inum),zx(inum) ! the intercepts returned

  !  if (from da,db) a segment does not straddle the boundary,
  !                  for that segment rx,zx contains the nearer endpoint

  integer istat(inum)               ! segment status

  !  istat(j)=2 -- both endpoints outside bdy
  !  istat(j)=1 -- 1st endpoint outside, 2nd endpoint inside
  !  istat(j)=-1 -- 1st endpoint inside, 2nd endpoint outside
  !  istat(j)=-2 -- both endpoints inside bdy
  !    (rx(j),zx(j)) contains bdy intercept if abs(istat(j))=1.

  integer ierr                      ! completion code, 0=OK

  !  ierr only set in case of serious error

  real*8 ra(inum),phia(inum),rb(inum),phib(inum)
  real*8 rx(inum),phix(inum)

  !-----------------------------------------

  call eq_rcyl(inum,xa,ya,ra,phia)
  call eq_rcyl(inum,xb,yb,rb,phib)

  call eq_fxcep(inum,itype,idinit, &
       ra,za,phia,da,rb,zb,phib,db,tol, &
       rx,zx,phix,istat,ierr)

  call eq_xcyl(inum,rx,phix,xx,yx)

end subroutine eqxyz_fxcep

subroutine eqi_rzsmedZ(R,inumR,Z,inumZ,fdata,zsm)

  !  smooth in Z direction, in edge vicinity (see eqi_rzsmedg.for).

  use xplasma_definitions
  use eqi_rzbox_module

  implicit NONE

  integer inumR,inumZ
  real*8 R(inumR),Z(inumZ)
  real*8 fdata(inumR,inumZ)
  real*8 zsm

  !-----------------------------

  real*8 eps(inumZ),del(inumZ),f(inumZ),fsm(inumZ),zwkR(inumZ)
  real*8 dist(inumZ)

  real*8 zdista,zdum,zdum2

  integer iR,iZ,ict,idum1,idum2,iertmp

  real*8, parameter :: HALF = 0.5d0
  real*8, parameter :: C3OV2= 1.5d0
  real*8, parameter :: zbc = HALF

  !-----------------------------

  eps=1.0d30
  del=0.0d0

  do iR=1,inumR
     zwkR=R(iR)
     call xplasma_bdfind(sp,inumZ,ZwkR,Z,iertmp, &
          maptype=3,dist=dist)

     ict=0
     do iZ=1,inumZ
        zdista=abs(dist(iZ))
        if(zdista.le.HALF*zsm) then
           ict=ict+1
           del(iZ)=zsm
        else if(zdista.lt.C3OV2*zsm) then
           ict=ict+1
           del(iZ)=C3OV2*zsm-zdista
        endif
     enddo

     if(ict.gt.0) then

  !  something to smooth

        f=fdata(iR,1:inumZ)
        call r8filtr6(Z,f,fsm,inumZ,eps,inumZ,eps,0,del, &
             0,zdum,0,zdum,zbc,zbc,zdum2,idum1,idum2)
        fdata(iR,1:inumZ)=fsm

     endif
  enddo

end subroutine eqi_rzsmedZ

! 05may1999 fgtok -impno -s r8_precision.sub foo.sub "r8con.csh conversion"
C******************** START FILE INORD.FOR ; GROUP INORD ***************
C------------------------------------------------------------
C  INORD - INPUT A LIST OF NUMBERS - SORT IN ORDER
C
C  ******************************************************
C  *  INORD.FOR -- just input numbers from tty          *
C  *  INORDU.FOR -- input numbers from tty or Ufile     *
C  *    routines linked from different libraries        *
C  *    DMC 18 Sept 1992                                *
C  ******************************************************
C
      SUBROUTINE r8inord(X,WK,NDIM,NUM,LABEL,IDUPL)
C
      IMPLICIT NONE
C============
C idecl:  explicitize implicit INTEGER declarations:
      INTEGER ndim,lunt,lnout,num,ix,ier,idel,idp1,irdel,ir1,ir2,inum,i,
     > iold,idupl,ins
C============
C idecl:  explicitize implicit REAL declarations:
      REAL*8 xdel,r8dcod,dxdel,dx,xr1,xr2,xrtemp,xnew
C============
      CHARACTER*(*) LABEL
      REAL*8 X(NDIM),WK(NDIM)
C
C  X(NDIM) - LIST OF INPUT FLOATING PT NUMBERS (MAY BE MODIFIED)
C   NUM    - NUMBER OF ENTRIES IN LIST (MAY BE MODIFIED)
C  LABEL --- FOR USER PROMPT (INPUT) (JUST A FEW CHARS)
C  IDUPL --- =1 TO ALLOW DUPLICATE VALUES IN LIST (INPUT)
C
C
      LOGICAL LCHAR
      LOGICAL LXOUT
C
      LUNT=LNOUT(0)
 10   CONTINUE
      CALL NEUPAG
 11   CONTINUE
      IF(LXOUT(0)) THEN
        WRITE(LUNT,1001) LABEL
 1001 FORMAT(' INORD (ORDERED LIST "',A,'" INPUT) OPTIONS:'/
     >' type a NUMBER to add a value to the list, OR:'/
     >' C TO CLEAR LIST '/
     >' D <NUMBER> TO REMOVE <NUMBER> FROM LIST'/
     >' R <NUMBER1> <NUMBER2> TO REMOVE RANGE OF NUMBERS FROM LIST'/
     >' L TO TYPE OUT LIST CONTENTS   '/' Q TO QUIT')
        IF(NUM.EQ.0) THEN
          WRITE(LUNT,1002)
        ELSE IF(NUM.EQ.1) THEN
          WRITE(LUNT,1003) X(1)
        ELSE
          WRITE(LUNT,1004) NUM,X(1),X(NUM)
        ENDIF
 1002 FORMAT(' % CURRENTLY LIST IS EMPTY')
 1003 FORMAT(' % 1 ENTRY IN LIST:  ',1PD18.11)
 1004 FORMAT(' % ',I4,' ENTRIES IN LIST, RANGE:  ',
     >1PD18.11,' TO ',1PD18.11)
      ENDIF
C
      CALL UREAD(
     >'INORD:  ENTER NEW ITEM OR OPTION FOR LIST "'//LABEL//'":$')
      IF(LCHAR('Q')) THEN
        RETURN
      ELSE IF(LCHAR('C')) THEN
        NUM=0
        GO TO 11
      ELSE IF(LCHAR('L')) THEN
        IF(NUM.EQ.0) GO TO 10
        WRITE(LUNT,1010) (X(IX),IX=1,NUM)
 1010 FORMAT(4(2X,1PD18.11))
        CALL UPAUST(1)
        GO TO 11
      ELSE IF(LCHAR('D')) THEN
        IF(NUM.EQ.0) GO TO 10
        CALL UREAD('INORD:  SELECT VALUE (DELETE BY CLOSEST MATCH):$')
          IF(LCHAR('Q')) GO TO 10
          XDEL=r8dcod(IER)
          IF(IER.NE.0) GO TO 11
C  DETERMINE ENTRY SELECTED FOR DELETION
          IDEL=1
          IF(NUM.GT.1) THEN
            DXDEL=ABS(X(1)-XDEL)
            DO IX=2,NUM
              DX=ABS(X(IX)-XDEL)
              IF(DX.LT.DXDEL) THEN
                IDEL=IX
                DXDEL=DX
              ENDIF
            ENDDO
          ENDIF
C  DELETE SELECTED ENTRY
          IF(NUM.EQ.IDEL) THEN
            NUM=NUM-1
          ELSE
            IDP1=IDEL+1
            DO IX=IDP1,NUM
              X(IX-1)=X(IX)
            ENDDO
            NUM=NUM-1
          ENDIF
        GO TO 10
      ELSE IF(LCHAR('R')) THEN
        IF(NUM.EQ.0) GO TO 10
        CALL UREAD('INORD:  SELECT DELETE RANGE VALUE 1::$')
          IF(LCHAR('Q')) GO TO 10
          XR1=r8dcod(IER)
          IF(IER.NE.0) GO TO 11
        CALL UREAD('INORD:  SELECT DELETE RANGE VALUE 2::$')
          IF(LCHAR('Q')) GO TO 10
          XR2=r8dcod(IER)
          IF(IER.NE.0) GO TO 11
C  ASSURE XR1.LE.XR2
        IF(XR1.GT.XR2) THEN
          XRTEMP=XR1
          XR1=XR2
          XR2=XRTEMP
        ENDIF
C  FIND INDEX RANGE TO DELETE
        IRDEL=0
        DO IR1=1,NUM
          IF(XR1.LE.X(IR1)) GO TO 15
        ENDDO
        GO TO 19
 15     CONTINUE
        DO IR2=IR1,NUM
          IF(XR2.LT.X(IR2)) GO TO 18
        ENDDO
        IR2=NUM+1
 18     CONTINUE
        IR2=IR2-1
        IRDEL=IR2-IR1+1
 19     CONTINUE
        CALL NEUPAG
        WRITE(LUNT,1015) IRDEL
 1015   FORMAT(/' % ',I5,' LIST ENTRIES DELETED'/)
        IF(IRDEL.EQ.0) GO TO 11
C  DELETE THEM
        IF(IR2.LT.NUM) THEN
          INUM=NUM-IRDEL
          DO I=IR1,INUM
            IOLD=I+IRDEL
            X(I)=X(IOLD)
          ENDDO
        ENDIF
        NUM=NUM-IRDEL
        GO TO 10
      ELSE
C  NEW ENTRY?
        XNEW=r8dcod(IER)
        IF(IER.NE.0) GO TO 11
C  CHECK LIMIT
        IF(NUM.EQ.NDIM) THEN
          CALL UERMSI(' % LIST FULL, NUMBER OF ENTRIES',NDIM,-1)
          GO TO 11
        ENDIF
C  INSERT IN ORDER
        IF(NUM.EQ.0) THEN
          NUM=1
          X(NUM)=XNEW
        ELSE IF(XNEW.GT.X(NUM)) THEN
          NUM=NUM+1
          X(NUM)=XNEW
        ELSE
          DO IX=1,NUM
            IF(XNEW.LE.X(IX)) GO TO 20
          ENDDO
 20       CONTINUE
          IF((XNEW.EQ.X(IX)).AND.(IDUPL.NE.1)) THEN
            CALL UERMSF(' % DUPLICATE ENTRY',XNEW,-1)
            GO TO 11
          ENDIF
          INS=IX
          DO IX=NUM,INS,-1
            X(IX+1)=X(IX)
          ENDDO
          X(INS)=XNEW
          NUM=NUM+1
        ENDIF
        GO TO 10
      ENDIF
      END
C******************** END FILE INORD.FOR ; GROUP INORD *****************

subroutine eqx_bdfind(ivec,xx,yy,zz,zrho_in,zchi_out,zphi_out,zdist,ierr)

  !  accurately find the point on a boundary surface which is
  !  closest to a target point (x,y,z).

  !  input:

  IMPLICIT NONE

  integer ivec
  REAL*8 xx(abs(ivec)),yy(abs(ivec)),zz(abs(ivec)) ! cartesian target points
  REAL*8 zrho_in                    ! surface to be searched

  !  output:

  REAL*8 zchi_out(abs(ivec))             ! chi of nearest approach
  REAL*8 zphi_out(abs(ivec))             ! phi of nearest approach

  REAL*8 zdist(abs(ivec))                ! distance outside surface;

  integer ierr                      ! completion code, 0=OK

  !--------------------------
  real*8 zR(abs(ivec)),zphi(abs(ivec))
  !--------------------------

  call eq_rcyl(abs(ivec),xx,yy,zR,zphi)
  call eq_bdfind(ivec,zR,zZ,zphi,zrho_in,zchi_out,zphi_out,zdist,ierr)

end subroutine eqx_bdfind

!--------------------------------------------------------------------
subroutine eq_bdfind(ivec,zR,zZ,zphi,zrho_in, zchi_out,zphi_out,zdist,ierr)

  !  **vectorized** dmc Apr 2000

  !  accurately find the point on a boundary surface which is
  !  closest to a target point (zR,zZ,zphi)

  !  to begin the search, evaluate a coarse grid of points and look
  !  for the distance minima; use a root finder to zero in exactly
  !  (to machine precision).

  use xplasma_obj_instance
  use eq_module

  IMPLICIT NONE

  !  input:

  integer ivec                      ! vector length
  REAL*8 zR(abs(ivec)),zZ(abs(ivec)),zphi(abs(ivec)) ! target point
  REAL*8 zrho_in                    ! the (1) surface to be searched

  !  output:

  REAL*8 zchi_out(abs(ivec))             ! chi of nearest approach
  REAL*8 zphi_out(abs(ivec))             ! phi of nearest approach

  REAL*8 zdist(abs(ivec))                ! distance outside surface;

  integer ierr                      ! completion code, 0=OK

  !  if zdist.lt.0.0 then point is *inside* the surface;
  !  if zdist.eq.0.0 then the point is *on* the surface.
  !------------------------------------------------------------
  logical :: iccw
  !------------------------------------------------------------

  iccw = ivec.gt.0

  ierr = 9999

  call xplasma_bdfind(s,abs(ivec),zR,zZ,ierr, &
       phi_in=zphi,rho_in=zrho_in,ccw_theta=iccw,i2pi=2, &
       theta_out=zchi_out,phi_out=zphi_out,dist=zdist)

  if(ierr.ne.0) then
     write(lunerr,*) ' ?eq_rcyl: error in xplasma_bdfind:'
     call xplasma_error(s,ierr,lunerr)
  endif

end subroutine eq_bdfind

SUBROUTINE scrSINCOS(ZTHETA,JANG,SNTHTK,CSTHTK)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, one
  implicit none
  real(fp), intent(in) :: ztheta
  integer, intent(in) :: jang
  real(fp), dimension(jang), intent(out) :: csthtk
  real(fp), dimension(jang), intent(out) :: snthtk
  real(fp) :: zcosp
  real(fp) :: zsinp
  real(fp) :: zthetap
  integer :: i
 
  !
  !	THIS SUBROUTINE CALCULATES:
  !		SIN(ZTHETA)
  !		COS(ZTHETA)
  !		SIN(2*ZTHETA)
  !		COS(2*ZTHETA)
  !	ETC., UP TO JANG*ZTHETA
  !
  !
  !		ZTHETA IS INPUT ANGLE
  !		JANG IS HIGHEST N*ZTHETA TO CALCULATE
  !		SNTHTK IS THE ARRAY CONTAINING SIN(N*ZTHETA)
  !		CSTHTK IS THE ARRAY CONTAINING COS(N*ZTHETA)
  !
  !
  !  LOCAL MEMORY (DMC 6 JUL 1994)
  !
  DATA ZTHETAP/zero/
  DATA ZSINP/zero/
  DATA ZCOSP/one/
  !
  SAVE ZTHETAP,ZSINP,ZCOSP
  !
  !--------------------------------------------------------------------
  !
  !  DMC -- USE LOCAL MEMORY FOR SPEED
  !
  IF(ZTHETA.NE.ZTHETAP) THEN
    !
    !  EVALUATE SIN,COS
    !
    SNTHTK(1)=SIN(ZTHETA)
    CSTHTK(1)=COS(ZTHETA)
    ZTHETAP=ZTHETA
    ZSINP=SNTHTK(1)
    ZCOSP=CSTHTK(1)
  ELSE
    !
    !  REUSE PREVIOUS RESULTS
    !
    SNTHTK(1)=ZSINP
    CSTHTK(1)=ZCOSP
  ENDIF
  !
  DO I=2,JANG
    SNTHTK(I)=SNTHTK(I-1)*CSTHTK(1)+CSTHTK(I-1)*SNTHTK(1)
    CSTHTK(I)=CSTHTK(I-1)*CSTHTK(1)-SNTHTK(I-1)*SNTHTK(1)
  END DO
  !
  RETURN
END SUBROUTINE scrSINCOS

module xplasma_obj_instance

  ! declare an instance of an xplasma object; make this static, shared
  ! global instance publicly available.

  ! this declared instance is the one implicitly referred to by all legacy
  ! xplasma "f77" interface routines

  use xplasma_definitions
  use xplasma_obj_instance_mod

end module xplasma_obj_instance

subroutine eqm_chi(zchi,iauto,inum,ztol,id,ierr)

  use xplasma_obj_instance
  use eq_module

  !  set up chi grid -- must be strict ascending
  !  periodic grid, usually -pi to pi or 0 to 2pi.
  !  zchi(inum) = zchi(1) + 2pi.

  !  if iauto=1, the grid zchi(...) is generated here.

  !  ** THIS ROUTINE ASSUMES the poloidal angle coordinate chi is oriented
  !  so that chi=0 is near Rmax of a flux surface and dZ/dchi @chi=0 > 0, i.e.
  !  polar coordinate goes counter-clockwise around the flux surface for
  !  a plasma cross section drawn right of the machine centerline.  If this
  !  assumption is not desired, use eqm_chi_setccw instead!

  IMPLICIT NONE

  !  input:

  integer, intent(in) :: inum           ! #of grid bdy pts
  integer, intent(in) :: iauto          ! =1 to generate the chi grid -pi to pi
  REAL*8 zchi(inum)                     ! the grid (zone bdys, inum-1 zones).
  REAL*8, intent(in) :: ztol            ! even spacing tolerance

!  zchi is OUTPUT if iauto=1 is set: an evenly spaced grid spanning [-pi,pi]
!  output:

  integer id                        ! axis id code (returned)
  integer ierr                      ! =0: OK

  !--------------------------
  integer :: iccw
  !--------------------------

  iccw = 1

  call eqm_chi_setccw(iccw,zchi,iauto,inum,ztol,id,ierr)

end subroutine eqm_chi

subroutine eqm_chi_setccw(iccw,zchi,iauto,inum,ztol,id,ierr)

  use xplasma_obj_instance
  use eq_module

  !  set up chi grid -- must be strict ascending
  !  periodic grid, usually -pi to pi or 0 to 2pi.
  !  zchi(inum) = zchi(1) + 2pi.

  !  if iauto=1, the grid zchi(...) is generated here.

  !  ** ICCW=1 means ** the poloidal angle coordinate chi is oriented
  !  so that chi=0 is near Rmax of a flux surface and dZ/dchi @chi=0 > 0, i.e.
  !  polar coordinate goes counter-clockwise around the flux surface for
  !  a plasma cross section drawn right of the machine centerline.
  ! 
  !  ** ICCW<>1 the poloidal angle coordinate goes in reverse direction,
  !  clockwise around the flux surface.

  IMPLICIT NONE

  !  input:

  integer, intent(in) :: iccw           ! =1: CCW orientation of CHI

  integer, intent(in) :: inum           ! #of grid bdy pts
  integer, intent(in) :: iauto          ! =1 to generate the chi grid -pi to pi
  REAL*8 zchi(inum)                     ! the grid (zone bdys, inum-1 zones).
  REAL*8, intent(in) :: ztol            ! even spacing tolerance

!  zchi is OUTPUT if iauto=1 is set: an evenly spaced grid spanning [-pi,pi]
!  output:

  integer id                        ! axis id code (returned)
  integer ierr                      ! =0: OK

!-----------------

  real*8 zzchi(inum)
  integer i,inchi,iertmp
  logical :: lccw

!-------------------------------------------------------------

!  error checks:

  ierr=0
  id=0

  if(.not.eq_module_init) then
     write(lunerr,*) ' ?eqm_chi: initialization: call eqm_select first!'
     ierr=1
     return
  else 
     call xplasma_coord_info(s,xplasma_theta_coord,ierr, ngrids=inchi)
     if(ierr.ne.0) then
        call xplasma_error(s,ierr,lunerr)
     else if(inchi.gt.0) then
        write(lunerr,*) ' ?eqm_rho: rho already defined!'
        write(lunerr,*) '  re-initialization: call eqm_select first.'
        ierr=1
        return
     endif
  endif
  if(ierr.ne.0) return

  if(iauto.eq.1) then
     do i=1,inum
        zzchi(i)=-cpi + (i-1)*c2pi/(inum-1)
     enddo
     zchi=zzchi
  else

     if(abs((zchi(inum)-zchi(1))-c2pi).gt.ceps4) then
        call eq_errmsg(' ?eqm_chi: zchi(nchi)-zchi(1) .ne. 2*pi')
        write(lunerr,*) ' zchi(1)=',zchi(1),' zchi(nchi)=',zchi(inum)
        ierr=1
     else
        zzchi=zchi
        zzchi(inum)=zzchi(1)+c2pi
     endif
  endif

  lccw = (iccw.eq.1) 

  if(ierr.gt.0) return

  call eqi_evenx(zzchi,inum,ztol)

  call xoi_author_set(ierr)

  call xplasma_create_grid(s,'__CHI',xplasma_theta_coord,zzchi, &
       id,ierr, lccw)

  call xoi_author_clear(iertmp)

  return
end subroutine eqm_chi_setccw

subroutine eq_xid_mag(ifnum,id_rank,id_rho,id_chi,id_phi,iorder,ierr)

  !  return information on a function vs. mag. coordinates

  use xplasma_obj_instance
  use eq_module
  implicit NONE

  integer, intent(in) :: ifnum      ! function id

  integer, intent(out) :: id_rank   ! dimensionality of object
  integer, intent(out) :: id_rho    ! rho axis id (0 if none)
  integer, intent(out) :: id_chi    ! chi axis id (0 if none)
  integer, intent(out) :: id_phi    ! phi axis id (0 if none)
  integer, intent(out) :: iorder    ! object's fit order

  integer, intent(out) :: ierr      ! completion code, (0=OK)

  !---------------------------------------------
  integer :: iertmp
  !---------------------------------------------

  id_rho=0
  id_chi=0
  id_phi=0

  call xplasma_prof_info(s,ifnum,ierr, &
       rank=id_rank, splineType=iorder)
  if(ierr.ne.0) then
     id_rank=0
     iorder=-99
     write(lunerr,*) ' ?xplasma error detected in eq_xid_mag.f90:'
     call xplasma_error(s,ierr,lunerr)
     return
  endif

  call xplasma_prof_gridInfo(s,ifnum,xplasma_rho_coord,id_rho,iertmp)
  call xplasma_prof_gridInfo(s,ifnum,xplasma_theta_coord,id_chi,iertmp)
  call xplasma_prof_gridInfo(s,ifnum,xplasma_phi_coord,id_phi,iertmp)

end subroutine eq_xid_mag

subroutine eq_time(ztime)

  !  fetch the time (seconds)

  use xplasma_obj_instance
  use eq_module

  real*8, intent(out) :: ztime

  !-------------------
  integer :: ier
  !-------------------

  call xplasma_time_get(s,ztime,ier)
  if(ier.ne.0) then
     write(lunerr,*) ' %eq_time: failed to get xplasma time, ier=',ier
     call xplasma_error(s,ier,lunerr)
  endif

end subroutine eq_time

      SUBROUTINE MCRDR_OPENWR(LUN,NAME)
C
C  OPEN A FILE FOR *WRITE* ASCII SEQUENTIAL
C
      CHARACTER*(*) NAME
C
      CLOSE(UNIT=LUN,ERR=5)
 5    CONTINUE
C
      OPEN(UNIT=LUN,FILE=NAME,status='NEW',ACCESS='SEQUENTIAL')
C
      RETURN
      END

subroutine eqdbg_plot

  ! this was the old f77 plotting routine; now calls f90 module routine

  use xplasma_obj_instance
  use xplasma_debug_link

  implicit NONE

  call xplasma_debug_access(s)

end subroutine eqdbg_plot

subroutine rdtreq_hdr(lun,runid,time,tavg,pcur,tflux,ntheta,nsurf)
!
!  read ascii file containing MHD equilibrium data from TRANSP.
!  header information -- runid, scalars & no. of theta pts & surfaces.
!
  implicit NONE
!
  integer, intent(in) :: lun           ! lun of file open for reading
!
  character*(*) runid                  ! runid
!
  real, intent(out) :: time            ! data time
  real, intent(out) :: tavg            ! +/- averaging time
  real, intent(out) :: pcur            ! plasma current, Amps
  real, intent(out) :: tflux           ! enclosed toroidal flux, Webers
!
  integer, intent(out) :: ntheta       ! no. of theta grid points
  integer, intent(out) :: nsurf        ! no. of flux surfaces
!
!--------------------------------------------
!
  character(80) :: line
  integer i,i1,i2
!
!--------------------------------------------
! format stmts
!
1001 format(1x,a)
1002 format(1x,1pe13.6)
1003 format(1x,i6)
!
!--------------------------------------------
!
  do
     read(lun,1001) line
     if(line(1:12).eq.'TRANSP runid') then
 
        read(lun,1001) line
 
        ! use trailing non-blank word as runid label
 
        i2=len_trim(line)
        i1=1
        do i=i2,1,-1
           if(line(i:i).eq.' ') then
              i1=i+1
              exit
           endif
        enddo
 
        runid=line(i1:i2)
 
     else if(line(1:5).eq.'time:') then
        read(lun,1002) time
     else if(line(1:5).eq.'tavg:') then
        read(lun,1002) tavg
     else if(line(1:5).eq.'pcur:') then
        read(lun,1002) pcur
     else if(line(1:6).eq.'tflux:') then
        read(lun,1002) tflux
     else if(line(1:7).eq.'ntheta:') then
        read(lun,1003) ntheta
     else if(line(1:6).eq.'nsurf:') then
        read(lun,1003) nsurf
        exit
     else
        call errmsg_exit('?rdtreq_hdr:  unexpected line:  '//line)
     endif
  enddo
  return
end subroutine rdtreq_hdr
!============================================================================
subroutine rdtreq_data(lun,ntheta,nsurf,theta,rho,psi,pmhd,qmhd,gmhd,R,Z)
!
!  read ascii file containing MHD equilibrium data from TRANSP.
!  profile information -- dimensions from header
!
  implicit NONE
!
  integer, intent(in) :: lun           ! lun of file open for reading
  integer, intent(in) :: ntheta        ! theta dimension
  integer, intent(in) :: nsurf         ! flux surface dimension
!
  real, intent(out) :: theta(ntheta)   ! theta grid
  real, intent(out) :: rho(nsurf)      ! rho grid
  real, intent(out) :: psi(nsurf)      ! psi (Webers/rad)
  real, intent(out) :: pmhd(nsurf)     ! pressure (Pascals)
  real, intent(out) :: qmhd(nsurf)     ! q profile (dimensionless)
  real, intent(out) :: gmhd(nsurf)     ! g profile (R*B, m*Tesla)
!
  real, intent(out) :: R(ntheta,nsurf) ! R(theta,psi)
  real, intent(out) :: Z(ntheta,nsurf) ! Z(theta,psi)
!
!--------------------------------------------
!
  integer i,j
  character(80) :: line
!
!--------------------------------------------
! format stmts
!
1001 format(1x,a)
1004 format(5(1x,1pe13.6))
!
!--------------------------------------------
!
  do
     read(lun,1001) line
     if(line(1:6).eq.'theta:') then
        read(lun,1004) (theta(i),i=1,ntheta)
     else if(line(1:4).eq.'rho:') then
        read(lun,1004) (rho(i),i=1,nsurf)
     else if(line(1:4).eq.'psi:') then
        read(lun,1004) (psi(i),i=1,nsurf)
     else if(line(1:5).eq.'pmhd:') then
        read(lun,1004) (pmhd(i),i=1,nsurf)
     else if(line(1:5).eq.'qmhd:') then
        read(lun,1004) (qmhd(i),i=1,nsurf)
     else if(line(1:5).eq.'gmhd:') then
        read(lun,1004) (gmhd(i),i=1,nsurf)
     else if(line(1:2).eq.'R:') then
        read(lun,1004) ((R(i,j),i=1,ntheta),j=1,nsurf)
     else if(line(1:2).eq.'Z:') then
        read(lun,1004) ((Z(i,j),i=1,ntheta),j=1,nsurf)
        exit
     else
        call errmsg_exit('?rdtreq_data:  unexpected line:  '//line)
     endif
  enddo
  return
end subroutine rdtreq_data
 

      subroutine eq_errmsg(msg)
c
      use xplasma_obj_instance
      use eq_module
c
      IMPLICIT NONE
c
      character*(*) msg                 ! error message to write
c
c  write error message
c
      integer ilmsg,ier
      character*80 zmodel
c---------------------------------------------------------------------
c
      write(lunerr,*) ' '
      if(eq_premsg_text.ne.' ') then
         ilmsg=len_trim(eq_premsg_text)
         write(lunerr,*) eq_premsg_text(1:ilmsg)
      else
         call xplasma_global_info(s,ier, initLabel=zmodel)
         if(ier.ne.0) zmodel = '?? -- xplasma not initialized.'
         ilmsg=len_trim(zmodel)
         write(lunerr,*)
     >      ' (model:  ',zmodel(1:ilmsg),') eq_errmsg report:'
      endif
c
      ilmsg=max(1,len_trim(msg))
      write(lunerr,*) msg(1:ilmsg)
c
c  print any saved messages in the xplasma object
c
      call xplasma_error(s,9999,lunerr)
c
      return
      end

! 30Nov1999 fgtok -s r8_precision.sub r8bloat_names.sub "r8con.csh conversion"
C******************** START FILE FPOLAR.FOR ; GROUP TKBNDRY ******************
C.....................................................................
C  REV DMC -- REMOVED TRANSP COMMON
C   SO I CAN USE THIS IN RPLOT
C
C  REV BB / MAY 94 -- USE ATAN2 INSTEAD OF ATAN TO EVALUATE FPOLAR
C
C   output in range [0,twopi] instead of range [-pi,pi]
C   atan2 and fpolar are the same in the upper half plane; fpolar
C   is twopi greater in the lower half plane.
C
      REAL*8 FUNCTION r8fpolar ( ZR77, ZZ77 )
C
C	CALC. THE POLAR ANGLE DEFINED BY TAN(THETA)=ZZ77/ZR77
C
C============
C idecl:  explicitize implicit REAL declarations:
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      REAL*8 zz77,zr77,twopi,pi
C============
      DATA TWOPI/6.2831853071795862E0_R8/
      DATA PI/3.1415926535897931E0_R8/
C
C--------------------------------------------
C
      if (zz77 .ge. 0.0E0_R8) then
C
C  upper half plane  --  including z=0 line
C
       IF (ZR77 .NE. 0.E0_R8) THEN
C
          r8fpolar = ATAN2 ( ZZ77 , ZR77 )
C
       ELSE
C
C  on the vertical axis, at or above the z=0 line
C
        r8fpolar = PI*0.5E0_R8
C
       END IF
C
      else
C
C  lower half plane  --  excluding z=0 line
C
          r8fpolar = ATAN2 ( ZZ77 , ZR77 ) + TWOPI
C
      endif
C
      RETURN
      END
C******************** END FILE FPOLAR.FOR ; GROUP TKBNDRY ******************

subroutine eqmom_rcos(x,nx,inorm,im,momarr,iwarn)
 
  !  fetch im'th R cosine moment profile
  !  R(x,th) = R0(x)+sum[im=1 to kmom](Rc(im;x)*cos(i*th)+Rs(im;x)*sin(i*th))
  !  Z(x,th) = Z0(x)+sum[im=1 to kmom](Zc(im;x)*cos(i*th)+Zs(im;x)*sin(i*th))
  !
  !  for inorm=0 this routine returns (in momarr) Rc(im;x) or R0(x) if im=0.
  !  if im is out of range, momarr=0 and iwarn=1 are returned.
  !
  !  for inorm=1 return Rc(im;x)/x**im (a function which is extended smoothly
  !  to x=0).
 
  use xplasma_obj_instance
  use eq_module
  implicit NONE
 
  integer, intent(in) :: nx   ! no. of x values for which moment is desired.
  real*8, intent(in) :: x(nx) ! the x values
 
  integer, intent(in) :: inorm   ! =0: return moment; =1: return moment/x**im
  integer, intent(in) :: im      ! moment desired this call.
 
  real*8, intent(out) :: momarr(nx)  ! the moment coefficients returned.
  integer, intent(out) :: iwarn      ! 0=OK, -1 = im out of range.
                                     ! >0 means an some other error.
 
  !----------------------------------------
  integer :: ier,kmom
  !----------------------------------------
 
  call xmoments_kmom_get(kmom)

  iwarn=0
  if((im.lt.0).or.(im.gt.kmom)) then
     iwarn=-1
     momarr=0.0d0
  else
     call xpmom_get1(s,x,inorm,im,ier, rcmom=momarr)
     if(ier.ne.0) then
        write(lunerr,*) ' %eqmom_rcos: spline evaluation => ier=',ier
        call xplasma_error(s,ier,lunerr)
        iwarn=ier
     endif
  endif

end subroutine eqmom_rcos
 
subroutine eqmom_rsin(x,nx,inorm,im,momarr,iwarn)
 
  !  fetch im'th R sine moment profile
  !  R(x,th) = R0(x)+sum[im=1 to kmom](Rc(im;x)*cos(i*th)+Rs(im;x)*sin(i*th))
  !  Z(x,th) = Z0(x)+sum[im=1 to kmom](Zc(im;x)*cos(i*th)+Zs(im;x)*sin(i*th))
  !
  !  for inorm=0 this routine returns (in momarr) Rs(im;x)
  !  if im is out of range, momarr=0 and iwarn=1 are returned.
  !
  !  for inorm=1 return Rs(im;x)/x**im (a function which is extended smoothly
  !  to x=0).
 
  use xplasma_obj_instance
  use eq_module
  implicit NONE
 
  integer, intent(in) :: nx   ! no. of x values for which moment is desired.
  real*8, intent(in) :: x(nx) ! the x values
 
  integer, intent(in) :: inorm   ! =0: return moment; =1: return moment/x**im
  integer, intent(in) :: im      ! moment desired this call.
 
  real*8, intent(out) :: momarr(nx)  ! the moment coefficients returned.
  integer, intent(out) :: iwarn      ! 0=OK, -1 = im out of range.
                                     ! >0 means an some other error.
 
  !----------------------------------------
  integer :: ier,kmom
  !----------------------------------------
 
  call xmoments_kmom_get(kmom)

  iwarn=0
  if((im.lt.0).or.(im.gt.kmom)) then
     iwarn=-1
     momarr=0.0d0
  else
     call xpmom_get1(s,x,inorm,im,ier, rsmom=momarr)
     if(ier.ne.0) then
        write(lunerr,*) ' %eqmom_rsin: spline evaluation => ier=',ier
        call xplasma_error(s,ier,lunerr)
        iwarn=ier
     endif
  endif

end subroutine eqmom_rsin
 
subroutine eqmom_zcos(x,nx,inorm,im,momarr,iwarn)
 
  !  fetch im'th Z cosine moment profile
  !  R(x,th) = R0(x)+sum[im=1 to kmom](Rc(im;x)*cos(i*th)+Rs(im;x)*sin(i*th))
  !  Z(x,th) = Z0(x)+sum[im=1 to kmom](Zc(im;x)*cos(i*th)+Zs(im;x)*sin(i*th))
  !
  !  for inorm=0 this routine returns (in momarr) Zc(im;x) or Z0(x) if im=0.
  !  if im is out of range, momarr=0 and iwarn=1 are returned.
  !
  !  for inorm=1 return Zc(im;x)/x**im (a function which is extended smoothly
  !  to x=0).
 
  use xplasma_obj_instance
  use eq_module
  implicit NONE
 
  integer, intent(in) :: nx   ! no. of x values for which moment is desired.
  real*8, intent(in) :: x(nx) ! the x values
 
  integer, intent(in) :: inorm   ! =0: return moment; =1: return moment/x**im
  integer, intent(in) :: im      ! moment desired this call.
 
  real*8, intent(out) :: momarr(nx)  ! the moment coefficients returned.
  integer, intent(out) :: iwarn      ! 0=OK, -1 = im out of range.
                                     ! >0 means an some other error.
 
  !----------------------------------------
  integer :: ier,kmom
  !----------------------------------------
 
  call xmoments_kmom_get(kmom)

  iwarn=0
  if((im.lt.0).or.(im.gt.kmom)) then
     iwarn=-1
     momarr=0.0d0
  else
     call xpmom_get1(s,x,inorm,im,ier, zcmom=momarr)
     if(ier.ne.0) then
        write(lunerr,*) ' %eqmom_zcos: spline evaluation => ier=',ier
        call xplasma_error(s,ier,lunerr)
        iwarn=ier
     endif
  endif

end subroutine eqmom_zcos
 
subroutine eqmom_zsin(x,nx,inorm,im,momarr,iwarn)
 
  !  fetch im'th Z sine moment profile
  !  R(x,th) = R0(x)+sum[im=1 to kmom](Rc(im;x)*cos(i*th)+Rs(im;x)*sin(i*th))
  !  Z(x,th) = Z0(x)+sum[im=1 to kmom](Zc(im;x)*cos(i*th)+Zs(im;x)*sin(i*th))
  !
  !  for inorm=0 this routine returns (in momarr) Zs(im;x)
  !  if im is out of range, momarr=0 and iwarn=1 are returned.
  !
  !  for inorm=1 return Zs(im;x)/x**im (a function which is extended smoothly
  !  to x=0).
 
  use xplasma_obj_instance
  use eq_module
  implicit NONE
 
  integer, intent(in) :: nx   ! no. of x values for which moment is desired.
  real*8, intent(in) :: x(nx) ! the x values
 
  integer, intent(in) :: inorm   ! =0: return moment; =1: return moment/x**im
  integer, intent(in) :: im      ! moment desired this call.
 
  real*8, intent(out) :: momarr(nx)  ! the moment coefficients returned.
  integer, intent(out) :: iwarn      ! 0=OK, -1 = im out of range.
                                     ! >0 means an some other error.
 
  !----------------------------------------
  integer :: ier,kmom
  !----------------------------------------
 
  call xmoments_kmom_get(kmom)
 
  iwarn=0
  if((im.lt.0).or.(im.gt.kmom)) then
     iwarn=-1
     momarr=0.0d0
  else
     call xpmom_get1(s,x,inorm,im,ier, zsmom=momarr)
     if(ier.ne.0) then
        write(lunerr,*) ' %eqmom_zsin: spline evaluation => ier=',ier
        call xplasma_error(s,ier,lunerr)
        iwarn=ier
     endif
  endif

end subroutine eqmom_zsin
 

C******************** START FILE UFDCOD.FOR ; GROUP URDUTS ******************
C------------------------------------------------------------
C& UFDCOD  UREAD CHARACTER STRING TO FLOATING POINT DECODE
C
      REAL FUNCTION UFDCOD(STR,LENW,LENR,ICOD)
C
C  1ST THREE ARGUMENTS-- SEE URWORD
C   ICOD-- COMPLETION CODE
C    =0 NORMAL DECODE SUCCESSFUL
C    =-1 NULL WORD
C    =1 DECODE ERROR
C
      CHARACTER*(*) STR
C
C  DECODE BUFFER
C
      CHARACTER*20 ZDCOD,ZDCODL
      CHARACTER*1 ZCHAR,ZCHAR0
C
C  LIMITS OF WORD, PRESUMED INTEGER
C
      ILEN=LEN(STR)
C
      ZDCOD=' '
      ZDCODL=' '
C
      ZCHAR0=STR(1:1)
      IF((STR(1:1).EQ.'+').OR.(STR(1:1).EQ.'-')) STR(1:1)='z'
      CALL URWORD(STR,1,LENW,LENR)
C
C  CHECK IF FLOATING POINT WORD IS PROPERLY DELIMITTED; I.E. IF USER
C  HAS "+" OR "-" AS DELIMITER, WELL THIS MIGHT BE PART OF THE EXPONENT
C  HERE!
C
      IF(LENW.LT.ILEN) THEN
        ILW1=LENW+1
        IF((STR(ILW1:ILW1).EQ.'+').OR.(STR(ILW1:ILW1).EQ.'-')) THEN
          ZCHAR=STR(LENW:LENW)
          IF((ZCHAR.EQ.'D').OR.(ZCHAR.EQ.'E').OR.(ZCHAR.EQ.'d').OR.
     >         (ZCHAR.EQ.'e')) THEN
C  AN EXPONENT!
            ZCHAR=STR(ILW1:ILW1)
            STR(ILW1:ILW1)='x'  ! TEMPORARY PLACEHOLDER
            CALL URWORD(STR,1,LENW,LENR)  ! RECOMPUTE WORD LIMITS
            STR(ILW1:ILW1)=ZCHAR  ! RESTORE EXPONENT SIGN
          ENDIF
        ENDIF
      ENDIF
C
      STR(1:1)=ZCHAR0
C
      ILW=LENW
      IF(ILW.GT.0) CALL URWRDL(STR(1:ILW),ZDCODL,LENW)
C
      IF(LENW.EQ.0) THEN
        ICOD=-1
        UFDCOD=0.0
        RETURN
      ELSE IF(LENW.GT.20) THEN
        ICOD=1
        UFDCOD=0.0
        RETURN
      ENDIF
C
      ILW=20-LENW+1
      ZDCOD(ILW:20)=ZDCODL(1:LENW)
C  ATTEMPT DECODE
      READ(ZDCOD,1000,ERR=900) Z
 1000 FORMAT(G20.0)
C
C  SUCCESS
      UFDCOD=Z
      ICOD=0
      RETURN
C
 900  CONTINUE
C  ERROR
      ICOD=1
      UFDCOD=0.0
      RETURN
      END
C******************** END FILE UFDCOD.FOR ; GROUP URDUTS ******************

      subroutine eqm_select(model,ilaxi)
C
      use xplasma_obj_instance
      use xplasma_obj
      use eq_module
C
      IMPLICIT NONE
C
C  select an equilibrium model type
C
      character*(*) model       ! input label string
      integer ilaxi             ! input =1 if axisymmetric, o/w FALSE
      integer :: ier
C
C----------------------------------
C
      if(.not.eq_module_init) then
         call xoi_init(ier)
         if(ier.ne.0) write(lunerr,*)
     >        ' ?eqm_select: xplasma_init returned ier = ',ier
         eq_module_init = .TRUE.
      endif
C
      call xplasma_init(s,model,ier)
      if(ier.ne.0) write(lunerr,*)
     >     ' ?eqm_select: xplasma_init returned ier = ',ier
C
      if(ilaxi.eq.1) then
         continue               ! axisymmetry is supported
      else
         write(lunerr,*) 
     >        ' ?eqm_select: non-axisymmetric XPLASMA not implemented!'
      endif
C
      return
      end

!----------------------------------------------------------------------x
      subroutine dqng_fab(lunerr,label,func,aux,iarg,rho,
     >   a,b,epsabs,epsrel,noption,
     >   result,abserr,neval,ier)
!
!  interface to dqng_fth to allow non-adaptive evaluation of
!  the integral of f(x)*dx over [a,b].
!
!  func should support calls of the form
!      call func(neval,rhovec,xvec,phivec,aux, f, ierf)
!  with neval, rhovec(1:neval), xvec(1:neval), phivec(1:neval), aux
!  as input and f(1:neval) and ierf as output
!     rhovec(1:nvec)=rho, aux is as passed, phivec(1:neval)=0
!
!  (this involves extra complications in func but allows dqng_fth to be
!  reused)
!
      IMPLICIT NONE
!
      integer, intent(in) :: lunerr     ! unit for messages
      character*(*), intent(in) :: label ! integral id string for messages
      external func                     ! the integrand function
      real*8, intent(in) :: aux(*)      ! auxilliary data for integrand
      integer, intent(in) :: iarg       ! =1 -- integrate vs. theta, fixed
                                        ! rho (usual case)
      real*8, intent(in) :: rho         ! rho parameter for integrand
                                        !   if iarg=2: rho-> theta parameter
      real*8, intent(in) :: a,b         ! theta range of integration
                                        !   if iarg=2: a,b-> rho range of int.
      real*8, intent(in) :: epsabs,epsrel ! accuracy controls for noption=0
      integer, intent(in) :: noption    ! integration option (cf dqng_fth)
 
      real*8, intent(out) :: result     ! integration result
      real*8, intent(out) :: abserr     ! accuracy estimate ( noption=0 only )
      integer, intent(out) :: neval     ! no. of evaluations
      integer, intent(out) :: ier       ! completion code, 0=OK
 
!---------------------------------------------
 
      real*8, parameter :: const = 1.0d0
 
!---------------------------------------------
 
      call dqng_fth(lunerr,label,0,const,func,func,aux,iarg,rho,
     >   a,b,epsabs,epsrel,noption,
     >   result,abserr,neval,ier)
 
      return
      end
 
!----------------------------------------------------------------------x
      subroutine dqng_fth(lunerr,label,jacsign,const,fjac,func,aux,
     >   iarg,rho,a,b,epsabs,epsrel,noption,
     >   result,abserr,neval,ier)
!
!  dmc 11 Sept 2000 -- netlib:quadpack/dqng, adapted for fluxav
!    the integrand is const*jacsign*fjac*func, instead of "f"
!        const=twopi for jacsign=+/- 1 -- or other options
!        ...used in context of axisymmetric flux surface geometry
!        of a tokamak...
!
!  lunerr  -- open channel for messages
!  label   -- short label for integral (for error messages)
!  jacsign -- normal sign of det(Jacobian) (+/- 1)
!             integral is [a,b]dthe*const*jacsign*fjac*func
!                  (iarg=1 expected)
!
!             expect const=twopi; fjac=R*((1/grad(rho))*(dl/dtheta))
!                    --axisymmetric volume integral--
!
!    or set jacsign=0 for integral const*func*drho (iarg=2) or
!                                  const*func*dth (iarg=1) (no use of fjac).
!
!  const   -- 2pi (from phi-integration, *** axisymmetry assumed ***)
!             (for typical usage), or, other value as appropriate.
!
!  fjac    -- Jacobian vs. theta @ fixed rho & phi=0  (iarg=1 usage only)
!             dV = jacsign*const*fjac*drho*dth
!  func    -- Integrand vs. theta @ fixed rho & phi=0
!             or vs. rho @ fixed theta & phi=0, if iarg=2.
!
!  aux     -- auxilliary data passed from/to integrand
!
!  iarg    -- =1 -- fixed rho, integrate over theta
!             =2 -- fixed theta, integrate over rho
!
!  rho     -- fixed rho value  (fixed theta if iarg=2)
!  a,b     -- range of theta values (range of rho values if iarg=2)
!
!  integrand function evaluations are vectorized...
!
!  dmc 18 Sept 2000 -- adaptations for speed:  noption control:
!
!     noption=0 -- do as many evaluations as needed to achieve specified
!                  accuracy (i.e. original algorithm)
!                    (returns neval=21, 43, or 87 indicating #of required
!                     evalulations; returns corresponding abserr)
!     noption=1 -- do an 11-point integral -- **no accuracy check**
!                    (returns neval=11, abserr=0.0)
!     noption=2 -- do a 21-point integral -- check vs. 11-point integral
!                    (returns neval=21, abserr=21/11 difference)
!     noption=3 -- do a 43-point integral -- check vs. 21-point integral
!                    (returns neval=43, abserr=43/21 difference)
!     noption=4 -- do a 87-point integral -- check vs. 43-point integral
!                    (returns neval=87, abserr=87/43 difference)
!
c***begin prologue  dqng
c***date written   800101   (yymmdd)
c***revision date  810101   (yymmdd)
c***category no.  h2a1a1
c***keywords  automatic integrator, smooth integrand,
c             non-adaptive, gauss-kronrod(patterson)
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl math & progr. div. - k.u.leuven
c           kahaner,david,nbs - modified (2/82)
c***purpose  the routine calculates an approximation result to a
c            given definite integral i = integral of f over (a,b),
c            hopefully satisfying following claim for accuracy
c            abs(i-result).le.max(epsabs,epsrel*abs(i)).
c***description
c
c non-adaptive integration
c standard fortran subroutine
c double precision version
c
c           f      - double precision
c                    function subprogram defining the integrand function
c                    f(x). the actual name for f needs to be declared
c                    e x t e r n a l in the driver program.
!                       **replaced**
c
c           a      - double precision
c                    lower limit of integration
c
c           b      - double precision
c                    upper limit of integration
c
c           epsabs - double precision
c                    absolute accuracy requested
c           epsrel - double precision
c                    relative accuracy requested
c                    if  epsabs.le.0
c                    and epsrel.lt.max(50*rel.mach.acc.,0.5d-28),
c                    the routine will end with ier = 6.
c
c         on return
c           result - double precision
c                    approximation to the integral i
c                    result is obtained by applying the 21-point
c                    gauss-kronrod rule (res21) obtained by optimal
c                    addition of abscissae to the 10-point gauss rule
c                    (res10), or by applying the 43-point rule (res43)
c                    obtained by optimal addition of abscissae to the
c                    21-point gauss-kronrod rule, or by applying the
c                    87-point rule (res87) obtained by optimal addition
c                    of abscissae to the 43-point rule.
c
c           abserr - double precision
c                    estimate of the modulus of the absolute error,
c                    which should equal or exceed abs(i-result)
c
c           neval  - integer
c                    number of integrand evaluations
c
c           ier    - ier = 0 normal and reliable termination of the
c                            routine. it is assumed that the requested
c                            accuracy has been achieved.
c                    ier.gt.0 abnormal termination of the routine. it is
c                            assumed that the requested accuracy has
c                            not been achieved.
c           error messages
c                    ier = 1 the maximum number of steps has been
c                            executed. the integral is probably too
c                            difficult to be calculated by dqng.
c                        = 6 the input is invalid, because
c                            epsabs.le.0 and
c                            epsrel.lt.max(50*rel.mach.acc.,0.5d-28).
c                            result, abserr and neval are set to zero.
c
c***references  (none)
c***routines called  d1mach,xerror
c***end prologue  dqng
c
      IMPLICIT NONE
      REAL*8 a,absc,abserr,b,centr,dhlgth,
     *  d1mach,epmach,epsabs,epsrel,fcentr,fval,fval1,fval2,fv1,fv2,
     *  fv3,fv4,hlgth,result,res10,res21,res43,res87,resabs,resasc,
     *  reskh,savfun,uflow,w10,w21a,w21b,w43a,w43b,w87a,w87b,x1,x2,x3,x4
      integer ier,ipx,k,l,neval
      integer noption
cxx      external f
c
c  dmc arguments
c
      integer lunerr
      character*(*) label
      external func,fjac
      integer jacsign,iarg
      real*8 const
      real*8 rho
      real*8 aux(*)
c
c  dmc workspaces...
c
      real*8 rhovec(44),phivec(44),thvec(44),f(44),detj(44)
      integer ierf
c
      dimension fv1(5),fv2(5),fv3(5),fv4(5),x1(5),x2(5),x3(11),x4(22),
     *  w10(5),w21a(5),w21b(6),w43a(10),w43b(12),w87a(21),w87b(23),
     *  savfun(21)
c
c           the following data statements contain the
c           abscissae and weights of the integration rules used.
c
c           x1      abscissae common to the 10-, 21-, 43- and 87-
c                   point rule
c           x2      abscissae common to the 21-, 43- and 87-point rule
c           x3      abscissae common to the 43- and 87-point rule
c           x4      abscissae of the 87-point rule
c           w10     weights of the 10-point formula
c           w21a    weights of the 21-point formula for abscissae x1
c           w21b    weights of the 21-point formula for abscissae x2
c           w43a    weights of the 43-point formula for abscissae x1, x3
c           w43b    weights of the 43-point formula for abscissae x3
c           w87a    weights of the 87-point formula for abscissae x1,
c                   x2, x3
c           w87b    weights of the 87-point formula for abscissae x4
c
c
c gauss-kronrod-patterson quadrature coefficients for use in
c quadpack routine qng.  these coefficients were calculated with
c 101 decimal digit arithmetic by l. w. fullerton, bell labs, nov 1981.
c
      data x1    (  1) / 0.973906528517171720077964012084452D0/
      data x1    (  2) / 0.865063366688984510732096688423493D0/
      data x1    (  3) / 0.679409568299024406234327365114874D0/
      data x1    (  4) / 0.433395394129247190799265943165784D0/
      data x1    (  5) / 0.148874338981631210884826001129720D0/
      data w10   (  1) / 0.066671344308688137593568809893332D0/
      data w10   (  2) / 0.149451349150580593145776339657697D0/
      data w10   (  3) / 0.219086362515982043995534934228163D0/
      data w10   (  4) / 0.269266719309996355091226921569469D0/
      data w10   (  5) / 0.295524224714752870173892994651338D0/
c
      data x2    (  1) / 0.995657163025808080735527280689003D0/
      data x2    (  2) / 0.930157491355708226001207180059508D0/
      data x2    (  3) / 0.780817726586416897063717578345042D0/
      data x2    (  4) / 0.562757134668604683339000099272694D0/
      data x2    (  5) / 0.294392862701460198131126603103866D0/
      data w21a  (  1) / 0.032558162307964727478818972459390D0/
      data w21a  (  2) / 0.075039674810919952767043140916190D0/
      data w21a  (  3) / 0.109387158802297641899210590325805D0/
      data w21a  (  4) / 0.134709217311473325928054001771707D0/
      data w21a  (  5) / 0.147739104901338491374841515972068D0/
      data w21b  (  1) / 0.011694638867371874278064396062192D0/
      data w21b  (  2) / 0.054755896574351996031381300244580D0/
      data w21b  (  3) / 0.093125454583697605535065465083366D0/
      data w21b  (  4) / 0.123491976262065851077958109831074D0/
      data w21b  (  5) / 0.142775938577060080797094273138717D0/
      data w21b  (  6) / 0.149445554002916905664936468389821D0/
c
      data x3    (  1) / 0.999333360901932081394099323919911D0/
      data x3    (  2) / 0.987433402908088869795961478381209D0/
      data x3    (  3) / 0.954807934814266299257919200290473D0/
      data x3    (  4) / 0.900148695748328293625099494069092D0/
      data x3    (  5) / 0.825198314983114150847066732588520D0/
      data x3    (  6) / 0.732148388989304982612354848755461D0/
      data x3    (  7) / 0.622847970537725238641159120344323D0/
      data x3    (  8) / 0.499479574071056499952214885499755D0/
      data x3    (  9) / 0.364901661346580768043989548502644D0/
      data x3    ( 10) / 0.222254919776601296498260928066212D0/
      data x3    ( 11) / 0.074650617461383322043914435796506D0/
      data w43a  (  1) / 0.016296734289666564924281974617663D0/
      data w43a  (  2) / 0.037522876120869501461613795898115D0/
      data w43a  (  3) / 0.054694902058255442147212685465005D0/
      data w43a  (  4) / 0.067355414609478086075553166302174D0/
      data w43a  (  5) / 0.073870199632393953432140695251367D0/
      data w43a  (  6) / 0.005768556059769796184184327908655D0/
      data w43a  (  7) / 0.027371890593248842081276069289151D0/
      data w43a  (  8) / 0.046560826910428830743339154433824D0/
      data w43a  (  9) / 0.061744995201442564496240336030883D0/
      data w43a  ( 10) / 0.071387267268693397768559114425516D0/
      data w43b  (  1) / 0.001844477640212414100389106552965D0/
      data w43b  (  2) / 0.010798689585891651740465406741293D0/
      data w43b  (  3) / 0.021895363867795428102523123075149D0/
      data w43b  (  4) / 0.032597463975345689443882222526137D0/
      data w43b  (  5) / 0.042163137935191811847627924327955D0/
      data w43b  (  6) / 0.050741939600184577780189020092084D0/
      data w43b  (  7) / 0.058379395542619248375475369330206D0/
      data w43b  (  8) / 0.064746404951445885544689259517511D0/
      data w43b  (  9) / 0.069566197912356484528633315038405D0/
      data w43b  ( 10) / 0.072824441471833208150939535192842D0/
      data w43b  ( 11) / 0.074507751014175118273571813842889D0/
      data w43b  ( 12) / 0.074722147517403005594425168280423D0/
c
      data x4    (  1) / 0.999902977262729234490529830591582D0/
      data x4    (  2) / 0.997989895986678745427496322365960D0/
      data x4    (  3) / 0.992175497860687222808523352251425D0/
      data x4    (  4) / 0.981358163572712773571916941623894D0/
      data x4    (  5) / 0.965057623858384619128284110607926D0/
      data x4    (  6) / 0.943167613133670596816416634507426D0/
      data x4    (  7) / 0.915806414685507209591826430720050D0/
      data x4    (  8) / 0.883221657771316501372117548744163D0/
      data x4    (  9) / 0.845710748462415666605902011504855D0/
      data x4    ( 10) / 0.803557658035230982788739474980964D0/
      data x4    ( 11) / 0.757005730685495558328942793432020D0/
      data x4    ( 12) / 0.706273209787321819824094274740840D0/
      data x4    ( 13) / 0.651589466501177922534422205016736D0/
      data x4    ( 14) / 0.593223374057961088875273770349144D0/
      data x4    ( 15) / 0.531493605970831932285268948562671D0/
      data x4    ( 16) / 0.466763623042022844871966781659270D0/
      data x4    ( 17) / 0.399424847859218804732101665817923D0/
      data x4    ( 18) / 0.329874877106188288265053371824597D0/
      data x4    ( 19) / 0.258503559202161551802280975429025D0/
      data x4    ( 20) / 0.185695396568346652015917141167606D0/
      data x4    ( 21) / 0.111842213179907468172398359241362D0/
      data x4    ( 22) / 0.037352123394619870814998165437704D0/
      data w87a  (  1) / 0.008148377384149172900002878448190D0/
      data w87a  (  2) / 0.018761438201562822243935059003794D0/
      data w87a  (  3) / 0.027347451050052286161582829741283D0/
      data w87a  (  4) / 0.033677707311637930046581056957588D0/
      data w87a  (  5) / 0.036935099820427907614589586742499D0/
      data w87a  (  6) / 0.002884872430211530501334156248695D0/
      data w87a  (  7) / 0.013685946022712701888950035273128D0/
      data w87a  (  8) / 0.023280413502888311123409291030404D0/
      data w87a  (  9) / 0.030872497611713358675466394126442D0/
      data w87a  ( 10) / 0.035693633639418770719351355457044D0/
      data w87a  ( 11) / 0.000915283345202241360843392549948D0/
      data w87a  ( 12) / 0.005399280219300471367738743391053D0/
      data w87a  ( 13) / 0.010947679601118931134327826856808D0/
      data w87a  ( 14) / 0.016298731696787335262665703223280D0/
      data w87a  ( 15) / 0.021081568889203835112433060188190D0/
      data w87a  ( 16) / 0.025370969769253827243467999831710D0/
      data w87a  ( 17) / 0.029189697756475752501446154084920D0/
      data w87a  ( 18) / 0.032373202467202789685788194889595D0/
      data w87a  ( 19) / 0.034783098950365142750781997949596D0/
      data w87a  ( 20) / 0.036412220731351787562801163687577D0/
      data w87a  ( 21) / 0.037253875503047708539592001191226D0/
      data w87b  (  1) / 0.000274145563762072350016527092881D0/
      data w87b  (  2) / 0.001807124155057942948341311753254D0/
      data w87b  (  3) / 0.004096869282759164864458070683480D0/
      data w87b  (  4) / 0.006758290051847378699816577897424D0/
      data w87b  (  5) / 0.009549957672201646536053581325377D0/
      data w87b  (  6) / 0.012329447652244853694626639963780D0/
      data w87b  (  7) / 0.015010447346388952376697286041943D0/
      data w87b  (  8) / 0.017548967986243191099665352925900D0/
      data w87b  (  9) / 0.019938037786440888202278192730714D0/
      data w87b  ( 10) / 0.022194935961012286796332102959499D0/
      data w87b  ( 11) / 0.024339147126000805470360647041454D0/
      data w87b  ( 12) / 0.026374505414839207241503786552615D0/
      data w87b  ( 13) / 0.028286910788771200659968002987960D0/
      data w87b  ( 14) / 0.030052581128092695322521110347341D0/
      data w87b  ( 15) / 0.031646751371439929404586051078883D0/
      data w87b  ( 16) / 0.033050413419978503290785944862689D0/
      data w87b  ( 17) / 0.034255099704226061787082821046821D0/
      data w87b  ( 18) / 0.035262412660156681033782717998428D0/
      data w87b  ( 19) / 0.036076989622888701185500318003895D0/
      data w87b  ( 20) / 0.036698604498456094498018047441094D0/
      data w87b  ( 21) / 0.037120549269832576114119958413599D0/
      data w87b  ( 22) / 0.037334228751935040321235449094698D0/
      data w87b  ( 23) / 0.037361073762679023410321241766599D0/
c
c           list of major variables
c           -----------------------
c
c           centr  - mid point of the integration interval
c           hlgth  - half-length of the integration interval
c           fcentr - function value at mid point
c           absc   - abscissa
c           fval   - function value
c           savfun - array of function values which have already been
c                    computed
c           res10  - 10-point gauss result
c           res21  - 21-point kronrod result
c           res43  - 43-point result
c           res87  - 87-point result
c           resabs - approximation to the integral of abs(f)
c           resasc - approximation to the integral of abs(f-i/(b-a))
c
c           machine dependent constants
c           ---------------------------
c
c           epmach is the largest relative spacing.
c           uflow is the smallest positive magnitude.
c
c***first executable statement  dqng
      epmach = d1mach(4)
      uflow = d1mach(1)
c
c           test on validity of parameters
c           ------------------------------
c
      result = 0.0D+00
      abserr = 0.0D+00
      neval = 0
      ier = 6
      if(epsabs.le.0.0D+00.and.epsrel.lt.max(0.5D+02*epmach,0.5D-28))
     *  go to 80
 
      if(iarg.eq.1) then
         rhovec = rho
      else if(iarg.eq.2) then
         if(jacsign.ne.0) then
            ier = 99
            write(lunerr,*) ' ?dqng_fth: iarg=2 => jacsign=0 expected.'
            go to 80
         endif
         thvec = rho
      else
         write(lunerr,*) ' ?dqng_fth: iarg=',iarg,' unexpected.'
         go to 80
      endif
 
      phivec = 0.0D0
 
      hlgth = 0.5D+00*(b-a)
      dhlgth = abs(hlgth)
      centr = 0.5D+00*(b+a)
cxx      fcentr = f(centr)
      if(iarg.eq.1) then
         thvec(1)=centr
      else
         rhovec(1)=centr
      endif
c
      if(noption.eq.1) then
         neval=11
      else
         neval = 21
      endif
      ier = 1
c
c          compute the integral using the 10- and 21-point formula.
c
      do 70 l = 1,3
      go to (5,25,45),l
    5 res10 = 0.0D+00
c
c  (dmc) set up function evaluation vector
c
      do k=1,5
         absc = hlgth*x1(k)
         if(iarg.eq.1) then
            thvec(1+k)=centr+absc
            thvec(6+k)=centr-absc
         else
            rhovec(1+k)=centr+absc
            rhovec(6+k)=centr-absc
         endif
         absc = hlgth*x2(k)
         if(iarg.eq.1) then
            thvec(11+k)=centr+absc
            thvec(16+k)=centr-absc
         else
            rhovec(11+k)=centr+absc
            rhovec(16+k)=centr-absc
         endif
      enddo
c
c  (dmc) evaluate function vector with error checking
c
      if(jacsign.ne.0) then
         call fjac(neval,rhovec,thvec,phivec,aux, detj, ierf)
         if(ierf.ne.0) then
            write(lunerr,*) ' ?dqng_fth(21):  fjac error flag ier=',ierf
            ier=2
            go to 80
         endif
         if(maxval(jacsign*detj(1:neval)).le.0.0D0) then
            write(lunerr,*)
     >         ' ?dqng_fth(21):  fjac:  det(J) sign error!  rho=',
     >         rho
            ier=99
            go to 80
         endif
      endif
c
      call func(neval,rhovec,thvec,phivec,aux, f, ierf)
      if(ierf.ne.0) then
         write(lunerr,*) ' ?dqng_fth(21:  func error flag ier=',ierf
         ier=2
         go to 80
      endif
c
c  const (2pi if jacsign.ne.0) from integral(dphi) in axisymmetry
c
      if(jacsign.ne.0) then
         do k=1,neval
            f(k)=const*jacsign*detj(k)*f(k)
         enddo
      else
         f(1:neval)=const*f(1:neval)
      endif
c
      fcentr=f(1)
      res21 = w21b(6)*fcentr
      resabs = w21b(6)*abs(fcentr)
c
      do 10 k=1,5
cxx        fval1 = f(centr+absc)
cxx        fval2 = f(centr-absc)
        fval1=f(1+k)
        fval2=f(6+k)
        fval = fval1+fval2
        res10 = res10+w10(k)*fval
        res21 = res21+w21a(k)*fval
        resabs = resabs+w21a(k)*(abs(fval1)+abs(fval2))
        savfun(k) = fval
        fv1(k) = fval1
        fv2(k) = fval2
   10 continue
c
c ** noption = 1 -- all done **
c
      if(noption.eq.1) then
         result = res10*hlgth
         abserr = 0.0D0
         ier=0
         return
      endif
c
      ipx = 5
      do 15 k=1,5
        ipx = ipx+1
cxx        fval1 = f(centr+absc)
cxx        fval2 = f(centr-absc)
        fval1=f(11+k)
        fval2=f(16+k)
        fval = fval1+fval2
        res21 = res21+w21b(k)*fval
        resabs = resabs+w21b(k)*(abs(fval1)+abs(fval2))
        savfun(ipx) = fval
        fv3(k) = fval1
        fv4(k) = fval2
   15 continue
c
c          test for convergence.
c
      result = res21*hlgth
      resabs = resabs*dhlgth
      reskh = 0.5D+00*res21
      resasc = w21b(6)*abs(fcentr-reskh)
      do 20 k = 1,5
        resasc = resasc+w21a(k)*(abs(fv1(k)-reskh)+abs(fv2(k)-reskh))
     *                  +w21b(k)*(abs(fv3(k)-reskh)+abs(fv4(k)-reskh))
   20 continue
      abserr = abs((res21-res10)*hlgth)
      resasc = resasc*dhlgth
      go to 65
c
c          compute the integral using the 43-point formula.
c
   25 res43 = w43b(12)*fcentr
      neval = 43
      do 30 k=1,10
        res43 = res43+savfun(k)*w43a(k)
   30 continue
c
c  (dmc)  evaluate theta vector
c
      do k=1,11
         absc = hlgth*x3(k)
         if(iarg.eq.1) then
            thvec(k)=centr+absc
            thvec(11+k)=centr-absc
         else
            rhovec(k)=centr+absc
            rhovec(11+k)=centr-absc
         endif
      enddo
c
c  (dmc) evaluate function vector with error checking
c
      if(jacsign.ne.0) then
         call fjac(22,rhovec,thvec,phivec,aux, detj, ierf)
         if(ierf.ne.0) then
            write(lunerr,*) ' ?dqng_fth(22):  fjac error flag ier=',ierf
            ier=2
            go to 80
         endif
         if(maxval(jacsign*detj(1:22)).le.0.0D0) then
            write(lunerr,*)
     >         ' ?dqng_fth(22):  fjac:  det(J) sign error!  rho=',
     >         rho
            ier=99
            go to 80
         endif
      endif
c
      call func(22,rhovec,thvec,phivec,aux, f, ierf)
      if(ierf.ne.0) then
         write(lunerr,*) ' ?dqng_fth(22):  func error flag ier=',ierf
         ier=2
         go to 80
      endif
c
c  const (2pi if jacsign.ne.0) from integral(dphi) in axisymmetry
c
      if(jacsign.ne.0) then
         do k=1,22
            f(k)=const*jacsign*detj(k)*f(k)
         enddo
      else
         f(1:22)=const*f(1:22)
      endif
c
      do 40 k=1,11
        ipx = ipx+1
cxx        fval = f(absc+centr)+f(centr-absc)
        fval = f(k)+f(11+k)
        res43 = res43+fval*w43b(k)
        savfun(ipx) = fval
   40 continue
c
c          test for convergence.
c
      result = res43*hlgth
      abserr = abs((res43-res21)*hlgth)
      go to 65
c
c          compute the integral using the 87-point formula.
c
   45 res87 = w87b(23)*fcentr
      neval = 87
      do 50 k=1,21
        res87 = res87+savfun(k)*w87a(k)
   50 continue
c
c  (dmc)  evaluate theta vector
c
      do k=1,22
         absc = hlgth*x4(k)
         if(iarg.eq.1) then
            thvec(k)=centr+absc
            thvec(22+k)=centr-absc
         else
            rhovec(k)=centr+absc
            rhovec(22+k)=centr-absc
         endif
      enddo
c
c  (dmc) evaluate function vector with error checking
c
      if(jacsign.ne.0) then
         call fjac(44,rhovec,thvec,phivec,aux, detj, ierf)
         if(ierf.ne.0) then
            write(lunerr,*) ' ?dqng_fth(44):  fjac error flag ier=',ierf
            ier=2
            go to 80
         endif
         if(maxval(jacsign*detj(1:44)).le.0.0D0) then
            write(lunerr,*)
     >         ' ?dqng_fth(44):  fjac:  det(J) sign error!  rho=',
     >         rho
            ier=99
            go to 80
         endif
      endif
c
      call func(44,rhovec,thvec,phivec,aux, f, ierf)
      if(ierf.ne.0) then
         write(lunerr,*) ' ?dqng_fth(44):  func error flag ier=',ierf
         ier=2
         go to 80
      endif
c
c  const (2pi if jacsign.ne.0) from integral(dphi) in axisymmetry
c
      if(jacsign.ne.0) then
         do k=1,44
            f(k)=const*jacsign*detj(k)*f(k)
         enddo
      else
         f(1:44)=const*f(1:44)
      endif
c
      do 60 k=1,22
cxx        res87 = res87+w87b(k)*(f(absc+centr)+f(centr-absc))
        res87 = res87+w87b(k)*(f(k)+f(22+k))
   60 continue
      result = res87*hlgth
      abserr = abs((res87-res43)*hlgth)
   65 if(resasc.ne.0.0D+00.and.abserr.ne.0.0D+00)
     *  abserr = resasc*min(0.1D+01,(0.2D+03*abserr/resasc)**1.5D+00)
      if (resabs.gt.uflow/(0.5D+02*epmach)) abserr = max
     *  ((epmach*0.5D+02)*resabs,abserr)
c
      if(noption.eq.0) then
         if (abserr.le.max(epsabs,epsrel*abs(result))) ier = 0
      else
c
c ***noption control -- stop after fixed number of evaluations if set...
c note l is the loop index...
c
         if (noption.eq.(l+1)) ier = 0
      endif
c
c ***jump out of do-loop
c
      if (ier.eq.0) go to 999
c
   70 continue
   80 continue
      write(lunerr,*) ' ?dqng_fth:  error evaluating integral:  ',label
  999 return
      end

subroutine eqm_gen_q(qname,id,ierr)
 
  use xplasma_obj_instance
  use eq_module

  implicit NONE
 
  ! use XPLASMA to generate a q profile
  ! q = phi'/(2pi*psi') = (dV/drho)*<1/R**2>*g / (dpsi/drho) / (2pi)**2
 
  !-------------------------------------------------------
  character*(*), intent(in) :: qname   ! name to assign to this q profile
  integer, intent(out) :: id           ! xplasma id of profile created
  integer, intent(out) :: ierr         ! completion code, 0=OK
 
  !  if an error occors, id=0 on output.
  !-------------------------------------------------------
  integer :: iorder
  !-------------------------------------------------------
 
  iorder=1  ! Generate a Hermite profile

  call xplasma_gen_q(s,qname,iorder,id,ierr)

  if(ierr.ne.0) then
     write(lunerr,*) &
          ' ?eqm_gen_q: xplasma_gen_q call failed:'
     call xplasma_error(s,ierr,lunerr)
  endif
 
end subroutine eqm_gen_q

!******************** START FILE FILFN6.FOR ; GROUP FILTR6 ******************
!
!  FILFN6
!
!  COMPUTE WEIGHTED AVERAGE ABOUT PT X(J0).
!
!  END CONDITIONS:
!     XEND?=0==> FIX END PT. OF REGION BEING SMOOTHED.
!                THE DATA CURVE IS REFLECTED ABOUT THE PT.
!                [X(1),Y(1)] ( OR [X(N),Y(N)])       (E0)
!               SO THAT BY SYMMETRY OF THE WEIGHTING
!                FUNCTION ==> THE END PTS ARE FIXED
!
!      XEND?=1==> DON'T FIX END PT. OF REGION. END PT
!                IS RESET TO WEIGHTED AVERAGE OF NEARBY PTS.
!                THE DATA IS REFLECTED ABOUT THE LINE X=X(1)
!                FOR THE LEFT END, ABOUT THE LINE X=X(N)
!                FOR  THE RIGHT END.                 (E1)
!
!
!  IF XEND DOES NOT EQUAL 0 OR 1 XEND SHOULD BE BETWEEN 0 AND 1;
!   THEN THE 'EXTENSION FORMULA' IS E=(1-XEND)*E0+XEND*E1
!
REAL(fp) FUNCTION r8filfn6(X,Y,N,J0,DELTA0,XEND1,XEND2,ICOD)
  !
  !  DMC NOV 1985 - ICOD=1 : NORMAL TRIANGULAR WEIGHTED AVG INTEGRAL
  !
  !    ICOD=2 : BROKEN TWO PIECE TRIANGLE FOR SAWTOOTH CORRELATION
  !             INTEGRAL
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: ZERO, HALF, ONE
  implicit none
  ! Arguments
  integer, intent(in) :: n, j0
  real(fp), dimension(n), intent(in) :: x
  real(fp), dimension(n), intent(in) :: y
  real(fp), dimension(n), intent(in) :: delta0
  real(fp), intent(in) :: xend1, xend2
  integer, intent(in) :: icod
  ! Local variables:
  integer :: j,jr
  real(fp) :: delta,xlim1,xlim2,denom, &
       zsign,wasum,xa,ya,xb,yb,ya0,ya1,xa1,yb0,yb1,xb1

  real(fp), external :: r8wxcint
  real(fp), external :: r8wxfint
  !
  !  CHECK FOR NUMERICALLY ZERO OR NEGATIVE DELTA
  DELTA=min((X(N)-X(1)),DELTA0(J0))
  IF((DELTA.LE.ZERO).OR.((X(J0)+DELTA).EQ.X(J0))) THEN
    IF(ICOD.EQ.1) THEN
      r8filfn6=Y(J0)
    ELSE
      r8filfn6=ZERO
    ENDIF
    RETURN
  ENDIF
  !
  IF(ICOD.EQ.1) THEN
    !  CHECK FOR FIXED ENDPOINTS
    r8filfn6=Y(J0)
    IF((J0.EQ.1).AND.(XEND1.EQ.ZERO)) RETURN
    IF((J0.EQ.N).AND.(XEND2.EQ.ZERO)) RETURN
  ENDIF
  !
  !  EVALUATE DENOMINATOR OF WEIGHTED AVERAGE FORMULA
  !
  XLIM1=X(J0)-DELTA
  XLIM2=X(J0)+DELTA
  !
  DENOM=r8wxcint(XLIM1,XLIM2,ONE,X(J0),DELTA)
  !
  !  EVALUATE NUMERATOR OF WGTED. AVG.
  !
  !  (A) PTS TO THE LEFT OF X(J0)
  !
  ZSIGN=ONE
  WASUM=ZERO
  !
  J=J0
  XA=X(J0)
  YA=Y(J0)
10 J=J-1
  XB=XA
  YB=YA
  IF (J) 11,11,12
  !
  !  REFLECT PTS ABOUT X(1),Y(1)
  !
11 CONTINUE
  JR=min(N,(2-J))
  IF((X(J0)-XB).GE.DELTA.or.(J.LE.(1-N))) GO TO 50
  XA=X(1)-(X(JR)-X(1))
  YA0=Y(1)-(Y(JR)-Y(1))
  YA1=Y(JR)
  YA=(ONE-XEND1)*YA0+XEND1*YA1
  GO TO 15
  !
12 CONTINUE
  IF((X(J0)-XB).GE.DELTA) GO TO 50
  XA=X(J)
  YA=Y(J)
  !
  !  COMPUTE WEIGHTED AVERAGE INTEGRAL FROM XA1 TO XB
  !
15 CONTINUE
  XA1=max(XA,(X(J0)-DELTA))
  WASUM=WASUM+ZSIGN*r8wxfint(XA1,XB,XA,YA,XB,YB,X(J0),DELTA)
  !
  GO TO 10
!
  ! (B) COMPUTE CONTRIBUTION OF DATA TO RIGHT OF X(J0)
  !
50 CONTINUE
  !
  IF(ICOD.EQ.2) ZSIGN=-ONE
  !
  J=J0-1
  XB=X(J0)
  YB=Y(J0)
60 J=J+1
  XA=XB
  YA=YB
  IF(N-J) 61,61,62
  !
  !  REFLECT ABOUT X(N),Y(N)
  !
61 CONTINUE
  JR=max(1,(N+N-J-1))
  IF((XA-X(J0)).GE.DELTA.or.(J.GE.(2*N-1))) GO TO 100
  XB=X(N)+(X(N)-X(JR))
  YB0=Y(N)+(Y(N)-Y(JR))
  YB1=Y(JR)
  YB=(ONE-XEND2)*YB0+XEND2*YB1
  GO TO 65
  !
62 CONTINUE
  IF((XA-X(J0)).GE.DELTA) GO TO 100
  XB=X(J+1)
  YB=Y(J+1)
  !
  !  INTEGRATE FROM XA TO XB1
  !
65 XB1=min(XB,(X(J0)+DELTA))
  !
  WASUM=WASUM+ZSIGN*r8wxfint(XA,XB1,XA,YA,XB,YB,X(J0),DELTA)
  !
  GO TO 60
  !
  !
  !  RETURN COMPUTED WEIGHTED AVERAGE
  !
100 CONTINUE
  !
  r8filfn6=WASUM/DENOM
  !
  RETURN
END FUNCTION r8filfn6

#! /bin/csh -f
#
#  generate r8bloat (real*8 precision) from asymmetric single precision
#  TRANSP bloat routines
#
#    1.  create the working directory...
#
  if ( ! -d $TMPDIR_TR/r8bloat ) then
    mkdir $TMPDIR_TR/r8bloat
  endif
#
  echo " "
  echo 'r8bloat_lib.csh starting ("no match" message may follow...)'
#
  set wkdir = $TMPDIR_TR/r8bloat
  rm $wkdir/*.*
#
#    2.  fetch the sources into the working directory...
#
  set csdir = $CODESYSDIR/source
#
  cp $csdir/fftsub/*.for $wkdir
  cp $csdir/comput/bloata0.for $wkdir
  cp $csdir/comput/tk*.* $wkdir
  cp $csdir/comput/fpolar.for $wkdir
  cp $csdir/comput/lokjaca.for $wkdir
  cp $csdir/comput/sincos.for $wkdir
#
  echo " "
  echo "r8bloat_lib.csh:  work directory has r4 sources:"
  cd $wkdir
  ls
#
#    3.  get list of subroutine & function names; create substitution table
#
  foreach file ( *.for )
    fgtok $file >> r8bloat_names.tmp
  end
#
  set r8bloat_names = `cat r8bloat_names.tmp`
  rm r8bloat_names.tmp
#
  @ i = 0
  while ( $i < $#r8bloat_names ) 
    @ i++
    echo "$r8bloat_names[$i] r8$r8bloat_names[$i]" >> r8bloat_names.sub
  end
#
  echo " "
  echo "r8bloat_lib.csh:  substitution table succesfully generated."
#
# cat r8bloat_names.sub
#
  set ilist = ( *.inc )
#
  foreach file ( *.for ) 
    echo " converting:  $file ..."
    r8_convert $file r8$file r8bloat_names.sub
    @ j = 0
    while ( $j < $#ilist ) 
      @ j++
      supsub r8$file $ilist[$j] r8$ilist[$j]
    end
    rm $file
    if ( -f r8$file~ ) then
      rm r8$file~
    endif
  end
#
  foreach file ( $ilist ) 
    echo " converting include file:  $file ..."
    r8_convert_include $file r8$file r8bloat_names.sub
    rm $file
  end
#
  echo " "
  echo " conversion done; copying back to r8bloat source library directory."
#
  rm $csdir/r8bloat/*.for
  rm $csdir/r8bloat/*.inc
#
  cp $wkdir/*.* $csdir/r8bloat
#
  cd $csdir/r8bloat
  ls -l

#
#  for a DEC/Compaq alpha...
#
#   NTCC libraries
   set libdir = /usr/ntcc/lib
#
#   NTCC f90 "public" modules
   set moddir = /usr/ntcc/mod
#
#   for the DEC/Compaq alpha linux workstation...
#
   set f90opt = "fort -fast -assume no2underscore"
   set f90opt = "$f90opt -I$moddir"
#
#  MDSplus is not linked.  In this program "-lnetcdf -llapack"
#  and "-lreadline -lhistory -ltermcap" could be omitted; -lblas is needed.
#  however, related programs will need netcdf and lapack, and, the gnu
#  libraries -lreadline, etc., enable command line editing / recall inside
#  interactive fortran programs, which is useful.
#
   $f90opt  geqxpl2.for -L $libdir -lxplasma \
                      -lfluxav -lmclib -lsmlib -ltrgraf \
                      -lureadsub -lsg -ljc -lnscrunch -lr8bloat -lfftsub \
                      -lcomput -lvaxonly -lpspline -lezcdf -llsode  \
                      -llsode_linpack -lportlib \
                   -L/usr/local/lib \
                      -lnetcdf -llapack -lblas \
                      -lreadline -lhistory -ltermcap
